(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define(['exports'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.typescriptNpmPackage = {}));
})(this, (function (exports) { 'use strict';

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }

    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m") throw new TypeError("Private method is not writable");
        if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
        var e = new Error(message);
        return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
    };

    /**
     * JavaScript numbers are only precise up to 53 bits. Since Bitcoin relies on
     * 256-bit cryptography, this BigNumber class enables operations on larger
     * numbers.
     *
     * @class BigNumber
     */
    class BigNumber {
        /**
         * @privateinitializer
         */
        static zeros = [
            '',
            '0',
            '00',
            '000',
            '0000',
            '00000',
            '000000',
            '0000000',
            '00000000',
            '000000000',
            '0000000000',
            '00000000000',
            '000000000000',
            '0000000000000',
            '00000000000000',
            '000000000000000',
            '0000000000000000',
            '00000000000000000',
            '000000000000000000',
            '0000000000000000000',
            '00000000000000000000',
            '000000000000000000000',
            '0000000000000000000000',
            '00000000000000000000000',
            '000000000000000000000000',
            '0000000000000000000000000'
        ];
        /**
         * @privateinitializer
         */
        static groupSizes = [
            0, 0,
            25, 16, 12, 11, 10, 9, 8,
            8, 7, 7, 7, 7, 6, 6,
            6, 6, 6, 6, 6, 5, 5,
            5, 5, 5, 5, 5, 5, 5,
            5, 5, 5, 5, 5, 5, 5
        ];
        /**
         * @privateinitializer
         */
        static groupBases = [
            0, 0,
            33554432, 43046721, 16777216, 48828125, 60466176, 40353607, 16777216,
            43046721, 10000000, 19487171, 35831808, 62748517, 7529536, 11390625,
            16777216, 24137569, 34012224, 47045881, 64000000, 4084101, 5153632,
            6436343, 7962624, 9765625, 11881376, 14348907, 17210368, 20511149,
            24300000, 28629151, 33554432, 39135393, 45435424, 52521875, 60466176
        ];
        /**
         * The word size of big number chunks.
         *
         * @property wordSize
         *
         * @example
         * console.log(BigNumber.wordSize);  // output: 26
         */
        static wordSize = 26;
        /**
         * Negative flag. Indicates whether the big number is a negative number.
         * - If 0, the number is positive.
         * - If 1, the number is negative.
         *
         * @property negative
         *
         * @example
         * let num = new BigNumber("-10");
         * console.log(num.negative);  // output: 1
         */
        negative;
        /**
         * Array of numbers, where each number represents a part of the value of the big number.
         *
         * @property words
         *
         * @example
         * let num = new BigNumber(50000);
         * console.log(num.words);  // output: [ 50000 ]
         */
        words;
        /**
         * Length of the words array.
         *
         * @property length
         *
         * @example
         * let num = new BigNumber(50000);
         * console.log(num.length);  // output: 1
         */
        length;
        /**
         * Reduction context of the big number.
         *
         * @property red
         */
        red;
        /**
         * Checks whether a value is an instance of BigNumber. If not, then checks the features of the input to determine potential compatibility. Regular JS numbers fail this check.
         *
         * @method isBN
         * @param num - The value to be checked.
         * @returns - Returns a boolean value determining whether or not the checked num parameter is a BigNumber.
         *
         * @example
         * const validNum = new BigNumber(5);
         * BigNumber.isBN(validNum); // returns true
         *
         * const invalidNum = 5;
         * BigNumber.isBN(invalidNum); // returns false
         */
        static isBN(num) {
            if (num instanceof BigNumber) {
                return true;
            }
            return num !== null && typeof num === 'object' &&
                num.constructor.wordSize === BigNumber.wordSize &&
                Array.isArray(num.words);
        }
        /**
         * Returns the bigger value between two BigNumbers
         *
         * @method max
         * @param left - The first BigNumber to be compared.
         * @param right - The second BigNumber to be compared.
         * @returns - Returns the bigger BigNumber between left and right.
         *
         * @example
         * const bn1 = new BigNumber(5);
         * const bn2 = new BigNumber(10);
         * BigNumber.max(bn1, bn2); // returns bn2
         */
        static max(left, right) {
            if (left.cmp(right) > 0)
                return left;
            return right;
        }
        /**
         * Returns the smaller value between two BigNumbers
         *
         * @method min
         * @param left - The first BigNumber to be compared.
         * @param right - The second BigNumber to be compared.
         * @returns - Returns the smaller value between left and right.
         *
         * @example
         * const bn1 = new BigNumber(5);
         * const bn2 = new BigNumber(10);
         * BigNumber.min(bn1, bn2); // returns bn1
         */
        static min(left, right) {
            if (left.cmp(right) < 0)
                return left;
            return right;
        }
        /**
         * @constructor
         *
         * @param number - The number (various types accepted) to construct a BigNumber from. Default is 0.
         *
         * @param base - The base of number provided. By default is 10.
         *
         * @param endian - The endianness provided. By default is 'big endian'.
         *
         * @example
         * import BigNumber from './BigNumber';
         * const bn = new BigNumber('123456', 10, 'be');
         */
        constructor(number = 0, base = 10, endian = 'be') {
            this.negative = 0;
            this.words = [];
            this.length = 0;
            // Reduction context
            this.red = null;
            if (number !== null) {
                if (base === 'le' || base === 'be') {
                    endian = base;
                    base = 10;
                }
                if (typeof number === 'number') {
                    return this.initNumber(number, base, endian);
                }
                if (typeof number === 'object') {
                    return this.initArray(number, endian);
                }
                if (base === 'hex') {
                    base = 16;
                }
                this.assert(base === (base | 0) && base >= 2 && base <= 36);
                number = number.toString().replace(/\s+/g, '');
                let start = 0;
                if (number[0] === '-') {
                    start++;
                    this.negative = 1;
                }
                if (start < number.length) {
                    if (base === 16) {
                        this.parseHex(number, start, endian);
                    }
                    else {
                        this.parseBase(number, base, start);
                        if (endian === 'le') {
                            this.initArray(this.toArray(), endian);
                        }
                    }
                }
            }
        }
        /**
         * Asserts that a certain condition is true. If it is not, throws an error with the provided message.
         *
         * @method assert
         * @private
         * @param val - The condition to be checked.
         * @param msg - The error message to throw if the condition is not satisfied. Default is 'Assertion failed'.
         */
        assert(val, msg = 'Assertion failed') {
            if (!val)
                throw new Error(msg);
        }
        /**
         * Function to initialize a BigNumber from a regular number. It also determines if the number is negative and sets the negative property accordingly.
         * If the endianness provided is little endian ('le'), it reverses the bytes.
         *
         * @method initNumber
         * @private
         * @param number - The number to initialize the BigNumber from.
         * @param base - The base of the number provided.
         * @param endian - The endianness ('be' for big-endian, 'le' for little-endian).
         * @returns The current BigNumber instance.
         */
        initNumber(number, base, endian) {
            if (number < 0) {
                this.negative = 1;
                number = -number;
            }
            if (number < 0x4000000) {
                this.words = [number & 0x3ffffff];
                this.length = 1;
            }
            else if (number < 0x10000000000000) {
                this.words = [
                    number & 0x3ffffff,
                    (number / 0x4000000) & 0x3ffffff
                ];
                this.length = 2;
            }
            else {
                this.assert(number < 0x20000000000000, 'The number is larger than 2 ^ 53 (unsafe)');
                this.words = [
                    number & 0x3ffffff,
                    (number / 0x4000000) & 0x3ffffff,
                    1
                ];
                this.length = 3;
            }
            if (endian !== 'le')
                return this;
            // Reverse the bytes
            this.initArray(this.toArray(), endian);
            return this;
        }
        /**
         * Creates a new BigNumber from the provided number array and initializes it based on the base and endian provided.
         *
         * @method initArray
         * @private
         * @param number - The array of numbers to initialize the BigNumber from. Each number represents a part of the value of the big number.
         * @param endian - The endianness ('be' for big-endian, 'le' for little-endian).
         * @return The current BigNumber instance.
         */
        initArray(number, endian) {
            // Perhaps a Uint8Array
            this.assert(typeof number.length === 'number', 'The number must have a length');
            if (number.length <= 0) {
                this.words = [0];
                this.length = 1;
                return this;
            }
            this.length = Math.ceil(number.length / 3);
            this.words = new Array(this.length);
            let i = 0;
            for (; i < this.length; i++) {
                this.words[i] = 0;
            }
            let j, w;
            let off = 0;
            if (endian === 'be') {
                for (i = number.length - 1, j = 0; i >= 0; i -= 3) {
                    w = number[i] | (number[i - 1] << 8) | (number[i - 2] << 16);
                    this.words[j] |= (w << off) & 0x3ffffff;
                    this.words[j + 1] = (w >>> (26 - off)) & 0x3ffffff;
                    off += 24;
                    if (off >= 26) {
                        off -= 26;
                        j++;
                    }
                }
            }
            else if (endian === 'le') {
                for (i = 0, j = 0; i < number.length; i += 3) {
                    w = number[i] | (number[i + 1] << 8) | (number[i + 2] << 16);
                    this.words[j] |= (w << off) & 0x3ffffff;
                    this.words[j + 1] = (w >>> (26 - off)) & 0x3ffffff;
                    off += 24;
                    if (off >= 26) {
                        off -= 26;
                        j++;
                    }
                }
            }
            return this.strip();
        }
        /**
         * Function to extract the 4-bit number from a hexadecimal character
         *
         * @method parseHex4Bits
         * @private
         * @param string - The string containing the hexadecimal character.
         * @param index - The index of the hexadecimal character in the string.
         * @return The decimal value corresponding to the hexadecimal character.
         */
        parseHex4Bits(string, index) {
            const c = string.charCodeAt(index);
            // '0' - '9'
            if (c >= 48 && c <= 57) {
                return c - 48;
                // 'A' - 'F'
            }
            else if (c >= 65 && c <= 70) {
                return c - 55;
                // 'a' - 'f'
            }
            else if (c >= 97 && c <= 102) {
                return c - 87;
            }
            else {
                throw new Error('Invalid character in ' + string);
            }
        }
        /**
         * Function to extract the 8-bit number from two hexadecimal characters
         *
         * @method parseHexByte
         * @private
         * @param string - The string containing the hexadecimal characters.
         * @param lowerBound - The lower bound of the index to start parsing from.
         * @param index - The index of the second hexadecimal character in the string.
         * @return The decimal value corresponding to the two hexadecimal characters.
         */
        parseHexByte(string, lowerBound, index) {
            let r = this.parseHex4Bits(string, index);
            if (index - 1 >= lowerBound) {
                r |= this.parseHex4Bits(string, index - 1) << 4;
            }
            return r;
        }
        /**
         * Function to parse and convert a specific string portion into a big number in hexadecimal base.
         *
         * @method parseHex
         * @private
         * @param number - The string to parse.
         * @param start - The index to start parsing from.
         * @param endian - The endianness ('be', 'le').
         * @return The current BigNumber instance.
         */
        parseHex(number, start, endian) {
            // Create possibly bigger array to ensure that it fits the number
            this.length = Math.ceil((number.length - start) / 6);
            this.words = new Array(this.length);
            let i = 0;
            for (; i < this.length; i++) {
                this.words[i] = 0;
            }
            // 24-bits chunks
            let off = 0;
            let j = 0;
            let w;
            if (endian === 'be') {
                for (i = number.length - 1; i >= start; i -= 2) {
                    w = this.parseHexByte(number, start, i) << off;
                    this.words[j] |= w & 0x3ffffff;
                    if (off >= 18) {
                        off -= 18;
                        j += 1;
                        this.words[j] |= w >>> 26;
                    }
                    else {
                        off += 8;
                    }
                }
            }
            else {
                const parseLength = number.length - start;
                for (i = parseLength % 2 === 0 ? start + 1 : start; i < number.length; i += 2) {
                    w = this.parseHexByte(number, start, i) << off;
                    this.words[j] |= w & 0x3ffffff;
                    if (off >= 18) {
                        off -= 18;
                        j += 1;
                        this.words[j] |= w >>> 26;
                    }
                    else {
                        off += 8;
                    }
                }
            }
            return this.strip();
        }
        /**
         * Function to convert a particular string portion into a base word.
         *
         * @method parseBaseWord
         * @private
         * @param str - The string to parse.
         * @param start - The index to start parsing from.
         * @param end - The index to stop parsing at.
         * @param mul - The base to be used for the conversion.
         * @return The decimal value of the parsed base word.
         */
        parseBaseWord(str, start, end, mul) {
            let r = 0;
            let b = 0;
            const len = Math.min(str.length, end);
            for (let i = start; i < len; i++) {
                const c = str.charCodeAt(i) - 48;
                r *= mul;
                // 'a'
                if (c >= 49) {
                    b = c - 49 + 0xa;
                    // 'A'
                }
                else if (c >= 17) {
                    b = c - 17 + 0xa;
                    // '0' - '9'
                }
                else {
                    b = c;
                }
                this.assert(c >= 0 && b < mul, 'Invalid character');
                r += b;
            }
            return r;
        }
        /**
         * Function to convert a string into a big number in a specific base.
         *
         * @method parseBase
         * @private
         * @param number - The string to be converted into a big number.
         * @param base - The base to be used for conversion.
         * @param start - The index to start conversion from.
         * @return The current BigNumber instance.
         */
        parseBase(number, base, start) {
            // Initialize as zero
            this.words = [0];
            this.length = 1;
            // Find length of limb in base
            let limbLen = 0;
            let limbPow = 1;
            for (; limbPow <= 0x3ffffff; limbPow *= base) {
                limbLen++;
            }
            limbLen--;
            limbPow = (limbPow / base) | 0;
            const total = number.length - start;
            const mod = total % limbLen;
            const end = Math.min(total, total - mod) + start;
            let word = 0;
            let i = start;
            for (; i < end; i += limbLen) {
                word = this.parseBaseWord(number, i, i + limbLen, base);
                this.imuln(limbPow);
                if (this.words[0] + word < 0x4000000) {
                    this.words[0] += word;
                }
                else {
                    this._iaddn(word);
                }
            }
            if (mod !== 0) {
                let pow = 1;
                word = this.parseBaseWord(number, i, number.length, base);
                for (i = 0; i < mod; i++) {
                    pow *= base;
                }
                this.imuln(pow);
                if (this.words[0] + word < 0x4000000) {
                    this.words[0] += word;
                }
                else {
                    this._iaddn(word);
                }
            }
            return this.strip();
        }
        /**
         * The copy method copies the state of this BigNumber into an exsiting `dest` BigNumber.
         *
         * @method copy
         * @param dest - The BigNumber instance that will be updated to become a copy.
         *
         * @example
         * const bn1 = new BigNumber('123456', 10, 'be');
         * const bn2 = new BigNumber();
         * bn1.copy(bn2);
         * // bn2 is now a BigNumber representing 123456
         */
        copy(dest) {
            dest.words = new Array(this.length);
            for (let i = 0; i < this.length; i++) {
                dest.words[i] = this.words[i];
            }
            dest.length = this.length;
            dest.negative = this.negative;
            dest.red = this.red;
        }
        /**
         *
         * Directly transfers the attributes of the source BigNumber to the destination BigNumber.
         *
         * @method move
         * @param dest - The BigNumber that attributes will be moved into.
         * @param src - The BigNumber that attributes will be moved from.
         *
         * @example
         * const src = new BigNumber('123456', 10, 'be');
         * const dest = new BigNumber();
         * BigNumber.move(dest, src);
         * // dest is now a BigNumber representing 123456
         */
        static move(dest, src) {
            dest.words = src.words;
            dest.length = src.length;
            dest.negative = src.negative;
            dest.red = src.red;
        }
        /**
         * Creates a copy of the current BigNumber instance.
         *
         * @method clone
         * @returns A new BigNumber instance, identical to the original.
         *
         * @example
         * const bn = new BigNumber('123456', 10, 'be');
         * const bnClone = bn.clone();
         */
        clone() {
            const r = new BigNumber();
            this.copy(r);
            return r;
        }
        /**
         * Increases the BigNumber length up to a certain size and initializes new elements with 0.
         *
         * @method expand
         * @param size - The desired size to grow the BigNumber length.
         * @returns The BigNumber instance after expansion.
         *
         * @example
         * const bn = new BigNumber('123456', 10, 'be');
         * bn.expand(10);
         */
        expand(size) {
            while (this.length < size) {
                this.words[this.length++] = 0;
            }
            return this;
        }
        /**
         * Removes leading zeros.
         *
         * @method strip
         * @returns - Returns the BigNumber after stripping leading zeros.
         *
         * @example
         * const bn = new BigNumber("000000", 2, "be");
         * bn.strip();
         * // bn now represents 0
         */
        strip() {
            while (this.length > 1 && this.words[this.length - 1] === 0) {
                this.length--;
            }
            return this.normSign();
        }
        /**
         * Normalizes the sign of the BigNumber. Changes -0 to 0.
         *
         * @method normSign
         * @returns The normalized BigNumber instance.
         *
         * @example
         * const bn = new BigNumber('-0', 10, 'be');
         * bn.normSign();
         */
        normSign() {
            // -0 = 0
            if (this.length === 1 && this.words[0] === 0) {
                this.negative = 0;
            }
            return this;
        }
        /**
         * Utility for inspecting the current BigNumber instance. Accompanied with a prefix '<BN: ' or '<BN-R: '.
         *
         * @method inspect
         * @returns A string representation to inspect the BigNumber instance.
         *
         * @example
         * const bn = new BigNumber('123456', 10, 'be');
         * bn.inspect();
         */
        inspect() {
            return (this.red !== null ? '<BN-R: ' : '<BN: ') + this.toString(16) + '>';
        }
        /**
         * Converts the BigNumber instance to a string representation.
         *
         * @method toString
         * @param base - The base for representing number. Default is 10. Other accepted values are 16 and 'hex'.
         * @param padding - Represents the minimum number of digits to represent the BigNumber as a string. Default is 1.
         * @throws If base is not between 2 and 36.
         * @returns The string representation of the BigNumber instance
         *
         * @example
         * const bn = new BigNumber('123456', 10, 'be');
         * bn.toString(16); // Converts the BigNumber to a hexadecimal string.
         */
        toString(base = 10, padding = 1) {
            let out;
            if (base === 16 || base === 'hex') {
                out = '';
                let off = 0;
                let carry = 0;
                for (let i = 0; i < this.length; i++) {
                    const w = this.words[i];
                    const word = (((w << off) | carry) & 0xffffff).toString(16);
                    carry = (w >>> (24 - off)) & 0xffffff;
                    off += 2;
                    if (off >= 26) {
                        off -= 26;
                        i--;
                    }
                    if (carry !== 0 || i !== this.length - 1) {
                        out = BigNumber.zeros[6 - word.length] + word + out;
                    }
                    else {
                        out = word + out;
                    }
                }
                if (carry !== 0) {
                    out = carry.toString(16) + out;
                }
                if (padding === 0 && out === '0') {
                    return '';
                }
                while (out.length % padding !== 0 && padding !== 0) {
                    out = '0' + out;
                }
                if (this.negative !== 0) {
                    out = '-' + out;
                }
                return out;
            }
            if (base === (base | 0) && base >= 2 && base <= 36) {
                const groupSize = BigNumber.groupSizes[base];
                const groupBase = BigNumber.groupBases[base];
                out = '';
                let c = this.clone();
                c.negative = 0;
                while (!c.isZero()) {
                    const r = c.modrn(groupBase).toString(base);
                    c = c.idivn(groupBase);
                    if (!c.isZero()) {
                        out = BigNumber.zeros[groupSize - r.length] + r + out;
                    }
                    else {
                        out = r + out;
                    }
                }
                if (this.isZero()) {
                    out = '0' + out;
                }
                while (out.length % padding !== 0) {
                    out = '0' + out;
                }
                if (this.negative !== 0) {
                    out = '-' + out;
                }
                return out;
            }
            throw new Error('Base should be between 2 and 36');
        }
        /**
         * Converts the BigNumber instance to a JavaScript number.
         * Please note that JavaScript numbers are only precise up to 53 bits.
         *
         * @method toNumber
         * @throws If the BigNumber instance cannot be safely stored in a JavaScript number
         * @returns The JavaScript number representation of the BigNumber instance.
         *
         * @example
         * const bn = new BigNumber('123456', 10, 'be');
         * bn.toNumber();
         */
        toNumber() {
            let ret = this.words[0];
            if (this.length === 2) {
                ret += this.words[1] * 0x4000000;
            }
            else if (this.length === 3 && this.words[2] === 0x01) {
                // NOTE: at this stage it is known that the top bit is set
                ret += 0x10000000000000 + (this.words[1] * 0x4000000);
            }
            else if (this.length > 2) {
                throw new Error('Number can only safely store up to 53 bits');
            }
            return (this.negative !== 0) ? -ret : ret;
        }
        /**
         * Converts the BigNumber instance to a JSON-formatted string.
         *
         * @method toJSON
         * @returns The JSON string representation of the BigNumber instance.
         *
         * @example
         * const bn = new BigNumber('123456', 10, 'be');
         * bn.toJSON();
         */
        toJSON() {
            return this.toString(16);
        }
        /**
         * An internal method to format the BigNumber instance into ArrayTypes of Little Endian Type.
         * This is a private method.
         *
         * @method toArrayLikeLE
         * @private
         * @param res - The resultant ArrayType instance
         * @param byteLength - The byte length to define the size of ArrayType
         */
        toArrayLikeLE(res, byteLength) {
            let position = 0;
            let carry = 0;
            for (let i = 0, shift = 0; i < this.length; i++) {
                const word = (this.words[i] << shift) | carry;
                res[position++] = word & 0xff;
                if (position < res.length) {
                    res[position++] = (word >> 8) & 0xff;
                }
                if (position < res.length) {
                    res[position++] = (word >> 16) & 0xff;
                }
                if (shift === 6) {
                    if (position < res.length) {
                        res[position++] = (word >> 24) & 0xff;
                    }
                    carry = 0;
                    shift = 0;
                }
                else {
                    carry = word >>> 24;
                    shift += 2;
                }
            }
            if (position < res.length) {
                res[position++] = carry;
                while (position < res.length) {
                    res[position++] = 0;
                }
            }
        }
        /**
         * An internal method to format the BigNumber instance into ArrayTypes of Big Endian Type.
         * This is a private method.
         *
         * @method toArrayLikeBE
         * @private
         * @param res - The resultant ArrayType instance
         * @param byteLength - The byte length to define the size of ArrayType
         */
        toArrayLikeBE(res, byteLength) {
            let position = res.length - 1;
            let carry = 0;
            for (let i = 0, shift = 0; i < this.length; i++) {
                const word = (this.words[i] << shift) | carry;
                res[position--] = word & 0xff;
                if (position >= 0) {
                    res[position--] = (word >> 8) & 0xff;
                }
                if (position >= 0) {
                    res[position--] = (word >> 16) & 0xff;
                }
                if (shift === 6) {
                    if (position >= 0) {
                        res[position--] = (word >> 24) & 0xff;
                    }
                    carry = 0;
                    shift = 0;
                }
                else {
                    carry = word >>> 24;
                    shift += 2;
                }
            }
            if (position >= 0) {
                res[position--] = carry;
                while (position >= 0) {
                    res[position--] = 0;
                }
            }
        }
        /**
         * Converts the BigNumber instance to a JavaScript number array.
         *
         * @method toArray
         * @param endian - The endian for converting BigNumber to array. Default value is 'be'.
         * @param length - The length for the resultant array. Default value is undefined.
         * @returns The JavaScript array representation of the BigNumber instance.
         *
         * @example
         * const bn = new BigNumber('123456', 10, 'be');
         * bn.toArray('be', 8);
         */
        toArray(endian = 'be', length) {
            this.strip();
            const byteLength = this.byteLength();
            const reqLength = length ?? Math.max(1, byteLength);
            this.assert(byteLength <= reqLength, 'byte array longer than desired length');
            this.assert(reqLength > 0, 'Requested array length <= 0');
            const res = new Array(reqLength);
            if (endian === 'le') {
                this.toArrayLikeLE(res, byteLength);
            }
            else {
                this.toArrayLikeBE(res, byteLength);
            }
            return res;
        }
        /**
         * A utility method to count the word bits.
         * This is a private method.
         *
         * @method countWordBits
         * @private
         * @param w - The input number to count the word bits.
         * @returns The number of word bits
         */
        countWordBits(w) {
            if (typeof Math.clz32 === 'function') {
                return 32 - Math.clz32(w);
            }
            let t = w;
            let r = 0;
            if (t >= 0x1000) {
                r += 13;
                t >>>= 13;
            }
            if (t >= 0x40) {
                r += 7;
                t >>>= 7;
            }
            if (t >= 0x8) {
                r += 4;
                t >>>= 4;
            }
            if (t >= 0x02) {
                r += 2;
                t >>>= 2;
            }
            return r + t;
        }
        /**
         * A utility method to compute the number of zero bits.
         * This is a private method.
         *
         * @method zeroWordBits
         * @private
         * @param w - The input number to count the zero bits.
         * @returns The number of zero bits
         */
        zeroWordBits(w) {
            // Short-cut
            if (w === 0)
                return 26;
            let t = w;
            let r = 0;
            if ((t & 0x1fff) === 0) {
                r += 13;
                t >>>= 13;
            }
            if ((t & 0x7f) === 0) {
                r += 7;
                t >>>= 7;
            }
            if ((t & 0xf) === 0) {
                r += 4;
                t >>>= 4;
            }
            if ((t & 0x3) === 0) {
                r += 2;
                t >>>= 2;
            }
            if ((t & 0x1) === 0) {
                r++;
            }
            return r;
        }
        /**
         * Returns the number of used bits in this big number.
         *
         * @method bitLength
         * @returns The number of used bits
         */
        bitLength() {
            const w = this.words[this.length - 1];
            const hi = this.countWordBits(w);
            return (this.length - 1) * 26 + hi;
        }
        /**
         * Convert a big number to a boolean array representing
         * a binary number, where each array index is a bit.
         * @static
         * @method toBitArray
         * @param num - The big number to convert.
         * @returns Returns an array of booleans representing
         * a binary number, with each array index being a bit.
         * @example
         * const BigNumber = require("./BigNumber");
         * const bn = new BigNumber('6'); // binary: 110
         * const bits = BigNumber.toBitArray(bn); // [1,1,0]
         */
        static toBitArray(num) {
            const w = new Array(num.bitLength());
            for (let bit = 0; bit < w.length; bit++) {
                const off = (bit / 26) | 0;
                const wbit = bit % 26;
                w[bit] = (num.words[off] >>> wbit) & 0x01;
            }
            return w;
        }
        /**
         * Convert this big number to a boolean array representing
         * a binary number, where each array index is a bit.
         * @method toBitArray
         * @returns Returns an array of booleans representing a binary number.
         *
         * @example
         * const BigNumber = require("./BigNumber");
         * const bn = new BigNumber('6'); // binary: 110
         * const bits = bn.toBitArray(); // [ 1, 1, 0 ]
         */
        toBitArray() {
            return BigNumber.toBitArray(this);
        }
        /**
         * Returns the number of trailing zero bits in the big number.
         * @method zeroBits
         * @returns Returns the number of trailing zero bits
         * in the binary representation of the big number.
         * @example
         * const BigNumber = require("./BigNumber");
         * const bn = new BigNumber('8'); // binary: 1000
         * const zeroBits = bn.zeroBits(); // 3
         */
        zeroBits() {
            if (this.isZero())
                return 0;
            let r = 0;
            for (let i = 0; i < this.length; i++) {
                const b = this.zeroWordBits(this.words[i]);
                r += b;
                if (b !== 26)
                    break;
            }
            return r;
        }
        /**
         * Get the byte length of the BigNumber
         *
         * @method byteLength
         * @returns Returns the byte length of the big number.
         * @example
         * const BigNumber = require("./BigNumber");
         * const bn = new BigNumber('1234');
         * const byteLen = bn.byteLength();
         */
        byteLength() {
            return Math.ceil(this.bitLength() / 8);
        }
        /**
         * Converts this big number to two's complement with a specified bit width.
         * @method toTwos
         * @param width - The bit width.
         * @returns Returns the two's complement of the big number.
         *
         * @example
         * const BigNumber = require("./BigNumber");
         * const bn = new BigNumber('-1234');
         * const twosComp = bn.toTwos(16);
         */
        toTwos(width) {
            if (this.negative !== 0) {
                return this.abs().inotn(width).iaddn(1);
            }
            return this.clone();
        }
        /**
         * Converts this big number from two's complement with a specified bit width.
         * @method fromTwos
         * @param width - The bit width.
         * @returns Returns the big number converted from two's complement.
         *
         * @example
         * const BigNumber = require("./BigNumber");
         * const bn = new BigNumber('-1234');
         * const fromTwos = bn.fromTwos(16);
         */
        fromTwos(width) {
            if (this.testn(width - 1)) {
                return this.notn(width).iaddn(1).ineg();
            }
            return this.clone();
        }
        /**
         * Checks if the big number is negative.
         * @method isNeg
         * @returns Returns true if the big number is negative, otherwise false.
         *
         * @example
         * const BigNumber = require("./BigNumber");
         * const bn = new BigNumber('-1234');
         * const isNegative = bn.isNeg(); // true
         */
        isNeg() {
            return this.negative !== 0;
        }
        /**
         * Negates the big number and returns a new instance.
         * @method neg
         * @returns Returns a new BigNumber that is the negation of this big number.
         *
         * @example
         * const BigNumber = require("./BigNumber");
         * const bn = new BigNumber('1234');
         * const neg = bn.neg(); // -1234
         */
        neg() {
            return this.clone().ineg();
        }
        /**
         * Negates the big number in-place.
         * @method ineg
         * @returns Returns this big number as the negation of itself.
         *
         * @example
         * const BigNumber = require("./BigNumber");
         * const bn = new BigNumber('1234');
         * bn.ineg(); // bn is now -1234
         */
        ineg() {
            if (!this.isZero()) {
                this.negative ^= 1;
            }
            return this;
        }
        /**
         * Performs a bitwise OR operation with another BigNumber and stores
         * the result in this BigNumber.
         * @method iuor
         * @param num - The other BigNumber.
         * @returns Returns this BigNumber after performing the bitwise OR operation.
         *
         * @example
         * const BigNumber = require("./BigNumber");
         * const bn1 = new BigNumber('10'); // binary: 1010
         * const bn2 = new(num: BigNumber): BigNumber BigNumber('6'); // binary: 0110
         * bn1.iuor(bn2); // now, bn1 binary: 1110
         */
        iuor(num) {
            while (this.length < num.length) {
                this.words[this.length++] = 0;
            }
            for (let i = 0; i < num.length; i++) {
                this.words[i] = this.words[i] | num.words[i];
            }
            return this.strip();
        }
        /**
         * Performs a bitwise OR operation with another BigNumber, considering
         * that neither of the numbers can be negative. Stores the result in this BigNumber.
         * @method ior
         * @param num - The other BigNumber.
         * @returns Returns this BigNumber after performing the bitwise OR operation.
         *
         * @example
         * const BigNumber = require("./BigNumber");
         * const bn1 = new BigNumber('10'); // binary: 1010
         * const bn2 = new BigNumber('6'); // binary: 0110
         * bn1.ior(bn2); // now, bn1 binary: 1110
         */
        ior(num) {
            this.assert((this.negative | num.negative) === 0);
            return this.iuor(num);
        }
        /**
         * Performs a bitwise OR operation on the current instance and given
         * BigNumber and returns a new BigNumber, in such a way that if either
         * the corresponding bit in the first operand or the second operand is
         * 1, then the output is also 1.
         *
         * @method or
         * @param num - The BigNumber to perform the bitwise OR operation with.
         * @returns Returns a new BigNumber resulting from the bitwise OR operation.
         *
         * @example
         * const num1 = new BigNumber('10');
         * const num2 = new BigNumber('20');
         * console.log(num1.or(num2).toString());
         */
        or(num) {
            if (this.length > num.length)
                return this.clone().ior(num);
            return num.clone().ior(this);
        }
        /**
         * Performs a bitwise OR operation on the current instance and given
         * BigNumber without considering signed bit(no negative values) and returns a new BigNumber,
         * similar to the `or` method.
         *
         * @method uor
         * @param num - The BigNumber to perform the bitwise OR operation with.
         * @returns Returns a new BigNumber resulting from the bitwise OR operation without sign consideration.
         *
         * @example
         * const num1 = new BigNumber('10');
         * const num2 = new BigNumber('20');
         * console.log(num1.uor(num2).toString());
         */
        uor(num) {
            if (this.length > num.length)
                return this.clone().iuor(num);
            return num.clone().iuor(this);
        }
        /**
         * Performs a bitwise AND operation in-place(this method changes the calling object)
         * on the current instance and given BigNumber such that it modifies the current
         * instance and keeps the bits set in the result only if the corresponding bit is set
         * in both operands.
         *
         * @method iuand
         * @param num - The BigNumber to perform the bitwise AND operation with.
         * @returns Returns the current BigNumber instance after performing the bitwise AND operation.
         *
         * @example
         * const num1 = new BigNumber('10');
         * const num2 = new BigNumber('20');
         * console.log(num1.iuand(num2).toString());
         */
        iuand(num) {
            const minLength = Math.min(this.length, num.length);
            for (let i = 0; i < minLength; i++) {
                this.words[i] = this.words[i] & num.words[i];
            }
            this.length = minLength;
            return this.strip();
        }
        /**
         * Performs an in-place operation that does a bitwise AND operation in-place,
         * on the current instance and given BigNumber such that it modifies the current
         * instance only if neither operand is negative. This method is similar to the iuand method but
         * checks for negative values before operation.
         *
         * @method iand
         * @param num - The BigNumber to perform the bitwise AND operation with.
         * @returns Returns the current BigNumber instance after performing the bitwise AND operation.
         *
         * @example
         * const num1 = new BigNumber('10');
         * const num2 = new BigNumber('20');
         * console.log(num1.iand(num2).toString());
         */
        iand(num) {
            this.assert((this.negative | num.negative) === 0);
            return this.iuand(num);
        }
        /**
         * Performs a bitwise AND operation that returns a new BigNumber, and keeps the bits
         * set in the result only if the corresponding bit is set in both operands.
         *
         * @method and
         * @param num - The BigNumber to perform the bitwise AND operation with.
         * @returns Returns new BigNumber resulting from the bitwise AND operation.
         *
         * @example
         * const num1 = new BigNumber('10');
         * const num2 = new BigNumber('20');
         * console.log(num1.and(num2).toString());
         */
        and(num) {
            if (this.length > num.length)
                return this.clone().iand(num);
            return num.clone().iand(this);
        }
        /**
         * Performs a bitwise AND operation without considering signed bit
         * (no negative values) which returns a new BigNumber, similar to the `and` method.
         *
         * @method uand
         * @param num - The BigNumber to perform the bitwise AND operation with.
         * @returns Returns new BigNumber resulting from the bitwise AND operation without sign consideration.
         *
         * @example
         * const num1 = new BigNumber('10');
         * const num2 = new BigNumber('20');
         * console.log(num1.uand(num2).toString());
         */
        uand(num) {
            if (this.length > num.length)
                return this.clone().iuand(num);
            return num.clone().iuand(this);
        }
        /**
         * Modifies the current instance by performing a bitwise XOR operation
         * in-place with the provided BigNumber. It keeps the bits set in the result only if the
         * corresponding bits in the operands are different.
         *
         * @method iuxor
         * @param num - The BigNumber to perform the bitwise XOR operation with.
         * @returns Returns the current BigNumber instance after performing the bitwise XOR operation.
         *
         * @example
         * const num1 = new BigNumber('10');
         * const num2 = new BigNumber('20');
         * console.log(num1.iuxor(num2).toString());
         */
        iuxor(num) {
            if (this.length > num.length) {
                for (let i = 0; i < num.length; i++) {
                    this.words[i] = this.words[i] ^ num.words[i];
                }
            }
            else {
                for (let i = 0; i < this.length; i++) {
                    this.words[i] = this.words[i] ^ num.words[i];
                }
                for (let i = this.length; i < num.length; i++) {
                    this.words[i] = num.words[i];
                }
                this.length = num.length;
            }
            return this.strip();
        }
        /**
         * Performs an in-place operation that does a bitwise XOR operation in-place,
         * on the current instance and given BigNumber such that it modifies the current
         * instance only if neither operand is negative. This method is similar to the iuxor method but
         * checks for negative values before operation.
         *
         * @method ixor
         * @param num - The BigNumber to perform the bitwise XOR operation with.
         * @returns Returns the current BigNumber instance after performing the bitwise XOR operation.
         *
         * @example
         * const num1 = new BigNumber('10');
         * const num2 = new BigNumber('20');
         * console.log(num1.ixor(num2).toString());
         */
        ixor(num) {
            this.assert((this.negative | num.negative) === 0, 'Neither number can be negative');
            return this.iuxor(num);
        }
        /**
         * Performs a bitwise XOR operation which returns a new BigNumber, and keeps the bits
         * set in the result only if the corresponding bits in the operands are different.
         *
         * @method xor
         * @param num - The BigNumber to perform the bitwise XOR operation with.
         * @returns Returns a new BigNumber resulting from the bitwise XOR operation.
         *
         * @example
         * const num1 = new BigNumber('10');
         * const num2 = new BigNumber('20');
         * console.log(num1.xor(num2).toString());
         */
        xor(num) {
            if (this.length > num.length)
                return this.clone().ixor(num);
            return num.clone().ixor(this);
        }
        /**
         * Performs an unsigned XOR operation on this BigNumber with the supplied BigNumber. Returns a new BigNumber.
         *
         * @method uxor
         * @param num - The BigNumber with which the unsigned bitwise XOR operation is to be performed.
         * @returns Returns a new BigNumber resulting from the unsigned bitwise XOR operation.
         *
         * @example
         * const num1 = new BigNumber('30');
         * const num2 = new BigNumber('40');
         * console.log(num1.uxor(num2).toString()); // Output will be the result of unsigned XOR operation
         */
        uxor(num) {
            if (this.length > num.length)
                return this.clone().iuxor(num);
            return num.clone().iuxor(this);
        }
        /**
         * In-place method that performs a bitwise NOT operation on a BigNumber up to a specified bit width.
         *
         * @method inotn
         * @param width - The number of bits to perform the NOT operation on.
         * @returns Returns the BigNumber after performing the bitwise NOT operation.
         *
         * @example
         * const num = new BigNumber('42');
         * num.inotn(10);
         * console.log(num.toString());
         */
        inotn(width) {
            this.assert(typeof width === 'number' && width >= 0, 'The width needs to be a number greater than zero');
            let bytesNeeded = Math.ceil(width / 26) | 0;
            const bitsLeft = width % 26;
            // Extend the number with leading zeroes
            this.expand(bytesNeeded);
            if (bitsLeft > 0) {
                bytesNeeded--;
            }
            // Handle complete words
            let i = 0;
            for (; i < bytesNeeded; i++) {
                this.words[i] = ~this.words[i] & 0x3ffffff;
            }
            // Handle the residue
            if (bitsLeft > 0) {
                this.words[i] = ~this.words[i] & (0x3ffffff >> (26 - bitsLeft));
            }
            // And remove leading zeroes
            return this.strip();
        }
        /**
         * Performs a bitwise NOT operation on a BigNumber up to a specified bit width. Returns a new BigNumber.
         *
         * @method notn
         * @param width - The number of bits to perform the NOT operation on.
         * @returns Returns a new BigNumber resulting from the bitwise NOT operation.
         *
         * @example
         * const num = new BigNumber('42');
         * const notnResult = num.notn(10);
         * console.log(notnResult.toString());
         */
        notn(width) {
            return this.clone().inotn(width);
        }
        /**
         * Set `bit` of `this` BigNumber. The `bit` is a position in the binary representation,
         * and `val` is the value to be set at that position (`0` or `1`).
         *
         * @method setn
         * @param bit - The bit position to set.
         * @param val - The value to set at the bit position.
         * @returns Returns the BigNumber after setting the value at the bit position.
         *
         * @example
         * const num = new BigNumber('42');
         * num.setn(2, 1);
         * console.log(num.toString());
         */
        setn(bit, val) {
            this.assert(typeof bit === 'number' && bit >= 0);
            const off = (bit / 26) | 0;
            const wbit = bit % 26;
            this.expand(off + 1);
            if (val === 1 || val === true) {
                this.words[off] = this.words[off] | (1 << wbit);
            }
            else {
                this.words[off] = this.words[off] & ~(1 << wbit);
            }
            return this.strip();
        }
        /**
         * Add `num` to `this` BigNumber in-place.
         *
         * @method iadd
         * @param num - The BigNumber to add to `this` BigNumber.
         * @returns Returns the BigNumber after performing the addition.
         *
         * @example
         * const num1 = new BigNumber('10');
         * num1.iadd(new BigNumber('20'));
         * console.log(num1.toString());
         */
        iadd(num) {
            let r;
            // negative + positive
            if (this.negative !== 0 && num.negative === 0) {
                this.negative = 0;
                r = this.isub(num);
                this.negative ^= 1;
                return this.normSign();
                // positive + negative
            }
            else if (this.negative === 0 && num.negative !== 0) {
                num.negative = 0;
                r = this.isub(num);
                num.negative = 1;
                return r.normSign();
            }
            // a.length > b.length
            let a, b;
            if (this.length > num.length) {
                /* eslint-disable @typescript-eslint/no-this-alias */
                a = this;
                b = num;
            }
            else {
                a = num;
                /* eslint-disable @typescript-eslint/no-this-alias */
                b = this;
            }
            let carry = 0;
            let i = 0;
            for (; i < b.length; i++) {
                r = (a.words[i] | 0) + (b.words[i] | 0) + carry;
                this.words[i] = r & 0x3ffffff;
                carry = r >>> 26;
            }
            for (; carry !== 0 && i < a.length; i++) {
                r = (a.words[i] | 0) + carry;
                this.words[i] = r & 0x3ffffff;
                carry = r >>> 26;
            }
            this.length = a.length;
            if (carry !== 0) {
                this.words[this.length] = carry;
                this.length++;
                // Copy the rest of the words
            }
            else if (a !== this) {
                for (; i < a.length; i++) {
                    this.words[i] = a.words[i];
                }
            }
            return this;
        }
        /**
         * Add `num` to `this` BigNumber.
         *
         * @method add
         * @param num - The BigNumber to add to `this` BigNumber.
         * @returns Returns a new BigNumber which is the result of the addition.
         *
         * @example
         * const num1 = new BigNumber('10');
         * const addResult = num1.add(new BigNumber('20'));
         * console.log(addResult.toString());
         */
        add(num) {
            let res;
            if (num.negative !== 0 && this.negative === 0) {
                num.negative = 0;
                res = this.sub(num);
                num.negative ^= 1;
                return res;
            }
            else if (num.negative === 0 && this.negative !== 0) {
                this.negative = 0;
                res = num.sub(this);
                this.negative = 1;
                return res;
            }
            if (this.length > num.length)
                return this.clone().iadd(num);
            return num.clone().iadd(this);
        }
        /**
         * Subtract `num` from `this` BigNumber in-place.
         *
         * @method isub
         * @param num - The BigNumber to be subtracted from `this` BigNumber.
         * @returns Returns the BigNumber after performing the subtraction.
         *
         * @example
         * const num1 = new BigNumber('20');
         * num1.isub(new BigNumber('10'));
         * console.log(num1.toString());
         */
        isub(num) {
            let r;
            // this - (-num) = this + num
            if (num.negative !== 0) {
                num.negative = 0;
                r = this.iadd(num);
                num.negative = 1;
                return r.normSign();
                // -this - num = -(this + num)
            }
            else if (this.negative !== 0) {
                this.negative = 0;
                this.iadd(num);
                this.negative = 1;
                return this.normSign();
            }
            // At this point both numbers are positive
            const cmp = this.cmp(num);
            // Optimization - zeroify
            if (cmp === 0) {
                this.negative = 0;
                this.length = 1;
                this.words[0] = 0;
                return this;
            }
            // a > b
            let a, b;
            if (cmp > 0) {
                /* eslint-disable @typescript-eslint/no-this-alias */
                a = this;
                b = num;
            }
            else {
                a = num;
                /* eslint-disable @typescript-eslint/no-this-alias */
                b = this;
            }
            let carry = 0;
            let i = 0;
            for (; i < b.length; i++) {
                r = (a.words[i] | 0) - (b.words[i] | 0) + carry;
                carry = r >> 26;
                this.words[i] = r & 0x3ffffff;
            }
            for (; carry !== 0 && i < a.length; i++) {
                r = (a.words[i] | 0) + carry;
                carry = r >> 26;
                this.words[i] = r & 0x3ffffff;
            }
            // Copy rest of the words
            if (carry === 0 && i < a.length && a !== this) {
                for (; i < a.length; i++) {
                    this.words[i] = a.words[i];
                }
            }
            this.length = Math.max(this.length, i);
            if (a !== this) {
                this.negative = 1;
            }
            return this.strip();
        }
        /**
         * Subtract `num` from `this` BigNumber.
         *
         * @method sub
         * @param num - The BigNumber to be subtracted from `this` BigNumber.
         * @returns Returns a new BigNumber which is the result of the subtraction.
         *
         * @example
         * const num1 = new BigNumber('20');
         * const subResult = num1.sub(new BigNumber('10'));
         * console.log(subResult.toString());
         */
        sub(num) {
            return this.clone().isub(num);
        }
        smallMulTo(self, num, out) {
            out.negative = num.negative ^ self.negative;
            let len = (self.length + num.length) | 0;
            out.length = len;
            len = (len - 1) | 0;
            // Peel one iteration (compiler can't do it, because of code complexity)
            let a = self.words[0] | 0;
            let b = num.words[0] | 0;
            let r = a * b;
            const lo = r & 0x3ffffff;
            let carry = (r / 0x4000000) | 0;
            out.words[0] = lo;
            let k = 1;
            for (; k < len; k++) {
                // Sum all words with the same `i + j = k` and accumulate `ncarry`,
                // note that ncarry could be >= 0x3ffffff
                let ncarry = carry >>> 26;
                let rword = carry & 0x3ffffff;
                const maxJ = Math.min(k, num.length - 1);
                for (let j = Math.max(0, k - self.length + 1); j <= maxJ; j++) {
                    const i = (k - j) | 0;
                    a = self.words[i] | 0;
                    b = num.words[j] | 0;
                    r = a * b + rword;
                    ncarry += (r / 0x4000000) | 0;
                    rword = r & 0x3ffffff;
                }
                out.words[k] = rword | 0;
                carry = ncarry | 0;
            }
            if (carry !== 0) {
                out.words[k] = carry | 0;
            }
            else {
                out.length--;
            }
            return out.strip();
        }
        comb10MulTo(self, num, out) {
            const a = self.words;
            const b = num.words;
            const o = out.words;
            let c = 0;
            let lo;
            let mid;
            let hi;
            const a0 = a[0] | 0;
            const al0 = a0 & 0x1fff;
            const ah0 = a0 >>> 13;
            const a1 = a[1] | 0;
            const al1 = a1 & 0x1fff;
            const ah1 = a1 >>> 13;
            const a2 = a[2] | 0;
            const al2 = a2 & 0x1fff;
            const ah2 = a2 >>> 13;
            const a3 = a[3] | 0;
            const al3 = a3 & 0x1fff;
            const ah3 = a3 >>> 13;
            const a4 = a[4] | 0;
            const al4 = a4 & 0x1fff;
            const ah4 = a4 >>> 13;
            const a5 = a[5] | 0;
            const al5 = a5 & 0x1fff;
            const ah5 = a5 >>> 13;
            const a6 = a[6] | 0;
            const al6 = a6 & 0x1fff;
            const ah6 = a6 >>> 13;
            const a7 = a[7] | 0;
            const al7 = a7 & 0x1fff;
            const ah7 = a7 >>> 13;
            const a8 = a[8] | 0;
            const al8 = a8 & 0x1fff;
            const ah8 = a8 >>> 13;
            const a9 = a[9] | 0;
            const al9 = a9 & 0x1fff;
            const ah9 = a9 >>> 13;
            const b0 = b[0] | 0;
            const bl0 = b0 & 0x1fff;
            const bh0 = b0 >>> 13;
            const b1 = b[1] | 0;
            const bl1 = b1 & 0x1fff;
            const bh1 = b1 >>> 13;
            const b2 = b[2] | 0;
            const bl2 = b2 & 0x1fff;
            const bh2 = b2 >>> 13;
            const b3 = b[3] | 0;
            const bl3 = b3 & 0x1fff;
            const bh3 = b3 >>> 13;
            const b4 = b[4] | 0;
            const bl4 = b4 & 0x1fff;
            const bh4 = b4 >>> 13;
            const b5 = b[5] | 0;
            const bl5 = b5 & 0x1fff;
            const bh5 = b5 >>> 13;
            const b6 = b[6] | 0;
            const bl6 = b6 & 0x1fff;
            const bh6 = b6 >>> 13;
            const b7 = b[7] | 0;
            const bl7 = b7 & 0x1fff;
            const bh7 = b7 >>> 13;
            const b8 = b[8] | 0;
            const bl8 = b8 & 0x1fff;
            const bh8 = b8 >>> 13;
            const b9 = b[9] | 0;
            const bl9 = b9 & 0x1fff;
            const bh9 = b9 >>> 13;
            out.negative = self.negative ^ num.negative;
            out.length = 19;
            /* k = 0 */
            lo = Math.imul(al0, bl0);
            mid = Math.imul(al0, bh0);
            mid = (mid + Math.imul(ah0, bl0)) | 0;
            hi = Math.imul(ah0, bh0);
            let w0 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w0 >>> 26)) | 0;
            w0 &= 0x3ffffff;
            /* k = 1 */
            lo = Math.imul(al1, bl0);
            mid = Math.imul(al1, bh0);
            mid = (mid + Math.imul(ah1, bl0)) | 0;
            hi = Math.imul(ah1, bh0);
            lo = (lo + Math.imul(al0, bl1)) | 0;
            mid = (mid + Math.imul(al0, bh1)) | 0;
            mid = (mid + Math.imul(ah0, bl1)) | 0;
            hi = (hi + Math.imul(ah0, bh1)) | 0;
            let w1 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w1 >>> 26)) | 0;
            w1 &= 0x3ffffff;
            /* k = 2 */
            lo = Math.imul(al2, bl0);
            mid = Math.imul(al2, bh0);
            mid = (mid + Math.imul(ah2, bl0)) | 0;
            hi = Math.imul(ah2, bh0);
            lo = (lo + Math.imul(al1, bl1)) | 0;
            mid = (mid + Math.imul(al1, bh1)) | 0;
            mid = (mid + Math.imul(ah1, bl1)) | 0;
            hi = (hi + Math.imul(ah1, bh1)) | 0;
            lo = (lo + Math.imul(al0, bl2)) | 0;
            mid = (mid + Math.imul(al0, bh2)) | 0;
            mid = (mid + Math.imul(ah0, bl2)) | 0;
            hi = (hi + Math.imul(ah0, bh2)) | 0;
            let w2 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w2 >>> 26)) | 0;
            w2 &= 0x3ffffff;
            /* k = 3 */
            lo = Math.imul(al3, bl0);
            mid = Math.imul(al3, bh0);
            mid = (mid + Math.imul(ah3, bl0)) | 0;
            hi = Math.imul(ah3, bh0);
            lo = (lo + Math.imul(al2, bl1)) | 0;
            mid = (mid + Math.imul(al2, bh1)) | 0;
            mid = (mid + Math.imul(ah2, bl1)) | 0;
            hi = (hi + Math.imul(ah2, bh1)) | 0;
            lo = (lo + Math.imul(al1, bl2)) | 0;
            mid = (mid + Math.imul(al1, bh2)) | 0;
            mid = (mid + Math.imul(ah1, bl2)) | 0;
            hi = (hi + Math.imul(ah1, bh2)) | 0;
            lo = (lo + Math.imul(al0, bl3)) | 0;
            mid = (mid + Math.imul(al0, bh3)) | 0;
            mid = (mid + Math.imul(ah0, bl3)) | 0;
            hi = (hi + Math.imul(ah0, bh3)) | 0;
            let w3 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w3 >>> 26)) | 0;
            w3 &= 0x3ffffff;
            /* k = 4 */
            lo = Math.imul(al4, bl0);
            mid = Math.imul(al4, bh0);
            mid = (mid + Math.imul(ah4, bl0)) | 0;
            hi = Math.imul(ah4, bh0);
            lo = (lo + Math.imul(al3, bl1)) | 0;
            mid = (mid + Math.imul(al3, bh1)) | 0;
            mid = (mid + Math.imul(ah3, bl1)) | 0;
            hi = (hi + Math.imul(ah3, bh1)) | 0;
            lo = (lo + Math.imul(al2, bl2)) | 0;
            mid = (mid + Math.imul(al2, bh2)) | 0;
            mid = (mid + Math.imul(ah2, bl2)) | 0;
            hi = (hi + Math.imul(ah2, bh2)) | 0;
            lo = (lo + Math.imul(al1, bl3)) | 0;
            mid = (mid + Math.imul(al1, bh3)) | 0;
            mid = (mid + Math.imul(ah1, bl3)) | 0;
            hi = (hi + Math.imul(ah1, bh3)) | 0;
            lo = (lo + Math.imul(al0, bl4)) | 0;
            mid = (mid + Math.imul(al0, bh4)) | 0;
            mid = (mid + Math.imul(ah0, bl4)) | 0;
            hi = (hi + Math.imul(ah0, bh4)) | 0;
            let w4 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w4 >>> 26)) | 0;
            w4 &= 0x3ffffff;
            /* k = 5 */
            lo = Math.imul(al5, bl0);
            mid = Math.imul(al5, bh0);
            mid = (mid + Math.imul(ah5, bl0)) | 0;
            hi = Math.imul(ah5, bh0);
            lo = (lo + Math.imul(al4, bl1)) | 0;
            mid = (mid + Math.imul(al4, bh1)) | 0;
            mid = (mid + Math.imul(ah4, bl1)) | 0;
            hi = (hi + Math.imul(ah4, bh1)) | 0;
            lo = (lo + Math.imul(al3, bl2)) | 0;
            mid = (mid + Math.imul(al3, bh2)) | 0;
            mid = (mid + Math.imul(ah3, bl2)) | 0;
            hi = (hi + Math.imul(ah3, bh2)) | 0;
            lo = (lo + Math.imul(al2, bl3)) | 0;
            mid = (mid + Math.imul(al2, bh3)) | 0;
            mid = (mid + Math.imul(ah2, bl3)) | 0;
            hi = (hi + Math.imul(ah2, bh3)) | 0;
            lo = (lo + Math.imul(al1, bl4)) | 0;
            mid = (mid + Math.imul(al1, bh4)) | 0;
            mid = (mid + Math.imul(ah1, bl4)) | 0;
            hi = (hi + Math.imul(ah1, bh4)) | 0;
            lo = (lo + Math.imul(al0, bl5)) | 0;
            mid = (mid + Math.imul(al0, bh5)) | 0;
            mid = (mid + Math.imul(ah0, bl5)) | 0;
            hi = (hi + Math.imul(ah0, bh5)) | 0;
            let w5 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w5 >>> 26)) | 0;
            w5 &= 0x3ffffff;
            /* k = 6 */
            lo = Math.imul(al6, bl0);
            mid = Math.imul(al6, bh0);
            mid = (mid + Math.imul(ah6, bl0)) | 0;
            hi = Math.imul(ah6, bh0);
            lo = (lo + Math.imul(al5, bl1)) | 0;
            mid = (mid + Math.imul(al5, bh1)) | 0;
            mid = (mid + Math.imul(ah5, bl1)) | 0;
            hi = (hi + Math.imul(ah5, bh1)) | 0;
            lo = (lo + Math.imul(al4, bl2)) | 0;
            mid = (mid + Math.imul(al4, bh2)) | 0;
            mid = (mid + Math.imul(ah4, bl2)) | 0;
            hi = (hi + Math.imul(ah4, bh2)) | 0;
            lo = (lo + Math.imul(al3, bl3)) | 0;
            mid = (mid + Math.imul(al3, bh3)) | 0;
            mid = (mid + Math.imul(ah3, bl3)) | 0;
            hi = (hi + Math.imul(ah3, bh3)) | 0;
            lo = (lo + Math.imul(al2, bl4)) | 0;
            mid = (mid + Math.imul(al2, bh4)) | 0;
            mid = (mid + Math.imul(ah2, bl4)) | 0;
            hi = (hi + Math.imul(ah2, bh4)) | 0;
            lo = (lo + Math.imul(al1, bl5)) | 0;
            mid = (mid + Math.imul(al1, bh5)) | 0;
            mid = (mid + Math.imul(ah1, bl5)) | 0;
            hi = (hi + Math.imul(ah1, bh5)) | 0;
            lo = (lo + Math.imul(al0, bl6)) | 0;
            mid = (mid + Math.imul(al0, bh6)) | 0;
            mid = (mid + Math.imul(ah0, bl6)) | 0;
            hi = (hi + Math.imul(ah0, bh6)) | 0;
            let w6 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w6 >>> 26)) | 0;
            w6 &= 0x3ffffff;
            /* k = 7 */
            lo = Math.imul(al7, bl0);
            mid = Math.imul(al7, bh0);
            mid = (mid + Math.imul(ah7, bl0)) | 0;
            hi = Math.imul(ah7, bh0);
            lo = (lo + Math.imul(al6, bl1)) | 0;
            mid = (mid + Math.imul(al6, bh1)) | 0;
            mid = (mid + Math.imul(ah6, bl1)) | 0;
            hi = (hi + Math.imul(ah6, bh1)) | 0;
            lo = (lo + Math.imul(al5, bl2)) | 0;
            mid = (mid + Math.imul(al5, bh2)) | 0;
            mid = (mid + Math.imul(ah5, bl2)) | 0;
            hi = (hi + Math.imul(ah5, bh2)) | 0;
            lo = (lo + Math.imul(al4, bl3)) | 0;
            mid = (mid + Math.imul(al4, bh3)) | 0;
            mid = (mid + Math.imul(ah4, bl3)) | 0;
            hi = (hi + Math.imul(ah4, bh3)) | 0;
            lo = (lo + Math.imul(al3, bl4)) | 0;
            mid = (mid + Math.imul(al3, bh4)) | 0;
            mid = (mid + Math.imul(ah3, bl4)) | 0;
            hi = (hi + Math.imul(ah3, bh4)) | 0;
            lo = (lo + Math.imul(al2, bl5)) | 0;
            mid = (mid + Math.imul(al2, bh5)) | 0;
            mid = (mid + Math.imul(ah2, bl5)) | 0;
            hi = (hi + Math.imul(ah2, bh5)) | 0;
            lo = (lo + Math.imul(al1, bl6)) | 0;
            mid = (mid + Math.imul(al1, bh6)) | 0;
            mid = (mid + Math.imul(ah1, bl6)) | 0;
            hi = (hi + Math.imul(ah1, bh6)) | 0;
            lo = (lo + Math.imul(al0, bl7)) | 0;
            mid = (mid + Math.imul(al0, bh7)) | 0;
            mid = (mid + Math.imul(ah0, bl7)) | 0;
            hi = (hi + Math.imul(ah0, bh7)) | 0;
            let w7 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w7 >>> 26)) | 0;
            w7 &= 0x3ffffff;
            /* k = 8 */
            lo = Math.imul(al8, bl0);
            mid = Math.imul(al8, bh0);
            mid = (mid + Math.imul(ah8, bl0)) | 0;
            hi = Math.imul(ah8, bh0);
            lo = (lo + Math.imul(al7, bl1)) | 0;
            mid = (mid + Math.imul(al7, bh1)) | 0;
            mid = (mid + Math.imul(ah7, bl1)) | 0;
            hi = (hi + Math.imul(ah7, bh1)) | 0;
            lo = (lo + Math.imul(al6, bl2)) | 0;
            mid = (mid + Math.imul(al6, bh2)) | 0;
            mid = (mid + Math.imul(ah6, bl2)) | 0;
            hi = (hi + Math.imul(ah6, bh2)) | 0;
            lo = (lo + Math.imul(al5, bl3)) | 0;
            mid = (mid + Math.imul(al5, bh3)) | 0;
            mid = (mid + Math.imul(ah5, bl3)) | 0;
            hi = (hi + Math.imul(ah5, bh3)) | 0;
            lo = (lo + Math.imul(al4, bl4)) | 0;
            mid = (mid + Math.imul(al4, bh4)) | 0;
            mid = (mid + Math.imul(ah4, bl4)) | 0;
            hi = (hi + Math.imul(ah4, bh4)) | 0;
            lo = (lo + Math.imul(al3, bl5)) | 0;
            mid = (mid + Math.imul(al3, bh5)) | 0;
            mid = (mid + Math.imul(ah3, bl5)) | 0;
            hi = (hi + Math.imul(ah3, bh5)) | 0;
            lo = (lo + Math.imul(al2, bl6)) | 0;
            mid = (mid + Math.imul(al2, bh6)) | 0;
            mid = (mid + Math.imul(ah2, bl6)) | 0;
            hi = (hi + Math.imul(ah2, bh6)) | 0;
            lo = (lo + Math.imul(al1, bl7)) | 0;
            mid = (mid + Math.imul(al1, bh7)) | 0;
            mid = (mid + Math.imul(ah1, bl7)) | 0;
            hi = (hi + Math.imul(ah1, bh7)) | 0;
            lo = (lo + Math.imul(al0, bl8)) | 0;
            mid = (mid + Math.imul(al0, bh8)) | 0;
            mid = (mid + Math.imul(ah0, bl8)) | 0;
            hi = (hi + Math.imul(ah0, bh8)) | 0;
            let w8 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w8 >>> 26)) | 0;
            w8 &= 0x3ffffff;
            /* k = 9 */
            lo = Math.imul(al9, bl0);
            mid = Math.imul(al9, bh0);
            mid = (mid + Math.imul(ah9, bl0)) | 0;
            hi = Math.imul(ah9, bh0);
            lo = (lo + Math.imul(al8, bl1)) | 0;
            mid = (mid + Math.imul(al8, bh1)) | 0;
            mid = (mid + Math.imul(ah8, bl1)) | 0;
            hi = (hi + Math.imul(ah8, bh1)) | 0;
            lo = (lo + Math.imul(al7, bl2)) | 0;
            mid = (mid + Math.imul(al7, bh2)) | 0;
            mid = (mid + Math.imul(ah7, bl2)) | 0;
            hi = (hi + Math.imul(ah7, bh2)) | 0;
            lo = (lo + Math.imul(al6, bl3)) | 0;
            mid = (mid + Math.imul(al6, bh3)) | 0;
            mid = (mid + Math.imul(ah6, bl3)) | 0;
            hi = (hi + Math.imul(ah6, bh3)) | 0;
            lo = (lo + Math.imul(al5, bl4)) | 0;
            mid = (mid + Math.imul(al5, bh4)) | 0;
            mid = (mid + Math.imul(ah5, bl4)) | 0;
            hi = (hi + Math.imul(ah5, bh4)) | 0;
            lo = (lo + Math.imul(al4, bl5)) | 0;
            mid = (mid + Math.imul(al4, bh5)) | 0;
            mid = (mid + Math.imul(ah4, bl5)) | 0;
            hi = (hi + Math.imul(ah4, bh5)) | 0;
            lo = (lo + Math.imul(al3, bl6)) | 0;
            mid = (mid + Math.imul(al3, bh6)) | 0;
            mid = (mid + Math.imul(ah3, bl6)) | 0;
            hi = (hi + Math.imul(ah3, bh6)) | 0;
            lo = (lo + Math.imul(al2, bl7)) | 0;
            mid = (mid + Math.imul(al2, bh7)) | 0;
            mid = (mid + Math.imul(ah2, bl7)) | 0;
            hi = (hi + Math.imul(ah2, bh7)) | 0;
            lo = (lo + Math.imul(al1, bl8)) | 0;
            mid = (mid + Math.imul(al1, bh8)) | 0;
            mid = (mid + Math.imul(ah1, bl8)) | 0;
            hi = (hi + Math.imul(ah1, bh8)) | 0;
            lo = (lo + Math.imul(al0, bl9)) | 0;
            mid = (mid + Math.imul(al0, bh9)) | 0;
            mid = (mid + Math.imul(ah0, bl9)) | 0;
            hi = (hi + Math.imul(ah0, bh9)) | 0;
            let w9 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w9 >>> 26)) | 0;
            w9 &= 0x3ffffff;
            /* k = 10 */
            lo = Math.imul(al9, bl1);
            mid = Math.imul(al9, bh1);
            mid = (mid + Math.imul(ah9, bl1)) | 0;
            hi = Math.imul(ah9, bh1);
            lo = (lo + Math.imul(al8, bl2)) | 0;
            mid = (mid + Math.imul(al8, bh2)) | 0;
            mid = (mid + Math.imul(ah8, bl2)) | 0;
            hi = (hi + Math.imul(ah8, bh2)) | 0;
            lo = (lo + Math.imul(al7, bl3)) | 0;
            mid = (mid + Math.imul(al7, bh3)) | 0;
            mid = (mid + Math.imul(ah7, bl3)) | 0;
            hi = (hi + Math.imul(ah7, bh3)) | 0;
            lo = (lo + Math.imul(al6, bl4)) | 0;
            mid = (mid + Math.imul(al6, bh4)) | 0;
            mid = (mid + Math.imul(ah6, bl4)) | 0;
            hi = (hi + Math.imul(ah6, bh4)) | 0;
            lo = (lo + Math.imul(al5, bl5)) | 0;
            mid = (mid + Math.imul(al5, bh5)) | 0;
            mid = (mid + Math.imul(ah5, bl5)) | 0;
            hi = (hi + Math.imul(ah5, bh5)) | 0;
            lo = (lo + Math.imul(al4, bl6)) | 0;
            mid = (mid + Math.imul(al4, bh6)) | 0;
            mid = (mid + Math.imul(ah4, bl6)) | 0;
            hi = (hi + Math.imul(ah4, bh6)) | 0;
            lo = (lo + Math.imul(al3, bl7)) | 0;
            mid = (mid + Math.imul(al3, bh7)) | 0;
            mid = (mid + Math.imul(ah3, bl7)) | 0;
            hi = (hi + Math.imul(ah3, bh7)) | 0;
            lo = (lo + Math.imul(al2, bl8)) | 0;
            mid = (mid + Math.imul(al2, bh8)) | 0;
            mid = (mid + Math.imul(ah2, bl8)) | 0;
            hi = (hi + Math.imul(ah2, bh8)) | 0;
            lo = (lo + Math.imul(al1, bl9)) | 0;
            mid = (mid + Math.imul(al1, bh9)) | 0;
            mid = (mid + Math.imul(ah1, bl9)) | 0;
            hi = (hi + Math.imul(ah1, bh9)) | 0;
            let w10 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w10 >>> 26)) | 0;
            w10 &= 0x3ffffff;
            /* k = 11 */
            lo = Math.imul(al9, bl2);
            mid = Math.imul(al9, bh2);
            mid = (mid + Math.imul(ah9, bl2)) | 0;
            hi = Math.imul(ah9, bh2);
            lo = (lo + Math.imul(al8, bl3)) | 0;
            mid = (mid + Math.imul(al8, bh3)) | 0;
            mid = (mid + Math.imul(ah8, bl3)) | 0;
            hi = (hi + Math.imul(ah8, bh3)) | 0;
            lo = (lo + Math.imul(al7, bl4)) | 0;
            mid = (mid + Math.imul(al7, bh4)) | 0;
            mid = (mid + Math.imul(ah7, bl4)) | 0;
            hi = (hi + Math.imul(ah7, bh4)) | 0;
            lo = (lo + Math.imul(al6, bl5)) | 0;
            mid = (mid + Math.imul(al6, bh5)) | 0;
            mid = (mid + Math.imul(ah6, bl5)) | 0;
            hi = (hi + Math.imul(ah6, bh5)) | 0;
            lo = (lo + Math.imul(al5, bl6)) | 0;
            mid = (mid + Math.imul(al5, bh6)) | 0;
            mid = (mid + Math.imul(ah5, bl6)) | 0;
            hi = (hi + Math.imul(ah5, bh6)) | 0;
            lo = (lo + Math.imul(al4, bl7)) | 0;
            mid = (mid + Math.imul(al4, bh7)) | 0;
            mid = (mid + Math.imul(ah4, bl7)) | 0;
            hi = (hi + Math.imul(ah4, bh7)) | 0;
            lo = (lo + Math.imul(al3, bl8)) | 0;
            mid = (mid + Math.imul(al3, bh8)) | 0;
            mid = (mid + Math.imul(ah3, bl8)) | 0;
            hi = (hi + Math.imul(ah3, bh8)) | 0;
            lo = (lo + Math.imul(al2, bl9)) | 0;
            mid = (mid + Math.imul(al2, bh9)) | 0;
            mid = (mid + Math.imul(ah2, bl9)) | 0;
            hi = (hi + Math.imul(ah2, bh9)) | 0;
            let w11 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w11 >>> 26)) | 0;
            w11 &= 0x3ffffff;
            /* k = 12 */
            lo = Math.imul(al9, bl3);
            mid = Math.imul(al9, bh3);
            mid = (mid + Math.imul(ah9, bl3)) | 0;
            hi = Math.imul(ah9, bh3);
            lo = (lo + Math.imul(al8, bl4)) | 0;
            mid = (mid + Math.imul(al8, bh4)) | 0;
            mid = (mid + Math.imul(ah8, bl4)) | 0;
            hi = (hi + Math.imul(ah8, bh4)) | 0;
            lo = (lo + Math.imul(al7, bl5)) | 0;
            mid = (mid + Math.imul(al7, bh5)) | 0;
            mid = (mid + Math.imul(ah7, bl5)) | 0;
            hi = (hi + Math.imul(ah7, bh5)) | 0;
            lo = (lo + Math.imul(al6, bl6)) | 0;
            mid = (mid + Math.imul(al6, bh6)) | 0;
            mid = (mid + Math.imul(ah6, bl6)) | 0;
            hi = (hi + Math.imul(ah6, bh6)) | 0;
            lo = (lo + Math.imul(al5, bl7)) | 0;
            mid = (mid + Math.imul(al5, bh7)) | 0;
            mid = (mid + Math.imul(ah5, bl7)) | 0;
            hi = (hi + Math.imul(ah5, bh7)) | 0;
            lo = (lo + Math.imul(al4, bl8)) | 0;
            mid = (mid + Math.imul(al4, bh8)) | 0;
            mid = (mid + Math.imul(ah4, bl8)) | 0;
            hi = (hi + Math.imul(ah4, bh8)) | 0;
            lo = (lo + Math.imul(al3, bl9)) | 0;
            mid = (mid + Math.imul(al3, bh9)) | 0;
            mid = (mid + Math.imul(ah3, bl9)) | 0;
            hi = (hi + Math.imul(ah3, bh9)) | 0;
            let w12 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w12 >>> 26)) | 0;
            w12 &= 0x3ffffff;
            /* k = 13 */
            lo = Math.imul(al9, bl4);
            mid = Math.imul(al9, bh4);
            mid = (mid + Math.imul(ah9, bl4)) | 0;
            hi = Math.imul(ah9, bh4);
            lo = (lo + Math.imul(al8, bl5)) | 0;
            mid = (mid + Math.imul(al8, bh5)) | 0;
            mid = (mid + Math.imul(ah8, bl5)) | 0;
            hi = (hi + Math.imul(ah8, bh5)) | 0;
            lo = (lo + Math.imul(al7, bl6)) | 0;
            mid = (mid + Math.imul(al7, bh6)) | 0;
            mid = (mid + Math.imul(ah7, bl6)) | 0;
            hi = (hi + Math.imul(ah7, bh6)) | 0;
            lo = (lo + Math.imul(al6, bl7)) | 0;
            mid = (mid + Math.imul(al6, bh7)) | 0;
            mid = (mid + Math.imul(ah6, bl7)) | 0;
            hi = (hi + Math.imul(ah6, bh7)) | 0;
            lo = (lo + Math.imul(al5, bl8)) | 0;
            mid = (mid + Math.imul(al5, bh8)) | 0;
            mid = (mid + Math.imul(ah5, bl8)) | 0;
            hi = (hi + Math.imul(ah5, bh8)) | 0;
            lo = (lo + Math.imul(al4, bl9)) | 0;
            mid = (mid + Math.imul(al4, bh9)) | 0;
            mid = (mid + Math.imul(ah4, bl9)) | 0;
            hi = (hi + Math.imul(ah4, bh9)) | 0;
            let w13 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w13 >>> 26)) | 0;
            w13 &= 0x3ffffff;
            /* k = 14 */
            lo = Math.imul(al9, bl5);
            mid = Math.imul(al9, bh5);
            mid = (mid + Math.imul(ah9, bl5)) | 0;
            hi = Math.imul(ah9, bh5);
            lo = (lo + Math.imul(al8, bl6)) | 0;
            mid = (mid + Math.imul(al8, bh6)) | 0;
            mid = (mid + Math.imul(ah8, bl6)) | 0;
            hi = (hi + Math.imul(ah8, bh6)) | 0;
            lo = (lo + Math.imul(al7, bl7)) | 0;
            mid = (mid + Math.imul(al7, bh7)) | 0;
            mid = (mid + Math.imul(ah7, bl7)) | 0;
            hi = (hi + Math.imul(ah7, bh7)) | 0;
            lo = (lo + Math.imul(al6, bl8)) | 0;
            mid = (mid + Math.imul(al6, bh8)) | 0;
            mid = (mid + Math.imul(ah6, bl8)) | 0;
            hi = (hi + Math.imul(ah6, bh8)) | 0;
            lo = (lo + Math.imul(al5, bl9)) | 0;
            mid = (mid + Math.imul(al5, bh9)) | 0;
            mid = (mid + Math.imul(ah5, bl9)) | 0;
            hi = (hi + Math.imul(ah5, bh9)) | 0;
            let w14 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w14 >>> 26)) | 0;
            w14 &= 0x3ffffff;
            /* k = 15 */
            lo = Math.imul(al9, bl6);
            mid = Math.imul(al9, bh6);
            mid = (mid + Math.imul(ah9, bl6)) | 0;
            hi = Math.imul(ah9, bh6);
            lo = (lo + Math.imul(al8, bl7)) | 0;
            mid = (mid + Math.imul(al8, bh7)) | 0;
            mid = (mid + Math.imul(ah8, bl7)) | 0;
            hi = (hi + Math.imul(ah8, bh7)) | 0;
            lo = (lo + Math.imul(al7, bl8)) | 0;
            mid = (mid + Math.imul(al7, bh8)) | 0;
            mid = (mid + Math.imul(ah7, bl8)) | 0;
            hi = (hi + Math.imul(ah7, bh8)) | 0;
            lo = (lo + Math.imul(al6, bl9)) | 0;
            mid = (mid + Math.imul(al6, bh9)) | 0;
            mid = (mid + Math.imul(ah6, bl9)) | 0;
            hi = (hi + Math.imul(ah6, bh9)) | 0;
            let w15 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w15 >>> 26)) | 0;
            w15 &= 0x3ffffff;
            /* k = 16 */
            lo = Math.imul(al9, bl7);
            mid = Math.imul(al9, bh7);
            mid = (mid + Math.imul(ah9, bl7)) | 0;
            hi = Math.imul(ah9, bh7);
            lo = (lo + Math.imul(al8, bl8)) | 0;
            mid = (mid + Math.imul(al8, bh8)) | 0;
            mid = (mid + Math.imul(ah8, bl8)) | 0;
            hi = (hi + Math.imul(ah8, bh8)) | 0;
            lo = (lo + Math.imul(al7, bl9)) | 0;
            mid = (mid + Math.imul(al7, bh9)) | 0;
            mid = (mid + Math.imul(ah7, bl9)) | 0;
            hi = (hi + Math.imul(ah7, bh9)) | 0;
            let w16 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w16 >>> 26)) | 0;
            w16 &= 0x3ffffff;
            /* k = 17 */
            lo = Math.imul(al9, bl8);
            mid = Math.imul(al9, bh8);
            mid = (mid + Math.imul(ah9, bl8)) | 0;
            hi = Math.imul(ah9, bh8);
            lo = (lo + Math.imul(al8, bl9)) | 0;
            mid = (mid + Math.imul(al8, bh9)) | 0;
            mid = (mid + Math.imul(ah8, bl9)) | 0;
            hi = (hi + Math.imul(ah8, bh9)) | 0;
            let w17 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w17 >>> 26)) | 0;
            w17 &= 0x3ffffff;
            /* k = 18 */
            lo = Math.imul(al9, bl9);
            mid = Math.imul(al9, bh9);
            mid = (mid + Math.imul(ah9, bl9)) | 0;
            hi = Math.imul(ah9, bh9);
            let w18 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
            c = (((hi + (mid >>> 13)) | 0) + (w18 >>> 26)) | 0;
            w18 &= 0x3ffffff;
            o[0] = w0;
            o[1] = w1;
            o[2] = w2;
            o[3] = w3;
            o[4] = w4;
            o[5] = w5;
            o[6] = w6;
            o[7] = w7;
            o[8] = w8;
            o[9] = w9;
            o[10] = w10;
            o[11] = w11;
            o[12] = w12;
            o[13] = w13;
            o[14] = w14;
            o[15] = w15;
            o[16] = w16;
            o[17] = w17;
            o[18] = w18;
            if (c !== 0) {
                o[19] = c;
                out.length++;
            }
            return out;
        }
        bigMulTo(self, num, out) {
            out.negative = num.negative ^ self.negative;
            out.length = self.length + num.length;
            let carry = 0;
            let hncarry = 0;
            let k = 0;
            for (; k < out.length - 1; k++) {
                // Sum all words with the same `i + j = k` and accumulate `ncarry`,
                // note that ncarry could be >= 0x3ffffff
                let ncarry = hncarry;
                hncarry = 0;
                let rword = carry & 0x3ffffff;
                const maxJ = Math.min(k, num.length - 1);
                for (let j = Math.max(0, k - self.length + 1); j <= maxJ; j++) {
                    const i = k - j;
                    const a = self.words[i] | 0;
                    const b = num.words[j] | 0;
                    const r = a * b;
                    let lo = r & 0x3ffffff;
                    ncarry = (ncarry + ((r / 0x4000000) | 0)) | 0;
                    lo = (lo + rword) | 0;
                    rword = lo & 0x3ffffff;
                    ncarry = (ncarry + (lo >>> 26)) | 0;
                    hncarry += ncarry >>> 26;
                    ncarry &= 0x3ffffff;
                }
                out.words[k] = rword;
                carry = ncarry;
                ncarry = hncarry;
            }
            if (carry !== 0) {
                out.words[k] = carry;
            }
            else {
                out.length--;
            }
            return out.strip();
        }
        /**
         * Performs multiplication between the BigNumber instance and a given BigNumber.
         * It chooses the multiplication method based on the lengths of the numbers to optimize execution time.
         *
         * @method mulTo
         * @param num - The BigNumber multiply with.
         * @param out - The BigNumber where to store the result.
         * @returns The BigNumber resulting from the multiplication operation.
         *
         * @example
         * const bn1 = new BigNumber('12345');
         * const bn2 = new BigNumber('23456');
         * const output = new BigNumber();
         * bn1.mulTo(bn2, output);
         */
        mulTo(num, out) {
            let res;
            const len = this.length + num.length;
            if (this.length === 10 && num.length === 10) {
                res = this.comb10MulTo(this, num, out);
            }
            else if (len < 63) {
                res = this.smallMulTo(this, num, out);
            }
            else {
                res = this.bigMulTo(this, num, out);
            }
            return res;
        }
        /**
         * Performs multiplication between the BigNumber instance and a given BigNumber.
         * It creates a new BigNumber to store the result.
         *
         * @method mul
         * @param num - The BigNumber to multiply with.
         * @returns The BigNumber resulting from the multiplication operation.
         *
         * @example
         * const bn1 = new BigNumber('12345');
         * const bn2 = new BigNumber('23456');
         * const result = bn1.mul(bn2);
         */
        mul(num) {
            const out = new BigNumber();
            out.words = new Array(this.length + num.length);
            return this.mulTo(num, out);
        }
        /**
         * Performs an in-place multiplication of the BigNumber instance by a given BigNumber.
         *
         * @method imul
         * @param num - The BigNumber to multiply with.
         * @returns The BigNumber itself after the multiplication.
         *
         * @example
         * const bn1 = new BigNumber('12345');
         * const bn2 = new BigNumber('23456');
         * bn1.imul(bn2);
         */
        imul(num) {
            return this.clone().mulTo(num, this);
        }
        /**
         * Performs an in-place multiplication of the BigNumber instance by a number.
         * This method asserts the input to be a number less than 0x4000000 to prevent overflowing.
         * If negavtive number is provided, the resulting BigNumber will be inversely negative.
         *
         * @method imuln
         * @param num - The number to multiply with.
         * @returns The BigNumber itself after the multiplication.
         *
         * @example
         * const bn = new BigNumber('12345');
         * bn.imuln(23456);
         */
        imuln(num) {
            const isNegNum = num < 0;
            if (isNegNum)
                num = -num;
            this.assert(typeof num === 'number');
            this.assert(num < 0x4000000);
            // Carry
            let carry = 0;
            let i = 0;
            for (; i < this.length; i++) {
                const w = (this.words[i] | 0) * num;
                const lo = (w & 0x3ffffff) + (carry & 0x3ffffff);
                carry >>= 26;
                carry += (w / 0x4000000) | 0;
                // NOTE: lo is 27bit maximum
                carry += lo >>> 26;
                this.words[i] = lo & 0x3ffffff;
            }
            if (carry !== 0) {
                this.words[i] = carry;
                this.length++;
            }
            return isNegNum ? this.ineg() : this;
        }
        /**
         * Performs multiplication between the BigNumber instance and a number.
         * It performs the multiplication operation in-place to a cloned BigNumber.
         *
         * @method muln
         * @param num - The number to multiply with.
         * @returns The resulting BigNumber from the multiplication operation.
         *
         * @example
         * const bn = new BigNumber('12345');
         * const result = bn.muln(23456);
         */
        muln(num) {
            return this.clone().imuln(num);
        }
        /**
         * Squares the BigNumber instance.
         *
         * @method sqr
         * @returns The BigNumber squared.
         *
         * @example
         * const bn = new BigNumber('12345');
         * const result = bn.sqr();
         */
        sqr() {
            return this.mul(this);
        }
        /**
         * Performs in-place multiplication of the BigNumber instance by itself.
         *
         * @method isqr
         * @returns The result of multiplying the BigNumber instance by itself.
         *
         * @example
         * let myNumber = new BigNumber(4);
         * myNumber.isqr(); // Returns BigNumber of value 16
         */
        isqr() {
            return this.imul(this.clone());
        }
        /**
         * Raises the BigNumber instance to the power of the specified BigNumber.
         *
         * @method pow
         * @param num - The exponent to raise the BigNumber instance to.
         * @returns The result of raising the BigNumber instance to the power of num.
         *
         * @example
         * let base = new BigNumber(2);
         * let exponent = new BigNumber(3);
         * base.pow(exponent); // Returns BigNumber of value 8
         */
        pow(num) {
            const w = BigNumber.toBitArray(num);
            if (w.length === 0)
                return new BigNumber(1);
            // Skip leading zeroes
            /* eslint-disable @typescript-eslint/no-this-alias */
            let res = this;
            let i = 0;
            for (; i < w.length; i++, res = res.sqr()) {
                if (w[i] !== 0)
                    break;
            }
            if (++i < w.length) {
                for (let q = res.sqr(); i < w.length; i++, q = q.sqr()) {
                    if (w[i] === 0)
                        continue;
                    res = res.mul(q);
                }
            }
            return res;
        }
        /**
         * Performs in-place bitwise left shift operation on the BigNumber instance.
         *
         * @method iushln
         * @param bits - The number of positions to shift.
         * @returns The BigNumber instance after performing the shift operation.
         *
         * @example
         * let myNumber = new BigNumber(4);
         * myNumber.iushln(2); // Returns BigNumber of value 16
         */
        iushln(bits) {
            this.assert(typeof bits === 'number' && bits >= 0);
            const r = bits % 26;
            const s = (bits - r) / 26;
            const carryMask = (0x3ffffff >>> (26 - r)) << (26 - r);
            let i;
            if (r !== 0) {
                let carry = 0;
                for (i = 0; i < this.length; i++) {
                    const newCarry = this.words[i] & carryMask;
                    const c = ((this.words[i] | 0) - newCarry) << r;
                    this.words[i] = c | carry;
                    carry = newCarry >>> (26 - r);
                }
                if (carry !== 0) {
                    this.words[i] = carry;
                    this.length++;
                }
            }
            if (s !== 0) {
                for (i = this.length - 1; i >= 0; i--) {
                    this.words[i + s] = this.words[i];
                }
                for (i = 0; i < s; i++) {
                    this.words[i] = 0;
                }
                this.length += s;
            }
            return this.strip();
        }
        /**
         * Performs an in-place left shift operation on the BigNumber instance only if it is non-negative.
         *
         * @method ishln
         * @param bits - The number of positions to shift.
         * @returns The BigNumber instance after performing the shift operation.
         *
         * @example
         * let myNumber = new BigNumber(4);
         * myNumber.ishln(2); // Returns BigNumber of value 16
         */
        ishln(bits) {
            this.assert(this.negative === 0);
            return this.iushln(bits);
        }
        /**
         * Performs an in-place unsigned bitwise right shift operation on the BigNumber instance.
         *
         * @method iushrn
         * @param bits - The number of positions to shift.
         * @param hint - Lowest bit before trailing zeroes.
         * @param extended - To be filled with the bits that are shifted out.
         * @returns The BigNumber instance after performing the shift operation.
         *
         * @example
         * let myNumber = new BigNumber(16);
         * myNumber.iushrn(2); // Returns BigNumber of value 4
         */
        iushrn(bits, hint, extended) {
            this.assert(typeof bits === 'number' && bits >= 0);
            let h;
            if (typeof hint === 'number' && hint !== 0) {
                h = (hint - (hint % 26)) / 26;
            }
            else {
                h = 0;
            }
            const r = bits % 26;
            const s = Math.min((bits - r) / 26, this.length);
            const mask = 0x3ffffff ^ ((0x3ffffff >>> r) << r);
            const maskedWords = extended;
            h -= s;
            h = Math.max(0, h);
            // Extended mode, copy masked part
            let i = 0;
            if (typeof maskedWords !== 'undefined') {
                for (; i < s; i++) {
                    maskedWords.words[i] = this.words[i];
                }
                maskedWords.length = s;
            }
            if (s === 0) ;
            else if (this.length > s) {
                this.length -= s;
                for (i = 0; i < this.length; i++) {
                    this.words[i] = this.words[i + s];
                }
            }
            else {
                this.words[0] = 0;
                this.length = 1;
            }
            let carry = 0;
            for (i = this.length - 1; i >= 0 && (carry !== 0 || i >= h); i--) {
                const word = this.words[i] | 0;
                this.words[i] = (carry << (26 - r)) | (word >>> r);
                carry = word & mask;
            }
            // Push carried bits as a mask
            if ((maskedWords != null) && carry !== 0) {
                maskedWords.words[maskedWords.length++] = carry;
            }
            if (this.length === 0) {
                this.words[0] = 0;
                this.length = 1;
            }
            return this.strip();
        }
        /**
         * Performs an in-place right shift operation on the BigNumber instance only if it is non-negative.
         *
         * @method ishrn
         * @param bits - The number of positions to shift.
         * @param hint - Lowest bit before trailing zeroes.
         * @param extended - To be filled with the bits that are shifted out.
         * @returns The BigNumber instance after performing the shift operation.
         *
         * @example
         * let myNumber = new BigNumber(16);
         * myNumber.ishrn(2); // Returns BigNumber of value 4
         */
        ishrn(bits, hint, extended) {
            this.assert(this.negative === 0);
            return this.iushrn(bits, hint, extended);
        }
        /**
         * Performs a bitwise left shift operation on a clone of the BigNumber instance.
         *
         * @method shln
         * @param bits - The number of positions to shift.
         * @returns A new BigNumber, which is the result of the shift operation.
         *
         * @example
         * let myNumber = new BigNumber(4);
         * let shiftedNumber = myNumber.shln(2);
         * console.log(shiftedNumber.toString()); // Outputs "16"
         */
        shln(bits) {
            return this.clone().ishln(bits);
        }
        /**
         * Performs an unsigned bitwise shift left operation on a clone of the BigNumber instance.
         *
         * @method ushln
         * @param bits - The number of bits to shift.
         * @returns A new BigNumber resulting from the shift operation.
         *
         * @example
         * let myNumber = new BigNumber(4);
         * let shiftedNumber = myNumber.ushln(2);
         * console.log(shiftedNumber.toString()); // Outputs "16"
         */
        ushln(bits) {
            return this.clone().iushln(bits);
        }
        /**
         * Performs a bitwise right shift operation on a clone of the BigNumber instance.
         *
         * @method shrn
         * @param bits - The number of bits to shift.
         * @returns A new BigNumber resulting from the shift operation.
         *
         * @example
         * let myNumber = new BigNumber(16);
         * let shiftedNumber = myNumber.shrn(3);
         * console.log(shiftedNumber.toString()); // Outputs "2"
         */
        shrn(bits) {
            return this.clone().ishrn(bits);
        }
        /**
         * Performs an unsigned bitwise shift right operation on a clone of the BigNumber instance.
         *
         * @method ushrn
         * @param bits - The number of bits to shift.
         * @returns A new BigNumber resulting from the shift operation.
         *
         * @example
         * let myNumber = new BigNumber(20);
         * let shiftedNumber = myNumber.ushrn(2);
         * console.log(shiftedNumber.toString()); // Outputs "5"
         */
        ushrn(bits) {
            return this.clone().iushrn(bits);
        }
        /**
         * Tests if the nth bit of the BigNumber is set.
         *
         * @method testn
         * @param bit - The position of the bit to test.
         * @returns A boolean indicating whether the nth bit is set.
         *
         * @example
         * let myNumber = new BigNumber(10); // 1010 in binary
         * myNumber.testn(1); // Returns true (indicating that the second bit from right is set)
         */
        testn(bit) {
            this.assert(typeof bit === 'number' && bit >= 0);
            const r = bit % 26;
            const s = (bit - r) / 26;
            const q = 1 << r;
            // Fast case: bit is much higher than all existing words
            if (this.length <= s)
                return false;
            // Check bit and return
            const w = this.words[s];
            return Boolean(w & q);
        }
        /**
         * Performs an in-place operation to keep only the lower bits of the number.
         * @method imaskn
         * @param bits - The number of lower bits to keep.
         * @returns Returns the BigNumber with only the specified lower bits.
         * @throws Will throw an error if bits is not a positive number.
         * @throws Will throw an error if initial BigNumber is negative as imaskn only works with positive numbers.
         * @example
         * const myNumber = new BigNumber(52);
         * myNumber.imaskn(2); // myNumber becomes 0 because lower 2 bits of 52 (110100) are 00.
         */
        imaskn(bits) {
            this.assert(typeof bits === 'number' && bits >= 0);
            const r = bits % 26;
            let s = (bits - r) / 26;
            this.assert(this.negative === 0, 'imaskn works only with positive numbers');
            if (this.length <= s) {
                return this;
            }
            if (r !== 0) {
                s++;
            }
            this.length = Math.min(s, this.length);
            if (r !== 0) {
                const mask = 0x3ffffff ^ ((0x3ffffff >>> r) << r);
                this.words[this.length - 1] &= mask;
            }
            return this.strip();
        }
        /**
         * Returns a new BigNumber that keeps only the lower bits of the original number.
         * @method maskn
         * @param bits - The number of lower bits to keep.
         * @returns Returns a new BigNumber with only the specified lower bits of the original number.
         * @example
         * const myNumber = new BigNumber(52);
         * const newNumber = myNumber.maskn(2); // newNumber becomes 0, myNumber doesn't change.
         */
        maskn(bits) {
            return this.clone().imaskn(bits);
        }
        /**
         * Performs an in-place addition of a plain number to the BigNumber.
         * @method iaddn
         * @param num - The plain number to add.
         * @returns Returns the BigNumber after the addition.
         * @throws Will throw an error if num is not a number or is larger than 0x4000000.
         * @example
         * const myNumber = new BigNumber(50);
         * myNumber.iaddn(2); // myNumber becomes 52.
         */
        iaddn(num) {
            this.assert(typeof num === 'number');
            this.assert(num < 0x4000000, 'num is too large');
            if (num < 0)
                return this.isubn(-num);
            // Possible sign change
            if (this.negative !== 0) {
                if (this.length === 1 && (this.words[0] | 0) <= num) {
                    this.words[0] = num - (this.words[0] | 0);
                    this.negative = 0;
                    return this;
                }
                this.negative = 0;
                this.isubn(num);
                this.negative = 1;
                return this;
            }
            // Add without checks
            return this._iaddn(num);
        }
        /**
         * A helper method for in-place addition, used when there are no sign changes or size checks needed.
         * @private
         * @method _iaddn
         * @param num - The plain number to add.
         * @returns Returns the BigNumber after the addition.
         */
        _iaddn(num) {
            this.words[0] += num;
            // Carry
            let i = 0;
            for (; i < this.length && this.words[i] >= 0x4000000; i++) {
                this.words[i] -= 0x4000000;
                if (i === this.length - 1) {
                    this.words[i + 1] = 1;
                }
                else {
                    this.words[i + 1]++;
                }
            }
            this.length = Math.max(this.length, i + 1);
            return this;
        }
        /**
         * Performs an in-place subtraction of a plain number from the BigNumber.
         * @method isubn
         * @param num - The plain number to subtract.
         * @returns Returns the BigNumber after the subtraction.
         * @throws Will throw an error if num is not a number or is larger than 0x4000000.
         * @example
         * const myNumber = new BigNumber(52);
         * myNumber.isubn(2); // myNumber becomes 50.
         */
        isubn(num) {
            this.assert(typeof num === 'number');
            this.assert(num < 0x4000000);
            if (num < 0)
                return this.iaddn(-num);
            if (this.negative !== 0) {
                this.negative = 0;
                this.iaddn(num);
                this.negative = 1;
                return this;
            }
            this.words[0] -= num;
            if (this.length === 1 && this.words[0] < 0) {
                this.words[0] = -this.words[0];
                this.negative = 1;
            }
            else {
                // Carry
                for (let i = 0; i < this.length && this.words[i] < 0; i++) {
                    this.words[i] += 0x4000000;
                    this.words[i + 1] -= 1;
                }
            }
            return this.strip();
        }
        /**
         * Returns a new BigNumber that is the result of adding a plain number to the original BigNumber.
         * @method addn
         * @param num - The plain number to add.
         * @returns Returns a new BigNumber which is the sum of the original BigNumber and the plain number.
         * @example
         * const myNumber = new BigNumber(50);
         * const newNumber = myNumber.addn(2); // newNumber becomes 52, myNumber doesn't change.
         */
        addn(num) {
            return this.clone().iaddn(num);
        }
        /**
         * Returns a new BigNumber that is the result of subtracting a plain number from the original BigNumber.
         * @method subn
         * @param num - The plain number to subtract.
         * @returns Returns a new BigNumber which is the difference of the original BigNumber and the plain number.
         * @example
         * const myNumber = new BigNumber(52);
         * const newNumber = myNumber.subn(2);  // newNumber becomes 50, myNumber doesn't change.
         */
        subn(num) {
            return this.clone().isubn(num);
        }
        /**
         * Performs an in-place operation to make the BigNumber an absolute value.
         * @method iabs
         * @returns Returns the BigNumber as an absolute value.
         * @example
         * const myNumber = new BigNumber(-50);
         * myNumber.iabs(); // myNumber becomes 50.
         */
        iabs() {
            this.negative = 0;
            return this;
        }
        /**
         * Obtains the absolute value of a BigNumber instance.
         * This operation does not affect the actual object but instead returns a new instance of BigNumber.
         *
         * @method abs
         * @returns a new BigNumber instance with the absolute value of the current instance.
         *
         * @example
         * let negativeNumber = new BigNumber(-10);
         * let absolute = negativeNumber.abs();
         * console.log(absolute.toString()); // Outputs: "10"
         */
        abs() {
            return this.clone().iabs();
        }
        /**
         * Perform an in-place shift left, subtract, and multiply operation on a BigNumber instance.
         * This method modifies the existing BigNumber instance.
         *
         * @method _ishlnsubmul
         * @param num - The BigNumber to be operated on.
         * @param mul - The multiplication factor.
         * @param shift - The number of places to shift left.
         * @returns the updated BigNumber instance after performing the in-place shift, subtract, and multiply operations.
         *
         * @example
         * let number = new BigNumber(10);
         * number._ishlnsubmul(new BigNumber(2), 3, 1);
         * console.log(number.toString()); // Outputs result after performing operations
         */
        _ishlnsubmul(num, mul, shift) {
            const len = num.length + shift;
            let i;
            this.expand(len);
            let w;
            let carry = 0;
            for (i = 0; i < num.length; i++) {
                w = (this.words[i + shift] | 0) + carry;
                const right = (num.words[i] | 0) * mul;
                w -= right & 0x3ffffff;
                carry = (w >> 26) - ((right / 0x4000000) | 0);
                this.words[i + shift] = w & 0x3ffffff;
            }
            for (; i < this.length - shift; i++) {
                w = (this.words[i + shift] | 0) + carry;
                carry = w >> 26;
                this.words[i + shift] = w & 0x3ffffff;
            }
            if (carry === 0)
                return this.strip();
            // Subtraction overflow
            this.assert(carry === -1, 'carry must be -1');
            carry = 0;
            for (i = 0; i < this.length; i++) {
                w = -(this.words[i] | 0) + carry;
                carry = w >> 26;
                this.words[i] = w & 0x3ffffff;
            }
            this.negative = 1;
            return this.strip();
        }
        /**
         * Performs a division on a BigNumber instance word-wise.
         *
         * This is a private method and should not be directly accessed.
         *
         * @method wordDiv
         * @private
         * @param num - The BigNumber to divide by.
         * @param mode - Specifies the operation mode as 'mod' for modulus or 'div' for division.
         * @returns Object with division (div) and modulo (mod) results, subject to the 'mode' specified.
         */
        wordDiv(num, mode) {
            let shift = this.length - num.length;
            let a = this.clone();
            let b = num;
            // Normalize
            let bhi = b.words[b.length - 1] | 0;
            const bhiBits = this.countWordBits(bhi);
            shift = 26 - bhiBits;
            if (shift !== 0) {
                b = b.ushln(shift);
                a.iushln(shift);
                bhi = b.words[b.length - 1] | 0;
            }
            // Initialize quotient
            const m = a.length - b.length;
            let q;
            if (mode !== 'mod') {
                q = new BigNumber();
                q.length = m + 1;
                q.words = new Array(q.length);
                for (let i = 0; i < q.length; i++) {
                    q.words[i] = 0;
                }
            }
            const diff = a.clone()._ishlnsubmul(b, 1, m);
            if (diff.negative === 0) {
                a = diff;
                if (typeof q !== 'undefined') {
                    q.words[m] = 1;
                }
            }
            for (let j = m - 1; j >= 0; j--) {
                let qj = (a.words[b.length + j] | 0) * 0x4000000 +
                    (a.words[b.length + j - 1] | 0);
                // NOTE: (qj / bhi) is (0x3ffffff * 0x4000000 + 0x3ffffff) / 0x2000000 max
                // (0x7ffffff)
                qj = Math.min((qj / bhi) | 0, 0x3ffffff);
                a._ishlnsubmul(b, qj, j);
                while (a.negative !== 0) {
                    qj--;
                    a.negative = 0;
                    a._ishlnsubmul(b, 1, j);
                    if (!a.isZero()) {
                        a.negative ^= 1;
                    }
                }
                if (typeof q !== 'undefined') {
                    q.words[j] = qj;
                }
            }
            if (typeof q !== 'undefined') {
                q.strip();
            }
            a.strip();
            // Denormalize
            if (mode !== 'div' && shift !== 0) {
                a.iushrn(shift);
            }
            return {
                div: q ?? null,
                mod: a
            };
        }
        /**
         * Performs division and/or modulus operation on a BigNumber instance depending on the 'mode' parameter.
         * If the mode parameter is not provided, both division and modulus results are returned.
         *
         * @method divmod
         * @param num - The BigNumber to divide by.
         * @param mode - Specifies operation as 'mod' for modulus, 'div' for division, or both if not specified.
         * @param positive - Specifies if unsigned modulus is requested.
         * @returns Object with properties for division (div) and modulo (mod) results.
         *
         * @example
         * let number = new BigNumber(10);
         * let result = number.divmod(new BigNumber(3));
         * console.log(result.div.toString()); // Outputs: "3"
         * console.log(result.mod.toString()); // Outputs: "1"
         */
        divmod(num, mode, positive) {
            this.assert(!num.isZero());
            if (this.isZero()) {
                return {
                    div: new BigNumber(0),
                    mod: new BigNumber(0)
                };
            }
            let div, mod, res;
            if (this.negative !== 0 && num.negative === 0) {
                res = this.neg().divmod(num, mode);
                if (mode !== 'mod') {
                    div = res.div.neg();
                }
                if (mode !== 'div') {
                    mod = res.mod.neg();
                    if (positive && mod.negative !== 0) {
                        mod.iadd(num);
                    }
                }
                return {
                    div,
                    mod
                };
            }
            if (this.negative === 0 && num.negative !== 0) {
                res = this.divmod(num.neg(), mode);
                if (mode !== 'mod') {
                    div = res.div.neg();
                }
                return {
                    div,
                    mod: res.mod
                };
            }
            if ((this.negative & num.negative) !== 0) {
                res = this.neg().divmod(num.neg(), mode);
                if (mode !== 'div') {
                    mod = res.mod.neg();
                    if (positive && mod.negative !== 0) {
                        mod.isub(num);
                    }
                }
                return {
                    div: res.div,
                    mod
                };
            }
            // Both numbers are positive at this point
            // Strip both numbers to approximate shift value
            if (num.length > this.length || this.cmp(num) < 0) {
                return {
                    div: new BigNumber(0),
                    mod: this
                };
            }
            // Very short reduction
            if (num.length === 1) {
                if (mode === 'div') {
                    return {
                        div: this.divn(num.words[0]),
                        mod: null
                    };
                }
                if (mode === 'mod') {
                    return {
                        div: null,
                        mod: new BigNumber(this.modrn(num.words[0]))
                    };
                }
                return {
                    div: this.divn(num.words[0]),
                    mod: new BigNumber(this.modrn(num.words[0]))
                };
            }
            return this.wordDiv(num, mode);
        }
        /**
         * Divides a BigNumber instance by another BigNumber and returns result. This does not modify the actual object.
         *
         * @method div
         * @param num - The BigNumber to divide by.
         * @returns A new BigNumber instance of the division result.
         *
         * @example
         * let number = new BigNumber(10);
         * let result = number.div(new BigNumber(2));
         * console.log(result.toString()); // Outputs: "5"
         */
        div(num) {
            return this.divmod(num, 'div', false).div;
        }
        /**
         * Returns the remainder after division of one `BigNumber` by another `BigNumber`.
         *
         * @method mod
         * @param num - The divisor `BigNumber`.
         * @returns The remainder `BigNumber` after division.
         *
         * @example
         * const bigNum1 = new BigNumber('100');
         * const bigNum2 = new BigNumber('45');
         * const remainder = bigNum1.mod(bigNum2); // remainder here would be '10'
         */
        mod(num) {
            return this.divmod(num, 'mod', false).mod;
        }
        /**
         * Returns the remainder after unsigned division of one `BigNumber` by another `BigNumber`.
         *
         * @method umod
         * @param num - The divisor `BigNumber`.
         * @returns The remainder `BigNumber` after unsigned division.
         * Note: Here 'unsigned division' means that signs of the numbers are ignored.
         *
         * @example
         * const bigNum1 = new BigNumber('-100');
         * const bigNum2 = new BigNumber('45');
         * const remainder = bigNum1.umod(bigNum2); // remainder here would be '10' as signs are ignored.
         */
        umod(num) {
            return this.divmod(num, 'mod', true).mod;
        }
        /**
         * Returns the rounded quotient after division of one `BigNumber` by another `BigNumber`.
         *
         * @method divRound
         * @param num - The divisor `BigNumber`.
         * @returns The rounded quotient `BigNumber` after division.
         *
         * @example
         * const bigNum1 = new BigNumber('100');
         * const bigNum2 = new BigNumber('45');
         * const quotient = bigNum1.divRound(bigNum2); // quotient here would be '2'
         */
        divRound(num) {
            const dm = this.divmod(num);
            // Fast case - exact division
            if (dm.mod.isZero())
                return dm.div;
            const mod = dm.div.negative !== 0
                ? dm.mod.isub(num)
                : dm.mod;
            const half = num.ushrn(1);
            const r2 = num.andln(1);
            const cmp = mod.cmp(half);
            // Round down
            if (cmp < 0 || (r2 === 1 && cmp === 0))
                return dm.div;
            // Round up
            return dm.div.negative !== 0 ? dm.div.isubn(1) : dm.div.iaddn(1);
        }
        /**
         * Returns the remainder after division of a `BigNumber` by a primitive number.
         *
         * @method modrn
         * @param num - The divisor primitive number.
         * @returns The remainder number after division.
         *
         * @example
         * const bigNum = new BigNumber('100');
         * const num = 45;
         * const remainder = bigNum.modrn(num); // remainder here would be '10'
         */
        modrn(num) {
            const isNegNum = num < 0;
            if (isNegNum)
                num = -num;
            this.assert(num <= 0x3ffffff);
            const p = (1 << 26) % num;
            let acc = 0;
            for (let i = this.length - 1; i >= 0; i--) {
                acc = (p * acc + (this.words[i] | 0)) % num;
            }
            return isNegNum ? -acc : acc;
        }
        /**
         * Performs an in-place division of a `BigNumber` by a primitive number.
         *
         * @method idivn
         * @param num - The divisor primitive number.
         * @returns The `BigNumber` itself after being divided.
         * Note: 'in-place' means that this operation modifies the original `BigNumber`.
         *
         * @example
         * const bigNum = new BigNumber('100');
         * const num = 45;
         * bigNum.idivn(num); // the bigNum here directly becomes '2'
         */
        idivn(num) {
            const isNegNum = num < 0;
            if (isNegNum)
                num = -num;
            this.assert(num <= 0x3ffffff);
            let carry = 0;
            for (let i = this.length - 1; i >= 0; i--) {
                const w = (this.words[i] | 0) + carry * 0x4000000;
                this.words[i] = (w / num) | 0;
                carry = w % num;
            }
            this.strip();
            return isNegNum ? this.ineg() : this;
        }
        /**
         * Returns the quotient `BigNumber` after division of one `BigNumber` by a primitive number.
         *
         * @method divn
         * @param num - The divisor primitive number.
         * @returns A new quotient `BigNumber` after division.
         *
         * @example
         * const bigNum = new BigNumber('100');
         * const num = 45;
         * const quotient = bigNum.divn(num); // quotient here would be '2'
         */
        divn(num) {
            return this.clone().idivn(num);
        }
        /**
         * Computes the Extended Euclidean Algorithm for this BigNumber and provided BigNumber `p`.
         * The Extended Euclidean Algorithm is a method to find the GCD (Greatest Common Divisor) and the multiplicative inverse in a modulus field.
         *
         * @method egcd
         * @param p - The `BigNumber` with which the Extended Euclidean Algorithm will be computed.
         * @returns An object `{a: BigNumber, b: BigNumber, gcd: BigNumber}` where `gcd` is the GCD of the numbers, `a` is the coefficient of `this`, and `b` is the coefficient of `p` in Bézout's identity.
         *
         * @example
         * const bigNum1 = new BigNumber('100');
         * const bigNum2 = new BigNumber('45');
         * const result = bigNum1.egcd(bigNum2);
         */
        egcd(p) {
            this.assert(p.negative === 0, 'p must not be negative');
            this.assert(!p.isZero(), 'p must not be zero');
            let x = this;
            const y = p.clone();
            if (x.negative !== 0) {
                x = x.umod(p);
            }
            else {
                x = x.clone();
            }
            // A * x + B * y = x
            const A = new BigNumber(1);
            const B = new BigNumber(0);
            // C * x + D * y = y
            const C = new BigNumber(0);
            const D = new BigNumber(1);
            let g = 0;
            while (x.isEven() && y.isEven()) {
                x.iushrn(1);
                y.iushrn(1);
                ++g;
            }
            const yp = y.clone();
            const xp = x.clone();
            while (!x.isZero()) {
                let i = 0;
                let im = 1;
                for (; (x.words[0] & im) === 0 && i < 26; ++i, im <<= 1)
                    ;
                if (i > 0) {
                    x.iushrn(i);
                    while (i-- > 0) {
                        if (A.isOdd() || B.isOdd()) {
                            A.iadd(yp);
                            B.isub(xp);
                        }
                        A.iushrn(1);
                        B.iushrn(1);
                    }
                }
                let j = 0;
                let jm = 1;
                for (; (y.words[0] & jm) === 0 && j < 26; ++j, jm <<= 1)
                    ;
                if (j > 0) {
                    y.iushrn(j);
                    while (j-- > 0) {
                        if (C.isOdd() || D.isOdd()) {
                            C.iadd(yp);
                            D.isub(xp);
                        }
                        C.iushrn(1);
                        D.iushrn(1);
                    }
                }
                if (x.cmp(y) >= 0) {
                    x.isub(y);
                    A.isub(C);
                    B.isub(D);
                }
                else {
                    y.isub(x);
                    C.isub(A);
                    D.isub(B);
                }
            }
            return {
                a: C,
                b: D,
                gcd: y.iushln(g)
            };
        }
        /**
         * Compute the multiplicative inverse of the current BigNumber in the modulus field specified by `p`.
         * The multiplicative inverse is a number which when multiplied with the current BigNumber gives '1' in the modulus field.
         *
         * @method _invmp
         * @param p - The `BigNumber` specifying the modulus field.
         * @returns The multiplicative inverse `BigNumber` in the modulus field specified by `p`.
         *
         * @example
         * const bigNum = new BigNumber('45');
         * const p = new BigNumber('100');
         * const inverse = bigNum._invmp(p); // inverse here would be a BigNumber such that (inverse*bigNum) % p = '1'
         */
        _invmp(p) {
            this.assert(p.negative === 0, 'p must not be negative');
            this.assert(!p.isZero(), 'p must not be zero');
            let a = this;
            const b = p.clone();
            if (a.negative !== 0) {
                a = a.umod(p);
            }
            else {
                a = a.clone();
            }
            const x1 = new BigNumber(1);
            const x2 = new BigNumber(0);
            const delta = b.clone();
            while (a.cmpn(1) > 0 && b.cmpn(1) > 0) {
                let i = 0;
                let im = 1;
                for (; (a.words[0] & im) === 0 && i < 26; ++i, im <<= 1)
                    ;
                if (i > 0) {
                    a.iushrn(i);
                    while (i-- > 0) {
                        if (x1.isOdd()) {
                            x1.iadd(delta);
                        }
                        x1.iushrn(1);
                    }
                }
                let j = 0;
                let jm = 1;
                for (; (b.words[0] & jm) === 0 && j < 26; ++j, jm <<= 1)
                    ;
                if (j > 0) {
                    b.iushrn(j);
                    while (j-- > 0) {
                        if (x2.isOdd()) {
                            x2.iadd(delta);
                        }
                        x2.iushrn(1);
                    }
                }
                if (a.cmp(b) >= 0) {
                    a.isub(b);
                    x1.isub(x2);
                }
                else {
                    b.isub(a);
                    x2.isub(x1);
                }
            }
            let res;
            if (a.cmpn(1) === 0) {
                res = x1;
            }
            else {
                res = x2;
            }
            if (res.cmpn(0) < 0) {
                res.iadd(p);
            }
            return res;
        }
        /**
         * Computes and returns the greatest common divisor (GCD) of this BigNumber and the provided BigNumber.
         *
         * @method gcd
         * @param num - The BigNumber with which to compute the GCD.
         * @returns The GCD of this BigNumber and the provided BigNumber.
         *
         * @example
         * let a = new BigNumber(48);
         * let b = new BigNumber(18);
         * let gcd = a.gcd(b);
         */
        gcd(num) {
            if (this.isZero())
                return num.abs();
            if (num.isZero())
                return this.abs();
            let a = this.clone();
            let b = num.clone();
            a.negative = 0;
            b.negative = 0;
            // Remove common factor of two
            let shift = 0;
            for (; a.isEven() && b.isEven(); shift++) {
                a.iushrn(1);
                b.iushrn(1);
            }
            do {
                while (a.isEven()) {
                    a.iushrn(1);
                }
                while (b.isEven()) {
                    b.iushrn(1);
                }
                const r = a.cmp(b);
                if (r < 0) {
                    // Swap `a` and `b` to make `a` always bigger than `b`
                    const t = a;
                    a = b;
                    b = t;
                }
                else if (r === 0 || b.cmpn(1) === 0) {
                    break;
                }
                a.isub(b);
            } while (true);
            return b.iushln(shift);
        }
        /**
         * Computes and returns the modular multiplicative inverse of this BigNumber in the field defined by the provided BigNumber.
         *
         * @method invm
         * @param num - The BigNumber that defines the field.
         * @returns The modular multiplicative inverse of this BigNumber.
         *
         * @example
         * let a = new BigNumber(3);
         * let field = new BigNumber(7);
         * let inverse = a.invm(field);
         */
        invm(num) {
            return this.egcd(num).a.umod(num);
        }
        /**
         * Checks if this BigNumber is even.
         * An even number is an integer which is evenly divisible by two.
         *
         * @method isEven
         * @returns true if this BigNumber is even, else false.
         *
         * @example
         * let a = new BigNumber(4);
         * let isEven = a.isEven(); // true
         */
        isEven() {
            return (this.words[0] & 1) === 0;
        }
        /**
         * Checks if this BigNumber is Odd.
         * An odd number is an integer which is not evenly divisible by two.
         *
         * @method isOdd
         * @returns true if this BigNumber is Odd, else false.
         *
         * @example
         * let a = new BigNumber(3);
         * let isOdd = a.isOdd(); // true
         */
        isOdd() {
            return (this.words[0] & 1) === 1;
        }
        /**
         * Returns the result of bitwise AND operation between the least significant 26 bits of
         * this BigNumber and the provided number.
         * This method is mostly used to mask-off less significant bits.
         *
         * @method andln
         * @param num - The number to AND with.
         * @returns The result of the AND operation.
         *
         * @example
         * let a = new BigNumber(60);
         * let result = a.andln(13); // 12
         */
        andln(num) {
            return this.words[0] & num;
        }
        /**
         * Increments the value at the bit position specified by the input parameter.
         *
         * @method bincn
         * @param bit - The bit position to increment at.
         * @returns This BigNumber after incrementing at the specific bit position.
         *
         * @example
         * let a = new BigNumber(5);
         * a.bincn(2); // a = 7
         */
        bincn(bit) {
            this.assert(typeof bit === 'number');
            const r = bit % 26;
            const s = (bit - r) / 26;
            const q = 1 << r;
            // Fast case: bit is much higher than all existing words
            if (this.length <= s) {
                this.expand(s + 1);
                this.words[s] |= q;
                return this;
            }
            // Add bit and propagate, if needed
            let carry = q;
            let i = s;
            for (; carry !== 0 && i < this.length; i++) {
                let w = this.words[i] | 0;
                w += carry;
                carry = w >>> 26;
                w &= 0x3ffffff;
                this.words[i] = w;
            }
            if (carry !== 0) {
                this.words[i] = carry;
                this.length++;
            }
            return this;
        }
        /**
         * Checks if this BigNumber is Zero.
         * A BigNumber is zero if it only contains one word and that word is 0.
         *
         * @method isZero
         * @returns true if this BigNumber is Zero, else false.
         *
         * @example
         * let a = new BigNumber(0);
         * let isZero = a.isZero(); // true
         */
        isZero() {
            return this.length === 1 && this.words[0] === 0;
        }
        /**
         * Compares this BigNumber with the given number.
         * It returns -1 if this BigNumber is less than the number, 0 if they're equal, and 1 if the BigNumber is greater than the number.
         *
         * @method cmpn
         * @param num - The number to compare with.
         * @returns -1, 0, or 1 based on the comparison result.
         *
         * @example
         * let a = new BigNumber(15);
         * let result = a.cmpn(10); // 1
         */
        cmpn(num) {
            const negative = num < 0;
            if (this.negative !== 0 && !negative)
                return -1;
            if (this.negative === 0 && negative)
                return 1;
            this.strip();
            let res;
            if (this.length > 1) {
                res = 1;
            }
            else {
                if (negative) {
                    num = -num;
                }
                this.assert(num <= 0x3ffffff, 'Number is too big');
                const w = this.words[0] | 0;
                res = w === num ? 0 : w < num ? -1 : 1;
            }
            if (this.negative !== 0)
                return (-res | 0);
            return res;
        }
        /**
         * Compare this big number with another big number.
         * @method cmp
         * @param num - The big number to compare with.
         * @returns Returns:
         * 1 if this big number is greater,
         * -1 if it's less,
         * 0 if they are equal.
         *
         * @example
         * import BigNumber from './BigNumber';
         * const bn1 = new BigNumber('10');
         * const bn2 = new BigNumber('6');
         * const comparisonResult = bn1.cmp(bn2); // 1 - because 10 is greater than 6
         */
        cmp(num) {
            if (this.negative !== 0 && num.negative === 0)
                return -1;
            if (this.negative === 0 && num.negative !== 0)
                return 1;
            const res = this.ucmp(num);
            if (this.negative !== 0)
                return (-res | 0);
            return res;
        }
        /**
         * Performs an unsigned comparison between this BigNumber instance and another.
         *
         * @method ucmp
         * @param num - The BigNumber instance to compare with.
         * @returns Returns 1 if this BigNumber is bigger, -1 if it is smaller, and 0 if they are equal.
         *
         * @example
         * let bigNumber1 = new BigNumber('1234');
         * let bigNumber2 = new BigNumber('2345');
         * let comparisonResult = bigNumber1.ucmp(bigNumber2); // Returns -1
         */
        ucmp(num) {
            // At this point both numbers have the same sign
            if (this.length > num.length)
                return 1;
            if (this.length < num.length)
                return -1;
            let res = 0;
            for (let i = this.length - 1; i >= 0; i--) {
                const a = this.words[i] | 0;
                const b = num.words[i] | 0;
                if (a === b)
                    continue;
                if (a < b) {
                    res = -1;
                }
                else if (a > b) {
                    res = 1;
                }
                break;
            }
            return res;
        }
        /**
         * Checks if this BigNumber instance is greater than a number.
         *
         * @method gtn
         * @param num - The number to compare with.
         * @returns Returns true if this BigNumber is greater than the number, false otherwise.
         *
         * @example
         * let bigNumber = new BigNumber('2345');
         * let isGreater = bigNumber.gtn(1234); // Returns true
         */
        gtn(num) {
            return this.cmpn(num) === 1;
        }
        /**
         * Checks if this BigNumber instance is greater than another BigNumber.
         *
         * @method gt
         * @param num - The BigNumber to compare with.
         * @returns Returns true if this BigNumber is greater than the other BigNumber, false otherwise.
         *
         * @example
         * let bigNumber1 = new BigNumber('2345');
         * let bigNumber2 = new BigNumber('1234');
         * let isGreater = bigNumber1.gt(bigNumber2); // Returns true
         */
        gt(num) {
            return this.cmp(num) === 1;
        }
        /**
         * Checks if this BigNumber instance is greater than or equal to a number.
         *
         * @method gten
         * @param num - The number to compare with.
         * @returns Returns true if this BigNumber is greater than or equal to the number, false otherwise.
         *
         * @example
         * let bigNumber = new BigNumber('1234');
         * let isGreaterOrEqual = bigNumber.gten(1234); // Returns true
         */
        gten(num) {
            return this.cmpn(num) >= 0;
        }
        /**
         * Checks if this BigNumber instance is greater than or equal to another BigNumber.
         *
         * @method gte
         * @param num - The BigNumber to compare with.
         * @returns Returns true if this BigNumber is greater than or equal to the other BigNumber, false otherwise.
         *
         * @example
         * let bigNumber1 = new BigNumber('1234');
         * let bigNumber2 = new BigNumber('1234');
         * let isGreaterOrEqual = bigNumber1.gte(bigNumber2); // Returns true
         */
        gte(num) {
            return this.cmp(num) >= 0;
        }
        /**
         * Checks if this BigNumber instance is less than a number.
         *
         * @method ltn
         * @param num - The number to compare with.
         * @returns Returns true if this BigNumber is less than the number, false otherwise.
         *
         * @example
         * let bigNumber = new BigNumber('1234');
         * let isLess = bigNumber.ltn(2345); // Returns true
         */
        ltn(num) {
            return this.cmpn(num) === -1;
        }
        /**
         * Checks if this BigNumber instance is less than another BigNumber.
         *
         * @method lt
         * @param num - The BigNumber to compare with.
         * @returns Returns true if this BigNumber is less than the other BigNumber, false otherwise.
         *
         * @example
         * let bigNumber1 = new BigNumber('1234');
         * let bigNumber2 = new BigNumber('2345');
         * let isLess = bigNumber1.lt(bigNumber2); // Returns true
         */
        lt(num) {
            return this.cmp(num) === -1;
        }
        /**
         * Checks if this BigNumber instance is less than or equal to a number.
         *
         * @method lten
         * @param num - The number to compare with.
         * @returns Returns true if this BigNumber is less than or equal to the number, false otherwise.
         *
         * @example
         * let bigNumber = new BigNumber('2345');
         * let isLessOrEqual = bigNumber.lten(2345); // Returns true
         */
        lten(num) {
            return this.cmpn(num) <= 0;
        }
        /**
         * Checks if this BigNumber instance is less than or equal to another BigNumber.
         *
         * @method lte
         * @param num - The BigNumber to compare with.
         * @returns Returns true if this BigNumber is less than or equal to the other BigNumber, false otherwise.
         *
         * @example
         * let bigNumber1 = new BigNumber('2345');
         * let bigNumber2 = new BigNumber('2345');
         * let isLessOrEqual = bigNumber1.lte(bigNumber2); // Returns true
         */
        lte(num) {
            return this.cmp(num) <= 0;
        }
        /**
         * Checks if this BigNumber instance is equal to a number.
         *
         * @method eqn
         * @param num - The number to compare with.
         * @returns Returns true if this BigNumber is equal to the number, false otherwise.
         *
         * @example
         * let bigNumber = new BigNumber('1234');
         * let isEqual = bigNumber.eqn(1234); // Returns true
         */
        eqn(num) {
            return this.cmpn(num) === 0;
        }
        /**
         * Compares the current BigNumber with the given number and returns whether they're equal.
         *
         * @method eq
         * @param num - The number to compare equality with.
         * @returns Returns true if the current BigNumber is equal to the provided number, otherwise false.
         *
         * @example
         * let bigNum = new BigNumber(10);
         * bigNum.eq(new BigNumber(10)); // true
         */
        eq(num) {
            return this.cmp(num) === 0;
        }
        /**
         * Converts a BigNumber to a reduction context ensuring the number is a positive integer and is not already in a reduction context.
         * Throws an error in case the number is either negative or already in a reduction context.
         *
         * @method toRed
         * @param ctx - The ReductionContext to convert the BigNumber to.
         * @returns Returns the BigNumber in the given ReductionContext.
         *
         * @example
         * let bigNum = new BigNumber(10);
         * let redCtx = new ReductionContext();
         * bigNum.toRed(redCtx);
         */
        toRed(ctx) {
            this.assert(this.red == null, 'Already a number in reduction context');
            this.assert(this.negative === 0, 'red works only with positives');
            return ctx.convertTo(this).forceRed(ctx);
        }
        /**
         * Converts a BigNumber from a reduction context, making sure the number is indeed in a reduction context.
         * Throws an error in case the number is not in a reduction context.
         *
         * @method fromRed
         * @returns Returns the BigNumber out of the ReductionContext.
         *
         * @example
         * let bigNum = new BigNumber(10);
         * let redCtx = new ReductionContext();
         * bigNum.toRed(redCtx);
         * bigNum.fromRed();
         */
        fromRed() {
            this.assert(this.red, 'fromRed works only with numbers in reduction context');
            return (this.red).convertFrom(this);
        }
        /**
         * Forces the current BigNumber into a reduction context, irrespective of the BigNumber's current state.
         *
         * @method forceRed
         * @param ctx - The ReductionContext to forcefully convert the BigNumber to.
         * @returns Returns the BigNumber in the given ReductionContext.
         *
         * @example
         * let bigNum = new BigNumber(10);
         * let redCtx = new ReductionContext();
         * bigNum.forceRed(redCtx);
         */
        forceRed(ctx) {
            // this.assert(this.red == null, 'Already a number in reduction context')
            this.red = ctx;
            return this;
        }
        /**
         * Performs addition operation of the current BigNumber with the given number in a reduction context.
         * Throws an error in case the number is not in a reduction context.
         *
         * @method redAdd
         * @param num - The number to add to the current BigNumber.
         * @returns Returns a new BigNumber that's the sum of the current BigNumber and the provided number in the reduction context.
         *
         * @example
         * let bigNum = new BigNumber(10);
         * let redCtx = new ReductionContext();
         * bigNum.toRed(redCtx);
         * bigNum.redAdd(new BigNumber(20)); // returns a BigNumber of 30 in reduction context
         */
        redAdd(num) {
            this.assert(this.red, 'redAdd works only with red numbers');
            return (this.red).add(this, num);
        }
        /**
         * Performs in-place addition operation of the current BigNumber with the given number in a reduction context.
         * Throws an error in case the number is not in a reduction context.
         *
         * @method redIAdd
         * @param num - The number to add to the current BigNumber.
         * @returns Returns the modified current BigNumber after adding the provided number in the reduction context.
         *
         * @example
         * let bigNum = new BigNumber(10);
         * let redCtx = new ReductionContext();
         * bigNum.toRed(redCtx);
         * bigNum.redIAdd(new BigNumber(20)); // modifies the bigNum to 30 in reduction context
         */
        redIAdd(num) {
            this.assert(this.red, 'redIAdd works only with red numbers');
            return (this.red).iadd(this, num);
        }
        /**
         * Performs subtraction operation of the current BigNumber with the given number in a reduction context.
         * Throws an error in case the number is not in a reduction context.
         *
         * @method redSub
         * @param num - The number to subtract from the current BigNumber.
         * @returns Returns a new BigNumber that's the subtraction result of the current BigNumber and the provided number in the reduction context.
         *
         * @example
         * let bigNum = new BigNumber(30);
         * let redCtx = new ReductionContext();
         * bigNum.toRed(redCtx);
         * bigNum.redSub(new BigNumber(20)); // returns a BigNumber of 10 in reduction context
         */
        redSub(num) {
            this.assert(this.red, 'redSub works only with red numbers');
            return (this.red).sub(this, num);
        }
        /**
         * Performs in-place subtraction operation of the current BigNumber with the given number in a reduction context.
         * Throws an error in case the number is not in a reduction context.
         *
         * @method redISub
         * @param num - The number to subtract from the current BigNumber.
         * @returns Returns the modified current BigNumber after subtracting the provided number in the reduction context.
         *
         * @example
         * let bigNum = new BigNumber(30);
         * let redCtx = new ReductionContext();
         * bigNum.toRed(redCtx);
         * bigNum.redISub(new BigNumber(20)); // modifies the bigNum to 10 in reduction context
         */
        redISub(num) {
            this.assert(this.red, 'redISub works only with red numbers');
            return (this.red).isub(this, num);
        }
        /**
         * Performs the shift left operation on the current BigNumber in the reduction context.
         * Throws an error in case the number is not in a reduction context.
         *
         * @method redShl
         * @param num - The positions to shift left the current BigNumber.
         * @returns Returns a new BigNumber after performing the shift left operation on the current BigNumber in the reduction context.
         *
         * @example
         * let bigNum = new BigNumber(1);
         * let redCtx = new ReductionContext();
         * bigNum.toRed(redCtx);
         * bigNum.redShl(2); // returns a BigNumber of 4 in reduction context
         */
        redShl(num) {
            this.assert(this.red, 'redShl works only with red numbers');
            return (this.red).shl(this, num);
        }
        /**
         * Performs multiplication operation of the current BigNumber with the given number in a reduction context.
         * Throws an error in case the number is not in a reduction context.
         *
         * @method redMul
         * @param num - The number to multiply with the current BigNumber.
         * @returns Returns a new BigNumber that's the product of the current BigNumber and the provided number in the reduction context.
         *
         * @example
         * let bigNum = new BigNumber(10);
         * let redCtx = new ReductionContext();
         * bigNum.toRed(redCtx);
         * bigNum.redMul(new BigNumber(20)); // returns a BigNumber of 200 in reduction context
         */
        redMul(num) {
            this.assert(this.red, 'redMul works only with red numbers');
            (this.red).verify2(this, num);
            return (this.red).mul(this, num);
        }
        /**
         * Performs an in-place multiplication of this BigNumber instance with another BigNumber within a reduction context.
         * Expects that this BigNumber is within the reduction context i.e., it has been reduced.
         *
         * @method redIMul
         * @param num - The BigNumber to multiply with the current BigNumber.
         * @returns A BigNumber that is the result of the in-place multiplication operation, within the reduction context.
         *
         * @example
         * let bigNum1 = new BigNumber('10').toRed(someRed);
         * let bigNum2 = new BigNumber('5');
         * bigNum1.redIMul(bigNum2);
         */
        redIMul(num) {
            this.assert(this.red, 'redMul works only with red numbers');
            (this.red).verify2(this, num);
            return (this.red).imul(this, num);
        }
        /**
         * Square of a "red" (reduced) BigNumber.
         * This function squares the calling BigNumber and returns the result.
         * It only works if the number is "reduced". A number is considered reduced
         * if it has a `red` field that points to a reduction context object.
         *
         * @method redSqr
         * @throws If the BigNumber is not reduced
         * @returns The square of the BigNumber
         *
         * @example
         * const num = new BigNumber('25').toRed(someRed);
         * const result = num.redSqr();
         * console.log(result.toString()); // Outputs: '625' mod the red value
         */
        redSqr() {
            this.assert(this.red, 'redSqr works only with red numbers');
            (this.red).verify1(this);
            return (this.red).sqr(this);
        }
        /**
         * In-place square of a "red" (reduced) BigNumber.
         * This function squares the calling BigNumber and overwrites it with the result.
         * It only works if the number is "reduced". A number is considered reduced
         * if it has a `red` field that points to a reduction context object.
         *
         * @method redISqr
         * @throws If the BigNumber is not reduced
         * @returns This BigNumber squared in place
         *
         * @example
         * const num = new BigNumber('25').toRed(someRed);
         * num.redISqr();
         * console.log(num.toString()); // Outputs: '625' mod the red value
         */
        redISqr() {
            this.assert(this.red, 'redISqr works only with red numbers');
            (this.red).verify1(this);
            return (this.red).isqr(this);
        }
        /**
         * Square root of a "red" (reduced) BigNumber.
         * This function calculates the square root of the calling BigNumber
         * and returns the result. It only works if the number is "reduced".
         * A number is considered reduced if it has a `red`
         * field that points to a reduction context object.
         *
         * @method redSqrt
         * @throws If the BigNumber is not reduced
         * @returns The square root of the BigNumber
         *
         * @example
         * const num = new BigNumber('4').toRed(someRed);
         * const result = num.redSqrt();
         * console.log(result.toString()); // Outputs: '2' mod the red value
         */
        redSqrt() {
            this.assert(this.red, 'redSqrt works only with red numbers');
            (this.red).verify1(this);
            return (this.red).sqrt(this);
        }
        /**
         * Find multiplicative inverse (reciprocal) in respect to reduction context.
         * The method works only on numbers that have a reduction context set.
         *
         * @method redInvm
         * @returns Returns a BigNumber that is multiplicative inverse in respect to the reduction context.
         * @throws Will throw an error if this number does not have a reduction context.
         *
         * @example
         * let a = new BigNumber('2345', 16);
         * a.red = someReductionContext;
         * let aInverse = a.redInvm();
         */
        redInvm() {
            this.assert(this.red, 'redInvm works only with red numbers');
            (this.red).verify1(this);
            return (this.red).invm(this);
        }
        /**
         * Find negative version of this number in respect to reduction context.
         * The method works only on numbers that have a reduction context set.
         *
         * @method redNeg
         * @returns Returns a BigNumber that is the negative version of this number in respect to the reduction context.
         * @throws Will throw an error if this number does not have a reduction context.
         *
         * @example
         * let a = new BigNumber('2345', 16);
         * a.red = someReductionContext;
         * let aNeg = a.redNeg();
         */
        redNeg() {
            this.assert(this.red, 'redNeg works only with red numbers');
            (this.red).verify1(this);
            return (this.red).neg(this);
        }
        /**
         * Raises this number to the power of 'num', in respect to reduction context.
         * Note that 'num' must not have a reduction context set.
         *
         * @method redPow
         * @param num - The exponent to raise this number to.
         * @returns Returns a BigNumber that is this number raised to the power of 'num', in respect to the reduction context.
         * @throws Will throw an error if this number does not have a reduction context or 'num' has a reduction context.
         *
         * @example
         * let a = new BigNumber(3);
         * a.red = someReductionContext;
         * let b = new BigNumber(3);
         * let result = a.redPow(b);  // equivalent to (a^b) mod red
         */
        redPow(num) {
            this.assert((this.red != null) && (num.red == null), 'redPow(normalNum)');
            (this.red).verify1(this);
            return (this.red).pow(this, num);
        }
        /**
         * Creates a BigNumber from a hexadecimal string.
         *
         * @static
         * @method fromHex
         * @param hex - The hexadecimal string to create a BigNumber from.
         * @returns Returns a BigNumber created from the hexadecimal input string.
         *
         * @example
         * const exampleHex = 'a1b2c3';
         * const bigNumber = BigNumber.fromHex(exampleHex);
         */
        static fromHex(hex, endian) {
            if (endian === 'big') {
                return new BigNumber(hex, 16);
            }
            else {
                return new BigNumber(hex, 16, 'le');
            }
        }
        /**
         * Converts this BigNumber to a hexadecimal string.
         *
         * @method toHex
         * @param length - The minimum length of the hex string
         * @returns Returns a string representing the hexadecimal value of this BigNumber.
         *
         * @example
         * const bigNumber = new BigNumber(255);
         * const hex = bigNumber.toHex();
         */
        toHex(length = 0) {
            return this.toString('hex', length * 2);
        }
        /**
         * Creates a BigNumber from a JSON-serialized string.
         *
         * @static
         * @method fromJSON
         * @param str - The JSON-serialized string to create a BigNumber from.
         * @returns Returns a BigNumber created from the JSON input string.
         *
         * @example
         * const serialized = '{"type":"BigNumber","hex":"a1b2c3"}';
         * const bigNumber = BigNumber.fromJSON(serialized);
         */
        static fromJSON(str) {
            return new BigNumber(str);
        }
        /**
         * Creates a BigNumber from a number.
         *
         * @static
         * @method fromNumber
         * @param n - The number to create a BigNumber from.
         * @returns Returns a BigNumber equivalent to the input number.
         *
         * @example
         * const number = 1234;
         * const bigNumber = BigNumber.fromNumber(number);
         */
        static fromNumber(n) {
            return new BigNumber(n);
        }
        /**
         * Creates a BigNumber from a string, considering an optional base.
         *
         * @static
         * @method fromString
         * @param str - The string to create a BigNumber from.
         * @param base - The base used for conversion. If not provided, base 10 is assumed.
         * @returns Returns a BigNumber equivalent to the string after conversion from the specified base.
         *
         * @example
         * const str = '1234';
         * const bigNumber = BigNumber.fromString(str, 16);
         */
        static fromString(str, base) {
            return new BigNumber(str, base);
        }
        /**
         * Creates a BigNumber from a signed magnitude number.
         *
         * @static
         * @method fromSm
         * @param num - The signed magnitude number to convert to a BigNumber.
         * @param endian - Defines endianess. If not provided, big endian is assumed.
         * @returns Returns a BigNumber equivalent to the signed magnitude number interpreted with specified endianess.
         *
         * @example
         * const num = [0x81]
         * const bigNumber = BigNumber.fromSm(num, { endian: 'little' }); // equivalent to BigNumber from '-1'
         */
        static fromSm(num, endian = 'big') {
            let n = num;
            if (num.length === 0) {
                return new BigNumber(0);
            }
            if (endian === 'little') {
                n = [...n];
                n = n.reverse();
            }
            if ((n[0] & 0x80) !== 0) {
                n = [...n];
                n[0] = n[0] & 0x7f;
                return new BigNumber(n).neg();
            }
            else {
                return new BigNumber(n);
            }
        }
        /**
         * Converts this BigNumber to a signed magnitude number.
         *
         * @method toSm
         * @param endian - Defines endianess. If not provided, big endian is assumed.
         * @returns Returns an array equivalent to this BigNumber interpreted as a signed magnitude with specified endianess.
         *
         * @example
         * const bigNumber = new BigNumber(-1);
         * const num = bigNumber.toSm('little'); // [0x81]
         */
        toSm(endian = 'big') {
            let num;
            if (this.cmpn(0) === -1) {
                num = this.neg().toArray();
                if ((num[0] & 0x80) !== 0) {
                    num = [0x80, ...num];
                }
                else {
                    num[0] = num[0] | 0x80;
                }
            }
            else {
                num = this.toArray();
                if ((num[0] & 0x80) !== 0) {
                    num = [0x00, ...num];
                }
            }
            if (num.length === 1 && num[0] === 0) {
                num = [];
            }
            if (endian === 'little') {
                num = num.reverse();
            }
            return num;
        }
        /**
         * Creates a BigNumber from a number representing the "bits" value in a block header.
         *
         * @static
         * @method fromBits
         * @param bits - The number representing the bits value in a block header.
         * @param strict - If true, an error is thrown if the number has negative bit set.
         * @returns Returns a BigNumber equivalent to the "bits" value in a block header.
         * @throws Will throw an error if `strict` is `true` and the number has negative bit set.
         *
         * @example
         * const bits = 0x1d00ffff;
         * const bigNumber = BigNumber.fromBits(bits);
         */
        static fromBits(bits, strict = false) {
            // Convert to signed 32-bit value manually without using Buffer
            bits = (bits & 0x80000000) ? bits - 0x100000000 : bits;
            if (strict && (bits & 0x00800000) !== 0) {
                throw new Error('negative bit set');
            }
            const nsize = bits >> 24;
            const nword = bits & 0x007fffff;
            // Manually create the byte array (similar to the original buffer)
            let bytes = [
                (nword >> 24) & 0xFF,
                (nword >> 16) & 0xFF,
                (nword >> 8) & 0xFF,
                nword & 0xFF
            ];
            if (nsize <= 3) {
                bytes = bytes.slice(1, 1 + nsize); // remove the most significant byte(s) as necessary
            }
            else {
                // add trailing zeros (similar to the original buffer fill)
                for (let i = 0; i < nsize - 3; i++) {
                    bytes.push(0);
                }
            }
            // Adjust for sign if the negative bit was set, and then convert array to BigNumber
            if ((bits & 0x00800000) !== 0) {
                return new BigNumber(bytes).neg();
            }
            else {
                return new BigNumber(bytes);
            }
        }
        /**
         * Converts this BigNumber to a number representing the "bits" value in a block header.
         *
         * @method toBits
         * @returns Returns a number equivalent to the "bits" value in a block header.
         *
         * @example
         * const bigNumber = new BigNumber(1);
         * const bits = bigNumber.toBits();
         */
        toBits() {
            let byteArray;
            if (this.ltn(0)) {
                byteArray = this.neg().toArray('be');
            }
            else {
                byteArray = this.toArray('be');
            }
            // Ensure that the byte array is of a minimum size
            while (byteArray.length < 4) {
                byteArray.unshift(0);
            }
            // For the case where byteArray represents '00', the bits should be 0x00000000
            if (byteArray.every(byte => byte === 0)) {
                return 0x00000000;
            }
            // Remove leading zeros from the byte array for further processing
            while (byteArray[0] === 0) {
                byteArray.shift();
            }
            let nsize = byteArray.length;
            // We're interested in the first three bytes for the "nword"
            // or in smaller cases, what's available
            let nword = byteArray.slice(0, 3).reduce((acc, val) => (acc * 256) + val, 0);
            // Ensure we don't have the sign bit set initially
            if ((nword & 0x800000) !== 0) {
                // If the 24th bit is set, we're going to need one more byte to represent this number
                byteArray.unshift(0); // Unshift a zero byte to not change the actual number
                nsize += 1;
                nword >>>= 8; // Shift right to make room for that byte
            }
            // Encode size and the 3 bytes into "nword"
            let bits = (nsize << 24) | nword;
            if (this.ltn(0)) {
                // If the number is negative, set the 0x00800000 bit to indicate sign
                bits |= 0x00800000;
            }
            return bits >>> 0; // Convert to unsigned 32-bit integer
        }
        /**
         * Creates a BigNumber from the format used in Bitcoin scripts.
         *
         * @static
         * @method fromScriptNum
         * @param num - The number in the format used in Bitcoin scripts.
         * @param requireMinimal - If true, non-minimally encoded values will throw an error.
         * @param maxNumSize - The maximum allowed size for the number. If not provided, defaults to 4.
         * @returns Returns a BigNumber equivalent to the number used in a Bitcoin script.
         * @throws Will throw an error if `requireMinimal` is `true` and the value is non-minimally encoded. Will throw an error if number length is greater than `maxNumSize`.
         *
         * @example
         * const num = [0x02, 0x01]
         * const bigNumber = BigNumber.fromScriptNum(num, true, 5)
         */
        static fromScriptNum(num, requireMinimal, maxNumSize) {
            if (maxNumSize === undefined) {
                maxNumSize = Number.MAX_SAFE_INTEGER;
            }
            if (num.length > maxNumSize) {
                throw new Error('script number overflow');
            }
            if (requireMinimal && num.length > 0) {
                // Check that the number is encoded with the minimum possible
                // number of bytes.
                //
                // If the most-significant-byte - excluding the sign bit - is zero
                // then we're not minimal. Note how this test also rejects the
                // negative-zero encoding, 0x80.
                if ((num[num.length - 1] & 0x7f) === 0) {
                    // One exception: if there's more than one byte and the most
                    // significant bit of the second-most-significant-byte is set
                    // it would conflict with the sign bit. An example of this case
                    // is +-255, which encode to 0xff00 and 0xff80 respectively.
                    // (big-endian).
                    if (num.length <= 1 || (num[num.length - 2] & 0x80) === 0) {
                        throw new Error('non-minimally encoded script number');
                    }
                }
            }
            return BigNumber.fromSm(num, 'little');
        }
        /**
         * Converts this BigNumber to a number in the format used in Bitcoin scripts.
         *
         * @method toScriptNum
         * @returns Returns the equivalent to this BigNumber as a Bitcoin script number.
         *
         * @example
         * const bigNumber = new BigNumber(258)
         * const num = bigNumber.toScriptNum() // equivalent to bigNumber.toSm('little')
         */
        toScriptNum() {
            return this.toSm('little');
        }
    }

    /**
     * A representation of a pseudo-Mersenne prime.
     * A pseudo-Mersenne prime has the general form 2^n - k, where n and k are integers.
     *
     * @class Mersenne
     *
     * @property name - The identifier for the Mersenne instance.
     * @property p - BigNumber equivalent to 2^n - k.
     * @property k - The constant subtracted from 2^n to derive a pseudo-Mersenne prime.
     * @property n - The exponent which determines the magnitude of the prime.
     */
    class Mersenne {
        name;
        p;
        k;
        n;
        tmp;
        /**
         * @constructor
         * @param name - An identifier for the Mersenne instance.
         * @param p - A string representation of the pseudo-Mersenne prime, expressed in hexadecimal.
         *
         * @example
         * const mersenne = new Mersenne('M31', '7FFFFFFF');
         */
        constructor(name, p) {
            // P = 2 ^ N - K
            this.name = name;
            this.p = new BigNumber(p, 16);
            this.n = this.p.bitLength();
            this.k = new BigNumber(1).iushln(this.n).isub(this.p);
            this.tmp = this._tmp();
        }
        /**
         * Creates a temporary BigNumber structure for computations,
         * ensuring the appropriate number of words are initially allocated.
         *
         * @method _tmp
         * @returns A BigNumber with scaled size depending on prime magnitude.
         */
        _tmp() {
            const tmp = new BigNumber();
            tmp.words = new Array(Math.ceil(this.n / 13));
            return tmp;
        }
        /**
         * Reduces an input BigNumber in place, under the assumption that
         * it is less than the square of the pseudo-Mersenne prime.
         *
         * @method ireduce
         * @param num - The BigNumber to be reduced.
         * @returns The reduced BigNumber.
         *
         * @example
         * const reduced = mersenne.ireduce(new BigNumber('2345', 16));
         */
        ireduce(num) {
            // Assumes that `num` is less than `P^2`
            // num = HI * (2 ^ N - K) + HI * K + LO = HI * K + LO (mod P)
            let r = num;
            let rlen;
            do {
                this.split(r, this.tmp);
                r = this.imulK(r);
                r = r.iadd(this.tmp);
                rlen = r.bitLength();
            } while (rlen > this.n);
            const cmp = rlen < this.n ? -1 : r.ucmp(this.p);
            if (cmp === 0) {
                r.words[0] = 0;
                r.length = 1;
            }
            else if (cmp > 0) {
                r.isub(this.p);
            }
            else {
                if (r.strip !== undefined) {
                    // r is a BN v4 instance
                    r.strip();
                }
                else {
                    // r is a BN v5 instance
                    r.strip();
                }
            }
            return r;
        }
        /**
         * Shifts bits of the input BigNumber to the right, in place,
         * to meet the magnitude of the pseudo-Mersenne prime.
         *
         * @method split
         * @param input - The BigNumber to be shifted.
         * @param out - The BigNumber to hold the shifted result.
         *
         * @example
         * mersenne.split(new BigNumber('2345', 16), new BigNumber());
         */
        split(input, out) {
            input.iushrn(this.n, 0, out);
        }
        /**
         * Performs an in-place multiplication of the parameter by constant k.
         *
         * @method imulK
         * @param num - The BigNumber to multiply with k.
         * @returns The result of the multiplication, in BigNumber format.
         *
         * @example
         * const multiplied = mersenne.imulK(new BigNumber('2345', 16));
         */
        imulK(num) {
            return num.imul(this.k);
        }
    }

    /**
     * A class representing K-256, a prime number with optimizations, specifically used in the secp256k1 curve.
     * It extends the functionalities of the Mersenne class.
     * K-256 prime is represented as 'ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff fffffffe fffffc2f'
     *
     * @class K256
     * @extends {Mersenne}
     *
     * @example
     * const k256 = new K256();
     */
    class K256 extends Mersenne {
        /**
         * Constructor for the K256 class.
         * Creates an instance of K256 using the super constructor from Mersenne.
         *
         * @constructor
         *
         * @example
         * const k256 = new K256();
         */
        constructor() {
            super('k256', 'ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff fffffffe fffffc2f');
        }
        /**
         * Splits a BigNumber into a new BigNumber based on specific computation
         * rules. This method modifies the input and output big numbers.
         *
         * @method split
         * @param input - The BigNumber to be split.
         * @param output - The BigNumber that results from the split.
         *
         * @example
         * const input = new BigNumber(3456);
         * const output = new BigNumber(0);
         * k256.split(input, output);
         */
        split(input, output) {
            // 256 = 9 * 26 + 22
            const mask = 0x3fffff;
            const outLen = Math.min(input.length, 9);
            let i = 0;
            for (; i < outLen; i++) {
                output.words[i] = input.words[i];
            }
            output.length = outLen;
            if (input.length <= 9) {
                input.words[0] = 0;
                input.length = 1;
                return;
            }
            // Shift by 9 limbs
            let prev = input.words[9];
            output.words[output.length++] = prev & mask;
            for (i = 10; i < input.length; i++) {
                const next = input.words[i] | 0;
                input.words[i - 10] = ((next & mask) << 4) | (prev >>> 22);
                prev = next;
            }
            prev >>>= 22;
            input.words[i - 10] = prev;
            if (prev === 0 && input.length > 10) {
                input.length -= 10;
            }
            else {
                input.length -= 9;
            }
        }
        /**
         * Multiplies a BigNumber ('num') with the constant 'K' in-place and returns the result.
         * 'K' is equal to 0x1000003d1 or in decimal representation: [ 64, 977 ].
         *
         * @method imulK
         * @param num - The BigNumber to multiply with K.
         * @returns Returns the mutated BigNumber after multiplication.
         *
         * @example
         * const number = new BigNumber(12345);
         * const result = k256.imulK(number);
         */
        imulK(num) {
            // K = 0x1000003d1 = [ 0x40, 0x3d1 ]
            num.words[num.length] = 0;
            num.words[num.length + 1] = 0;
            num.length += 2;
            // bounded at: 0x40 * 0x3ffffff + 0x3d0 = 0x100000390
            let lo = 0;
            for (let i = 0; i < num.length; i++) {
                const w = num.words[i] | 0;
                lo += w * 0x3d1;
                num.words[i] = lo & 0x3ffffff;
                lo = w * 0x40 + ((lo / 0x4000000) | 0);
            }
            // Fast length reduction
            if (num.words[num.length - 1] === 0) {
                num.length--;
                if (num.words[num.length - 1] === 0) {
                    num.length--;
                }
            }
            return num;
        }
    }

    /**
     * A base reduction engine that provides several arithmetic operations over
     * big numbers under a modulus context. It's particularly suitable for
     * calculations required in cryptography algorithms and encoding schemas.
     *
     * @class ReductionContext
     *
     * @property prime - The prime number utilised in the reduction context, typically an instance of Mersenne class.
     * @property m - The modulus used for reduction operations.
     */
    class ReductionContext {
        prime;
        m;
        /**
         * Constructs a new ReductionContext.
         *
         * @constructor
         * @param m - A BigNumber representing the modulus, or 'k256' to create a context for Koblitz curve.
         *
         * @example
         * new ReductionContext(new BigNumber(11));
         * new ReductionContext('k256');
         */
        constructor(m) {
            if (m === 'k256') {
                const prime = new K256();
                this.m = prime.p;
                this.prime = prime;
            }
            else {
                this.assert(m.gtn(1), 'modulus must be greater than 1');
                this.m = m;
                this.prime = null;
            }
        }
        /**
         * Asserts that given value is truthy. Throws an Error with a provided message
         * if the value is falsy.
         *
         * @private
         * @param val - The value to be checked.
         * @param msg - The error message to be thrown if the value is falsy.
         *
         * @example
         * this.assert(1 < 2, '1 is not less than 2');
         * this.assert(2 < 1, '2 is less than 1'); // throws an Error with message '2 is less than 1'
         */
        assert(val, msg = 'Assertion failed') {
            if (!val)
                throw new Error(msg);
        }
        /**
         * Verifies that a BigNumber is positive and red. Throws an error if these
         * conditions are not met.
         *
         * @param a - The BigNumber to be verified.
         *
         * @example
         * this.verify1(new BigNumber(10).toRed());
         * this.verify1(new BigNumber(-10).toRed()); //throws an Error
         * this.verify1(new BigNumber(10)); //throws an Error
         */
        verify1(a) {
            this.assert(a.negative === 0, 'red works only with positives');
            this.assert(a.red, 'red works only with red numbers');
        }
        /**
         * Verifies that two BigNumbers are both positive and red. Also checks
         * that they have the same reduction context. Throws an error if these
         * conditions are not met.
         *
         * @param a - The first BigNumber to be verified.
         * @param b - The second BigNumber to be verified.
         *
         * @example
         * this.verify2(new BigNumber(10).toRed(this), new BigNumber(20).toRed(this));
         * this.verify2(new BigNumber(-10).toRed(this), new BigNumber(20).toRed(this)); //throws an Error
         * this.verify2(new BigNumber(10).toRed(this), new BigNumber(20)); //throws an Error
         */
        verify2(a, b) {
            this.assert((a.negative | b.negative) === 0, 'red works only with positives');
            this.assert((a.red != null) && a.red === b.red, 'red works only with red numbers');
        }
        /**
         * Performs an in-place reduction of the given BigNumber by the modulus of the reduction context, 'm'.
         *
         * @method imod
         *
         * @param a - BigNumber to be reduced.
         *
         * @returns Returns the reduced result.
         *
         * @example
         * const context = new ReductionContext(new BigNumber(7));
         * context.imod(new BigNumber(19)); // Returns 5
         */
        imod(a) {
            if (this.prime != null)
                return this.prime.ireduce(a).forceRed(this);
            BigNumber.move(a, a.umod(this.m).forceRed(this));
            return a;
        }
        /**
         * Negates a BigNumber in the context of the modulus.
         *
         * @method neg
         *
         * @param a - BigNumber to negate.
         *
         * @returns Returns the negation of 'a' in the reduction context.
         *
         * @example
         * const context = new ReductionContext(new BigNumber(7));
         * context.neg(new BigNumber(3)); // Returns 4
         */
        neg(a) {
            if (a.isZero()) {
                return a.clone();
            }
            return this.m.sub(a).forceRed(this);
        }
        /**
         * Performs the addition operation on two BigNumbers in the reduction context.
         *
         * @method add
         *
         * @param a - First BigNumber to add.
         * @param b - Second BigNumber to add.
         *
         * @returns Returns the result of 'a + b' in the reduction context.
         *
         * @example
         * const context = new ReductionContext(new BigNumber(5));
         * context.add(new BigNumber(2), new BigNumber(4)); // Returns 1
         */
        add(a, b) {
            this.verify2(a, b);
            const res = a.add(b);
            if (res.cmp(this.m) >= 0) {
                res.isub(this.m);
            }
            return res.forceRed(this);
        }
        /**
         * Performs an in-place addition operation on two BigNumbers in the reduction context
         * in order to avoid creating a new BigNumber, it modifies the first one with the result.
         *
         * @method iadd
         *
         * @param a - First BigNumber to add.
         * @param b - Second BigNumber to add.
         *
         * @returns Returns the modified 'a' after addition with 'b' in the reduction context.
         *
         * @example
         * const context = new ReductionContext(new BigNumber(5));
         * const a = new BigNumber(2);
         * context.iadd(a, new BigNumber(4)); // Modifies 'a' to be 1
         */
        iadd(a, b) {
            this.verify2(a, b);
            const res = a.iadd(b);
            if (res.cmp(this.m) >= 0) {
                res.isub(this.m);
            }
            return res;
        }
        /**
         * Subtracts one BigNumber from another BigNumber in the reduction context.
         *
         * @method sub
         *
         * @param a - BigNumber to be subtracted from.
         * @param b - BigNumber to subtract.
         *
         * @returns Returns the result of 'a - b' in the reduction context.
         *
         * @example
         * const context = new ReductionContext(new BigNumber(7));
         * context.sub(new BigNumber(3), new BigNumber(2)); // Returns 1
         */
        sub(a, b) {
            this.verify2(a, b);
            const res = a.sub(b);
            if (res.cmpn(0) < 0) {
                res.iadd(this.m);
            }
            return res.forceRed(this);
        }
        /**
         * Performs in-place subtraction of one BigNumber from another in the reduction context,
         * it modifies the first BigNumber with the result.
         *
         * @method isub
         *
         * @param a - BigNumber to be subtracted from.
         * @param b - BigNumber to subtract.
         *
         * @returns Returns the modified 'a' after subtraction of 'b' in the reduction context.
         *
         * @example
         * const context = new ReductionContext(new BigNumber(5));
         * const a = new BigNumber(4);
         * context.isub(a, new BigNumber(2)); // Modifies 'a' to be 2
         */
        isub(a, b) {
            this.verify2(a, b);
            const res = a.isub(b);
            if (res.cmpn(0) < 0) {
                res.iadd(this.m);
            }
            return res;
        }
        /**
         * Performs bitwise shift left operation on a BigNumber in the reduction context.
         *
         * @method shl
         *
         * @param a - BigNumber to perform shift on.
         * @param num - The number of positions to shift.
         *
         * @returns Returns the result of shifting 'a' left by 'num' positions in the reduction context.
         *
         * @example
         * const context = new ReductionContext(new BigNumber(32));
         * context.shl(new BigNumber(4), 2); // Returns 16
         */
        shl(a, num) {
            this.verify1(a);
            return this.imod(a.ushln(num));
        }
        /**
         * Performs in-place multiplication of two BigNumbers in the reduction context,
         * modifying the first BigNumber with the result.
         *
         * @method imul
         *
         * @param a - First BigNumber to multiply.
         * @param b - Second BigNumber to multiply.
         *
         * @returns Returns the modified 'a' after multiplication with 'b' in the reduction context.
         *
         * @example
         * const context = new ReductionContext(new BigNumber(7));
         * const a = new BigNumber(3);
         * context.imul(a, new BigNumber(2)); // Modifies 'a' to be 6
         */
        imul(a, b) {
            this.verify2(a, b);
            return this.imod(a.imul(b));
        }
        /**
         * Multiplies two BigNumbers in the reduction context.
         *
         * @method mul
         *
         * @param a - First BigNumber to multiply.
         * @param b - Second BigNumber to multiply.
         *
         * @returns Returns the result of 'a * b' in the reduction context.
         *
         * @example
         * const context = new ReductionContext(new BigNumber(7));
         * context.mul(new BigNumber(3), new BigNumber(2)); // Returns 6
         */
        mul(a, b) {
            this.verify2(a, b);
            return this.imod(a.mul(b));
        }
        /**
         * Calculates the square of a BigNumber in the reduction context,
         * modifying the original BigNumber with the result.
         *
         * @method isqr
         *
         * @param a - BigNumber to be squared.
         *
         * @returns Returns the squared 'a' in the reduction context.
         *
         * @example
         * const context = new ReductionContext(new BigNumber(7));
         * const a = new BigNumber(3);
         * context.isqr(a); // Modifies 'a' to be 2 (9 % 7 = 2)
         */
        isqr(a) {
            return this.imul(a, a.clone());
        }
        /**
         * Calculates the square of a BigNumber in the reduction context.
         *
         * @method sqr
         *
         * @param a - BigNumber to be squared.
         *
         * @returns Returns the result of 'a^2' in the reduction context.
         *
         * @example
         * const context = new ReductionContext(new BigNumber(7));
         * context.sqr(new BigNumber(3)); // Returns 2 (9 % 7 = 2)
         */
        sqr(a) {
            return this.mul(a, a);
        }
        /**
         * Calculates the square root of a BigNumber in the reduction context.
         *
         * @method sqrt
         *
         * @param a - The BigNumber to calculate the square root of.
         *
         * @returns Returns the square root of 'a' in the reduction context.
         *
         * @example
         * const context = new ReductionContext(new BigNumber(9));
         * context.sqrt(new BigNumber(4)); // Returns 2
         */
        sqrt(a) {
            if (a.isZero())
                return a.clone();
            const mod3 = this.m.andln(3);
            this.assert(mod3 % 2 === 1);
            // Fast case
            if (mod3 === 3) {
                const pow = this.m.add(new BigNumber(1)).iushrn(2);
                return this.pow(a, pow);
            }
            // Tonelli-Shanks algorithm (Totally unoptimized and slow)
            //
            // Find Q and S, that Q * 2 ^ S = (P - 1)
            const q = this.m.subn(1);
            let s = 0;
            while (!q.isZero() && q.andln(1) === 0) {
                s++;
                q.iushrn(1);
            }
            this.assert(!q.isZero());
            const one = new BigNumber(1).toRed(this);
            const nOne = one.redNeg();
            // Find quadratic non-residue
            // NOTE: Max is such because of generalized Riemann hypothesis.
            const lpow = this.m.subn(1).iushrn(1);
            const zl = this.m.bitLength();
            const z = new BigNumber(2 * zl * zl).toRed(this);
            while (this.pow(z, lpow).cmp(nOne) !== 0) {
                z.redIAdd(nOne);
            }
            let c = this.pow(z, q);
            let r = this.pow(a, q.addn(1).iushrn(1));
            let t = this.pow(a, q);
            let m = s;
            while (t.cmp(one) !== 0) {
                let tmp = t;
                let i = 0;
                for (; tmp.cmp(one) !== 0; i++) {
                    tmp = tmp.redSqr();
                }
                this.assert(i < m);
                const b = this.pow(c, new BigNumber(1).iushln(m - i - 1));
                r = r.redMul(b);
                c = b.redSqr();
                t = t.redMul(c);
                m = i;
            }
            return r;
        }
        /**
         * Calculates the multiplicative inverse of a BigNumber in the reduction context.
         *
         * @method invm
         *
         * @param a - The BigNumber to find the multiplicative inverse of.
         *
         * @returns Returns the multiplicative inverse of 'a' in the reduction context.
         *
         * @example
         * const context = new ReductionContext(new BigNumber(11));
         * context.invm(new BigNumber(3)); // Returns 4 (3*4 mod 11 = 1)
         */
        invm(a) {
            const inv = a._invmp(this.m);
            if (inv.negative !== 0) {
                inv.negative = 0;
                return this.imod(inv).redNeg();
            }
            else {
                return this.imod(inv);
            }
        }
        /**
         * Raises a BigNumber to a power in the reduction context.
         *
         * @method pow
         *
         * @param a - The BigNumber to be raised to a power.
         * @param num - The power to raise the BigNumber to.
         *
         * @returns Returns the result of 'a' raised to the power of 'num' in the reduction context.
         *
         * @example
         * const context = new ReductionContext(new BigNumber(7));
         * context.pow(new BigNumber(3), new BigNumber(2)); // Returns 2 (3^2 % 7)
         */
        pow(a, num) {
            if (num.isZero())
                return new BigNumber(1).toRed(this);
            if (num.cmpn(1) === 0)
                return a.clone();
            const windowSize = 4;
            const wnd = new Array(1 << windowSize);
            wnd[0] = new BigNumber(1).toRed(this);
            wnd[1] = a;
            let i = 2;
            for (; i < wnd.length; i++) {
                wnd[i] = this.mul(wnd[i - 1], a);
            }
            let res = wnd[0];
            let current = 0;
            let currentLen = 0;
            let start = num.bitLength() % 26;
            if (start === 0) {
                start = 26;
            }
            for (i = num.length - 1; i >= 0; i--) {
                const word = num.words[i];
                for (let j = start - 1; j >= 0; j--) {
                    const bit = (word >> j) & 1;
                    if (res !== wnd[0]) {
                        res = this.sqr(res);
                    }
                    if (bit === 0 && current === 0) {
                        currentLen = 0;
                        continue;
                    }
                    current <<= 1;
                    current |= bit;
                    currentLen++;
                    if (currentLen !== windowSize && (i !== 0 || j !== 0))
                        continue;
                    res = this.mul(res, wnd[current]);
                    currentLen = 0;
                    current = 0;
                }
                start = 26;
            }
            return res;
        }
        /**
         * Converts a BigNumber to its equivalent in the reduction context.
         *
         * @method convertTo
         *
         * @param num - The BigNumber to convert to the reduction context.
         *
         * @returns Returns the converted BigNumber compatible with the reduction context.
         *
         * @example
         * const context = new ReductionContext(new BigNumber(7));
         * context.convertTo(new BigNumber(8)); // Returns 1 (8 % 7)
         */
        convertTo(num) {
            const r = num.umod(this.m);
            return r === num ? r.clone() : r;
        }
        /**
         * Converts a BigNumber from reduction context to its regular form.
         *
         * @method convertFrom
         *
         * @param num - The BigNumber to convert from the reduction context.
         *
         * @returns Returns the converted BigNumber in its regular form.
         *
         * @example
         * const context = new ReductionContext(new BigNumber(7));
         * const a = context.convertTo(new BigNumber(8)); // 'a' is now 1 in the reduction context
         * context.convertFrom(a); // Returns 1
         */
        convertFrom(num) {
            const res = num.clone();
            res.red = null;
            return res;
        }
    }

    /**
     * Represents a Montgomery reduction context, which is a mathematical method
     * for performing modular multiplication without division.
     *
     * Montgomery reduction is an algorithm used mainly in cryptography which can
     * help to speed up calculations in contexts where there are many repeated
     * computations.
     *
     * This class extends the `ReductionContext` class.
     *
     * @class MontgomoryMethod
     * @extends {ReductionContext}
     *
     * @property shift - The number of bits in the modulus.
     * @property r - The 2^shift, shifted left by the bit length of modulus `m`.
     * @property r2 - The square of `r` modulo `m`.
     * @property rinv - The modular multiplicative inverse of `r` mod `m`.
     * @property minv - The modular multiplicative inverse of `m` mod `r`.
     */
    class MontgomoryMethod extends ReductionContext {
        shift;
        r;
        r2;
        rinv;
        minv;
        /**
         * @constructor
         * @param m - The modulus to be used for the Montgomery method reductions.
         */
        constructor(m) {
            super(m);
            this.shift = this.m.bitLength();
            if (this.shift % 26 !== 0) {
                this.shift += 26 - (this.shift % 26);
            }
            this.r = new BigNumber(1).iushln(this.shift);
            this.r2 = this.imod(this.r.sqr());
            this.rinv = this.r._invmp(this.m);
            this.minv = this.rinv.mul(this.r).isubn(1).div(this.m);
            this.minv = this.minv.umod(this.r);
            this.minv = this.r.sub(this.minv);
        }
        /**
         * Converts a number into the Montgomery domain.
         *
         * @method convertTo
         * @param num - The number to be converted into the Montgomery domain.
         * @returns The result of the conversion into the Montgomery domain.
         *
         * @example
         * const montMethod = new MontgomoryMethod(m);
         * const convertedNum = montMethod.convertTo(num);
         */
        convertTo(num) {
            return this.imod(num.ushln(this.shift));
        }
        /**
         * Converts a number from the Montgomery domain back to the original domain.
         *
         * @method convertFrom
         * @param num - The number to be converted from the Montgomery domain.
         * @returns The result of the conversion from the Montgomery domain.
         *
         * @example
         * const montMethod = new MontgomoryMethod(m);
         * const convertedNum = montMethod.convertFrom(num);
         */
        convertFrom(num) {
            const r = this.imod(num.mul(this.rinv));
            r.red = null;
            return r;
        }
        /**
         * Performs an in-place multiplication of two numbers in the Montgomery domain.
         *
         * @method imul
         * @param a - The first number to multiply.
         * @param b - The second number to multiply.
         * @returns The result of the in-place multiplication.
         *
         * @example
         * const montMethod = new MontgomoryMethod(m);
         * const product = montMethod.imul(a, b);
         */
        imul(a, b) {
            if (a.isZero() || b.isZero()) {
                a.words[0] = 0;
                a.length = 1;
                return a;
            }
            const t = a.imul(b);
            const c = t.maskn(this.shift).mul(this.minv).imaskn(this.shift).mul(this.m);
            const u = t.isub(c).iushrn(this.shift);
            let res = u;
            if (u.cmp(this.m) >= 0) {
                res = u.isub(this.m);
            }
            else if (u.cmpn(0) < 0) {
                res = u.iadd(this.m);
            }
            return res.forceRed(this);
        }
        /**
         * Performs the multiplication of two numbers in the Montgomery domain.
         *
         * @method mul
         * @param a - The first number to multiply.
         * @param b - The second number to multiply.
         * @returns The result of the multiplication.
         *
         * @example
         * const montMethod = new MontgomoryMethod(m);
         * const product = montMethod.mul(a, b);
         */
        mul(a, b) {
            if (a.isZero() || b.isZero())
                return new BigNumber(0).forceRed(this);
            const t = a.mul(b);
            const c = t.maskn(this.shift).mul(this.minv).imaskn(this.shift).mul(this.m);
            const u = t.isub(c).iushrn(this.shift);
            let res = u;
            if (u.cmp(this.m) >= 0) {
                res = u.isub(this.m);
            }
            else if (u.cmpn(0) < 0) {
                res = u.iadd(this.m);
            }
            return res.forceRed(this);
        }
        /**
         * Calculates the modular multiplicative inverse of a number in the Montgomery domain.
         *
         * @method invm
         * @param a - The number to compute the modular multiplicative inverse of.
         * @returns The modular multiplicative inverse of 'a'.
         *
         * @example
         * const montMethod = new MontgomoryMethod(m);
         * const inverse = montMethod.invm(a);
         */
        invm(a) {
            // (AR)^-1 * R^2 = (A^-1 * R^-1) * R^2 = A^-1 * R
            const res = this.imod(a._invmp(this.m).mul(this.r2));
            return res.forceRed(this);
        }
    }

    /**
     * Base class for Point (affine coordinates) and JacobianPoint classes,
     * defining their curve and type.
     */
    class BasePoint {
        curve;
        type;
        precomputed;
        constructor(type) {
            this.curve = new Curve();
            this.type = type;
            this.precomputed = null;
        }
    }

    /**
     * The `JacobianPoint` class extends the `BasePoint` class for handling Jacobian coordinates on an Elliptic Curve.
     * This class defines the properties and the methods needed to work with points in Jacobian coordinates.
     *
     * The Jacobian coordinates represent a point (x, y, z) on an Elliptic Curve such that the usual (x, y) coordinates are given by (x/z^2, y/z^3).
     *
     * @property x - The `x` coordinate of the point in the Jacobian form.
     * @property y - The `y` coordinate of the point in the Jacobian form.
     * @property z - The `z` coordinate of the point in the Jacobian form.
     * @property zOne - Flag that indicates if the `z` coordinate is one.
     *
     * @example
     * const pointJ = new JacobianPoint('3', '4', '1');
     */
    class JacobianPoint extends BasePoint {
        x;
        y;
        z;
        zOne;
        /**
         * Constructs a new `JacobianPoint` instance.
         *
         * @param x - If `null`, the x-coordinate will default to the curve's defined 'one' constant.
         * If `x` is not a BigNumber, `x` will be converted to a `BigNumber` assuming it is a hex string.
         *
         * @param y - If `null`, the y-coordinate will default to the curve's defined 'one' constant.
         * If `y` is not a BigNumber, `y` will be converted to a `BigNumber` assuming it is a hex string.
         *
         * @param z - If `null`, the z-coordinate will default to 0.
         * If `z` is not a BigNumber, `z` will be converted to a `BigNumber` assuming it is a hex string.
         *
         * @example
         * const pointJ1 = new JacobianPoint(null, null, null); // creates point at infinity
         * const pointJ2 = new JacobianPoint('3', '4', '1'); // creates point (3, 4, 1)
         */
        constructor(x, y, z) {
            super('jacobian');
            if (x === null && y === null && z === null) {
                this.x = this.curve.one;
                this.y = this.curve.one;
                this.z = new BigNumber(0);
            }
            else {
                if (!BigNumber.isBN(x)) {
                    x = new BigNumber(x, 16);
                }
                this.x = x;
                if (!BigNumber.isBN(y)) {
                    y = new BigNumber(y, 16);
                }
                this.y = y;
                if (!BigNumber.isBN(z)) {
                    z = new BigNumber(z, 16);
                }
                this.z = z;
            }
            if (this.x.red == null) {
                this.x = this.x.toRed(this.curve.red);
            }
            if (this.y.red == null) {
                this.y = this.y.toRed(this.curve.red);
            }
            if (this.z.red == null) {
                this.z = this.z.toRed(this.curve.red);
            }
            this.zOne = this.z === this.curve.one;
        }
        /**
         * Converts the `JacobianPoint` object instance to standard affine `Point` format and returns `Point` type.
         *
         * @returns The `Point`(affine) object representing the same point as the original `JacobianPoint`.
         *
         * If the initial `JacobianPoint` represents point at infinity, an instance of `Point` at infinity is returned.
         *
         * @example
         * const pointJ = new JacobianPoint('3', '4', '1');
         * const pointP = pointJ.toP();  // The point in affine coordinates.
         */
        toP() {
            if (this.isInfinity()) {
                return new Point(null, null);
            }
            const zinv = this.z.redInvm();
            const zinv2 = zinv.redSqr();
            const ax = this.x.redMul(zinv2);
            const ay = this.y.redMul(zinv2).redMul(zinv);
            return new Point(ax, ay);
        }
        /**
         * Negation operation. It returns the additive inverse of the Jacobian point.
         *
         * @method neg
         * @returns Returns a new Jacobian point as the result of the negation.
         *
         * @example
         * const jp = new JacobianPoint(x, y, z)
         * const result = jp.neg()
         */
        neg() {
            return new JacobianPoint(this.x, this.y.redNeg(), this.z);
        }
        /**
         * Addition operation in the Jacobian coordinates. It takes a Jacobian point as an argument
         * and returns a new Jacobian point as a result of the addition. In the special cases,
         * when either one of the points is the point at infinity, it will return the other point.
         *
         * @method add
         * @param p - The Jacobian point to be added.
         * @returns Returns a new Jacobian point as the result of the addition.
         *
         * @example
         * const p1 = new JacobianPoint(x1, y1, z1)
         * const p2 = new JacobianPoint(x2, y2, z2)
         * const result = p1.add(p2)
         */
        add(p) {
            // O + P = P
            if (this.isInfinity()) {
                return p;
            }
            // P + O = P
            if (p.isInfinity()) {
                return this;
            }
            // 12M + 4S + 7A
            const pz2 = p.z.redSqr();
            const z2 = this.z.redSqr();
            const u1 = this.x.redMul(pz2);
            const u2 = p.x.redMul(z2);
            const s1 = this.y.redMul(pz2.redMul(p.z));
            const s2 = p.y.redMul(z2.redMul(this.z));
            const h = u1.redSub(u2);
            const r = s1.redSub(s2);
            if (h.cmpn(0) === 0) {
                if (r.cmpn(0) !== 0) {
                    return new JacobianPoint(null, null, null);
                }
                else {
                    return this.dbl();
                }
            }
            const h2 = h.redSqr();
            const h3 = h2.redMul(h);
            const v = u1.redMul(h2);
            const nx = r.redSqr().redIAdd(h3).redISub(v).redISub(v);
            const ny = r.redMul(v.redISub(nx)).redISub(s1.redMul(h3));
            const nz = this.z.redMul(p.z).redMul(h);
            return new JacobianPoint(nx, ny, nz);
        }
        /**
         * Mixed addition operation. This function combines the standard point addition with
         * the transformation from the affine to Jacobian coordinates. It first converts
         * the affine point to Jacobian, and then preforms the addition.
         *
         * @method mixedAdd
         * @param p - The affine point to be added.
         * @returns Returns the result of the mixed addition as a new Jacobian point.
         *
         * @example
         * const jp = new JacobianPoint(x1, y1, z1)
         * const ap = new Point(x2, y2)
         * const result = jp.mixedAdd(ap)
         */
        mixedAdd(p) {
            // O + P = P
            if (this.isInfinity()) {
                return p.toJ();
            }
            // P + O = P
            if (p.isInfinity()) {
                return this;
            }
            // 8M + 3S + 7A
            const z2 = this.z.redSqr();
            const u1 = this.x;
            const u2 = p.x.redMul(z2);
            const s1 = this.y;
            const s2 = p.y.redMul(z2).redMul(this.z);
            const h = u1.redSub(u2);
            const r = s1.redSub(s2);
            if (h.cmpn(0) === 0) {
                if (r.cmpn(0) !== 0) {
                    return new JacobianPoint(null, null, null);
                }
                else {
                    return this.dbl();
                }
            }
            const h2 = h.redSqr();
            const h3 = h2.redMul(h);
            const v = u1.redMul(h2);
            const nx = r.redSqr().redIAdd(h3).redISub(v).redISub(v);
            const ny = r.redMul(v.redISub(nx)).redISub(s1.redMul(h3));
            const nz = this.z.redMul(h);
            return new JacobianPoint(nx, ny, nz);
        }
        /**
         * Multiple doubling operation. It doubles the Jacobian point as many times as the pow parameter specifies. If pow is 0 or the point is the point at infinity, it will return the point itself.
         *
         * @method dblp
         * @param pow - The number of times the point should be doubled.
         * @returns Returns a new Jacobian point as the result of multiple doublings.
         *
         * @example
         * const jp = new JacobianPoint(x, y, z)
         * const result = jp.dblp(3)
         */
        dblp(pow) {
            if (pow === 0) {
                return this;
            }
            if (this.isInfinity()) {
                return this;
            }
            if (typeof pow === 'undefined') {
                return this.dbl();
            }
            /* eslint-disable @typescript-eslint/no-this-alias */
            let r = this;
            for (let i = 0; i < pow; i++) {
                r = r.dbl();
            }
            return r;
        }
        /**
         * Point doubling operation in the Jacobian coordinates. A special case is when the point is the point at infinity, in this case, this function will return the point itself.
         *
         * @method dbl
         * @returns Returns a new Jacobian point as the result of the doubling.
         *
         * @example
         * const jp = new JacobianPoint(x, y, z)
         * const result = jp.dbl()
         */
        dbl() {
            if (this.isInfinity()) {
                return this;
            }
            let nx;
            let ny;
            let nz;
            // Z = 1
            if (this.zOne) {
                // hyperelliptic.org/EFD/g1p/auto-shortw-jacobian-0.html
                //     #doubling-mdbl-2007-bl
                // 1M + 5S + 14A
                // XX = X1^2
                const xx = this.x.redSqr();
                // YY = Y1^2
                const yy = this.y.redSqr();
                // YYYY = YY^2
                const yyyy = yy.redSqr();
                // S = 2 * ((X1 + YY)^2 - XX - YYYY)
                let s = this.x.redAdd(yy).redSqr().redISub(xx).redISub(yyyy);
                s = s.redIAdd(s);
                // M = 3 * XX + a; a = 0
                const m = xx.redAdd(xx).redIAdd(xx);
                // T = M ^ 2 - 2*S
                const t = m.redSqr().redISub(s).redISub(s);
                // 8 * YYYY
                let yyyy8 = yyyy.redIAdd(yyyy);
                yyyy8 = yyyy8.redIAdd(yyyy8);
                yyyy8 = yyyy8.redIAdd(yyyy8);
                // X3 = T
                nx = t;
                // Y3 = M * (S - T) - 8 * YYYY
                ny = m.redMul(s.redISub(t)).redISub(yyyy8);
                // Z3 = 2*Y1
                nz = this.y.redAdd(this.y);
            }
            else {
                // hyperelliptic.org/EFD/g1p/auto-shortw-jacobian-0.html
                //     #doubling-dbl-2009-l
                // 2M + 5S + 13A
                // A = X1^2
                const a = this.x.redSqr();
                // B = Y1^2
                const b = this.y.redSqr();
                // C = B^2
                const c = b.redSqr();
                // D = 2 * ((X1 + B)^2 - A - C)
                let d = this.x.redAdd(b).redSqr().redISub(a).redISub(c);
                d = d.redIAdd(d);
                // E = 3 * A
                const e = a.redAdd(a).redIAdd(a);
                // F = E^2
                const f = e.redSqr();
                // 8 * C
                let c8 = c.redIAdd(c);
                c8 = c8.redIAdd(c8);
                c8 = c8.redIAdd(c8);
                // X3 = F - 2 * D
                nx = f.redISub(d).redISub(d);
                // Y3 = E * (D - X3) - 8 * C
                ny = e.redMul(d.redISub(nx)).redISub(c8);
                // Z3 = 2 * Y1 * Z1
                nz = this.y.redMul(this.z);
                nz = nz.redIAdd(nz);
            }
            return new JacobianPoint(nx, ny, nz);
        }
        /**
         * Equality check operation. It checks whether the affine or Jacobian point is equal to this Jacobian point.
         *
         * @method eq
         * @param p - The affine or Jacobian point to compare with.
         * @returns Returns true if the points are equal, otherwise returns false.
         *
         * @example
         * const jp1 = new JacobianPoint(x1, y1, z1)
         * const jp2 = new JacobianPoint(x2, y2, z2)
         * const areEqual = jp1.eq(jp2)
         */
        eq(p) {
            if (p.type === 'affine') {
                return this.eq(p.toJ());
            }
            if (this === p) {
                return true;
            }
            // x1 * z2^2 == x2 * z1^2
            const z2 = this.z.redSqr();
            p = p;
            const pz2 = p.z.redSqr();
            if (this.x.redMul(pz2).redISub(p.x.redMul(z2)).cmpn(0) !== 0) {
                return false;
            }
            // y1 * z2^3 == y2 * z1^3
            const z3 = z2.redMul(this.z);
            const pz3 = pz2.redMul(p.z);
            return this.y.redMul(pz3).redISub(p.y.redMul(z3)).cmpn(0) === 0;
        }
        /**
         * Equality check operation in relation to an x coordinate of a point in projective coordinates.
         * It checks whether the x coordinate of the Jacobian point is equal to the provided x coordinate
         * of a point in projective coordinates.
         *
         * @method eqXToP
         * @param x - The x coordinate of a point in projective coordinates.
         * @returns Returns true if the x coordinates are equal, otherwise returns false.
         *
         * @example
         * const jp = new JacobianPoint(x1, y1, z1)
         * const isXEqual = jp.eqXToP(x2)
         */
        eqXToP(x) {
            const zs = this.z.redSqr();
            const rx = x.toRed(this.curve.red).redMul(zs);
            if (this.x.cmp(rx) === 0) {
                return true;
            }
            const xc = x.clone();
            const t = this.curve.redN.redMul(zs);
            for (;;) {
                xc.iadd(this.curve.n);
                if (xc.cmp(this.curve.p) >= 0) {
                    return false;
                }
                rx.redIAdd(t);
                if (this.x.cmp(rx) === 0) {
                    return true;
                }
            }
        }
        /**
         * Returns the string representation of the JacobianPoint instance.
         * @method inspect
         * @returns Returns the string description of the JacobianPoint. If the JacobianPoint represents a point at infinity, the return value of this function is '<EC JPoint Infinity>'. For a normal point, it returns the string description format as '<EC JPoint x: x-coordinate y: y-coordinate z: z-coordinate>'.
         *
         * @example
         * const point = new JacobianPoint('5', '6', '1');
         * console.log(point.inspect()); // Output: '<EC JPoint x: 5 y: 6 z: 1>'
         */
        inspect() {
            if (this.isInfinity()) {
                return '<EC JPoint Infinity>';
            }
            return '<EC JPoint x: ' + this.x.toString(16, 2) +
                ' y: ' + this.y.toString(16, 2) +
                ' z: ' + this.z.toString(16, 2) + '>';
        }
        /**
         * Checks whether the JacobianPoint instance represents a point at infinity.
         * @method isInfinity
         * @returns Returns true if the JacobianPoint's z-coordinate equals to zero (which represents the point at infinity in Jacobian coordinates). Returns false otherwise.
         *
         * @example
         * const point = new JacobianPoint('5', '6', '0');
         * console.log(point.isInfinity()); // Output: true
         */
        isInfinity() {
            return this.z.cmpn(0) === 0;
        }
    }

    const assert$1 = (expression, message = 'Hash assertion failed') => {
        if (!expression) {
            throw new Error(message);
        }
    };
    /**
     * The BaseHash class is an abstract base class for cryptographic hash functions.
     * It provides a common structure and functionality for hash function classes.
     *
     * @class BaseHash
     *
     * @property pending - Stores partially processed message segments.
     * @property pendingTotal - The total number of characters that are being stored in `pending`
     * @property blockSize - The size of each block to processed.
     * @property outSize - The size of the final hash output.
     * @property endian - The endianness used during processing, can either be 'big' or 'little'.
     * @property _delta8 - The block size divided by 8, useful in various computations.
     * @property _delta32 - The block size divided by 32, useful in various computations.
     * @property padLength - The length of padding to be added to finalize the computation.
     * @property hmacStrength - The HMAC strength value.
     *
     * @param blockSize - The size of the block to be hashed.
     * @param outSize - The size of the resulting hash.
     * @param hmacStrength - The strength of the HMAC.
     * @param padLength - The length of the padding to be added.
     *
     * @example
     * Sub-classes would extend this base BaseHash class like:
     * class RIPEMD160 extends BaseHash {
     *   constructor () {
     *     super(512, 160, 192, 64);
     *     // ...
     *   }
     *   // ...
     * }
     */
    class BaseHash {
        pending;
        pendingTotal;
        blockSize;
        outSize;
        endian;
        _delta8;
        _delta32;
        padLength;
        hmacStrength;
        constructor(blockSize, outSize, hmacStrength, padLength) {
            this.pending = null;
            this.pendingTotal = 0;
            this.blockSize = blockSize;
            this.outSize = outSize;
            this.hmacStrength = hmacStrength;
            this.padLength = padLength / 8;
            this.endian = 'big';
            this._delta8 = this.blockSize / 8;
            this._delta32 = this.blockSize / 32;
        }
        _update(msg, start) {
            throw new Error('Not implemented');
        }
        _digest() {
            throw new Error('Not implemented');
        }
        _digestHex() {
            throw new Error('Not implemented');
        }
        /**
         * Converts the input message into an array, pads it, and joins into 32bit blocks.
         * If there is enough data, it tries updating the hash computation.
         *
         * @method update
         * @param msg - The message segment to include in the hashing computation.
         * @param enc - The encoding of the message. If 'hex', the string will be treated as such, 'utf8' otherwise.
         *
         * @returns Returns the instance of the object for chaining.
         *
         * @example
         * sha256.update('Hello World', 'utf8');
         */
        update(msg, enc) {
            // Convert message to array, pad it, and join into 32bit blocks
            msg = toArray$3(msg, enc);
            if (this.pending == null) {
                this.pending = msg;
            }
            else {
                this.pending = this.pending.concat(msg);
            }
            this.pendingTotal += msg.length;
            // Enough data, try updating
            if (this.pending.length >= this._delta8) {
                msg = this.pending;
                // Process pending data in blocks
                const r = msg.length % this._delta8;
                this.pending = msg.slice(msg.length - r, msg.length);
                if (this.pending.length === 0) {
                    this.pending = null;
                }
                msg = join32(msg, 0, msg.length - r, this.endian);
                for (let i = 0; i < msg.length; i += this._delta32) {
                    this._update(msg, i);
                }
            }
            return this;
        }
        /**
         * Finalizes the hash computation and returns the hash value/result.
         *
         * @method digest
         *
         * @returns Returns the final hash value.
         *
         * @example
         * const hash = sha256.digest();
         */
        digest() {
            this.update(this._pad());
            assert$1(this.pending === null);
            return this._digest();
        }
        ;
        /**
         * Finalizes the hash computation and returns the hash value/result as a hex string.
         *
         * @method digest
         *
         * @returns Returns the final hash value as a hex string.
         *
         * @example
         * const hash = sha256.digestHex();
         */
        digestHex() {
            this.update(this._pad());
            assert$1(this.pending === null);
            return this._digestHex();
        }
        ;
        /**
         * [Private Method] Used internally to prepare the padding for the final stage of the hash computation.
         *
         * @method _pad
         * @private
         *
         * @returns Returns an array denoting the padding.
         */
        _pad() {
            let len = this.pendingTotal;
            const bytes = this._delta8;
            const k = bytes - ((len + this.padLength) % bytes);
            const res = new Array(k + this.padLength);
            res[0] = 0x80;
            let i;
            for (i = 1; i < k; i++) {
                res[i] = 0;
            }
            // Append length
            len <<= 3;
            let t;
            if (this.endian === 'big') {
                for (t = 8; t < this.padLength; t++) {
                    res[i++] = 0;
                }
                res[i++] = 0;
                res[i++] = 0;
                res[i++] = 0;
                res[i++] = 0;
                res[i++] = (len >>> 24) & 0xff;
                res[i++] = (len >>> 16) & 0xff;
                res[i++] = (len >>> 8) & 0xff;
                res[i++] = len & 0xff;
            }
            else {
                res[i++] = len & 0xff;
                res[i++] = (len >>> 8) & 0xff;
                res[i++] = (len >>> 16) & 0xff;
                res[i++] = (len >>> 24) & 0xff;
                res[i++] = 0;
                res[i++] = 0;
                res[i++] = 0;
                res[i++] = 0;
                for (t = 8; t < this.padLength; t++) {
                    res[i++] = 0;
                }
            }
            return res;
        }
    }
    function isSurrogatePair(msg, i) {
        if ((msg.charCodeAt(i) & 0xFC00) !== 0xD800) {
            return false;
        }
        if (i < 0 || i + 1 >= msg.length) {
            return false;
        }
        return (msg.charCodeAt(i + 1) & 0xFC00) === 0xDC00;
    }
    /**
     *
     * @param msg
     * @param enc Optional. Encoding to use if msg is string. Default is 'utf8'.
     * @returns array of byte values from msg. If msg is an array, a copy is returned.
     */
    function toArray$3(msg, enc) {
        if (Array.isArray(msg)) {
            return msg.slice();
        }
        if (!msg) {
            return [];
        }
        const res = [];
        if (typeof msg === 'string') {
            if (enc !== 'hex') {
                // Inspired by stringToUtf8ByteArray() in closure-library by Google
                // https://github.com/google/closure-library/blob/8598d87242af59aac233270742c8984e2b2bdbe0/closure/goog/crypt/crypt.js#L117-L143
                // Apache License 2.0
                // https://github.com/google/closure-library/blob/master/LICENSE
                let p = 0;
                for (let i = 0; i < msg.length; i++) {
                    let c = msg.charCodeAt(i);
                    if (c < 128) {
                        res[p++] = c;
                    }
                    else if (c < 2048) {
                        res[p++] = (c >> 6) | 192;
                        res[p++] = (c & 63) | 128;
                    }
                    else if (isSurrogatePair(msg, i)) {
                        c = 0x10000 + ((c & 0x03FF) << 10) + (msg.charCodeAt(++i) & 0x03FF);
                        res[p++] = (c >> 18) | 240;
                        res[p++] = ((c >> 12) & 63) | 128;
                        res[p++] = ((c >> 6) & 63) | 128;
                        res[p++] = (c & 63) | 128;
                    }
                    else {
                        res[p++] = (c >> 12) | 224;
                        res[p++] = ((c >> 6) & 63) | 128;
                        res[p++] = (c & 63) | 128;
                    }
                }
            }
            else {
                msg = msg.replace(/[^a-z0-9]+/ig, '');
                if (msg.length % 2 !== 0) {
                    msg = '0' + msg;
                }
                for (let i = 0; i < msg.length; i += 2) {
                    res.push(parseInt(msg[i] + msg[i + 1], 16));
                }
            }
        }
        else {
            msg = msg;
            for (let i = 0; i < msg.length; i++) {
                res[i] = msg[i] | 0;
            }
        }
        return res;
    }
    function htonl(w) {
        const res = (w >>> 24) |
            ((w >>> 8) & 0xff00) |
            ((w << 8) & 0xff0000) |
            ((w & 0xff) << 24);
        return res >>> 0;
    }
    function toHex32(msg, endian) {
        let res = '';
        for (let i = 0; i < msg.length; i++) {
            let w = msg[i];
            if (endian === 'little') {
                w = htonl(w);
            }
            res += zero8(w.toString(16));
        }
        return res;
    }
    function zero8(word) {
        if (word.length === 7) {
            return '0' + word;
        }
        else if (word.length === 6) {
            return '00' + word;
        }
        else if (word.length === 5) {
            return '000' + word;
        }
        else if (word.length === 4) {
            return '0000' + word;
        }
        else if (word.length === 3) {
            return '00000' + word;
        }
        else if (word.length === 2) {
            return '000000' + word;
        }
        else if (word.length === 1) {
            return '0000000' + word;
        }
        else {
            return word;
        }
    }
    function join32(msg, start, end, endian) {
        const len = end - start;
        assert$1(len % 4 === 0);
        const res = new Array(len / 4);
        for (let i = 0, k = start; i < res.length; i++, k += 4) {
            let w;
            if (endian === 'big') {
                w = (msg[k] << 24) | (msg[k + 1] << 16) | (msg[k + 2] << 8) | msg[k + 3];
            }
            else {
                w = (msg[k + 3] << 24) | (msg[k + 2] << 16) | (msg[k + 1] << 8) | msg[k];
            }
            res[i] = w >>> 0;
        }
        return res;
    }
    function split32(msg, endian) {
        const res = new Array(msg.length * 4);
        for (let i = 0, k = 0; i < msg.length; i++, k += 4) {
            const m = msg[i];
            if (endian === 'big') {
                res[k] = m >>> 24;
                res[k + 1] = (m >>> 16) & 0xff;
                res[k + 2] = (m >>> 8) & 0xff;
                res[k + 3] = m & 0xff;
            }
            else {
                res[k + 3] = m >>> 24;
                res[k + 2] = (m >>> 16) & 0xff;
                res[k + 1] = (m >>> 8) & 0xff;
                res[k] = m & 0xff;
            }
        }
        return res;
    }
    function rotr32(w, b) {
        return (w >>> b) | (w << (32 - b));
    }
    function rotl32(w, b) {
        return (w << b) | (w >>> (32 - b));
    }
    function sum32(a, b) {
        return (a + b) >>> 0;
    }
    function SUM32_3(a, b, c) {
        return (a + b + c) >>> 0;
    }
    function SUM32_4(a, b, c, d) {
        return (a + b + c + d) >>> 0;
    }
    function SUM32_5(a, b, c, d, e) {
        return (a + b + c + d + e) >>> 0;
    }
    function ch32(x, y, z) {
        return (x & y) ^ ((~x) & z);
    }
    function maj32(x, y, z) {
        return (x & y) ^ (x & z) ^ (y & z);
    }
    function S0_256(x) {
        return rotr32(x, 2) ^ rotr32(x, 13) ^ rotr32(x, 22);
    }
    function S1_256(x) {
        return rotr32(x, 6) ^ rotr32(x, 11) ^ rotr32(x, 25);
    }
    function G0_256(x) {
        return rotr32(x, 7) ^ rotr32(x, 18) ^ (x >>> 3);
    }
    function G1_256(x) {
        return rotr32(x, 17) ^ rotr32(x, 19) ^ (x >>> 10);
    }
    const r = [
        0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15,
        7, 4, 13, 1, 10, 6, 15, 3, 12, 0, 9, 5, 2, 14, 11, 8,
        3, 10, 14, 4, 9, 15, 8, 1, 2, 7, 0, 6, 13, 11, 5, 12,
        1, 9, 11, 10, 0, 8, 12, 4, 13, 3, 7, 15, 14, 5, 6, 2,
        4, 0, 5, 9, 7, 12, 2, 10, 14, 1, 3, 8, 11, 6, 15, 13
    ];
    const rh = [
        5, 14, 7, 0, 9, 2, 11, 4, 13, 6, 15, 8, 1, 10, 3, 12,
        6, 11, 3, 7, 0, 13, 5, 10, 14, 15, 8, 12, 4, 9, 1, 2,
        15, 5, 1, 3, 7, 14, 6, 9, 11, 8, 12, 2, 10, 0, 4, 13,
        8, 6, 4, 1, 3, 11, 15, 0, 5, 12, 2, 13, 9, 7, 10, 14,
        12, 15, 10, 4, 1, 5, 8, 7, 6, 2, 13, 14, 0, 3, 9, 11
    ];
    const s = [
        11, 14, 15, 12, 5, 8, 7, 9, 11, 13, 14, 15, 6, 7, 9, 8,
        7, 6, 8, 13, 11, 9, 7, 15, 7, 12, 15, 9, 11, 7, 13, 12,
        11, 13, 6, 7, 14, 9, 13, 15, 14, 8, 13, 6, 5, 12, 7, 5,
        11, 12, 14, 15, 14, 15, 9, 8, 9, 14, 5, 6, 8, 6, 5, 12,
        9, 15, 5, 11, 6, 8, 13, 12, 5, 12, 13, 14, 11, 8, 5, 6
    ];
    const sh = [
        8, 9, 9, 11, 13, 15, 15, 5, 7, 7, 8, 11, 14, 14, 12, 6,
        9, 13, 15, 7, 12, 8, 9, 11, 7, 7, 12, 7, 6, 15, 13, 11,
        9, 7, 15, 11, 8, 6, 6, 14, 12, 13, 5, 14, 13, 13, 7, 5,
        15, 5, 8, 11, 14, 14, 6, 14, 6, 9, 12, 9, 12, 5, 15, 8,
        8, 5, 12, 9, 12, 5, 14, 6, 8, 13, 6, 5, 15, 13, 11, 11
    ];
    function f(j, x, y, z) {
        if (j <= 15) {
            return x ^ y ^ z;
        }
        else if (j <= 31) {
            return (x & y) | ((~x) & z);
        }
        else if (j <= 47) {
            return (x | (~y)) ^ z;
        }
        else if (j <= 63) {
            return (x & z) | (y & (~z));
        }
        else {
            return x ^ (y | (~z));
        }
    }
    function K(j) {
        if (j <= 15) {
            return 0x00000000;
        }
        else if (j <= 31) {
            return 0x5a827999;
        }
        else if (j <= 47) {
            return 0x6ed9eba1;
        }
        else if (j <= 63) {
            return 0x8f1bbcdc;
        }
        else {
            return 0xa953fd4e;
        }
    }
    function Kh(j) {
        if (j <= 15) {
            return 0x50a28be6;
        }
        else if (j <= 31) {
            return 0x5c4dd124;
        }
        else if (j <= 47) {
            return 0x6d703ef3;
        }
        else if (j <= 63) {
            return 0x7a6d76e9;
        }
        else {
            return 0x00000000;
        }
    }
    function sum64(buf, pos, ah, al) {
        const bh = buf[pos];
        const bl = buf[pos + 1];
        const lo = (al + bl) >>> 0;
        const hi = (lo < al ? 1 : 0) + ah + bh;
        buf[pos] = hi >>> 0;
        buf[pos + 1] = lo;
    }
    function sum64_hi(ah, al, bh, bl) {
        const lo = (al + bl) >>> 0;
        const hi = (lo < al ? 1 : 0) + ah + bh;
        return hi >>> 0;
    }
    function sum64_lo(ah, al, bh, bl) {
        const lo = al + bl;
        return lo >>> 0;
    }
    function sum64_4_hi(ah, al, bh, bl, ch, cl, dh, dl) {
        let carry = 0;
        let lo = al;
        lo = (lo + bl) >>> 0;
        carry += lo < al ? 1 : 0;
        lo = (lo + cl) >>> 0;
        carry += lo < cl ? 1 : 0;
        lo = (lo + dl) >>> 0;
        carry += lo < dl ? 1 : 0;
        const hi = ah + bh + ch + dh + carry;
        return hi >>> 0;
    }
    function sum64_4_lo(ah, al, bh, bl, ch, cl, dh, dl) {
        const lo = al + bl + cl + dl;
        return lo >>> 0;
    }
    function sum64_5_hi(ah, al, bh, bl, ch, cl, dh, dl, eh, el) {
        let carry = 0;
        let lo = al;
        lo = (lo + bl) >>> 0;
        carry += lo < al ? 1 : 0;
        lo = (lo + cl) >>> 0;
        carry += lo < cl ? 1 : 0;
        lo = (lo + dl) >>> 0;
        carry += lo < dl ? 1 : 0;
        lo = (lo + el) >>> 0;
        carry += lo < el ? 1 : 0;
        const hi = ah + bh + ch + dh + eh + carry;
        return hi >>> 0;
    }
    function sum64_5_lo(ah, al, bh, bl, ch, cl, dh, dl, eh, el) {
        const lo = al + bl + cl + dl + el;
        return lo >>> 0;
    }
    function rotr64_hi(ah, al, num) {
        const r = (al << (32 - num)) | (ah >>> num);
        return r >>> 0;
    }
    function rotr64_lo(ah, al, num) {
        const r = (ah << (32 - num)) | (al >>> num);
        return r >>> 0;
    }
    function shr64_hi(ah, al, num) {
        return ah >>> num;
    }
    function shr64_lo(ah, al, num) {
        const r = (ah << (32 - num)) | (al >>> num);
        return r >>> 0;
    }
    /**
     * An implementation of RIPEMD160 cryptographic hash function. Extends the BaseHash class.
     * It provides a way to compute a 'digest' for any kind of input data; transforming the data
     * into a unique output of fixed size. The output is deterministic; it will always be
     * the same for the same input.
     *
     * @class RIPEMD160
     * @param None
     *
     * @constructor
     * Use the RIPEMD160 constructor to create an instance of RIPEMD160 hash function.
     *
     * @example
     * const ripemd160 = new RIPEMD160();
     *
     * @property h - Array that is updated iteratively as part of hashing computation.
     */
    class RIPEMD160 extends BaseHash {
        h;
        constructor() {
            super(512, 160, 192, 64);
            this.endian = 'little';
            this.h = [0x67452301, 0xefcdab89, 0x98badcfe, 0x10325476, 0xc3d2e1f0];
            this.endian = 'little';
        }
        _update(msg, start) {
            let A = this.h[0];
            let B = this.h[1];
            let C = this.h[2];
            let D = this.h[3];
            let E = this.h[4];
            let Ah = A;
            let Bh = B;
            let Ch = C;
            let Dh = D;
            let Eh = E;
            let T;
            for (let j = 0; j < 80; j++) {
                T = sum32(rotl32(SUM32_4(A, f(j, B, C, D), msg[r[j] + start], K(j)), s[j]), E);
                A = E;
                E = D;
                D = rotl32(C, 10);
                C = B;
                B = T;
                T = sum32(rotl32(SUM32_4(Ah, f(79 - j, Bh, Ch, Dh), msg[rh[j] + start], Kh(j)), sh[j]), Eh);
                Ah = Eh;
                Eh = Dh;
                Dh = rotl32(Ch, 10);
                Ch = Bh;
                Bh = T;
            }
            T = SUM32_3(this.h[1], C, Dh);
            this.h[1] = SUM32_3(this.h[2], D, Eh);
            this.h[2] = SUM32_3(this.h[3], E, Ah);
            this.h[3] = SUM32_3(this.h[4], A, Bh);
            this.h[4] = SUM32_3(this.h[0], B, Ch);
            this.h[0] = T;
        }
        _digest() {
            return split32(this.h, 'little');
        }
        _digestHex() {
            return toHex32(this.h, 'little');
        }
    }
    /**
     * An implementation of SHA256 cryptographic hash function. Extends the BaseHash class.
     * It provides a way to compute a 'digest' for any kind of input data; transforming the data
     * into a unique output of fixed size. The output is deterministic; it will always be
     * the same for the same input.
     *
     * @class SHA256
     * @param None
     *
     * @constructor
     * Use the SHA256 constructor to create an instance of SHA256 hash function.
     *
     * @example
     * const sha256 = new SHA256();
     *
     * @property h - The initial hash constants
     * @property W - Provides a way to recycle usage of the array memory.
     * @property k - The round constants used for each round of SHA-256
     */
    class SHA256 extends BaseHash {
        h;
        W;
        k;
        constructor() {
            super(512, 256, 192, 64);
            this.h = [
                0x6a09e667, 0xbb67ae85, 0x3c6ef372, 0xa54ff53a,
                0x510e527f, 0x9b05688c, 0x1f83d9ab, 0x5be0cd19
            ];
            this.k = [
                0x428a2f98, 0x71374491, 0xb5c0fbcf, 0xe9b5dba5,
                0x3956c25b, 0x59f111f1, 0x923f82a4, 0xab1c5ed5,
                0xd807aa98, 0x12835b01, 0x243185be, 0x550c7dc3,
                0x72be5d74, 0x80deb1fe, 0x9bdc06a7, 0xc19bf174,
                0xe49b69c1, 0xefbe4786, 0x0fc19dc6, 0x240ca1cc,
                0x2de92c6f, 0x4a7484aa, 0x5cb0a9dc, 0x76f988da,
                0x983e5152, 0xa831c66d, 0xb00327c8, 0xbf597fc7,
                0xc6e00bf3, 0xd5a79147, 0x06ca6351, 0x14292967,
                0x27b70a85, 0x2e1b2138, 0x4d2c6dfc, 0x53380d13,
                0x650a7354, 0x766a0abb, 0x81c2c92e, 0x92722c85,
                0xa2bfe8a1, 0xa81a664b, 0xc24b8b70, 0xc76c51a3,
                0xd192e819, 0xd6990624, 0xf40e3585, 0x106aa070,
                0x19a4c116, 0x1e376c08, 0x2748774c, 0x34b0bcb5,
                0x391c0cb3, 0x4ed8aa4a, 0x5b9cca4f, 0x682e6ff3,
                0x748f82ee, 0x78a5636f, 0x84c87814, 0x8cc70208,
                0x90befffa, 0xa4506ceb, 0xbef9a3f7, 0xc67178f2
            ];
            this.W = new Array(64);
        }
        _update(msg, start) {
            const W = this.W;
            let i;
            for (i = 0; i < 16; i++) {
                W[i] = msg[start + i];
            }
            for (; i < W.length; i++) {
                W[i] = SUM32_4(G1_256(W[i - 2]), W[i - 7], G0_256(W[i - 15]), W[i - 16]);
            }
            let a = this.h[0];
            let b = this.h[1];
            let c = this.h[2];
            let d = this.h[3];
            let e = this.h[4];
            let f = this.h[5];
            let g = this.h[6];
            let h = this.h[7];
            assert$1(this.k.length === W.length);
            for (i = 0; i < W.length; i++) {
                const T1 = SUM32_5(h, S1_256(e), ch32(e, f, g), this.k[i], W[i]);
                const T2 = sum32(S0_256(a), maj32(a, b, c));
                h = g;
                g = f;
                f = e;
                e = sum32(d, T1);
                d = c;
                c = b;
                b = a;
                a = sum32(T1, T2);
            }
            this.h[0] = sum32(this.h[0], a);
            this.h[1] = sum32(this.h[1], b);
            this.h[2] = sum32(this.h[2], c);
            this.h[3] = sum32(this.h[3], d);
            this.h[4] = sum32(this.h[4], e);
            this.h[5] = sum32(this.h[5], f);
            this.h[6] = sum32(this.h[6], g);
            this.h[7] = sum32(this.h[7], h);
        }
        ;
        _digest() {
            return split32(this.h, 'big');
        }
        _digestHex() {
            return toHex32(this.h, 'big');
        }
    }
    /**
     * An implementation of SHA512 cryptographic hash function. Extends the BaseHash class.
     * It provides a way to compute a 'digest' for any kind of input data; transforming the data
     * into a unique output of fixed size. The output is deterministic; it will always be
     * the same for the same input.
     *
     * @class SHA512
     * @param None
     *
     * @constructor
     * Use the SHA512 constructor to create an instance of SHA512 hash function.
     *
     * @example
     * const sha512 = new SHA512();
     *
     * @property h - The initial hash constants.
     * @property W - Provides a way to recycle usage of the array memory.
     * @property k - The round constants used for each round of SHA-512.
     */
    class SHA512 extends BaseHash {
        h;
        W;
        k;
        constructor() {
            super(1024, 512, 192, 128);
            this.h = [
                0x6a09e667, 0xf3bcc908,
                0xbb67ae85, 0x84caa73b,
                0x3c6ef372, 0xfe94f82b,
                0xa54ff53a, 0x5f1d36f1,
                0x510e527f, 0xade682d1,
                0x9b05688c, 0x2b3e6c1f,
                0x1f83d9ab, 0xfb41bd6b,
                0x5be0cd19, 0x137e2179
            ];
            this.k = [
                0x428a2f98, 0xd728ae22, 0x71374491, 0x23ef65cd,
                0xb5c0fbcf, 0xec4d3b2f, 0xe9b5dba5, 0x8189dbbc,
                0x3956c25b, 0xf348b538, 0x59f111f1, 0xb605d019,
                0x923f82a4, 0xaf194f9b, 0xab1c5ed5, 0xda6d8118,
                0xd807aa98, 0xa3030242, 0x12835b01, 0x45706fbe,
                0x243185be, 0x4ee4b28c, 0x550c7dc3, 0xd5ffb4e2,
                0x72be5d74, 0xf27b896f, 0x80deb1fe, 0x3b1696b1,
                0x9bdc06a7, 0x25c71235, 0xc19bf174, 0xcf692694,
                0xe49b69c1, 0x9ef14ad2, 0xefbe4786, 0x384f25e3,
                0x0fc19dc6, 0x8b8cd5b5, 0x240ca1cc, 0x77ac9c65,
                0x2de92c6f, 0x592b0275, 0x4a7484aa, 0x6ea6e483,
                0x5cb0a9dc, 0xbd41fbd4, 0x76f988da, 0x831153b5,
                0x983e5152, 0xee66dfab, 0xa831c66d, 0x2db43210,
                0xb00327c8, 0x98fb213f, 0xbf597fc7, 0xbeef0ee4,
                0xc6e00bf3, 0x3da88fc2, 0xd5a79147, 0x930aa725,
                0x06ca6351, 0xe003826f, 0x14292967, 0x0a0e6e70,
                0x27b70a85, 0x46d22ffc, 0x2e1b2138, 0x5c26c926,
                0x4d2c6dfc, 0x5ac42aed, 0x53380d13, 0x9d95b3df,
                0x650a7354, 0x8baf63de, 0x766a0abb, 0x3c77b2a8,
                0x81c2c92e, 0x47edaee6, 0x92722c85, 0x1482353b,
                0xa2bfe8a1, 0x4cf10364, 0xa81a664b, 0xbc423001,
                0xc24b8b70, 0xd0f89791, 0xc76c51a3, 0x0654be30,
                0xd192e819, 0xd6ef5218, 0xd6990624, 0x5565a910,
                0xf40e3585, 0x5771202a, 0x106aa070, 0x32bbd1b8,
                0x19a4c116, 0xb8d2d0c8, 0x1e376c08, 0x5141ab53,
                0x2748774c, 0xdf8eeb99, 0x34b0bcb5, 0xe19b48a8,
                0x391c0cb3, 0xc5c95a63, 0x4ed8aa4a, 0xe3418acb,
                0x5b9cca4f, 0x7763e373, 0x682e6ff3, 0xd6b2b8a3,
                0x748f82ee, 0x5defb2fc, 0x78a5636f, 0x43172f60,
                0x84c87814, 0xa1f0ab72, 0x8cc70208, 0x1a6439ec,
                0x90befffa, 0x23631e28, 0xa4506ceb, 0xde82bde9,
                0xbef9a3f7, 0xb2c67915, 0xc67178f2, 0xe372532b,
                0xca273ece, 0xea26619c, 0xd186b8c7, 0x21c0c207,
                0xeada7dd6, 0xcde0eb1e, 0xf57d4f7f, 0xee6ed178,
                0x06f067aa, 0x72176fba, 0x0a637dc5, 0xa2c898a6,
                0x113f9804, 0xbef90dae, 0x1b710b35, 0x131c471b,
                0x28db77f5, 0x23047d84, 0x32caab7b, 0x40c72493,
                0x3c9ebe0a, 0x15c9bebc, 0x431d67c4, 0x9c100d4c,
                0x4cc5d4be, 0xcb3e42b6, 0x597f299c, 0xfc657e2a,
                0x5fcb6fab, 0x3ad6faec, 0x6c44198c, 0x4a475817
            ];
            this.W = new Array(160);
        }
        _prepareBlock(msg, start) {
            const W = this.W;
            // 32 x 32bit words
            let i;
            for (i = 0; i < 32; i++) {
                W[i] = msg[start + i];
            }
            for (; i < W.length; i += 2) {
                const c0_hi = g1_512_hi(W[i - 4], W[i - 3]); // i - 2
                const c0_lo = g1_512_lo(W[i - 4], W[i - 3]);
                const c1_hi = W[i - 14]; // i - 7
                const c1_lo = W[i - 13];
                const c2_hi = g0_512_hi(W[i - 30], W[i - 29]); // i - 15
                const c2_lo = g0_512_lo(W[i - 30], W[i - 29]);
                const c3_hi = W[i - 32]; // i - 16
                const c3_lo = W[i - 31];
                W[i] = sum64_4_hi(c0_hi, c0_lo, c1_hi, c1_lo, c2_hi, c2_lo, c3_hi, c3_lo);
                W[i + 1] = sum64_4_lo(c0_hi, c0_lo, c1_hi, c1_lo, c2_hi, c2_lo, c3_hi, c3_lo);
            }
        }
        _update(msg, start) {
            this._prepareBlock(msg, start);
            const W = this.W;
            let ah = this.h[0];
            let al = this.h[1];
            let bh = this.h[2];
            let bl = this.h[3];
            let ch = this.h[4];
            let cl = this.h[5];
            let dh = this.h[6];
            let dl = this.h[7];
            let eh = this.h[8];
            let el = this.h[9];
            let fh = this.h[10];
            let fl = this.h[11];
            let gh = this.h[12];
            let gl = this.h[13];
            let hh = this.h[14];
            let hl = this.h[15];
            assert$1(this.k.length === W.length);
            for (let i = 0; i < W.length; i += 2) {
                let c0_hi = hh;
                let c0_lo = hl;
                let c1_hi = s1_512_hi(eh, el);
                let c1_lo = s1_512_lo(eh, el);
                const c2_hi = ch64_hi(eh, el, fh, fl, gh);
                const c2_lo = ch64_lo(eh, el, fh, fl, gh, gl);
                const c3_hi = this.k[i];
                const c3_lo = this.k[i + 1];
                const c4_hi = W[i];
                const c4_lo = W[i + 1];
                const T1_hi = sum64_5_hi(c0_hi, c0_lo, c1_hi, c1_lo, c2_hi, c2_lo, c3_hi, c3_lo, c4_hi, c4_lo);
                const T1_lo = sum64_5_lo(c0_hi, c0_lo, c1_hi, c1_lo, c2_hi, c2_lo, c3_hi, c3_lo, c4_hi, c4_lo);
                c0_hi = s0_512_hi(ah, al);
                c0_lo = s0_512_lo(ah, al);
                c1_hi = maj64_hi(ah, al, bh, bl, ch);
                c1_lo = maj64_lo(ah, al, bh, bl, ch, cl);
                const T2_hi = sum64_hi(c0_hi, c0_lo, c1_hi, c1_lo);
                const T2_lo = sum64_lo(c0_hi, c0_lo, c1_hi, c1_lo);
                hh = gh;
                hl = gl;
                gh = fh;
                gl = fl;
                fh = eh;
                fl = el;
                eh = sum64_hi(dh, dl, T1_hi, T1_lo);
                el = sum64_lo(dl, dl, T1_hi, T1_lo);
                dh = ch;
                dl = cl;
                ch = bh;
                cl = bl;
                bh = ah;
                bl = al;
                ah = sum64_hi(T1_hi, T1_lo, T2_hi, T2_lo);
                al = sum64_lo(T1_hi, T1_lo, T2_hi, T2_lo);
            }
            sum64(this.h, 0, ah, al);
            sum64(this.h, 2, bh, bl);
            sum64(this.h, 4, ch, cl);
            sum64(this.h, 6, dh, dl);
            sum64(this.h, 8, eh, el);
            sum64(this.h, 10, fh, fl);
            sum64(this.h, 12, gh, gl);
            sum64(this.h, 14, hh, hl);
        }
        _digest() {
            return split32(this.h, 'big');
        }
        _digestHex() {
            return toHex32(this.h, 'big');
        }
    }
    function ch64_hi(xh, xl, yh, yl, zh, zl) {
        let r = (xh & yh) ^ ((~xh) & zh);
        if (r < 0) {
            r += 0x100000000;
        }
        return r;
    }
    function ch64_lo(xh, xl, yh, yl, zh, zl) {
        let r = (xl & yl) ^ ((~xl) & zl);
        if (r < 0) {
            r += 0x100000000;
        }
        return r;
    }
    function maj64_hi(xh, xl, yh, yl, zh, zl) {
        let r = (xh & yh) ^ (xh & zh) ^ (yh & zh);
        if (r < 0) {
            r += 0x100000000;
        }
        return r;
    }
    function maj64_lo(xh, xl, yh, yl, zh, zl) {
        let r = (xl & yl) ^ (xl & zl) ^ (yl & zl);
        if (r < 0) {
            r += 0x100000000;
        }
        return r;
    }
    function s0_512_hi(xh, xl) {
        const c0_hi = rotr64_hi(xh, xl, 28);
        const c1_hi = rotr64_hi(xl, xh, 2); // 34
        const c2_hi = rotr64_hi(xl, xh, 7); // 39
        let r = c0_hi ^ c1_hi ^ c2_hi;
        if (r < 0) {
            r += 0x100000000;
        }
        return r;
    }
    function s0_512_lo(xh, xl) {
        const c0_lo = rotr64_lo(xh, xl, 28);
        const c1_lo = rotr64_lo(xl, xh, 2); // 34
        const c2_lo = rotr64_lo(xl, xh, 7); // 39
        let r = c0_lo ^ c1_lo ^ c2_lo;
        if (r < 0) {
            r += 0x100000000;
        }
        return r;
    }
    function s1_512_hi(xh, xl) {
        const c0_hi = rotr64_hi(xh, xl, 14);
        const c1_hi = rotr64_hi(xh, xl, 18);
        const c2_hi = rotr64_hi(xl, xh, 9); // 41
        let r = c0_hi ^ c1_hi ^ c2_hi;
        if (r < 0) {
            r += 0x100000000;
        }
        return r;
    }
    function s1_512_lo(xh, xl) {
        const c0_lo = rotr64_lo(xh, xl, 14);
        const c1_lo = rotr64_lo(xh, xl, 18);
        const c2_lo = rotr64_lo(xl, xh, 9); // 41
        let r = c0_lo ^ c1_lo ^ c2_lo;
        if (r < 0) {
            r += 0x100000000;
        }
        return r;
    }
    function g0_512_hi(xh, xl) {
        const c0_hi = rotr64_hi(xh, xl, 1);
        const c1_hi = rotr64_hi(xh, xl, 8);
        const c2_hi = shr64_hi(xh, xl, 7);
        let r = c0_hi ^ c1_hi ^ c2_hi;
        if (r < 0) {
            r += 0x100000000;
        }
        return r;
    }
    function g0_512_lo(xh, xl) {
        const c0_lo = rotr64_lo(xh, xl, 1);
        const c1_lo = rotr64_lo(xh, xl, 8);
        const c2_lo = shr64_lo(xh, xl, 7);
        let r = c0_lo ^ c1_lo ^ c2_lo;
        if (r < 0) {
            r += 0x100000000;
        }
        return r;
    }
    function g1_512_hi(xh, xl) {
        const c0_hi = rotr64_hi(xh, xl, 19);
        const c1_hi = rotr64_hi(xl, xh, 29); // 61
        const c2_hi = shr64_hi(xh, xl, 6);
        let r = c0_hi ^ c1_hi ^ c2_hi;
        if (r < 0) {
            r += 0x100000000;
        }
        return r;
    }
    function g1_512_lo(xh, xl) {
        const c0_lo = rotr64_lo(xh, xl, 19);
        const c1_lo = rotr64_lo(xl, xh, 29); // 61
        const c2_lo = shr64_lo(xh, xl, 6);
        let r = c0_lo ^ c1_lo ^ c2_lo;
        if (r < 0) {
            r += 0x100000000;
        }
        return r;
    }
    /**
     * The `SHA256HMAC` class is used to create Hash-based Message Authentication Code (HMAC) using the SHA-256 cryptographic hash function.
     *
     * HMAC is a specific type of MAC involving a cryptographic hash function and a secret cryptographic key. It may be used to simultaneously verify both the data integrity and the authenticity of a message.
     *
     * This class also uses the SHA-256 cryptographic hash algorithm that produces a 256-bit (32-byte) hash value.
     *
     * @property inner - Represents the inner hash of SHA-256.
     * @property outer - Represents the outer hash of SHA-256.
     * @property blockSize - The block size for the SHA-256 hash function, in bytes. It's set to 64 bytes.
     * @property outSize - The output size of the SHA-256 hash function, in bytes. It's set to 32 bytes.
     */
    class SHA256HMAC {
        inner;
        outer;
        blockSize = 64;
        outSize = 32;
        /**
         * The constructor for the `SHA256HMAC` class.
         *
         * It initializes the `SHA256HMAC` object and sets up the inner and outer padded keys.
         * If the key size is larger than the blockSize, it is digested using SHA-256.
         * If the key size is less than the blockSize, it is padded with zeroes.
         *
         * @constructor
         * @param key - The key to use to create the HMAC. Can be a number array or a string in hexadecimal format.
         *
         * @example
         * const myHMAC = new SHA256HMAC('deadbeef');
         */
        constructor(key) {
            key = toArray$3(key, 'hex');
            // Shorten key, if needed
            if (key.length > this.blockSize) {
                key = new SHA256().update(key).digest();
            }
            assert$1(key.length <= this.blockSize);
            // Add padding to key
            let i;
            for (i = key.length; i < this.blockSize; i++) {
                key.push(0);
            }
            for (i = 0; i < key.length; i++) {
                key[i] ^= 0x36;
            }
            this.inner = new SHA256().update(key);
            // 0x36 ^ 0x5c = 0x6a
            for (i = 0; i < key.length; i++) {
                key[i] ^= 0x6a;
            }
            this.outer = new SHA256().update(key);
        }
        /**
         * Updates the `SHA256HMAC` object with part of the message to be hashed.
         *
         * @method update
         * @param msg - Part of the message to hash. Can be a number array or a string.
         * @param enc - If 'hex', then the input is encoded as hexadecimal. If undefined or not 'hex', then no encoding is performed.
         * @returns Returns the instance of `SHA256HMAC` for chaining calls.
         *
         * @example
         * myHMAC.update('deadbeef', 'hex');
         */
        update(msg, enc) {
            this.inner.update(msg, enc);
            return this;
        }
        /**
         * Finalizes the HMAC computation and returns the resultant hash.
         *
         * @method digest
         * @returns Returns the digest of the hashed data. Can be a number array or a string.
         *
         * @example
         * let hashedMessage = myHMAC.digest();
         */
        digest() {
            this.outer.update(this.inner.digest());
            return this.outer.digest();
        }
        /**
         * Finalizes the HMAC computation and returns the resultant hash as a hex string.
         *
         * @method digest
         * @returns Returns the digest of the hashed data as a hex string
         *
         * @example
         * let hashedMessage = myHMAC.digestHex();
         */
        digestHex() {
            this.outer.update(this.inner.digest());
            return this.outer.digestHex();
        }
    }
    /**
     * The `SHA512HMAC` class is used to create Hash-based Message Authentication Code (HMAC) using the SHA-512 cryptographic hash function.
     *
     * HMAC is a specific type of MAC involving a cryptographic hash function and a secret cryptographic key. It may be used to simultaneously verify both the data integrity and the authenticity of a message.
     *
     * This class also uses the SHA-512 cryptographic hash algorithm that produces a 512-bit (64-byte) hash value.
     *
     * @property inner - Represents the inner hash of SHA-512.
     * @property outer - Represents the outer hash of SHA-512.
     * @property blockSize - The block size for the SHA-512 hash function, in bytes. It's set to 128 bytes.
     * @property outSize - The output size of the SHA-512 hash function, in bytes. It's set to 64 bytes.
     */
    class SHA512HMAC {
        inner;
        outer;
        blockSize = 128;
        outSize = 32;
        /**
         * The constructor for the `SHA512HMAC` class.
         *
         * It initializes the `SHA512HMAC` object and sets up the inner and outer padded keys.
         * If the key size is larger than the blockSize, it is digested using SHA-512.
         * If the key size is less than the blockSize, it is padded with zeroes.
         *
         * @constructor
         * @param key - The key to use to create the HMAC. Can be a number array or a string in hexadecimal format.
         *
         * @example
         * const myHMAC = new SHA512HMAC('deadbeef');
         */
        constructor(key) {
            key = toArray$3(key, 'hex');
            // Shorten key, if needed
            if (key.length > this.blockSize) {
                key = new SHA512().update(key).digest();
            }
            assert$1(key.length <= this.blockSize);
            // Add padding to key
            let i;
            for (i = key.length; i < this.blockSize; i++) {
                key.push(0);
            }
            for (i = 0; i < key.length; i++) {
                key[i] ^= 0x36;
            }
            this.inner = new SHA512().update(key);
            // 0x36 ^ 0x5c = 0x6a
            for (i = 0; i < key.length; i++) {
                key[i] ^= 0x6a;
            }
            this.outer = new SHA512().update(key);
        }
        /**
         * Updates the `SHA512HMAC` object with part of the message to be hashed.
         *
         * @method update
         * @param msg - Part of the message to hash. Can be a number array or a string.
         * @param enc - If 'hex', then the input is encoded as hexadecimal. If undefined or not 'hex', then no encoding is performed.
         * @returns Returns the instance of `SHA512HMAC` for chaining calls.
         *
         * @example
         * myHMAC.update('deadbeef', 'hex');
         */
        update(msg, enc) {
            this.inner.update(msg, enc);
            return this;
        }
        /**
         * Finalizes the HMAC computation and returns the resultant hash.
         *
         * @method digest
         * @returns Returns the digest of the hashed data as a number array.
         *
         * @example
         * let hashedMessage = myHMAC.digest();
         */
        digest() {
            this.outer.update(this.inner.digest());
            return this.outer.digest();
        }
        /**
         * Finalizes the HMAC computation and returns the resultant hash as a hex string.
         *
         * @method digest
         * @returns Returns the digest of the hashed data as a hex string
         *
         * @example
         * let hashedMessage = myHMAC.digestHex();
         */
        digestHex() {
            this.outer.update(this.inner.digest());
            return this.outer.digestHex();
        }
    }
    /**
     * Computes RIPEMD160 hash of a given message.
     * @function ripemd160
     * @param msg - The message to compute the hash for.
     * @param enc - The encoding of msg if string. Default is 'utf8'.
     *
     * @returns the computed RIPEMD160 hash of the message.
     *
     * @example
     * const digest = ripemd160('Hello, world!');
     */
    const ripemd160 = (msg, enc) => {
        return new RIPEMD160().update(msg, enc).digest();
    };
    /**
     * Computes SHA256 hash of a given message.
     * @function sha256
     * @param msg - The message to compute the hash for.
     * @param enc - The encoding of msg if string. Default is 'utf8'.
     *
     * @returns the computed SHA256 hash of the message.
     *
     * @example
     * const digest = sha256('Hello, world!');
     */
    const sha256 = (msg, enc) => {
        return new SHA256().update(msg, enc).digest();
    };
    /**
     * Computes SHA512 hash of a given message.
     * @function sha512
     * @param msg - The message to compute the hash for.
     * @param enc - The encoding of msg if string. Default is 'utf8'.
     *
     * @returns the computed SHA512 hash of the message.
     *
     * @example
     * const digest = sha512('Hello, world!');
     */
    const sha512 = (msg, enc) => {
        return new SHA512().update(msg, enc).digest();
    };
    /**
     * Performs a 'double hash' using SHA256. This means the data is hashed twice
     * with SHA256. First, the SHA256 hash of the message is computed, then the
     * SHA256 hash of the resulting hash is computed.
     * @function hash256
     * @param msg - The message to compute the hash for.
     * @param enc - The encoding of msg if string. Default is 'utf8'.
     *
     * @returns the double hashed SHA256 output.
     *
     * @example
     * const doubleHash = hash256('Hello, world!');
     */
    const hash256 = (msg, enc) => {
        const first = new SHA256().update(msg, enc).digest();
        return new SHA256().update(first).digest();
    };
    /**
     * Computes SHA256 hash of a given message and then computes a RIPEMD160 hash of the result.
     *
     * @function hash160
     * @param msg - The message to compute the hash for.
     * @param enc - The encoding of msg if string. Default is 'utf8'.
     *
     * @returns the RIPEMD160 hash of the SHA256 hash of the input message.
     *
     * @example
     * const hash = hash160('Hello, world!');
     */
    const hash160 = (msg, enc) => {
        const first = new SHA256().update(msg, enc).digest();
        return new RIPEMD160().update(first).digest();
    };
    /**
     * Computes SHA256 HMAC of a given message with a given key.
     * @function sha256hmac
     * @param key - The key used to compute the HMAC
     * @param msg - The message to compute the hash for.
     * @param enc - The encoding of msg if string. Default is 'utf8'.
     *
     * @returns the computed HMAC of the message.
     *
     * @example
     * const digest = sha256hmac('deadbeef', 'ffff001d');
     */
    const sha256hmac = (key, msg, enc) => {
        return new SHA256HMAC(key).update(msg, enc).digest();
    };
    /**
     * Computes SHA512 HMAC of a given message with a given key.
     * @function sha512hmac
     * @param key - The key used to compute the HMAC
     * @param msg - The message to compute the hash for.
     * @param enc - The encoding of msg if string. Default is 'utf8'.
     *
     * @returns the computed HMAC of the message.
     *
     * @example
     * const digest = sha512hmac('deadbeef', 'ffff001d');
     */
    const sha512hmac = (key, msg, enc) => {
        return new SHA512HMAC(key).update(msg, enc).digest();
    };

    /**
     * Prepends a '0' to an odd character length word to ensure it has an even number of characters.
     * @param {string} word - The input word.
     * @returns {string} - The word with a leading '0' if it's an odd character length; otherwise, the original word.
     */
    const zero2 = (word) => {
        if (word.length % 2 === 1) {
            return '0' + word;
        }
        else {
            return word;
        }
    };
    /**
     * Converts an array of numbers to a hexadecimal string representation.
     * @param {number[]} msg - The input array of numbers.
     * @returns {string} - The hexadecimal string representation of the input array.
     */
    const toHex$3 = (msg) => {
        let res = '';
        for (let i = 0; i < msg.length; i++) {
            res += zero2(msg[i].toString(16));
        }
        return res;
    };
    /**
     * Converts various message formats into an array of numbers.
     * Supports arrays, hexadecimal strings, base64 strings, and UTF-8 strings.
     *
     * @param {any} msg - The input message (array or string).
     * @param {('hex' | 'utf8' | 'base64')} enc - Specifies the string encoding, if applicable.
     * @returns {any[]} - Array representation of the input.
     */
    const toArray$2 = (msg, enc) => {
        // Return a copy if already an array
        if (Array.isArray(msg)) {
            return msg.slice();
        }
        // Return empty array for falsy values
        if (!msg) {
            return [];
        }
        const res = [];
        // Convert non-string messages to numbers
        if (typeof msg !== 'string') {
            for (let i = 0; i < msg.length; i++) {
                res[i] = msg[i] | 0;
            }
            return res;
        }
        // Handle hexadecimal encoding
        if (enc === 'hex') {
            msg = msg.replace(/[^a-z0-9]+/ig, '');
            if (msg.length % 2 !== 0) {
                msg = '0' + msg;
            }
            for (let i = 0; i < msg.length; i += 2) {
                res.push(parseInt(msg[i] + msg[i + 1], 16));
            }
            // Handle base64
        }
        else if (enc === 'base64') {
            const base64Chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
            const result = [];
            let currentBit = 0;
            let currentByte = 0;
            for (const char of msg.replace(/=+$/, '')) {
                currentBit = (currentBit << 6) | base64Chars.indexOf(char);
                currentByte += 6;
                if (currentByte >= 8) {
                    currentByte -= 8;
                    result.push((currentBit >> currentByte) & 0xFF);
                    currentBit &= (1 << currentByte) - 1;
                }
            }
            return result;
        }
        else {
            // Handle UTF-8 encoding
            for (let i = 0; i < msg.length; i++) {
                const c = msg.charCodeAt(i);
                const hi = c >> 8;
                const lo = c & 0xff;
                if (hi) {
                    res.push(hi, lo);
                }
                else {
                    res.push(lo);
                }
            }
        }
        return res;
    };
    /**
     * Converts an array of numbers to a UTF-8 encoded string.
     * @param {number[]} arr - The input array of numbers.
     * @returns {string} - The UTF-8 encoded string.
     */
    const toUTF8$2 = (arr) => {
        let result = '';
        for (let i = 0; i < arr.length; i++) {
            const byte = arr[i];
            // 1-byte sequence (0xxxxxxx)
            if (byte <= 0x7F) {
                result += String.fromCharCode(byte);
            }
            // 2-byte sequence (110xxxxx 10xxxxxx)
            else if (byte >= 0xC0 && byte <= 0xDF) {
                const byte2 = arr[++i];
                const codePoint = ((byte & 0x1F) << 6) | (byte2 & 0x3F);
                result += String.fromCharCode(codePoint);
            }
            // 3-byte sequence (1110xxxx 10xxxxxx 10xxxxxx)
            else if (byte >= 0xE0 && byte <= 0xEF) {
                const byte2 = arr[++i];
                const byte3 = arr[++i];
                const codePoint = ((byte & 0x0F) << 12) | ((byte2 & 0x3F) << 6) | (byte3 & 0x3F);
                result += String.fromCharCode(codePoint);
            }
            // 4-byte sequence (11110xxx 10xxxxxx 10xxxxxx 10xxxxxx)
            else if (byte >= 0xF0 && byte <= 0xF7) {
                const byte2 = arr[++i];
                const byte3 = arr[++i];
                const byte4 = arr[++i];
                const codePoint = ((byte & 0x07) << 18) | ((byte2 & 0x3F) << 12) | ((byte3 & 0x3F) << 6) | (byte4 & 0x3F);
                // Convert to UTF-16 surrogate pair
                const surrogate1 = 0xD800 + ((codePoint - 0x10000) >> 10);
                const surrogate2 = 0xDC00 + ((codePoint - 0x10000) & 0x3FF);
                result += String.fromCharCode(surrogate1, surrogate2);
            }
        }
        return result;
    };
    /**
     * Encodes an array of numbers into a specified encoding ('hex' or 'utf8'). If no encoding is provided, returns the original array.
     * @param {number[]} arr - The input array of numbers.
     * @param {('hex' | 'utf8')} enc - The desired encoding.
     * @returns {string | number[]} - The encoded message as a string (for 'hex' and 'utf8') or the original array.
     */
    const encode$1 = (arr, enc) => {
        switch (enc) {
            case 'hex':
                return toHex$3(arr);
            case 'utf8':
                return toUTF8$2(arr);
            // If no encoding is provided, return the original array
            default:
                return arr;
        }
    };
    /**
     * Converts an array of bytes (each between 0 and 255) into a base64 encoded string.
     *
     * @param {number[]} byteArray - An array of numbers where each number is a byte (0-255).
     * @returns {string} The base64 encoded string.
     *
     * @example
     * const bytes = [72, 101, 108, 108, 111]; // Represents the string "Hello"
     * console.log(toBase64(bytes)); // Outputs: SGVsbG8=
     */
    function toBase64$2(byteArray) {
        const base64Chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
        let result = '';
        let i;
        for (i = 0; i < byteArray.length; i += 3) {
            const byte1 = byteArray[i];
            const byte2 = i + 1 < byteArray.length ? byteArray[i + 1] : 0;
            const byte3 = i + 2 < byteArray.length ? byteArray[i + 2] : 0;
            const encoded1 = byte1 >> 2;
            const encoded2 = ((byte1 & 0x03) << 4) | (byte2 >> 4);
            const encoded3 = ((byte2 & 0x0F) << 2) | (byte3 >> 6);
            const encoded4 = byte3 & 0x3F;
            result += base64Chars.charAt(encoded1) + base64Chars.charAt(encoded2);
            result += i + 1 < byteArray.length ? base64Chars.charAt(encoded3) : '=';
            result += i + 2 < byteArray.length ? base64Chars.charAt(encoded4) : '=';
        }
        return result;
    }
    const base58chars = '123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz';
    /**
     * Converts a string from base58 to a binary array
     * @param str - The string representation
     * @returns The binary representation
     */
    const fromBase58 = (str) => {
        if (!str || typeof str !== 'string') {
            throw new Error(`Expected base58 string but got “${str}”`);
        }
        if (str.match(/[IOl0]/gmu)) {
            throw new Error(`Invalid base58 character “${str.match(/[IOl0]/gmu)}”`);
        }
        const lz = str.match(/^1+/gmu);
        const psz = lz ? lz[0].length : 0;
        const size = ((str.length - psz) * (Math.log(58) / Math.log(256)) + 1) >>> 0;
        const uint8 = new Uint8Array([
            ...new Uint8Array(psz),
            ...str
                .match(/.{1}/gmu)
                .map((i) => base58chars.indexOf(i))
                .reduce((acc, i) => {
                acc = acc.map((j) => {
                    const x = j * 58 + i;
                    i = x >> 8;
                    return x;
                });
                return acc;
            }, new Uint8Array(size))
                .reverse()
                .filter(((lastValue) => (value) => 
            // @ts-expect-error
            (lastValue = lastValue || value))(false))
        ]);
        return [...uint8];
    };
    /**
     * Converts a binary array into a base58 string
     * @param bin - The binary array to convert to base58
     * @returns The base58 string representation
     */
    const toBase58$1 = (bin) => {
        const base58Map = Array(256).fill(-1);
        for (let i = 0; i < base58chars.length; ++i) {
            base58Map[base58chars.charCodeAt(i)] = i;
        }
        const result = [];
        for (const byte of bin) {
            let carry = byte;
            for (let j = 0; j < result.length; ++j) {
                const x = (base58Map[result[j]] << 8) + carry;
                result[j] = base58chars.charCodeAt(x % 58);
                carry = (x / 58) | 0;
            }
            while (carry) {
                result.push(base58chars.charCodeAt(carry % 58));
                carry = (carry / 58) | 0;
            }
        }
        for (const byte of bin) {
            if (byte)
                break;
            else
                result.push('1'.charCodeAt(0));
        }
        result.reverse();
        return String.fromCharCode(...result);
    };
    /**
     * Converts a binary array into a base58check string with a checksum
     * @param bin - The binary array to convert to base58check
     * @returns The base58check string representation
     */
    const toBase58Check = (bin, prefix = [0]) => {
        let hash = hash256([...prefix, ...bin]);
        hash = [...prefix, ...bin, ...hash.slice(0, 4)];
        return toBase58$1(hash);
    };
    /**
     * Converts a base58check string into a binary array after validating the checksum
     * @param str - The base58check string to convert to binary
     * @param enc - If hex, the return values will be hex strings, arrays of numbers otherwise
     * @param prefixLength - The length of the prefix. Optional, defaults to 1.
     * @returns The binary array representation
     */
    const fromBase58Check = (str, enc, prefixLength = 1) => {
        const bin = fromBase58(str);
        let prefix = bin.slice(0, prefixLength);
        let data = bin.slice(prefixLength, -4);
        let hash = [...prefix, ...data];
        hash = hash256(hash);
        bin.slice(-4).forEach((check, index) => {
            if (check !== hash[index]) {
                throw new Error('Invalid checksum');
            }
        });
        if (enc === 'hex') {
            prefix = toHex$3(prefix);
            data = toHex$3(data);
        }
        return { prefix, data };
    };
    class Writer {
        bufs;
        constructor(bufs) {
            this.bufs = bufs || [];
        }
        getLength() {
            let len = 0;
            for (const buf of this.bufs) {
                len = len + buf.length;
            }
            return len;
        }
        toArray() {
            let ret = [];
            for (const x of this.bufs) {
                if (x.length < 65536) {
                    ret.push(...x);
                }
                else {
                    ret = ret.concat(x);
                }
            }
            return ret;
        }
        write(buf) {
            this.bufs.push(buf);
            return this;
        }
        writeReverse(buf) {
            const buf2 = new Array(buf.length);
            for (let i = 0; i < buf2.length; i++) {
                buf2[i] = buf[buf.length - 1 - i];
            }
            this.bufs.push(buf2);
            return this;
        }
        writeUInt8(n) {
            const buf = new Array(1);
            buf[0] = n;
            this.write(buf);
            return this;
        }
        writeInt8(n) {
            const buf = new Array(1);
            buf[0] = n & 0xFF;
            this.write(buf);
            return this;
        }
        writeUInt16BE(n) {
            this.bufs.push([
                (n >> 8) & 0xFF,
                n & 0xFF // low byte is just the last 8 bits
            ]);
            return this;
        }
        writeInt16BE(n) {
            return this.writeUInt16BE(n & 0xFFFF); // Mask with 0xFFFF to get the lower 16 bits
        }
        writeUInt16LE(n) {
            this.bufs.push([
                n & 0xFF,
                (n >> 8) & 0xFF // shift right 8 bits to get the high byte
            ]);
            return this;
        }
        writeInt16LE(n) {
            return this.writeUInt16LE(n & 0xFFFF); // Mask with 0xFFFF to get the lower 16 bits
        }
        writeUInt32BE(n) {
            this.bufs.push([
                (n >> 24) & 0xFF,
                (n >> 16) & 0xFF,
                (n >> 8) & 0xFF,
                n & 0xFF // lowest byte
            ]);
            return this;
        }
        writeInt32BE(n) {
            return this.writeUInt32BE(n >>> 0); // Using unsigned right shift to handle negative numbers
        }
        writeUInt32LE(n) {
            this.bufs.push([
                n & 0xFF,
                (n >> 8) & 0xFF,
                (n >> 16) & 0xFF,
                (n >> 24) & 0xFF // highest byte
            ]);
            return this;
        }
        writeInt32LE(n) {
            return this.writeUInt32LE(n >>> 0); // Using unsigned right shift to handle negative numbers
        }
        writeUInt64BEBn(bn) {
            const buf = bn.toArray('be', 8);
            this.write(buf);
            return this;
        }
        writeUInt64LEBn(bn) {
            const buf = bn.toArray('be', 8);
            this.writeReverse(buf);
            return this;
        }
        writeUInt64LE(n) {
            const buf = new BigNumber(n).toArray('be', 8);
            this.writeReverse(buf);
            return this;
        }
        writeVarIntNum(n) {
            const buf = Writer.varIntNum(n);
            this.write(buf);
            return this;
        }
        writeVarIntBn(bn) {
            const buf = Writer.varIntBn(bn);
            this.write(buf);
            return this;
        }
        static varIntNum(n) {
            let buf;
            if (n < 253) {
                buf = [n]; // 1 byte
            }
            else if (n < 0x10000) {
                // 253 followed by the number in little-endian format
                buf = [
                    253,
                    n & 0xFF,
                    (n >> 8) & 0xFF // high byte
                ];
            }
            else if (n < 0x100000000) {
                // 254 followed by the number in little-endian format
                buf = [
                    254,
                    n & 0xFF,
                    (n >> 8) & 0xFF,
                    (n >> 16) & 0xFF,
                    (n >> 24) & 0xFF
                ];
            }
            else {
                // 255 followed by the number in little-endian format
                // Since JavaScript bitwise operations work on 32 bits, we need to handle 64-bit numbers in two parts
                const low = n & 0xFFFFFFFF;
                const high = Math.floor(n / 0x100000000) & 0xFFFFFFFF;
                buf = [
                    255,
                    low & 0xFF,
                    (low >> 8) & 0xFF,
                    (low >> 16) & 0xFF,
                    (low >> 24) & 0xFF,
                    high & 0xFF,
                    (high >> 8) & 0xFF,
                    (high >> 16) & 0xFF,
                    (high >> 24) & 0xFF
                ];
            }
            return buf;
        }
        static varIntBn(bn) {
            let buf;
            if (bn.ltn(253)) {
                const n = bn.toNumber();
                // No need for bitwise operation as the value is within a byte's range
                buf = [n];
            }
            else if (bn.ltn(0x10000)) {
                const n = bn.toNumber();
                // Value fits in a uint16
                buf = [253, n & 0xFF, (n >> 8) & 0xFF];
            }
            else if (bn.lt(new BigNumber(0x100000000))) {
                const n = bn.toNumber();
                // Value fits in a uint32
                buf = [254, n & 0xFF, (n >> 8) & 0xFF, (n >> 16) & 0xFF, (n >> 24) & 0xFF];
            }
            else {
                const bw = new Writer();
                bw.writeUInt8(255);
                bw.writeUInt64LEBn(bn);
                buf = bw.toArray();
            }
            return buf;
        }
    }
    class Reader {
        bin;
        pos;
        constructor(bin = [], pos = 0) {
            this.bin = bin;
            this.pos = pos;
        }
        eof() {
            return this.pos >= this.bin.length;
        }
        read(len = this.bin.length) {
            const bin = this.bin.slice(this.pos, this.pos + len);
            this.pos = this.pos + len;
            return bin;
        }
        readReverse(len = this.bin.length) {
            const bin = this.bin.slice(this.pos, this.pos + len);
            this.pos = this.pos + len;
            const buf2 = new Array(bin.length);
            for (let i = 0; i < buf2.length; i++) {
                buf2[i] = bin[bin.length - 1 - i];
            }
            return buf2;
        }
        readUInt8() {
            const val = this.bin[this.pos];
            this.pos += 1;
            return val;
        }
        readInt8() {
            const val = this.bin[this.pos];
            this.pos += 1;
            // If the sign bit is set, convert to negative value
            return (val & 0x80) !== 0 ? val - 0x100 : val;
        }
        readUInt16BE() {
            const val = (this.bin[this.pos] << 8) | this.bin[this.pos + 1];
            this.pos += 2;
            return val;
        }
        readInt16BE() {
            const val = this.readUInt16BE();
            // If the sign bit is set, convert to negative value
            return (val & 0x8000) !== 0 ? val - 0x10000 : val;
        }
        readUInt16LE() {
            const val = this.bin[this.pos] | (this.bin[this.pos + 1] << 8);
            this.pos += 2;
            return val;
        }
        readInt16LE() {
            const val = this.readUInt16LE();
            // If the sign bit is set, convert to negative value
            const x = (val & 0x8000) !== 0 ? val - 0x10000 : val;
            return x;
        }
        readUInt32BE() {
            const val = (this.bin[this.pos] * 0x1000000) + // Shift the first byte by 24 bits
                ((this.bin[this.pos + 1] << 16) | // Shift the second byte by 16 bits
                    (this.bin[this.pos + 2] << 8) | // Shift the third byte by 8 bits
                    this.bin[this.pos + 3]); // The fourth byte
            this.pos += 4;
            return val;
        }
        readInt32BE() {
            const val = this.readUInt32BE();
            // If the sign bit is set, convert to negative value
            return (val & 0x80000000) !== 0 ? val - 0x100000000 : val;
        }
        readUInt32LE() {
            const val = (this.bin[this.pos] |
                (this.bin[this.pos + 1] << 8) |
                (this.bin[this.pos + 2] << 16) |
                (this.bin[this.pos + 3] << 24)) >>> 0;
            this.pos += 4;
            return val;
        }
        readInt32LE() {
            const val = this.readUInt32LE();
            // Explicitly check if the sign bit is set and then convert to a negative value
            return (val & 0x80000000) !== 0 ? val - 0x100000000 : val;
        }
        readUInt64BEBn() {
            const bin = this.bin.slice(this.pos, this.pos + 8);
            const bn = new BigNumber(bin);
            this.pos = this.pos + 8;
            return bn;
        }
        readUInt64LEBn() {
            const bin = this.readReverse(8);
            const bn = new BigNumber(bin);
            return bn;
        }
        readVarIntNum() {
            const first = this.readUInt8();
            let bn;
            switch (first) {
                case 0xfd:
                    return this.readUInt16LE();
                case 0xfe:
                    return this.readUInt32LE();
                case 0xff:
                    bn = this.readUInt64LEBn();
                    if (bn.lte(new BigNumber(2).pow(new BigNumber(53)))) {
                        return bn.toNumber();
                    }
                    else {
                        throw new Error('number too large to retain precision - use readVarIntBn');
                    }
                default:
                    return first;
            }
        }
        readVarInt() {
            const first = this.bin[this.pos];
            switch (first) {
                case 0xfd:
                    return this.read(1 + 2);
                case 0xfe:
                    return this.read(1 + 4);
                case 0xff:
                    return this.read(1 + 8);
                default:
                    return this.read(1);
            }
        }
        readVarIntBn() {
            const first = this.readUInt8();
            switch (first) {
                case 0xfd:
                    return new BigNumber(this.readUInt16LE());
                case 0xfe:
                    return new BigNumber(this.readUInt32LE());
                case 0xff:
                    return this.readUInt64LEBn();
                default:
                    return new BigNumber(first);
            }
        }
    }

    var BSVUtils = /*#__PURE__*/Object.freeze({
        __proto__: null,
        zero2: zero2,
        toHex: toHex$3,
        toArray: toArray$2,
        toUTF8: toUTF8$2,
        encode: encode$1,
        toBase64: toBase64$2,
        fromBase58: fromBase58,
        toBase58: toBase58$1,
        toBase58Check: toBase58Check,
        fromBase58Check: fromBase58Check,
        Writer: Writer,
        Reader: Reader
    });

    /**
     * `Point` class is a representation of an elliptic curve point with affine coordinates.
     * It extends the functionality of BasePoint and carries x, y coordinates of point on the curve.
     * It also introduces new methods for handling Point operations in elliptic curve.
     *
     * @class Point
     * @extends {BasePoint}
     *
     * @property x - The x-coordinate of the point.
     * @property y - The y-coordinate of the point.
     * @property inf - Flag to record if the point is at infinity in the Elliptic Curve.
     */
    class Point extends BasePoint {
        x;
        y;
        inf;
        /**
         * Creates a point object from a given Array. These numbers can represent coordinates in hex format, or points
         * in multiple established formats.
         * The function verifies the integrity of the provided data and throws errors if inconsistencies are found.
         *
         * @method fromDER
         * @static
         * @param bytes - The point representation number array.
         * @returns Returns a new point representing the given string.
         * @throws `Error` If the point number[] value has a wrong length.
         * @throws `Error` If the point format is unknown.
         *
         * @example
         * const derPoint = [ 2, 18, 123, 108, 125, 83, 1, 251, 164, 214, 16, 119, 200, 216, 210, 193, 251, 193, 129, 67, 97, 146, 210, 216, 77, 254, 18, 6, 150, 190, 99, 198, 128 ];
         * const point = Point.fromDER(derPoint);
         */
        static fromDER(bytes) {
            const len = 32;
            // uncompressed, hybrid-odd, hybrid-even
            if ((bytes[0] === 0x04 || bytes[0] === 0x06 || bytes[0] === 0x07) &&
                bytes.length - 1 === 2 * len) {
                if (bytes[0] === 0x06) {
                    if (bytes[bytes.length - 1] % 2 !== 0) {
                        throw new Error('Point string value is wrong length');
                    }
                }
                else if (bytes[0] === 0x07) {
                    if (bytes[bytes.length - 1] % 2 !== 1) {
                        throw new Error('Point string value is wrong length');
                    }
                }
                const res = new Point(bytes.slice(1, 1 + len), bytes.slice(1 + len, 1 + 2 * len));
                return res;
            }
            else if ((bytes[0] === 0x02 || bytes[0] === 0x03) &&
                bytes.length - 1 === len) {
                return Point.fromX(bytes.slice(1, 1 + len), bytes[0] === 0x03);
            }
            throw new Error('Unknown point format');
        }
        /**
         * Creates a point object from a given string. This string can represent coordinates in hex format, or points
         * in multiple established formats.
         * The function verifies the integrity of the provided data and throws errors if inconsistencies are found.
         *
         * @method fromString
         * @static
         *
         * @param str The point representation string.
         * @returns Returns a new point representing the given string.
         * @throws `Error` If the point string value has a wrong length.
         * @throws `Error` If the point format is unknown.
         *
         * @example
         * const pointStr = 'abcdef';
         * const point = Point.fromString(pointStr);
         */
        static fromString(str) {
            const bytes = toArray$2(str, 'hex');
            return Point.fromDER(bytes);
        }
        /**
         * Generates a point from an x coordinate and a boolean indicating whether the corresponding
         * y coordinate is odd.
         *
         * @method fromX
         * @static
         * @param x - The x coordinate of the point.
         * @param odd - Boolean indicating whether the corresponding y coordinate is odd or not.
         * @returns Returns the new point.
         * @throws `Error` If the point is invalid.
         *
         * @example
         * const xCoordinate = new BigNumber('10');
         * const point = Point.fromX(xCoordinate, true);
         */
        static fromX(x, odd) {
            const red = new ReductionContext('k256');
            const a = new BigNumber(0).toRed(red);
            const b = new BigNumber(7).toRed(red);
            const zero = new BigNumber(0).toRed(red);
            if (!BigNumber.isBN(x)) {
                x = new BigNumber(x, 16);
            }
            x = x;
            if (x.red == null) {
                x = x.toRed(red);
            }
            const y2 = x.redSqr().redMul(x).redIAdd(x.redMul(a)).redIAdd(b);
            let y = y2.redSqrt();
            if (y.redSqr().redSub(y2).cmp(zero) !== 0) {
                throw new Error('invalid point');
            }
            // XXX Is there any way to tell if the number is odd without converting it
            // to non-red form?
            const isOdd = y.fromRed().isOdd();
            if ((odd && !isOdd) || (!odd && isOdd)) {
                y = y.redNeg();
            }
            return new Point(x, y);
        }
        /**
         * Generates a point from a serialized JSON object. The function accounts for different options in the JSON object,
         * including precomputed values for optimization of EC operations, and calls another helper function to turn nested
         * JSON points into proper Point objects.
         *
         * @method fromJSON
         * @static
         * @param obj - An object or array that holds the data for the point.
         * @param isRed - A boolean to direct how the Point is constructed from the JSON object.
         * @returns Returns a new point based on the deserialized JSON object.
         *
         * @example
         * const serializedPoint = '{"x":52,"y":15}';
         * const point = Point.fromJSON(serializedPoint, true);
         */
        static fromJSON(obj, isRed) {
            if (typeof obj === 'string') {
                obj = JSON.parse(obj);
            }
            const res = new Point(obj[0], obj[1], isRed);
            if (typeof obj[2] !== 'object') {
                return res;
            }
            const obj2point = (obj) => {
                return new Point(obj[0], obj[1], isRed);
            };
            const pre = obj[2];
            res.precomputed = {
                beta: null,
                doubles: typeof pre.doubles === 'object' && pre.doubles !== null
                    ? {
                        step: pre.doubles.step,
                        points: [res].concat(pre.doubles.points.map(obj2point))
                    }
                    : undefined,
                naf: typeof pre.naf === 'object' && pre.naf !== null
                    ? {
                        wnd: pre.naf.wnd,
                        points: [res].concat(pre.naf.points.map(obj2point))
                    }
                    : undefined
            };
            return res;
        }
        /**
         * @constructor
         * @param x - The x-coordinate of the point. May be a number, a BigNumber, a string (which will be interpreted as hex), a number array, or null. If null, an "Infinity" point is constructed.
         * @param y - The y-coordinate of the point, similar to x.
         * @param isRed - A boolean indicating if the point is a member of the field of integers modulo the k256 prime. Default is true.
         *
         * @example
         * new Point('abc123', 'def456');
         * new Point(null, null); // Generates Infinity point.
         */
        constructor(x, y, isRed = true) {
            super('affine');
            this.precomputed = null;
            if (x === null && y === null) {
                this.x = null;
                this.y = null;
                this.inf = true;
            }
            else {
                if (!BigNumber.isBN(x)) {
                    x = new BigNumber(x, 16);
                }
                this.x = x;
                if (!BigNumber.isBN(y)) {
                    y = new BigNumber(y, 16);
                }
                this.y = y;
                // Force redgomery representation when loading from JSON
                if (isRed) {
                    this.x.forceRed(this.curve.red);
                    this.y.forceRed(this.curve.red);
                }
                if (this.x.red === null) {
                    this.x = this.x.toRed(this.curve.red);
                }
                if (this.y.red === null) {
                    this.y = this.y.toRed(this.curve.red);
                }
                this.inf = false;
            }
        }
        /**
         * Validates if a point belongs to the curve. Follows the short Weierstrass
         * equation for elliptic curves: y^2 = x^3 + ax + b.
         *
         * @method validate
         * @returns {boolean} true if the point is on the curve, false otherwise.
         *
         * @example
         * const aPoint = new Point(x, y);
         * const isValid = aPoint.validate();
         */
        validate() {
            return this.curve.validate(this);
        }
        /**
         * Encodes the coordinates of a point into an array or a hexadecimal string.
         * The details of encoding are determined by the optional compact and enc parameters.
         *
         * @method encode
         * @param compact - If true, an additional prefix byte 0x02 or 0x03 based on the 'y' coordinate being even or odd respectively is used. If false, byte 0x04 is used.
         * @param enc - Expects the string 'hex' if hexadecimal string encoding is required instead of an array of numbers.
         * @throws Will throw an error if the specified encoding method is not recognized. Expects 'hex'.
         * @returns If enc is undefined, a byte array representation of the point will be returned. if enc is 'hex', a hexadecimal string representation of the point will be returned.
         *
         * @example
         * const aPoint = new Point(x, y);
         * const encodedPointArray = aPoint.encode();
         * const encodedPointHex = aPoint.encode(true, 'hex');
         */
        encode(compact = true, enc) {
            const len = this.curve.p.byteLength();
            const x = this.getX().toArray('be', len);
            let res;
            if (compact) {
                res = [this.getY().isEven() ? 0x02 : 0x03].concat(x);
            }
            else {
                res = [0x04].concat(x, this.getY().toArray('be', len));
            }
            if (enc !== 'hex') {
                return res;
            }
            else {
                return toHex$3(res);
            }
        }
        /**
         * Converts the point coordinates to a hexadecimal string. A wrapper method
         * for encode. Byte 0x02 or 0x03 is used as prefix based on the 'y' coordinate being even or odd respectively.
         *
         * @method toString
         * @returns {string} A hexadecimal string representation of the point coordinates.
         *
         * @example
         * const aPoint = new Point(x, y);
         * const stringPoint = aPoint.toString();
         */
        toString() {
            return this.encode(true, 'hex');
        }
        /**
         * Exports the x and y coordinates of the point, and the precomputed doubles and non-adjacent form (NAF) for optimization. The output is an array.
         *
         * @method toJSON
         * @returns An Array where first two elements are the coordinates of the point and optional third element is an object with doubles and NAF points.
         *
         * @example
         * const aPoint = new Point(x, y);
         * const jsonPoint = aPoint.toJSON();
         */
        toJSON() {
            if (this.precomputed == null) {
                return [this.x, this.y];
            }
            return [this.x, this.y, typeof this.precomputed === 'object' && this.precomputed !== null
                    ? {
                        doubles: (this.precomputed.doubles != null)
                            ? {
                                step: this.precomputed.doubles.step,
                                points: this.precomputed.doubles.points.slice(1)
                            }
                            : undefined,
                        naf: (this.precomputed.naf != null)
                            ? {
                                wnd: this.precomputed.naf.wnd,
                                points: this.precomputed.naf.points.slice(1)
                            }
                            : undefined
                    }
                    : undefined];
        }
        /**
         * Provides the point coordinates in a human-readable string format for debugging purposes.
         *
         * @method inspect
         * @returns String of the format '<EC Point x: x-coordinate y: y-coordinate>', or '<EC Point Infinity>' if the point is at infinity.
         *
         * @example
         * const aPoint = new Point(x, y);
         * console.log(aPoint.inspect());
         */
        inspect() {
            if (this.isInfinity()) {
                return '<EC Point Infinity>';
            }
            return '<EC Point x: ' + this.x.fromRed().toString(16, 2) +
                ' y: ' + this.y.fromRed().toString(16, 2) + '>';
        }
        /**
         * Checks if the point is at infinity.
         * @method isInfinity
         * @returns Returns whether or not the point is at infinity.
         *
         * @example
         * const p = new Point(null, null);
         * console.log(p.isInfinity()); // outputs: true
         */
        isInfinity() {
            return this.inf;
        }
        /**
         * Adds another Point to this Point, returning a new Point.
         *
         * @method add
         * @param p - The Point to add to this one.
         * @returns A new Point that results from the addition.
         *
         * @example
         * const p1 = new Point(1, 2);
         * const p2 = new Point(2, 3);
         * const result = p1.add(p2);
         */
        add(p) {
            // O + P = P
            if (this.inf) {
                return p;
            }
            // P + O = P
            if (p.inf) {
                return this;
            }
            // P + P = 2P
            if (this.eq(p)) {
                return this.dbl();
            }
            // P + (-P) = O
            if (this.neg().eq(p)) {
                return new Point(null, null);
            }
            // P + Q = O
            if (this.x.cmp(p.x) === 0) {
                return new Point(null, null);
            }
            let c = this.y.redSub(p.y);
            if (c.cmpn(0) !== 0) {
                c = c.redMul(this.x.redSub(p.x).redInvm());
            }
            const nx = c.redSqr().redISub(this.x).redISub(p.x);
            const ny = c.redMul(this.x.redSub(nx)).redISub(this.y);
            return new Point(nx, ny);
        }
        /**
         * Doubles the current point.
         *
         * @method dbl
         *
         * @example
         * const P = new Point('123', '456');
         * const result = P.dbl();
         * */
        dbl() {
            if (this.inf) {
                return this;
            }
            // 2P = O
            const ys1 = this.y.redAdd(this.y);
            if (ys1.cmpn(0) === 0) {
                return new Point(null, null);
            }
            const a = this.curve.a;
            const x2 = this.x.redSqr();
            const dyinv = ys1.redInvm();
            const c = x2.redAdd(x2).redIAdd(x2).redIAdd(a).redMul(dyinv);
            const nx = c.redSqr().redISub(this.x.redAdd(this.x));
            const ny = c.redMul(this.x.redSub(nx)).redISub(this.y);
            return new Point(nx, ny);
        }
        /**
         * Returns X coordinate of point
         *
         * @example
         * const P = new Point('123', '456');
         * const x = P.getX();
         */
        getX() {
            return this.x.fromRed();
        }
        /**
         * Returns X coordinate of point
         *
         * @example
         * const P = new Point('123', '456');
         * const x = P.getX();
         */
        getY() {
            return this.y.fromRed();
        }
        /**
         * Multiplies this Point by a scalar value, returning a new Point.
         *
         * @method mul
         * @param k - The scalar value to multiply this Point by.
         * @returns  A new Point that results from the multiplication.
         *
         * @example
         * const p = new Point(1, 2);
         * const result = p.mul(2); // this doubles the Point
         */
        mul(k) {
            if (!BigNumber.isBN(k)) {
                k = new BigNumber(k, 16);
            }
            k = k;
            if (this.isInfinity()) {
                return this;
            }
            else if (this._hasDoubles(k)) {
                return this._fixedNafMul(k);
            }
            else {
                return this._endoWnafMulAdd([this], [k]);
            }
        }
        /**
         * Performs a multiplication and addition operation in a single step.
         * Multiplies this Point by k1, adds the resulting Point to the result of p2 multiplied by k2.
         *
         * @method mulAdd
         * @param k1 - The scalar value to multiply this Point by.
         * @param p2 - The other Point to be involved in the operation.
         * @param k2 - The scalar value to multiply the Point p2 by.
         * @returns A Point that results from the combined multiplication and addition operations.
         *
         * @example
         * const p1 = new Point(1, 2);
         * const p2 = new Point(2, 3);
         * const result = p1.mulAdd(2, p2, 3);
         */
        mulAdd(k1, p2, k2) {
            const points = [this, p2];
            const coeffs = [k1, k2];
            return this._endoWnafMulAdd(points, coeffs);
        }
        /**
         * Performs the Jacobian multiplication and addition operation in a single
         * step. Instead of returning a regular Point, the result is a JacobianPoint.
         *
         * @method jmulAdd
         * @param k1 - The scalar value to multiply this Point by.
         * @param p2 - The other Point to be involved in the operation
         * @param k2 - The scalar value to multiply the Point p2 by.
         * @returns A JacobianPoint that results from the combined multiplication and addition operation.
         *
         * @example
         * const p1 = new Point(1, 2);
         * const p2 = new Point(2, 3);
         * const result = p1.jmulAdd(2, p2, 3);
         */
        jmulAdd(k1, p2, k2) {
            const points = [this, p2];
            const coeffs = [k1, k2];
            return this._endoWnafMulAdd(points, coeffs, true);
        }
        /**
         * Checks if the Point instance is equal to another given Point.
         *
         * @method eq
         * @param p - The Point to be checked if equal to the current instance.
         *
         * @returns Whether the two Point instances are equal. Both the 'x' and 'y' coordinates have to match, and both points have to either be valid or at infinity for equality. If both conditions are true, it returns true, else it returns false.
         *
         * @example
         * const p1 = new Point(5, 20);
         * const p2 = new Point(5, 20);
         * const areEqual = p1.eq(p2); // returns true
         */
        eq(p) {
            return this === p || ((this.inf === p.inf) &&
                (this.inf || (this.x.cmp(p.x) === 0 && this.y.cmp(p.y) === 0)));
        }
        /**
         * Negate a point. The negation of a point P is the mirror of P about x-axis.
         *
         * @method neg
         *
         * @example
         * const P = new Point('123', '456');
         * const result = P.neg();
         */
        neg(_precompute) {
            if (this.inf) {
                return this;
            }
            const res = new Point(this.x, this.y.redNeg());
            if (_precompute && (this.precomputed != null)) {
                const pre = this.precomputed;
                const negate = (p) => p.neg();
                res.precomputed = {
                    naf: (pre.naf != null) && {
                        wnd: pre.naf.wnd,
                        points: pre.naf.points.map(negate)
                    },
                    doubles: (pre.doubles != null) && {
                        step: pre.doubles.step,
                        points: pre.doubles.points.map((p) => p.neg())
                    },
                    beta: undefined
                };
            }
            return res;
        }
        /**
         * Performs the "doubling" operation on the Point a given number of times.
         * This is used in elliptic curve operations to perform multiplication by 2, multiple times.
         * If the point is at infinity, it simply returns the point because doubling
         * a point at infinity is still infinity.
         *
         * @method dblp
         * @param k - The number of times the "doubling" operation is to be performed on the Point.
         * @returns The Point after 'k' "doubling" operations have been performed.
         *
         * @example
         * const p = new Point(5, 20);
         * const doubledPoint = p.dblp(10); // returns the point after "doubled" 10 times
         */
        dblp(k) {
            /* eslint-disable @typescript-eslint/no-this-alias */
            let r = this;
            for (let i = 0; i < k; i++) {
                r = r.dbl();
            }
            return r;
        }
        /**
         * Converts the point to a Jacobian point. If the point is at infinity, the corresponding Jacobian point
         * will also be at infinity.
         *
         * @method toJ
         * @returns Returns a new Jacobian point based on the current point.
         *
         * @example
         * const point = new Point(xCoordinate, yCoordinate);
         * const jacobianPoint = point.toJ();
         */
        toJ() {
            if (this.inf) {
                return new JacobianPoint(null, null, null);
            }
            const res = new JacobianPoint(this.x, this.y, this.curve.one);
            return res;
        }
        _getBeta() {
            if (typeof this.curve.endo !== 'object') {
                return;
            }
            const pre = this.precomputed;
            if (typeof pre === 'object' && pre !== null && typeof pre.beta === 'object' && pre.beta !== null) {
                return pre.beta;
            }
            const beta = new Point(this.x.redMul(this.curve.endo.beta), this.y);
            if (pre != null) {
                const curve = this.curve;
                const endoMul = (p) => {
                    return new Point(p.x.redMul(curve.endo.beta), p.y);
                };
                pre.beta = beta;
                beta.precomputed = {
                    beta: null,
                    naf: (pre.naf != null)
                        ? {
                            wnd: pre.naf.wnd,
                            points: pre.naf.points.map(endoMul)
                        }
                        : undefined,
                    doubles: (pre.doubles != null)
                        ? {
                            step: pre.doubles.step,
                            points: pre.doubles.points.map(endoMul)
                        }
                        : undefined
                };
            }
            return beta;
        }
        _fixedNafMul(k) {
            if (typeof this.precomputed !== 'object' || this.precomputed === null) {
                throw new Error('_fixedNafMul requires precomputed values for the point');
            }
            const doubles = this._getDoubles();
            const naf = this.curve.getNAF(k, 1, this.curve._bitLength);
            let I = (1 << (doubles.step + 1)) - (doubles.step % 2 === 0 ? 2 : 1);
            I /= 3;
            // Translate into more windowed form
            const repr = [];
            for (let j = 0; j < naf.length; j += doubles.step) {
                let nafW = 0;
                for (let k = j + doubles.step - 1; k >= j; k--) {
                    nafW = (nafW << 1) + naf[k];
                }
                repr.push(nafW);
            }
            let a = new JacobianPoint(null, null, null);
            let b = new JacobianPoint(null, null, null);
            for (let i = I; i > 0; i--) {
                for (let j = 0; j < repr.length; j++) {
                    const nafW = repr[j];
                    if (nafW === i) {
                        b = b.mixedAdd(doubles.points[j]);
                    }
                    else if (nafW === -i) {
                        b = b.mixedAdd((doubles.points[j]).neg());
                    }
                }
                a = a.add(b);
            }
            return a.toP();
        }
        _wnafMulAdd(defW, points, coeffs, len, jacobianResult) {
            const wndWidth = this.curve._wnafT1;
            const wnd = this.curve._wnafT2;
            const naf = this.curve._wnafT3;
            // Fill all arrays
            let max = 0;
            for (let i = 0; i < len; i++) {
                const p = points[i];
                const nafPoints = p._getNAFPoints(defW);
                wndWidth[i] = nafPoints.wnd;
                wnd[i] = nafPoints.points;
            }
            // Comb small window NAFs
            for (let i = len - 1; i >= 1; i -= 2) {
                const a = i - 1;
                const b = i;
                if (wndWidth[a] !== 1 || wndWidth[b] !== 1) {
                    naf[a] = this.curve
                        .getNAF(coeffs[a], wndWidth[a], this.curve._bitLength);
                    naf[b] = this.curve
                        .getNAF(coeffs[b], wndWidth[b], this.curve._bitLength);
                    max = Math.max(naf[a].length, max);
                    max = Math.max(naf[b].length, max);
                    continue;
                }
                const comb = [
                    points[a],
                    null,
                    null,
                    points[b] /* 7 */
                ];
                // Try to avoid Projective points, if possible
                if (points[a].y.cmp(points[b].y) === 0) {
                    comb[1] = points[a].add(points[b]);
                    comb[2] = points[a].toJ().mixedAdd(points[b].neg());
                }
                else if (points[a].y.cmp(points[b].y.redNeg()) === 0) {
                    comb[1] = points[a].toJ().mixedAdd(points[b]);
                    comb[2] = points[a].add(points[b].neg());
                }
                else {
                    comb[1] = points[a].toJ().mixedAdd(points[b]);
                    comb[2] = points[a].toJ().mixedAdd(points[b].neg());
                }
                const index = [
                    -3,
                    -1,
                    -5,
                    -7,
                    0,
                    7,
                    5,
                    1,
                    3 /* 1 1 */
                ];
                const jsf = this.curve.getJSF(coeffs[a], coeffs[b]);
                max = Math.max(jsf[0].length, max);
                naf[a] = new Array(max);
                naf[b] = new Array(max);
                for (let j = 0; j < max; j++) {
                    const ja = jsf[0][j] | 0;
                    const jb = jsf[1][j] | 0;
                    naf[a][j] = index[(ja + 1) * 3 + (jb + 1)];
                    naf[b][j] = 0;
                    wnd[a] = comb;
                }
            }
            let acc = new JacobianPoint(null, null, null);
            const tmp = this.curve._wnafT4;
            for (let i = max; i >= 0; i--) {
                let k = 0;
                while (i >= 0) {
                    let zero = true;
                    for (let j = 0; j < len; j++) {
                        tmp[j] = naf[j][i] | 0;
                        if (tmp[j] !== 0) {
                            zero = false;
                        }
                    }
                    if (!zero) {
                        break;
                    }
                    k++;
                    i--;
                }
                if (i >= 0) {
                    k++;
                }
                acc = acc.dblp(k);
                if (i < 0) {
                    break;
                }
                for (let j = 0; j < len; j++) {
                    const z = tmp[j];
                    let p;
                    if (z === 0) {
                        continue;
                    }
                    else if (z > 0) {
                        p = wnd[j][(z - 1) >> 1];
                    }
                    else if (z < 0) {
                        p = wnd[j][(-z - 1) >> 1].neg();
                    }
                    if (p.type === 'affine') {
                        acc = acc.mixedAdd(p);
                    }
                    else {
                        acc = acc.add(p);
                    }
                }
            }
            // Zeroify references
            for (let i = 0; i < len; i++) {
                wnd[i] = null;
            }
            if (jacobianResult) {
                return acc;
            }
            else {
                return acc.toP();
            }
        }
        _endoWnafMulAdd(points, coeffs, jacobianResult) {
            const npoints = this.curve._endoWnafT1;
            const ncoeffs = this.curve._endoWnafT2;
            let i;
            for (i = 0; i < points.length; i++) {
                const split = this.curve._endoSplit(coeffs[i]);
                let p = points[i];
                let beta = p._getBeta();
                if (split.k1.negative !== 0) {
                    split.k1.ineg();
                    p = p.neg(true);
                }
                if (split.k2.negative !== 0) {
                    split.k2.ineg();
                    beta = beta.neg(true);
                }
                npoints[i * 2] = p;
                npoints[i * 2 + 1] = beta;
                ncoeffs[i * 2] = split.k1;
                ncoeffs[i * 2 + 1] = split.k2;
            }
            const res = this._wnafMulAdd(1, npoints, ncoeffs, i * 2, jacobianResult);
            // Clean-up references to points and coefficients
            for (let j = 0; j < i * 2; j++) {
                npoints[j] = null;
                ncoeffs[j] = null;
            }
            return res;
        }
        _hasDoubles(k) {
            if (this.precomputed == null) {
                return false;
            }
            const doubles = this.precomputed.doubles;
            if (typeof doubles !== 'object') {
                return false;
            }
            return doubles.points.length >= Math.ceil((k.bitLength() + 1) / doubles.step);
        }
        ;
        _getDoubles(step, power) {
            if (typeof this.precomputed === 'object' && this.precomputed !== null &&
                typeof this.precomputed.doubles === 'object' &&
                this.precomputed.doubles !== null) {
                return this.precomputed.doubles;
            }
            const doubles = [this];
            /* eslint-disable @typescript-eslint/no-this-alias */
            let acc = this;
            for (let i = 0; i < power; i += step) {
                for (let j = 0; j < step; j++) {
                    acc = acc.dbl();
                }
                doubles.push(acc);
            }
            return {
                step,
                points: doubles
            };
        }
        ;
        _getNAFPoints(wnd) {
            if (typeof this.precomputed === 'object' && this.precomputed !== null &&
                typeof this.precomputed.naf === 'object' && this.precomputed.naf !== null) {
                return this.precomputed.naf;
            }
            const res = [this];
            const max = (1 << wnd) - 1;
            const dbl = max === 1 ? null : this.dbl();
            for (let i = 1; i < max; i++) {
                res[i] = res[i - 1].add(dbl);
            }
            return {
                wnd,
                points: res
            };
        }
    }

    // This ensures that only one curve is ever created, enhancing performance.
    // This assumes there is never a need to have multiple distinct Curve instances.
    // So far, this assumption has proven to be valid.
    let globalCurve;
    class Curve {
        p;
        red;
        redN;
        zero;
        one;
        two;
        g;
        n;
        a;
        b;
        tinv;
        zeroA;
        threeA;
        endo; // beta, lambda, basis
        _endoWnafT1;
        _endoWnafT2;
        _wnafT1;
        _wnafT2;
        _wnafT3;
        _wnafT4;
        _bitLength;
        // Represent num in a w-NAF form
        static assert(expression, message = 'Elliptic curve assertion failed') {
            if (!expression) {
                throw new Error(message);
            }
        }
        getNAF(num, w, bits) {
            const naf = new Array(Math.max(num.bitLength(), bits) + 1);
            naf.fill(0);
            const ws = 1 << (w + 1);
            const k = num.clone();
            for (let i = 0; i < naf.length; i++) {
                let z;
                const mod = k.andln(ws - 1);
                if (k.isOdd()) {
                    if (mod > (ws >> 1) - 1) {
                        z = (ws >> 1) - mod;
                    }
                    else {
                        z = mod;
                    }
                    k.isubn(z);
                }
                else {
                    z = 0;
                }
                naf[i] = z;
                k.iushrn(1);
            }
            return naf;
        }
        // Represent k1, k2 in a Joint Sparse Form
        getJSF(k1, k2) {
            const jsf = [
                [],
                []
            ];
            k1 = k1.clone();
            k2 = k2.clone();
            let d1 = 0;
            let d2 = 0;
            while (k1.cmpn(-d1) > 0 || k2.cmpn(-d2) > 0) {
                // First phase
                let m14 = (k1.andln(3) + d1) & 3;
                let m24 = (k2.andln(3) + d2) & 3;
                if (m14 === 3) {
                    m14 = -1;
                }
                if (m24 === 3) {
                    m24 = -1;
                }
                let u1;
                if ((m14 & 1) === 0) {
                    u1 = 0;
                }
                else {
                    const m8 = (k1.andln(7) + d1) & 7;
                    if ((m8 === 3 || m8 === 5) && m24 === 2) {
                        u1 = -m14;
                    }
                    else {
                        u1 = m14;
                    }
                }
                jsf[0].push(u1);
                let u2;
                if ((m24 & 1) === 0) {
                    u2 = 0;
                }
                else {
                    const m8 = (k2.andln(7) + d2) & 7;
                    if ((m8 === 3 || m8 === 5) && m14 === 2) {
                        u2 = -m24;
                    }
                    else {
                        u2 = m24;
                    }
                }
                jsf[1].push(u2);
                // Second phase
                if (2 * d1 === u1 + 1) {
                    d1 = 1 - d1;
                }
                if (2 * d2 === u2 + 1) {
                    d2 = 1 - d2;
                }
                k1.iushrn(1);
                k2.iushrn(1);
            }
            return jsf;
        }
        static cachedProperty(obj, name, computer) {
            const key = '_' + name;
            obj.prototype[name] = function cachedProperty() {
                const r = this[key] !== undefined
                    ? this[key]
                    : this[key] = computer.call(this);
                return r;
            };
        }
        static parseBytes(bytes) {
            return typeof bytes === 'string'
                ? toArray$2(bytes, 'hex')
                : bytes;
        }
        static intFromLE(bytes) {
            return new BigNumber(bytes, 'hex', 'le');
        }
        constructor() {
            const precomputed = {
                doubles: {
                    step: 4,
                    points: [
                        [
                            'e60fce93b59e9ec53011aabc21c23e97b2a31369b87a5ae9c44ee89e2a6dec0a',
                            'f7e3507399e595929db99f34f57937101296891e44d23f0be1f32cce69616821'
                        ],
                        [
                            '8282263212c609d9ea2a6e3e172de238d8c39cabd5ac1ca10646e23fd5f51508',
                            '11f8a8098557dfe45e8256e830b60ace62d613ac2f7b17bed31b6eaff6e26caf'
                        ],
                        [
                            '175e159f728b865a72f99cc6c6fc846de0b93833fd2222ed73fce5b551e5b739',
                            'd3506e0d9e3c79eba4ef97a51ff71f5eacb5955add24345c6efa6ffee9fed695'
                        ],
                        [
                            '363d90d447b00c9c99ceac05b6262ee053441c7e55552ffe526bad8f83ff4640',
                            '4e273adfc732221953b445397f3363145b9a89008199ecb62003c7f3bee9de9'
                        ],
                        [
                            '8b4b5f165df3c2be8c6244b5b745638843e4a781a15bcd1b69f79a55dffdf80c',
                            '4aad0a6f68d308b4b3fbd7813ab0da04f9e336546162ee56b3eff0c65fd4fd36'
                        ],
                        [
                            '723cbaa6e5db996d6bf771c00bd548c7b700dbffa6c0e77bcb6115925232fcda',
                            '96e867b5595cc498a921137488824d6e2660a0653779494801dc069d9eb39f5f'
                        ],
                        [
                            'eebfa4d493bebf98ba5feec812c2d3b50947961237a919839a533eca0e7dd7fa',
                            '5d9a8ca3970ef0f269ee7edaf178089d9ae4cdc3a711f712ddfd4fdae1de8999'
                        ],
                        [
                            '100f44da696e71672791d0a09b7bde459f1215a29b3c03bfefd7835b39a48db0',
                            'cdd9e13192a00b772ec8f3300c090666b7ff4a18ff5195ac0fbd5cd62bc65a09'
                        ],
                        [
                            'e1031be262c7ed1b1dc9227a4a04c017a77f8d4464f3b3852c8acde6e534fd2d',
                            '9d7061928940405e6bb6a4176597535af292dd419e1ced79a44f18f29456a00d'
                        ],
                        [
                            'feea6cae46d55b530ac2839f143bd7ec5cf8b266a41d6af52d5e688d9094696d',
                            'e57c6b6c97dce1bab06e4e12bf3ecd5c981c8957cc41442d3155debf18090088'
                        ],
                        [
                            'da67a91d91049cdcb367be4be6ffca3cfeed657d808583de33fa978bc1ec6cb1',
                            '9bacaa35481642bc41f463f7ec9780e5dec7adc508f740a17e9ea8e27a68be1d'
                        ],
                        [
                            '53904faa0b334cdda6e000935ef22151ec08d0f7bb11069f57545ccc1a37b7c0',
                            '5bc087d0bc80106d88c9eccac20d3c1c13999981e14434699dcb096b022771c8'
                        ],
                        [
                            '8e7bcd0bd35983a7719cca7764ca906779b53a043a9b8bcaeff959f43ad86047',
                            '10b7770b2a3da4b3940310420ca9514579e88e2e47fd68b3ea10047e8460372a'
                        ],
                        [
                            '385eed34c1cdff21e6d0818689b81bde71a7f4f18397e6690a841e1599c43862',
                            '283bebc3e8ea23f56701de19e9ebf4576b304eec2086dc8cc0458fe5542e5453'
                        ],
                        [
                            '6f9d9b803ecf191637c73a4413dfa180fddf84a5947fbc9c606ed86c3fac3a7',
                            '7c80c68e603059ba69b8e2a30e45c4d47ea4dd2f5c281002d86890603a842160'
                        ],
                        [
                            '3322d401243c4e2582a2147c104d6ecbf774d163db0f5e5313b7e0e742d0e6bd',
                            '56e70797e9664ef5bfb019bc4ddaf9b72805f63ea2873af624f3a2e96c28b2a0'
                        ],
                        [
                            '85672c7d2de0b7da2bd1770d89665868741b3f9af7643397721d74d28134ab83',
                            '7c481b9b5b43b2eb6374049bfa62c2e5e77f17fcc5298f44c8e3094f790313a6'
                        ],
                        [
                            '948bf809b1988a46b06c9f1919413b10f9226c60f668832ffd959af60c82a0a',
                            '53a562856dcb6646dc6b74c5d1c3418c6d4dff08c97cd2bed4cb7f88d8c8e589'
                        ],
                        [
                            '6260ce7f461801c34f067ce0f02873a8f1b0e44dfc69752accecd819f38fd8e8',
                            'bc2da82b6fa5b571a7f09049776a1ef7ecd292238051c198c1a84e95b2b4ae17'
                        ],
                        [
                            'e5037de0afc1d8d43d8348414bbf4103043ec8f575bfdc432953cc8d2037fa2d',
                            '4571534baa94d3b5f9f98d09fb990bddbd5f5b03ec481f10e0e5dc841d755bda'
                        ],
                        [
                            'e06372b0f4a207adf5ea905e8f1771b4e7e8dbd1c6a6c5b725866a0ae4fce725',
                            '7a908974bce18cfe12a27bb2ad5a488cd7484a7787104870b27034f94eee31dd'
                        ],
                        [
                            '213c7a715cd5d45358d0bbf9dc0ce02204b10bdde2a3f58540ad6908d0559754',
                            '4b6dad0b5ae462507013ad06245ba190bb4850f5f36a7eeddff2c27534b458f2'
                        ],
                        [
                            '4e7c272a7af4b34e8dbb9352a5419a87e2838c70adc62cddf0cc3a3b08fbd53c',
                            '17749c766c9d0b18e16fd09f6def681b530b9614bff7dd33e0b3941817dcaae6'
                        ],
                        [
                            'fea74e3dbe778b1b10f238ad61686aa5c76e3db2be43057632427e2840fb27b6',
                            '6e0568db9b0b13297cf674deccb6af93126b596b973f7b77701d3db7f23cb96f'
                        ],
                        [
                            '76e64113f677cf0e10a2570d599968d31544e179b760432952c02a4417bdde39',
                            'c90ddf8dee4e95cf577066d70681f0d35e2a33d2b56d2032b4b1752d1901ac01'
                        ],
                        [
                            'c738c56b03b2abe1e8281baa743f8f9a8f7cc643df26cbee3ab150242bcbb891',
                            '893fb578951ad2537f718f2eacbfbbbb82314eef7880cfe917e735d9699a84c3'
                        ],
                        [
                            'd895626548b65b81e264c7637c972877d1d72e5f3a925014372e9f6588f6c14b',
                            'febfaa38f2bc7eae728ec60818c340eb03428d632bb067e179363ed75d7d991f'
                        ],
                        [
                            'b8da94032a957518eb0f6433571e8761ceffc73693e84edd49150a564f676e03',
                            '2804dfa44805a1e4d7c99cc9762808b092cc584d95ff3b511488e4e74efdf6e7'
                        ],
                        [
                            'e80fea14441fb33a7d8adab9475d7fab2019effb5156a792f1a11778e3c0df5d',
                            'eed1de7f638e00771e89768ca3ca94472d155e80af322ea9fcb4291b6ac9ec78'
                        ],
                        [
                            'a301697bdfcd704313ba48e51d567543f2a182031efd6915ddc07bbcc4e16070',
                            '7370f91cfb67e4f5081809fa25d40f9b1735dbf7c0a11a130c0d1a041e177ea1'
                        ],
                        [
                            '90ad85b389d6b936463f9d0512678de208cc330b11307fffab7ac63e3fb04ed4',
                            'e507a3620a38261affdcbd9427222b839aefabe1582894d991d4d48cb6ef150'
                        ],
                        [
                            '8f68b9d2f63b5f339239c1ad981f162ee88c5678723ea3351b7b444c9ec4c0da',
                            '662a9f2dba063986de1d90c2b6be215dbbea2cfe95510bfdf23cbf79501fff82'
                        ],
                        [
                            'e4f3fb0176af85d65ff99ff9198c36091f48e86503681e3e6686fd5053231e11',
                            '1e63633ad0ef4f1c1661a6d0ea02b7286cc7e74ec951d1c9822c38576feb73bc'
                        ],
                        [
                            '8c00fa9b18ebf331eb961537a45a4266c7034f2f0d4e1d0716fb6eae20eae29e',
                            'efa47267fea521a1a9dc343a3736c974c2fadafa81e36c54e7d2a4c66702414b'
                        ],
                        [
                            'e7a26ce69dd4829f3e10cec0a9e98ed3143d084f308b92c0997fddfc60cb3e41',
                            '2a758e300fa7984b471b006a1aafbb18d0a6b2c0420e83e20e8a9421cf2cfd51'
                        ],
                        [
                            'b6459e0ee3662ec8d23540c223bcbdc571cbcb967d79424f3cf29eb3de6b80ef',
                            '67c876d06f3e06de1dadf16e5661db3c4b3ae6d48e35b2ff30bf0b61a71ba45'
                        ],
                        [
                            'd68a80c8280bb840793234aa118f06231d6f1fc67e73c5a5deda0f5b496943e8',
                            'db8ba9fff4b586d00c4b1f9177b0e28b5b0e7b8f7845295a294c84266b133120'
                        ],
                        [
                            '324aed7df65c804252dc0270907a30b09612aeb973449cea4095980fc28d3d5d',
                            '648a365774b61f2ff130c0c35aec1f4f19213b0c7e332843967224af96ab7c84'
                        ],
                        [
                            '4df9c14919cde61f6d51dfdbe5fee5dceec4143ba8d1ca888e8bd373fd054c96',
                            '35ec51092d8728050974c23a1d85d4b5d506cdc288490192ebac06cad10d5d'
                        ],
                        [
                            '9c3919a84a474870faed8a9c1cc66021523489054d7f0308cbfc99c8ac1f98cd',
                            'ddb84f0f4a4ddd57584f044bf260e641905326f76c64c8e6be7e5e03d4fc599d'
                        ],
                        [
                            '6057170b1dd12fdf8de05f281d8e06bb91e1493a8b91d4cc5a21382120a959e5',
                            '9a1af0b26a6a4807add9a2daf71df262465152bc3ee24c65e899be932385a2a8'
                        ],
                        [
                            'a576df8e23a08411421439a4518da31880cef0fba7d4df12b1a6973eecb94266',
                            '40a6bf20e76640b2c92b97afe58cd82c432e10a7f514d9f3ee8be11ae1b28ec8'
                        ],
                        [
                            '7778a78c28dec3e30a05fe9629de8c38bb30d1f5cf9a3a208f763889be58ad71',
                            '34626d9ab5a5b22ff7098e12f2ff580087b38411ff24ac563b513fc1fd9f43ac'
                        ],
                        [
                            '928955ee637a84463729fd30e7afd2ed5f96274e5ad7e5cb09eda9c06d903ac',
                            'c25621003d3f42a827b78a13093a95eeac3d26efa8a8d83fc5180e935bcd091f'
                        ],
                        [
                            '85d0fef3ec6db109399064f3a0e3b2855645b4a907ad354527aae75163d82751',
                            '1f03648413a38c0be29d496e582cf5663e8751e96877331582c237a24eb1f962'
                        ],
                        [
                            'ff2b0dce97eece97c1c9b6041798b85dfdfb6d8882da20308f5404824526087e',
                            '493d13fef524ba188af4c4dc54d07936c7b7ed6fb90e2ceb2c951e01f0c29907'
                        ],
                        [
                            '827fbbe4b1e880ea9ed2b2e6301b212b57f1ee148cd6dd28780e5e2cf856e241',
                            'c60f9c923c727b0b71bef2c67d1d12687ff7a63186903166d605b68baec293ec'
                        ],
                        [
                            'eaa649f21f51bdbae7be4ae34ce6e5217a58fdce7f47f9aa7f3b58fa2120e2b3',
                            'be3279ed5bbbb03ac69a80f89879aa5a01a6b965f13f7e59d47a5305ba5ad93d'
                        ],
                        [
                            'e4a42d43c5cf169d9391df6decf42ee541b6d8f0c9a137401e23632dda34d24f',
                            '4d9f92e716d1c73526fc99ccfb8ad34ce886eedfa8d8e4f13a7f7131deba9414'
                        ],
                        [
                            '1ec80fef360cbdd954160fadab352b6b92b53576a88fea4947173b9d4300bf19',
                            'aeefe93756b5340d2f3a4958a7abbf5e0146e77f6295a07b671cdc1cc107cefd'
                        ],
                        [
                            '146a778c04670c2f91b00af4680dfa8bce3490717d58ba889ddb5928366642be',
                            'b318e0ec3354028add669827f9d4b2870aaa971d2f7e5ed1d0b297483d83efd0'
                        ],
                        [
                            'fa50c0f61d22e5f07e3acebb1aa07b128d0012209a28b9776d76a8793180eef9',
                            '6b84c6922397eba9b72cd2872281a68a5e683293a57a213b38cd8d7d3f4f2811'
                        ],
                        [
                            'da1d61d0ca721a11b1a5bf6b7d88e8421a288ab5d5bba5220e53d32b5f067ec2',
                            '8157f55a7c99306c79c0766161c91e2966a73899d279b48a655fba0f1ad836f1'
                        ],
                        [
                            'a8e282ff0c9706907215ff98e8fd416615311de0446f1e062a73b0610d064e13',
                            '7f97355b8db81c09abfb7f3c5b2515888b679a3e50dd6bd6cef7c73111f4cc0c'
                        ],
                        [
                            '174a53b9c9a285872d39e56e6913cab15d59b1fa512508c022f382de8319497c',
                            'ccc9dc37abfc9c1657b4155f2c47f9e6646b3a1d8cb9854383da13ac079afa73'
                        ],
                        [
                            '959396981943785c3d3e57edf5018cdbe039e730e4918b3d884fdff09475b7ba',
                            '2e7e552888c331dd8ba0386a4b9cd6849c653f64c8709385e9b8abf87524f2fd'
                        ],
                        [
                            'd2a63a50ae401e56d645a1153b109a8fcca0a43d561fba2dbb51340c9d82b151',
                            'e82d86fb6443fcb7565aee58b2948220a70f750af484ca52d4142174dcf89405'
                        ],
                        [
                            '64587e2335471eb890ee7896d7cfdc866bacbdbd3839317b3436f9b45617e073',
                            'd99fcdd5bf6902e2ae96dd6447c299a185b90a39133aeab358299e5e9faf6589'
                        ],
                        [
                            '8481bde0e4e4d885b3a546d3e549de042f0aa6cea250e7fd358d6c86dd45e458',
                            '38ee7b8cba5404dd84a25bf39cecb2ca900a79c42b262e556d64b1b59779057e'
                        ],
                        [
                            '13464a57a78102aa62b6979ae817f4637ffcfed3c4b1ce30bcd6303f6caf666b',
                            '69be159004614580ef7e433453ccb0ca48f300a81d0942e13f495a907f6ecc27'
                        ],
                        [
                            'bc4a9df5b713fe2e9aef430bcc1dc97a0cd9ccede2f28588cada3a0d2d83f366',
                            'd3a81ca6e785c06383937adf4b798caa6e8a9fbfa547b16d758d666581f33c1'
                        ],
                        [
                            '8c28a97bf8298bc0d23d8c749452a32e694b65e30a9472a3954ab30fe5324caa',
                            '40a30463a3305193378fedf31f7cc0eb7ae784f0451cb9459e71dc73cbef9482'
                        ],
                        [
                            '8ea9666139527a8c1dd94ce4f071fd23c8b350c5a4bb33748c4ba111faccae0',
                            '620efabbc8ee2782e24e7c0cfb95c5d735b783be9cf0f8e955af34a30e62b945'
                        ],
                        [
                            'dd3625faef5ba06074669716bbd3788d89bdde815959968092f76cc4eb9a9787',
                            '7a188fa3520e30d461da2501045731ca941461982883395937f68d00c644a573'
                        ],
                        [
                            'f710d79d9eb962297e4f6232b40e8f7feb2bc63814614d692c12de752408221e',
                            'ea98e67232d3b3295d3b535532115ccac8612c721851617526ae47a9c77bfc82'
                        ]
                    ]
                },
                naf: {
                    wnd: 7,
                    points: [
                        [
                            'f9308a019258c31049344f85f89d5229b531c845836f99b08601f113bce036f9',
                            '388f7b0f632de8140fe337e62a37f3566500a99934c2231b6cb9fd7584b8e672'
                        ],
                        [
                            '2f8bde4d1a07209355b4a7250a5c5128e88b84bddc619ab7cba8d569b240efe4',
                            'd8ac222636e5e3d6d4dba9dda6c9c426f788271bab0d6840dca87d3aa6ac62d6'
                        ],
                        [
                            '5cbdf0646e5db4eaa398f365f2ea7a0e3d419b7e0330e39ce92bddedcac4f9bc',
                            '6aebca40ba255960a3178d6d861a54dba813d0b813fde7b5a5082628087264da'
                        ],
                        [
                            'acd484e2f0c7f65309ad178a9f559abde09796974c57e714c35f110dfc27ccbe',
                            'cc338921b0a7d9fd64380971763b61e9add888a4375f8e0f05cc262ac64f9c37'
                        ],
                        [
                            '774ae7f858a9411e5ef4246b70c65aac5649980be5c17891bbec17895da008cb',
                            'd984a032eb6b5e190243dd56d7b7b365372db1e2dff9d6a8301d74c9c953c61b'
                        ],
                        [
                            'f28773c2d975288bc7d1d205c3748651b075fbc6610e58cddeeddf8f19405aa8',
                            'ab0902e8d880a89758212eb65cdaf473a1a06da521fa91f29b5cb52db03ed81'
                        ],
                        [
                            'd7924d4f7d43ea965a465ae3095ff41131e5946f3c85f79e44adbcf8e27e080e',
                            '581e2872a86c72a683842ec228cc6defea40af2bd896d3a5c504dc9ff6a26b58'
                        ],
                        [
                            'defdea4cdb677750a420fee807eacf21eb9898ae79b9768766e4faa04a2d4a34',
                            '4211ab0694635168e997b0ead2a93daeced1f4a04a95c0f6cfb199f69e56eb77'
                        ],
                        [
                            '2b4ea0a797a443d293ef5cff444f4979f06acfebd7e86d277475656138385b6c',
                            '85e89bc037945d93b343083b5a1c86131a01f60c50269763b570c854e5c09b7a'
                        ],
                        [
                            '352bbf4a4cdd12564f93fa332ce333301d9ad40271f8107181340aef25be59d5',
                            '321eb4075348f534d59c18259dda3e1f4a1b3b2e71b1039c67bd3d8bcf81998c'
                        ],
                        [
                            '2fa2104d6b38d11b0230010559879124e42ab8dfeff5ff29dc9cdadd4ecacc3f',
                            '2de1068295dd865b64569335bd5dd80181d70ecfc882648423ba76b532b7d67'
                        ],
                        [
                            '9248279b09b4d68dab21a9b066edda83263c3d84e09572e269ca0cd7f5453714',
                            '73016f7bf234aade5d1aa71bdea2b1ff3fc0de2a887912ffe54a32ce97cb3402'
                        ],
                        [
                            'daed4f2be3a8bf278e70132fb0beb7522f570e144bf615c07e996d443dee8729',
                            'a69dce4a7d6c98e8d4a1aca87ef8d7003f83c230f3afa726ab40e52290be1c55'
                        ],
                        [
                            'c44d12c7065d812e8acf28d7cbb19f9011ecd9e9fdf281b0e6a3b5e87d22e7db',
                            '2119a460ce326cdc76c45926c982fdac0e106e861edf61c5a039063f0e0e6482'
                        ],
                        [
                            '6a245bf6dc698504c89a20cfded60853152b695336c28063b61c65cbd269e6b4',
                            'e022cf42c2bd4a708b3f5126f16a24ad8b33ba48d0423b6efd5e6348100d8a82'
                        ],
                        [
                            '1697ffa6fd9de627c077e3d2fe541084ce13300b0bec1146f95ae57f0d0bd6a5',
                            'b9c398f186806f5d27561506e4557433a2cf15009e498ae7adee9d63d01b2396'
                        ],
                        [
                            '605bdb019981718b986d0f07e834cb0d9deb8360ffb7f61df982345ef27a7479',
                            '2972d2de4f8d20681a78d93ec96fe23c26bfae84fb14db43b01e1e9056b8c49'
                        ],
                        [
                            '62d14dab4150bf497402fdc45a215e10dcb01c354959b10cfe31c7e9d87ff33d',
                            '80fc06bd8cc5b01098088a1950eed0db01aa132967ab472235f5642483b25eaf'
                        ],
                        [
                            '80c60ad0040f27dade5b4b06c408e56b2c50e9f56b9b8b425e555c2f86308b6f',
                            '1c38303f1cc5c30f26e66bad7fe72f70a65eed4cbe7024eb1aa01f56430bd57a'
                        ],
                        [
                            '7a9375ad6167ad54aa74c6348cc54d344cc5dc9487d847049d5eabb0fa03c8fb',
                            'd0e3fa9eca8726909559e0d79269046bdc59ea10c70ce2b02d499ec224dc7f7'
                        ],
                        [
                            'd528ecd9b696b54c907a9ed045447a79bb408ec39b68df504bb51f459bc3ffc9',
                            'eecf41253136e5f99966f21881fd656ebc4345405c520dbc063465b521409933'
                        ],
                        [
                            '49370a4b5f43412ea25f514e8ecdad05266115e4a7ecb1387231808f8b45963',
                            '758f3f41afd6ed428b3081b0512fd62a54c3f3afbb5b6764b653052a12949c9a'
                        ],
                        [
                            '77f230936ee88cbbd73df930d64702ef881d811e0e1498e2f1c13eb1fc345d74',
                            '958ef42a7886b6400a08266e9ba1b37896c95330d97077cbbe8eb3c7671c60d6'
                        ],
                        [
                            'f2dac991cc4ce4b9ea44887e5c7c0bce58c80074ab9d4dbaeb28531b7739f530',
                            'e0dedc9b3b2f8dad4da1f32dec2531df9eb5fbeb0598e4fd1a117dba703a3c37'
                        ],
                        [
                            '463b3d9f662621fb1b4be8fbbe2520125a216cdfc9dae3debcba4850c690d45b',
                            '5ed430d78c296c3543114306dd8622d7c622e27c970a1de31cb377b01af7307e'
                        ],
                        [
                            'f16f804244e46e2a09232d4aff3b59976b98fac14328a2d1a32496b49998f247',
                            'cedabd9b82203f7e13d206fcdf4e33d92a6c53c26e5cce26d6579962c4e31df6'
                        ],
                        [
                            'caf754272dc84563b0352b7a14311af55d245315ace27c65369e15f7151d41d1',
                            'cb474660ef35f5f2a41b643fa5e460575f4fa9b7962232a5c32f908318a04476'
                        ],
                        [
                            '2600ca4b282cb986f85d0f1709979d8b44a09c07cb86d7c124497bc86f082120',
                            '4119b88753c15bd6a693b03fcddbb45d5ac6be74ab5f0ef44b0be9475a7e4b40'
                        ],
                        [
                            '7635ca72d7e8432c338ec53cd12220bc01c48685e24f7dc8c602a7746998e435',
                            '91b649609489d613d1d5e590f78e6d74ecfc061d57048bad9e76f302c5b9c61'
                        ],
                        [
                            '754e3239f325570cdbbf4a87deee8a66b7f2b33479d468fbc1a50743bf56cc18',
                            '673fb86e5bda30fb3cd0ed304ea49a023ee33d0197a695d0c5d98093c536683'
                        ],
                        [
                            'e3e6bd1071a1e96aff57859c82d570f0330800661d1c952f9fe2694691d9b9e8',
                            '59c9e0bba394e76f40c0aa58379a3cb6a5a2283993e90c4167002af4920e37f5'
                        ],
                        [
                            '186b483d056a033826ae73d88f732985c4ccb1f32ba35f4b4cc47fdcf04aa6eb',
                            '3b952d32c67cf77e2e17446e204180ab21fb8090895138b4a4a797f86e80888b'
                        ],
                        [
                            'df9d70a6b9876ce544c98561f4be4f725442e6d2b737d9c91a8321724ce0963f',
                            '55eb2dafd84d6ccd5f862b785dc39d4ab157222720ef9da217b8c45cf2ba2417'
                        ],
                        [
                            '5edd5cc23c51e87a497ca815d5dce0f8ab52554f849ed8995de64c5f34ce7143',
                            'efae9c8dbc14130661e8cec030c89ad0c13c66c0d17a2905cdc706ab7399a868'
                        ],
                        [
                            '290798c2b6476830da12fe02287e9e777aa3fba1c355b17a722d362f84614fba',
                            'e38da76dcd440621988d00bcf79af25d5b29c094db2a23146d003afd41943e7a'
                        ],
                        [
                            'af3c423a95d9f5b3054754efa150ac39cd29552fe360257362dfdecef4053b45',
                            'f98a3fd831eb2b749a93b0e6f35cfb40c8cd5aa667a15581bc2feded498fd9c6'
                        ],
                        [
                            '766dbb24d134e745cccaa28c99bf274906bb66b26dcf98df8d2fed50d884249a',
                            '744b1152eacbe5e38dcc887980da38b897584a65fa06cedd2c924f97cbac5996'
                        ],
                        [
                            '59dbf46f8c94759ba21277c33784f41645f7b44f6c596a58ce92e666191abe3e',
                            'c534ad44175fbc300f4ea6ce648309a042ce739a7919798cd85e216c4a307f6e'
                        ],
                        [
                            'f13ada95103c4537305e691e74e9a4a8dd647e711a95e73cb62dc6018cfd87b8',
                            'e13817b44ee14de663bf4bc808341f326949e21a6a75c2570778419bdaf5733d'
                        ],
                        [
                            '7754b4fa0e8aced06d4167a2c59cca4cda1869c06ebadfb6488550015a88522c',
                            '30e93e864e669d82224b967c3020b8fa8d1e4e350b6cbcc537a48b57841163a2'
                        ],
                        [
                            '948dcadf5990e048aa3874d46abef9d701858f95de8041d2a6828c99e2262519',
                            'e491a42537f6e597d5d28a3224b1bc25df9154efbd2ef1d2cbba2cae5347d57e'
                        ],
                        [
                            '7962414450c76c1689c7b48f8202ec37fb224cf5ac0bfa1570328a8a3d7c77ab',
                            '100b610ec4ffb4760d5c1fc133ef6f6b12507a051f04ac5760afa5b29db83437'
                        ],
                        [
                            '3514087834964b54b15b160644d915485a16977225b8847bb0dd085137ec47ca',
                            'ef0afbb2056205448e1652c48e8127fc6039e77c15c2378b7e7d15a0de293311'
                        ],
                        [
                            'd3cc30ad6b483e4bc79ce2c9dd8bc54993e947eb8df787b442943d3f7b527eaf',
                            '8b378a22d827278d89c5e9be8f9508ae3c2ad46290358630afb34db04eede0a4'
                        ],
                        [
                            '1624d84780732860ce1c78fcbfefe08b2b29823db913f6493975ba0ff4847610',
                            '68651cf9b6da903e0914448c6cd9d4ca896878f5282be4c8cc06e2a404078575'
                        ],
                        [
                            '733ce80da955a8a26902c95633e62a985192474b5af207da6df7b4fd5fc61cd4',
                            'f5435a2bd2badf7d485a4d8b8db9fcce3e1ef8e0201e4578c54673bc1dc5ea1d'
                        ],
                        [
                            '15d9441254945064cf1a1c33bbd3b49f8966c5092171e699ef258dfab81c045c',
                            'd56eb30b69463e7234f5137b73b84177434800bacebfc685fc37bbe9efe4070d'
                        ],
                        [
                            'a1d0fcf2ec9de675b612136e5ce70d271c21417c9d2b8aaaac138599d0717940',
                            'edd77f50bcb5a3cab2e90737309667f2641462a54070f3d519212d39c197a629'
                        ],
                        [
                            'e22fbe15c0af8ccc5780c0735f84dbe9a790badee8245c06c7ca37331cb36980',
                            'a855babad5cd60c88b430a69f53a1a7a38289154964799be43d06d77d31da06'
                        ],
                        [
                            '311091dd9860e8e20ee13473c1155f5f69635e394704eaa74009452246cfa9b3',
                            '66db656f87d1f04fffd1f04788c06830871ec5a64feee685bd80f0b1286d8374'
                        ],
                        [
                            '34c1fd04d301be89b31c0442d3e6ac24883928b45a9340781867d4232ec2dbdf',
                            '9414685e97b1b5954bd46f730174136d57f1ceeb487443dc5321857ba73abee'
                        ],
                        [
                            'f219ea5d6b54701c1c14de5b557eb42a8d13f3abbcd08affcc2a5e6b049b8d63',
                            '4cb95957e83d40b0f73af4544cccf6b1f4b08d3c07b27fb8d8c2962a400766d1'
                        ],
                        [
                            'd7b8740f74a8fbaab1f683db8f45de26543a5490bca627087236912469a0b448',
                            'fa77968128d9c92ee1010f337ad4717eff15db5ed3c049b3411e0315eaa4593b'
                        ],
                        [
                            '32d31c222f8f6f0ef86f7c98d3a3335ead5bcd32abdd94289fe4d3091aa824bf',
                            '5f3032f5892156e39ccd3d7915b9e1da2e6dac9e6f26e961118d14b8462e1661'
                        ],
                        [
                            '7461f371914ab32671045a155d9831ea8793d77cd59592c4340f86cbc18347b5',
                            '8ec0ba238b96bec0cbdddcae0aa442542eee1ff50c986ea6b39847b3cc092ff6'
                        ],
                        [
                            'ee079adb1df1860074356a25aa38206a6d716b2c3e67453d287698bad7b2b2d6',
                            '8dc2412aafe3be5c4c5f37e0ecc5f9f6a446989af04c4e25ebaac479ec1c8c1e'
                        ],
                        [
                            '16ec93e447ec83f0467b18302ee620f7e65de331874c9dc72bfd8616ba9da6b5',
                            '5e4631150e62fb40d0e8c2a7ca5804a39d58186a50e497139626778e25b0674d'
                        ],
                        [
                            'eaa5f980c245f6f038978290afa70b6bd8855897f98b6aa485b96065d537bd99',
                            'f65f5d3e292c2e0819a528391c994624d784869d7e6ea67fb18041024edc07dc'
                        ],
                        [
                            '78c9407544ac132692ee1910a02439958ae04877151342ea96c4b6b35a49f51',
                            'f3e0319169eb9b85d5404795539a5e68fa1fbd583c064d2462b675f194a3ddb4'
                        ],
                        [
                            '494f4be219a1a77016dcd838431aea0001cdc8ae7a6fc688726578d9702857a5',
                            '42242a969283a5f339ba7f075e36ba2af925ce30d767ed6e55f4b031880d562c'
                        ],
                        [
                            'a598a8030da6d86c6bc7f2f5144ea549d28211ea58faa70ebf4c1e665c1fe9b5',
                            '204b5d6f84822c307e4b4a7140737aec23fc63b65b35f86a10026dbd2d864e6b'
                        ],
                        [
                            'c41916365abb2b5d09192f5f2dbeafec208f020f12570a184dbadc3e58595997',
                            '4f14351d0087efa49d245b328984989d5caf9450f34bfc0ed16e96b58fa9913'
                        ],
                        [
                            '841d6063a586fa475a724604da03bc5b92a2e0d2e0a36acfe4c73a5514742881',
                            '73867f59c0659e81904f9a1c7543698e62562d6744c169ce7a36de01a8d6154'
                        ],
                        [
                            '5e95bb399a6971d376026947f89bde2f282b33810928be4ded112ac4d70e20d5',
                            '39f23f366809085beebfc71181313775a99c9aed7d8ba38b161384c746012865'
                        ],
                        [
                            '36e4641a53948fd476c39f8a99fd974e5ec07564b5315d8bf99471bca0ef2f66',
                            'd2424b1b1abe4eb8164227b085c9aa9456ea13493fd563e06fd51cf5694c78fc'
                        ],
                        [
                            '336581ea7bfbbb290c191a2f507a41cf5643842170e914faeab27c2c579f726',
                            'ead12168595fe1be99252129b6e56b3391f7ab1410cd1e0ef3dcdcabd2fda224'
                        ],
                        [
                            '8ab89816dadfd6b6a1f2634fcf00ec8403781025ed6890c4849742706bd43ede',
                            '6fdcef09f2f6d0a044e654aef624136f503d459c3e89845858a47a9129cdd24e'
                        ],
                        [
                            '1e33f1a746c9c5778133344d9299fcaa20b0938e8acff2544bb40284b8c5fb94',
                            '60660257dd11b3aa9c8ed618d24edff2306d320f1d03010e33a7d2057f3b3b6'
                        ],
                        [
                            '85b7c1dcb3cec1b7ee7f30ded79dd20a0ed1f4cc18cbcfcfa410361fd8f08f31',
                            '3d98a9cdd026dd43f39048f25a8847f4fcafad1895d7a633c6fed3c35e999511'
                        ],
                        [
                            '29df9fbd8d9e46509275f4b125d6d45d7fbe9a3b878a7af872a2800661ac5f51',
                            'b4c4fe99c775a606e2d8862179139ffda61dc861c019e55cd2876eb2a27d84b'
                        ],
                        [
                            'a0b1cae06b0a847a3fea6e671aaf8adfdfe58ca2f768105c8082b2e449fce252',
                            'ae434102edde0958ec4b19d917a6a28e6b72da1834aff0e650f049503a296cf2'
                        ],
                        [
                            '4e8ceafb9b3e9a136dc7ff67e840295b499dfb3b2133e4ba113f2e4c0e121e5',
                            'cf2174118c8b6d7a4b48f6d534ce5c79422c086a63460502b827ce62a326683c'
                        ],
                        [
                            'd24a44e047e19b6f5afb81c7ca2f69080a5076689a010919f42725c2b789a33b',
                            '6fb8d5591b466f8fc63db50f1c0f1c69013f996887b8244d2cdec417afea8fa3'
                        ],
                        [
                            'ea01606a7a6c9cdd249fdfcfacb99584001edd28abbab77b5104e98e8e3b35d4',
                            '322af4908c7312b0cfbfe369f7a7b3cdb7d4494bc2823700cfd652188a3ea98d'
                        ],
                        [
                            'af8addbf2b661c8a6c6328655eb96651252007d8c5ea31be4ad196de8ce2131f',
                            '6749e67c029b85f52a034eafd096836b2520818680e26ac8f3dfbcdb71749700'
                        ],
                        [
                            'e3ae1974566ca06cc516d47e0fb165a674a3dabcfca15e722f0e3450f45889',
                            '2aeabe7e4531510116217f07bf4d07300de97e4874f81f533420a72eeb0bd6a4'
                        ],
                        [
                            '591ee355313d99721cf6993ffed1e3e301993ff3ed258802075ea8ced397e246',
                            'b0ea558a113c30bea60fc4775460c7901ff0b053d25ca2bdeee98f1a4be5d196'
                        ],
                        [
                            '11396d55fda54c49f19aa97318d8da61fa8584e47b084945077cf03255b52984',
                            '998c74a8cd45ac01289d5833a7beb4744ff536b01b257be4c5767bea93ea57a4'
                        ],
                        [
                            '3c5d2a1ba39c5a1790000738c9e0c40b8dcdfd5468754b6405540157e017aa7a',
                            'b2284279995a34e2f9d4de7396fc18b80f9b8b9fdd270f6661f79ca4c81bd257'
                        ],
                        [
                            'cc8704b8a60a0defa3a99a7299f2e9c3fbc395afb04ac078425ef8a1793cc030',
                            'bdd46039feed17881d1e0862db347f8cf395b74fc4bcdc4e940b74e3ac1f1b13'
                        ],
                        [
                            'c533e4f7ea8555aacd9777ac5cad29b97dd4defccc53ee7ea204119b2889b197',
                            '6f0a256bc5efdf429a2fb6242f1a43a2d9b925bb4a4b3a26bb8e0f45eb596096'
                        ],
                        [
                            'c14f8f2ccb27d6f109f6d08d03cc96a69ba8c34eec07bbcf566d48e33da6593',
                            'c359d6923bb398f7fd4473e16fe1c28475b740dd098075e6c0e8649113dc3a38'
                        ],
                        [
                            'a6cbc3046bc6a450bac24789fa17115a4c9739ed75f8f21ce441f72e0b90e6ef',
                            '21ae7f4680e889bb130619e2c0f95a360ceb573c70603139862afd617fa9b9f'
                        ],
                        [
                            '347d6d9a02c48927ebfb86c1359b1caf130a3c0267d11ce6344b39f99d43cc38',
                            '60ea7f61a353524d1c987f6ecec92f086d565ab687870cb12689ff1e31c74448'
                        ],
                        [
                            'da6545d2181db8d983f7dcb375ef5866d47c67b1bf31c8cf855ef7437b72656a',
                            '49b96715ab6878a79e78f07ce5680c5d6673051b4935bd897fea824b77dc208a'
                        ],
                        [
                            'c40747cc9d012cb1a13b8148309c6de7ec25d6945d657146b9d5994b8feb1111',
                            '5ca560753be2a12fc6de6caf2cb489565db936156b9514e1bb5e83037e0fa2d4'
                        ],
                        [
                            '4e42c8ec82c99798ccf3a610be870e78338c7f713348bd34c8203ef4037f3502',
                            '7571d74ee5e0fb92a7a8b33a07783341a5492144cc54bcc40a94473693606437'
                        ],
                        [
                            '3775ab7089bc6af823aba2e1af70b236d251cadb0c86743287522a1b3b0dedea',
                            'be52d107bcfa09d8bcb9736a828cfa7fac8db17bf7a76a2c42ad961409018cf7'
                        ],
                        [
                            'cee31cbf7e34ec379d94fb814d3d775ad954595d1314ba8846959e3e82f74e26',
                            '8fd64a14c06b589c26b947ae2bcf6bfa0149ef0be14ed4d80f448a01c43b1c6d'
                        ],
                        [
                            'b4f9eaea09b6917619f6ea6a4eb5464efddb58fd45b1ebefcdc1a01d08b47986',
                            '39e5c9925b5a54b07433a4f18c61726f8bb131c012ca542eb24a8ac07200682a'
                        ],
                        [
                            'd4263dfc3d2df923a0179a48966d30ce84e2515afc3dccc1b77907792ebcc60e',
                            '62dfaf07a0f78feb30e30d6295853ce189e127760ad6cf7fae164e122a208d54'
                        ],
                        [
                            '48457524820fa65a4f8d35eb6930857c0032acc0a4a2de422233eeda897612c4',
                            '25a748ab367979d98733c38a1fa1c2e7dc6cc07db2d60a9ae7a76aaa49bd0f77'
                        ],
                        [
                            'dfeeef1881101f2cb11644f3a2afdfc2045e19919152923f367a1767c11cceda',
                            'ecfb7056cf1de042f9420bab396793c0c390bde74b4bbdff16a83ae09a9a7517'
                        ],
                        [
                            '6d7ef6b17543f8373c573f44e1f389835d89bcbc6062ced36c82df83b8fae859',
                            'cd450ec335438986dfefa10c57fea9bcc521a0959b2d80bbf74b190dca712d10'
                        ],
                        [
                            'e75605d59102a5a2684500d3b991f2e3f3c88b93225547035af25af66e04541f',
                            'f5c54754a8f71ee540b9b48728473e314f729ac5308b06938360990e2bfad125'
                        ],
                        [
                            'eb98660f4c4dfaa06a2be453d5020bc99a0c2e60abe388457dd43fefb1ed620c',
                            '6cb9a8876d9cb8520609af3add26cd20a0a7cd8a9411131ce85f44100099223e'
                        ],
                        [
                            '13e87b027d8514d35939f2e6892b19922154596941888336dc3563e3b8dba942',
                            'fef5a3c68059a6dec5d624114bf1e91aac2b9da568d6abeb2570d55646b8adf1'
                        ],
                        [
                            'ee163026e9fd6fe017c38f06a5be6fc125424b371ce2708e7bf4491691e5764a',
                            '1acb250f255dd61c43d94ccc670d0f58f49ae3fa15b96623e5430da0ad6c62b2'
                        ],
                        [
                            'b268f5ef9ad51e4d78de3a750c2dc89b1e626d43505867999932e5db33af3d80',
                            '5f310d4b3c99b9ebb19f77d41c1dee018cf0d34fd4191614003e945a1216e423'
                        ],
                        [
                            'ff07f3118a9df035e9fad85eb6c7bfe42b02f01ca99ceea3bf7ffdba93c4750d',
                            '438136d603e858a3a5c440c38eccbaddc1d2942114e2eddd4740d098ced1f0d8'
                        ],
                        [
                            '8d8b9855c7c052a34146fd20ffb658bea4b9f69e0d825ebec16e8c3ce2b526a1',
                            'cdb559eedc2d79f926baf44fb84ea4d44bcf50fee51d7ceb30e2e7f463036758'
                        ],
                        [
                            '52db0b5384dfbf05bfa9d472d7ae26dfe4b851ceca91b1eba54263180da32b63',
                            'c3b997d050ee5d423ebaf66a6db9f57b3180c902875679de924b69d84a7b375'
                        ],
                        [
                            'e62f9490d3d51da6395efd24e80919cc7d0f29c3f3fa48c6fff543becbd43352',
                            '6d89ad7ba4876b0b22c2ca280c682862f342c8591f1daf5170e07bfd9ccafa7d'
                        ],
                        [
                            '7f30ea2476b399b4957509c88f77d0191afa2ff5cb7b14fd6d8e7d65aaab1193',
                            'ca5ef7d4b231c94c3b15389a5f6311e9daff7bb67b103e9880ef4bff637acaec'
                        ],
                        [
                            '5098ff1e1d9f14fb46a210fada6c903fef0fb7b4a1dd1d9ac60a0361800b7a00',
                            '9731141d81fc8f8084d37c6e7542006b3ee1b40d60dfe5362a5b132fd17ddc0'
                        ],
                        [
                            '32b78c7de9ee512a72895be6b9cbefa6e2f3c4ccce445c96b9f2c81e2778ad58',
                            'ee1849f513df71e32efc3896ee28260c73bb80547ae2275ba497237794c8753c'
                        ],
                        [
                            'e2cb74fddc8e9fbcd076eef2a7c72b0ce37d50f08269dfc074b581550547a4f7',
                            'd3aa2ed71c9dd2247a62df062736eb0baddea9e36122d2be8641abcb005cc4a4'
                        ],
                        [
                            '8438447566d4d7bedadc299496ab357426009a35f235cb141be0d99cd10ae3a8',
                            'c4e1020916980a4da5d01ac5e6ad330734ef0d7906631c4f2390426b2edd791f'
                        ],
                        [
                            '4162d488b89402039b584c6fc6c308870587d9c46f660b878ab65c82c711d67e',
                            '67163e903236289f776f22c25fb8a3afc1732f2b84b4e95dbda47ae5a0852649'
                        ],
                        [
                            '3fad3fa84caf0f34f0f89bfd2dcf54fc175d767aec3e50684f3ba4a4bf5f683d',
                            'cd1bc7cb6cc407bb2f0ca647c718a730cf71872e7d0d2a53fa20efcdfe61826'
                        ],
                        [
                            '674f2600a3007a00568c1a7ce05d0816c1fb84bf1370798f1c69532faeb1a86b',
                            '299d21f9413f33b3edf43b257004580b70db57da0b182259e09eecc69e0d38a5'
                        ],
                        [
                            'd32f4da54ade74abb81b815ad1fb3b263d82d6c692714bcff87d29bd5ee9f08f',
                            'f9429e738b8e53b968e99016c059707782e14f4535359d582fc416910b3eea87'
                        ],
                        [
                            '30e4e670435385556e593657135845d36fbb6931f72b08cb1ed954f1e3ce3ff6',
                            '462f9bce619898638499350113bbc9b10a878d35da70740dc695a559eb88db7b'
                        ],
                        [
                            'be2062003c51cc3004682904330e4dee7f3dcd10b01e580bf1971b04d4cad297',
                            '62188bc49d61e5428573d48a74e1c655b1c61090905682a0d5558ed72dccb9bc'
                        ],
                        [
                            '93144423ace3451ed29e0fb9ac2af211cb6e84a601df5993c419859fff5df04a',
                            '7c10dfb164c3425f5c71a3f9d7992038f1065224f72bb9d1d902a6d13037b47c'
                        ],
                        [
                            'b015f8044f5fcbdcf21ca26d6c34fb8197829205c7b7d2a7cb66418c157b112c',
                            'ab8c1e086d04e813744a655b2df8d5f83b3cdc6faa3088c1d3aea1454e3a1d5f'
                        ],
                        [
                            'd5e9e1da649d97d89e4868117a465a3a4f8a18de57a140d36b3f2af341a21b52',
                            '4cb04437f391ed73111a13cc1d4dd0db1693465c2240480d8955e8592f27447a'
                        ],
                        [
                            'd3ae41047dd7ca065dbf8ed77b992439983005cd72e16d6f996a5316d36966bb',
                            'bd1aeb21ad22ebb22a10f0303417c6d964f8cdd7df0aca614b10dc14d125ac46'
                        ],
                        [
                            '463e2763d885f958fc66cdd22800f0a487197d0a82e377b49f80af87c897b065',
                            'bfefacdb0e5d0fd7df3a311a94de062b26b80c61fbc97508b79992671ef7ca7f'
                        ],
                        [
                            '7985fdfd127c0567c6f53ec1bb63ec3158e597c40bfe747c83cddfc910641917',
                            '603c12daf3d9862ef2b25fe1de289aed24ed291e0ec6708703a5bd567f32ed03'
                        ],
                        [
                            '74a1ad6b5f76e39db2dd249410eac7f99e74c59cb83d2d0ed5ff1543da7703e9',
                            'cc6157ef18c9c63cd6193d83631bbea0093e0968942e8c33d5737fd790e0db08'
                        ],
                        [
                            '30682a50703375f602d416664ba19b7fc9bab42c72747463a71d0896b22f6da3',
                            '553e04f6b018b4fa6c8f39e7f311d3176290d0e0f19ca73f17714d9977a22ff8'
                        ],
                        [
                            '9e2158f0d7c0d5f26c3791efefa79597654e7a2b2464f52b1ee6c1347769ef57',
                            '712fcdd1b9053f09003a3481fa7762e9ffd7c8ef35a38509e2fbf2629008373'
                        ],
                        [
                            '176e26989a43c9cfeba4029c202538c28172e566e3c4fce7322857f3be327d66',
                            'ed8cc9d04b29eb877d270b4878dc43c19aefd31f4eee09ee7b47834c1fa4b1c3'
                        ],
                        [
                            '75d46efea3771e6e68abb89a13ad747ecf1892393dfc4f1b7004788c50374da8',
                            '9852390a99507679fd0b86fd2b39a868d7efc22151346e1a3ca4726586a6bed8'
                        ],
                        [
                            '809a20c67d64900ffb698c4c825f6d5f2310fb0451c869345b7319f645605721',
                            '9e994980d9917e22b76b061927fa04143d096ccc54963e6a5ebfa5f3f8e286c1'
                        ],
                        [
                            '1b38903a43f7f114ed4500b4eac7083fdefece1cf29c63528d563446f972c180',
                            '4036edc931a60ae889353f77fd53de4a2708b26b6f5da72ad3394119daf408f9'
                        ]
                    ]
                }
            };
            if (typeof globalCurve !== 'undefined') {
                return globalCurve;
            }
            else {
                /* eslint-disable @typescript-eslint/no-this-alias */
                globalCurve = this;
            }
            const conf = {
                prime: 'k256',
                p: 'ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff fffffffe fffffc2f',
                a: '0',
                b: '7',
                n: 'ffffffff ffffffff ffffffff fffffffe baaedce6 af48a03b bfd25e8c d0364141',
                h: '1',
                // Precomputed endomorphism
                beta: '7ae96a2b657c07106e64479eac3434e99cf0497512f58995c1396c28719501ee',
                lambda: '5363ad4cc05c30e0a5261c028812645a122e22ea20816678df02967c1b23bd72',
                basis: [
                    {
                        a: '3086d221a7d46bcde86c90e49284eb15',
                        b: '-e4437ed6010e88286f547fa90abfe4c3'
                    },
                    {
                        a: '114ca50f7a8e2f3f657c1108d9d44cfd8',
                        b: '3086d221a7d46bcde86c90e49284eb15'
                    }
                ],
                gRed: false,
                g: [
                    '79be667ef9dcbbac55a06295ce870b07029bfcdb2dce28d959f2815b16f81798',
                    '483ada7726a3c4655da4fbfc0e1108a8fd17b448a68554199c47d08ffb10d4b8',
                    precomputed
                ]
            };
            this.p = new BigNumber(conf.p, 16);
            // Use Montgomery, when there is no fast reduction for the prime
            this.red = new ReductionContext(conf.prime);
            // Useful for many curves
            this.zero = new BigNumber(0).toRed(this.red);
            this.one = new BigNumber(1).toRed(this.red);
            this.two = new BigNumber(2).toRed(this.red);
            // Curve configuration, optional
            this.n = new BigNumber(conf.n, 16);
            this.g = Point.fromJSON(conf.g, conf.gRed);
            // Temporary arrays
            this._wnafT1 = new Array(4);
            this._wnafT2 = new Array(4);
            this._wnafT3 = new Array(4);
            this._wnafT4 = new Array(4);
            this._bitLength = this.n.bitLength();
            this.redN = this.n.toRed(this.red);
            this.a = new BigNumber(conf.a, 16).toRed(this.red);
            this.b = new BigNumber(conf.b, 16).toRed(this.red);
            this.tinv = this.two.redInvm();
            this.zeroA = this.a.fromRed().cmpn(0) === 0;
            this.threeA = this.a.fromRed().sub(this.p).cmpn(-3) === 0;
            // If the curve is endomorphic, precalculate beta and lambda
            this.endo = this._getEndomorphism(conf);
            this._endoWnafT1 = new Array(4);
            this._endoWnafT2 = new Array(4);
        }
        _getEndomorphism(conf) {
            // No efficient endomorphism
            if (!this.zeroA || this.p.modrn(3) !== 1) {
                return;
            }
            // Compute beta and lambda, that lambda * P = (beta * Px; Py)
            let beta;
            let lambda;
            if (conf.beta !== undefined) {
                beta = new BigNumber(conf.beta, 16).toRed(this.red);
            }
            else {
                const betas = this._getEndoRoots(this.p);
                // Choose the smallest beta
                beta = betas[0].cmp(betas[1]) < 0 ? betas[0] : betas[1];
                beta = beta.toRed(this.red);
            }
            if (conf.lambda !== undefined) {
                lambda = new BigNumber(conf.lambda, 16);
            }
            else {
                // Choose the lambda that is matching selected beta
                const lambdas = this._getEndoRoots(this.n);
                if (this.g.mul(lambdas[0]).x.cmp(this.g.x.redMul(beta)) === 0) {
                    lambda = lambdas[0];
                }
                else {
                    lambda = lambdas[1];
                    Curve.assert(this.g.mul(lambda).x.cmp(this.g.x.redMul(beta)) === 0);
                }
            }
            // Get basis vectors, used for balanced length-two representation
            let basis;
            if (typeof conf.basis === 'object' && conf.basis !== null) {
                basis = conf.basis.map(function (vec) {
                    return {
                        a: new BigNumber(vec.a, 16),
                        b: new BigNumber(vec.b, 16)
                    };
                });
            }
            else {
                basis = this._getEndoBasis(lambda);
            }
            return {
                beta,
                lambda,
                basis
            };
        }
        ;
        _getEndoRoots(num) {
            // Find roots of for x^2 + x + 1 in F
            // Root = (-1 +- Sqrt(-3)) / 2
            //
            const red = num === this.p ? this.red : new MontgomoryMethod(num);
            const tinv = new BigNumber(2).toRed(red).redInvm();
            const ntinv = tinv.redNeg();
            const s = new BigNumber(3).toRed(red).redNeg().redSqrt().redMul(tinv);
            const l1 = ntinv.redAdd(s).fromRed();
            const l2 = ntinv.redSub(s).fromRed();
            return [l1, l2];
        }
        ;
        _getEndoBasis(lambda) {
            // aprxSqrt >= sqrt(this.n)
            const aprxSqrt = this.n.ushrn(Math.floor(this.n.bitLength() / 2));
            // 3.74
            // Run EGCD, until r(L + 1) < aprxSqrt
            let u = lambda;
            let v = this.n.clone();
            let x1 = new BigNumber(1);
            let y1 = new BigNumber(0);
            let x2 = new BigNumber(0);
            let y2 = new BigNumber(1);
            // NOTE: all vectors are roots of: a + b * lambda = 0 (mod n)
            let a0;
            let b0;
            // First vector
            let a1;
            let b1;
            // Second vector
            let a2;
            let b2;
            let prevR;
            let i = 0;
            let r;
            let x;
            while (u.cmpn(0) !== 0) {
                const q = v.div(u);
                r = v.sub(q.mul(u));
                x = x2.sub(q.mul(x1));
                const y = y2.sub(q.mul(y1));
                if (typeof a1 !== 'object' && r.cmp(aprxSqrt) < 0) {
                    a0 = prevR.neg();
                    b0 = x1;
                    a1 = r.neg();
                    b1 = x;
                }
                else if (typeof a1 === 'object' && ++i === 2) {
                    break;
                }
                prevR = r;
                v = u;
                u = r;
                x2 = x1;
                x1 = x;
                y2 = y1;
                y1 = y;
            }
            a2 = r.neg();
            b2 = x;
            const len1 = a1.sqr().add(b1.sqr());
            const len2 = a2.sqr().add(b2.sqr());
            if (len2.cmp(len1) >= 0) {
                a2 = a0;
                b2 = b0;
            }
            // Normalize signs
            if (a1.negative !== 0) {
                a1 = a1.neg();
                b1 = b1.neg();
            }
            if (a2.negative !== 0) {
                a2 = a2.neg();
                b2 = b2.neg();
            }
            return [
                { a: a1, b: b1 },
                { a: a2, b: b2 }
            ];
        }
        _endoSplit(k) {
            const basis = this.endo.basis;
            const v1 = basis[0];
            const v2 = basis[1];
            const c1 = v2.b.mul(k).divRound(this.n);
            const c2 = v1.b.neg().mul(k).divRound(this.n);
            const p1 = c1.mul(v1.a);
            const p2 = c2.mul(v2.a);
            const q1 = c1.mul(v1.b);
            const q2 = c2.mul(v2.b);
            // Calculate answer
            const k1 = k.sub(p1).sub(p2);
            const k2 = q1.add(q2).neg();
            return { k1, k2 };
        }
        validate(point) {
            if (point.inf) {
                return true;
            }
            const x = point.x;
            const y = point.y;
            const ax = this.a.redMul(x);
            const rhs = x.redSqr().redMul(x).redIAdd(ax).redIAdd(this.b);
            return y.redSqr().redISub(rhs).cmpn(0) === 0;
        }
        ;
    }

    /**
     * Represents a digital signature.
     *
     * A digital signature is a mathematical scheme for verifying the authenticity of
     * digital messages or documents. In many scenarios, it is equivalent to a handwritten signature or stamped seal.
     * The signature pair (R, S) corresponds to the raw ECDSA ([Elliptic Curve Digital Signature Algorithm](https://en.wikipedia.org/wiki/Elliptic_Curve_Digital_Signature_Algorithm)) signature.
     * Signatures are often serialized into a format known as '[DER encoding](https://en.wikipedia.org/wiki/X.690#DER_encoding)' for transmission.
     *
     * @class Signature
     */
    class Signature {
        /**
         * @property Represents the "r" component of the digital signature
         */
        r;
        /**
         * @property Represents the "s" component of the digital signature
         */
        s;
        /**
         * Takes an array of numbers or a string and returns a new Signature instance.
         * This method will throw an error if the DER encoding is invalid.
         * If a string is provided, it is assumed to represent a hexadecimal sequence.
         *
         * @static
         * @method fromDER
         * @param data - The sequence to decode from DER encoding.
         * @param enc - The encoding of the data string.
         * @returns The decoded data in the form of Signature instance.
         *
         * @example
         * const signature = Signature.fromDER('30440220018c1f5502f8...', 'hex');
         */
        static fromDER(data, enc) {
            const getLength = (buf, p) => {
                const initial = buf[p.place++];
                if ((initial & 0x80) === 0) {
                    return initial;
                }
                else {
                    throw new Error('Invalid DER entity length');
                }
            };
            class Position {
                place;
                constructor() {
                    this.place = 0;
                }
            }
            data = toArray$2(data, enc);
            const p = new Position();
            if (data[p.place++] !== 0x30) {
                throw new Error('Signature DER must start with 0x30');
            }
            const len = getLength(data, p);
            if ((len + p.place) !== data.length) {
                throw new Error('Signature DER invalid');
            }
            if (data[p.place++] !== 0x02) {
                throw new Error('Signature DER invalid');
            }
            const rlen = getLength(data, p);
            let r = data.slice(p.place, rlen + p.place);
            p.place += rlen;
            if (data[p.place++] !== 0x02) {
                throw new Error('Signature DER invalid');
            }
            const slen = getLength(data, p);
            if (data.length !== slen + p.place) {
                throw new Error('Invalid R-length in signature DER');
            }
            let s = data.slice(p.place, slen + p.place);
            if (r[0] === 0) {
                if ((r[1] & 0x80) !== 0) {
                    r = r.slice(1);
                }
                else {
                    throw new Error('Invalid R-value in signature DER');
                }
            }
            if (s[0] === 0) {
                if ((s[1] & 0x80) !== 0) {
                    s = s.slice(1);
                }
                else {
                    throw new Error('Invalid S-value in signature DER');
                }
            }
            return new Signature(new BigNumber(r), new BigNumber(s));
        }
        /**
         * Takes an array of numbers or a string and returns a new Signature instance.
         * This method will throw an error if the Compact encoding is invalid.
         * If a string is provided, it is assumed to represent a hexadecimal sequence.
         * compactByte value 27-30 means uncompressed public key.
         * 31-34 means compressed public key.
         * The range represents the recovery param which can be 0,1,2,3.
         * We could support recovery functions in future if there's demand.
         *
         * @static
         * @method fromCompact
         * @param data - The sequence to decode from Compact encoding.
         * @param enc - The encoding of the data string.
         * @returns The decoded data in the form of Signature instance.
         *
         * @example
         * const signature = Signature.fromCompact('1b18c1f5502f8...', 'hex');
         */
        static fromCompact(data, enc) {
            data = toArray$2(data, enc);
            if (data.length !== 65) {
                throw new Error('Invalid Compact Signature');
            }
            const compactByte = data[0];
            if (compactByte < 27 || compactByte >= 35) {
                throw new Error('Invalid Compact Byte');
            }
            return new Signature(new BigNumber(data.slice(1, 33)), new BigNumber(data.slice(33, 65)));
        }
        /**
         * Creates an instance of the Signature class.
         *
         * @constructor
         * @param r - The R component of the signature.
         * @param s - The S component of the signature.
         *
         * @example
         * const r = new BigNumber('208755674028...');
         * const s = new BigNumber('564745627577...');
         * const signature = new Signature(r, s);
         */
        constructor(r, s) {
            this.r = r;
            this.s = s;
        }
        /**
         * Verifies a digital signature.
         *
         * This method will return true if the signature, key, and message hash match.
         * If the data or key do not match the signature, the function returns false.
         *
         * @method verify
         * @param msg - The message to verify.
         * @param key - The public key used to sign the original message.
         * @param enc - The encoding of the msg string.
         * @returns A boolean representing whether the signature is valid.
         *
         * @example
         * const msg = 'The quick brown fox jumps over the lazy dog';
         * const publicKey = PublicKey.fromString('04188ca1050...');
         * const isVerified = signature.verify(msg, publicKey);
         */
        verify(msg, key, enc) {
            const msgHash = new BigNumber(sha256(msg, enc), 16);
            return verify$1(msgHash, this, key);
        }
        /**
         * Converts an instance of Signature into DER encoding.
         * An alias for the toDER method.
         *
         * If the encoding parameter is set to 'hex', the function will return a hex string.
         * If 'base64', it will return a base64 string.
         * Otherwise, it will return an array of numbers.
         *
         * @method toDER
         * @param enc - The encoding to use for the output.
         * @returns The current instance in DER encoding.
         *
         * @example
         * const der = signature.toString('base64');
         */
        toString(enc) {
            return this.toDER(enc);
        }
        /**
         * Converts an instance of Signature into DER encoding.
         *
         * If the encoding parameter is set to 'hex', the function will return a hex string.
         * If 'base64', it will return a base64 string.
         * Otherwise, it will return an array of numbers.
         *
         * @method toDER
         * @param enc - The encoding to use for the output.
         * @returns The current instance in DER encoding.
         *
         * @example
         * const der = signature.toDER('hex');
         */
        toDER(enc) {
            const constructLength = (arr, len) => {
                if (len < 0x80) {
                    arr.push(len);
                }
                else {
                    throw new Error('len must be < 0x80');
                }
            };
            const rmPadding = (buf) => {
                let i = 0;
                const len = buf.length - 1;
                while ((buf[i] === 0) && ((buf[i + 1] & 0x80) === 0) && i < len) {
                    i++;
                }
                if (i === 0) {
                    return buf;
                }
                return buf.slice(i);
            };
            let r = this.r.toArray();
            let s = this.s.toArray();
            // Pad values
            if ((r[0] & 0x80) !== 0) {
                r = [0].concat(r);
            }
            // Pad values
            if ((s[0] & 0x80) !== 0) {
                s = [0].concat(s);
            }
            r = rmPadding(r);
            s = rmPadding(s);
            while ((s[0] === 0) && (s[1] & 0x80) === 0) {
                s = s.slice(1);
            }
            let arr = [0x02];
            constructLength(arr, r.length);
            arr = arr.concat(r);
            arr.push(0x02);
            constructLength(arr, s.length);
            const backHalf = arr.concat(s);
            let res = [0x30];
            constructLength(res, backHalf.length);
            res = res.concat(backHalf);
            if (enc === 'hex') {
                return toHex$3(res);
            }
            else if (enc === 'base64') {
                return toBase64$2(res);
            }
            else {
                return res;
            }
        }
        /**
         * Converts an instance of Signature into Compact encoding.
         *
         * If the encoding parameter is set to 'hex', the function will return a hex string.
         * If 'base64', it will return a base64 string.
         * Otherwise, it will return an array of numbers.
         *
         * @method toCompact
         * @param enc - The encoding to use for the output.
         * @returns The current instance in DER encoding.
         *
         * @example
         * const compact = signature.toCompact(3, true, 'base64');
         */
        toCompact(recovery, compressed, enc) {
            if (recovery < 0 || recovery > 3)
                throw new Error('Invalid recovery param');
            if (typeof compressed !== 'boolean')
                throw new Error('Invalid compressed param');
            let compactByte = 27 + recovery;
            if (compressed) {
                compactByte += 4;
            }
            let arr = [compactByte];
            arr = arr.concat(this.r.toArray('be', 32));
            arr = arr.concat(this.s.toArray('be', 32));
            if (enc === 'hex') {
                return toHex$3(arr);
            }
            else if (enc === 'base64') {
                return toBase64$2(arr);
            }
            else {
                return arr;
            }
        }
        /**
         * Recovers the public key from a signature.
         * This method will return the public key if it finds a valid public key.
         * If it does not find a valid public key, it will throw an error.
         * The recovery factor is a number between 0 and 3.
         * @method RecoverPublicKey
         * @param recovery - The recovery factor.
         * @param e - The message hash.
         * @returns The public key associated with the signature.
         *
         * @example
         * const publicKey = signature.RecoverPublicKey(0, msgHash);
         */
        RecoverPublicKey(recovery, e) {
            const r = this.r;
            const s = this.s;
            // A set LSB signifies that the y-coordinate is odd
            const isYOdd = !!(recovery & 1);
            // The more significant bit specifies whether we should use the
            // first or second candidate key.
            const isSecondKey = recovery >> 1;
            const curve = new Curve();
            const n = curve.n;
            const G = curve.g;
            // 1.1 LEt x = r + jn
            const x = isSecondKey ? r.add(n) : r;
            const R = Point.fromX(x, isYOdd);
            // 1.4 Check that nR is at infinity
            const nR = R.mul(n);
            if (!nR.isInfinity()) {
                throw new Error('nR is not at infinity');
            }
            // Compute -e from e
            const eNeg = e.neg().umod(n);
            // 1.6.1 Compute Q = r^-1 (sR - eG)
            // Q = r^-1 (sR + -eG)
            const rInv = r.invm(n);
            // const Q = R.multiplyTwo(s, G, eNeg).mul(rInv)
            const srInv = rInv.mul(s).umod(n);
            const eInvrInv = rInv.mul(eNeg).umod(n);
            const Q = G.mul(eInvrInv).add(R.mul(srInv));
            const pubKey = new PublicKey(Q);
            pubKey.validate();
            return pubKey;
        }
        /**
         * Calculates the recovery factor which will work for a particular public key and message hash.
         * This method will return the recovery factor if it finds a valid recovery factor.
         * If it does not find a valid recovery factor, it will throw an error.
         * The recovery factor is a number between 0 and 3.
         *
         * @method CalculateRecoveryFactor
         * @param msgHash - The message hash.
         * @returns the recovery factor: number
         * /
         * @example
         * const recovery = signature.CalculateRecoveryFactor(publicKey, msgHash);
         */
        CalculateRecoveryFactor(pubkey, msgHash) {
            for (let recovery = 0; recovery < 4; recovery++) {
                let Qprime;
                try {
                    Qprime = this.RecoverPublicKey(recovery, msgHash);
                }
                catch (e) {
                    continue;
                }
                if (pubkey.eq(Qprime)) {
                    return recovery;
                }
            }
            throw new Error('Unable to find valid recovery factor');
        }
    }

    /**
     * This class behaves as a HMAC-based deterministic random bit generator (DRBG). It implements a deterministic random number generator using SHA256HMAC HASH function. It takes an initial entropy and nonce when instantiated for seeding purpose.
     * @class DRBG
     *
     * @constructor
     * @param entropy - Initial entropy either in number array or hexadecimal string.
     * @param nonce - Initial nonce either in number array or hexadecimal string.
     *
     * @throws Throws an error message 'Not enough entropy. Minimum is 256 bits' when entropy's length is less than 32.
     *
     * @example
     * const drbg = new DRBG('af12de...', '123ef...');
     */
    class DRBG {
        K;
        V;
        constructor(entropy, nonce) {
            entropy = toArray$2(entropy, 'hex');
            nonce = toArray$2(nonce, 'hex');
            if (entropy.length < 32) {
                throw new Error('Not enough entropy. Minimum is 256 bits');
            }
            const seed = entropy.concat(nonce);
            this.K = new Array(32);
            this.V = new Array(32);
            for (let i = 0; i < 32; i++) {
                this.K[i] = 0x00;
                this.V[i] = 0x01;
            }
            this.update(seed);
        }
        /**
         * Generates HMAC using the K value of the instance. This method is used internally for operations.
         *
         * @method hmac
         * @returns The SHA256HMAC object created with K value.
         *
         * @example
         * const hmac = drbg.hmac();
         */
        hmac() {
            return new SHA256HMAC(this.K);
        }
        /**
         * Updates the `K` and `V` values of the instance based on the seed.
         * The seed if not provided uses `V` as seed.
         *
         * @method update
         * @param seed - an optional value that used to update `K` and `V`. Default is `undefined`.
         * @returns Nothing, but updates the internal state `K` and `V` value.
         *
         * @example
         * drbg.update('e13af...');
         */
        update(seed) {
            let kmac = this.hmac()
                .update(this.V)
                .update([0x00]);
            if (seed !== undefined) {
                kmac = kmac.update(seed);
            }
            this.K = kmac.digest();
            this.V = this.hmac().update(this.V).digest();
            if (seed === undefined) {
                return;
            }
            this.K = this.hmac()
                .update(this.V)
                .update([0x01])
                .update(seed)
                .digest();
            this.V = this.hmac().update(this.V).digest();
        }
        /**
         * Generates deterministic random hexadecimal string of given length.
         * In every generation process, it also updates the internal state `K` and `V`.
         *
         * @method generate
         * @param len - The length of required random number.
         * @returns The required deterministic random hexadecimal string.
         *
         * @example
         * const randomHex = drbg.generate(256);
         */
        generate(len) {
            let temp = [];
            while (temp.length < len) {
                this.V = this.hmac().update(this.V).digest();
                temp = temp.concat(this.V);
            }
            const res = temp.slice(0, len);
            this.update();
            return toHex$3(res);
        }
    }

    /**
     * Truncates a BigNumber message to the length of the curve order n, in the context of the Elliptic Curve Digital Signature Algorithm (ECDSA).
     * This method is used as part of ECDSA signing and verification.
     *
     * The method calculates `delta`, which is a difference obtained by subtracting the bit length of the curve order `n` from the byte length of the message in bits.
     * If `delta` is greater than zero, logical shifts msg to the right by `delta`, retaining the sign.
     *
     * Another condition is tested, but only if `truncOnly` is false. This condition compares the value of msg to curve order `n`.
     * If msg is greater or equal to `n`, it is decreased by `n` and returned.
     *
     * @method truncateToN
     * @param msg - The BigNumber message to be truncated.
     * @param truncOnly - An optional boolean parameter that if set to true, the method will only perform truncation of the BigNumber without doing the additional subtraction from the curve order.
     * @returns Returns the truncated BigNumber value, potentially subtracted by the curve order n.
     *
     * @example
     * let msg = new BigNumber('1234567890abcdef', 16);
     * let truncatedMsg = truncateToN(msg);
     */
    function truncateToN(msg, truncOnly) {
        const curve = new Curve();
        const delta = msg.byteLength() * 8 - curve.n.bitLength();
        if (delta > 0) {
            msg = msg.ushrn(delta);
        }
        if (!truncOnly && msg.cmp(curve.n) >= 0) {
            return msg.sub(curve.n);
        }
        else {
            return msg;
        }
    }
    /**
     * Generates a digital signature for a given message.
     *
     * @function sign
     * @param msg - The BigNumber message for which the signature has to be computed.
     * @param key - Private key in BigNumber.
     * @param forceLowS - Optional boolean flag if True forces "s" to be the lower of two possible values.
     * @param customK - Optional specification for k value, which can be a function or BigNumber.
     * @returns Returns the elliptic curve digital signature of the message.
     *
     * @example
     * const msg = new BigNumber('2664878')
     * const key = new BigNumber('123456')
     * const signature = sign(msg, key)
     */
    const sign$2 = (msg, key, forceLowS = false, customK) => {
        const curve = new Curve();
        msg = truncateToN(msg);
        // Zero-extend key to provide enough entropy
        const bytes = curve.n.byteLength();
        const bkey = key.toArray('be', bytes);
        // Zero-extend nonce to have the same byte size as N
        const nonce = msg.toArray('be', bytes);
        // Instantiate Hmac_DRBG
        const drbg = new DRBG(bkey, nonce);
        // Number of bytes to generate
        const ns1 = curve.n.subn(1);
        for (let iter = 0;; iter++) {
            // Compute the k-value
            let k = typeof customK === 'function'
                ? customK(iter)
                : BigNumber.isBN(customK)
                    ? customK
                    : new BigNumber(drbg.generate(bytes), 16);
            k = truncateToN(k, true);
            if (k.cmpn(1) <= 0 || k.cmp(ns1) >= 0) {
                if (BigNumber.isBN(customK)) {
                    throw new Error('Invalid fixed custom K value (must be more than 1 and less than N-1)');
                }
                else {
                    continue;
                }
            }
            const kp = curve.g.mul(k);
            if (kp.isInfinity()) {
                if (BigNumber.isBN(customK)) {
                    throw new Error('Invalid fixed custom K value (must not create a point at infinity when multiplied by the generator point)');
                }
                else {
                    continue;
                }
            }
            const kpX = kp.getX();
            const r = kpX.umod(curve.n);
            if (r.cmpn(0) === 0) {
                if (BigNumber.isBN(customK)) {
                    throw new Error('Invalid fixed custom K value (when multiplied by G, the resulting x coordinate mod N must not be zero)');
                }
                else {
                    continue;
                }
            }
            let s = k.invm(curve.n).mul(r.mul(key).iadd(msg));
            s = s.umod(curve.n);
            if (s.cmpn(0) === 0) {
                if (BigNumber.isBN(customK)) {
                    throw new Error('Invalid fixed custom K value (when used with the key, it cannot create a zero value for S)');
                }
                else {
                    continue;
                }
            }
            // Use complement of `s`, if it is > `n / 2`
            if (forceLowS && s.cmp(curve.n.ushrn(1)) > 0) {
                s = curve.n.sub(s);
            }
            return new Signature(r, s);
        }
    };
    /**
     * Verifies a digital signature of a given message.
     *
     * Message and key used during the signature generation process, and the previously computed signature
     * are used to validate the authenticity of the digital signature.
     *
     * @function verify
     * @param msg - The BigNumber message for which the signature has to be verified.
     * @param sig - Signature object consisting of parameters 'r' and 's'.
     * @param key - Public key in Point.
     * @returns Returns true if the signature is valid and false otherwise.
     *
     * @example
     * const msg = new BigNumber('2664878', 16)
     * const key = new Point(new BigNumber(10), new BigNumber(20)
     * const signature = sign(msg, new BigNumber('123456'))
     * const isVerified = verify(msg, sig, key)
     */
    const verify$1 = (msg, sig, key) => {
        const curve = new Curve();
        msg = truncateToN(msg);
        // Perform primitive values validation
        const r = sig.r;
        const s = sig.s;
        if (r.cmpn(1) < 0 || r.cmp(curve.n) >= 0) {
            return false;
        }
        if (s.cmpn(1) < 0 || s.cmp(curve.n) >= 0) {
            return false;
        }
        // Validate signature
        const sinv = s.invm(curve.n);
        const u1 = sinv.mul(msg).umod(curve.n);
        const u2 = sinv.mul(r).umod(curve.n);
        // NOTE: Greg Maxwell's trick, inspired by:
        // https://git.io/vad3K
        const p = curve.g.jmulAdd(u1, key, u2);
        if (p.isInfinity()) {
            return false;
        }
        // Compare `p.x` of Jacobian point with `r`,
        // this will do `p.x == r * p.z^2` instead of multiplying `p.x` by the
        // inverse of `p.z^2`
        return p.eqXToP(r);
    };

    /**
     * The PublicKey class extends the Point class. It is used in public-key cryptography to derive shared secret, verify message signatures, and encode the public key in the DER format.
     * The class comes with static methods to generate PublicKey instances from private keys or from strings.
     *
     * @extends {Point}
     * @see {@link Point} for more information on Point.
     */
    class PublicKey extends Point {
        /**
         * Static factory method to derive a public key from a private key.
         * It multiplies the generator point 'g' on the elliptic curve by the private key.
         *
         * @static
         * @method fromPrivateKey
         *
         * @param key - The private key from which to derive the public key.
         *
         * @returns Returns the PublicKey derived from the given PrivateKey.
         *
         * @example
         * const myPrivKey = new PrivateKey(...)
         * const myPubKey = PublicKey.fromPrivateKey(myPrivKey)
         */
        static fromPrivateKey(key) {
            const c = new Curve();
            const p = c.g.mul(key);
            return new PublicKey(p.x, p.y);
        }
        /**
         * Static factory method to create a PublicKey instance from a string.
         *
         * @param str - A string representing a public key.
         *
         * @returns Returns the PublicKey created from the string.
         *
         * @example
         * const myPubKey = PublicKey.fromString("03....")
         */
        static fromString(str) {
            const p = Point.fromString(str);
            return new PublicKey(p.x, p.y);
        }
        /**
         * Static factory method to create a PublicKey instance from a number array.
         *
         * @param bytes - A number array representing a public key.
         *
         * @returns Returns the PublicKey created from the number array.
         *
         * @example
         * const myPubKey = PublicKey.fromString("03....")
         */
        static fromDER(bytes) {
            const p = Point.fromDER(bytes);
            return new PublicKey(p.x, p.y);
        }
        /**
         * @constructor
         * @param x - A point or the x-coordinate of the point. May be a number, a BigNumber, a string (which will be interpreted as hex), a number array, or null. If null, an "Infinity" point is constructed.
         * @param y - If x is not a point, the y-coordinate of the point, similar to x.
         * @param isRed - A boolean indicating if the point is a member of the field of integers modulo the k256 prime. Default is true.
         *
         * @example
         * new PublicKey(point1);
         * new PublicKey('abc123', 'def456');
         */
        constructor(x, y = null, isRed = true) {
            if (x instanceof Point) {
                super(x.getX(), x.getY());
            }
            else {
                super(x, y, isRed);
            }
        }
        /**
         * Derive a shared secret from a public key and a private key for use in symmetric encryption.
         * This method multiplies the public key (an instance of Point) with a private key.
         *
         * @param priv - The private key to use in deriving the shared secret.
         *
         * @returns Returns the Point representing the shared secret.
         *
         * @throws Will throw an error if the public key is not valid for ECDH secret derivation.
         *
         * @example
         * const myPrivKey = new PrivateKey(...)
         * const sharedSecret = myPubKey.deriveSharedSecret(myPrivKey)
         */
        deriveSharedSecret(priv) {
            if (!this.validate()) {
                throw new Error('Public key not valid for ECDH secret derivation');
            }
            return this.mul(priv);
        }
        /**
         * Verify a signature of a message using this public key.
         *
         * @param msg - The message to verify. It can be a string or an array of numbers.
         * @param sig - The Signature of the message that needs verification.
         * @param enc - The encoding of the message. It defaults to 'utf8'.
         *
         * @returns Returns true if the signature is verified successfully, otherwise false.
         *
         * @example
         * const myMessage = "Hello, world!"
         * const mySignature = new Signature(...)
         * const isVerified = myPubKey.verify(myMessage, mySignature)
         */
        verify(msg, sig, enc) {
            const msgHash = new BigNumber(sha256(msg, enc), 16);
            return verify$1(msgHash, sig, this);
        }
        /**
         * Encode the public key to DER (Distinguished Encoding Rules) format.
         *
         * @returns Returns the DER-encoded public key in number array or string.
         *
         * @param enc - The encoding of the DER string. undefined = number array, 'hex' = hex string.
         *
         * @example
         * const derPublicKey = myPubKey.toDER()
         */
        toDER(enc) {
            if (enc === 'hex')
                return this.encode(true, enc);
            return this.encode(true);
        }
        /**
         * Hash sha256 and ripemd160 of the public key.
         *
         * @returns Returns the hash of the public key.
         *
         * @example
         * const publicKeyHash = pubkey.toHash()
         */
        toHash(enc) {
            const pkh = hash160(this.encode(true));
            if (enc === 'hex') {
                return toHex$3(pkh);
            }
            return pkh;
        }
        /**
         * Base58Check encodes the hash of the public key with a prefix to indicate locking script type.
         * Defaults to P2PKH for mainnet, otherwise known as a "Bitcoin Address".
         *
         * @param prefix defaults to [0x00] for mainnet, set to [0x6f] for testnet or use the strings 'mainnet' or 'testnet'
         *
         * @returns Returns the address encoding associated with the hash of the public key.
         *
         * @example
         * const address = pubkey.toAddress()
         * const address = pubkey.toAddress('mainnet')
         * const testnetAddress = pubkey.toAddress([0x6f])
         * const testnetAddress = pubkey.toAddress('testnet')
         */
        toAddress(prefix = [0x00]) {
            if (typeof prefix === 'string') {
                if (prefix === 'testnet' || prefix === 'test') {
                    prefix = [0x6f];
                }
                else if (prefix === 'mainnet' || prefix === 'main') {
                    prefix = [0x00];
                }
                else {
                    throw new Error(`Invalid prefix ${prefix}`);
                }
            }
            return toBase58Check(this.toHash(), prefix);
        }
        /**
         * Derives a child key with BRC-42.
         * @param privateKey The private key of the other party
         * @param invoiceNumber The invoice number used to derive the child key
         * @returns The derived child key.
         */
        deriveChild(privateKey, invoiceNumber) {
            const sharedSecret = this.deriveSharedSecret(privateKey);
            const invoiceNumberBin = toArray$2(invoiceNumber, 'utf8');
            const hmac = sha256hmac(sharedSecret.encode(true), invoiceNumberBin);
            const curve = new Curve();
            const point = curve.g.mul(new BigNumber(hmac));
            const finalPoint = this.add(point);
            return new PublicKey(finalPoint.x, finalPoint.y);
        }
        /**
         * Takes an array of numbers or a string and returns a new PublicKey instance.
         * This method will throw an error if the Compact encoding is invalid.
         * If a string is provided, it is assumed to represent a hexadecimal sequence.
         * compactByte value 27-30 means uncompressed public key.
         * 31-34 means compressed public key.
         * The range represents the recovery param which can be 0,1,2,3.
         *
         * @static
         * @method fromMsgHashAndCompactSignature
         * @param msgHash - The message hash which was signed.
         * @param signature - The signature in compact format.
         * @param enc - The encoding of the signature string.
         * @returns A PublicKey instance derived from the message hash and compact signature.
         * @example
         * const publicKey = Signature.fromMsgHashAndCompactSignature(msgHash, 'IMOl2mVKfDgsSsHT4uIYBNN4e...', 'base64');
         */
        static fromMsgHashAndCompactSignature(msgHash, signature, enc) {
            const data = toArray$2(signature, enc);
            if (data.length !== 65) {
                throw new Error('Invalid Compact Signature');
            }
            const compactByte = data[0];
            if (compactByte < 27 || compactByte >= 35) {
                throw new Error('Invalid Compact Byte');
            }
            let r = data[0] - 27;
            if (r > 3) {
                r -= 4;
            }
            const s = new Signature(new BigNumber(data.slice(1, 33)), new BigNumber(data.slice(33, 65)));
            return s.RecoverPublicKey(r, msgHash);
        }
    }

    class Rand {
        _rand;
        constructor() {
            const noRand = () => {
                throw new Error('No secure random number generator is available in this environment.');
            };
            if (typeof self === 'object') {
                /* eslint-disable-next-line */
                if (self.crypto && self.crypto.getRandomValues) {
                    this._rand = n => {
                        const arr = new Uint8Array(n);
                        /* eslint-disable-next-line */
                        self.crypto.getRandomValues(arr);
                        return [...arr];
                    };
                }
                else /* if (typeof window === 'object') */ {
                    this._rand = noRand;
                }
            }
            else {
                try {
                    /* eslint-disable-next-line */
                    const crypto = require('crypto');
                    if (typeof crypto.randomBytes === 'function') {
                        this._rand = n => [...crypto.randomBytes(n)];
                    }
                }
                catch (e) {
                    this._rand = noRand;
                }
            }
        }
        generate(len) {
            return this._rand(len);
        }
    }
    let ayn = null;
    /**
     * Generates a sequence of pseudo-random bytes with the given length.
     *
     * @param len - The number of bytes to generate
     *
     * @returns The generated bytes
     *
     * @example
     * import Random from '@bsv/sdk/primitives/Random'
     * const bytes = Random(32) // Produces 32 random bytes
     */
    var Random = (len) => {
        if (ayn == null) {
            ayn = new Rand();
        }
        return ayn.generate(len);
    };

    class PointInFiniteField {
        x;
        y;
        constructor(x, y) {
            const P = new Curve().p; // arithmetic is mod P
            this.x = x.umod(P);
            this.y = y.umod(P);
        }
        toString() {
            return toBase58$1(this.x.toArray()) + '.' + toBase58$1(this.y.toArray());
        }
        static fromString(str) {
            const [x, y] = str.split('.');
            return new PointInFiniteField(new BigNumber(fromBase58(x)), new BigNumber(fromBase58(y)));
        }
    }
    /**
     * Polynomial class
     *
     * This class is used to create a polynomial with a given threshold and a private key.
     * The polynomial is used to create shares of the private key.
     *
     * @param key - The private key to split
     * @param threshold - The number of shares required to recombine the private key
     *
     * @example
     * const key = new PrivateKey()
     * const threshold = 2
     * const polynomial = new Polynomial(key, threshold)
     *
     */
    class Polynomial {
        points;
        threshold;
        constructor(points, threshold) {
            this.points = points;
            this.threshold = threshold || points.length;
        }
        static fromPrivateKey(key, threshold) {
            const P = new Curve().p; // arithmetic is mod P
            // The key is the y-intercept of the polynomial where x=0.
            const points = [new PointInFiniteField(new BigNumber(0), new BigNumber(key.toArray()))];
            // The other values are random
            for (let i = 1; i < threshold; i++) {
                const randomX = new BigNumber(Random(32)).umod(P);
                const randomY = new BigNumber(Random(32)).umod(P);
                points.push(new PointInFiniteField(randomX, randomY));
            }
            return new Polynomial(points);
        }
        // Evaluate the polynomial at x by using Lagrange interpolation
        valueAt(x) {
            const P = new Curve().p; // arithmetic is mod P
            let y = new BigNumber(0);
            for (let i = 0; i < this.threshold; i++) {
                let term = this.points[i].y;
                for (let j = 0; j < this.threshold; j++) {
                    if (i !== j) {
                        const xj = this.points[j].x;
                        const xi = this.points[i].x;
                        const numerator = x.sub(xj).umod(P);
                        const denominator = xi.sub(xj).umod(P);
                        const denominatorInverse = denominator.invm(P);
                        const fraction = numerator.mul(denominatorInverse).umod(P);
                        term = term.mul(fraction).umod(P);
                    }
                }
                y = y.add(term).umod(P);
            }
            return y;
        }
    }

    /**
     * @class KeyShares
     *
     * This class is used to store the shares of a private key.
     *
     * @param shares - An array of shares
     * @param threshold - The number of shares required to recombine the private key
     *
     * @returns KeyShares
     *
     * @example
     * const key = PrivateKey.fromShares(shares)
     *
     */
    class KeyShares {
        points;
        threshold;
        integrity;
        constructor(points, threshold, integrity) {
            this.points = points;
            this.threshold = threshold;
            this.integrity = integrity;
        }
        static fromBackupFormat(shares) {
            let threshold = 0;
            let integrity = '';
            const points = shares.map((share, idx) => {
                const shareParts = share.split('.');
                if (shareParts.length !== 4)
                    throw Error('Invalid share format in share ' + idx + '. Expected format: "x.y.t.i" - received ' + share);
                const [x, y, t, i] = shareParts;
                if (!t)
                    throw Error('Threshold not found in share ' + idx);
                if (!i)
                    throw Error('Integrity not found in share ' + idx);
                const tInt = parseInt(t);
                if (idx !== 0 && threshold !== tInt)
                    throw Error('Threshold mismatch in share ' + idx);
                if (idx !== 0 && integrity !== i)
                    throw Error('Integrity mismatch in share ' + idx);
                threshold = tInt;
                integrity = i;
                return PointInFiniteField.fromString([x, y].join('.'));
            });
            return new KeyShares(points, threshold, integrity);
        }
        toBackupFormat() {
            return this.points.map(share => share.toString() + '.' + this.threshold + '.' + this.integrity);
        }
    }
    /**
     * Represents a Private Key, which is a secret that can be used to generate signatures in a cryptographic system.
     *
     * The `PrivateKey` class extends from the `BigNumber` class. It offers methods to create signatures, verify them,
     * create a corresponding public key and derive a shared secret from a public key.
     *
     * @extends {BigNumber}
     * @see {@link BigNumber} for more information on BigNumber.
     */
    class PrivateKey extends BigNumber {
        /**
         * Generates a private key randomly.
         *
         * @method fromRandom
         * @static
         * @returns The newly generated Private Key.
         *
         * @example
         * const privateKey = PrivateKey.fromRandom();
         */
        static fromRandom() {
            return new PrivateKey(Random(32));
        }
        /**
         * Generates a private key from a string.
         *
         * @method fromString
         * @static
         * @param str - The string to generate the private key from.
         * @param base - The base of the string.
         * @returns The generated Private Key.
         * @throws Will throw an error if the string is not valid.
         **/
        static fromString(str, base) {
            return new PrivateKey(BigNumber.fromString(str, base).toArray());
        }
        /**
         * Generates a private key from a WIF (Wallet Import Format) string.
         *
         * @method fromWif
         * @static
         * @param wif - The WIF string to generate the private key from.
         * @param base - The base of the string.
         * @returns The generated Private Key.
         * @throws Will throw an error if the string is not a valid WIF.
         **/
        static fromWif(wif, prefixLength = 1) {
            const decoded = fromBase58Check(wif, null, prefixLength);
            if (decoded.data.length !== 33) {
                throw new Error('Invalid WIF length');
            }
            if (decoded.data[32] !== 1) {
                throw new Error('Invalid WIF padding');
            }
            return new PrivateKey(decoded.data.slice(0, 32));
        }
        /**
         * @constructor
         *
         * @param number - The number (various types accepted) to construct a BigNumber from. Default is 0.
         *
         * @param base - The base of number provided. By default is 10. Ignored if number is BigNumber.
         *
         * @param endian - The endianness provided. By default is 'big endian'. Ignored if number is BigNumber.
         *
         * @param modN - Optional. Default 'apply. If 'apply', apply modN to input to guarantee a valid PrivateKey. If 'error', if input is out of field throw Error('Input is out of field'). If 'nocheck', assumes input is in field.
         *
         * @example
         * import PrivateKey from './PrivateKey';
         * import BigNumber from './BigNumber';
         * const privKey = new PrivateKey(new BigNumber('123456', 10, 'be'));
         */
        constructor(number = 0, base = 10, endian = 'be', modN = 'apply') {
            if (number instanceof BigNumber) {
                super();
                number.copy(this);
            }
            else {
                super(number, base, endian);
            }
            if (modN !== 'nocheck') {
                const check = this.checkInField();
                if (!check.inField) {
                    if (modN === 'error') {
                        throw new Error('Input is out of field');
                    }
                    // Force the PrivateKey BigNumber value to lie in the field limited by curve.n
                    BigNumber.move(this, check.modN);
                }
            }
        }
        /**
         * A utility function to check that the value of this PrivateKey lies in the field limited by curve.n
         * @returns { inField, modN } where modN is this PrivateKey's current BigNumber value mod curve.n, and inField is true only if modN equals current BigNumber value.
         */
        checkInField() {
            const curve = new Curve();
            const modN = this.mod(curve.n);
            const inField = this.cmp(modN) === 0;
            return { inField, modN };
        }
        /**
         * @returns true if the PrivateKey's current BigNumber value lies in the field limited by curve.n
         */
        isValid() {
            return this.checkInField().inField;
        }
        /**
         * Signs a message using the private key.
         *
         * @method sign
         * @param msg - The message (array of numbers or string) to be signed.
         * @param enc - If 'hex' the string will be treated as hex, utf8 otherwise.
         * @param forceLowS - If true (the default), the signature will be forced to have a low S value.
         * @param customK — If provided, uses a custom K-value for the signature. Provie a function that returns a BigNumber, or the BigNumber itself.
         * @returns A digital signature generated from the hash of the message and the private key.
         *
         * @example
         * const privateKey = PrivateKey.fromRandom();
         * const signature = privateKey.sign('Hello, World!');
         */
        sign(msg, enc, forceLowS = true, customK) {
            const msgHash = new BigNumber(sha256(msg, enc), 16);
            return sign$2(msgHash, this, forceLowS, customK);
        }
        /**
         * Verifies a message's signature using the public key associated with this private key.
         *
         * @method verify
         * @param msg - The original message which has been signed.
         * @param sig - The signature to be verified.
         * @param enc - The data encoding method.
         * @returns Whether or not the signature is valid.
         *
         * @example
         * const privateKey = PrivateKey.fromRandom();
         * const signature = privateKey.sign('Hello, World!');
         * const isSignatureValid = privateKey.verify('Hello, World!', signature);
         */
        verify(msg, sig, enc) {
            const msgHash = new BigNumber(sha256(msg, enc), 16);
            return verify$1(msgHash, sig, this.toPublicKey());
        }
        /**
         * Converts the private key to its corresponding public key.
         *
         * The public key is generated by multiplying the base point G of the curve and the private key.
         *
         * @method toPublicKey
         * @returns The generated PublicKey.
         *
         * @example
         * const privateKey = PrivateKey.fromRandom();
         * const publicKey = privateKey.toPublicKey();
         */
        toPublicKey() {
            const c = new Curve();
            const p = c.g.mul(this);
            return new PublicKey(p.x, p.y);
        }
        /**
         * Converts the private key to a Wallet Import Format (WIF) string.
         *
         * Base58Check encoding is used for encoding the private key.
         * The prefix
         *
         * @method toWif
         * @returns The WIF string.
         *
         * @param prefix defaults to [0x80] for mainnet, set it to [0xef] for testnet.
         *
         * @throws Error('Value is out of field') if current BigNumber value is out of field limited by curve.n
         *
         * @example
         * const privateKey = PrivateKey.fromRandom();
         * const wif = privateKey.toWif();
         * const testnetWif = privateKey.toWif([0xef]);
         */
        toWif(prefix = [0x80]) {
            if (!this.isValid()) {
                throw new Error('Value is out of field');
            }
            return toBase58Check([...this.toArray('be', 32), 1], prefix);
        }
        /**
         * Base58Check encodes the hash of the public key associated with this private key with a prefix to indicate locking script type.
         * Defaults to P2PKH for mainnet, otherwise known as a "Bitcoin Address".
         *
         * @param prefix defaults to [0x00] for mainnet, set to [0x6f] for testnet or use the strings 'testnet' or 'mainnet'
         *
         * @returns Returns the address encoding associated with the hash of the public key associated with this private key.
         *
         * @example
         * const address = privkey.toAddress()
         * const address = privkey.toAddress('mainnet')
         * const testnetAddress = privkey.toAddress([0x6f])
         * const testnetAddress = privkey.toAddress('testnet')
         */
        toAddress(prefix = [0x00]) {
            return this.toPublicKey().toAddress(prefix);
        }
        /**
         * Derives a shared secret from the public key.
         *
         * @method deriveSharedSecret
         * @param key - The public key to derive the shared secret from.
         * @returns The derived shared secret (a point on the curve).
         * @throws Will throw an error if the public key is not valid.
         *
         * @example
         * const privateKey = PrivateKey.fromRandom();
         * const publicKey = privateKey.toPublicKey();
         * const sharedSecret = privateKey.deriveSharedSecret(publicKey);
         */
        deriveSharedSecret(key) {
            if (!key.validate()) {
                throw new Error('Public key not valid for ECDH secret derivation');
            }
            return key.mul(this);
        }
        /**
         * Derives a child key with BRC-42.
         * @param publicKey The public key of the other party
         * @param invoiceNumber The invoice number used to derive the child key
         * @returns The derived child key.
         */
        deriveChild(publicKey, invoiceNumber) {
            const sharedSecret = this.deriveSharedSecret(publicKey);
            const invoiceNumberBin = toArray$2(invoiceNumber, 'utf8');
            const hmac = sha256hmac(sharedSecret.encode(true), invoiceNumberBin);
            const curve = new Curve();
            return new PrivateKey(this.add(new BigNumber(hmac)).mod(curve.n).toArray());
        }
        /**
         * Splits the private key into shares using Shamir's Secret Sharing Scheme.
         *
         * @param threshold The minimum number of shares required to reconstruct the private key.
         * @param totalShares The total number of shares to generate.
         * @param prime The prime number to be used in Shamir's Secret Sharing Scheme.
         * @returns An array of shares.
         *
         * @example
         * const key = PrivateKey.fromRandom()
         * const shares = key.toKeyShares(2, 5)
         */
        toKeyShares(threshold, totalShares) {
            if (typeof threshold !== 'number' || typeof totalShares !== 'number')
                throw new Error('threshold and totalShares must be numbers');
            if (threshold < 2)
                throw new Error('threshold must be at least 2');
            if (totalShares < 2)
                throw new Error('totalShares must be at least 2');
            if (threshold > totalShares)
                throw new Error('threshold should be less than or equal to totalShares');
            const poly = Polynomial.fromPrivateKey(this, threshold);
            const points = [];
            for (let i = 0; i < totalShares; i++) {
                const x = new BigNumber(PrivateKey.fromRandom().toArray());
                const y = poly.valueAt(x);
                points.push(new PointInFiniteField(x, y));
            }
            const integrity = this.toPublicKey().toHash('hex').slice(0, 8);
            return new KeyShares(points, threshold, integrity);
        }
        /**
         * @method toBackupShares
         *
         * Creates a backup of the private key by splitting it into shares.
         *
         *
         * @param threshold The number of shares which will be required to reconstruct the private key.
         * @param totalShares The number of shares to generate for distribution.
         * @returns
         */
        toBackupShares(threshold, totalShares) {
            return this.toKeyShares(threshold, totalShares).toBackupFormat();
        }
        /**
         *
         * @method fromBackupShares
         *
         * Creates a private key from backup shares.
         *
         * @param shares
         * @returns PrivateKey
         */
        static fromBackupShares(shares) {
            return PrivateKey.fromKeyShares(KeyShares.fromBackupFormat(shares));
        }
        /**
         * Combines shares to reconstruct the private key.
         *
         * @param shares An array of points (shares) to be used to reconstruct the private key.
         * @param threshold The minimum number of shares required to reconstruct the private key.
         *
         * @returns The reconstructed private key.
         *
         * @example
         * const share1 = '2NWeap6SDBTL5jVnvk9yUxyfLqNrDs2Bw85KNDfLJwRT.4yLtSm327NApsbuP7QXVW3CWDuBRgmS6rRiFkAkTukic'
         * const share2 = '7NbgGA8iAsxg2s6mBLkLFtGKQrnc4aCbooHJJV31cWs4.GUgXtudthawE3Eevc1waT3Atr1Ft7j1XxdUguVo3B7x3'
         * const reconstructedKey = PrivateKey.fromKeyShares({ shares: [share1, share2], threshold: 2, integrity: '23409547' })
         *
         **/
        static fromKeyShares(keyShares) {
            const { points, threshold, integrity } = keyShares;
            if (threshold < 2 || threshold > 99)
                throw new Error('threshold should be between 2 and 99');
            if (points.length < threshold)
                throw new Error(`At least ${threshold} shares are required to reconstruct the private key`);
            // check to see if two points have the same x value
            for (let i = 0; i < threshold; i++) {
                for (let j = i + 1; j < threshold; j++) {
                    if (points[i].x.eq(points[j].x)) {
                        throw new Error('Duplicate share detected, each must be unique.');
                    }
                }
            }
            const poly = new Polynomial(points, threshold);
            const privateKey = new PrivateKey(poly.valueAt(new BigNumber(0)).toArray());
            const integrityHash = privateKey.toPublicKey().toHash('hex').slice(0, 8);
            if (integrityHash !== integrity) {
                throw new Error('Integrity hash mismatch');
            }
            return privateKey;
        }
    }

    const createZeroBlock = function (length) {
        let i;
        const result = [];
        for (i = 0; i < length; i++) {
            result.push(0x00);
        }
        return result;
    };
    [0xe1].concat(createZeroBlock(15));

    const prefix = 'Bitcoin Signed Message:\n';
    /**
     * Generates a SHA256 double-hash of the prefixed message.
     * @deprecated Replaced by BRC-77 which uses a more secure and private method for message signing.
     * @param messageBuf The message buffer to be hashed.
     * @returns The double-hash of the prefixed message as a number array.
     */
    const magicHash = (messageBuf) => {
        const bw = new Writer();
        bw.writeVarIntNum(prefix.length);
        bw.write(toArray$2(prefix, 'utf8'));
        bw.writeVarIntNum(messageBuf.length);
        bw.write(messageBuf);
        const buf = bw.toArray();
        const hashBuf = hash256(buf);
        return hashBuf;
    };
    /**
     * Signs a BSM message using the given private key.
     * @deprecated Replaced by BRC-77 which employs BRC-42 key derivation and BRC-43 invoice numbers for enhanced security and privacy.
     * @param message The message to be signed as a number array.
     * @param privateKey The private key used for signing the message.
     * @returns The signature object.
     */
    const sign$1 = (message, privateKey) => {
        const hashBuf = magicHash(message);
        return sign$2(new BigNumber(hashBuf), privateKey, true);
    };
    /**
     * Verifies a BSM signed message using the given public key.
     * @deprecated Replaced by BRC-77 which provides privately-verifiable signatures and avoids key reuse.
     * @param message The message to be verified as a number array.
     * @param sig The signature object.
     * @param pubKey The public key for verification.
     * @returns True if the signature is valid, false otherwise.
     */
    const verify = (message, sig, pubKey) => {
        const hashBuf = magicHash(message);
        return verify$1(new BigNumber(hashBuf), sig, pubKey);
    };

    /**
     * @deprecated
     * The HD class implements the Bitcoin Improvement Proposal 32 (BIP32) hierarchical deterministic wallets.
     * It allows the generation of child keys from a master key, ensuring a tree-like structure of keys and addresses.
     * This class is deprecated due to the introduction of BRC-42, which offers an enhanced key derivation scheme.
     * BRC-42 uses invoice numbers for key derivation, improving privacy and scalability compared to BIP32.
     *
     * @class HD
     * @deprecated Replaced by BRC-42 which uses invoice numbers and supports private derivation.
     */
    class HD {
        versionBytesNum;
        depth;
        parentFingerPrint;
        childIndex;
        chainCode;
        privKey;
        pubKey;
        constants = {
            pubKey: 0x0488b21e,
            privKey: 0x0488ade4
        };
        /**
           * Constructor for the BIP32 HD wallet.
           * Initializes an HD wallet with optional parameters for version bytes, depth, parent fingerprint, child index, chain code, private key, and public key.
           * @param versionBytesNum - Version bytes number for the wallet.
           * @param depth - Depth of the key in the hierarchy.
           * @param parentFingerPrint - Fingerprint of the parent key.
           * @param childIndex - Index of the child key.
           * @param chainCode - Chain code for key derivation.
           * @param privKey - Private key of the wallet.
           * @param pubKey - Public key of the wallet.
           */
        constructor(versionBytesNum, depth, parentFingerPrint, childIndex, chainCode, privKey, pubKey) {
            this.versionBytesNum = versionBytesNum;
            this.depth = depth;
            this.parentFingerPrint = parentFingerPrint;
            this.childIndex = childIndex;
            this.chainCode = chainCode;
            this.privKey = privKey;
            this.pubKey = pubKey;
        }
        /**
           * Generates a new HD wallet with random keys.
           * This method creates a root HD wallet with randomly generated private and public keys.
           * @returns {HD} The current HD instance with generated keys.
           */
        fromRandom() {
            this.versionBytesNum = this.constants.privKey;
            this.depth = 0x00;
            this.parentFingerPrint = [0, 0, 0, 0];
            this.childIndex = 0;
            this.chainCode = Random(32);
            this.privKey = PrivateKey.fromRandom();
            this.pubKey = this.privKey.toPublicKey();
            return this;
        }
        /**
           * Generates a new HD wallet with random keys.
           * This method creates a root HD wallet with randomly generated private and public keys.
           * @returns {HD} A new HD instance with generated keys.
           * @static
           */
        static fromRandom() {
            return new this().fromRandom();
        }
        /**
         * Initializes the HD wallet from a given base58 encoded string.
         * This method decodes a provided string to set up the HD wallet's properties.
         * @param str - A base58 encoded string representing the wallet.
         * @returns {HD} The new instance with properties set from the string.
         */
        static fromString(str) {
            return new this().fromString(str);
        }
        /**
           * Initializes the HD wallet from a given base58 encoded string.
           * This method decodes a provided string to set up the HD wallet's properties.
           * @param str - A base58 encoded string representing the wallet.
           * @returns {HD} The current instance with properties set from the string.
           */
        fromString(str) {
            const decoded = fromBase58Check(str);
            return this.fromBinary([...decoded.prefix, ...decoded.data]);
        }
        /**
         * Initializes the HD wallet from a seed.
         * This method generates keys and other properties from a given seed, conforming to the BIP32 specification.
         * @param bytes - An array of bytes representing the seed.
         * @returns {HD} The current instance with properties set from the seed.
         */
        static fromSeed(bytes) {
            return new this().fromSeed(bytes);
        }
        /**
           * Initializes the HD wallet from a seed.
           * This method generates keys and other properties from a given seed, conforming to the BIP32 specification.
           * @param bytes - An array of bytes representing the seed.
           * @returns {HD} The current instance with properties set from the seed.
           */
        fromSeed(bytes) {
            if (bytes.length < 128 / 8) {
                throw new Error('Need more than 128 bits of entropy');
            }
            if (bytes.length > 512 / 8) {
                throw new Error('More than 512 bits of entropy is nonstandard');
            }
            const hash = sha512hmac(toArray$2('Bitcoin seed', 'utf8'), bytes);
            this.depth = 0x00;
            this.parentFingerPrint = [0, 0, 0, 0];
            this.childIndex = 0;
            this.chainCode = hash.slice(32, 64);
            this.versionBytesNum = this.constants.privKey;
            this.privKey = new PrivateKey(hash.slice(0, 32));
            this.pubKey = this.privKey.toPublicKey();
            return this;
        }
        /**
         * Initializes the HD wallet from a binary buffer.
         * Parses a binary buffer to set up the wallet's properties.
         * @param buf - A buffer containing the wallet data.
         * @returns {HD} The new instance with properties set from the buffer.
         */
        static fromBinary(buf) {
            return new this().fromBinary(buf);
        }
        /**
         * Initializes the HD wallet from a binary buffer.
         * Parses a binary buffer to set up the wallet's properties.
         * @param buf - A buffer containing the wallet data.
         * @returns {HD} The current instance with properties set from the buffer.
         */
        fromBinary(buf) {
            // Both pub and private extended keys are 78 buf
            if (buf.length !== 78) {
                throw new Error('incorrect bip32 data length');
            }
            const reader = new Reader(buf);
            this.versionBytesNum = reader.readUInt32BE();
            this.depth = reader.readUInt8();
            this.parentFingerPrint = reader.read(4);
            this.childIndex = reader.readUInt32BE();
            this.chainCode = reader.read(32);
            const keyBytes = reader.read(33);
            const isPrivate = this.versionBytesNum === this.constants.privKey;
            const isPublic = this.versionBytesNum === this.constants.pubKey;
            if (isPrivate && keyBytes[0] === 0) {
                this.privKey = new PrivateKey(keyBytes.slice(1, 33));
                this.pubKey = this.privKey.toPublicKey();
            }
            else if (isPublic && (keyBytes[0] === 0x02 || keyBytes[0] === 0x03)) {
                this.pubKey = PublicKey.fromString(toHex$3(keyBytes));
            }
            else {
                throw new Error('Invalid key');
            }
            return this;
        }
        /**
         * Converts the HD wallet to a base58 encoded string.
         * This method provides a string representation of the HD wallet's current state.
         * @returns {string} A base58 encoded string of the HD wallet.
         */
        toString() {
            const bin = this.toBinary();
            return toBase58Check(bin, []);
        }
        /**
           * Derives a child HD wallet based on a given path.
           * The path specifies the hierarchy of the child key to be derived.
           * @param path - A string representing the derivation path (e.g., 'm/0'/1).
           * @returns {HD} A new HD instance representing the derived child wallet.
           */
        derive(path) {
            if (path === 'm') {
                return this;
            }
            const e = path.split('/');
            // eslint-disable-next-line @typescript-eslint/no-this-alias
            let bip32 = this;
            for (const i in e) {
                const c = e[i];
                if (i === '0') {
                    if (c !== 'm') {
                        throw new Error('invalid path');
                    }
                    continue;
                }
                if (parseInt(c.replace("'", ''), 10).toString() !== c.replace("'", '')) {
                    throw new Error('invalid path');
                }
                const usePrivate = c.length > 1 && c[c.length - 1] === "'";
                let childIndex = parseInt(usePrivate ? c.slice(0, c.length - 1) : c, 10) & 0x7fffffff;
                if (usePrivate) {
                    childIndex += 0x80000000;
                }
                bip32 = bip32.deriveChild(childIndex);
            }
            return bip32;
        }
        /**
           * Derives a child HD wallet from the current wallet based on an index.
           * This method generates either a private or public child key depending on the current wallet's state.
           * @param i - The index of the child key to derive.
           * @returns {HD} A new HD instance representing the derived child wallet.
           */
        deriveChild(i) {
            if (typeof i !== 'number') {
                throw new Error('i must be a number');
            }
            const ibc = [];
            ibc.push((i >> 24) & 0xff);
            ibc.push((i >> 16) & 0xff);
            ibc.push((i >> 8) & 0xff);
            ibc.push(i & 0xff);
            const ib = [...ibc];
            const usePrivate = (i & 0x80000000) !== 0;
            const isPrivate = this.versionBytesNum === this.constants.privKey;
            if (usePrivate && (!this.privKey || !isPrivate)) {
                throw new Error('Cannot do private key derivation without private key');
            }
            let ret = null;
            if (this.privKey) {
                let data = null;
                if (usePrivate) {
                    data = [0, ...this.privKey.toArray('be', 32), ...ib];
                }
                else {
                    data = [...this.pubKey.encode(true), ...ib];
                }
                const hash = sha512hmac(this.chainCode, data);
                const il = new BigNumber(hash.slice(0, 32));
                const ir = hash.slice(32, 64);
                // ki = IL + kpar (mod n).
                const k = il.add(this.privKey).mod(new Curve().n);
                ret = new HD();
                ret.chainCode = ir;
                ret.privKey = new PrivateKey(k.toArray());
                ret.pubKey = ret.privKey.toPublicKey();
            }
            else {
                const data = [...this.pubKey.encode(true), ...ib];
                const hash = sha512hmac(this.chainCode, data);
                const il = new BigNumber(hash.slice(0, 32));
                const ir = hash.slice(32, 64);
                // Ki = (IL + kpar)*G = IL*G + Kpar
                const ilG = new Curve().g.mul(il);
                const Kpar = this.pubKey;
                const Ki = ilG.add(Kpar);
                const newpub = new PublicKey(Ki.x, Ki.y);
                ret = new HD();
                ret.chainCode = ir;
                ret.pubKey = newpub;
            }
            ret.childIndex = i;
            const pubKeyhash = hash160(this.pubKey.encode(true));
            ret.parentFingerPrint = pubKeyhash.slice(0, 4);
            ret.versionBytesNum = this.versionBytesNum;
            ret.depth = this.depth + 1;
            return ret;
        }
        /**
           * Converts the current HD wallet to a public-only wallet.
           * This method strips away the private key information, leaving only the public part.
           * @returns {HD} A new HD instance representing the public-only wallet.
           */
        toPublic() {
            const bip32 = new HD(this.versionBytesNum, this.depth, this.parentFingerPrint, this.childIndex, this.chainCode, this.privKey, this.pubKey);
            bip32.versionBytesNum = this.constants.pubKey;
            bip32.privKey = undefined;
            return bip32;
        }
        /**
           * Converts the HD wallet into a binary representation.
           * This method serializes the wallet's properties into a binary format.
           * @returns {number[]} An array of numbers representing the binary data of the wallet.
           */
        toBinary() {
            const isPrivate = this.versionBytesNum === this.constants.privKey;
            const isPublic = this.versionBytesNum === this.constants.pubKey;
            if (isPrivate) {
                return new Writer()
                    .writeUInt32BE(this.versionBytesNum)
                    .writeUInt8(this.depth)
                    .write(this.parentFingerPrint)
                    .writeUInt32BE(this.childIndex)
                    .write(this.chainCode)
                    .writeUInt8(0)
                    .write(this.privKey.toArray('be', 32))
                    .toArray();
            }
            else if (isPublic) {
                return new Writer()
                    .writeUInt32BE(this.versionBytesNum)
                    .writeUInt8(this.depth)
                    .write(this.parentFingerPrint)
                    .writeUInt32BE(this.childIndex)
                    .write(this.chainCode)
                    .write(this.pubKey.encode(true))
                    .toArray();
            }
            else {
                throw new Error('bip32: invalid versionBytesNum byte');
            }
        }
        /**
           * Checks if the HD wallet contains a private key.
           * This method determines whether the wallet is a private key wallet or a public key only wallet.
           * @returns {boolean} A boolean value indicating whether the wallet has a private key (true) or not (false).
           */
        isPrivate() {
            return this.versionBytesNum === this.constants.privKey;
        }
    }

    // import { AESWrappercbc } from './aescbc'
    function AES(key) {
        if (!this._tables[0][0][0])
            this._precompute();
        let tmp, encKey, decKey;
        const sbox = this._tables[0][4];
        const decTable = this._tables[1];
        const keyLen = key.length;
        let rcon = 1;
        if (keyLen !== 4 && keyLen !== 6 && keyLen !== 8) {
            throw new Error('invalid aes key size');
        }
        this._key = [encKey = key.slice(0), decKey = []];
        // schedule encryption keys
        for (var i = keyLen; i < 4 * keyLen + 28; i++) {
            tmp = encKey[i - 1];
            // apply sbox
            if (i % keyLen === 0 || (keyLen === 8 && i % keyLen === 4)) {
                tmp = sbox[tmp >>> 24] << 24 ^ sbox[tmp >> 16 & 255] << 16 ^ sbox[tmp >> 8 & 255] << 8 ^ sbox[tmp & 255];
                // shift rows and add rcon
                if (i % keyLen === 0) {
                    tmp = tmp << 8 ^ tmp >>> 24 ^ rcon << 24;
                    rcon = rcon << 1 ^ (rcon >> 7) * 283;
                }
            }
            encKey[i] = encKey[i - keyLen] ^ tmp;
        }
        // schedule decryption keys
        for (let j = 0; i; j++, i--) {
            tmp = encKey[j & 3 ? i : i - 4];
            if (i <= 4 || j < 4) {
                decKey[j] = tmp;
            }
            else {
                decKey[j] = decTable[0][sbox[tmp >>> 24]] ^
                    decTable[1][sbox[tmp >> 16 & 255]] ^
                    decTable[2][sbox[tmp >> 8 & 255]] ^
                    decTable[3][sbox[tmp & 255]];
            }
        }
    }
    AES.prototype = {
        /**
           * Encrypt an array of 4 big-endian words.
           * @param {Array} data The plaintext.
           * @return {Array} The ciphertext.
           */
        encrypt: function (data) { return this._crypt(data, 0); },
        /**
           * Decrypt an array of 4 big-endian words.
           * @param {Array} data The ciphertext.
           * @return {Array} The plaintext.
           */
        decrypt: function (data) { return this._crypt(data, 1); },
        /**
           * The expanded S-box and inverse S-box tables.  These will be computed
           * on the client so that we don't have to send them down the wire.
           *
           * There are two tables, _tables[0] is for encryption and
           * _tables[1] is for decryption.
           *
           * The first 4 sub-tables are the expanded S-box with MixColumns.  The
           * last (_tables[01][4]) is the S-box itself.
           *
           * @private
           */
        _tables: [
            [new Uint32Array(256), new Uint32Array(256), new Uint32Array(256), new Uint32Array(256), new Uint32Array(256)],
            [new Uint32Array(256), new Uint32Array(256), new Uint32Array(256), new Uint32Array(256), new Uint32Array(256)]
        ],
        // Expand the S-box tables.
        _precompute: function () {
            const encTable = this._tables[0];
            const decTable = this._tables[1];
            const sbox = encTable[4];
            const sboxInv = decTable[4];
            let i;
            let x;
            let xInv;
            const d = new Uint8Array(256);
            const th = new Uint8Array(256);
            let x2;
            let x4;
            let x8;
            let s;
            let tEnc;
            let tDec;
            // Compute double and third tables
            for (i = 0; i < 256; i++) {
                th[(d[i] = i << 1 ^ (i >> 7) * 283) ^ i] = i;
            }
            for (x = xInv = 0; !sbox[x]; x ^= x2 || 1, xInv = th[xInv] || 1) {
                // Compute sbox
                s = xInv ^ xInv << 1 ^ xInv << 2 ^ xInv << 3 ^ xInv << 4;
                s = s >> 8 ^ s & 255 ^ 99;
                sbox[x] = s;
                sboxInv[s] = x;
                // Compute MixColumns
                x8 = d[x4 = d[x2 = d[x]]];
                tDec = x8 * 0x1010101 ^ x4 * 0x10001 ^ x2 * 0x101 ^ x * 0x1010100;
                tEnc = d[s] * 0x101 ^ s * 0x1010100;
                for (i = 0; i < 4; i++) {
                    encTable[i][x] = tEnc = tEnc << 24 ^ tEnc >>> 8;
                    decTable[i][s] = tDec = tDec << 24 ^ tDec >>> 8;
                }
            }
        },
        /**
           * Encryption and decryption core.
           * @param {Array} input Four words to be encrypted or decrypted.
           * @param dir The direction, 0 for encrypt and 1 for decrypt.
           * @return {Array} The four encrypted or decrypted words.
           * @private
           */
        _crypt: function (input, dir) {
            if (input.length !== 4) {
                throw new Error('invalid aes block size');
            }
            const key = this._key[dir];
            // state variables a,b,c,d are loaded with pre-whitened data
            let a = input[0] ^ key[0];
            let b = input[dir ? 3 : 1] ^ key[1];
            let c = input[2] ^ key[2];
            let d = input[dir ? 1 : 3] ^ key[3];
            let a2;
            let b2;
            let c2;
            const nInnerRounds = key.length / 4 - 2;
            let i;
            let kIndex = 4;
            const out = new Uint32Array(4);
            const // <--- this is slower in Node.js, about the same in Chrome */
            table = this._tables[dir];
            // load up the tables
            const t0 = table[0];
            const t1 = table[1];
            const t2 = table[2];
            const t3 = table[3];
            const sbox = table[4];
            // Inner rounds.  Cribbed from OpenSSL.
            for (i = 0; i < nInnerRounds; i++) {
                a2 = t0[a >>> 24] ^ t1[b >> 16 & 255] ^ t2[c >> 8 & 255] ^ t3[d & 255] ^ key[kIndex];
                b2 = t0[b >>> 24] ^ t1[c >> 16 & 255] ^ t2[d >> 8 & 255] ^ t3[a & 255] ^ key[kIndex + 1];
                c2 = t0[c >>> 24] ^ t1[d >> 16 & 255] ^ t2[a >> 8 & 255] ^ t3[b & 255] ^ key[kIndex + 2];
                d = t0[d >>> 24] ^ t1[a >> 16 & 255] ^ t2[b >> 8 & 255] ^ t3[c & 255] ^ key[kIndex + 3];
                kIndex += 4;
                a = a2;
                b = b2;
                c = c2;
            }
            // Last round.
            for (i = 0; i < 4; i++) {
                out[dir ? 3 & -i : i] =
                    sbox[a >>> 24] << 24 ^
                        sbox[b >> 16 & 255] << 16 ^
                        sbox[c >> 8 & 255] << 8 ^
                        sbox[d & 255] ^
                        key[kIndex++];
                a2 = a;
                a = b;
                b = c;
                c = d;
                d = a2;
            }
            return out;
        }
    };
    class AESWrapper {
        static encrypt(messageBuf, keyBuf) {
            const key = AESWrapper.buf2Words((keyBuf));
            const message = AESWrapper.buf2Words((messageBuf));
            const a = new AES(key);
            const enc = a.encrypt(message);
            const encBuf = AESWrapper.words2Buf(enc);
            return encBuf;
        }
        static decrypt(encBuf, keyBuf) {
            const enc = AESWrapper.buf2Words((encBuf));
            const key = AESWrapper.buf2Words((keyBuf));
            const a = new AES(key);
            const message = a.decrypt(enc);
            const messageBuf = AESWrapper.words2Buf(message);
            return messageBuf;
        }
        static buf2Words(buf) {
            if (buf.length % 4) {
                throw new Error('buf length must be a multiple of 4');
            }
            const words = [];
            for (let i = 0; i < buf.length / 4; i++) {
                const val = (buf[i * 4] * 0x1000000) + // Shift the first byte by 24 bits
                    ((buf[i * 4 + 1] << 16) | // Shift the second byte by 16 bits
                        (buf[i * 4 + 2] << 8) | // Shift the third byte by 8 bits
                        buf[i * 4 + 3]); // The fourth byte
                words.push(val);
            }
            return words;
        }
        static words2Buf(words) {
            const buf = new Array(words.length * 4);
            for (let i = 0; i < words.length; i++) {
                const word = words[i];
                buf[i * 4] = (word >>> 24) & 0xFF;
                buf[i * 4 + 1] = (word >>> 16) & 0xFF;
                buf[i * 4 + 2] = (word >>> 8) & 0xFF;
                buf[i * 4 + 3] = word & 0xFF;
            }
            return buf;
        }
    }
    class CBC {
        static buf2BlocksBuf(buf, blockSize) {
            const bytesize = blockSize / 8;
            const blockBufs = [];
            for (let i = 0; i <= buf.length / bytesize; i++) {
                let blockBuf = buf.slice(i * bytesize, i * bytesize + bytesize);
                if (blockBuf.length < blockSize) {
                    blockBuf = CBC.pkcs7Pad(blockBuf, blockSize);
                }
                blockBufs.push(blockBuf);
            }
            return blockBufs;
        }
        static blockBufs2Buf(blockBufs) {
            let last = blockBufs[blockBufs.length - 1];
            last = CBC.pkcs7Unpad(last);
            blockBufs[blockBufs.length - 1] = last;
            const buf = blockBufs.flat();
            return buf;
        }
        static encrypt(messageBuf, ivBuf, blockCipher /* TODO: type */, cipherKeyBuf) {
            const blockSize = ivBuf.length * 8;
            const blockBufs = CBC.buf2BlocksBuf(messageBuf, blockSize);
            const encBufs = CBC.encryptBlocks(blockBufs, ivBuf, blockCipher, cipherKeyBuf);
            const encBuf = encBufs.flat();
            return encBuf;
        }
        static decrypt(encBuf, ivBuf, blockCipher /* TODO: type */, cipherKeyBuf) {
            const bytesize = ivBuf.length;
            const encBufs = [];
            for (let i = 0; i < encBuf.length / bytesize; i++) {
                encBufs.push(encBuf.slice(i * bytesize, i * bytesize + bytesize));
            }
            const blockBufs = CBC.decryptBlocks(encBufs, ivBuf, blockCipher, cipherKeyBuf);
            const buf = CBC.blockBufs2Buf(blockBufs);
            return buf;
        }
        static encryptBlock(blockBuf, ivBuf, blockCipher /* TODO: type */, cipherKeyBuf) {
            const xorbuf = CBC.xorBufs(blockBuf, ivBuf);
            const encBuf = blockCipher.encrypt(xorbuf, cipherKeyBuf);
            return encBuf;
        }
        static decryptBlock(encBuf, ivBuf, blockCipher /* TODO: type */, cipherKeyBuf) {
            const xorbuf = blockCipher.decrypt(encBuf, cipherKeyBuf);
            const blockBuf = CBC.xorBufs(xorbuf, ivBuf);
            return blockBuf;
        }
        static encryptBlocks(blockBufs, ivBuf, blockCipher /* TODO: type */, cipherKeyBuf) {
            const encBufs = [];
            for (let i = 0; i < blockBufs.length; i++) {
                const blockBuf = blockBufs[i];
                const encBuf = CBC.encryptBlock(blockBuf, ivBuf, blockCipher, cipherKeyBuf);
                encBufs.push(encBuf);
                ivBuf = encBuf;
            }
            return encBufs;
        }
        static decryptBlocks(encBufs, ivBuf, blockCipher /* TODO: type */, cipherKeyBuf) {
            const blockBufs = [];
            for (let i = 0; i < encBufs.length; i++) {
                const encBuf = encBufs[i];
                const blockBuf = CBC.decryptBlock(encBuf, ivBuf, blockCipher, cipherKeyBuf);
                blockBufs.push(blockBuf);
                ivBuf = encBuf;
            }
            return blockBufs;
        }
        static pkcs7Pad(buf, blockSize) {
            const bytesize = blockSize / 8;
            const padbytesize = bytesize - buf.length;
            const pad = new Array(padbytesize);
            pad.fill(padbytesize);
            const paddedbuf = [...buf, ...pad];
            return paddedbuf;
        }
        static pkcs7Unpad(paddedbuf) {
            const padlength = paddedbuf[paddedbuf.length - 1];
            const padbuf = paddedbuf.slice(paddedbuf.length - padlength, paddedbuf.length);
            const padbuf2 = new Array(padlength);
            padbuf2.fill(padlength);
            if (toHex$3(padbuf) !== toHex$3(padbuf2)) {
                throw new Error('invalid padding');
            }
            return paddedbuf.slice(0, paddedbuf.length - padlength);
        }
        static xorBufs(buf1, buf2) {
            if (buf1.length !== buf2.length) {
                throw new Error('bufs must have the same length');
            }
            const buf = new Array(buf1.length);
            for (let i = 0; i < buf1.length; i++) {
                buf[i] = buf1[i] ^ buf2[i];
            }
            return buf;
        }
    }
    class AESCBC {
        static encrypt(messageBuf, cipherKeyBuf, ivBuf, concatIvBuf = true) {
            ivBuf = ivBuf || new Array(128 / 8).fill(0) || Random(128 / 8);
            const ctBuf = CBC.encrypt(messageBuf, ivBuf, AESWrapper, cipherKeyBuf);
            if (concatIvBuf) {
                return [...ivBuf, ...ctBuf];
            }
            else {
                return [...ctBuf];
            }
        }
        static decrypt(encBuf, cipherKeyBuf, ivBuf) {
            if (!ivBuf) {
                ivBuf = encBuf.slice(0, 128 / 8);
                const ctBuf = encBuf.slice(128 / 8);
                return CBC.decrypt(ctBuf, ivBuf, AESWrapper, cipherKeyBuf);
            }
            else {
                const ctBuf = encBuf;
                return CBC.decrypt(ctBuf, ivBuf, AESWrapper, cipherKeyBuf);
            }
        }
    }
    /**
     * @class ECIES
     * Implements the Electrum ECIES protocol for encrypted communication.
     *
     * @prprecated This class is deprecated in favor of the BRC-78 standard for portable encrypted messages,
     * which provides a more comprehensive and secure solution by integrating with BRC-42 and BRC-43 standards.
     */
    class ECIES {
        /**
           * Generates the initialization vector (iv), encryption key (kE), and MAC key (kM)
           * using the sender's private key and receiver's public key.
           *
           * @param {PrivateKey} privKey - The sender's private key.
           * @param {PublicKey} pubKey - The receiver's public key.
           * @returns {Object} An object containing the iv, kE, and kM as number arrays.
           */
        static ivkEkM(privKey, pubKey) {
            const r = privKey;
            const KB = pubKey;
            const P = KB.mul(r);
            const S = new PublicKey(P.x, P.y);
            const Sbuf = S.encode(true);
            const hash = sha512(Sbuf);
            return {
                iv: hash.slice(0, 16),
                kE: hash.slice(16, 32),
                kM: hash.slice(32, 64)
            };
        }
        /**
           * Encrypts a given message using the Electrum ECIES method.
           *
           * @param {number[]} messageBuf - The message to be encrypted, in number array format.
           * @param {PublicKey} toPublicKey - The public key of the recipient.
           * @param {PrivateKey} [fromPrivateKey] - The private key of the sender. If not provided, a random private key is used.
           * @param {boolean} [noKey=false] - If true, does not include the sender's public key in the encrypted message.
           * @returns {number[]} The encrypted message as a number array.
           */
        static electrumEncrypt(messageBuf, toPublicKey, fromPrivateKey, noKey = false) {
            let Rbuf;
            if (fromPrivateKey === null) {
                fromPrivateKey = PrivateKey.fromRandom();
            }
            if (!noKey) {
                Rbuf = fromPrivateKey.toPublicKey().encode(true);
            }
            const { iv, kE, kM } = ECIES.ivkEkM(fromPrivateKey, toPublicKey);
            const ciphertext = AESCBC.encrypt(messageBuf, kE, iv, false);
            const BIE1 = toArray$2('BIE1', 'utf8');
            let encBuf;
            if (Rbuf) {
                encBuf = [...BIE1, ...Rbuf, ...ciphertext];
            }
            else {
                encBuf = [...BIE1, ...ciphertext];
            }
            const hmac = sha256hmac(kM, encBuf);
            return [...encBuf, ...hmac];
        }
        /**
           * Decrypts a message encrypted using the Electrum ECIES method.
           *
           * @param {number[]} encBuf - The encrypted message buffer.
           * @param {PrivateKey} toPrivateKey - The private key of the recipient.
           * @param {PublicKey} [fromPublicKey=null] - The public key of the sender. If not provided, it is extracted from the message.
           * @returns {number[]} The decrypted message as a number array.
           */
        static electrumDecrypt(encBuf, toPrivateKey, fromPublicKey = null) {
            const tagLength = 32;
            const magic = encBuf.slice(0, 4);
            if (encode$1(magic, 'utf8') !== 'BIE1') {
                throw new Error('Invalid Magic');
            }
            let offset = 4;
            if (fromPublicKey === null) {
                // BIE1 use compressed public key, length is always 33.
                const pub = encBuf.slice(4, 37);
                fromPublicKey = PublicKey.fromString(toHex$3(pub));
                offset = 37;
            }
            const { iv, kE, kM } = ECIES.ivkEkM(toPrivateKey, fromPublicKey);
            const ciphertext = encBuf.slice(offset, encBuf.length - tagLength);
            const hmac = encBuf.slice(encBuf.length - tagLength, encBuf.length);
            const hmac2 = sha256hmac(kM, encBuf.slice(0, encBuf.length - tagLength));
            if (toHex$3(hmac) !== toHex$3(hmac2)) {
                throw new Error('Invalid checksum');
            }
            return AESCBC.decrypt(ciphertext, kE, iv);
        }
        /**
           * Encrypts a given message using the Bitcore variant of ECIES.
           *
           * @param {number[]} messageBuf - The message to be encrypted, in number array format.
           * @param {PublicKey} toPublicKey - The public key of the recipient.
           * @param {PrivateKey} [fromPrivateKey] - The private key of the sender. If not provided, a random private key is used.
           * @param {number[]} [ivBuf] - The initialization vector for encryption. If not provided, a random IV is used.
           * @returns {number[]} The encrypted message as a number array.
           */
        static bitcoreEncrypt(messageBuf, toPublicKey, fromPrivateKey, ivBuf) {
            if (!fromPrivateKey) {
                fromPrivateKey = PrivateKey.fromRandom();
            }
            const r = fromPrivateKey;
            const RPublicKey = fromPrivateKey.toPublicKey();
            const RBuf = RPublicKey.encode(true);
            const KB = toPublicKey;
            const P = KB.mul(r);
            const S = P.getX();
            const Sbuf = S.toArray('be', 32);
            const kEkM = sha512(Sbuf);
            const kE = kEkM.slice(0, 32);
            const kM = kEkM.slice(32, 64);
            const c = AESCBC.encrypt(messageBuf, kE, ivBuf);
            const d = sha256hmac(kM, [...c]);
            const encBuf = [...RBuf, ...c, ...d];
            return encBuf;
        }
        /**
           * Decrypts a message encrypted using the Bitcore variant of ECIES.
           *
           * @param {number[]} encBuf - The encrypted message buffer.
           * @param {PrivateKey} toPrivateKey - The private key of the recipient.
           * @returns {number[]} The decrypted message as a number array.
           */
        static bitcoreDecrypt(encBuf, toPrivateKey) {
            const kB = toPrivateKey;
            const fromPublicKey = PublicKey.fromString(toHex$3(encBuf.slice(0, 33)));
            const R = fromPublicKey;
            const P = R.mul(kB);
            if (P.eq(new Point(0, 0))) {
                throw new Error('P equals 0');
            }
            const S = P.getX();
            const Sbuf = S.toArray('be', 32);
            const kEkM = sha512(Sbuf);
            const kE = kEkM.slice(0, 32);
            const kM = kEkM.slice(32, 64);
            const c = encBuf.slice(33, encBuf.length - 32);
            const d = encBuf.slice(encBuf.length - 32, encBuf.length);
            const d2 = sha256hmac(kM, c);
            if (toHex$3(d) !== toHex$3(d2)) {
                throw new Error('Invalid checksum');
            }
            const messageBuf = AESCBC.decrypt(c, kE);
            return [...messageBuf];
        }
    }

    var global$1 = (typeof global !== "undefined" ? global :
      typeof self !== "undefined" ? self :
      typeof window !== "undefined" ? window : {});

    var lookup$1 = [];
    var revLookup$1 = [];
    var Arr$1 = typeof Uint8Array !== 'undefined' ? Uint8Array : Array;
    var inited$1 = false;
    function init$1 () {
      inited$1 = true;
      var code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
      for (var i = 0, len = code.length; i < len; ++i) {
        lookup$1[i] = code[i];
        revLookup$1[code.charCodeAt(i)] = i;
      }

      revLookup$1['-'.charCodeAt(0)] = 62;
      revLookup$1['_'.charCodeAt(0)] = 63;
    }

    function toByteArray$1 (b64) {
      if (!inited$1) {
        init$1();
      }
      var i, j, l, tmp, placeHolders, arr;
      var len = b64.length;

      if (len % 4 > 0) {
        throw new Error('Invalid string. Length must be a multiple of 4')
      }

      // the number of equal signs (place holders)
      // if there are two placeholders, than the two characters before it
      // represent one byte
      // if there is only one, then the three characters before it represent 2 bytes
      // this is just a cheap hack to not do indexOf twice
      placeHolders = b64[len - 2] === '=' ? 2 : b64[len - 1] === '=' ? 1 : 0;

      // base64 is 4/3 + up to two characters of the original data
      arr = new Arr$1(len * 3 / 4 - placeHolders);

      // if there are placeholders, only get up to the last complete 4 chars
      l = placeHolders > 0 ? len - 4 : len;

      var L = 0;

      for (i = 0, j = 0; i < l; i += 4, j += 3) {
        tmp = (revLookup$1[b64.charCodeAt(i)] << 18) | (revLookup$1[b64.charCodeAt(i + 1)] << 12) | (revLookup$1[b64.charCodeAt(i + 2)] << 6) | revLookup$1[b64.charCodeAt(i + 3)];
        arr[L++] = (tmp >> 16) & 0xFF;
        arr[L++] = (tmp >> 8) & 0xFF;
        arr[L++] = tmp & 0xFF;
      }

      if (placeHolders === 2) {
        tmp = (revLookup$1[b64.charCodeAt(i)] << 2) | (revLookup$1[b64.charCodeAt(i + 1)] >> 4);
        arr[L++] = tmp & 0xFF;
      } else if (placeHolders === 1) {
        tmp = (revLookup$1[b64.charCodeAt(i)] << 10) | (revLookup$1[b64.charCodeAt(i + 1)] << 4) | (revLookup$1[b64.charCodeAt(i + 2)] >> 2);
        arr[L++] = (tmp >> 8) & 0xFF;
        arr[L++] = tmp & 0xFF;
      }

      return arr
    }

    function tripletToBase64$1 (num) {
      return lookup$1[num >> 18 & 0x3F] + lookup$1[num >> 12 & 0x3F] + lookup$1[num >> 6 & 0x3F] + lookup$1[num & 0x3F]
    }

    function encodeChunk$1 (uint8, start, end) {
      var tmp;
      var output = [];
      for (var i = start; i < end; i += 3) {
        tmp = (uint8[i] << 16) + (uint8[i + 1] << 8) + (uint8[i + 2]);
        output.push(tripletToBase64$1(tmp));
      }
      return output.join('')
    }

    function fromByteArray$1 (uint8) {
      if (!inited$1) {
        init$1();
      }
      var tmp;
      var len = uint8.length;
      var extraBytes = len % 3; // if we have 1 byte left, pad 2 bytes
      var output = '';
      var parts = [];
      var maxChunkLength = 16383; // must be multiple of 3

      // go through the array every three bytes, we'll deal with trailing stuff later
      for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
        parts.push(encodeChunk$1(uint8, i, (i + maxChunkLength) > len2 ? len2 : (i + maxChunkLength)));
      }

      // pad the end with zeros, but make sure to not forget the extra bytes
      if (extraBytes === 1) {
        tmp = uint8[len - 1];
        output += lookup$1[tmp >> 2];
        output += lookup$1[(tmp << 4) & 0x3F];
        output += '==';
      } else if (extraBytes === 2) {
        tmp = (uint8[len - 2] << 8) + (uint8[len - 1]);
        output += lookup$1[tmp >> 10];
        output += lookup$1[(tmp >> 4) & 0x3F];
        output += lookup$1[(tmp << 2) & 0x3F];
        output += '=';
      }

      parts.push(output);

      return parts.join('')
    }

    function read$1 (buffer, offset, isLE, mLen, nBytes) {
      var e, m;
      var eLen = nBytes * 8 - mLen - 1;
      var eMax = (1 << eLen) - 1;
      var eBias = eMax >> 1;
      var nBits = -7;
      var i = isLE ? (nBytes - 1) : 0;
      var d = isLE ? -1 : 1;
      var s = buffer[offset + i];

      i += d;

      e = s & ((1 << (-nBits)) - 1);
      s >>= (-nBits);
      nBits += eLen;
      for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {}

      m = e & ((1 << (-nBits)) - 1);
      e >>= (-nBits);
      nBits += mLen;
      for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {}

      if (e === 0) {
        e = 1 - eBias;
      } else if (e === eMax) {
        return m ? NaN : ((s ? -1 : 1) * Infinity)
      } else {
        m = m + Math.pow(2, mLen);
        e = e - eBias;
      }
      return (s ? -1 : 1) * m * Math.pow(2, e - mLen)
    }

    function write$1 (buffer, value, offset, isLE, mLen, nBytes) {
      var e, m, c;
      var eLen = nBytes * 8 - mLen - 1;
      var eMax = (1 << eLen) - 1;
      var eBias = eMax >> 1;
      var rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0);
      var i = isLE ? 0 : (nBytes - 1);
      var d = isLE ? 1 : -1;
      var s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0;

      value = Math.abs(value);

      if (isNaN(value) || value === Infinity) {
        m = isNaN(value) ? 1 : 0;
        e = eMax;
      } else {
        e = Math.floor(Math.log(value) / Math.LN2);
        if (value * (c = Math.pow(2, -e)) < 1) {
          e--;
          c *= 2;
        }
        if (e + eBias >= 1) {
          value += rt / c;
        } else {
          value += rt * Math.pow(2, 1 - eBias);
        }
        if (value * c >= 2) {
          e++;
          c /= 2;
        }

        if (e + eBias >= eMax) {
          m = 0;
          e = eMax;
        } else if (e + eBias >= 1) {
          m = (value * c - 1) * Math.pow(2, mLen);
          e = e + eBias;
        } else {
          m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen);
          e = 0;
        }
      }

      for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

      e = (e << mLen) | m;
      eLen += mLen;
      for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

      buffer[offset + i - d] |= s * 128;
    }

    var toString$1 = {}.toString;

    var isArray$3 = Array.isArray || function (arr) {
      return toString$1.call(arr) == '[object Array]';
    };

    /*!
     * The buffer module from node.js, for the browser.
     *
     * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
     * @license  MIT
     */

    var INSPECT_MAX_BYTES$1 = 50;

    /**
     * If `Buffer.TYPED_ARRAY_SUPPORT`:
     *   === true    Use Uint8Array implementation (fastest)
     *   === false   Use Object implementation (most compatible, even IE6)
     *
     * Browsers that support typed arrays are IE 10+, Firefox 4+, Chrome 7+, Safari 5.1+,
     * Opera 11.6+, iOS 4.2+.
     *
     * Due to various browser bugs, sometimes the Object implementation will be used even
     * when the browser supports typed arrays.
     *
     * Note:
     *
     *   - Firefox 4-29 lacks support for adding new properties to `Uint8Array` instances,
     *     See: https://bugzilla.mozilla.org/show_bug.cgi?id=695438.
     *
     *   - Chrome 9-10 is missing the `TypedArray.prototype.subarray` function.
     *
     *   - IE10 has a broken `TypedArray.prototype.subarray` function which returns arrays of
     *     incorrect length in some situations.

     * We detect these buggy browsers and set `Buffer.TYPED_ARRAY_SUPPORT` to `false` so they
     * get the Object implementation, which is slower but behaves correctly.
     */
    Buffer$3.TYPED_ARRAY_SUPPORT = global$1.TYPED_ARRAY_SUPPORT !== undefined
      ? global$1.TYPED_ARRAY_SUPPORT
      : true;

    /*
     * Export kMaxLength after typed array support is determined.
     */
    kMaxLength$1();

    function kMaxLength$1 () {
      return Buffer$3.TYPED_ARRAY_SUPPORT
        ? 0x7fffffff
        : 0x3fffffff
    }

    function createBuffer$1 (that, length) {
      if (kMaxLength$1() < length) {
        throw new RangeError('Invalid typed array length')
      }
      if (Buffer$3.TYPED_ARRAY_SUPPORT) {
        // Return an augmented `Uint8Array` instance, for best performance
        that = new Uint8Array(length);
        that.__proto__ = Buffer$3.prototype;
      } else {
        // Fallback: Return an object instance of the Buffer class
        if (that === null) {
          that = new Buffer$3(length);
        }
        that.length = length;
      }

      return that
    }

    /**
     * The Buffer constructor returns instances of `Uint8Array` that have their
     * prototype changed to `Buffer.prototype`. Furthermore, `Buffer` is a subclass of
     * `Uint8Array`, so the returned instances will have all the node `Buffer` methods
     * and the `Uint8Array` methods. Square bracket notation works as expected -- it
     * returns a single octet.
     *
     * The `Uint8Array` prototype remains unmodified.
     */

    function Buffer$3 (arg, encodingOrOffset, length) {
      if (!Buffer$3.TYPED_ARRAY_SUPPORT && !(this instanceof Buffer$3)) {
        return new Buffer$3(arg, encodingOrOffset, length)
      }

      // Common case.
      if (typeof arg === 'number') {
        if (typeof encodingOrOffset === 'string') {
          throw new Error(
            'If encoding is specified then the first argument must be a string'
          )
        }
        return allocUnsafe$1(this, arg)
      }
      return from$1(this, arg, encodingOrOffset, length)
    }

    Buffer$3.poolSize = 8192; // not used by this implementation

    // TODO: Legacy, not needed anymore. Remove in next major version.
    Buffer$3._augment = function (arr) {
      arr.__proto__ = Buffer$3.prototype;
      return arr
    };

    function from$1 (that, value, encodingOrOffset, length) {
      if (typeof value === 'number') {
        throw new TypeError('"value" argument must not be a number')
      }

      if (typeof ArrayBuffer !== 'undefined' && value instanceof ArrayBuffer) {
        return fromArrayBuffer$1(that, value, encodingOrOffset, length)
      }

      if (typeof value === 'string') {
        return fromString$1(that, value, encodingOrOffset)
      }

      return fromObject$1(that, value)
    }

    /**
     * Functionally equivalent to Buffer(arg, encoding) but throws a TypeError
     * if value is a number.
     * Buffer.from(str[, encoding])
     * Buffer.from(array)
     * Buffer.from(buffer)
     * Buffer.from(arrayBuffer[, byteOffset[, length]])
     **/
    Buffer$3.from = function (value, encodingOrOffset, length) {
      return from$1(null, value, encodingOrOffset, length)
    };

    if (Buffer$3.TYPED_ARRAY_SUPPORT) {
      Buffer$3.prototype.__proto__ = Uint8Array.prototype;
      Buffer$3.__proto__ = Uint8Array;
    }

    function assertSize$1 (size) {
      if (typeof size !== 'number') {
        throw new TypeError('"size" argument must be a number')
      } else if (size < 0) {
        throw new RangeError('"size" argument must not be negative')
      }
    }

    function alloc$1 (that, size, fill, encoding) {
      assertSize$1(size);
      if (size <= 0) {
        return createBuffer$1(that, size)
      }
      if (fill !== undefined) {
        // Only pay attention to encoding if it's a string. This
        // prevents accidentally sending in a number that would
        // be interpretted as a start offset.
        return typeof encoding === 'string'
          ? createBuffer$1(that, size).fill(fill, encoding)
          : createBuffer$1(that, size).fill(fill)
      }
      return createBuffer$1(that, size)
    }

    /**
     * Creates a new filled Buffer instance.
     * alloc(size[, fill[, encoding]])
     **/
    Buffer$3.alloc = function (size, fill, encoding) {
      return alloc$1(null, size, fill, encoding)
    };

    function allocUnsafe$1 (that, size) {
      assertSize$1(size);
      that = createBuffer$1(that, size < 0 ? 0 : checked$1(size) | 0);
      if (!Buffer$3.TYPED_ARRAY_SUPPORT) {
        for (var i = 0; i < size; ++i) {
          that[i] = 0;
        }
      }
      return that
    }

    /**
     * Equivalent to Buffer(num), by default creates a non-zero-filled Buffer instance.
     * */
    Buffer$3.allocUnsafe = function (size) {
      return allocUnsafe$1(null, size)
    };
    /**
     * Equivalent to SlowBuffer(num), by default creates a non-zero-filled Buffer instance.
     */
    Buffer$3.allocUnsafeSlow = function (size) {
      return allocUnsafe$1(null, size)
    };

    function fromString$1 (that, string, encoding) {
      if (typeof encoding !== 'string' || encoding === '') {
        encoding = 'utf8';
      }

      if (!Buffer$3.isEncoding(encoding)) {
        throw new TypeError('"encoding" must be a valid string encoding')
      }

      var length = byteLength$1(string, encoding) | 0;
      that = createBuffer$1(that, length);

      var actual = that.write(string, encoding);

      if (actual !== length) {
        // Writing a hex string, for example, that contains invalid characters will
        // cause everything after the first invalid character to be ignored. (e.g.
        // 'abxxcd' will be treated as 'ab')
        that = that.slice(0, actual);
      }

      return that
    }

    function fromArrayLike$1 (that, array) {
      var length = array.length < 0 ? 0 : checked$1(array.length) | 0;
      that = createBuffer$1(that, length);
      for (var i = 0; i < length; i += 1) {
        that[i] = array[i] & 255;
      }
      return that
    }

    function fromArrayBuffer$1 (that, array, byteOffset, length) {
      array.byteLength; // this throws if `array` is not a valid ArrayBuffer

      if (byteOffset < 0 || array.byteLength < byteOffset) {
        throw new RangeError('\'offset\' is out of bounds')
      }

      if (array.byteLength < byteOffset + (length || 0)) {
        throw new RangeError('\'length\' is out of bounds')
      }

      if (byteOffset === undefined && length === undefined) {
        array = new Uint8Array(array);
      } else if (length === undefined) {
        array = new Uint8Array(array, byteOffset);
      } else {
        array = new Uint8Array(array, byteOffset, length);
      }

      if (Buffer$3.TYPED_ARRAY_SUPPORT) {
        // Return an augmented `Uint8Array` instance, for best performance
        that = array;
        that.__proto__ = Buffer$3.prototype;
      } else {
        // Fallback: Return an object instance of the Buffer class
        that = fromArrayLike$1(that, array);
      }
      return that
    }

    function fromObject$1 (that, obj) {
      if (internalIsBuffer$1(obj)) {
        var len = checked$1(obj.length) | 0;
        that = createBuffer$1(that, len);

        if (that.length === 0) {
          return that
        }

        obj.copy(that, 0, 0, len);
        return that
      }

      if (obj) {
        if ((typeof ArrayBuffer !== 'undefined' &&
            obj.buffer instanceof ArrayBuffer) || 'length' in obj) {
          if (typeof obj.length !== 'number' || isnan$1(obj.length)) {
            return createBuffer$1(that, 0)
          }
          return fromArrayLike$1(that, obj)
        }

        if (obj.type === 'Buffer' && isArray$3(obj.data)) {
          return fromArrayLike$1(that, obj.data)
        }
      }

      throw new TypeError('First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.')
    }

    function checked$1 (length) {
      // Note: cannot use `length < kMaxLength()` here because that fails when
      // length is NaN (which is otherwise coerced to zero.)
      if (length >= kMaxLength$1()) {
        throw new RangeError('Attempt to allocate Buffer larger than maximum ' +
                             'size: 0x' + kMaxLength$1().toString(16) + ' bytes')
      }
      return length | 0
    }
    Buffer$3.isBuffer = isBuffer$1;
    function internalIsBuffer$1 (b) {
      return !!(b != null && b._isBuffer)
    }

    Buffer$3.compare = function compare (a, b) {
      if (!internalIsBuffer$1(a) || !internalIsBuffer$1(b)) {
        throw new TypeError('Arguments must be Buffers')
      }

      if (a === b) return 0

      var x = a.length;
      var y = b.length;

      for (var i = 0, len = Math.min(x, y); i < len; ++i) {
        if (a[i] !== b[i]) {
          x = a[i];
          y = b[i];
          break
        }
      }

      if (x < y) return -1
      if (y < x) return 1
      return 0
    };

    Buffer$3.isEncoding = function isEncoding (encoding) {
      switch (String(encoding).toLowerCase()) {
        case 'hex':
        case 'utf8':
        case 'utf-8':
        case 'ascii':
        case 'latin1':
        case 'binary':
        case 'base64':
        case 'ucs2':
        case 'ucs-2':
        case 'utf16le':
        case 'utf-16le':
          return true
        default:
          return false
      }
    };

    Buffer$3.concat = function concat (list, length) {
      if (!isArray$3(list)) {
        throw new TypeError('"list" argument must be an Array of Buffers')
      }

      if (list.length === 0) {
        return Buffer$3.alloc(0)
      }

      var i;
      if (length === undefined) {
        length = 0;
        for (i = 0; i < list.length; ++i) {
          length += list[i].length;
        }
      }

      var buffer = Buffer$3.allocUnsafe(length);
      var pos = 0;
      for (i = 0; i < list.length; ++i) {
        var buf = list[i];
        if (!internalIsBuffer$1(buf)) {
          throw new TypeError('"list" argument must be an Array of Buffers')
        }
        buf.copy(buffer, pos);
        pos += buf.length;
      }
      return buffer
    };

    function byteLength$1 (string, encoding) {
      if (internalIsBuffer$1(string)) {
        return string.length
      }
      if (typeof ArrayBuffer !== 'undefined' && typeof ArrayBuffer.isView === 'function' &&
          (ArrayBuffer.isView(string) || string instanceof ArrayBuffer)) {
        return string.byteLength
      }
      if (typeof string !== 'string') {
        string = '' + string;
      }

      var len = string.length;
      if (len === 0) return 0

      // Use a for loop to avoid recursion
      var loweredCase = false;
      for (;;) {
        switch (encoding) {
          case 'ascii':
          case 'latin1':
          case 'binary':
            return len
          case 'utf8':
          case 'utf-8':
          case undefined:
            return utf8ToBytes$1(string).length
          case 'ucs2':
          case 'ucs-2':
          case 'utf16le':
          case 'utf-16le':
            return len * 2
          case 'hex':
            return len >>> 1
          case 'base64':
            return base64ToBytes$1(string).length
          default:
            if (loweredCase) return utf8ToBytes$1(string).length // assume utf8
            encoding = ('' + encoding).toLowerCase();
            loweredCase = true;
        }
      }
    }
    Buffer$3.byteLength = byteLength$1;

    function slowToString$1 (encoding, start, end) {
      var loweredCase = false;

      // No need to verify that "this.length <= MAX_UINT32" since it's a read-only
      // property of a typed array.

      // This behaves neither like String nor Uint8Array in that we set start/end
      // to their upper/lower bounds if the value passed is out of range.
      // undefined is handled specially as per ECMA-262 6th Edition,
      // Section 13.3.3.7 Runtime Semantics: KeyedBindingInitialization.
      if (start === undefined || start < 0) {
        start = 0;
      }
      // Return early if start > this.length. Done here to prevent potential uint32
      // coercion fail below.
      if (start > this.length) {
        return ''
      }

      if (end === undefined || end > this.length) {
        end = this.length;
      }

      if (end <= 0) {
        return ''
      }

      // Force coersion to uint32. This will also coerce falsey/NaN values to 0.
      end >>>= 0;
      start >>>= 0;

      if (end <= start) {
        return ''
      }

      if (!encoding) encoding = 'utf8';

      while (true) {
        switch (encoding) {
          case 'hex':
            return hexSlice$1(this, start, end)

          case 'utf8':
          case 'utf-8':
            return utf8Slice$1(this, start, end)

          case 'ascii':
            return asciiSlice$1(this, start, end)

          case 'latin1':
          case 'binary':
            return latin1Slice$1(this, start, end)

          case 'base64':
            return base64Slice$1(this, start, end)

          case 'ucs2':
          case 'ucs-2':
          case 'utf16le':
          case 'utf-16le':
            return utf16leSlice$1(this, start, end)

          default:
            if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
            encoding = (encoding + '').toLowerCase();
            loweredCase = true;
        }
      }
    }

    // The property is used by `Buffer.isBuffer` and `is-buffer` (in Safari 5-7) to detect
    // Buffer instances.
    Buffer$3.prototype._isBuffer = true;

    function swap$1 (b, n, m) {
      var i = b[n];
      b[n] = b[m];
      b[m] = i;
    }

    Buffer$3.prototype.swap16 = function swap16 () {
      var len = this.length;
      if (len % 2 !== 0) {
        throw new RangeError('Buffer size must be a multiple of 16-bits')
      }
      for (var i = 0; i < len; i += 2) {
        swap$1(this, i, i + 1);
      }
      return this
    };

    Buffer$3.prototype.swap32 = function swap32 () {
      var len = this.length;
      if (len % 4 !== 0) {
        throw new RangeError('Buffer size must be a multiple of 32-bits')
      }
      for (var i = 0; i < len; i += 4) {
        swap$1(this, i, i + 3);
        swap$1(this, i + 1, i + 2);
      }
      return this
    };

    Buffer$3.prototype.swap64 = function swap64 () {
      var len = this.length;
      if (len % 8 !== 0) {
        throw new RangeError('Buffer size must be a multiple of 64-bits')
      }
      for (var i = 0; i < len; i += 8) {
        swap$1(this, i, i + 7);
        swap$1(this, i + 1, i + 6);
        swap$1(this, i + 2, i + 5);
        swap$1(this, i + 3, i + 4);
      }
      return this
    };

    Buffer$3.prototype.toString = function toString () {
      var length = this.length | 0;
      if (length === 0) return ''
      if (arguments.length === 0) return utf8Slice$1(this, 0, length)
      return slowToString$1.apply(this, arguments)
    };

    Buffer$3.prototype.equals = function equals (b) {
      if (!internalIsBuffer$1(b)) throw new TypeError('Argument must be a Buffer')
      if (this === b) return true
      return Buffer$3.compare(this, b) === 0
    };

    Buffer$3.prototype.inspect = function inspect () {
      var str = '';
      var max = INSPECT_MAX_BYTES$1;
      if (this.length > 0) {
        str = this.toString('hex', 0, max).match(/.{2}/g).join(' ');
        if (this.length > max) str += ' ... ';
      }
      return '<Buffer ' + str + '>'
    };

    Buffer$3.prototype.compare = function compare (target, start, end, thisStart, thisEnd) {
      if (!internalIsBuffer$1(target)) {
        throw new TypeError('Argument must be a Buffer')
      }

      if (start === undefined) {
        start = 0;
      }
      if (end === undefined) {
        end = target ? target.length : 0;
      }
      if (thisStart === undefined) {
        thisStart = 0;
      }
      if (thisEnd === undefined) {
        thisEnd = this.length;
      }

      if (start < 0 || end > target.length || thisStart < 0 || thisEnd > this.length) {
        throw new RangeError('out of range index')
      }

      if (thisStart >= thisEnd && start >= end) {
        return 0
      }
      if (thisStart >= thisEnd) {
        return -1
      }
      if (start >= end) {
        return 1
      }

      start >>>= 0;
      end >>>= 0;
      thisStart >>>= 0;
      thisEnd >>>= 0;

      if (this === target) return 0

      var x = thisEnd - thisStart;
      var y = end - start;
      var len = Math.min(x, y);

      var thisCopy = this.slice(thisStart, thisEnd);
      var targetCopy = target.slice(start, end);

      for (var i = 0; i < len; ++i) {
        if (thisCopy[i] !== targetCopy[i]) {
          x = thisCopy[i];
          y = targetCopy[i];
          break
        }
      }

      if (x < y) return -1
      if (y < x) return 1
      return 0
    };

    // Finds either the first index of `val` in `buffer` at offset >= `byteOffset`,
    // OR the last index of `val` in `buffer` at offset <= `byteOffset`.
    //
    // Arguments:
    // - buffer - a Buffer to search
    // - val - a string, Buffer, or number
    // - byteOffset - an index into `buffer`; will be clamped to an int32
    // - encoding - an optional encoding, relevant is val is a string
    // - dir - true for indexOf, false for lastIndexOf
    function bidirectionalIndexOf$1 (buffer, val, byteOffset, encoding, dir) {
      // Empty buffer means no match
      if (buffer.length === 0) return -1

      // Normalize byteOffset
      if (typeof byteOffset === 'string') {
        encoding = byteOffset;
        byteOffset = 0;
      } else if (byteOffset > 0x7fffffff) {
        byteOffset = 0x7fffffff;
      } else if (byteOffset < -0x80000000) {
        byteOffset = -0x80000000;
      }
      byteOffset = +byteOffset;  // Coerce to Number.
      if (isNaN(byteOffset)) {
        // byteOffset: it it's undefined, null, NaN, "foo", etc, search whole buffer
        byteOffset = dir ? 0 : (buffer.length - 1);
      }

      // Normalize byteOffset: negative offsets start from the end of the buffer
      if (byteOffset < 0) byteOffset = buffer.length + byteOffset;
      if (byteOffset >= buffer.length) {
        if (dir) return -1
        else byteOffset = buffer.length - 1;
      } else if (byteOffset < 0) {
        if (dir) byteOffset = 0;
        else return -1
      }

      // Normalize val
      if (typeof val === 'string') {
        val = Buffer$3.from(val, encoding);
      }

      // Finally, search either indexOf (if dir is true) or lastIndexOf
      if (internalIsBuffer$1(val)) {
        // Special case: looking for empty string/buffer always fails
        if (val.length === 0) {
          return -1
        }
        return arrayIndexOf$1(buffer, val, byteOffset, encoding, dir)
      } else if (typeof val === 'number') {
        val = val & 0xFF; // Search for a byte value [0-255]
        if (Buffer$3.TYPED_ARRAY_SUPPORT &&
            typeof Uint8Array.prototype.indexOf === 'function') {
          if (dir) {
            return Uint8Array.prototype.indexOf.call(buffer, val, byteOffset)
          } else {
            return Uint8Array.prototype.lastIndexOf.call(buffer, val, byteOffset)
          }
        }
        return arrayIndexOf$1(buffer, [ val ], byteOffset, encoding, dir)
      }

      throw new TypeError('val must be string, number or Buffer')
    }

    function arrayIndexOf$1 (arr, val, byteOffset, encoding, dir) {
      var indexSize = 1;
      var arrLength = arr.length;
      var valLength = val.length;

      if (encoding !== undefined) {
        encoding = String(encoding).toLowerCase();
        if (encoding === 'ucs2' || encoding === 'ucs-2' ||
            encoding === 'utf16le' || encoding === 'utf-16le') {
          if (arr.length < 2 || val.length < 2) {
            return -1
          }
          indexSize = 2;
          arrLength /= 2;
          valLength /= 2;
          byteOffset /= 2;
        }
      }

      function read (buf, i) {
        if (indexSize === 1) {
          return buf[i]
        } else {
          return buf.readUInt16BE(i * indexSize)
        }
      }

      var i;
      if (dir) {
        var foundIndex = -1;
        for (i = byteOffset; i < arrLength; i++) {
          if (read(arr, i) === read(val, foundIndex === -1 ? 0 : i - foundIndex)) {
            if (foundIndex === -1) foundIndex = i;
            if (i - foundIndex + 1 === valLength) return foundIndex * indexSize
          } else {
            if (foundIndex !== -1) i -= i - foundIndex;
            foundIndex = -1;
          }
        }
      } else {
        if (byteOffset + valLength > arrLength) byteOffset = arrLength - valLength;
        for (i = byteOffset; i >= 0; i--) {
          var found = true;
          for (var j = 0; j < valLength; j++) {
            if (read(arr, i + j) !== read(val, j)) {
              found = false;
              break
            }
          }
          if (found) return i
        }
      }

      return -1
    }

    Buffer$3.prototype.includes = function includes (val, byteOffset, encoding) {
      return this.indexOf(val, byteOffset, encoding) !== -1
    };

    Buffer$3.prototype.indexOf = function indexOf (val, byteOffset, encoding) {
      return bidirectionalIndexOf$1(this, val, byteOffset, encoding, true)
    };

    Buffer$3.prototype.lastIndexOf = function lastIndexOf (val, byteOffset, encoding) {
      return bidirectionalIndexOf$1(this, val, byteOffset, encoding, false)
    };

    function hexWrite$1 (buf, string, offset, length) {
      offset = Number(offset) || 0;
      var remaining = buf.length - offset;
      if (!length) {
        length = remaining;
      } else {
        length = Number(length);
        if (length > remaining) {
          length = remaining;
        }
      }

      // must be an even number of digits
      var strLen = string.length;
      if (strLen % 2 !== 0) throw new TypeError('Invalid hex string')

      if (length > strLen / 2) {
        length = strLen / 2;
      }
      for (var i = 0; i < length; ++i) {
        var parsed = parseInt(string.substr(i * 2, 2), 16);
        if (isNaN(parsed)) return i
        buf[offset + i] = parsed;
      }
      return i
    }

    function utf8Write$1 (buf, string, offset, length) {
      return blitBuffer$1(utf8ToBytes$1(string, buf.length - offset), buf, offset, length)
    }

    function asciiWrite$1 (buf, string, offset, length) {
      return blitBuffer$1(asciiToBytes$1(string), buf, offset, length)
    }

    function latin1Write$1 (buf, string, offset, length) {
      return asciiWrite$1(buf, string, offset, length)
    }

    function base64Write$1 (buf, string, offset, length) {
      return blitBuffer$1(base64ToBytes$1(string), buf, offset, length)
    }

    function ucs2Write$1 (buf, string, offset, length) {
      return blitBuffer$1(utf16leToBytes$1(string, buf.length - offset), buf, offset, length)
    }

    Buffer$3.prototype.write = function write (string, offset, length, encoding) {
      // Buffer#write(string)
      if (offset === undefined) {
        encoding = 'utf8';
        length = this.length;
        offset = 0;
      // Buffer#write(string, encoding)
      } else if (length === undefined && typeof offset === 'string') {
        encoding = offset;
        length = this.length;
        offset = 0;
      // Buffer#write(string, offset[, length][, encoding])
      } else if (isFinite(offset)) {
        offset = offset | 0;
        if (isFinite(length)) {
          length = length | 0;
          if (encoding === undefined) encoding = 'utf8';
        } else {
          encoding = length;
          length = undefined;
        }
      // legacy write(string, encoding, offset, length) - remove in v0.13
      } else {
        throw new Error(
          'Buffer.write(string, encoding, offset[, length]) is no longer supported'
        )
      }

      var remaining = this.length - offset;
      if (length === undefined || length > remaining) length = remaining;

      if ((string.length > 0 && (length < 0 || offset < 0)) || offset > this.length) {
        throw new RangeError('Attempt to write outside buffer bounds')
      }

      if (!encoding) encoding = 'utf8';

      var loweredCase = false;
      for (;;) {
        switch (encoding) {
          case 'hex':
            return hexWrite$1(this, string, offset, length)

          case 'utf8':
          case 'utf-8':
            return utf8Write$1(this, string, offset, length)

          case 'ascii':
            return asciiWrite$1(this, string, offset, length)

          case 'latin1':
          case 'binary':
            return latin1Write$1(this, string, offset, length)

          case 'base64':
            // Warning: maxLength not taken into account in base64Write
            return base64Write$1(this, string, offset, length)

          case 'ucs2':
          case 'ucs-2':
          case 'utf16le':
          case 'utf-16le':
            return ucs2Write$1(this, string, offset, length)

          default:
            if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
            encoding = ('' + encoding).toLowerCase();
            loweredCase = true;
        }
      }
    };

    Buffer$3.prototype.toJSON = function toJSON () {
      return {
        type: 'Buffer',
        data: Array.prototype.slice.call(this._arr || this, 0)
      }
    };

    function base64Slice$1 (buf, start, end) {
      if (start === 0 && end === buf.length) {
        return fromByteArray$1(buf)
      } else {
        return fromByteArray$1(buf.slice(start, end))
      }
    }

    function utf8Slice$1 (buf, start, end) {
      end = Math.min(buf.length, end);
      var res = [];

      var i = start;
      while (i < end) {
        var firstByte = buf[i];
        var codePoint = null;
        var bytesPerSequence = (firstByte > 0xEF) ? 4
          : (firstByte > 0xDF) ? 3
          : (firstByte > 0xBF) ? 2
          : 1;

        if (i + bytesPerSequence <= end) {
          var secondByte, thirdByte, fourthByte, tempCodePoint;

          switch (bytesPerSequence) {
            case 1:
              if (firstByte < 0x80) {
                codePoint = firstByte;
              }
              break
            case 2:
              secondByte = buf[i + 1];
              if ((secondByte & 0xC0) === 0x80) {
                tempCodePoint = (firstByte & 0x1F) << 0x6 | (secondByte & 0x3F);
                if (tempCodePoint > 0x7F) {
                  codePoint = tempCodePoint;
                }
              }
              break
            case 3:
              secondByte = buf[i + 1];
              thirdByte = buf[i + 2];
              if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80) {
                tempCodePoint = (firstByte & 0xF) << 0xC | (secondByte & 0x3F) << 0x6 | (thirdByte & 0x3F);
                if (tempCodePoint > 0x7FF && (tempCodePoint < 0xD800 || tempCodePoint > 0xDFFF)) {
                  codePoint = tempCodePoint;
                }
              }
              break
            case 4:
              secondByte = buf[i + 1];
              thirdByte = buf[i + 2];
              fourthByte = buf[i + 3];
              if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80 && (fourthByte & 0xC0) === 0x80) {
                tempCodePoint = (firstByte & 0xF) << 0x12 | (secondByte & 0x3F) << 0xC | (thirdByte & 0x3F) << 0x6 | (fourthByte & 0x3F);
                if (tempCodePoint > 0xFFFF && tempCodePoint < 0x110000) {
                  codePoint = tempCodePoint;
                }
              }
          }
        }

        if (codePoint === null) {
          // we did not generate a valid codePoint so insert a
          // replacement char (U+FFFD) and advance only 1 byte
          codePoint = 0xFFFD;
          bytesPerSequence = 1;
        } else if (codePoint > 0xFFFF) {
          // encode to utf16 (surrogate pair dance)
          codePoint -= 0x10000;
          res.push(codePoint >>> 10 & 0x3FF | 0xD800);
          codePoint = 0xDC00 | codePoint & 0x3FF;
        }

        res.push(codePoint);
        i += bytesPerSequence;
      }

      return decodeCodePointsArray$1(res)
    }

    // Based on http://stackoverflow.com/a/22747272/680742, the browser with
    // the lowest limit is Chrome, with 0x10000 args.
    // We go 1 magnitude less, for safety
    var MAX_ARGUMENTS_LENGTH$1 = 0x1000;

    function decodeCodePointsArray$1 (codePoints) {
      var len = codePoints.length;
      if (len <= MAX_ARGUMENTS_LENGTH$1) {
        return String.fromCharCode.apply(String, codePoints) // avoid extra slice()
      }

      // Decode in chunks to avoid "call stack size exceeded".
      var res = '';
      var i = 0;
      while (i < len) {
        res += String.fromCharCode.apply(
          String,
          codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH$1)
        );
      }
      return res
    }

    function asciiSlice$1 (buf, start, end) {
      var ret = '';
      end = Math.min(buf.length, end);

      for (var i = start; i < end; ++i) {
        ret += String.fromCharCode(buf[i] & 0x7F);
      }
      return ret
    }

    function latin1Slice$1 (buf, start, end) {
      var ret = '';
      end = Math.min(buf.length, end);

      for (var i = start; i < end; ++i) {
        ret += String.fromCharCode(buf[i]);
      }
      return ret
    }

    function hexSlice$1 (buf, start, end) {
      var len = buf.length;

      if (!start || start < 0) start = 0;
      if (!end || end < 0 || end > len) end = len;

      var out = '';
      for (var i = start; i < end; ++i) {
        out += toHex$2(buf[i]);
      }
      return out
    }

    function utf16leSlice$1 (buf, start, end) {
      var bytes = buf.slice(start, end);
      var res = '';
      for (var i = 0; i < bytes.length; i += 2) {
        res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256);
      }
      return res
    }

    Buffer$3.prototype.slice = function slice (start, end) {
      var len = this.length;
      start = ~~start;
      end = end === undefined ? len : ~~end;

      if (start < 0) {
        start += len;
        if (start < 0) start = 0;
      } else if (start > len) {
        start = len;
      }

      if (end < 0) {
        end += len;
        if (end < 0) end = 0;
      } else if (end > len) {
        end = len;
      }

      if (end < start) end = start;

      var newBuf;
      if (Buffer$3.TYPED_ARRAY_SUPPORT) {
        newBuf = this.subarray(start, end);
        newBuf.__proto__ = Buffer$3.prototype;
      } else {
        var sliceLen = end - start;
        newBuf = new Buffer$3(sliceLen, undefined);
        for (var i = 0; i < sliceLen; ++i) {
          newBuf[i] = this[i + start];
        }
      }

      return newBuf
    };

    /*
     * Need to make sure that buffer isn't trying to write out of bounds.
     */
    function checkOffset$1 (offset, ext, length) {
      if ((offset % 1) !== 0 || offset < 0) throw new RangeError('offset is not uint')
      if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length')
    }

    Buffer$3.prototype.readUIntLE = function readUIntLE (offset, byteLength, noAssert) {
      offset = offset | 0;
      byteLength = byteLength | 0;
      if (!noAssert) checkOffset$1(offset, byteLength, this.length);

      var val = this[offset];
      var mul = 1;
      var i = 0;
      while (++i < byteLength && (mul *= 0x100)) {
        val += this[offset + i] * mul;
      }

      return val
    };

    Buffer$3.prototype.readUIntBE = function readUIntBE (offset, byteLength, noAssert) {
      offset = offset | 0;
      byteLength = byteLength | 0;
      if (!noAssert) {
        checkOffset$1(offset, byteLength, this.length);
      }

      var val = this[offset + --byteLength];
      var mul = 1;
      while (byteLength > 0 && (mul *= 0x100)) {
        val += this[offset + --byteLength] * mul;
      }

      return val
    };

    Buffer$3.prototype.readUInt8 = function readUInt8 (offset, noAssert) {
      if (!noAssert) checkOffset$1(offset, 1, this.length);
      return this[offset]
    };

    Buffer$3.prototype.readUInt16LE = function readUInt16LE (offset, noAssert) {
      if (!noAssert) checkOffset$1(offset, 2, this.length);
      return this[offset] | (this[offset + 1] << 8)
    };

    Buffer$3.prototype.readUInt16BE = function readUInt16BE (offset, noAssert) {
      if (!noAssert) checkOffset$1(offset, 2, this.length);
      return (this[offset] << 8) | this[offset + 1]
    };

    Buffer$3.prototype.readUInt32LE = function readUInt32LE (offset, noAssert) {
      if (!noAssert) checkOffset$1(offset, 4, this.length);

      return ((this[offset]) |
          (this[offset + 1] << 8) |
          (this[offset + 2] << 16)) +
          (this[offset + 3] * 0x1000000)
    };

    Buffer$3.prototype.readUInt32BE = function readUInt32BE (offset, noAssert) {
      if (!noAssert) checkOffset$1(offset, 4, this.length);

      return (this[offset] * 0x1000000) +
        ((this[offset + 1] << 16) |
        (this[offset + 2] << 8) |
        this[offset + 3])
    };

    Buffer$3.prototype.readIntLE = function readIntLE (offset, byteLength, noAssert) {
      offset = offset | 0;
      byteLength = byteLength | 0;
      if (!noAssert) checkOffset$1(offset, byteLength, this.length);

      var val = this[offset];
      var mul = 1;
      var i = 0;
      while (++i < byteLength && (mul *= 0x100)) {
        val += this[offset + i] * mul;
      }
      mul *= 0x80;

      if (val >= mul) val -= Math.pow(2, 8 * byteLength);

      return val
    };

    Buffer$3.prototype.readIntBE = function readIntBE (offset, byteLength, noAssert) {
      offset = offset | 0;
      byteLength = byteLength | 0;
      if (!noAssert) checkOffset$1(offset, byteLength, this.length);

      var i = byteLength;
      var mul = 1;
      var val = this[offset + --i];
      while (i > 0 && (mul *= 0x100)) {
        val += this[offset + --i] * mul;
      }
      mul *= 0x80;

      if (val >= mul) val -= Math.pow(2, 8 * byteLength);

      return val
    };

    Buffer$3.prototype.readInt8 = function readInt8 (offset, noAssert) {
      if (!noAssert) checkOffset$1(offset, 1, this.length);
      if (!(this[offset] & 0x80)) return (this[offset])
      return ((0xff - this[offset] + 1) * -1)
    };

    Buffer$3.prototype.readInt16LE = function readInt16LE (offset, noAssert) {
      if (!noAssert) checkOffset$1(offset, 2, this.length);
      var val = this[offset] | (this[offset + 1] << 8);
      return (val & 0x8000) ? val | 0xFFFF0000 : val
    };

    Buffer$3.prototype.readInt16BE = function readInt16BE (offset, noAssert) {
      if (!noAssert) checkOffset$1(offset, 2, this.length);
      var val = this[offset + 1] | (this[offset] << 8);
      return (val & 0x8000) ? val | 0xFFFF0000 : val
    };

    Buffer$3.prototype.readInt32LE = function readInt32LE (offset, noAssert) {
      if (!noAssert) checkOffset$1(offset, 4, this.length);

      return (this[offset]) |
        (this[offset + 1] << 8) |
        (this[offset + 2] << 16) |
        (this[offset + 3] << 24)
    };

    Buffer$3.prototype.readInt32BE = function readInt32BE (offset, noAssert) {
      if (!noAssert) checkOffset$1(offset, 4, this.length);

      return (this[offset] << 24) |
        (this[offset + 1] << 16) |
        (this[offset + 2] << 8) |
        (this[offset + 3])
    };

    Buffer$3.prototype.readFloatLE = function readFloatLE (offset, noAssert) {
      if (!noAssert) checkOffset$1(offset, 4, this.length);
      return read$1(this, offset, true, 23, 4)
    };

    Buffer$3.prototype.readFloatBE = function readFloatBE (offset, noAssert) {
      if (!noAssert) checkOffset$1(offset, 4, this.length);
      return read$1(this, offset, false, 23, 4)
    };

    Buffer$3.prototype.readDoubleLE = function readDoubleLE (offset, noAssert) {
      if (!noAssert) checkOffset$1(offset, 8, this.length);
      return read$1(this, offset, true, 52, 8)
    };

    Buffer$3.prototype.readDoubleBE = function readDoubleBE (offset, noAssert) {
      if (!noAssert) checkOffset$1(offset, 8, this.length);
      return read$1(this, offset, false, 52, 8)
    };

    function checkInt$1 (buf, value, offset, ext, max, min) {
      if (!internalIsBuffer$1(buf)) throw new TypeError('"buffer" argument must be a Buffer instance')
      if (value > max || value < min) throw new RangeError('"value" argument is out of bounds')
      if (offset + ext > buf.length) throw new RangeError('Index out of range')
    }

    Buffer$3.prototype.writeUIntLE = function writeUIntLE (value, offset, byteLength, noAssert) {
      value = +value;
      offset = offset | 0;
      byteLength = byteLength | 0;
      if (!noAssert) {
        var maxBytes = Math.pow(2, 8 * byteLength) - 1;
        checkInt$1(this, value, offset, byteLength, maxBytes, 0);
      }

      var mul = 1;
      var i = 0;
      this[offset] = value & 0xFF;
      while (++i < byteLength && (mul *= 0x100)) {
        this[offset + i] = (value / mul) & 0xFF;
      }

      return offset + byteLength
    };

    Buffer$3.prototype.writeUIntBE = function writeUIntBE (value, offset, byteLength, noAssert) {
      value = +value;
      offset = offset | 0;
      byteLength = byteLength | 0;
      if (!noAssert) {
        var maxBytes = Math.pow(2, 8 * byteLength) - 1;
        checkInt$1(this, value, offset, byteLength, maxBytes, 0);
      }

      var i = byteLength - 1;
      var mul = 1;
      this[offset + i] = value & 0xFF;
      while (--i >= 0 && (mul *= 0x100)) {
        this[offset + i] = (value / mul) & 0xFF;
      }

      return offset + byteLength
    };

    Buffer$3.prototype.writeUInt8 = function writeUInt8 (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt$1(this, value, offset, 1, 0xff, 0);
      if (!Buffer$3.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
      this[offset] = (value & 0xff);
      return offset + 1
    };

    function objectWriteUInt16$1 (buf, value, offset, littleEndian) {
      if (value < 0) value = 0xffff + value + 1;
      for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; ++i) {
        buf[offset + i] = (value & (0xff << (8 * (littleEndian ? i : 1 - i)))) >>>
          (littleEndian ? i : 1 - i) * 8;
      }
    }

    Buffer$3.prototype.writeUInt16LE = function writeUInt16LE (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt$1(this, value, offset, 2, 0xffff, 0);
      if (Buffer$3.TYPED_ARRAY_SUPPORT) {
        this[offset] = (value & 0xff);
        this[offset + 1] = (value >>> 8);
      } else {
        objectWriteUInt16$1(this, value, offset, true);
      }
      return offset + 2
    };

    Buffer$3.prototype.writeUInt16BE = function writeUInt16BE (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt$1(this, value, offset, 2, 0xffff, 0);
      if (Buffer$3.TYPED_ARRAY_SUPPORT) {
        this[offset] = (value >>> 8);
        this[offset + 1] = (value & 0xff);
      } else {
        objectWriteUInt16$1(this, value, offset, false);
      }
      return offset + 2
    };

    function objectWriteUInt32$1 (buf, value, offset, littleEndian) {
      if (value < 0) value = 0xffffffff + value + 1;
      for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; ++i) {
        buf[offset + i] = (value >>> (littleEndian ? i : 3 - i) * 8) & 0xff;
      }
    }

    Buffer$3.prototype.writeUInt32LE = function writeUInt32LE (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt$1(this, value, offset, 4, 0xffffffff, 0);
      if (Buffer$3.TYPED_ARRAY_SUPPORT) {
        this[offset + 3] = (value >>> 24);
        this[offset + 2] = (value >>> 16);
        this[offset + 1] = (value >>> 8);
        this[offset] = (value & 0xff);
      } else {
        objectWriteUInt32$1(this, value, offset, true);
      }
      return offset + 4
    };

    Buffer$3.prototype.writeUInt32BE = function writeUInt32BE (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt$1(this, value, offset, 4, 0xffffffff, 0);
      if (Buffer$3.TYPED_ARRAY_SUPPORT) {
        this[offset] = (value >>> 24);
        this[offset + 1] = (value >>> 16);
        this[offset + 2] = (value >>> 8);
        this[offset + 3] = (value & 0xff);
      } else {
        objectWriteUInt32$1(this, value, offset, false);
      }
      return offset + 4
    };

    Buffer$3.prototype.writeIntLE = function writeIntLE (value, offset, byteLength, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) {
        var limit = Math.pow(2, 8 * byteLength - 1);

        checkInt$1(this, value, offset, byteLength, limit - 1, -limit);
      }

      var i = 0;
      var mul = 1;
      var sub = 0;
      this[offset] = value & 0xFF;
      while (++i < byteLength && (mul *= 0x100)) {
        if (value < 0 && sub === 0 && this[offset + i - 1] !== 0) {
          sub = 1;
        }
        this[offset + i] = ((value / mul) >> 0) - sub & 0xFF;
      }

      return offset + byteLength
    };

    Buffer$3.prototype.writeIntBE = function writeIntBE (value, offset, byteLength, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) {
        var limit = Math.pow(2, 8 * byteLength - 1);

        checkInt$1(this, value, offset, byteLength, limit - 1, -limit);
      }

      var i = byteLength - 1;
      var mul = 1;
      var sub = 0;
      this[offset + i] = value & 0xFF;
      while (--i >= 0 && (mul *= 0x100)) {
        if (value < 0 && sub === 0 && this[offset + i + 1] !== 0) {
          sub = 1;
        }
        this[offset + i] = ((value / mul) >> 0) - sub & 0xFF;
      }

      return offset + byteLength
    };

    Buffer$3.prototype.writeInt8 = function writeInt8 (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt$1(this, value, offset, 1, 0x7f, -0x80);
      if (!Buffer$3.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
      if (value < 0) value = 0xff + value + 1;
      this[offset] = (value & 0xff);
      return offset + 1
    };

    Buffer$3.prototype.writeInt16LE = function writeInt16LE (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt$1(this, value, offset, 2, 0x7fff, -0x8000);
      if (Buffer$3.TYPED_ARRAY_SUPPORT) {
        this[offset] = (value & 0xff);
        this[offset + 1] = (value >>> 8);
      } else {
        objectWriteUInt16$1(this, value, offset, true);
      }
      return offset + 2
    };

    Buffer$3.prototype.writeInt16BE = function writeInt16BE (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt$1(this, value, offset, 2, 0x7fff, -0x8000);
      if (Buffer$3.TYPED_ARRAY_SUPPORT) {
        this[offset] = (value >>> 8);
        this[offset + 1] = (value & 0xff);
      } else {
        objectWriteUInt16$1(this, value, offset, false);
      }
      return offset + 2
    };

    Buffer$3.prototype.writeInt32LE = function writeInt32LE (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt$1(this, value, offset, 4, 0x7fffffff, -0x80000000);
      if (Buffer$3.TYPED_ARRAY_SUPPORT) {
        this[offset] = (value & 0xff);
        this[offset + 1] = (value >>> 8);
        this[offset + 2] = (value >>> 16);
        this[offset + 3] = (value >>> 24);
      } else {
        objectWriteUInt32$1(this, value, offset, true);
      }
      return offset + 4
    };

    Buffer$3.prototype.writeInt32BE = function writeInt32BE (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt$1(this, value, offset, 4, 0x7fffffff, -0x80000000);
      if (value < 0) value = 0xffffffff + value + 1;
      if (Buffer$3.TYPED_ARRAY_SUPPORT) {
        this[offset] = (value >>> 24);
        this[offset + 1] = (value >>> 16);
        this[offset + 2] = (value >>> 8);
        this[offset + 3] = (value & 0xff);
      } else {
        objectWriteUInt32$1(this, value, offset, false);
      }
      return offset + 4
    };

    function checkIEEE754$1 (buf, value, offset, ext, max, min) {
      if (offset + ext > buf.length) throw new RangeError('Index out of range')
      if (offset < 0) throw new RangeError('Index out of range')
    }

    function writeFloat$1 (buf, value, offset, littleEndian, noAssert) {
      if (!noAssert) {
        checkIEEE754$1(buf, value, offset, 4);
      }
      write$1(buf, value, offset, littleEndian, 23, 4);
      return offset + 4
    }

    Buffer$3.prototype.writeFloatLE = function writeFloatLE (value, offset, noAssert) {
      return writeFloat$1(this, value, offset, true, noAssert)
    };

    Buffer$3.prototype.writeFloatBE = function writeFloatBE (value, offset, noAssert) {
      return writeFloat$1(this, value, offset, false, noAssert)
    };

    function writeDouble$1 (buf, value, offset, littleEndian, noAssert) {
      if (!noAssert) {
        checkIEEE754$1(buf, value, offset, 8);
      }
      write$1(buf, value, offset, littleEndian, 52, 8);
      return offset + 8
    }

    Buffer$3.prototype.writeDoubleLE = function writeDoubleLE (value, offset, noAssert) {
      return writeDouble$1(this, value, offset, true, noAssert)
    };

    Buffer$3.prototype.writeDoubleBE = function writeDoubleBE (value, offset, noAssert) {
      return writeDouble$1(this, value, offset, false, noAssert)
    };

    // copy(targetBuffer, targetStart=0, sourceStart=0, sourceEnd=buffer.length)
    Buffer$3.prototype.copy = function copy (target, targetStart, start, end) {
      if (!start) start = 0;
      if (!end && end !== 0) end = this.length;
      if (targetStart >= target.length) targetStart = target.length;
      if (!targetStart) targetStart = 0;
      if (end > 0 && end < start) end = start;

      // Copy 0 bytes; we're done
      if (end === start) return 0
      if (target.length === 0 || this.length === 0) return 0

      // Fatal error conditions
      if (targetStart < 0) {
        throw new RangeError('targetStart out of bounds')
      }
      if (start < 0 || start >= this.length) throw new RangeError('sourceStart out of bounds')
      if (end < 0) throw new RangeError('sourceEnd out of bounds')

      // Are we oob?
      if (end > this.length) end = this.length;
      if (target.length - targetStart < end - start) {
        end = target.length - targetStart + start;
      }

      var len = end - start;
      var i;

      if (this === target && start < targetStart && targetStart < end) {
        // descending copy from end
        for (i = len - 1; i >= 0; --i) {
          target[i + targetStart] = this[i + start];
        }
      } else if (len < 1000 || !Buffer$3.TYPED_ARRAY_SUPPORT) {
        // ascending copy from start
        for (i = 0; i < len; ++i) {
          target[i + targetStart] = this[i + start];
        }
      } else {
        Uint8Array.prototype.set.call(
          target,
          this.subarray(start, start + len),
          targetStart
        );
      }

      return len
    };

    // Usage:
    //    buffer.fill(number[, offset[, end]])
    //    buffer.fill(buffer[, offset[, end]])
    //    buffer.fill(string[, offset[, end]][, encoding])
    Buffer$3.prototype.fill = function fill (val, start, end, encoding) {
      // Handle string cases:
      if (typeof val === 'string') {
        if (typeof start === 'string') {
          encoding = start;
          start = 0;
          end = this.length;
        } else if (typeof end === 'string') {
          encoding = end;
          end = this.length;
        }
        if (val.length === 1) {
          var code = val.charCodeAt(0);
          if (code < 256) {
            val = code;
          }
        }
        if (encoding !== undefined && typeof encoding !== 'string') {
          throw new TypeError('encoding must be a string')
        }
        if (typeof encoding === 'string' && !Buffer$3.isEncoding(encoding)) {
          throw new TypeError('Unknown encoding: ' + encoding)
        }
      } else if (typeof val === 'number') {
        val = val & 255;
      }

      // Invalid ranges are not set to a default, so can range check early.
      if (start < 0 || this.length < start || this.length < end) {
        throw new RangeError('Out of range index')
      }

      if (end <= start) {
        return this
      }

      start = start >>> 0;
      end = end === undefined ? this.length : end >>> 0;

      if (!val) val = 0;

      var i;
      if (typeof val === 'number') {
        for (i = start; i < end; ++i) {
          this[i] = val;
        }
      } else {
        var bytes = internalIsBuffer$1(val)
          ? val
          : utf8ToBytes$1(new Buffer$3(val, encoding).toString());
        var len = bytes.length;
        for (i = 0; i < end - start; ++i) {
          this[i + start] = bytes[i % len];
        }
      }

      return this
    };

    // HELPER FUNCTIONS
    // ================

    var INVALID_BASE64_RE$1 = /[^+\/0-9A-Za-z-_]/g;

    function base64clean$1 (str) {
      // Node strips out invalid characters like \n and \t from the string, base64-js does not
      str = stringtrim$1(str).replace(INVALID_BASE64_RE$1, '');
      // Node converts strings with length < 2 to ''
      if (str.length < 2) return ''
      // Node allows for non-padded base64 strings (missing trailing ===), base64-js does not
      while (str.length % 4 !== 0) {
        str = str + '=';
      }
      return str
    }

    function stringtrim$1 (str) {
      if (str.trim) return str.trim()
      return str.replace(/^\s+|\s+$/g, '')
    }

    function toHex$2 (n) {
      if (n < 16) return '0' + n.toString(16)
      return n.toString(16)
    }

    function utf8ToBytes$1 (string, units) {
      units = units || Infinity;
      var codePoint;
      var length = string.length;
      var leadSurrogate = null;
      var bytes = [];

      for (var i = 0; i < length; ++i) {
        codePoint = string.charCodeAt(i);

        // is surrogate component
        if (codePoint > 0xD7FF && codePoint < 0xE000) {
          // last char was a lead
          if (!leadSurrogate) {
            // no lead yet
            if (codePoint > 0xDBFF) {
              // unexpected trail
              if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
              continue
            } else if (i + 1 === length) {
              // unpaired lead
              if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
              continue
            }

            // valid lead
            leadSurrogate = codePoint;

            continue
          }

          // 2 leads in a row
          if (codePoint < 0xDC00) {
            if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
            leadSurrogate = codePoint;
            continue
          }

          // valid surrogate pair
          codePoint = (leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00) + 0x10000;
        } else if (leadSurrogate) {
          // valid bmp char, but last char was a lead
          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
        }

        leadSurrogate = null;

        // encode utf8
        if (codePoint < 0x80) {
          if ((units -= 1) < 0) break
          bytes.push(codePoint);
        } else if (codePoint < 0x800) {
          if ((units -= 2) < 0) break
          bytes.push(
            codePoint >> 0x6 | 0xC0,
            codePoint & 0x3F | 0x80
          );
        } else if (codePoint < 0x10000) {
          if ((units -= 3) < 0) break
          bytes.push(
            codePoint >> 0xC | 0xE0,
            codePoint >> 0x6 & 0x3F | 0x80,
            codePoint & 0x3F | 0x80
          );
        } else if (codePoint < 0x110000) {
          if ((units -= 4) < 0) break
          bytes.push(
            codePoint >> 0x12 | 0xF0,
            codePoint >> 0xC & 0x3F | 0x80,
            codePoint >> 0x6 & 0x3F | 0x80,
            codePoint & 0x3F | 0x80
          );
        } else {
          throw new Error('Invalid code point')
        }
      }

      return bytes
    }

    function asciiToBytes$1 (str) {
      var byteArray = [];
      for (var i = 0; i < str.length; ++i) {
        // Node's code seems to be doing this and not & 0x7F..
        byteArray.push(str.charCodeAt(i) & 0xFF);
      }
      return byteArray
    }

    function utf16leToBytes$1 (str, units) {
      var c, hi, lo;
      var byteArray = [];
      for (var i = 0; i < str.length; ++i) {
        if ((units -= 2) < 0) break

        c = str.charCodeAt(i);
        hi = c >> 8;
        lo = c % 256;
        byteArray.push(lo);
        byteArray.push(hi);
      }

      return byteArray
    }


    function base64ToBytes$1 (str) {
      return toByteArray$1(base64clean$1(str))
    }

    function blitBuffer$1 (src, dst, offset, length) {
      for (var i = 0; i < length; ++i) {
        if ((i + offset >= dst.length) || (i >= src.length)) break
        dst[i + offset] = src[i];
      }
      return i
    }

    function isnan$1 (val) {
      return val !== val // eslint-disable-line no-self-compare
    }


    // the following is from is-buffer, also by Feross Aboukhadijeh and with same lisence
    // The _isBuffer check is for Safari 5-7 support, because it's missing
    // Object.prototype.constructor. Remove this eventually
    function isBuffer$1(obj) {
      return obj != null && (!!obj._isBuffer || isFastBuffer$1(obj) || isSlowBuffer$1(obj))
    }

    function isFastBuffer$1 (obj) {
      return !!obj.constructor && typeof obj.constructor.isBuffer === 'function' && obj.constructor.isBuffer(obj)
    }

    // For Node v0.10 support. Remove this eventually.
    function isSlowBuffer$1 (obj) {
      return typeof obj.readFloatLE === 'function' && typeof obj.slice === 'function' && isFastBuffer$1(obj.slice(0, 0))
    }

    // shim for using process in browser
    // based off https://github.com/defunctzombie/node-process/blob/master/browser.js

    function defaultSetTimout$1() {
        throw new Error('setTimeout has not been defined');
    }
    function defaultClearTimeout$1 () {
        throw new Error('clearTimeout has not been defined');
    }
    var cachedSetTimeout$1 = defaultSetTimout$1;
    var cachedClearTimeout$1 = defaultClearTimeout$1;
    if (typeof global$1.setTimeout === 'function') {
        cachedSetTimeout$1 = setTimeout;
    }
    if (typeof global$1.clearTimeout === 'function') {
        cachedClearTimeout$1 = clearTimeout;
    }

    function runTimeout$1(fun) {
        if (cachedSetTimeout$1 === setTimeout) {
            //normal enviroments in sane situations
            return setTimeout(fun, 0);
        }
        // if setTimeout wasn't available but was latter defined
        if ((cachedSetTimeout$1 === defaultSetTimout$1 || !cachedSetTimeout$1) && setTimeout) {
            cachedSetTimeout$1 = setTimeout;
            return setTimeout(fun, 0);
        }
        try {
            // when when somebody has screwed with setTimeout but no I.E. maddness
            return cachedSetTimeout$1(fun, 0);
        } catch(e){
            try {
                // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
                return cachedSetTimeout$1.call(null, fun, 0);
            } catch(e){
                // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
                return cachedSetTimeout$1.call(this, fun, 0);
            }
        }


    }
    function runClearTimeout$1(marker) {
        if (cachedClearTimeout$1 === clearTimeout) {
            //normal enviroments in sane situations
            return clearTimeout(marker);
        }
        // if clearTimeout wasn't available but was latter defined
        if ((cachedClearTimeout$1 === defaultClearTimeout$1 || !cachedClearTimeout$1) && clearTimeout) {
            cachedClearTimeout$1 = clearTimeout;
            return clearTimeout(marker);
        }
        try {
            // when when somebody has screwed with setTimeout but no I.E. maddness
            return cachedClearTimeout$1(marker);
        } catch (e){
            try {
                // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
                return cachedClearTimeout$1.call(null, marker);
            } catch (e){
                // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
                // Some versions of I.E. have different rules for clearTimeout vs setTimeout
                return cachedClearTimeout$1.call(this, marker);
            }
        }



    }
    var queue$1 = [];
    var draining$1 = false;
    var currentQueue$1;
    var queueIndex$1 = -1;

    function cleanUpNextTick$1() {
        if (!draining$1 || !currentQueue$1) {
            return;
        }
        draining$1 = false;
        if (currentQueue$1.length) {
            queue$1 = currentQueue$1.concat(queue$1);
        } else {
            queueIndex$1 = -1;
        }
        if (queue$1.length) {
            drainQueue$1();
        }
    }

    function drainQueue$1() {
        if (draining$1) {
            return;
        }
        var timeout = runTimeout$1(cleanUpNextTick$1);
        draining$1 = true;

        var len = queue$1.length;
        while(len) {
            currentQueue$1 = queue$1;
            queue$1 = [];
            while (++queueIndex$1 < len) {
                if (currentQueue$1) {
                    currentQueue$1[queueIndex$1].run();
                }
            }
            queueIndex$1 = -1;
            len = queue$1.length;
        }
        currentQueue$1 = null;
        draining$1 = false;
        runClearTimeout$1(timeout);
    }
    function nextTick$1(fun) {
        var args = new Array(arguments.length - 1);
        if (arguments.length > 1) {
            for (var i = 1; i < arguments.length; i++) {
                args[i - 1] = arguments[i];
            }
        }
        queue$1.push(new Item$1(fun, args));
        if (queue$1.length === 1 && !draining$1) {
            runTimeout$1(drainQueue$1);
        }
    }
    // v8 likes predictible objects
    function Item$1(fun, array) {
        this.fun = fun;
        this.array = array;
    }
    Item$1.prototype.run = function () {
        this.fun.apply(null, this.array);
    };
    var title$1 = 'browser';
    var platform$1 = 'browser';
    var browser$2 = true;
    var env$1 = {};
    var argv$1 = [];
    var version$2 = ''; // empty string to avoid regexp issues
    var versions$1 = {};
    var release$1 = {};
    var config$1 = {};

    function noop$1() {}

    var on$1 = noop$1;
    var addListener$1 = noop$1;
    var once$1 = noop$1;
    var off$1 = noop$1;
    var removeListener$1 = noop$1;
    var removeAllListeners$1 = noop$1;
    var emit$1 = noop$1;

    function binding$2(name) {
        throw new Error('process.binding is not supported');
    }

    function cwd$1 () { return '/' }
    function chdir$1 (dir) {
        throw new Error('process.chdir is not supported');
    }function umask$1() { return 0; }

    // from https://github.com/kumavis/browser-process-hrtime/blob/master/index.js
    var performance$1 = global$1.performance || {};
    var performanceNow$1 =
      performance$1.now        ||
      performance$1.mozNow     ||
      performance$1.msNow      ||
      performance$1.oNow       ||
      performance$1.webkitNow  ||
      function(){ return (new Date()).getTime() };

    // generate timestamp or delta
    // see http://nodejs.org/api/process.html#process_process_hrtime
    function hrtime$1(previousTimestamp){
      var clocktime = performanceNow$1.call(performance$1)*1e-3;
      var seconds = Math.floor(clocktime);
      var nanoseconds = Math.floor((clocktime%1)*1e9);
      if (previousTimestamp) {
        seconds = seconds - previousTimestamp[0];
        nanoseconds = nanoseconds - previousTimestamp[1];
        if (nanoseconds<0) {
          seconds--;
          nanoseconds += 1e9;
        }
      }
      return [seconds,nanoseconds]
    }

    var startTime$1 = new Date();
    function uptime$1() {
      var currentTime = new Date();
      var dif = currentTime - startTime$1;
      return dif / 1000;
    }

    var browser$1$1 = {
      nextTick: nextTick$1,
      title: title$1,
      browser: browser$2,
      env: env$1,
      argv: argv$1,
      version: version$2,
      versions: versions$1,
      on: on$1,
      addListener: addListener$1,
      once: once$1,
      off: off$1,
      removeListener: removeListener$1,
      removeAllListeners: removeAllListeners$1,
      emit: emit$1,
      binding: binding$2,
      cwd: cwd$1,
      chdir: chdir$1,
      umask: umask$1,
      hrtime: hrtime$1,
      platform: platform$1,
      release: release$1,
      config: config$1,
      uptime: uptime$1
    };

    var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

    function getAugmentedNamespace(n) {
      var f = n.default;
    	if (typeof f == "function") {
    		var a = function () {
    			return f.apply(this, arguments);
    		};
    		a.prototype = f.prototype;
      } else a = {};
      Object.defineProperty(a, '__esModule', {value: true});
    	Object.keys(n).forEach(function (k) {
    		var d = Object.getOwnPropertyDescriptor(n, k);
    		Object.defineProperty(a, k, d.get ? d : {
    			enumerable: true,
    			get: function () {
    				return n[k];
    			}
    		});
    	});
    	return a;
    }

    var lib$1 = {exports: {}};

    var domain;

    // This constructor is used to store event handlers. Instantiating this is
    // faster than explicitly calling `Object.create(null)` to get a "clean" empty
    // object (tested with v8 v4.9).
    function EventHandlers() {}
    EventHandlers.prototype = Object.create(null);

    function EventEmitter() {
      EventEmitter.init.call(this);
    }

    // nodejs oddity
    // require('events') === require('events').EventEmitter
    EventEmitter.EventEmitter = EventEmitter;

    EventEmitter.usingDomains = false;

    EventEmitter.prototype.domain = undefined;
    EventEmitter.prototype._events = undefined;
    EventEmitter.prototype._maxListeners = undefined;

    // By default EventEmitters will print a warning if more than 10 listeners are
    // added to it. This is a useful default which helps finding memory leaks.
    EventEmitter.defaultMaxListeners = 10;

    EventEmitter.init = function() {
      this.domain = null;
      if (EventEmitter.usingDomains) {
        // if there is an active domain, then attach to it.
        if (domain.active ) ;
      }

      if (!this._events || this._events === Object.getPrototypeOf(this)._events) {
        this._events = new EventHandlers();
        this._eventsCount = 0;
      }

      this._maxListeners = this._maxListeners || undefined;
    };

    // Obviously not all Emitters should be limited to 10. This function allows
    // that to be increased. Set to zero for unlimited.
    EventEmitter.prototype.setMaxListeners = function setMaxListeners(n) {
      if (typeof n !== 'number' || n < 0 || isNaN(n))
        throw new TypeError('"n" argument must be a positive number');
      this._maxListeners = n;
      return this;
    };

    function $getMaxListeners(that) {
      if (that._maxListeners === undefined)
        return EventEmitter.defaultMaxListeners;
      return that._maxListeners;
    }

    EventEmitter.prototype.getMaxListeners = function getMaxListeners() {
      return $getMaxListeners(this);
    };

    // These standalone emit* functions are used to optimize calling of event
    // handlers for fast cases because emit() itself often has a variable number of
    // arguments and can be deoptimized because of that. These functions always have
    // the same number of arguments and thus do not get deoptimized, so the code
    // inside them can execute faster.
    function emitNone(handler, isFn, self) {
      if (isFn)
        handler.call(self);
      else {
        var len = handler.length;
        var listeners = arrayClone(handler, len);
        for (var i = 0; i < len; ++i)
          listeners[i].call(self);
      }
    }
    function emitOne(handler, isFn, self, arg1) {
      if (isFn)
        handler.call(self, arg1);
      else {
        var len = handler.length;
        var listeners = arrayClone(handler, len);
        for (var i = 0; i < len; ++i)
          listeners[i].call(self, arg1);
      }
    }
    function emitTwo(handler, isFn, self, arg1, arg2) {
      if (isFn)
        handler.call(self, arg1, arg2);
      else {
        var len = handler.length;
        var listeners = arrayClone(handler, len);
        for (var i = 0; i < len; ++i)
          listeners[i].call(self, arg1, arg2);
      }
    }
    function emitThree(handler, isFn, self, arg1, arg2, arg3) {
      if (isFn)
        handler.call(self, arg1, arg2, arg3);
      else {
        var len = handler.length;
        var listeners = arrayClone(handler, len);
        for (var i = 0; i < len; ++i)
          listeners[i].call(self, arg1, arg2, arg3);
      }
    }

    function emitMany(handler, isFn, self, args) {
      if (isFn)
        handler.apply(self, args);
      else {
        var len = handler.length;
        var listeners = arrayClone(handler, len);
        for (var i = 0; i < len; ++i)
          listeners[i].apply(self, args);
      }
    }

    EventEmitter.prototype.emit = function emit(type) {
      var er, handler, len, args, i, events, domain;
      var doError = (type === 'error');

      events = this._events;
      if (events)
        doError = (doError && events.error == null);
      else if (!doError)
        return false;

      domain = this.domain;

      // If there is no 'error' event listener then throw.
      if (doError) {
        er = arguments[1];
        if (domain) {
          if (!er)
            er = new Error('Uncaught, unspecified "error" event');
          er.domainEmitter = this;
          er.domain = domain;
          er.domainThrown = false;
          domain.emit('error', er);
        } else if (er instanceof Error) {
          throw er; // Unhandled 'error' event
        } else {
          // At least give some kind of context to the user
          var err = new Error('Uncaught, unspecified "error" event. (' + er + ')');
          err.context = er;
          throw err;
        }
        return false;
      }

      handler = events[type];

      if (!handler)
        return false;

      var isFn = typeof handler === 'function';
      len = arguments.length;
      switch (len) {
        // fast cases
        case 1:
          emitNone(handler, isFn, this);
          break;
        case 2:
          emitOne(handler, isFn, this, arguments[1]);
          break;
        case 3:
          emitTwo(handler, isFn, this, arguments[1], arguments[2]);
          break;
        case 4:
          emitThree(handler, isFn, this, arguments[1], arguments[2], arguments[3]);
          break;
        // slower
        default:
          args = new Array(len - 1);
          for (i = 1; i < len; i++)
            args[i - 1] = arguments[i];
          emitMany(handler, isFn, this, args);
      }

      return true;
    };

    function _addListener(target, type, listener, prepend) {
      var m;
      var events;
      var existing;

      if (typeof listener !== 'function')
        throw new TypeError('"listener" argument must be a function');

      events = target._events;
      if (!events) {
        events = target._events = new EventHandlers();
        target._eventsCount = 0;
      } else {
        // To avoid recursion in the case that type === "newListener"! Before
        // adding it to the listeners, first emit "newListener".
        if (events.newListener) {
          target.emit('newListener', type,
                      listener.listener ? listener.listener : listener);

          // Re-assign `events` because a newListener handler could have caused the
          // this._events to be assigned to a new object
          events = target._events;
        }
        existing = events[type];
      }

      if (!existing) {
        // Optimize the case of one listener. Don't need the extra array object.
        existing = events[type] = listener;
        ++target._eventsCount;
      } else {
        if (typeof existing === 'function') {
          // Adding the second element, need to change to array.
          existing = events[type] = prepend ? [listener, existing] :
                                              [existing, listener];
        } else {
          // If we've already got an array, just append.
          if (prepend) {
            existing.unshift(listener);
          } else {
            existing.push(listener);
          }
        }

        // Check for listener leak
        if (!existing.warned) {
          m = $getMaxListeners(target);
          if (m && m > 0 && existing.length > m) {
            existing.warned = true;
            var w = new Error('Possible EventEmitter memory leak detected. ' +
                                existing.length + ' ' + type + ' listeners added. ' +
                                'Use emitter.setMaxListeners() to increase limit');
            w.name = 'MaxListenersExceededWarning';
            w.emitter = target;
            w.type = type;
            w.count = existing.length;
            emitWarning(w);
          }
        }
      }

      return target;
    }
    function emitWarning(e) {
      typeof console.warn === 'function' ? console.warn(e) : console.log(e);
    }
    EventEmitter.prototype.addListener = function addListener(type, listener) {
      return _addListener(this, type, listener, false);
    };

    EventEmitter.prototype.on = EventEmitter.prototype.addListener;

    EventEmitter.prototype.prependListener =
        function prependListener(type, listener) {
          return _addListener(this, type, listener, true);
        };

    function _onceWrap(target, type, listener) {
      var fired = false;
      function g() {
        target.removeListener(type, g);
        if (!fired) {
          fired = true;
          listener.apply(target, arguments);
        }
      }
      g.listener = listener;
      return g;
    }

    EventEmitter.prototype.once = function once(type, listener) {
      if (typeof listener !== 'function')
        throw new TypeError('"listener" argument must be a function');
      this.on(type, _onceWrap(this, type, listener));
      return this;
    };

    EventEmitter.prototype.prependOnceListener =
        function prependOnceListener(type, listener) {
          if (typeof listener !== 'function')
            throw new TypeError('"listener" argument must be a function');
          this.prependListener(type, _onceWrap(this, type, listener));
          return this;
        };

    // emits a 'removeListener' event iff the listener was removed
    EventEmitter.prototype.removeListener =
        function removeListener(type, listener) {
          var list, events, position, i, originalListener;

          if (typeof listener !== 'function')
            throw new TypeError('"listener" argument must be a function');

          events = this._events;
          if (!events)
            return this;

          list = events[type];
          if (!list)
            return this;

          if (list === listener || (list.listener && list.listener === listener)) {
            if (--this._eventsCount === 0)
              this._events = new EventHandlers();
            else {
              delete events[type];
              if (events.removeListener)
                this.emit('removeListener', type, list.listener || listener);
            }
          } else if (typeof list !== 'function') {
            position = -1;

            for (i = list.length; i-- > 0;) {
              if (list[i] === listener ||
                  (list[i].listener && list[i].listener === listener)) {
                originalListener = list[i].listener;
                position = i;
                break;
              }
            }

            if (position < 0)
              return this;

            if (list.length === 1) {
              list[0] = undefined;
              if (--this._eventsCount === 0) {
                this._events = new EventHandlers();
                return this;
              } else {
                delete events[type];
              }
            } else {
              spliceOne(list, position);
            }

            if (events.removeListener)
              this.emit('removeListener', type, originalListener || listener);
          }

          return this;
        };

    EventEmitter.prototype.removeAllListeners =
        function removeAllListeners(type) {
          var listeners, events;

          events = this._events;
          if (!events)
            return this;

          // not listening for removeListener, no need to emit
          if (!events.removeListener) {
            if (arguments.length === 0) {
              this._events = new EventHandlers();
              this._eventsCount = 0;
            } else if (events[type]) {
              if (--this._eventsCount === 0)
                this._events = new EventHandlers();
              else
                delete events[type];
            }
            return this;
          }

          // emit removeListener for all listeners on all events
          if (arguments.length === 0) {
            var keys = Object.keys(events);
            for (var i = 0, key; i < keys.length; ++i) {
              key = keys[i];
              if (key === 'removeListener') continue;
              this.removeAllListeners(key);
            }
            this.removeAllListeners('removeListener');
            this._events = new EventHandlers();
            this._eventsCount = 0;
            return this;
          }

          listeners = events[type];

          if (typeof listeners === 'function') {
            this.removeListener(type, listeners);
          } else if (listeners) {
            // LIFO order
            do {
              this.removeListener(type, listeners[listeners.length - 1]);
            } while (listeners[0]);
          }

          return this;
        };

    EventEmitter.prototype.listeners = function listeners(type) {
      var evlistener;
      var ret;
      var events = this._events;

      if (!events)
        ret = [];
      else {
        evlistener = events[type];
        if (!evlistener)
          ret = [];
        else if (typeof evlistener === 'function')
          ret = [evlistener.listener || evlistener];
        else
          ret = unwrapListeners(evlistener);
      }

      return ret;
    };

    EventEmitter.listenerCount = function(emitter, type) {
      if (typeof emitter.listenerCount === 'function') {
        return emitter.listenerCount(type);
      } else {
        return listenerCount$1.call(emitter, type);
      }
    };

    EventEmitter.prototype.listenerCount = listenerCount$1;
    function listenerCount$1(type) {
      var events = this._events;

      if (events) {
        var evlistener = events[type];

        if (typeof evlistener === 'function') {
          return 1;
        } else if (evlistener) {
          return evlistener.length;
        }
      }

      return 0;
    }

    EventEmitter.prototype.eventNames = function eventNames() {
      return this._eventsCount > 0 ? Reflect.ownKeys(this._events) : [];
    };

    // About 1.5x faster than the two-arg version of Array#splice().
    function spliceOne(list, index) {
      for (var i = index, k = i + 1, n = list.length; k < n; i += 1, k += 1)
        list[i] = list[k];
      list.pop();
    }

    function arrayClone(arr, i) {
      var copy = new Array(i);
      while (i--)
        copy[i] = arr[i];
      return copy;
    }

    function unwrapListeners(arr) {
      var ret = new Array(arr.length);
      for (var i = 0; i < ret.length; ++i) {
        ret[i] = arr[i].listener || arr[i];
      }
      return ret;
    }

    // shim for using process in browser
    // based off https://github.com/defunctzombie/node-process/blob/master/browser.js

    function defaultSetTimout() {
        throw new Error('setTimeout has not been defined');
    }
    function defaultClearTimeout () {
        throw new Error('clearTimeout has not been defined');
    }
    var cachedSetTimeout = defaultSetTimout;
    var cachedClearTimeout = defaultClearTimeout;
    if (typeof global$1.setTimeout === 'function') {
        cachedSetTimeout = setTimeout;
    }
    if (typeof global$1.clearTimeout === 'function') {
        cachedClearTimeout = clearTimeout;
    }

    function runTimeout(fun) {
        if (cachedSetTimeout === setTimeout) {
            //normal enviroments in sane situations
            return setTimeout(fun, 0);
        }
        // if setTimeout wasn't available but was latter defined
        if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
            cachedSetTimeout = setTimeout;
            return setTimeout(fun, 0);
        }
        try {
            // when when somebody has screwed with setTimeout but no I.E. maddness
            return cachedSetTimeout(fun, 0);
        } catch(e){
            try {
                // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
                return cachedSetTimeout.call(null, fun, 0);
            } catch(e){
                // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
                return cachedSetTimeout.call(this, fun, 0);
            }
        }


    }
    function runClearTimeout(marker) {
        if (cachedClearTimeout === clearTimeout) {
            //normal enviroments in sane situations
            return clearTimeout(marker);
        }
        // if clearTimeout wasn't available but was latter defined
        if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
            cachedClearTimeout = clearTimeout;
            return clearTimeout(marker);
        }
        try {
            // when when somebody has screwed with setTimeout but no I.E. maddness
            return cachedClearTimeout(marker);
        } catch (e){
            try {
                // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
                return cachedClearTimeout.call(null, marker);
            } catch (e){
                // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
                // Some versions of I.E. have different rules for clearTimeout vs setTimeout
                return cachedClearTimeout.call(this, marker);
            }
        }



    }
    var queue = [];
    var draining = false;
    var currentQueue;
    var queueIndex = -1;

    function cleanUpNextTick() {
        if (!draining || !currentQueue) {
            return;
        }
        draining = false;
        if (currentQueue.length) {
            queue = currentQueue.concat(queue);
        } else {
            queueIndex = -1;
        }
        if (queue.length) {
            drainQueue();
        }
    }

    function drainQueue() {
        if (draining) {
            return;
        }
        var timeout = runTimeout(cleanUpNextTick);
        draining = true;

        var len = queue.length;
        while(len) {
            currentQueue = queue;
            queue = [];
            while (++queueIndex < len) {
                if (currentQueue) {
                    currentQueue[queueIndex].run();
                }
            }
            queueIndex = -1;
            len = queue.length;
        }
        currentQueue = null;
        draining = false;
        runClearTimeout(timeout);
    }
    function nextTick(fun) {
        var args = new Array(arguments.length - 1);
        if (arguments.length > 1) {
            for (var i = 1; i < arguments.length; i++) {
                args[i - 1] = arguments[i];
            }
        }
        queue.push(new Item(fun, args));
        if (queue.length === 1 && !draining) {
            runTimeout(drainQueue);
        }
    }
    // v8 likes predictible objects
    function Item(fun, array) {
        this.fun = fun;
        this.array = array;
    }
    Item.prototype.run = function () {
        this.fun.apply(null, this.array);
    };
    var title = 'browser';
    var platform = 'browser';
    var browser$1 = true;
    var env = {};
    var argv = [];
    var version$1 = ''; // empty string to avoid regexp issues
    var versions = {};
    var release = {};
    var config = {};

    function noop() {}

    var on = noop;
    var addListener = noop;
    var once = noop;
    var off = noop;
    var removeListener = noop;
    var removeAllListeners = noop;
    var emit = noop;

    function binding$1(name) {
        throw new Error('process.binding is not supported');
    }

    function cwd () { return '/' }
    function chdir (dir) {
        throw new Error('process.chdir is not supported');
    }function umask() { return 0; }

    // from https://github.com/kumavis/browser-process-hrtime/blob/master/index.js
    var performance = global$1.performance || {};
    var performanceNow =
      performance.now        ||
      performance.mozNow     ||
      performance.msNow      ||
      performance.oNow       ||
      performance.webkitNow  ||
      function(){ return (new Date()).getTime() };

    // generate timestamp or delta
    // see http://nodejs.org/api/process.html#process_process_hrtime
    function hrtime(previousTimestamp){
      var clocktime = performanceNow.call(performance)*1e-3;
      var seconds = Math.floor(clocktime);
      var nanoseconds = Math.floor((clocktime%1)*1e9);
      if (previousTimestamp) {
        seconds = seconds - previousTimestamp[0];
        nanoseconds = nanoseconds - previousTimestamp[1];
        if (nanoseconds<0) {
          seconds--;
          nanoseconds += 1e9;
        }
      }
      return [seconds,nanoseconds]
    }

    var startTime = new Date();
    function uptime() {
      var currentTime = new Date();
      var dif = currentTime - startTime;
      return dif / 1000;
    }

    var process = {
      nextTick: nextTick,
      title: title,
      browser: browser$1,
      env: env,
      argv: argv,
      version: version$1,
      versions: versions,
      on: on,
      addListener: addListener,
      once: once,
      off: off,
      removeListener: removeListener,
      removeAllListeners: removeAllListeners,
      emit: emit,
      binding: binding$1,
      cwd: cwd,
      chdir: chdir,
      umask: umask,
      hrtime: hrtime,
      platform: platform,
      release: release,
      config: config,
      uptime: uptime
    };

    var inherits;
    if (typeof Object.create === 'function'){
      inherits = function inherits(ctor, superCtor) {
        // implementation from standard node.js 'util' module
        ctor.super_ = superCtor;
        ctor.prototype = Object.create(superCtor.prototype, {
          constructor: {
            value: ctor,
            enumerable: false,
            writable: true,
            configurable: true
          }
        });
      };
    } else {
      inherits = function inherits(ctor, superCtor) {
        ctor.super_ = superCtor;
        var TempCtor = function () {};
        TempCtor.prototype = superCtor.prototype;
        ctor.prototype = new TempCtor();
        ctor.prototype.constructor = ctor;
      };
    }
    var inherits$1 = inherits;

    var formatRegExp = /%[sdj%]/g;
    function format$1(f) {
      if (!isString(f)) {
        var objects = [];
        for (var i = 0; i < arguments.length; i++) {
          objects.push(inspect(arguments[i]));
        }
        return objects.join(' ');
      }

      var i = 1;
      var args = arguments;
      var len = args.length;
      var str = String(f).replace(formatRegExp, function(x) {
        if (x === '%%') return '%';
        if (i >= len) return x;
        switch (x) {
          case '%s': return String(args[i++]);
          case '%d': return Number(args[i++]);
          case '%j':
            try {
              return JSON.stringify(args[i++]);
            } catch (_) {
              return '[Circular]';
            }
          default:
            return x;
        }
      });
      for (var x = args[i]; i < len; x = args[++i]) {
        if (isNull(x) || !isObject(x)) {
          str += ' ' + x;
        } else {
          str += ' ' + inspect(x);
        }
      }
      return str;
    }

    // Mark that a method should not be used.
    // Returns a modified function which warns once by default.
    // If --no-deprecation is set, then it is a no-op.
    function deprecate(fn, msg) {
      // Allow for deprecating things in the process of starting up.
      if (isUndefined(global$1.process)) {
        return function() {
          return deprecate(fn, msg).apply(this, arguments);
        };
      }

      if (process.noDeprecation === true) {
        return fn;
      }

      var warned = false;
      function deprecated() {
        if (!warned) {
          if (process.throwDeprecation) {
            throw new Error(msg);
          } else if (process.traceDeprecation) {
            console.trace(msg);
          } else {
            console.error(msg);
          }
          warned = true;
        }
        return fn.apply(this, arguments);
      }

      return deprecated;
    }

    var debugs = {};
    var debugEnviron;
    function debuglog(set) {
      if (isUndefined(debugEnviron))
        debugEnviron = process.env.NODE_DEBUG || '';
      set = set.toUpperCase();
      if (!debugs[set]) {
        if (new RegExp('\\b' + set + '\\b', 'i').test(debugEnviron)) {
          var pid = 0;
          debugs[set] = function() {
            var msg = format$1.apply(null, arguments);
            console.error('%s %d: %s', set, pid, msg);
          };
        } else {
          debugs[set] = function() {};
        }
      }
      return debugs[set];
    }

    /**
     * Echos the value of a value. Trys to print the value out
     * in the best way possible given the different types.
     *
     * @param {Object} obj The object to print out.
     * @param {Object} opts Optional options object that alters the output.
     */
    /* legacy: obj, showHidden, depth, colors*/
    function inspect(obj, opts) {
      // default options
      var ctx = {
        seen: [],
        stylize: stylizeNoColor
      };
      // legacy...
      if (arguments.length >= 3) ctx.depth = arguments[2];
      if (arguments.length >= 4) ctx.colors = arguments[3];
      if (isBoolean(opts)) {
        // legacy...
        ctx.showHidden = opts;
      } else if (opts) {
        // got an "options" object
        _extend(ctx, opts);
      }
      // set default options
      if (isUndefined(ctx.showHidden)) ctx.showHidden = false;
      if (isUndefined(ctx.depth)) ctx.depth = 2;
      if (isUndefined(ctx.colors)) ctx.colors = false;
      if (isUndefined(ctx.customInspect)) ctx.customInspect = true;
      if (ctx.colors) ctx.stylize = stylizeWithColor;
      return formatValue(ctx, obj, ctx.depth);
    }

    // http://en.wikipedia.org/wiki/ANSI_escape_code#graphics
    inspect.colors = {
      'bold' : [1, 22],
      'italic' : [3, 23],
      'underline' : [4, 24],
      'inverse' : [7, 27],
      'white' : [37, 39],
      'grey' : [90, 39],
      'black' : [30, 39],
      'blue' : [34, 39],
      'cyan' : [36, 39],
      'green' : [32, 39],
      'magenta' : [35, 39],
      'red' : [31, 39],
      'yellow' : [33, 39]
    };

    // Don't use 'blue' not visible on cmd.exe
    inspect.styles = {
      'special': 'cyan',
      'number': 'yellow',
      'boolean': 'yellow',
      'undefined': 'grey',
      'null': 'bold',
      'string': 'green',
      'date': 'magenta',
      // "name": intentionally not styling
      'regexp': 'red'
    };


    function stylizeWithColor(str, styleType) {
      var style = inspect.styles[styleType];

      if (style) {
        return '\u001b[' + inspect.colors[style][0] + 'm' + str +
               '\u001b[' + inspect.colors[style][1] + 'm';
      } else {
        return str;
      }
    }


    function stylizeNoColor(str, styleType) {
      return str;
    }


    function arrayToHash(array) {
      var hash = {};

      array.forEach(function(val, idx) {
        hash[val] = true;
      });

      return hash;
    }


    function formatValue(ctx, value, recurseTimes) {
      // Provide a hook for user-specified inspect functions.
      // Check that value is an object with an inspect function on it
      if (ctx.customInspect &&
          value &&
          isFunction$1(value.inspect) &&
          // Filter out the util module, it's inspect function is special
          value.inspect !== inspect &&
          // Also filter out any prototype objects using the circular check.
          !(value.constructor && value.constructor.prototype === value)) {
        var ret = value.inspect(recurseTimes, ctx);
        if (!isString(ret)) {
          ret = formatValue(ctx, ret, recurseTimes);
        }
        return ret;
      }

      // Primitive types cannot have properties
      var primitive = formatPrimitive(ctx, value);
      if (primitive) {
        return primitive;
      }

      // Look up the keys of the object.
      var keys = Object.keys(value);
      var visibleKeys = arrayToHash(keys);

      if (ctx.showHidden) {
        keys = Object.getOwnPropertyNames(value);
      }

      // IE doesn't make error fields non-enumerable
      // http://msdn.microsoft.com/en-us/library/ie/dww52sbt(v=vs.94).aspx
      if (isError(value)
          && (keys.indexOf('message') >= 0 || keys.indexOf('description') >= 0)) {
        return formatError(value);
      }

      // Some type of object without properties can be shortcutted.
      if (keys.length === 0) {
        if (isFunction$1(value)) {
          var name = value.name ? ': ' + value.name : '';
          return ctx.stylize('[Function' + name + ']', 'special');
        }
        if (isRegExp(value)) {
          return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
        }
        if (isDate(value)) {
          return ctx.stylize(Date.prototype.toString.call(value), 'date');
        }
        if (isError(value)) {
          return formatError(value);
        }
      }

      var base = '', array = false, braces = ['{', '}'];

      // Make Array say that they are Array
      if (isArray$2(value)) {
        array = true;
        braces = ['[', ']'];
      }

      // Make functions say that they are functions
      if (isFunction$1(value)) {
        var n = value.name ? ': ' + value.name : '';
        base = ' [Function' + n + ']';
      }

      // Make RegExps say that they are RegExps
      if (isRegExp(value)) {
        base = ' ' + RegExp.prototype.toString.call(value);
      }

      // Make dates with properties first say the date
      if (isDate(value)) {
        base = ' ' + Date.prototype.toUTCString.call(value);
      }

      // Make error with message first say the error
      if (isError(value)) {
        base = ' ' + formatError(value);
      }

      if (keys.length === 0 && (!array || value.length == 0)) {
        return braces[0] + base + braces[1];
      }

      if (recurseTimes < 0) {
        if (isRegExp(value)) {
          return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
        } else {
          return ctx.stylize('[Object]', 'special');
        }
      }

      ctx.seen.push(value);

      var output;
      if (array) {
        output = formatArray(ctx, value, recurseTimes, visibleKeys, keys);
      } else {
        output = keys.map(function(key) {
          return formatProperty(ctx, value, recurseTimes, visibleKeys, key, array);
        });
      }

      ctx.seen.pop();

      return reduceToSingleString(output, base, braces);
    }


    function formatPrimitive(ctx, value) {
      if (isUndefined(value))
        return ctx.stylize('undefined', 'undefined');
      if (isString(value)) {
        var simple = '\'' + JSON.stringify(value).replace(/^"|"$/g, '')
                                                 .replace(/'/g, "\\'")
                                                 .replace(/\\"/g, '"') + '\'';
        return ctx.stylize(simple, 'string');
      }
      if (isNumber(value))
        return ctx.stylize('' + value, 'number');
      if (isBoolean(value))
        return ctx.stylize('' + value, 'boolean');
      // For some reason typeof null is "object", so special case here.
      if (isNull(value))
        return ctx.stylize('null', 'null');
    }


    function formatError(value) {
      return '[' + Error.prototype.toString.call(value) + ']';
    }


    function formatArray(ctx, value, recurseTimes, visibleKeys, keys) {
      var output = [];
      for (var i = 0, l = value.length; i < l; ++i) {
        if (hasOwnProperty$1(value, String(i))) {
          output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
              String(i), true));
        } else {
          output.push('');
        }
      }
      keys.forEach(function(key) {
        if (!key.match(/^\d+$/)) {
          output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
              key, true));
        }
      });
      return output;
    }


    function formatProperty(ctx, value, recurseTimes, visibleKeys, key, array) {
      var name, str, desc;
      desc = Object.getOwnPropertyDescriptor(value, key) || { value: value[key] };
      if (desc.get) {
        if (desc.set) {
          str = ctx.stylize('[Getter/Setter]', 'special');
        } else {
          str = ctx.stylize('[Getter]', 'special');
        }
      } else {
        if (desc.set) {
          str = ctx.stylize('[Setter]', 'special');
        }
      }
      if (!hasOwnProperty$1(visibleKeys, key)) {
        name = '[' + key + ']';
      }
      if (!str) {
        if (ctx.seen.indexOf(desc.value) < 0) {
          if (isNull(recurseTimes)) {
            str = formatValue(ctx, desc.value, null);
          } else {
            str = formatValue(ctx, desc.value, recurseTimes - 1);
          }
          if (str.indexOf('\n') > -1) {
            if (array) {
              str = str.split('\n').map(function(line) {
                return '  ' + line;
              }).join('\n').substr(2);
            } else {
              str = '\n' + str.split('\n').map(function(line) {
                return '   ' + line;
              }).join('\n');
            }
          }
        } else {
          str = ctx.stylize('[Circular]', 'special');
        }
      }
      if (isUndefined(name)) {
        if (array && key.match(/^\d+$/)) {
          return str;
        }
        name = JSON.stringify('' + key);
        if (name.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
          name = name.substr(1, name.length - 2);
          name = ctx.stylize(name, 'name');
        } else {
          name = name.replace(/'/g, "\\'")
                     .replace(/\\"/g, '"')
                     .replace(/(^"|"$)/g, "'");
          name = ctx.stylize(name, 'string');
        }
      }

      return name + ': ' + str;
    }


    function reduceToSingleString(output, base, braces) {
      var length = output.reduce(function(prev, cur) {
        if (cur.indexOf('\n') >= 0) ;
        return prev + cur.replace(/\u001b\[\d\d?m/g, '').length + 1;
      }, 0);

      if (length > 60) {
        return braces[0] +
               (base === '' ? '' : base + '\n ') +
               ' ' +
               output.join(',\n  ') +
               ' ' +
               braces[1];
      }

      return braces[0] + base + ' ' + output.join(', ') + ' ' + braces[1];
    }


    // NOTE: These type checking functions intentionally don't use `instanceof`
    // because it is fragile and can be easily faked with `Object.create()`.
    function isArray$2(ar) {
      return Array.isArray(ar);
    }

    function isBoolean(arg) {
      return typeof arg === 'boolean';
    }

    function isNull(arg) {
      return arg === null;
    }

    function isNullOrUndefined(arg) {
      return arg == null;
    }

    function isNumber(arg) {
      return typeof arg === 'number';
    }

    function isString(arg) {
      return typeof arg === 'string';
    }

    function isUndefined(arg) {
      return arg === void 0;
    }

    function isRegExp(re) {
      return isObject(re) && objectToString(re) === '[object RegExp]';
    }

    function isObject(arg) {
      return typeof arg === 'object' && arg !== null;
    }

    function isDate(d) {
      return isObject(d) && objectToString(d) === '[object Date]';
    }

    function isError(e) {
      return isObject(e) &&
          (objectToString(e) === '[object Error]' || e instanceof Error);
    }

    function isFunction$1(arg) {
      return typeof arg === 'function';
    }

    function objectToString(o) {
      return Object.prototype.toString.call(o);
    }

    function _extend(origin, add) {
      // Don't do anything if add isn't an object
      if (!add || !isObject(add)) return origin;

      var keys = Object.keys(add);
      var i = keys.length;
      while (i--) {
        origin[keys[i]] = add[keys[i]];
      }
      return origin;
    }
    function hasOwnProperty$1(obj, prop) {
      return Object.prototype.hasOwnProperty.call(obj, prop);
    }

    var lookup = [];
    var revLookup = [];
    var Arr = typeof Uint8Array !== 'undefined' ? Uint8Array : Array;
    var inited = false;
    function init () {
      inited = true;
      var code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
      for (var i = 0, len = code.length; i < len; ++i) {
        lookup[i] = code[i];
        revLookup[code.charCodeAt(i)] = i;
      }

      revLookup['-'.charCodeAt(0)] = 62;
      revLookup['_'.charCodeAt(0)] = 63;
    }

    function toByteArray (b64) {
      if (!inited) {
        init();
      }
      var i, j, l, tmp, placeHolders, arr;
      var len = b64.length;

      if (len % 4 > 0) {
        throw new Error('Invalid string. Length must be a multiple of 4')
      }

      // the number of equal signs (place holders)
      // if there are two placeholders, than the two characters before it
      // represent one byte
      // if there is only one, then the three characters before it represent 2 bytes
      // this is just a cheap hack to not do indexOf twice
      placeHolders = b64[len - 2] === '=' ? 2 : b64[len - 1] === '=' ? 1 : 0;

      // base64 is 4/3 + up to two characters of the original data
      arr = new Arr(len * 3 / 4 - placeHolders);

      // if there are placeholders, only get up to the last complete 4 chars
      l = placeHolders > 0 ? len - 4 : len;

      var L = 0;

      for (i = 0, j = 0; i < l; i += 4, j += 3) {
        tmp = (revLookup[b64.charCodeAt(i)] << 18) | (revLookup[b64.charCodeAt(i + 1)] << 12) | (revLookup[b64.charCodeAt(i + 2)] << 6) | revLookup[b64.charCodeAt(i + 3)];
        arr[L++] = (tmp >> 16) & 0xFF;
        arr[L++] = (tmp >> 8) & 0xFF;
        arr[L++] = tmp & 0xFF;
      }

      if (placeHolders === 2) {
        tmp = (revLookup[b64.charCodeAt(i)] << 2) | (revLookup[b64.charCodeAt(i + 1)] >> 4);
        arr[L++] = tmp & 0xFF;
      } else if (placeHolders === 1) {
        tmp = (revLookup[b64.charCodeAt(i)] << 10) | (revLookup[b64.charCodeAt(i + 1)] << 4) | (revLookup[b64.charCodeAt(i + 2)] >> 2);
        arr[L++] = (tmp >> 8) & 0xFF;
        arr[L++] = tmp & 0xFF;
      }

      return arr
    }

    function tripletToBase64 (num) {
      return lookup[num >> 18 & 0x3F] + lookup[num >> 12 & 0x3F] + lookup[num >> 6 & 0x3F] + lookup[num & 0x3F]
    }

    function encodeChunk (uint8, start, end) {
      var tmp;
      var output = [];
      for (var i = start; i < end; i += 3) {
        tmp = (uint8[i] << 16) + (uint8[i + 1] << 8) + (uint8[i + 2]);
        output.push(tripletToBase64(tmp));
      }
      return output.join('')
    }

    function fromByteArray (uint8) {
      if (!inited) {
        init();
      }
      var tmp;
      var len = uint8.length;
      var extraBytes = len % 3; // if we have 1 byte left, pad 2 bytes
      var output = '';
      var parts = [];
      var maxChunkLength = 16383; // must be multiple of 3

      // go through the array every three bytes, we'll deal with trailing stuff later
      for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
        parts.push(encodeChunk(uint8, i, (i + maxChunkLength) > len2 ? len2 : (i + maxChunkLength)));
      }

      // pad the end with zeros, but make sure to not forget the extra bytes
      if (extraBytes === 1) {
        tmp = uint8[len - 1];
        output += lookup[tmp >> 2];
        output += lookup[(tmp << 4) & 0x3F];
        output += '==';
      } else if (extraBytes === 2) {
        tmp = (uint8[len - 2] << 8) + (uint8[len - 1]);
        output += lookup[tmp >> 10];
        output += lookup[(tmp >> 4) & 0x3F];
        output += lookup[(tmp << 2) & 0x3F];
        output += '=';
      }

      parts.push(output);

      return parts.join('')
    }

    function read (buffer, offset, isLE, mLen, nBytes) {
      var e, m;
      var eLen = nBytes * 8 - mLen - 1;
      var eMax = (1 << eLen) - 1;
      var eBias = eMax >> 1;
      var nBits = -7;
      var i = isLE ? (nBytes - 1) : 0;
      var d = isLE ? -1 : 1;
      var s = buffer[offset + i];

      i += d;

      e = s & ((1 << (-nBits)) - 1);
      s >>= (-nBits);
      nBits += eLen;
      for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {}

      m = e & ((1 << (-nBits)) - 1);
      e >>= (-nBits);
      nBits += mLen;
      for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {}

      if (e === 0) {
        e = 1 - eBias;
      } else if (e === eMax) {
        return m ? NaN : ((s ? -1 : 1) * Infinity)
      } else {
        m = m + Math.pow(2, mLen);
        e = e - eBias;
      }
      return (s ? -1 : 1) * m * Math.pow(2, e - mLen)
    }

    function write (buffer, value, offset, isLE, mLen, nBytes) {
      var e, m, c;
      var eLen = nBytes * 8 - mLen - 1;
      var eMax = (1 << eLen) - 1;
      var eBias = eMax >> 1;
      var rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0);
      var i = isLE ? 0 : (nBytes - 1);
      var d = isLE ? 1 : -1;
      var s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0;

      value = Math.abs(value);

      if (isNaN(value) || value === Infinity) {
        m = isNaN(value) ? 1 : 0;
        e = eMax;
      } else {
        e = Math.floor(Math.log(value) / Math.LN2);
        if (value * (c = Math.pow(2, -e)) < 1) {
          e--;
          c *= 2;
        }
        if (e + eBias >= 1) {
          value += rt / c;
        } else {
          value += rt * Math.pow(2, 1 - eBias);
        }
        if (value * c >= 2) {
          e++;
          c /= 2;
        }

        if (e + eBias >= eMax) {
          m = 0;
          e = eMax;
        } else if (e + eBias >= 1) {
          m = (value * c - 1) * Math.pow(2, mLen);
          e = e + eBias;
        } else {
          m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen);
          e = 0;
        }
      }

      for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

      e = (e << mLen) | m;
      eLen += mLen;
      for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

      buffer[offset + i - d] |= s * 128;
    }

    var toString = {}.toString;

    var isArray$1 = Array.isArray || function (arr) {
      return toString.call(arr) == '[object Array]';
    };

    var INSPECT_MAX_BYTES = 50;

    /**
     * If `Buffer.TYPED_ARRAY_SUPPORT`:
     *   === true    Use Uint8Array implementation (fastest)
     *   === false   Use Object implementation (most compatible, even IE6)
     *
     * Browsers that support typed arrays are IE 10+, Firefox 4+, Chrome 7+, Safari 5.1+,
     * Opera 11.6+, iOS 4.2+.
     *
     * Due to various browser bugs, sometimes the Object implementation will be used even
     * when the browser supports typed arrays.
     *
     * Note:
     *
     *   - Firefox 4-29 lacks support for adding new properties to `Uint8Array` instances,
     *     See: https://bugzilla.mozilla.org/show_bug.cgi?id=695438.
     *
     *   - Chrome 9-10 is missing the `TypedArray.prototype.subarray` function.
     *
     *   - IE10 has a broken `TypedArray.prototype.subarray` function which returns arrays of
     *     incorrect length in some situations.

     * We detect these buggy browsers and set `Buffer.TYPED_ARRAY_SUPPORT` to `false` so they
     * get the Object implementation, which is slower but behaves correctly.
     */
    Buffer$2.TYPED_ARRAY_SUPPORT = global$1.TYPED_ARRAY_SUPPORT !== undefined
      ? global$1.TYPED_ARRAY_SUPPORT
      : true;

    /*
     * Export kMaxLength after typed array support is determined.
     */
    var _kMaxLength = kMaxLength();

    function kMaxLength () {
      return Buffer$2.TYPED_ARRAY_SUPPORT
        ? 0x7fffffff
        : 0x3fffffff
    }

    function createBuffer (that, length) {
      if (kMaxLength() < length) {
        throw new RangeError('Invalid typed array length')
      }
      if (Buffer$2.TYPED_ARRAY_SUPPORT) {
        // Return an augmented `Uint8Array` instance, for best performance
        that = new Uint8Array(length);
        that.__proto__ = Buffer$2.prototype;
      } else {
        // Fallback: Return an object instance of the Buffer class
        if (that === null) {
          that = new Buffer$2(length);
        }
        that.length = length;
      }

      return that
    }

    /**
     * The Buffer constructor returns instances of `Uint8Array` that have their
     * prototype changed to `Buffer.prototype`. Furthermore, `Buffer` is a subclass of
     * `Uint8Array`, so the returned instances will have all the node `Buffer` methods
     * and the `Uint8Array` methods. Square bracket notation works as expected -- it
     * returns a single octet.
     *
     * The `Uint8Array` prototype remains unmodified.
     */

    function Buffer$2 (arg, encodingOrOffset, length) {
      if (!Buffer$2.TYPED_ARRAY_SUPPORT && !(this instanceof Buffer$2)) {
        return new Buffer$2(arg, encodingOrOffset, length)
      }

      // Common case.
      if (typeof arg === 'number') {
        if (typeof encodingOrOffset === 'string') {
          throw new Error(
            'If encoding is specified then the first argument must be a string'
          )
        }
        return allocUnsafe(this, arg)
      }
      return from(this, arg, encodingOrOffset, length)
    }

    Buffer$2.poolSize = 8192; // not used by this implementation

    // TODO: Legacy, not needed anymore. Remove in next major version.
    Buffer$2._augment = function (arr) {
      arr.__proto__ = Buffer$2.prototype;
      return arr
    };

    function from (that, value, encodingOrOffset, length) {
      if (typeof value === 'number') {
        throw new TypeError('"value" argument must not be a number')
      }

      if (typeof ArrayBuffer !== 'undefined' && value instanceof ArrayBuffer) {
        return fromArrayBuffer(that, value, encodingOrOffset, length)
      }

      if (typeof value === 'string') {
        return fromString(that, value, encodingOrOffset)
      }

      return fromObject(that, value)
    }

    /**
     * Functionally equivalent to Buffer(arg, encoding) but throws a TypeError
     * if value is a number.
     * Buffer.from(str[, encoding])
     * Buffer.from(array)
     * Buffer.from(buffer)
     * Buffer.from(arrayBuffer[, byteOffset[, length]])
     **/
    Buffer$2.from = function (value, encodingOrOffset, length) {
      return from(null, value, encodingOrOffset, length)
    };

    if (Buffer$2.TYPED_ARRAY_SUPPORT) {
      Buffer$2.prototype.__proto__ = Uint8Array.prototype;
      Buffer$2.__proto__ = Uint8Array;
      if (typeof Symbol !== 'undefined' && Symbol.species &&
          Buffer$2[Symbol.species] === Buffer$2) ;
    }

    function assertSize (size) {
      if (typeof size !== 'number') {
        throw new TypeError('"size" argument must be a number')
      } else if (size < 0) {
        throw new RangeError('"size" argument must not be negative')
      }
    }

    function alloc (that, size, fill, encoding) {
      assertSize(size);
      if (size <= 0) {
        return createBuffer(that, size)
      }
      if (fill !== undefined) {
        // Only pay attention to encoding if it's a string. This
        // prevents accidentally sending in a number that would
        // be interpretted as a start offset.
        return typeof encoding === 'string'
          ? createBuffer(that, size).fill(fill, encoding)
          : createBuffer(that, size).fill(fill)
      }
      return createBuffer(that, size)
    }

    /**
     * Creates a new filled Buffer instance.
     * alloc(size[, fill[, encoding]])
     **/
    Buffer$2.alloc = function (size, fill, encoding) {
      return alloc(null, size, fill, encoding)
    };

    function allocUnsafe (that, size) {
      assertSize(size);
      that = createBuffer(that, size < 0 ? 0 : checked(size) | 0);
      if (!Buffer$2.TYPED_ARRAY_SUPPORT) {
        for (var i = 0; i < size; ++i) {
          that[i] = 0;
        }
      }
      return that
    }

    /**
     * Equivalent to Buffer(num), by default creates a non-zero-filled Buffer instance.
     * */
    Buffer$2.allocUnsafe = function (size) {
      return allocUnsafe(null, size)
    };
    /**
     * Equivalent to SlowBuffer(num), by default creates a non-zero-filled Buffer instance.
     */
    Buffer$2.allocUnsafeSlow = function (size) {
      return allocUnsafe(null, size)
    };

    function fromString (that, string, encoding) {
      if (typeof encoding !== 'string' || encoding === '') {
        encoding = 'utf8';
      }

      if (!Buffer$2.isEncoding(encoding)) {
        throw new TypeError('"encoding" must be a valid string encoding')
      }

      var length = byteLength(string, encoding) | 0;
      that = createBuffer(that, length);

      var actual = that.write(string, encoding);

      if (actual !== length) {
        // Writing a hex string, for example, that contains invalid characters will
        // cause everything after the first invalid character to be ignored. (e.g.
        // 'abxxcd' will be treated as 'ab')
        that = that.slice(0, actual);
      }

      return that
    }

    function fromArrayLike (that, array) {
      var length = array.length < 0 ? 0 : checked(array.length) | 0;
      that = createBuffer(that, length);
      for (var i = 0; i < length; i += 1) {
        that[i] = array[i] & 255;
      }
      return that
    }

    function fromArrayBuffer (that, array, byteOffset, length) {
      array.byteLength; // this throws if `array` is not a valid ArrayBuffer

      if (byteOffset < 0 || array.byteLength < byteOffset) {
        throw new RangeError('\'offset\' is out of bounds')
      }

      if (array.byteLength < byteOffset + (length || 0)) {
        throw new RangeError('\'length\' is out of bounds')
      }

      if (byteOffset === undefined && length === undefined) {
        array = new Uint8Array(array);
      } else if (length === undefined) {
        array = new Uint8Array(array, byteOffset);
      } else {
        array = new Uint8Array(array, byteOffset, length);
      }

      if (Buffer$2.TYPED_ARRAY_SUPPORT) {
        // Return an augmented `Uint8Array` instance, for best performance
        that = array;
        that.__proto__ = Buffer$2.prototype;
      } else {
        // Fallback: Return an object instance of the Buffer class
        that = fromArrayLike(that, array);
      }
      return that
    }

    function fromObject (that, obj) {
      if (internalIsBuffer(obj)) {
        var len = checked(obj.length) | 0;
        that = createBuffer(that, len);

        if (that.length === 0) {
          return that
        }

        obj.copy(that, 0, 0, len);
        return that
      }

      if (obj) {
        if ((typeof ArrayBuffer !== 'undefined' &&
            obj.buffer instanceof ArrayBuffer) || 'length' in obj) {
          if (typeof obj.length !== 'number' || isnan(obj.length)) {
            return createBuffer(that, 0)
          }
          return fromArrayLike(that, obj)
        }

        if (obj.type === 'Buffer' && isArray$1(obj.data)) {
          return fromArrayLike(that, obj.data)
        }
      }

      throw new TypeError('First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.')
    }

    function checked (length) {
      // Note: cannot use `length < kMaxLength()` here because that fails when
      // length is NaN (which is otherwise coerced to zero.)
      if (length >= kMaxLength()) {
        throw new RangeError('Attempt to allocate Buffer larger than maximum ' +
                             'size: 0x' + kMaxLength().toString(16) + ' bytes')
      }
      return length | 0
    }

    function SlowBuffer (length) {
      if (+length != length) { // eslint-disable-line eqeqeq
        length = 0;
      }
      return Buffer$2.alloc(+length)
    }
    Buffer$2.isBuffer = isBuffer;
    function internalIsBuffer (b) {
      return !!(b != null && b._isBuffer)
    }

    Buffer$2.compare = function compare (a, b) {
      if (!internalIsBuffer(a) || !internalIsBuffer(b)) {
        throw new TypeError('Arguments must be Buffers')
      }

      if (a === b) return 0

      var x = a.length;
      var y = b.length;

      for (var i = 0, len = Math.min(x, y); i < len; ++i) {
        if (a[i] !== b[i]) {
          x = a[i];
          y = b[i];
          break
        }
      }

      if (x < y) return -1
      if (y < x) return 1
      return 0
    };

    Buffer$2.isEncoding = function isEncoding (encoding) {
      switch (String(encoding).toLowerCase()) {
        case 'hex':
        case 'utf8':
        case 'utf-8':
        case 'ascii':
        case 'latin1':
        case 'binary':
        case 'base64':
        case 'ucs2':
        case 'ucs-2':
        case 'utf16le':
        case 'utf-16le':
          return true
        default:
          return false
      }
    };

    Buffer$2.concat = function concat (list, length) {
      if (!isArray$1(list)) {
        throw new TypeError('"list" argument must be an Array of Buffers')
      }

      if (list.length === 0) {
        return Buffer$2.alloc(0)
      }

      var i;
      if (length === undefined) {
        length = 0;
        for (i = 0; i < list.length; ++i) {
          length += list[i].length;
        }
      }

      var buffer = Buffer$2.allocUnsafe(length);
      var pos = 0;
      for (i = 0; i < list.length; ++i) {
        var buf = list[i];
        if (!internalIsBuffer(buf)) {
          throw new TypeError('"list" argument must be an Array of Buffers')
        }
        buf.copy(buffer, pos);
        pos += buf.length;
      }
      return buffer
    };

    function byteLength (string, encoding) {
      if (internalIsBuffer(string)) {
        return string.length
      }
      if (typeof ArrayBuffer !== 'undefined' && typeof ArrayBuffer.isView === 'function' &&
          (ArrayBuffer.isView(string) || string instanceof ArrayBuffer)) {
        return string.byteLength
      }
      if (typeof string !== 'string') {
        string = '' + string;
      }

      var len = string.length;
      if (len === 0) return 0

      // Use a for loop to avoid recursion
      var loweredCase = false;
      for (;;) {
        switch (encoding) {
          case 'ascii':
          case 'latin1':
          case 'binary':
            return len
          case 'utf8':
          case 'utf-8':
          case undefined:
            return utf8ToBytes(string).length
          case 'ucs2':
          case 'ucs-2':
          case 'utf16le':
          case 'utf-16le':
            return len * 2
          case 'hex':
            return len >>> 1
          case 'base64':
            return base64ToBytes(string).length
          default:
            if (loweredCase) return utf8ToBytes(string).length // assume utf8
            encoding = ('' + encoding).toLowerCase();
            loweredCase = true;
        }
      }
    }
    Buffer$2.byteLength = byteLength;

    function slowToString (encoding, start, end) {
      var loweredCase = false;

      // No need to verify that "this.length <= MAX_UINT32" since it's a read-only
      // property of a typed array.

      // This behaves neither like String nor Uint8Array in that we set start/end
      // to their upper/lower bounds if the value passed is out of range.
      // undefined is handled specially as per ECMA-262 6th Edition,
      // Section 13.3.3.7 Runtime Semantics: KeyedBindingInitialization.
      if (start === undefined || start < 0) {
        start = 0;
      }
      // Return early if start > this.length. Done here to prevent potential uint32
      // coercion fail below.
      if (start > this.length) {
        return ''
      }

      if (end === undefined || end > this.length) {
        end = this.length;
      }

      if (end <= 0) {
        return ''
      }

      // Force coersion to uint32. This will also coerce falsey/NaN values to 0.
      end >>>= 0;
      start >>>= 0;

      if (end <= start) {
        return ''
      }

      if (!encoding) encoding = 'utf8';

      while (true) {
        switch (encoding) {
          case 'hex':
            return hexSlice(this, start, end)

          case 'utf8':
          case 'utf-8':
            return utf8Slice(this, start, end)

          case 'ascii':
            return asciiSlice(this, start, end)

          case 'latin1':
          case 'binary':
            return latin1Slice(this, start, end)

          case 'base64':
            return base64Slice(this, start, end)

          case 'ucs2':
          case 'ucs-2':
          case 'utf16le':
          case 'utf-16le':
            return utf16leSlice(this, start, end)

          default:
            if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
            encoding = (encoding + '').toLowerCase();
            loweredCase = true;
        }
      }
    }

    // The property is used by `Buffer.isBuffer` and `is-buffer` (in Safari 5-7) to detect
    // Buffer instances.
    Buffer$2.prototype._isBuffer = true;

    function swap (b, n, m) {
      var i = b[n];
      b[n] = b[m];
      b[m] = i;
    }

    Buffer$2.prototype.swap16 = function swap16 () {
      var len = this.length;
      if (len % 2 !== 0) {
        throw new RangeError('Buffer size must be a multiple of 16-bits')
      }
      for (var i = 0; i < len; i += 2) {
        swap(this, i, i + 1);
      }
      return this
    };

    Buffer$2.prototype.swap32 = function swap32 () {
      var len = this.length;
      if (len % 4 !== 0) {
        throw new RangeError('Buffer size must be a multiple of 32-bits')
      }
      for (var i = 0; i < len; i += 4) {
        swap(this, i, i + 3);
        swap(this, i + 1, i + 2);
      }
      return this
    };

    Buffer$2.prototype.swap64 = function swap64 () {
      var len = this.length;
      if (len % 8 !== 0) {
        throw new RangeError('Buffer size must be a multiple of 64-bits')
      }
      for (var i = 0; i < len; i += 8) {
        swap(this, i, i + 7);
        swap(this, i + 1, i + 6);
        swap(this, i + 2, i + 5);
        swap(this, i + 3, i + 4);
      }
      return this
    };

    Buffer$2.prototype.toString = function toString () {
      var length = this.length | 0;
      if (length === 0) return ''
      if (arguments.length === 0) return utf8Slice(this, 0, length)
      return slowToString.apply(this, arguments)
    };

    Buffer$2.prototype.equals = function equals (b) {
      if (!internalIsBuffer(b)) throw new TypeError('Argument must be a Buffer')
      if (this === b) return true
      return Buffer$2.compare(this, b) === 0
    };

    Buffer$2.prototype.inspect = function inspect () {
      var str = '';
      var max = INSPECT_MAX_BYTES;
      if (this.length > 0) {
        str = this.toString('hex', 0, max).match(/.{2}/g).join(' ');
        if (this.length > max) str += ' ... ';
      }
      return '<Buffer ' + str + '>'
    };

    Buffer$2.prototype.compare = function compare (target, start, end, thisStart, thisEnd) {
      if (!internalIsBuffer(target)) {
        throw new TypeError('Argument must be a Buffer')
      }

      if (start === undefined) {
        start = 0;
      }
      if (end === undefined) {
        end = target ? target.length : 0;
      }
      if (thisStart === undefined) {
        thisStart = 0;
      }
      if (thisEnd === undefined) {
        thisEnd = this.length;
      }

      if (start < 0 || end > target.length || thisStart < 0 || thisEnd > this.length) {
        throw new RangeError('out of range index')
      }

      if (thisStart >= thisEnd && start >= end) {
        return 0
      }
      if (thisStart >= thisEnd) {
        return -1
      }
      if (start >= end) {
        return 1
      }

      start >>>= 0;
      end >>>= 0;
      thisStart >>>= 0;
      thisEnd >>>= 0;

      if (this === target) return 0

      var x = thisEnd - thisStart;
      var y = end - start;
      var len = Math.min(x, y);

      var thisCopy = this.slice(thisStart, thisEnd);
      var targetCopy = target.slice(start, end);

      for (var i = 0; i < len; ++i) {
        if (thisCopy[i] !== targetCopy[i]) {
          x = thisCopy[i];
          y = targetCopy[i];
          break
        }
      }

      if (x < y) return -1
      if (y < x) return 1
      return 0
    };

    // Finds either the first index of `val` in `buffer` at offset >= `byteOffset`,
    // OR the last index of `val` in `buffer` at offset <= `byteOffset`.
    //
    // Arguments:
    // - buffer - a Buffer to search
    // - val - a string, Buffer, or number
    // - byteOffset - an index into `buffer`; will be clamped to an int32
    // - encoding - an optional encoding, relevant is val is a string
    // - dir - true for indexOf, false for lastIndexOf
    function bidirectionalIndexOf (buffer, val, byteOffset, encoding, dir) {
      // Empty buffer means no match
      if (buffer.length === 0) return -1

      // Normalize byteOffset
      if (typeof byteOffset === 'string') {
        encoding = byteOffset;
        byteOffset = 0;
      } else if (byteOffset > 0x7fffffff) {
        byteOffset = 0x7fffffff;
      } else if (byteOffset < -0x80000000) {
        byteOffset = -0x80000000;
      }
      byteOffset = +byteOffset;  // Coerce to Number.
      if (isNaN(byteOffset)) {
        // byteOffset: it it's undefined, null, NaN, "foo", etc, search whole buffer
        byteOffset = dir ? 0 : (buffer.length - 1);
      }

      // Normalize byteOffset: negative offsets start from the end of the buffer
      if (byteOffset < 0) byteOffset = buffer.length + byteOffset;
      if (byteOffset >= buffer.length) {
        if (dir) return -1
        else byteOffset = buffer.length - 1;
      } else if (byteOffset < 0) {
        if (dir) byteOffset = 0;
        else return -1
      }

      // Normalize val
      if (typeof val === 'string') {
        val = Buffer$2.from(val, encoding);
      }

      // Finally, search either indexOf (if dir is true) or lastIndexOf
      if (internalIsBuffer(val)) {
        // Special case: looking for empty string/buffer always fails
        if (val.length === 0) {
          return -1
        }
        return arrayIndexOf(buffer, val, byteOffset, encoding, dir)
      } else if (typeof val === 'number') {
        val = val & 0xFF; // Search for a byte value [0-255]
        if (Buffer$2.TYPED_ARRAY_SUPPORT &&
            typeof Uint8Array.prototype.indexOf === 'function') {
          if (dir) {
            return Uint8Array.prototype.indexOf.call(buffer, val, byteOffset)
          } else {
            return Uint8Array.prototype.lastIndexOf.call(buffer, val, byteOffset)
          }
        }
        return arrayIndexOf(buffer, [ val ], byteOffset, encoding, dir)
      }

      throw new TypeError('val must be string, number or Buffer')
    }

    function arrayIndexOf (arr, val, byteOffset, encoding, dir) {
      var indexSize = 1;
      var arrLength = arr.length;
      var valLength = val.length;

      if (encoding !== undefined) {
        encoding = String(encoding).toLowerCase();
        if (encoding === 'ucs2' || encoding === 'ucs-2' ||
            encoding === 'utf16le' || encoding === 'utf-16le') {
          if (arr.length < 2 || val.length < 2) {
            return -1
          }
          indexSize = 2;
          arrLength /= 2;
          valLength /= 2;
          byteOffset /= 2;
        }
      }

      function read (buf, i) {
        if (indexSize === 1) {
          return buf[i]
        } else {
          return buf.readUInt16BE(i * indexSize)
        }
      }

      var i;
      if (dir) {
        var foundIndex = -1;
        for (i = byteOffset; i < arrLength; i++) {
          if (read(arr, i) === read(val, foundIndex === -1 ? 0 : i - foundIndex)) {
            if (foundIndex === -1) foundIndex = i;
            if (i - foundIndex + 1 === valLength) return foundIndex * indexSize
          } else {
            if (foundIndex !== -1) i -= i - foundIndex;
            foundIndex = -1;
          }
        }
      } else {
        if (byteOffset + valLength > arrLength) byteOffset = arrLength - valLength;
        for (i = byteOffset; i >= 0; i--) {
          var found = true;
          for (var j = 0; j < valLength; j++) {
            if (read(arr, i + j) !== read(val, j)) {
              found = false;
              break
            }
          }
          if (found) return i
        }
      }

      return -1
    }

    Buffer$2.prototype.includes = function includes (val, byteOffset, encoding) {
      return this.indexOf(val, byteOffset, encoding) !== -1
    };

    Buffer$2.prototype.indexOf = function indexOf (val, byteOffset, encoding) {
      return bidirectionalIndexOf(this, val, byteOffset, encoding, true)
    };

    Buffer$2.prototype.lastIndexOf = function lastIndexOf (val, byteOffset, encoding) {
      return bidirectionalIndexOf(this, val, byteOffset, encoding, false)
    };

    function hexWrite (buf, string, offset, length) {
      offset = Number(offset) || 0;
      var remaining = buf.length - offset;
      if (!length) {
        length = remaining;
      } else {
        length = Number(length);
        if (length > remaining) {
          length = remaining;
        }
      }

      // must be an even number of digits
      var strLen = string.length;
      if (strLen % 2 !== 0) throw new TypeError('Invalid hex string')

      if (length > strLen / 2) {
        length = strLen / 2;
      }
      for (var i = 0; i < length; ++i) {
        var parsed = parseInt(string.substr(i * 2, 2), 16);
        if (isNaN(parsed)) return i
        buf[offset + i] = parsed;
      }
      return i
    }

    function utf8Write (buf, string, offset, length) {
      return blitBuffer(utf8ToBytes(string, buf.length - offset), buf, offset, length)
    }

    function asciiWrite (buf, string, offset, length) {
      return blitBuffer(asciiToBytes(string), buf, offset, length)
    }

    function latin1Write (buf, string, offset, length) {
      return asciiWrite(buf, string, offset, length)
    }

    function base64Write (buf, string, offset, length) {
      return blitBuffer(base64ToBytes(string), buf, offset, length)
    }

    function ucs2Write (buf, string, offset, length) {
      return blitBuffer(utf16leToBytes(string, buf.length - offset), buf, offset, length)
    }

    Buffer$2.prototype.write = function write (string, offset, length, encoding) {
      // Buffer#write(string)
      if (offset === undefined) {
        encoding = 'utf8';
        length = this.length;
        offset = 0;
      // Buffer#write(string, encoding)
      } else if (length === undefined && typeof offset === 'string') {
        encoding = offset;
        length = this.length;
        offset = 0;
      // Buffer#write(string, offset[, length][, encoding])
      } else if (isFinite(offset)) {
        offset = offset | 0;
        if (isFinite(length)) {
          length = length | 0;
          if (encoding === undefined) encoding = 'utf8';
        } else {
          encoding = length;
          length = undefined;
        }
      // legacy write(string, encoding, offset, length) - remove in v0.13
      } else {
        throw new Error(
          'Buffer.write(string, encoding, offset[, length]) is no longer supported'
        )
      }

      var remaining = this.length - offset;
      if (length === undefined || length > remaining) length = remaining;

      if ((string.length > 0 && (length < 0 || offset < 0)) || offset > this.length) {
        throw new RangeError('Attempt to write outside buffer bounds')
      }

      if (!encoding) encoding = 'utf8';

      var loweredCase = false;
      for (;;) {
        switch (encoding) {
          case 'hex':
            return hexWrite(this, string, offset, length)

          case 'utf8':
          case 'utf-8':
            return utf8Write(this, string, offset, length)

          case 'ascii':
            return asciiWrite(this, string, offset, length)

          case 'latin1':
          case 'binary':
            return latin1Write(this, string, offset, length)

          case 'base64':
            // Warning: maxLength not taken into account in base64Write
            return base64Write(this, string, offset, length)

          case 'ucs2':
          case 'ucs-2':
          case 'utf16le':
          case 'utf-16le':
            return ucs2Write(this, string, offset, length)

          default:
            if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
            encoding = ('' + encoding).toLowerCase();
            loweredCase = true;
        }
      }
    };

    Buffer$2.prototype.toJSON = function toJSON () {
      return {
        type: 'Buffer',
        data: Array.prototype.slice.call(this._arr || this, 0)
      }
    };

    function base64Slice (buf, start, end) {
      if (start === 0 && end === buf.length) {
        return fromByteArray(buf)
      } else {
        return fromByteArray(buf.slice(start, end))
      }
    }

    function utf8Slice (buf, start, end) {
      end = Math.min(buf.length, end);
      var res = [];

      var i = start;
      while (i < end) {
        var firstByte = buf[i];
        var codePoint = null;
        var bytesPerSequence = (firstByte > 0xEF) ? 4
          : (firstByte > 0xDF) ? 3
          : (firstByte > 0xBF) ? 2
          : 1;

        if (i + bytesPerSequence <= end) {
          var secondByte, thirdByte, fourthByte, tempCodePoint;

          switch (bytesPerSequence) {
            case 1:
              if (firstByte < 0x80) {
                codePoint = firstByte;
              }
              break
            case 2:
              secondByte = buf[i + 1];
              if ((secondByte & 0xC0) === 0x80) {
                tempCodePoint = (firstByte & 0x1F) << 0x6 | (secondByte & 0x3F);
                if (tempCodePoint > 0x7F) {
                  codePoint = tempCodePoint;
                }
              }
              break
            case 3:
              secondByte = buf[i + 1];
              thirdByte = buf[i + 2];
              if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80) {
                tempCodePoint = (firstByte & 0xF) << 0xC | (secondByte & 0x3F) << 0x6 | (thirdByte & 0x3F);
                if (tempCodePoint > 0x7FF && (tempCodePoint < 0xD800 || tempCodePoint > 0xDFFF)) {
                  codePoint = tempCodePoint;
                }
              }
              break
            case 4:
              secondByte = buf[i + 1];
              thirdByte = buf[i + 2];
              fourthByte = buf[i + 3];
              if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80 && (fourthByte & 0xC0) === 0x80) {
                tempCodePoint = (firstByte & 0xF) << 0x12 | (secondByte & 0x3F) << 0xC | (thirdByte & 0x3F) << 0x6 | (fourthByte & 0x3F);
                if (tempCodePoint > 0xFFFF && tempCodePoint < 0x110000) {
                  codePoint = tempCodePoint;
                }
              }
          }
        }

        if (codePoint === null) {
          // we did not generate a valid codePoint so insert a
          // replacement char (U+FFFD) and advance only 1 byte
          codePoint = 0xFFFD;
          bytesPerSequence = 1;
        } else if (codePoint > 0xFFFF) {
          // encode to utf16 (surrogate pair dance)
          codePoint -= 0x10000;
          res.push(codePoint >>> 10 & 0x3FF | 0xD800);
          codePoint = 0xDC00 | codePoint & 0x3FF;
        }

        res.push(codePoint);
        i += bytesPerSequence;
      }

      return decodeCodePointsArray(res)
    }

    // Based on http://stackoverflow.com/a/22747272/680742, the browser with
    // the lowest limit is Chrome, with 0x10000 args.
    // We go 1 magnitude less, for safety
    var MAX_ARGUMENTS_LENGTH = 0x1000;

    function decodeCodePointsArray (codePoints) {
      var len = codePoints.length;
      if (len <= MAX_ARGUMENTS_LENGTH) {
        return String.fromCharCode.apply(String, codePoints) // avoid extra slice()
      }

      // Decode in chunks to avoid "call stack size exceeded".
      var res = '';
      var i = 0;
      while (i < len) {
        res += String.fromCharCode.apply(
          String,
          codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH)
        );
      }
      return res
    }

    function asciiSlice (buf, start, end) {
      var ret = '';
      end = Math.min(buf.length, end);

      for (var i = start; i < end; ++i) {
        ret += String.fromCharCode(buf[i] & 0x7F);
      }
      return ret
    }

    function latin1Slice (buf, start, end) {
      var ret = '';
      end = Math.min(buf.length, end);

      for (var i = start; i < end; ++i) {
        ret += String.fromCharCode(buf[i]);
      }
      return ret
    }

    function hexSlice (buf, start, end) {
      var len = buf.length;

      if (!start || start < 0) start = 0;
      if (!end || end < 0 || end > len) end = len;

      var out = '';
      for (var i = start; i < end; ++i) {
        out += toHex$1(buf[i]);
      }
      return out
    }

    function utf16leSlice (buf, start, end) {
      var bytes = buf.slice(start, end);
      var res = '';
      for (var i = 0; i < bytes.length; i += 2) {
        res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256);
      }
      return res
    }

    Buffer$2.prototype.slice = function slice (start, end) {
      var len = this.length;
      start = ~~start;
      end = end === undefined ? len : ~~end;

      if (start < 0) {
        start += len;
        if (start < 0) start = 0;
      } else if (start > len) {
        start = len;
      }

      if (end < 0) {
        end += len;
        if (end < 0) end = 0;
      } else if (end > len) {
        end = len;
      }

      if (end < start) end = start;

      var newBuf;
      if (Buffer$2.TYPED_ARRAY_SUPPORT) {
        newBuf = this.subarray(start, end);
        newBuf.__proto__ = Buffer$2.prototype;
      } else {
        var sliceLen = end - start;
        newBuf = new Buffer$2(sliceLen, undefined);
        for (var i = 0; i < sliceLen; ++i) {
          newBuf[i] = this[i + start];
        }
      }

      return newBuf
    };

    /*
     * Need to make sure that buffer isn't trying to write out of bounds.
     */
    function checkOffset (offset, ext, length) {
      if ((offset % 1) !== 0 || offset < 0) throw new RangeError('offset is not uint')
      if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length')
    }

    Buffer$2.prototype.readUIntLE = function readUIntLE (offset, byteLength, noAssert) {
      offset = offset | 0;
      byteLength = byteLength | 0;
      if (!noAssert) checkOffset(offset, byteLength, this.length);

      var val = this[offset];
      var mul = 1;
      var i = 0;
      while (++i < byteLength && (mul *= 0x100)) {
        val += this[offset + i] * mul;
      }

      return val
    };

    Buffer$2.prototype.readUIntBE = function readUIntBE (offset, byteLength, noAssert) {
      offset = offset | 0;
      byteLength = byteLength | 0;
      if (!noAssert) {
        checkOffset(offset, byteLength, this.length);
      }

      var val = this[offset + --byteLength];
      var mul = 1;
      while (byteLength > 0 && (mul *= 0x100)) {
        val += this[offset + --byteLength] * mul;
      }

      return val
    };

    Buffer$2.prototype.readUInt8 = function readUInt8 (offset, noAssert) {
      if (!noAssert) checkOffset(offset, 1, this.length);
      return this[offset]
    };

    Buffer$2.prototype.readUInt16LE = function readUInt16LE (offset, noAssert) {
      if (!noAssert) checkOffset(offset, 2, this.length);
      return this[offset] | (this[offset + 1] << 8)
    };

    Buffer$2.prototype.readUInt16BE = function readUInt16BE (offset, noAssert) {
      if (!noAssert) checkOffset(offset, 2, this.length);
      return (this[offset] << 8) | this[offset + 1]
    };

    Buffer$2.prototype.readUInt32LE = function readUInt32LE (offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);

      return ((this[offset]) |
          (this[offset + 1] << 8) |
          (this[offset + 2] << 16)) +
          (this[offset + 3] * 0x1000000)
    };

    Buffer$2.prototype.readUInt32BE = function readUInt32BE (offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);

      return (this[offset] * 0x1000000) +
        ((this[offset + 1] << 16) |
        (this[offset + 2] << 8) |
        this[offset + 3])
    };

    Buffer$2.prototype.readIntLE = function readIntLE (offset, byteLength, noAssert) {
      offset = offset | 0;
      byteLength = byteLength | 0;
      if (!noAssert) checkOffset(offset, byteLength, this.length);

      var val = this[offset];
      var mul = 1;
      var i = 0;
      while (++i < byteLength && (mul *= 0x100)) {
        val += this[offset + i] * mul;
      }
      mul *= 0x80;

      if (val >= mul) val -= Math.pow(2, 8 * byteLength);

      return val
    };

    Buffer$2.prototype.readIntBE = function readIntBE (offset, byteLength, noAssert) {
      offset = offset | 0;
      byteLength = byteLength | 0;
      if (!noAssert) checkOffset(offset, byteLength, this.length);

      var i = byteLength;
      var mul = 1;
      var val = this[offset + --i];
      while (i > 0 && (mul *= 0x100)) {
        val += this[offset + --i] * mul;
      }
      mul *= 0x80;

      if (val >= mul) val -= Math.pow(2, 8 * byteLength);

      return val
    };

    Buffer$2.prototype.readInt8 = function readInt8 (offset, noAssert) {
      if (!noAssert) checkOffset(offset, 1, this.length);
      if (!(this[offset] & 0x80)) return (this[offset])
      return ((0xff - this[offset] + 1) * -1)
    };

    Buffer$2.prototype.readInt16LE = function readInt16LE (offset, noAssert) {
      if (!noAssert) checkOffset(offset, 2, this.length);
      var val = this[offset] | (this[offset + 1] << 8);
      return (val & 0x8000) ? val | 0xFFFF0000 : val
    };

    Buffer$2.prototype.readInt16BE = function readInt16BE (offset, noAssert) {
      if (!noAssert) checkOffset(offset, 2, this.length);
      var val = this[offset + 1] | (this[offset] << 8);
      return (val & 0x8000) ? val | 0xFFFF0000 : val
    };

    Buffer$2.prototype.readInt32LE = function readInt32LE (offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);

      return (this[offset]) |
        (this[offset + 1] << 8) |
        (this[offset + 2] << 16) |
        (this[offset + 3] << 24)
    };

    Buffer$2.prototype.readInt32BE = function readInt32BE (offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);

      return (this[offset] << 24) |
        (this[offset + 1] << 16) |
        (this[offset + 2] << 8) |
        (this[offset + 3])
    };

    Buffer$2.prototype.readFloatLE = function readFloatLE (offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return read(this, offset, true, 23, 4)
    };

    Buffer$2.prototype.readFloatBE = function readFloatBE (offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return read(this, offset, false, 23, 4)
    };

    Buffer$2.prototype.readDoubleLE = function readDoubleLE (offset, noAssert) {
      if (!noAssert) checkOffset(offset, 8, this.length);
      return read(this, offset, true, 52, 8)
    };

    Buffer$2.prototype.readDoubleBE = function readDoubleBE (offset, noAssert) {
      if (!noAssert) checkOffset(offset, 8, this.length);
      return read(this, offset, false, 52, 8)
    };

    function checkInt (buf, value, offset, ext, max, min) {
      if (!internalIsBuffer(buf)) throw new TypeError('"buffer" argument must be a Buffer instance')
      if (value > max || value < min) throw new RangeError('"value" argument is out of bounds')
      if (offset + ext > buf.length) throw new RangeError('Index out of range')
    }

    Buffer$2.prototype.writeUIntLE = function writeUIntLE (value, offset, byteLength, noAssert) {
      value = +value;
      offset = offset | 0;
      byteLength = byteLength | 0;
      if (!noAssert) {
        var maxBytes = Math.pow(2, 8 * byteLength) - 1;
        checkInt(this, value, offset, byteLength, maxBytes, 0);
      }

      var mul = 1;
      var i = 0;
      this[offset] = value & 0xFF;
      while (++i < byteLength && (mul *= 0x100)) {
        this[offset + i] = (value / mul) & 0xFF;
      }

      return offset + byteLength
    };

    Buffer$2.prototype.writeUIntBE = function writeUIntBE (value, offset, byteLength, noAssert) {
      value = +value;
      offset = offset | 0;
      byteLength = byteLength | 0;
      if (!noAssert) {
        var maxBytes = Math.pow(2, 8 * byteLength) - 1;
        checkInt(this, value, offset, byteLength, maxBytes, 0);
      }

      var i = byteLength - 1;
      var mul = 1;
      this[offset + i] = value & 0xFF;
      while (--i >= 0 && (mul *= 0x100)) {
        this[offset + i] = (value / mul) & 0xFF;
      }

      return offset + byteLength
    };

    Buffer$2.prototype.writeUInt8 = function writeUInt8 (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 1, 0xff, 0);
      if (!Buffer$2.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
      this[offset] = (value & 0xff);
      return offset + 1
    };

    function objectWriteUInt16 (buf, value, offset, littleEndian) {
      if (value < 0) value = 0xffff + value + 1;
      for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; ++i) {
        buf[offset + i] = (value & (0xff << (8 * (littleEndian ? i : 1 - i)))) >>>
          (littleEndian ? i : 1 - i) * 8;
      }
    }

    Buffer$2.prototype.writeUInt16LE = function writeUInt16LE (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0);
      if (Buffer$2.TYPED_ARRAY_SUPPORT) {
        this[offset] = (value & 0xff);
        this[offset + 1] = (value >>> 8);
      } else {
        objectWriteUInt16(this, value, offset, true);
      }
      return offset + 2
    };

    Buffer$2.prototype.writeUInt16BE = function writeUInt16BE (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0);
      if (Buffer$2.TYPED_ARRAY_SUPPORT) {
        this[offset] = (value >>> 8);
        this[offset + 1] = (value & 0xff);
      } else {
        objectWriteUInt16(this, value, offset, false);
      }
      return offset + 2
    };

    function objectWriteUInt32 (buf, value, offset, littleEndian) {
      if (value < 0) value = 0xffffffff + value + 1;
      for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; ++i) {
        buf[offset + i] = (value >>> (littleEndian ? i : 3 - i) * 8) & 0xff;
      }
    }

    Buffer$2.prototype.writeUInt32LE = function writeUInt32LE (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0);
      if (Buffer$2.TYPED_ARRAY_SUPPORT) {
        this[offset + 3] = (value >>> 24);
        this[offset + 2] = (value >>> 16);
        this[offset + 1] = (value >>> 8);
        this[offset] = (value & 0xff);
      } else {
        objectWriteUInt32(this, value, offset, true);
      }
      return offset + 4
    };

    Buffer$2.prototype.writeUInt32BE = function writeUInt32BE (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0);
      if (Buffer$2.TYPED_ARRAY_SUPPORT) {
        this[offset] = (value >>> 24);
        this[offset + 1] = (value >>> 16);
        this[offset + 2] = (value >>> 8);
        this[offset + 3] = (value & 0xff);
      } else {
        objectWriteUInt32(this, value, offset, false);
      }
      return offset + 4
    };

    Buffer$2.prototype.writeIntLE = function writeIntLE (value, offset, byteLength, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) {
        var limit = Math.pow(2, 8 * byteLength - 1);

        checkInt(this, value, offset, byteLength, limit - 1, -limit);
      }

      var i = 0;
      var mul = 1;
      var sub = 0;
      this[offset] = value & 0xFF;
      while (++i < byteLength && (mul *= 0x100)) {
        if (value < 0 && sub === 0 && this[offset + i - 1] !== 0) {
          sub = 1;
        }
        this[offset + i] = ((value / mul) >> 0) - sub & 0xFF;
      }

      return offset + byteLength
    };

    Buffer$2.prototype.writeIntBE = function writeIntBE (value, offset, byteLength, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) {
        var limit = Math.pow(2, 8 * byteLength - 1);

        checkInt(this, value, offset, byteLength, limit - 1, -limit);
      }

      var i = byteLength - 1;
      var mul = 1;
      var sub = 0;
      this[offset + i] = value & 0xFF;
      while (--i >= 0 && (mul *= 0x100)) {
        if (value < 0 && sub === 0 && this[offset + i + 1] !== 0) {
          sub = 1;
        }
        this[offset + i] = ((value / mul) >> 0) - sub & 0xFF;
      }

      return offset + byteLength
    };

    Buffer$2.prototype.writeInt8 = function writeInt8 (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 1, 0x7f, -0x80);
      if (!Buffer$2.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
      if (value < 0) value = 0xff + value + 1;
      this[offset] = (value & 0xff);
      return offset + 1
    };

    Buffer$2.prototype.writeInt16LE = function writeInt16LE (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000);
      if (Buffer$2.TYPED_ARRAY_SUPPORT) {
        this[offset] = (value & 0xff);
        this[offset + 1] = (value >>> 8);
      } else {
        objectWriteUInt16(this, value, offset, true);
      }
      return offset + 2
    };

    Buffer$2.prototype.writeInt16BE = function writeInt16BE (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000);
      if (Buffer$2.TYPED_ARRAY_SUPPORT) {
        this[offset] = (value >>> 8);
        this[offset + 1] = (value & 0xff);
      } else {
        objectWriteUInt16(this, value, offset, false);
      }
      return offset + 2
    };

    Buffer$2.prototype.writeInt32LE = function writeInt32LE (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);
      if (Buffer$2.TYPED_ARRAY_SUPPORT) {
        this[offset] = (value & 0xff);
        this[offset + 1] = (value >>> 8);
        this[offset + 2] = (value >>> 16);
        this[offset + 3] = (value >>> 24);
      } else {
        objectWriteUInt32(this, value, offset, true);
      }
      return offset + 4
    };

    Buffer$2.prototype.writeInt32BE = function writeInt32BE (value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);
      if (value < 0) value = 0xffffffff + value + 1;
      if (Buffer$2.TYPED_ARRAY_SUPPORT) {
        this[offset] = (value >>> 24);
        this[offset + 1] = (value >>> 16);
        this[offset + 2] = (value >>> 8);
        this[offset + 3] = (value & 0xff);
      } else {
        objectWriteUInt32(this, value, offset, false);
      }
      return offset + 4
    };

    function checkIEEE754 (buf, value, offset, ext, max, min) {
      if (offset + ext > buf.length) throw new RangeError('Index out of range')
      if (offset < 0) throw new RangeError('Index out of range')
    }

    function writeFloat (buf, value, offset, littleEndian, noAssert) {
      if (!noAssert) {
        checkIEEE754(buf, value, offset, 4);
      }
      write(buf, value, offset, littleEndian, 23, 4);
      return offset + 4
    }

    Buffer$2.prototype.writeFloatLE = function writeFloatLE (value, offset, noAssert) {
      return writeFloat(this, value, offset, true, noAssert)
    };

    Buffer$2.prototype.writeFloatBE = function writeFloatBE (value, offset, noAssert) {
      return writeFloat(this, value, offset, false, noAssert)
    };

    function writeDouble (buf, value, offset, littleEndian, noAssert) {
      if (!noAssert) {
        checkIEEE754(buf, value, offset, 8);
      }
      write(buf, value, offset, littleEndian, 52, 8);
      return offset + 8
    }

    Buffer$2.prototype.writeDoubleLE = function writeDoubleLE (value, offset, noAssert) {
      return writeDouble(this, value, offset, true, noAssert)
    };

    Buffer$2.prototype.writeDoubleBE = function writeDoubleBE (value, offset, noAssert) {
      return writeDouble(this, value, offset, false, noAssert)
    };

    // copy(targetBuffer, targetStart=0, sourceStart=0, sourceEnd=buffer.length)
    Buffer$2.prototype.copy = function copy (target, targetStart, start, end) {
      if (!start) start = 0;
      if (!end && end !== 0) end = this.length;
      if (targetStart >= target.length) targetStart = target.length;
      if (!targetStart) targetStart = 0;
      if (end > 0 && end < start) end = start;

      // Copy 0 bytes; we're done
      if (end === start) return 0
      if (target.length === 0 || this.length === 0) return 0

      // Fatal error conditions
      if (targetStart < 0) {
        throw new RangeError('targetStart out of bounds')
      }
      if (start < 0 || start >= this.length) throw new RangeError('sourceStart out of bounds')
      if (end < 0) throw new RangeError('sourceEnd out of bounds')

      // Are we oob?
      if (end > this.length) end = this.length;
      if (target.length - targetStart < end - start) {
        end = target.length - targetStart + start;
      }

      var len = end - start;
      var i;

      if (this === target && start < targetStart && targetStart < end) {
        // descending copy from end
        for (i = len - 1; i >= 0; --i) {
          target[i + targetStart] = this[i + start];
        }
      } else if (len < 1000 || !Buffer$2.TYPED_ARRAY_SUPPORT) {
        // ascending copy from start
        for (i = 0; i < len; ++i) {
          target[i + targetStart] = this[i + start];
        }
      } else {
        Uint8Array.prototype.set.call(
          target,
          this.subarray(start, start + len),
          targetStart
        );
      }

      return len
    };

    // Usage:
    //    buffer.fill(number[, offset[, end]])
    //    buffer.fill(buffer[, offset[, end]])
    //    buffer.fill(string[, offset[, end]][, encoding])
    Buffer$2.prototype.fill = function fill (val, start, end, encoding) {
      // Handle string cases:
      if (typeof val === 'string') {
        if (typeof start === 'string') {
          encoding = start;
          start = 0;
          end = this.length;
        } else if (typeof end === 'string') {
          encoding = end;
          end = this.length;
        }
        if (val.length === 1) {
          var code = val.charCodeAt(0);
          if (code < 256) {
            val = code;
          }
        }
        if (encoding !== undefined && typeof encoding !== 'string') {
          throw new TypeError('encoding must be a string')
        }
        if (typeof encoding === 'string' && !Buffer$2.isEncoding(encoding)) {
          throw new TypeError('Unknown encoding: ' + encoding)
        }
      } else if (typeof val === 'number') {
        val = val & 255;
      }

      // Invalid ranges are not set to a default, so can range check early.
      if (start < 0 || this.length < start || this.length < end) {
        throw new RangeError('Out of range index')
      }

      if (end <= start) {
        return this
      }

      start = start >>> 0;
      end = end === undefined ? this.length : end >>> 0;

      if (!val) val = 0;

      var i;
      if (typeof val === 'number') {
        for (i = start; i < end; ++i) {
          this[i] = val;
        }
      } else {
        var bytes = internalIsBuffer(val)
          ? val
          : utf8ToBytes(new Buffer$2(val, encoding).toString());
        var len = bytes.length;
        for (i = 0; i < end - start; ++i) {
          this[i + start] = bytes[i % len];
        }
      }

      return this
    };

    // HELPER FUNCTIONS
    // ================

    var INVALID_BASE64_RE = /[^+\/0-9A-Za-z-_]/g;

    function base64clean (str) {
      // Node strips out invalid characters like \n and \t from the string, base64-js does not
      str = stringtrim(str).replace(INVALID_BASE64_RE, '');
      // Node converts strings with length < 2 to ''
      if (str.length < 2) return ''
      // Node allows for non-padded base64 strings (missing trailing ===), base64-js does not
      while (str.length % 4 !== 0) {
        str = str + '=';
      }
      return str
    }

    function stringtrim (str) {
      if (str.trim) return str.trim()
      return str.replace(/^\s+|\s+$/g, '')
    }

    function toHex$1 (n) {
      if (n < 16) return '0' + n.toString(16)
      return n.toString(16)
    }

    function utf8ToBytes (string, units) {
      units = units || Infinity;
      var codePoint;
      var length = string.length;
      var leadSurrogate = null;
      var bytes = [];

      for (var i = 0; i < length; ++i) {
        codePoint = string.charCodeAt(i);

        // is surrogate component
        if (codePoint > 0xD7FF && codePoint < 0xE000) {
          // last char was a lead
          if (!leadSurrogate) {
            // no lead yet
            if (codePoint > 0xDBFF) {
              // unexpected trail
              if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
              continue
            } else if (i + 1 === length) {
              // unpaired lead
              if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
              continue
            }

            // valid lead
            leadSurrogate = codePoint;

            continue
          }

          // 2 leads in a row
          if (codePoint < 0xDC00) {
            if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
            leadSurrogate = codePoint;
            continue
          }

          // valid surrogate pair
          codePoint = (leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00) + 0x10000;
        } else if (leadSurrogate) {
          // valid bmp char, but last char was a lead
          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
        }

        leadSurrogate = null;

        // encode utf8
        if (codePoint < 0x80) {
          if ((units -= 1) < 0) break
          bytes.push(codePoint);
        } else if (codePoint < 0x800) {
          if ((units -= 2) < 0) break
          bytes.push(
            codePoint >> 0x6 | 0xC0,
            codePoint & 0x3F | 0x80
          );
        } else if (codePoint < 0x10000) {
          if ((units -= 3) < 0) break
          bytes.push(
            codePoint >> 0xC | 0xE0,
            codePoint >> 0x6 & 0x3F | 0x80,
            codePoint & 0x3F | 0x80
          );
        } else if (codePoint < 0x110000) {
          if ((units -= 4) < 0) break
          bytes.push(
            codePoint >> 0x12 | 0xF0,
            codePoint >> 0xC & 0x3F | 0x80,
            codePoint >> 0x6 & 0x3F | 0x80,
            codePoint & 0x3F | 0x80
          );
        } else {
          throw new Error('Invalid code point')
        }
      }

      return bytes
    }

    function asciiToBytes (str) {
      var byteArray = [];
      for (var i = 0; i < str.length; ++i) {
        // Node's code seems to be doing this and not & 0x7F..
        byteArray.push(str.charCodeAt(i) & 0xFF);
      }
      return byteArray
    }

    function utf16leToBytes (str, units) {
      var c, hi, lo;
      var byteArray = [];
      for (var i = 0; i < str.length; ++i) {
        if ((units -= 2) < 0) break

        c = str.charCodeAt(i);
        hi = c >> 8;
        lo = c % 256;
        byteArray.push(lo);
        byteArray.push(hi);
      }

      return byteArray
    }


    function base64ToBytes (str) {
      return toByteArray(base64clean(str))
    }

    function blitBuffer (src, dst, offset, length) {
      for (var i = 0; i < length; ++i) {
        if ((i + offset >= dst.length) || (i >= src.length)) break
        dst[i + offset] = src[i];
      }
      return i
    }

    function isnan (val) {
      return val !== val // eslint-disable-line no-self-compare
    }


    // the following is from is-buffer, also by Feross Aboukhadijeh and with same lisence
    // The _isBuffer check is for Safari 5-7 support, because it's missing
    // Object.prototype.constructor. Remove this eventually
    function isBuffer(obj) {
      return obj != null && (!!obj._isBuffer || isFastBuffer(obj) || isSlowBuffer(obj))
    }

    function isFastBuffer (obj) {
      return !!obj.constructor && typeof obj.constructor.isBuffer === 'function' && obj.constructor.isBuffer(obj)
    }

    // For Node v0.10 support. Remove this eventually.
    function isSlowBuffer (obj) {
      return typeof obj.readFloatLE === 'function' && typeof obj.slice === 'function' && isFastBuffer(obj.slice(0, 0))
    }

    var bufferEs6 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        INSPECT_MAX_BYTES: INSPECT_MAX_BYTES,
        kMaxLength: _kMaxLength,
        Buffer: Buffer$2,
        SlowBuffer: SlowBuffer,
        isBuffer: isBuffer
    });

    function BufferList() {
      this.head = null;
      this.tail = null;
      this.length = 0;
    }

    BufferList.prototype.push = function (v) {
      var entry = { data: v, next: null };
      if (this.length > 0) this.tail.next = entry;else this.head = entry;
      this.tail = entry;
      ++this.length;
    };

    BufferList.prototype.unshift = function (v) {
      var entry = { data: v, next: this.head };
      if (this.length === 0) this.tail = entry;
      this.head = entry;
      ++this.length;
    };

    BufferList.prototype.shift = function () {
      if (this.length === 0) return;
      var ret = this.head.data;
      if (this.length === 1) this.head = this.tail = null;else this.head = this.head.next;
      --this.length;
      return ret;
    };

    BufferList.prototype.clear = function () {
      this.head = this.tail = null;
      this.length = 0;
    };

    BufferList.prototype.join = function (s) {
      if (this.length === 0) return '';
      var p = this.head;
      var ret = '' + p.data;
      while (p = p.next) {
        ret += s + p.data;
      }return ret;
    };

    BufferList.prototype.concat = function (n) {
      if (this.length === 0) return Buffer$2.alloc(0);
      if (this.length === 1) return this.head.data;
      var ret = Buffer$2.allocUnsafe(n >>> 0);
      var p = this.head;
      var i = 0;
      while (p) {
        p.data.copy(ret, i);
        i += p.data.length;
        p = p.next;
      }
      return ret;
    };

    // Copyright Joyent, Inc. and other Node contributors.
    var isBufferEncoding = Buffer$2.isEncoding
      || function(encoding) {
           switch (encoding && encoding.toLowerCase()) {
             case 'hex': case 'utf8': case 'utf-8': case 'ascii': case 'binary': case 'base64': case 'ucs2': case 'ucs-2': case 'utf16le': case 'utf-16le': case 'raw': return true;
             default: return false;
           }
         };


    function assertEncoding(encoding) {
      if (encoding && !isBufferEncoding(encoding)) {
        throw new Error('Unknown encoding: ' + encoding);
      }
    }

    // StringDecoder provides an interface for efficiently splitting a series of
    // buffers into a series of JS strings without breaking apart multi-byte
    // characters. CESU-8 is handled as part of the UTF-8 encoding.
    //
    // @TODO Handling all encodings inside a single object makes it very difficult
    // to reason about this code, so it should be split up in the future.
    // @TODO There should be a utf8-strict encoding that rejects invalid UTF-8 code
    // points as used by CESU-8.
    function StringDecoder(encoding) {
      this.encoding = (encoding || 'utf8').toLowerCase().replace(/[-_]/, '');
      assertEncoding(encoding);
      switch (this.encoding) {
        case 'utf8':
          // CESU-8 represents each of Surrogate Pair by 3-bytes
          this.surrogateSize = 3;
          break;
        case 'ucs2':
        case 'utf16le':
          // UTF-16 represents each of Surrogate Pair by 2-bytes
          this.surrogateSize = 2;
          this.detectIncompleteChar = utf16DetectIncompleteChar;
          break;
        case 'base64':
          // Base-64 stores 3 bytes in 4 chars, and pads the remainder.
          this.surrogateSize = 3;
          this.detectIncompleteChar = base64DetectIncompleteChar;
          break;
        default:
          this.write = passThroughWrite;
          return;
      }

      // Enough space to store all bytes of a single character. UTF-8 needs 4
      // bytes, but CESU-8 may require up to 6 (3 bytes per surrogate).
      this.charBuffer = new Buffer$2(6);
      // Number of bytes received for the current incomplete multi-byte character.
      this.charReceived = 0;
      // Number of bytes expected for the current incomplete multi-byte character.
      this.charLength = 0;
    }

    // write decodes the given buffer and returns it as JS string that is
    // guaranteed to not contain any partial multi-byte characters. Any partial
    // character found at the end of the buffer is buffered up, and will be
    // returned when calling write again with the remaining bytes.
    //
    // Note: Converting a Buffer containing an orphan surrogate to a String
    // currently works, but converting a String to a Buffer (via `new Buffer`, or
    // Buffer#write) will replace incomplete surrogates with the unicode
    // replacement character. See https://codereview.chromium.org/121173009/ .
    StringDecoder.prototype.write = function(buffer) {
      var charStr = '';
      // if our last write ended with an incomplete multibyte character
      while (this.charLength) {
        // determine how many remaining bytes this buffer has to offer for this char
        var available = (buffer.length >= this.charLength - this.charReceived) ?
            this.charLength - this.charReceived :
            buffer.length;

        // add the new bytes to the char buffer
        buffer.copy(this.charBuffer, this.charReceived, 0, available);
        this.charReceived += available;

        if (this.charReceived < this.charLength) {
          // still not enough chars in this buffer? wait for more ...
          return '';
        }

        // remove bytes belonging to the current character from the buffer
        buffer = buffer.slice(available, buffer.length);

        // get the character that was split
        charStr = this.charBuffer.slice(0, this.charLength).toString(this.encoding);

        // CESU-8: lead surrogate (D800-DBFF) is also the incomplete character
        var charCode = charStr.charCodeAt(charStr.length - 1);
        if (charCode >= 0xD800 && charCode <= 0xDBFF) {
          this.charLength += this.surrogateSize;
          charStr = '';
          continue;
        }
        this.charReceived = this.charLength = 0;

        // if there are no more bytes in this buffer, just emit our char
        if (buffer.length === 0) {
          return charStr;
        }
        break;
      }

      // determine and set charLength / charReceived
      this.detectIncompleteChar(buffer);

      var end = buffer.length;
      if (this.charLength) {
        // buffer the incomplete character bytes we got
        buffer.copy(this.charBuffer, 0, buffer.length - this.charReceived, end);
        end -= this.charReceived;
      }

      charStr += buffer.toString(this.encoding, 0, end);

      var end = charStr.length - 1;
      var charCode = charStr.charCodeAt(end);
      // CESU-8: lead surrogate (D800-DBFF) is also the incomplete character
      if (charCode >= 0xD800 && charCode <= 0xDBFF) {
        var size = this.surrogateSize;
        this.charLength += size;
        this.charReceived += size;
        this.charBuffer.copy(this.charBuffer, size, 0, size);
        buffer.copy(this.charBuffer, 0, 0, size);
        return charStr.substring(0, end);
      }

      // or just emit the charStr
      return charStr;
    };

    // detectIncompleteChar determines if there is an incomplete UTF-8 character at
    // the end of the given buffer. If so, it sets this.charLength to the byte
    // length that character, and sets this.charReceived to the number of bytes
    // that are available for this character.
    StringDecoder.prototype.detectIncompleteChar = function(buffer) {
      // determine how many bytes we have to check at the end of this buffer
      var i = (buffer.length >= 3) ? 3 : buffer.length;

      // Figure out if one of the last i bytes of our buffer announces an
      // incomplete char.
      for (; i > 0; i--) {
        var c = buffer[buffer.length - i];

        // See http://en.wikipedia.org/wiki/UTF-8#Description

        // 110XXXXX
        if (i == 1 && c >> 5 == 0x06) {
          this.charLength = 2;
          break;
        }

        // 1110XXXX
        if (i <= 2 && c >> 4 == 0x0E) {
          this.charLength = 3;
          break;
        }

        // 11110XXX
        if (i <= 3 && c >> 3 == 0x1E) {
          this.charLength = 4;
          break;
        }
      }
      this.charReceived = i;
    };

    StringDecoder.prototype.end = function(buffer) {
      var res = '';
      if (buffer && buffer.length)
        res = this.write(buffer);

      if (this.charReceived) {
        var cr = this.charReceived;
        var buf = this.charBuffer;
        var enc = this.encoding;
        res += buf.slice(0, cr).toString(enc);
      }

      return res;
    };

    function passThroughWrite(buffer) {
      return buffer.toString(this.encoding);
    }

    function utf16DetectIncompleteChar(buffer) {
      this.charReceived = buffer.length % 2;
      this.charLength = this.charReceived ? 2 : 0;
    }

    function base64DetectIncompleteChar(buffer) {
      this.charReceived = buffer.length % 3;
      this.charLength = this.charReceived ? 3 : 0;
    }

    Readable.ReadableState = ReadableState;

    var debug = debuglog('stream');
    inherits$1(Readable, EventEmitter);

    function prependListener(emitter, event, fn) {
      // Sadly this is not cacheable as some libraries bundle their own
      // event emitter implementation with them.
      if (typeof emitter.prependListener === 'function') {
        return emitter.prependListener(event, fn);
      } else {
        // This is a hack to make sure that our error handler is attached before any
        // userland ones.  NEVER DO THIS. This is here only because this code needs
        // to continue to work with older versions of Node.js that do not include
        // the prependListener() method. The goal is to eventually remove this hack.
        if (!emitter._events || !emitter._events[event])
          emitter.on(event, fn);
        else if (Array.isArray(emitter._events[event]))
          emitter._events[event].unshift(fn);
        else
          emitter._events[event] = [fn, emitter._events[event]];
      }
    }
    function listenerCount (emitter, type) {
      return emitter.listeners(type).length;
    }
    function ReadableState(options, stream) {

      options = options || {};

      // object stream flag. Used to make read(n) ignore n and to
      // make all the buffer merging and length checks go away
      this.objectMode = !!options.objectMode;

      if (stream instanceof Duplex) this.objectMode = this.objectMode || !!options.readableObjectMode;

      // the point at which it stops calling _read() to fill the buffer
      // Note: 0 is a valid value, means "don't call _read preemptively ever"
      var hwm = options.highWaterMark;
      var defaultHwm = this.objectMode ? 16 : 16 * 1024;
      this.highWaterMark = hwm || hwm === 0 ? hwm : defaultHwm;

      // cast to ints.
      this.highWaterMark = ~ ~this.highWaterMark;

      // A linked list is used to store data chunks instead of an array because the
      // linked list can remove elements from the beginning faster than
      // array.shift()
      this.buffer = new BufferList();
      this.length = 0;
      this.pipes = null;
      this.pipesCount = 0;
      this.flowing = null;
      this.ended = false;
      this.endEmitted = false;
      this.reading = false;

      // a flag to be able to tell if the onwrite cb is called immediately,
      // or on a later tick.  We set this to true at first, because any
      // actions that shouldn't happen until "later" should generally also
      // not happen before the first write call.
      this.sync = true;

      // whenever we return null, then we set a flag to say
      // that we're awaiting a 'readable' event emission.
      this.needReadable = false;
      this.emittedReadable = false;
      this.readableListening = false;
      this.resumeScheduled = false;

      // Crypto is kind of old and crusty.  Historically, its default string
      // encoding is 'binary' so we have to make this configurable.
      // Everything else in the universe uses 'utf8', though.
      this.defaultEncoding = options.defaultEncoding || 'utf8';

      // when piping, we only care about 'readable' events that happen
      // after read()ing all the bytes and not getting any pushback.
      this.ranOut = false;

      // the number of writers that are awaiting a drain event in .pipe()s
      this.awaitDrain = 0;

      // if true, a maybeReadMore has been scheduled
      this.readingMore = false;

      this.decoder = null;
      this.encoding = null;
      if (options.encoding) {
        this.decoder = new StringDecoder(options.encoding);
        this.encoding = options.encoding;
      }
    }
    function Readable(options) {

      if (!(this instanceof Readable)) return new Readable(options);

      this._readableState = new ReadableState(options, this);

      // legacy
      this.readable = true;

      if (options && typeof options.read === 'function') this._read = options.read;

      EventEmitter.call(this);
    }

    // Manually shove something into the read() buffer.
    // This returns true if the highWaterMark has not been hit yet,
    // similar to how Writable.write() returns true if you should
    // write() some more.
    Readable.prototype.push = function (chunk, encoding) {
      var state = this._readableState;

      if (!state.objectMode && typeof chunk === 'string') {
        encoding = encoding || state.defaultEncoding;
        if (encoding !== state.encoding) {
          chunk = Buffer$3.from(chunk, encoding);
          encoding = '';
        }
      }

      return readableAddChunk(this, state, chunk, encoding, false);
    };

    // Unshift should *always* be something directly out of read()
    Readable.prototype.unshift = function (chunk) {
      var state = this._readableState;
      return readableAddChunk(this, state, chunk, '', true);
    };

    Readable.prototype.isPaused = function () {
      return this._readableState.flowing === false;
    };

    function readableAddChunk(stream, state, chunk, encoding, addToFront) {
      var er = chunkInvalid(state, chunk);
      if (er) {
        stream.emit('error', er);
      } else if (chunk === null) {
        state.reading = false;
        onEofChunk(stream, state);
      } else if (state.objectMode || chunk && chunk.length > 0) {
        if (state.ended && !addToFront) {
          var e = new Error('stream.push() after EOF');
          stream.emit('error', e);
        } else if (state.endEmitted && addToFront) {
          var _e = new Error('stream.unshift() after end event');
          stream.emit('error', _e);
        } else {
          var skipAdd;
          if (state.decoder && !addToFront && !encoding) {
            chunk = state.decoder.write(chunk);
            skipAdd = !state.objectMode && chunk.length === 0;
          }

          if (!addToFront) state.reading = false;

          // Don't add to the buffer if we've decoded to an empty string chunk and
          // we're not in object mode
          if (!skipAdd) {
            // if we want the data now, just emit it.
            if (state.flowing && state.length === 0 && !state.sync) {
              stream.emit('data', chunk);
              stream.read(0);
            } else {
              // update the buffer info.
              state.length += state.objectMode ? 1 : chunk.length;
              if (addToFront) state.buffer.unshift(chunk);else state.buffer.push(chunk);

              if (state.needReadable) emitReadable(stream);
            }
          }

          maybeReadMore(stream, state);
        }
      } else if (!addToFront) {
        state.reading = false;
      }

      return needMoreData(state);
    }

    // if it's past the high water mark, we can push in some more.
    // Also, if we have no data yet, we can stand some
    // more bytes.  This is to work around cases where hwm=0,
    // such as the repl.  Also, if the push() triggered a
    // readable event, and the user called read(largeNumber) such that
    // needReadable was set, then we ought to push more, so that another
    // 'readable' event will be triggered.
    function needMoreData(state) {
      return !state.ended && (state.needReadable || state.length < state.highWaterMark || state.length === 0);
    }

    // backwards compatibility.
    Readable.prototype.setEncoding = function (enc) {
      this._readableState.decoder = new StringDecoder(enc);
      this._readableState.encoding = enc;
      return this;
    };

    // Don't raise the hwm > 8MB
    var MAX_HWM = 0x800000;
    function computeNewHighWaterMark(n) {
      if (n >= MAX_HWM) {
        n = MAX_HWM;
      } else {
        // Get the next highest power of 2 to prevent increasing hwm excessively in
        // tiny amounts
        n--;
        n |= n >>> 1;
        n |= n >>> 2;
        n |= n >>> 4;
        n |= n >>> 8;
        n |= n >>> 16;
        n++;
      }
      return n;
    }

    // This function is designed to be inlinable, so please take care when making
    // changes to the function body.
    function howMuchToRead(n, state) {
      if (n <= 0 || state.length === 0 && state.ended) return 0;
      if (state.objectMode) return 1;
      if (n !== n) {
        // Only flow one buffer at a time
        if (state.flowing && state.length) return state.buffer.head.data.length;else return state.length;
      }
      // If we're asking for more than the current hwm, then raise the hwm.
      if (n > state.highWaterMark) state.highWaterMark = computeNewHighWaterMark(n);
      if (n <= state.length) return n;
      // Don't have enough
      if (!state.ended) {
        state.needReadable = true;
        return 0;
      }
      return state.length;
    }

    // you can override either this method, or the async _read(n) below.
    Readable.prototype.read = function (n) {
      debug('read', n);
      n = parseInt(n, 10);
      var state = this._readableState;
      var nOrig = n;

      if (n !== 0) state.emittedReadable = false;

      // if we're doing read(0) to trigger a readable event, but we
      // already have a bunch of data in the buffer, then just trigger
      // the 'readable' event and move on.
      if (n === 0 && state.needReadable && (state.length >= state.highWaterMark || state.ended)) {
        debug('read: emitReadable', state.length, state.ended);
        if (state.length === 0 && state.ended) endReadable(this);else emitReadable(this);
        return null;
      }

      n = howMuchToRead(n, state);

      // if we've ended, and we're now clear, then finish it up.
      if (n === 0 && state.ended) {
        if (state.length === 0) endReadable(this);
        return null;
      }

      // All the actual chunk generation logic needs to be
      // *below* the call to _read.  The reason is that in certain
      // synthetic stream cases, such as passthrough streams, _read
      // may be a completely synchronous operation which may change
      // the state of the read buffer, providing enough data when
      // before there was *not* enough.
      //
      // So, the steps are:
      // 1. Figure out what the state of things will be after we do
      // a read from the buffer.
      //
      // 2. If that resulting state will trigger a _read, then call _read.
      // Note that this may be asynchronous, or synchronous.  Yes, it is
      // deeply ugly to write APIs this way, but that still doesn't mean
      // that the Readable class should behave improperly, as streams are
      // designed to be sync/async agnostic.
      // Take note if the _read call is sync or async (ie, if the read call
      // has returned yet), so that we know whether or not it's safe to emit
      // 'readable' etc.
      //
      // 3. Actually pull the requested chunks out of the buffer and return.

      // if we need a readable event, then we need to do some reading.
      var doRead = state.needReadable;
      debug('need readable', doRead);

      // if we currently have less than the highWaterMark, then also read some
      if (state.length === 0 || state.length - n < state.highWaterMark) {
        doRead = true;
        debug('length less than watermark', doRead);
      }

      // however, if we've ended, then there's no point, and if we're already
      // reading, then it's unnecessary.
      if (state.ended || state.reading) {
        doRead = false;
        debug('reading or ended', doRead);
      } else if (doRead) {
        debug('do read');
        state.reading = true;
        state.sync = true;
        // if the length is currently zero, then we *need* a readable event.
        if (state.length === 0) state.needReadable = true;
        // call internal read method
        this._read(state.highWaterMark);
        state.sync = false;
        // If _read pushed data synchronously, then `reading` will be false,
        // and we need to re-evaluate how much data we can return to the user.
        if (!state.reading) n = howMuchToRead(nOrig, state);
      }

      var ret;
      if (n > 0) ret = fromList(n, state);else ret = null;

      if (ret === null) {
        state.needReadable = true;
        n = 0;
      } else {
        state.length -= n;
      }

      if (state.length === 0) {
        // If we have nothing in the buffer, then we want to know
        // as soon as we *do* get something into the buffer.
        if (!state.ended) state.needReadable = true;

        // If we tried to read() past the EOF, then emit end on the next tick.
        if (nOrig !== n && state.ended) endReadable(this);
      }

      if (ret !== null) this.emit('data', ret);

      return ret;
    };

    function chunkInvalid(state, chunk) {
      var er = null;
      if (!Buffer$3.isBuffer(chunk) && typeof chunk !== 'string' && chunk !== null && chunk !== undefined && !state.objectMode) {
        er = new TypeError('Invalid non-string/buffer chunk');
      }
      return er;
    }

    function onEofChunk(stream, state) {
      if (state.ended) return;
      if (state.decoder) {
        var chunk = state.decoder.end();
        if (chunk && chunk.length) {
          state.buffer.push(chunk);
          state.length += state.objectMode ? 1 : chunk.length;
        }
      }
      state.ended = true;

      // emit 'readable' now to make sure it gets picked up.
      emitReadable(stream);
    }

    // Don't emit readable right away in sync mode, because this can trigger
    // another read() call => stack overflow.  This way, it might trigger
    // a nextTick recursion warning, but that's not so bad.
    function emitReadable(stream) {
      var state = stream._readableState;
      state.needReadable = false;
      if (!state.emittedReadable) {
        debug('emitReadable', state.flowing);
        state.emittedReadable = true;
        if (state.sync) nextTick(emitReadable_, stream);else emitReadable_(stream);
      }
    }

    function emitReadable_(stream) {
      debug('emit readable');
      stream.emit('readable');
      flow(stream);
    }

    // at this point, the user has presumably seen the 'readable' event,
    // and called read() to consume some data.  that may have triggered
    // in turn another _read(n) call, in which case reading = true if
    // it's in progress.
    // However, if we're not ended, or reading, and the length < hwm,
    // then go ahead and try to read some more preemptively.
    function maybeReadMore(stream, state) {
      if (!state.readingMore) {
        state.readingMore = true;
        nextTick(maybeReadMore_, stream, state);
      }
    }

    function maybeReadMore_(stream, state) {
      var len = state.length;
      while (!state.reading && !state.flowing && !state.ended && state.length < state.highWaterMark) {
        debug('maybeReadMore read 0');
        stream.read(0);
        if (len === state.length)
          // didn't get any data, stop spinning.
          break;else len = state.length;
      }
      state.readingMore = false;
    }

    // abstract method.  to be overridden in specific implementation classes.
    // call cb(er, data) where data is <= n in length.
    // for virtual (non-string, non-buffer) streams, "length" is somewhat
    // arbitrary, and perhaps not very meaningful.
    Readable.prototype._read = function (n) {
      this.emit('error', new Error('not implemented'));
    };

    Readable.prototype.pipe = function (dest, pipeOpts) {
      var src = this;
      var state = this._readableState;

      switch (state.pipesCount) {
        case 0:
          state.pipes = dest;
          break;
        case 1:
          state.pipes = [state.pipes, dest];
          break;
        default:
          state.pipes.push(dest);
          break;
      }
      state.pipesCount += 1;
      debug('pipe count=%d opts=%j', state.pipesCount, pipeOpts);

      var doEnd = (!pipeOpts || pipeOpts.end !== false);

      var endFn = doEnd ? onend : cleanup;
      if (state.endEmitted) nextTick(endFn);else src.once('end', endFn);

      dest.on('unpipe', onunpipe);
      function onunpipe(readable) {
        debug('onunpipe');
        if (readable === src) {
          cleanup();
        }
      }

      function onend() {
        debug('onend');
        dest.end();
      }

      // when the dest drains, it reduces the awaitDrain counter
      // on the source.  This would be more elegant with a .once()
      // handler in flow(), but adding and removing repeatedly is
      // too slow.
      var ondrain = pipeOnDrain(src);
      dest.on('drain', ondrain);

      var cleanedUp = false;
      function cleanup() {
        debug('cleanup');
        // cleanup event handlers once the pipe is broken
        dest.removeListener('close', onclose);
        dest.removeListener('finish', onfinish);
        dest.removeListener('drain', ondrain);
        dest.removeListener('error', onerror);
        dest.removeListener('unpipe', onunpipe);
        src.removeListener('end', onend);
        src.removeListener('end', cleanup);
        src.removeListener('data', ondata);

        cleanedUp = true;

        // if the reader is waiting for a drain event from this
        // specific writer, then it would cause it to never start
        // flowing again.
        // So, if this is awaiting a drain, then we just call it now.
        // If we don't know, then assume that we are waiting for one.
        if (state.awaitDrain && (!dest._writableState || dest._writableState.needDrain)) ondrain();
      }

      // If the user pushes more data while we're writing to dest then we'll end up
      // in ondata again. However, we only want to increase awaitDrain once because
      // dest will only emit one 'drain' event for the multiple writes.
      // => Introduce a guard on increasing awaitDrain.
      var increasedAwaitDrain = false;
      src.on('data', ondata);
      function ondata(chunk) {
        debug('ondata');
        increasedAwaitDrain = false;
        var ret = dest.write(chunk);
        if (false === ret && !increasedAwaitDrain) {
          // If the user unpiped during `dest.write()`, it is possible
          // to get stuck in a permanently paused state if that write
          // also returned false.
          // => Check whether `dest` is still a piping destination.
          if ((state.pipesCount === 1 && state.pipes === dest || state.pipesCount > 1 && indexOf(state.pipes, dest) !== -1) && !cleanedUp) {
            debug('false write response, pause', src._readableState.awaitDrain);
            src._readableState.awaitDrain++;
            increasedAwaitDrain = true;
          }
          src.pause();
        }
      }

      // if the dest has an error, then stop piping into it.
      // however, don't suppress the throwing behavior for this.
      function onerror(er) {
        debug('onerror', er);
        unpipe();
        dest.removeListener('error', onerror);
        if (listenerCount(dest, 'error') === 0) dest.emit('error', er);
      }

      // Make sure our error handler is attached before userland ones.
      prependListener(dest, 'error', onerror);

      // Both close and finish should trigger unpipe, but only once.
      function onclose() {
        dest.removeListener('finish', onfinish);
        unpipe();
      }
      dest.once('close', onclose);
      function onfinish() {
        debug('onfinish');
        dest.removeListener('close', onclose);
        unpipe();
      }
      dest.once('finish', onfinish);

      function unpipe() {
        debug('unpipe');
        src.unpipe(dest);
      }

      // tell the dest that it's being piped to
      dest.emit('pipe', src);

      // start the flow if it hasn't been started already.
      if (!state.flowing) {
        debug('pipe resume');
        src.resume();
      }

      return dest;
    };

    function pipeOnDrain(src) {
      return function () {
        var state = src._readableState;
        debug('pipeOnDrain', state.awaitDrain);
        if (state.awaitDrain) state.awaitDrain--;
        if (state.awaitDrain === 0 && src.listeners('data').length) {
          state.flowing = true;
          flow(src);
        }
      };
    }

    Readable.prototype.unpipe = function (dest) {
      var state = this._readableState;

      // if we're not piping anywhere, then do nothing.
      if (state.pipesCount === 0) return this;

      // just one destination.  most common case.
      if (state.pipesCount === 1) {
        // passed in one, but it's not the right one.
        if (dest && dest !== state.pipes) return this;

        if (!dest) dest = state.pipes;

        // got a match.
        state.pipes = null;
        state.pipesCount = 0;
        state.flowing = false;
        if (dest) dest.emit('unpipe', this);
        return this;
      }

      // slow case. multiple pipe destinations.

      if (!dest) {
        // remove all.
        var dests = state.pipes;
        var len = state.pipesCount;
        state.pipes = null;
        state.pipesCount = 0;
        state.flowing = false;

        for (var _i = 0; _i < len; _i++) {
          dests[_i].emit('unpipe', this);
        }return this;
      }

      // try to find the right one.
      var i = indexOf(state.pipes, dest);
      if (i === -1) return this;

      state.pipes.splice(i, 1);
      state.pipesCount -= 1;
      if (state.pipesCount === 1) state.pipes = state.pipes[0];

      dest.emit('unpipe', this);

      return this;
    };

    // set up data events if they are asked for
    // Ensure readable listeners eventually get something
    Readable.prototype.on = function (ev, fn) {
      var res = EventEmitter.prototype.on.call(this, ev, fn);

      if (ev === 'data') {
        // Start flowing on next tick if stream isn't explicitly paused
        if (this._readableState.flowing !== false) this.resume();
      } else if (ev === 'readable') {
        var state = this._readableState;
        if (!state.endEmitted && !state.readableListening) {
          state.readableListening = state.needReadable = true;
          state.emittedReadable = false;
          if (!state.reading) {
            nextTick(nReadingNextTick, this);
          } else if (state.length) {
            emitReadable(this);
          }
        }
      }

      return res;
    };
    Readable.prototype.addListener = Readable.prototype.on;

    function nReadingNextTick(self) {
      debug('readable nexttick read 0');
      self.read(0);
    }

    // pause() and resume() are remnants of the legacy readable stream API
    // If the user uses them, then switch into old mode.
    Readable.prototype.resume = function () {
      var state = this._readableState;
      if (!state.flowing) {
        debug('resume');
        state.flowing = true;
        resume(this, state);
      }
      return this;
    };

    function resume(stream, state) {
      if (!state.resumeScheduled) {
        state.resumeScheduled = true;
        nextTick(resume_, stream, state);
      }
    }

    function resume_(stream, state) {
      if (!state.reading) {
        debug('resume read 0');
        stream.read(0);
      }

      state.resumeScheduled = false;
      state.awaitDrain = 0;
      stream.emit('resume');
      flow(stream);
      if (state.flowing && !state.reading) stream.read(0);
    }

    Readable.prototype.pause = function () {
      debug('call pause flowing=%j', this._readableState.flowing);
      if (false !== this._readableState.flowing) {
        debug('pause');
        this._readableState.flowing = false;
        this.emit('pause');
      }
      return this;
    };

    function flow(stream) {
      var state = stream._readableState;
      debug('flow', state.flowing);
      while (state.flowing && stream.read() !== null) {}
    }

    // wrap an old-style stream as the async data source.
    // This is *not* part of the readable stream interface.
    // It is an ugly unfortunate mess of history.
    Readable.prototype.wrap = function (stream) {
      var state = this._readableState;
      var paused = false;

      var self = this;
      stream.on('end', function () {
        debug('wrapped end');
        if (state.decoder && !state.ended) {
          var chunk = state.decoder.end();
          if (chunk && chunk.length) self.push(chunk);
        }

        self.push(null);
      });

      stream.on('data', function (chunk) {
        debug('wrapped data');
        if (state.decoder) chunk = state.decoder.write(chunk);

        // don't skip over falsy values in objectMode
        if (state.objectMode && (chunk === null || chunk === undefined)) return;else if (!state.objectMode && (!chunk || !chunk.length)) return;

        var ret = self.push(chunk);
        if (!ret) {
          paused = true;
          stream.pause();
        }
      });

      // proxy all the other methods.
      // important when wrapping filters and duplexes.
      for (var i in stream) {
        if (this[i] === undefined && typeof stream[i] === 'function') {
          this[i] = function (method) {
            return function () {
              return stream[method].apply(stream, arguments);
            };
          }(i);
        }
      }

      // proxy certain important events.
      var events = ['error', 'close', 'destroy', 'pause', 'resume'];
      forEach(events, function (ev) {
        stream.on(ev, self.emit.bind(self, ev));
      });

      // when we try to consume some more bytes, simply unpause the
      // underlying stream.
      self._read = function (n) {
        debug('wrapped _read', n);
        if (paused) {
          paused = false;
          stream.resume();
        }
      };

      return self;
    };

    // exposed for testing purposes only.
    Readable._fromList = fromList;

    // Pluck off n bytes from an array of buffers.
    // Length is the combined lengths of all the buffers in the list.
    // This function is designed to be inlinable, so please take care when making
    // changes to the function body.
    function fromList(n, state) {
      // nothing buffered
      if (state.length === 0) return null;

      var ret;
      if (state.objectMode) ret = state.buffer.shift();else if (!n || n >= state.length) {
        // read it all, truncate the list
        if (state.decoder) ret = state.buffer.join('');else if (state.buffer.length === 1) ret = state.buffer.head.data;else ret = state.buffer.concat(state.length);
        state.buffer.clear();
      } else {
        // read part of list
        ret = fromListPartial(n, state.buffer, state.decoder);
      }

      return ret;
    }

    // Extracts only enough buffered data to satisfy the amount requested.
    // This function is designed to be inlinable, so please take care when making
    // changes to the function body.
    function fromListPartial(n, list, hasStrings) {
      var ret;
      if (n < list.head.data.length) {
        // slice is the same for buffers and strings
        ret = list.head.data.slice(0, n);
        list.head.data = list.head.data.slice(n);
      } else if (n === list.head.data.length) {
        // first chunk is a perfect match
        ret = list.shift();
      } else {
        // result spans more than one buffer
        ret = hasStrings ? copyFromBufferString(n, list) : copyFromBuffer(n, list);
      }
      return ret;
    }

    // Copies a specified amount of characters from the list of buffered data
    // chunks.
    // This function is designed to be inlinable, so please take care when making
    // changes to the function body.
    function copyFromBufferString(n, list) {
      var p = list.head;
      var c = 1;
      var ret = p.data;
      n -= ret.length;
      while (p = p.next) {
        var str = p.data;
        var nb = n > str.length ? str.length : n;
        if (nb === str.length) ret += str;else ret += str.slice(0, n);
        n -= nb;
        if (n === 0) {
          if (nb === str.length) {
            ++c;
            if (p.next) list.head = p.next;else list.head = list.tail = null;
          } else {
            list.head = p;
            p.data = str.slice(nb);
          }
          break;
        }
        ++c;
      }
      list.length -= c;
      return ret;
    }

    // Copies a specified amount of bytes from the list of buffered data chunks.
    // This function is designed to be inlinable, so please take care when making
    // changes to the function body.
    function copyFromBuffer(n, list) {
      var ret = Buffer$3.allocUnsafe(n);
      var p = list.head;
      var c = 1;
      p.data.copy(ret);
      n -= p.data.length;
      while (p = p.next) {
        var buf = p.data;
        var nb = n > buf.length ? buf.length : n;
        buf.copy(ret, ret.length - n, 0, nb);
        n -= nb;
        if (n === 0) {
          if (nb === buf.length) {
            ++c;
            if (p.next) list.head = p.next;else list.head = list.tail = null;
          } else {
            list.head = p;
            p.data = buf.slice(nb);
          }
          break;
        }
        ++c;
      }
      list.length -= c;
      return ret;
    }

    function endReadable(stream) {
      var state = stream._readableState;

      // If we get here before consuming all the bytes, then that is a
      // bug in node.  Should never happen.
      if (state.length > 0) throw new Error('"endReadable()" called on non-empty stream');

      if (!state.endEmitted) {
        state.ended = true;
        nextTick(endReadableNT, state, stream);
      }
    }

    function endReadableNT(state, stream) {
      // Check that we didn't get one last unshift.
      if (!state.endEmitted && state.length === 0) {
        state.endEmitted = true;
        stream.readable = false;
        stream.emit('end');
      }
    }

    function forEach(xs, f) {
      for (var i = 0, l = xs.length; i < l; i++) {
        f(xs[i], i);
      }
    }

    function indexOf(xs, x) {
      for (var i = 0, l = xs.length; i < l; i++) {
        if (xs[i] === x) return i;
      }
      return -1;
    }

    // A bit simpler than readable streams.
    Writable.WritableState = WritableState;
    inherits$1(Writable, EventEmitter);

    function nop() {}

    function WriteReq(chunk, encoding, cb) {
      this.chunk = chunk;
      this.encoding = encoding;
      this.callback = cb;
      this.next = null;
    }

    function WritableState(options, stream) {
      Object.defineProperty(this, 'buffer', {
        get: deprecate(function () {
          return this.getBuffer();
        }, '_writableState.buffer is deprecated. Use _writableState.getBuffer ' + 'instead.')
      });
      options = options || {};

      // object stream flag to indicate whether or not this stream
      // contains buffers or objects.
      this.objectMode = !!options.objectMode;

      if (stream instanceof Duplex) this.objectMode = this.objectMode || !!options.writableObjectMode;

      // the point at which write() starts returning false
      // Note: 0 is a valid value, means that we always return false if
      // the entire buffer is not flushed immediately on write()
      var hwm = options.highWaterMark;
      var defaultHwm = this.objectMode ? 16 : 16 * 1024;
      this.highWaterMark = hwm || hwm === 0 ? hwm : defaultHwm;

      // cast to ints.
      this.highWaterMark = ~ ~this.highWaterMark;

      this.needDrain = false;
      // at the start of calling end()
      this.ending = false;
      // when end() has been called, and returned
      this.ended = false;
      // when 'finish' is emitted
      this.finished = false;

      // should we decode strings into buffers before passing to _write?
      // this is here so that some node-core streams can optimize string
      // handling at a lower level.
      var noDecode = options.decodeStrings === false;
      this.decodeStrings = !noDecode;

      // Crypto is kind of old and crusty.  Historically, its default string
      // encoding is 'binary' so we have to make this configurable.
      // Everything else in the universe uses 'utf8', though.
      this.defaultEncoding = options.defaultEncoding || 'utf8';

      // not an actual buffer we keep track of, but a measurement
      // of how much we're waiting to get pushed to some underlying
      // socket or file.
      this.length = 0;

      // a flag to see when we're in the middle of a write.
      this.writing = false;

      // when true all writes will be buffered until .uncork() call
      this.corked = 0;

      // a flag to be able to tell if the onwrite cb is called immediately,
      // or on a later tick.  We set this to true at first, because any
      // actions that shouldn't happen until "later" should generally also
      // not happen before the first write call.
      this.sync = true;

      // a flag to know if we're processing previously buffered items, which
      // may call the _write() callback in the same tick, so that we don't
      // end up in an overlapped onwrite situation.
      this.bufferProcessing = false;

      // the callback that's passed to _write(chunk,cb)
      this.onwrite = function (er) {
        onwrite(stream, er);
      };

      // the callback that the user supplies to write(chunk,encoding,cb)
      this.writecb = null;

      // the amount that is being written when _write is called.
      this.writelen = 0;

      this.bufferedRequest = null;
      this.lastBufferedRequest = null;

      // number of pending user-supplied write callbacks
      // this must be 0 before 'finish' can be emitted
      this.pendingcb = 0;

      // emit prefinish if the only thing we're waiting for is _write cbs
      // This is relevant for synchronous Transform streams
      this.prefinished = false;

      // True if the error was already emitted and should not be thrown again
      this.errorEmitted = false;

      // count buffered requests
      this.bufferedRequestCount = 0;

      // allocate the first CorkedRequest, there is always
      // one allocated and free to use, and we maintain at most two
      this.corkedRequestsFree = new CorkedRequest(this);
    }

    WritableState.prototype.getBuffer = function writableStateGetBuffer() {
      var current = this.bufferedRequest;
      var out = [];
      while (current) {
        out.push(current);
        current = current.next;
      }
      return out;
    };
    function Writable(options) {

      // Writable ctor is applied to Duplexes, though they're not
      // instanceof Writable, they're instanceof Readable.
      if (!(this instanceof Writable) && !(this instanceof Duplex)) return new Writable(options);

      this._writableState = new WritableState(options, this);

      // legacy.
      this.writable = true;

      if (options) {
        if (typeof options.write === 'function') this._write = options.write;

        if (typeof options.writev === 'function') this._writev = options.writev;
      }

      EventEmitter.call(this);
    }

    // Otherwise people can pipe Writable streams, which is just wrong.
    Writable.prototype.pipe = function () {
      this.emit('error', new Error('Cannot pipe, not readable'));
    };

    function writeAfterEnd(stream, cb) {
      var er = new Error('write after end');
      // TODO: defer error events consistently everywhere, not just the cb
      stream.emit('error', er);
      nextTick(cb, er);
    }

    // If we get something that is not a buffer, string, null, or undefined,
    // and we're not in objectMode, then that's an error.
    // Otherwise stream chunks are all considered to be of length=1, and the
    // watermarks determine how many objects to keep in the buffer, rather than
    // how many bytes or characters.
    function validChunk(stream, state, chunk, cb) {
      var valid = true;
      var er = false;
      // Always throw error if a null is written
      // if we are not in object mode then throw
      // if it is not a buffer, string, or undefined.
      if (chunk === null) {
        er = new TypeError('May not write null values to stream');
      } else if (!Buffer$2.isBuffer(chunk) && typeof chunk !== 'string' && chunk !== undefined && !state.objectMode) {
        er = new TypeError('Invalid non-string/buffer chunk');
      }
      if (er) {
        stream.emit('error', er);
        nextTick(cb, er);
        valid = false;
      }
      return valid;
    }

    Writable.prototype.write = function (chunk, encoding, cb) {
      var state = this._writableState;
      var ret = false;

      if (typeof encoding === 'function') {
        cb = encoding;
        encoding = null;
      }

      if (Buffer$2.isBuffer(chunk)) encoding = 'buffer';else if (!encoding) encoding = state.defaultEncoding;

      if (typeof cb !== 'function') cb = nop;

      if (state.ended) writeAfterEnd(this, cb);else if (validChunk(this, state, chunk, cb)) {
        state.pendingcb++;
        ret = writeOrBuffer(this, state, chunk, encoding, cb);
      }

      return ret;
    };

    Writable.prototype.cork = function () {
      var state = this._writableState;

      state.corked++;
    };

    Writable.prototype.uncork = function () {
      var state = this._writableState;

      if (state.corked) {
        state.corked--;

        if (!state.writing && !state.corked && !state.finished && !state.bufferProcessing && state.bufferedRequest) clearBuffer(this, state);
      }
    };

    Writable.prototype.setDefaultEncoding = function setDefaultEncoding(encoding) {
      // node::ParseEncoding() requires lower case.
      if (typeof encoding === 'string') encoding = encoding.toLowerCase();
      if (!(['hex', 'utf8', 'utf-8', 'ascii', 'binary', 'base64', 'ucs2', 'ucs-2', 'utf16le', 'utf-16le', 'raw'].indexOf((encoding + '').toLowerCase()) > -1)) throw new TypeError('Unknown encoding: ' + encoding);
      this._writableState.defaultEncoding = encoding;
      return this;
    };

    function decodeChunk(state, chunk, encoding) {
      if (!state.objectMode && state.decodeStrings !== false && typeof chunk === 'string') {
        chunk = Buffer$2.from(chunk, encoding);
      }
      return chunk;
    }

    // if we're already writing something, then just put this
    // in the queue, and wait our turn.  Otherwise, call _write
    // If we return false, then we need a drain event, so set that flag.
    function writeOrBuffer(stream, state, chunk, encoding, cb) {
      chunk = decodeChunk(state, chunk, encoding);

      if (Buffer$2.isBuffer(chunk)) encoding = 'buffer';
      var len = state.objectMode ? 1 : chunk.length;

      state.length += len;

      var ret = state.length < state.highWaterMark;
      // we must ensure that previous needDrain will not be reset to false.
      if (!ret) state.needDrain = true;

      if (state.writing || state.corked) {
        var last = state.lastBufferedRequest;
        state.lastBufferedRequest = new WriteReq(chunk, encoding, cb);
        if (last) {
          last.next = state.lastBufferedRequest;
        } else {
          state.bufferedRequest = state.lastBufferedRequest;
        }
        state.bufferedRequestCount += 1;
      } else {
        doWrite(stream, state, false, len, chunk, encoding, cb);
      }

      return ret;
    }

    function doWrite(stream, state, writev, len, chunk, encoding, cb) {
      state.writelen = len;
      state.writecb = cb;
      state.writing = true;
      state.sync = true;
      if (writev) stream._writev(chunk, state.onwrite);else stream._write(chunk, encoding, state.onwrite);
      state.sync = false;
    }

    function onwriteError(stream, state, sync, er, cb) {
      --state.pendingcb;
      if (sync) nextTick(cb, er);else cb(er);

      stream._writableState.errorEmitted = true;
      stream.emit('error', er);
    }

    function onwriteStateUpdate(state) {
      state.writing = false;
      state.writecb = null;
      state.length -= state.writelen;
      state.writelen = 0;
    }

    function onwrite(stream, er) {
      var state = stream._writableState;
      var sync = state.sync;
      var cb = state.writecb;

      onwriteStateUpdate(state);

      if (er) onwriteError(stream, state, sync, er, cb);else {
        // Check if we're actually ready to finish, but don't emit yet
        var finished = needFinish(state);

        if (!finished && !state.corked && !state.bufferProcessing && state.bufferedRequest) {
          clearBuffer(stream, state);
        }

        if (sync) {
          /*<replacement>*/
            nextTick(afterWrite, stream, state, finished, cb);
          /*</replacement>*/
        } else {
            afterWrite(stream, state, finished, cb);
          }
      }
    }

    function afterWrite(stream, state, finished, cb) {
      if (!finished) onwriteDrain(stream, state);
      state.pendingcb--;
      cb();
      finishMaybe(stream, state);
    }

    // Must force callback to be called on nextTick, so that we don't
    // emit 'drain' before the write() consumer gets the 'false' return
    // value, and has a chance to attach a 'drain' listener.
    function onwriteDrain(stream, state) {
      if (state.length === 0 && state.needDrain) {
        state.needDrain = false;
        stream.emit('drain');
      }
    }

    // if there's something in the buffer waiting, then process it
    function clearBuffer(stream, state) {
      state.bufferProcessing = true;
      var entry = state.bufferedRequest;

      if (stream._writev && entry && entry.next) {
        // Fast case, write everything using _writev()
        var l = state.bufferedRequestCount;
        var buffer = new Array(l);
        var holder = state.corkedRequestsFree;
        holder.entry = entry;

        var count = 0;
        while (entry) {
          buffer[count] = entry;
          entry = entry.next;
          count += 1;
        }

        doWrite(stream, state, true, state.length, buffer, '', holder.finish);

        // doWrite is almost always async, defer these to save a bit of time
        // as the hot path ends with doWrite
        state.pendingcb++;
        state.lastBufferedRequest = null;
        if (holder.next) {
          state.corkedRequestsFree = holder.next;
          holder.next = null;
        } else {
          state.corkedRequestsFree = new CorkedRequest(state);
        }
      } else {
        // Slow case, write chunks one-by-one
        while (entry) {
          var chunk = entry.chunk;
          var encoding = entry.encoding;
          var cb = entry.callback;
          var len = state.objectMode ? 1 : chunk.length;

          doWrite(stream, state, false, len, chunk, encoding, cb);
          entry = entry.next;
          // if we didn't call the onwrite immediately, then
          // it means that we need to wait until it does.
          // also, that means that the chunk and cb are currently
          // being processed, so move the buffer counter past them.
          if (state.writing) {
            break;
          }
        }

        if (entry === null) state.lastBufferedRequest = null;
      }

      state.bufferedRequestCount = 0;
      state.bufferedRequest = entry;
      state.bufferProcessing = false;
    }

    Writable.prototype._write = function (chunk, encoding, cb) {
      cb(new Error('not implemented'));
    };

    Writable.prototype._writev = null;

    Writable.prototype.end = function (chunk, encoding, cb) {
      var state = this._writableState;

      if (typeof chunk === 'function') {
        cb = chunk;
        chunk = null;
        encoding = null;
      } else if (typeof encoding === 'function') {
        cb = encoding;
        encoding = null;
      }

      if (chunk !== null && chunk !== undefined) this.write(chunk, encoding);

      // .end() fully uncorks
      if (state.corked) {
        state.corked = 1;
        this.uncork();
      }

      // ignore unnecessary end() calls.
      if (!state.ending && !state.finished) endWritable(this, state, cb);
    };

    function needFinish(state) {
      return state.ending && state.length === 0 && state.bufferedRequest === null && !state.finished && !state.writing;
    }

    function prefinish(stream, state) {
      if (!state.prefinished) {
        state.prefinished = true;
        stream.emit('prefinish');
      }
    }

    function finishMaybe(stream, state) {
      var need = needFinish(state);
      if (need) {
        if (state.pendingcb === 0) {
          prefinish(stream, state);
          state.finished = true;
          stream.emit('finish');
        } else {
          prefinish(stream, state);
        }
      }
      return need;
    }

    function endWritable(stream, state, cb) {
      state.ending = true;
      finishMaybe(stream, state);
      if (cb) {
        if (state.finished) nextTick(cb);else stream.once('finish', cb);
      }
      state.ended = true;
      stream.writable = false;
    }

    // It seems a linked list but it is not
    // there will be only 2 of these for each stream
    function CorkedRequest(state) {
      var _this = this;

      this.next = null;
      this.entry = null;

      this.finish = function (err) {
        var entry = _this.entry;
        _this.entry = null;
        while (entry) {
          var cb = entry.callback;
          state.pendingcb--;
          cb(err);
          entry = entry.next;
        }
        if (state.corkedRequestsFree) {
          state.corkedRequestsFree.next = _this;
        } else {
          state.corkedRequestsFree = _this;
        }
      };
    }

    inherits$1(Duplex, Readable);

    var keys = Object.keys(Writable.prototype);
    for (var v = 0; v < keys.length; v++) {
      var method = keys[v];
      if (!Duplex.prototype[method]) Duplex.prototype[method] = Writable.prototype[method];
    }
    function Duplex(options) {
      if (!(this instanceof Duplex)) return new Duplex(options);

      Readable.call(this, options);
      Writable.call(this, options);

      if (options && options.readable === false) this.readable = false;

      if (options && options.writable === false) this.writable = false;

      this.allowHalfOpen = true;
      if (options && options.allowHalfOpen === false) this.allowHalfOpen = false;

      this.once('end', onend);
    }

    // the no-half-open enforcer
    function onend() {
      // if we allow half-open state, or if the writable side ended,
      // then we're ok.
      if (this.allowHalfOpen || this._writableState.ended) return;

      // no more data can be written.
      // But allow more writes to happen in this tick.
      nextTick(onEndNT, this);
    }

    function onEndNT(self) {
      self.end();
    }

    // a transform stream is a readable/writable stream where you do
    inherits$1(Transform, Duplex);

    function TransformState(stream) {
      this.afterTransform = function (er, data) {
        return afterTransform(stream, er, data);
      };

      this.needTransform = false;
      this.transforming = false;
      this.writecb = null;
      this.writechunk = null;
      this.writeencoding = null;
    }

    function afterTransform(stream, er, data) {
      var ts = stream._transformState;
      ts.transforming = false;

      var cb = ts.writecb;

      if (!cb) return stream.emit('error', new Error('no writecb in Transform class'));

      ts.writechunk = null;
      ts.writecb = null;

      if (data !== null && data !== undefined) stream.push(data);

      cb(er);

      var rs = stream._readableState;
      rs.reading = false;
      if (rs.needReadable || rs.length < rs.highWaterMark) {
        stream._read(rs.highWaterMark);
      }
    }
    function Transform(options) {
      if (!(this instanceof Transform)) return new Transform(options);

      Duplex.call(this, options);

      this._transformState = new TransformState(this);

      // when the writable side finishes, then flush out anything remaining.
      var stream = this;

      // start out asking for a readable event once data is transformed.
      this._readableState.needReadable = true;

      // we have implemented the _read method, and done the other things
      // that Readable wants before the first _read call, so unset the
      // sync guard flag.
      this._readableState.sync = false;

      if (options) {
        if (typeof options.transform === 'function') this._transform = options.transform;

        if (typeof options.flush === 'function') this._flush = options.flush;
      }

      this.once('prefinish', function () {
        if (typeof this._flush === 'function') this._flush(function (er) {
          done(stream, er);
        });else done(stream);
      });
    }

    Transform.prototype.push = function (chunk, encoding) {
      this._transformState.needTransform = false;
      return Duplex.prototype.push.call(this, chunk, encoding);
    };

    // This is the part where you do stuff!
    // override this function in implementation classes.
    // 'chunk' is an input chunk.
    //
    // Call `push(newChunk)` to pass along transformed output
    // to the readable side.  You may call 'push' zero or more times.
    //
    // Call `cb(err)` when you are done with this chunk.  If you pass
    // an error, then that'll put the hurt on the whole operation.  If you
    // never call cb(), then you'll never get another chunk.
    Transform.prototype._transform = function (chunk, encoding, cb) {
      throw new Error('Not implemented');
    };

    Transform.prototype._write = function (chunk, encoding, cb) {
      var ts = this._transformState;
      ts.writecb = cb;
      ts.writechunk = chunk;
      ts.writeencoding = encoding;
      if (!ts.transforming) {
        var rs = this._readableState;
        if (ts.needTransform || rs.needReadable || rs.length < rs.highWaterMark) this._read(rs.highWaterMark);
      }
    };

    // Doesn't matter what the args are here.
    // _transform does all the work.
    // That we got here means that the readable side wants more data.
    Transform.prototype._read = function (n) {
      var ts = this._transformState;

      if (ts.writechunk !== null && ts.writecb && !ts.transforming) {
        ts.transforming = true;
        this._transform(ts.writechunk, ts.writeencoding, ts.afterTransform);
      } else {
        // mark that we need a transform, so that any data that comes in
        // will get processed, now that we've asked for it.
        ts.needTransform = true;
      }
    };

    function done(stream, er) {
      if (er) return stream.emit('error', er);

      // if there's nothing in the write buffer, then that means
      // that nothing more will ever be provided
      var ws = stream._writableState;
      var ts = stream._transformState;

      if (ws.length) throw new Error('Calling transform done when ws.length != 0');

      if (ts.transforming) throw new Error('Calling transform done when still transforming');

      return stream.push(null);
    }

    inherits$1(PassThrough, Transform);
    function PassThrough(options) {
      if (!(this instanceof PassThrough)) return new PassThrough(options);

      Transform.call(this, options);
    }

    PassThrough.prototype._transform = function (chunk, encoding, cb) {
      cb(null, chunk);
    };

    inherits$1(Stream, EventEmitter);
    Stream.Readable = Readable;
    Stream.Writable = Writable;
    Stream.Duplex = Duplex;
    Stream.Transform = Transform;
    Stream.PassThrough = PassThrough;

    // Backwards-compat with node 0.4.x
    Stream.Stream = Stream;

    // old-style streams.  Note that the pipe method (the only relevant
    // part of this class) is overridden in the Readable class.

    function Stream() {
      EventEmitter.call(this);
    }

    Stream.prototype.pipe = function(dest, options) {
      var source = this;

      function ondata(chunk) {
        if (dest.writable) {
          if (false === dest.write(chunk) && source.pause) {
            source.pause();
          }
        }
      }

      source.on('data', ondata);

      function ondrain() {
        if (source.readable && source.resume) {
          source.resume();
        }
      }

      dest.on('drain', ondrain);

      // If the 'end' option is not supplied, dest.end() will be called when
      // source gets the 'end' or 'close' events.  Only dest.end() once.
      if (!dest._isStdio && (!options || options.end !== false)) {
        source.on('end', onend);
        source.on('close', onclose);
      }

      var didOnEnd = false;
      function onend() {
        if (didOnEnd) return;
        didOnEnd = true;

        dest.end();
      }


      function onclose() {
        if (didOnEnd) return;
        didOnEnd = true;

        if (typeof dest.destroy === 'function') dest.destroy();
      }

      // don't leave dangling pipes when there are errors.
      function onerror(er) {
        cleanup();
        if (EventEmitter.listenerCount(this, 'error') === 0) {
          throw er; // Unhandled stream error in pipe.
        }
      }

      source.on('error', onerror);
      dest.on('error', onerror);

      // remove all the event listeners that were added.
      function cleanup() {
        source.removeListener('data', ondata);
        dest.removeListener('drain', ondrain);

        source.removeListener('end', onend);
        source.removeListener('close', onclose);

        source.removeListener('error', onerror);
        dest.removeListener('error', onerror);

        source.removeListener('end', cleanup);
        source.removeListener('close', cleanup);

        dest.removeListener('close', cleanup);
      }

      source.on('end', cleanup);
      source.on('close', cleanup);

      dest.on('close', cleanup);

      dest.emit('pipe', source);

      // Allow for unix-like usage: A.pipe(B).pipe(C)
      return dest;
    };

    var stream = /*#__PURE__*/Object.freeze({
        __proto__: null,
        'default': Stream,
        Readable: Readable,
        Writable: Writable,
        Duplex: Duplex,
        Transform: Transform,
        PassThrough: PassThrough,
        Stream: Stream
    });

    var require$$0$2 = /*@__PURE__*/getAugmentedNamespace(stream);

    var hasFetch = isFunction(global$1.fetch) && isFunction(global$1.ReadableStream);

    var _blobConstructor;
    function blobConstructor() {
      if (typeof _blobConstructor !== 'undefined') {
        return _blobConstructor;
      }
      try {
        new global$1.Blob([new ArrayBuffer(1)]);
        _blobConstructor = true;
      } catch (e) {
        _blobConstructor = false;
      }
      return _blobConstructor
    }
    var xhr;

    function checkTypeSupport(type) {
      if (!xhr) {
        xhr = new global$1.XMLHttpRequest();
        // If location.host is empty, e.g. if this page/worker was loaded
        // from a Blob, then use example.com to avoid an error
        xhr.open('GET', global$1.location.host ? '/' : 'https://example.com');
      }
      try {
        xhr.responseType = type;
        return xhr.responseType === type
      } catch (e) {
        return false
      }

    }

    // For some strange reason, Safari 7.0 reports typeof global.ArrayBuffer === 'object'.
    // Safari 7.1 appears to have fixed this bug.
    var haveArrayBuffer = typeof global$1.ArrayBuffer !== 'undefined';
    var haveSlice = haveArrayBuffer && isFunction(global$1.ArrayBuffer.prototype.slice);

    var arraybuffer = haveArrayBuffer && checkTypeSupport('arraybuffer');
      // These next two tests unavoidably show warnings in Chrome. Since fetch will always
      // be used if it's available, just return false for these to avoid the warnings.
    var msstream = !hasFetch && haveSlice && checkTypeSupport('ms-stream');
    var mozchunkedarraybuffer = !hasFetch && haveArrayBuffer &&
      checkTypeSupport('moz-chunked-arraybuffer');
    var overrideMimeType = isFunction(xhr.overrideMimeType);
    var vbArray = isFunction(global$1.VBArray);

    function isFunction(value) {
      return typeof value === 'function'
    }

    xhr = null; // Help gc

    var rStates = {
      UNSENT: 0,
      OPENED: 1,
      HEADERS_RECEIVED: 2,
      LOADING: 3,
      DONE: 4
    };
    function IncomingMessage(xhr, response, mode) {
      var self = this;
      Readable.call(self);

      self._mode = mode;
      self.headers = {};
      self.rawHeaders = [];
      self.trailers = {};
      self.rawTrailers = [];

      // Fake the 'close' event, but only once 'end' fires
      self.on('end', function() {
        // The nextTick is necessary to prevent the 'request' module from causing an infinite loop
        browser$1$1.nextTick(function() {
          self.emit('close');
        });
      });
      var read;
      if (mode === 'fetch') {
        self._fetchResponse = response;

        self.url = response.url;
        self.statusCode = response.status;
        self.statusMessage = response.statusText;
          // backwards compatible version of for (<item> of <iterable>):
          // for (var <item>,_i,_it = <iterable>[Symbol.iterator](); <item> = (_i = _it.next()).value,!_i.done;)
        for (var header, _i, _it = response.headers[Symbol.iterator](); header = (_i = _it.next()).value, !_i.done;) {
          self.headers[header[0].toLowerCase()] = header[1];
          self.rawHeaders.push(header[0], header[1]);
        }

        // TODO: this doesn't respect backpressure. Once WritableStream is available, this can be fixed
        var reader = response.body.getReader();

        read = function () {
          reader.read().then(function(result) {
            if (self._destroyed)
              return
            if (result.done) {
              self.push(null);
              return
            }
            self.push(new Buffer$3(result.value));
            read();
          });
        };
        read();

      } else {
        self._xhr = xhr;
        self._pos = 0;

        self.url = xhr.responseURL;
        self.statusCode = xhr.status;
        self.statusMessage = xhr.statusText;
        var headers = xhr.getAllResponseHeaders().split(/\r?\n/);
        headers.forEach(function(header) {
          var matches = header.match(/^([^:]+):\s*(.*)/);
          if (matches) {
            var key = matches[1].toLowerCase();
            if (key === 'set-cookie') {
              if (self.headers[key] === undefined) {
                self.headers[key] = [];
              }
              self.headers[key].push(matches[2]);
            } else if (self.headers[key] !== undefined) {
              self.headers[key] += ', ' + matches[2];
            } else {
              self.headers[key] = matches[2];
            }
            self.rawHeaders.push(matches[1], matches[2]);
          }
        });

        self._charset = 'x-user-defined';
        if (!overrideMimeType) {
          var mimeType = self.rawHeaders['mime-type'];
          if (mimeType) {
            var charsetMatch = mimeType.match(/;\s*charset=([^;])(;|$)/);
            if (charsetMatch) {
              self._charset = charsetMatch[1].toLowerCase();
            }
          }
          if (!self._charset)
            self._charset = 'utf-8'; // best guess
        }
      }
    }

    inherits$1(IncomingMessage, Readable);

    IncomingMessage.prototype._read = function() {};

    IncomingMessage.prototype._onXHRProgress = function() {
      var self = this;

      var xhr = self._xhr;

      var response = null;
      switch (self._mode) {
      case 'text:vbarray': // For IE9
        if (xhr.readyState !== rStates.DONE)
          break
        try {
          // This fails in IE8
          response = new global$1.VBArray(xhr.responseBody).toArray();
        } catch (e) {
          // pass
        }
        if (response !== null) {
          self.push(new Buffer$3(response));
          break
        }
        // Falls through in IE8
      case 'text':
        try { // This will fail when readyState = 3 in IE9. Switch mode and wait for readyState = 4
          response = xhr.responseText;
        } catch (e) {
          self._mode = 'text:vbarray';
          break
        }
        if (response.length > self._pos) {
          var newData = response.substr(self._pos);
          if (self._charset === 'x-user-defined') {
            var buffer = new Buffer$3(newData.length);
            for (var i = 0; i < newData.length; i++)
              buffer[i] = newData.charCodeAt(i) & 0xff;

            self.push(buffer);
          } else {
            self.push(newData, self._charset);
          }
          self._pos = response.length;
        }
        break
      case 'arraybuffer':
        if (xhr.readyState !== rStates.DONE || !xhr.response)
          break
        response = xhr.response;
        self.push(new Buffer$3(new Uint8Array(response)));
        break
      case 'moz-chunked-arraybuffer': // take whole
        response = xhr.response;
        if (xhr.readyState !== rStates.LOADING || !response)
          break
        self.push(new Buffer$3(new Uint8Array(response)));
        break
      case 'ms-stream':
        response = xhr.response;
        if (xhr.readyState !== rStates.LOADING)
          break
        var reader = new global$1.MSStreamReader();
        reader.onprogress = function() {
          if (reader.result.byteLength > self._pos) {
            self.push(new Buffer$3(new Uint8Array(reader.result.slice(self._pos))));
            self._pos = reader.result.byteLength;
          }
        };
        reader.onload = function() {
          self.push(null);
        };
          // reader.onerror = ??? // TODO: this
        reader.readAsArrayBuffer(response);
        break
      }

      // The ms-stream case handles end separately in reader.onload()
      if (self._xhr.readyState === rStates.DONE && self._mode !== 'ms-stream') {
        self.push(null);
      }
    };

    // from https://github.com/jhiesey/to-arraybuffer/blob/6502d9850e70ba7935a7df4ad86b358fc216f9f0/index.js
    function toArrayBuffer (buf) {
      // If the buffer is backed by a Uint8Array, a faster version will work
      if (buf instanceof Uint8Array) {
        // If the buffer isn't a subarray, return the underlying ArrayBuffer
        if (buf.byteOffset === 0 && buf.byteLength === buf.buffer.byteLength) {
          return buf.buffer
        } else if (typeof buf.buffer.slice === 'function') {
          // Otherwise we need to get a proper copy
          return buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength)
        }
      }

      if (isBuffer(buf)) {
        // This is the slow version that will work with any Buffer
        // implementation (even in old browsers)
        var arrayCopy = new Uint8Array(buf.length);
        var len = buf.length;
        for (var i = 0; i < len; i++) {
          arrayCopy[i] = buf[i];
        }
        return arrayCopy.buffer
      } else {
        throw new Error('Argument must be a Buffer')
      }
    }

    function decideMode(preferBinary, useFetch) {
      if (hasFetch && useFetch) {
        return 'fetch'
      } else if (mozchunkedarraybuffer) {
        return 'moz-chunked-arraybuffer'
      } else if (msstream) {
        return 'ms-stream'
      } else if (arraybuffer && preferBinary) {
        return 'arraybuffer'
      } else if (vbArray && preferBinary) {
        return 'text:vbarray'
      } else {
        return 'text'
      }
    }

    function ClientRequest(opts) {
      var self = this;
      Writable.call(self);

      self._opts = opts;
      self._body = [];
      self._headers = {};
      if (opts.auth)
        self.setHeader('Authorization', 'Basic ' + new Buffer$3(opts.auth).toString('base64'));
      Object.keys(opts.headers).forEach(function(name) {
        self.setHeader(name, opts.headers[name]);
      });

      var preferBinary;
      var useFetch = true;
      if (opts.mode === 'disable-fetch') {
        // If the use of XHR should be preferred and includes preserving the 'content-type' header
        useFetch = false;
        preferBinary = true;
      } else if (opts.mode === 'prefer-streaming') {
        // If streaming is a high priority but binary compatibility and
        // the accuracy of the 'content-type' header aren't
        preferBinary = false;
      } else if (opts.mode === 'allow-wrong-content-type') {
        // If streaming is more important than preserving the 'content-type' header
        preferBinary = !overrideMimeType;
      } else if (!opts.mode || opts.mode === 'default' || opts.mode === 'prefer-fast') {
        // Use binary if text streaming may corrupt data or the content-type header, or for speed
        preferBinary = true;
      } else {
        throw new Error('Invalid value for opts.mode')
      }
      self._mode = decideMode(preferBinary, useFetch);

      self.on('finish', function() {
        self._onFinish();
      });
    }

    inherits$1(ClientRequest, Writable);
    // Taken from http://www.w3.org/TR/XMLHttpRequest/#the-setrequestheader%28%29-method
    var unsafeHeaders = [
      'accept-charset',
      'accept-encoding',
      'access-control-request-headers',
      'access-control-request-method',
      'connection',
      'content-length',
      'cookie',
      'cookie2',
      'date',
      'dnt',
      'expect',
      'host',
      'keep-alive',
      'origin',
      'referer',
      'te',
      'trailer',
      'transfer-encoding',
      'upgrade',
      'user-agent',
      'via'
    ];
    ClientRequest.prototype.setHeader = function(name, value) {
      var self = this;
      var lowerName = name.toLowerCase();
        // This check is not necessary, but it prevents warnings from browsers about setting unsafe
        // headers. To be honest I'm not entirely sure hiding these warnings is a good thing, but
        // http-browserify did it, so I will too.
      if (unsafeHeaders.indexOf(lowerName) !== -1)
        return

      self._headers[lowerName] = {
        name: name,
        value: value
      };
    };

    ClientRequest.prototype.getHeader = function(name) {
      var self = this;
      return self._headers[name.toLowerCase()].value
    };

    ClientRequest.prototype.removeHeader = function(name) {
      var self = this;
      delete self._headers[name.toLowerCase()];
    };

    ClientRequest.prototype._onFinish = function() {
      var self = this;

      if (self._destroyed)
        return
      var opts = self._opts;

      var headersObj = self._headers;
      var body;
      if (opts.method === 'POST' || opts.method === 'PUT' || opts.method === 'PATCH') {
        if (blobConstructor()) {
          body = new global$1.Blob(self._body.map(function(buffer) {
            return toArrayBuffer(buffer)
          }), {
            type: (headersObj['content-type'] || {}).value || ''
          });
        } else {
          // get utf8 string
          body = Buffer$3.concat(self._body).toString();
        }
      }

      if (self._mode === 'fetch') {
        var headers = Object.keys(headersObj).map(function(name) {
          return [headersObj[name].name, headersObj[name].value]
        });

        global$1.fetch(self._opts.url, {
          method: self._opts.method,
          headers: headers,
          body: body,
          mode: 'cors',
          credentials: opts.withCredentials ? 'include' : 'same-origin'
        }).then(function(response) {
          self._fetchResponse = response;
          self._connect();
        }, function(reason) {
          self.emit('error', reason);
        });
      } else {
        var xhr = self._xhr = new global$1.XMLHttpRequest();
        try {
          xhr.open(self._opts.method, self._opts.url, true);
        } catch (err) {
          browser$1$1.nextTick(function() {
            self.emit('error', err);
          });
          return
        }

        // Can't set responseType on really old browsers
        if ('responseType' in xhr)
          xhr.responseType = self._mode.split(':')[0];

        if ('withCredentials' in xhr)
          xhr.withCredentials = !!opts.withCredentials;

        if (self._mode === 'text' && 'overrideMimeType' in xhr)
          xhr.overrideMimeType('text/plain; charset=x-user-defined');

        Object.keys(headersObj).forEach(function(name) {
          xhr.setRequestHeader(headersObj[name].name, headersObj[name].value);
        });

        self._response = null;
        xhr.onreadystatechange = function() {
          switch (xhr.readyState) {
          case rStates.LOADING:
          case rStates.DONE:
            self._onXHRProgress();
            break
          }
        };
          // Necessary for streaming in Firefox, since xhr.response is ONLY defined
          // in onprogress, not in onreadystatechange with xhr.readyState = 3
        if (self._mode === 'moz-chunked-arraybuffer') {
          xhr.onprogress = function() {
            self._onXHRProgress();
          };
        }

        xhr.onerror = function() {
          if (self._destroyed)
            return
          self.emit('error', new Error('XHR error'));
        };

        try {
          xhr.send(body);
        } catch (err) {
          browser$1$1.nextTick(function() {
            self.emit('error', err);
          });
          return
        }
      }
    };

    /**
     * Checks if xhr.status is readable and non-zero, indicating no error.
     * Even though the spec says it should be available in readyState 3,
     * accessing it throws an exception in IE8
     */
    function statusValid(xhr) {
      try {
        var status = xhr.status;
        return (status !== null && status !== 0)
      } catch (e) {
        return false
      }
    }

    ClientRequest.prototype._onXHRProgress = function() {
      var self = this;

      if (!statusValid(self._xhr) || self._destroyed)
        return

      if (!self._response)
        self._connect();

      self._response._onXHRProgress();
    };

    ClientRequest.prototype._connect = function() {
      var self = this;

      if (self._destroyed)
        return

      self._response = new IncomingMessage(self._xhr, self._fetchResponse, self._mode);
      self.emit('response', self._response);
    };

    ClientRequest.prototype._write = function(chunk, encoding, cb) {
      var self = this;

      self._body.push(chunk);
      cb();
    };

    ClientRequest.prototype.abort = ClientRequest.prototype.destroy = function() {
      var self = this;
      self._destroyed = true;
      if (self._response)
        self._response._destroyed = true;
      if (self._xhr)
        self._xhr.abort();
        // Currently, there isn't a way to truly abort a fetch.
        // If you like bikeshedding, see https://github.com/whatwg/fetch/issues/27
    };

    ClientRequest.prototype.end = function(data, encoding, cb) {
      var self = this;
      if (typeof data === 'function') {
        cb = data;
        data = undefined;
      }

      Writable.prototype.end.call(self, data, encoding, cb);
    };

    ClientRequest.prototype.flushHeaders = function() {};
    ClientRequest.prototype.setTimeout = function() {};
    ClientRequest.prototype.setNoDelay = function() {};
    ClientRequest.prototype.setSocketKeepAlive = function() {};

    /*! https://mths.be/punycode v1.4.1 by @mathias */


    /** Highest positive signed 32-bit float value */
    var maxInt = 2147483647; // aka. 0x7FFFFFFF or 2^31-1

    /** Bootstring parameters */
    var base = 36;
    var tMin = 1;
    var tMax = 26;
    var skew = 38;
    var damp = 700;
    var initialBias = 72;
    var initialN = 128; // 0x80
    var delimiter = '-'; // '\x2D'

    /** Regular expressions */
    var regexPunycode = /^xn--/;
    var regexNonASCII = /[^\x20-\x7E]/; // unprintable ASCII chars + non-ASCII chars
    var regexSeparators = /[\x2E\u3002\uFF0E\uFF61]/g; // RFC 3490 separators

    /** Error messages */
    var errors = {
      'overflow': 'Overflow: input needs wider integers to process',
      'not-basic': 'Illegal input >= 0x80 (not a basic code point)',
      'invalid-input': 'Invalid input'
    };

    /** Convenience shortcuts */
    var baseMinusTMin = base - tMin;
    var floor = Math.floor;
    var stringFromCharCode = String.fromCharCode;

    /*--------------------------------------------------------------------------*/

    /**
     * A generic error utility function.
     * @private
     * @param {String} type The error type.
     * @returns {Error} Throws a `RangeError` with the applicable error message.
     */
    function error(type) {
      throw new RangeError(errors[type]);
    }

    /**
     * A generic `Array#map` utility function.
     * @private
     * @param {Array} array The array to iterate over.
     * @param {Function} callback The function that gets called for every array
     * item.
     * @returns {Array} A new array of values returned by the callback function.
     */
    function map$1(array, fn) {
      var length = array.length;
      var result = [];
      while (length--) {
        result[length] = fn(array[length]);
      }
      return result;
    }

    /**
     * A simple `Array#map`-like wrapper to work with domain name strings or email
     * addresses.
     * @private
     * @param {String} domain The domain name or email address.
     * @param {Function} callback The function that gets called for every
     * character.
     * @returns {Array} A new string of characters returned by the callback
     * function.
     */
    function mapDomain(string, fn) {
      var parts = string.split('@');
      var result = '';
      if (parts.length > 1) {
        // In email addresses, only the domain name should be punycoded. Leave
        // the local part (i.e. everything up to `@`) intact.
        result = parts[0] + '@';
        string = parts[1];
      }
      // Avoid `split(regex)` for IE8 compatibility. See #17.
      string = string.replace(regexSeparators, '\x2E');
      var labels = string.split('.');
      var encoded = map$1(labels, fn).join('.');
      return result + encoded;
    }

    /**
     * Creates an array containing the numeric code points of each Unicode
     * character in the string. While JavaScript uses UCS-2 internally,
     * this function will convert a pair of surrogate halves (each of which
     * UCS-2 exposes as separate characters) into a single code point,
     * matching UTF-16.
     * @see `punycode.ucs2.encode`
     * @see <https://mathiasbynens.be/notes/javascript-encoding>
     * @memberOf punycode.ucs2
     * @name decode
     * @param {String} string The Unicode input string (UCS-2).
     * @returns {Array} The new array of code points.
     */
    function ucs2decode(string) {
      var output = [],
        counter = 0,
        length = string.length,
        value,
        extra;
      while (counter < length) {
        value = string.charCodeAt(counter++);
        if (value >= 0xD800 && value <= 0xDBFF && counter < length) {
          // high surrogate, and there is a next character
          extra = string.charCodeAt(counter++);
          if ((extra & 0xFC00) == 0xDC00) { // low surrogate
            output.push(((value & 0x3FF) << 10) + (extra & 0x3FF) + 0x10000);
          } else {
            // unmatched surrogate; only append this code unit, in case the next
            // code unit is the high surrogate of a surrogate pair
            output.push(value);
            counter--;
          }
        } else {
          output.push(value);
        }
      }
      return output;
    }

    /**
     * Creates a string based on an array of numeric code points.
     * @see `punycode.ucs2.decode`
     * @memberOf punycode.ucs2
     * @name encode
     * @param {Array} codePoints The array of numeric code points.
     * @returns {String} The new Unicode string (UCS-2).
     */
    function ucs2encode(array) {
      return map$1(array, function(value) {
        var output = '';
        if (value > 0xFFFF) {
          value -= 0x10000;
          output += stringFromCharCode(value >>> 10 & 0x3FF | 0xD800);
          value = 0xDC00 | value & 0x3FF;
        }
        output += stringFromCharCode(value);
        return output;
      }).join('');
    }

    /**
     * Converts a basic code point into a digit/integer.
     * @see `digitToBasic()`
     * @private
     * @param {Number} codePoint The basic numeric code point value.
     * @returns {Number} The numeric value of a basic code point (for use in
     * representing integers) in the range `0` to `base - 1`, or `base` if
     * the code point does not represent a value.
     */
    function basicToDigit(codePoint) {
      if (codePoint - 48 < 10) {
        return codePoint - 22;
      }
      if (codePoint - 65 < 26) {
        return codePoint - 65;
      }
      if (codePoint - 97 < 26) {
        return codePoint - 97;
      }
      return base;
    }

    /**
     * Converts a digit/integer into a basic code point.
     * @see `basicToDigit()`
     * @private
     * @param {Number} digit The numeric value of a basic code point.
     * @returns {Number} The basic code point whose value (when used for
     * representing integers) is `digit`, which needs to be in the range
     * `0` to `base - 1`. If `flag` is non-zero, the uppercase form is
     * used; else, the lowercase form is used. The behavior is undefined
     * if `flag` is non-zero and `digit` has no uppercase form.
     */
    function digitToBasic(digit, flag) {
      //  0..25 map to ASCII a..z or A..Z
      // 26..35 map to ASCII 0..9
      return digit + 22 + 75 * (digit < 26) - ((flag != 0) << 5);
    }

    /**
     * Bias adaptation function as per section 3.4 of RFC 3492.
     * https://tools.ietf.org/html/rfc3492#section-3.4
     * @private
     */
    function adapt(delta, numPoints, firstTime) {
      var k = 0;
      delta = firstTime ? floor(delta / damp) : delta >> 1;
      delta += floor(delta / numPoints);
      for ( /* no initialization */ ; delta > baseMinusTMin * tMax >> 1; k += base) {
        delta = floor(delta / baseMinusTMin);
      }
      return floor(k + (baseMinusTMin + 1) * delta / (delta + skew));
    }

    /**
     * Converts a Punycode string of ASCII-only symbols to a string of Unicode
     * symbols.
     * @memberOf punycode
     * @param {String} input The Punycode string of ASCII-only symbols.
     * @returns {String} The resulting string of Unicode symbols.
     */
    function decode(input) {
      // Don't use UCS-2
      var output = [],
        inputLength = input.length,
        out,
        i = 0,
        n = initialN,
        bias = initialBias,
        basic,
        j,
        index,
        oldi,
        w,
        k,
        digit,
        t,
        /** Cached calculation results */
        baseMinusT;

      // Handle the basic code points: let `basic` be the number of input code
      // points before the last delimiter, or `0` if there is none, then copy
      // the first basic code points to the output.

      basic = input.lastIndexOf(delimiter);
      if (basic < 0) {
        basic = 0;
      }

      for (j = 0; j < basic; ++j) {
        // if it's not a basic code point
        if (input.charCodeAt(j) >= 0x80) {
          error('not-basic');
        }
        output.push(input.charCodeAt(j));
      }

      // Main decoding loop: start just after the last delimiter if any basic code
      // points were copied; start at the beginning otherwise.

      for (index = basic > 0 ? basic + 1 : 0; index < inputLength; /* no final expression */ ) {

        // `index` is the index of the next character to be consumed.
        // Decode a generalized variable-length integer into `delta`,
        // which gets added to `i`. The overflow checking is easier
        // if we increase `i` as we go, then subtract off its starting
        // value at the end to obtain `delta`.
        for (oldi = i, w = 1, k = base; /* no condition */ ; k += base) {

          if (index >= inputLength) {
            error('invalid-input');
          }

          digit = basicToDigit(input.charCodeAt(index++));

          if (digit >= base || digit > floor((maxInt - i) / w)) {
            error('overflow');
          }

          i += digit * w;
          t = k <= bias ? tMin : (k >= bias + tMax ? tMax : k - bias);

          if (digit < t) {
            break;
          }

          baseMinusT = base - t;
          if (w > floor(maxInt / baseMinusT)) {
            error('overflow');
          }

          w *= baseMinusT;

        }

        out = output.length + 1;
        bias = adapt(i - oldi, out, oldi == 0);

        // `i` was supposed to wrap around from `out` to `0`,
        // incrementing `n` each time, so we'll fix that now:
        if (floor(i / out) > maxInt - n) {
          error('overflow');
        }

        n += floor(i / out);
        i %= out;

        // Insert `n` at position `i` of the output
        output.splice(i++, 0, n);

      }

      return ucs2encode(output);
    }

    /**
     * Converts a string of Unicode symbols (e.g. a domain name label) to a
     * Punycode string of ASCII-only symbols.
     * @memberOf punycode
     * @param {String} input The string of Unicode symbols.
     * @returns {String} The resulting Punycode string of ASCII-only symbols.
     */
    function encode(input) {
      var n,
        delta,
        handledCPCount,
        basicLength,
        bias,
        j,
        m,
        q,
        k,
        t,
        currentValue,
        output = [],
        /** `inputLength` will hold the number of code points in `input`. */
        inputLength,
        /** Cached calculation results */
        handledCPCountPlusOne,
        baseMinusT,
        qMinusT;

      // Convert the input in UCS-2 to Unicode
      input = ucs2decode(input);

      // Cache the length
      inputLength = input.length;

      // Initialize the state
      n = initialN;
      delta = 0;
      bias = initialBias;

      // Handle the basic code points
      for (j = 0; j < inputLength; ++j) {
        currentValue = input[j];
        if (currentValue < 0x80) {
          output.push(stringFromCharCode(currentValue));
        }
      }

      handledCPCount = basicLength = output.length;

      // `handledCPCount` is the number of code points that have been handled;
      // `basicLength` is the number of basic code points.

      // Finish the basic string - if it is not empty - with a delimiter
      if (basicLength) {
        output.push(delimiter);
      }

      // Main encoding loop:
      while (handledCPCount < inputLength) {

        // All non-basic code points < n have been handled already. Find the next
        // larger one:
        for (m = maxInt, j = 0; j < inputLength; ++j) {
          currentValue = input[j];
          if (currentValue >= n && currentValue < m) {
            m = currentValue;
          }
        }

        // Increase `delta` enough to advance the decoder's <n,i> state to <m,0>,
        // but guard against overflow
        handledCPCountPlusOne = handledCPCount + 1;
        if (m - n > floor((maxInt - delta) / handledCPCountPlusOne)) {
          error('overflow');
        }

        delta += (m - n) * handledCPCountPlusOne;
        n = m;

        for (j = 0; j < inputLength; ++j) {
          currentValue = input[j];

          if (currentValue < n && ++delta > maxInt) {
            error('overflow');
          }

          if (currentValue == n) {
            // Represent delta as a generalized variable-length integer
            for (q = delta, k = base; /* no condition */ ; k += base) {
              t = k <= bias ? tMin : (k >= bias + tMax ? tMax : k - bias);
              if (q < t) {
                break;
              }
              qMinusT = q - t;
              baseMinusT = base - t;
              output.push(
                stringFromCharCode(digitToBasic(t + qMinusT % baseMinusT, 0))
              );
              q = floor(qMinusT / baseMinusT);
            }

            output.push(stringFromCharCode(digitToBasic(q, 0)));
            bias = adapt(delta, handledCPCountPlusOne, handledCPCount == basicLength);
            delta = 0;
            ++handledCPCount;
          }
        }

        ++delta;
        ++n;

      }
      return output.join('');
    }

    /**
     * Converts a Punycode string representing a domain name or an email address
     * to Unicode. Only the Punycoded parts of the input will be converted, i.e.
     * it doesn't matter if you call it on a string that has already been
     * converted to Unicode.
     * @memberOf punycode
     * @param {String} input The Punycoded domain name or email address to
     * convert to Unicode.
     * @returns {String} The Unicode representation of the given Punycode
     * string.
     */
    function toUnicode(input) {
      return mapDomain(input, function(string) {
        return regexPunycode.test(string) ?
          decode(string.slice(4).toLowerCase()) :
          string;
      });
    }

    /**
     * Converts a Unicode string representing a domain name or an email address to
     * Punycode. Only the non-ASCII parts of the domain name will be converted,
     * i.e. it doesn't matter if you call it with a domain that's already in
     * ASCII.
     * @memberOf punycode
     * @param {String} input The domain name or email address to convert, as a
     * Unicode string.
     * @returns {String} The Punycode representation of the given domain name or
     * email address.
     */
    function toASCII(input) {
      return mapDomain(input, function(string) {
        return regexNonASCII.test(string) ?
          'xn--' + encode(string) :
          string;
      });
    }
    var version = '1.4.1';
    /**
     * An object of methods to convert from JavaScript's internal character
     * representation (UCS-2) to Unicode code points, and back.
     * @see <https://mathiasbynens.be/notes/javascript-encoding>
     * @memberOf punycode
     * @type Object
     */

    var ucs2 = {
      decode: ucs2decode,
      encode: ucs2encode
    };
    var punycode$1 = {
      version: version,
      ucs2: ucs2,
      toASCII: toASCII,
      toUnicode: toUnicode,
      encode: encode,
      decode: decode
    };

    var punycode$2 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        decode: decode,
        encode: encode,
        toUnicode: toUnicode,
        toASCII: toASCII,
        version: version,
        ucs2: ucs2,
        'default': punycode$1
    });

    // Copyright Joyent, Inc. and other Node contributors.
    //
    // Permission is hereby granted, free of charge, to any person obtaining a
    // copy of this software and associated documentation files (the
    // "Software"), to deal in the Software without restriction, including
    // without limitation the rights to use, copy, modify, merge, publish,
    // distribute, sublicense, and/or sell copies of the Software, and to permit
    // persons to whom the Software is furnished to do so, subject to the
    // following conditions:
    //
    // The above copyright notice and this permission notice shall be included
    // in all copies or substantial portions of the Software.
    //
    // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
    // OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
    // NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
    // DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
    // OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
    // USE OR OTHER DEALINGS IN THE SOFTWARE.


    // If obj.hasOwnProperty has been overridden, then calling
    // obj.hasOwnProperty(prop) will break.
    // See: https://github.com/joyent/node/issues/1707
    function hasOwnProperty(obj, prop) {
      return Object.prototype.hasOwnProperty.call(obj, prop);
    }
    var isArray = Array.isArray || function (xs) {
      return Object.prototype.toString.call(xs) === '[object Array]';
    };
    function stringifyPrimitive(v) {
      switch (typeof v) {
        case 'string':
          return v;

        case 'boolean':
          return v ? 'true' : 'false';

        case 'number':
          return isFinite(v) ? v : '';

        default:
          return '';
      }
    }

    function stringify (obj, sep, eq, name) {
      sep = sep || '&';
      eq = eq || '=';
      if (obj === null) {
        obj = undefined;
      }

      if (typeof obj === 'object') {
        return map(objectKeys(obj), function(k) {
          var ks = encodeURIComponent(stringifyPrimitive(k)) + eq;
          if (isArray(obj[k])) {
            return map(obj[k], function(v) {
              return ks + encodeURIComponent(stringifyPrimitive(v));
            }).join(sep);
          } else {
            return ks + encodeURIComponent(stringifyPrimitive(obj[k]));
          }
        }).join(sep);

      }

      if (!name) return '';
      return encodeURIComponent(stringifyPrimitive(name)) + eq +
             encodeURIComponent(stringifyPrimitive(obj));
    }
    function map (xs, f) {
      if (xs.map) return xs.map(f);
      var res = [];
      for (var i = 0; i < xs.length; i++) {
        res.push(f(xs[i], i));
      }
      return res;
    }

    var objectKeys = Object.keys || function (obj) {
      var res = [];
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) res.push(key);
      }
      return res;
    };

    function parse$1(qs, sep, eq, options) {
      sep = sep || '&';
      eq = eq || '=';
      var obj = {};

      if (typeof qs !== 'string' || qs.length === 0) {
        return obj;
      }

      var regexp = /\+/g;
      qs = qs.split(sep);

      var maxKeys = 1000;
      if (options && typeof options.maxKeys === 'number') {
        maxKeys = options.maxKeys;
      }

      var len = qs.length;
      // maxKeys <= 0 means that we should not limit keys count
      if (maxKeys > 0 && len > maxKeys) {
        len = maxKeys;
      }

      for (var i = 0; i < len; ++i) {
        var x = qs[i].replace(regexp, '%20'),
            idx = x.indexOf(eq),
            kstr, vstr, k, v;

        if (idx >= 0) {
          kstr = x.substr(0, idx);
          vstr = x.substr(idx + 1);
        } else {
          kstr = x;
          vstr = '';
        }

        k = decodeURIComponent(kstr);
        v = decodeURIComponent(vstr);

        if (!hasOwnProperty(obj, k)) {
          obj[k] = v;
        } else if (isArray(obj[k])) {
          obj[k].push(v);
        } else {
          obj[k] = [obj[k], v];
        }
      }

      return obj;
    }

    // Copyright Joyent, Inc. and other Node contributors.
    var url = {
      parse: urlParse,
      resolve: urlResolve,
      resolveObject: urlResolveObject,
      format: urlFormat,
      Url: Url
    };
    function Url() {
      this.protocol = null;
      this.slashes = null;
      this.auth = null;
      this.host = null;
      this.port = null;
      this.hostname = null;
      this.hash = null;
      this.search = null;
      this.query = null;
      this.pathname = null;
      this.path = null;
      this.href = null;
    }

    // Reference: RFC 3986, RFC 1808, RFC 2396

    // define these here so at least they only have to be
    // compiled once on the first module load.
    var protocolPattern = /^([a-z0-9.+-]+:)/i,
      portPattern = /:[0-9]*$/,

      // Special case for a simple path URL
      simplePathPattern = /^(\/\/?(?!\/)[^\?\s]*)(\?[^\s]*)?$/,

      // RFC 2396: characters reserved for delimiting URLs.
      // We actually just auto-escape these.
      delims = ['<', '>', '"', '`', ' ', '\r', '\n', '\t'],

      // RFC 2396: characters not allowed for various reasons.
      unwise = ['{', '}', '|', '\\', '^', '`'].concat(delims),

      // Allowed by RFCs, but cause of XSS attacks.  Always escape these.
      autoEscape = ['\''].concat(unwise),
      // Characters that are never ever allowed in a hostname.
      // Note that any invalid chars are also handled, but these
      // are the ones that are *expected* to be seen, so we fast-path
      // them.
      nonHostChars = ['%', '/', '?', ';', '#'].concat(autoEscape),
      hostEndingChars = ['/', '?', '#'],
      hostnameMaxLen = 255,
      hostnamePartPattern = /^[+a-z0-9A-Z_-]{0,63}$/,
      hostnamePartStart = /^([+a-z0-9A-Z_-]{0,63})(.*)$/,
      // protocols that can allow "unsafe" and "unwise" chars.
      unsafeProtocol = {
        'javascript': true,
        'javascript:': true
      },
      // protocols that never have a hostname.
      hostlessProtocol = {
        'javascript': true,
        'javascript:': true
      },
      // protocols that always contain a // bit.
      slashedProtocol = {
        'http': true,
        'https': true,
        'ftp': true,
        'gopher': true,
        'file': true,
        'http:': true,
        'https:': true,
        'ftp:': true,
        'gopher:': true,
        'file:': true
      };

    function urlParse(url, parseQueryString, slashesDenoteHost) {
      if (url && isObject(url) && url instanceof Url) return url;

      var u = new Url;
      u.parse(url, parseQueryString, slashesDenoteHost);
      return u;
    }
    Url.prototype.parse = function(url, parseQueryString, slashesDenoteHost) {
      return parse(this, url, parseQueryString, slashesDenoteHost);
    };

    function parse(self, url, parseQueryString, slashesDenoteHost) {
      if (!isString(url)) {
        throw new TypeError('Parameter \'url\' must be a string, not ' + typeof url);
      }

      // Copy chrome, IE, opera backslash-handling behavior.
      // Back slashes before the query string get converted to forward slashes
      // See: https://code.google.com/p/chromium/issues/detail?id=25916
      var queryIndex = url.indexOf('?'),
        splitter =
        (queryIndex !== -1 && queryIndex < url.indexOf('#')) ? '?' : '#',
        uSplit = url.split(splitter),
        slashRegex = /\\/g;
      uSplit[0] = uSplit[0].replace(slashRegex, '/');
      url = uSplit.join(splitter);

      var rest = url;

      // trim before proceeding.
      // This is to support parse stuff like "  http://foo.com  \n"
      rest = rest.trim();

      if (!slashesDenoteHost && url.split('#').length === 1) {
        // Try fast path regexp
        var simplePath = simplePathPattern.exec(rest);
        if (simplePath) {
          self.path = rest;
          self.href = rest;
          self.pathname = simplePath[1];
          if (simplePath[2]) {
            self.search = simplePath[2];
            if (parseQueryString) {
              self.query = parse$1(self.search.substr(1));
            } else {
              self.query = self.search.substr(1);
            }
          } else if (parseQueryString) {
            self.search = '';
            self.query = {};
          }
          return self;
        }
      }

      var proto = protocolPattern.exec(rest);
      if (proto) {
        proto = proto[0];
        var lowerProto = proto.toLowerCase();
        self.protocol = lowerProto;
        rest = rest.substr(proto.length);
      }

      // figure out if it's got a host
      // user@server is *always* interpreted as a hostname, and url
      // resolution will treat //foo/bar as host=foo,path=bar because that's
      // how the browser resolves relative URLs.
      if (slashesDenoteHost || proto || rest.match(/^\/\/[^@\/]+@[^@\/]+/)) {
        var slashes = rest.substr(0, 2) === '//';
        if (slashes && !(proto && hostlessProtocol[proto])) {
          rest = rest.substr(2);
          self.slashes = true;
        }
      }
      var i, hec, l, p;
      if (!hostlessProtocol[proto] &&
        (slashes || (proto && !slashedProtocol[proto]))) {

        // there's a hostname.
        // the first instance of /, ?, ;, or # ends the host.
        //
        // If there is an @ in the hostname, then non-host chars *are* allowed
        // to the left of the last @ sign, unless some host-ending character
        // comes *before* the @-sign.
        // URLs are obnoxious.
        //
        // ex:
        // http://a@b@c/ => user:a@b host:c
        // http://a@b?@c => user:a host:c path:/?@c

        // v0.12 TODO(isaacs): This is not quite how Chrome does things.
        // Review our test case against browsers more comprehensively.

        // find the first instance of any hostEndingChars
        var hostEnd = -1;
        for (i = 0; i < hostEndingChars.length; i++) {
          hec = rest.indexOf(hostEndingChars[i]);
          if (hec !== -1 && (hostEnd === -1 || hec < hostEnd))
            hostEnd = hec;
        }

        // at this point, either we have an explicit point where the
        // auth portion cannot go past, or the last @ char is the decider.
        var auth, atSign;
        if (hostEnd === -1) {
          // atSign can be anywhere.
          atSign = rest.lastIndexOf('@');
        } else {
          // atSign must be in auth portion.
          // http://a@b/c@d => host:b auth:a path:/c@d
          atSign = rest.lastIndexOf('@', hostEnd);
        }

        // Now we have a portion which is definitely the auth.
        // Pull that off.
        if (atSign !== -1) {
          auth = rest.slice(0, atSign);
          rest = rest.slice(atSign + 1);
          self.auth = decodeURIComponent(auth);
        }

        // the host is the remaining to the left of the first non-host char
        hostEnd = -1;
        for (i = 0; i < nonHostChars.length; i++) {
          hec = rest.indexOf(nonHostChars[i]);
          if (hec !== -1 && (hostEnd === -1 || hec < hostEnd))
            hostEnd = hec;
        }
        // if we still have not hit it, then the entire thing is a host.
        if (hostEnd === -1)
          hostEnd = rest.length;

        self.host = rest.slice(0, hostEnd);
        rest = rest.slice(hostEnd);

        // pull out port.
        parseHost(self);

        // we've indicated that there is a hostname,
        // so even if it's empty, it has to be present.
        self.hostname = self.hostname || '';

        // if hostname begins with [ and ends with ]
        // assume that it's an IPv6 address.
        var ipv6Hostname = self.hostname[0] === '[' &&
          self.hostname[self.hostname.length - 1] === ']';

        // validate a little.
        if (!ipv6Hostname) {
          var hostparts = self.hostname.split(/\./);
          for (i = 0, l = hostparts.length; i < l; i++) {
            var part = hostparts[i];
            if (!part) continue;
            if (!part.match(hostnamePartPattern)) {
              var newpart = '';
              for (var j = 0, k = part.length; j < k; j++) {
                if (part.charCodeAt(j) > 127) {
                  // we replace non-ASCII char with a temporary placeholder
                  // we need this to make sure size of hostname is not
                  // broken by replacing non-ASCII by nothing
                  newpart += 'x';
                } else {
                  newpart += part[j];
                }
              }
              // we test again with ASCII char only
              if (!newpart.match(hostnamePartPattern)) {
                var validParts = hostparts.slice(0, i);
                var notHost = hostparts.slice(i + 1);
                var bit = part.match(hostnamePartStart);
                if (bit) {
                  validParts.push(bit[1]);
                  notHost.unshift(bit[2]);
                }
                if (notHost.length) {
                  rest = '/' + notHost.join('.') + rest;
                }
                self.hostname = validParts.join('.');
                break;
              }
            }
          }
        }

        if (self.hostname.length > hostnameMaxLen) {
          self.hostname = '';
        } else {
          // hostnames are always lower case.
          self.hostname = self.hostname.toLowerCase();
        }

        if (!ipv6Hostname) {
          // IDNA Support: Returns a punycoded representation of "domain".
          // It only converts parts of the domain name that
          // have non-ASCII characters, i.e. it doesn't matter if
          // you call it with a domain that already is ASCII-only.
          self.hostname = toASCII(self.hostname);
        }

        p = self.port ? ':' + self.port : '';
        var h = self.hostname || '';
        self.host = h + p;
        self.href += self.host;

        // strip [ and ] from the hostname
        // the host field still retains them, though
        if (ipv6Hostname) {
          self.hostname = self.hostname.substr(1, self.hostname.length - 2);
          if (rest[0] !== '/') {
            rest = '/' + rest;
          }
        }
      }

      // now rest is set to the post-host stuff.
      // chop off any delim chars.
      if (!unsafeProtocol[lowerProto]) {

        // First, make 100% sure that any "autoEscape" chars get
        // escaped, even if encodeURIComponent doesn't think they
        // need to be.
        for (i = 0, l = autoEscape.length; i < l; i++) {
          var ae = autoEscape[i];
          if (rest.indexOf(ae) === -1)
            continue;
          var esc = encodeURIComponent(ae);
          if (esc === ae) {
            esc = escape(ae);
          }
          rest = rest.split(ae).join(esc);
        }
      }


      // chop off from the tail first.
      var hash = rest.indexOf('#');
      if (hash !== -1) {
        // got a fragment string.
        self.hash = rest.substr(hash);
        rest = rest.slice(0, hash);
      }
      var qm = rest.indexOf('?');
      if (qm !== -1) {
        self.search = rest.substr(qm);
        self.query = rest.substr(qm + 1);
        if (parseQueryString) {
          self.query = parse$1(self.query);
        }
        rest = rest.slice(0, qm);
      } else if (parseQueryString) {
        // no query string, but parseQueryString still requested
        self.search = '';
        self.query = {};
      }
      if (rest) self.pathname = rest;
      if (slashedProtocol[lowerProto] &&
        self.hostname && !self.pathname) {
        self.pathname = '/';
      }

      //to support http.request
      if (self.pathname || self.search) {
        p = self.pathname || '';
        var s = self.search || '';
        self.path = p + s;
      }

      // finally, reconstruct the href based on what has been validated.
      self.href = format(self);
      return self;
    }

    // format a parsed object into a url string
    function urlFormat(obj) {
      // ensure it's an object, and not a string url.
      // If it's an obj, this is a no-op.
      // this way, you can call url_format() on strings
      // to clean up potentially wonky urls.
      if (isString(obj)) obj = parse({}, obj);
      return format(obj);
    }

    function format(self) {
      var auth = self.auth || '';
      if (auth) {
        auth = encodeURIComponent(auth);
        auth = auth.replace(/%3A/i, ':');
        auth += '@';
      }

      var protocol = self.protocol || '',
        pathname = self.pathname || '',
        hash = self.hash || '',
        host = false,
        query = '';

      if (self.host) {
        host = auth + self.host;
      } else if (self.hostname) {
        host = auth + (self.hostname.indexOf(':') === -1 ?
          self.hostname :
          '[' + this.hostname + ']');
        if (self.port) {
          host += ':' + self.port;
        }
      }

      if (self.query &&
        isObject(self.query) &&
        Object.keys(self.query).length) {
        query = stringify(self.query);
      }

      var search = self.search || (query && ('?' + query)) || '';

      if (protocol && protocol.substr(-1) !== ':') protocol += ':';

      // only the slashedProtocols get the //.  Not mailto:, xmpp:, etc.
      // unless they had them to begin with.
      if (self.slashes ||
        (!protocol || slashedProtocol[protocol]) && host !== false) {
        host = '//' + (host || '');
        if (pathname && pathname.charAt(0) !== '/') pathname = '/' + pathname;
      } else if (!host) {
        host = '';
      }

      if (hash && hash.charAt(0) !== '#') hash = '#' + hash;
      if (search && search.charAt(0) !== '?') search = '?' + search;

      pathname = pathname.replace(/[?#]/g, function(match) {
        return encodeURIComponent(match);
      });
      search = search.replace('#', '%23');

      return protocol + host + pathname + search + hash;
    }

    Url.prototype.format = function() {
      return format(this);
    };

    function urlResolve(source, relative) {
      return urlParse(source, false, true).resolve(relative);
    }

    Url.prototype.resolve = function(relative) {
      return this.resolveObject(urlParse(relative, false, true)).format();
    };

    function urlResolveObject(source, relative) {
      if (!source) return relative;
      return urlParse(source, false, true).resolveObject(relative);
    }

    Url.prototype.resolveObject = function(relative) {
      if (isString(relative)) {
        var rel = new Url();
        rel.parse(relative, false, true);
        relative = rel;
      }

      var result = new Url();
      var tkeys = Object.keys(this);
      for (var tk = 0; tk < tkeys.length; tk++) {
        var tkey = tkeys[tk];
        result[tkey] = this[tkey];
      }

      // hash is always overridden, no matter what.
      // even href="" will remove it.
      result.hash = relative.hash;

      // if the relative url is empty, then there's nothing left to do here.
      if (relative.href === '') {
        result.href = result.format();
        return result;
      }

      // hrefs like //foo/bar always cut to the protocol.
      if (relative.slashes && !relative.protocol) {
        // take everything except the protocol from relative
        var rkeys = Object.keys(relative);
        for (var rk = 0; rk < rkeys.length; rk++) {
          var rkey = rkeys[rk];
          if (rkey !== 'protocol')
            result[rkey] = relative[rkey];
        }

        //urlParse appends trailing / to urls like http://www.example.com
        if (slashedProtocol[result.protocol] &&
          result.hostname && !result.pathname) {
          result.path = result.pathname = '/';
        }

        result.href = result.format();
        return result;
      }
      var relPath;
      if (relative.protocol && relative.protocol !== result.protocol) {
        // if it's a known url protocol, then changing
        // the protocol does weird things
        // first, if it's not file:, then we MUST have a host,
        // and if there was a path
        // to begin with, then we MUST have a path.
        // if it is file:, then the host is dropped,
        // because that's known to be hostless.
        // anything else is assumed to be absolute.
        if (!slashedProtocol[relative.protocol]) {
          var keys = Object.keys(relative);
          for (var v = 0; v < keys.length; v++) {
            var k = keys[v];
            result[k] = relative[k];
          }
          result.href = result.format();
          return result;
        }

        result.protocol = relative.protocol;
        if (!relative.host && !hostlessProtocol[relative.protocol]) {
          relPath = (relative.pathname || '').split('/');
          while (relPath.length && !(relative.host = relPath.shift()));
          if (!relative.host) relative.host = '';
          if (!relative.hostname) relative.hostname = '';
          if (relPath[0] !== '') relPath.unshift('');
          if (relPath.length < 2) relPath.unshift('');
          result.pathname = relPath.join('/');
        } else {
          result.pathname = relative.pathname;
        }
        result.search = relative.search;
        result.query = relative.query;
        result.host = relative.host || '';
        result.auth = relative.auth;
        result.hostname = relative.hostname || relative.host;
        result.port = relative.port;
        // to support http.request
        if (result.pathname || result.search) {
          var p = result.pathname || '';
          var s = result.search || '';
          result.path = p + s;
        }
        result.slashes = result.slashes || relative.slashes;
        result.href = result.format();
        return result;
      }

      var isSourceAbs = (result.pathname && result.pathname.charAt(0) === '/'),
        isRelAbs = (
          relative.host ||
          relative.pathname && relative.pathname.charAt(0) === '/'
        ),
        mustEndAbs = (isRelAbs || isSourceAbs ||
          (result.host && relative.pathname)),
        removeAllDots = mustEndAbs,
        srcPath = result.pathname && result.pathname.split('/') || [],
        psychotic = result.protocol && !slashedProtocol[result.protocol];
      relPath = relative.pathname && relative.pathname.split('/') || [];
      // if the url is a non-slashed url, then relative
      // links like ../.. should be able
      // to crawl up to the hostname, as well.  This is strange.
      // result.protocol has already been set by now.
      // Later on, put the first path part into the host field.
      if (psychotic) {
        result.hostname = '';
        result.port = null;
        if (result.host) {
          if (srcPath[0] === '') srcPath[0] = result.host;
          else srcPath.unshift(result.host);
        }
        result.host = '';
        if (relative.protocol) {
          relative.hostname = null;
          relative.port = null;
          if (relative.host) {
            if (relPath[0] === '') relPath[0] = relative.host;
            else relPath.unshift(relative.host);
          }
          relative.host = null;
        }
        mustEndAbs = mustEndAbs && (relPath[0] === '' || srcPath[0] === '');
      }
      var authInHost;
      if (isRelAbs) {
        // it's absolute.
        result.host = (relative.host || relative.host === '') ?
          relative.host : result.host;
        result.hostname = (relative.hostname || relative.hostname === '') ?
          relative.hostname : result.hostname;
        result.search = relative.search;
        result.query = relative.query;
        srcPath = relPath;
        // fall through to the dot-handling below.
      } else if (relPath.length) {
        // it's relative
        // throw away the existing file, and take the new path instead.
        if (!srcPath) srcPath = [];
        srcPath.pop();
        srcPath = srcPath.concat(relPath);
        result.search = relative.search;
        result.query = relative.query;
      } else if (!isNullOrUndefined(relative.search)) {
        // just pull out the search.
        // like href='?foo'.
        // Put this after the other two cases because it simplifies the booleans
        if (psychotic) {
          result.hostname = result.host = srcPath.shift();
          //occationaly the auth can get stuck only in host
          //this especially happens in cases like
          //url.resolveObject('mailto:local1@domain1', 'local2@domain2')
          authInHost = result.host && result.host.indexOf('@') > 0 ?
            result.host.split('@') : false;
          if (authInHost) {
            result.auth = authInHost.shift();
            result.host = result.hostname = authInHost.shift();
          }
        }
        result.search = relative.search;
        result.query = relative.query;
        //to support http.request
        if (!isNull(result.pathname) || !isNull(result.search)) {
          result.path = (result.pathname ? result.pathname : '') +
            (result.search ? result.search : '');
        }
        result.href = result.format();
        return result;
      }

      if (!srcPath.length) {
        // no path at all.  easy.
        // we've already handled the other stuff above.
        result.pathname = null;
        //to support http.request
        if (result.search) {
          result.path = '/' + result.search;
        } else {
          result.path = null;
        }
        result.href = result.format();
        return result;
      }

      // if a url ENDs in . or .., then it must get a trailing slash.
      // however, if it ends in anything else non-slashy,
      // then it must NOT get a trailing slash.
      var last = srcPath.slice(-1)[0];
      var hasTrailingSlash = (
        (result.host || relative.host || srcPath.length > 1) &&
        (last === '.' || last === '..') || last === '');

      // strip single dots, resolve double dots to parent dir
      // if the path tries to go above the root, `up` ends up > 0
      var up = 0;
      for (var i = srcPath.length; i >= 0; i--) {
        last = srcPath[i];
        if (last === '.') {
          srcPath.splice(i, 1);
        } else if (last === '..') {
          srcPath.splice(i, 1);
          up++;
        } else if (up) {
          srcPath.splice(i, 1);
          up--;
        }
      }

      // if the path is allowed to go above the root, restore leading ..s
      if (!mustEndAbs && !removeAllDots) {
        for (; up--; up) {
          srcPath.unshift('..');
        }
      }

      if (mustEndAbs && srcPath[0] !== '' &&
        (!srcPath[0] || srcPath[0].charAt(0) !== '/')) {
        srcPath.unshift('');
      }

      if (hasTrailingSlash && (srcPath.join('/').substr(-1) !== '/')) {
        srcPath.push('');
      }

      var isAbsolute = srcPath[0] === '' ||
        (srcPath[0] && srcPath[0].charAt(0) === '/');

      // put the host back
      if (psychotic) {
        result.hostname = result.host = isAbsolute ? '' :
          srcPath.length ? srcPath.shift() : '';
        //occationaly the auth can get stuck only in host
        //this especially happens in cases like
        //url.resolveObject('mailto:local1@domain1', 'local2@domain2')
        authInHost = result.host && result.host.indexOf('@') > 0 ?
          result.host.split('@') : false;
        if (authInHost) {
          result.auth = authInHost.shift();
          result.host = result.hostname = authInHost.shift();
        }
      }

      mustEndAbs = mustEndAbs || (result.host && srcPath.length);

      if (mustEndAbs && !isAbsolute) {
        srcPath.unshift('');
      }

      if (!srcPath.length) {
        result.pathname = null;
        result.path = null;
      } else {
        result.pathname = srcPath.join('/');
      }

      //to support request.http
      if (!isNull(result.pathname) || !isNull(result.search)) {
        result.path = (result.pathname ? result.pathname : '') +
          (result.search ? result.search : '');
      }
      result.auth = relative.auth || result.auth;
      result.slashes = result.slashes || relative.slashes;
      result.href = result.format();
      return result;
    };

    Url.prototype.parseHost = function() {
      return parseHost(this);
    };

    function parseHost(self) {
      var host = self.host;
      var port = portPattern.exec(host);
      if (port) {
        port = port[0];
        if (port !== ':') {
          self.port = port.substr(1);
        }
        host = host.substr(0, host.length - port.length);
      }
      if (host) self.hostname = host;
    }

    var url$1 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        parse: urlParse,
        resolve: urlResolve,
        resolveObject: urlResolveObject,
        format: urlFormat,
        'default': url,
        Url: Url
    });

    function request(opts, cb) {
      if (typeof opts === 'string')
        opts = urlParse(opts);


      // Normally, the page is loaded from http or https, so not specifying a protocol
      // will result in a (valid) protocol-relative url. However, this won't work if
      // the protocol is something else, like 'file:'
      var defaultProtocol = global$1.location.protocol.search(/^https?:$/) === -1 ? 'http:' : '';

      var protocol = opts.protocol || defaultProtocol;
      var host = opts.hostname || opts.host;
      var port = opts.port;
      var path = opts.path || '/';

      // Necessary for IPv6 addresses
      if (host && host.indexOf(':') !== -1)
        host = '[' + host + ']';

      // This may be a relative url. The browser should always be able to interpret it correctly.
      opts.url = (host ? (protocol + '//' + host) : '') + (port ? ':' + port : '') + path;
      opts.method = (opts.method || 'GET').toUpperCase();
      opts.headers = opts.headers || {};

      // Also valid opts.auth, opts.mode

      var req = new ClientRequest(opts);
      if (cb)
        req.on('response', cb);
      return req
    }

    function get(opts, cb) {
      var req = request(opts, cb);
      req.end();
      return req
    }

    function Agent() {}
    Agent.defaultMaxSockets = 4;

    var METHODS = [
      'CHECKOUT',
      'CONNECT',
      'COPY',
      'DELETE',
      'GET',
      'HEAD',
      'LOCK',
      'M-SEARCH',
      'MERGE',
      'MKACTIVITY',
      'MKCOL',
      'MOVE',
      'NOTIFY',
      'OPTIONS',
      'PATCH',
      'POST',
      'PROPFIND',
      'PROPPATCH',
      'PURGE',
      'PUT',
      'REPORT',
      'SEARCH',
      'SUBSCRIBE',
      'TRACE',
      'UNLOCK',
      'UNSUBSCRIBE'
    ];
    var STATUS_CODES = {
      100: 'Continue',
      101: 'Switching Protocols',
      102: 'Processing', // RFC 2518, obsoleted by RFC 4918
      200: 'OK',
      201: 'Created',
      202: 'Accepted',
      203: 'Non-Authoritative Information',
      204: 'No Content',
      205: 'Reset Content',
      206: 'Partial Content',
      207: 'Multi-Status', // RFC 4918
      300: 'Multiple Choices',
      301: 'Moved Permanently',
      302: 'Moved Temporarily',
      303: 'See Other',
      304: 'Not Modified',
      305: 'Use Proxy',
      307: 'Temporary Redirect',
      400: 'Bad Request',
      401: 'Unauthorized',
      402: 'Payment Required',
      403: 'Forbidden',
      404: 'Not Found',
      405: 'Method Not Allowed',
      406: 'Not Acceptable',
      407: 'Proxy Authentication Required',
      408: 'Request Time-out',
      409: 'Conflict',
      410: 'Gone',
      411: 'Length Required',
      412: 'Precondition Failed',
      413: 'Request Entity Too Large',
      414: 'Request-URI Too Large',
      415: 'Unsupported Media Type',
      416: 'Requested Range Not Satisfiable',
      417: 'Expectation Failed',
      418: 'I\'m a teapot', // RFC 2324
      422: 'Unprocessable Entity', // RFC 4918
      423: 'Locked', // RFC 4918
      424: 'Failed Dependency', // RFC 4918
      425: 'Unordered Collection', // RFC 4918
      426: 'Upgrade Required', // RFC 2817
      428: 'Precondition Required', // RFC 6585
      429: 'Too Many Requests', // RFC 6585
      431: 'Request Header Fields Too Large', // RFC 6585
      500: 'Internal Server Error',
      501: 'Not Implemented',
      502: 'Bad Gateway',
      503: 'Service Unavailable',
      504: 'Gateway Time-out',
      505: 'HTTP Version Not Supported',
      506: 'Variant Also Negotiates', // RFC 2295
      507: 'Insufficient Storage', // RFC 4918
      509: 'Bandwidth Limit Exceeded',
      510: 'Not Extended', // RFC 2774
      511: 'Network Authentication Required' // RFC 6585
    };

    var http = {
      request,
      get,
      Agent,
      METHODS,
      STATUS_CODES
    };

    var http$1 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        request: request,
        get: get,
        Agent: Agent,
        METHODS: METHODS,
        STATUS_CODES: STATUS_CODES,
        'default': http
    });

    var require$$4 = /*@__PURE__*/getAugmentedNamespace(http$1);

    var require$$2 = /*@__PURE__*/getAugmentedNamespace(url$1);

    var publicApi = {};

    var URL = {exports: {}};

    var conversions = {};
    var lib = conversions;

    function sign(x) {
        return x < 0 ? -1 : 1;
    }

    function evenRound(x) {
        // Round x to the nearest integer, choosing the even integer if it lies halfway between two.
        if ((x % 1) === 0.5 && (x & 1) === 0) { // [even number].5; round down (i.e. floor)
            return Math.floor(x);
        } else {
            return Math.round(x);
        }
    }

    function createNumberConversion(bitLength, typeOpts) {
        if (!typeOpts.unsigned) {
            --bitLength;
        }
        const lowerBound = typeOpts.unsigned ? 0 : -Math.pow(2, bitLength);
        const upperBound = Math.pow(2, bitLength) - 1;

        const moduloVal = typeOpts.moduloBitLength ? Math.pow(2, typeOpts.moduloBitLength) : Math.pow(2, bitLength);
        const moduloBound = typeOpts.moduloBitLength ? Math.pow(2, typeOpts.moduloBitLength - 1) : Math.pow(2, bitLength - 1);

        return function(V, opts) {
            if (!opts) opts = {};

            let x = +V;

            if (opts.enforceRange) {
                if (!Number.isFinite(x)) {
                    throw new TypeError("Argument is not a finite number");
                }

                x = sign(x) * Math.floor(Math.abs(x));
                if (x < lowerBound || x > upperBound) {
                    throw new TypeError("Argument is not in byte range");
                }

                return x;
            }

            if (!isNaN(x) && opts.clamp) {
                x = evenRound(x);

                if (x < lowerBound) x = lowerBound;
                if (x > upperBound) x = upperBound;
                return x;
            }

            if (!Number.isFinite(x) || x === 0) {
                return 0;
            }

            x = sign(x) * Math.floor(Math.abs(x));
            x = x % moduloVal;

            if (!typeOpts.unsigned && x >= moduloBound) {
                return x - moduloVal;
            } else if (typeOpts.unsigned) {
                if (x < 0) {
                  x += moduloVal;
                } else if (x === -0) { // don't return negative zero
                  return 0;
                }
            }

            return x;
        }
    }

    conversions["void"] = function () {
        return undefined;
    };

    conversions["boolean"] = function (val) {
        return !!val;
    };

    conversions["byte"] = createNumberConversion(8, { unsigned: false });
    conversions["octet"] = createNumberConversion(8, { unsigned: true });

    conversions["short"] = createNumberConversion(16, { unsigned: false });
    conversions["unsigned short"] = createNumberConversion(16, { unsigned: true });

    conversions["long"] = createNumberConversion(32, { unsigned: false });
    conversions["unsigned long"] = createNumberConversion(32, { unsigned: true });

    conversions["long long"] = createNumberConversion(32, { unsigned: false, moduloBitLength: 64 });
    conversions["unsigned long long"] = createNumberConversion(32, { unsigned: true, moduloBitLength: 64 });

    conversions["double"] = function (V) {
        const x = +V;

        if (!Number.isFinite(x)) {
            throw new TypeError("Argument is not a finite floating-point value");
        }

        return x;
    };

    conversions["unrestricted double"] = function (V) {
        const x = +V;

        if (isNaN(x)) {
            throw new TypeError("Argument is NaN");
        }

        return x;
    };

    // not quite valid, but good enough for JS
    conversions["float"] = conversions["double"];
    conversions["unrestricted float"] = conversions["unrestricted double"];

    conversions["DOMString"] = function (V, opts) {
        if (!opts) opts = {};

        if (opts.treatNullAsEmptyString && V === null) {
            return "";
        }

        return String(V);
    };

    conversions["ByteString"] = function (V, opts) {
        const x = String(V);
        let c = undefined;
        for (let i = 0; (c = x.codePointAt(i)) !== undefined; ++i) {
            if (c > 255) {
                throw new TypeError("Argument is not a valid bytestring");
            }
        }

        return x;
    };

    conversions["USVString"] = function (V) {
        const S = String(V);
        const n = S.length;
        const U = [];
        for (let i = 0; i < n; ++i) {
            const c = S.charCodeAt(i);
            if (c < 0xD800 || c > 0xDFFF) {
                U.push(String.fromCodePoint(c));
            } else if (0xDC00 <= c && c <= 0xDFFF) {
                U.push(String.fromCodePoint(0xFFFD));
            } else {
                if (i === n - 1) {
                    U.push(String.fromCodePoint(0xFFFD));
                } else {
                    const d = S.charCodeAt(i + 1);
                    if (0xDC00 <= d && d <= 0xDFFF) {
                        const a = c & 0x3FF;
                        const b = d & 0x3FF;
                        U.push(String.fromCodePoint((2 << 15) + (2 << 9) * a + b));
                        ++i;
                    } else {
                        U.push(String.fromCodePoint(0xFFFD));
                    }
                }
            }
        }

        return U.join('');
    };

    conversions["Date"] = function (V, opts) {
        if (!(V instanceof Date)) {
            throw new TypeError("Argument is not a Date object");
        }
        if (isNaN(V)) {
            return undefined;
        }

        return V;
    };

    conversions["RegExp"] = function (V, opts) {
        if (!(V instanceof RegExp)) {
            V = new RegExp(V);
        }

        return V;
    };

    var utils = {exports: {}};

    (function (module) {

    	module.exports.mixin = function mixin(target, source) {
    	  const keys = Object.getOwnPropertyNames(source);
    	  for (let i = 0; i < keys.length; ++i) {
    	    Object.defineProperty(target, keys[i], Object.getOwnPropertyDescriptor(source, keys[i]));
    	  }
    	};

    	module.exports.wrapperSymbol = Symbol("wrapper");
    	module.exports.implSymbol = Symbol("impl");

    	module.exports.wrapperForImpl = function (impl) {
    	  return impl[module.exports.wrapperSymbol];
    	};

    	module.exports.implForWrapper = function (wrapper) {
    	  return wrapper[module.exports.implSymbol];
    	};
    } (utils));

    var URLImpl = {};

    var urlStateMachine = {exports: {}};

    var require$$0$1 = /*@__PURE__*/getAugmentedNamespace(punycode$2);

    var tr46 = {};

    var require$$1 = [
    	[
    		[
    			0,
    			44
    		],
    		"disallowed_STD3_valid"
    	],
    	[
    		[
    			45,
    			46
    		],
    		"valid"
    	],
    	[
    		[
    			47,
    			47
    		],
    		"disallowed_STD3_valid"
    	],
    	[
    		[
    			48,
    			57
    		],
    		"valid"
    	],
    	[
    		[
    			58,
    			64
    		],
    		"disallowed_STD3_valid"
    	],
    	[
    		[
    			65,
    			65
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			66,
    			66
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			67,
    			67
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			68,
    			68
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			69,
    			69
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			70,
    			70
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			71,
    			71
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			72,
    			72
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			73,
    			73
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			74,
    			74
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			75,
    			75
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			76,
    			76
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			77,
    			77
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			78,
    			78
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			79,
    			79
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			80,
    			80
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			81,
    			81
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			82,
    			82
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			83,
    			83
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			84,
    			84
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			85,
    			85
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			86,
    			86
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			87,
    			87
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			88,
    			88
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			89,
    			89
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			90,
    			90
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			91,
    			96
    		],
    		"disallowed_STD3_valid"
    	],
    	[
    		[
    			97,
    			122
    		],
    		"valid"
    	],
    	[
    		[
    			123,
    			127
    		],
    		"disallowed_STD3_valid"
    	],
    	[
    		[
    			128,
    			159
    		],
    		"disallowed"
    	],
    	[
    		[
    			160,
    			160
    		],
    		"disallowed_STD3_mapped",
    		[
    			32
    		]
    	],
    	[
    		[
    			161,
    			167
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			168,
    			168
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			776
    		]
    	],
    	[
    		[
    			169,
    			169
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			170,
    			170
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			171,
    			172
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			173,
    			173
    		],
    		"ignored"
    	],
    	[
    		[
    			174,
    			174
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			175,
    			175
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			772
    		]
    	],
    	[
    		[
    			176,
    			177
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			178,
    			178
    		],
    		"mapped",
    		[
    			50
    		]
    	],
    	[
    		[
    			179,
    			179
    		],
    		"mapped",
    		[
    			51
    		]
    	],
    	[
    		[
    			180,
    			180
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			769
    		]
    	],
    	[
    		[
    			181,
    			181
    		],
    		"mapped",
    		[
    			956
    		]
    	],
    	[
    		[
    			182,
    			182
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			183,
    			183
    		],
    		"valid"
    	],
    	[
    		[
    			184,
    			184
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			807
    		]
    	],
    	[
    		[
    			185,
    			185
    		],
    		"mapped",
    		[
    			49
    		]
    	],
    	[
    		[
    			186,
    			186
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			187,
    			187
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			188,
    			188
    		],
    		"mapped",
    		[
    			49,
    			8260,
    			52
    		]
    	],
    	[
    		[
    			189,
    			189
    		],
    		"mapped",
    		[
    			49,
    			8260,
    			50
    		]
    	],
    	[
    		[
    			190,
    			190
    		],
    		"mapped",
    		[
    			51,
    			8260,
    			52
    		]
    	],
    	[
    		[
    			191,
    			191
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			192,
    			192
    		],
    		"mapped",
    		[
    			224
    		]
    	],
    	[
    		[
    			193,
    			193
    		],
    		"mapped",
    		[
    			225
    		]
    	],
    	[
    		[
    			194,
    			194
    		],
    		"mapped",
    		[
    			226
    		]
    	],
    	[
    		[
    			195,
    			195
    		],
    		"mapped",
    		[
    			227
    		]
    	],
    	[
    		[
    			196,
    			196
    		],
    		"mapped",
    		[
    			228
    		]
    	],
    	[
    		[
    			197,
    			197
    		],
    		"mapped",
    		[
    			229
    		]
    	],
    	[
    		[
    			198,
    			198
    		],
    		"mapped",
    		[
    			230
    		]
    	],
    	[
    		[
    			199,
    			199
    		],
    		"mapped",
    		[
    			231
    		]
    	],
    	[
    		[
    			200,
    			200
    		],
    		"mapped",
    		[
    			232
    		]
    	],
    	[
    		[
    			201,
    			201
    		],
    		"mapped",
    		[
    			233
    		]
    	],
    	[
    		[
    			202,
    			202
    		],
    		"mapped",
    		[
    			234
    		]
    	],
    	[
    		[
    			203,
    			203
    		],
    		"mapped",
    		[
    			235
    		]
    	],
    	[
    		[
    			204,
    			204
    		],
    		"mapped",
    		[
    			236
    		]
    	],
    	[
    		[
    			205,
    			205
    		],
    		"mapped",
    		[
    			237
    		]
    	],
    	[
    		[
    			206,
    			206
    		],
    		"mapped",
    		[
    			238
    		]
    	],
    	[
    		[
    			207,
    			207
    		],
    		"mapped",
    		[
    			239
    		]
    	],
    	[
    		[
    			208,
    			208
    		],
    		"mapped",
    		[
    			240
    		]
    	],
    	[
    		[
    			209,
    			209
    		],
    		"mapped",
    		[
    			241
    		]
    	],
    	[
    		[
    			210,
    			210
    		],
    		"mapped",
    		[
    			242
    		]
    	],
    	[
    		[
    			211,
    			211
    		],
    		"mapped",
    		[
    			243
    		]
    	],
    	[
    		[
    			212,
    			212
    		],
    		"mapped",
    		[
    			244
    		]
    	],
    	[
    		[
    			213,
    			213
    		],
    		"mapped",
    		[
    			245
    		]
    	],
    	[
    		[
    			214,
    			214
    		],
    		"mapped",
    		[
    			246
    		]
    	],
    	[
    		[
    			215,
    			215
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			216,
    			216
    		],
    		"mapped",
    		[
    			248
    		]
    	],
    	[
    		[
    			217,
    			217
    		],
    		"mapped",
    		[
    			249
    		]
    	],
    	[
    		[
    			218,
    			218
    		],
    		"mapped",
    		[
    			250
    		]
    	],
    	[
    		[
    			219,
    			219
    		],
    		"mapped",
    		[
    			251
    		]
    	],
    	[
    		[
    			220,
    			220
    		],
    		"mapped",
    		[
    			252
    		]
    	],
    	[
    		[
    			221,
    			221
    		],
    		"mapped",
    		[
    			253
    		]
    	],
    	[
    		[
    			222,
    			222
    		],
    		"mapped",
    		[
    			254
    		]
    	],
    	[
    		[
    			223,
    			223
    		],
    		"deviation",
    		[
    			115,
    			115
    		]
    	],
    	[
    		[
    			224,
    			246
    		],
    		"valid"
    	],
    	[
    		[
    			247,
    			247
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			248,
    			255
    		],
    		"valid"
    	],
    	[
    		[
    			256,
    			256
    		],
    		"mapped",
    		[
    			257
    		]
    	],
    	[
    		[
    			257,
    			257
    		],
    		"valid"
    	],
    	[
    		[
    			258,
    			258
    		],
    		"mapped",
    		[
    			259
    		]
    	],
    	[
    		[
    			259,
    			259
    		],
    		"valid"
    	],
    	[
    		[
    			260,
    			260
    		],
    		"mapped",
    		[
    			261
    		]
    	],
    	[
    		[
    			261,
    			261
    		],
    		"valid"
    	],
    	[
    		[
    			262,
    			262
    		],
    		"mapped",
    		[
    			263
    		]
    	],
    	[
    		[
    			263,
    			263
    		],
    		"valid"
    	],
    	[
    		[
    			264,
    			264
    		],
    		"mapped",
    		[
    			265
    		]
    	],
    	[
    		[
    			265,
    			265
    		],
    		"valid"
    	],
    	[
    		[
    			266,
    			266
    		],
    		"mapped",
    		[
    			267
    		]
    	],
    	[
    		[
    			267,
    			267
    		],
    		"valid"
    	],
    	[
    		[
    			268,
    			268
    		],
    		"mapped",
    		[
    			269
    		]
    	],
    	[
    		[
    			269,
    			269
    		],
    		"valid"
    	],
    	[
    		[
    			270,
    			270
    		],
    		"mapped",
    		[
    			271
    		]
    	],
    	[
    		[
    			271,
    			271
    		],
    		"valid"
    	],
    	[
    		[
    			272,
    			272
    		],
    		"mapped",
    		[
    			273
    		]
    	],
    	[
    		[
    			273,
    			273
    		],
    		"valid"
    	],
    	[
    		[
    			274,
    			274
    		],
    		"mapped",
    		[
    			275
    		]
    	],
    	[
    		[
    			275,
    			275
    		],
    		"valid"
    	],
    	[
    		[
    			276,
    			276
    		],
    		"mapped",
    		[
    			277
    		]
    	],
    	[
    		[
    			277,
    			277
    		],
    		"valid"
    	],
    	[
    		[
    			278,
    			278
    		],
    		"mapped",
    		[
    			279
    		]
    	],
    	[
    		[
    			279,
    			279
    		],
    		"valid"
    	],
    	[
    		[
    			280,
    			280
    		],
    		"mapped",
    		[
    			281
    		]
    	],
    	[
    		[
    			281,
    			281
    		],
    		"valid"
    	],
    	[
    		[
    			282,
    			282
    		],
    		"mapped",
    		[
    			283
    		]
    	],
    	[
    		[
    			283,
    			283
    		],
    		"valid"
    	],
    	[
    		[
    			284,
    			284
    		],
    		"mapped",
    		[
    			285
    		]
    	],
    	[
    		[
    			285,
    			285
    		],
    		"valid"
    	],
    	[
    		[
    			286,
    			286
    		],
    		"mapped",
    		[
    			287
    		]
    	],
    	[
    		[
    			287,
    			287
    		],
    		"valid"
    	],
    	[
    		[
    			288,
    			288
    		],
    		"mapped",
    		[
    			289
    		]
    	],
    	[
    		[
    			289,
    			289
    		],
    		"valid"
    	],
    	[
    		[
    			290,
    			290
    		],
    		"mapped",
    		[
    			291
    		]
    	],
    	[
    		[
    			291,
    			291
    		],
    		"valid"
    	],
    	[
    		[
    			292,
    			292
    		],
    		"mapped",
    		[
    			293
    		]
    	],
    	[
    		[
    			293,
    			293
    		],
    		"valid"
    	],
    	[
    		[
    			294,
    			294
    		],
    		"mapped",
    		[
    			295
    		]
    	],
    	[
    		[
    			295,
    			295
    		],
    		"valid"
    	],
    	[
    		[
    			296,
    			296
    		],
    		"mapped",
    		[
    			297
    		]
    	],
    	[
    		[
    			297,
    			297
    		],
    		"valid"
    	],
    	[
    		[
    			298,
    			298
    		],
    		"mapped",
    		[
    			299
    		]
    	],
    	[
    		[
    			299,
    			299
    		],
    		"valid"
    	],
    	[
    		[
    			300,
    			300
    		],
    		"mapped",
    		[
    			301
    		]
    	],
    	[
    		[
    			301,
    			301
    		],
    		"valid"
    	],
    	[
    		[
    			302,
    			302
    		],
    		"mapped",
    		[
    			303
    		]
    	],
    	[
    		[
    			303,
    			303
    		],
    		"valid"
    	],
    	[
    		[
    			304,
    			304
    		],
    		"mapped",
    		[
    			105,
    			775
    		]
    	],
    	[
    		[
    			305,
    			305
    		],
    		"valid"
    	],
    	[
    		[
    			306,
    			307
    		],
    		"mapped",
    		[
    			105,
    			106
    		]
    	],
    	[
    		[
    			308,
    			308
    		],
    		"mapped",
    		[
    			309
    		]
    	],
    	[
    		[
    			309,
    			309
    		],
    		"valid"
    	],
    	[
    		[
    			310,
    			310
    		],
    		"mapped",
    		[
    			311
    		]
    	],
    	[
    		[
    			311,
    			312
    		],
    		"valid"
    	],
    	[
    		[
    			313,
    			313
    		],
    		"mapped",
    		[
    			314
    		]
    	],
    	[
    		[
    			314,
    			314
    		],
    		"valid"
    	],
    	[
    		[
    			315,
    			315
    		],
    		"mapped",
    		[
    			316
    		]
    	],
    	[
    		[
    			316,
    			316
    		],
    		"valid"
    	],
    	[
    		[
    			317,
    			317
    		],
    		"mapped",
    		[
    			318
    		]
    	],
    	[
    		[
    			318,
    			318
    		],
    		"valid"
    	],
    	[
    		[
    			319,
    			320
    		],
    		"mapped",
    		[
    			108,
    			183
    		]
    	],
    	[
    		[
    			321,
    			321
    		],
    		"mapped",
    		[
    			322
    		]
    	],
    	[
    		[
    			322,
    			322
    		],
    		"valid"
    	],
    	[
    		[
    			323,
    			323
    		],
    		"mapped",
    		[
    			324
    		]
    	],
    	[
    		[
    			324,
    			324
    		],
    		"valid"
    	],
    	[
    		[
    			325,
    			325
    		],
    		"mapped",
    		[
    			326
    		]
    	],
    	[
    		[
    			326,
    			326
    		],
    		"valid"
    	],
    	[
    		[
    			327,
    			327
    		],
    		"mapped",
    		[
    			328
    		]
    	],
    	[
    		[
    			328,
    			328
    		],
    		"valid"
    	],
    	[
    		[
    			329,
    			329
    		],
    		"mapped",
    		[
    			700,
    			110
    		]
    	],
    	[
    		[
    			330,
    			330
    		],
    		"mapped",
    		[
    			331
    		]
    	],
    	[
    		[
    			331,
    			331
    		],
    		"valid"
    	],
    	[
    		[
    			332,
    			332
    		],
    		"mapped",
    		[
    			333
    		]
    	],
    	[
    		[
    			333,
    			333
    		],
    		"valid"
    	],
    	[
    		[
    			334,
    			334
    		],
    		"mapped",
    		[
    			335
    		]
    	],
    	[
    		[
    			335,
    			335
    		],
    		"valid"
    	],
    	[
    		[
    			336,
    			336
    		],
    		"mapped",
    		[
    			337
    		]
    	],
    	[
    		[
    			337,
    			337
    		],
    		"valid"
    	],
    	[
    		[
    			338,
    			338
    		],
    		"mapped",
    		[
    			339
    		]
    	],
    	[
    		[
    			339,
    			339
    		],
    		"valid"
    	],
    	[
    		[
    			340,
    			340
    		],
    		"mapped",
    		[
    			341
    		]
    	],
    	[
    		[
    			341,
    			341
    		],
    		"valid"
    	],
    	[
    		[
    			342,
    			342
    		],
    		"mapped",
    		[
    			343
    		]
    	],
    	[
    		[
    			343,
    			343
    		],
    		"valid"
    	],
    	[
    		[
    			344,
    			344
    		],
    		"mapped",
    		[
    			345
    		]
    	],
    	[
    		[
    			345,
    			345
    		],
    		"valid"
    	],
    	[
    		[
    			346,
    			346
    		],
    		"mapped",
    		[
    			347
    		]
    	],
    	[
    		[
    			347,
    			347
    		],
    		"valid"
    	],
    	[
    		[
    			348,
    			348
    		],
    		"mapped",
    		[
    			349
    		]
    	],
    	[
    		[
    			349,
    			349
    		],
    		"valid"
    	],
    	[
    		[
    			350,
    			350
    		],
    		"mapped",
    		[
    			351
    		]
    	],
    	[
    		[
    			351,
    			351
    		],
    		"valid"
    	],
    	[
    		[
    			352,
    			352
    		],
    		"mapped",
    		[
    			353
    		]
    	],
    	[
    		[
    			353,
    			353
    		],
    		"valid"
    	],
    	[
    		[
    			354,
    			354
    		],
    		"mapped",
    		[
    			355
    		]
    	],
    	[
    		[
    			355,
    			355
    		],
    		"valid"
    	],
    	[
    		[
    			356,
    			356
    		],
    		"mapped",
    		[
    			357
    		]
    	],
    	[
    		[
    			357,
    			357
    		],
    		"valid"
    	],
    	[
    		[
    			358,
    			358
    		],
    		"mapped",
    		[
    			359
    		]
    	],
    	[
    		[
    			359,
    			359
    		],
    		"valid"
    	],
    	[
    		[
    			360,
    			360
    		],
    		"mapped",
    		[
    			361
    		]
    	],
    	[
    		[
    			361,
    			361
    		],
    		"valid"
    	],
    	[
    		[
    			362,
    			362
    		],
    		"mapped",
    		[
    			363
    		]
    	],
    	[
    		[
    			363,
    			363
    		],
    		"valid"
    	],
    	[
    		[
    			364,
    			364
    		],
    		"mapped",
    		[
    			365
    		]
    	],
    	[
    		[
    			365,
    			365
    		],
    		"valid"
    	],
    	[
    		[
    			366,
    			366
    		],
    		"mapped",
    		[
    			367
    		]
    	],
    	[
    		[
    			367,
    			367
    		],
    		"valid"
    	],
    	[
    		[
    			368,
    			368
    		],
    		"mapped",
    		[
    			369
    		]
    	],
    	[
    		[
    			369,
    			369
    		],
    		"valid"
    	],
    	[
    		[
    			370,
    			370
    		],
    		"mapped",
    		[
    			371
    		]
    	],
    	[
    		[
    			371,
    			371
    		],
    		"valid"
    	],
    	[
    		[
    			372,
    			372
    		],
    		"mapped",
    		[
    			373
    		]
    	],
    	[
    		[
    			373,
    			373
    		],
    		"valid"
    	],
    	[
    		[
    			374,
    			374
    		],
    		"mapped",
    		[
    			375
    		]
    	],
    	[
    		[
    			375,
    			375
    		],
    		"valid"
    	],
    	[
    		[
    			376,
    			376
    		],
    		"mapped",
    		[
    			255
    		]
    	],
    	[
    		[
    			377,
    			377
    		],
    		"mapped",
    		[
    			378
    		]
    	],
    	[
    		[
    			378,
    			378
    		],
    		"valid"
    	],
    	[
    		[
    			379,
    			379
    		],
    		"mapped",
    		[
    			380
    		]
    	],
    	[
    		[
    			380,
    			380
    		],
    		"valid"
    	],
    	[
    		[
    			381,
    			381
    		],
    		"mapped",
    		[
    			382
    		]
    	],
    	[
    		[
    			382,
    			382
    		],
    		"valid"
    	],
    	[
    		[
    			383,
    			383
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			384,
    			384
    		],
    		"valid"
    	],
    	[
    		[
    			385,
    			385
    		],
    		"mapped",
    		[
    			595
    		]
    	],
    	[
    		[
    			386,
    			386
    		],
    		"mapped",
    		[
    			387
    		]
    	],
    	[
    		[
    			387,
    			387
    		],
    		"valid"
    	],
    	[
    		[
    			388,
    			388
    		],
    		"mapped",
    		[
    			389
    		]
    	],
    	[
    		[
    			389,
    			389
    		],
    		"valid"
    	],
    	[
    		[
    			390,
    			390
    		],
    		"mapped",
    		[
    			596
    		]
    	],
    	[
    		[
    			391,
    			391
    		],
    		"mapped",
    		[
    			392
    		]
    	],
    	[
    		[
    			392,
    			392
    		],
    		"valid"
    	],
    	[
    		[
    			393,
    			393
    		],
    		"mapped",
    		[
    			598
    		]
    	],
    	[
    		[
    			394,
    			394
    		],
    		"mapped",
    		[
    			599
    		]
    	],
    	[
    		[
    			395,
    			395
    		],
    		"mapped",
    		[
    			396
    		]
    	],
    	[
    		[
    			396,
    			397
    		],
    		"valid"
    	],
    	[
    		[
    			398,
    			398
    		],
    		"mapped",
    		[
    			477
    		]
    	],
    	[
    		[
    			399,
    			399
    		],
    		"mapped",
    		[
    			601
    		]
    	],
    	[
    		[
    			400,
    			400
    		],
    		"mapped",
    		[
    			603
    		]
    	],
    	[
    		[
    			401,
    			401
    		],
    		"mapped",
    		[
    			402
    		]
    	],
    	[
    		[
    			402,
    			402
    		],
    		"valid"
    	],
    	[
    		[
    			403,
    			403
    		],
    		"mapped",
    		[
    			608
    		]
    	],
    	[
    		[
    			404,
    			404
    		],
    		"mapped",
    		[
    			611
    		]
    	],
    	[
    		[
    			405,
    			405
    		],
    		"valid"
    	],
    	[
    		[
    			406,
    			406
    		],
    		"mapped",
    		[
    			617
    		]
    	],
    	[
    		[
    			407,
    			407
    		],
    		"mapped",
    		[
    			616
    		]
    	],
    	[
    		[
    			408,
    			408
    		],
    		"mapped",
    		[
    			409
    		]
    	],
    	[
    		[
    			409,
    			411
    		],
    		"valid"
    	],
    	[
    		[
    			412,
    			412
    		],
    		"mapped",
    		[
    			623
    		]
    	],
    	[
    		[
    			413,
    			413
    		],
    		"mapped",
    		[
    			626
    		]
    	],
    	[
    		[
    			414,
    			414
    		],
    		"valid"
    	],
    	[
    		[
    			415,
    			415
    		],
    		"mapped",
    		[
    			629
    		]
    	],
    	[
    		[
    			416,
    			416
    		],
    		"mapped",
    		[
    			417
    		]
    	],
    	[
    		[
    			417,
    			417
    		],
    		"valid"
    	],
    	[
    		[
    			418,
    			418
    		],
    		"mapped",
    		[
    			419
    		]
    	],
    	[
    		[
    			419,
    			419
    		],
    		"valid"
    	],
    	[
    		[
    			420,
    			420
    		],
    		"mapped",
    		[
    			421
    		]
    	],
    	[
    		[
    			421,
    			421
    		],
    		"valid"
    	],
    	[
    		[
    			422,
    			422
    		],
    		"mapped",
    		[
    			640
    		]
    	],
    	[
    		[
    			423,
    			423
    		],
    		"mapped",
    		[
    			424
    		]
    	],
    	[
    		[
    			424,
    			424
    		],
    		"valid"
    	],
    	[
    		[
    			425,
    			425
    		],
    		"mapped",
    		[
    			643
    		]
    	],
    	[
    		[
    			426,
    			427
    		],
    		"valid"
    	],
    	[
    		[
    			428,
    			428
    		],
    		"mapped",
    		[
    			429
    		]
    	],
    	[
    		[
    			429,
    			429
    		],
    		"valid"
    	],
    	[
    		[
    			430,
    			430
    		],
    		"mapped",
    		[
    			648
    		]
    	],
    	[
    		[
    			431,
    			431
    		],
    		"mapped",
    		[
    			432
    		]
    	],
    	[
    		[
    			432,
    			432
    		],
    		"valid"
    	],
    	[
    		[
    			433,
    			433
    		],
    		"mapped",
    		[
    			650
    		]
    	],
    	[
    		[
    			434,
    			434
    		],
    		"mapped",
    		[
    			651
    		]
    	],
    	[
    		[
    			435,
    			435
    		],
    		"mapped",
    		[
    			436
    		]
    	],
    	[
    		[
    			436,
    			436
    		],
    		"valid"
    	],
    	[
    		[
    			437,
    			437
    		],
    		"mapped",
    		[
    			438
    		]
    	],
    	[
    		[
    			438,
    			438
    		],
    		"valid"
    	],
    	[
    		[
    			439,
    			439
    		],
    		"mapped",
    		[
    			658
    		]
    	],
    	[
    		[
    			440,
    			440
    		],
    		"mapped",
    		[
    			441
    		]
    	],
    	[
    		[
    			441,
    			443
    		],
    		"valid"
    	],
    	[
    		[
    			444,
    			444
    		],
    		"mapped",
    		[
    			445
    		]
    	],
    	[
    		[
    			445,
    			451
    		],
    		"valid"
    	],
    	[
    		[
    			452,
    			454
    		],
    		"mapped",
    		[
    			100,
    			382
    		]
    	],
    	[
    		[
    			455,
    			457
    		],
    		"mapped",
    		[
    			108,
    			106
    		]
    	],
    	[
    		[
    			458,
    			460
    		],
    		"mapped",
    		[
    			110,
    			106
    		]
    	],
    	[
    		[
    			461,
    			461
    		],
    		"mapped",
    		[
    			462
    		]
    	],
    	[
    		[
    			462,
    			462
    		],
    		"valid"
    	],
    	[
    		[
    			463,
    			463
    		],
    		"mapped",
    		[
    			464
    		]
    	],
    	[
    		[
    			464,
    			464
    		],
    		"valid"
    	],
    	[
    		[
    			465,
    			465
    		],
    		"mapped",
    		[
    			466
    		]
    	],
    	[
    		[
    			466,
    			466
    		],
    		"valid"
    	],
    	[
    		[
    			467,
    			467
    		],
    		"mapped",
    		[
    			468
    		]
    	],
    	[
    		[
    			468,
    			468
    		],
    		"valid"
    	],
    	[
    		[
    			469,
    			469
    		],
    		"mapped",
    		[
    			470
    		]
    	],
    	[
    		[
    			470,
    			470
    		],
    		"valid"
    	],
    	[
    		[
    			471,
    			471
    		],
    		"mapped",
    		[
    			472
    		]
    	],
    	[
    		[
    			472,
    			472
    		],
    		"valid"
    	],
    	[
    		[
    			473,
    			473
    		],
    		"mapped",
    		[
    			474
    		]
    	],
    	[
    		[
    			474,
    			474
    		],
    		"valid"
    	],
    	[
    		[
    			475,
    			475
    		],
    		"mapped",
    		[
    			476
    		]
    	],
    	[
    		[
    			476,
    			477
    		],
    		"valid"
    	],
    	[
    		[
    			478,
    			478
    		],
    		"mapped",
    		[
    			479
    		]
    	],
    	[
    		[
    			479,
    			479
    		],
    		"valid"
    	],
    	[
    		[
    			480,
    			480
    		],
    		"mapped",
    		[
    			481
    		]
    	],
    	[
    		[
    			481,
    			481
    		],
    		"valid"
    	],
    	[
    		[
    			482,
    			482
    		],
    		"mapped",
    		[
    			483
    		]
    	],
    	[
    		[
    			483,
    			483
    		],
    		"valid"
    	],
    	[
    		[
    			484,
    			484
    		],
    		"mapped",
    		[
    			485
    		]
    	],
    	[
    		[
    			485,
    			485
    		],
    		"valid"
    	],
    	[
    		[
    			486,
    			486
    		],
    		"mapped",
    		[
    			487
    		]
    	],
    	[
    		[
    			487,
    			487
    		],
    		"valid"
    	],
    	[
    		[
    			488,
    			488
    		],
    		"mapped",
    		[
    			489
    		]
    	],
    	[
    		[
    			489,
    			489
    		],
    		"valid"
    	],
    	[
    		[
    			490,
    			490
    		],
    		"mapped",
    		[
    			491
    		]
    	],
    	[
    		[
    			491,
    			491
    		],
    		"valid"
    	],
    	[
    		[
    			492,
    			492
    		],
    		"mapped",
    		[
    			493
    		]
    	],
    	[
    		[
    			493,
    			493
    		],
    		"valid"
    	],
    	[
    		[
    			494,
    			494
    		],
    		"mapped",
    		[
    			495
    		]
    	],
    	[
    		[
    			495,
    			496
    		],
    		"valid"
    	],
    	[
    		[
    			497,
    			499
    		],
    		"mapped",
    		[
    			100,
    			122
    		]
    	],
    	[
    		[
    			500,
    			500
    		],
    		"mapped",
    		[
    			501
    		]
    	],
    	[
    		[
    			501,
    			501
    		],
    		"valid"
    	],
    	[
    		[
    			502,
    			502
    		],
    		"mapped",
    		[
    			405
    		]
    	],
    	[
    		[
    			503,
    			503
    		],
    		"mapped",
    		[
    			447
    		]
    	],
    	[
    		[
    			504,
    			504
    		],
    		"mapped",
    		[
    			505
    		]
    	],
    	[
    		[
    			505,
    			505
    		],
    		"valid"
    	],
    	[
    		[
    			506,
    			506
    		],
    		"mapped",
    		[
    			507
    		]
    	],
    	[
    		[
    			507,
    			507
    		],
    		"valid"
    	],
    	[
    		[
    			508,
    			508
    		],
    		"mapped",
    		[
    			509
    		]
    	],
    	[
    		[
    			509,
    			509
    		],
    		"valid"
    	],
    	[
    		[
    			510,
    			510
    		],
    		"mapped",
    		[
    			511
    		]
    	],
    	[
    		[
    			511,
    			511
    		],
    		"valid"
    	],
    	[
    		[
    			512,
    			512
    		],
    		"mapped",
    		[
    			513
    		]
    	],
    	[
    		[
    			513,
    			513
    		],
    		"valid"
    	],
    	[
    		[
    			514,
    			514
    		],
    		"mapped",
    		[
    			515
    		]
    	],
    	[
    		[
    			515,
    			515
    		],
    		"valid"
    	],
    	[
    		[
    			516,
    			516
    		],
    		"mapped",
    		[
    			517
    		]
    	],
    	[
    		[
    			517,
    			517
    		],
    		"valid"
    	],
    	[
    		[
    			518,
    			518
    		],
    		"mapped",
    		[
    			519
    		]
    	],
    	[
    		[
    			519,
    			519
    		],
    		"valid"
    	],
    	[
    		[
    			520,
    			520
    		],
    		"mapped",
    		[
    			521
    		]
    	],
    	[
    		[
    			521,
    			521
    		],
    		"valid"
    	],
    	[
    		[
    			522,
    			522
    		],
    		"mapped",
    		[
    			523
    		]
    	],
    	[
    		[
    			523,
    			523
    		],
    		"valid"
    	],
    	[
    		[
    			524,
    			524
    		],
    		"mapped",
    		[
    			525
    		]
    	],
    	[
    		[
    			525,
    			525
    		],
    		"valid"
    	],
    	[
    		[
    			526,
    			526
    		],
    		"mapped",
    		[
    			527
    		]
    	],
    	[
    		[
    			527,
    			527
    		],
    		"valid"
    	],
    	[
    		[
    			528,
    			528
    		],
    		"mapped",
    		[
    			529
    		]
    	],
    	[
    		[
    			529,
    			529
    		],
    		"valid"
    	],
    	[
    		[
    			530,
    			530
    		],
    		"mapped",
    		[
    			531
    		]
    	],
    	[
    		[
    			531,
    			531
    		],
    		"valid"
    	],
    	[
    		[
    			532,
    			532
    		],
    		"mapped",
    		[
    			533
    		]
    	],
    	[
    		[
    			533,
    			533
    		],
    		"valid"
    	],
    	[
    		[
    			534,
    			534
    		],
    		"mapped",
    		[
    			535
    		]
    	],
    	[
    		[
    			535,
    			535
    		],
    		"valid"
    	],
    	[
    		[
    			536,
    			536
    		],
    		"mapped",
    		[
    			537
    		]
    	],
    	[
    		[
    			537,
    			537
    		],
    		"valid"
    	],
    	[
    		[
    			538,
    			538
    		],
    		"mapped",
    		[
    			539
    		]
    	],
    	[
    		[
    			539,
    			539
    		],
    		"valid"
    	],
    	[
    		[
    			540,
    			540
    		],
    		"mapped",
    		[
    			541
    		]
    	],
    	[
    		[
    			541,
    			541
    		],
    		"valid"
    	],
    	[
    		[
    			542,
    			542
    		],
    		"mapped",
    		[
    			543
    		]
    	],
    	[
    		[
    			543,
    			543
    		],
    		"valid"
    	],
    	[
    		[
    			544,
    			544
    		],
    		"mapped",
    		[
    			414
    		]
    	],
    	[
    		[
    			545,
    			545
    		],
    		"valid"
    	],
    	[
    		[
    			546,
    			546
    		],
    		"mapped",
    		[
    			547
    		]
    	],
    	[
    		[
    			547,
    			547
    		],
    		"valid"
    	],
    	[
    		[
    			548,
    			548
    		],
    		"mapped",
    		[
    			549
    		]
    	],
    	[
    		[
    			549,
    			549
    		],
    		"valid"
    	],
    	[
    		[
    			550,
    			550
    		],
    		"mapped",
    		[
    			551
    		]
    	],
    	[
    		[
    			551,
    			551
    		],
    		"valid"
    	],
    	[
    		[
    			552,
    			552
    		],
    		"mapped",
    		[
    			553
    		]
    	],
    	[
    		[
    			553,
    			553
    		],
    		"valid"
    	],
    	[
    		[
    			554,
    			554
    		],
    		"mapped",
    		[
    			555
    		]
    	],
    	[
    		[
    			555,
    			555
    		],
    		"valid"
    	],
    	[
    		[
    			556,
    			556
    		],
    		"mapped",
    		[
    			557
    		]
    	],
    	[
    		[
    			557,
    			557
    		],
    		"valid"
    	],
    	[
    		[
    			558,
    			558
    		],
    		"mapped",
    		[
    			559
    		]
    	],
    	[
    		[
    			559,
    			559
    		],
    		"valid"
    	],
    	[
    		[
    			560,
    			560
    		],
    		"mapped",
    		[
    			561
    		]
    	],
    	[
    		[
    			561,
    			561
    		],
    		"valid"
    	],
    	[
    		[
    			562,
    			562
    		],
    		"mapped",
    		[
    			563
    		]
    	],
    	[
    		[
    			563,
    			563
    		],
    		"valid"
    	],
    	[
    		[
    			564,
    			566
    		],
    		"valid"
    	],
    	[
    		[
    			567,
    			569
    		],
    		"valid"
    	],
    	[
    		[
    			570,
    			570
    		],
    		"mapped",
    		[
    			11365
    		]
    	],
    	[
    		[
    			571,
    			571
    		],
    		"mapped",
    		[
    			572
    		]
    	],
    	[
    		[
    			572,
    			572
    		],
    		"valid"
    	],
    	[
    		[
    			573,
    			573
    		],
    		"mapped",
    		[
    			410
    		]
    	],
    	[
    		[
    			574,
    			574
    		],
    		"mapped",
    		[
    			11366
    		]
    	],
    	[
    		[
    			575,
    			576
    		],
    		"valid"
    	],
    	[
    		[
    			577,
    			577
    		],
    		"mapped",
    		[
    			578
    		]
    	],
    	[
    		[
    			578,
    			578
    		],
    		"valid"
    	],
    	[
    		[
    			579,
    			579
    		],
    		"mapped",
    		[
    			384
    		]
    	],
    	[
    		[
    			580,
    			580
    		],
    		"mapped",
    		[
    			649
    		]
    	],
    	[
    		[
    			581,
    			581
    		],
    		"mapped",
    		[
    			652
    		]
    	],
    	[
    		[
    			582,
    			582
    		],
    		"mapped",
    		[
    			583
    		]
    	],
    	[
    		[
    			583,
    			583
    		],
    		"valid"
    	],
    	[
    		[
    			584,
    			584
    		],
    		"mapped",
    		[
    			585
    		]
    	],
    	[
    		[
    			585,
    			585
    		],
    		"valid"
    	],
    	[
    		[
    			586,
    			586
    		],
    		"mapped",
    		[
    			587
    		]
    	],
    	[
    		[
    			587,
    			587
    		],
    		"valid"
    	],
    	[
    		[
    			588,
    			588
    		],
    		"mapped",
    		[
    			589
    		]
    	],
    	[
    		[
    			589,
    			589
    		],
    		"valid"
    	],
    	[
    		[
    			590,
    			590
    		],
    		"mapped",
    		[
    			591
    		]
    	],
    	[
    		[
    			591,
    			591
    		],
    		"valid"
    	],
    	[
    		[
    			592,
    			680
    		],
    		"valid"
    	],
    	[
    		[
    			681,
    			685
    		],
    		"valid"
    	],
    	[
    		[
    			686,
    			687
    		],
    		"valid"
    	],
    	[
    		[
    			688,
    			688
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			689,
    			689
    		],
    		"mapped",
    		[
    			614
    		]
    	],
    	[
    		[
    			690,
    			690
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			691,
    			691
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			692,
    			692
    		],
    		"mapped",
    		[
    			633
    		]
    	],
    	[
    		[
    			693,
    			693
    		],
    		"mapped",
    		[
    			635
    		]
    	],
    	[
    		[
    			694,
    			694
    		],
    		"mapped",
    		[
    			641
    		]
    	],
    	[
    		[
    			695,
    			695
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			696,
    			696
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			697,
    			705
    		],
    		"valid"
    	],
    	[
    		[
    			706,
    			709
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			710,
    			721
    		],
    		"valid"
    	],
    	[
    		[
    			722,
    			727
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			728,
    			728
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			774
    		]
    	],
    	[
    		[
    			729,
    			729
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			775
    		]
    	],
    	[
    		[
    			730,
    			730
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			778
    		]
    	],
    	[
    		[
    			731,
    			731
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			808
    		]
    	],
    	[
    		[
    			732,
    			732
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			771
    		]
    	],
    	[
    		[
    			733,
    			733
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			779
    		]
    	],
    	[
    		[
    			734,
    			734
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			735,
    			735
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			736,
    			736
    		],
    		"mapped",
    		[
    			611
    		]
    	],
    	[
    		[
    			737,
    			737
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			738,
    			738
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			739,
    			739
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			740,
    			740
    		],
    		"mapped",
    		[
    			661
    		]
    	],
    	[
    		[
    			741,
    			745
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			746,
    			747
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			748,
    			748
    		],
    		"valid"
    	],
    	[
    		[
    			749,
    			749
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			750,
    			750
    		],
    		"valid"
    	],
    	[
    		[
    			751,
    			767
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			768,
    			831
    		],
    		"valid"
    	],
    	[
    		[
    			832,
    			832
    		],
    		"mapped",
    		[
    			768
    		]
    	],
    	[
    		[
    			833,
    			833
    		],
    		"mapped",
    		[
    			769
    		]
    	],
    	[
    		[
    			834,
    			834
    		],
    		"valid"
    	],
    	[
    		[
    			835,
    			835
    		],
    		"mapped",
    		[
    			787
    		]
    	],
    	[
    		[
    			836,
    			836
    		],
    		"mapped",
    		[
    			776,
    			769
    		]
    	],
    	[
    		[
    			837,
    			837
    		],
    		"mapped",
    		[
    			953
    		]
    	],
    	[
    		[
    			838,
    			846
    		],
    		"valid"
    	],
    	[
    		[
    			847,
    			847
    		],
    		"ignored"
    	],
    	[
    		[
    			848,
    			855
    		],
    		"valid"
    	],
    	[
    		[
    			856,
    			860
    		],
    		"valid"
    	],
    	[
    		[
    			861,
    			863
    		],
    		"valid"
    	],
    	[
    		[
    			864,
    			865
    		],
    		"valid"
    	],
    	[
    		[
    			866,
    			866
    		],
    		"valid"
    	],
    	[
    		[
    			867,
    			879
    		],
    		"valid"
    	],
    	[
    		[
    			880,
    			880
    		],
    		"mapped",
    		[
    			881
    		]
    	],
    	[
    		[
    			881,
    			881
    		],
    		"valid"
    	],
    	[
    		[
    			882,
    			882
    		],
    		"mapped",
    		[
    			883
    		]
    	],
    	[
    		[
    			883,
    			883
    		],
    		"valid"
    	],
    	[
    		[
    			884,
    			884
    		],
    		"mapped",
    		[
    			697
    		]
    	],
    	[
    		[
    			885,
    			885
    		],
    		"valid"
    	],
    	[
    		[
    			886,
    			886
    		],
    		"mapped",
    		[
    			887
    		]
    	],
    	[
    		[
    			887,
    			887
    		],
    		"valid"
    	],
    	[
    		[
    			888,
    			889
    		],
    		"disallowed"
    	],
    	[
    		[
    			890,
    			890
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			953
    		]
    	],
    	[
    		[
    			891,
    			893
    		],
    		"valid"
    	],
    	[
    		[
    			894,
    			894
    		],
    		"disallowed_STD3_mapped",
    		[
    			59
    		]
    	],
    	[
    		[
    			895,
    			895
    		],
    		"mapped",
    		[
    			1011
    		]
    	],
    	[
    		[
    			896,
    			899
    		],
    		"disallowed"
    	],
    	[
    		[
    			900,
    			900
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			769
    		]
    	],
    	[
    		[
    			901,
    			901
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			776,
    			769
    		]
    	],
    	[
    		[
    			902,
    			902
    		],
    		"mapped",
    		[
    			940
    		]
    	],
    	[
    		[
    			903,
    			903
    		],
    		"mapped",
    		[
    			183
    		]
    	],
    	[
    		[
    			904,
    			904
    		],
    		"mapped",
    		[
    			941
    		]
    	],
    	[
    		[
    			905,
    			905
    		],
    		"mapped",
    		[
    			942
    		]
    	],
    	[
    		[
    			906,
    			906
    		],
    		"mapped",
    		[
    			943
    		]
    	],
    	[
    		[
    			907,
    			907
    		],
    		"disallowed"
    	],
    	[
    		[
    			908,
    			908
    		],
    		"mapped",
    		[
    			972
    		]
    	],
    	[
    		[
    			909,
    			909
    		],
    		"disallowed"
    	],
    	[
    		[
    			910,
    			910
    		],
    		"mapped",
    		[
    			973
    		]
    	],
    	[
    		[
    			911,
    			911
    		],
    		"mapped",
    		[
    			974
    		]
    	],
    	[
    		[
    			912,
    			912
    		],
    		"valid"
    	],
    	[
    		[
    			913,
    			913
    		],
    		"mapped",
    		[
    			945
    		]
    	],
    	[
    		[
    			914,
    			914
    		],
    		"mapped",
    		[
    			946
    		]
    	],
    	[
    		[
    			915,
    			915
    		],
    		"mapped",
    		[
    			947
    		]
    	],
    	[
    		[
    			916,
    			916
    		],
    		"mapped",
    		[
    			948
    		]
    	],
    	[
    		[
    			917,
    			917
    		],
    		"mapped",
    		[
    			949
    		]
    	],
    	[
    		[
    			918,
    			918
    		],
    		"mapped",
    		[
    			950
    		]
    	],
    	[
    		[
    			919,
    			919
    		],
    		"mapped",
    		[
    			951
    		]
    	],
    	[
    		[
    			920,
    			920
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			921,
    			921
    		],
    		"mapped",
    		[
    			953
    		]
    	],
    	[
    		[
    			922,
    			922
    		],
    		"mapped",
    		[
    			954
    		]
    	],
    	[
    		[
    			923,
    			923
    		],
    		"mapped",
    		[
    			955
    		]
    	],
    	[
    		[
    			924,
    			924
    		],
    		"mapped",
    		[
    			956
    		]
    	],
    	[
    		[
    			925,
    			925
    		],
    		"mapped",
    		[
    			957
    		]
    	],
    	[
    		[
    			926,
    			926
    		],
    		"mapped",
    		[
    			958
    		]
    	],
    	[
    		[
    			927,
    			927
    		],
    		"mapped",
    		[
    			959
    		]
    	],
    	[
    		[
    			928,
    			928
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			929,
    			929
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			930,
    			930
    		],
    		"disallowed"
    	],
    	[
    		[
    			931,
    			931
    		],
    		"mapped",
    		[
    			963
    		]
    	],
    	[
    		[
    			932,
    			932
    		],
    		"mapped",
    		[
    			964
    		]
    	],
    	[
    		[
    			933,
    			933
    		],
    		"mapped",
    		[
    			965
    		]
    	],
    	[
    		[
    			934,
    			934
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			935,
    			935
    		],
    		"mapped",
    		[
    			967
    		]
    	],
    	[
    		[
    			936,
    			936
    		],
    		"mapped",
    		[
    			968
    		]
    	],
    	[
    		[
    			937,
    			937
    		],
    		"mapped",
    		[
    			969
    		]
    	],
    	[
    		[
    			938,
    			938
    		],
    		"mapped",
    		[
    			970
    		]
    	],
    	[
    		[
    			939,
    			939
    		],
    		"mapped",
    		[
    			971
    		]
    	],
    	[
    		[
    			940,
    			961
    		],
    		"valid"
    	],
    	[
    		[
    			962,
    			962
    		],
    		"deviation",
    		[
    			963
    		]
    	],
    	[
    		[
    			963,
    			974
    		],
    		"valid"
    	],
    	[
    		[
    			975,
    			975
    		],
    		"mapped",
    		[
    			983
    		]
    	],
    	[
    		[
    			976,
    			976
    		],
    		"mapped",
    		[
    			946
    		]
    	],
    	[
    		[
    			977,
    			977
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			978,
    			978
    		],
    		"mapped",
    		[
    			965
    		]
    	],
    	[
    		[
    			979,
    			979
    		],
    		"mapped",
    		[
    			973
    		]
    	],
    	[
    		[
    			980,
    			980
    		],
    		"mapped",
    		[
    			971
    		]
    	],
    	[
    		[
    			981,
    			981
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			982,
    			982
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			983,
    			983
    		],
    		"valid"
    	],
    	[
    		[
    			984,
    			984
    		],
    		"mapped",
    		[
    			985
    		]
    	],
    	[
    		[
    			985,
    			985
    		],
    		"valid"
    	],
    	[
    		[
    			986,
    			986
    		],
    		"mapped",
    		[
    			987
    		]
    	],
    	[
    		[
    			987,
    			987
    		],
    		"valid"
    	],
    	[
    		[
    			988,
    			988
    		],
    		"mapped",
    		[
    			989
    		]
    	],
    	[
    		[
    			989,
    			989
    		],
    		"valid"
    	],
    	[
    		[
    			990,
    			990
    		],
    		"mapped",
    		[
    			991
    		]
    	],
    	[
    		[
    			991,
    			991
    		],
    		"valid"
    	],
    	[
    		[
    			992,
    			992
    		],
    		"mapped",
    		[
    			993
    		]
    	],
    	[
    		[
    			993,
    			993
    		],
    		"valid"
    	],
    	[
    		[
    			994,
    			994
    		],
    		"mapped",
    		[
    			995
    		]
    	],
    	[
    		[
    			995,
    			995
    		],
    		"valid"
    	],
    	[
    		[
    			996,
    			996
    		],
    		"mapped",
    		[
    			997
    		]
    	],
    	[
    		[
    			997,
    			997
    		],
    		"valid"
    	],
    	[
    		[
    			998,
    			998
    		],
    		"mapped",
    		[
    			999
    		]
    	],
    	[
    		[
    			999,
    			999
    		],
    		"valid"
    	],
    	[
    		[
    			1000,
    			1000
    		],
    		"mapped",
    		[
    			1001
    		]
    	],
    	[
    		[
    			1001,
    			1001
    		],
    		"valid"
    	],
    	[
    		[
    			1002,
    			1002
    		],
    		"mapped",
    		[
    			1003
    		]
    	],
    	[
    		[
    			1003,
    			1003
    		],
    		"valid"
    	],
    	[
    		[
    			1004,
    			1004
    		],
    		"mapped",
    		[
    			1005
    		]
    	],
    	[
    		[
    			1005,
    			1005
    		],
    		"valid"
    	],
    	[
    		[
    			1006,
    			1006
    		],
    		"mapped",
    		[
    			1007
    		]
    	],
    	[
    		[
    			1007,
    			1007
    		],
    		"valid"
    	],
    	[
    		[
    			1008,
    			1008
    		],
    		"mapped",
    		[
    			954
    		]
    	],
    	[
    		[
    			1009,
    			1009
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			1010,
    			1010
    		],
    		"mapped",
    		[
    			963
    		]
    	],
    	[
    		[
    			1011,
    			1011
    		],
    		"valid"
    	],
    	[
    		[
    			1012,
    			1012
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			1013,
    			1013
    		],
    		"mapped",
    		[
    			949
    		]
    	],
    	[
    		[
    			1014,
    			1014
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1015,
    			1015
    		],
    		"mapped",
    		[
    			1016
    		]
    	],
    	[
    		[
    			1016,
    			1016
    		],
    		"valid"
    	],
    	[
    		[
    			1017,
    			1017
    		],
    		"mapped",
    		[
    			963
    		]
    	],
    	[
    		[
    			1018,
    			1018
    		],
    		"mapped",
    		[
    			1019
    		]
    	],
    	[
    		[
    			1019,
    			1019
    		],
    		"valid"
    	],
    	[
    		[
    			1020,
    			1020
    		],
    		"valid"
    	],
    	[
    		[
    			1021,
    			1021
    		],
    		"mapped",
    		[
    			891
    		]
    	],
    	[
    		[
    			1022,
    			1022
    		],
    		"mapped",
    		[
    			892
    		]
    	],
    	[
    		[
    			1023,
    			1023
    		],
    		"mapped",
    		[
    			893
    		]
    	],
    	[
    		[
    			1024,
    			1024
    		],
    		"mapped",
    		[
    			1104
    		]
    	],
    	[
    		[
    			1025,
    			1025
    		],
    		"mapped",
    		[
    			1105
    		]
    	],
    	[
    		[
    			1026,
    			1026
    		],
    		"mapped",
    		[
    			1106
    		]
    	],
    	[
    		[
    			1027,
    			1027
    		],
    		"mapped",
    		[
    			1107
    		]
    	],
    	[
    		[
    			1028,
    			1028
    		],
    		"mapped",
    		[
    			1108
    		]
    	],
    	[
    		[
    			1029,
    			1029
    		],
    		"mapped",
    		[
    			1109
    		]
    	],
    	[
    		[
    			1030,
    			1030
    		],
    		"mapped",
    		[
    			1110
    		]
    	],
    	[
    		[
    			1031,
    			1031
    		],
    		"mapped",
    		[
    			1111
    		]
    	],
    	[
    		[
    			1032,
    			1032
    		],
    		"mapped",
    		[
    			1112
    		]
    	],
    	[
    		[
    			1033,
    			1033
    		],
    		"mapped",
    		[
    			1113
    		]
    	],
    	[
    		[
    			1034,
    			1034
    		],
    		"mapped",
    		[
    			1114
    		]
    	],
    	[
    		[
    			1035,
    			1035
    		],
    		"mapped",
    		[
    			1115
    		]
    	],
    	[
    		[
    			1036,
    			1036
    		],
    		"mapped",
    		[
    			1116
    		]
    	],
    	[
    		[
    			1037,
    			1037
    		],
    		"mapped",
    		[
    			1117
    		]
    	],
    	[
    		[
    			1038,
    			1038
    		],
    		"mapped",
    		[
    			1118
    		]
    	],
    	[
    		[
    			1039,
    			1039
    		],
    		"mapped",
    		[
    			1119
    		]
    	],
    	[
    		[
    			1040,
    			1040
    		],
    		"mapped",
    		[
    			1072
    		]
    	],
    	[
    		[
    			1041,
    			1041
    		],
    		"mapped",
    		[
    			1073
    		]
    	],
    	[
    		[
    			1042,
    			1042
    		],
    		"mapped",
    		[
    			1074
    		]
    	],
    	[
    		[
    			1043,
    			1043
    		],
    		"mapped",
    		[
    			1075
    		]
    	],
    	[
    		[
    			1044,
    			1044
    		],
    		"mapped",
    		[
    			1076
    		]
    	],
    	[
    		[
    			1045,
    			1045
    		],
    		"mapped",
    		[
    			1077
    		]
    	],
    	[
    		[
    			1046,
    			1046
    		],
    		"mapped",
    		[
    			1078
    		]
    	],
    	[
    		[
    			1047,
    			1047
    		],
    		"mapped",
    		[
    			1079
    		]
    	],
    	[
    		[
    			1048,
    			1048
    		],
    		"mapped",
    		[
    			1080
    		]
    	],
    	[
    		[
    			1049,
    			1049
    		],
    		"mapped",
    		[
    			1081
    		]
    	],
    	[
    		[
    			1050,
    			1050
    		],
    		"mapped",
    		[
    			1082
    		]
    	],
    	[
    		[
    			1051,
    			1051
    		],
    		"mapped",
    		[
    			1083
    		]
    	],
    	[
    		[
    			1052,
    			1052
    		],
    		"mapped",
    		[
    			1084
    		]
    	],
    	[
    		[
    			1053,
    			1053
    		],
    		"mapped",
    		[
    			1085
    		]
    	],
    	[
    		[
    			1054,
    			1054
    		],
    		"mapped",
    		[
    			1086
    		]
    	],
    	[
    		[
    			1055,
    			1055
    		],
    		"mapped",
    		[
    			1087
    		]
    	],
    	[
    		[
    			1056,
    			1056
    		],
    		"mapped",
    		[
    			1088
    		]
    	],
    	[
    		[
    			1057,
    			1057
    		],
    		"mapped",
    		[
    			1089
    		]
    	],
    	[
    		[
    			1058,
    			1058
    		],
    		"mapped",
    		[
    			1090
    		]
    	],
    	[
    		[
    			1059,
    			1059
    		],
    		"mapped",
    		[
    			1091
    		]
    	],
    	[
    		[
    			1060,
    			1060
    		],
    		"mapped",
    		[
    			1092
    		]
    	],
    	[
    		[
    			1061,
    			1061
    		],
    		"mapped",
    		[
    			1093
    		]
    	],
    	[
    		[
    			1062,
    			1062
    		],
    		"mapped",
    		[
    			1094
    		]
    	],
    	[
    		[
    			1063,
    			1063
    		],
    		"mapped",
    		[
    			1095
    		]
    	],
    	[
    		[
    			1064,
    			1064
    		],
    		"mapped",
    		[
    			1096
    		]
    	],
    	[
    		[
    			1065,
    			1065
    		],
    		"mapped",
    		[
    			1097
    		]
    	],
    	[
    		[
    			1066,
    			1066
    		],
    		"mapped",
    		[
    			1098
    		]
    	],
    	[
    		[
    			1067,
    			1067
    		],
    		"mapped",
    		[
    			1099
    		]
    	],
    	[
    		[
    			1068,
    			1068
    		],
    		"mapped",
    		[
    			1100
    		]
    	],
    	[
    		[
    			1069,
    			1069
    		],
    		"mapped",
    		[
    			1101
    		]
    	],
    	[
    		[
    			1070,
    			1070
    		],
    		"mapped",
    		[
    			1102
    		]
    	],
    	[
    		[
    			1071,
    			1071
    		],
    		"mapped",
    		[
    			1103
    		]
    	],
    	[
    		[
    			1072,
    			1103
    		],
    		"valid"
    	],
    	[
    		[
    			1104,
    			1104
    		],
    		"valid"
    	],
    	[
    		[
    			1105,
    			1116
    		],
    		"valid"
    	],
    	[
    		[
    			1117,
    			1117
    		],
    		"valid"
    	],
    	[
    		[
    			1118,
    			1119
    		],
    		"valid"
    	],
    	[
    		[
    			1120,
    			1120
    		],
    		"mapped",
    		[
    			1121
    		]
    	],
    	[
    		[
    			1121,
    			1121
    		],
    		"valid"
    	],
    	[
    		[
    			1122,
    			1122
    		],
    		"mapped",
    		[
    			1123
    		]
    	],
    	[
    		[
    			1123,
    			1123
    		],
    		"valid"
    	],
    	[
    		[
    			1124,
    			1124
    		],
    		"mapped",
    		[
    			1125
    		]
    	],
    	[
    		[
    			1125,
    			1125
    		],
    		"valid"
    	],
    	[
    		[
    			1126,
    			1126
    		],
    		"mapped",
    		[
    			1127
    		]
    	],
    	[
    		[
    			1127,
    			1127
    		],
    		"valid"
    	],
    	[
    		[
    			1128,
    			1128
    		],
    		"mapped",
    		[
    			1129
    		]
    	],
    	[
    		[
    			1129,
    			1129
    		],
    		"valid"
    	],
    	[
    		[
    			1130,
    			1130
    		],
    		"mapped",
    		[
    			1131
    		]
    	],
    	[
    		[
    			1131,
    			1131
    		],
    		"valid"
    	],
    	[
    		[
    			1132,
    			1132
    		],
    		"mapped",
    		[
    			1133
    		]
    	],
    	[
    		[
    			1133,
    			1133
    		],
    		"valid"
    	],
    	[
    		[
    			1134,
    			1134
    		],
    		"mapped",
    		[
    			1135
    		]
    	],
    	[
    		[
    			1135,
    			1135
    		],
    		"valid"
    	],
    	[
    		[
    			1136,
    			1136
    		],
    		"mapped",
    		[
    			1137
    		]
    	],
    	[
    		[
    			1137,
    			1137
    		],
    		"valid"
    	],
    	[
    		[
    			1138,
    			1138
    		],
    		"mapped",
    		[
    			1139
    		]
    	],
    	[
    		[
    			1139,
    			1139
    		],
    		"valid"
    	],
    	[
    		[
    			1140,
    			1140
    		],
    		"mapped",
    		[
    			1141
    		]
    	],
    	[
    		[
    			1141,
    			1141
    		],
    		"valid"
    	],
    	[
    		[
    			1142,
    			1142
    		],
    		"mapped",
    		[
    			1143
    		]
    	],
    	[
    		[
    			1143,
    			1143
    		],
    		"valid"
    	],
    	[
    		[
    			1144,
    			1144
    		],
    		"mapped",
    		[
    			1145
    		]
    	],
    	[
    		[
    			1145,
    			1145
    		],
    		"valid"
    	],
    	[
    		[
    			1146,
    			1146
    		],
    		"mapped",
    		[
    			1147
    		]
    	],
    	[
    		[
    			1147,
    			1147
    		],
    		"valid"
    	],
    	[
    		[
    			1148,
    			1148
    		],
    		"mapped",
    		[
    			1149
    		]
    	],
    	[
    		[
    			1149,
    			1149
    		],
    		"valid"
    	],
    	[
    		[
    			1150,
    			1150
    		],
    		"mapped",
    		[
    			1151
    		]
    	],
    	[
    		[
    			1151,
    			1151
    		],
    		"valid"
    	],
    	[
    		[
    			1152,
    			1152
    		],
    		"mapped",
    		[
    			1153
    		]
    	],
    	[
    		[
    			1153,
    			1153
    		],
    		"valid"
    	],
    	[
    		[
    			1154,
    			1154
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1155,
    			1158
    		],
    		"valid"
    	],
    	[
    		[
    			1159,
    			1159
    		],
    		"valid"
    	],
    	[
    		[
    			1160,
    			1161
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1162,
    			1162
    		],
    		"mapped",
    		[
    			1163
    		]
    	],
    	[
    		[
    			1163,
    			1163
    		],
    		"valid"
    	],
    	[
    		[
    			1164,
    			1164
    		],
    		"mapped",
    		[
    			1165
    		]
    	],
    	[
    		[
    			1165,
    			1165
    		],
    		"valid"
    	],
    	[
    		[
    			1166,
    			1166
    		],
    		"mapped",
    		[
    			1167
    		]
    	],
    	[
    		[
    			1167,
    			1167
    		],
    		"valid"
    	],
    	[
    		[
    			1168,
    			1168
    		],
    		"mapped",
    		[
    			1169
    		]
    	],
    	[
    		[
    			1169,
    			1169
    		],
    		"valid"
    	],
    	[
    		[
    			1170,
    			1170
    		],
    		"mapped",
    		[
    			1171
    		]
    	],
    	[
    		[
    			1171,
    			1171
    		],
    		"valid"
    	],
    	[
    		[
    			1172,
    			1172
    		],
    		"mapped",
    		[
    			1173
    		]
    	],
    	[
    		[
    			1173,
    			1173
    		],
    		"valid"
    	],
    	[
    		[
    			1174,
    			1174
    		],
    		"mapped",
    		[
    			1175
    		]
    	],
    	[
    		[
    			1175,
    			1175
    		],
    		"valid"
    	],
    	[
    		[
    			1176,
    			1176
    		],
    		"mapped",
    		[
    			1177
    		]
    	],
    	[
    		[
    			1177,
    			1177
    		],
    		"valid"
    	],
    	[
    		[
    			1178,
    			1178
    		],
    		"mapped",
    		[
    			1179
    		]
    	],
    	[
    		[
    			1179,
    			1179
    		],
    		"valid"
    	],
    	[
    		[
    			1180,
    			1180
    		],
    		"mapped",
    		[
    			1181
    		]
    	],
    	[
    		[
    			1181,
    			1181
    		],
    		"valid"
    	],
    	[
    		[
    			1182,
    			1182
    		],
    		"mapped",
    		[
    			1183
    		]
    	],
    	[
    		[
    			1183,
    			1183
    		],
    		"valid"
    	],
    	[
    		[
    			1184,
    			1184
    		],
    		"mapped",
    		[
    			1185
    		]
    	],
    	[
    		[
    			1185,
    			1185
    		],
    		"valid"
    	],
    	[
    		[
    			1186,
    			1186
    		],
    		"mapped",
    		[
    			1187
    		]
    	],
    	[
    		[
    			1187,
    			1187
    		],
    		"valid"
    	],
    	[
    		[
    			1188,
    			1188
    		],
    		"mapped",
    		[
    			1189
    		]
    	],
    	[
    		[
    			1189,
    			1189
    		],
    		"valid"
    	],
    	[
    		[
    			1190,
    			1190
    		],
    		"mapped",
    		[
    			1191
    		]
    	],
    	[
    		[
    			1191,
    			1191
    		],
    		"valid"
    	],
    	[
    		[
    			1192,
    			1192
    		],
    		"mapped",
    		[
    			1193
    		]
    	],
    	[
    		[
    			1193,
    			1193
    		],
    		"valid"
    	],
    	[
    		[
    			1194,
    			1194
    		],
    		"mapped",
    		[
    			1195
    		]
    	],
    	[
    		[
    			1195,
    			1195
    		],
    		"valid"
    	],
    	[
    		[
    			1196,
    			1196
    		],
    		"mapped",
    		[
    			1197
    		]
    	],
    	[
    		[
    			1197,
    			1197
    		],
    		"valid"
    	],
    	[
    		[
    			1198,
    			1198
    		],
    		"mapped",
    		[
    			1199
    		]
    	],
    	[
    		[
    			1199,
    			1199
    		],
    		"valid"
    	],
    	[
    		[
    			1200,
    			1200
    		],
    		"mapped",
    		[
    			1201
    		]
    	],
    	[
    		[
    			1201,
    			1201
    		],
    		"valid"
    	],
    	[
    		[
    			1202,
    			1202
    		],
    		"mapped",
    		[
    			1203
    		]
    	],
    	[
    		[
    			1203,
    			1203
    		],
    		"valid"
    	],
    	[
    		[
    			1204,
    			1204
    		],
    		"mapped",
    		[
    			1205
    		]
    	],
    	[
    		[
    			1205,
    			1205
    		],
    		"valid"
    	],
    	[
    		[
    			1206,
    			1206
    		],
    		"mapped",
    		[
    			1207
    		]
    	],
    	[
    		[
    			1207,
    			1207
    		],
    		"valid"
    	],
    	[
    		[
    			1208,
    			1208
    		],
    		"mapped",
    		[
    			1209
    		]
    	],
    	[
    		[
    			1209,
    			1209
    		],
    		"valid"
    	],
    	[
    		[
    			1210,
    			1210
    		],
    		"mapped",
    		[
    			1211
    		]
    	],
    	[
    		[
    			1211,
    			1211
    		],
    		"valid"
    	],
    	[
    		[
    			1212,
    			1212
    		],
    		"mapped",
    		[
    			1213
    		]
    	],
    	[
    		[
    			1213,
    			1213
    		],
    		"valid"
    	],
    	[
    		[
    			1214,
    			1214
    		],
    		"mapped",
    		[
    			1215
    		]
    	],
    	[
    		[
    			1215,
    			1215
    		],
    		"valid"
    	],
    	[
    		[
    			1216,
    			1216
    		],
    		"disallowed"
    	],
    	[
    		[
    			1217,
    			1217
    		],
    		"mapped",
    		[
    			1218
    		]
    	],
    	[
    		[
    			1218,
    			1218
    		],
    		"valid"
    	],
    	[
    		[
    			1219,
    			1219
    		],
    		"mapped",
    		[
    			1220
    		]
    	],
    	[
    		[
    			1220,
    			1220
    		],
    		"valid"
    	],
    	[
    		[
    			1221,
    			1221
    		],
    		"mapped",
    		[
    			1222
    		]
    	],
    	[
    		[
    			1222,
    			1222
    		],
    		"valid"
    	],
    	[
    		[
    			1223,
    			1223
    		],
    		"mapped",
    		[
    			1224
    		]
    	],
    	[
    		[
    			1224,
    			1224
    		],
    		"valid"
    	],
    	[
    		[
    			1225,
    			1225
    		],
    		"mapped",
    		[
    			1226
    		]
    	],
    	[
    		[
    			1226,
    			1226
    		],
    		"valid"
    	],
    	[
    		[
    			1227,
    			1227
    		],
    		"mapped",
    		[
    			1228
    		]
    	],
    	[
    		[
    			1228,
    			1228
    		],
    		"valid"
    	],
    	[
    		[
    			1229,
    			1229
    		],
    		"mapped",
    		[
    			1230
    		]
    	],
    	[
    		[
    			1230,
    			1230
    		],
    		"valid"
    	],
    	[
    		[
    			1231,
    			1231
    		],
    		"valid"
    	],
    	[
    		[
    			1232,
    			1232
    		],
    		"mapped",
    		[
    			1233
    		]
    	],
    	[
    		[
    			1233,
    			1233
    		],
    		"valid"
    	],
    	[
    		[
    			1234,
    			1234
    		],
    		"mapped",
    		[
    			1235
    		]
    	],
    	[
    		[
    			1235,
    			1235
    		],
    		"valid"
    	],
    	[
    		[
    			1236,
    			1236
    		],
    		"mapped",
    		[
    			1237
    		]
    	],
    	[
    		[
    			1237,
    			1237
    		],
    		"valid"
    	],
    	[
    		[
    			1238,
    			1238
    		],
    		"mapped",
    		[
    			1239
    		]
    	],
    	[
    		[
    			1239,
    			1239
    		],
    		"valid"
    	],
    	[
    		[
    			1240,
    			1240
    		],
    		"mapped",
    		[
    			1241
    		]
    	],
    	[
    		[
    			1241,
    			1241
    		],
    		"valid"
    	],
    	[
    		[
    			1242,
    			1242
    		],
    		"mapped",
    		[
    			1243
    		]
    	],
    	[
    		[
    			1243,
    			1243
    		],
    		"valid"
    	],
    	[
    		[
    			1244,
    			1244
    		],
    		"mapped",
    		[
    			1245
    		]
    	],
    	[
    		[
    			1245,
    			1245
    		],
    		"valid"
    	],
    	[
    		[
    			1246,
    			1246
    		],
    		"mapped",
    		[
    			1247
    		]
    	],
    	[
    		[
    			1247,
    			1247
    		],
    		"valid"
    	],
    	[
    		[
    			1248,
    			1248
    		],
    		"mapped",
    		[
    			1249
    		]
    	],
    	[
    		[
    			1249,
    			1249
    		],
    		"valid"
    	],
    	[
    		[
    			1250,
    			1250
    		],
    		"mapped",
    		[
    			1251
    		]
    	],
    	[
    		[
    			1251,
    			1251
    		],
    		"valid"
    	],
    	[
    		[
    			1252,
    			1252
    		],
    		"mapped",
    		[
    			1253
    		]
    	],
    	[
    		[
    			1253,
    			1253
    		],
    		"valid"
    	],
    	[
    		[
    			1254,
    			1254
    		],
    		"mapped",
    		[
    			1255
    		]
    	],
    	[
    		[
    			1255,
    			1255
    		],
    		"valid"
    	],
    	[
    		[
    			1256,
    			1256
    		],
    		"mapped",
    		[
    			1257
    		]
    	],
    	[
    		[
    			1257,
    			1257
    		],
    		"valid"
    	],
    	[
    		[
    			1258,
    			1258
    		],
    		"mapped",
    		[
    			1259
    		]
    	],
    	[
    		[
    			1259,
    			1259
    		],
    		"valid"
    	],
    	[
    		[
    			1260,
    			1260
    		],
    		"mapped",
    		[
    			1261
    		]
    	],
    	[
    		[
    			1261,
    			1261
    		],
    		"valid"
    	],
    	[
    		[
    			1262,
    			1262
    		],
    		"mapped",
    		[
    			1263
    		]
    	],
    	[
    		[
    			1263,
    			1263
    		],
    		"valid"
    	],
    	[
    		[
    			1264,
    			1264
    		],
    		"mapped",
    		[
    			1265
    		]
    	],
    	[
    		[
    			1265,
    			1265
    		],
    		"valid"
    	],
    	[
    		[
    			1266,
    			1266
    		],
    		"mapped",
    		[
    			1267
    		]
    	],
    	[
    		[
    			1267,
    			1267
    		],
    		"valid"
    	],
    	[
    		[
    			1268,
    			1268
    		],
    		"mapped",
    		[
    			1269
    		]
    	],
    	[
    		[
    			1269,
    			1269
    		],
    		"valid"
    	],
    	[
    		[
    			1270,
    			1270
    		],
    		"mapped",
    		[
    			1271
    		]
    	],
    	[
    		[
    			1271,
    			1271
    		],
    		"valid"
    	],
    	[
    		[
    			1272,
    			1272
    		],
    		"mapped",
    		[
    			1273
    		]
    	],
    	[
    		[
    			1273,
    			1273
    		],
    		"valid"
    	],
    	[
    		[
    			1274,
    			1274
    		],
    		"mapped",
    		[
    			1275
    		]
    	],
    	[
    		[
    			1275,
    			1275
    		],
    		"valid"
    	],
    	[
    		[
    			1276,
    			1276
    		],
    		"mapped",
    		[
    			1277
    		]
    	],
    	[
    		[
    			1277,
    			1277
    		],
    		"valid"
    	],
    	[
    		[
    			1278,
    			1278
    		],
    		"mapped",
    		[
    			1279
    		]
    	],
    	[
    		[
    			1279,
    			1279
    		],
    		"valid"
    	],
    	[
    		[
    			1280,
    			1280
    		],
    		"mapped",
    		[
    			1281
    		]
    	],
    	[
    		[
    			1281,
    			1281
    		],
    		"valid"
    	],
    	[
    		[
    			1282,
    			1282
    		],
    		"mapped",
    		[
    			1283
    		]
    	],
    	[
    		[
    			1283,
    			1283
    		],
    		"valid"
    	],
    	[
    		[
    			1284,
    			1284
    		],
    		"mapped",
    		[
    			1285
    		]
    	],
    	[
    		[
    			1285,
    			1285
    		],
    		"valid"
    	],
    	[
    		[
    			1286,
    			1286
    		],
    		"mapped",
    		[
    			1287
    		]
    	],
    	[
    		[
    			1287,
    			1287
    		],
    		"valid"
    	],
    	[
    		[
    			1288,
    			1288
    		],
    		"mapped",
    		[
    			1289
    		]
    	],
    	[
    		[
    			1289,
    			1289
    		],
    		"valid"
    	],
    	[
    		[
    			1290,
    			1290
    		],
    		"mapped",
    		[
    			1291
    		]
    	],
    	[
    		[
    			1291,
    			1291
    		],
    		"valid"
    	],
    	[
    		[
    			1292,
    			1292
    		],
    		"mapped",
    		[
    			1293
    		]
    	],
    	[
    		[
    			1293,
    			1293
    		],
    		"valid"
    	],
    	[
    		[
    			1294,
    			1294
    		],
    		"mapped",
    		[
    			1295
    		]
    	],
    	[
    		[
    			1295,
    			1295
    		],
    		"valid"
    	],
    	[
    		[
    			1296,
    			1296
    		],
    		"mapped",
    		[
    			1297
    		]
    	],
    	[
    		[
    			1297,
    			1297
    		],
    		"valid"
    	],
    	[
    		[
    			1298,
    			1298
    		],
    		"mapped",
    		[
    			1299
    		]
    	],
    	[
    		[
    			1299,
    			1299
    		],
    		"valid"
    	],
    	[
    		[
    			1300,
    			1300
    		],
    		"mapped",
    		[
    			1301
    		]
    	],
    	[
    		[
    			1301,
    			1301
    		],
    		"valid"
    	],
    	[
    		[
    			1302,
    			1302
    		],
    		"mapped",
    		[
    			1303
    		]
    	],
    	[
    		[
    			1303,
    			1303
    		],
    		"valid"
    	],
    	[
    		[
    			1304,
    			1304
    		],
    		"mapped",
    		[
    			1305
    		]
    	],
    	[
    		[
    			1305,
    			1305
    		],
    		"valid"
    	],
    	[
    		[
    			1306,
    			1306
    		],
    		"mapped",
    		[
    			1307
    		]
    	],
    	[
    		[
    			1307,
    			1307
    		],
    		"valid"
    	],
    	[
    		[
    			1308,
    			1308
    		],
    		"mapped",
    		[
    			1309
    		]
    	],
    	[
    		[
    			1309,
    			1309
    		],
    		"valid"
    	],
    	[
    		[
    			1310,
    			1310
    		],
    		"mapped",
    		[
    			1311
    		]
    	],
    	[
    		[
    			1311,
    			1311
    		],
    		"valid"
    	],
    	[
    		[
    			1312,
    			1312
    		],
    		"mapped",
    		[
    			1313
    		]
    	],
    	[
    		[
    			1313,
    			1313
    		],
    		"valid"
    	],
    	[
    		[
    			1314,
    			1314
    		],
    		"mapped",
    		[
    			1315
    		]
    	],
    	[
    		[
    			1315,
    			1315
    		],
    		"valid"
    	],
    	[
    		[
    			1316,
    			1316
    		],
    		"mapped",
    		[
    			1317
    		]
    	],
    	[
    		[
    			1317,
    			1317
    		],
    		"valid"
    	],
    	[
    		[
    			1318,
    			1318
    		],
    		"mapped",
    		[
    			1319
    		]
    	],
    	[
    		[
    			1319,
    			1319
    		],
    		"valid"
    	],
    	[
    		[
    			1320,
    			1320
    		],
    		"mapped",
    		[
    			1321
    		]
    	],
    	[
    		[
    			1321,
    			1321
    		],
    		"valid"
    	],
    	[
    		[
    			1322,
    			1322
    		],
    		"mapped",
    		[
    			1323
    		]
    	],
    	[
    		[
    			1323,
    			1323
    		],
    		"valid"
    	],
    	[
    		[
    			1324,
    			1324
    		],
    		"mapped",
    		[
    			1325
    		]
    	],
    	[
    		[
    			1325,
    			1325
    		],
    		"valid"
    	],
    	[
    		[
    			1326,
    			1326
    		],
    		"mapped",
    		[
    			1327
    		]
    	],
    	[
    		[
    			1327,
    			1327
    		],
    		"valid"
    	],
    	[
    		[
    			1328,
    			1328
    		],
    		"disallowed"
    	],
    	[
    		[
    			1329,
    			1329
    		],
    		"mapped",
    		[
    			1377
    		]
    	],
    	[
    		[
    			1330,
    			1330
    		],
    		"mapped",
    		[
    			1378
    		]
    	],
    	[
    		[
    			1331,
    			1331
    		],
    		"mapped",
    		[
    			1379
    		]
    	],
    	[
    		[
    			1332,
    			1332
    		],
    		"mapped",
    		[
    			1380
    		]
    	],
    	[
    		[
    			1333,
    			1333
    		],
    		"mapped",
    		[
    			1381
    		]
    	],
    	[
    		[
    			1334,
    			1334
    		],
    		"mapped",
    		[
    			1382
    		]
    	],
    	[
    		[
    			1335,
    			1335
    		],
    		"mapped",
    		[
    			1383
    		]
    	],
    	[
    		[
    			1336,
    			1336
    		],
    		"mapped",
    		[
    			1384
    		]
    	],
    	[
    		[
    			1337,
    			1337
    		],
    		"mapped",
    		[
    			1385
    		]
    	],
    	[
    		[
    			1338,
    			1338
    		],
    		"mapped",
    		[
    			1386
    		]
    	],
    	[
    		[
    			1339,
    			1339
    		],
    		"mapped",
    		[
    			1387
    		]
    	],
    	[
    		[
    			1340,
    			1340
    		],
    		"mapped",
    		[
    			1388
    		]
    	],
    	[
    		[
    			1341,
    			1341
    		],
    		"mapped",
    		[
    			1389
    		]
    	],
    	[
    		[
    			1342,
    			1342
    		],
    		"mapped",
    		[
    			1390
    		]
    	],
    	[
    		[
    			1343,
    			1343
    		],
    		"mapped",
    		[
    			1391
    		]
    	],
    	[
    		[
    			1344,
    			1344
    		],
    		"mapped",
    		[
    			1392
    		]
    	],
    	[
    		[
    			1345,
    			1345
    		],
    		"mapped",
    		[
    			1393
    		]
    	],
    	[
    		[
    			1346,
    			1346
    		],
    		"mapped",
    		[
    			1394
    		]
    	],
    	[
    		[
    			1347,
    			1347
    		],
    		"mapped",
    		[
    			1395
    		]
    	],
    	[
    		[
    			1348,
    			1348
    		],
    		"mapped",
    		[
    			1396
    		]
    	],
    	[
    		[
    			1349,
    			1349
    		],
    		"mapped",
    		[
    			1397
    		]
    	],
    	[
    		[
    			1350,
    			1350
    		],
    		"mapped",
    		[
    			1398
    		]
    	],
    	[
    		[
    			1351,
    			1351
    		],
    		"mapped",
    		[
    			1399
    		]
    	],
    	[
    		[
    			1352,
    			1352
    		],
    		"mapped",
    		[
    			1400
    		]
    	],
    	[
    		[
    			1353,
    			1353
    		],
    		"mapped",
    		[
    			1401
    		]
    	],
    	[
    		[
    			1354,
    			1354
    		],
    		"mapped",
    		[
    			1402
    		]
    	],
    	[
    		[
    			1355,
    			1355
    		],
    		"mapped",
    		[
    			1403
    		]
    	],
    	[
    		[
    			1356,
    			1356
    		],
    		"mapped",
    		[
    			1404
    		]
    	],
    	[
    		[
    			1357,
    			1357
    		],
    		"mapped",
    		[
    			1405
    		]
    	],
    	[
    		[
    			1358,
    			1358
    		],
    		"mapped",
    		[
    			1406
    		]
    	],
    	[
    		[
    			1359,
    			1359
    		],
    		"mapped",
    		[
    			1407
    		]
    	],
    	[
    		[
    			1360,
    			1360
    		],
    		"mapped",
    		[
    			1408
    		]
    	],
    	[
    		[
    			1361,
    			1361
    		],
    		"mapped",
    		[
    			1409
    		]
    	],
    	[
    		[
    			1362,
    			1362
    		],
    		"mapped",
    		[
    			1410
    		]
    	],
    	[
    		[
    			1363,
    			1363
    		],
    		"mapped",
    		[
    			1411
    		]
    	],
    	[
    		[
    			1364,
    			1364
    		],
    		"mapped",
    		[
    			1412
    		]
    	],
    	[
    		[
    			1365,
    			1365
    		],
    		"mapped",
    		[
    			1413
    		]
    	],
    	[
    		[
    			1366,
    			1366
    		],
    		"mapped",
    		[
    			1414
    		]
    	],
    	[
    		[
    			1367,
    			1368
    		],
    		"disallowed"
    	],
    	[
    		[
    			1369,
    			1369
    		],
    		"valid"
    	],
    	[
    		[
    			1370,
    			1375
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1376,
    			1376
    		],
    		"disallowed"
    	],
    	[
    		[
    			1377,
    			1414
    		],
    		"valid"
    	],
    	[
    		[
    			1415,
    			1415
    		],
    		"mapped",
    		[
    			1381,
    			1410
    		]
    	],
    	[
    		[
    			1416,
    			1416
    		],
    		"disallowed"
    	],
    	[
    		[
    			1417,
    			1417
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1418,
    			1418
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1419,
    			1420
    		],
    		"disallowed"
    	],
    	[
    		[
    			1421,
    			1422
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1423,
    			1423
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1424,
    			1424
    		],
    		"disallowed"
    	],
    	[
    		[
    			1425,
    			1441
    		],
    		"valid"
    	],
    	[
    		[
    			1442,
    			1442
    		],
    		"valid"
    	],
    	[
    		[
    			1443,
    			1455
    		],
    		"valid"
    	],
    	[
    		[
    			1456,
    			1465
    		],
    		"valid"
    	],
    	[
    		[
    			1466,
    			1466
    		],
    		"valid"
    	],
    	[
    		[
    			1467,
    			1469
    		],
    		"valid"
    	],
    	[
    		[
    			1470,
    			1470
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1471,
    			1471
    		],
    		"valid"
    	],
    	[
    		[
    			1472,
    			1472
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1473,
    			1474
    		],
    		"valid"
    	],
    	[
    		[
    			1475,
    			1475
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1476,
    			1476
    		],
    		"valid"
    	],
    	[
    		[
    			1477,
    			1477
    		],
    		"valid"
    	],
    	[
    		[
    			1478,
    			1478
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1479,
    			1479
    		],
    		"valid"
    	],
    	[
    		[
    			1480,
    			1487
    		],
    		"disallowed"
    	],
    	[
    		[
    			1488,
    			1514
    		],
    		"valid"
    	],
    	[
    		[
    			1515,
    			1519
    		],
    		"disallowed"
    	],
    	[
    		[
    			1520,
    			1524
    		],
    		"valid"
    	],
    	[
    		[
    			1525,
    			1535
    		],
    		"disallowed"
    	],
    	[
    		[
    			1536,
    			1539
    		],
    		"disallowed"
    	],
    	[
    		[
    			1540,
    			1540
    		],
    		"disallowed"
    	],
    	[
    		[
    			1541,
    			1541
    		],
    		"disallowed"
    	],
    	[
    		[
    			1542,
    			1546
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1547,
    			1547
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1548,
    			1548
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1549,
    			1551
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1552,
    			1557
    		],
    		"valid"
    	],
    	[
    		[
    			1558,
    			1562
    		],
    		"valid"
    	],
    	[
    		[
    			1563,
    			1563
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1564,
    			1564
    		],
    		"disallowed"
    	],
    	[
    		[
    			1565,
    			1565
    		],
    		"disallowed"
    	],
    	[
    		[
    			1566,
    			1566
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1567,
    			1567
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1568,
    			1568
    		],
    		"valid"
    	],
    	[
    		[
    			1569,
    			1594
    		],
    		"valid"
    	],
    	[
    		[
    			1595,
    			1599
    		],
    		"valid"
    	],
    	[
    		[
    			1600,
    			1600
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1601,
    			1618
    		],
    		"valid"
    	],
    	[
    		[
    			1619,
    			1621
    		],
    		"valid"
    	],
    	[
    		[
    			1622,
    			1624
    		],
    		"valid"
    	],
    	[
    		[
    			1625,
    			1630
    		],
    		"valid"
    	],
    	[
    		[
    			1631,
    			1631
    		],
    		"valid"
    	],
    	[
    		[
    			1632,
    			1641
    		],
    		"valid"
    	],
    	[
    		[
    			1642,
    			1645
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1646,
    			1647
    		],
    		"valid"
    	],
    	[
    		[
    			1648,
    			1652
    		],
    		"valid"
    	],
    	[
    		[
    			1653,
    			1653
    		],
    		"mapped",
    		[
    			1575,
    			1652
    		]
    	],
    	[
    		[
    			1654,
    			1654
    		],
    		"mapped",
    		[
    			1608,
    			1652
    		]
    	],
    	[
    		[
    			1655,
    			1655
    		],
    		"mapped",
    		[
    			1735,
    			1652
    		]
    	],
    	[
    		[
    			1656,
    			1656
    		],
    		"mapped",
    		[
    			1610,
    			1652
    		]
    	],
    	[
    		[
    			1657,
    			1719
    		],
    		"valid"
    	],
    	[
    		[
    			1720,
    			1721
    		],
    		"valid"
    	],
    	[
    		[
    			1722,
    			1726
    		],
    		"valid"
    	],
    	[
    		[
    			1727,
    			1727
    		],
    		"valid"
    	],
    	[
    		[
    			1728,
    			1742
    		],
    		"valid"
    	],
    	[
    		[
    			1743,
    			1743
    		],
    		"valid"
    	],
    	[
    		[
    			1744,
    			1747
    		],
    		"valid"
    	],
    	[
    		[
    			1748,
    			1748
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1749,
    			1756
    		],
    		"valid"
    	],
    	[
    		[
    			1757,
    			1757
    		],
    		"disallowed"
    	],
    	[
    		[
    			1758,
    			1758
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1759,
    			1768
    		],
    		"valid"
    	],
    	[
    		[
    			1769,
    			1769
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1770,
    			1773
    		],
    		"valid"
    	],
    	[
    		[
    			1774,
    			1775
    		],
    		"valid"
    	],
    	[
    		[
    			1776,
    			1785
    		],
    		"valid"
    	],
    	[
    		[
    			1786,
    			1790
    		],
    		"valid"
    	],
    	[
    		[
    			1791,
    			1791
    		],
    		"valid"
    	],
    	[
    		[
    			1792,
    			1805
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			1806,
    			1806
    		],
    		"disallowed"
    	],
    	[
    		[
    			1807,
    			1807
    		],
    		"disallowed"
    	],
    	[
    		[
    			1808,
    			1836
    		],
    		"valid"
    	],
    	[
    		[
    			1837,
    			1839
    		],
    		"valid"
    	],
    	[
    		[
    			1840,
    			1866
    		],
    		"valid"
    	],
    	[
    		[
    			1867,
    			1868
    		],
    		"disallowed"
    	],
    	[
    		[
    			1869,
    			1871
    		],
    		"valid"
    	],
    	[
    		[
    			1872,
    			1901
    		],
    		"valid"
    	],
    	[
    		[
    			1902,
    			1919
    		],
    		"valid"
    	],
    	[
    		[
    			1920,
    			1968
    		],
    		"valid"
    	],
    	[
    		[
    			1969,
    			1969
    		],
    		"valid"
    	],
    	[
    		[
    			1970,
    			1983
    		],
    		"disallowed"
    	],
    	[
    		[
    			1984,
    			2037
    		],
    		"valid"
    	],
    	[
    		[
    			2038,
    			2042
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			2043,
    			2047
    		],
    		"disallowed"
    	],
    	[
    		[
    			2048,
    			2093
    		],
    		"valid"
    	],
    	[
    		[
    			2094,
    			2095
    		],
    		"disallowed"
    	],
    	[
    		[
    			2096,
    			2110
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			2111,
    			2111
    		],
    		"disallowed"
    	],
    	[
    		[
    			2112,
    			2139
    		],
    		"valid"
    	],
    	[
    		[
    			2140,
    			2141
    		],
    		"disallowed"
    	],
    	[
    		[
    			2142,
    			2142
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			2143,
    			2207
    		],
    		"disallowed"
    	],
    	[
    		[
    			2208,
    			2208
    		],
    		"valid"
    	],
    	[
    		[
    			2209,
    			2209
    		],
    		"valid"
    	],
    	[
    		[
    			2210,
    			2220
    		],
    		"valid"
    	],
    	[
    		[
    			2221,
    			2226
    		],
    		"valid"
    	],
    	[
    		[
    			2227,
    			2228
    		],
    		"valid"
    	],
    	[
    		[
    			2229,
    			2274
    		],
    		"disallowed"
    	],
    	[
    		[
    			2275,
    			2275
    		],
    		"valid"
    	],
    	[
    		[
    			2276,
    			2302
    		],
    		"valid"
    	],
    	[
    		[
    			2303,
    			2303
    		],
    		"valid"
    	],
    	[
    		[
    			2304,
    			2304
    		],
    		"valid"
    	],
    	[
    		[
    			2305,
    			2307
    		],
    		"valid"
    	],
    	[
    		[
    			2308,
    			2308
    		],
    		"valid"
    	],
    	[
    		[
    			2309,
    			2361
    		],
    		"valid"
    	],
    	[
    		[
    			2362,
    			2363
    		],
    		"valid"
    	],
    	[
    		[
    			2364,
    			2381
    		],
    		"valid"
    	],
    	[
    		[
    			2382,
    			2382
    		],
    		"valid"
    	],
    	[
    		[
    			2383,
    			2383
    		],
    		"valid"
    	],
    	[
    		[
    			2384,
    			2388
    		],
    		"valid"
    	],
    	[
    		[
    			2389,
    			2389
    		],
    		"valid"
    	],
    	[
    		[
    			2390,
    			2391
    		],
    		"valid"
    	],
    	[
    		[
    			2392,
    			2392
    		],
    		"mapped",
    		[
    			2325,
    			2364
    		]
    	],
    	[
    		[
    			2393,
    			2393
    		],
    		"mapped",
    		[
    			2326,
    			2364
    		]
    	],
    	[
    		[
    			2394,
    			2394
    		],
    		"mapped",
    		[
    			2327,
    			2364
    		]
    	],
    	[
    		[
    			2395,
    			2395
    		],
    		"mapped",
    		[
    			2332,
    			2364
    		]
    	],
    	[
    		[
    			2396,
    			2396
    		],
    		"mapped",
    		[
    			2337,
    			2364
    		]
    	],
    	[
    		[
    			2397,
    			2397
    		],
    		"mapped",
    		[
    			2338,
    			2364
    		]
    	],
    	[
    		[
    			2398,
    			2398
    		],
    		"mapped",
    		[
    			2347,
    			2364
    		]
    	],
    	[
    		[
    			2399,
    			2399
    		],
    		"mapped",
    		[
    			2351,
    			2364
    		]
    	],
    	[
    		[
    			2400,
    			2403
    		],
    		"valid"
    	],
    	[
    		[
    			2404,
    			2405
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			2406,
    			2415
    		],
    		"valid"
    	],
    	[
    		[
    			2416,
    			2416
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			2417,
    			2418
    		],
    		"valid"
    	],
    	[
    		[
    			2419,
    			2423
    		],
    		"valid"
    	],
    	[
    		[
    			2424,
    			2424
    		],
    		"valid"
    	],
    	[
    		[
    			2425,
    			2426
    		],
    		"valid"
    	],
    	[
    		[
    			2427,
    			2428
    		],
    		"valid"
    	],
    	[
    		[
    			2429,
    			2429
    		],
    		"valid"
    	],
    	[
    		[
    			2430,
    			2431
    		],
    		"valid"
    	],
    	[
    		[
    			2432,
    			2432
    		],
    		"valid"
    	],
    	[
    		[
    			2433,
    			2435
    		],
    		"valid"
    	],
    	[
    		[
    			2436,
    			2436
    		],
    		"disallowed"
    	],
    	[
    		[
    			2437,
    			2444
    		],
    		"valid"
    	],
    	[
    		[
    			2445,
    			2446
    		],
    		"disallowed"
    	],
    	[
    		[
    			2447,
    			2448
    		],
    		"valid"
    	],
    	[
    		[
    			2449,
    			2450
    		],
    		"disallowed"
    	],
    	[
    		[
    			2451,
    			2472
    		],
    		"valid"
    	],
    	[
    		[
    			2473,
    			2473
    		],
    		"disallowed"
    	],
    	[
    		[
    			2474,
    			2480
    		],
    		"valid"
    	],
    	[
    		[
    			2481,
    			2481
    		],
    		"disallowed"
    	],
    	[
    		[
    			2482,
    			2482
    		],
    		"valid"
    	],
    	[
    		[
    			2483,
    			2485
    		],
    		"disallowed"
    	],
    	[
    		[
    			2486,
    			2489
    		],
    		"valid"
    	],
    	[
    		[
    			2490,
    			2491
    		],
    		"disallowed"
    	],
    	[
    		[
    			2492,
    			2492
    		],
    		"valid"
    	],
    	[
    		[
    			2493,
    			2493
    		],
    		"valid"
    	],
    	[
    		[
    			2494,
    			2500
    		],
    		"valid"
    	],
    	[
    		[
    			2501,
    			2502
    		],
    		"disallowed"
    	],
    	[
    		[
    			2503,
    			2504
    		],
    		"valid"
    	],
    	[
    		[
    			2505,
    			2506
    		],
    		"disallowed"
    	],
    	[
    		[
    			2507,
    			2509
    		],
    		"valid"
    	],
    	[
    		[
    			2510,
    			2510
    		],
    		"valid"
    	],
    	[
    		[
    			2511,
    			2518
    		],
    		"disallowed"
    	],
    	[
    		[
    			2519,
    			2519
    		],
    		"valid"
    	],
    	[
    		[
    			2520,
    			2523
    		],
    		"disallowed"
    	],
    	[
    		[
    			2524,
    			2524
    		],
    		"mapped",
    		[
    			2465,
    			2492
    		]
    	],
    	[
    		[
    			2525,
    			2525
    		],
    		"mapped",
    		[
    			2466,
    			2492
    		]
    	],
    	[
    		[
    			2526,
    			2526
    		],
    		"disallowed"
    	],
    	[
    		[
    			2527,
    			2527
    		],
    		"mapped",
    		[
    			2479,
    			2492
    		]
    	],
    	[
    		[
    			2528,
    			2531
    		],
    		"valid"
    	],
    	[
    		[
    			2532,
    			2533
    		],
    		"disallowed"
    	],
    	[
    		[
    			2534,
    			2545
    		],
    		"valid"
    	],
    	[
    		[
    			2546,
    			2554
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			2555,
    			2555
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			2556,
    			2560
    		],
    		"disallowed"
    	],
    	[
    		[
    			2561,
    			2561
    		],
    		"valid"
    	],
    	[
    		[
    			2562,
    			2562
    		],
    		"valid"
    	],
    	[
    		[
    			2563,
    			2563
    		],
    		"valid"
    	],
    	[
    		[
    			2564,
    			2564
    		],
    		"disallowed"
    	],
    	[
    		[
    			2565,
    			2570
    		],
    		"valid"
    	],
    	[
    		[
    			2571,
    			2574
    		],
    		"disallowed"
    	],
    	[
    		[
    			2575,
    			2576
    		],
    		"valid"
    	],
    	[
    		[
    			2577,
    			2578
    		],
    		"disallowed"
    	],
    	[
    		[
    			2579,
    			2600
    		],
    		"valid"
    	],
    	[
    		[
    			2601,
    			2601
    		],
    		"disallowed"
    	],
    	[
    		[
    			2602,
    			2608
    		],
    		"valid"
    	],
    	[
    		[
    			2609,
    			2609
    		],
    		"disallowed"
    	],
    	[
    		[
    			2610,
    			2610
    		],
    		"valid"
    	],
    	[
    		[
    			2611,
    			2611
    		],
    		"mapped",
    		[
    			2610,
    			2620
    		]
    	],
    	[
    		[
    			2612,
    			2612
    		],
    		"disallowed"
    	],
    	[
    		[
    			2613,
    			2613
    		],
    		"valid"
    	],
    	[
    		[
    			2614,
    			2614
    		],
    		"mapped",
    		[
    			2616,
    			2620
    		]
    	],
    	[
    		[
    			2615,
    			2615
    		],
    		"disallowed"
    	],
    	[
    		[
    			2616,
    			2617
    		],
    		"valid"
    	],
    	[
    		[
    			2618,
    			2619
    		],
    		"disallowed"
    	],
    	[
    		[
    			2620,
    			2620
    		],
    		"valid"
    	],
    	[
    		[
    			2621,
    			2621
    		],
    		"disallowed"
    	],
    	[
    		[
    			2622,
    			2626
    		],
    		"valid"
    	],
    	[
    		[
    			2627,
    			2630
    		],
    		"disallowed"
    	],
    	[
    		[
    			2631,
    			2632
    		],
    		"valid"
    	],
    	[
    		[
    			2633,
    			2634
    		],
    		"disallowed"
    	],
    	[
    		[
    			2635,
    			2637
    		],
    		"valid"
    	],
    	[
    		[
    			2638,
    			2640
    		],
    		"disallowed"
    	],
    	[
    		[
    			2641,
    			2641
    		],
    		"valid"
    	],
    	[
    		[
    			2642,
    			2648
    		],
    		"disallowed"
    	],
    	[
    		[
    			2649,
    			2649
    		],
    		"mapped",
    		[
    			2582,
    			2620
    		]
    	],
    	[
    		[
    			2650,
    			2650
    		],
    		"mapped",
    		[
    			2583,
    			2620
    		]
    	],
    	[
    		[
    			2651,
    			2651
    		],
    		"mapped",
    		[
    			2588,
    			2620
    		]
    	],
    	[
    		[
    			2652,
    			2652
    		],
    		"valid"
    	],
    	[
    		[
    			2653,
    			2653
    		],
    		"disallowed"
    	],
    	[
    		[
    			2654,
    			2654
    		],
    		"mapped",
    		[
    			2603,
    			2620
    		]
    	],
    	[
    		[
    			2655,
    			2661
    		],
    		"disallowed"
    	],
    	[
    		[
    			2662,
    			2676
    		],
    		"valid"
    	],
    	[
    		[
    			2677,
    			2677
    		],
    		"valid"
    	],
    	[
    		[
    			2678,
    			2688
    		],
    		"disallowed"
    	],
    	[
    		[
    			2689,
    			2691
    		],
    		"valid"
    	],
    	[
    		[
    			2692,
    			2692
    		],
    		"disallowed"
    	],
    	[
    		[
    			2693,
    			2699
    		],
    		"valid"
    	],
    	[
    		[
    			2700,
    			2700
    		],
    		"valid"
    	],
    	[
    		[
    			2701,
    			2701
    		],
    		"valid"
    	],
    	[
    		[
    			2702,
    			2702
    		],
    		"disallowed"
    	],
    	[
    		[
    			2703,
    			2705
    		],
    		"valid"
    	],
    	[
    		[
    			2706,
    			2706
    		],
    		"disallowed"
    	],
    	[
    		[
    			2707,
    			2728
    		],
    		"valid"
    	],
    	[
    		[
    			2729,
    			2729
    		],
    		"disallowed"
    	],
    	[
    		[
    			2730,
    			2736
    		],
    		"valid"
    	],
    	[
    		[
    			2737,
    			2737
    		],
    		"disallowed"
    	],
    	[
    		[
    			2738,
    			2739
    		],
    		"valid"
    	],
    	[
    		[
    			2740,
    			2740
    		],
    		"disallowed"
    	],
    	[
    		[
    			2741,
    			2745
    		],
    		"valid"
    	],
    	[
    		[
    			2746,
    			2747
    		],
    		"disallowed"
    	],
    	[
    		[
    			2748,
    			2757
    		],
    		"valid"
    	],
    	[
    		[
    			2758,
    			2758
    		],
    		"disallowed"
    	],
    	[
    		[
    			2759,
    			2761
    		],
    		"valid"
    	],
    	[
    		[
    			2762,
    			2762
    		],
    		"disallowed"
    	],
    	[
    		[
    			2763,
    			2765
    		],
    		"valid"
    	],
    	[
    		[
    			2766,
    			2767
    		],
    		"disallowed"
    	],
    	[
    		[
    			2768,
    			2768
    		],
    		"valid"
    	],
    	[
    		[
    			2769,
    			2783
    		],
    		"disallowed"
    	],
    	[
    		[
    			2784,
    			2784
    		],
    		"valid"
    	],
    	[
    		[
    			2785,
    			2787
    		],
    		"valid"
    	],
    	[
    		[
    			2788,
    			2789
    		],
    		"disallowed"
    	],
    	[
    		[
    			2790,
    			2799
    		],
    		"valid"
    	],
    	[
    		[
    			2800,
    			2800
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			2801,
    			2801
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			2802,
    			2808
    		],
    		"disallowed"
    	],
    	[
    		[
    			2809,
    			2809
    		],
    		"valid"
    	],
    	[
    		[
    			2810,
    			2816
    		],
    		"disallowed"
    	],
    	[
    		[
    			2817,
    			2819
    		],
    		"valid"
    	],
    	[
    		[
    			2820,
    			2820
    		],
    		"disallowed"
    	],
    	[
    		[
    			2821,
    			2828
    		],
    		"valid"
    	],
    	[
    		[
    			2829,
    			2830
    		],
    		"disallowed"
    	],
    	[
    		[
    			2831,
    			2832
    		],
    		"valid"
    	],
    	[
    		[
    			2833,
    			2834
    		],
    		"disallowed"
    	],
    	[
    		[
    			2835,
    			2856
    		],
    		"valid"
    	],
    	[
    		[
    			2857,
    			2857
    		],
    		"disallowed"
    	],
    	[
    		[
    			2858,
    			2864
    		],
    		"valid"
    	],
    	[
    		[
    			2865,
    			2865
    		],
    		"disallowed"
    	],
    	[
    		[
    			2866,
    			2867
    		],
    		"valid"
    	],
    	[
    		[
    			2868,
    			2868
    		],
    		"disallowed"
    	],
    	[
    		[
    			2869,
    			2869
    		],
    		"valid"
    	],
    	[
    		[
    			2870,
    			2873
    		],
    		"valid"
    	],
    	[
    		[
    			2874,
    			2875
    		],
    		"disallowed"
    	],
    	[
    		[
    			2876,
    			2883
    		],
    		"valid"
    	],
    	[
    		[
    			2884,
    			2884
    		],
    		"valid"
    	],
    	[
    		[
    			2885,
    			2886
    		],
    		"disallowed"
    	],
    	[
    		[
    			2887,
    			2888
    		],
    		"valid"
    	],
    	[
    		[
    			2889,
    			2890
    		],
    		"disallowed"
    	],
    	[
    		[
    			2891,
    			2893
    		],
    		"valid"
    	],
    	[
    		[
    			2894,
    			2901
    		],
    		"disallowed"
    	],
    	[
    		[
    			2902,
    			2903
    		],
    		"valid"
    	],
    	[
    		[
    			2904,
    			2907
    		],
    		"disallowed"
    	],
    	[
    		[
    			2908,
    			2908
    		],
    		"mapped",
    		[
    			2849,
    			2876
    		]
    	],
    	[
    		[
    			2909,
    			2909
    		],
    		"mapped",
    		[
    			2850,
    			2876
    		]
    	],
    	[
    		[
    			2910,
    			2910
    		],
    		"disallowed"
    	],
    	[
    		[
    			2911,
    			2913
    		],
    		"valid"
    	],
    	[
    		[
    			2914,
    			2915
    		],
    		"valid"
    	],
    	[
    		[
    			2916,
    			2917
    		],
    		"disallowed"
    	],
    	[
    		[
    			2918,
    			2927
    		],
    		"valid"
    	],
    	[
    		[
    			2928,
    			2928
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			2929,
    			2929
    		],
    		"valid"
    	],
    	[
    		[
    			2930,
    			2935
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			2936,
    			2945
    		],
    		"disallowed"
    	],
    	[
    		[
    			2946,
    			2947
    		],
    		"valid"
    	],
    	[
    		[
    			2948,
    			2948
    		],
    		"disallowed"
    	],
    	[
    		[
    			2949,
    			2954
    		],
    		"valid"
    	],
    	[
    		[
    			2955,
    			2957
    		],
    		"disallowed"
    	],
    	[
    		[
    			2958,
    			2960
    		],
    		"valid"
    	],
    	[
    		[
    			2961,
    			2961
    		],
    		"disallowed"
    	],
    	[
    		[
    			2962,
    			2965
    		],
    		"valid"
    	],
    	[
    		[
    			2966,
    			2968
    		],
    		"disallowed"
    	],
    	[
    		[
    			2969,
    			2970
    		],
    		"valid"
    	],
    	[
    		[
    			2971,
    			2971
    		],
    		"disallowed"
    	],
    	[
    		[
    			2972,
    			2972
    		],
    		"valid"
    	],
    	[
    		[
    			2973,
    			2973
    		],
    		"disallowed"
    	],
    	[
    		[
    			2974,
    			2975
    		],
    		"valid"
    	],
    	[
    		[
    			2976,
    			2978
    		],
    		"disallowed"
    	],
    	[
    		[
    			2979,
    			2980
    		],
    		"valid"
    	],
    	[
    		[
    			2981,
    			2983
    		],
    		"disallowed"
    	],
    	[
    		[
    			2984,
    			2986
    		],
    		"valid"
    	],
    	[
    		[
    			2987,
    			2989
    		],
    		"disallowed"
    	],
    	[
    		[
    			2990,
    			2997
    		],
    		"valid"
    	],
    	[
    		[
    			2998,
    			2998
    		],
    		"valid"
    	],
    	[
    		[
    			2999,
    			3001
    		],
    		"valid"
    	],
    	[
    		[
    			3002,
    			3005
    		],
    		"disallowed"
    	],
    	[
    		[
    			3006,
    			3010
    		],
    		"valid"
    	],
    	[
    		[
    			3011,
    			3013
    		],
    		"disallowed"
    	],
    	[
    		[
    			3014,
    			3016
    		],
    		"valid"
    	],
    	[
    		[
    			3017,
    			3017
    		],
    		"disallowed"
    	],
    	[
    		[
    			3018,
    			3021
    		],
    		"valid"
    	],
    	[
    		[
    			3022,
    			3023
    		],
    		"disallowed"
    	],
    	[
    		[
    			3024,
    			3024
    		],
    		"valid"
    	],
    	[
    		[
    			3025,
    			3030
    		],
    		"disallowed"
    	],
    	[
    		[
    			3031,
    			3031
    		],
    		"valid"
    	],
    	[
    		[
    			3032,
    			3045
    		],
    		"disallowed"
    	],
    	[
    		[
    			3046,
    			3046
    		],
    		"valid"
    	],
    	[
    		[
    			3047,
    			3055
    		],
    		"valid"
    	],
    	[
    		[
    			3056,
    			3058
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			3059,
    			3066
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			3067,
    			3071
    		],
    		"disallowed"
    	],
    	[
    		[
    			3072,
    			3072
    		],
    		"valid"
    	],
    	[
    		[
    			3073,
    			3075
    		],
    		"valid"
    	],
    	[
    		[
    			3076,
    			3076
    		],
    		"disallowed"
    	],
    	[
    		[
    			3077,
    			3084
    		],
    		"valid"
    	],
    	[
    		[
    			3085,
    			3085
    		],
    		"disallowed"
    	],
    	[
    		[
    			3086,
    			3088
    		],
    		"valid"
    	],
    	[
    		[
    			3089,
    			3089
    		],
    		"disallowed"
    	],
    	[
    		[
    			3090,
    			3112
    		],
    		"valid"
    	],
    	[
    		[
    			3113,
    			3113
    		],
    		"disallowed"
    	],
    	[
    		[
    			3114,
    			3123
    		],
    		"valid"
    	],
    	[
    		[
    			3124,
    			3124
    		],
    		"valid"
    	],
    	[
    		[
    			3125,
    			3129
    		],
    		"valid"
    	],
    	[
    		[
    			3130,
    			3132
    		],
    		"disallowed"
    	],
    	[
    		[
    			3133,
    			3133
    		],
    		"valid"
    	],
    	[
    		[
    			3134,
    			3140
    		],
    		"valid"
    	],
    	[
    		[
    			3141,
    			3141
    		],
    		"disallowed"
    	],
    	[
    		[
    			3142,
    			3144
    		],
    		"valid"
    	],
    	[
    		[
    			3145,
    			3145
    		],
    		"disallowed"
    	],
    	[
    		[
    			3146,
    			3149
    		],
    		"valid"
    	],
    	[
    		[
    			3150,
    			3156
    		],
    		"disallowed"
    	],
    	[
    		[
    			3157,
    			3158
    		],
    		"valid"
    	],
    	[
    		[
    			3159,
    			3159
    		],
    		"disallowed"
    	],
    	[
    		[
    			3160,
    			3161
    		],
    		"valid"
    	],
    	[
    		[
    			3162,
    			3162
    		],
    		"valid"
    	],
    	[
    		[
    			3163,
    			3167
    		],
    		"disallowed"
    	],
    	[
    		[
    			3168,
    			3169
    		],
    		"valid"
    	],
    	[
    		[
    			3170,
    			3171
    		],
    		"valid"
    	],
    	[
    		[
    			3172,
    			3173
    		],
    		"disallowed"
    	],
    	[
    		[
    			3174,
    			3183
    		],
    		"valid"
    	],
    	[
    		[
    			3184,
    			3191
    		],
    		"disallowed"
    	],
    	[
    		[
    			3192,
    			3199
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			3200,
    			3200
    		],
    		"disallowed"
    	],
    	[
    		[
    			3201,
    			3201
    		],
    		"valid"
    	],
    	[
    		[
    			3202,
    			3203
    		],
    		"valid"
    	],
    	[
    		[
    			3204,
    			3204
    		],
    		"disallowed"
    	],
    	[
    		[
    			3205,
    			3212
    		],
    		"valid"
    	],
    	[
    		[
    			3213,
    			3213
    		],
    		"disallowed"
    	],
    	[
    		[
    			3214,
    			3216
    		],
    		"valid"
    	],
    	[
    		[
    			3217,
    			3217
    		],
    		"disallowed"
    	],
    	[
    		[
    			3218,
    			3240
    		],
    		"valid"
    	],
    	[
    		[
    			3241,
    			3241
    		],
    		"disallowed"
    	],
    	[
    		[
    			3242,
    			3251
    		],
    		"valid"
    	],
    	[
    		[
    			3252,
    			3252
    		],
    		"disallowed"
    	],
    	[
    		[
    			3253,
    			3257
    		],
    		"valid"
    	],
    	[
    		[
    			3258,
    			3259
    		],
    		"disallowed"
    	],
    	[
    		[
    			3260,
    			3261
    		],
    		"valid"
    	],
    	[
    		[
    			3262,
    			3268
    		],
    		"valid"
    	],
    	[
    		[
    			3269,
    			3269
    		],
    		"disallowed"
    	],
    	[
    		[
    			3270,
    			3272
    		],
    		"valid"
    	],
    	[
    		[
    			3273,
    			3273
    		],
    		"disallowed"
    	],
    	[
    		[
    			3274,
    			3277
    		],
    		"valid"
    	],
    	[
    		[
    			3278,
    			3284
    		],
    		"disallowed"
    	],
    	[
    		[
    			3285,
    			3286
    		],
    		"valid"
    	],
    	[
    		[
    			3287,
    			3293
    		],
    		"disallowed"
    	],
    	[
    		[
    			3294,
    			3294
    		],
    		"valid"
    	],
    	[
    		[
    			3295,
    			3295
    		],
    		"disallowed"
    	],
    	[
    		[
    			3296,
    			3297
    		],
    		"valid"
    	],
    	[
    		[
    			3298,
    			3299
    		],
    		"valid"
    	],
    	[
    		[
    			3300,
    			3301
    		],
    		"disallowed"
    	],
    	[
    		[
    			3302,
    			3311
    		],
    		"valid"
    	],
    	[
    		[
    			3312,
    			3312
    		],
    		"disallowed"
    	],
    	[
    		[
    			3313,
    			3314
    		],
    		"valid"
    	],
    	[
    		[
    			3315,
    			3328
    		],
    		"disallowed"
    	],
    	[
    		[
    			3329,
    			3329
    		],
    		"valid"
    	],
    	[
    		[
    			3330,
    			3331
    		],
    		"valid"
    	],
    	[
    		[
    			3332,
    			3332
    		],
    		"disallowed"
    	],
    	[
    		[
    			3333,
    			3340
    		],
    		"valid"
    	],
    	[
    		[
    			3341,
    			3341
    		],
    		"disallowed"
    	],
    	[
    		[
    			3342,
    			3344
    		],
    		"valid"
    	],
    	[
    		[
    			3345,
    			3345
    		],
    		"disallowed"
    	],
    	[
    		[
    			3346,
    			3368
    		],
    		"valid"
    	],
    	[
    		[
    			3369,
    			3369
    		],
    		"valid"
    	],
    	[
    		[
    			3370,
    			3385
    		],
    		"valid"
    	],
    	[
    		[
    			3386,
    			3386
    		],
    		"valid"
    	],
    	[
    		[
    			3387,
    			3388
    		],
    		"disallowed"
    	],
    	[
    		[
    			3389,
    			3389
    		],
    		"valid"
    	],
    	[
    		[
    			3390,
    			3395
    		],
    		"valid"
    	],
    	[
    		[
    			3396,
    			3396
    		],
    		"valid"
    	],
    	[
    		[
    			3397,
    			3397
    		],
    		"disallowed"
    	],
    	[
    		[
    			3398,
    			3400
    		],
    		"valid"
    	],
    	[
    		[
    			3401,
    			3401
    		],
    		"disallowed"
    	],
    	[
    		[
    			3402,
    			3405
    		],
    		"valid"
    	],
    	[
    		[
    			3406,
    			3406
    		],
    		"valid"
    	],
    	[
    		[
    			3407,
    			3414
    		],
    		"disallowed"
    	],
    	[
    		[
    			3415,
    			3415
    		],
    		"valid"
    	],
    	[
    		[
    			3416,
    			3422
    		],
    		"disallowed"
    	],
    	[
    		[
    			3423,
    			3423
    		],
    		"valid"
    	],
    	[
    		[
    			3424,
    			3425
    		],
    		"valid"
    	],
    	[
    		[
    			3426,
    			3427
    		],
    		"valid"
    	],
    	[
    		[
    			3428,
    			3429
    		],
    		"disallowed"
    	],
    	[
    		[
    			3430,
    			3439
    		],
    		"valid"
    	],
    	[
    		[
    			3440,
    			3445
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			3446,
    			3448
    		],
    		"disallowed"
    	],
    	[
    		[
    			3449,
    			3449
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			3450,
    			3455
    		],
    		"valid"
    	],
    	[
    		[
    			3456,
    			3457
    		],
    		"disallowed"
    	],
    	[
    		[
    			3458,
    			3459
    		],
    		"valid"
    	],
    	[
    		[
    			3460,
    			3460
    		],
    		"disallowed"
    	],
    	[
    		[
    			3461,
    			3478
    		],
    		"valid"
    	],
    	[
    		[
    			3479,
    			3481
    		],
    		"disallowed"
    	],
    	[
    		[
    			3482,
    			3505
    		],
    		"valid"
    	],
    	[
    		[
    			3506,
    			3506
    		],
    		"disallowed"
    	],
    	[
    		[
    			3507,
    			3515
    		],
    		"valid"
    	],
    	[
    		[
    			3516,
    			3516
    		],
    		"disallowed"
    	],
    	[
    		[
    			3517,
    			3517
    		],
    		"valid"
    	],
    	[
    		[
    			3518,
    			3519
    		],
    		"disallowed"
    	],
    	[
    		[
    			3520,
    			3526
    		],
    		"valid"
    	],
    	[
    		[
    			3527,
    			3529
    		],
    		"disallowed"
    	],
    	[
    		[
    			3530,
    			3530
    		],
    		"valid"
    	],
    	[
    		[
    			3531,
    			3534
    		],
    		"disallowed"
    	],
    	[
    		[
    			3535,
    			3540
    		],
    		"valid"
    	],
    	[
    		[
    			3541,
    			3541
    		],
    		"disallowed"
    	],
    	[
    		[
    			3542,
    			3542
    		],
    		"valid"
    	],
    	[
    		[
    			3543,
    			3543
    		],
    		"disallowed"
    	],
    	[
    		[
    			3544,
    			3551
    		],
    		"valid"
    	],
    	[
    		[
    			3552,
    			3557
    		],
    		"disallowed"
    	],
    	[
    		[
    			3558,
    			3567
    		],
    		"valid"
    	],
    	[
    		[
    			3568,
    			3569
    		],
    		"disallowed"
    	],
    	[
    		[
    			3570,
    			3571
    		],
    		"valid"
    	],
    	[
    		[
    			3572,
    			3572
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			3573,
    			3584
    		],
    		"disallowed"
    	],
    	[
    		[
    			3585,
    			3634
    		],
    		"valid"
    	],
    	[
    		[
    			3635,
    			3635
    		],
    		"mapped",
    		[
    			3661,
    			3634
    		]
    	],
    	[
    		[
    			3636,
    			3642
    		],
    		"valid"
    	],
    	[
    		[
    			3643,
    			3646
    		],
    		"disallowed"
    	],
    	[
    		[
    			3647,
    			3647
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			3648,
    			3662
    		],
    		"valid"
    	],
    	[
    		[
    			3663,
    			3663
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			3664,
    			3673
    		],
    		"valid"
    	],
    	[
    		[
    			3674,
    			3675
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			3676,
    			3712
    		],
    		"disallowed"
    	],
    	[
    		[
    			3713,
    			3714
    		],
    		"valid"
    	],
    	[
    		[
    			3715,
    			3715
    		],
    		"disallowed"
    	],
    	[
    		[
    			3716,
    			3716
    		],
    		"valid"
    	],
    	[
    		[
    			3717,
    			3718
    		],
    		"disallowed"
    	],
    	[
    		[
    			3719,
    			3720
    		],
    		"valid"
    	],
    	[
    		[
    			3721,
    			3721
    		],
    		"disallowed"
    	],
    	[
    		[
    			3722,
    			3722
    		],
    		"valid"
    	],
    	[
    		[
    			3723,
    			3724
    		],
    		"disallowed"
    	],
    	[
    		[
    			3725,
    			3725
    		],
    		"valid"
    	],
    	[
    		[
    			3726,
    			3731
    		],
    		"disallowed"
    	],
    	[
    		[
    			3732,
    			3735
    		],
    		"valid"
    	],
    	[
    		[
    			3736,
    			3736
    		],
    		"disallowed"
    	],
    	[
    		[
    			3737,
    			3743
    		],
    		"valid"
    	],
    	[
    		[
    			3744,
    			3744
    		],
    		"disallowed"
    	],
    	[
    		[
    			3745,
    			3747
    		],
    		"valid"
    	],
    	[
    		[
    			3748,
    			3748
    		],
    		"disallowed"
    	],
    	[
    		[
    			3749,
    			3749
    		],
    		"valid"
    	],
    	[
    		[
    			3750,
    			3750
    		],
    		"disallowed"
    	],
    	[
    		[
    			3751,
    			3751
    		],
    		"valid"
    	],
    	[
    		[
    			3752,
    			3753
    		],
    		"disallowed"
    	],
    	[
    		[
    			3754,
    			3755
    		],
    		"valid"
    	],
    	[
    		[
    			3756,
    			3756
    		],
    		"disallowed"
    	],
    	[
    		[
    			3757,
    			3762
    		],
    		"valid"
    	],
    	[
    		[
    			3763,
    			3763
    		],
    		"mapped",
    		[
    			3789,
    			3762
    		]
    	],
    	[
    		[
    			3764,
    			3769
    		],
    		"valid"
    	],
    	[
    		[
    			3770,
    			3770
    		],
    		"disallowed"
    	],
    	[
    		[
    			3771,
    			3773
    		],
    		"valid"
    	],
    	[
    		[
    			3774,
    			3775
    		],
    		"disallowed"
    	],
    	[
    		[
    			3776,
    			3780
    		],
    		"valid"
    	],
    	[
    		[
    			3781,
    			3781
    		],
    		"disallowed"
    	],
    	[
    		[
    			3782,
    			3782
    		],
    		"valid"
    	],
    	[
    		[
    			3783,
    			3783
    		],
    		"disallowed"
    	],
    	[
    		[
    			3784,
    			3789
    		],
    		"valid"
    	],
    	[
    		[
    			3790,
    			3791
    		],
    		"disallowed"
    	],
    	[
    		[
    			3792,
    			3801
    		],
    		"valid"
    	],
    	[
    		[
    			3802,
    			3803
    		],
    		"disallowed"
    	],
    	[
    		[
    			3804,
    			3804
    		],
    		"mapped",
    		[
    			3755,
    			3737
    		]
    	],
    	[
    		[
    			3805,
    			3805
    		],
    		"mapped",
    		[
    			3755,
    			3745
    		]
    	],
    	[
    		[
    			3806,
    			3807
    		],
    		"valid"
    	],
    	[
    		[
    			3808,
    			3839
    		],
    		"disallowed"
    	],
    	[
    		[
    			3840,
    			3840
    		],
    		"valid"
    	],
    	[
    		[
    			3841,
    			3850
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			3851,
    			3851
    		],
    		"valid"
    	],
    	[
    		[
    			3852,
    			3852
    		],
    		"mapped",
    		[
    			3851
    		]
    	],
    	[
    		[
    			3853,
    			3863
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			3864,
    			3865
    		],
    		"valid"
    	],
    	[
    		[
    			3866,
    			3871
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			3872,
    			3881
    		],
    		"valid"
    	],
    	[
    		[
    			3882,
    			3892
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			3893,
    			3893
    		],
    		"valid"
    	],
    	[
    		[
    			3894,
    			3894
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			3895,
    			3895
    		],
    		"valid"
    	],
    	[
    		[
    			3896,
    			3896
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			3897,
    			3897
    		],
    		"valid"
    	],
    	[
    		[
    			3898,
    			3901
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			3902,
    			3906
    		],
    		"valid"
    	],
    	[
    		[
    			3907,
    			3907
    		],
    		"mapped",
    		[
    			3906,
    			4023
    		]
    	],
    	[
    		[
    			3908,
    			3911
    		],
    		"valid"
    	],
    	[
    		[
    			3912,
    			3912
    		],
    		"disallowed"
    	],
    	[
    		[
    			3913,
    			3916
    		],
    		"valid"
    	],
    	[
    		[
    			3917,
    			3917
    		],
    		"mapped",
    		[
    			3916,
    			4023
    		]
    	],
    	[
    		[
    			3918,
    			3921
    		],
    		"valid"
    	],
    	[
    		[
    			3922,
    			3922
    		],
    		"mapped",
    		[
    			3921,
    			4023
    		]
    	],
    	[
    		[
    			3923,
    			3926
    		],
    		"valid"
    	],
    	[
    		[
    			3927,
    			3927
    		],
    		"mapped",
    		[
    			3926,
    			4023
    		]
    	],
    	[
    		[
    			3928,
    			3931
    		],
    		"valid"
    	],
    	[
    		[
    			3932,
    			3932
    		],
    		"mapped",
    		[
    			3931,
    			4023
    		]
    	],
    	[
    		[
    			3933,
    			3944
    		],
    		"valid"
    	],
    	[
    		[
    			3945,
    			3945
    		],
    		"mapped",
    		[
    			3904,
    			4021
    		]
    	],
    	[
    		[
    			3946,
    			3946
    		],
    		"valid"
    	],
    	[
    		[
    			3947,
    			3948
    		],
    		"valid"
    	],
    	[
    		[
    			3949,
    			3952
    		],
    		"disallowed"
    	],
    	[
    		[
    			3953,
    			3954
    		],
    		"valid"
    	],
    	[
    		[
    			3955,
    			3955
    		],
    		"mapped",
    		[
    			3953,
    			3954
    		]
    	],
    	[
    		[
    			3956,
    			3956
    		],
    		"valid"
    	],
    	[
    		[
    			3957,
    			3957
    		],
    		"mapped",
    		[
    			3953,
    			3956
    		]
    	],
    	[
    		[
    			3958,
    			3958
    		],
    		"mapped",
    		[
    			4018,
    			3968
    		]
    	],
    	[
    		[
    			3959,
    			3959
    		],
    		"mapped",
    		[
    			4018,
    			3953,
    			3968
    		]
    	],
    	[
    		[
    			3960,
    			3960
    		],
    		"mapped",
    		[
    			4019,
    			3968
    		]
    	],
    	[
    		[
    			3961,
    			3961
    		],
    		"mapped",
    		[
    			4019,
    			3953,
    			3968
    		]
    	],
    	[
    		[
    			3962,
    			3968
    		],
    		"valid"
    	],
    	[
    		[
    			3969,
    			3969
    		],
    		"mapped",
    		[
    			3953,
    			3968
    		]
    	],
    	[
    		[
    			3970,
    			3972
    		],
    		"valid"
    	],
    	[
    		[
    			3973,
    			3973
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			3974,
    			3979
    		],
    		"valid"
    	],
    	[
    		[
    			3980,
    			3983
    		],
    		"valid"
    	],
    	[
    		[
    			3984,
    			3986
    		],
    		"valid"
    	],
    	[
    		[
    			3987,
    			3987
    		],
    		"mapped",
    		[
    			3986,
    			4023
    		]
    	],
    	[
    		[
    			3988,
    			3989
    		],
    		"valid"
    	],
    	[
    		[
    			3990,
    			3990
    		],
    		"valid"
    	],
    	[
    		[
    			3991,
    			3991
    		],
    		"valid"
    	],
    	[
    		[
    			3992,
    			3992
    		],
    		"disallowed"
    	],
    	[
    		[
    			3993,
    			3996
    		],
    		"valid"
    	],
    	[
    		[
    			3997,
    			3997
    		],
    		"mapped",
    		[
    			3996,
    			4023
    		]
    	],
    	[
    		[
    			3998,
    			4001
    		],
    		"valid"
    	],
    	[
    		[
    			4002,
    			4002
    		],
    		"mapped",
    		[
    			4001,
    			4023
    		]
    	],
    	[
    		[
    			4003,
    			4006
    		],
    		"valid"
    	],
    	[
    		[
    			4007,
    			4007
    		],
    		"mapped",
    		[
    			4006,
    			4023
    		]
    	],
    	[
    		[
    			4008,
    			4011
    		],
    		"valid"
    	],
    	[
    		[
    			4012,
    			4012
    		],
    		"mapped",
    		[
    			4011,
    			4023
    		]
    	],
    	[
    		[
    			4013,
    			4013
    		],
    		"valid"
    	],
    	[
    		[
    			4014,
    			4016
    		],
    		"valid"
    	],
    	[
    		[
    			4017,
    			4023
    		],
    		"valid"
    	],
    	[
    		[
    			4024,
    			4024
    		],
    		"valid"
    	],
    	[
    		[
    			4025,
    			4025
    		],
    		"mapped",
    		[
    			3984,
    			4021
    		]
    	],
    	[
    		[
    			4026,
    			4028
    		],
    		"valid"
    	],
    	[
    		[
    			4029,
    			4029
    		],
    		"disallowed"
    	],
    	[
    		[
    			4030,
    			4037
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4038,
    			4038
    		],
    		"valid"
    	],
    	[
    		[
    			4039,
    			4044
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4045,
    			4045
    		],
    		"disallowed"
    	],
    	[
    		[
    			4046,
    			4046
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4047,
    			4047
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4048,
    			4049
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4050,
    			4052
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4053,
    			4056
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4057,
    			4058
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4059,
    			4095
    		],
    		"disallowed"
    	],
    	[
    		[
    			4096,
    			4129
    		],
    		"valid"
    	],
    	[
    		[
    			4130,
    			4130
    		],
    		"valid"
    	],
    	[
    		[
    			4131,
    			4135
    		],
    		"valid"
    	],
    	[
    		[
    			4136,
    			4136
    		],
    		"valid"
    	],
    	[
    		[
    			4137,
    			4138
    		],
    		"valid"
    	],
    	[
    		[
    			4139,
    			4139
    		],
    		"valid"
    	],
    	[
    		[
    			4140,
    			4146
    		],
    		"valid"
    	],
    	[
    		[
    			4147,
    			4149
    		],
    		"valid"
    	],
    	[
    		[
    			4150,
    			4153
    		],
    		"valid"
    	],
    	[
    		[
    			4154,
    			4159
    		],
    		"valid"
    	],
    	[
    		[
    			4160,
    			4169
    		],
    		"valid"
    	],
    	[
    		[
    			4170,
    			4175
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4176,
    			4185
    		],
    		"valid"
    	],
    	[
    		[
    			4186,
    			4249
    		],
    		"valid"
    	],
    	[
    		[
    			4250,
    			4253
    		],
    		"valid"
    	],
    	[
    		[
    			4254,
    			4255
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4256,
    			4293
    		],
    		"disallowed"
    	],
    	[
    		[
    			4294,
    			4294
    		],
    		"disallowed"
    	],
    	[
    		[
    			4295,
    			4295
    		],
    		"mapped",
    		[
    			11559
    		]
    	],
    	[
    		[
    			4296,
    			4300
    		],
    		"disallowed"
    	],
    	[
    		[
    			4301,
    			4301
    		],
    		"mapped",
    		[
    			11565
    		]
    	],
    	[
    		[
    			4302,
    			4303
    		],
    		"disallowed"
    	],
    	[
    		[
    			4304,
    			4342
    		],
    		"valid"
    	],
    	[
    		[
    			4343,
    			4344
    		],
    		"valid"
    	],
    	[
    		[
    			4345,
    			4346
    		],
    		"valid"
    	],
    	[
    		[
    			4347,
    			4347
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4348,
    			4348
    		],
    		"mapped",
    		[
    			4316
    		]
    	],
    	[
    		[
    			4349,
    			4351
    		],
    		"valid"
    	],
    	[
    		[
    			4352,
    			4441
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4442,
    			4446
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4447,
    			4448
    		],
    		"disallowed"
    	],
    	[
    		[
    			4449,
    			4514
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4515,
    			4519
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4520,
    			4601
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4602,
    			4607
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4608,
    			4614
    		],
    		"valid"
    	],
    	[
    		[
    			4615,
    			4615
    		],
    		"valid"
    	],
    	[
    		[
    			4616,
    			4678
    		],
    		"valid"
    	],
    	[
    		[
    			4679,
    			4679
    		],
    		"valid"
    	],
    	[
    		[
    			4680,
    			4680
    		],
    		"valid"
    	],
    	[
    		[
    			4681,
    			4681
    		],
    		"disallowed"
    	],
    	[
    		[
    			4682,
    			4685
    		],
    		"valid"
    	],
    	[
    		[
    			4686,
    			4687
    		],
    		"disallowed"
    	],
    	[
    		[
    			4688,
    			4694
    		],
    		"valid"
    	],
    	[
    		[
    			4695,
    			4695
    		],
    		"disallowed"
    	],
    	[
    		[
    			4696,
    			4696
    		],
    		"valid"
    	],
    	[
    		[
    			4697,
    			4697
    		],
    		"disallowed"
    	],
    	[
    		[
    			4698,
    			4701
    		],
    		"valid"
    	],
    	[
    		[
    			4702,
    			4703
    		],
    		"disallowed"
    	],
    	[
    		[
    			4704,
    			4742
    		],
    		"valid"
    	],
    	[
    		[
    			4743,
    			4743
    		],
    		"valid"
    	],
    	[
    		[
    			4744,
    			4744
    		],
    		"valid"
    	],
    	[
    		[
    			4745,
    			4745
    		],
    		"disallowed"
    	],
    	[
    		[
    			4746,
    			4749
    		],
    		"valid"
    	],
    	[
    		[
    			4750,
    			4751
    		],
    		"disallowed"
    	],
    	[
    		[
    			4752,
    			4782
    		],
    		"valid"
    	],
    	[
    		[
    			4783,
    			4783
    		],
    		"valid"
    	],
    	[
    		[
    			4784,
    			4784
    		],
    		"valid"
    	],
    	[
    		[
    			4785,
    			4785
    		],
    		"disallowed"
    	],
    	[
    		[
    			4786,
    			4789
    		],
    		"valid"
    	],
    	[
    		[
    			4790,
    			4791
    		],
    		"disallowed"
    	],
    	[
    		[
    			4792,
    			4798
    		],
    		"valid"
    	],
    	[
    		[
    			4799,
    			4799
    		],
    		"disallowed"
    	],
    	[
    		[
    			4800,
    			4800
    		],
    		"valid"
    	],
    	[
    		[
    			4801,
    			4801
    		],
    		"disallowed"
    	],
    	[
    		[
    			4802,
    			4805
    		],
    		"valid"
    	],
    	[
    		[
    			4806,
    			4807
    		],
    		"disallowed"
    	],
    	[
    		[
    			4808,
    			4814
    		],
    		"valid"
    	],
    	[
    		[
    			4815,
    			4815
    		],
    		"valid"
    	],
    	[
    		[
    			4816,
    			4822
    		],
    		"valid"
    	],
    	[
    		[
    			4823,
    			4823
    		],
    		"disallowed"
    	],
    	[
    		[
    			4824,
    			4846
    		],
    		"valid"
    	],
    	[
    		[
    			4847,
    			4847
    		],
    		"valid"
    	],
    	[
    		[
    			4848,
    			4878
    		],
    		"valid"
    	],
    	[
    		[
    			4879,
    			4879
    		],
    		"valid"
    	],
    	[
    		[
    			4880,
    			4880
    		],
    		"valid"
    	],
    	[
    		[
    			4881,
    			4881
    		],
    		"disallowed"
    	],
    	[
    		[
    			4882,
    			4885
    		],
    		"valid"
    	],
    	[
    		[
    			4886,
    			4887
    		],
    		"disallowed"
    	],
    	[
    		[
    			4888,
    			4894
    		],
    		"valid"
    	],
    	[
    		[
    			4895,
    			4895
    		],
    		"valid"
    	],
    	[
    		[
    			4896,
    			4934
    		],
    		"valid"
    	],
    	[
    		[
    			4935,
    			4935
    		],
    		"valid"
    	],
    	[
    		[
    			4936,
    			4954
    		],
    		"valid"
    	],
    	[
    		[
    			4955,
    			4956
    		],
    		"disallowed"
    	],
    	[
    		[
    			4957,
    			4958
    		],
    		"valid"
    	],
    	[
    		[
    			4959,
    			4959
    		],
    		"valid"
    	],
    	[
    		[
    			4960,
    			4960
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4961,
    			4988
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			4989,
    			4991
    		],
    		"disallowed"
    	],
    	[
    		[
    			4992,
    			5007
    		],
    		"valid"
    	],
    	[
    		[
    			5008,
    			5017
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			5018,
    			5023
    		],
    		"disallowed"
    	],
    	[
    		[
    			5024,
    			5108
    		],
    		"valid"
    	],
    	[
    		[
    			5109,
    			5109
    		],
    		"valid"
    	],
    	[
    		[
    			5110,
    			5111
    		],
    		"disallowed"
    	],
    	[
    		[
    			5112,
    			5112
    		],
    		"mapped",
    		[
    			5104
    		]
    	],
    	[
    		[
    			5113,
    			5113
    		],
    		"mapped",
    		[
    			5105
    		]
    	],
    	[
    		[
    			5114,
    			5114
    		],
    		"mapped",
    		[
    			5106
    		]
    	],
    	[
    		[
    			5115,
    			5115
    		],
    		"mapped",
    		[
    			5107
    		]
    	],
    	[
    		[
    			5116,
    			5116
    		],
    		"mapped",
    		[
    			5108
    		]
    	],
    	[
    		[
    			5117,
    			5117
    		],
    		"mapped",
    		[
    			5109
    		]
    	],
    	[
    		[
    			5118,
    			5119
    		],
    		"disallowed"
    	],
    	[
    		[
    			5120,
    			5120
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			5121,
    			5740
    		],
    		"valid"
    	],
    	[
    		[
    			5741,
    			5742
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			5743,
    			5750
    		],
    		"valid"
    	],
    	[
    		[
    			5751,
    			5759
    		],
    		"valid"
    	],
    	[
    		[
    			5760,
    			5760
    		],
    		"disallowed"
    	],
    	[
    		[
    			5761,
    			5786
    		],
    		"valid"
    	],
    	[
    		[
    			5787,
    			5788
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			5789,
    			5791
    		],
    		"disallowed"
    	],
    	[
    		[
    			5792,
    			5866
    		],
    		"valid"
    	],
    	[
    		[
    			5867,
    			5872
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			5873,
    			5880
    		],
    		"valid"
    	],
    	[
    		[
    			5881,
    			5887
    		],
    		"disallowed"
    	],
    	[
    		[
    			5888,
    			5900
    		],
    		"valid"
    	],
    	[
    		[
    			5901,
    			5901
    		],
    		"disallowed"
    	],
    	[
    		[
    			5902,
    			5908
    		],
    		"valid"
    	],
    	[
    		[
    			5909,
    			5919
    		],
    		"disallowed"
    	],
    	[
    		[
    			5920,
    			5940
    		],
    		"valid"
    	],
    	[
    		[
    			5941,
    			5942
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			5943,
    			5951
    		],
    		"disallowed"
    	],
    	[
    		[
    			5952,
    			5971
    		],
    		"valid"
    	],
    	[
    		[
    			5972,
    			5983
    		],
    		"disallowed"
    	],
    	[
    		[
    			5984,
    			5996
    		],
    		"valid"
    	],
    	[
    		[
    			5997,
    			5997
    		],
    		"disallowed"
    	],
    	[
    		[
    			5998,
    			6000
    		],
    		"valid"
    	],
    	[
    		[
    			6001,
    			6001
    		],
    		"disallowed"
    	],
    	[
    		[
    			6002,
    			6003
    		],
    		"valid"
    	],
    	[
    		[
    			6004,
    			6015
    		],
    		"disallowed"
    	],
    	[
    		[
    			6016,
    			6067
    		],
    		"valid"
    	],
    	[
    		[
    			6068,
    			6069
    		],
    		"disallowed"
    	],
    	[
    		[
    			6070,
    			6099
    		],
    		"valid"
    	],
    	[
    		[
    			6100,
    			6102
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			6103,
    			6103
    		],
    		"valid"
    	],
    	[
    		[
    			6104,
    			6107
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			6108,
    			6108
    		],
    		"valid"
    	],
    	[
    		[
    			6109,
    			6109
    		],
    		"valid"
    	],
    	[
    		[
    			6110,
    			6111
    		],
    		"disallowed"
    	],
    	[
    		[
    			6112,
    			6121
    		],
    		"valid"
    	],
    	[
    		[
    			6122,
    			6127
    		],
    		"disallowed"
    	],
    	[
    		[
    			6128,
    			6137
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			6138,
    			6143
    		],
    		"disallowed"
    	],
    	[
    		[
    			6144,
    			6149
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			6150,
    			6150
    		],
    		"disallowed"
    	],
    	[
    		[
    			6151,
    			6154
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			6155,
    			6157
    		],
    		"ignored"
    	],
    	[
    		[
    			6158,
    			6158
    		],
    		"disallowed"
    	],
    	[
    		[
    			6159,
    			6159
    		],
    		"disallowed"
    	],
    	[
    		[
    			6160,
    			6169
    		],
    		"valid"
    	],
    	[
    		[
    			6170,
    			6175
    		],
    		"disallowed"
    	],
    	[
    		[
    			6176,
    			6263
    		],
    		"valid"
    	],
    	[
    		[
    			6264,
    			6271
    		],
    		"disallowed"
    	],
    	[
    		[
    			6272,
    			6313
    		],
    		"valid"
    	],
    	[
    		[
    			6314,
    			6314
    		],
    		"valid"
    	],
    	[
    		[
    			6315,
    			6319
    		],
    		"disallowed"
    	],
    	[
    		[
    			6320,
    			6389
    		],
    		"valid"
    	],
    	[
    		[
    			6390,
    			6399
    		],
    		"disallowed"
    	],
    	[
    		[
    			6400,
    			6428
    		],
    		"valid"
    	],
    	[
    		[
    			6429,
    			6430
    		],
    		"valid"
    	],
    	[
    		[
    			6431,
    			6431
    		],
    		"disallowed"
    	],
    	[
    		[
    			6432,
    			6443
    		],
    		"valid"
    	],
    	[
    		[
    			6444,
    			6447
    		],
    		"disallowed"
    	],
    	[
    		[
    			6448,
    			6459
    		],
    		"valid"
    	],
    	[
    		[
    			6460,
    			6463
    		],
    		"disallowed"
    	],
    	[
    		[
    			6464,
    			6464
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			6465,
    			6467
    		],
    		"disallowed"
    	],
    	[
    		[
    			6468,
    			6469
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			6470,
    			6509
    		],
    		"valid"
    	],
    	[
    		[
    			6510,
    			6511
    		],
    		"disallowed"
    	],
    	[
    		[
    			6512,
    			6516
    		],
    		"valid"
    	],
    	[
    		[
    			6517,
    			6527
    		],
    		"disallowed"
    	],
    	[
    		[
    			6528,
    			6569
    		],
    		"valid"
    	],
    	[
    		[
    			6570,
    			6571
    		],
    		"valid"
    	],
    	[
    		[
    			6572,
    			6575
    		],
    		"disallowed"
    	],
    	[
    		[
    			6576,
    			6601
    		],
    		"valid"
    	],
    	[
    		[
    			6602,
    			6607
    		],
    		"disallowed"
    	],
    	[
    		[
    			6608,
    			6617
    		],
    		"valid"
    	],
    	[
    		[
    			6618,
    			6618
    		],
    		"valid",
    		[
    		],
    		"XV8"
    	],
    	[
    		[
    			6619,
    			6621
    		],
    		"disallowed"
    	],
    	[
    		[
    			6622,
    			6623
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			6624,
    			6655
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			6656,
    			6683
    		],
    		"valid"
    	],
    	[
    		[
    			6684,
    			6685
    		],
    		"disallowed"
    	],
    	[
    		[
    			6686,
    			6687
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			6688,
    			6750
    		],
    		"valid"
    	],
    	[
    		[
    			6751,
    			6751
    		],
    		"disallowed"
    	],
    	[
    		[
    			6752,
    			6780
    		],
    		"valid"
    	],
    	[
    		[
    			6781,
    			6782
    		],
    		"disallowed"
    	],
    	[
    		[
    			6783,
    			6793
    		],
    		"valid"
    	],
    	[
    		[
    			6794,
    			6799
    		],
    		"disallowed"
    	],
    	[
    		[
    			6800,
    			6809
    		],
    		"valid"
    	],
    	[
    		[
    			6810,
    			6815
    		],
    		"disallowed"
    	],
    	[
    		[
    			6816,
    			6822
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			6823,
    			6823
    		],
    		"valid"
    	],
    	[
    		[
    			6824,
    			6829
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			6830,
    			6831
    		],
    		"disallowed"
    	],
    	[
    		[
    			6832,
    			6845
    		],
    		"valid"
    	],
    	[
    		[
    			6846,
    			6846
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			6847,
    			6911
    		],
    		"disallowed"
    	],
    	[
    		[
    			6912,
    			6987
    		],
    		"valid"
    	],
    	[
    		[
    			6988,
    			6991
    		],
    		"disallowed"
    	],
    	[
    		[
    			6992,
    			7001
    		],
    		"valid"
    	],
    	[
    		[
    			7002,
    			7018
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			7019,
    			7027
    		],
    		"valid"
    	],
    	[
    		[
    			7028,
    			7036
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			7037,
    			7039
    		],
    		"disallowed"
    	],
    	[
    		[
    			7040,
    			7082
    		],
    		"valid"
    	],
    	[
    		[
    			7083,
    			7085
    		],
    		"valid"
    	],
    	[
    		[
    			7086,
    			7097
    		],
    		"valid"
    	],
    	[
    		[
    			7098,
    			7103
    		],
    		"valid"
    	],
    	[
    		[
    			7104,
    			7155
    		],
    		"valid"
    	],
    	[
    		[
    			7156,
    			7163
    		],
    		"disallowed"
    	],
    	[
    		[
    			7164,
    			7167
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			7168,
    			7223
    		],
    		"valid"
    	],
    	[
    		[
    			7224,
    			7226
    		],
    		"disallowed"
    	],
    	[
    		[
    			7227,
    			7231
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			7232,
    			7241
    		],
    		"valid"
    	],
    	[
    		[
    			7242,
    			7244
    		],
    		"disallowed"
    	],
    	[
    		[
    			7245,
    			7293
    		],
    		"valid"
    	],
    	[
    		[
    			7294,
    			7295
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			7296,
    			7359
    		],
    		"disallowed"
    	],
    	[
    		[
    			7360,
    			7367
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			7368,
    			7375
    		],
    		"disallowed"
    	],
    	[
    		[
    			7376,
    			7378
    		],
    		"valid"
    	],
    	[
    		[
    			7379,
    			7379
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			7380,
    			7410
    		],
    		"valid"
    	],
    	[
    		[
    			7411,
    			7414
    		],
    		"valid"
    	],
    	[
    		[
    			7415,
    			7415
    		],
    		"disallowed"
    	],
    	[
    		[
    			7416,
    			7417
    		],
    		"valid"
    	],
    	[
    		[
    			7418,
    			7423
    		],
    		"disallowed"
    	],
    	[
    		[
    			7424,
    			7467
    		],
    		"valid"
    	],
    	[
    		[
    			7468,
    			7468
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			7469,
    			7469
    		],
    		"mapped",
    		[
    			230
    		]
    	],
    	[
    		[
    			7470,
    			7470
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			7471,
    			7471
    		],
    		"valid"
    	],
    	[
    		[
    			7472,
    			7472
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			7473,
    			7473
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			7474,
    			7474
    		],
    		"mapped",
    		[
    			477
    		]
    	],
    	[
    		[
    			7475,
    			7475
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			7476,
    			7476
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			7477,
    			7477
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			7478,
    			7478
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			7479,
    			7479
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			7480,
    			7480
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			7481,
    			7481
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			7482,
    			7482
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			7483,
    			7483
    		],
    		"valid"
    	],
    	[
    		[
    			7484,
    			7484
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			7485,
    			7485
    		],
    		"mapped",
    		[
    			547
    		]
    	],
    	[
    		[
    			7486,
    			7486
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			7487,
    			7487
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			7488,
    			7488
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			7489,
    			7489
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			7490,
    			7490
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			7491,
    			7491
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			7492,
    			7492
    		],
    		"mapped",
    		[
    			592
    		]
    	],
    	[
    		[
    			7493,
    			7493
    		],
    		"mapped",
    		[
    			593
    		]
    	],
    	[
    		[
    			7494,
    			7494
    		],
    		"mapped",
    		[
    			7426
    		]
    	],
    	[
    		[
    			7495,
    			7495
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			7496,
    			7496
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			7497,
    			7497
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			7498,
    			7498
    		],
    		"mapped",
    		[
    			601
    		]
    	],
    	[
    		[
    			7499,
    			7499
    		],
    		"mapped",
    		[
    			603
    		]
    	],
    	[
    		[
    			7500,
    			7500
    		],
    		"mapped",
    		[
    			604
    		]
    	],
    	[
    		[
    			7501,
    			7501
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			7502,
    			7502
    		],
    		"valid"
    	],
    	[
    		[
    			7503,
    			7503
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			7504,
    			7504
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			7505,
    			7505
    		],
    		"mapped",
    		[
    			331
    		]
    	],
    	[
    		[
    			7506,
    			7506
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			7507,
    			7507
    		],
    		"mapped",
    		[
    			596
    		]
    	],
    	[
    		[
    			7508,
    			7508
    		],
    		"mapped",
    		[
    			7446
    		]
    	],
    	[
    		[
    			7509,
    			7509
    		],
    		"mapped",
    		[
    			7447
    		]
    	],
    	[
    		[
    			7510,
    			7510
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			7511,
    			7511
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			7512,
    			7512
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			7513,
    			7513
    		],
    		"mapped",
    		[
    			7453
    		]
    	],
    	[
    		[
    			7514,
    			7514
    		],
    		"mapped",
    		[
    			623
    		]
    	],
    	[
    		[
    			7515,
    			7515
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			7516,
    			7516
    		],
    		"mapped",
    		[
    			7461
    		]
    	],
    	[
    		[
    			7517,
    			7517
    		],
    		"mapped",
    		[
    			946
    		]
    	],
    	[
    		[
    			7518,
    			7518
    		],
    		"mapped",
    		[
    			947
    		]
    	],
    	[
    		[
    			7519,
    			7519
    		],
    		"mapped",
    		[
    			948
    		]
    	],
    	[
    		[
    			7520,
    			7520
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			7521,
    			7521
    		],
    		"mapped",
    		[
    			967
    		]
    	],
    	[
    		[
    			7522,
    			7522
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			7523,
    			7523
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			7524,
    			7524
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			7525,
    			7525
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			7526,
    			7526
    		],
    		"mapped",
    		[
    			946
    		]
    	],
    	[
    		[
    			7527,
    			7527
    		],
    		"mapped",
    		[
    			947
    		]
    	],
    	[
    		[
    			7528,
    			7528
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			7529,
    			7529
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			7530,
    			7530
    		],
    		"mapped",
    		[
    			967
    		]
    	],
    	[
    		[
    			7531,
    			7531
    		],
    		"valid"
    	],
    	[
    		[
    			7532,
    			7543
    		],
    		"valid"
    	],
    	[
    		[
    			7544,
    			7544
    		],
    		"mapped",
    		[
    			1085
    		]
    	],
    	[
    		[
    			7545,
    			7578
    		],
    		"valid"
    	],
    	[
    		[
    			7579,
    			7579
    		],
    		"mapped",
    		[
    			594
    		]
    	],
    	[
    		[
    			7580,
    			7580
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			7581,
    			7581
    		],
    		"mapped",
    		[
    			597
    		]
    	],
    	[
    		[
    			7582,
    			7582
    		],
    		"mapped",
    		[
    			240
    		]
    	],
    	[
    		[
    			7583,
    			7583
    		],
    		"mapped",
    		[
    			604
    		]
    	],
    	[
    		[
    			7584,
    			7584
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			7585,
    			7585
    		],
    		"mapped",
    		[
    			607
    		]
    	],
    	[
    		[
    			7586,
    			7586
    		],
    		"mapped",
    		[
    			609
    		]
    	],
    	[
    		[
    			7587,
    			7587
    		],
    		"mapped",
    		[
    			613
    		]
    	],
    	[
    		[
    			7588,
    			7588
    		],
    		"mapped",
    		[
    			616
    		]
    	],
    	[
    		[
    			7589,
    			7589
    		],
    		"mapped",
    		[
    			617
    		]
    	],
    	[
    		[
    			7590,
    			7590
    		],
    		"mapped",
    		[
    			618
    		]
    	],
    	[
    		[
    			7591,
    			7591
    		],
    		"mapped",
    		[
    			7547
    		]
    	],
    	[
    		[
    			7592,
    			7592
    		],
    		"mapped",
    		[
    			669
    		]
    	],
    	[
    		[
    			7593,
    			7593
    		],
    		"mapped",
    		[
    			621
    		]
    	],
    	[
    		[
    			7594,
    			7594
    		],
    		"mapped",
    		[
    			7557
    		]
    	],
    	[
    		[
    			7595,
    			7595
    		],
    		"mapped",
    		[
    			671
    		]
    	],
    	[
    		[
    			7596,
    			7596
    		],
    		"mapped",
    		[
    			625
    		]
    	],
    	[
    		[
    			7597,
    			7597
    		],
    		"mapped",
    		[
    			624
    		]
    	],
    	[
    		[
    			7598,
    			7598
    		],
    		"mapped",
    		[
    			626
    		]
    	],
    	[
    		[
    			7599,
    			7599
    		],
    		"mapped",
    		[
    			627
    		]
    	],
    	[
    		[
    			7600,
    			7600
    		],
    		"mapped",
    		[
    			628
    		]
    	],
    	[
    		[
    			7601,
    			7601
    		],
    		"mapped",
    		[
    			629
    		]
    	],
    	[
    		[
    			7602,
    			7602
    		],
    		"mapped",
    		[
    			632
    		]
    	],
    	[
    		[
    			7603,
    			7603
    		],
    		"mapped",
    		[
    			642
    		]
    	],
    	[
    		[
    			7604,
    			7604
    		],
    		"mapped",
    		[
    			643
    		]
    	],
    	[
    		[
    			7605,
    			7605
    		],
    		"mapped",
    		[
    			427
    		]
    	],
    	[
    		[
    			7606,
    			7606
    		],
    		"mapped",
    		[
    			649
    		]
    	],
    	[
    		[
    			7607,
    			7607
    		],
    		"mapped",
    		[
    			650
    		]
    	],
    	[
    		[
    			7608,
    			7608
    		],
    		"mapped",
    		[
    			7452
    		]
    	],
    	[
    		[
    			7609,
    			7609
    		],
    		"mapped",
    		[
    			651
    		]
    	],
    	[
    		[
    			7610,
    			7610
    		],
    		"mapped",
    		[
    			652
    		]
    	],
    	[
    		[
    			7611,
    			7611
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			7612,
    			7612
    		],
    		"mapped",
    		[
    			656
    		]
    	],
    	[
    		[
    			7613,
    			7613
    		],
    		"mapped",
    		[
    			657
    		]
    	],
    	[
    		[
    			7614,
    			7614
    		],
    		"mapped",
    		[
    			658
    		]
    	],
    	[
    		[
    			7615,
    			7615
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			7616,
    			7619
    		],
    		"valid"
    	],
    	[
    		[
    			7620,
    			7626
    		],
    		"valid"
    	],
    	[
    		[
    			7627,
    			7654
    		],
    		"valid"
    	],
    	[
    		[
    			7655,
    			7669
    		],
    		"valid"
    	],
    	[
    		[
    			7670,
    			7675
    		],
    		"disallowed"
    	],
    	[
    		[
    			7676,
    			7676
    		],
    		"valid"
    	],
    	[
    		[
    			7677,
    			7677
    		],
    		"valid"
    	],
    	[
    		[
    			7678,
    			7679
    		],
    		"valid"
    	],
    	[
    		[
    			7680,
    			7680
    		],
    		"mapped",
    		[
    			7681
    		]
    	],
    	[
    		[
    			7681,
    			7681
    		],
    		"valid"
    	],
    	[
    		[
    			7682,
    			7682
    		],
    		"mapped",
    		[
    			7683
    		]
    	],
    	[
    		[
    			7683,
    			7683
    		],
    		"valid"
    	],
    	[
    		[
    			7684,
    			7684
    		],
    		"mapped",
    		[
    			7685
    		]
    	],
    	[
    		[
    			7685,
    			7685
    		],
    		"valid"
    	],
    	[
    		[
    			7686,
    			7686
    		],
    		"mapped",
    		[
    			7687
    		]
    	],
    	[
    		[
    			7687,
    			7687
    		],
    		"valid"
    	],
    	[
    		[
    			7688,
    			7688
    		],
    		"mapped",
    		[
    			7689
    		]
    	],
    	[
    		[
    			7689,
    			7689
    		],
    		"valid"
    	],
    	[
    		[
    			7690,
    			7690
    		],
    		"mapped",
    		[
    			7691
    		]
    	],
    	[
    		[
    			7691,
    			7691
    		],
    		"valid"
    	],
    	[
    		[
    			7692,
    			7692
    		],
    		"mapped",
    		[
    			7693
    		]
    	],
    	[
    		[
    			7693,
    			7693
    		],
    		"valid"
    	],
    	[
    		[
    			7694,
    			7694
    		],
    		"mapped",
    		[
    			7695
    		]
    	],
    	[
    		[
    			7695,
    			7695
    		],
    		"valid"
    	],
    	[
    		[
    			7696,
    			7696
    		],
    		"mapped",
    		[
    			7697
    		]
    	],
    	[
    		[
    			7697,
    			7697
    		],
    		"valid"
    	],
    	[
    		[
    			7698,
    			7698
    		],
    		"mapped",
    		[
    			7699
    		]
    	],
    	[
    		[
    			7699,
    			7699
    		],
    		"valid"
    	],
    	[
    		[
    			7700,
    			7700
    		],
    		"mapped",
    		[
    			7701
    		]
    	],
    	[
    		[
    			7701,
    			7701
    		],
    		"valid"
    	],
    	[
    		[
    			7702,
    			7702
    		],
    		"mapped",
    		[
    			7703
    		]
    	],
    	[
    		[
    			7703,
    			7703
    		],
    		"valid"
    	],
    	[
    		[
    			7704,
    			7704
    		],
    		"mapped",
    		[
    			7705
    		]
    	],
    	[
    		[
    			7705,
    			7705
    		],
    		"valid"
    	],
    	[
    		[
    			7706,
    			7706
    		],
    		"mapped",
    		[
    			7707
    		]
    	],
    	[
    		[
    			7707,
    			7707
    		],
    		"valid"
    	],
    	[
    		[
    			7708,
    			7708
    		],
    		"mapped",
    		[
    			7709
    		]
    	],
    	[
    		[
    			7709,
    			7709
    		],
    		"valid"
    	],
    	[
    		[
    			7710,
    			7710
    		],
    		"mapped",
    		[
    			7711
    		]
    	],
    	[
    		[
    			7711,
    			7711
    		],
    		"valid"
    	],
    	[
    		[
    			7712,
    			7712
    		],
    		"mapped",
    		[
    			7713
    		]
    	],
    	[
    		[
    			7713,
    			7713
    		],
    		"valid"
    	],
    	[
    		[
    			7714,
    			7714
    		],
    		"mapped",
    		[
    			7715
    		]
    	],
    	[
    		[
    			7715,
    			7715
    		],
    		"valid"
    	],
    	[
    		[
    			7716,
    			7716
    		],
    		"mapped",
    		[
    			7717
    		]
    	],
    	[
    		[
    			7717,
    			7717
    		],
    		"valid"
    	],
    	[
    		[
    			7718,
    			7718
    		],
    		"mapped",
    		[
    			7719
    		]
    	],
    	[
    		[
    			7719,
    			7719
    		],
    		"valid"
    	],
    	[
    		[
    			7720,
    			7720
    		],
    		"mapped",
    		[
    			7721
    		]
    	],
    	[
    		[
    			7721,
    			7721
    		],
    		"valid"
    	],
    	[
    		[
    			7722,
    			7722
    		],
    		"mapped",
    		[
    			7723
    		]
    	],
    	[
    		[
    			7723,
    			7723
    		],
    		"valid"
    	],
    	[
    		[
    			7724,
    			7724
    		],
    		"mapped",
    		[
    			7725
    		]
    	],
    	[
    		[
    			7725,
    			7725
    		],
    		"valid"
    	],
    	[
    		[
    			7726,
    			7726
    		],
    		"mapped",
    		[
    			7727
    		]
    	],
    	[
    		[
    			7727,
    			7727
    		],
    		"valid"
    	],
    	[
    		[
    			7728,
    			7728
    		],
    		"mapped",
    		[
    			7729
    		]
    	],
    	[
    		[
    			7729,
    			7729
    		],
    		"valid"
    	],
    	[
    		[
    			7730,
    			7730
    		],
    		"mapped",
    		[
    			7731
    		]
    	],
    	[
    		[
    			7731,
    			7731
    		],
    		"valid"
    	],
    	[
    		[
    			7732,
    			7732
    		],
    		"mapped",
    		[
    			7733
    		]
    	],
    	[
    		[
    			7733,
    			7733
    		],
    		"valid"
    	],
    	[
    		[
    			7734,
    			7734
    		],
    		"mapped",
    		[
    			7735
    		]
    	],
    	[
    		[
    			7735,
    			7735
    		],
    		"valid"
    	],
    	[
    		[
    			7736,
    			7736
    		],
    		"mapped",
    		[
    			7737
    		]
    	],
    	[
    		[
    			7737,
    			7737
    		],
    		"valid"
    	],
    	[
    		[
    			7738,
    			7738
    		],
    		"mapped",
    		[
    			7739
    		]
    	],
    	[
    		[
    			7739,
    			7739
    		],
    		"valid"
    	],
    	[
    		[
    			7740,
    			7740
    		],
    		"mapped",
    		[
    			7741
    		]
    	],
    	[
    		[
    			7741,
    			7741
    		],
    		"valid"
    	],
    	[
    		[
    			7742,
    			7742
    		],
    		"mapped",
    		[
    			7743
    		]
    	],
    	[
    		[
    			7743,
    			7743
    		],
    		"valid"
    	],
    	[
    		[
    			7744,
    			7744
    		],
    		"mapped",
    		[
    			7745
    		]
    	],
    	[
    		[
    			7745,
    			7745
    		],
    		"valid"
    	],
    	[
    		[
    			7746,
    			7746
    		],
    		"mapped",
    		[
    			7747
    		]
    	],
    	[
    		[
    			7747,
    			7747
    		],
    		"valid"
    	],
    	[
    		[
    			7748,
    			7748
    		],
    		"mapped",
    		[
    			7749
    		]
    	],
    	[
    		[
    			7749,
    			7749
    		],
    		"valid"
    	],
    	[
    		[
    			7750,
    			7750
    		],
    		"mapped",
    		[
    			7751
    		]
    	],
    	[
    		[
    			7751,
    			7751
    		],
    		"valid"
    	],
    	[
    		[
    			7752,
    			7752
    		],
    		"mapped",
    		[
    			7753
    		]
    	],
    	[
    		[
    			7753,
    			7753
    		],
    		"valid"
    	],
    	[
    		[
    			7754,
    			7754
    		],
    		"mapped",
    		[
    			7755
    		]
    	],
    	[
    		[
    			7755,
    			7755
    		],
    		"valid"
    	],
    	[
    		[
    			7756,
    			7756
    		],
    		"mapped",
    		[
    			7757
    		]
    	],
    	[
    		[
    			7757,
    			7757
    		],
    		"valid"
    	],
    	[
    		[
    			7758,
    			7758
    		],
    		"mapped",
    		[
    			7759
    		]
    	],
    	[
    		[
    			7759,
    			7759
    		],
    		"valid"
    	],
    	[
    		[
    			7760,
    			7760
    		],
    		"mapped",
    		[
    			7761
    		]
    	],
    	[
    		[
    			7761,
    			7761
    		],
    		"valid"
    	],
    	[
    		[
    			7762,
    			7762
    		],
    		"mapped",
    		[
    			7763
    		]
    	],
    	[
    		[
    			7763,
    			7763
    		],
    		"valid"
    	],
    	[
    		[
    			7764,
    			7764
    		],
    		"mapped",
    		[
    			7765
    		]
    	],
    	[
    		[
    			7765,
    			7765
    		],
    		"valid"
    	],
    	[
    		[
    			7766,
    			7766
    		],
    		"mapped",
    		[
    			7767
    		]
    	],
    	[
    		[
    			7767,
    			7767
    		],
    		"valid"
    	],
    	[
    		[
    			7768,
    			7768
    		],
    		"mapped",
    		[
    			7769
    		]
    	],
    	[
    		[
    			7769,
    			7769
    		],
    		"valid"
    	],
    	[
    		[
    			7770,
    			7770
    		],
    		"mapped",
    		[
    			7771
    		]
    	],
    	[
    		[
    			7771,
    			7771
    		],
    		"valid"
    	],
    	[
    		[
    			7772,
    			7772
    		],
    		"mapped",
    		[
    			7773
    		]
    	],
    	[
    		[
    			7773,
    			7773
    		],
    		"valid"
    	],
    	[
    		[
    			7774,
    			7774
    		],
    		"mapped",
    		[
    			7775
    		]
    	],
    	[
    		[
    			7775,
    			7775
    		],
    		"valid"
    	],
    	[
    		[
    			7776,
    			7776
    		],
    		"mapped",
    		[
    			7777
    		]
    	],
    	[
    		[
    			7777,
    			7777
    		],
    		"valid"
    	],
    	[
    		[
    			7778,
    			7778
    		],
    		"mapped",
    		[
    			7779
    		]
    	],
    	[
    		[
    			7779,
    			7779
    		],
    		"valid"
    	],
    	[
    		[
    			7780,
    			7780
    		],
    		"mapped",
    		[
    			7781
    		]
    	],
    	[
    		[
    			7781,
    			7781
    		],
    		"valid"
    	],
    	[
    		[
    			7782,
    			7782
    		],
    		"mapped",
    		[
    			7783
    		]
    	],
    	[
    		[
    			7783,
    			7783
    		],
    		"valid"
    	],
    	[
    		[
    			7784,
    			7784
    		],
    		"mapped",
    		[
    			7785
    		]
    	],
    	[
    		[
    			7785,
    			7785
    		],
    		"valid"
    	],
    	[
    		[
    			7786,
    			7786
    		],
    		"mapped",
    		[
    			7787
    		]
    	],
    	[
    		[
    			7787,
    			7787
    		],
    		"valid"
    	],
    	[
    		[
    			7788,
    			7788
    		],
    		"mapped",
    		[
    			7789
    		]
    	],
    	[
    		[
    			7789,
    			7789
    		],
    		"valid"
    	],
    	[
    		[
    			7790,
    			7790
    		],
    		"mapped",
    		[
    			7791
    		]
    	],
    	[
    		[
    			7791,
    			7791
    		],
    		"valid"
    	],
    	[
    		[
    			7792,
    			7792
    		],
    		"mapped",
    		[
    			7793
    		]
    	],
    	[
    		[
    			7793,
    			7793
    		],
    		"valid"
    	],
    	[
    		[
    			7794,
    			7794
    		],
    		"mapped",
    		[
    			7795
    		]
    	],
    	[
    		[
    			7795,
    			7795
    		],
    		"valid"
    	],
    	[
    		[
    			7796,
    			7796
    		],
    		"mapped",
    		[
    			7797
    		]
    	],
    	[
    		[
    			7797,
    			7797
    		],
    		"valid"
    	],
    	[
    		[
    			7798,
    			7798
    		],
    		"mapped",
    		[
    			7799
    		]
    	],
    	[
    		[
    			7799,
    			7799
    		],
    		"valid"
    	],
    	[
    		[
    			7800,
    			7800
    		],
    		"mapped",
    		[
    			7801
    		]
    	],
    	[
    		[
    			7801,
    			7801
    		],
    		"valid"
    	],
    	[
    		[
    			7802,
    			7802
    		],
    		"mapped",
    		[
    			7803
    		]
    	],
    	[
    		[
    			7803,
    			7803
    		],
    		"valid"
    	],
    	[
    		[
    			7804,
    			7804
    		],
    		"mapped",
    		[
    			7805
    		]
    	],
    	[
    		[
    			7805,
    			7805
    		],
    		"valid"
    	],
    	[
    		[
    			7806,
    			7806
    		],
    		"mapped",
    		[
    			7807
    		]
    	],
    	[
    		[
    			7807,
    			7807
    		],
    		"valid"
    	],
    	[
    		[
    			7808,
    			7808
    		],
    		"mapped",
    		[
    			7809
    		]
    	],
    	[
    		[
    			7809,
    			7809
    		],
    		"valid"
    	],
    	[
    		[
    			7810,
    			7810
    		],
    		"mapped",
    		[
    			7811
    		]
    	],
    	[
    		[
    			7811,
    			7811
    		],
    		"valid"
    	],
    	[
    		[
    			7812,
    			7812
    		],
    		"mapped",
    		[
    			7813
    		]
    	],
    	[
    		[
    			7813,
    			7813
    		],
    		"valid"
    	],
    	[
    		[
    			7814,
    			7814
    		],
    		"mapped",
    		[
    			7815
    		]
    	],
    	[
    		[
    			7815,
    			7815
    		],
    		"valid"
    	],
    	[
    		[
    			7816,
    			7816
    		],
    		"mapped",
    		[
    			7817
    		]
    	],
    	[
    		[
    			7817,
    			7817
    		],
    		"valid"
    	],
    	[
    		[
    			7818,
    			7818
    		],
    		"mapped",
    		[
    			7819
    		]
    	],
    	[
    		[
    			7819,
    			7819
    		],
    		"valid"
    	],
    	[
    		[
    			7820,
    			7820
    		],
    		"mapped",
    		[
    			7821
    		]
    	],
    	[
    		[
    			7821,
    			7821
    		],
    		"valid"
    	],
    	[
    		[
    			7822,
    			7822
    		],
    		"mapped",
    		[
    			7823
    		]
    	],
    	[
    		[
    			7823,
    			7823
    		],
    		"valid"
    	],
    	[
    		[
    			7824,
    			7824
    		],
    		"mapped",
    		[
    			7825
    		]
    	],
    	[
    		[
    			7825,
    			7825
    		],
    		"valid"
    	],
    	[
    		[
    			7826,
    			7826
    		],
    		"mapped",
    		[
    			7827
    		]
    	],
    	[
    		[
    			7827,
    			7827
    		],
    		"valid"
    	],
    	[
    		[
    			7828,
    			7828
    		],
    		"mapped",
    		[
    			7829
    		]
    	],
    	[
    		[
    			7829,
    			7833
    		],
    		"valid"
    	],
    	[
    		[
    			7834,
    			7834
    		],
    		"mapped",
    		[
    			97,
    			702
    		]
    	],
    	[
    		[
    			7835,
    			7835
    		],
    		"mapped",
    		[
    			7777
    		]
    	],
    	[
    		[
    			7836,
    			7837
    		],
    		"valid"
    	],
    	[
    		[
    			7838,
    			7838
    		],
    		"mapped",
    		[
    			115,
    			115
    		]
    	],
    	[
    		[
    			7839,
    			7839
    		],
    		"valid"
    	],
    	[
    		[
    			7840,
    			7840
    		],
    		"mapped",
    		[
    			7841
    		]
    	],
    	[
    		[
    			7841,
    			7841
    		],
    		"valid"
    	],
    	[
    		[
    			7842,
    			7842
    		],
    		"mapped",
    		[
    			7843
    		]
    	],
    	[
    		[
    			7843,
    			7843
    		],
    		"valid"
    	],
    	[
    		[
    			7844,
    			7844
    		],
    		"mapped",
    		[
    			7845
    		]
    	],
    	[
    		[
    			7845,
    			7845
    		],
    		"valid"
    	],
    	[
    		[
    			7846,
    			7846
    		],
    		"mapped",
    		[
    			7847
    		]
    	],
    	[
    		[
    			7847,
    			7847
    		],
    		"valid"
    	],
    	[
    		[
    			7848,
    			7848
    		],
    		"mapped",
    		[
    			7849
    		]
    	],
    	[
    		[
    			7849,
    			7849
    		],
    		"valid"
    	],
    	[
    		[
    			7850,
    			7850
    		],
    		"mapped",
    		[
    			7851
    		]
    	],
    	[
    		[
    			7851,
    			7851
    		],
    		"valid"
    	],
    	[
    		[
    			7852,
    			7852
    		],
    		"mapped",
    		[
    			7853
    		]
    	],
    	[
    		[
    			7853,
    			7853
    		],
    		"valid"
    	],
    	[
    		[
    			7854,
    			7854
    		],
    		"mapped",
    		[
    			7855
    		]
    	],
    	[
    		[
    			7855,
    			7855
    		],
    		"valid"
    	],
    	[
    		[
    			7856,
    			7856
    		],
    		"mapped",
    		[
    			7857
    		]
    	],
    	[
    		[
    			7857,
    			7857
    		],
    		"valid"
    	],
    	[
    		[
    			7858,
    			7858
    		],
    		"mapped",
    		[
    			7859
    		]
    	],
    	[
    		[
    			7859,
    			7859
    		],
    		"valid"
    	],
    	[
    		[
    			7860,
    			7860
    		],
    		"mapped",
    		[
    			7861
    		]
    	],
    	[
    		[
    			7861,
    			7861
    		],
    		"valid"
    	],
    	[
    		[
    			7862,
    			7862
    		],
    		"mapped",
    		[
    			7863
    		]
    	],
    	[
    		[
    			7863,
    			7863
    		],
    		"valid"
    	],
    	[
    		[
    			7864,
    			7864
    		],
    		"mapped",
    		[
    			7865
    		]
    	],
    	[
    		[
    			7865,
    			7865
    		],
    		"valid"
    	],
    	[
    		[
    			7866,
    			7866
    		],
    		"mapped",
    		[
    			7867
    		]
    	],
    	[
    		[
    			7867,
    			7867
    		],
    		"valid"
    	],
    	[
    		[
    			7868,
    			7868
    		],
    		"mapped",
    		[
    			7869
    		]
    	],
    	[
    		[
    			7869,
    			7869
    		],
    		"valid"
    	],
    	[
    		[
    			7870,
    			7870
    		],
    		"mapped",
    		[
    			7871
    		]
    	],
    	[
    		[
    			7871,
    			7871
    		],
    		"valid"
    	],
    	[
    		[
    			7872,
    			7872
    		],
    		"mapped",
    		[
    			7873
    		]
    	],
    	[
    		[
    			7873,
    			7873
    		],
    		"valid"
    	],
    	[
    		[
    			7874,
    			7874
    		],
    		"mapped",
    		[
    			7875
    		]
    	],
    	[
    		[
    			7875,
    			7875
    		],
    		"valid"
    	],
    	[
    		[
    			7876,
    			7876
    		],
    		"mapped",
    		[
    			7877
    		]
    	],
    	[
    		[
    			7877,
    			7877
    		],
    		"valid"
    	],
    	[
    		[
    			7878,
    			7878
    		],
    		"mapped",
    		[
    			7879
    		]
    	],
    	[
    		[
    			7879,
    			7879
    		],
    		"valid"
    	],
    	[
    		[
    			7880,
    			7880
    		],
    		"mapped",
    		[
    			7881
    		]
    	],
    	[
    		[
    			7881,
    			7881
    		],
    		"valid"
    	],
    	[
    		[
    			7882,
    			7882
    		],
    		"mapped",
    		[
    			7883
    		]
    	],
    	[
    		[
    			7883,
    			7883
    		],
    		"valid"
    	],
    	[
    		[
    			7884,
    			7884
    		],
    		"mapped",
    		[
    			7885
    		]
    	],
    	[
    		[
    			7885,
    			7885
    		],
    		"valid"
    	],
    	[
    		[
    			7886,
    			7886
    		],
    		"mapped",
    		[
    			7887
    		]
    	],
    	[
    		[
    			7887,
    			7887
    		],
    		"valid"
    	],
    	[
    		[
    			7888,
    			7888
    		],
    		"mapped",
    		[
    			7889
    		]
    	],
    	[
    		[
    			7889,
    			7889
    		],
    		"valid"
    	],
    	[
    		[
    			7890,
    			7890
    		],
    		"mapped",
    		[
    			7891
    		]
    	],
    	[
    		[
    			7891,
    			7891
    		],
    		"valid"
    	],
    	[
    		[
    			7892,
    			7892
    		],
    		"mapped",
    		[
    			7893
    		]
    	],
    	[
    		[
    			7893,
    			7893
    		],
    		"valid"
    	],
    	[
    		[
    			7894,
    			7894
    		],
    		"mapped",
    		[
    			7895
    		]
    	],
    	[
    		[
    			7895,
    			7895
    		],
    		"valid"
    	],
    	[
    		[
    			7896,
    			7896
    		],
    		"mapped",
    		[
    			7897
    		]
    	],
    	[
    		[
    			7897,
    			7897
    		],
    		"valid"
    	],
    	[
    		[
    			7898,
    			7898
    		],
    		"mapped",
    		[
    			7899
    		]
    	],
    	[
    		[
    			7899,
    			7899
    		],
    		"valid"
    	],
    	[
    		[
    			7900,
    			7900
    		],
    		"mapped",
    		[
    			7901
    		]
    	],
    	[
    		[
    			7901,
    			7901
    		],
    		"valid"
    	],
    	[
    		[
    			7902,
    			7902
    		],
    		"mapped",
    		[
    			7903
    		]
    	],
    	[
    		[
    			7903,
    			7903
    		],
    		"valid"
    	],
    	[
    		[
    			7904,
    			7904
    		],
    		"mapped",
    		[
    			7905
    		]
    	],
    	[
    		[
    			7905,
    			7905
    		],
    		"valid"
    	],
    	[
    		[
    			7906,
    			7906
    		],
    		"mapped",
    		[
    			7907
    		]
    	],
    	[
    		[
    			7907,
    			7907
    		],
    		"valid"
    	],
    	[
    		[
    			7908,
    			7908
    		],
    		"mapped",
    		[
    			7909
    		]
    	],
    	[
    		[
    			7909,
    			7909
    		],
    		"valid"
    	],
    	[
    		[
    			7910,
    			7910
    		],
    		"mapped",
    		[
    			7911
    		]
    	],
    	[
    		[
    			7911,
    			7911
    		],
    		"valid"
    	],
    	[
    		[
    			7912,
    			7912
    		],
    		"mapped",
    		[
    			7913
    		]
    	],
    	[
    		[
    			7913,
    			7913
    		],
    		"valid"
    	],
    	[
    		[
    			7914,
    			7914
    		],
    		"mapped",
    		[
    			7915
    		]
    	],
    	[
    		[
    			7915,
    			7915
    		],
    		"valid"
    	],
    	[
    		[
    			7916,
    			7916
    		],
    		"mapped",
    		[
    			7917
    		]
    	],
    	[
    		[
    			7917,
    			7917
    		],
    		"valid"
    	],
    	[
    		[
    			7918,
    			7918
    		],
    		"mapped",
    		[
    			7919
    		]
    	],
    	[
    		[
    			7919,
    			7919
    		],
    		"valid"
    	],
    	[
    		[
    			7920,
    			7920
    		],
    		"mapped",
    		[
    			7921
    		]
    	],
    	[
    		[
    			7921,
    			7921
    		],
    		"valid"
    	],
    	[
    		[
    			7922,
    			7922
    		],
    		"mapped",
    		[
    			7923
    		]
    	],
    	[
    		[
    			7923,
    			7923
    		],
    		"valid"
    	],
    	[
    		[
    			7924,
    			7924
    		],
    		"mapped",
    		[
    			7925
    		]
    	],
    	[
    		[
    			7925,
    			7925
    		],
    		"valid"
    	],
    	[
    		[
    			7926,
    			7926
    		],
    		"mapped",
    		[
    			7927
    		]
    	],
    	[
    		[
    			7927,
    			7927
    		],
    		"valid"
    	],
    	[
    		[
    			7928,
    			7928
    		],
    		"mapped",
    		[
    			7929
    		]
    	],
    	[
    		[
    			7929,
    			7929
    		],
    		"valid"
    	],
    	[
    		[
    			7930,
    			7930
    		],
    		"mapped",
    		[
    			7931
    		]
    	],
    	[
    		[
    			7931,
    			7931
    		],
    		"valid"
    	],
    	[
    		[
    			7932,
    			7932
    		],
    		"mapped",
    		[
    			7933
    		]
    	],
    	[
    		[
    			7933,
    			7933
    		],
    		"valid"
    	],
    	[
    		[
    			7934,
    			7934
    		],
    		"mapped",
    		[
    			7935
    		]
    	],
    	[
    		[
    			7935,
    			7935
    		],
    		"valid"
    	],
    	[
    		[
    			7936,
    			7943
    		],
    		"valid"
    	],
    	[
    		[
    			7944,
    			7944
    		],
    		"mapped",
    		[
    			7936
    		]
    	],
    	[
    		[
    			7945,
    			7945
    		],
    		"mapped",
    		[
    			7937
    		]
    	],
    	[
    		[
    			7946,
    			7946
    		],
    		"mapped",
    		[
    			7938
    		]
    	],
    	[
    		[
    			7947,
    			7947
    		],
    		"mapped",
    		[
    			7939
    		]
    	],
    	[
    		[
    			7948,
    			7948
    		],
    		"mapped",
    		[
    			7940
    		]
    	],
    	[
    		[
    			7949,
    			7949
    		],
    		"mapped",
    		[
    			7941
    		]
    	],
    	[
    		[
    			7950,
    			7950
    		],
    		"mapped",
    		[
    			7942
    		]
    	],
    	[
    		[
    			7951,
    			7951
    		],
    		"mapped",
    		[
    			7943
    		]
    	],
    	[
    		[
    			7952,
    			7957
    		],
    		"valid"
    	],
    	[
    		[
    			7958,
    			7959
    		],
    		"disallowed"
    	],
    	[
    		[
    			7960,
    			7960
    		],
    		"mapped",
    		[
    			7952
    		]
    	],
    	[
    		[
    			7961,
    			7961
    		],
    		"mapped",
    		[
    			7953
    		]
    	],
    	[
    		[
    			7962,
    			7962
    		],
    		"mapped",
    		[
    			7954
    		]
    	],
    	[
    		[
    			7963,
    			7963
    		],
    		"mapped",
    		[
    			7955
    		]
    	],
    	[
    		[
    			7964,
    			7964
    		],
    		"mapped",
    		[
    			7956
    		]
    	],
    	[
    		[
    			7965,
    			7965
    		],
    		"mapped",
    		[
    			7957
    		]
    	],
    	[
    		[
    			7966,
    			7967
    		],
    		"disallowed"
    	],
    	[
    		[
    			7968,
    			7975
    		],
    		"valid"
    	],
    	[
    		[
    			7976,
    			7976
    		],
    		"mapped",
    		[
    			7968
    		]
    	],
    	[
    		[
    			7977,
    			7977
    		],
    		"mapped",
    		[
    			7969
    		]
    	],
    	[
    		[
    			7978,
    			7978
    		],
    		"mapped",
    		[
    			7970
    		]
    	],
    	[
    		[
    			7979,
    			7979
    		],
    		"mapped",
    		[
    			7971
    		]
    	],
    	[
    		[
    			7980,
    			7980
    		],
    		"mapped",
    		[
    			7972
    		]
    	],
    	[
    		[
    			7981,
    			7981
    		],
    		"mapped",
    		[
    			7973
    		]
    	],
    	[
    		[
    			7982,
    			7982
    		],
    		"mapped",
    		[
    			7974
    		]
    	],
    	[
    		[
    			7983,
    			7983
    		],
    		"mapped",
    		[
    			7975
    		]
    	],
    	[
    		[
    			7984,
    			7991
    		],
    		"valid"
    	],
    	[
    		[
    			7992,
    			7992
    		],
    		"mapped",
    		[
    			7984
    		]
    	],
    	[
    		[
    			7993,
    			7993
    		],
    		"mapped",
    		[
    			7985
    		]
    	],
    	[
    		[
    			7994,
    			7994
    		],
    		"mapped",
    		[
    			7986
    		]
    	],
    	[
    		[
    			7995,
    			7995
    		],
    		"mapped",
    		[
    			7987
    		]
    	],
    	[
    		[
    			7996,
    			7996
    		],
    		"mapped",
    		[
    			7988
    		]
    	],
    	[
    		[
    			7997,
    			7997
    		],
    		"mapped",
    		[
    			7989
    		]
    	],
    	[
    		[
    			7998,
    			7998
    		],
    		"mapped",
    		[
    			7990
    		]
    	],
    	[
    		[
    			7999,
    			7999
    		],
    		"mapped",
    		[
    			7991
    		]
    	],
    	[
    		[
    			8000,
    			8005
    		],
    		"valid"
    	],
    	[
    		[
    			8006,
    			8007
    		],
    		"disallowed"
    	],
    	[
    		[
    			8008,
    			8008
    		],
    		"mapped",
    		[
    			8000
    		]
    	],
    	[
    		[
    			8009,
    			8009
    		],
    		"mapped",
    		[
    			8001
    		]
    	],
    	[
    		[
    			8010,
    			8010
    		],
    		"mapped",
    		[
    			8002
    		]
    	],
    	[
    		[
    			8011,
    			8011
    		],
    		"mapped",
    		[
    			8003
    		]
    	],
    	[
    		[
    			8012,
    			8012
    		],
    		"mapped",
    		[
    			8004
    		]
    	],
    	[
    		[
    			8013,
    			8013
    		],
    		"mapped",
    		[
    			8005
    		]
    	],
    	[
    		[
    			8014,
    			8015
    		],
    		"disallowed"
    	],
    	[
    		[
    			8016,
    			8023
    		],
    		"valid"
    	],
    	[
    		[
    			8024,
    			8024
    		],
    		"disallowed"
    	],
    	[
    		[
    			8025,
    			8025
    		],
    		"mapped",
    		[
    			8017
    		]
    	],
    	[
    		[
    			8026,
    			8026
    		],
    		"disallowed"
    	],
    	[
    		[
    			8027,
    			8027
    		],
    		"mapped",
    		[
    			8019
    		]
    	],
    	[
    		[
    			8028,
    			8028
    		],
    		"disallowed"
    	],
    	[
    		[
    			8029,
    			8029
    		],
    		"mapped",
    		[
    			8021
    		]
    	],
    	[
    		[
    			8030,
    			8030
    		],
    		"disallowed"
    	],
    	[
    		[
    			8031,
    			8031
    		],
    		"mapped",
    		[
    			8023
    		]
    	],
    	[
    		[
    			8032,
    			8039
    		],
    		"valid"
    	],
    	[
    		[
    			8040,
    			8040
    		],
    		"mapped",
    		[
    			8032
    		]
    	],
    	[
    		[
    			8041,
    			8041
    		],
    		"mapped",
    		[
    			8033
    		]
    	],
    	[
    		[
    			8042,
    			8042
    		],
    		"mapped",
    		[
    			8034
    		]
    	],
    	[
    		[
    			8043,
    			8043
    		],
    		"mapped",
    		[
    			8035
    		]
    	],
    	[
    		[
    			8044,
    			8044
    		],
    		"mapped",
    		[
    			8036
    		]
    	],
    	[
    		[
    			8045,
    			8045
    		],
    		"mapped",
    		[
    			8037
    		]
    	],
    	[
    		[
    			8046,
    			8046
    		],
    		"mapped",
    		[
    			8038
    		]
    	],
    	[
    		[
    			8047,
    			8047
    		],
    		"mapped",
    		[
    			8039
    		]
    	],
    	[
    		[
    			8048,
    			8048
    		],
    		"valid"
    	],
    	[
    		[
    			8049,
    			8049
    		],
    		"mapped",
    		[
    			940
    		]
    	],
    	[
    		[
    			8050,
    			8050
    		],
    		"valid"
    	],
    	[
    		[
    			8051,
    			8051
    		],
    		"mapped",
    		[
    			941
    		]
    	],
    	[
    		[
    			8052,
    			8052
    		],
    		"valid"
    	],
    	[
    		[
    			8053,
    			8053
    		],
    		"mapped",
    		[
    			942
    		]
    	],
    	[
    		[
    			8054,
    			8054
    		],
    		"valid"
    	],
    	[
    		[
    			8055,
    			8055
    		],
    		"mapped",
    		[
    			943
    		]
    	],
    	[
    		[
    			8056,
    			8056
    		],
    		"valid"
    	],
    	[
    		[
    			8057,
    			8057
    		],
    		"mapped",
    		[
    			972
    		]
    	],
    	[
    		[
    			8058,
    			8058
    		],
    		"valid"
    	],
    	[
    		[
    			8059,
    			8059
    		],
    		"mapped",
    		[
    			973
    		]
    	],
    	[
    		[
    			8060,
    			8060
    		],
    		"valid"
    	],
    	[
    		[
    			8061,
    			8061
    		],
    		"mapped",
    		[
    			974
    		]
    	],
    	[
    		[
    			8062,
    			8063
    		],
    		"disallowed"
    	],
    	[
    		[
    			8064,
    			8064
    		],
    		"mapped",
    		[
    			7936,
    			953
    		]
    	],
    	[
    		[
    			8065,
    			8065
    		],
    		"mapped",
    		[
    			7937,
    			953
    		]
    	],
    	[
    		[
    			8066,
    			8066
    		],
    		"mapped",
    		[
    			7938,
    			953
    		]
    	],
    	[
    		[
    			8067,
    			8067
    		],
    		"mapped",
    		[
    			7939,
    			953
    		]
    	],
    	[
    		[
    			8068,
    			8068
    		],
    		"mapped",
    		[
    			7940,
    			953
    		]
    	],
    	[
    		[
    			8069,
    			8069
    		],
    		"mapped",
    		[
    			7941,
    			953
    		]
    	],
    	[
    		[
    			8070,
    			8070
    		],
    		"mapped",
    		[
    			7942,
    			953
    		]
    	],
    	[
    		[
    			8071,
    			8071
    		],
    		"mapped",
    		[
    			7943,
    			953
    		]
    	],
    	[
    		[
    			8072,
    			8072
    		],
    		"mapped",
    		[
    			7936,
    			953
    		]
    	],
    	[
    		[
    			8073,
    			8073
    		],
    		"mapped",
    		[
    			7937,
    			953
    		]
    	],
    	[
    		[
    			8074,
    			8074
    		],
    		"mapped",
    		[
    			7938,
    			953
    		]
    	],
    	[
    		[
    			8075,
    			8075
    		],
    		"mapped",
    		[
    			7939,
    			953
    		]
    	],
    	[
    		[
    			8076,
    			8076
    		],
    		"mapped",
    		[
    			7940,
    			953
    		]
    	],
    	[
    		[
    			8077,
    			8077
    		],
    		"mapped",
    		[
    			7941,
    			953
    		]
    	],
    	[
    		[
    			8078,
    			8078
    		],
    		"mapped",
    		[
    			7942,
    			953
    		]
    	],
    	[
    		[
    			8079,
    			8079
    		],
    		"mapped",
    		[
    			7943,
    			953
    		]
    	],
    	[
    		[
    			8080,
    			8080
    		],
    		"mapped",
    		[
    			7968,
    			953
    		]
    	],
    	[
    		[
    			8081,
    			8081
    		],
    		"mapped",
    		[
    			7969,
    			953
    		]
    	],
    	[
    		[
    			8082,
    			8082
    		],
    		"mapped",
    		[
    			7970,
    			953
    		]
    	],
    	[
    		[
    			8083,
    			8083
    		],
    		"mapped",
    		[
    			7971,
    			953
    		]
    	],
    	[
    		[
    			8084,
    			8084
    		],
    		"mapped",
    		[
    			7972,
    			953
    		]
    	],
    	[
    		[
    			8085,
    			8085
    		],
    		"mapped",
    		[
    			7973,
    			953
    		]
    	],
    	[
    		[
    			8086,
    			8086
    		],
    		"mapped",
    		[
    			7974,
    			953
    		]
    	],
    	[
    		[
    			8087,
    			8087
    		],
    		"mapped",
    		[
    			7975,
    			953
    		]
    	],
    	[
    		[
    			8088,
    			8088
    		],
    		"mapped",
    		[
    			7968,
    			953
    		]
    	],
    	[
    		[
    			8089,
    			8089
    		],
    		"mapped",
    		[
    			7969,
    			953
    		]
    	],
    	[
    		[
    			8090,
    			8090
    		],
    		"mapped",
    		[
    			7970,
    			953
    		]
    	],
    	[
    		[
    			8091,
    			8091
    		],
    		"mapped",
    		[
    			7971,
    			953
    		]
    	],
    	[
    		[
    			8092,
    			8092
    		],
    		"mapped",
    		[
    			7972,
    			953
    		]
    	],
    	[
    		[
    			8093,
    			8093
    		],
    		"mapped",
    		[
    			7973,
    			953
    		]
    	],
    	[
    		[
    			8094,
    			8094
    		],
    		"mapped",
    		[
    			7974,
    			953
    		]
    	],
    	[
    		[
    			8095,
    			8095
    		],
    		"mapped",
    		[
    			7975,
    			953
    		]
    	],
    	[
    		[
    			8096,
    			8096
    		],
    		"mapped",
    		[
    			8032,
    			953
    		]
    	],
    	[
    		[
    			8097,
    			8097
    		],
    		"mapped",
    		[
    			8033,
    			953
    		]
    	],
    	[
    		[
    			8098,
    			8098
    		],
    		"mapped",
    		[
    			8034,
    			953
    		]
    	],
    	[
    		[
    			8099,
    			8099
    		],
    		"mapped",
    		[
    			8035,
    			953
    		]
    	],
    	[
    		[
    			8100,
    			8100
    		],
    		"mapped",
    		[
    			8036,
    			953
    		]
    	],
    	[
    		[
    			8101,
    			8101
    		],
    		"mapped",
    		[
    			8037,
    			953
    		]
    	],
    	[
    		[
    			8102,
    			8102
    		],
    		"mapped",
    		[
    			8038,
    			953
    		]
    	],
    	[
    		[
    			8103,
    			8103
    		],
    		"mapped",
    		[
    			8039,
    			953
    		]
    	],
    	[
    		[
    			8104,
    			8104
    		],
    		"mapped",
    		[
    			8032,
    			953
    		]
    	],
    	[
    		[
    			8105,
    			8105
    		],
    		"mapped",
    		[
    			8033,
    			953
    		]
    	],
    	[
    		[
    			8106,
    			8106
    		],
    		"mapped",
    		[
    			8034,
    			953
    		]
    	],
    	[
    		[
    			8107,
    			8107
    		],
    		"mapped",
    		[
    			8035,
    			953
    		]
    	],
    	[
    		[
    			8108,
    			8108
    		],
    		"mapped",
    		[
    			8036,
    			953
    		]
    	],
    	[
    		[
    			8109,
    			8109
    		],
    		"mapped",
    		[
    			8037,
    			953
    		]
    	],
    	[
    		[
    			8110,
    			8110
    		],
    		"mapped",
    		[
    			8038,
    			953
    		]
    	],
    	[
    		[
    			8111,
    			8111
    		],
    		"mapped",
    		[
    			8039,
    			953
    		]
    	],
    	[
    		[
    			8112,
    			8113
    		],
    		"valid"
    	],
    	[
    		[
    			8114,
    			8114
    		],
    		"mapped",
    		[
    			8048,
    			953
    		]
    	],
    	[
    		[
    			8115,
    			8115
    		],
    		"mapped",
    		[
    			945,
    			953
    		]
    	],
    	[
    		[
    			8116,
    			8116
    		],
    		"mapped",
    		[
    			940,
    			953
    		]
    	],
    	[
    		[
    			8117,
    			8117
    		],
    		"disallowed"
    	],
    	[
    		[
    			8118,
    			8118
    		],
    		"valid"
    	],
    	[
    		[
    			8119,
    			8119
    		],
    		"mapped",
    		[
    			8118,
    			953
    		]
    	],
    	[
    		[
    			8120,
    			8120
    		],
    		"mapped",
    		[
    			8112
    		]
    	],
    	[
    		[
    			8121,
    			8121
    		],
    		"mapped",
    		[
    			8113
    		]
    	],
    	[
    		[
    			8122,
    			8122
    		],
    		"mapped",
    		[
    			8048
    		]
    	],
    	[
    		[
    			8123,
    			8123
    		],
    		"mapped",
    		[
    			940
    		]
    	],
    	[
    		[
    			8124,
    			8124
    		],
    		"mapped",
    		[
    			945,
    			953
    		]
    	],
    	[
    		[
    			8125,
    			8125
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			787
    		]
    	],
    	[
    		[
    			8126,
    			8126
    		],
    		"mapped",
    		[
    			953
    		]
    	],
    	[
    		[
    			8127,
    			8127
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			787
    		]
    	],
    	[
    		[
    			8128,
    			8128
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			834
    		]
    	],
    	[
    		[
    			8129,
    			8129
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			776,
    			834
    		]
    	],
    	[
    		[
    			8130,
    			8130
    		],
    		"mapped",
    		[
    			8052,
    			953
    		]
    	],
    	[
    		[
    			8131,
    			8131
    		],
    		"mapped",
    		[
    			951,
    			953
    		]
    	],
    	[
    		[
    			8132,
    			8132
    		],
    		"mapped",
    		[
    			942,
    			953
    		]
    	],
    	[
    		[
    			8133,
    			8133
    		],
    		"disallowed"
    	],
    	[
    		[
    			8134,
    			8134
    		],
    		"valid"
    	],
    	[
    		[
    			8135,
    			8135
    		],
    		"mapped",
    		[
    			8134,
    			953
    		]
    	],
    	[
    		[
    			8136,
    			8136
    		],
    		"mapped",
    		[
    			8050
    		]
    	],
    	[
    		[
    			8137,
    			8137
    		],
    		"mapped",
    		[
    			941
    		]
    	],
    	[
    		[
    			8138,
    			8138
    		],
    		"mapped",
    		[
    			8052
    		]
    	],
    	[
    		[
    			8139,
    			8139
    		],
    		"mapped",
    		[
    			942
    		]
    	],
    	[
    		[
    			8140,
    			8140
    		],
    		"mapped",
    		[
    			951,
    			953
    		]
    	],
    	[
    		[
    			8141,
    			8141
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			787,
    			768
    		]
    	],
    	[
    		[
    			8142,
    			8142
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			787,
    			769
    		]
    	],
    	[
    		[
    			8143,
    			8143
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			787,
    			834
    		]
    	],
    	[
    		[
    			8144,
    			8146
    		],
    		"valid"
    	],
    	[
    		[
    			8147,
    			8147
    		],
    		"mapped",
    		[
    			912
    		]
    	],
    	[
    		[
    			8148,
    			8149
    		],
    		"disallowed"
    	],
    	[
    		[
    			8150,
    			8151
    		],
    		"valid"
    	],
    	[
    		[
    			8152,
    			8152
    		],
    		"mapped",
    		[
    			8144
    		]
    	],
    	[
    		[
    			8153,
    			8153
    		],
    		"mapped",
    		[
    			8145
    		]
    	],
    	[
    		[
    			8154,
    			8154
    		],
    		"mapped",
    		[
    			8054
    		]
    	],
    	[
    		[
    			8155,
    			8155
    		],
    		"mapped",
    		[
    			943
    		]
    	],
    	[
    		[
    			8156,
    			8156
    		],
    		"disallowed"
    	],
    	[
    		[
    			8157,
    			8157
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			788,
    			768
    		]
    	],
    	[
    		[
    			8158,
    			8158
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			788,
    			769
    		]
    	],
    	[
    		[
    			8159,
    			8159
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			788,
    			834
    		]
    	],
    	[
    		[
    			8160,
    			8162
    		],
    		"valid"
    	],
    	[
    		[
    			8163,
    			8163
    		],
    		"mapped",
    		[
    			944
    		]
    	],
    	[
    		[
    			8164,
    			8167
    		],
    		"valid"
    	],
    	[
    		[
    			8168,
    			8168
    		],
    		"mapped",
    		[
    			8160
    		]
    	],
    	[
    		[
    			8169,
    			8169
    		],
    		"mapped",
    		[
    			8161
    		]
    	],
    	[
    		[
    			8170,
    			8170
    		],
    		"mapped",
    		[
    			8058
    		]
    	],
    	[
    		[
    			8171,
    			8171
    		],
    		"mapped",
    		[
    			973
    		]
    	],
    	[
    		[
    			8172,
    			8172
    		],
    		"mapped",
    		[
    			8165
    		]
    	],
    	[
    		[
    			8173,
    			8173
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			776,
    			768
    		]
    	],
    	[
    		[
    			8174,
    			8174
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			776,
    			769
    		]
    	],
    	[
    		[
    			8175,
    			8175
    		],
    		"disallowed_STD3_mapped",
    		[
    			96
    		]
    	],
    	[
    		[
    			8176,
    			8177
    		],
    		"disallowed"
    	],
    	[
    		[
    			8178,
    			8178
    		],
    		"mapped",
    		[
    			8060,
    			953
    		]
    	],
    	[
    		[
    			8179,
    			8179
    		],
    		"mapped",
    		[
    			969,
    			953
    		]
    	],
    	[
    		[
    			8180,
    			8180
    		],
    		"mapped",
    		[
    			974,
    			953
    		]
    	],
    	[
    		[
    			8181,
    			8181
    		],
    		"disallowed"
    	],
    	[
    		[
    			8182,
    			8182
    		],
    		"valid"
    	],
    	[
    		[
    			8183,
    			8183
    		],
    		"mapped",
    		[
    			8182,
    			953
    		]
    	],
    	[
    		[
    			8184,
    			8184
    		],
    		"mapped",
    		[
    			8056
    		]
    	],
    	[
    		[
    			8185,
    			8185
    		],
    		"mapped",
    		[
    			972
    		]
    	],
    	[
    		[
    			8186,
    			8186
    		],
    		"mapped",
    		[
    			8060
    		]
    	],
    	[
    		[
    			8187,
    			8187
    		],
    		"mapped",
    		[
    			974
    		]
    	],
    	[
    		[
    			8188,
    			8188
    		],
    		"mapped",
    		[
    			969,
    			953
    		]
    	],
    	[
    		[
    			8189,
    			8189
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			769
    		]
    	],
    	[
    		[
    			8190,
    			8190
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			788
    		]
    	],
    	[
    		[
    			8191,
    			8191
    		],
    		"disallowed"
    	],
    	[
    		[
    			8192,
    			8202
    		],
    		"disallowed_STD3_mapped",
    		[
    			32
    		]
    	],
    	[
    		[
    			8203,
    			8203
    		],
    		"ignored"
    	],
    	[
    		[
    			8204,
    			8205
    		],
    		"deviation",
    		[
    		]
    	],
    	[
    		[
    			8206,
    			8207
    		],
    		"disallowed"
    	],
    	[
    		[
    			8208,
    			8208
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8209,
    			8209
    		],
    		"mapped",
    		[
    			8208
    		]
    	],
    	[
    		[
    			8210,
    			8214
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8215,
    			8215
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			819
    		]
    	],
    	[
    		[
    			8216,
    			8227
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8228,
    			8230
    		],
    		"disallowed"
    	],
    	[
    		[
    			8231,
    			8231
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8232,
    			8238
    		],
    		"disallowed"
    	],
    	[
    		[
    			8239,
    			8239
    		],
    		"disallowed_STD3_mapped",
    		[
    			32
    		]
    	],
    	[
    		[
    			8240,
    			8242
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8243,
    			8243
    		],
    		"mapped",
    		[
    			8242,
    			8242
    		]
    	],
    	[
    		[
    			8244,
    			8244
    		],
    		"mapped",
    		[
    			8242,
    			8242,
    			8242
    		]
    	],
    	[
    		[
    			8245,
    			8245
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8246,
    			8246
    		],
    		"mapped",
    		[
    			8245,
    			8245
    		]
    	],
    	[
    		[
    			8247,
    			8247
    		],
    		"mapped",
    		[
    			8245,
    			8245,
    			8245
    		]
    	],
    	[
    		[
    			8248,
    			8251
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8252,
    			8252
    		],
    		"disallowed_STD3_mapped",
    		[
    			33,
    			33
    		]
    	],
    	[
    		[
    			8253,
    			8253
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8254,
    			8254
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			773
    		]
    	],
    	[
    		[
    			8255,
    			8262
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8263,
    			8263
    		],
    		"disallowed_STD3_mapped",
    		[
    			63,
    			63
    		]
    	],
    	[
    		[
    			8264,
    			8264
    		],
    		"disallowed_STD3_mapped",
    		[
    			63,
    			33
    		]
    	],
    	[
    		[
    			8265,
    			8265
    		],
    		"disallowed_STD3_mapped",
    		[
    			33,
    			63
    		]
    	],
    	[
    		[
    			8266,
    			8269
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8270,
    			8274
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8275,
    			8276
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8277,
    			8278
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8279,
    			8279
    		],
    		"mapped",
    		[
    			8242,
    			8242,
    			8242,
    			8242
    		]
    	],
    	[
    		[
    			8280,
    			8286
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8287,
    			8287
    		],
    		"disallowed_STD3_mapped",
    		[
    			32
    		]
    	],
    	[
    		[
    			8288,
    			8288
    		],
    		"ignored"
    	],
    	[
    		[
    			8289,
    			8291
    		],
    		"disallowed"
    	],
    	[
    		[
    			8292,
    			8292
    		],
    		"ignored"
    	],
    	[
    		[
    			8293,
    			8293
    		],
    		"disallowed"
    	],
    	[
    		[
    			8294,
    			8297
    		],
    		"disallowed"
    	],
    	[
    		[
    			8298,
    			8303
    		],
    		"disallowed"
    	],
    	[
    		[
    			8304,
    			8304
    		],
    		"mapped",
    		[
    			48
    		]
    	],
    	[
    		[
    			8305,
    			8305
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			8306,
    			8307
    		],
    		"disallowed"
    	],
    	[
    		[
    			8308,
    			8308
    		],
    		"mapped",
    		[
    			52
    		]
    	],
    	[
    		[
    			8309,
    			8309
    		],
    		"mapped",
    		[
    			53
    		]
    	],
    	[
    		[
    			8310,
    			8310
    		],
    		"mapped",
    		[
    			54
    		]
    	],
    	[
    		[
    			8311,
    			8311
    		],
    		"mapped",
    		[
    			55
    		]
    	],
    	[
    		[
    			8312,
    			8312
    		],
    		"mapped",
    		[
    			56
    		]
    	],
    	[
    		[
    			8313,
    			8313
    		],
    		"mapped",
    		[
    			57
    		]
    	],
    	[
    		[
    			8314,
    			8314
    		],
    		"disallowed_STD3_mapped",
    		[
    			43
    		]
    	],
    	[
    		[
    			8315,
    			8315
    		],
    		"mapped",
    		[
    			8722
    		]
    	],
    	[
    		[
    			8316,
    			8316
    		],
    		"disallowed_STD3_mapped",
    		[
    			61
    		]
    	],
    	[
    		[
    			8317,
    			8317
    		],
    		"disallowed_STD3_mapped",
    		[
    			40
    		]
    	],
    	[
    		[
    			8318,
    			8318
    		],
    		"disallowed_STD3_mapped",
    		[
    			41
    		]
    	],
    	[
    		[
    			8319,
    			8319
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			8320,
    			8320
    		],
    		"mapped",
    		[
    			48
    		]
    	],
    	[
    		[
    			8321,
    			8321
    		],
    		"mapped",
    		[
    			49
    		]
    	],
    	[
    		[
    			8322,
    			8322
    		],
    		"mapped",
    		[
    			50
    		]
    	],
    	[
    		[
    			8323,
    			8323
    		],
    		"mapped",
    		[
    			51
    		]
    	],
    	[
    		[
    			8324,
    			8324
    		],
    		"mapped",
    		[
    			52
    		]
    	],
    	[
    		[
    			8325,
    			8325
    		],
    		"mapped",
    		[
    			53
    		]
    	],
    	[
    		[
    			8326,
    			8326
    		],
    		"mapped",
    		[
    			54
    		]
    	],
    	[
    		[
    			8327,
    			8327
    		],
    		"mapped",
    		[
    			55
    		]
    	],
    	[
    		[
    			8328,
    			8328
    		],
    		"mapped",
    		[
    			56
    		]
    	],
    	[
    		[
    			8329,
    			8329
    		],
    		"mapped",
    		[
    			57
    		]
    	],
    	[
    		[
    			8330,
    			8330
    		],
    		"disallowed_STD3_mapped",
    		[
    			43
    		]
    	],
    	[
    		[
    			8331,
    			8331
    		],
    		"mapped",
    		[
    			8722
    		]
    	],
    	[
    		[
    			8332,
    			8332
    		],
    		"disallowed_STD3_mapped",
    		[
    			61
    		]
    	],
    	[
    		[
    			8333,
    			8333
    		],
    		"disallowed_STD3_mapped",
    		[
    			40
    		]
    	],
    	[
    		[
    			8334,
    			8334
    		],
    		"disallowed_STD3_mapped",
    		[
    			41
    		]
    	],
    	[
    		[
    			8335,
    			8335
    		],
    		"disallowed"
    	],
    	[
    		[
    			8336,
    			8336
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			8337,
    			8337
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			8338,
    			8338
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			8339,
    			8339
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			8340,
    			8340
    		],
    		"mapped",
    		[
    			601
    		]
    	],
    	[
    		[
    			8341,
    			8341
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			8342,
    			8342
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			8343,
    			8343
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			8344,
    			8344
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			8345,
    			8345
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			8346,
    			8346
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			8347,
    			8347
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			8348,
    			8348
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			8349,
    			8351
    		],
    		"disallowed"
    	],
    	[
    		[
    			8352,
    			8359
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8360,
    			8360
    		],
    		"mapped",
    		[
    			114,
    			115
    		]
    	],
    	[
    		[
    			8361,
    			8362
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8363,
    			8363
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8364,
    			8364
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8365,
    			8367
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8368,
    			8369
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8370,
    			8373
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8374,
    			8376
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8377,
    			8377
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8378,
    			8378
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8379,
    			8381
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8382,
    			8382
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8383,
    			8399
    		],
    		"disallowed"
    	],
    	[
    		[
    			8400,
    			8417
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8418,
    			8419
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8420,
    			8426
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8427,
    			8427
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8428,
    			8431
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8432,
    			8432
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8433,
    			8447
    		],
    		"disallowed"
    	],
    	[
    		[
    			8448,
    			8448
    		],
    		"disallowed_STD3_mapped",
    		[
    			97,
    			47,
    			99
    		]
    	],
    	[
    		[
    			8449,
    			8449
    		],
    		"disallowed_STD3_mapped",
    		[
    			97,
    			47,
    			115
    		]
    	],
    	[
    		[
    			8450,
    			8450
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			8451,
    			8451
    		],
    		"mapped",
    		[
    			176,
    			99
    		]
    	],
    	[
    		[
    			8452,
    			8452
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8453,
    			8453
    		],
    		"disallowed_STD3_mapped",
    		[
    			99,
    			47,
    			111
    		]
    	],
    	[
    		[
    			8454,
    			8454
    		],
    		"disallowed_STD3_mapped",
    		[
    			99,
    			47,
    			117
    		]
    	],
    	[
    		[
    			8455,
    			8455
    		],
    		"mapped",
    		[
    			603
    		]
    	],
    	[
    		[
    			8456,
    			8456
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8457,
    			8457
    		],
    		"mapped",
    		[
    			176,
    			102
    		]
    	],
    	[
    		[
    			8458,
    			8458
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			8459,
    			8462
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			8463,
    			8463
    		],
    		"mapped",
    		[
    			295
    		]
    	],
    	[
    		[
    			8464,
    			8465
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			8466,
    			8467
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			8468,
    			8468
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8469,
    			8469
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			8470,
    			8470
    		],
    		"mapped",
    		[
    			110,
    			111
    		]
    	],
    	[
    		[
    			8471,
    			8472
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8473,
    			8473
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			8474,
    			8474
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			8475,
    			8477
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			8478,
    			8479
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8480,
    			8480
    		],
    		"mapped",
    		[
    			115,
    			109
    		]
    	],
    	[
    		[
    			8481,
    			8481
    		],
    		"mapped",
    		[
    			116,
    			101,
    			108
    		]
    	],
    	[
    		[
    			8482,
    			8482
    		],
    		"mapped",
    		[
    			116,
    			109
    		]
    	],
    	[
    		[
    			8483,
    			8483
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8484,
    			8484
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			8485,
    			8485
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8486,
    			8486
    		],
    		"mapped",
    		[
    			969
    		]
    	],
    	[
    		[
    			8487,
    			8487
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8488,
    			8488
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			8489,
    			8489
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8490,
    			8490
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			8491,
    			8491
    		],
    		"mapped",
    		[
    			229
    		]
    	],
    	[
    		[
    			8492,
    			8492
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			8493,
    			8493
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			8494,
    			8494
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8495,
    			8496
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			8497,
    			8497
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			8498,
    			8498
    		],
    		"disallowed"
    	],
    	[
    		[
    			8499,
    			8499
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			8500,
    			8500
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			8501,
    			8501
    		],
    		"mapped",
    		[
    			1488
    		]
    	],
    	[
    		[
    			8502,
    			8502
    		],
    		"mapped",
    		[
    			1489
    		]
    	],
    	[
    		[
    			8503,
    			8503
    		],
    		"mapped",
    		[
    			1490
    		]
    	],
    	[
    		[
    			8504,
    			8504
    		],
    		"mapped",
    		[
    			1491
    		]
    	],
    	[
    		[
    			8505,
    			8505
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			8506,
    			8506
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8507,
    			8507
    		],
    		"mapped",
    		[
    			102,
    			97,
    			120
    		]
    	],
    	[
    		[
    			8508,
    			8508
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			8509,
    			8510
    		],
    		"mapped",
    		[
    			947
    		]
    	],
    	[
    		[
    			8511,
    			8511
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			8512,
    			8512
    		],
    		"mapped",
    		[
    			8721
    		]
    	],
    	[
    		[
    			8513,
    			8516
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8517,
    			8518
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			8519,
    			8519
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			8520,
    			8520
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			8521,
    			8521
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			8522,
    			8523
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8524,
    			8524
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8525,
    			8525
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8526,
    			8526
    		],
    		"valid"
    	],
    	[
    		[
    			8527,
    			8527
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8528,
    			8528
    		],
    		"mapped",
    		[
    			49,
    			8260,
    			55
    		]
    	],
    	[
    		[
    			8529,
    			8529
    		],
    		"mapped",
    		[
    			49,
    			8260,
    			57
    		]
    	],
    	[
    		[
    			8530,
    			8530
    		],
    		"mapped",
    		[
    			49,
    			8260,
    			49,
    			48
    		]
    	],
    	[
    		[
    			8531,
    			8531
    		],
    		"mapped",
    		[
    			49,
    			8260,
    			51
    		]
    	],
    	[
    		[
    			8532,
    			8532
    		],
    		"mapped",
    		[
    			50,
    			8260,
    			51
    		]
    	],
    	[
    		[
    			8533,
    			8533
    		],
    		"mapped",
    		[
    			49,
    			8260,
    			53
    		]
    	],
    	[
    		[
    			8534,
    			8534
    		],
    		"mapped",
    		[
    			50,
    			8260,
    			53
    		]
    	],
    	[
    		[
    			8535,
    			8535
    		],
    		"mapped",
    		[
    			51,
    			8260,
    			53
    		]
    	],
    	[
    		[
    			8536,
    			8536
    		],
    		"mapped",
    		[
    			52,
    			8260,
    			53
    		]
    	],
    	[
    		[
    			8537,
    			8537
    		],
    		"mapped",
    		[
    			49,
    			8260,
    			54
    		]
    	],
    	[
    		[
    			8538,
    			8538
    		],
    		"mapped",
    		[
    			53,
    			8260,
    			54
    		]
    	],
    	[
    		[
    			8539,
    			8539
    		],
    		"mapped",
    		[
    			49,
    			8260,
    			56
    		]
    	],
    	[
    		[
    			8540,
    			8540
    		],
    		"mapped",
    		[
    			51,
    			8260,
    			56
    		]
    	],
    	[
    		[
    			8541,
    			8541
    		],
    		"mapped",
    		[
    			53,
    			8260,
    			56
    		]
    	],
    	[
    		[
    			8542,
    			8542
    		],
    		"mapped",
    		[
    			55,
    			8260,
    			56
    		]
    	],
    	[
    		[
    			8543,
    			8543
    		],
    		"mapped",
    		[
    			49,
    			8260
    		]
    	],
    	[
    		[
    			8544,
    			8544
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			8545,
    			8545
    		],
    		"mapped",
    		[
    			105,
    			105
    		]
    	],
    	[
    		[
    			8546,
    			8546
    		],
    		"mapped",
    		[
    			105,
    			105,
    			105
    		]
    	],
    	[
    		[
    			8547,
    			8547
    		],
    		"mapped",
    		[
    			105,
    			118
    		]
    	],
    	[
    		[
    			8548,
    			8548
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			8549,
    			8549
    		],
    		"mapped",
    		[
    			118,
    			105
    		]
    	],
    	[
    		[
    			8550,
    			8550
    		],
    		"mapped",
    		[
    			118,
    			105,
    			105
    		]
    	],
    	[
    		[
    			8551,
    			8551
    		],
    		"mapped",
    		[
    			118,
    			105,
    			105,
    			105
    		]
    	],
    	[
    		[
    			8552,
    			8552
    		],
    		"mapped",
    		[
    			105,
    			120
    		]
    	],
    	[
    		[
    			8553,
    			8553
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			8554,
    			8554
    		],
    		"mapped",
    		[
    			120,
    			105
    		]
    	],
    	[
    		[
    			8555,
    			8555
    		],
    		"mapped",
    		[
    			120,
    			105,
    			105
    		]
    	],
    	[
    		[
    			8556,
    			8556
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			8557,
    			8557
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			8558,
    			8558
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			8559,
    			8559
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			8560,
    			8560
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			8561,
    			8561
    		],
    		"mapped",
    		[
    			105,
    			105
    		]
    	],
    	[
    		[
    			8562,
    			8562
    		],
    		"mapped",
    		[
    			105,
    			105,
    			105
    		]
    	],
    	[
    		[
    			8563,
    			8563
    		],
    		"mapped",
    		[
    			105,
    			118
    		]
    	],
    	[
    		[
    			8564,
    			8564
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			8565,
    			8565
    		],
    		"mapped",
    		[
    			118,
    			105
    		]
    	],
    	[
    		[
    			8566,
    			8566
    		],
    		"mapped",
    		[
    			118,
    			105,
    			105
    		]
    	],
    	[
    		[
    			8567,
    			8567
    		],
    		"mapped",
    		[
    			118,
    			105,
    			105,
    			105
    		]
    	],
    	[
    		[
    			8568,
    			8568
    		],
    		"mapped",
    		[
    			105,
    			120
    		]
    	],
    	[
    		[
    			8569,
    			8569
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			8570,
    			8570
    		],
    		"mapped",
    		[
    			120,
    			105
    		]
    	],
    	[
    		[
    			8571,
    			8571
    		],
    		"mapped",
    		[
    			120,
    			105,
    			105
    		]
    	],
    	[
    		[
    			8572,
    			8572
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			8573,
    			8573
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			8574,
    			8574
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			8575,
    			8575
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			8576,
    			8578
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8579,
    			8579
    		],
    		"disallowed"
    	],
    	[
    		[
    			8580,
    			8580
    		],
    		"valid"
    	],
    	[
    		[
    			8581,
    			8584
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8585,
    			8585
    		],
    		"mapped",
    		[
    			48,
    			8260,
    			51
    		]
    	],
    	[
    		[
    			8586,
    			8587
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8588,
    			8591
    		],
    		"disallowed"
    	],
    	[
    		[
    			8592,
    			8682
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8683,
    			8691
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8692,
    			8703
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8704,
    			8747
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8748,
    			8748
    		],
    		"mapped",
    		[
    			8747,
    			8747
    		]
    	],
    	[
    		[
    			8749,
    			8749
    		],
    		"mapped",
    		[
    			8747,
    			8747,
    			8747
    		]
    	],
    	[
    		[
    			8750,
    			8750
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8751,
    			8751
    		],
    		"mapped",
    		[
    			8750,
    			8750
    		]
    	],
    	[
    		[
    			8752,
    			8752
    		],
    		"mapped",
    		[
    			8750,
    			8750,
    			8750
    		]
    	],
    	[
    		[
    			8753,
    			8799
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8800,
    			8800
    		],
    		"disallowed_STD3_valid"
    	],
    	[
    		[
    			8801,
    			8813
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8814,
    			8815
    		],
    		"disallowed_STD3_valid"
    	],
    	[
    		[
    			8816,
    			8945
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8946,
    			8959
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8960,
    			8960
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8961,
    			8961
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			8962,
    			9000
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9001,
    			9001
    		],
    		"mapped",
    		[
    			12296
    		]
    	],
    	[
    		[
    			9002,
    			9002
    		],
    		"mapped",
    		[
    			12297
    		]
    	],
    	[
    		[
    			9003,
    			9082
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9083,
    			9083
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9084,
    			9084
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9085,
    			9114
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9115,
    			9166
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9167,
    			9168
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9169,
    			9179
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9180,
    			9191
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9192,
    			9192
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9193,
    			9203
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9204,
    			9210
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9211,
    			9215
    		],
    		"disallowed"
    	],
    	[
    		[
    			9216,
    			9252
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9253,
    			9254
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9255,
    			9279
    		],
    		"disallowed"
    	],
    	[
    		[
    			9280,
    			9290
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9291,
    			9311
    		],
    		"disallowed"
    	],
    	[
    		[
    			9312,
    			9312
    		],
    		"mapped",
    		[
    			49
    		]
    	],
    	[
    		[
    			9313,
    			9313
    		],
    		"mapped",
    		[
    			50
    		]
    	],
    	[
    		[
    			9314,
    			9314
    		],
    		"mapped",
    		[
    			51
    		]
    	],
    	[
    		[
    			9315,
    			9315
    		],
    		"mapped",
    		[
    			52
    		]
    	],
    	[
    		[
    			9316,
    			9316
    		],
    		"mapped",
    		[
    			53
    		]
    	],
    	[
    		[
    			9317,
    			9317
    		],
    		"mapped",
    		[
    			54
    		]
    	],
    	[
    		[
    			9318,
    			9318
    		],
    		"mapped",
    		[
    			55
    		]
    	],
    	[
    		[
    			9319,
    			9319
    		],
    		"mapped",
    		[
    			56
    		]
    	],
    	[
    		[
    			9320,
    			9320
    		],
    		"mapped",
    		[
    			57
    		]
    	],
    	[
    		[
    			9321,
    			9321
    		],
    		"mapped",
    		[
    			49,
    			48
    		]
    	],
    	[
    		[
    			9322,
    			9322
    		],
    		"mapped",
    		[
    			49,
    			49
    		]
    	],
    	[
    		[
    			9323,
    			9323
    		],
    		"mapped",
    		[
    			49,
    			50
    		]
    	],
    	[
    		[
    			9324,
    			9324
    		],
    		"mapped",
    		[
    			49,
    			51
    		]
    	],
    	[
    		[
    			9325,
    			9325
    		],
    		"mapped",
    		[
    			49,
    			52
    		]
    	],
    	[
    		[
    			9326,
    			9326
    		],
    		"mapped",
    		[
    			49,
    			53
    		]
    	],
    	[
    		[
    			9327,
    			9327
    		],
    		"mapped",
    		[
    			49,
    			54
    		]
    	],
    	[
    		[
    			9328,
    			9328
    		],
    		"mapped",
    		[
    			49,
    			55
    		]
    	],
    	[
    		[
    			9329,
    			9329
    		],
    		"mapped",
    		[
    			49,
    			56
    		]
    	],
    	[
    		[
    			9330,
    			9330
    		],
    		"mapped",
    		[
    			49,
    			57
    		]
    	],
    	[
    		[
    			9331,
    			9331
    		],
    		"mapped",
    		[
    			50,
    			48
    		]
    	],
    	[
    		[
    			9332,
    			9332
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			49,
    			41
    		]
    	],
    	[
    		[
    			9333,
    			9333
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			50,
    			41
    		]
    	],
    	[
    		[
    			9334,
    			9334
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			51,
    			41
    		]
    	],
    	[
    		[
    			9335,
    			9335
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			52,
    			41
    		]
    	],
    	[
    		[
    			9336,
    			9336
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			53,
    			41
    		]
    	],
    	[
    		[
    			9337,
    			9337
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			54,
    			41
    		]
    	],
    	[
    		[
    			9338,
    			9338
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			55,
    			41
    		]
    	],
    	[
    		[
    			9339,
    			9339
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			56,
    			41
    		]
    	],
    	[
    		[
    			9340,
    			9340
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			57,
    			41
    		]
    	],
    	[
    		[
    			9341,
    			9341
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			49,
    			48,
    			41
    		]
    	],
    	[
    		[
    			9342,
    			9342
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			49,
    			49,
    			41
    		]
    	],
    	[
    		[
    			9343,
    			9343
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			49,
    			50,
    			41
    		]
    	],
    	[
    		[
    			9344,
    			9344
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			49,
    			51,
    			41
    		]
    	],
    	[
    		[
    			9345,
    			9345
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			49,
    			52,
    			41
    		]
    	],
    	[
    		[
    			9346,
    			9346
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			49,
    			53,
    			41
    		]
    	],
    	[
    		[
    			9347,
    			9347
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			49,
    			54,
    			41
    		]
    	],
    	[
    		[
    			9348,
    			9348
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			49,
    			55,
    			41
    		]
    	],
    	[
    		[
    			9349,
    			9349
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			49,
    			56,
    			41
    		]
    	],
    	[
    		[
    			9350,
    			9350
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			49,
    			57,
    			41
    		]
    	],
    	[
    		[
    			9351,
    			9351
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			50,
    			48,
    			41
    		]
    	],
    	[
    		[
    			9352,
    			9371
    		],
    		"disallowed"
    	],
    	[
    		[
    			9372,
    			9372
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			97,
    			41
    		]
    	],
    	[
    		[
    			9373,
    			9373
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			98,
    			41
    		]
    	],
    	[
    		[
    			9374,
    			9374
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			99,
    			41
    		]
    	],
    	[
    		[
    			9375,
    			9375
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			100,
    			41
    		]
    	],
    	[
    		[
    			9376,
    			9376
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			101,
    			41
    		]
    	],
    	[
    		[
    			9377,
    			9377
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			102,
    			41
    		]
    	],
    	[
    		[
    			9378,
    			9378
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			103,
    			41
    		]
    	],
    	[
    		[
    			9379,
    			9379
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			104,
    			41
    		]
    	],
    	[
    		[
    			9380,
    			9380
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			105,
    			41
    		]
    	],
    	[
    		[
    			9381,
    			9381
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			106,
    			41
    		]
    	],
    	[
    		[
    			9382,
    			9382
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			107,
    			41
    		]
    	],
    	[
    		[
    			9383,
    			9383
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			108,
    			41
    		]
    	],
    	[
    		[
    			9384,
    			9384
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			109,
    			41
    		]
    	],
    	[
    		[
    			9385,
    			9385
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			110,
    			41
    		]
    	],
    	[
    		[
    			9386,
    			9386
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			111,
    			41
    		]
    	],
    	[
    		[
    			9387,
    			9387
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			112,
    			41
    		]
    	],
    	[
    		[
    			9388,
    			9388
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			113,
    			41
    		]
    	],
    	[
    		[
    			9389,
    			9389
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			114,
    			41
    		]
    	],
    	[
    		[
    			9390,
    			9390
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			115,
    			41
    		]
    	],
    	[
    		[
    			9391,
    			9391
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			116,
    			41
    		]
    	],
    	[
    		[
    			9392,
    			9392
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			117,
    			41
    		]
    	],
    	[
    		[
    			9393,
    			9393
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			118,
    			41
    		]
    	],
    	[
    		[
    			9394,
    			9394
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			119,
    			41
    		]
    	],
    	[
    		[
    			9395,
    			9395
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			120,
    			41
    		]
    	],
    	[
    		[
    			9396,
    			9396
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			121,
    			41
    		]
    	],
    	[
    		[
    			9397,
    			9397
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			122,
    			41
    		]
    	],
    	[
    		[
    			9398,
    			9398
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			9399,
    			9399
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			9400,
    			9400
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			9401,
    			9401
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			9402,
    			9402
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			9403,
    			9403
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			9404,
    			9404
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			9405,
    			9405
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			9406,
    			9406
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			9407,
    			9407
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			9408,
    			9408
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			9409,
    			9409
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			9410,
    			9410
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			9411,
    			9411
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			9412,
    			9412
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			9413,
    			9413
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			9414,
    			9414
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			9415,
    			9415
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			9416,
    			9416
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			9417,
    			9417
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			9418,
    			9418
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			9419,
    			9419
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			9420,
    			9420
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			9421,
    			9421
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			9422,
    			9422
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			9423,
    			9423
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			9424,
    			9424
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			9425,
    			9425
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			9426,
    			9426
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			9427,
    			9427
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			9428,
    			9428
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			9429,
    			9429
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			9430,
    			9430
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			9431,
    			9431
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			9432,
    			9432
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			9433,
    			9433
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			9434,
    			9434
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			9435,
    			9435
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			9436,
    			9436
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			9437,
    			9437
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			9438,
    			9438
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			9439,
    			9439
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			9440,
    			9440
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			9441,
    			9441
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			9442,
    			9442
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			9443,
    			9443
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			9444,
    			9444
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			9445,
    			9445
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			9446,
    			9446
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			9447,
    			9447
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			9448,
    			9448
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			9449,
    			9449
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			9450,
    			9450
    		],
    		"mapped",
    		[
    			48
    		]
    	],
    	[
    		[
    			9451,
    			9470
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9471,
    			9471
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9472,
    			9621
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9622,
    			9631
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9632,
    			9711
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9712,
    			9719
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9720,
    			9727
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9728,
    			9747
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9748,
    			9749
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9750,
    			9751
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9752,
    			9752
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9753,
    			9753
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9754,
    			9839
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9840,
    			9841
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9842,
    			9853
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9854,
    			9855
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9856,
    			9865
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9866,
    			9873
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9874,
    			9884
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9885,
    			9885
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9886,
    			9887
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9888,
    			9889
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9890,
    			9905
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9906,
    			9906
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9907,
    			9916
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9917,
    			9919
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9920,
    			9923
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9924,
    			9933
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9934,
    			9934
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9935,
    			9953
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9954,
    			9954
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9955,
    			9955
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9956,
    			9959
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9960,
    			9983
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9984,
    			9984
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9985,
    			9988
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9989,
    			9989
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9990,
    			9993
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9994,
    			9995
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			9996,
    			10023
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10024,
    			10024
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10025,
    			10059
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10060,
    			10060
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10061,
    			10061
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10062,
    			10062
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10063,
    			10066
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10067,
    			10069
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10070,
    			10070
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10071,
    			10071
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10072,
    			10078
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10079,
    			10080
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10081,
    			10087
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10088,
    			10101
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10102,
    			10132
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10133,
    			10135
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10136,
    			10159
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10160,
    			10160
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10161,
    			10174
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10175,
    			10175
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10176,
    			10182
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10183,
    			10186
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10187,
    			10187
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10188,
    			10188
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10189,
    			10189
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10190,
    			10191
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10192,
    			10219
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10220,
    			10223
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10224,
    			10239
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10240,
    			10495
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10496,
    			10763
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10764,
    			10764
    		],
    		"mapped",
    		[
    			8747,
    			8747,
    			8747,
    			8747
    		]
    	],
    	[
    		[
    			10765,
    			10867
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10868,
    			10868
    		],
    		"disallowed_STD3_mapped",
    		[
    			58,
    			58,
    			61
    		]
    	],
    	[
    		[
    			10869,
    			10869
    		],
    		"disallowed_STD3_mapped",
    		[
    			61,
    			61
    		]
    	],
    	[
    		[
    			10870,
    			10870
    		],
    		"disallowed_STD3_mapped",
    		[
    			61,
    			61,
    			61
    		]
    	],
    	[
    		[
    			10871,
    			10971
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			10972,
    			10972
    		],
    		"mapped",
    		[
    			10973,
    			824
    		]
    	],
    	[
    		[
    			10973,
    			11007
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11008,
    			11021
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11022,
    			11027
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11028,
    			11034
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11035,
    			11039
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11040,
    			11043
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11044,
    			11084
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11085,
    			11087
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11088,
    			11092
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11093,
    			11097
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11098,
    			11123
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11124,
    			11125
    		],
    		"disallowed"
    	],
    	[
    		[
    			11126,
    			11157
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11158,
    			11159
    		],
    		"disallowed"
    	],
    	[
    		[
    			11160,
    			11193
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11194,
    			11196
    		],
    		"disallowed"
    	],
    	[
    		[
    			11197,
    			11208
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11209,
    			11209
    		],
    		"disallowed"
    	],
    	[
    		[
    			11210,
    			11217
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11218,
    			11243
    		],
    		"disallowed"
    	],
    	[
    		[
    			11244,
    			11247
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11248,
    			11263
    		],
    		"disallowed"
    	],
    	[
    		[
    			11264,
    			11264
    		],
    		"mapped",
    		[
    			11312
    		]
    	],
    	[
    		[
    			11265,
    			11265
    		],
    		"mapped",
    		[
    			11313
    		]
    	],
    	[
    		[
    			11266,
    			11266
    		],
    		"mapped",
    		[
    			11314
    		]
    	],
    	[
    		[
    			11267,
    			11267
    		],
    		"mapped",
    		[
    			11315
    		]
    	],
    	[
    		[
    			11268,
    			11268
    		],
    		"mapped",
    		[
    			11316
    		]
    	],
    	[
    		[
    			11269,
    			11269
    		],
    		"mapped",
    		[
    			11317
    		]
    	],
    	[
    		[
    			11270,
    			11270
    		],
    		"mapped",
    		[
    			11318
    		]
    	],
    	[
    		[
    			11271,
    			11271
    		],
    		"mapped",
    		[
    			11319
    		]
    	],
    	[
    		[
    			11272,
    			11272
    		],
    		"mapped",
    		[
    			11320
    		]
    	],
    	[
    		[
    			11273,
    			11273
    		],
    		"mapped",
    		[
    			11321
    		]
    	],
    	[
    		[
    			11274,
    			11274
    		],
    		"mapped",
    		[
    			11322
    		]
    	],
    	[
    		[
    			11275,
    			11275
    		],
    		"mapped",
    		[
    			11323
    		]
    	],
    	[
    		[
    			11276,
    			11276
    		],
    		"mapped",
    		[
    			11324
    		]
    	],
    	[
    		[
    			11277,
    			11277
    		],
    		"mapped",
    		[
    			11325
    		]
    	],
    	[
    		[
    			11278,
    			11278
    		],
    		"mapped",
    		[
    			11326
    		]
    	],
    	[
    		[
    			11279,
    			11279
    		],
    		"mapped",
    		[
    			11327
    		]
    	],
    	[
    		[
    			11280,
    			11280
    		],
    		"mapped",
    		[
    			11328
    		]
    	],
    	[
    		[
    			11281,
    			11281
    		],
    		"mapped",
    		[
    			11329
    		]
    	],
    	[
    		[
    			11282,
    			11282
    		],
    		"mapped",
    		[
    			11330
    		]
    	],
    	[
    		[
    			11283,
    			11283
    		],
    		"mapped",
    		[
    			11331
    		]
    	],
    	[
    		[
    			11284,
    			11284
    		],
    		"mapped",
    		[
    			11332
    		]
    	],
    	[
    		[
    			11285,
    			11285
    		],
    		"mapped",
    		[
    			11333
    		]
    	],
    	[
    		[
    			11286,
    			11286
    		],
    		"mapped",
    		[
    			11334
    		]
    	],
    	[
    		[
    			11287,
    			11287
    		],
    		"mapped",
    		[
    			11335
    		]
    	],
    	[
    		[
    			11288,
    			11288
    		],
    		"mapped",
    		[
    			11336
    		]
    	],
    	[
    		[
    			11289,
    			11289
    		],
    		"mapped",
    		[
    			11337
    		]
    	],
    	[
    		[
    			11290,
    			11290
    		],
    		"mapped",
    		[
    			11338
    		]
    	],
    	[
    		[
    			11291,
    			11291
    		],
    		"mapped",
    		[
    			11339
    		]
    	],
    	[
    		[
    			11292,
    			11292
    		],
    		"mapped",
    		[
    			11340
    		]
    	],
    	[
    		[
    			11293,
    			11293
    		],
    		"mapped",
    		[
    			11341
    		]
    	],
    	[
    		[
    			11294,
    			11294
    		],
    		"mapped",
    		[
    			11342
    		]
    	],
    	[
    		[
    			11295,
    			11295
    		],
    		"mapped",
    		[
    			11343
    		]
    	],
    	[
    		[
    			11296,
    			11296
    		],
    		"mapped",
    		[
    			11344
    		]
    	],
    	[
    		[
    			11297,
    			11297
    		],
    		"mapped",
    		[
    			11345
    		]
    	],
    	[
    		[
    			11298,
    			11298
    		],
    		"mapped",
    		[
    			11346
    		]
    	],
    	[
    		[
    			11299,
    			11299
    		],
    		"mapped",
    		[
    			11347
    		]
    	],
    	[
    		[
    			11300,
    			11300
    		],
    		"mapped",
    		[
    			11348
    		]
    	],
    	[
    		[
    			11301,
    			11301
    		],
    		"mapped",
    		[
    			11349
    		]
    	],
    	[
    		[
    			11302,
    			11302
    		],
    		"mapped",
    		[
    			11350
    		]
    	],
    	[
    		[
    			11303,
    			11303
    		],
    		"mapped",
    		[
    			11351
    		]
    	],
    	[
    		[
    			11304,
    			11304
    		],
    		"mapped",
    		[
    			11352
    		]
    	],
    	[
    		[
    			11305,
    			11305
    		],
    		"mapped",
    		[
    			11353
    		]
    	],
    	[
    		[
    			11306,
    			11306
    		],
    		"mapped",
    		[
    			11354
    		]
    	],
    	[
    		[
    			11307,
    			11307
    		],
    		"mapped",
    		[
    			11355
    		]
    	],
    	[
    		[
    			11308,
    			11308
    		],
    		"mapped",
    		[
    			11356
    		]
    	],
    	[
    		[
    			11309,
    			11309
    		],
    		"mapped",
    		[
    			11357
    		]
    	],
    	[
    		[
    			11310,
    			11310
    		],
    		"mapped",
    		[
    			11358
    		]
    	],
    	[
    		[
    			11311,
    			11311
    		],
    		"disallowed"
    	],
    	[
    		[
    			11312,
    			11358
    		],
    		"valid"
    	],
    	[
    		[
    			11359,
    			11359
    		],
    		"disallowed"
    	],
    	[
    		[
    			11360,
    			11360
    		],
    		"mapped",
    		[
    			11361
    		]
    	],
    	[
    		[
    			11361,
    			11361
    		],
    		"valid"
    	],
    	[
    		[
    			11362,
    			11362
    		],
    		"mapped",
    		[
    			619
    		]
    	],
    	[
    		[
    			11363,
    			11363
    		],
    		"mapped",
    		[
    			7549
    		]
    	],
    	[
    		[
    			11364,
    			11364
    		],
    		"mapped",
    		[
    			637
    		]
    	],
    	[
    		[
    			11365,
    			11366
    		],
    		"valid"
    	],
    	[
    		[
    			11367,
    			11367
    		],
    		"mapped",
    		[
    			11368
    		]
    	],
    	[
    		[
    			11368,
    			11368
    		],
    		"valid"
    	],
    	[
    		[
    			11369,
    			11369
    		],
    		"mapped",
    		[
    			11370
    		]
    	],
    	[
    		[
    			11370,
    			11370
    		],
    		"valid"
    	],
    	[
    		[
    			11371,
    			11371
    		],
    		"mapped",
    		[
    			11372
    		]
    	],
    	[
    		[
    			11372,
    			11372
    		],
    		"valid"
    	],
    	[
    		[
    			11373,
    			11373
    		],
    		"mapped",
    		[
    			593
    		]
    	],
    	[
    		[
    			11374,
    			11374
    		],
    		"mapped",
    		[
    			625
    		]
    	],
    	[
    		[
    			11375,
    			11375
    		],
    		"mapped",
    		[
    			592
    		]
    	],
    	[
    		[
    			11376,
    			11376
    		],
    		"mapped",
    		[
    			594
    		]
    	],
    	[
    		[
    			11377,
    			11377
    		],
    		"valid"
    	],
    	[
    		[
    			11378,
    			11378
    		],
    		"mapped",
    		[
    			11379
    		]
    	],
    	[
    		[
    			11379,
    			11379
    		],
    		"valid"
    	],
    	[
    		[
    			11380,
    			11380
    		],
    		"valid"
    	],
    	[
    		[
    			11381,
    			11381
    		],
    		"mapped",
    		[
    			11382
    		]
    	],
    	[
    		[
    			11382,
    			11383
    		],
    		"valid"
    	],
    	[
    		[
    			11384,
    			11387
    		],
    		"valid"
    	],
    	[
    		[
    			11388,
    			11388
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			11389,
    			11389
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			11390,
    			11390
    		],
    		"mapped",
    		[
    			575
    		]
    	],
    	[
    		[
    			11391,
    			11391
    		],
    		"mapped",
    		[
    			576
    		]
    	],
    	[
    		[
    			11392,
    			11392
    		],
    		"mapped",
    		[
    			11393
    		]
    	],
    	[
    		[
    			11393,
    			11393
    		],
    		"valid"
    	],
    	[
    		[
    			11394,
    			11394
    		],
    		"mapped",
    		[
    			11395
    		]
    	],
    	[
    		[
    			11395,
    			11395
    		],
    		"valid"
    	],
    	[
    		[
    			11396,
    			11396
    		],
    		"mapped",
    		[
    			11397
    		]
    	],
    	[
    		[
    			11397,
    			11397
    		],
    		"valid"
    	],
    	[
    		[
    			11398,
    			11398
    		],
    		"mapped",
    		[
    			11399
    		]
    	],
    	[
    		[
    			11399,
    			11399
    		],
    		"valid"
    	],
    	[
    		[
    			11400,
    			11400
    		],
    		"mapped",
    		[
    			11401
    		]
    	],
    	[
    		[
    			11401,
    			11401
    		],
    		"valid"
    	],
    	[
    		[
    			11402,
    			11402
    		],
    		"mapped",
    		[
    			11403
    		]
    	],
    	[
    		[
    			11403,
    			11403
    		],
    		"valid"
    	],
    	[
    		[
    			11404,
    			11404
    		],
    		"mapped",
    		[
    			11405
    		]
    	],
    	[
    		[
    			11405,
    			11405
    		],
    		"valid"
    	],
    	[
    		[
    			11406,
    			11406
    		],
    		"mapped",
    		[
    			11407
    		]
    	],
    	[
    		[
    			11407,
    			11407
    		],
    		"valid"
    	],
    	[
    		[
    			11408,
    			11408
    		],
    		"mapped",
    		[
    			11409
    		]
    	],
    	[
    		[
    			11409,
    			11409
    		],
    		"valid"
    	],
    	[
    		[
    			11410,
    			11410
    		],
    		"mapped",
    		[
    			11411
    		]
    	],
    	[
    		[
    			11411,
    			11411
    		],
    		"valid"
    	],
    	[
    		[
    			11412,
    			11412
    		],
    		"mapped",
    		[
    			11413
    		]
    	],
    	[
    		[
    			11413,
    			11413
    		],
    		"valid"
    	],
    	[
    		[
    			11414,
    			11414
    		],
    		"mapped",
    		[
    			11415
    		]
    	],
    	[
    		[
    			11415,
    			11415
    		],
    		"valid"
    	],
    	[
    		[
    			11416,
    			11416
    		],
    		"mapped",
    		[
    			11417
    		]
    	],
    	[
    		[
    			11417,
    			11417
    		],
    		"valid"
    	],
    	[
    		[
    			11418,
    			11418
    		],
    		"mapped",
    		[
    			11419
    		]
    	],
    	[
    		[
    			11419,
    			11419
    		],
    		"valid"
    	],
    	[
    		[
    			11420,
    			11420
    		],
    		"mapped",
    		[
    			11421
    		]
    	],
    	[
    		[
    			11421,
    			11421
    		],
    		"valid"
    	],
    	[
    		[
    			11422,
    			11422
    		],
    		"mapped",
    		[
    			11423
    		]
    	],
    	[
    		[
    			11423,
    			11423
    		],
    		"valid"
    	],
    	[
    		[
    			11424,
    			11424
    		],
    		"mapped",
    		[
    			11425
    		]
    	],
    	[
    		[
    			11425,
    			11425
    		],
    		"valid"
    	],
    	[
    		[
    			11426,
    			11426
    		],
    		"mapped",
    		[
    			11427
    		]
    	],
    	[
    		[
    			11427,
    			11427
    		],
    		"valid"
    	],
    	[
    		[
    			11428,
    			11428
    		],
    		"mapped",
    		[
    			11429
    		]
    	],
    	[
    		[
    			11429,
    			11429
    		],
    		"valid"
    	],
    	[
    		[
    			11430,
    			11430
    		],
    		"mapped",
    		[
    			11431
    		]
    	],
    	[
    		[
    			11431,
    			11431
    		],
    		"valid"
    	],
    	[
    		[
    			11432,
    			11432
    		],
    		"mapped",
    		[
    			11433
    		]
    	],
    	[
    		[
    			11433,
    			11433
    		],
    		"valid"
    	],
    	[
    		[
    			11434,
    			11434
    		],
    		"mapped",
    		[
    			11435
    		]
    	],
    	[
    		[
    			11435,
    			11435
    		],
    		"valid"
    	],
    	[
    		[
    			11436,
    			11436
    		],
    		"mapped",
    		[
    			11437
    		]
    	],
    	[
    		[
    			11437,
    			11437
    		],
    		"valid"
    	],
    	[
    		[
    			11438,
    			11438
    		],
    		"mapped",
    		[
    			11439
    		]
    	],
    	[
    		[
    			11439,
    			11439
    		],
    		"valid"
    	],
    	[
    		[
    			11440,
    			11440
    		],
    		"mapped",
    		[
    			11441
    		]
    	],
    	[
    		[
    			11441,
    			11441
    		],
    		"valid"
    	],
    	[
    		[
    			11442,
    			11442
    		],
    		"mapped",
    		[
    			11443
    		]
    	],
    	[
    		[
    			11443,
    			11443
    		],
    		"valid"
    	],
    	[
    		[
    			11444,
    			11444
    		],
    		"mapped",
    		[
    			11445
    		]
    	],
    	[
    		[
    			11445,
    			11445
    		],
    		"valid"
    	],
    	[
    		[
    			11446,
    			11446
    		],
    		"mapped",
    		[
    			11447
    		]
    	],
    	[
    		[
    			11447,
    			11447
    		],
    		"valid"
    	],
    	[
    		[
    			11448,
    			11448
    		],
    		"mapped",
    		[
    			11449
    		]
    	],
    	[
    		[
    			11449,
    			11449
    		],
    		"valid"
    	],
    	[
    		[
    			11450,
    			11450
    		],
    		"mapped",
    		[
    			11451
    		]
    	],
    	[
    		[
    			11451,
    			11451
    		],
    		"valid"
    	],
    	[
    		[
    			11452,
    			11452
    		],
    		"mapped",
    		[
    			11453
    		]
    	],
    	[
    		[
    			11453,
    			11453
    		],
    		"valid"
    	],
    	[
    		[
    			11454,
    			11454
    		],
    		"mapped",
    		[
    			11455
    		]
    	],
    	[
    		[
    			11455,
    			11455
    		],
    		"valid"
    	],
    	[
    		[
    			11456,
    			11456
    		],
    		"mapped",
    		[
    			11457
    		]
    	],
    	[
    		[
    			11457,
    			11457
    		],
    		"valid"
    	],
    	[
    		[
    			11458,
    			11458
    		],
    		"mapped",
    		[
    			11459
    		]
    	],
    	[
    		[
    			11459,
    			11459
    		],
    		"valid"
    	],
    	[
    		[
    			11460,
    			11460
    		],
    		"mapped",
    		[
    			11461
    		]
    	],
    	[
    		[
    			11461,
    			11461
    		],
    		"valid"
    	],
    	[
    		[
    			11462,
    			11462
    		],
    		"mapped",
    		[
    			11463
    		]
    	],
    	[
    		[
    			11463,
    			11463
    		],
    		"valid"
    	],
    	[
    		[
    			11464,
    			11464
    		],
    		"mapped",
    		[
    			11465
    		]
    	],
    	[
    		[
    			11465,
    			11465
    		],
    		"valid"
    	],
    	[
    		[
    			11466,
    			11466
    		],
    		"mapped",
    		[
    			11467
    		]
    	],
    	[
    		[
    			11467,
    			11467
    		],
    		"valid"
    	],
    	[
    		[
    			11468,
    			11468
    		],
    		"mapped",
    		[
    			11469
    		]
    	],
    	[
    		[
    			11469,
    			11469
    		],
    		"valid"
    	],
    	[
    		[
    			11470,
    			11470
    		],
    		"mapped",
    		[
    			11471
    		]
    	],
    	[
    		[
    			11471,
    			11471
    		],
    		"valid"
    	],
    	[
    		[
    			11472,
    			11472
    		],
    		"mapped",
    		[
    			11473
    		]
    	],
    	[
    		[
    			11473,
    			11473
    		],
    		"valid"
    	],
    	[
    		[
    			11474,
    			11474
    		],
    		"mapped",
    		[
    			11475
    		]
    	],
    	[
    		[
    			11475,
    			11475
    		],
    		"valid"
    	],
    	[
    		[
    			11476,
    			11476
    		],
    		"mapped",
    		[
    			11477
    		]
    	],
    	[
    		[
    			11477,
    			11477
    		],
    		"valid"
    	],
    	[
    		[
    			11478,
    			11478
    		],
    		"mapped",
    		[
    			11479
    		]
    	],
    	[
    		[
    			11479,
    			11479
    		],
    		"valid"
    	],
    	[
    		[
    			11480,
    			11480
    		],
    		"mapped",
    		[
    			11481
    		]
    	],
    	[
    		[
    			11481,
    			11481
    		],
    		"valid"
    	],
    	[
    		[
    			11482,
    			11482
    		],
    		"mapped",
    		[
    			11483
    		]
    	],
    	[
    		[
    			11483,
    			11483
    		],
    		"valid"
    	],
    	[
    		[
    			11484,
    			11484
    		],
    		"mapped",
    		[
    			11485
    		]
    	],
    	[
    		[
    			11485,
    			11485
    		],
    		"valid"
    	],
    	[
    		[
    			11486,
    			11486
    		],
    		"mapped",
    		[
    			11487
    		]
    	],
    	[
    		[
    			11487,
    			11487
    		],
    		"valid"
    	],
    	[
    		[
    			11488,
    			11488
    		],
    		"mapped",
    		[
    			11489
    		]
    	],
    	[
    		[
    			11489,
    			11489
    		],
    		"valid"
    	],
    	[
    		[
    			11490,
    			11490
    		],
    		"mapped",
    		[
    			11491
    		]
    	],
    	[
    		[
    			11491,
    			11492
    		],
    		"valid"
    	],
    	[
    		[
    			11493,
    			11498
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11499,
    			11499
    		],
    		"mapped",
    		[
    			11500
    		]
    	],
    	[
    		[
    			11500,
    			11500
    		],
    		"valid"
    	],
    	[
    		[
    			11501,
    			11501
    		],
    		"mapped",
    		[
    			11502
    		]
    	],
    	[
    		[
    			11502,
    			11505
    		],
    		"valid"
    	],
    	[
    		[
    			11506,
    			11506
    		],
    		"mapped",
    		[
    			11507
    		]
    	],
    	[
    		[
    			11507,
    			11507
    		],
    		"valid"
    	],
    	[
    		[
    			11508,
    			11512
    		],
    		"disallowed"
    	],
    	[
    		[
    			11513,
    			11519
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11520,
    			11557
    		],
    		"valid"
    	],
    	[
    		[
    			11558,
    			11558
    		],
    		"disallowed"
    	],
    	[
    		[
    			11559,
    			11559
    		],
    		"valid"
    	],
    	[
    		[
    			11560,
    			11564
    		],
    		"disallowed"
    	],
    	[
    		[
    			11565,
    			11565
    		],
    		"valid"
    	],
    	[
    		[
    			11566,
    			11567
    		],
    		"disallowed"
    	],
    	[
    		[
    			11568,
    			11621
    		],
    		"valid"
    	],
    	[
    		[
    			11622,
    			11623
    		],
    		"valid"
    	],
    	[
    		[
    			11624,
    			11630
    		],
    		"disallowed"
    	],
    	[
    		[
    			11631,
    			11631
    		],
    		"mapped",
    		[
    			11617
    		]
    	],
    	[
    		[
    			11632,
    			11632
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11633,
    			11646
    		],
    		"disallowed"
    	],
    	[
    		[
    			11647,
    			11647
    		],
    		"valid"
    	],
    	[
    		[
    			11648,
    			11670
    		],
    		"valid"
    	],
    	[
    		[
    			11671,
    			11679
    		],
    		"disallowed"
    	],
    	[
    		[
    			11680,
    			11686
    		],
    		"valid"
    	],
    	[
    		[
    			11687,
    			11687
    		],
    		"disallowed"
    	],
    	[
    		[
    			11688,
    			11694
    		],
    		"valid"
    	],
    	[
    		[
    			11695,
    			11695
    		],
    		"disallowed"
    	],
    	[
    		[
    			11696,
    			11702
    		],
    		"valid"
    	],
    	[
    		[
    			11703,
    			11703
    		],
    		"disallowed"
    	],
    	[
    		[
    			11704,
    			11710
    		],
    		"valid"
    	],
    	[
    		[
    			11711,
    			11711
    		],
    		"disallowed"
    	],
    	[
    		[
    			11712,
    			11718
    		],
    		"valid"
    	],
    	[
    		[
    			11719,
    			11719
    		],
    		"disallowed"
    	],
    	[
    		[
    			11720,
    			11726
    		],
    		"valid"
    	],
    	[
    		[
    			11727,
    			11727
    		],
    		"disallowed"
    	],
    	[
    		[
    			11728,
    			11734
    		],
    		"valid"
    	],
    	[
    		[
    			11735,
    			11735
    		],
    		"disallowed"
    	],
    	[
    		[
    			11736,
    			11742
    		],
    		"valid"
    	],
    	[
    		[
    			11743,
    			11743
    		],
    		"disallowed"
    	],
    	[
    		[
    			11744,
    			11775
    		],
    		"valid"
    	],
    	[
    		[
    			11776,
    			11799
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11800,
    			11803
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11804,
    			11805
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11806,
    			11822
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11823,
    			11823
    		],
    		"valid"
    	],
    	[
    		[
    			11824,
    			11824
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11825,
    			11825
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11826,
    			11835
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11836,
    			11842
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11843,
    			11903
    		],
    		"disallowed"
    	],
    	[
    		[
    			11904,
    			11929
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11930,
    			11930
    		],
    		"disallowed"
    	],
    	[
    		[
    			11931,
    			11934
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			11935,
    			11935
    		],
    		"mapped",
    		[
    			27597
    		]
    	],
    	[
    		[
    			11936,
    			12018
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			12019,
    			12019
    		],
    		"mapped",
    		[
    			40863
    		]
    	],
    	[
    		[
    			12020,
    			12031
    		],
    		"disallowed"
    	],
    	[
    		[
    			12032,
    			12032
    		],
    		"mapped",
    		[
    			19968
    		]
    	],
    	[
    		[
    			12033,
    			12033
    		],
    		"mapped",
    		[
    			20008
    		]
    	],
    	[
    		[
    			12034,
    			12034
    		],
    		"mapped",
    		[
    			20022
    		]
    	],
    	[
    		[
    			12035,
    			12035
    		],
    		"mapped",
    		[
    			20031
    		]
    	],
    	[
    		[
    			12036,
    			12036
    		],
    		"mapped",
    		[
    			20057
    		]
    	],
    	[
    		[
    			12037,
    			12037
    		],
    		"mapped",
    		[
    			20101
    		]
    	],
    	[
    		[
    			12038,
    			12038
    		],
    		"mapped",
    		[
    			20108
    		]
    	],
    	[
    		[
    			12039,
    			12039
    		],
    		"mapped",
    		[
    			20128
    		]
    	],
    	[
    		[
    			12040,
    			12040
    		],
    		"mapped",
    		[
    			20154
    		]
    	],
    	[
    		[
    			12041,
    			12041
    		],
    		"mapped",
    		[
    			20799
    		]
    	],
    	[
    		[
    			12042,
    			12042
    		],
    		"mapped",
    		[
    			20837
    		]
    	],
    	[
    		[
    			12043,
    			12043
    		],
    		"mapped",
    		[
    			20843
    		]
    	],
    	[
    		[
    			12044,
    			12044
    		],
    		"mapped",
    		[
    			20866
    		]
    	],
    	[
    		[
    			12045,
    			12045
    		],
    		"mapped",
    		[
    			20886
    		]
    	],
    	[
    		[
    			12046,
    			12046
    		],
    		"mapped",
    		[
    			20907
    		]
    	],
    	[
    		[
    			12047,
    			12047
    		],
    		"mapped",
    		[
    			20960
    		]
    	],
    	[
    		[
    			12048,
    			12048
    		],
    		"mapped",
    		[
    			20981
    		]
    	],
    	[
    		[
    			12049,
    			12049
    		],
    		"mapped",
    		[
    			20992
    		]
    	],
    	[
    		[
    			12050,
    			12050
    		],
    		"mapped",
    		[
    			21147
    		]
    	],
    	[
    		[
    			12051,
    			12051
    		],
    		"mapped",
    		[
    			21241
    		]
    	],
    	[
    		[
    			12052,
    			12052
    		],
    		"mapped",
    		[
    			21269
    		]
    	],
    	[
    		[
    			12053,
    			12053
    		],
    		"mapped",
    		[
    			21274
    		]
    	],
    	[
    		[
    			12054,
    			12054
    		],
    		"mapped",
    		[
    			21304
    		]
    	],
    	[
    		[
    			12055,
    			12055
    		],
    		"mapped",
    		[
    			21313
    		]
    	],
    	[
    		[
    			12056,
    			12056
    		],
    		"mapped",
    		[
    			21340
    		]
    	],
    	[
    		[
    			12057,
    			12057
    		],
    		"mapped",
    		[
    			21353
    		]
    	],
    	[
    		[
    			12058,
    			12058
    		],
    		"mapped",
    		[
    			21378
    		]
    	],
    	[
    		[
    			12059,
    			12059
    		],
    		"mapped",
    		[
    			21430
    		]
    	],
    	[
    		[
    			12060,
    			12060
    		],
    		"mapped",
    		[
    			21448
    		]
    	],
    	[
    		[
    			12061,
    			12061
    		],
    		"mapped",
    		[
    			21475
    		]
    	],
    	[
    		[
    			12062,
    			12062
    		],
    		"mapped",
    		[
    			22231
    		]
    	],
    	[
    		[
    			12063,
    			12063
    		],
    		"mapped",
    		[
    			22303
    		]
    	],
    	[
    		[
    			12064,
    			12064
    		],
    		"mapped",
    		[
    			22763
    		]
    	],
    	[
    		[
    			12065,
    			12065
    		],
    		"mapped",
    		[
    			22786
    		]
    	],
    	[
    		[
    			12066,
    			12066
    		],
    		"mapped",
    		[
    			22794
    		]
    	],
    	[
    		[
    			12067,
    			12067
    		],
    		"mapped",
    		[
    			22805
    		]
    	],
    	[
    		[
    			12068,
    			12068
    		],
    		"mapped",
    		[
    			22823
    		]
    	],
    	[
    		[
    			12069,
    			12069
    		],
    		"mapped",
    		[
    			22899
    		]
    	],
    	[
    		[
    			12070,
    			12070
    		],
    		"mapped",
    		[
    			23376
    		]
    	],
    	[
    		[
    			12071,
    			12071
    		],
    		"mapped",
    		[
    			23424
    		]
    	],
    	[
    		[
    			12072,
    			12072
    		],
    		"mapped",
    		[
    			23544
    		]
    	],
    	[
    		[
    			12073,
    			12073
    		],
    		"mapped",
    		[
    			23567
    		]
    	],
    	[
    		[
    			12074,
    			12074
    		],
    		"mapped",
    		[
    			23586
    		]
    	],
    	[
    		[
    			12075,
    			12075
    		],
    		"mapped",
    		[
    			23608
    		]
    	],
    	[
    		[
    			12076,
    			12076
    		],
    		"mapped",
    		[
    			23662
    		]
    	],
    	[
    		[
    			12077,
    			12077
    		],
    		"mapped",
    		[
    			23665
    		]
    	],
    	[
    		[
    			12078,
    			12078
    		],
    		"mapped",
    		[
    			24027
    		]
    	],
    	[
    		[
    			12079,
    			12079
    		],
    		"mapped",
    		[
    			24037
    		]
    	],
    	[
    		[
    			12080,
    			12080
    		],
    		"mapped",
    		[
    			24049
    		]
    	],
    	[
    		[
    			12081,
    			12081
    		],
    		"mapped",
    		[
    			24062
    		]
    	],
    	[
    		[
    			12082,
    			12082
    		],
    		"mapped",
    		[
    			24178
    		]
    	],
    	[
    		[
    			12083,
    			12083
    		],
    		"mapped",
    		[
    			24186
    		]
    	],
    	[
    		[
    			12084,
    			12084
    		],
    		"mapped",
    		[
    			24191
    		]
    	],
    	[
    		[
    			12085,
    			12085
    		],
    		"mapped",
    		[
    			24308
    		]
    	],
    	[
    		[
    			12086,
    			12086
    		],
    		"mapped",
    		[
    			24318
    		]
    	],
    	[
    		[
    			12087,
    			12087
    		],
    		"mapped",
    		[
    			24331
    		]
    	],
    	[
    		[
    			12088,
    			12088
    		],
    		"mapped",
    		[
    			24339
    		]
    	],
    	[
    		[
    			12089,
    			12089
    		],
    		"mapped",
    		[
    			24400
    		]
    	],
    	[
    		[
    			12090,
    			12090
    		],
    		"mapped",
    		[
    			24417
    		]
    	],
    	[
    		[
    			12091,
    			12091
    		],
    		"mapped",
    		[
    			24435
    		]
    	],
    	[
    		[
    			12092,
    			12092
    		],
    		"mapped",
    		[
    			24515
    		]
    	],
    	[
    		[
    			12093,
    			12093
    		],
    		"mapped",
    		[
    			25096
    		]
    	],
    	[
    		[
    			12094,
    			12094
    		],
    		"mapped",
    		[
    			25142
    		]
    	],
    	[
    		[
    			12095,
    			12095
    		],
    		"mapped",
    		[
    			25163
    		]
    	],
    	[
    		[
    			12096,
    			12096
    		],
    		"mapped",
    		[
    			25903
    		]
    	],
    	[
    		[
    			12097,
    			12097
    		],
    		"mapped",
    		[
    			25908
    		]
    	],
    	[
    		[
    			12098,
    			12098
    		],
    		"mapped",
    		[
    			25991
    		]
    	],
    	[
    		[
    			12099,
    			12099
    		],
    		"mapped",
    		[
    			26007
    		]
    	],
    	[
    		[
    			12100,
    			12100
    		],
    		"mapped",
    		[
    			26020
    		]
    	],
    	[
    		[
    			12101,
    			12101
    		],
    		"mapped",
    		[
    			26041
    		]
    	],
    	[
    		[
    			12102,
    			12102
    		],
    		"mapped",
    		[
    			26080
    		]
    	],
    	[
    		[
    			12103,
    			12103
    		],
    		"mapped",
    		[
    			26085
    		]
    	],
    	[
    		[
    			12104,
    			12104
    		],
    		"mapped",
    		[
    			26352
    		]
    	],
    	[
    		[
    			12105,
    			12105
    		],
    		"mapped",
    		[
    			26376
    		]
    	],
    	[
    		[
    			12106,
    			12106
    		],
    		"mapped",
    		[
    			26408
    		]
    	],
    	[
    		[
    			12107,
    			12107
    		],
    		"mapped",
    		[
    			27424
    		]
    	],
    	[
    		[
    			12108,
    			12108
    		],
    		"mapped",
    		[
    			27490
    		]
    	],
    	[
    		[
    			12109,
    			12109
    		],
    		"mapped",
    		[
    			27513
    		]
    	],
    	[
    		[
    			12110,
    			12110
    		],
    		"mapped",
    		[
    			27571
    		]
    	],
    	[
    		[
    			12111,
    			12111
    		],
    		"mapped",
    		[
    			27595
    		]
    	],
    	[
    		[
    			12112,
    			12112
    		],
    		"mapped",
    		[
    			27604
    		]
    	],
    	[
    		[
    			12113,
    			12113
    		],
    		"mapped",
    		[
    			27611
    		]
    	],
    	[
    		[
    			12114,
    			12114
    		],
    		"mapped",
    		[
    			27663
    		]
    	],
    	[
    		[
    			12115,
    			12115
    		],
    		"mapped",
    		[
    			27668
    		]
    	],
    	[
    		[
    			12116,
    			12116
    		],
    		"mapped",
    		[
    			27700
    		]
    	],
    	[
    		[
    			12117,
    			12117
    		],
    		"mapped",
    		[
    			28779
    		]
    	],
    	[
    		[
    			12118,
    			12118
    		],
    		"mapped",
    		[
    			29226
    		]
    	],
    	[
    		[
    			12119,
    			12119
    		],
    		"mapped",
    		[
    			29238
    		]
    	],
    	[
    		[
    			12120,
    			12120
    		],
    		"mapped",
    		[
    			29243
    		]
    	],
    	[
    		[
    			12121,
    			12121
    		],
    		"mapped",
    		[
    			29247
    		]
    	],
    	[
    		[
    			12122,
    			12122
    		],
    		"mapped",
    		[
    			29255
    		]
    	],
    	[
    		[
    			12123,
    			12123
    		],
    		"mapped",
    		[
    			29273
    		]
    	],
    	[
    		[
    			12124,
    			12124
    		],
    		"mapped",
    		[
    			29275
    		]
    	],
    	[
    		[
    			12125,
    			12125
    		],
    		"mapped",
    		[
    			29356
    		]
    	],
    	[
    		[
    			12126,
    			12126
    		],
    		"mapped",
    		[
    			29572
    		]
    	],
    	[
    		[
    			12127,
    			12127
    		],
    		"mapped",
    		[
    			29577
    		]
    	],
    	[
    		[
    			12128,
    			12128
    		],
    		"mapped",
    		[
    			29916
    		]
    	],
    	[
    		[
    			12129,
    			12129
    		],
    		"mapped",
    		[
    			29926
    		]
    	],
    	[
    		[
    			12130,
    			12130
    		],
    		"mapped",
    		[
    			29976
    		]
    	],
    	[
    		[
    			12131,
    			12131
    		],
    		"mapped",
    		[
    			29983
    		]
    	],
    	[
    		[
    			12132,
    			12132
    		],
    		"mapped",
    		[
    			29992
    		]
    	],
    	[
    		[
    			12133,
    			12133
    		],
    		"mapped",
    		[
    			30000
    		]
    	],
    	[
    		[
    			12134,
    			12134
    		],
    		"mapped",
    		[
    			30091
    		]
    	],
    	[
    		[
    			12135,
    			12135
    		],
    		"mapped",
    		[
    			30098
    		]
    	],
    	[
    		[
    			12136,
    			12136
    		],
    		"mapped",
    		[
    			30326
    		]
    	],
    	[
    		[
    			12137,
    			12137
    		],
    		"mapped",
    		[
    			30333
    		]
    	],
    	[
    		[
    			12138,
    			12138
    		],
    		"mapped",
    		[
    			30382
    		]
    	],
    	[
    		[
    			12139,
    			12139
    		],
    		"mapped",
    		[
    			30399
    		]
    	],
    	[
    		[
    			12140,
    			12140
    		],
    		"mapped",
    		[
    			30446
    		]
    	],
    	[
    		[
    			12141,
    			12141
    		],
    		"mapped",
    		[
    			30683
    		]
    	],
    	[
    		[
    			12142,
    			12142
    		],
    		"mapped",
    		[
    			30690
    		]
    	],
    	[
    		[
    			12143,
    			12143
    		],
    		"mapped",
    		[
    			30707
    		]
    	],
    	[
    		[
    			12144,
    			12144
    		],
    		"mapped",
    		[
    			31034
    		]
    	],
    	[
    		[
    			12145,
    			12145
    		],
    		"mapped",
    		[
    			31160
    		]
    	],
    	[
    		[
    			12146,
    			12146
    		],
    		"mapped",
    		[
    			31166
    		]
    	],
    	[
    		[
    			12147,
    			12147
    		],
    		"mapped",
    		[
    			31348
    		]
    	],
    	[
    		[
    			12148,
    			12148
    		],
    		"mapped",
    		[
    			31435
    		]
    	],
    	[
    		[
    			12149,
    			12149
    		],
    		"mapped",
    		[
    			31481
    		]
    	],
    	[
    		[
    			12150,
    			12150
    		],
    		"mapped",
    		[
    			31859
    		]
    	],
    	[
    		[
    			12151,
    			12151
    		],
    		"mapped",
    		[
    			31992
    		]
    	],
    	[
    		[
    			12152,
    			12152
    		],
    		"mapped",
    		[
    			32566
    		]
    	],
    	[
    		[
    			12153,
    			12153
    		],
    		"mapped",
    		[
    			32593
    		]
    	],
    	[
    		[
    			12154,
    			12154
    		],
    		"mapped",
    		[
    			32650
    		]
    	],
    	[
    		[
    			12155,
    			12155
    		],
    		"mapped",
    		[
    			32701
    		]
    	],
    	[
    		[
    			12156,
    			12156
    		],
    		"mapped",
    		[
    			32769
    		]
    	],
    	[
    		[
    			12157,
    			12157
    		],
    		"mapped",
    		[
    			32780
    		]
    	],
    	[
    		[
    			12158,
    			12158
    		],
    		"mapped",
    		[
    			32786
    		]
    	],
    	[
    		[
    			12159,
    			12159
    		],
    		"mapped",
    		[
    			32819
    		]
    	],
    	[
    		[
    			12160,
    			12160
    		],
    		"mapped",
    		[
    			32895
    		]
    	],
    	[
    		[
    			12161,
    			12161
    		],
    		"mapped",
    		[
    			32905
    		]
    	],
    	[
    		[
    			12162,
    			12162
    		],
    		"mapped",
    		[
    			33251
    		]
    	],
    	[
    		[
    			12163,
    			12163
    		],
    		"mapped",
    		[
    			33258
    		]
    	],
    	[
    		[
    			12164,
    			12164
    		],
    		"mapped",
    		[
    			33267
    		]
    	],
    	[
    		[
    			12165,
    			12165
    		],
    		"mapped",
    		[
    			33276
    		]
    	],
    	[
    		[
    			12166,
    			12166
    		],
    		"mapped",
    		[
    			33292
    		]
    	],
    	[
    		[
    			12167,
    			12167
    		],
    		"mapped",
    		[
    			33307
    		]
    	],
    	[
    		[
    			12168,
    			12168
    		],
    		"mapped",
    		[
    			33311
    		]
    	],
    	[
    		[
    			12169,
    			12169
    		],
    		"mapped",
    		[
    			33390
    		]
    	],
    	[
    		[
    			12170,
    			12170
    		],
    		"mapped",
    		[
    			33394
    		]
    	],
    	[
    		[
    			12171,
    			12171
    		],
    		"mapped",
    		[
    			33400
    		]
    	],
    	[
    		[
    			12172,
    			12172
    		],
    		"mapped",
    		[
    			34381
    		]
    	],
    	[
    		[
    			12173,
    			12173
    		],
    		"mapped",
    		[
    			34411
    		]
    	],
    	[
    		[
    			12174,
    			12174
    		],
    		"mapped",
    		[
    			34880
    		]
    	],
    	[
    		[
    			12175,
    			12175
    		],
    		"mapped",
    		[
    			34892
    		]
    	],
    	[
    		[
    			12176,
    			12176
    		],
    		"mapped",
    		[
    			34915
    		]
    	],
    	[
    		[
    			12177,
    			12177
    		],
    		"mapped",
    		[
    			35198
    		]
    	],
    	[
    		[
    			12178,
    			12178
    		],
    		"mapped",
    		[
    			35211
    		]
    	],
    	[
    		[
    			12179,
    			12179
    		],
    		"mapped",
    		[
    			35282
    		]
    	],
    	[
    		[
    			12180,
    			12180
    		],
    		"mapped",
    		[
    			35328
    		]
    	],
    	[
    		[
    			12181,
    			12181
    		],
    		"mapped",
    		[
    			35895
    		]
    	],
    	[
    		[
    			12182,
    			12182
    		],
    		"mapped",
    		[
    			35910
    		]
    	],
    	[
    		[
    			12183,
    			12183
    		],
    		"mapped",
    		[
    			35925
    		]
    	],
    	[
    		[
    			12184,
    			12184
    		],
    		"mapped",
    		[
    			35960
    		]
    	],
    	[
    		[
    			12185,
    			12185
    		],
    		"mapped",
    		[
    			35997
    		]
    	],
    	[
    		[
    			12186,
    			12186
    		],
    		"mapped",
    		[
    			36196
    		]
    	],
    	[
    		[
    			12187,
    			12187
    		],
    		"mapped",
    		[
    			36208
    		]
    	],
    	[
    		[
    			12188,
    			12188
    		],
    		"mapped",
    		[
    			36275
    		]
    	],
    	[
    		[
    			12189,
    			12189
    		],
    		"mapped",
    		[
    			36523
    		]
    	],
    	[
    		[
    			12190,
    			12190
    		],
    		"mapped",
    		[
    			36554
    		]
    	],
    	[
    		[
    			12191,
    			12191
    		],
    		"mapped",
    		[
    			36763
    		]
    	],
    	[
    		[
    			12192,
    			12192
    		],
    		"mapped",
    		[
    			36784
    		]
    	],
    	[
    		[
    			12193,
    			12193
    		],
    		"mapped",
    		[
    			36789
    		]
    	],
    	[
    		[
    			12194,
    			12194
    		],
    		"mapped",
    		[
    			37009
    		]
    	],
    	[
    		[
    			12195,
    			12195
    		],
    		"mapped",
    		[
    			37193
    		]
    	],
    	[
    		[
    			12196,
    			12196
    		],
    		"mapped",
    		[
    			37318
    		]
    	],
    	[
    		[
    			12197,
    			12197
    		],
    		"mapped",
    		[
    			37324
    		]
    	],
    	[
    		[
    			12198,
    			12198
    		],
    		"mapped",
    		[
    			37329
    		]
    	],
    	[
    		[
    			12199,
    			12199
    		],
    		"mapped",
    		[
    			38263
    		]
    	],
    	[
    		[
    			12200,
    			12200
    		],
    		"mapped",
    		[
    			38272
    		]
    	],
    	[
    		[
    			12201,
    			12201
    		],
    		"mapped",
    		[
    			38428
    		]
    	],
    	[
    		[
    			12202,
    			12202
    		],
    		"mapped",
    		[
    			38582
    		]
    	],
    	[
    		[
    			12203,
    			12203
    		],
    		"mapped",
    		[
    			38585
    		]
    	],
    	[
    		[
    			12204,
    			12204
    		],
    		"mapped",
    		[
    			38632
    		]
    	],
    	[
    		[
    			12205,
    			12205
    		],
    		"mapped",
    		[
    			38737
    		]
    	],
    	[
    		[
    			12206,
    			12206
    		],
    		"mapped",
    		[
    			38750
    		]
    	],
    	[
    		[
    			12207,
    			12207
    		],
    		"mapped",
    		[
    			38754
    		]
    	],
    	[
    		[
    			12208,
    			12208
    		],
    		"mapped",
    		[
    			38761
    		]
    	],
    	[
    		[
    			12209,
    			12209
    		],
    		"mapped",
    		[
    			38859
    		]
    	],
    	[
    		[
    			12210,
    			12210
    		],
    		"mapped",
    		[
    			38893
    		]
    	],
    	[
    		[
    			12211,
    			12211
    		],
    		"mapped",
    		[
    			38899
    		]
    	],
    	[
    		[
    			12212,
    			12212
    		],
    		"mapped",
    		[
    			38913
    		]
    	],
    	[
    		[
    			12213,
    			12213
    		],
    		"mapped",
    		[
    			39080
    		]
    	],
    	[
    		[
    			12214,
    			12214
    		],
    		"mapped",
    		[
    			39131
    		]
    	],
    	[
    		[
    			12215,
    			12215
    		],
    		"mapped",
    		[
    			39135
    		]
    	],
    	[
    		[
    			12216,
    			12216
    		],
    		"mapped",
    		[
    			39318
    		]
    	],
    	[
    		[
    			12217,
    			12217
    		],
    		"mapped",
    		[
    			39321
    		]
    	],
    	[
    		[
    			12218,
    			12218
    		],
    		"mapped",
    		[
    			39340
    		]
    	],
    	[
    		[
    			12219,
    			12219
    		],
    		"mapped",
    		[
    			39592
    		]
    	],
    	[
    		[
    			12220,
    			12220
    		],
    		"mapped",
    		[
    			39640
    		]
    	],
    	[
    		[
    			12221,
    			12221
    		],
    		"mapped",
    		[
    			39647
    		]
    	],
    	[
    		[
    			12222,
    			12222
    		],
    		"mapped",
    		[
    			39717
    		]
    	],
    	[
    		[
    			12223,
    			12223
    		],
    		"mapped",
    		[
    			39727
    		]
    	],
    	[
    		[
    			12224,
    			12224
    		],
    		"mapped",
    		[
    			39730
    		]
    	],
    	[
    		[
    			12225,
    			12225
    		],
    		"mapped",
    		[
    			39740
    		]
    	],
    	[
    		[
    			12226,
    			12226
    		],
    		"mapped",
    		[
    			39770
    		]
    	],
    	[
    		[
    			12227,
    			12227
    		],
    		"mapped",
    		[
    			40165
    		]
    	],
    	[
    		[
    			12228,
    			12228
    		],
    		"mapped",
    		[
    			40565
    		]
    	],
    	[
    		[
    			12229,
    			12229
    		],
    		"mapped",
    		[
    			40575
    		]
    	],
    	[
    		[
    			12230,
    			12230
    		],
    		"mapped",
    		[
    			40613
    		]
    	],
    	[
    		[
    			12231,
    			12231
    		],
    		"mapped",
    		[
    			40635
    		]
    	],
    	[
    		[
    			12232,
    			12232
    		],
    		"mapped",
    		[
    			40643
    		]
    	],
    	[
    		[
    			12233,
    			12233
    		],
    		"mapped",
    		[
    			40653
    		]
    	],
    	[
    		[
    			12234,
    			12234
    		],
    		"mapped",
    		[
    			40657
    		]
    	],
    	[
    		[
    			12235,
    			12235
    		],
    		"mapped",
    		[
    			40697
    		]
    	],
    	[
    		[
    			12236,
    			12236
    		],
    		"mapped",
    		[
    			40701
    		]
    	],
    	[
    		[
    			12237,
    			12237
    		],
    		"mapped",
    		[
    			40718
    		]
    	],
    	[
    		[
    			12238,
    			12238
    		],
    		"mapped",
    		[
    			40723
    		]
    	],
    	[
    		[
    			12239,
    			12239
    		],
    		"mapped",
    		[
    			40736
    		]
    	],
    	[
    		[
    			12240,
    			12240
    		],
    		"mapped",
    		[
    			40763
    		]
    	],
    	[
    		[
    			12241,
    			12241
    		],
    		"mapped",
    		[
    			40778
    		]
    	],
    	[
    		[
    			12242,
    			12242
    		],
    		"mapped",
    		[
    			40786
    		]
    	],
    	[
    		[
    			12243,
    			12243
    		],
    		"mapped",
    		[
    			40845
    		]
    	],
    	[
    		[
    			12244,
    			12244
    		],
    		"mapped",
    		[
    			40860
    		]
    	],
    	[
    		[
    			12245,
    			12245
    		],
    		"mapped",
    		[
    			40864
    		]
    	],
    	[
    		[
    			12246,
    			12271
    		],
    		"disallowed"
    	],
    	[
    		[
    			12272,
    			12283
    		],
    		"disallowed"
    	],
    	[
    		[
    			12284,
    			12287
    		],
    		"disallowed"
    	],
    	[
    		[
    			12288,
    			12288
    		],
    		"disallowed_STD3_mapped",
    		[
    			32
    		]
    	],
    	[
    		[
    			12289,
    			12289
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			12290,
    			12290
    		],
    		"mapped",
    		[
    			46
    		]
    	],
    	[
    		[
    			12291,
    			12292
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			12293,
    			12295
    		],
    		"valid"
    	],
    	[
    		[
    			12296,
    			12329
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			12330,
    			12333
    		],
    		"valid"
    	],
    	[
    		[
    			12334,
    			12341
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			12342,
    			12342
    		],
    		"mapped",
    		[
    			12306
    		]
    	],
    	[
    		[
    			12343,
    			12343
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			12344,
    			12344
    		],
    		"mapped",
    		[
    			21313
    		]
    	],
    	[
    		[
    			12345,
    			12345
    		],
    		"mapped",
    		[
    			21316
    		]
    	],
    	[
    		[
    			12346,
    			12346
    		],
    		"mapped",
    		[
    			21317
    		]
    	],
    	[
    		[
    			12347,
    			12347
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			12348,
    			12348
    		],
    		"valid"
    	],
    	[
    		[
    			12349,
    			12349
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			12350,
    			12350
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			12351,
    			12351
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			12352,
    			12352
    		],
    		"disallowed"
    	],
    	[
    		[
    			12353,
    			12436
    		],
    		"valid"
    	],
    	[
    		[
    			12437,
    			12438
    		],
    		"valid"
    	],
    	[
    		[
    			12439,
    			12440
    		],
    		"disallowed"
    	],
    	[
    		[
    			12441,
    			12442
    		],
    		"valid"
    	],
    	[
    		[
    			12443,
    			12443
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			12441
    		]
    	],
    	[
    		[
    			12444,
    			12444
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			12442
    		]
    	],
    	[
    		[
    			12445,
    			12446
    		],
    		"valid"
    	],
    	[
    		[
    			12447,
    			12447
    		],
    		"mapped",
    		[
    			12424,
    			12426
    		]
    	],
    	[
    		[
    			12448,
    			12448
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			12449,
    			12542
    		],
    		"valid"
    	],
    	[
    		[
    			12543,
    			12543
    		],
    		"mapped",
    		[
    			12467,
    			12488
    		]
    	],
    	[
    		[
    			12544,
    			12548
    		],
    		"disallowed"
    	],
    	[
    		[
    			12549,
    			12588
    		],
    		"valid"
    	],
    	[
    		[
    			12589,
    			12589
    		],
    		"valid"
    	],
    	[
    		[
    			12590,
    			12592
    		],
    		"disallowed"
    	],
    	[
    		[
    			12593,
    			12593
    		],
    		"mapped",
    		[
    			4352
    		]
    	],
    	[
    		[
    			12594,
    			12594
    		],
    		"mapped",
    		[
    			4353
    		]
    	],
    	[
    		[
    			12595,
    			12595
    		],
    		"mapped",
    		[
    			4522
    		]
    	],
    	[
    		[
    			12596,
    			12596
    		],
    		"mapped",
    		[
    			4354
    		]
    	],
    	[
    		[
    			12597,
    			12597
    		],
    		"mapped",
    		[
    			4524
    		]
    	],
    	[
    		[
    			12598,
    			12598
    		],
    		"mapped",
    		[
    			4525
    		]
    	],
    	[
    		[
    			12599,
    			12599
    		],
    		"mapped",
    		[
    			4355
    		]
    	],
    	[
    		[
    			12600,
    			12600
    		],
    		"mapped",
    		[
    			4356
    		]
    	],
    	[
    		[
    			12601,
    			12601
    		],
    		"mapped",
    		[
    			4357
    		]
    	],
    	[
    		[
    			12602,
    			12602
    		],
    		"mapped",
    		[
    			4528
    		]
    	],
    	[
    		[
    			12603,
    			12603
    		],
    		"mapped",
    		[
    			4529
    		]
    	],
    	[
    		[
    			12604,
    			12604
    		],
    		"mapped",
    		[
    			4530
    		]
    	],
    	[
    		[
    			12605,
    			12605
    		],
    		"mapped",
    		[
    			4531
    		]
    	],
    	[
    		[
    			12606,
    			12606
    		],
    		"mapped",
    		[
    			4532
    		]
    	],
    	[
    		[
    			12607,
    			12607
    		],
    		"mapped",
    		[
    			4533
    		]
    	],
    	[
    		[
    			12608,
    			12608
    		],
    		"mapped",
    		[
    			4378
    		]
    	],
    	[
    		[
    			12609,
    			12609
    		],
    		"mapped",
    		[
    			4358
    		]
    	],
    	[
    		[
    			12610,
    			12610
    		],
    		"mapped",
    		[
    			4359
    		]
    	],
    	[
    		[
    			12611,
    			12611
    		],
    		"mapped",
    		[
    			4360
    		]
    	],
    	[
    		[
    			12612,
    			12612
    		],
    		"mapped",
    		[
    			4385
    		]
    	],
    	[
    		[
    			12613,
    			12613
    		],
    		"mapped",
    		[
    			4361
    		]
    	],
    	[
    		[
    			12614,
    			12614
    		],
    		"mapped",
    		[
    			4362
    		]
    	],
    	[
    		[
    			12615,
    			12615
    		],
    		"mapped",
    		[
    			4363
    		]
    	],
    	[
    		[
    			12616,
    			12616
    		],
    		"mapped",
    		[
    			4364
    		]
    	],
    	[
    		[
    			12617,
    			12617
    		],
    		"mapped",
    		[
    			4365
    		]
    	],
    	[
    		[
    			12618,
    			12618
    		],
    		"mapped",
    		[
    			4366
    		]
    	],
    	[
    		[
    			12619,
    			12619
    		],
    		"mapped",
    		[
    			4367
    		]
    	],
    	[
    		[
    			12620,
    			12620
    		],
    		"mapped",
    		[
    			4368
    		]
    	],
    	[
    		[
    			12621,
    			12621
    		],
    		"mapped",
    		[
    			4369
    		]
    	],
    	[
    		[
    			12622,
    			12622
    		],
    		"mapped",
    		[
    			4370
    		]
    	],
    	[
    		[
    			12623,
    			12623
    		],
    		"mapped",
    		[
    			4449
    		]
    	],
    	[
    		[
    			12624,
    			12624
    		],
    		"mapped",
    		[
    			4450
    		]
    	],
    	[
    		[
    			12625,
    			12625
    		],
    		"mapped",
    		[
    			4451
    		]
    	],
    	[
    		[
    			12626,
    			12626
    		],
    		"mapped",
    		[
    			4452
    		]
    	],
    	[
    		[
    			12627,
    			12627
    		],
    		"mapped",
    		[
    			4453
    		]
    	],
    	[
    		[
    			12628,
    			12628
    		],
    		"mapped",
    		[
    			4454
    		]
    	],
    	[
    		[
    			12629,
    			12629
    		],
    		"mapped",
    		[
    			4455
    		]
    	],
    	[
    		[
    			12630,
    			12630
    		],
    		"mapped",
    		[
    			4456
    		]
    	],
    	[
    		[
    			12631,
    			12631
    		],
    		"mapped",
    		[
    			4457
    		]
    	],
    	[
    		[
    			12632,
    			12632
    		],
    		"mapped",
    		[
    			4458
    		]
    	],
    	[
    		[
    			12633,
    			12633
    		],
    		"mapped",
    		[
    			4459
    		]
    	],
    	[
    		[
    			12634,
    			12634
    		],
    		"mapped",
    		[
    			4460
    		]
    	],
    	[
    		[
    			12635,
    			12635
    		],
    		"mapped",
    		[
    			4461
    		]
    	],
    	[
    		[
    			12636,
    			12636
    		],
    		"mapped",
    		[
    			4462
    		]
    	],
    	[
    		[
    			12637,
    			12637
    		],
    		"mapped",
    		[
    			4463
    		]
    	],
    	[
    		[
    			12638,
    			12638
    		],
    		"mapped",
    		[
    			4464
    		]
    	],
    	[
    		[
    			12639,
    			12639
    		],
    		"mapped",
    		[
    			4465
    		]
    	],
    	[
    		[
    			12640,
    			12640
    		],
    		"mapped",
    		[
    			4466
    		]
    	],
    	[
    		[
    			12641,
    			12641
    		],
    		"mapped",
    		[
    			4467
    		]
    	],
    	[
    		[
    			12642,
    			12642
    		],
    		"mapped",
    		[
    			4468
    		]
    	],
    	[
    		[
    			12643,
    			12643
    		],
    		"mapped",
    		[
    			4469
    		]
    	],
    	[
    		[
    			12644,
    			12644
    		],
    		"disallowed"
    	],
    	[
    		[
    			12645,
    			12645
    		],
    		"mapped",
    		[
    			4372
    		]
    	],
    	[
    		[
    			12646,
    			12646
    		],
    		"mapped",
    		[
    			4373
    		]
    	],
    	[
    		[
    			12647,
    			12647
    		],
    		"mapped",
    		[
    			4551
    		]
    	],
    	[
    		[
    			12648,
    			12648
    		],
    		"mapped",
    		[
    			4552
    		]
    	],
    	[
    		[
    			12649,
    			12649
    		],
    		"mapped",
    		[
    			4556
    		]
    	],
    	[
    		[
    			12650,
    			12650
    		],
    		"mapped",
    		[
    			4558
    		]
    	],
    	[
    		[
    			12651,
    			12651
    		],
    		"mapped",
    		[
    			4563
    		]
    	],
    	[
    		[
    			12652,
    			12652
    		],
    		"mapped",
    		[
    			4567
    		]
    	],
    	[
    		[
    			12653,
    			12653
    		],
    		"mapped",
    		[
    			4569
    		]
    	],
    	[
    		[
    			12654,
    			12654
    		],
    		"mapped",
    		[
    			4380
    		]
    	],
    	[
    		[
    			12655,
    			12655
    		],
    		"mapped",
    		[
    			4573
    		]
    	],
    	[
    		[
    			12656,
    			12656
    		],
    		"mapped",
    		[
    			4575
    		]
    	],
    	[
    		[
    			12657,
    			12657
    		],
    		"mapped",
    		[
    			4381
    		]
    	],
    	[
    		[
    			12658,
    			12658
    		],
    		"mapped",
    		[
    			4382
    		]
    	],
    	[
    		[
    			12659,
    			12659
    		],
    		"mapped",
    		[
    			4384
    		]
    	],
    	[
    		[
    			12660,
    			12660
    		],
    		"mapped",
    		[
    			4386
    		]
    	],
    	[
    		[
    			12661,
    			12661
    		],
    		"mapped",
    		[
    			4387
    		]
    	],
    	[
    		[
    			12662,
    			12662
    		],
    		"mapped",
    		[
    			4391
    		]
    	],
    	[
    		[
    			12663,
    			12663
    		],
    		"mapped",
    		[
    			4393
    		]
    	],
    	[
    		[
    			12664,
    			12664
    		],
    		"mapped",
    		[
    			4395
    		]
    	],
    	[
    		[
    			12665,
    			12665
    		],
    		"mapped",
    		[
    			4396
    		]
    	],
    	[
    		[
    			12666,
    			12666
    		],
    		"mapped",
    		[
    			4397
    		]
    	],
    	[
    		[
    			12667,
    			12667
    		],
    		"mapped",
    		[
    			4398
    		]
    	],
    	[
    		[
    			12668,
    			12668
    		],
    		"mapped",
    		[
    			4399
    		]
    	],
    	[
    		[
    			12669,
    			12669
    		],
    		"mapped",
    		[
    			4402
    		]
    	],
    	[
    		[
    			12670,
    			12670
    		],
    		"mapped",
    		[
    			4406
    		]
    	],
    	[
    		[
    			12671,
    			12671
    		],
    		"mapped",
    		[
    			4416
    		]
    	],
    	[
    		[
    			12672,
    			12672
    		],
    		"mapped",
    		[
    			4423
    		]
    	],
    	[
    		[
    			12673,
    			12673
    		],
    		"mapped",
    		[
    			4428
    		]
    	],
    	[
    		[
    			12674,
    			12674
    		],
    		"mapped",
    		[
    			4593
    		]
    	],
    	[
    		[
    			12675,
    			12675
    		],
    		"mapped",
    		[
    			4594
    		]
    	],
    	[
    		[
    			12676,
    			12676
    		],
    		"mapped",
    		[
    			4439
    		]
    	],
    	[
    		[
    			12677,
    			12677
    		],
    		"mapped",
    		[
    			4440
    		]
    	],
    	[
    		[
    			12678,
    			12678
    		],
    		"mapped",
    		[
    			4441
    		]
    	],
    	[
    		[
    			12679,
    			12679
    		],
    		"mapped",
    		[
    			4484
    		]
    	],
    	[
    		[
    			12680,
    			12680
    		],
    		"mapped",
    		[
    			4485
    		]
    	],
    	[
    		[
    			12681,
    			12681
    		],
    		"mapped",
    		[
    			4488
    		]
    	],
    	[
    		[
    			12682,
    			12682
    		],
    		"mapped",
    		[
    			4497
    		]
    	],
    	[
    		[
    			12683,
    			12683
    		],
    		"mapped",
    		[
    			4498
    		]
    	],
    	[
    		[
    			12684,
    			12684
    		],
    		"mapped",
    		[
    			4500
    		]
    	],
    	[
    		[
    			12685,
    			12685
    		],
    		"mapped",
    		[
    			4510
    		]
    	],
    	[
    		[
    			12686,
    			12686
    		],
    		"mapped",
    		[
    			4513
    		]
    	],
    	[
    		[
    			12687,
    			12687
    		],
    		"disallowed"
    	],
    	[
    		[
    			12688,
    			12689
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			12690,
    			12690
    		],
    		"mapped",
    		[
    			19968
    		]
    	],
    	[
    		[
    			12691,
    			12691
    		],
    		"mapped",
    		[
    			20108
    		]
    	],
    	[
    		[
    			12692,
    			12692
    		],
    		"mapped",
    		[
    			19977
    		]
    	],
    	[
    		[
    			12693,
    			12693
    		],
    		"mapped",
    		[
    			22235
    		]
    	],
    	[
    		[
    			12694,
    			12694
    		],
    		"mapped",
    		[
    			19978
    		]
    	],
    	[
    		[
    			12695,
    			12695
    		],
    		"mapped",
    		[
    			20013
    		]
    	],
    	[
    		[
    			12696,
    			12696
    		],
    		"mapped",
    		[
    			19979
    		]
    	],
    	[
    		[
    			12697,
    			12697
    		],
    		"mapped",
    		[
    			30002
    		]
    	],
    	[
    		[
    			12698,
    			12698
    		],
    		"mapped",
    		[
    			20057
    		]
    	],
    	[
    		[
    			12699,
    			12699
    		],
    		"mapped",
    		[
    			19993
    		]
    	],
    	[
    		[
    			12700,
    			12700
    		],
    		"mapped",
    		[
    			19969
    		]
    	],
    	[
    		[
    			12701,
    			12701
    		],
    		"mapped",
    		[
    			22825
    		]
    	],
    	[
    		[
    			12702,
    			12702
    		],
    		"mapped",
    		[
    			22320
    		]
    	],
    	[
    		[
    			12703,
    			12703
    		],
    		"mapped",
    		[
    			20154
    		]
    	],
    	[
    		[
    			12704,
    			12727
    		],
    		"valid"
    	],
    	[
    		[
    			12728,
    			12730
    		],
    		"valid"
    	],
    	[
    		[
    			12731,
    			12735
    		],
    		"disallowed"
    	],
    	[
    		[
    			12736,
    			12751
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			12752,
    			12771
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			12772,
    			12783
    		],
    		"disallowed"
    	],
    	[
    		[
    			12784,
    			12799
    		],
    		"valid"
    	],
    	[
    		[
    			12800,
    			12800
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			4352,
    			41
    		]
    	],
    	[
    		[
    			12801,
    			12801
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			4354,
    			41
    		]
    	],
    	[
    		[
    			12802,
    			12802
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			4355,
    			41
    		]
    	],
    	[
    		[
    			12803,
    			12803
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			4357,
    			41
    		]
    	],
    	[
    		[
    			12804,
    			12804
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			4358,
    			41
    		]
    	],
    	[
    		[
    			12805,
    			12805
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			4359,
    			41
    		]
    	],
    	[
    		[
    			12806,
    			12806
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			4361,
    			41
    		]
    	],
    	[
    		[
    			12807,
    			12807
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			4363,
    			41
    		]
    	],
    	[
    		[
    			12808,
    			12808
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			4364,
    			41
    		]
    	],
    	[
    		[
    			12809,
    			12809
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			4366,
    			41
    		]
    	],
    	[
    		[
    			12810,
    			12810
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			4367,
    			41
    		]
    	],
    	[
    		[
    			12811,
    			12811
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			4368,
    			41
    		]
    	],
    	[
    		[
    			12812,
    			12812
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			4369,
    			41
    		]
    	],
    	[
    		[
    			12813,
    			12813
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			4370,
    			41
    		]
    	],
    	[
    		[
    			12814,
    			12814
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			44032,
    			41
    		]
    	],
    	[
    		[
    			12815,
    			12815
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			45208,
    			41
    		]
    	],
    	[
    		[
    			12816,
    			12816
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			45796,
    			41
    		]
    	],
    	[
    		[
    			12817,
    			12817
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			46972,
    			41
    		]
    	],
    	[
    		[
    			12818,
    			12818
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			47560,
    			41
    		]
    	],
    	[
    		[
    			12819,
    			12819
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			48148,
    			41
    		]
    	],
    	[
    		[
    			12820,
    			12820
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			49324,
    			41
    		]
    	],
    	[
    		[
    			12821,
    			12821
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			50500,
    			41
    		]
    	],
    	[
    		[
    			12822,
    			12822
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			51088,
    			41
    		]
    	],
    	[
    		[
    			12823,
    			12823
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			52264,
    			41
    		]
    	],
    	[
    		[
    			12824,
    			12824
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			52852,
    			41
    		]
    	],
    	[
    		[
    			12825,
    			12825
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			53440,
    			41
    		]
    	],
    	[
    		[
    			12826,
    			12826
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			54028,
    			41
    		]
    	],
    	[
    		[
    			12827,
    			12827
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			54616,
    			41
    		]
    	],
    	[
    		[
    			12828,
    			12828
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			51452,
    			41
    		]
    	],
    	[
    		[
    			12829,
    			12829
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			50724,
    			51204,
    			41
    		]
    	],
    	[
    		[
    			12830,
    			12830
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			50724,
    			54980,
    			41
    		]
    	],
    	[
    		[
    			12831,
    			12831
    		],
    		"disallowed"
    	],
    	[
    		[
    			12832,
    			12832
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			19968,
    			41
    		]
    	],
    	[
    		[
    			12833,
    			12833
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			20108,
    			41
    		]
    	],
    	[
    		[
    			12834,
    			12834
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			19977,
    			41
    		]
    	],
    	[
    		[
    			12835,
    			12835
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			22235,
    			41
    		]
    	],
    	[
    		[
    			12836,
    			12836
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			20116,
    			41
    		]
    	],
    	[
    		[
    			12837,
    			12837
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			20845,
    			41
    		]
    	],
    	[
    		[
    			12838,
    			12838
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			19971,
    			41
    		]
    	],
    	[
    		[
    			12839,
    			12839
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			20843,
    			41
    		]
    	],
    	[
    		[
    			12840,
    			12840
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			20061,
    			41
    		]
    	],
    	[
    		[
    			12841,
    			12841
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			21313,
    			41
    		]
    	],
    	[
    		[
    			12842,
    			12842
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			26376,
    			41
    		]
    	],
    	[
    		[
    			12843,
    			12843
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			28779,
    			41
    		]
    	],
    	[
    		[
    			12844,
    			12844
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			27700,
    			41
    		]
    	],
    	[
    		[
    			12845,
    			12845
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			26408,
    			41
    		]
    	],
    	[
    		[
    			12846,
    			12846
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			37329,
    			41
    		]
    	],
    	[
    		[
    			12847,
    			12847
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			22303,
    			41
    		]
    	],
    	[
    		[
    			12848,
    			12848
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			26085,
    			41
    		]
    	],
    	[
    		[
    			12849,
    			12849
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			26666,
    			41
    		]
    	],
    	[
    		[
    			12850,
    			12850
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			26377,
    			41
    		]
    	],
    	[
    		[
    			12851,
    			12851
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			31038,
    			41
    		]
    	],
    	[
    		[
    			12852,
    			12852
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			21517,
    			41
    		]
    	],
    	[
    		[
    			12853,
    			12853
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			29305,
    			41
    		]
    	],
    	[
    		[
    			12854,
    			12854
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			36001,
    			41
    		]
    	],
    	[
    		[
    			12855,
    			12855
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			31069,
    			41
    		]
    	],
    	[
    		[
    			12856,
    			12856
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			21172,
    			41
    		]
    	],
    	[
    		[
    			12857,
    			12857
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			20195,
    			41
    		]
    	],
    	[
    		[
    			12858,
    			12858
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			21628,
    			41
    		]
    	],
    	[
    		[
    			12859,
    			12859
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			23398,
    			41
    		]
    	],
    	[
    		[
    			12860,
    			12860
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			30435,
    			41
    		]
    	],
    	[
    		[
    			12861,
    			12861
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			20225,
    			41
    		]
    	],
    	[
    		[
    			12862,
    			12862
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			36039,
    			41
    		]
    	],
    	[
    		[
    			12863,
    			12863
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			21332,
    			41
    		]
    	],
    	[
    		[
    			12864,
    			12864
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			31085,
    			41
    		]
    	],
    	[
    		[
    			12865,
    			12865
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			20241,
    			41
    		]
    	],
    	[
    		[
    			12866,
    			12866
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			33258,
    			41
    		]
    	],
    	[
    		[
    			12867,
    			12867
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			33267,
    			41
    		]
    	],
    	[
    		[
    			12868,
    			12868
    		],
    		"mapped",
    		[
    			21839
    		]
    	],
    	[
    		[
    			12869,
    			12869
    		],
    		"mapped",
    		[
    			24188
    		]
    	],
    	[
    		[
    			12870,
    			12870
    		],
    		"mapped",
    		[
    			25991
    		]
    	],
    	[
    		[
    			12871,
    			12871
    		],
    		"mapped",
    		[
    			31631
    		]
    	],
    	[
    		[
    			12872,
    			12879
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			12880,
    			12880
    		],
    		"mapped",
    		[
    			112,
    			116,
    			101
    		]
    	],
    	[
    		[
    			12881,
    			12881
    		],
    		"mapped",
    		[
    			50,
    			49
    		]
    	],
    	[
    		[
    			12882,
    			12882
    		],
    		"mapped",
    		[
    			50,
    			50
    		]
    	],
    	[
    		[
    			12883,
    			12883
    		],
    		"mapped",
    		[
    			50,
    			51
    		]
    	],
    	[
    		[
    			12884,
    			12884
    		],
    		"mapped",
    		[
    			50,
    			52
    		]
    	],
    	[
    		[
    			12885,
    			12885
    		],
    		"mapped",
    		[
    			50,
    			53
    		]
    	],
    	[
    		[
    			12886,
    			12886
    		],
    		"mapped",
    		[
    			50,
    			54
    		]
    	],
    	[
    		[
    			12887,
    			12887
    		],
    		"mapped",
    		[
    			50,
    			55
    		]
    	],
    	[
    		[
    			12888,
    			12888
    		],
    		"mapped",
    		[
    			50,
    			56
    		]
    	],
    	[
    		[
    			12889,
    			12889
    		],
    		"mapped",
    		[
    			50,
    			57
    		]
    	],
    	[
    		[
    			12890,
    			12890
    		],
    		"mapped",
    		[
    			51,
    			48
    		]
    	],
    	[
    		[
    			12891,
    			12891
    		],
    		"mapped",
    		[
    			51,
    			49
    		]
    	],
    	[
    		[
    			12892,
    			12892
    		],
    		"mapped",
    		[
    			51,
    			50
    		]
    	],
    	[
    		[
    			12893,
    			12893
    		],
    		"mapped",
    		[
    			51,
    			51
    		]
    	],
    	[
    		[
    			12894,
    			12894
    		],
    		"mapped",
    		[
    			51,
    			52
    		]
    	],
    	[
    		[
    			12895,
    			12895
    		],
    		"mapped",
    		[
    			51,
    			53
    		]
    	],
    	[
    		[
    			12896,
    			12896
    		],
    		"mapped",
    		[
    			4352
    		]
    	],
    	[
    		[
    			12897,
    			12897
    		],
    		"mapped",
    		[
    			4354
    		]
    	],
    	[
    		[
    			12898,
    			12898
    		],
    		"mapped",
    		[
    			4355
    		]
    	],
    	[
    		[
    			12899,
    			12899
    		],
    		"mapped",
    		[
    			4357
    		]
    	],
    	[
    		[
    			12900,
    			12900
    		],
    		"mapped",
    		[
    			4358
    		]
    	],
    	[
    		[
    			12901,
    			12901
    		],
    		"mapped",
    		[
    			4359
    		]
    	],
    	[
    		[
    			12902,
    			12902
    		],
    		"mapped",
    		[
    			4361
    		]
    	],
    	[
    		[
    			12903,
    			12903
    		],
    		"mapped",
    		[
    			4363
    		]
    	],
    	[
    		[
    			12904,
    			12904
    		],
    		"mapped",
    		[
    			4364
    		]
    	],
    	[
    		[
    			12905,
    			12905
    		],
    		"mapped",
    		[
    			4366
    		]
    	],
    	[
    		[
    			12906,
    			12906
    		],
    		"mapped",
    		[
    			4367
    		]
    	],
    	[
    		[
    			12907,
    			12907
    		],
    		"mapped",
    		[
    			4368
    		]
    	],
    	[
    		[
    			12908,
    			12908
    		],
    		"mapped",
    		[
    			4369
    		]
    	],
    	[
    		[
    			12909,
    			12909
    		],
    		"mapped",
    		[
    			4370
    		]
    	],
    	[
    		[
    			12910,
    			12910
    		],
    		"mapped",
    		[
    			44032
    		]
    	],
    	[
    		[
    			12911,
    			12911
    		],
    		"mapped",
    		[
    			45208
    		]
    	],
    	[
    		[
    			12912,
    			12912
    		],
    		"mapped",
    		[
    			45796
    		]
    	],
    	[
    		[
    			12913,
    			12913
    		],
    		"mapped",
    		[
    			46972
    		]
    	],
    	[
    		[
    			12914,
    			12914
    		],
    		"mapped",
    		[
    			47560
    		]
    	],
    	[
    		[
    			12915,
    			12915
    		],
    		"mapped",
    		[
    			48148
    		]
    	],
    	[
    		[
    			12916,
    			12916
    		],
    		"mapped",
    		[
    			49324
    		]
    	],
    	[
    		[
    			12917,
    			12917
    		],
    		"mapped",
    		[
    			50500
    		]
    	],
    	[
    		[
    			12918,
    			12918
    		],
    		"mapped",
    		[
    			51088
    		]
    	],
    	[
    		[
    			12919,
    			12919
    		],
    		"mapped",
    		[
    			52264
    		]
    	],
    	[
    		[
    			12920,
    			12920
    		],
    		"mapped",
    		[
    			52852
    		]
    	],
    	[
    		[
    			12921,
    			12921
    		],
    		"mapped",
    		[
    			53440
    		]
    	],
    	[
    		[
    			12922,
    			12922
    		],
    		"mapped",
    		[
    			54028
    		]
    	],
    	[
    		[
    			12923,
    			12923
    		],
    		"mapped",
    		[
    			54616
    		]
    	],
    	[
    		[
    			12924,
    			12924
    		],
    		"mapped",
    		[
    			52280,
    			44256
    		]
    	],
    	[
    		[
    			12925,
    			12925
    		],
    		"mapped",
    		[
    			51452,
    			51032
    		]
    	],
    	[
    		[
    			12926,
    			12926
    		],
    		"mapped",
    		[
    			50864
    		]
    	],
    	[
    		[
    			12927,
    			12927
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			12928,
    			12928
    		],
    		"mapped",
    		[
    			19968
    		]
    	],
    	[
    		[
    			12929,
    			12929
    		],
    		"mapped",
    		[
    			20108
    		]
    	],
    	[
    		[
    			12930,
    			12930
    		],
    		"mapped",
    		[
    			19977
    		]
    	],
    	[
    		[
    			12931,
    			12931
    		],
    		"mapped",
    		[
    			22235
    		]
    	],
    	[
    		[
    			12932,
    			12932
    		],
    		"mapped",
    		[
    			20116
    		]
    	],
    	[
    		[
    			12933,
    			12933
    		],
    		"mapped",
    		[
    			20845
    		]
    	],
    	[
    		[
    			12934,
    			12934
    		],
    		"mapped",
    		[
    			19971
    		]
    	],
    	[
    		[
    			12935,
    			12935
    		],
    		"mapped",
    		[
    			20843
    		]
    	],
    	[
    		[
    			12936,
    			12936
    		],
    		"mapped",
    		[
    			20061
    		]
    	],
    	[
    		[
    			12937,
    			12937
    		],
    		"mapped",
    		[
    			21313
    		]
    	],
    	[
    		[
    			12938,
    			12938
    		],
    		"mapped",
    		[
    			26376
    		]
    	],
    	[
    		[
    			12939,
    			12939
    		],
    		"mapped",
    		[
    			28779
    		]
    	],
    	[
    		[
    			12940,
    			12940
    		],
    		"mapped",
    		[
    			27700
    		]
    	],
    	[
    		[
    			12941,
    			12941
    		],
    		"mapped",
    		[
    			26408
    		]
    	],
    	[
    		[
    			12942,
    			12942
    		],
    		"mapped",
    		[
    			37329
    		]
    	],
    	[
    		[
    			12943,
    			12943
    		],
    		"mapped",
    		[
    			22303
    		]
    	],
    	[
    		[
    			12944,
    			12944
    		],
    		"mapped",
    		[
    			26085
    		]
    	],
    	[
    		[
    			12945,
    			12945
    		],
    		"mapped",
    		[
    			26666
    		]
    	],
    	[
    		[
    			12946,
    			12946
    		],
    		"mapped",
    		[
    			26377
    		]
    	],
    	[
    		[
    			12947,
    			12947
    		],
    		"mapped",
    		[
    			31038
    		]
    	],
    	[
    		[
    			12948,
    			12948
    		],
    		"mapped",
    		[
    			21517
    		]
    	],
    	[
    		[
    			12949,
    			12949
    		],
    		"mapped",
    		[
    			29305
    		]
    	],
    	[
    		[
    			12950,
    			12950
    		],
    		"mapped",
    		[
    			36001
    		]
    	],
    	[
    		[
    			12951,
    			12951
    		],
    		"mapped",
    		[
    			31069
    		]
    	],
    	[
    		[
    			12952,
    			12952
    		],
    		"mapped",
    		[
    			21172
    		]
    	],
    	[
    		[
    			12953,
    			12953
    		],
    		"mapped",
    		[
    			31192
    		]
    	],
    	[
    		[
    			12954,
    			12954
    		],
    		"mapped",
    		[
    			30007
    		]
    	],
    	[
    		[
    			12955,
    			12955
    		],
    		"mapped",
    		[
    			22899
    		]
    	],
    	[
    		[
    			12956,
    			12956
    		],
    		"mapped",
    		[
    			36969
    		]
    	],
    	[
    		[
    			12957,
    			12957
    		],
    		"mapped",
    		[
    			20778
    		]
    	],
    	[
    		[
    			12958,
    			12958
    		],
    		"mapped",
    		[
    			21360
    		]
    	],
    	[
    		[
    			12959,
    			12959
    		],
    		"mapped",
    		[
    			27880
    		]
    	],
    	[
    		[
    			12960,
    			12960
    		],
    		"mapped",
    		[
    			38917
    		]
    	],
    	[
    		[
    			12961,
    			12961
    		],
    		"mapped",
    		[
    			20241
    		]
    	],
    	[
    		[
    			12962,
    			12962
    		],
    		"mapped",
    		[
    			20889
    		]
    	],
    	[
    		[
    			12963,
    			12963
    		],
    		"mapped",
    		[
    			27491
    		]
    	],
    	[
    		[
    			12964,
    			12964
    		],
    		"mapped",
    		[
    			19978
    		]
    	],
    	[
    		[
    			12965,
    			12965
    		],
    		"mapped",
    		[
    			20013
    		]
    	],
    	[
    		[
    			12966,
    			12966
    		],
    		"mapped",
    		[
    			19979
    		]
    	],
    	[
    		[
    			12967,
    			12967
    		],
    		"mapped",
    		[
    			24038
    		]
    	],
    	[
    		[
    			12968,
    			12968
    		],
    		"mapped",
    		[
    			21491
    		]
    	],
    	[
    		[
    			12969,
    			12969
    		],
    		"mapped",
    		[
    			21307
    		]
    	],
    	[
    		[
    			12970,
    			12970
    		],
    		"mapped",
    		[
    			23447
    		]
    	],
    	[
    		[
    			12971,
    			12971
    		],
    		"mapped",
    		[
    			23398
    		]
    	],
    	[
    		[
    			12972,
    			12972
    		],
    		"mapped",
    		[
    			30435
    		]
    	],
    	[
    		[
    			12973,
    			12973
    		],
    		"mapped",
    		[
    			20225
    		]
    	],
    	[
    		[
    			12974,
    			12974
    		],
    		"mapped",
    		[
    			36039
    		]
    	],
    	[
    		[
    			12975,
    			12975
    		],
    		"mapped",
    		[
    			21332
    		]
    	],
    	[
    		[
    			12976,
    			12976
    		],
    		"mapped",
    		[
    			22812
    		]
    	],
    	[
    		[
    			12977,
    			12977
    		],
    		"mapped",
    		[
    			51,
    			54
    		]
    	],
    	[
    		[
    			12978,
    			12978
    		],
    		"mapped",
    		[
    			51,
    			55
    		]
    	],
    	[
    		[
    			12979,
    			12979
    		],
    		"mapped",
    		[
    			51,
    			56
    		]
    	],
    	[
    		[
    			12980,
    			12980
    		],
    		"mapped",
    		[
    			51,
    			57
    		]
    	],
    	[
    		[
    			12981,
    			12981
    		],
    		"mapped",
    		[
    			52,
    			48
    		]
    	],
    	[
    		[
    			12982,
    			12982
    		],
    		"mapped",
    		[
    			52,
    			49
    		]
    	],
    	[
    		[
    			12983,
    			12983
    		],
    		"mapped",
    		[
    			52,
    			50
    		]
    	],
    	[
    		[
    			12984,
    			12984
    		],
    		"mapped",
    		[
    			52,
    			51
    		]
    	],
    	[
    		[
    			12985,
    			12985
    		],
    		"mapped",
    		[
    			52,
    			52
    		]
    	],
    	[
    		[
    			12986,
    			12986
    		],
    		"mapped",
    		[
    			52,
    			53
    		]
    	],
    	[
    		[
    			12987,
    			12987
    		],
    		"mapped",
    		[
    			52,
    			54
    		]
    	],
    	[
    		[
    			12988,
    			12988
    		],
    		"mapped",
    		[
    			52,
    			55
    		]
    	],
    	[
    		[
    			12989,
    			12989
    		],
    		"mapped",
    		[
    			52,
    			56
    		]
    	],
    	[
    		[
    			12990,
    			12990
    		],
    		"mapped",
    		[
    			52,
    			57
    		]
    	],
    	[
    		[
    			12991,
    			12991
    		],
    		"mapped",
    		[
    			53,
    			48
    		]
    	],
    	[
    		[
    			12992,
    			12992
    		],
    		"mapped",
    		[
    			49,
    			26376
    		]
    	],
    	[
    		[
    			12993,
    			12993
    		],
    		"mapped",
    		[
    			50,
    			26376
    		]
    	],
    	[
    		[
    			12994,
    			12994
    		],
    		"mapped",
    		[
    			51,
    			26376
    		]
    	],
    	[
    		[
    			12995,
    			12995
    		],
    		"mapped",
    		[
    			52,
    			26376
    		]
    	],
    	[
    		[
    			12996,
    			12996
    		],
    		"mapped",
    		[
    			53,
    			26376
    		]
    	],
    	[
    		[
    			12997,
    			12997
    		],
    		"mapped",
    		[
    			54,
    			26376
    		]
    	],
    	[
    		[
    			12998,
    			12998
    		],
    		"mapped",
    		[
    			55,
    			26376
    		]
    	],
    	[
    		[
    			12999,
    			12999
    		],
    		"mapped",
    		[
    			56,
    			26376
    		]
    	],
    	[
    		[
    			13000,
    			13000
    		],
    		"mapped",
    		[
    			57,
    			26376
    		]
    	],
    	[
    		[
    			13001,
    			13001
    		],
    		"mapped",
    		[
    			49,
    			48,
    			26376
    		]
    	],
    	[
    		[
    			13002,
    			13002
    		],
    		"mapped",
    		[
    			49,
    			49,
    			26376
    		]
    	],
    	[
    		[
    			13003,
    			13003
    		],
    		"mapped",
    		[
    			49,
    			50,
    			26376
    		]
    	],
    	[
    		[
    			13004,
    			13004
    		],
    		"mapped",
    		[
    			104,
    			103
    		]
    	],
    	[
    		[
    			13005,
    			13005
    		],
    		"mapped",
    		[
    			101,
    			114,
    			103
    		]
    	],
    	[
    		[
    			13006,
    			13006
    		],
    		"mapped",
    		[
    			101,
    			118
    		]
    	],
    	[
    		[
    			13007,
    			13007
    		],
    		"mapped",
    		[
    			108,
    			116,
    			100
    		]
    	],
    	[
    		[
    			13008,
    			13008
    		],
    		"mapped",
    		[
    			12450
    		]
    	],
    	[
    		[
    			13009,
    			13009
    		],
    		"mapped",
    		[
    			12452
    		]
    	],
    	[
    		[
    			13010,
    			13010
    		],
    		"mapped",
    		[
    			12454
    		]
    	],
    	[
    		[
    			13011,
    			13011
    		],
    		"mapped",
    		[
    			12456
    		]
    	],
    	[
    		[
    			13012,
    			13012
    		],
    		"mapped",
    		[
    			12458
    		]
    	],
    	[
    		[
    			13013,
    			13013
    		],
    		"mapped",
    		[
    			12459
    		]
    	],
    	[
    		[
    			13014,
    			13014
    		],
    		"mapped",
    		[
    			12461
    		]
    	],
    	[
    		[
    			13015,
    			13015
    		],
    		"mapped",
    		[
    			12463
    		]
    	],
    	[
    		[
    			13016,
    			13016
    		],
    		"mapped",
    		[
    			12465
    		]
    	],
    	[
    		[
    			13017,
    			13017
    		],
    		"mapped",
    		[
    			12467
    		]
    	],
    	[
    		[
    			13018,
    			13018
    		],
    		"mapped",
    		[
    			12469
    		]
    	],
    	[
    		[
    			13019,
    			13019
    		],
    		"mapped",
    		[
    			12471
    		]
    	],
    	[
    		[
    			13020,
    			13020
    		],
    		"mapped",
    		[
    			12473
    		]
    	],
    	[
    		[
    			13021,
    			13021
    		],
    		"mapped",
    		[
    			12475
    		]
    	],
    	[
    		[
    			13022,
    			13022
    		],
    		"mapped",
    		[
    			12477
    		]
    	],
    	[
    		[
    			13023,
    			13023
    		],
    		"mapped",
    		[
    			12479
    		]
    	],
    	[
    		[
    			13024,
    			13024
    		],
    		"mapped",
    		[
    			12481
    		]
    	],
    	[
    		[
    			13025,
    			13025
    		],
    		"mapped",
    		[
    			12484
    		]
    	],
    	[
    		[
    			13026,
    			13026
    		],
    		"mapped",
    		[
    			12486
    		]
    	],
    	[
    		[
    			13027,
    			13027
    		],
    		"mapped",
    		[
    			12488
    		]
    	],
    	[
    		[
    			13028,
    			13028
    		],
    		"mapped",
    		[
    			12490
    		]
    	],
    	[
    		[
    			13029,
    			13029
    		],
    		"mapped",
    		[
    			12491
    		]
    	],
    	[
    		[
    			13030,
    			13030
    		],
    		"mapped",
    		[
    			12492
    		]
    	],
    	[
    		[
    			13031,
    			13031
    		],
    		"mapped",
    		[
    			12493
    		]
    	],
    	[
    		[
    			13032,
    			13032
    		],
    		"mapped",
    		[
    			12494
    		]
    	],
    	[
    		[
    			13033,
    			13033
    		],
    		"mapped",
    		[
    			12495
    		]
    	],
    	[
    		[
    			13034,
    			13034
    		],
    		"mapped",
    		[
    			12498
    		]
    	],
    	[
    		[
    			13035,
    			13035
    		],
    		"mapped",
    		[
    			12501
    		]
    	],
    	[
    		[
    			13036,
    			13036
    		],
    		"mapped",
    		[
    			12504
    		]
    	],
    	[
    		[
    			13037,
    			13037
    		],
    		"mapped",
    		[
    			12507
    		]
    	],
    	[
    		[
    			13038,
    			13038
    		],
    		"mapped",
    		[
    			12510
    		]
    	],
    	[
    		[
    			13039,
    			13039
    		],
    		"mapped",
    		[
    			12511
    		]
    	],
    	[
    		[
    			13040,
    			13040
    		],
    		"mapped",
    		[
    			12512
    		]
    	],
    	[
    		[
    			13041,
    			13041
    		],
    		"mapped",
    		[
    			12513
    		]
    	],
    	[
    		[
    			13042,
    			13042
    		],
    		"mapped",
    		[
    			12514
    		]
    	],
    	[
    		[
    			13043,
    			13043
    		],
    		"mapped",
    		[
    			12516
    		]
    	],
    	[
    		[
    			13044,
    			13044
    		],
    		"mapped",
    		[
    			12518
    		]
    	],
    	[
    		[
    			13045,
    			13045
    		],
    		"mapped",
    		[
    			12520
    		]
    	],
    	[
    		[
    			13046,
    			13046
    		],
    		"mapped",
    		[
    			12521
    		]
    	],
    	[
    		[
    			13047,
    			13047
    		],
    		"mapped",
    		[
    			12522
    		]
    	],
    	[
    		[
    			13048,
    			13048
    		],
    		"mapped",
    		[
    			12523
    		]
    	],
    	[
    		[
    			13049,
    			13049
    		],
    		"mapped",
    		[
    			12524
    		]
    	],
    	[
    		[
    			13050,
    			13050
    		],
    		"mapped",
    		[
    			12525
    		]
    	],
    	[
    		[
    			13051,
    			13051
    		],
    		"mapped",
    		[
    			12527
    		]
    	],
    	[
    		[
    			13052,
    			13052
    		],
    		"mapped",
    		[
    			12528
    		]
    	],
    	[
    		[
    			13053,
    			13053
    		],
    		"mapped",
    		[
    			12529
    		]
    	],
    	[
    		[
    			13054,
    			13054
    		],
    		"mapped",
    		[
    			12530
    		]
    	],
    	[
    		[
    			13055,
    			13055
    		],
    		"disallowed"
    	],
    	[
    		[
    			13056,
    			13056
    		],
    		"mapped",
    		[
    			12450,
    			12497,
    			12540,
    			12488
    		]
    	],
    	[
    		[
    			13057,
    			13057
    		],
    		"mapped",
    		[
    			12450,
    			12523,
    			12501,
    			12449
    		]
    	],
    	[
    		[
    			13058,
    			13058
    		],
    		"mapped",
    		[
    			12450,
    			12531,
    			12506,
    			12450
    		]
    	],
    	[
    		[
    			13059,
    			13059
    		],
    		"mapped",
    		[
    			12450,
    			12540,
    			12523
    		]
    	],
    	[
    		[
    			13060,
    			13060
    		],
    		"mapped",
    		[
    			12452,
    			12491,
    			12531,
    			12464
    		]
    	],
    	[
    		[
    			13061,
    			13061
    		],
    		"mapped",
    		[
    			12452,
    			12531,
    			12481
    		]
    	],
    	[
    		[
    			13062,
    			13062
    		],
    		"mapped",
    		[
    			12454,
    			12457,
    			12531
    		]
    	],
    	[
    		[
    			13063,
    			13063
    		],
    		"mapped",
    		[
    			12456,
    			12473,
    			12463,
    			12540,
    			12489
    		]
    	],
    	[
    		[
    			13064,
    			13064
    		],
    		"mapped",
    		[
    			12456,
    			12540,
    			12459,
    			12540
    		]
    	],
    	[
    		[
    			13065,
    			13065
    		],
    		"mapped",
    		[
    			12458,
    			12531,
    			12473
    		]
    	],
    	[
    		[
    			13066,
    			13066
    		],
    		"mapped",
    		[
    			12458,
    			12540,
    			12512
    		]
    	],
    	[
    		[
    			13067,
    			13067
    		],
    		"mapped",
    		[
    			12459,
    			12452,
    			12522
    		]
    	],
    	[
    		[
    			13068,
    			13068
    		],
    		"mapped",
    		[
    			12459,
    			12521,
    			12483,
    			12488
    		]
    	],
    	[
    		[
    			13069,
    			13069
    		],
    		"mapped",
    		[
    			12459,
    			12525,
    			12522,
    			12540
    		]
    	],
    	[
    		[
    			13070,
    			13070
    		],
    		"mapped",
    		[
    			12460,
    			12525,
    			12531
    		]
    	],
    	[
    		[
    			13071,
    			13071
    		],
    		"mapped",
    		[
    			12460,
    			12531,
    			12510
    		]
    	],
    	[
    		[
    			13072,
    			13072
    		],
    		"mapped",
    		[
    			12462,
    			12460
    		]
    	],
    	[
    		[
    			13073,
    			13073
    		],
    		"mapped",
    		[
    			12462,
    			12491,
    			12540
    		]
    	],
    	[
    		[
    			13074,
    			13074
    		],
    		"mapped",
    		[
    			12461,
    			12517,
    			12522,
    			12540
    		]
    	],
    	[
    		[
    			13075,
    			13075
    		],
    		"mapped",
    		[
    			12462,
    			12523,
    			12480,
    			12540
    		]
    	],
    	[
    		[
    			13076,
    			13076
    		],
    		"mapped",
    		[
    			12461,
    			12525
    		]
    	],
    	[
    		[
    			13077,
    			13077
    		],
    		"mapped",
    		[
    			12461,
    			12525,
    			12464,
    			12521,
    			12512
    		]
    	],
    	[
    		[
    			13078,
    			13078
    		],
    		"mapped",
    		[
    			12461,
    			12525,
    			12513,
    			12540,
    			12488,
    			12523
    		]
    	],
    	[
    		[
    			13079,
    			13079
    		],
    		"mapped",
    		[
    			12461,
    			12525,
    			12527,
    			12483,
    			12488
    		]
    	],
    	[
    		[
    			13080,
    			13080
    		],
    		"mapped",
    		[
    			12464,
    			12521,
    			12512
    		]
    	],
    	[
    		[
    			13081,
    			13081
    		],
    		"mapped",
    		[
    			12464,
    			12521,
    			12512,
    			12488,
    			12531
    		]
    	],
    	[
    		[
    			13082,
    			13082
    		],
    		"mapped",
    		[
    			12463,
    			12523,
    			12476,
    			12452,
    			12525
    		]
    	],
    	[
    		[
    			13083,
    			13083
    		],
    		"mapped",
    		[
    			12463,
    			12525,
    			12540,
    			12493
    		]
    	],
    	[
    		[
    			13084,
    			13084
    		],
    		"mapped",
    		[
    			12465,
    			12540,
    			12473
    		]
    	],
    	[
    		[
    			13085,
    			13085
    		],
    		"mapped",
    		[
    			12467,
    			12523,
    			12490
    		]
    	],
    	[
    		[
    			13086,
    			13086
    		],
    		"mapped",
    		[
    			12467,
    			12540,
    			12509
    		]
    	],
    	[
    		[
    			13087,
    			13087
    		],
    		"mapped",
    		[
    			12469,
    			12452,
    			12463,
    			12523
    		]
    	],
    	[
    		[
    			13088,
    			13088
    		],
    		"mapped",
    		[
    			12469,
    			12531,
    			12481,
    			12540,
    			12512
    		]
    	],
    	[
    		[
    			13089,
    			13089
    		],
    		"mapped",
    		[
    			12471,
    			12522,
    			12531,
    			12464
    		]
    	],
    	[
    		[
    			13090,
    			13090
    		],
    		"mapped",
    		[
    			12475,
    			12531,
    			12481
    		]
    	],
    	[
    		[
    			13091,
    			13091
    		],
    		"mapped",
    		[
    			12475,
    			12531,
    			12488
    		]
    	],
    	[
    		[
    			13092,
    			13092
    		],
    		"mapped",
    		[
    			12480,
    			12540,
    			12473
    		]
    	],
    	[
    		[
    			13093,
    			13093
    		],
    		"mapped",
    		[
    			12487,
    			12471
    		]
    	],
    	[
    		[
    			13094,
    			13094
    		],
    		"mapped",
    		[
    			12489,
    			12523
    		]
    	],
    	[
    		[
    			13095,
    			13095
    		],
    		"mapped",
    		[
    			12488,
    			12531
    		]
    	],
    	[
    		[
    			13096,
    			13096
    		],
    		"mapped",
    		[
    			12490,
    			12494
    		]
    	],
    	[
    		[
    			13097,
    			13097
    		],
    		"mapped",
    		[
    			12494,
    			12483,
    			12488
    		]
    	],
    	[
    		[
    			13098,
    			13098
    		],
    		"mapped",
    		[
    			12495,
    			12452,
    			12484
    		]
    	],
    	[
    		[
    			13099,
    			13099
    		],
    		"mapped",
    		[
    			12497,
    			12540,
    			12475,
    			12531,
    			12488
    		]
    	],
    	[
    		[
    			13100,
    			13100
    		],
    		"mapped",
    		[
    			12497,
    			12540,
    			12484
    		]
    	],
    	[
    		[
    			13101,
    			13101
    		],
    		"mapped",
    		[
    			12496,
    			12540,
    			12524,
    			12523
    		]
    	],
    	[
    		[
    			13102,
    			13102
    		],
    		"mapped",
    		[
    			12500,
    			12450,
    			12473,
    			12488,
    			12523
    		]
    	],
    	[
    		[
    			13103,
    			13103
    		],
    		"mapped",
    		[
    			12500,
    			12463,
    			12523
    		]
    	],
    	[
    		[
    			13104,
    			13104
    		],
    		"mapped",
    		[
    			12500,
    			12467
    		]
    	],
    	[
    		[
    			13105,
    			13105
    		],
    		"mapped",
    		[
    			12499,
    			12523
    		]
    	],
    	[
    		[
    			13106,
    			13106
    		],
    		"mapped",
    		[
    			12501,
    			12449,
    			12521,
    			12483,
    			12489
    		]
    	],
    	[
    		[
    			13107,
    			13107
    		],
    		"mapped",
    		[
    			12501,
    			12451,
    			12540,
    			12488
    		]
    	],
    	[
    		[
    			13108,
    			13108
    		],
    		"mapped",
    		[
    			12502,
    			12483,
    			12471,
    			12455,
    			12523
    		]
    	],
    	[
    		[
    			13109,
    			13109
    		],
    		"mapped",
    		[
    			12501,
    			12521,
    			12531
    		]
    	],
    	[
    		[
    			13110,
    			13110
    		],
    		"mapped",
    		[
    			12504,
    			12463,
    			12479,
    			12540,
    			12523
    		]
    	],
    	[
    		[
    			13111,
    			13111
    		],
    		"mapped",
    		[
    			12506,
    			12477
    		]
    	],
    	[
    		[
    			13112,
    			13112
    		],
    		"mapped",
    		[
    			12506,
    			12491,
    			12498
    		]
    	],
    	[
    		[
    			13113,
    			13113
    		],
    		"mapped",
    		[
    			12504,
    			12523,
    			12484
    		]
    	],
    	[
    		[
    			13114,
    			13114
    		],
    		"mapped",
    		[
    			12506,
    			12531,
    			12473
    		]
    	],
    	[
    		[
    			13115,
    			13115
    		],
    		"mapped",
    		[
    			12506,
    			12540,
    			12472
    		]
    	],
    	[
    		[
    			13116,
    			13116
    		],
    		"mapped",
    		[
    			12505,
    			12540,
    			12479
    		]
    	],
    	[
    		[
    			13117,
    			13117
    		],
    		"mapped",
    		[
    			12509,
    			12452,
    			12531,
    			12488
    		]
    	],
    	[
    		[
    			13118,
    			13118
    		],
    		"mapped",
    		[
    			12508,
    			12523,
    			12488
    		]
    	],
    	[
    		[
    			13119,
    			13119
    		],
    		"mapped",
    		[
    			12507,
    			12531
    		]
    	],
    	[
    		[
    			13120,
    			13120
    		],
    		"mapped",
    		[
    			12509,
    			12531,
    			12489
    		]
    	],
    	[
    		[
    			13121,
    			13121
    		],
    		"mapped",
    		[
    			12507,
    			12540,
    			12523
    		]
    	],
    	[
    		[
    			13122,
    			13122
    		],
    		"mapped",
    		[
    			12507,
    			12540,
    			12531
    		]
    	],
    	[
    		[
    			13123,
    			13123
    		],
    		"mapped",
    		[
    			12510,
    			12452,
    			12463,
    			12525
    		]
    	],
    	[
    		[
    			13124,
    			13124
    		],
    		"mapped",
    		[
    			12510,
    			12452,
    			12523
    		]
    	],
    	[
    		[
    			13125,
    			13125
    		],
    		"mapped",
    		[
    			12510,
    			12483,
    			12495
    		]
    	],
    	[
    		[
    			13126,
    			13126
    		],
    		"mapped",
    		[
    			12510,
    			12523,
    			12463
    		]
    	],
    	[
    		[
    			13127,
    			13127
    		],
    		"mapped",
    		[
    			12510,
    			12531,
    			12471,
    			12519,
    			12531
    		]
    	],
    	[
    		[
    			13128,
    			13128
    		],
    		"mapped",
    		[
    			12511,
    			12463,
    			12525,
    			12531
    		]
    	],
    	[
    		[
    			13129,
    			13129
    		],
    		"mapped",
    		[
    			12511,
    			12522
    		]
    	],
    	[
    		[
    			13130,
    			13130
    		],
    		"mapped",
    		[
    			12511,
    			12522,
    			12496,
    			12540,
    			12523
    		]
    	],
    	[
    		[
    			13131,
    			13131
    		],
    		"mapped",
    		[
    			12513,
    			12460
    		]
    	],
    	[
    		[
    			13132,
    			13132
    		],
    		"mapped",
    		[
    			12513,
    			12460,
    			12488,
    			12531
    		]
    	],
    	[
    		[
    			13133,
    			13133
    		],
    		"mapped",
    		[
    			12513,
    			12540,
    			12488,
    			12523
    		]
    	],
    	[
    		[
    			13134,
    			13134
    		],
    		"mapped",
    		[
    			12516,
    			12540,
    			12489
    		]
    	],
    	[
    		[
    			13135,
    			13135
    		],
    		"mapped",
    		[
    			12516,
    			12540,
    			12523
    		]
    	],
    	[
    		[
    			13136,
    			13136
    		],
    		"mapped",
    		[
    			12518,
    			12450,
    			12531
    		]
    	],
    	[
    		[
    			13137,
    			13137
    		],
    		"mapped",
    		[
    			12522,
    			12483,
    			12488,
    			12523
    		]
    	],
    	[
    		[
    			13138,
    			13138
    		],
    		"mapped",
    		[
    			12522,
    			12521
    		]
    	],
    	[
    		[
    			13139,
    			13139
    		],
    		"mapped",
    		[
    			12523,
    			12500,
    			12540
    		]
    	],
    	[
    		[
    			13140,
    			13140
    		],
    		"mapped",
    		[
    			12523,
    			12540,
    			12502,
    			12523
    		]
    	],
    	[
    		[
    			13141,
    			13141
    		],
    		"mapped",
    		[
    			12524,
    			12512
    		]
    	],
    	[
    		[
    			13142,
    			13142
    		],
    		"mapped",
    		[
    			12524,
    			12531,
    			12488,
    			12466,
    			12531
    		]
    	],
    	[
    		[
    			13143,
    			13143
    		],
    		"mapped",
    		[
    			12527,
    			12483,
    			12488
    		]
    	],
    	[
    		[
    			13144,
    			13144
    		],
    		"mapped",
    		[
    			48,
    			28857
    		]
    	],
    	[
    		[
    			13145,
    			13145
    		],
    		"mapped",
    		[
    			49,
    			28857
    		]
    	],
    	[
    		[
    			13146,
    			13146
    		],
    		"mapped",
    		[
    			50,
    			28857
    		]
    	],
    	[
    		[
    			13147,
    			13147
    		],
    		"mapped",
    		[
    			51,
    			28857
    		]
    	],
    	[
    		[
    			13148,
    			13148
    		],
    		"mapped",
    		[
    			52,
    			28857
    		]
    	],
    	[
    		[
    			13149,
    			13149
    		],
    		"mapped",
    		[
    			53,
    			28857
    		]
    	],
    	[
    		[
    			13150,
    			13150
    		],
    		"mapped",
    		[
    			54,
    			28857
    		]
    	],
    	[
    		[
    			13151,
    			13151
    		],
    		"mapped",
    		[
    			55,
    			28857
    		]
    	],
    	[
    		[
    			13152,
    			13152
    		],
    		"mapped",
    		[
    			56,
    			28857
    		]
    	],
    	[
    		[
    			13153,
    			13153
    		],
    		"mapped",
    		[
    			57,
    			28857
    		]
    	],
    	[
    		[
    			13154,
    			13154
    		],
    		"mapped",
    		[
    			49,
    			48,
    			28857
    		]
    	],
    	[
    		[
    			13155,
    			13155
    		],
    		"mapped",
    		[
    			49,
    			49,
    			28857
    		]
    	],
    	[
    		[
    			13156,
    			13156
    		],
    		"mapped",
    		[
    			49,
    			50,
    			28857
    		]
    	],
    	[
    		[
    			13157,
    			13157
    		],
    		"mapped",
    		[
    			49,
    			51,
    			28857
    		]
    	],
    	[
    		[
    			13158,
    			13158
    		],
    		"mapped",
    		[
    			49,
    			52,
    			28857
    		]
    	],
    	[
    		[
    			13159,
    			13159
    		],
    		"mapped",
    		[
    			49,
    			53,
    			28857
    		]
    	],
    	[
    		[
    			13160,
    			13160
    		],
    		"mapped",
    		[
    			49,
    			54,
    			28857
    		]
    	],
    	[
    		[
    			13161,
    			13161
    		],
    		"mapped",
    		[
    			49,
    			55,
    			28857
    		]
    	],
    	[
    		[
    			13162,
    			13162
    		],
    		"mapped",
    		[
    			49,
    			56,
    			28857
    		]
    	],
    	[
    		[
    			13163,
    			13163
    		],
    		"mapped",
    		[
    			49,
    			57,
    			28857
    		]
    	],
    	[
    		[
    			13164,
    			13164
    		],
    		"mapped",
    		[
    			50,
    			48,
    			28857
    		]
    	],
    	[
    		[
    			13165,
    			13165
    		],
    		"mapped",
    		[
    			50,
    			49,
    			28857
    		]
    	],
    	[
    		[
    			13166,
    			13166
    		],
    		"mapped",
    		[
    			50,
    			50,
    			28857
    		]
    	],
    	[
    		[
    			13167,
    			13167
    		],
    		"mapped",
    		[
    			50,
    			51,
    			28857
    		]
    	],
    	[
    		[
    			13168,
    			13168
    		],
    		"mapped",
    		[
    			50,
    			52,
    			28857
    		]
    	],
    	[
    		[
    			13169,
    			13169
    		],
    		"mapped",
    		[
    			104,
    			112,
    			97
    		]
    	],
    	[
    		[
    			13170,
    			13170
    		],
    		"mapped",
    		[
    			100,
    			97
    		]
    	],
    	[
    		[
    			13171,
    			13171
    		],
    		"mapped",
    		[
    			97,
    			117
    		]
    	],
    	[
    		[
    			13172,
    			13172
    		],
    		"mapped",
    		[
    			98,
    			97,
    			114
    		]
    	],
    	[
    		[
    			13173,
    			13173
    		],
    		"mapped",
    		[
    			111,
    			118
    		]
    	],
    	[
    		[
    			13174,
    			13174
    		],
    		"mapped",
    		[
    			112,
    			99
    		]
    	],
    	[
    		[
    			13175,
    			13175
    		],
    		"mapped",
    		[
    			100,
    			109
    		]
    	],
    	[
    		[
    			13176,
    			13176
    		],
    		"mapped",
    		[
    			100,
    			109,
    			50
    		]
    	],
    	[
    		[
    			13177,
    			13177
    		],
    		"mapped",
    		[
    			100,
    			109,
    			51
    		]
    	],
    	[
    		[
    			13178,
    			13178
    		],
    		"mapped",
    		[
    			105,
    			117
    		]
    	],
    	[
    		[
    			13179,
    			13179
    		],
    		"mapped",
    		[
    			24179,
    			25104
    		]
    	],
    	[
    		[
    			13180,
    			13180
    		],
    		"mapped",
    		[
    			26157,
    			21644
    		]
    	],
    	[
    		[
    			13181,
    			13181
    		],
    		"mapped",
    		[
    			22823,
    			27491
    		]
    	],
    	[
    		[
    			13182,
    			13182
    		],
    		"mapped",
    		[
    			26126,
    			27835
    		]
    	],
    	[
    		[
    			13183,
    			13183
    		],
    		"mapped",
    		[
    			26666,
    			24335,
    			20250,
    			31038
    		]
    	],
    	[
    		[
    			13184,
    			13184
    		],
    		"mapped",
    		[
    			112,
    			97
    		]
    	],
    	[
    		[
    			13185,
    			13185
    		],
    		"mapped",
    		[
    			110,
    			97
    		]
    	],
    	[
    		[
    			13186,
    			13186
    		],
    		"mapped",
    		[
    			956,
    			97
    		]
    	],
    	[
    		[
    			13187,
    			13187
    		],
    		"mapped",
    		[
    			109,
    			97
    		]
    	],
    	[
    		[
    			13188,
    			13188
    		],
    		"mapped",
    		[
    			107,
    			97
    		]
    	],
    	[
    		[
    			13189,
    			13189
    		],
    		"mapped",
    		[
    			107,
    			98
    		]
    	],
    	[
    		[
    			13190,
    			13190
    		],
    		"mapped",
    		[
    			109,
    			98
    		]
    	],
    	[
    		[
    			13191,
    			13191
    		],
    		"mapped",
    		[
    			103,
    			98
    		]
    	],
    	[
    		[
    			13192,
    			13192
    		],
    		"mapped",
    		[
    			99,
    			97,
    			108
    		]
    	],
    	[
    		[
    			13193,
    			13193
    		],
    		"mapped",
    		[
    			107,
    			99,
    			97,
    			108
    		]
    	],
    	[
    		[
    			13194,
    			13194
    		],
    		"mapped",
    		[
    			112,
    			102
    		]
    	],
    	[
    		[
    			13195,
    			13195
    		],
    		"mapped",
    		[
    			110,
    			102
    		]
    	],
    	[
    		[
    			13196,
    			13196
    		],
    		"mapped",
    		[
    			956,
    			102
    		]
    	],
    	[
    		[
    			13197,
    			13197
    		],
    		"mapped",
    		[
    			956,
    			103
    		]
    	],
    	[
    		[
    			13198,
    			13198
    		],
    		"mapped",
    		[
    			109,
    			103
    		]
    	],
    	[
    		[
    			13199,
    			13199
    		],
    		"mapped",
    		[
    			107,
    			103
    		]
    	],
    	[
    		[
    			13200,
    			13200
    		],
    		"mapped",
    		[
    			104,
    			122
    		]
    	],
    	[
    		[
    			13201,
    			13201
    		],
    		"mapped",
    		[
    			107,
    			104,
    			122
    		]
    	],
    	[
    		[
    			13202,
    			13202
    		],
    		"mapped",
    		[
    			109,
    			104,
    			122
    		]
    	],
    	[
    		[
    			13203,
    			13203
    		],
    		"mapped",
    		[
    			103,
    			104,
    			122
    		]
    	],
    	[
    		[
    			13204,
    			13204
    		],
    		"mapped",
    		[
    			116,
    			104,
    			122
    		]
    	],
    	[
    		[
    			13205,
    			13205
    		],
    		"mapped",
    		[
    			956,
    			108
    		]
    	],
    	[
    		[
    			13206,
    			13206
    		],
    		"mapped",
    		[
    			109,
    			108
    		]
    	],
    	[
    		[
    			13207,
    			13207
    		],
    		"mapped",
    		[
    			100,
    			108
    		]
    	],
    	[
    		[
    			13208,
    			13208
    		],
    		"mapped",
    		[
    			107,
    			108
    		]
    	],
    	[
    		[
    			13209,
    			13209
    		],
    		"mapped",
    		[
    			102,
    			109
    		]
    	],
    	[
    		[
    			13210,
    			13210
    		],
    		"mapped",
    		[
    			110,
    			109
    		]
    	],
    	[
    		[
    			13211,
    			13211
    		],
    		"mapped",
    		[
    			956,
    			109
    		]
    	],
    	[
    		[
    			13212,
    			13212
    		],
    		"mapped",
    		[
    			109,
    			109
    		]
    	],
    	[
    		[
    			13213,
    			13213
    		],
    		"mapped",
    		[
    			99,
    			109
    		]
    	],
    	[
    		[
    			13214,
    			13214
    		],
    		"mapped",
    		[
    			107,
    			109
    		]
    	],
    	[
    		[
    			13215,
    			13215
    		],
    		"mapped",
    		[
    			109,
    			109,
    			50
    		]
    	],
    	[
    		[
    			13216,
    			13216
    		],
    		"mapped",
    		[
    			99,
    			109,
    			50
    		]
    	],
    	[
    		[
    			13217,
    			13217
    		],
    		"mapped",
    		[
    			109,
    			50
    		]
    	],
    	[
    		[
    			13218,
    			13218
    		],
    		"mapped",
    		[
    			107,
    			109,
    			50
    		]
    	],
    	[
    		[
    			13219,
    			13219
    		],
    		"mapped",
    		[
    			109,
    			109,
    			51
    		]
    	],
    	[
    		[
    			13220,
    			13220
    		],
    		"mapped",
    		[
    			99,
    			109,
    			51
    		]
    	],
    	[
    		[
    			13221,
    			13221
    		],
    		"mapped",
    		[
    			109,
    			51
    		]
    	],
    	[
    		[
    			13222,
    			13222
    		],
    		"mapped",
    		[
    			107,
    			109,
    			51
    		]
    	],
    	[
    		[
    			13223,
    			13223
    		],
    		"mapped",
    		[
    			109,
    			8725,
    			115
    		]
    	],
    	[
    		[
    			13224,
    			13224
    		],
    		"mapped",
    		[
    			109,
    			8725,
    			115,
    			50
    		]
    	],
    	[
    		[
    			13225,
    			13225
    		],
    		"mapped",
    		[
    			112,
    			97
    		]
    	],
    	[
    		[
    			13226,
    			13226
    		],
    		"mapped",
    		[
    			107,
    			112,
    			97
    		]
    	],
    	[
    		[
    			13227,
    			13227
    		],
    		"mapped",
    		[
    			109,
    			112,
    			97
    		]
    	],
    	[
    		[
    			13228,
    			13228
    		],
    		"mapped",
    		[
    			103,
    			112,
    			97
    		]
    	],
    	[
    		[
    			13229,
    			13229
    		],
    		"mapped",
    		[
    			114,
    			97,
    			100
    		]
    	],
    	[
    		[
    			13230,
    			13230
    		],
    		"mapped",
    		[
    			114,
    			97,
    			100,
    			8725,
    			115
    		]
    	],
    	[
    		[
    			13231,
    			13231
    		],
    		"mapped",
    		[
    			114,
    			97,
    			100,
    			8725,
    			115,
    			50
    		]
    	],
    	[
    		[
    			13232,
    			13232
    		],
    		"mapped",
    		[
    			112,
    			115
    		]
    	],
    	[
    		[
    			13233,
    			13233
    		],
    		"mapped",
    		[
    			110,
    			115
    		]
    	],
    	[
    		[
    			13234,
    			13234
    		],
    		"mapped",
    		[
    			956,
    			115
    		]
    	],
    	[
    		[
    			13235,
    			13235
    		],
    		"mapped",
    		[
    			109,
    			115
    		]
    	],
    	[
    		[
    			13236,
    			13236
    		],
    		"mapped",
    		[
    			112,
    			118
    		]
    	],
    	[
    		[
    			13237,
    			13237
    		],
    		"mapped",
    		[
    			110,
    			118
    		]
    	],
    	[
    		[
    			13238,
    			13238
    		],
    		"mapped",
    		[
    			956,
    			118
    		]
    	],
    	[
    		[
    			13239,
    			13239
    		],
    		"mapped",
    		[
    			109,
    			118
    		]
    	],
    	[
    		[
    			13240,
    			13240
    		],
    		"mapped",
    		[
    			107,
    			118
    		]
    	],
    	[
    		[
    			13241,
    			13241
    		],
    		"mapped",
    		[
    			109,
    			118
    		]
    	],
    	[
    		[
    			13242,
    			13242
    		],
    		"mapped",
    		[
    			112,
    			119
    		]
    	],
    	[
    		[
    			13243,
    			13243
    		],
    		"mapped",
    		[
    			110,
    			119
    		]
    	],
    	[
    		[
    			13244,
    			13244
    		],
    		"mapped",
    		[
    			956,
    			119
    		]
    	],
    	[
    		[
    			13245,
    			13245
    		],
    		"mapped",
    		[
    			109,
    			119
    		]
    	],
    	[
    		[
    			13246,
    			13246
    		],
    		"mapped",
    		[
    			107,
    			119
    		]
    	],
    	[
    		[
    			13247,
    			13247
    		],
    		"mapped",
    		[
    			109,
    			119
    		]
    	],
    	[
    		[
    			13248,
    			13248
    		],
    		"mapped",
    		[
    			107,
    			969
    		]
    	],
    	[
    		[
    			13249,
    			13249
    		],
    		"mapped",
    		[
    			109,
    			969
    		]
    	],
    	[
    		[
    			13250,
    			13250
    		],
    		"disallowed"
    	],
    	[
    		[
    			13251,
    			13251
    		],
    		"mapped",
    		[
    			98,
    			113
    		]
    	],
    	[
    		[
    			13252,
    			13252
    		],
    		"mapped",
    		[
    			99,
    			99
    		]
    	],
    	[
    		[
    			13253,
    			13253
    		],
    		"mapped",
    		[
    			99,
    			100
    		]
    	],
    	[
    		[
    			13254,
    			13254
    		],
    		"mapped",
    		[
    			99,
    			8725,
    			107,
    			103
    		]
    	],
    	[
    		[
    			13255,
    			13255
    		],
    		"disallowed"
    	],
    	[
    		[
    			13256,
    			13256
    		],
    		"mapped",
    		[
    			100,
    			98
    		]
    	],
    	[
    		[
    			13257,
    			13257
    		],
    		"mapped",
    		[
    			103,
    			121
    		]
    	],
    	[
    		[
    			13258,
    			13258
    		],
    		"mapped",
    		[
    			104,
    			97
    		]
    	],
    	[
    		[
    			13259,
    			13259
    		],
    		"mapped",
    		[
    			104,
    			112
    		]
    	],
    	[
    		[
    			13260,
    			13260
    		],
    		"mapped",
    		[
    			105,
    			110
    		]
    	],
    	[
    		[
    			13261,
    			13261
    		],
    		"mapped",
    		[
    			107,
    			107
    		]
    	],
    	[
    		[
    			13262,
    			13262
    		],
    		"mapped",
    		[
    			107,
    			109
    		]
    	],
    	[
    		[
    			13263,
    			13263
    		],
    		"mapped",
    		[
    			107,
    			116
    		]
    	],
    	[
    		[
    			13264,
    			13264
    		],
    		"mapped",
    		[
    			108,
    			109
    		]
    	],
    	[
    		[
    			13265,
    			13265
    		],
    		"mapped",
    		[
    			108,
    			110
    		]
    	],
    	[
    		[
    			13266,
    			13266
    		],
    		"mapped",
    		[
    			108,
    			111,
    			103
    		]
    	],
    	[
    		[
    			13267,
    			13267
    		],
    		"mapped",
    		[
    			108,
    			120
    		]
    	],
    	[
    		[
    			13268,
    			13268
    		],
    		"mapped",
    		[
    			109,
    			98
    		]
    	],
    	[
    		[
    			13269,
    			13269
    		],
    		"mapped",
    		[
    			109,
    			105,
    			108
    		]
    	],
    	[
    		[
    			13270,
    			13270
    		],
    		"mapped",
    		[
    			109,
    			111,
    			108
    		]
    	],
    	[
    		[
    			13271,
    			13271
    		],
    		"mapped",
    		[
    			112,
    			104
    		]
    	],
    	[
    		[
    			13272,
    			13272
    		],
    		"disallowed"
    	],
    	[
    		[
    			13273,
    			13273
    		],
    		"mapped",
    		[
    			112,
    			112,
    			109
    		]
    	],
    	[
    		[
    			13274,
    			13274
    		],
    		"mapped",
    		[
    			112,
    			114
    		]
    	],
    	[
    		[
    			13275,
    			13275
    		],
    		"mapped",
    		[
    			115,
    			114
    		]
    	],
    	[
    		[
    			13276,
    			13276
    		],
    		"mapped",
    		[
    			115,
    			118
    		]
    	],
    	[
    		[
    			13277,
    			13277
    		],
    		"mapped",
    		[
    			119,
    			98
    		]
    	],
    	[
    		[
    			13278,
    			13278
    		],
    		"mapped",
    		[
    			118,
    			8725,
    			109
    		]
    	],
    	[
    		[
    			13279,
    			13279
    		],
    		"mapped",
    		[
    			97,
    			8725,
    			109
    		]
    	],
    	[
    		[
    			13280,
    			13280
    		],
    		"mapped",
    		[
    			49,
    			26085
    		]
    	],
    	[
    		[
    			13281,
    			13281
    		],
    		"mapped",
    		[
    			50,
    			26085
    		]
    	],
    	[
    		[
    			13282,
    			13282
    		],
    		"mapped",
    		[
    			51,
    			26085
    		]
    	],
    	[
    		[
    			13283,
    			13283
    		],
    		"mapped",
    		[
    			52,
    			26085
    		]
    	],
    	[
    		[
    			13284,
    			13284
    		],
    		"mapped",
    		[
    			53,
    			26085
    		]
    	],
    	[
    		[
    			13285,
    			13285
    		],
    		"mapped",
    		[
    			54,
    			26085
    		]
    	],
    	[
    		[
    			13286,
    			13286
    		],
    		"mapped",
    		[
    			55,
    			26085
    		]
    	],
    	[
    		[
    			13287,
    			13287
    		],
    		"mapped",
    		[
    			56,
    			26085
    		]
    	],
    	[
    		[
    			13288,
    			13288
    		],
    		"mapped",
    		[
    			57,
    			26085
    		]
    	],
    	[
    		[
    			13289,
    			13289
    		],
    		"mapped",
    		[
    			49,
    			48,
    			26085
    		]
    	],
    	[
    		[
    			13290,
    			13290
    		],
    		"mapped",
    		[
    			49,
    			49,
    			26085
    		]
    	],
    	[
    		[
    			13291,
    			13291
    		],
    		"mapped",
    		[
    			49,
    			50,
    			26085
    		]
    	],
    	[
    		[
    			13292,
    			13292
    		],
    		"mapped",
    		[
    			49,
    			51,
    			26085
    		]
    	],
    	[
    		[
    			13293,
    			13293
    		],
    		"mapped",
    		[
    			49,
    			52,
    			26085
    		]
    	],
    	[
    		[
    			13294,
    			13294
    		],
    		"mapped",
    		[
    			49,
    			53,
    			26085
    		]
    	],
    	[
    		[
    			13295,
    			13295
    		],
    		"mapped",
    		[
    			49,
    			54,
    			26085
    		]
    	],
    	[
    		[
    			13296,
    			13296
    		],
    		"mapped",
    		[
    			49,
    			55,
    			26085
    		]
    	],
    	[
    		[
    			13297,
    			13297
    		],
    		"mapped",
    		[
    			49,
    			56,
    			26085
    		]
    	],
    	[
    		[
    			13298,
    			13298
    		],
    		"mapped",
    		[
    			49,
    			57,
    			26085
    		]
    	],
    	[
    		[
    			13299,
    			13299
    		],
    		"mapped",
    		[
    			50,
    			48,
    			26085
    		]
    	],
    	[
    		[
    			13300,
    			13300
    		],
    		"mapped",
    		[
    			50,
    			49,
    			26085
    		]
    	],
    	[
    		[
    			13301,
    			13301
    		],
    		"mapped",
    		[
    			50,
    			50,
    			26085
    		]
    	],
    	[
    		[
    			13302,
    			13302
    		],
    		"mapped",
    		[
    			50,
    			51,
    			26085
    		]
    	],
    	[
    		[
    			13303,
    			13303
    		],
    		"mapped",
    		[
    			50,
    			52,
    			26085
    		]
    	],
    	[
    		[
    			13304,
    			13304
    		],
    		"mapped",
    		[
    			50,
    			53,
    			26085
    		]
    	],
    	[
    		[
    			13305,
    			13305
    		],
    		"mapped",
    		[
    			50,
    			54,
    			26085
    		]
    	],
    	[
    		[
    			13306,
    			13306
    		],
    		"mapped",
    		[
    			50,
    			55,
    			26085
    		]
    	],
    	[
    		[
    			13307,
    			13307
    		],
    		"mapped",
    		[
    			50,
    			56,
    			26085
    		]
    	],
    	[
    		[
    			13308,
    			13308
    		],
    		"mapped",
    		[
    			50,
    			57,
    			26085
    		]
    	],
    	[
    		[
    			13309,
    			13309
    		],
    		"mapped",
    		[
    			51,
    			48,
    			26085
    		]
    	],
    	[
    		[
    			13310,
    			13310
    		],
    		"mapped",
    		[
    			51,
    			49,
    			26085
    		]
    	],
    	[
    		[
    			13311,
    			13311
    		],
    		"mapped",
    		[
    			103,
    			97,
    			108
    		]
    	],
    	[
    		[
    			13312,
    			19893
    		],
    		"valid"
    	],
    	[
    		[
    			19894,
    			19903
    		],
    		"disallowed"
    	],
    	[
    		[
    			19904,
    			19967
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			19968,
    			40869
    		],
    		"valid"
    	],
    	[
    		[
    			40870,
    			40891
    		],
    		"valid"
    	],
    	[
    		[
    			40892,
    			40899
    		],
    		"valid"
    	],
    	[
    		[
    			40900,
    			40907
    		],
    		"valid"
    	],
    	[
    		[
    			40908,
    			40908
    		],
    		"valid"
    	],
    	[
    		[
    			40909,
    			40917
    		],
    		"valid"
    	],
    	[
    		[
    			40918,
    			40959
    		],
    		"disallowed"
    	],
    	[
    		[
    			40960,
    			42124
    		],
    		"valid"
    	],
    	[
    		[
    			42125,
    			42127
    		],
    		"disallowed"
    	],
    	[
    		[
    			42128,
    			42145
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42146,
    			42147
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42148,
    			42163
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42164,
    			42164
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42165,
    			42176
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42177,
    			42177
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42178,
    			42180
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42181,
    			42181
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42182,
    			42182
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42183,
    			42191
    		],
    		"disallowed"
    	],
    	[
    		[
    			42192,
    			42237
    		],
    		"valid"
    	],
    	[
    		[
    			42238,
    			42239
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42240,
    			42508
    		],
    		"valid"
    	],
    	[
    		[
    			42509,
    			42511
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42512,
    			42539
    		],
    		"valid"
    	],
    	[
    		[
    			42540,
    			42559
    		],
    		"disallowed"
    	],
    	[
    		[
    			42560,
    			42560
    		],
    		"mapped",
    		[
    			42561
    		]
    	],
    	[
    		[
    			42561,
    			42561
    		],
    		"valid"
    	],
    	[
    		[
    			42562,
    			42562
    		],
    		"mapped",
    		[
    			42563
    		]
    	],
    	[
    		[
    			42563,
    			42563
    		],
    		"valid"
    	],
    	[
    		[
    			42564,
    			42564
    		],
    		"mapped",
    		[
    			42565
    		]
    	],
    	[
    		[
    			42565,
    			42565
    		],
    		"valid"
    	],
    	[
    		[
    			42566,
    			42566
    		],
    		"mapped",
    		[
    			42567
    		]
    	],
    	[
    		[
    			42567,
    			42567
    		],
    		"valid"
    	],
    	[
    		[
    			42568,
    			42568
    		],
    		"mapped",
    		[
    			42569
    		]
    	],
    	[
    		[
    			42569,
    			42569
    		],
    		"valid"
    	],
    	[
    		[
    			42570,
    			42570
    		],
    		"mapped",
    		[
    			42571
    		]
    	],
    	[
    		[
    			42571,
    			42571
    		],
    		"valid"
    	],
    	[
    		[
    			42572,
    			42572
    		],
    		"mapped",
    		[
    			42573
    		]
    	],
    	[
    		[
    			42573,
    			42573
    		],
    		"valid"
    	],
    	[
    		[
    			42574,
    			42574
    		],
    		"mapped",
    		[
    			42575
    		]
    	],
    	[
    		[
    			42575,
    			42575
    		],
    		"valid"
    	],
    	[
    		[
    			42576,
    			42576
    		],
    		"mapped",
    		[
    			42577
    		]
    	],
    	[
    		[
    			42577,
    			42577
    		],
    		"valid"
    	],
    	[
    		[
    			42578,
    			42578
    		],
    		"mapped",
    		[
    			42579
    		]
    	],
    	[
    		[
    			42579,
    			42579
    		],
    		"valid"
    	],
    	[
    		[
    			42580,
    			42580
    		],
    		"mapped",
    		[
    			42581
    		]
    	],
    	[
    		[
    			42581,
    			42581
    		],
    		"valid"
    	],
    	[
    		[
    			42582,
    			42582
    		],
    		"mapped",
    		[
    			42583
    		]
    	],
    	[
    		[
    			42583,
    			42583
    		],
    		"valid"
    	],
    	[
    		[
    			42584,
    			42584
    		],
    		"mapped",
    		[
    			42585
    		]
    	],
    	[
    		[
    			42585,
    			42585
    		],
    		"valid"
    	],
    	[
    		[
    			42586,
    			42586
    		],
    		"mapped",
    		[
    			42587
    		]
    	],
    	[
    		[
    			42587,
    			42587
    		],
    		"valid"
    	],
    	[
    		[
    			42588,
    			42588
    		],
    		"mapped",
    		[
    			42589
    		]
    	],
    	[
    		[
    			42589,
    			42589
    		],
    		"valid"
    	],
    	[
    		[
    			42590,
    			42590
    		],
    		"mapped",
    		[
    			42591
    		]
    	],
    	[
    		[
    			42591,
    			42591
    		],
    		"valid"
    	],
    	[
    		[
    			42592,
    			42592
    		],
    		"mapped",
    		[
    			42593
    		]
    	],
    	[
    		[
    			42593,
    			42593
    		],
    		"valid"
    	],
    	[
    		[
    			42594,
    			42594
    		],
    		"mapped",
    		[
    			42595
    		]
    	],
    	[
    		[
    			42595,
    			42595
    		],
    		"valid"
    	],
    	[
    		[
    			42596,
    			42596
    		],
    		"mapped",
    		[
    			42597
    		]
    	],
    	[
    		[
    			42597,
    			42597
    		],
    		"valid"
    	],
    	[
    		[
    			42598,
    			42598
    		],
    		"mapped",
    		[
    			42599
    		]
    	],
    	[
    		[
    			42599,
    			42599
    		],
    		"valid"
    	],
    	[
    		[
    			42600,
    			42600
    		],
    		"mapped",
    		[
    			42601
    		]
    	],
    	[
    		[
    			42601,
    			42601
    		],
    		"valid"
    	],
    	[
    		[
    			42602,
    			42602
    		],
    		"mapped",
    		[
    			42603
    		]
    	],
    	[
    		[
    			42603,
    			42603
    		],
    		"valid"
    	],
    	[
    		[
    			42604,
    			42604
    		],
    		"mapped",
    		[
    			42605
    		]
    	],
    	[
    		[
    			42605,
    			42607
    		],
    		"valid"
    	],
    	[
    		[
    			42608,
    			42611
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42612,
    			42619
    		],
    		"valid"
    	],
    	[
    		[
    			42620,
    			42621
    		],
    		"valid"
    	],
    	[
    		[
    			42622,
    			42622
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42623,
    			42623
    		],
    		"valid"
    	],
    	[
    		[
    			42624,
    			42624
    		],
    		"mapped",
    		[
    			42625
    		]
    	],
    	[
    		[
    			42625,
    			42625
    		],
    		"valid"
    	],
    	[
    		[
    			42626,
    			42626
    		],
    		"mapped",
    		[
    			42627
    		]
    	],
    	[
    		[
    			42627,
    			42627
    		],
    		"valid"
    	],
    	[
    		[
    			42628,
    			42628
    		],
    		"mapped",
    		[
    			42629
    		]
    	],
    	[
    		[
    			42629,
    			42629
    		],
    		"valid"
    	],
    	[
    		[
    			42630,
    			42630
    		],
    		"mapped",
    		[
    			42631
    		]
    	],
    	[
    		[
    			42631,
    			42631
    		],
    		"valid"
    	],
    	[
    		[
    			42632,
    			42632
    		],
    		"mapped",
    		[
    			42633
    		]
    	],
    	[
    		[
    			42633,
    			42633
    		],
    		"valid"
    	],
    	[
    		[
    			42634,
    			42634
    		],
    		"mapped",
    		[
    			42635
    		]
    	],
    	[
    		[
    			42635,
    			42635
    		],
    		"valid"
    	],
    	[
    		[
    			42636,
    			42636
    		],
    		"mapped",
    		[
    			42637
    		]
    	],
    	[
    		[
    			42637,
    			42637
    		],
    		"valid"
    	],
    	[
    		[
    			42638,
    			42638
    		],
    		"mapped",
    		[
    			42639
    		]
    	],
    	[
    		[
    			42639,
    			42639
    		],
    		"valid"
    	],
    	[
    		[
    			42640,
    			42640
    		],
    		"mapped",
    		[
    			42641
    		]
    	],
    	[
    		[
    			42641,
    			42641
    		],
    		"valid"
    	],
    	[
    		[
    			42642,
    			42642
    		],
    		"mapped",
    		[
    			42643
    		]
    	],
    	[
    		[
    			42643,
    			42643
    		],
    		"valid"
    	],
    	[
    		[
    			42644,
    			42644
    		],
    		"mapped",
    		[
    			42645
    		]
    	],
    	[
    		[
    			42645,
    			42645
    		],
    		"valid"
    	],
    	[
    		[
    			42646,
    			42646
    		],
    		"mapped",
    		[
    			42647
    		]
    	],
    	[
    		[
    			42647,
    			42647
    		],
    		"valid"
    	],
    	[
    		[
    			42648,
    			42648
    		],
    		"mapped",
    		[
    			42649
    		]
    	],
    	[
    		[
    			42649,
    			42649
    		],
    		"valid"
    	],
    	[
    		[
    			42650,
    			42650
    		],
    		"mapped",
    		[
    			42651
    		]
    	],
    	[
    		[
    			42651,
    			42651
    		],
    		"valid"
    	],
    	[
    		[
    			42652,
    			42652
    		],
    		"mapped",
    		[
    			1098
    		]
    	],
    	[
    		[
    			42653,
    			42653
    		],
    		"mapped",
    		[
    			1100
    		]
    	],
    	[
    		[
    			42654,
    			42654
    		],
    		"valid"
    	],
    	[
    		[
    			42655,
    			42655
    		],
    		"valid"
    	],
    	[
    		[
    			42656,
    			42725
    		],
    		"valid"
    	],
    	[
    		[
    			42726,
    			42735
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42736,
    			42737
    		],
    		"valid"
    	],
    	[
    		[
    			42738,
    			42743
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42744,
    			42751
    		],
    		"disallowed"
    	],
    	[
    		[
    			42752,
    			42774
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42775,
    			42778
    		],
    		"valid"
    	],
    	[
    		[
    			42779,
    			42783
    		],
    		"valid"
    	],
    	[
    		[
    			42784,
    			42785
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42786,
    			42786
    		],
    		"mapped",
    		[
    			42787
    		]
    	],
    	[
    		[
    			42787,
    			42787
    		],
    		"valid"
    	],
    	[
    		[
    			42788,
    			42788
    		],
    		"mapped",
    		[
    			42789
    		]
    	],
    	[
    		[
    			42789,
    			42789
    		],
    		"valid"
    	],
    	[
    		[
    			42790,
    			42790
    		],
    		"mapped",
    		[
    			42791
    		]
    	],
    	[
    		[
    			42791,
    			42791
    		],
    		"valid"
    	],
    	[
    		[
    			42792,
    			42792
    		],
    		"mapped",
    		[
    			42793
    		]
    	],
    	[
    		[
    			42793,
    			42793
    		],
    		"valid"
    	],
    	[
    		[
    			42794,
    			42794
    		],
    		"mapped",
    		[
    			42795
    		]
    	],
    	[
    		[
    			42795,
    			42795
    		],
    		"valid"
    	],
    	[
    		[
    			42796,
    			42796
    		],
    		"mapped",
    		[
    			42797
    		]
    	],
    	[
    		[
    			42797,
    			42797
    		],
    		"valid"
    	],
    	[
    		[
    			42798,
    			42798
    		],
    		"mapped",
    		[
    			42799
    		]
    	],
    	[
    		[
    			42799,
    			42801
    		],
    		"valid"
    	],
    	[
    		[
    			42802,
    			42802
    		],
    		"mapped",
    		[
    			42803
    		]
    	],
    	[
    		[
    			42803,
    			42803
    		],
    		"valid"
    	],
    	[
    		[
    			42804,
    			42804
    		],
    		"mapped",
    		[
    			42805
    		]
    	],
    	[
    		[
    			42805,
    			42805
    		],
    		"valid"
    	],
    	[
    		[
    			42806,
    			42806
    		],
    		"mapped",
    		[
    			42807
    		]
    	],
    	[
    		[
    			42807,
    			42807
    		],
    		"valid"
    	],
    	[
    		[
    			42808,
    			42808
    		],
    		"mapped",
    		[
    			42809
    		]
    	],
    	[
    		[
    			42809,
    			42809
    		],
    		"valid"
    	],
    	[
    		[
    			42810,
    			42810
    		],
    		"mapped",
    		[
    			42811
    		]
    	],
    	[
    		[
    			42811,
    			42811
    		],
    		"valid"
    	],
    	[
    		[
    			42812,
    			42812
    		],
    		"mapped",
    		[
    			42813
    		]
    	],
    	[
    		[
    			42813,
    			42813
    		],
    		"valid"
    	],
    	[
    		[
    			42814,
    			42814
    		],
    		"mapped",
    		[
    			42815
    		]
    	],
    	[
    		[
    			42815,
    			42815
    		],
    		"valid"
    	],
    	[
    		[
    			42816,
    			42816
    		],
    		"mapped",
    		[
    			42817
    		]
    	],
    	[
    		[
    			42817,
    			42817
    		],
    		"valid"
    	],
    	[
    		[
    			42818,
    			42818
    		],
    		"mapped",
    		[
    			42819
    		]
    	],
    	[
    		[
    			42819,
    			42819
    		],
    		"valid"
    	],
    	[
    		[
    			42820,
    			42820
    		],
    		"mapped",
    		[
    			42821
    		]
    	],
    	[
    		[
    			42821,
    			42821
    		],
    		"valid"
    	],
    	[
    		[
    			42822,
    			42822
    		],
    		"mapped",
    		[
    			42823
    		]
    	],
    	[
    		[
    			42823,
    			42823
    		],
    		"valid"
    	],
    	[
    		[
    			42824,
    			42824
    		],
    		"mapped",
    		[
    			42825
    		]
    	],
    	[
    		[
    			42825,
    			42825
    		],
    		"valid"
    	],
    	[
    		[
    			42826,
    			42826
    		],
    		"mapped",
    		[
    			42827
    		]
    	],
    	[
    		[
    			42827,
    			42827
    		],
    		"valid"
    	],
    	[
    		[
    			42828,
    			42828
    		],
    		"mapped",
    		[
    			42829
    		]
    	],
    	[
    		[
    			42829,
    			42829
    		],
    		"valid"
    	],
    	[
    		[
    			42830,
    			42830
    		],
    		"mapped",
    		[
    			42831
    		]
    	],
    	[
    		[
    			42831,
    			42831
    		],
    		"valid"
    	],
    	[
    		[
    			42832,
    			42832
    		],
    		"mapped",
    		[
    			42833
    		]
    	],
    	[
    		[
    			42833,
    			42833
    		],
    		"valid"
    	],
    	[
    		[
    			42834,
    			42834
    		],
    		"mapped",
    		[
    			42835
    		]
    	],
    	[
    		[
    			42835,
    			42835
    		],
    		"valid"
    	],
    	[
    		[
    			42836,
    			42836
    		],
    		"mapped",
    		[
    			42837
    		]
    	],
    	[
    		[
    			42837,
    			42837
    		],
    		"valid"
    	],
    	[
    		[
    			42838,
    			42838
    		],
    		"mapped",
    		[
    			42839
    		]
    	],
    	[
    		[
    			42839,
    			42839
    		],
    		"valid"
    	],
    	[
    		[
    			42840,
    			42840
    		],
    		"mapped",
    		[
    			42841
    		]
    	],
    	[
    		[
    			42841,
    			42841
    		],
    		"valid"
    	],
    	[
    		[
    			42842,
    			42842
    		],
    		"mapped",
    		[
    			42843
    		]
    	],
    	[
    		[
    			42843,
    			42843
    		],
    		"valid"
    	],
    	[
    		[
    			42844,
    			42844
    		],
    		"mapped",
    		[
    			42845
    		]
    	],
    	[
    		[
    			42845,
    			42845
    		],
    		"valid"
    	],
    	[
    		[
    			42846,
    			42846
    		],
    		"mapped",
    		[
    			42847
    		]
    	],
    	[
    		[
    			42847,
    			42847
    		],
    		"valid"
    	],
    	[
    		[
    			42848,
    			42848
    		],
    		"mapped",
    		[
    			42849
    		]
    	],
    	[
    		[
    			42849,
    			42849
    		],
    		"valid"
    	],
    	[
    		[
    			42850,
    			42850
    		],
    		"mapped",
    		[
    			42851
    		]
    	],
    	[
    		[
    			42851,
    			42851
    		],
    		"valid"
    	],
    	[
    		[
    			42852,
    			42852
    		],
    		"mapped",
    		[
    			42853
    		]
    	],
    	[
    		[
    			42853,
    			42853
    		],
    		"valid"
    	],
    	[
    		[
    			42854,
    			42854
    		],
    		"mapped",
    		[
    			42855
    		]
    	],
    	[
    		[
    			42855,
    			42855
    		],
    		"valid"
    	],
    	[
    		[
    			42856,
    			42856
    		],
    		"mapped",
    		[
    			42857
    		]
    	],
    	[
    		[
    			42857,
    			42857
    		],
    		"valid"
    	],
    	[
    		[
    			42858,
    			42858
    		],
    		"mapped",
    		[
    			42859
    		]
    	],
    	[
    		[
    			42859,
    			42859
    		],
    		"valid"
    	],
    	[
    		[
    			42860,
    			42860
    		],
    		"mapped",
    		[
    			42861
    		]
    	],
    	[
    		[
    			42861,
    			42861
    		],
    		"valid"
    	],
    	[
    		[
    			42862,
    			42862
    		],
    		"mapped",
    		[
    			42863
    		]
    	],
    	[
    		[
    			42863,
    			42863
    		],
    		"valid"
    	],
    	[
    		[
    			42864,
    			42864
    		],
    		"mapped",
    		[
    			42863
    		]
    	],
    	[
    		[
    			42865,
    			42872
    		],
    		"valid"
    	],
    	[
    		[
    			42873,
    			42873
    		],
    		"mapped",
    		[
    			42874
    		]
    	],
    	[
    		[
    			42874,
    			42874
    		],
    		"valid"
    	],
    	[
    		[
    			42875,
    			42875
    		],
    		"mapped",
    		[
    			42876
    		]
    	],
    	[
    		[
    			42876,
    			42876
    		],
    		"valid"
    	],
    	[
    		[
    			42877,
    			42877
    		],
    		"mapped",
    		[
    			7545
    		]
    	],
    	[
    		[
    			42878,
    			42878
    		],
    		"mapped",
    		[
    			42879
    		]
    	],
    	[
    		[
    			42879,
    			42879
    		],
    		"valid"
    	],
    	[
    		[
    			42880,
    			42880
    		],
    		"mapped",
    		[
    			42881
    		]
    	],
    	[
    		[
    			42881,
    			42881
    		],
    		"valid"
    	],
    	[
    		[
    			42882,
    			42882
    		],
    		"mapped",
    		[
    			42883
    		]
    	],
    	[
    		[
    			42883,
    			42883
    		],
    		"valid"
    	],
    	[
    		[
    			42884,
    			42884
    		],
    		"mapped",
    		[
    			42885
    		]
    	],
    	[
    		[
    			42885,
    			42885
    		],
    		"valid"
    	],
    	[
    		[
    			42886,
    			42886
    		],
    		"mapped",
    		[
    			42887
    		]
    	],
    	[
    		[
    			42887,
    			42888
    		],
    		"valid"
    	],
    	[
    		[
    			42889,
    			42890
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			42891,
    			42891
    		],
    		"mapped",
    		[
    			42892
    		]
    	],
    	[
    		[
    			42892,
    			42892
    		],
    		"valid"
    	],
    	[
    		[
    			42893,
    			42893
    		],
    		"mapped",
    		[
    			613
    		]
    	],
    	[
    		[
    			42894,
    			42894
    		],
    		"valid"
    	],
    	[
    		[
    			42895,
    			42895
    		],
    		"valid"
    	],
    	[
    		[
    			42896,
    			42896
    		],
    		"mapped",
    		[
    			42897
    		]
    	],
    	[
    		[
    			42897,
    			42897
    		],
    		"valid"
    	],
    	[
    		[
    			42898,
    			42898
    		],
    		"mapped",
    		[
    			42899
    		]
    	],
    	[
    		[
    			42899,
    			42899
    		],
    		"valid"
    	],
    	[
    		[
    			42900,
    			42901
    		],
    		"valid"
    	],
    	[
    		[
    			42902,
    			42902
    		],
    		"mapped",
    		[
    			42903
    		]
    	],
    	[
    		[
    			42903,
    			42903
    		],
    		"valid"
    	],
    	[
    		[
    			42904,
    			42904
    		],
    		"mapped",
    		[
    			42905
    		]
    	],
    	[
    		[
    			42905,
    			42905
    		],
    		"valid"
    	],
    	[
    		[
    			42906,
    			42906
    		],
    		"mapped",
    		[
    			42907
    		]
    	],
    	[
    		[
    			42907,
    			42907
    		],
    		"valid"
    	],
    	[
    		[
    			42908,
    			42908
    		],
    		"mapped",
    		[
    			42909
    		]
    	],
    	[
    		[
    			42909,
    			42909
    		],
    		"valid"
    	],
    	[
    		[
    			42910,
    			42910
    		],
    		"mapped",
    		[
    			42911
    		]
    	],
    	[
    		[
    			42911,
    			42911
    		],
    		"valid"
    	],
    	[
    		[
    			42912,
    			42912
    		],
    		"mapped",
    		[
    			42913
    		]
    	],
    	[
    		[
    			42913,
    			42913
    		],
    		"valid"
    	],
    	[
    		[
    			42914,
    			42914
    		],
    		"mapped",
    		[
    			42915
    		]
    	],
    	[
    		[
    			42915,
    			42915
    		],
    		"valid"
    	],
    	[
    		[
    			42916,
    			42916
    		],
    		"mapped",
    		[
    			42917
    		]
    	],
    	[
    		[
    			42917,
    			42917
    		],
    		"valid"
    	],
    	[
    		[
    			42918,
    			42918
    		],
    		"mapped",
    		[
    			42919
    		]
    	],
    	[
    		[
    			42919,
    			42919
    		],
    		"valid"
    	],
    	[
    		[
    			42920,
    			42920
    		],
    		"mapped",
    		[
    			42921
    		]
    	],
    	[
    		[
    			42921,
    			42921
    		],
    		"valid"
    	],
    	[
    		[
    			42922,
    			42922
    		],
    		"mapped",
    		[
    			614
    		]
    	],
    	[
    		[
    			42923,
    			42923
    		],
    		"mapped",
    		[
    			604
    		]
    	],
    	[
    		[
    			42924,
    			42924
    		],
    		"mapped",
    		[
    			609
    		]
    	],
    	[
    		[
    			42925,
    			42925
    		],
    		"mapped",
    		[
    			620
    		]
    	],
    	[
    		[
    			42926,
    			42927
    		],
    		"disallowed"
    	],
    	[
    		[
    			42928,
    			42928
    		],
    		"mapped",
    		[
    			670
    		]
    	],
    	[
    		[
    			42929,
    			42929
    		],
    		"mapped",
    		[
    			647
    		]
    	],
    	[
    		[
    			42930,
    			42930
    		],
    		"mapped",
    		[
    			669
    		]
    	],
    	[
    		[
    			42931,
    			42931
    		],
    		"mapped",
    		[
    			43859
    		]
    	],
    	[
    		[
    			42932,
    			42932
    		],
    		"mapped",
    		[
    			42933
    		]
    	],
    	[
    		[
    			42933,
    			42933
    		],
    		"valid"
    	],
    	[
    		[
    			42934,
    			42934
    		],
    		"mapped",
    		[
    			42935
    		]
    	],
    	[
    		[
    			42935,
    			42935
    		],
    		"valid"
    	],
    	[
    		[
    			42936,
    			42998
    		],
    		"disallowed"
    	],
    	[
    		[
    			42999,
    			42999
    		],
    		"valid"
    	],
    	[
    		[
    			43000,
    			43000
    		],
    		"mapped",
    		[
    			295
    		]
    	],
    	[
    		[
    			43001,
    			43001
    		],
    		"mapped",
    		[
    			339
    		]
    	],
    	[
    		[
    			43002,
    			43002
    		],
    		"valid"
    	],
    	[
    		[
    			43003,
    			43007
    		],
    		"valid"
    	],
    	[
    		[
    			43008,
    			43047
    		],
    		"valid"
    	],
    	[
    		[
    			43048,
    			43051
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			43052,
    			43055
    		],
    		"disallowed"
    	],
    	[
    		[
    			43056,
    			43065
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			43066,
    			43071
    		],
    		"disallowed"
    	],
    	[
    		[
    			43072,
    			43123
    		],
    		"valid"
    	],
    	[
    		[
    			43124,
    			43127
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			43128,
    			43135
    		],
    		"disallowed"
    	],
    	[
    		[
    			43136,
    			43204
    		],
    		"valid"
    	],
    	[
    		[
    			43205,
    			43213
    		],
    		"disallowed"
    	],
    	[
    		[
    			43214,
    			43215
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			43216,
    			43225
    		],
    		"valid"
    	],
    	[
    		[
    			43226,
    			43231
    		],
    		"disallowed"
    	],
    	[
    		[
    			43232,
    			43255
    		],
    		"valid"
    	],
    	[
    		[
    			43256,
    			43258
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			43259,
    			43259
    		],
    		"valid"
    	],
    	[
    		[
    			43260,
    			43260
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			43261,
    			43261
    		],
    		"valid"
    	],
    	[
    		[
    			43262,
    			43263
    		],
    		"disallowed"
    	],
    	[
    		[
    			43264,
    			43309
    		],
    		"valid"
    	],
    	[
    		[
    			43310,
    			43311
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			43312,
    			43347
    		],
    		"valid"
    	],
    	[
    		[
    			43348,
    			43358
    		],
    		"disallowed"
    	],
    	[
    		[
    			43359,
    			43359
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			43360,
    			43388
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			43389,
    			43391
    		],
    		"disallowed"
    	],
    	[
    		[
    			43392,
    			43456
    		],
    		"valid"
    	],
    	[
    		[
    			43457,
    			43469
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			43470,
    			43470
    		],
    		"disallowed"
    	],
    	[
    		[
    			43471,
    			43481
    		],
    		"valid"
    	],
    	[
    		[
    			43482,
    			43485
    		],
    		"disallowed"
    	],
    	[
    		[
    			43486,
    			43487
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			43488,
    			43518
    		],
    		"valid"
    	],
    	[
    		[
    			43519,
    			43519
    		],
    		"disallowed"
    	],
    	[
    		[
    			43520,
    			43574
    		],
    		"valid"
    	],
    	[
    		[
    			43575,
    			43583
    		],
    		"disallowed"
    	],
    	[
    		[
    			43584,
    			43597
    		],
    		"valid"
    	],
    	[
    		[
    			43598,
    			43599
    		],
    		"disallowed"
    	],
    	[
    		[
    			43600,
    			43609
    		],
    		"valid"
    	],
    	[
    		[
    			43610,
    			43611
    		],
    		"disallowed"
    	],
    	[
    		[
    			43612,
    			43615
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			43616,
    			43638
    		],
    		"valid"
    	],
    	[
    		[
    			43639,
    			43641
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			43642,
    			43643
    		],
    		"valid"
    	],
    	[
    		[
    			43644,
    			43647
    		],
    		"valid"
    	],
    	[
    		[
    			43648,
    			43714
    		],
    		"valid"
    	],
    	[
    		[
    			43715,
    			43738
    		],
    		"disallowed"
    	],
    	[
    		[
    			43739,
    			43741
    		],
    		"valid"
    	],
    	[
    		[
    			43742,
    			43743
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			43744,
    			43759
    		],
    		"valid"
    	],
    	[
    		[
    			43760,
    			43761
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			43762,
    			43766
    		],
    		"valid"
    	],
    	[
    		[
    			43767,
    			43776
    		],
    		"disallowed"
    	],
    	[
    		[
    			43777,
    			43782
    		],
    		"valid"
    	],
    	[
    		[
    			43783,
    			43784
    		],
    		"disallowed"
    	],
    	[
    		[
    			43785,
    			43790
    		],
    		"valid"
    	],
    	[
    		[
    			43791,
    			43792
    		],
    		"disallowed"
    	],
    	[
    		[
    			43793,
    			43798
    		],
    		"valid"
    	],
    	[
    		[
    			43799,
    			43807
    		],
    		"disallowed"
    	],
    	[
    		[
    			43808,
    			43814
    		],
    		"valid"
    	],
    	[
    		[
    			43815,
    			43815
    		],
    		"disallowed"
    	],
    	[
    		[
    			43816,
    			43822
    		],
    		"valid"
    	],
    	[
    		[
    			43823,
    			43823
    		],
    		"disallowed"
    	],
    	[
    		[
    			43824,
    			43866
    		],
    		"valid"
    	],
    	[
    		[
    			43867,
    			43867
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			43868,
    			43868
    		],
    		"mapped",
    		[
    			42791
    		]
    	],
    	[
    		[
    			43869,
    			43869
    		],
    		"mapped",
    		[
    			43831
    		]
    	],
    	[
    		[
    			43870,
    			43870
    		],
    		"mapped",
    		[
    			619
    		]
    	],
    	[
    		[
    			43871,
    			43871
    		],
    		"mapped",
    		[
    			43858
    		]
    	],
    	[
    		[
    			43872,
    			43875
    		],
    		"valid"
    	],
    	[
    		[
    			43876,
    			43877
    		],
    		"valid"
    	],
    	[
    		[
    			43878,
    			43887
    		],
    		"disallowed"
    	],
    	[
    		[
    			43888,
    			43888
    		],
    		"mapped",
    		[
    			5024
    		]
    	],
    	[
    		[
    			43889,
    			43889
    		],
    		"mapped",
    		[
    			5025
    		]
    	],
    	[
    		[
    			43890,
    			43890
    		],
    		"mapped",
    		[
    			5026
    		]
    	],
    	[
    		[
    			43891,
    			43891
    		],
    		"mapped",
    		[
    			5027
    		]
    	],
    	[
    		[
    			43892,
    			43892
    		],
    		"mapped",
    		[
    			5028
    		]
    	],
    	[
    		[
    			43893,
    			43893
    		],
    		"mapped",
    		[
    			5029
    		]
    	],
    	[
    		[
    			43894,
    			43894
    		],
    		"mapped",
    		[
    			5030
    		]
    	],
    	[
    		[
    			43895,
    			43895
    		],
    		"mapped",
    		[
    			5031
    		]
    	],
    	[
    		[
    			43896,
    			43896
    		],
    		"mapped",
    		[
    			5032
    		]
    	],
    	[
    		[
    			43897,
    			43897
    		],
    		"mapped",
    		[
    			5033
    		]
    	],
    	[
    		[
    			43898,
    			43898
    		],
    		"mapped",
    		[
    			5034
    		]
    	],
    	[
    		[
    			43899,
    			43899
    		],
    		"mapped",
    		[
    			5035
    		]
    	],
    	[
    		[
    			43900,
    			43900
    		],
    		"mapped",
    		[
    			5036
    		]
    	],
    	[
    		[
    			43901,
    			43901
    		],
    		"mapped",
    		[
    			5037
    		]
    	],
    	[
    		[
    			43902,
    			43902
    		],
    		"mapped",
    		[
    			5038
    		]
    	],
    	[
    		[
    			43903,
    			43903
    		],
    		"mapped",
    		[
    			5039
    		]
    	],
    	[
    		[
    			43904,
    			43904
    		],
    		"mapped",
    		[
    			5040
    		]
    	],
    	[
    		[
    			43905,
    			43905
    		],
    		"mapped",
    		[
    			5041
    		]
    	],
    	[
    		[
    			43906,
    			43906
    		],
    		"mapped",
    		[
    			5042
    		]
    	],
    	[
    		[
    			43907,
    			43907
    		],
    		"mapped",
    		[
    			5043
    		]
    	],
    	[
    		[
    			43908,
    			43908
    		],
    		"mapped",
    		[
    			5044
    		]
    	],
    	[
    		[
    			43909,
    			43909
    		],
    		"mapped",
    		[
    			5045
    		]
    	],
    	[
    		[
    			43910,
    			43910
    		],
    		"mapped",
    		[
    			5046
    		]
    	],
    	[
    		[
    			43911,
    			43911
    		],
    		"mapped",
    		[
    			5047
    		]
    	],
    	[
    		[
    			43912,
    			43912
    		],
    		"mapped",
    		[
    			5048
    		]
    	],
    	[
    		[
    			43913,
    			43913
    		],
    		"mapped",
    		[
    			5049
    		]
    	],
    	[
    		[
    			43914,
    			43914
    		],
    		"mapped",
    		[
    			5050
    		]
    	],
    	[
    		[
    			43915,
    			43915
    		],
    		"mapped",
    		[
    			5051
    		]
    	],
    	[
    		[
    			43916,
    			43916
    		],
    		"mapped",
    		[
    			5052
    		]
    	],
    	[
    		[
    			43917,
    			43917
    		],
    		"mapped",
    		[
    			5053
    		]
    	],
    	[
    		[
    			43918,
    			43918
    		],
    		"mapped",
    		[
    			5054
    		]
    	],
    	[
    		[
    			43919,
    			43919
    		],
    		"mapped",
    		[
    			5055
    		]
    	],
    	[
    		[
    			43920,
    			43920
    		],
    		"mapped",
    		[
    			5056
    		]
    	],
    	[
    		[
    			43921,
    			43921
    		],
    		"mapped",
    		[
    			5057
    		]
    	],
    	[
    		[
    			43922,
    			43922
    		],
    		"mapped",
    		[
    			5058
    		]
    	],
    	[
    		[
    			43923,
    			43923
    		],
    		"mapped",
    		[
    			5059
    		]
    	],
    	[
    		[
    			43924,
    			43924
    		],
    		"mapped",
    		[
    			5060
    		]
    	],
    	[
    		[
    			43925,
    			43925
    		],
    		"mapped",
    		[
    			5061
    		]
    	],
    	[
    		[
    			43926,
    			43926
    		],
    		"mapped",
    		[
    			5062
    		]
    	],
    	[
    		[
    			43927,
    			43927
    		],
    		"mapped",
    		[
    			5063
    		]
    	],
    	[
    		[
    			43928,
    			43928
    		],
    		"mapped",
    		[
    			5064
    		]
    	],
    	[
    		[
    			43929,
    			43929
    		],
    		"mapped",
    		[
    			5065
    		]
    	],
    	[
    		[
    			43930,
    			43930
    		],
    		"mapped",
    		[
    			5066
    		]
    	],
    	[
    		[
    			43931,
    			43931
    		],
    		"mapped",
    		[
    			5067
    		]
    	],
    	[
    		[
    			43932,
    			43932
    		],
    		"mapped",
    		[
    			5068
    		]
    	],
    	[
    		[
    			43933,
    			43933
    		],
    		"mapped",
    		[
    			5069
    		]
    	],
    	[
    		[
    			43934,
    			43934
    		],
    		"mapped",
    		[
    			5070
    		]
    	],
    	[
    		[
    			43935,
    			43935
    		],
    		"mapped",
    		[
    			5071
    		]
    	],
    	[
    		[
    			43936,
    			43936
    		],
    		"mapped",
    		[
    			5072
    		]
    	],
    	[
    		[
    			43937,
    			43937
    		],
    		"mapped",
    		[
    			5073
    		]
    	],
    	[
    		[
    			43938,
    			43938
    		],
    		"mapped",
    		[
    			5074
    		]
    	],
    	[
    		[
    			43939,
    			43939
    		],
    		"mapped",
    		[
    			5075
    		]
    	],
    	[
    		[
    			43940,
    			43940
    		],
    		"mapped",
    		[
    			5076
    		]
    	],
    	[
    		[
    			43941,
    			43941
    		],
    		"mapped",
    		[
    			5077
    		]
    	],
    	[
    		[
    			43942,
    			43942
    		],
    		"mapped",
    		[
    			5078
    		]
    	],
    	[
    		[
    			43943,
    			43943
    		],
    		"mapped",
    		[
    			5079
    		]
    	],
    	[
    		[
    			43944,
    			43944
    		],
    		"mapped",
    		[
    			5080
    		]
    	],
    	[
    		[
    			43945,
    			43945
    		],
    		"mapped",
    		[
    			5081
    		]
    	],
    	[
    		[
    			43946,
    			43946
    		],
    		"mapped",
    		[
    			5082
    		]
    	],
    	[
    		[
    			43947,
    			43947
    		],
    		"mapped",
    		[
    			5083
    		]
    	],
    	[
    		[
    			43948,
    			43948
    		],
    		"mapped",
    		[
    			5084
    		]
    	],
    	[
    		[
    			43949,
    			43949
    		],
    		"mapped",
    		[
    			5085
    		]
    	],
    	[
    		[
    			43950,
    			43950
    		],
    		"mapped",
    		[
    			5086
    		]
    	],
    	[
    		[
    			43951,
    			43951
    		],
    		"mapped",
    		[
    			5087
    		]
    	],
    	[
    		[
    			43952,
    			43952
    		],
    		"mapped",
    		[
    			5088
    		]
    	],
    	[
    		[
    			43953,
    			43953
    		],
    		"mapped",
    		[
    			5089
    		]
    	],
    	[
    		[
    			43954,
    			43954
    		],
    		"mapped",
    		[
    			5090
    		]
    	],
    	[
    		[
    			43955,
    			43955
    		],
    		"mapped",
    		[
    			5091
    		]
    	],
    	[
    		[
    			43956,
    			43956
    		],
    		"mapped",
    		[
    			5092
    		]
    	],
    	[
    		[
    			43957,
    			43957
    		],
    		"mapped",
    		[
    			5093
    		]
    	],
    	[
    		[
    			43958,
    			43958
    		],
    		"mapped",
    		[
    			5094
    		]
    	],
    	[
    		[
    			43959,
    			43959
    		],
    		"mapped",
    		[
    			5095
    		]
    	],
    	[
    		[
    			43960,
    			43960
    		],
    		"mapped",
    		[
    			5096
    		]
    	],
    	[
    		[
    			43961,
    			43961
    		],
    		"mapped",
    		[
    			5097
    		]
    	],
    	[
    		[
    			43962,
    			43962
    		],
    		"mapped",
    		[
    			5098
    		]
    	],
    	[
    		[
    			43963,
    			43963
    		],
    		"mapped",
    		[
    			5099
    		]
    	],
    	[
    		[
    			43964,
    			43964
    		],
    		"mapped",
    		[
    			5100
    		]
    	],
    	[
    		[
    			43965,
    			43965
    		],
    		"mapped",
    		[
    			5101
    		]
    	],
    	[
    		[
    			43966,
    			43966
    		],
    		"mapped",
    		[
    			5102
    		]
    	],
    	[
    		[
    			43967,
    			43967
    		],
    		"mapped",
    		[
    			5103
    		]
    	],
    	[
    		[
    			43968,
    			44010
    		],
    		"valid"
    	],
    	[
    		[
    			44011,
    			44011
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			44012,
    			44013
    		],
    		"valid"
    	],
    	[
    		[
    			44014,
    			44015
    		],
    		"disallowed"
    	],
    	[
    		[
    			44016,
    			44025
    		],
    		"valid"
    	],
    	[
    		[
    			44026,
    			44031
    		],
    		"disallowed"
    	],
    	[
    		[
    			44032,
    			55203
    		],
    		"valid"
    	],
    	[
    		[
    			55204,
    			55215
    		],
    		"disallowed"
    	],
    	[
    		[
    			55216,
    			55238
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			55239,
    			55242
    		],
    		"disallowed"
    	],
    	[
    		[
    			55243,
    			55291
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			55292,
    			55295
    		],
    		"disallowed"
    	],
    	[
    		[
    			55296,
    			57343
    		],
    		"disallowed"
    	],
    	[
    		[
    			57344,
    			63743
    		],
    		"disallowed"
    	],
    	[
    		[
    			63744,
    			63744
    		],
    		"mapped",
    		[
    			35912
    		]
    	],
    	[
    		[
    			63745,
    			63745
    		],
    		"mapped",
    		[
    			26356
    		]
    	],
    	[
    		[
    			63746,
    			63746
    		],
    		"mapped",
    		[
    			36554
    		]
    	],
    	[
    		[
    			63747,
    			63747
    		],
    		"mapped",
    		[
    			36040
    		]
    	],
    	[
    		[
    			63748,
    			63748
    		],
    		"mapped",
    		[
    			28369
    		]
    	],
    	[
    		[
    			63749,
    			63749
    		],
    		"mapped",
    		[
    			20018
    		]
    	],
    	[
    		[
    			63750,
    			63750
    		],
    		"mapped",
    		[
    			21477
    		]
    	],
    	[
    		[
    			63751,
    			63752
    		],
    		"mapped",
    		[
    			40860
    		]
    	],
    	[
    		[
    			63753,
    			63753
    		],
    		"mapped",
    		[
    			22865
    		]
    	],
    	[
    		[
    			63754,
    			63754
    		],
    		"mapped",
    		[
    			37329
    		]
    	],
    	[
    		[
    			63755,
    			63755
    		],
    		"mapped",
    		[
    			21895
    		]
    	],
    	[
    		[
    			63756,
    			63756
    		],
    		"mapped",
    		[
    			22856
    		]
    	],
    	[
    		[
    			63757,
    			63757
    		],
    		"mapped",
    		[
    			25078
    		]
    	],
    	[
    		[
    			63758,
    			63758
    		],
    		"mapped",
    		[
    			30313
    		]
    	],
    	[
    		[
    			63759,
    			63759
    		],
    		"mapped",
    		[
    			32645
    		]
    	],
    	[
    		[
    			63760,
    			63760
    		],
    		"mapped",
    		[
    			34367
    		]
    	],
    	[
    		[
    			63761,
    			63761
    		],
    		"mapped",
    		[
    			34746
    		]
    	],
    	[
    		[
    			63762,
    			63762
    		],
    		"mapped",
    		[
    			35064
    		]
    	],
    	[
    		[
    			63763,
    			63763
    		],
    		"mapped",
    		[
    			37007
    		]
    	],
    	[
    		[
    			63764,
    			63764
    		],
    		"mapped",
    		[
    			27138
    		]
    	],
    	[
    		[
    			63765,
    			63765
    		],
    		"mapped",
    		[
    			27931
    		]
    	],
    	[
    		[
    			63766,
    			63766
    		],
    		"mapped",
    		[
    			28889
    		]
    	],
    	[
    		[
    			63767,
    			63767
    		],
    		"mapped",
    		[
    			29662
    		]
    	],
    	[
    		[
    			63768,
    			63768
    		],
    		"mapped",
    		[
    			33853
    		]
    	],
    	[
    		[
    			63769,
    			63769
    		],
    		"mapped",
    		[
    			37226
    		]
    	],
    	[
    		[
    			63770,
    			63770
    		],
    		"mapped",
    		[
    			39409
    		]
    	],
    	[
    		[
    			63771,
    			63771
    		],
    		"mapped",
    		[
    			20098
    		]
    	],
    	[
    		[
    			63772,
    			63772
    		],
    		"mapped",
    		[
    			21365
    		]
    	],
    	[
    		[
    			63773,
    			63773
    		],
    		"mapped",
    		[
    			27396
    		]
    	],
    	[
    		[
    			63774,
    			63774
    		],
    		"mapped",
    		[
    			29211
    		]
    	],
    	[
    		[
    			63775,
    			63775
    		],
    		"mapped",
    		[
    			34349
    		]
    	],
    	[
    		[
    			63776,
    			63776
    		],
    		"mapped",
    		[
    			40478
    		]
    	],
    	[
    		[
    			63777,
    			63777
    		],
    		"mapped",
    		[
    			23888
    		]
    	],
    	[
    		[
    			63778,
    			63778
    		],
    		"mapped",
    		[
    			28651
    		]
    	],
    	[
    		[
    			63779,
    			63779
    		],
    		"mapped",
    		[
    			34253
    		]
    	],
    	[
    		[
    			63780,
    			63780
    		],
    		"mapped",
    		[
    			35172
    		]
    	],
    	[
    		[
    			63781,
    			63781
    		],
    		"mapped",
    		[
    			25289
    		]
    	],
    	[
    		[
    			63782,
    			63782
    		],
    		"mapped",
    		[
    			33240
    		]
    	],
    	[
    		[
    			63783,
    			63783
    		],
    		"mapped",
    		[
    			34847
    		]
    	],
    	[
    		[
    			63784,
    			63784
    		],
    		"mapped",
    		[
    			24266
    		]
    	],
    	[
    		[
    			63785,
    			63785
    		],
    		"mapped",
    		[
    			26391
    		]
    	],
    	[
    		[
    			63786,
    			63786
    		],
    		"mapped",
    		[
    			28010
    		]
    	],
    	[
    		[
    			63787,
    			63787
    		],
    		"mapped",
    		[
    			29436
    		]
    	],
    	[
    		[
    			63788,
    			63788
    		],
    		"mapped",
    		[
    			37070
    		]
    	],
    	[
    		[
    			63789,
    			63789
    		],
    		"mapped",
    		[
    			20358
    		]
    	],
    	[
    		[
    			63790,
    			63790
    		],
    		"mapped",
    		[
    			20919
    		]
    	],
    	[
    		[
    			63791,
    			63791
    		],
    		"mapped",
    		[
    			21214
    		]
    	],
    	[
    		[
    			63792,
    			63792
    		],
    		"mapped",
    		[
    			25796
    		]
    	],
    	[
    		[
    			63793,
    			63793
    		],
    		"mapped",
    		[
    			27347
    		]
    	],
    	[
    		[
    			63794,
    			63794
    		],
    		"mapped",
    		[
    			29200
    		]
    	],
    	[
    		[
    			63795,
    			63795
    		],
    		"mapped",
    		[
    			30439
    		]
    	],
    	[
    		[
    			63796,
    			63796
    		],
    		"mapped",
    		[
    			32769
    		]
    	],
    	[
    		[
    			63797,
    			63797
    		],
    		"mapped",
    		[
    			34310
    		]
    	],
    	[
    		[
    			63798,
    			63798
    		],
    		"mapped",
    		[
    			34396
    		]
    	],
    	[
    		[
    			63799,
    			63799
    		],
    		"mapped",
    		[
    			36335
    		]
    	],
    	[
    		[
    			63800,
    			63800
    		],
    		"mapped",
    		[
    			38706
    		]
    	],
    	[
    		[
    			63801,
    			63801
    		],
    		"mapped",
    		[
    			39791
    		]
    	],
    	[
    		[
    			63802,
    			63802
    		],
    		"mapped",
    		[
    			40442
    		]
    	],
    	[
    		[
    			63803,
    			63803
    		],
    		"mapped",
    		[
    			30860
    		]
    	],
    	[
    		[
    			63804,
    			63804
    		],
    		"mapped",
    		[
    			31103
    		]
    	],
    	[
    		[
    			63805,
    			63805
    		],
    		"mapped",
    		[
    			32160
    		]
    	],
    	[
    		[
    			63806,
    			63806
    		],
    		"mapped",
    		[
    			33737
    		]
    	],
    	[
    		[
    			63807,
    			63807
    		],
    		"mapped",
    		[
    			37636
    		]
    	],
    	[
    		[
    			63808,
    			63808
    		],
    		"mapped",
    		[
    			40575
    		]
    	],
    	[
    		[
    			63809,
    			63809
    		],
    		"mapped",
    		[
    			35542
    		]
    	],
    	[
    		[
    			63810,
    			63810
    		],
    		"mapped",
    		[
    			22751
    		]
    	],
    	[
    		[
    			63811,
    			63811
    		],
    		"mapped",
    		[
    			24324
    		]
    	],
    	[
    		[
    			63812,
    			63812
    		],
    		"mapped",
    		[
    			31840
    		]
    	],
    	[
    		[
    			63813,
    			63813
    		],
    		"mapped",
    		[
    			32894
    		]
    	],
    	[
    		[
    			63814,
    			63814
    		],
    		"mapped",
    		[
    			29282
    		]
    	],
    	[
    		[
    			63815,
    			63815
    		],
    		"mapped",
    		[
    			30922
    		]
    	],
    	[
    		[
    			63816,
    			63816
    		],
    		"mapped",
    		[
    			36034
    		]
    	],
    	[
    		[
    			63817,
    			63817
    		],
    		"mapped",
    		[
    			38647
    		]
    	],
    	[
    		[
    			63818,
    			63818
    		],
    		"mapped",
    		[
    			22744
    		]
    	],
    	[
    		[
    			63819,
    			63819
    		],
    		"mapped",
    		[
    			23650
    		]
    	],
    	[
    		[
    			63820,
    			63820
    		],
    		"mapped",
    		[
    			27155
    		]
    	],
    	[
    		[
    			63821,
    			63821
    		],
    		"mapped",
    		[
    			28122
    		]
    	],
    	[
    		[
    			63822,
    			63822
    		],
    		"mapped",
    		[
    			28431
    		]
    	],
    	[
    		[
    			63823,
    			63823
    		],
    		"mapped",
    		[
    			32047
    		]
    	],
    	[
    		[
    			63824,
    			63824
    		],
    		"mapped",
    		[
    			32311
    		]
    	],
    	[
    		[
    			63825,
    			63825
    		],
    		"mapped",
    		[
    			38475
    		]
    	],
    	[
    		[
    			63826,
    			63826
    		],
    		"mapped",
    		[
    			21202
    		]
    	],
    	[
    		[
    			63827,
    			63827
    		],
    		"mapped",
    		[
    			32907
    		]
    	],
    	[
    		[
    			63828,
    			63828
    		],
    		"mapped",
    		[
    			20956
    		]
    	],
    	[
    		[
    			63829,
    			63829
    		],
    		"mapped",
    		[
    			20940
    		]
    	],
    	[
    		[
    			63830,
    			63830
    		],
    		"mapped",
    		[
    			31260
    		]
    	],
    	[
    		[
    			63831,
    			63831
    		],
    		"mapped",
    		[
    			32190
    		]
    	],
    	[
    		[
    			63832,
    			63832
    		],
    		"mapped",
    		[
    			33777
    		]
    	],
    	[
    		[
    			63833,
    			63833
    		],
    		"mapped",
    		[
    			38517
    		]
    	],
    	[
    		[
    			63834,
    			63834
    		],
    		"mapped",
    		[
    			35712
    		]
    	],
    	[
    		[
    			63835,
    			63835
    		],
    		"mapped",
    		[
    			25295
    		]
    	],
    	[
    		[
    			63836,
    			63836
    		],
    		"mapped",
    		[
    			27138
    		]
    	],
    	[
    		[
    			63837,
    			63837
    		],
    		"mapped",
    		[
    			35582
    		]
    	],
    	[
    		[
    			63838,
    			63838
    		],
    		"mapped",
    		[
    			20025
    		]
    	],
    	[
    		[
    			63839,
    			63839
    		],
    		"mapped",
    		[
    			23527
    		]
    	],
    	[
    		[
    			63840,
    			63840
    		],
    		"mapped",
    		[
    			24594
    		]
    	],
    	[
    		[
    			63841,
    			63841
    		],
    		"mapped",
    		[
    			29575
    		]
    	],
    	[
    		[
    			63842,
    			63842
    		],
    		"mapped",
    		[
    			30064
    		]
    	],
    	[
    		[
    			63843,
    			63843
    		],
    		"mapped",
    		[
    			21271
    		]
    	],
    	[
    		[
    			63844,
    			63844
    		],
    		"mapped",
    		[
    			30971
    		]
    	],
    	[
    		[
    			63845,
    			63845
    		],
    		"mapped",
    		[
    			20415
    		]
    	],
    	[
    		[
    			63846,
    			63846
    		],
    		"mapped",
    		[
    			24489
    		]
    	],
    	[
    		[
    			63847,
    			63847
    		],
    		"mapped",
    		[
    			19981
    		]
    	],
    	[
    		[
    			63848,
    			63848
    		],
    		"mapped",
    		[
    			27852
    		]
    	],
    	[
    		[
    			63849,
    			63849
    		],
    		"mapped",
    		[
    			25976
    		]
    	],
    	[
    		[
    			63850,
    			63850
    		],
    		"mapped",
    		[
    			32034
    		]
    	],
    	[
    		[
    			63851,
    			63851
    		],
    		"mapped",
    		[
    			21443
    		]
    	],
    	[
    		[
    			63852,
    			63852
    		],
    		"mapped",
    		[
    			22622
    		]
    	],
    	[
    		[
    			63853,
    			63853
    		],
    		"mapped",
    		[
    			30465
    		]
    	],
    	[
    		[
    			63854,
    			63854
    		],
    		"mapped",
    		[
    			33865
    		]
    	],
    	[
    		[
    			63855,
    			63855
    		],
    		"mapped",
    		[
    			35498
    		]
    	],
    	[
    		[
    			63856,
    			63856
    		],
    		"mapped",
    		[
    			27578
    		]
    	],
    	[
    		[
    			63857,
    			63857
    		],
    		"mapped",
    		[
    			36784
    		]
    	],
    	[
    		[
    			63858,
    			63858
    		],
    		"mapped",
    		[
    			27784
    		]
    	],
    	[
    		[
    			63859,
    			63859
    		],
    		"mapped",
    		[
    			25342
    		]
    	],
    	[
    		[
    			63860,
    			63860
    		],
    		"mapped",
    		[
    			33509
    		]
    	],
    	[
    		[
    			63861,
    			63861
    		],
    		"mapped",
    		[
    			25504
    		]
    	],
    	[
    		[
    			63862,
    			63862
    		],
    		"mapped",
    		[
    			30053
    		]
    	],
    	[
    		[
    			63863,
    			63863
    		],
    		"mapped",
    		[
    			20142
    		]
    	],
    	[
    		[
    			63864,
    			63864
    		],
    		"mapped",
    		[
    			20841
    		]
    	],
    	[
    		[
    			63865,
    			63865
    		],
    		"mapped",
    		[
    			20937
    		]
    	],
    	[
    		[
    			63866,
    			63866
    		],
    		"mapped",
    		[
    			26753
    		]
    	],
    	[
    		[
    			63867,
    			63867
    		],
    		"mapped",
    		[
    			31975
    		]
    	],
    	[
    		[
    			63868,
    			63868
    		],
    		"mapped",
    		[
    			33391
    		]
    	],
    	[
    		[
    			63869,
    			63869
    		],
    		"mapped",
    		[
    			35538
    		]
    	],
    	[
    		[
    			63870,
    			63870
    		],
    		"mapped",
    		[
    			37327
    		]
    	],
    	[
    		[
    			63871,
    			63871
    		],
    		"mapped",
    		[
    			21237
    		]
    	],
    	[
    		[
    			63872,
    			63872
    		],
    		"mapped",
    		[
    			21570
    		]
    	],
    	[
    		[
    			63873,
    			63873
    		],
    		"mapped",
    		[
    			22899
    		]
    	],
    	[
    		[
    			63874,
    			63874
    		],
    		"mapped",
    		[
    			24300
    		]
    	],
    	[
    		[
    			63875,
    			63875
    		],
    		"mapped",
    		[
    			26053
    		]
    	],
    	[
    		[
    			63876,
    			63876
    		],
    		"mapped",
    		[
    			28670
    		]
    	],
    	[
    		[
    			63877,
    			63877
    		],
    		"mapped",
    		[
    			31018
    		]
    	],
    	[
    		[
    			63878,
    			63878
    		],
    		"mapped",
    		[
    			38317
    		]
    	],
    	[
    		[
    			63879,
    			63879
    		],
    		"mapped",
    		[
    			39530
    		]
    	],
    	[
    		[
    			63880,
    			63880
    		],
    		"mapped",
    		[
    			40599
    		]
    	],
    	[
    		[
    			63881,
    			63881
    		],
    		"mapped",
    		[
    			40654
    		]
    	],
    	[
    		[
    			63882,
    			63882
    		],
    		"mapped",
    		[
    			21147
    		]
    	],
    	[
    		[
    			63883,
    			63883
    		],
    		"mapped",
    		[
    			26310
    		]
    	],
    	[
    		[
    			63884,
    			63884
    		],
    		"mapped",
    		[
    			27511
    		]
    	],
    	[
    		[
    			63885,
    			63885
    		],
    		"mapped",
    		[
    			36706
    		]
    	],
    	[
    		[
    			63886,
    			63886
    		],
    		"mapped",
    		[
    			24180
    		]
    	],
    	[
    		[
    			63887,
    			63887
    		],
    		"mapped",
    		[
    			24976
    		]
    	],
    	[
    		[
    			63888,
    			63888
    		],
    		"mapped",
    		[
    			25088
    		]
    	],
    	[
    		[
    			63889,
    			63889
    		],
    		"mapped",
    		[
    			25754
    		]
    	],
    	[
    		[
    			63890,
    			63890
    		],
    		"mapped",
    		[
    			28451
    		]
    	],
    	[
    		[
    			63891,
    			63891
    		],
    		"mapped",
    		[
    			29001
    		]
    	],
    	[
    		[
    			63892,
    			63892
    		],
    		"mapped",
    		[
    			29833
    		]
    	],
    	[
    		[
    			63893,
    			63893
    		],
    		"mapped",
    		[
    			31178
    		]
    	],
    	[
    		[
    			63894,
    			63894
    		],
    		"mapped",
    		[
    			32244
    		]
    	],
    	[
    		[
    			63895,
    			63895
    		],
    		"mapped",
    		[
    			32879
    		]
    	],
    	[
    		[
    			63896,
    			63896
    		],
    		"mapped",
    		[
    			36646
    		]
    	],
    	[
    		[
    			63897,
    			63897
    		],
    		"mapped",
    		[
    			34030
    		]
    	],
    	[
    		[
    			63898,
    			63898
    		],
    		"mapped",
    		[
    			36899
    		]
    	],
    	[
    		[
    			63899,
    			63899
    		],
    		"mapped",
    		[
    			37706
    		]
    	],
    	[
    		[
    			63900,
    			63900
    		],
    		"mapped",
    		[
    			21015
    		]
    	],
    	[
    		[
    			63901,
    			63901
    		],
    		"mapped",
    		[
    			21155
    		]
    	],
    	[
    		[
    			63902,
    			63902
    		],
    		"mapped",
    		[
    			21693
    		]
    	],
    	[
    		[
    			63903,
    			63903
    		],
    		"mapped",
    		[
    			28872
    		]
    	],
    	[
    		[
    			63904,
    			63904
    		],
    		"mapped",
    		[
    			35010
    		]
    	],
    	[
    		[
    			63905,
    			63905
    		],
    		"mapped",
    		[
    			35498
    		]
    	],
    	[
    		[
    			63906,
    			63906
    		],
    		"mapped",
    		[
    			24265
    		]
    	],
    	[
    		[
    			63907,
    			63907
    		],
    		"mapped",
    		[
    			24565
    		]
    	],
    	[
    		[
    			63908,
    			63908
    		],
    		"mapped",
    		[
    			25467
    		]
    	],
    	[
    		[
    			63909,
    			63909
    		],
    		"mapped",
    		[
    			27566
    		]
    	],
    	[
    		[
    			63910,
    			63910
    		],
    		"mapped",
    		[
    			31806
    		]
    	],
    	[
    		[
    			63911,
    			63911
    		],
    		"mapped",
    		[
    			29557
    		]
    	],
    	[
    		[
    			63912,
    			63912
    		],
    		"mapped",
    		[
    			20196
    		]
    	],
    	[
    		[
    			63913,
    			63913
    		],
    		"mapped",
    		[
    			22265
    		]
    	],
    	[
    		[
    			63914,
    			63914
    		],
    		"mapped",
    		[
    			23527
    		]
    	],
    	[
    		[
    			63915,
    			63915
    		],
    		"mapped",
    		[
    			23994
    		]
    	],
    	[
    		[
    			63916,
    			63916
    		],
    		"mapped",
    		[
    			24604
    		]
    	],
    	[
    		[
    			63917,
    			63917
    		],
    		"mapped",
    		[
    			29618
    		]
    	],
    	[
    		[
    			63918,
    			63918
    		],
    		"mapped",
    		[
    			29801
    		]
    	],
    	[
    		[
    			63919,
    			63919
    		],
    		"mapped",
    		[
    			32666
    		]
    	],
    	[
    		[
    			63920,
    			63920
    		],
    		"mapped",
    		[
    			32838
    		]
    	],
    	[
    		[
    			63921,
    			63921
    		],
    		"mapped",
    		[
    			37428
    		]
    	],
    	[
    		[
    			63922,
    			63922
    		],
    		"mapped",
    		[
    			38646
    		]
    	],
    	[
    		[
    			63923,
    			63923
    		],
    		"mapped",
    		[
    			38728
    		]
    	],
    	[
    		[
    			63924,
    			63924
    		],
    		"mapped",
    		[
    			38936
    		]
    	],
    	[
    		[
    			63925,
    			63925
    		],
    		"mapped",
    		[
    			20363
    		]
    	],
    	[
    		[
    			63926,
    			63926
    		],
    		"mapped",
    		[
    			31150
    		]
    	],
    	[
    		[
    			63927,
    			63927
    		],
    		"mapped",
    		[
    			37300
    		]
    	],
    	[
    		[
    			63928,
    			63928
    		],
    		"mapped",
    		[
    			38584
    		]
    	],
    	[
    		[
    			63929,
    			63929
    		],
    		"mapped",
    		[
    			24801
    		]
    	],
    	[
    		[
    			63930,
    			63930
    		],
    		"mapped",
    		[
    			20102
    		]
    	],
    	[
    		[
    			63931,
    			63931
    		],
    		"mapped",
    		[
    			20698
    		]
    	],
    	[
    		[
    			63932,
    			63932
    		],
    		"mapped",
    		[
    			23534
    		]
    	],
    	[
    		[
    			63933,
    			63933
    		],
    		"mapped",
    		[
    			23615
    		]
    	],
    	[
    		[
    			63934,
    			63934
    		],
    		"mapped",
    		[
    			26009
    		]
    	],
    	[
    		[
    			63935,
    			63935
    		],
    		"mapped",
    		[
    			27138
    		]
    	],
    	[
    		[
    			63936,
    			63936
    		],
    		"mapped",
    		[
    			29134
    		]
    	],
    	[
    		[
    			63937,
    			63937
    		],
    		"mapped",
    		[
    			30274
    		]
    	],
    	[
    		[
    			63938,
    			63938
    		],
    		"mapped",
    		[
    			34044
    		]
    	],
    	[
    		[
    			63939,
    			63939
    		],
    		"mapped",
    		[
    			36988
    		]
    	],
    	[
    		[
    			63940,
    			63940
    		],
    		"mapped",
    		[
    			40845
    		]
    	],
    	[
    		[
    			63941,
    			63941
    		],
    		"mapped",
    		[
    			26248
    		]
    	],
    	[
    		[
    			63942,
    			63942
    		],
    		"mapped",
    		[
    			38446
    		]
    	],
    	[
    		[
    			63943,
    			63943
    		],
    		"mapped",
    		[
    			21129
    		]
    	],
    	[
    		[
    			63944,
    			63944
    		],
    		"mapped",
    		[
    			26491
    		]
    	],
    	[
    		[
    			63945,
    			63945
    		],
    		"mapped",
    		[
    			26611
    		]
    	],
    	[
    		[
    			63946,
    			63946
    		],
    		"mapped",
    		[
    			27969
    		]
    	],
    	[
    		[
    			63947,
    			63947
    		],
    		"mapped",
    		[
    			28316
    		]
    	],
    	[
    		[
    			63948,
    			63948
    		],
    		"mapped",
    		[
    			29705
    		]
    	],
    	[
    		[
    			63949,
    			63949
    		],
    		"mapped",
    		[
    			30041
    		]
    	],
    	[
    		[
    			63950,
    			63950
    		],
    		"mapped",
    		[
    			30827
    		]
    	],
    	[
    		[
    			63951,
    			63951
    		],
    		"mapped",
    		[
    			32016
    		]
    	],
    	[
    		[
    			63952,
    			63952
    		],
    		"mapped",
    		[
    			39006
    		]
    	],
    	[
    		[
    			63953,
    			63953
    		],
    		"mapped",
    		[
    			20845
    		]
    	],
    	[
    		[
    			63954,
    			63954
    		],
    		"mapped",
    		[
    			25134
    		]
    	],
    	[
    		[
    			63955,
    			63955
    		],
    		"mapped",
    		[
    			38520
    		]
    	],
    	[
    		[
    			63956,
    			63956
    		],
    		"mapped",
    		[
    			20523
    		]
    	],
    	[
    		[
    			63957,
    			63957
    		],
    		"mapped",
    		[
    			23833
    		]
    	],
    	[
    		[
    			63958,
    			63958
    		],
    		"mapped",
    		[
    			28138
    		]
    	],
    	[
    		[
    			63959,
    			63959
    		],
    		"mapped",
    		[
    			36650
    		]
    	],
    	[
    		[
    			63960,
    			63960
    		],
    		"mapped",
    		[
    			24459
    		]
    	],
    	[
    		[
    			63961,
    			63961
    		],
    		"mapped",
    		[
    			24900
    		]
    	],
    	[
    		[
    			63962,
    			63962
    		],
    		"mapped",
    		[
    			26647
    		]
    	],
    	[
    		[
    			63963,
    			63963
    		],
    		"mapped",
    		[
    			29575
    		]
    	],
    	[
    		[
    			63964,
    			63964
    		],
    		"mapped",
    		[
    			38534
    		]
    	],
    	[
    		[
    			63965,
    			63965
    		],
    		"mapped",
    		[
    			21033
    		]
    	],
    	[
    		[
    			63966,
    			63966
    		],
    		"mapped",
    		[
    			21519
    		]
    	],
    	[
    		[
    			63967,
    			63967
    		],
    		"mapped",
    		[
    			23653
    		]
    	],
    	[
    		[
    			63968,
    			63968
    		],
    		"mapped",
    		[
    			26131
    		]
    	],
    	[
    		[
    			63969,
    			63969
    		],
    		"mapped",
    		[
    			26446
    		]
    	],
    	[
    		[
    			63970,
    			63970
    		],
    		"mapped",
    		[
    			26792
    		]
    	],
    	[
    		[
    			63971,
    			63971
    		],
    		"mapped",
    		[
    			27877
    		]
    	],
    	[
    		[
    			63972,
    			63972
    		],
    		"mapped",
    		[
    			29702
    		]
    	],
    	[
    		[
    			63973,
    			63973
    		],
    		"mapped",
    		[
    			30178
    		]
    	],
    	[
    		[
    			63974,
    			63974
    		],
    		"mapped",
    		[
    			32633
    		]
    	],
    	[
    		[
    			63975,
    			63975
    		],
    		"mapped",
    		[
    			35023
    		]
    	],
    	[
    		[
    			63976,
    			63976
    		],
    		"mapped",
    		[
    			35041
    		]
    	],
    	[
    		[
    			63977,
    			63977
    		],
    		"mapped",
    		[
    			37324
    		]
    	],
    	[
    		[
    			63978,
    			63978
    		],
    		"mapped",
    		[
    			38626
    		]
    	],
    	[
    		[
    			63979,
    			63979
    		],
    		"mapped",
    		[
    			21311
    		]
    	],
    	[
    		[
    			63980,
    			63980
    		],
    		"mapped",
    		[
    			28346
    		]
    	],
    	[
    		[
    			63981,
    			63981
    		],
    		"mapped",
    		[
    			21533
    		]
    	],
    	[
    		[
    			63982,
    			63982
    		],
    		"mapped",
    		[
    			29136
    		]
    	],
    	[
    		[
    			63983,
    			63983
    		],
    		"mapped",
    		[
    			29848
    		]
    	],
    	[
    		[
    			63984,
    			63984
    		],
    		"mapped",
    		[
    			34298
    		]
    	],
    	[
    		[
    			63985,
    			63985
    		],
    		"mapped",
    		[
    			38563
    		]
    	],
    	[
    		[
    			63986,
    			63986
    		],
    		"mapped",
    		[
    			40023
    		]
    	],
    	[
    		[
    			63987,
    			63987
    		],
    		"mapped",
    		[
    			40607
    		]
    	],
    	[
    		[
    			63988,
    			63988
    		],
    		"mapped",
    		[
    			26519
    		]
    	],
    	[
    		[
    			63989,
    			63989
    		],
    		"mapped",
    		[
    			28107
    		]
    	],
    	[
    		[
    			63990,
    			63990
    		],
    		"mapped",
    		[
    			33256
    		]
    	],
    	[
    		[
    			63991,
    			63991
    		],
    		"mapped",
    		[
    			31435
    		]
    	],
    	[
    		[
    			63992,
    			63992
    		],
    		"mapped",
    		[
    			31520
    		]
    	],
    	[
    		[
    			63993,
    			63993
    		],
    		"mapped",
    		[
    			31890
    		]
    	],
    	[
    		[
    			63994,
    			63994
    		],
    		"mapped",
    		[
    			29376
    		]
    	],
    	[
    		[
    			63995,
    			63995
    		],
    		"mapped",
    		[
    			28825
    		]
    	],
    	[
    		[
    			63996,
    			63996
    		],
    		"mapped",
    		[
    			35672
    		]
    	],
    	[
    		[
    			63997,
    			63997
    		],
    		"mapped",
    		[
    			20160
    		]
    	],
    	[
    		[
    			63998,
    			63998
    		],
    		"mapped",
    		[
    			33590
    		]
    	],
    	[
    		[
    			63999,
    			63999
    		],
    		"mapped",
    		[
    			21050
    		]
    	],
    	[
    		[
    			64000,
    			64000
    		],
    		"mapped",
    		[
    			20999
    		]
    	],
    	[
    		[
    			64001,
    			64001
    		],
    		"mapped",
    		[
    			24230
    		]
    	],
    	[
    		[
    			64002,
    			64002
    		],
    		"mapped",
    		[
    			25299
    		]
    	],
    	[
    		[
    			64003,
    			64003
    		],
    		"mapped",
    		[
    			31958
    		]
    	],
    	[
    		[
    			64004,
    			64004
    		],
    		"mapped",
    		[
    			23429
    		]
    	],
    	[
    		[
    			64005,
    			64005
    		],
    		"mapped",
    		[
    			27934
    		]
    	],
    	[
    		[
    			64006,
    			64006
    		],
    		"mapped",
    		[
    			26292
    		]
    	],
    	[
    		[
    			64007,
    			64007
    		],
    		"mapped",
    		[
    			36667
    		]
    	],
    	[
    		[
    			64008,
    			64008
    		],
    		"mapped",
    		[
    			34892
    		]
    	],
    	[
    		[
    			64009,
    			64009
    		],
    		"mapped",
    		[
    			38477
    		]
    	],
    	[
    		[
    			64010,
    			64010
    		],
    		"mapped",
    		[
    			35211
    		]
    	],
    	[
    		[
    			64011,
    			64011
    		],
    		"mapped",
    		[
    			24275
    		]
    	],
    	[
    		[
    			64012,
    			64012
    		],
    		"mapped",
    		[
    			20800
    		]
    	],
    	[
    		[
    			64013,
    			64013
    		],
    		"mapped",
    		[
    			21952
    		]
    	],
    	[
    		[
    			64014,
    			64015
    		],
    		"valid"
    	],
    	[
    		[
    			64016,
    			64016
    		],
    		"mapped",
    		[
    			22618
    		]
    	],
    	[
    		[
    			64017,
    			64017
    		],
    		"valid"
    	],
    	[
    		[
    			64018,
    			64018
    		],
    		"mapped",
    		[
    			26228
    		]
    	],
    	[
    		[
    			64019,
    			64020
    		],
    		"valid"
    	],
    	[
    		[
    			64021,
    			64021
    		],
    		"mapped",
    		[
    			20958
    		]
    	],
    	[
    		[
    			64022,
    			64022
    		],
    		"mapped",
    		[
    			29482
    		]
    	],
    	[
    		[
    			64023,
    			64023
    		],
    		"mapped",
    		[
    			30410
    		]
    	],
    	[
    		[
    			64024,
    			64024
    		],
    		"mapped",
    		[
    			31036
    		]
    	],
    	[
    		[
    			64025,
    			64025
    		],
    		"mapped",
    		[
    			31070
    		]
    	],
    	[
    		[
    			64026,
    			64026
    		],
    		"mapped",
    		[
    			31077
    		]
    	],
    	[
    		[
    			64027,
    			64027
    		],
    		"mapped",
    		[
    			31119
    		]
    	],
    	[
    		[
    			64028,
    			64028
    		],
    		"mapped",
    		[
    			38742
    		]
    	],
    	[
    		[
    			64029,
    			64029
    		],
    		"mapped",
    		[
    			31934
    		]
    	],
    	[
    		[
    			64030,
    			64030
    		],
    		"mapped",
    		[
    			32701
    		]
    	],
    	[
    		[
    			64031,
    			64031
    		],
    		"valid"
    	],
    	[
    		[
    			64032,
    			64032
    		],
    		"mapped",
    		[
    			34322
    		]
    	],
    	[
    		[
    			64033,
    			64033
    		],
    		"valid"
    	],
    	[
    		[
    			64034,
    			64034
    		],
    		"mapped",
    		[
    			35576
    		]
    	],
    	[
    		[
    			64035,
    			64036
    		],
    		"valid"
    	],
    	[
    		[
    			64037,
    			64037
    		],
    		"mapped",
    		[
    			36920
    		]
    	],
    	[
    		[
    			64038,
    			64038
    		],
    		"mapped",
    		[
    			37117
    		]
    	],
    	[
    		[
    			64039,
    			64041
    		],
    		"valid"
    	],
    	[
    		[
    			64042,
    			64042
    		],
    		"mapped",
    		[
    			39151
    		]
    	],
    	[
    		[
    			64043,
    			64043
    		],
    		"mapped",
    		[
    			39164
    		]
    	],
    	[
    		[
    			64044,
    			64044
    		],
    		"mapped",
    		[
    			39208
    		]
    	],
    	[
    		[
    			64045,
    			64045
    		],
    		"mapped",
    		[
    			40372
    		]
    	],
    	[
    		[
    			64046,
    			64046
    		],
    		"mapped",
    		[
    			37086
    		]
    	],
    	[
    		[
    			64047,
    			64047
    		],
    		"mapped",
    		[
    			38583
    		]
    	],
    	[
    		[
    			64048,
    			64048
    		],
    		"mapped",
    		[
    			20398
    		]
    	],
    	[
    		[
    			64049,
    			64049
    		],
    		"mapped",
    		[
    			20711
    		]
    	],
    	[
    		[
    			64050,
    			64050
    		],
    		"mapped",
    		[
    			20813
    		]
    	],
    	[
    		[
    			64051,
    			64051
    		],
    		"mapped",
    		[
    			21193
    		]
    	],
    	[
    		[
    			64052,
    			64052
    		],
    		"mapped",
    		[
    			21220
    		]
    	],
    	[
    		[
    			64053,
    			64053
    		],
    		"mapped",
    		[
    			21329
    		]
    	],
    	[
    		[
    			64054,
    			64054
    		],
    		"mapped",
    		[
    			21917
    		]
    	],
    	[
    		[
    			64055,
    			64055
    		],
    		"mapped",
    		[
    			22022
    		]
    	],
    	[
    		[
    			64056,
    			64056
    		],
    		"mapped",
    		[
    			22120
    		]
    	],
    	[
    		[
    			64057,
    			64057
    		],
    		"mapped",
    		[
    			22592
    		]
    	],
    	[
    		[
    			64058,
    			64058
    		],
    		"mapped",
    		[
    			22696
    		]
    	],
    	[
    		[
    			64059,
    			64059
    		],
    		"mapped",
    		[
    			23652
    		]
    	],
    	[
    		[
    			64060,
    			64060
    		],
    		"mapped",
    		[
    			23662
    		]
    	],
    	[
    		[
    			64061,
    			64061
    		],
    		"mapped",
    		[
    			24724
    		]
    	],
    	[
    		[
    			64062,
    			64062
    		],
    		"mapped",
    		[
    			24936
    		]
    	],
    	[
    		[
    			64063,
    			64063
    		],
    		"mapped",
    		[
    			24974
    		]
    	],
    	[
    		[
    			64064,
    			64064
    		],
    		"mapped",
    		[
    			25074
    		]
    	],
    	[
    		[
    			64065,
    			64065
    		],
    		"mapped",
    		[
    			25935
    		]
    	],
    	[
    		[
    			64066,
    			64066
    		],
    		"mapped",
    		[
    			26082
    		]
    	],
    	[
    		[
    			64067,
    			64067
    		],
    		"mapped",
    		[
    			26257
    		]
    	],
    	[
    		[
    			64068,
    			64068
    		],
    		"mapped",
    		[
    			26757
    		]
    	],
    	[
    		[
    			64069,
    			64069
    		],
    		"mapped",
    		[
    			28023
    		]
    	],
    	[
    		[
    			64070,
    			64070
    		],
    		"mapped",
    		[
    			28186
    		]
    	],
    	[
    		[
    			64071,
    			64071
    		],
    		"mapped",
    		[
    			28450
    		]
    	],
    	[
    		[
    			64072,
    			64072
    		],
    		"mapped",
    		[
    			29038
    		]
    	],
    	[
    		[
    			64073,
    			64073
    		],
    		"mapped",
    		[
    			29227
    		]
    	],
    	[
    		[
    			64074,
    			64074
    		],
    		"mapped",
    		[
    			29730
    		]
    	],
    	[
    		[
    			64075,
    			64075
    		],
    		"mapped",
    		[
    			30865
    		]
    	],
    	[
    		[
    			64076,
    			64076
    		],
    		"mapped",
    		[
    			31038
    		]
    	],
    	[
    		[
    			64077,
    			64077
    		],
    		"mapped",
    		[
    			31049
    		]
    	],
    	[
    		[
    			64078,
    			64078
    		],
    		"mapped",
    		[
    			31048
    		]
    	],
    	[
    		[
    			64079,
    			64079
    		],
    		"mapped",
    		[
    			31056
    		]
    	],
    	[
    		[
    			64080,
    			64080
    		],
    		"mapped",
    		[
    			31062
    		]
    	],
    	[
    		[
    			64081,
    			64081
    		],
    		"mapped",
    		[
    			31069
    		]
    	],
    	[
    		[
    			64082,
    			64082
    		],
    		"mapped",
    		[
    			31117
    		]
    	],
    	[
    		[
    			64083,
    			64083
    		],
    		"mapped",
    		[
    			31118
    		]
    	],
    	[
    		[
    			64084,
    			64084
    		],
    		"mapped",
    		[
    			31296
    		]
    	],
    	[
    		[
    			64085,
    			64085
    		],
    		"mapped",
    		[
    			31361
    		]
    	],
    	[
    		[
    			64086,
    			64086
    		],
    		"mapped",
    		[
    			31680
    		]
    	],
    	[
    		[
    			64087,
    			64087
    		],
    		"mapped",
    		[
    			32244
    		]
    	],
    	[
    		[
    			64088,
    			64088
    		],
    		"mapped",
    		[
    			32265
    		]
    	],
    	[
    		[
    			64089,
    			64089
    		],
    		"mapped",
    		[
    			32321
    		]
    	],
    	[
    		[
    			64090,
    			64090
    		],
    		"mapped",
    		[
    			32626
    		]
    	],
    	[
    		[
    			64091,
    			64091
    		],
    		"mapped",
    		[
    			32773
    		]
    	],
    	[
    		[
    			64092,
    			64092
    		],
    		"mapped",
    		[
    			33261
    		]
    	],
    	[
    		[
    			64093,
    			64094
    		],
    		"mapped",
    		[
    			33401
    		]
    	],
    	[
    		[
    			64095,
    			64095
    		],
    		"mapped",
    		[
    			33879
    		]
    	],
    	[
    		[
    			64096,
    			64096
    		],
    		"mapped",
    		[
    			35088
    		]
    	],
    	[
    		[
    			64097,
    			64097
    		],
    		"mapped",
    		[
    			35222
    		]
    	],
    	[
    		[
    			64098,
    			64098
    		],
    		"mapped",
    		[
    			35585
    		]
    	],
    	[
    		[
    			64099,
    			64099
    		],
    		"mapped",
    		[
    			35641
    		]
    	],
    	[
    		[
    			64100,
    			64100
    		],
    		"mapped",
    		[
    			36051
    		]
    	],
    	[
    		[
    			64101,
    			64101
    		],
    		"mapped",
    		[
    			36104
    		]
    	],
    	[
    		[
    			64102,
    			64102
    		],
    		"mapped",
    		[
    			36790
    		]
    	],
    	[
    		[
    			64103,
    			64103
    		],
    		"mapped",
    		[
    			36920
    		]
    	],
    	[
    		[
    			64104,
    			64104
    		],
    		"mapped",
    		[
    			38627
    		]
    	],
    	[
    		[
    			64105,
    			64105
    		],
    		"mapped",
    		[
    			38911
    		]
    	],
    	[
    		[
    			64106,
    			64106
    		],
    		"mapped",
    		[
    			38971
    		]
    	],
    	[
    		[
    			64107,
    			64107
    		],
    		"mapped",
    		[
    			24693
    		]
    	],
    	[
    		[
    			64108,
    			64108
    		],
    		"mapped",
    		[
    			148206
    		]
    	],
    	[
    		[
    			64109,
    			64109
    		],
    		"mapped",
    		[
    			33304
    		]
    	],
    	[
    		[
    			64110,
    			64111
    		],
    		"disallowed"
    	],
    	[
    		[
    			64112,
    			64112
    		],
    		"mapped",
    		[
    			20006
    		]
    	],
    	[
    		[
    			64113,
    			64113
    		],
    		"mapped",
    		[
    			20917
    		]
    	],
    	[
    		[
    			64114,
    			64114
    		],
    		"mapped",
    		[
    			20840
    		]
    	],
    	[
    		[
    			64115,
    			64115
    		],
    		"mapped",
    		[
    			20352
    		]
    	],
    	[
    		[
    			64116,
    			64116
    		],
    		"mapped",
    		[
    			20805
    		]
    	],
    	[
    		[
    			64117,
    			64117
    		],
    		"mapped",
    		[
    			20864
    		]
    	],
    	[
    		[
    			64118,
    			64118
    		],
    		"mapped",
    		[
    			21191
    		]
    	],
    	[
    		[
    			64119,
    			64119
    		],
    		"mapped",
    		[
    			21242
    		]
    	],
    	[
    		[
    			64120,
    			64120
    		],
    		"mapped",
    		[
    			21917
    		]
    	],
    	[
    		[
    			64121,
    			64121
    		],
    		"mapped",
    		[
    			21845
    		]
    	],
    	[
    		[
    			64122,
    			64122
    		],
    		"mapped",
    		[
    			21913
    		]
    	],
    	[
    		[
    			64123,
    			64123
    		],
    		"mapped",
    		[
    			21986
    		]
    	],
    	[
    		[
    			64124,
    			64124
    		],
    		"mapped",
    		[
    			22618
    		]
    	],
    	[
    		[
    			64125,
    			64125
    		],
    		"mapped",
    		[
    			22707
    		]
    	],
    	[
    		[
    			64126,
    			64126
    		],
    		"mapped",
    		[
    			22852
    		]
    	],
    	[
    		[
    			64127,
    			64127
    		],
    		"mapped",
    		[
    			22868
    		]
    	],
    	[
    		[
    			64128,
    			64128
    		],
    		"mapped",
    		[
    			23138
    		]
    	],
    	[
    		[
    			64129,
    			64129
    		],
    		"mapped",
    		[
    			23336
    		]
    	],
    	[
    		[
    			64130,
    			64130
    		],
    		"mapped",
    		[
    			24274
    		]
    	],
    	[
    		[
    			64131,
    			64131
    		],
    		"mapped",
    		[
    			24281
    		]
    	],
    	[
    		[
    			64132,
    			64132
    		],
    		"mapped",
    		[
    			24425
    		]
    	],
    	[
    		[
    			64133,
    			64133
    		],
    		"mapped",
    		[
    			24493
    		]
    	],
    	[
    		[
    			64134,
    			64134
    		],
    		"mapped",
    		[
    			24792
    		]
    	],
    	[
    		[
    			64135,
    			64135
    		],
    		"mapped",
    		[
    			24910
    		]
    	],
    	[
    		[
    			64136,
    			64136
    		],
    		"mapped",
    		[
    			24840
    		]
    	],
    	[
    		[
    			64137,
    			64137
    		],
    		"mapped",
    		[
    			24974
    		]
    	],
    	[
    		[
    			64138,
    			64138
    		],
    		"mapped",
    		[
    			24928
    		]
    	],
    	[
    		[
    			64139,
    			64139
    		],
    		"mapped",
    		[
    			25074
    		]
    	],
    	[
    		[
    			64140,
    			64140
    		],
    		"mapped",
    		[
    			25140
    		]
    	],
    	[
    		[
    			64141,
    			64141
    		],
    		"mapped",
    		[
    			25540
    		]
    	],
    	[
    		[
    			64142,
    			64142
    		],
    		"mapped",
    		[
    			25628
    		]
    	],
    	[
    		[
    			64143,
    			64143
    		],
    		"mapped",
    		[
    			25682
    		]
    	],
    	[
    		[
    			64144,
    			64144
    		],
    		"mapped",
    		[
    			25942
    		]
    	],
    	[
    		[
    			64145,
    			64145
    		],
    		"mapped",
    		[
    			26228
    		]
    	],
    	[
    		[
    			64146,
    			64146
    		],
    		"mapped",
    		[
    			26391
    		]
    	],
    	[
    		[
    			64147,
    			64147
    		],
    		"mapped",
    		[
    			26395
    		]
    	],
    	[
    		[
    			64148,
    			64148
    		],
    		"mapped",
    		[
    			26454
    		]
    	],
    	[
    		[
    			64149,
    			64149
    		],
    		"mapped",
    		[
    			27513
    		]
    	],
    	[
    		[
    			64150,
    			64150
    		],
    		"mapped",
    		[
    			27578
    		]
    	],
    	[
    		[
    			64151,
    			64151
    		],
    		"mapped",
    		[
    			27969
    		]
    	],
    	[
    		[
    			64152,
    			64152
    		],
    		"mapped",
    		[
    			28379
    		]
    	],
    	[
    		[
    			64153,
    			64153
    		],
    		"mapped",
    		[
    			28363
    		]
    	],
    	[
    		[
    			64154,
    			64154
    		],
    		"mapped",
    		[
    			28450
    		]
    	],
    	[
    		[
    			64155,
    			64155
    		],
    		"mapped",
    		[
    			28702
    		]
    	],
    	[
    		[
    			64156,
    			64156
    		],
    		"mapped",
    		[
    			29038
    		]
    	],
    	[
    		[
    			64157,
    			64157
    		],
    		"mapped",
    		[
    			30631
    		]
    	],
    	[
    		[
    			64158,
    			64158
    		],
    		"mapped",
    		[
    			29237
    		]
    	],
    	[
    		[
    			64159,
    			64159
    		],
    		"mapped",
    		[
    			29359
    		]
    	],
    	[
    		[
    			64160,
    			64160
    		],
    		"mapped",
    		[
    			29482
    		]
    	],
    	[
    		[
    			64161,
    			64161
    		],
    		"mapped",
    		[
    			29809
    		]
    	],
    	[
    		[
    			64162,
    			64162
    		],
    		"mapped",
    		[
    			29958
    		]
    	],
    	[
    		[
    			64163,
    			64163
    		],
    		"mapped",
    		[
    			30011
    		]
    	],
    	[
    		[
    			64164,
    			64164
    		],
    		"mapped",
    		[
    			30237
    		]
    	],
    	[
    		[
    			64165,
    			64165
    		],
    		"mapped",
    		[
    			30239
    		]
    	],
    	[
    		[
    			64166,
    			64166
    		],
    		"mapped",
    		[
    			30410
    		]
    	],
    	[
    		[
    			64167,
    			64167
    		],
    		"mapped",
    		[
    			30427
    		]
    	],
    	[
    		[
    			64168,
    			64168
    		],
    		"mapped",
    		[
    			30452
    		]
    	],
    	[
    		[
    			64169,
    			64169
    		],
    		"mapped",
    		[
    			30538
    		]
    	],
    	[
    		[
    			64170,
    			64170
    		],
    		"mapped",
    		[
    			30528
    		]
    	],
    	[
    		[
    			64171,
    			64171
    		],
    		"mapped",
    		[
    			30924
    		]
    	],
    	[
    		[
    			64172,
    			64172
    		],
    		"mapped",
    		[
    			31409
    		]
    	],
    	[
    		[
    			64173,
    			64173
    		],
    		"mapped",
    		[
    			31680
    		]
    	],
    	[
    		[
    			64174,
    			64174
    		],
    		"mapped",
    		[
    			31867
    		]
    	],
    	[
    		[
    			64175,
    			64175
    		],
    		"mapped",
    		[
    			32091
    		]
    	],
    	[
    		[
    			64176,
    			64176
    		],
    		"mapped",
    		[
    			32244
    		]
    	],
    	[
    		[
    			64177,
    			64177
    		],
    		"mapped",
    		[
    			32574
    		]
    	],
    	[
    		[
    			64178,
    			64178
    		],
    		"mapped",
    		[
    			32773
    		]
    	],
    	[
    		[
    			64179,
    			64179
    		],
    		"mapped",
    		[
    			33618
    		]
    	],
    	[
    		[
    			64180,
    			64180
    		],
    		"mapped",
    		[
    			33775
    		]
    	],
    	[
    		[
    			64181,
    			64181
    		],
    		"mapped",
    		[
    			34681
    		]
    	],
    	[
    		[
    			64182,
    			64182
    		],
    		"mapped",
    		[
    			35137
    		]
    	],
    	[
    		[
    			64183,
    			64183
    		],
    		"mapped",
    		[
    			35206
    		]
    	],
    	[
    		[
    			64184,
    			64184
    		],
    		"mapped",
    		[
    			35222
    		]
    	],
    	[
    		[
    			64185,
    			64185
    		],
    		"mapped",
    		[
    			35519
    		]
    	],
    	[
    		[
    			64186,
    			64186
    		],
    		"mapped",
    		[
    			35576
    		]
    	],
    	[
    		[
    			64187,
    			64187
    		],
    		"mapped",
    		[
    			35531
    		]
    	],
    	[
    		[
    			64188,
    			64188
    		],
    		"mapped",
    		[
    			35585
    		]
    	],
    	[
    		[
    			64189,
    			64189
    		],
    		"mapped",
    		[
    			35582
    		]
    	],
    	[
    		[
    			64190,
    			64190
    		],
    		"mapped",
    		[
    			35565
    		]
    	],
    	[
    		[
    			64191,
    			64191
    		],
    		"mapped",
    		[
    			35641
    		]
    	],
    	[
    		[
    			64192,
    			64192
    		],
    		"mapped",
    		[
    			35722
    		]
    	],
    	[
    		[
    			64193,
    			64193
    		],
    		"mapped",
    		[
    			36104
    		]
    	],
    	[
    		[
    			64194,
    			64194
    		],
    		"mapped",
    		[
    			36664
    		]
    	],
    	[
    		[
    			64195,
    			64195
    		],
    		"mapped",
    		[
    			36978
    		]
    	],
    	[
    		[
    			64196,
    			64196
    		],
    		"mapped",
    		[
    			37273
    		]
    	],
    	[
    		[
    			64197,
    			64197
    		],
    		"mapped",
    		[
    			37494
    		]
    	],
    	[
    		[
    			64198,
    			64198
    		],
    		"mapped",
    		[
    			38524
    		]
    	],
    	[
    		[
    			64199,
    			64199
    		],
    		"mapped",
    		[
    			38627
    		]
    	],
    	[
    		[
    			64200,
    			64200
    		],
    		"mapped",
    		[
    			38742
    		]
    	],
    	[
    		[
    			64201,
    			64201
    		],
    		"mapped",
    		[
    			38875
    		]
    	],
    	[
    		[
    			64202,
    			64202
    		],
    		"mapped",
    		[
    			38911
    		]
    	],
    	[
    		[
    			64203,
    			64203
    		],
    		"mapped",
    		[
    			38923
    		]
    	],
    	[
    		[
    			64204,
    			64204
    		],
    		"mapped",
    		[
    			38971
    		]
    	],
    	[
    		[
    			64205,
    			64205
    		],
    		"mapped",
    		[
    			39698
    		]
    	],
    	[
    		[
    			64206,
    			64206
    		],
    		"mapped",
    		[
    			40860
    		]
    	],
    	[
    		[
    			64207,
    			64207
    		],
    		"mapped",
    		[
    			141386
    		]
    	],
    	[
    		[
    			64208,
    			64208
    		],
    		"mapped",
    		[
    			141380
    		]
    	],
    	[
    		[
    			64209,
    			64209
    		],
    		"mapped",
    		[
    			144341
    		]
    	],
    	[
    		[
    			64210,
    			64210
    		],
    		"mapped",
    		[
    			15261
    		]
    	],
    	[
    		[
    			64211,
    			64211
    		],
    		"mapped",
    		[
    			16408
    		]
    	],
    	[
    		[
    			64212,
    			64212
    		],
    		"mapped",
    		[
    			16441
    		]
    	],
    	[
    		[
    			64213,
    			64213
    		],
    		"mapped",
    		[
    			152137
    		]
    	],
    	[
    		[
    			64214,
    			64214
    		],
    		"mapped",
    		[
    			154832
    		]
    	],
    	[
    		[
    			64215,
    			64215
    		],
    		"mapped",
    		[
    			163539
    		]
    	],
    	[
    		[
    			64216,
    			64216
    		],
    		"mapped",
    		[
    			40771
    		]
    	],
    	[
    		[
    			64217,
    			64217
    		],
    		"mapped",
    		[
    			40846
    		]
    	],
    	[
    		[
    			64218,
    			64255
    		],
    		"disallowed"
    	],
    	[
    		[
    			64256,
    			64256
    		],
    		"mapped",
    		[
    			102,
    			102
    		]
    	],
    	[
    		[
    			64257,
    			64257
    		],
    		"mapped",
    		[
    			102,
    			105
    		]
    	],
    	[
    		[
    			64258,
    			64258
    		],
    		"mapped",
    		[
    			102,
    			108
    		]
    	],
    	[
    		[
    			64259,
    			64259
    		],
    		"mapped",
    		[
    			102,
    			102,
    			105
    		]
    	],
    	[
    		[
    			64260,
    			64260
    		],
    		"mapped",
    		[
    			102,
    			102,
    			108
    		]
    	],
    	[
    		[
    			64261,
    			64262
    		],
    		"mapped",
    		[
    			115,
    			116
    		]
    	],
    	[
    		[
    			64263,
    			64274
    		],
    		"disallowed"
    	],
    	[
    		[
    			64275,
    			64275
    		],
    		"mapped",
    		[
    			1396,
    			1398
    		]
    	],
    	[
    		[
    			64276,
    			64276
    		],
    		"mapped",
    		[
    			1396,
    			1381
    		]
    	],
    	[
    		[
    			64277,
    			64277
    		],
    		"mapped",
    		[
    			1396,
    			1387
    		]
    	],
    	[
    		[
    			64278,
    			64278
    		],
    		"mapped",
    		[
    			1406,
    			1398
    		]
    	],
    	[
    		[
    			64279,
    			64279
    		],
    		"mapped",
    		[
    			1396,
    			1389
    		]
    	],
    	[
    		[
    			64280,
    			64284
    		],
    		"disallowed"
    	],
    	[
    		[
    			64285,
    			64285
    		],
    		"mapped",
    		[
    			1497,
    			1460
    		]
    	],
    	[
    		[
    			64286,
    			64286
    		],
    		"valid"
    	],
    	[
    		[
    			64287,
    			64287
    		],
    		"mapped",
    		[
    			1522,
    			1463
    		]
    	],
    	[
    		[
    			64288,
    			64288
    		],
    		"mapped",
    		[
    			1506
    		]
    	],
    	[
    		[
    			64289,
    			64289
    		],
    		"mapped",
    		[
    			1488
    		]
    	],
    	[
    		[
    			64290,
    			64290
    		],
    		"mapped",
    		[
    			1491
    		]
    	],
    	[
    		[
    			64291,
    			64291
    		],
    		"mapped",
    		[
    			1492
    		]
    	],
    	[
    		[
    			64292,
    			64292
    		],
    		"mapped",
    		[
    			1499
    		]
    	],
    	[
    		[
    			64293,
    			64293
    		],
    		"mapped",
    		[
    			1500
    		]
    	],
    	[
    		[
    			64294,
    			64294
    		],
    		"mapped",
    		[
    			1501
    		]
    	],
    	[
    		[
    			64295,
    			64295
    		],
    		"mapped",
    		[
    			1512
    		]
    	],
    	[
    		[
    			64296,
    			64296
    		],
    		"mapped",
    		[
    			1514
    		]
    	],
    	[
    		[
    			64297,
    			64297
    		],
    		"disallowed_STD3_mapped",
    		[
    			43
    		]
    	],
    	[
    		[
    			64298,
    			64298
    		],
    		"mapped",
    		[
    			1513,
    			1473
    		]
    	],
    	[
    		[
    			64299,
    			64299
    		],
    		"mapped",
    		[
    			1513,
    			1474
    		]
    	],
    	[
    		[
    			64300,
    			64300
    		],
    		"mapped",
    		[
    			1513,
    			1468,
    			1473
    		]
    	],
    	[
    		[
    			64301,
    			64301
    		],
    		"mapped",
    		[
    			1513,
    			1468,
    			1474
    		]
    	],
    	[
    		[
    			64302,
    			64302
    		],
    		"mapped",
    		[
    			1488,
    			1463
    		]
    	],
    	[
    		[
    			64303,
    			64303
    		],
    		"mapped",
    		[
    			1488,
    			1464
    		]
    	],
    	[
    		[
    			64304,
    			64304
    		],
    		"mapped",
    		[
    			1488,
    			1468
    		]
    	],
    	[
    		[
    			64305,
    			64305
    		],
    		"mapped",
    		[
    			1489,
    			1468
    		]
    	],
    	[
    		[
    			64306,
    			64306
    		],
    		"mapped",
    		[
    			1490,
    			1468
    		]
    	],
    	[
    		[
    			64307,
    			64307
    		],
    		"mapped",
    		[
    			1491,
    			1468
    		]
    	],
    	[
    		[
    			64308,
    			64308
    		],
    		"mapped",
    		[
    			1492,
    			1468
    		]
    	],
    	[
    		[
    			64309,
    			64309
    		],
    		"mapped",
    		[
    			1493,
    			1468
    		]
    	],
    	[
    		[
    			64310,
    			64310
    		],
    		"mapped",
    		[
    			1494,
    			1468
    		]
    	],
    	[
    		[
    			64311,
    			64311
    		],
    		"disallowed"
    	],
    	[
    		[
    			64312,
    			64312
    		],
    		"mapped",
    		[
    			1496,
    			1468
    		]
    	],
    	[
    		[
    			64313,
    			64313
    		],
    		"mapped",
    		[
    			1497,
    			1468
    		]
    	],
    	[
    		[
    			64314,
    			64314
    		],
    		"mapped",
    		[
    			1498,
    			1468
    		]
    	],
    	[
    		[
    			64315,
    			64315
    		],
    		"mapped",
    		[
    			1499,
    			1468
    		]
    	],
    	[
    		[
    			64316,
    			64316
    		],
    		"mapped",
    		[
    			1500,
    			1468
    		]
    	],
    	[
    		[
    			64317,
    			64317
    		],
    		"disallowed"
    	],
    	[
    		[
    			64318,
    			64318
    		],
    		"mapped",
    		[
    			1502,
    			1468
    		]
    	],
    	[
    		[
    			64319,
    			64319
    		],
    		"disallowed"
    	],
    	[
    		[
    			64320,
    			64320
    		],
    		"mapped",
    		[
    			1504,
    			1468
    		]
    	],
    	[
    		[
    			64321,
    			64321
    		],
    		"mapped",
    		[
    			1505,
    			1468
    		]
    	],
    	[
    		[
    			64322,
    			64322
    		],
    		"disallowed"
    	],
    	[
    		[
    			64323,
    			64323
    		],
    		"mapped",
    		[
    			1507,
    			1468
    		]
    	],
    	[
    		[
    			64324,
    			64324
    		],
    		"mapped",
    		[
    			1508,
    			1468
    		]
    	],
    	[
    		[
    			64325,
    			64325
    		],
    		"disallowed"
    	],
    	[
    		[
    			64326,
    			64326
    		],
    		"mapped",
    		[
    			1510,
    			1468
    		]
    	],
    	[
    		[
    			64327,
    			64327
    		],
    		"mapped",
    		[
    			1511,
    			1468
    		]
    	],
    	[
    		[
    			64328,
    			64328
    		],
    		"mapped",
    		[
    			1512,
    			1468
    		]
    	],
    	[
    		[
    			64329,
    			64329
    		],
    		"mapped",
    		[
    			1513,
    			1468
    		]
    	],
    	[
    		[
    			64330,
    			64330
    		],
    		"mapped",
    		[
    			1514,
    			1468
    		]
    	],
    	[
    		[
    			64331,
    			64331
    		],
    		"mapped",
    		[
    			1493,
    			1465
    		]
    	],
    	[
    		[
    			64332,
    			64332
    		],
    		"mapped",
    		[
    			1489,
    			1471
    		]
    	],
    	[
    		[
    			64333,
    			64333
    		],
    		"mapped",
    		[
    			1499,
    			1471
    		]
    	],
    	[
    		[
    			64334,
    			64334
    		],
    		"mapped",
    		[
    			1508,
    			1471
    		]
    	],
    	[
    		[
    			64335,
    			64335
    		],
    		"mapped",
    		[
    			1488,
    			1500
    		]
    	],
    	[
    		[
    			64336,
    			64337
    		],
    		"mapped",
    		[
    			1649
    		]
    	],
    	[
    		[
    			64338,
    			64341
    		],
    		"mapped",
    		[
    			1659
    		]
    	],
    	[
    		[
    			64342,
    			64345
    		],
    		"mapped",
    		[
    			1662
    		]
    	],
    	[
    		[
    			64346,
    			64349
    		],
    		"mapped",
    		[
    			1664
    		]
    	],
    	[
    		[
    			64350,
    			64353
    		],
    		"mapped",
    		[
    			1658
    		]
    	],
    	[
    		[
    			64354,
    			64357
    		],
    		"mapped",
    		[
    			1663
    		]
    	],
    	[
    		[
    			64358,
    			64361
    		],
    		"mapped",
    		[
    			1657
    		]
    	],
    	[
    		[
    			64362,
    			64365
    		],
    		"mapped",
    		[
    			1700
    		]
    	],
    	[
    		[
    			64366,
    			64369
    		],
    		"mapped",
    		[
    			1702
    		]
    	],
    	[
    		[
    			64370,
    			64373
    		],
    		"mapped",
    		[
    			1668
    		]
    	],
    	[
    		[
    			64374,
    			64377
    		],
    		"mapped",
    		[
    			1667
    		]
    	],
    	[
    		[
    			64378,
    			64381
    		],
    		"mapped",
    		[
    			1670
    		]
    	],
    	[
    		[
    			64382,
    			64385
    		],
    		"mapped",
    		[
    			1671
    		]
    	],
    	[
    		[
    			64386,
    			64387
    		],
    		"mapped",
    		[
    			1677
    		]
    	],
    	[
    		[
    			64388,
    			64389
    		],
    		"mapped",
    		[
    			1676
    		]
    	],
    	[
    		[
    			64390,
    			64391
    		],
    		"mapped",
    		[
    			1678
    		]
    	],
    	[
    		[
    			64392,
    			64393
    		],
    		"mapped",
    		[
    			1672
    		]
    	],
    	[
    		[
    			64394,
    			64395
    		],
    		"mapped",
    		[
    			1688
    		]
    	],
    	[
    		[
    			64396,
    			64397
    		],
    		"mapped",
    		[
    			1681
    		]
    	],
    	[
    		[
    			64398,
    			64401
    		],
    		"mapped",
    		[
    			1705
    		]
    	],
    	[
    		[
    			64402,
    			64405
    		],
    		"mapped",
    		[
    			1711
    		]
    	],
    	[
    		[
    			64406,
    			64409
    		],
    		"mapped",
    		[
    			1715
    		]
    	],
    	[
    		[
    			64410,
    			64413
    		],
    		"mapped",
    		[
    			1713
    		]
    	],
    	[
    		[
    			64414,
    			64415
    		],
    		"mapped",
    		[
    			1722
    		]
    	],
    	[
    		[
    			64416,
    			64419
    		],
    		"mapped",
    		[
    			1723
    		]
    	],
    	[
    		[
    			64420,
    			64421
    		],
    		"mapped",
    		[
    			1728
    		]
    	],
    	[
    		[
    			64422,
    			64425
    		],
    		"mapped",
    		[
    			1729
    		]
    	],
    	[
    		[
    			64426,
    			64429
    		],
    		"mapped",
    		[
    			1726
    		]
    	],
    	[
    		[
    			64430,
    			64431
    		],
    		"mapped",
    		[
    			1746
    		]
    	],
    	[
    		[
    			64432,
    			64433
    		],
    		"mapped",
    		[
    			1747
    		]
    	],
    	[
    		[
    			64434,
    			64449
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			64450,
    			64466
    		],
    		"disallowed"
    	],
    	[
    		[
    			64467,
    			64470
    		],
    		"mapped",
    		[
    			1709
    		]
    	],
    	[
    		[
    			64471,
    			64472
    		],
    		"mapped",
    		[
    			1735
    		]
    	],
    	[
    		[
    			64473,
    			64474
    		],
    		"mapped",
    		[
    			1734
    		]
    	],
    	[
    		[
    			64475,
    			64476
    		],
    		"mapped",
    		[
    			1736
    		]
    	],
    	[
    		[
    			64477,
    			64477
    		],
    		"mapped",
    		[
    			1735,
    			1652
    		]
    	],
    	[
    		[
    			64478,
    			64479
    		],
    		"mapped",
    		[
    			1739
    		]
    	],
    	[
    		[
    			64480,
    			64481
    		],
    		"mapped",
    		[
    			1733
    		]
    	],
    	[
    		[
    			64482,
    			64483
    		],
    		"mapped",
    		[
    			1737
    		]
    	],
    	[
    		[
    			64484,
    			64487
    		],
    		"mapped",
    		[
    			1744
    		]
    	],
    	[
    		[
    			64488,
    			64489
    		],
    		"mapped",
    		[
    			1609
    		]
    	],
    	[
    		[
    			64490,
    			64491
    		],
    		"mapped",
    		[
    			1574,
    			1575
    		]
    	],
    	[
    		[
    			64492,
    			64493
    		],
    		"mapped",
    		[
    			1574,
    			1749
    		]
    	],
    	[
    		[
    			64494,
    			64495
    		],
    		"mapped",
    		[
    			1574,
    			1608
    		]
    	],
    	[
    		[
    			64496,
    			64497
    		],
    		"mapped",
    		[
    			1574,
    			1735
    		]
    	],
    	[
    		[
    			64498,
    			64499
    		],
    		"mapped",
    		[
    			1574,
    			1734
    		]
    	],
    	[
    		[
    			64500,
    			64501
    		],
    		"mapped",
    		[
    			1574,
    			1736
    		]
    	],
    	[
    		[
    			64502,
    			64504
    		],
    		"mapped",
    		[
    			1574,
    			1744
    		]
    	],
    	[
    		[
    			64505,
    			64507
    		],
    		"mapped",
    		[
    			1574,
    			1609
    		]
    	],
    	[
    		[
    			64508,
    			64511
    		],
    		"mapped",
    		[
    			1740
    		]
    	],
    	[
    		[
    			64512,
    			64512
    		],
    		"mapped",
    		[
    			1574,
    			1580
    		]
    	],
    	[
    		[
    			64513,
    			64513
    		],
    		"mapped",
    		[
    			1574,
    			1581
    		]
    	],
    	[
    		[
    			64514,
    			64514
    		],
    		"mapped",
    		[
    			1574,
    			1605
    		]
    	],
    	[
    		[
    			64515,
    			64515
    		],
    		"mapped",
    		[
    			1574,
    			1609
    		]
    	],
    	[
    		[
    			64516,
    			64516
    		],
    		"mapped",
    		[
    			1574,
    			1610
    		]
    	],
    	[
    		[
    			64517,
    			64517
    		],
    		"mapped",
    		[
    			1576,
    			1580
    		]
    	],
    	[
    		[
    			64518,
    			64518
    		],
    		"mapped",
    		[
    			1576,
    			1581
    		]
    	],
    	[
    		[
    			64519,
    			64519
    		],
    		"mapped",
    		[
    			1576,
    			1582
    		]
    	],
    	[
    		[
    			64520,
    			64520
    		],
    		"mapped",
    		[
    			1576,
    			1605
    		]
    	],
    	[
    		[
    			64521,
    			64521
    		],
    		"mapped",
    		[
    			1576,
    			1609
    		]
    	],
    	[
    		[
    			64522,
    			64522
    		],
    		"mapped",
    		[
    			1576,
    			1610
    		]
    	],
    	[
    		[
    			64523,
    			64523
    		],
    		"mapped",
    		[
    			1578,
    			1580
    		]
    	],
    	[
    		[
    			64524,
    			64524
    		],
    		"mapped",
    		[
    			1578,
    			1581
    		]
    	],
    	[
    		[
    			64525,
    			64525
    		],
    		"mapped",
    		[
    			1578,
    			1582
    		]
    	],
    	[
    		[
    			64526,
    			64526
    		],
    		"mapped",
    		[
    			1578,
    			1605
    		]
    	],
    	[
    		[
    			64527,
    			64527
    		],
    		"mapped",
    		[
    			1578,
    			1609
    		]
    	],
    	[
    		[
    			64528,
    			64528
    		],
    		"mapped",
    		[
    			1578,
    			1610
    		]
    	],
    	[
    		[
    			64529,
    			64529
    		],
    		"mapped",
    		[
    			1579,
    			1580
    		]
    	],
    	[
    		[
    			64530,
    			64530
    		],
    		"mapped",
    		[
    			1579,
    			1605
    		]
    	],
    	[
    		[
    			64531,
    			64531
    		],
    		"mapped",
    		[
    			1579,
    			1609
    		]
    	],
    	[
    		[
    			64532,
    			64532
    		],
    		"mapped",
    		[
    			1579,
    			1610
    		]
    	],
    	[
    		[
    			64533,
    			64533
    		],
    		"mapped",
    		[
    			1580,
    			1581
    		]
    	],
    	[
    		[
    			64534,
    			64534
    		],
    		"mapped",
    		[
    			1580,
    			1605
    		]
    	],
    	[
    		[
    			64535,
    			64535
    		],
    		"mapped",
    		[
    			1581,
    			1580
    		]
    	],
    	[
    		[
    			64536,
    			64536
    		],
    		"mapped",
    		[
    			1581,
    			1605
    		]
    	],
    	[
    		[
    			64537,
    			64537
    		],
    		"mapped",
    		[
    			1582,
    			1580
    		]
    	],
    	[
    		[
    			64538,
    			64538
    		],
    		"mapped",
    		[
    			1582,
    			1581
    		]
    	],
    	[
    		[
    			64539,
    			64539
    		],
    		"mapped",
    		[
    			1582,
    			1605
    		]
    	],
    	[
    		[
    			64540,
    			64540
    		],
    		"mapped",
    		[
    			1587,
    			1580
    		]
    	],
    	[
    		[
    			64541,
    			64541
    		],
    		"mapped",
    		[
    			1587,
    			1581
    		]
    	],
    	[
    		[
    			64542,
    			64542
    		],
    		"mapped",
    		[
    			1587,
    			1582
    		]
    	],
    	[
    		[
    			64543,
    			64543
    		],
    		"mapped",
    		[
    			1587,
    			1605
    		]
    	],
    	[
    		[
    			64544,
    			64544
    		],
    		"mapped",
    		[
    			1589,
    			1581
    		]
    	],
    	[
    		[
    			64545,
    			64545
    		],
    		"mapped",
    		[
    			1589,
    			1605
    		]
    	],
    	[
    		[
    			64546,
    			64546
    		],
    		"mapped",
    		[
    			1590,
    			1580
    		]
    	],
    	[
    		[
    			64547,
    			64547
    		],
    		"mapped",
    		[
    			1590,
    			1581
    		]
    	],
    	[
    		[
    			64548,
    			64548
    		],
    		"mapped",
    		[
    			1590,
    			1582
    		]
    	],
    	[
    		[
    			64549,
    			64549
    		],
    		"mapped",
    		[
    			1590,
    			1605
    		]
    	],
    	[
    		[
    			64550,
    			64550
    		],
    		"mapped",
    		[
    			1591,
    			1581
    		]
    	],
    	[
    		[
    			64551,
    			64551
    		],
    		"mapped",
    		[
    			1591,
    			1605
    		]
    	],
    	[
    		[
    			64552,
    			64552
    		],
    		"mapped",
    		[
    			1592,
    			1605
    		]
    	],
    	[
    		[
    			64553,
    			64553
    		],
    		"mapped",
    		[
    			1593,
    			1580
    		]
    	],
    	[
    		[
    			64554,
    			64554
    		],
    		"mapped",
    		[
    			1593,
    			1605
    		]
    	],
    	[
    		[
    			64555,
    			64555
    		],
    		"mapped",
    		[
    			1594,
    			1580
    		]
    	],
    	[
    		[
    			64556,
    			64556
    		],
    		"mapped",
    		[
    			1594,
    			1605
    		]
    	],
    	[
    		[
    			64557,
    			64557
    		],
    		"mapped",
    		[
    			1601,
    			1580
    		]
    	],
    	[
    		[
    			64558,
    			64558
    		],
    		"mapped",
    		[
    			1601,
    			1581
    		]
    	],
    	[
    		[
    			64559,
    			64559
    		],
    		"mapped",
    		[
    			1601,
    			1582
    		]
    	],
    	[
    		[
    			64560,
    			64560
    		],
    		"mapped",
    		[
    			1601,
    			1605
    		]
    	],
    	[
    		[
    			64561,
    			64561
    		],
    		"mapped",
    		[
    			1601,
    			1609
    		]
    	],
    	[
    		[
    			64562,
    			64562
    		],
    		"mapped",
    		[
    			1601,
    			1610
    		]
    	],
    	[
    		[
    			64563,
    			64563
    		],
    		"mapped",
    		[
    			1602,
    			1581
    		]
    	],
    	[
    		[
    			64564,
    			64564
    		],
    		"mapped",
    		[
    			1602,
    			1605
    		]
    	],
    	[
    		[
    			64565,
    			64565
    		],
    		"mapped",
    		[
    			1602,
    			1609
    		]
    	],
    	[
    		[
    			64566,
    			64566
    		],
    		"mapped",
    		[
    			1602,
    			1610
    		]
    	],
    	[
    		[
    			64567,
    			64567
    		],
    		"mapped",
    		[
    			1603,
    			1575
    		]
    	],
    	[
    		[
    			64568,
    			64568
    		],
    		"mapped",
    		[
    			1603,
    			1580
    		]
    	],
    	[
    		[
    			64569,
    			64569
    		],
    		"mapped",
    		[
    			1603,
    			1581
    		]
    	],
    	[
    		[
    			64570,
    			64570
    		],
    		"mapped",
    		[
    			1603,
    			1582
    		]
    	],
    	[
    		[
    			64571,
    			64571
    		],
    		"mapped",
    		[
    			1603,
    			1604
    		]
    	],
    	[
    		[
    			64572,
    			64572
    		],
    		"mapped",
    		[
    			1603,
    			1605
    		]
    	],
    	[
    		[
    			64573,
    			64573
    		],
    		"mapped",
    		[
    			1603,
    			1609
    		]
    	],
    	[
    		[
    			64574,
    			64574
    		],
    		"mapped",
    		[
    			1603,
    			1610
    		]
    	],
    	[
    		[
    			64575,
    			64575
    		],
    		"mapped",
    		[
    			1604,
    			1580
    		]
    	],
    	[
    		[
    			64576,
    			64576
    		],
    		"mapped",
    		[
    			1604,
    			1581
    		]
    	],
    	[
    		[
    			64577,
    			64577
    		],
    		"mapped",
    		[
    			1604,
    			1582
    		]
    	],
    	[
    		[
    			64578,
    			64578
    		],
    		"mapped",
    		[
    			1604,
    			1605
    		]
    	],
    	[
    		[
    			64579,
    			64579
    		],
    		"mapped",
    		[
    			1604,
    			1609
    		]
    	],
    	[
    		[
    			64580,
    			64580
    		],
    		"mapped",
    		[
    			1604,
    			1610
    		]
    	],
    	[
    		[
    			64581,
    			64581
    		],
    		"mapped",
    		[
    			1605,
    			1580
    		]
    	],
    	[
    		[
    			64582,
    			64582
    		],
    		"mapped",
    		[
    			1605,
    			1581
    		]
    	],
    	[
    		[
    			64583,
    			64583
    		],
    		"mapped",
    		[
    			1605,
    			1582
    		]
    	],
    	[
    		[
    			64584,
    			64584
    		],
    		"mapped",
    		[
    			1605,
    			1605
    		]
    	],
    	[
    		[
    			64585,
    			64585
    		],
    		"mapped",
    		[
    			1605,
    			1609
    		]
    	],
    	[
    		[
    			64586,
    			64586
    		],
    		"mapped",
    		[
    			1605,
    			1610
    		]
    	],
    	[
    		[
    			64587,
    			64587
    		],
    		"mapped",
    		[
    			1606,
    			1580
    		]
    	],
    	[
    		[
    			64588,
    			64588
    		],
    		"mapped",
    		[
    			1606,
    			1581
    		]
    	],
    	[
    		[
    			64589,
    			64589
    		],
    		"mapped",
    		[
    			1606,
    			1582
    		]
    	],
    	[
    		[
    			64590,
    			64590
    		],
    		"mapped",
    		[
    			1606,
    			1605
    		]
    	],
    	[
    		[
    			64591,
    			64591
    		],
    		"mapped",
    		[
    			1606,
    			1609
    		]
    	],
    	[
    		[
    			64592,
    			64592
    		],
    		"mapped",
    		[
    			1606,
    			1610
    		]
    	],
    	[
    		[
    			64593,
    			64593
    		],
    		"mapped",
    		[
    			1607,
    			1580
    		]
    	],
    	[
    		[
    			64594,
    			64594
    		],
    		"mapped",
    		[
    			1607,
    			1605
    		]
    	],
    	[
    		[
    			64595,
    			64595
    		],
    		"mapped",
    		[
    			1607,
    			1609
    		]
    	],
    	[
    		[
    			64596,
    			64596
    		],
    		"mapped",
    		[
    			1607,
    			1610
    		]
    	],
    	[
    		[
    			64597,
    			64597
    		],
    		"mapped",
    		[
    			1610,
    			1580
    		]
    	],
    	[
    		[
    			64598,
    			64598
    		],
    		"mapped",
    		[
    			1610,
    			1581
    		]
    	],
    	[
    		[
    			64599,
    			64599
    		],
    		"mapped",
    		[
    			1610,
    			1582
    		]
    	],
    	[
    		[
    			64600,
    			64600
    		],
    		"mapped",
    		[
    			1610,
    			1605
    		]
    	],
    	[
    		[
    			64601,
    			64601
    		],
    		"mapped",
    		[
    			1610,
    			1609
    		]
    	],
    	[
    		[
    			64602,
    			64602
    		],
    		"mapped",
    		[
    			1610,
    			1610
    		]
    	],
    	[
    		[
    			64603,
    			64603
    		],
    		"mapped",
    		[
    			1584,
    			1648
    		]
    	],
    	[
    		[
    			64604,
    			64604
    		],
    		"mapped",
    		[
    			1585,
    			1648
    		]
    	],
    	[
    		[
    			64605,
    			64605
    		],
    		"mapped",
    		[
    			1609,
    			1648
    		]
    	],
    	[
    		[
    			64606,
    			64606
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			1612,
    			1617
    		]
    	],
    	[
    		[
    			64607,
    			64607
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			1613,
    			1617
    		]
    	],
    	[
    		[
    			64608,
    			64608
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			1614,
    			1617
    		]
    	],
    	[
    		[
    			64609,
    			64609
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			1615,
    			1617
    		]
    	],
    	[
    		[
    			64610,
    			64610
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			1616,
    			1617
    		]
    	],
    	[
    		[
    			64611,
    			64611
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			1617,
    			1648
    		]
    	],
    	[
    		[
    			64612,
    			64612
    		],
    		"mapped",
    		[
    			1574,
    			1585
    		]
    	],
    	[
    		[
    			64613,
    			64613
    		],
    		"mapped",
    		[
    			1574,
    			1586
    		]
    	],
    	[
    		[
    			64614,
    			64614
    		],
    		"mapped",
    		[
    			1574,
    			1605
    		]
    	],
    	[
    		[
    			64615,
    			64615
    		],
    		"mapped",
    		[
    			1574,
    			1606
    		]
    	],
    	[
    		[
    			64616,
    			64616
    		],
    		"mapped",
    		[
    			1574,
    			1609
    		]
    	],
    	[
    		[
    			64617,
    			64617
    		],
    		"mapped",
    		[
    			1574,
    			1610
    		]
    	],
    	[
    		[
    			64618,
    			64618
    		],
    		"mapped",
    		[
    			1576,
    			1585
    		]
    	],
    	[
    		[
    			64619,
    			64619
    		],
    		"mapped",
    		[
    			1576,
    			1586
    		]
    	],
    	[
    		[
    			64620,
    			64620
    		],
    		"mapped",
    		[
    			1576,
    			1605
    		]
    	],
    	[
    		[
    			64621,
    			64621
    		],
    		"mapped",
    		[
    			1576,
    			1606
    		]
    	],
    	[
    		[
    			64622,
    			64622
    		],
    		"mapped",
    		[
    			1576,
    			1609
    		]
    	],
    	[
    		[
    			64623,
    			64623
    		],
    		"mapped",
    		[
    			1576,
    			1610
    		]
    	],
    	[
    		[
    			64624,
    			64624
    		],
    		"mapped",
    		[
    			1578,
    			1585
    		]
    	],
    	[
    		[
    			64625,
    			64625
    		],
    		"mapped",
    		[
    			1578,
    			1586
    		]
    	],
    	[
    		[
    			64626,
    			64626
    		],
    		"mapped",
    		[
    			1578,
    			1605
    		]
    	],
    	[
    		[
    			64627,
    			64627
    		],
    		"mapped",
    		[
    			1578,
    			1606
    		]
    	],
    	[
    		[
    			64628,
    			64628
    		],
    		"mapped",
    		[
    			1578,
    			1609
    		]
    	],
    	[
    		[
    			64629,
    			64629
    		],
    		"mapped",
    		[
    			1578,
    			1610
    		]
    	],
    	[
    		[
    			64630,
    			64630
    		],
    		"mapped",
    		[
    			1579,
    			1585
    		]
    	],
    	[
    		[
    			64631,
    			64631
    		],
    		"mapped",
    		[
    			1579,
    			1586
    		]
    	],
    	[
    		[
    			64632,
    			64632
    		],
    		"mapped",
    		[
    			1579,
    			1605
    		]
    	],
    	[
    		[
    			64633,
    			64633
    		],
    		"mapped",
    		[
    			1579,
    			1606
    		]
    	],
    	[
    		[
    			64634,
    			64634
    		],
    		"mapped",
    		[
    			1579,
    			1609
    		]
    	],
    	[
    		[
    			64635,
    			64635
    		],
    		"mapped",
    		[
    			1579,
    			1610
    		]
    	],
    	[
    		[
    			64636,
    			64636
    		],
    		"mapped",
    		[
    			1601,
    			1609
    		]
    	],
    	[
    		[
    			64637,
    			64637
    		],
    		"mapped",
    		[
    			1601,
    			1610
    		]
    	],
    	[
    		[
    			64638,
    			64638
    		],
    		"mapped",
    		[
    			1602,
    			1609
    		]
    	],
    	[
    		[
    			64639,
    			64639
    		],
    		"mapped",
    		[
    			1602,
    			1610
    		]
    	],
    	[
    		[
    			64640,
    			64640
    		],
    		"mapped",
    		[
    			1603,
    			1575
    		]
    	],
    	[
    		[
    			64641,
    			64641
    		],
    		"mapped",
    		[
    			1603,
    			1604
    		]
    	],
    	[
    		[
    			64642,
    			64642
    		],
    		"mapped",
    		[
    			1603,
    			1605
    		]
    	],
    	[
    		[
    			64643,
    			64643
    		],
    		"mapped",
    		[
    			1603,
    			1609
    		]
    	],
    	[
    		[
    			64644,
    			64644
    		],
    		"mapped",
    		[
    			1603,
    			1610
    		]
    	],
    	[
    		[
    			64645,
    			64645
    		],
    		"mapped",
    		[
    			1604,
    			1605
    		]
    	],
    	[
    		[
    			64646,
    			64646
    		],
    		"mapped",
    		[
    			1604,
    			1609
    		]
    	],
    	[
    		[
    			64647,
    			64647
    		],
    		"mapped",
    		[
    			1604,
    			1610
    		]
    	],
    	[
    		[
    			64648,
    			64648
    		],
    		"mapped",
    		[
    			1605,
    			1575
    		]
    	],
    	[
    		[
    			64649,
    			64649
    		],
    		"mapped",
    		[
    			1605,
    			1605
    		]
    	],
    	[
    		[
    			64650,
    			64650
    		],
    		"mapped",
    		[
    			1606,
    			1585
    		]
    	],
    	[
    		[
    			64651,
    			64651
    		],
    		"mapped",
    		[
    			1606,
    			1586
    		]
    	],
    	[
    		[
    			64652,
    			64652
    		],
    		"mapped",
    		[
    			1606,
    			1605
    		]
    	],
    	[
    		[
    			64653,
    			64653
    		],
    		"mapped",
    		[
    			1606,
    			1606
    		]
    	],
    	[
    		[
    			64654,
    			64654
    		],
    		"mapped",
    		[
    			1606,
    			1609
    		]
    	],
    	[
    		[
    			64655,
    			64655
    		],
    		"mapped",
    		[
    			1606,
    			1610
    		]
    	],
    	[
    		[
    			64656,
    			64656
    		],
    		"mapped",
    		[
    			1609,
    			1648
    		]
    	],
    	[
    		[
    			64657,
    			64657
    		],
    		"mapped",
    		[
    			1610,
    			1585
    		]
    	],
    	[
    		[
    			64658,
    			64658
    		],
    		"mapped",
    		[
    			1610,
    			1586
    		]
    	],
    	[
    		[
    			64659,
    			64659
    		],
    		"mapped",
    		[
    			1610,
    			1605
    		]
    	],
    	[
    		[
    			64660,
    			64660
    		],
    		"mapped",
    		[
    			1610,
    			1606
    		]
    	],
    	[
    		[
    			64661,
    			64661
    		],
    		"mapped",
    		[
    			1610,
    			1609
    		]
    	],
    	[
    		[
    			64662,
    			64662
    		],
    		"mapped",
    		[
    			1610,
    			1610
    		]
    	],
    	[
    		[
    			64663,
    			64663
    		],
    		"mapped",
    		[
    			1574,
    			1580
    		]
    	],
    	[
    		[
    			64664,
    			64664
    		],
    		"mapped",
    		[
    			1574,
    			1581
    		]
    	],
    	[
    		[
    			64665,
    			64665
    		],
    		"mapped",
    		[
    			1574,
    			1582
    		]
    	],
    	[
    		[
    			64666,
    			64666
    		],
    		"mapped",
    		[
    			1574,
    			1605
    		]
    	],
    	[
    		[
    			64667,
    			64667
    		],
    		"mapped",
    		[
    			1574,
    			1607
    		]
    	],
    	[
    		[
    			64668,
    			64668
    		],
    		"mapped",
    		[
    			1576,
    			1580
    		]
    	],
    	[
    		[
    			64669,
    			64669
    		],
    		"mapped",
    		[
    			1576,
    			1581
    		]
    	],
    	[
    		[
    			64670,
    			64670
    		],
    		"mapped",
    		[
    			1576,
    			1582
    		]
    	],
    	[
    		[
    			64671,
    			64671
    		],
    		"mapped",
    		[
    			1576,
    			1605
    		]
    	],
    	[
    		[
    			64672,
    			64672
    		],
    		"mapped",
    		[
    			1576,
    			1607
    		]
    	],
    	[
    		[
    			64673,
    			64673
    		],
    		"mapped",
    		[
    			1578,
    			1580
    		]
    	],
    	[
    		[
    			64674,
    			64674
    		],
    		"mapped",
    		[
    			1578,
    			1581
    		]
    	],
    	[
    		[
    			64675,
    			64675
    		],
    		"mapped",
    		[
    			1578,
    			1582
    		]
    	],
    	[
    		[
    			64676,
    			64676
    		],
    		"mapped",
    		[
    			1578,
    			1605
    		]
    	],
    	[
    		[
    			64677,
    			64677
    		],
    		"mapped",
    		[
    			1578,
    			1607
    		]
    	],
    	[
    		[
    			64678,
    			64678
    		],
    		"mapped",
    		[
    			1579,
    			1605
    		]
    	],
    	[
    		[
    			64679,
    			64679
    		],
    		"mapped",
    		[
    			1580,
    			1581
    		]
    	],
    	[
    		[
    			64680,
    			64680
    		],
    		"mapped",
    		[
    			1580,
    			1605
    		]
    	],
    	[
    		[
    			64681,
    			64681
    		],
    		"mapped",
    		[
    			1581,
    			1580
    		]
    	],
    	[
    		[
    			64682,
    			64682
    		],
    		"mapped",
    		[
    			1581,
    			1605
    		]
    	],
    	[
    		[
    			64683,
    			64683
    		],
    		"mapped",
    		[
    			1582,
    			1580
    		]
    	],
    	[
    		[
    			64684,
    			64684
    		],
    		"mapped",
    		[
    			1582,
    			1605
    		]
    	],
    	[
    		[
    			64685,
    			64685
    		],
    		"mapped",
    		[
    			1587,
    			1580
    		]
    	],
    	[
    		[
    			64686,
    			64686
    		],
    		"mapped",
    		[
    			1587,
    			1581
    		]
    	],
    	[
    		[
    			64687,
    			64687
    		],
    		"mapped",
    		[
    			1587,
    			1582
    		]
    	],
    	[
    		[
    			64688,
    			64688
    		],
    		"mapped",
    		[
    			1587,
    			1605
    		]
    	],
    	[
    		[
    			64689,
    			64689
    		],
    		"mapped",
    		[
    			1589,
    			1581
    		]
    	],
    	[
    		[
    			64690,
    			64690
    		],
    		"mapped",
    		[
    			1589,
    			1582
    		]
    	],
    	[
    		[
    			64691,
    			64691
    		],
    		"mapped",
    		[
    			1589,
    			1605
    		]
    	],
    	[
    		[
    			64692,
    			64692
    		],
    		"mapped",
    		[
    			1590,
    			1580
    		]
    	],
    	[
    		[
    			64693,
    			64693
    		],
    		"mapped",
    		[
    			1590,
    			1581
    		]
    	],
    	[
    		[
    			64694,
    			64694
    		],
    		"mapped",
    		[
    			1590,
    			1582
    		]
    	],
    	[
    		[
    			64695,
    			64695
    		],
    		"mapped",
    		[
    			1590,
    			1605
    		]
    	],
    	[
    		[
    			64696,
    			64696
    		],
    		"mapped",
    		[
    			1591,
    			1581
    		]
    	],
    	[
    		[
    			64697,
    			64697
    		],
    		"mapped",
    		[
    			1592,
    			1605
    		]
    	],
    	[
    		[
    			64698,
    			64698
    		],
    		"mapped",
    		[
    			1593,
    			1580
    		]
    	],
    	[
    		[
    			64699,
    			64699
    		],
    		"mapped",
    		[
    			1593,
    			1605
    		]
    	],
    	[
    		[
    			64700,
    			64700
    		],
    		"mapped",
    		[
    			1594,
    			1580
    		]
    	],
    	[
    		[
    			64701,
    			64701
    		],
    		"mapped",
    		[
    			1594,
    			1605
    		]
    	],
    	[
    		[
    			64702,
    			64702
    		],
    		"mapped",
    		[
    			1601,
    			1580
    		]
    	],
    	[
    		[
    			64703,
    			64703
    		],
    		"mapped",
    		[
    			1601,
    			1581
    		]
    	],
    	[
    		[
    			64704,
    			64704
    		],
    		"mapped",
    		[
    			1601,
    			1582
    		]
    	],
    	[
    		[
    			64705,
    			64705
    		],
    		"mapped",
    		[
    			1601,
    			1605
    		]
    	],
    	[
    		[
    			64706,
    			64706
    		],
    		"mapped",
    		[
    			1602,
    			1581
    		]
    	],
    	[
    		[
    			64707,
    			64707
    		],
    		"mapped",
    		[
    			1602,
    			1605
    		]
    	],
    	[
    		[
    			64708,
    			64708
    		],
    		"mapped",
    		[
    			1603,
    			1580
    		]
    	],
    	[
    		[
    			64709,
    			64709
    		],
    		"mapped",
    		[
    			1603,
    			1581
    		]
    	],
    	[
    		[
    			64710,
    			64710
    		],
    		"mapped",
    		[
    			1603,
    			1582
    		]
    	],
    	[
    		[
    			64711,
    			64711
    		],
    		"mapped",
    		[
    			1603,
    			1604
    		]
    	],
    	[
    		[
    			64712,
    			64712
    		],
    		"mapped",
    		[
    			1603,
    			1605
    		]
    	],
    	[
    		[
    			64713,
    			64713
    		],
    		"mapped",
    		[
    			1604,
    			1580
    		]
    	],
    	[
    		[
    			64714,
    			64714
    		],
    		"mapped",
    		[
    			1604,
    			1581
    		]
    	],
    	[
    		[
    			64715,
    			64715
    		],
    		"mapped",
    		[
    			1604,
    			1582
    		]
    	],
    	[
    		[
    			64716,
    			64716
    		],
    		"mapped",
    		[
    			1604,
    			1605
    		]
    	],
    	[
    		[
    			64717,
    			64717
    		],
    		"mapped",
    		[
    			1604,
    			1607
    		]
    	],
    	[
    		[
    			64718,
    			64718
    		],
    		"mapped",
    		[
    			1605,
    			1580
    		]
    	],
    	[
    		[
    			64719,
    			64719
    		],
    		"mapped",
    		[
    			1605,
    			1581
    		]
    	],
    	[
    		[
    			64720,
    			64720
    		],
    		"mapped",
    		[
    			1605,
    			1582
    		]
    	],
    	[
    		[
    			64721,
    			64721
    		],
    		"mapped",
    		[
    			1605,
    			1605
    		]
    	],
    	[
    		[
    			64722,
    			64722
    		],
    		"mapped",
    		[
    			1606,
    			1580
    		]
    	],
    	[
    		[
    			64723,
    			64723
    		],
    		"mapped",
    		[
    			1606,
    			1581
    		]
    	],
    	[
    		[
    			64724,
    			64724
    		],
    		"mapped",
    		[
    			1606,
    			1582
    		]
    	],
    	[
    		[
    			64725,
    			64725
    		],
    		"mapped",
    		[
    			1606,
    			1605
    		]
    	],
    	[
    		[
    			64726,
    			64726
    		],
    		"mapped",
    		[
    			1606,
    			1607
    		]
    	],
    	[
    		[
    			64727,
    			64727
    		],
    		"mapped",
    		[
    			1607,
    			1580
    		]
    	],
    	[
    		[
    			64728,
    			64728
    		],
    		"mapped",
    		[
    			1607,
    			1605
    		]
    	],
    	[
    		[
    			64729,
    			64729
    		],
    		"mapped",
    		[
    			1607,
    			1648
    		]
    	],
    	[
    		[
    			64730,
    			64730
    		],
    		"mapped",
    		[
    			1610,
    			1580
    		]
    	],
    	[
    		[
    			64731,
    			64731
    		],
    		"mapped",
    		[
    			1610,
    			1581
    		]
    	],
    	[
    		[
    			64732,
    			64732
    		],
    		"mapped",
    		[
    			1610,
    			1582
    		]
    	],
    	[
    		[
    			64733,
    			64733
    		],
    		"mapped",
    		[
    			1610,
    			1605
    		]
    	],
    	[
    		[
    			64734,
    			64734
    		],
    		"mapped",
    		[
    			1610,
    			1607
    		]
    	],
    	[
    		[
    			64735,
    			64735
    		],
    		"mapped",
    		[
    			1574,
    			1605
    		]
    	],
    	[
    		[
    			64736,
    			64736
    		],
    		"mapped",
    		[
    			1574,
    			1607
    		]
    	],
    	[
    		[
    			64737,
    			64737
    		],
    		"mapped",
    		[
    			1576,
    			1605
    		]
    	],
    	[
    		[
    			64738,
    			64738
    		],
    		"mapped",
    		[
    			1576,
    			1607
    		]
    	],
    	[
    		[
    			64739,
    			64739
    		],
    		"mapped",
    		[
    			1578,
    			1605
    		]
    	],
    	[
    		[
    			64740,
    			64740
    		],
    		"mapped",
    		[
    			1578,
    			1607
    		]
    	],
    	[
    		[
    			64741,
    			64741
    		],
    		"mapped",
    		[
    			1579,
    			1605
    		]
    	],
    	[
    		[
    			64742,
    			64742
    		],
    		"mapped",
    		[
    			1579,
    			1607
    		]
    	],
    	[
    		[
    			64743,
    			64743
    		],
    		"mapped",
    		[
    			1587,
    			1605
    		]
    	],
    	[
    		[
    			64744,
    			64744
    		],
    		"mapped",
    		[
    			1587,
    			1607
    		]
    	],
    	[
    		[
    			64745,
    			64745
    		],
    		"mapped",
    		[
    			1588,
    			1605
    		]
    	],
    	[
    		[
    			64746,
    			64746
    		],
    		"mapped",
    		[
    			1588,
    			1607
    		]
    	],
    	[
    		[
    			64747,
    			64747
    		],
    		"mapped",
    		[
    			1603,
    			1604
    		]
    	],
    	[
    		[
    			64748,
    			64748
    		],
    		"mapped",
    		[
    			1603,
    			1605
    		]
    	],
    	[
    		[
    			64749,
    			64749
    		],
    		"mapped",
    		[
    			1604,
    			1605
    		]
    	],
    	[
    		[
    			64750,
    			64750
    		],
    		"mapped",
    		[
    			1606,
    			1605
    		]
    	],
    	[
    		[
    			64751,
    			64751
    		],
    		"mapped",
    		[
    			1606,
    			1607
    		]
    	],
    	[
    		[
    			64752,
    			64752
    		],
    		"mapped",
    		[
    			1610,
    			1605
    		]
    	],
    	[
    		[
    			64753,
    			64753
    		],
    		"mapped",
    		[
    			1610,
    			1607
    		]
    	],
    	[
    		[
    			64754,
    			64754
    		],
    		"mapped",
    		[
    			1600,
    			1614,
    			1617
    		]
    	],
    	[
    		[
    			64755,
    			64755
    		],
    		"mapped",
    		[
    			1600,
    			1615,
    			1617
    		]
    	],
    	[
    		[
    			64756,
    			64756
    		],
    		"mapped",
    		[
    			1600,
    			1616,
    			1617
    		]
    	],
    	[
    		[
    			64757,
    			64757
    		],
    		"mapped",
    		[
    			1591,
    			1609
    		]
    	],
    	[
    		[
    			64758,
    			64758
    		],
    		"mapped",
    		[
    			1591,
    			1610
    		]
    	],
    	[
    		[
    			64759,
    			64759
    		],
    		"mapped",
    		[
    			1593,
    			1609
    		]
    	],
    	[
    		[
    			64760,
    			64760
    		],
    		"mapped",
    		[
    			1593,
    			1610
    		]
    	],
    	[
    		[
    			64761,
    			64761
    		],
    		"mapped",
    		[
    			1594,
    			1609
    		]
    	],
    	[
    		[
    			64762,
    			64762
    		],
    		"mapped",
    		[
    			1594,
    			1610
    		]
    	],
    	[
    		[
    			64763,
    			64763
    		],
    		"mapped",
    		[
    			1587,
    			1609
    		]
    	],
    	[
    		[
    			64764,
    			64764
    		],
    		"mapped",
    		[
    			1587,
    			1610
    		]
    	],
    	[
    		[
    			64765,
    			64765
    		],
    		"mapped",
    		[
    			1588,
    			1609
    		]
    	],
    	[
    		[
    			64766,
    			64766
    		],
    		"mapped",
    		[
    			1588,
    			1610
    		]
    	],
    	[
    		[
    			64767,
    			64767
    		],
    		"mapped",
    		[
    			1581,
    			1609
    		]
    	],
    	[
    		[
    			64768,
    			64768
    		],
    		"mapped",
    		[
    			1581,
    			1610
    		]
    	],
    	[
    		[
    			64769,
    			64769
    		],
    		"mapped",
    		[
    			1580,
    			1609
    		]
    	],
    	[
    		[
    			64770,
    			64770
    		],
    		"mapped",
    		[
    			1580,
    			1610
    		]
    	],
    	[
    		[
    			64771,
    			64771
    		],
    		"mapped",
    		[
    			1582,
    			1609
    		]
    	],
    	[
    		[
    			64772,
    			64772
    		],
    		"mapped",
    		[
    			1582,
    			1610
    		]
    	],
    	[
    		[
    			64773,
    			64773
    		],
    		"mapped",
    		[
    			1589,
    			1609
    		]
    	],
    	[
    		[
    			64774,
    			64774
    		],
    		"mapped",
    		[
    			1589,
    			1610
    		]
    	],
    	[
    		[
    			64775,
    			64775
    		],
    		"mapped",
    		[
    			1590,
    			1609
    		]
    	],
    	[
    		[
    			64776,
    			64776
    		],
    		"mapped",
    		[
    			1590,
    			1610
    		]
    	],
    	[
    		[
    			64777,
    			64777
    		],
    		"mapped",
    		[
    			1588,
    			1580
    		]
    	],
    	[
    		[
    			64778,
    			64778
    		],
    		"mapped",
    		[
    			1588,
    			1581
    		]
    	],
    	[
    		[
    			64779,
    			64779
    		],
    		"mapped",
    		[
    			1588,
    			1582
    		]
    	],
    	[
    		[
    			64780,
    			64780
    		],
    		"mapped",
    		[
    			1588,
    			1605
    		]
    	],
    	[
    		[
    			64781,
    			64781
    		],
    		"mapped",
    		[
    			1588,
    			1585
    		]
    	],
    	[
    		[
    			64782,
    			64782
    		],
    		"mapped",
    		[
    			1587,
    			1585
    		]
    	],
    	[
    		[
    			64783,
    			64783
    		],
    		"mapped",
    		[
    			1589,
    			1585
    		]
    	],
    	[
    		[
    			64784,
    			64784
    		],
    		"mapped",
    		[
    			1590,
    			1585
    		]
    	],
    	[
    		[
    			64785,
    			64785
    		],
    		"mapped",
    		[
    			1591,
    			1609
    		]
    	],
    	[
    		[
    			64786,
    			64786
    		],
    		"mapped",
    		[
    			1591,
    			1610
    		]
    	],
    	[
    		[
    			64787,
    			64787
    		],
    		"mapped",
    		[
    			1593,
    			1609
    		]
    	],
    	[
    		[
    			64788,
    			64788
    		],
    		"mapped",
    		[
    			1593,
    			1610
    		]
    	],
    	[
    		[
    			64789,
    			64789
    		],
    		"mapped",
    		[
    			1594,
    			1609
    		]
    	],
    	[
    		[
    			64790,
    			64790
    		],
    		"mapped",
    		[
    			1594,
    			1610
    		]
    	],
    	[
    		[
    			64791,
    			64791
    		],
    		"mapped",
    		[
    			1587,
    			1609
    		]
    	],
    	[
    		[
    			64792,
    			64792
    		],
    		"mapped",
    		[
    			1587,
    			1610
    		]
    	],
    	[
    		[
    			64793,
    			64793
    		],
    		"mapped",
    		[
    			1588,
    			1609
    		]
    	],
    	[
    		[
    			64794,
    			64794
    		],
    		"mapped",
    		[
    			1588,
    			1610
    		]
    	],
    	[
    		[
    			64795,
    			64795
    		],
    		"mapped",
    		[
    			1581,
    			1609
    		]
    	],
    	[
    		[
    			64796,
    			64796
    		],
    		"mapped",
    		[
    			1581,
    			1610
    		]
    	],
    	[
    		[
    			64797,
    			64797
    		],
    		"mapped",
    		[
    			1580,
    			1609
    		]
    	],
    	[
    		[
    			64798,
    			64798
    		],
    		"mapped",
    		[
    			1580,
    			1610
    		]
    	],
    	[
    		[
    			64799,
    			64799
    		],
    		"mapped",
    		[
    			1582,
    			1609
    		]
    	],
    	[
    		[
    			64800,
    			64800
    		],
    		"mapped",
    		[
    			1582,
    			1610
    		]
    	],
    	[
    		[
    			64801,
    			64801
    		],
    		"mapped",
    		[
    			1589,
    			1609
    		]
    	],
    	[
    		[
    			64802,
    			64802
    		],
    		"mapped",
    		[
    			1589,
    			1610
    		]
    	],
    	[
    		[
    			64803,
    			64803
    		],
    		"mapped",
    		[
    			1590,
    			1609
    		]
    	],
    	[
    		[
    			64804,
    			64804
    		],
    		"mapped",
    		[
    			1590,
    			1610
    		]
    	],
    	[
    		[
    			64805,
    			64805
    		],
    		"mapped",
    		[
    			1588,
    			1580
    		]
    	],
    	[
    		[
    			64806,
    			64806
    		],
    		"mapped",
    		[
    			1588,
    			1581
    		]
    	],
    	[
    		[
    			64807,
    			64807
    		],
    		"mapped",
    		[
    			1588,
    			1582
    		]
    	],
    	[
    		[
    			64808,
    			64808
    		],
    		"mapped",
    		[
    			1588,
    			1605
    		]
    	],
    	[
    		[
    			64809,
    			64809
    		],
    		"mapped",
    		[
    			1588,
    			1585
    		]
    	],
    	[
    		[
    			64810,
    			64810
    		],
    		"mapped",
    		[
    			1587,
    			1585
    		]
    	],
    	[
    		[
    			64811,
    			64811
    		],
    		"mapped",
    		[
    			1589,
    			1585
    		]
    	],
    	[
    		[
    			64812,
    			64812
    		],
    		"mapped",
    		[
    			1590,
    			1585
    		]
    	],
    	[
    		[
    			64813,
    			64813
    		],
    		"mapped",
    		[
    			1588,
    			1580
    		]
    	],
    	[
    		[
    			64814,
    			64814
    		],
    		"mapped",
    		[
    			1588,
    			1581
    		]
    	],
    	[
    		[
    			64815,
    			64815
    		],
    		"mapped",
    		[
    			1588,
    			1582
    		]
    	],
    	[
    		[
    			64816,
    			64816
    		],
    		"mapped",
    		[
    			1588,
    			1605
    		]
    	],
    	[
    		[
    			64817,
    			64817
    		],
    		"mapped",
    		[
    			1587,
    			1607
    		]
    	],
    	[
    		[
    			64818,
    			64818
    		],
    		"mapped",
    		[
    			1588,
    			1607
    		]
    	],
    	[
    		[
    			64819,
    			64819
    		],
    		"mapped",
    		[
    			1591,
    			1605
    		]
    	],
    	[
    		[
    			64820,
    			64820
    		],
    		"mapped",
    		[
    			1587,
    			1580
    		]
    	],
    	[
    		[
    			64821,
    			64821
    		],
    		"mapped",
    		[
    			1587,
    			1581
    		]
    	],
    	[
    		[
    			64822,
    			64822
    		],
    		"mapped",
    		[
    			1587,
    			1582
    		]
    	],
    	[
    		[
    			64823,
    			64823
    		],
    		"mapped",
    		[
    			1588,
    			1580
    		]
    	],
    	[
    		[
    			64824,
    			64824
    		],
    		"mapped",
    		[
    			1588,
    			1581
    		]
    	],
    	[
    		[
    			64825,
    			64825
    		],
    		"mapped",
    		[
    			1588,
    			1582
    		]
    	],
    	[
    		[
    			64826,
    			64826
    		],
    		"mapped",
    		[
    			1591,
    			1605
    		]
    	],
    	[
    		[
    			64827,
    			64827
    		],
    		"mapped",
    		[
    			1592,
    			1605
    		]
    	],
    	[
    		[
    			64828,
    			64829
    		],
    		"mapped",
    		[
    			1575,
    			1611
    		]
    	],
    	[
    		[
    			64830,
    			64831
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			64832,
    			64847
    		],
    		"disallowed"
    	],
    	[
    		[
    			64848,
    			64848
    		],
    		"mapped",
    		[
    			1578,
    			1580,
    			1605
    		]
    	],
    	[
    		[
    			64849,
    			64850
    		],
    		"mapped",
    		[
    			1578,
    			1581,
    			1580
    		]
    	],
    	[
    		[
    			64851,
    			64851
    		],
    		"mapped",
    		[
    			1578,
    			1581,
    			1605
    		]
    	],
    	[
    		[
    			64852,
    			64852
    		],
    		"mapped",
    		[
    			1578,
    			1582,
    			1605
    		]
    	],
    	[
    		[
    			64853,
    			64853
    		],
    		"mapped",
    		[
    			1578,
    			1605,
    			1580
    		]
    	],
    	[
    		[
    			64854,
    			64854
    		],
    		"mapped",
    		[
    			1578,
    			1605,
    			1581
    		]
    	],
    	[
    		[
    			64855,
    			64855
    		],
    		"mapped",
    		[
    			1578,
    			1605,
    			1582
    		]
    	],
    	[
    		[
    			64856,
    			64857
    		],
    		"mapped",
    		[
    			1580,
    			1605,
    			1581
    		]
    	],
    	[
    		[
    			64858,
    			64858
    		],
    		"mapped",
    		[
    			1581,
    			1605,
    			1610
    		]
    	],
    	[
    		[
    			64859,
    			64859
    		],
    		"mapped",
    		[
    			1581,
    			1605,
    			1609
    		]
    	],
    	[
    		[
    			64860,
    			64860
    		],
    		"mapped",
    		[
    			1587,
    			1581,
    			1580
    		]
    	],
    	[
    		[
    			64861,
    			64861
    		],
    		"mapped",
    		[
    			1587,
    			1580,
    			1581
    		]
    	],
    	[
    		[
    			64862,
    			64862
    		],
    		"mapped",
    		[
    			1587,
    			1580,
    			1609
    		]
    	],
    	[
    		[
    			64863,
    			64864
    		],
    		"mapped",
    		[
    			1587,
    			1605,
    			1581
    		]
    	],
    	[
    		[
    			64865,
    			64865
    		],
    		"mapped",
    		[
    			1587,
    			1605,
    			1580
    		]
    	],
    	[
    		[
    			64866,
    			64867
    		],
    		"mapped",
    		[
    			1587,
    			1605,
    			1605
    		]
    	],
    	[
    		[
    			64868,
    			64869
    		],
    		"mapped",
    		[
    			1589,
    			1581,
    			1581
    		]
    	],
    	[
    		[
    			64870,
    			64870
    		],
    		"mapped",
    		[
    			1589,
    			1605,
    			1605
    		]
    	],
    	[
    		[
    			64871,
    			64872
    		],
    		"mapped",
    		[
    			1588,
    			1581,
    			1605
    		]
    	],
    	[
    		[
    			64873,
    			64873
    		],
    		"mapped",
    		[
    			1588,
    			1580,
    			1610
    		]
    	],
    	[
    		[
    			64874,
    			64875
    		],
    		"mapped",
    		[
    			1588,
    			1605,
    			1582
    		]
    	],
    	[
    		[
    			64876,
    			64877
    		],
    		"mapped",
    		[
    			1588,
    			1605,
    			1605
    		]
    	],
    	[
    		[
    			64878,
    			64878
    		],
    		"mapped",
    		[
    			1590,
    			1581,
    			1609
    		]
    	],
    	[
    		[
    			64879,
    			64880
    		],
    		"mapped",
    		[
    			1590,
    			1582,
    			1605
    		]
    	],
    	[
    		[
    			64881,
    			64882
    		],
    		"mapped",
    		[
    			1591,
    			1605,
    			1581
    		]
    	],
    	[
    		[
    			64883,
    			64883
    		],
    		"mapped",
    		[
    			1591,
    			1605,
    			1605
    		]
    	],
    	[
    		[
    			64884,
    			64884
    		],
    		"mapped",
    		[
    			1591,
    			1605,
    			1610
    		]
    	],
    	[
    		[
    			64885,
    			64885
    		],
    		"mapped",
    		[
    			1593,
    			1580,
    			1605
    		]
    	],
    	[
    		[
    			64886,
    			64887
    		],
    		"mapped",
    		[
    			1593,
    			1605,
    			1605
    		]
    	],
    	[
    		[
    			64888,
    			64888
    		],
    		"mapped",
    		[
    			1593,
    			1605,
    			1609
    		]
    	],
    	[
    		[
    			64889,
    			64889
    		],
    		"mapped",
    		[
    			1594,
    			1605,
    			1605
    		]
    	],
    	[
    		[
    			64890,
    			64890
    		],
    		"mapped",
    		[
    			1594,
    			1605,
    			1610
    		]
    	],
    	[
    		[
    			64891,
    			64891
    		],
    		"mapped",
    		[
    			1594,
    			1605,
    			1609
    		]
    	],
    	[
    		[
    			64892,
    			64893
    		],
    		"mapped",
    		[
    			1601,
    			1582,
    			1605
    		]
    	],
    	[
    		[
    			64894,
    			64894
    		],
    		"mapped",
    		[
    			1602,
    			1605,
    			1581
    		]
    	],
    	[
    		[
    			64895,
    			64895
    		],
    		"mapped",
    		[
    			1602,
    			1605,
    			1605
    		]
    	],
    	[
    		[
    			64896,
    			64896
    		],
    		"mapped",
    		[
    			1604,
    			1581,
    			1605
    		]
    	],
    	[
    		[
    			64897,
    			64897
    		],
    		"mapped",
    		[
    			1604,
    			1581,
    			1610
    		]
    	],
    	[
    		[
    			64898,
    			64898
    		],
    		"mapped",
    		[
    			1604,
    			1581,
    			1609
    		]
    	],
    	[
    		[
    			64899,
    			64900
    		],
    		"mapped",
    		[
    			1604,
    			1580,
    			1580
    		]
    	],
    	[
    		[
    			64901,
    			64902
    		],
    		"mapped",
    		[
    			1604,
    			1582,
    			1605
    		]
    	],
    	[
    		[
    			64903,
    			64904
    		],
    		"mapped",
    		[
    			1604,
    			1605,
    			1581
    		]
    	],
    	[
    		[
    			64905,
    			64905
    		],
    		"mapped",
    		[
    			1605,
    			1581,
    			1580
    		]
    	],
    	[
    		[
    			64906,
    			64906
    		],
    		"mapped",
    		[
    			1605,
    			1581,
    			1605
    		]
    	],
    	[
    		[
    			64907,
    			64907
    		],
    		"mapped",
    		[
    			1605,
    			1581,
    			1610
    		]
    	],
    	[
    		[
    			64908,
    			64908
    		],
    		"mapped",
    		[
    			1605,
    			1580,
    			1581
    		]
    	],
    	[
    		[
    			64909,
    			64909
    		],
    		"mapped",
    		[
    			1605,
    			1580,
    			1605
    		]
    	],
    	[
    		[
    			64910,
    			64910
    		],
    		"mapped",
    		[
    			1605,
    			1582,
    			1580
    		]
    	],
    	[
    		[
    			64911,
    			64911
    		],
    		"mapped",
    		[
    			1605,
    			1582,
    			1605
    		]
    	],
    	[
    		[
    			64912,
    			64913
    		],
    		"disallowed"
    	],
    	[
    		[
    			64914,
    			64914
    		],
    		"mapped",
    		[
    			1605,
    			1580,
    			1582
    		]
    	],
    	[
    		[
    			64915,
    			64915
    		],
    		"mapped",
    		[
    			1607,
    			1605,
    			1580
    		]
    	],
    	[
    		[
    			64916,
    			64916
    		],
    		"mapped",
    		[
    			1607,
    			1605,
    			1605
    		]
    	],
    	[
    		[
    			64917,
    			64917
    		],
    		"mapped",
    		[
    			1606,
    			1581,
    			1605
    		]
    	],
    	[
    		[
    			64918,
    			64918
    		],
    		"mapped",
    		[
    			1606,
    			1581,
    			1609
    		]
    	],
    	[
    		[
    			64919,
    			64920
    		],
    		"mapped",
    		[
    			1606,
    			1580,
    			1605
    		]
    	],
    	[
    		[
    			64921,
    			64921
    		],
    		"mapped",
    		[
    			1606,
    			1580,
    			1609
    		]
    	],
    	[
    		[
    			64922,
    			64922
    		],
    		"mapped",
    		[
    			1606,
    			1605,
    			1610
    		]
    	],
    	[
    		[
    			64923,
    			64923
    		],
    		"mapped",
    		[
    			1606,
    			1605,
    			1609
    		]
    	],
    	[
    		[
    			64924,
    			64925
    		],
    		"mapped",
    		[
    			1610,
    			1605,
    			1605
    		]
    	],
    	[
    		[
    			64926,
    			64926
    		],
    		"mapped",
    		[
    			1576,
    			1582,
    			1610
    		]
    	],
    	[
    		[
    			64927,
    			64927
    		],
    		"mapped",
    		[
    			1578,
    			1580,
    			1610
    		]
    	],
    	[
    		[
    			64928,
    			64928
    		],
    		"mapped",
    		[
    			1578,
    			1580,
    			1609
    		]
    	],
    	[
    		[
    			64929,
    			64929
    		],
    		"mapped",
    		[
    			1578,
    			1582,
    			1610
    		]
    	],
    	[
    		[
    			64930,
    			64930
    		],
    		"mapped",
    		[
    			1578,
    			1582,
    			1609
    		]
    	],
    	[
    		[
    			64931,
    			64931
    		],
    		"mapped",
    		[
    			1578,
    			1605,
    			1610
    		]
    	],
    	[
    		[
    			64932,
    			64932
    		],
    		"mapped",
    		[
    			1578,
    			1605,
    			1609
    		]
    	],
    	[
    		[
    			64933,
    			64933
    		],
    		"mapped",
    		[
    			1580,
    			1605,
    			1610
    		]
    	],
    	[
    		[
    			64934,
    			64934
    		],
    		"mapped",
    		[
    			1580,
    			1581,
    			1609
    		]
    	],
    	[
    		[
    			64935,
    			64935
    		],
    		"mapped",
    		[
    			1580,
    			1605,
    			1609
    		]
    	],
    	[
    		[
    			64936,
    			64936
    		],
    		"mapped",
    		[
    			1587,
    			1582,
    			1609
    		]
    	],
    	[
    		[
    			64937,
    			64937
    		],
    		"mapped",
    		[
    			1589,
    			1581,
    			1610
    		]
    	],
    	[
    		[
    			64938,
    			64938
    		],
    		"mapped",
    		[
    			1588,
    			1581,
    			1610
    		]
    	],
    	[
    		[
    			64939,
    			64939
    		],
    		"mapped",
    		[
    			1590,
    			1581,
    			1610
    		]
    	],
    	[
    		[
    			64940,
    			64940
    		],
    		"mapped",
    		[
    			1604,
    			1580,
    			1610
    		]
    	],
    	[
    		[
    			64941,
    			64941
    		],
    		"mapped",
    		[
    			1604,
    			1605,
    			1610
    		]
    	],
    	[
    		[
    			64942,
    			64942
    		],
    		"mapped",
    		[
    			1610,
    			1581,
    			1610
    		]
    	],
    	[
    		[
    			64943,
    			64943
    		],
    		"mapped",
    		[
    			1610,
    			1580,
    			1610
    		]
    	],
    	[
    		[
    			64944,
    			64944
    		],
    		"mapped",
    		[
    			1610,
    			1605,
    			1610
    		]
    	],
    	[
    		[
    			64945,
    			64945
    		],
    		"mapped",
    		[
    			1605,
    			1605,
    			1610
    		]
    	],
    	[
    		[
    			64946,
    			64946
    		],
    		"mapped",
    		[
    			1602,
    			1605,
    			1610
    		]
    	],
    	[
    		[
    			64947,
    			64947
    		],
    		"mapped",
    		[
    			1606,
    			1581,
    			1610
    		]
    	],
    	[
    		[
    			64948,
    			64948
    		],
    		"mapped",
    		[
    			1602,
    			1605,
    			1581
    		]
    	],
    	[
    		[
    			64949,
    			64949
    		],
    		"mapped",
    		[
    			1604,
    			1581,
    			1605
    		]
    	],
    	[
    		[
    			64950,
    			64950
    		],
    		"mapped",
    		[
    			1593,
    			1605,
    			1610
    		]
    	],
    	[
    		[
    			64951,
    			64951
    		],
    		"mapped",
    		[
    			1603,
    			1605,
    			1610
    		]
    	],
    	[
    		[
    			64952,
    			64952
    		],
    		"mapped",
    		[
    			1606,
    			1580,
    			1581
    		]
    	],
    	[
    		[
    			64953,
    			64953
    		],
    		"mapped",
    		[
    			1605,
    			1582,
    			1610
    		]
    	],
    	[
    		[
    			64954,
    			64954
    		],
    		"mapped",
    		[
    			1604,
    			1580,
    			1605
    		]
    	],
    	[
    		[
    			64955,
    			64955
    		],
    		"mapped",
    		[
    			1603,
    			1605,
    			1605
    		]
    	],
    	[
    		[
    			64956,
    			64956
    		],
    		"mapped",
    		[
    			1604,
    			1580,
    			1605
    		]
    	],
    	[
    		[
    			64957,
    			64957
    		],
    		"mapped",
    		[
    			1606,
    			1580,
    			1581
    		]
    	],
    	[
    		[
    			64958,
    			64958
    		],
    		"mapped",
    		[
    			1580,
    			1581,
    			1610
    		]
    	],
    	[
    		[
    			64959,
    			64959
    		],
    		"mapped",
    		[
    			1581,
    			1580,
    			1610
    		]
    	],
    	[
    		[
    			64960,
    			64960
    		],
    		"mapped",
    		[
    			1605,
    			1580,
    			1610
    		]
    	],
    	[
    		[
    			64961,
    			64961
    		],
    		"mapped",
    		[
    			1601,
    			1605,
    			1610
    		]
    	],
    	[
    		[
    			64962,
    			64962
    		],
    		"mapped",
    		[
    			1576,
    			1581,
    			1610
    		]
    	],
    	[
    		[
    			64963,
    			64963
    		],
    		"mapped",
    		[
    			1603,
    			1605,
    			1605
    		]
    	],
    	[
    		[
    			64964,
    			64964
    		],
    		"mapped",
    		[
    			1593,
    			1580,
    			1605
    		]
    	],
    	[
    		[
    			64965,
    			64965
    		],
    		"mapped",
    		[
    			1589,
    			1605,
    			1605
    		]
    	],
    	[
    		[
    			64966,
    			64966
    		],
    		"mapped",
    		[
    			1587,
    			1582,
    			1610
    		]
    	],
    	[
    		[
    			64967,
    			64967
    		],
    		"mapped",
    		[
    			1606,
    			1580,
    			1610
    		]
    	],
    	[
    		[
    			64968,
    			64975
    		],
    		"disallowed"
    	],
    	[
    		[
    			64976,
    			65007
    		],
    		"disallowed"
    	],
    	[
    		[
    			65008,
    			65008
    		],
    		"mapped",
    		[
    			1589,
    			1604,
    			1746
    		]
    	],
    	[
    		[
    			65009,
    			65009
    		],
    		"mapped",
    		[
    			1602,
    			1604,
    			1746
    		]
    	],
    	[
    		[
    			65010,
    			65010
    		],
    		"mapped",
    		[
    			1575,
    			1604,
    			1604,
    			1607
    		]
    	],
    	[
    		[
    			65011,
    			65011
    		],
    		"mapped",
    		[
    			1575,
    			1603,
    			1576,
    			1585
    		]
    	],
    	[
    		[
    			65012,
    			65012
    		],
    		"mapped",
    		[
    			1605,
    			1581,
    			1605,
    			1583
    		]
    	],
    	[
    		[
    			65013,
    			65013
    		],
    		"mapped",
    		[
    			1589,
    			1604,
    			1593,
    			1605
    		]
    	],
    	[
    		[
    			65014,
    			65014
    		],
    		"mapped",
    		[
    			1585,
    			1587,
    			1608,
    			1604
    		]
    	],
    	[
    		[
    			65015,
    			65015
    		],
    		"mapped",
    		[
    			1593,
    			1604,
    			1610,
    			1607
    		]
    	],
    	[
    		[
    			65016,
    			65016
    		],
    		"mapped",
    		[
    			1608,
    			1587,
    			1604,
    			1605
    		]
    	],
    	[
    		[
    			65017,
    			65017
    		],
    		"mapped",
    		[
    			1589,
    			1604,
    			1609
    		]
    	],
    	[
    		[
    			65018,
    			65018
    		],
    		"disallowed_STD3_mapped",
    		[
    			1589,
    			1604,
    			1609,
    			32,
    			1575,
    			1604,
    			1604,
    			1607,
    			32,
    			1593,
    			1604,
    			1610,
    			1607,
    			32,
    			1608,
    			1587,
    			1604,
    			1605
    		]
    	],
    	[
    		[
    			65019,
    			65019
    		],
    		"disallowed_STD3_mapped",
    		[
    			1580,
    			1604,
    			32,
    			1580,
    			1604,
    			1575,
    			1604,
    			1607
    		]
    	],
    	[
    		[
    			65020,
    			65020
    		],
    		"mapped",
    		[
    			1585,
    			1740,
    			1575,
    			1604
    		]
    	],
    	[
    		[
    			65021,
    			65021
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			65022,
    			65023
    		],
    		"disallowed"
    	],
    	[
    		[
    			65024,
    			65039
    		],
    		"ignored"
    	],
    	[
    		[
    			65040,
    			65040
    		],
    		"disallowed_STD3_mapped",
    		[
    			44
    		]
    	],
    	[
    		[
    			65041,
    			65041
    		],
    		"mapped",
    		[
    			12289
    		]
    	],
    	[
    		[
    			65042,
    			65042
    		],
    		"disallowed"
    	],
    	[
    		[
    			65043,
    			65043
    		],
    		"disallowed_STD3_mapped",
    		[
    			58
    		]
    	],
    	[
    		[
    			65044,
    			65044
    		],
    		"disallowed_STD3_mapped",
    		[
    			59
    		]
    	],
    	[
    		[
    			65045,
    			65045
    		],
    		"disallowed_STD3_mapped",
    		[
    			33
    		]
    	],
    	[
    		[
    			65046,
    			65046
    		],
    		"disallowed_STD3_mapped",
    		[
    			63
    		]
    	],
    	[
    		[
    			65047,
    			65047
    		],
    		"mapped",
    		[
    			12310
    		]
    	],
    	[
    		[
    			65048,
    			65048
    		],
    		"mapped",
    		[
    			12311
    		]
    	],
    	[
    		[
    			65049,
    			65049
    		],
    		"disallowed"
    	],
    	[
    		[
    			65050,
    			65055
    		],
    		"disallowed"
    	],
    	[
    		[
    			65056,
    			65059
    		],
    		"valid"
    	],
    	[
    		[
    			65060,
    			65062
    		],
    		"valid"
    	],
    	[
    		[
    			65063,
    			65069
    		],
    		"valid"
    	],
    	[
    		[
    			65070,
    			65071
    		],
    		"valid"
    	],
    	[
    		[
    			65072,
    			65072
    		],
    		"disallowed"
    	],
    	[
    		[
    			65073,
    			65073
    		],
    		"mapped",
    		[
    			8212
    		]
    	],
    	[
    		[
    			65074,
    			65074
    		],
    		"mapped",
    		[
    			8211
    		]
    	],
    	[
    		[
    			65075,
    			65076
    		],
    		"disallowed_STD3_mapped",
    		[
    			95
    		]
    	],
    	[
    		[
    			65077,
    			65077
    		],
    		"disallowed_STD3_mapped",
    		[
    			40
    		]
    	],
    	[
    		[
    			65078,
    			65078
    		],
    		"disallowed_STD3_mapped",
    		[
    			41
    		]
    	],
    	[
    		[
    			65079,
    			65079
    		],
    		"disallowed_STD3_mapped",
    		[
    			123
    		]
    	],
    	[
    		[
    			65080,
    			65080
    		],
    		"disallowed_STD3_mapped",
    		[
    			125
    		]
    	],
    	[
    		[
    			65081,
    			65081
    		],
    		"mapped",
    		[
    			12308
    		]
    	],
    	[
    		[
    			65082,
    			65082
    		],
    		"mapped",
    		[
    			12309
    		]
    	],
    	[
    		[
    			65083,
    			65083
    		],
    		"mapped",
    		[
    			12304
    		]
    	],
    	[
    		[
    			65084,
    			65084
    		],
    		"mapped",
    		[
    			12305
    		]
    	],
    	[
    		[
    			65085,
    			65085
    		],
    		"mapped",
    		[
    			12298
    		]
    	],
    	[
    		[
    			65086,
    			65086
    		],
    		"mapped",
    		[
    			12299
    		]
    	],
    	[
    		[
    			65087,
    			65087
    		],
    		"mapped",
    		[
    			12296
    		]
    	],
    	[
    		[
    			65088,
    			65088
    		],
    		"mapped",
    		[
    			12297
    		]
    	],
    	[
    		[
    			65089,
    			65089
    		],
    		"mapped",
    		[
    			12300
    		]
    	],
    	[
    		[
    			65090,
    			65090
    		],
    		"mapped",
    		[
    			12301
    		]
    	],
    	[
    		[
    			65091,
    			65091
    		],
    		"mapped",
    		[
    			12302
    		]
    	],
    	[
    		[
    			65092,
    			65092
    		],
    		"mapped",
    		[
    			12303
    		]
    	],
    	[
    		[
    			65093,
    			65094
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			65095,
    			65095
    		],
    		"disallowed_STD3_mapped",
    		[
    			91
    		]
    	],
    	[
    		[
    			65096,
    			65096
    		],
    		"disallowed_STD3_mapped",
    		[
    			93
    		]
    	],
    	[
    		[
    			65097,
    			65100
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			773
    		]
    	],
    	[
    		[
    			65101,
    			65103
    		],
    		"disallowed_STD3_mapped",
    		[
    			95
    		]
    	],
    	[
    		[
    			65104,
    			65104
    		],
    		"disallowed_STD3_mapped",
    		[
    			44
    		]
    	],
    	[
    		[
    			65105,
    			65105
    		],
    		"mapped",
    		[
    			12289
    		]
    	],
    	[
    		[
    			65106,
    			65106
    		],
    		"disallowed"
    	],
    	[
    		[
    			65107,
    			65107
    		],
    		"disallowed"
    	],
    	[
    		[
    			65108,
    			65108
    		],
    		"disallowed_STD3_mapped",
    		[
    			59
    		]
    	],
    	[
    		[
    			65109,
    			65109
    		],
    		"disallowed_STD3_mapped",
    		[
    			58
    		]
    	],
    	[
    		[
    			65110,
    			65110
    		],
    		"disallowed_STD3_mapped",
    		[
    			63
    		]
    	],
    	[
    		[
    			65111,
    			65111
    		],
    		"disallowed_STD3_mapped",
    		[
    			33
    		]
    	],
    	[
    		[
    			65112,
    			65112
    		],
    		"mapped",
    		[
    			8212
    		]
    	],
    	[
    		[
    			65113,
    			65113
    		],
    		"disallowed_STD3_mapped",
    		[
    			40
    		]
    	],
    	[
    		[
    			65114,
    			65114
    		],
    		"disallowed_STD3_mapped",
    		[
    			41
    		]
    	],
    	[
    		[
    			65115,
    			65115
    		],
    		"disallowed_STD3_mapped",
    		[
    			123
    		]
    	],
    	[
    		[
    			65116,
    			65116
    		],
    		"disallowed_STD3_mapped",
    		[
    			125
    		]
    	],
    	[
    		[
    			65117,
    			65117
    		],
    		"mapped",
    		[
    			12308
    		]
    	],
    	[
    		[
    			65118,
    			65118
    		],
    		"mapped",
    		[
    			12309
    		]
    	],
    	[
    		[
    			65119,
    			65119
    		],
    		"disallowed_STD3_mapped",
    		[
    			35
    		]
    	],
    	[
    		[
    			65120,
    			65120
    		],
    		"disallowed_STD3_mapped",
    		[
    			38
    		]
    	],
    	[
    		[
    			65121,
    			65121
    		],
    		"disallowed_STD3_mapped",
    		[
    			42
    		]
    	],
    	[
    		[
    			65122,
    			65122
    		],
    		"disallowed_STD3_mapped",
    		[
    			43
    		]
    	],
    	[
    		[
    			65123,
    			65123
    		],
    		"mapped",
    		[
    			45
    		]
    	],
    	[
    		[
    			65124,
    			65124
    		],
    		"disallowed_STD3_mapped",
    		[
    			60
    		]
    	],
    	[
    		[
    			65125,
    			65125
    		],
    		"disallowed_STD3_mapped",
    		[
    			62
    		]
    	],
    	[
    		[
    			65126,
    			65126
    		],
    		"disallowed_STD3_mapped",
    		[
    			61
    		]
    	],
    	[
    		[
    			65127,
    			65127
    		],
    		"disallowed"
    	],
    	[
    		[
    			65128,
    			65128
    		],
    		"disallowed_STD3_mapped",
    		[
    			92
    		]
    	],
    	[
    		[
    			65129,
    			65129
    		],
    		"disallowed_STD3_mapped",
    		[
    			36
    		]
    	],
    	[
    		[
    			65130,
    			65130
    		],
    		"disallowed_STD3_mapped",
    		[
    			37
    		]
    	],
    	[
    		[
    			65131,
    			65131
    		],
    		"disallowed_STD3_mapped",
    		[
    			64
    		]
    	],
    	[
    		[
    			65132,
    			65135
    		],
    		"disallowed"
    	],
    	[
    		[
    			65136,
    			65136
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			1611
    		]
    	],
    	[
    		[
    			65137,
    			65137
    		],
    		"mapped",
    		[
    			1600,
    			1611
    		]
    	],
    	[
    		[
    			65138,
    			65138
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			1612
    		]
    	],
    	[
    		[
    			65139,
    			65139
    		],
    		"valid"
    	],
    	[
    		[
    			65140,
    			65140
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			1613
    		]
    	],
    	[
    		[
    			65141,
    			65141
    		],
    		"disallowed"
    	],
    	[
    		[
    			65142,
    			65142
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			1614
    		]
    	],
    	[
    		[
    			65143,
    			65143
    		],
    		"mapped",
    		[
    			1600,
    			1614
    		]
    	],
    	[
    		[
    			65144,
    			65144
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			1615
    		]
    	],
    	[
    		[
    			65145,
    			65145
    		],
    		"mapped",
    		[
    			1600,
    			1615
    		]
    	],
    	[
    		[
    			65146,
    			65146
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			1616
    		]
    	],
    	[
    		[
    			65147,
    			65147
    		],
    		"mapped",
    		[
    			1600,
    			1616
    		]
    	],
    	[
    		[
    			65148,
    			65148
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			1617
    		]
    	],
    	[
    		[
    			65149,
    			65149
    		],
    		"mapped",
    		[
    			1600,
    			1617
    		]
    	],
    	[
    		[
    			65150,
    			65150
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			1618
    		]
    	],
    	[
    		[
    			65151,
    			65151
    		],
    		"mapped",
    		[
    			1600,
    			1618
    		]
    	],
    	[
    		[
    			65152,
    			65152
    		],
    		"mapped",
    		[
    			1569
    		]
    	],
    	[
    		[
    			65153,
    			65154
    		],
    		"mapped",
    		[
    			1570
    		]
    	],
    	[
    		[
    			65155,
    			65156
    		],
    		"mapped",
    		[
    			1571
    		]
    	],
    	[
    		[
    			65157,
    			65158
    		],
    		"mapped",
    		[
    			1572
    		]
    	],
    	[
    		[
    			65159,
    			65160
    		],
    		"mapped",
    		[
    			1573
    		]
    	],
    	[
    		[
    			65161,
    			65164
    		],
    		"mapped",
    		[
    			1574
    		]
    	],
    	[
    		[
    			65165,
    			65166
    		],
    		"mapped",
    		[
    			1575
    		]
    	],
    	[
    		[
    			65167,
    			65170
    		],
    		"mapped",
    		[
    			1576
    		]
    	],
    	[
    		[
    			65171,
    			65172
    		],
    		"mapped",
    		[
    			1577
    		]
    	],
    	[
    		[
    			65173,
    			65176
    		],
    		"mapped",
    		[
    			1578
    		]
    	],
    	[
    		[
    			65177,
    			65180
    		],
    		"mapped",
    		[
    			1579
    		]
    	],
    	[
    		[
    			65181,
    			65184
    		],
    		"mapped",
    		[
    			1580
    		]
    	],
    	[
    		[
    			65185,
    			65188
    		],
    		"mapped",
    		[
    			1581
    		]
    	],
    	[
    		[
    			65189,
    			65192
    		],
    		"mapped",
    		[
    			1582
    		]
    	],
    	[
    		[
    			65193,
    			65194
    		],
    		"mapped",
    		[
    			1583
    		]
    	],
    	[
    		[
    			65195,
    			65196
    		],
    		"mapped",
    		[
    			1584
    		]
    	],
    	[
    		[
    			65197,
    			65198
    		],
    		"mapped",
    		[
    			1585
    		]
    	],
    	[
    		[
    			65199,
    			65200
    		],
    		"mapped",
    		[
    			1586
    		]
    	],
    	[
    		[
    			65201,
    			65204
    		],
    		"mapped",
    		[
    			1587
    		]
    	],
    	[
    		[
    			65205,
    			65208
    		],
    		"mapped",
    		[
    			1588
    		]
    	],
    	[
    		[
    			65209,
    			65212
    		],
    		"mapped",
    		[
    			1589
    		]
    	],
    	[
    		[
    			65213,
    			65216
    		],
    		"mapped",
    		[
    			1590
    		]
    	],
    	[
    		[
    			65217,
    			65220
    		],
    		"mapped",
    		[
    			1591
    		]
    	],
    	[
    		[
    			65221,
    			65224
    		],
    		"mapped",
    		[
    			1592
    		]
    	],
    	[
    		[
    			65225,
    			65228
    		],
    		"mapped",
    		[
    			1593
    		]
    	],
    	[
    		[
    			65229,
    			65232
    		],
    		"mapped",
    		[
    			1594
    		]
    	],
    	[
    		[
    			65233,
    			65236
    		],
    		"mapped",
    		[
    			1601
    		]
    	],
    	[
    		[
    			65237,
    			65240
    		],
    		"mapped",
    		[
    			1602
    		]
    	],
    	[
    		[
    			65241,
    			65244
    		],
    		"mapped",
    		[
    			1603
    		]
    	],
    	[
    		[
    			65245,
    			65248
    		],
    		"mapped",
    		[
    			1604
    		]
    	],
    	[
    		[
    			65249,
    			65252
    		],
    		"mapped",
    		[
    			1605
    		]
    	],
    	[
    		[
    			65253,
    			65256
    		],
    		"mapped",
    		[
    			1606
    		]
    	],
    	[
    		[
    			65257,
    			65260
    		],
    		"mapped",
    		[
    			1607
    		]
    	],
    	[
    		[
    			65261,
    			65262
    		],
    		"mapped",
    		[
    			1608
    		]
    	],
    	[
    		[
    			65263,
    			65264
    		],
    		"mapped",
    		[
    			1609
    		]
    	],
    	[
    		[
    			65265,
    			65268
    		],
    		"mapped",
    		[
    			1610
    		]
    	],
    	[
    		[
    			65269,
    			65270
    		],
    		"mapped",
    		[
    			1604,
    			1570
    		]
    	],
    	[
    		[
    			65271,
    			65272
    		],
    		"mapped",
    		[
    			1604,
    			1571
    		]
    	],
    	[
    		[
    			65273,
    			65274
    		],
    		"mapped",
    		[
    			1604,
    			1573
    		]
    	],
    	[
    		[
    			65275,
    			65276
    		],
    		"mapped",
    		[
    			1604,
    			1575
    		]
    	],
    	[
    		[
    			65277,
    			65278
    		],
    		"disallowed"
    	],
    	[
    		[
    			65279,
    			65279
    		],
    		"ignored"
    	],
    	[
    		[
    			65280,
    			65280
    		],
    		"disallowed"
    	],
    	[
    		[
    			65281,
    			65281
    		],
    		"disallowed_STD3_mapped",
    		[
    			33
    		]
    	],
    	[
    		[
    			65282,
    			65282
    		],
    		"disallowed_STD3_mapped",
    		[
    			34
    		]
    	],
    	[
    		[
    			65283,
    			65283
    		],
    		"disallowed_STD3_mapped",
    		[
    			35
    		]
    	],
    	[
    		[
    			65284,
    			65284
    		],
    		"disallowed_STD3_mapped",
    		[
    			36
    		]
    	],
    	[
    		[
    			65285,
    			65285
    		],
    		"disallowed_STD3_mapped",
    		[
    			37
    		]
    	],
    	[
    		[
    			65286,
    			65286
    		],
    		"disallowed_STD3_mapped",
    		[
    			38
    		]
    	],
    	[
    		[
    			65287,
    			65287
    		],
    		"disallowed_STD3_mapped",
    		[
    			39
    		]
    	],
    	[
    		[
    			65288,
    			65288
    		],
    		"disallowed_STD3_mapped",
    		[
    			40
    		]
    	],
    	[
    		[
    			65289,
    			65289
    		],
    		"disallowed_STD3_mapped",
    		[
    			41
    		]
    	],
    	[
    		[
    			65290,
    			65290
    		],
    		"disallowed_STD3_mapped",
    		[
    			42
    		]
    	],
    	[
    		[
    			65291,
    			65291
    		],
    		"disallowed_STD3_mapped",
    		[
    			43
    		]
    	],
    	[
    		[
    			65292,
    			65292
    		],
    		"disallowed_STD3_mapped",
    		[
    			44
    		]
    	],
    	[
    		[
    			65293,
    			65293
    		],
    		"mapped",
    		[
    			45
    		]
    	],
    	[
    		[
    			65294,
    			65294
    		],
    		"mapped",
    		[
    			46
    		]
    	],
    	[
    		[
    			65295,
    			65295
    		],
    		"disallowed_STD3_mapped",
    		[
    			47
    		]
    	],
    	[
    		[
    			65296,
    			65296
    		],
    		"mapped",
    		[
    			48
    		]
    	],
    	[
    		[
    			65297,
    			65297
    		],
    		"mapped",
    		[
    			49
    		]
    	],
    	[
    		[
    			65298,
    			65298
    		],
    		"mapped",
    		[
    			50
    		]
    	],
    	[
    		[
    			65299,
    			65299
    		],
    		"mapped",
    		[
    			51
    		]
    	],
    	[
    		[
    			65300,
    			65300
    		],
    		"mapped",
    		[
    			52
    		]
    	],
    	[
    		[
    			65301,
    			65301
    		],
    		"mapped",
    		[
    			53
    		]
    	],
    	[
    		[
    			65302,
    			65302
    		],
    		"mapped",
    		[
    			54
    		]
    	],
    	[
    		[
    			65303,
    			65303
    		],
    		"mapped",
    		[
    			55
    		]
    	],
    	[
    		[
    			65304,
    			65304
    		],
    		"mapped",
    		[
    			56
    		]
    	],
    	[
    		[
    			65305,
    			65305
    		],
    		"mapped",
    		[
    			57
    		]
    	],
    	[
    		[
    			65306,
    			65306
    		],
    		"disallowed_STD3_mapped",
    		[
    			58
    		]
    	],
    	[
    		[
    			65307,
    			65307
    		],
    		"disallowed_STD3_mapped",
    		[
    			59
    		]
    	],
    	[
    		[
    			65308,
    			65308
    		],
    		"disallowed_STD3_mapped",
    		[
    			60
    		]
    	],
    	[
    		[
    			65309,
    			65309
    		],
    		"disallowed_STD3_mapped",
    		[
    			61
    		]
    	],
    	[
    		[
    			65310,
    			65310
    		],
    		"disallowed_STD3_mapped",
    		[
    			62
    		]
    	],
    	[
    		[
    			65311,
    			65311
    		],
    		"disallowed_STD3_mapped",
    		[
    			63
    		]
    	],
    	[
    		[
    			65312,
    			65312
    		],
    		"disallowed_STD3_mapped",
    		[
    			64
    		]
    	],
    	[
    		[
    			65313,
    			65313
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			65314,
    			65314
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			65315,
    			65315
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			65316,
    			65316
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			65317,
    			65317
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			65318,
    			65318
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			65319,
    			65319
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			65320,
    			65320
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			65321,
    			65321
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			65322,
    			65322
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			65323,
    			65323
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			65324,
    			65324
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			65325,
    			65325
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			65326,
    			65326
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			65327,
    			65327
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			65328,
    			65328
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			65329,
    			65329
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			65330,
    			65330
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			65331,
    			65331
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			65332,
    			65332
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			65333,
    			65333
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			65334,
    			65334
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			65335,
    			65335
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			65336,
    			65336
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			65337,
    			65337
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			65338,
    			65338
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			65339,
    			65339
    		],
    		"disallowed_STD3_mapped",
    		[
    			91
    		]
    	],
    	[
    		[
    			65340,
    			65340
    		],
    		"disallowed_STD3_mapped",
    		[
    			92
    		]
    	],
    	[
    		[
    			65341,
    			65341
    		],
    		"disallowed_STD3_mapped",
    		[
    			93
    		]
    	],
    	[
    		[
    			65342,
    			65342
    		],
    		"disallowed_STD3_mapped",
    		[
    			94
    		]
    	],
    	[
    		[
    			65343,
    			65343
    		],
    		"disallowed_STD3_mapped",
    		[
    			95
    		]
    	],
    	[
    		[
    			65344,
    			65344
    		],
    		"disallowed_STD3_mapped",
    		[
    			96
    		]
    	],
    	[
    		[
    			65345,
    			65345
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			65346,
    			65346
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			65347,
    			65347
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			65348,
    			65348
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			65349,
    			65349
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			65350,
    			65350
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			65351,
    			65351
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			65352,
    			65352
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			65353,
    			65353
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			65354,
    			65354
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			65355,
    			65355
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			65356,
    			65356
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			65357,
    			65357
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			65358,
    			65358
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			65359,
    			65359
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			65360,
    			65360
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			65361,
    			65361
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			65362,
    			65362
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			65363,
    			65363
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			65364,
    			65364
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			65365,
    			65365
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			65366,
    			65366
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			65367,
    			65367
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			65368,
    			65368
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			65369,
    			65369
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			65370,
    			65370
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			65371,
    			65371
    		],
    		"disallowed_STD3_mapped",
    		[
    			123
    		]
    	],
    	[
    		[
    			65372,
    			65372
    		],
    		"disallowed_STD3_mapped",
    		[
    			124
    		]
    	],
    	[
    		[
    			65373,
    			65373
    		],
    		"disallowed_STD3_mapped",
    		[
    			125
    		]
    	],
    	[
    		[
    			65374,
    			65374
    		],
    		"disallowed_STD3_mapped",
    		[
    			126
    		]
    	],
    	[
    		[
    			65375,
    			65375
    		],
    		"mapped",
    		[
    			10629
    		]
    	],
    	[
    		[
    			65376,
    			65376
    		],
    		"mapped",
    		[
    			10630
    		]
    	],
    	[
    		[
    			65377,
    			65377
    		],
    		"mapped",
    		[
    			46
    		]
    	],
    	[
    		[
    			65378,
    			65378
    		],
    		"mapped",
    		[
    			12300
    		]
    	],
    	[
    		[
    			65379,
    			65379
    		],
    		"mapped",
    		[
    			12301
    		]
    	],
    	[
    		[
    			65380,
    			65380
    		],
    		"mapped",
    		[
    			12289
    		]
    	],
    	[
    		[
    			65381,
    			65381
    		],
    		"mapped",
    		[
    			12539
    		]
    	],
    	[
    		[
    			65382,
    			65382
    		],
    		"mapped",
    		[
    			12530
    		]
    	],
    	[
    		[
    			65383,
    			65383
    		],
    		"mapped",
    		[
    			12449
    		]
    	],
    	[
    		[
    			65384,
    			65384
    		],
    		"mapped",
    		[
    			12451
    		]
    	],
    	[
    		[
    			65385,
    			65385
    		],
    		"mapped",
    		[
    			12453
    		]
    	],
    	[
    		[
    			65386,
    			65386
    		],
    		"mapped",
    		[
    			12455
    		]
    	],
    	[
    		[
    			65387,
    			65387
    		],
    		"mapped",
    		[
    			12457
    		]
    	],
    	[
    		[
    			65388,
    			65388
    		],
    		"mapped",
    		[
    			12515
    		]
    	],
    	[
    		[
    			65389,
    			65389
    		],
    		"mapped",
    		[
    			12517
    		]
    	],
    	[
    		[
    			65390,
    			65390
    		],
    		"mapped",
    		[
    			12519
    		]
    	],
    	[
    		[
    			65391,
    			65391
    		],
    		"mapped",
    		[
    			12483
    		]
    	],
    	[
    		[
    			65392,
    			65392
    		],
    		"mapped",
    		[
    			12540
    		]
    	],
    	[
    		[
    			65393,
    			65393
    		],
    		"mapped",
    		[
    			12450
    		]
    	],
    	[
    		[
    			65394,
    			65394
    		],
    		"mapped",
    		[
    			12452
    		]
    	],
    	[
    		[
    			65395,
    			65395
    		],
    		"mapped",
    		[
    			12454
    		]
    	],
    	[
    		[
    			65396,
    			65396
    		],
    		"mapped",
    		[
    			12456
    		]
    	],
    	[
    		[
    			65397,
    			65397
    		],
    		"mapped",
    		[
    			12458
    		]
    	],
    	[
    		[
    			65398,
    			65398
    		],
    		"mapped",
    		[
    			12459
    		]
    	],
    	[
    		[
    			65399,
    			65399
    		],
    		"mapped",
    		[
    			12461
    		]
    	],
    	[
    		[
    			65400,
    			65400
    		],
    		"mapped",
    		[
    			12463
    		]
    	],
    	[
    		[
    			65401,
    			65401
    		],
    		"mapped",
    		[
    			12465
    		]
    	],
    	[
    		[
    			65402,
    			65402
    		],
    		"mapped",
    		[
    			12467
    		]
    	],
    	[
    		[
    			65403,
    			65403
    		],
    		"mapped",
    		[
    			12469
    		]
    	],
    	[
    		[
    			65404,
    			65404
    		],
    		"mapped",
    		[
    			12471
    		]
    	],
    	[
    		[
    			65405,
    			65405
    		],
    		"mapped",
    		[
    			12473
    		]
    	],
    	[
    		[
    			65406,
    			65406
    		],
    		"mapped",
    		[
    			12475
    		]
    	],
    	[
    		[
    			65407,
    			65407
    		],
    		"mapped",
    		[
    			12477
    		]
    	],
    	[
    		[
    			65408,
    			65408
    		],
    		"mapped",
    		[
    			12479
    		]
    	],
    	[
    		[
    			65409,
    			65409
    		],
    		"mapped",
    		[
    			12481
    		]
    	],
    	[
    		[
    			65410,
    			65410
    		],
    		"mapped",
    		[
    			12484
    		]
    	],
    	[
    		[
    			65411,
    			65411
    		],
    		"mapped",
    		[
    			12486
    		]
    	],
    	[
    		[
    			65412,
    			65412
    		],
    		"mapped",
    		[
    			12488
    		]
    	],
    	[
    		[
    			65413,
    			65413
    		],
    		"mapped",
    		[
    			12490
    		]
    	],
    	[
    		[
    			65414,
    			65414
    		],
    		"mapped",
    		[
    			12491
    		]
    	],
    	[
    		[
    			65415,
    			65415
    		],
    		"mapped",
    		[
    			12492
    		]
    	],
    	[
    		[
    			65416,
    			65416
    		],
    		"mapped",
    		[
    			12493
    		]
    	],
    	[
    		[
    			65417,
    			65417
    		],
    		"mapped",
    		[
    			12494
    		]
    	],
    	[
    		[
    			65418,
    			65418
    		],
    		"mapped",
    		[
    			12495
    		]
    	],
    	[
    		[
    			65419,
    			65419
    		],
    		"mapped",
    		[
    			12498
    		]
    	],
    	[
    		[
    			65420,
    			65420
    		],
    		"mapped",
    		[
    			12501
    		]
    	],
    	[
    		[
    			65421,
    			65421
    		],
    		"mapped",
    		[
    			12504
    		]
    	],
    	[
    		[
    			65422,
    			65422
    		],
    		"mapped",
    		[
    			12507
    		]
    	],
    	[
    		[
    			65423,
    			65423
    		],
    		"mapped",
    		[
    			12510
    		]
    	],
    	[
    		[
    			65424,
    			65424
    		],
    		"mapped",
    		[
    			12511
    		]
    	],
    	[
    		[
    			65425,
    			65425
    		],
    		"mapped",
    		[
    			12512
    		]
    	],
    	[
    		[
    			65426,
    			65426
    		],
    		"mapped",
    		[
    			12513
    		]
    	],
    	[
    		[
    			65427,
    			65427
    		],
    		"mapped",
    		[
    			12514
    		]
    	],
    	[
    		[
    			65428,
    			65428
    		],
    		"mapped",
    		[
    			12516
    		]
    	],
    	[
    		[
    			65429,
    			65429
    		],
    		"mapped",
    		[
    			12518
    		]
    	],
    	[
    		[
    			65430,
    			65430
    		],
    		"mapped",
    		[
    			12520
    		]
    	],
    	[
    		[
    			65431,
    			65431
    		],
    		"mapped",
    		[
    			12521
    		]
    	],
    	[
    		[
    			65432,
    			65432
    		],
    		"mapped",
    		[
    			12522
    		]
    	],
    	[
    		[
    			65433,
    			65433
    		],
    		"mapped",
    		[
    			12523
    		]
    	],
    	[
    		[
    			65434,
    			65434
    		],
    		"mapped",
    		[
    			12524
    		]
    	],
    	[
    		[
    			65435,
    			65435
    		],
    		"mapped",
    		[
    			12525
    		]
    	],
    	[
    		[
    			65436,
    			65436
    		],
    		"mapped",
    		[
    			12527
    		]
    	],
    	[
    		[
    			65437,
    			65437
    		],
    		"mapped",
    		[
    			12531
    		]
    	],
    	[
    		[
    			65438,
    			65438
    		],
    		"mapped",
    		[
    			12441
    		]
    	],
    	[
    		[
    			65439,
    			65439
    		],
    		"mapped",
    		[
    			12442
    		]
    	],
    	[
    		[
    			65440,
    			65440
    		],
    		"disallowed"
    	],
    	[
    		[
    			65441,
    			65441
    		],
    		"mapped",
    		[
    			4352
    		]
    	],
    	[
    		[
    			65442,
    			65442
    		],
    		"mapped",
    		[
    			4353
    		]
    	],
    	[
    		[
    			65443,
    			65443
    		],
    		"mapped",
    		[
    			4522
    		]
    	],
    	[
    		[
    			65444,
    			65444
    		],
    		"mapped",
    		[
    			4354
    		]
    	],
    	[
    		[
    			65445,
    			65445
    		],
    		"mapped",
    		[
    			4524
    		]
    	],
    	[
    		[
    			65446,
    			65446
    		],
    		"mapped",
    		[
    			4525
    		]
    	],
    	[
    		[
    			65447,
    			65447
    		],
    		"mapped",
    		[
    			4355
    		]
    	],
    	[
    		[
    			65448,
    			65448
    		],
    		"mapped",
    		[
    			4356
    		]
    	],
    	[
    		[
    			65449,
    			65449
    		],
    		"mapped",
    		[
    			4357
    		]
    	],
    	[
    		[
    			65450,
    			65450
    		],
    		"mapped",
    		[
    			4528
    		]
    	],
    	[
    		[
    			65451,
    			65451
    		],
    		"mapped",
    		[
    			4529
    		]
    	],
    	[
    		[
    			65452,
    			65452
    		],
    		"mapped",
    		[
    			4530
    		]
    	],
    	[
    		[
    			65453,
    			65453
    		],
    		"mapped",
    		[
    			4531
    		]
    	],
    	[
    		[
    			65454,
    			65454
    		],
    		"mapped",
    		[
    			4532
    		]
    	],
    	[
    		[
    			65455,
    			65455
    		],
    		"mapped",
    		[
    			4533
    		]
    	],
    	[
    		[
    			65456,
    			65456
    		],
    		"mapped",
    		[
    			4378
    		]
    	],
    	[
    		[
    			65457,
    			65457
    		],
    		"mapped",
    		[
    			4358
    		]
    	],
    	[
    		[
    			65458,
    			65458
    		],
    		"mapped",
    		[
    			4359
    		]
    	],
    	[
    		[
    			65459,
    			65459
    		],
    		"mapped",
    		[
    			4360
    		]
    	],
    	[
    		[
    			65460,
    			65460
    		],
    		"mapped",
    		[
    			4385
    		]
    	],
    	[
    		[
    			65461,
    			65461
    		],
    		"mapped",
    		[
    			4361
    		]
    	],
    	[
    		[
    			65462,
    			65462
    		],
    		"mapped",
    		[
    			4362
    		]
    	],
    	[
    		[
    			65463,
    			65463
    		],
    		"mapped",
    		[
    			4363
    		]
    	],
    	[
    		[
    			65464,
    			65464
    		],
    		"mapped",
    		[
    			4364
    		]
    	],
    	[
    		[
    			65465,
    			65465
    		],
    		"mapped",
    		[
    			4365
    		]
    	],
    	[
    		[
    			65466,
    			65466
    		],
    		"mapped",
    		[
    			4366
    		]
    	],
    	[
    		[
    			65467,
    			65467
    		],
    		"mapped",
    		[
    			4367
    		]
    	],
    	[
    		[
    			65468,
    			65468
    		],
    		"mapped",
    		[
    			4368
    		]
    	],
    	[
    		[
    			65469,
    			65469
    		],
    		"mapped",
    		[
    			4369
    		]
    	],
    	[
    		[
    			65470,
    			65470
    		],
    		"mapped",
    		[
    			4370
    		]
    	],
    	[
    		[
    			65471,
    			65473
    		],
    		"disallowed"
    	],
    	[
    		[
    			65474,
    			65474
    		],
    		"mapped",
    		[
    			4449
    		]
    	],
    	[
    		[
    			65475,
    			65475
    		],
    		"mapped",
    		[
    			4450
    		]
    	],
    	[
    		[
    			65476,
    			65476
    		],
    		"mapped",
    		[
    			4451
    		]
    	],
    	[
    		[
    			65477,
    			65477
    		],
    		"mapped",
    		[
    			4452
    		]
    	],
    	[
    		[
    			65478,
    			65478
    		],
    		"mapped",
    		[
    			4453
    		]
    	],
    	[
    		[
    			65479,
    			65479
    		],
    		"mapped",
    		[
    			4454
    		]
    	],
    	[
    		[
    			65480,
    			65481
    		],
    		"disallowed"
    	],
    	[
    		[
    			65482,
    			65482
    		],
    		"mapped",
    		[
    			4455
    		]
    	],
    	[
    		[
    			65483,
    			65483
    		],
    		"mapped",
    		[
    			4456
    		]
    	],
    	[
    		[
    			65484,
    			65484
    		],
    		"mapped",
    		[
    			4457
    		]
    	],
    	[
    		[
    			65485,
    			65485
    		],
    		"mapped",
    		[
    			4458
    		]
    	],
    	[
    		[
    			65486,
    			65486
    		],
    		"mapped",
    		[
    			4459
    		]
    	],
    	[
    		[
    			65487,
    			65487
    		],
    		"mapped",
    		[
    			4460
    		]
    	],
    	[
    		[
    			65488,
    			65489
    		],
    		"disallowed"
    	],
    	[
    		[
    			65490,
    			65490
    		],
    		"mapped",
    		[
    			4461
    		]
    	],
    	[
    		[
    			65491,
    			65491
    		],
    		"mapped",
    		[
    			4462
    		]
    	],
    	[
    		[
    			65492,
    			65492
    		],
    		"mapped",
    		[
    			4463
    		]
    	],
    	[
    		[
    			65493,
    			65493
    		],
    		"mapped",
    		[
    			4464
    		]
    	],
    	[
    		[
    			65494,
    			65494
    		],
    		"mapped",
    		[
    			4465
    		]
    	],
    	[
    		[
    			65495,
    			65495
    		],
    		"mapped",
    		[
    			4466
    		]
    	],
    	[
    		[
    			65496,
    			65497
    		],
    		"disallowed"
    	],
    	[
    		[
    			65498,
    			65498
    		],
    		"mapped",
    		[
    			4467
    		]
    	],
    	[
    		[
    			65499,
    			65499
    		],
    		"mapped",
    		[
    			4468
    		]
    	],
    	[
    		[
    			65500,
    			65500
    		],
    		"mapped",
    		[
    			4469
    		]
    	],
    	[
    		[
    			65501,
    			65503
    		],
    		"disallowed"
    	],
    	[
    		[
    			65504,
    			65504
    		],
    		"mapped",
    		[
    			162
    		]
    	],
    	[
    		[
    			65505,
    			65505
    		],
    		"mapped",
    		[
    			163
    		]
    	],
    	[
    		[
    			65506,
    			65506
    		],
    		"mapped",
    		[
    			172
    		]
    	],
    	[
    		[
    			65507,
    			65507
    		],
    		"disallowed_STD3_mapped",
    		[
    			32,
    			772
    		]
    	],
    	[
    		[
    			65508,
    			65508
    		],
    		"mapped",
    		[
    			166
    		]
    	],
    	[
    		[
    			65509,
    			65509
    		],
    		"mapped",
    		[
    			165
    		]
    	],
    	[
    		[
    			65510,
    			65510
    		],
    		"mapped",
    		[
    			8361
    		]
    	],
    	[
    		[
    			65511,
    			65511
    		],
    		"disallowed"
    	],
    	[
    		[
    			65512,
    			65512
    		],
    		"mapped",
    		[
    			9474
    		]
    	],
    	[
    		[
    			65513,
    			65513
    		],
    		"mapped",
    		[
    			8592
    		]
    	],
    	[
    		[
    			65514,
    			65514
    		],
    		"mapped",
    		[
    			8593
    		]
    	],
    	[
    		[
    			65515,
    			65515
    		],
    		"mapped",
    		[
    			8594
    		]
    	],
    	[
    		[
    			65516,
    			65516
    		],
    		"mapped",
    		[
    			8595
    		]
    	],
    	[
    		[
    			65517,
    			65517
    		],
    		"mapped",
    		[
    			9632
    		]
    	],
    	[
    		[
    			65518,
    			65518
    		],
    		"mapped",
    		[
    			9675
    		]
    	],
    	[
    		[
    			65519,
    			65528
    		],
    		"disallowed"
    	],
    	[
    		[
    			65529,
    			65531
    		],
    		"disallowed"
    	],
    	[
    		[
    			65532,
    			65532
    		],
    		"disallowed"
    	],
    	[
    		[
    			65533,
    			65533
    		],
    		"disallowed"
    	],
    	[
    		[
    			65534,
    			65535
    		],
    		"disallowed"
    	],
    	[
    		[
    			65536,
    			65547
    		],
    		"valid"
    	],
    	[
    		[
    			65548,
    			65548
    		],
    		"disallowed"
    	],
    	[
    		[
    			65549,
    			65574
    		],
    		"valid"
    	],
    	[
    		[
    			65575,
    			65575
    		],
    		"disallowed"
    	],
    	[
    		[
    			65576,
    			65594
    		],
    		"valid"
    	],
    	[
    		[
    			65595,
    			65595
    		],
    		"disallowed"
    	],
    	[
    		[
    			65596,
    			65597
    		],
    		"valid"
    	],
    	[
    		[
    			65598,
    			65598
    		],
    		"disallowed"
    	],
    	[
    		[
    			65599,
    			65613
    		],
    		"valid"
    	],
    	[
    		[
    			65614,
    			65615
    		],
    		"disallowed"
    	],
    	[
    		[
    			65616,
    			65629
    		],
    		"valid"
    	],
    	[
    		[
    			65630,
    			65663
    		],
    		"disallowed"
    	],
    	[
    		[
    			65664,
    			65786
    		],
    		"valid"
    	],
    	[
    		[
    			65787,
    			65791
    		],
    		"disallowed"
    	],
    	[
    		[
    			65792,
    			65794
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			65795,
    			65798
    		],
    		"disallowed"
    	],
    	[
    		[
    			65799,
    			65843
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			65844,
    			65846
    		],
    		"disallowed"
    	],
    	[
    		[
    			65847,
    			65855
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			65856,
    			65930
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			65931,
    			65932
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			65933,
    			65935
    		],
    		"disallowed"
    	],
    	[
    		[
    			65936,
    			65947
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			65948,
    			65951
    		],
    		"disallowed"
    	],
    	[
    		[
    			65952,
    			65952
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			65953,
    			65999
    		],
    		"disallowed"
    	],
    	[
    		[
    			66000,
    			66044
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			66045,
    			66045
    		],
    		"valid"
    	],
    	[
    		[
    			66046,
    			66175
    		],
    		"disallowed"
    	],
    	[
    		[
    			66176,
    			66204
    		],
    		"valid"
    	],
    	[
    		[
    			66205,
    			66207
    		],
    		"disallowed"
    	],
    	[
    		[
    			66208,
    			66256
    		],
    		"valid"
    	],
    	[
    		[
    			66257,
    			66271
    		],
    		"disallowed"
    	],
    	[
    		[
    			66272,
    			66272
    		],
    		"valid"
    	],
    	[
    		[
    			66273,
    			66299
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			66300,
    			66303
    		],
    		"disallowed"
    	],
    	[
    		[
    			66304,
    			66334
    		],
    		"valid"
    	],
    	[
    		[
    			66335,
    			66335
    		],
    		"valid"
    	],
    	[
    		[
    			66336,
    			66339
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			66340,
    			66351
    		],
    		"disallowed"
    	],
    	[
    		[
    			66352,
    			66368
    		],
    		"valid"
    	],
    	[
    		[
    			66369,
    			66369
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			66370,
    			66377
    		],
    		"valid"
    	],
    	[
    		[
    			66378,
    			66378
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			66379,
    			66383
    		],
    		"disallowed"
    	],
    	[
    		[
    			66384,
    			66426
    		],
    		"valid"
    	],
    	[
    		[
    			66427,
    			66431
    		],
    		"disallowed"
    	],
    	[
    		[
    			66432,
    			66461
    		],
    		"valid"
    	],
    	[
    		[
    			66462,
    			66462
    		],
    		"disallowed"
    	],
    	[
    		[
    			66463,
    			66463
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			66464,
    			66499
    		],
    		"valid"
    	],
    	[
    		[
    			66500,
    			66503
    		],
    		"disallowed"
    	],
    	[
    		[
    			66504,
    			66511
    		],
    		"valid"
    	],
    	[
    		[
    			66512,
    			66517
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			66518,
    			66559
    		],
    		"disallowed"
    	],
    	[
    		[
    			66560,
    			66560
    		],
    		"mapped",
    		[
    			66600
    		]
    	],
    	[
    		[
    			66561,
    			66561
    		],
    		"mapped",
    		[
    			66601
    		]
    	],
    	[
    		[
    			66562,
    			66562
    		],
    		"mapped",
    		[
    			66602
    		]
    	],
    	[
    		[
    			66563,
    			66563
    		],
    		"mapped",
    		[
    			66603
    		]
    	],
    	[
    		[
    			66564,
    			66564
    		],
    		"mapped",
    		[
    			66604
    		]
    	],
    	[
    		[
    			66565,
    			66565
    		],
    		"mapped",
    		[
    			66605
    		]
    	],
    	[
    		[
    			66566,
    			66566
    		],
    		"mapped",
    		[
    			66606
    		]
    	],
    	[
    		[
    			66567,
    			66567
    		],
    		"mapped",
    		[
    			66607
    		]
    	],
    	[
    		[
    			66568,
    			66568
    		],
    		"mapped",
    		[
    			66608
    		]
    	],
    	[
    		[
    			66569,
    			66569
    		],
    		"mapped",
    		[
    			66609
    		]
    	],
    	[
    		[
    			66570,
    			66570
    		],
    		"mapped",
    		[
    			66610
    		]
    	],
    	[
    		[
    			66571,
    			66571
    		],
    		"mapped",
    		[
    			66611
    		]
    	],
    	[
    		[
    			66572,
    			66572
    		],
    		"mapped",
    		[
    			66612
    		]
    	],
    	[
    		[
    			66573,
    			66573
    		],
    		"mapped",
    		[
    			66613
    		]
    	],
    	[
    		[
    			66574,
    			66574
    		],
    		"mapped",
    		[
    			66614
    		]
    	],
    	[
    		[
    			66575,
    			66575
    		],
    		"mapped",
    		[
    			66615
    		]
    	],
    	[
    		[
    			66576,
    			66576
    		],
    		"mapped",
    		[
    			66616
    		]
    	],
    	[
    		[
    			66577,
    			66577
    		],
    		"mapped",
    		[
    			66617
    		]
    	],
    	[
    		[
    			66578,
    			66578
    		],
    		"mapped",
    		[
    			66618
    		]
    	],
    	[
    		[
    			66579,
    			66579
    		],
    		"mapped",
    		[
    			66619
    		]
    	],
    	[
    		[
    			66580,
    			66580
    		],
    		"mapped",
    		[
    			66620
    		]
    	],
    	[
    		[
    			66581,
    			66581
    		],
    		"mapped",
    		[
    			66621
    		]
    	],
    	[
    		[
    			66582,
    			66582
    		],
    		"mapped",
    		[
    			66622
    		]
    	],
    	[
    		[
    			66583,
    			66583
    		],
    		"mapped",
    		[
    			66623
    		]
    	],
    	[
    		[
    			66584,
    			66584
    		],
    		"mapped",
    		[
    			66624
    		]
    	],
    	[
    		[
    			66585,
    			66585
    		],
    		"mapped",
    		[
    			66625
    		]
    	],
    	[
    		[
    			66586,
    			66586
    		],
    		"mapped",
    		[
    			66626
    		]
    	],
    	[
    		[
    			66587,
    			66587
    		],
    		"mapped",
    		[
    			66627
    		]
    	],
    	[
    		[
    			66588,
    			66588
    		],
    		"mapped",
    		[
    			66628
    		]
    	],
    	[
    		[
    			66589,
    			66589
    		],
    		"mapped",
    		[
    			66629
    		]
    	],
    	[
    		[
    			66590,
    			66590
    		],
    		"mapped",
    		[
    			66630
    		]
    	],
    	[
    		[
    			66591,
    			66591
    		],
    		"mapped",
    		[
    			66631
    		]
    	],
    	[
    		[
    			66592,
    			66592
    		],
    		"mapped",
    		[
    			66632
    		]
    	],
    	[
    		[
    			66593,
    			66593
    		],
    		"mapped",
    		[
    			66633
    		]
    	],
    	[
    		[
    			66594,
    			66594
    		],
    		"mapped",
    		[
    			66634
    		]
    	],
    	[
    		[
    			66595,
    			66595
    		],
    		"mapped",
    		[
    			66635
    		]
    	],
    	[
    		[
    			66596,
    			66596
    		],
    		"mapped",
    		[
    			66636
    		]
    	],
    	[
    		[
    			66597,
    			66597
    		],
    		"mapped",
    		[
    			66637
    		]
    	],
    	[
    		[
    			66598,
    			66598
    		],
    		"mapped",
    		[
    			66638
    		]
    	],
    	[
    		[
    			66599,
    			66599
    		],
    		"mapped",
    		[
    			66639
    		]
    	],
    	[
    		[
    			66600,
    			66637
    		],
    		"valid"
    	],
    	[
    		[
    			66638,
    			66717
    		],
    		"valid"
    	],
    	[
    		[
    			66718,
    			66719
    		],
    		"disallowed"
    	],
    	[
    		[
    			66720,
    			66729
    		],
    		"valid"
    	],
    	[
    		[
    			66730,
    			66815
    		],
    		"disallowed"
    	],
    	[
    		[
    			66816,
    			66855
    		],
    		"valid"
    	],
    	[
    		[
    			66856,
    			66863
    		],
    		"disallowed"
    	],
    	[
    		[
    			66864,
    			66915
    		],
    		"valid"
    	],
    	[
    		[
    			66916,
    			66926
    		],
    		"disallowed"
    	],
    	[
    		[
    			66927,
    			66927
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			66928,
    			67071
    		],
    		"disallowed"
    	],
    	[
    		[
    			67072,
    			67382
    		],
    		"valid"
    	],
    	[
    		[
    			67383,
    			67391
    		],
    		"disallowed"
    	],
    	[
    		[
    			67392,
    			67413
    		],
    		"valid"
    	],
    	[
    		[
    			67414,
    			67423
    		],
    		"disallowed"
    	],
    	[
    		[
    			67424,
    			67431
    		],
    		"valid"
    	],
    	[
    		[
    			67432,
    			67583
    		],
    		"disallowed"
    	],
    	[
    		[
    			67584,
    			67589
    		],
    		"valid"
    	],
    	[
    		[
    			67590,
    			67591
    		],
    		"disallowed"
    	],
    	[
    		[
    			67592,
    			67592
    		],
    		"valid"
    	],
    	[
    		[
    			67593,
    			67593
    		],
    		"disallowed"
    	],
    	[
    		[
    			67594,
    			67637
    		],
    		"valid"
    	],
    	[
    		[
    			67638,
    			67638
    		],
    		"disallowed"
    	],
    	[
    		[
    			67639,
    			67640
    		],
    		"valid"
    	],
    	[
    		[
    			67641,
    			67643
    		],
    		"disallowed"
    	],
    	[
    		[
    			67644,
    			67644
    		],
    		"valid"
    	],
    	[
    		[
    			67645,
    			67646
    		],
    		"disallowed"
    	],
    	[
    		[
    			67647,
    			67647
    		],
    		"valid"
    	],
    	[
    		[
    			67648,
    			67669
    		],
    		"valid"
    	],
    	[
    		[
    			67670,
    			67670
    		],
    		"disallowed"
    	],
    	[
    		[
    			67671,
    			67679
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			67680,
    			67702
    		],
    		"valid"
    	],
    	[
    		[
    			67703,
    			67711
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			67712,
    			67742
    		],
    		"valid"
    	],
    	[
    		[
    			67743,
    			67750
    		],
    		"disallowed"
    	],
    	[
    		[
    			67751,
    			67759
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			67760,
    			67807
    		],
    		"disallowed"
    	],
    	[
    		[
    			67808,
    			67826
    		],
    		"valid"
    	],
    	[
    		[
    			67827,
    			67827
    		],
    		"disallowed"
    	],
    	[
    		[
    			67828,
    			67829
    		],
    		"valid"
    	],
    	[
    		[
    			67830,
    			67834
    		],
    		"disallowed"
    	],
    	[
    		[
    			67835,
    			67839
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			67840,
    			67861
    		],
    		"valid"
    	],
    	[
    		[
    			67862,
    			67865
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			67866,
    			67867
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			67868,
    			67870
    		],
    		"disallowed"
    	],
    	[
    		[
    			67871,
    			67871
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			67872,
    			67897
    		],
    		"valid"
    	],
    	[
    		[
    			67898,
    			67902
    		],
    		"disallowed"
    	],
    	[
    		[
    			67903,
    			67903
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			67904,
    			67967
    		],
    		"disallowed"
    	],
    	[
    		[
    			67968,
    			68023
    		],
    		"valid"
    	],
    	[
    		[
    			68024,
    			68027
    		],
    		"disallowed"
    	],
    	[
    		[
    			68028,
    			68029
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			68030,
    			68031
    		],
    		"valid"
    	],
    	[
    		[
    			68032,
    			68047
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			68048,
    			68049
    		],
    		"disallowed"
    	],
    	[
    		[
    			68050,
    			68095
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			68096,
    			68099
    		],
    		"valid"
    	],
    	[
    		[
    			68100,
    			68100
    		],
    		"disallowed"
    	],
    	[
    		[
    			68101,
    			68102
    		],
    		"valid"
    	],
    	[
    		[
    			68103,
    			68107
    		],
    		"disallowed"
    	],
    	[
    		[
    			68108,
    			68115
    		],
    		"valid"
    	],
    	[
    		[
    			68116,
    			68116
    		],
    		"disallowed"
    	],
    	[
    		[
    			68117,
    			68119
    		],
    		"valid"
    	],
    	[
    		[
    			68120,
    			68120
    		],
    		"disallowed"
    	],
    	[
    		[
    			68121,
    			68147
    		],
    		"valid"
    	],
    	[
    		[
    			68148,
    			68151
    		],
    		"disallowed"
    	],
    	[
    		[
    			68152,
    			68154
    		],
    		"valid"
    	],
    	[
    		[
    			68155,
    			68158
    		],
    		"disallowed"
    	],
    	[
    		[
    			68159,
    			68159
    		],
    		"valid"
    	],
    	[
    		[
    			68160,
    			68167
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			68168,
    			68175
    		],
    		"disallowed"
    	],
    	[
    		[
    			68176,
    			68184
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			68185,
    			68191
    		],
    		"disallowed"
    	],
    	[
    		[
    			68192,
    			68220
    		],
    		"valid"
    	],
    	[
    		[
    			68221,
    			68223
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			68224,
    			68252
    		],
    		"valid"
    	],
    	[
    		[
    			68253,
    			68255
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			68256,
    			68287
    		],
    		"disallowed"
    	],
    	[
    		[
    			68288,
    			68295
    		],
    		"valid"
    	],
    	[
    		[
    			68296,
    			68296
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			68297,
    			68326
    		],
    		"valid"
    	],
    	[
    		[
    			68327,
    			68330
    		],
    		"disallowed"
    	],
    	[
    		[
    			68331,
    			68342
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			68343,
    			68351
    		],
    		"disallowed"
    	],
    	[
    		[
    			68352,
    			68405
    		],
    		"valid"
    	],
    	[
    		[
    			68406,
    			68408
    		],
    		"disallowed"
    	],
    	[
    		[
    			68409,
    			68415
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			68416,
    			68437
    		],
    		"valid"
    	],
    	[
    		[
    			68438,
    			68439
    		],
    		"disallowed"
    	],
    	[
    		[
    			68440,
    			68447
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			68448,
    			68466
    		],
    		"valid"
    	],
    	[
    		[
    			68467,
    			68471
    		],
    		"disallowed"
    	],
    	[
    		[
    			68472,
    			68479
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			68480,
    			68497
    		],
    		"valid"
    	],
    	[
    		[
    			68498,
    			68504
    		],
    		"disallowed"
    	],
    	[
    		[
    			68505,
    			68508
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			68509,
    			68520
    		],
    		"disallowed"
    	],
    	[
    		[
    			68521,
    			68527
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			68528,
    			68607
    		],
    		"disallowed"
    	],
    	[
    		[
    			68608,
    			68680
    		],
    		"valid"
    	],
    	[
    		[
    			68681,
    			68735
    		],
    		"disallowed"
    	],
    	[
    		[
    			68736,
    			68736
    		],
    		"mapped",
    		[
    			68800
    		]
    	],
    	[
    		[
    			68737,
    			68737
    		],
    		"mapped",
    		[
    			68801
    		]
    	],
    	[
    		[
    			68738,
    			68738
    		],
    		"mapped",
    		[
    			68802
    		]
    	],
    	[
    		[
    			68739,
    			68739
    		],
    		"mapped",
    		[
    			68803
    		]
    	],
    	[
    		[
    			68740,
    			68740
    		],
    		"mapped",
    		[
    			68804
    		]
    	],
    	[
    		[
    			68741,
    			68741
    		],
    		"mapped",
    		[
    			68805
    		]
    	],
    	[
    		[
    			68742,
    			68742
    		],
    		"mapped",
    		[
    			68806
    		]
    	],
    	[
    		[
    			68743,
    			68743
    		],
    		"mapped",
    		[
    			68807
    		]
    	],
    	[
    		[
    			68744,
    			68744
    		],
    		"mapped",
    		[
    			68808
    		]
    	],
    	[
    		[
    			68745,
    			68745
    		],
    		"mapped",
    		[
    			68809
    		]
    	],
    	[
    		[
    			68746,
    			68746
    		],
    		"mapped",
    		[
    			68810
    		]
    	],
    	[
    		[
    			68747,
    			68747
    		],
    		"mapped",
    		[
    			68811
    		]
    	],
    	[
    		[
    			68748,
    			68748
    		],
    		"mapped",
    		[
    			68812
    		]
    	],
    	[
    		[
    			68749,
    			68749
    		],
    		"mapped",
    		[
    			68813
    		]
    	],
    	[
    		[
    			68750,
    			68750
    		],
    		"mapped",
    		[
    			68814
    		]
    	],
    	[
    		[
    			68751,
    			68751
    		],
    		"mapped",
    		[
    			68815
    		]
    	],
    	[
    		[
    			68752,
    			68752
    		],
    		"mapped",
    		[
    			68816
    		]
    	],
    	[
    		[
    			68753,
    			68753
    		],
    		"mapped",
    		[
    			68817
    		]
    	],
    	[
    		[
    			68754,
    			68754
    		],
    		"mapped",
    		[
    			68818
    		]
    	],
    	[
    		[
    			68755,
    			68755
    		],
    		"mapped",
    		[
    			68819
    		]
    	],
    	[
    		[
    			68756,
    			68756
    		],
    		"mapped",
    		[
    			68820
    		]
    	],
    	[
    		[
    			68757,
    			68757
    		],
    		"mapped",
    		[
    			68821
    		]
    	],
    	[
    		[
    			68758,
    			68758
    		],
    		"mapped",
    		[
    			68822
    		]
    	],
    	[
    		[
    			68759,
    			68759
    		],
    		"mapped",
    		[
    			68823
    		]
    	],
    	[
    		[
    			68760,
    			68760
    		],
    		"mapped",
    		[
    			68824
    		]
    	],
    	[
    		[
    			68761,
    			68761
    		],
    		"mapped",
    		[
    			68825
    		]
    	],
    	[
    		[
    			68762,
    			68762
    		],
    		"mapped",
    		[
    			68826
    		]
    	],
    	[
    		[
    			68763,
    			68763
    		],
    		"mapped",
    		[
    			68827
    		]
    	],
    	[
    		[
    			68764,
    			68764
    		],
    		"mapped",
    		[
    			68828
    		]
    	],
    	[
    		[
    			68765,
    			68765
    		],
    		"mapped",
    		[
    			68829
    		]
    	],
    	[
    		[
    			68766,
    			68766
    		],
    		"mapped",
    		[
    			68830
    		]
    	],
    	[
    		[
    			68767,
    			68767
    		],
    		"mapped",
    		[
    			68831
    		]
    	],
    	[
    		[
    			68768,
    			68768
    		],
    		"mapped",
    		[
    			68832
    		]
    	],
    	[
    		[
    			68769,
    			68769
    		],
    		"mapped",
    		[
    			68833
    		]
    	],
    	[
    		[
    			68770,
    			68770
    		],
    		"mapped",
    		[
    			68834
    		]
    	],
    	[
    		[
    			68771,
    			68771
    		],
    		"mapped",
    		[
    			68835
    		]
    	],
    	[
    		[
    			68772,
    			68772
    		],
    		"mapped",
    		[
    			68836
    		]
    	],
    	[
    		[
    			68773,
    			68773
    		],
    		"mapped",
    		[
    			68837
    		]
    	],
    	[
    		[
    			68774,
    			68774
    		],
    		"mapped",
    		[
    			68838
    		]
    	],
    	[
    		[
    			68775,
    			68775
    		],
    		"mapped",
    		[
    			68839
    		]
    	],
    	[
    		[
    			68776,
    			68776
    		],
    		"mapped",
    		[
    			68840
    		]
    	],
    	[
    		[
    			68777,
    			68777
    		],
    		"mapped",
    		[
    			68841
    		]
    	],
    	[
    		[
    			68778,
    			68778
    		],
    		"mapped",
    		[
    			68842
    		]
    	],
    	[
    		[
    			68779,
    			68779
    		],
    		"mapped",
    		[
    			68843
    		]
    	],
    	[
    		[
    			68780,
    			68780
    		],
    		"mapped",
    		[
    			68844
    		]
    	],
    	[
    		[
    			68781,
    			68781
    		],
    		"mapped",
    		[
    			68845
    		]
    	],
    	[
    		[
    			68782,
    			68782
    		],
    		"mapped",
    		[
    			68846
    		]
    	],
    	[
    		[
    			68783,
    			68783
    		],
    		"mapped",
    		[
    			68847
    		]
    	],
    	[
    		[
    			68784,
    			68784
    		],
    		"mapped",
    		[
    			68848
    		]
    	],
    	[
    		[
    			68785,
    			68785
    		],
    		"mapped",
    		[
    			68849
    		]
    	],
    	[
    		[
    			68786,
    			68786
    		],
    		"mapped",
    		[
    			68850
    		]
    	],
    	[
    		[
    			68787,
    			68799
    		],
    		"disallowed"
    	],
    	[
    		[
    			68800,
    			68850
    		],
    		"valid"
    	],
    	[
    		[
    			68851,
    			68857
    		],
    		"disallowed"
    	],
    	[
    		[
    			68858,
    			68863
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			68864,
    			69215
    		],
    		"disallowed"
    	],
    	[
    		[
    			69216,
    			69246
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			69247,
    			69631
    		],
    		"disallowed"
    	],
    	[
    		[
    			69632,
    			69702
    		],
    		"valid"
    	],
    	[
    		[
    			69703,
    			69709
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			69710,
    			69713
    		],
    		"disallowed"
    	],
    	[
    		[
    			69714,
    			69733
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			69734,
    			69743
    		],
    		"valid"
    	],
    	[
    		[
    			69744,
    			69758
    		],
    		"disallowed"
    	],
    	[
    		[
    			69759,
    			69759
    		],
    		"valid"
    	],
    	[
    		[
    			69760,
    			69818
    		],
    		"valid"
    	],
    	[
    		[
    			69819,
    			69820
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			69821,
    			69821
    		],
    		"disallowed"
    	],
    	[
    		[
    			69822,
    			69825
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			69826,
    			69839
    		],
    		"disallowed"
    	],
    	[
    		[
    			69840,
    			69864
    		],
    		"valid"
    	],
    	[
    		[
    			69865,
    			69871
    		],
    		"disallowed"
    	],
    	[
    		[
    			69872,
    			69881
    		],
    		"valid"
    	],
    	[
    		[
    			69882,
    			69887
    		],
    		"disallowed"
    	],
    	[
    		[
    			69888,
    			69940
    		],
    		"valid"
    	],
    	[
    		[
    			69941,
    			69941
    		],
    		"disallowed"
    	],
    	[
    		[
    			69942,
    			69951
    		],
    		"valid"
    	],
    	[
    		[
    			69952,
    			69955
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			69956,
    			69967
    		],
    		"disallowed"
    	],
    	[
    		[
    			69968,
    			70003
    		],
    		"valid"
    	],
    	[
    		[
    			70004,
    			70005
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			70006,
    			70006
    		],
    		"valid"
    	],
    	[
    		[
    			70007,
    			70015
    		],
    		"disallowed"
    	],
    	[
    		[
    			70016,
    			70084
    		],
    		"valid"
    	],
    	[
    		[
    			70085,
    			70088
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			70089,
    			70089
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			70090,
    			70092
    		],
    		"valid"
    	],
    	[
    		[
    			70093,
    			70093
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			70094,
    			70095
    		],
    		"disallowed"
    	],
    	[
    		[
    			70096,
    			70105
    		],
    		"valid"
    	],
    	[
    		[
    			70106,
    			70106
    		],
    		"valid"
    	],
    	[
    		[
    			70107,
    			70107
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			70108,
    			70108
    		],
    		"valid"
    	],
    	[
    		[
    			70109,
    			70111
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			70112,
    			70112
    		],
    		"disallowed"
    	],
    	[
    		[
    			70113,
    			70132
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			70133,
    			70143
    		],
    		"disallowed"
    	],
    	[
    		[
    			70144,
    			70161
    		],
    		"valid"
    	],
    	[
    		[
    			70162,
    			70162
    		],
    		"disallowed"
    	],
    	[
    		[
    			70163,
    			70199
    		],
    		"valid"
    	],
    	[
    		[
    			70200,
    			70205
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			70206,
    			70271
    		],
    		"disallowed"
    	],
    	[
    		[
    			70272,
    			70278
    		],
    		"valid"
    	],
    	[
    		[
    			70279,
    			70279
    		],
    		"disallowed"
    	],
    	[
    		[
    			70280,
    			70280
    		],
    		"valid"
    	],
    	[
    		[
    			70281,
    			70281
    		],
    		"disallowed"
    	],
    	[
    		[
    			70282,
    			70285
    		],
    		"valid"
    	],
    	[
    		[
    			70286,
    			70286
    		],
    		"disallowed"
    	],
    	[
    		[
    			70287,
    			70301
    		],
    		"valid"
    	],
    	[
    		[
    			70302,
    			70302
    		],
    		"disallowed"
    	],
    	[
    		[
    			70303,
    			70312
    		],
    		"valid"
    	],
    	[
    		[
    			70313,
    			70313
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			70314,
    			70319
    		],
    		"disallowed"
    	],
    	[
    		[
    			70320,
    			70378
    		],
    		"valid"
    	],
    	[
    		[
    			70379,
    			70383
    		],
    		"disallowed"
    	],
    	[
    		[
    			70384,
    			70393
    		],
    		"valid"
    	],
    	[
    		[
    			70394,
    			70399
    		],
    		"disallowed"
    	],
    	[
    		[
    			70400,
    			70400
    		],
    		"valid"
    	],
    	[
    		[
    			70401,
    			70403
    		],
    		"valid"
    	],
    	[
    		[
    			70404,
    			70404
    		],
    		"disallowed"
    	],
    	[
    		[
    			70405,
    			70412
    		],
    		"valid"
    	],
    	[
    		[
    			70413,
    			70414
    		],
    		"disallowed"
    	],
    	[
    		[
    			70415,
    			70416
    		],
    		"valid"
    	],
    	[
    		[
    			70417,
    			70418
    		],
    		"disallowed"
    	],
    	[
    		[
    			70419,
    			70440
    		],
    		"valid"
    	],
    	[
    		[
    			70441,
    			70441
    		],
    		"disallowed"
    	],
    	[
    		[
    			70442,
    			70448
    		],
    		"valid"
    	],
    	[
    		[
    			70449,
    			70449
    		],
    		"disallowed"
    	],
    	[
    		[
    			70450,
    			70451
    		],
    		"valid"
    	],
    	[
    		[
    			70452,
    			70452
    		],
    		"disallowed"
    	],
    	[
    		[
    			70453,
    			70457
    		],
    		"valid"
    	],
    	[
    		[
    			70458,
    			70459
    		],
    		"disallowed"
    	],
    	[
    		[
    			70460,
    			70468
    		],
    		"valid"
    	],
    	[
    		[
    			70469,
    			70470
    		],
    		"disallowed"
    	],
    	[
    		[
    			70471,
    			70472
    		],
    		"valid"
    	],
    	[
    		[
    			70473,
    			70474
    		],
    		"disallowed"
    	],
    	[
    		[
    			70475,
    			70477
    		],
    		"valid"
    	],
    	[
    		[
    			70478,
    			70479
    		],
    		"disallowed"
    	],
    	[
    		[
    			70480,
    			70480
    		],
    		"valid"
    	],
    	[
    		[
    			70481,
    			70486
    		],
    		"disallowed"
    	],
    	[
    		[
    			70487,
    			70487
    		],
    		"valid"
    	],
    	[
    		[
    			70488,
    			70492
    		],
    		"disallowed"
    	],
    	[
    		[
    			70493,
    			70499
    		],
    		"valid"
    	],
    	[
    		[
    			70500,
    			70501
    		],
    		"disallowed"
    	],
    	[
    		[
    			70502,
    			70508
    		],
    		"valid"
    	],
    	[
    		[
    			70509,
    			70511
    		],
    		"disallowed"
    	],
    	[
    		[
    			70512,
    			70516
    		],
    		"valid"
    	],
    	[
    		[
    			70517,
    			70783
    		],
    		"disallowed"
    	],
    	[
    		[
    			70784,
    			70853
    		],
    		"valid"
    	],
    	[
    		[
    			70854,
    			70854
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			70855,
    			70855
    		],
    		"valid"
    	],
    	[
    		[
    			70856,
    			70863
    		],
    		"disallowed"
    	],
    	[
    		[
    			70864,
    			70873
    		],
    		"valid"
    	],
    	[
    		[
    			70874,
    			71039
    		],
    		"disallowed"
    	],
    	[
    		[
    			71040,
    			71093
    		],
    		"valid"
    	],
    	[
    		[
    			71094,
    			71095
    		],
    		"disallowed"
    	],
    	[
    		[
    			71096,
    			71104
    		],
    		"valid"
    	],
    	[
    		[
    			71105,
    			71113
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			71114,
    			71127
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			71128,
    			71133
    		],
    		"valid"
    	],
    	[
    		[
    			71134,
    			71167
    		],
    		"disallowed"
    	],
    	[
    		[
    			71168,
    			71232
    		],
    		"valid"
    	],
    	[
    		[
    			71233,
    			71235
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			71236,
    			71236
    		],
    		"valid"
    	],
    	[
    		[
    			71237,
    			71247
    		],
    		"disallowed"
    	],
    	[
    		[
    			71248,
    			71257
    		],
    		"valid"
    	],
    	[
    		[
    			71258,
    			71295
    		],
    		"disallowed"
    	],
    	[
    		[
    			71296,
    			71351
    		],
    		"valid"
    	],
    	[
    		[
    			71352,
    			71359
    		],
    		"disallowed"
    	],
    	[
    		[
    			71360,
    			71369
    		],
    		"valid"
    	],
    	[
    		[
    			71370,
    			71423
    		],
    		"disallowed"
    	],
    	[
    		[
    			71424,
    			71449
    		],
    		"valid"
    	],
    	[
    		[
    			71450,
    			71452
    		],
    		"disallowed"
    	],
    	[
    		[
    			71453,
    			71467
    		],
    		"valid"
    	],
    	[
    		[
    			71468,
    			71471
    		],
    		"disallowed"
    	],
    	[
    		[
    			71472,
    			71481
    		],
    		"valid"
    	],
    	[
    		[
    			71482,
    			71487
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			71488,
    			71839
    		],
    		"disallowed"
    	],
    	[
    		[
    			71840,
    			71840
    		],
    		"mapped",
    		[
    			71872
    		]
    	],
    	[
    		[
    			71841,
    			71841
    		],
    		"mapped",
    		[
    			71873
    		]
    	],
    	[
    		[
    			71842,
    			71842
    		],
    		"mapped",
    		[
    			71874
    		]
    	],
    	[
    		[
    			71843,
    			71843
    		],
    		"mapped",
    		[
    			71875
    		]
    	],
    	[
    		[
    			71844,
    			71844
    		],
    		"mapped",
    		[
    			71876
    		]
    	],
    	[
    		[
    			71845,
    			71845
    		],
    		"mapped",
    		[
    			71877
    		]
    	],
    	[
    		[
    			71846,
    			71846
    		],
    		"mapped",
    		[
    			71878
    		]
    	],
    	[
    		[
    			71847,
    			71847
    		],
    		"mapped",
    		[
    			71879
    		]
    	],
    	[
    		[
    			71848,
    			71848
    		],
    		"mapped",
    		[
    			71880
    		]
    	],
    	[
    		[
    			71849,
    			71849
    		],
    		"mapped",
    		[
    			71881
    		]
    	],
    	[
    		[
    			71850,
    			71850
    		],
    		"mapped",
    		[
    			71882
    		]
    	],
    	[
    		[
    			71851,
    			71851
    		],
    		"mapped",
    		[
    			71883
    		]
    	],
    	[
    		[
    			71852,
    			71852
    		],
    		"mapped",
    		[
    			71884
    		]
    	],
    	[
    		[
    			71853,
    			71853
    		],
    		"mapped",
    		[
    			71885
    		]
    	],
    	[
    		[
    			71854,
    			71854
    		],
    		"mapped",
    		[
    			71886
    		]
    	],
    	[
    		[
    			71855,
    			71855
    		],
    		"mapped",
    		[
    			71887
    		]
    	],
    	[
    		[
    			71856,
    			71856
    		],
    		"mapped",
    		[
    			71888
    		]
    	],
    	[
    		[
    			71857,
    			71857
    		],
    		"mapped",
    		[
    			71889
    		]
    	],
    	[
    		[
    			71858,
    			71858
    		],
    		"mapped",
    		[
    			71890
    		]
    	],
    	[
    		[
    			71859,
    			71859
    		],
    		"mapped",
    		[
    			71891
    		]
    	],
    	[
    		[
    			71860,
    			71860
    		],
    		"mapped",
    		[
    			71892
    		]
    	],
    	[
    		[
    			71861,
    			71861
    		],
    		"mapped",
    		[
    			71893
    		]
    	],
    	[
    		[
    			71862,
    			71862
    		],
    		"mapped",
    		[
    			71894
    		]
    	],
    	[
    		[
    			71863,
    			71863
    		],
    		"mapped",
    		[
    			71895
    		]
    	],
    	[
    		[
    			71864,
    			71864
    		],
    		"mapped",
    		[
    			71896
    		]
    	],
    	[
    		[
    			71865,
    			71865
    		],
    		"mapped",
    		[
    			71897
    		]
    	],
    	[
    		[
    			71866,
    			71866
    		],
    		"mapped",
    		[
    			71898
    		]
    	],
    	[
    		[
    			71867,
    			71867
    		],
    		"mapped",
    		[
    			71899
    		]
    	],
    	[
    		[
    			71868,
    			71868
    		],
    		"mapped",
    		[
    			71900
    		]
    	],
    	[
    		[
    			71869,
    			71869
    		],
    		"mapped",
    		[
    			71901
    		]
    	],
    	[
    		[
    			71870,
    			71870
    		],
    		"mapped",
    		[
    			71902
    		]
    	],
    	[
    		[
    			71871,
    			71871
    		],
    		"mapped",
    		[
    			71903
    		]
    	],
    	[
    		[
    			71872,
    			71913
    		],
    		"valid"
    	],
    	[
    		[
    			71914,
    			71922
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			71923,
    			71934
    		],
    		"disallowed"
    	],
    	[
    		[
    			71935,
    			71935
    		],
    		"valid"
    	],
    	[
    		[
    			71936,
    			72383
    		],
    		"disallowed"
    	],
    	[
    		[
    			72384,
    			72440
    		],
    		"valid"
    	],
    	[
    		[
    			72441,
    			73727
    		],
    		"disallowed"
    	],
    	[
    		[
    			73728,
    			74606
    		],
    		"valid"
    	],
    	[
    		[
    			74607,
    			74648
    		],
    		"valid"
    	],
    	[
    		[
    			74649,
    			74649
    		],
    		"valid"
    	],
    	[
    		[
    			74650,
    			74751
    		],
    		"disallowed"
    	],
    	[
    		[
    			74752,
    			74850
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			74851,
    			74862
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			74863,
    			74863
    		],
    		"disallowed"
    	],
    	[
    		[
    			74864,
    			74867
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			74868,
    			74868
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			74869,
    			74879
    		],
    		"disallowed"
    	],
    	[
    		[
    			74880,
    			75075
    		],
    		"valid"
    	],
    	[
    		[
    			75076,
    			77823
    		],
    		"disallowed"
    	],
    	[
    		[
    			77824,
    			78894
    		],
    		"valid"
    	],
    	[
    		[
    			78895,
    			82943
    		],
    		"disallowed"
    	],
    	[
    		[
    			82944,
    			83526
    		],
    		"valid"
    	],
    	[
    		[
    			83527,
    			92159
    		],
    		"disallowed"
    	],
    	[
    		[
    			92160,
    			92728
    		],
    		"valid"
    	],
    	[
    		[
    			92729,
    			92735
    		],
    		"disallowed"
    	],
    	[
    		[
    			92736,
    			92766
    		],
    		"valid"
    	],
    	[
    		[
    			92767,
    			92767
    		],
    		"disallowed"
    	],
    	[
    		[
    			92768,
    			92777
    		],
    		"valid"
    	],
    	[
    		[
    			92778,
    			92781
    		],
    		"disallowed"
    	],
    	[
    		[
    			92782,
    			92783
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			92784,
    			92879
    		],
    		"disallowed"
    	],
    	[
    		[
    			92880,
    			92909
    		],
    		"valid"
    	],
    	[
    		[
    			92910,
    			92911
    		],
    		"disallowed"
    	],
    	[
    		[
    			92912,
    			92916
    		],
    		"valid"
    	],
    	[
    		[
    			92917,
    			92917
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			92918,
    			92927
    		],
    		"disallowed"
    	],
    	[
    		[
    			92928,
    			92982
    		],
    		"valid"
    	],
    	[
    		[
    			92983,
    			92991
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			92992,
    			92995
    		],
    		"valid"
    	],
    	[
    		[
    			92996,
    			92997
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			92998,
    			93007
    		],
    		"disallowed"
    	],
    	[
    		[
    			93008,
    			93017
    		],
    		"valid"
    	],
    	[
    		[
    			93018,
    			93018
    		],
    		"disallowed"
    	],
    	[
    		[
    			93019,
    			93025
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			93026,
    			93026
    		],
    		"disallowed"
    	],
    	[
    		[
    			93027,
    			93047
    		],
    		"valid"
    	],
    	[
    		[
    			93048,
    			93052
    		],
    		"disallowed"
    	],
    	[
    		[
    			93053,
    			93071
    		],
    		"valid"
    	],
    	[
    		[
    			93072,
    			93951
    		],
    		"disallowed"
    	],
    	[
    		[
    			93952,
    			94020
    		],
    		"valid"
    	],
    	[
    		[
    			94021,
    			94031
    		],
    		"disallowed"
    	],
    	[
    		[
    			94032,
    			94078
    		],
    		"valid"
    	],
    	[
    		[
    			94079,
    			94094
    		],
    		"disallowed"
    	],
    	[
    		[
    			94095,
    			94111
    		],
    		"valid"
    	],
    	[
    		[
    			94112,
    			110591
    		],
    		"disallowed"
    	],
    	[
    		[
    			110592,
    			110593
    		],
    		"valid"
    	],
    	[
    		[
    			110594,
    			113663
    		],
    		"disallowed"
    	],
    	[
    		[
    			113664,
    			113770
    		],
    		"valid"
    	],
    	[
    		[
    			113771,
    			113775
    		],
    		"disallowed"
    	],
    	[
    		[
    			113776,
    			113788
    		],
    		"valid"
    	],
    	[
    		[
    			113789,
    			113791
    		],
    		"disallowed"
    	],
    	[
    		[
    			113792,
    			113800
    		],
    		"valid"
    	],
    	[
    		[
    			113801,
    			113807
    		],
    		"disallowed"
    	],
    	[
    		[
    			113808,
    			113817
    		],
    		"valid"
    	],
    	[
    		[
    			113818,
    			113819
    		],
    		"disallowed"
    	],
    	[
    		[
    			113820,
    			113820
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			113821,
    			113822
    		],
    		"valid"
    	],
    	[
    		[
    			113823,
    			113823
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			113824,
    			113827
    		],
    		"ignored"
    	],
    	[
    		[
    			113828,
    			118783
    		],
    		"disallowed"
    	],
    	[
    		[
    			118784,
    			119029
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			119030,
    			119039
    		],
    		"disallowed"
    	],
    	[
    		[
    			119040,
    			119078
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			119079,
    			119080
    		],
    		"disallowed"
    	],
    	[
    		[
    			119081,
    			119081
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			119082,
    			119133
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			119134,
    			119134
    		],
    		"mapped",
    		[
    			119127,
    			119141
    		]
    	],
    	[
    		[
    			119135,
    			119135
    		],
    		"mapped",
    		[
    			119128,
    			119141
    		]
    	],
    	[
    		[
    			119136,
    			119136
    		],
    		"mapped",
    		[
    			119128,
    			119141,
    			119150
    		]
    	],
    	[
    		[
    			119137,
    			119137
    		],
    		"mapped",
    		[
    			119128,
    			119141,
    			119151
    		]
    	],
    	[
    		[
    			119138,
    			119138
    		],
    		"mapped",
    		[
    			119128,
    			119141,
    			119152
    		]
    	],
    	[
    		[
    			119139,
    			119139
    		],
    		"mapped",
    		[
    			119128,
    			119141,
    			119153
    		]
    	],
    	[
    		[
    			119140,
    			119140
    		],
    		"mapped",
    		[
    			119128,
    			119141,
    			119154
    		]
    	],
    	[
    		[
    			119141,
    			119154
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			119155,
    			119162
    		],
    		"disallowed"
    	],
    	[
    		[
    			119163,
    			119226
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			119227,
    			119227
    		],
    		"mapped",
    		[
    			119225,
    			119141
    		]
    	],
    	[
    		[
    			119228,
    			119228
    		],
    		"mapped",
    		[
    			119226,
    			119141
    		]
    	],
    	[
    		[
    			119229,
    			119229
    		],
    		"mapped",
    		[
    			119225,
    			119141,
    			119150
    		]
    	],
    	[
    		[
    			119230,
    			119230
    		],
    		"mapped",
    		[
    			119226,
    			119141,
    			119150
    		]
    	],
    	[
    		[
    			119231,
    			119231
    		],
    		"mapped",
    		[
    			119225,
    			119141,
    			119151
    		]
    	],
    	[
    		[
    			119232,
    			119232
    		],
    		"mapped",
    		[
    			119226,
    			119141,
    			119151
    		]
    	],
    	[
    		[
    			119233,
    			119261
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			119262,
    			119272
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			119273,
    			119295
    		],
    		"disallowed"
    	],
    	[
    		[
    			119296,
    			119365
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			119366,
    			119551
    		],
    		"disallowed"
    	],
    	[
    		[
    			119552,
    			119638
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			119639,
    			119647
    		],
    		"disallowed"
    	],
    	[
    		[
    			119648,
    			119665
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			119666,
    			119807
    		],
    		"disallowed"
    	],
    	[
    		[
    			119808,
    			119808
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			119809,
    			119809
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			119810,
    			119810
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			119811,
    			119811
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			119812,
    			119812
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			119813,
    			119813
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			119814,
    			119814
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			119815,
    			119815
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			119816,
    			119816
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			119817,
    			119817
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			119818,
    			119818
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			119819,
    			119819
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			119820,
    			119820
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			119821,
    			119821
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			119822,
    			119822
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			119823,
    			119823
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			119824,
    			119824
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			119825,
    			119825
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			119826,
    			119826
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			119827,
    			119827
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			119828,
    			119828
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			119829,
    			119829
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			119830,
    			119830
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			119831,
    			119831
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			119832,
    			119832
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			119833,
    			119833
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			119834,
    			119834
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			119835,
    			119835
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			119836,
    			119836
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			119837,
    			119837
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			119838,
    			119838
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			119839,
    			119839
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			119840,
    			119840
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			119841,
    			119841
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			119842,
    			119842
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			119843,
    			119843
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			119844,
    			119844
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			119845,
    			119845
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			119846,
    			119846
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			119847,
    			119847
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			119848,
    			119848
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			119849,
    			119849
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			119850,
    			119850
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			119851,
    			119851
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			119852,
    			119852
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			119853,
    			119853
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			119854,
    			119854
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			119855,
    			119855
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			119856,
    			119856
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			119857,
    			119857
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			119858,
    			119858
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			119859,
    			119859
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			119860,
    			119860
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			119861,
    			119861
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			119862,
    			119862
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			119863,
    			119863
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			119864,
    			119864
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			119865,
    			119865
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			119866,
    			119866
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			119867,
    			119867
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			119868,
    			119868
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			119869,
    			119869
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			119870,
    			119870
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			119871,
    			119871
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			119872,
    			119872
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			119873,
    			119873
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			119874,
    			119874
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			119875,
    			119875
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			119876,
    			119876
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			119877,
    			119877
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			119878,
    			119878
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			119879,
    			119879
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			119880,
    			119880
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			119881,
    			119881
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			119882,
    			119882
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			119883,
    			119883
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			119884,
    			119884
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			119885,
    			119885
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			119886,
    			119886
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			119887,
    			119887
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			119888,
    			119888
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			119889,
    			119889
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			119890,
    			119890
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			119891,
    			119891
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			119892,
    			119892
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			119893,
    			119893
    		],
    		"disallowed"
    	],
    	[
    		[
    			119894,
    			119894
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			119895,
    			119895
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			119896,
    			119896
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			119897,
    			119897
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			119898,
    			119898
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			119899,
    			119899
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			119900,
    			119900
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			119901,
    			119901
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			119902,
    			119902
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			119903,
    			119903
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			119904,
    			119904
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			119905,
    			119905
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			119906,
    			119906
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			119907,
    			119907
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			119908,
    			119908
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			119909,
    			119909
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			119910,
    			119910
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			119911,
    			119911
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			119912,
    			119912
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			119913,
    			119913
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			119914,
    			119914
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			119915,
    			119915
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			119916,
    			119916
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			119917,
    			119917
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			119918,
    			119918
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			119919,
    			119919
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			119920,
    			119920
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			119921,
    			119921
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			119922,
    			119922
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			119923,
    			119923
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			119924,
    			119924
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			119925,
    			119925
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			119926,
    			119926
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			119927,
    			119927
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			119928,
    			119928
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			119929,
    			119929
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			119930,
    			119930
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			119931,
    			119931
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			119932,
    			119932
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			119933,
    			119933
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			119934,
    			119934
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			119935,
    			119935
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			119936,
    			119936
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			119937,
    			119937
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			119938,
    			119938
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			119939,
    			119939
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			119940,
    			119940
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			119941,
    			119941
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			119942,
    			119942
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			119943,
    			119943
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			119944,
    			119944
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			119945,
    			119945
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			119946,
    			119946
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			119947,
    			119947
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			119948,
    			119948
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			119949,
    			119949
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			119950,
    			119950
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			119951,
    			119951
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			119952,
    			119952
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			119953,
    			119953
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			119954,
    			119954
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			119955,
    			119955
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			119956,
    			119956
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			119957,
    			119957
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			119958,
    			119958
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			119959,
    			119959
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			119960,
    			119960
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			119961,
    			119961
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			119962,
    			119962
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			119963,
    			119963
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			119964,
    			119964
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			119965,
    			119965
    		],
    		"disallowed"
    	],
    	[
    		[
    			119966,
    			119966
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			119967,
    			119967
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			119968,
    			119969
    		],
    		"disallowed"
    	],
    	[
    		[
    			119970,
    			119970
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			119971,
    			119972
    		],
    		"disallowed"
    	],
    	[
    		[
    			119973,
    			119973
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			119974,
    			119974
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			119975,
    			119976
    		],
    		"disallowed"
    	],
    	[
    		[
    			119977,
    			119977
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			119978,
    			119978
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			119979,
    			119979
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			119980,
    			119980
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			119981,
    			119981
    		],
    		"disallowed"
    	],
    	[
    		[
    			119982,
    			119982
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			119983,
    			119983
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			119984,
    			119984
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			119985,
    			119985
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			119986,
    			119986
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			119987,
    			119987
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			119988,
    			119988
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			119989,
    			119989
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			119990,
    			119990
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			119991,
    			119991
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			119992,
    			119992
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			119993,
    			119993
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			119994,
    			119994
    		],
    		"disallowed"
    	],
    	[
    		[
    			119995,
    			119995
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			119996,
    			119996
    		],
    		"disallowed"
    	],
    	[
    		[
    			119997,
    			119997
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			119998,
    			119998
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			119999,
    			119999
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120000,
    			120000
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120001,
    			120001
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120002,
    			120002
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120003,
    			120003
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120004,
    			120004
    		],
    		"disallowed"
    	],
    	[
    		[
    			120005,
    			120005
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120006,
    			120006
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120007,
    			120007
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			120008,
    			120008
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120009,
    			120009
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120010,
    			120010
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120011,
    			120011
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120012,
    			120012
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120013,
    			120013
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120014,
    			120014
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120015,
    			120015
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			120016,
    			120016
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120017,
    			120017
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120018,
    			120018
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			120019,
    			120019
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120020,
    			120020
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120021,
    			120021
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120022,
    			120022
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120023,
    			120023
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			120024,
    			120024
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			120025,
    			120025
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120026,
    			120026
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120027,
    			120027
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120028,
    			120028
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120029,
    			120029
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120030,
    			120030
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120031,
    			120031
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120032,
    			120032
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120033,
    			120033
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			120034,
    			120034
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120035,
    			120035
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120036,
    			120036
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120037,
    			120037
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120038,
    			120038
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120039,
    			120039
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120040,
    			120040
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120041,
    			120041
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			120042,
    			120042
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120043,
    			120043
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120044,
    			120044
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			120045,
    			120045
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120046,
    			120046
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120047,
    			120047
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120048,
    			120048
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120049,
    			120049
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			120050,
    			120050
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			120051,
    			120051
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120052,
    			120052
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120053,
    			120053
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120054,
    			120054
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120055,
    			120055
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120056,
    			120056
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120057,
    			120057
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120058,
    			120058
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120059,
    			120059
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			120060,
    			120060
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120061,
    			120061
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120062,
    			120062
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120063,
    			120063
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120064,
    			120064
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120065,
    			120065
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120066,
    			120066
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120067,
    			120067
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			120068,
    			120068
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120069,
    			120069
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120070,
    			120070
    		],
    		"disallowed"
    	],
    	[
    		[
    			120071,
    			120071
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120072,
    			120072
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120073,
    			120073
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120074,
    			120074
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120075,
    			120076
    		],
    		"disallowed"
    	],
    	[
    		[
    			120077,
    			120077
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120078,
    			120078
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120079,
    			120079
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120080,
    			120080
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120081,
    			120081
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120082,
    			120082
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120083,
    			120083
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120084,
    			120084
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120085,
    			120085
    		],
    		"disallowed"
    	],
    	[
    		[
    			120086,
    			120086
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120087,
    			120087
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120088,
    			120088
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120089,
    			120089
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120090,
    			120090
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120091,
    			120091
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120092,
    			120092
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120093,
    			120093
    		],
    		"disallowed"
    	],
    	[
    		[
    			120094,
    			120094
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120095,
    			120095
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120096,
    			120096
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			120097,
    			120097
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120098,
    			120098
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120099,
    			120099
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120100,
    			120100
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120101,
    			120101
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			120102,
    			120102
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			120103,
    			120103
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120104,
    			120104
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120105,
    			120105
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120106,
    			120106
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120107,
    			120107
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120108,
    			120108
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120109,
    			120109
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120110,
    			120110
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120111,
    			120111
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			120112,
    			120112
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120113,
    			120113
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120114,
    			120114
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120115,
    			120115
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120116,
    			120116
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120117,
    			120117
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120118,
    			120118
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120119,
    			120119
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			120120,
    			120120
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120121,
    			120121
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120122,
    			120122
    		],
    		"disallowed"
    	],
    	[
    		[
    			120123,
    			120123
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120124,
    			120124
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120125,
    			120125
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120126,
    			120126
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120127,
    			120127
    		],
    		"disallowed"
    	],
    	[
    		[
    			120128,
    			120128
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			120129,
    			120129
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120130,
    			120130
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120131,
    			120131
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120132,
    			120132
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120133,
    			120133
    		],
    		"disallowed"
    	],
    	[
    		[
    			120134,
    			120134
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120135,
    			120137
    		],
    		"disallowed"
    	],
    	[
    		[
    			120138,
    			120138
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120139,
    			120139
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120140,
    			120140
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120141,
    			120141
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120142,
    			120142
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120143,
    			120143
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120144,
    			120144
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120145,
    			120145
    		],
    		"disallowed"
    	],
    	[
    		[
    			120146,
    			120146
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120147,
    			120147
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120148,
    			120148
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			120149,
    			120149
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120150,
    			120150
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120151,
    			120151
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120152,
    			120152
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120153,
    			120153
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			120154,
    			120154
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			120155,
    			120155
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120156,
    			120156
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120157,
    			120157
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120158,
    			120158
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120159,
    			120159
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120160,
    			120160
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120161,
    			120161
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120162,
    			120162
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120163,
    			120163
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			120164,
    			120164
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120165,
    			120165
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120166,
    			120166
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120167,
    			120167
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120168,
    			120168
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120169,
    			120169
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120170,
    			120170
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120171,
    			120171
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			120172,
    			120172
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120173,
    			120173
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120174,
    			120174
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			120175,
    			120175
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120176,
    			120176
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120177,
    			120177
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120178,
    			120178
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120179,
    			120179
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			120180,
    			120180
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			120181,
    			120181
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120182,
    			120182
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120183,
    			120183
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120184,
    			120184
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120185,
    			120185
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120186,
    			120186
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120187,
    			120187
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120188,
    			120188
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120189,
    			120189
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			120190,
    			120190
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120191,
    			120191
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120192,
    			120192
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120193,
    			120193
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120194,
    			120194
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120195,
    			120195
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120196,
    			120196
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120197,
    			120197
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			120198,
    			120198
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120199,
    			120199
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120200,
    			120200
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			120201,
    			120201
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120202,
    			120202
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120203,
    			120203
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120204,
    			120204
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120205,
    			120205
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			120206,
    			120206
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			120207,
    			120207
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120208,
    			120208
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120209,
    			120209
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120210,
    			120210
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120211,
    			120211
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120212,
    			120212
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120213,
    			120213
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120214,
    			120214
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120215,
    			120215
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			120216,
    			120216
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120217,
    			120217
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120218,
    			120218
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120219,
    			120219
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120220,
    			120220
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120221,
    			120221
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120222,
    			120222
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120223,
    			120223
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			120224,
    			120224
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120225,
    			120225
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120226,
    			120226
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			120227,
    			120227
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120228,
    			120228
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120229,
    			120229
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120230,
    			120230
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120231,
    			120231
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			120232,
    			120232
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			120233,
    			120233
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120234,
    			120234
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120235,
    			120235
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120236,
    			120236
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120237,
    			120237
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120238,
    			120238
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120239,
    			120239
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120240,
    			120240
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120241,
    			120241
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			120242,
    			120242
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120243,
    			120243
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120244,
    			120244
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120245,
    			120245
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120246,
    			120246
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120247,
    			120247
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120248,
    			120248
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120249,
    			120249
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			120250,
    			120250
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120251,
    			120251
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120252,
    			120252
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			120253,
    			120253
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120254,
    			120254
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120255,
    			120255
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120256,
    			120256
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120257,
    			120257
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			120258,
    			120258
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			120259,
    			120259
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120260,
    			120260
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120261,
    			120261
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120262,
    			120262
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120263,
    			120263
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120264,
    			120264
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120265,
    			120265
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120266,
    			120266
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120267,
    			120267
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			120268,
    			120268
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120269,
    			120269
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120270,
    			120270
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120271,
    			120271
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120272,
    			120272
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120273,
    			120273
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120274,
    			120274
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120275,
    			120275
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			120276,
    			120276
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120277,
    			120277
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120278,
    			120278
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			120279,
    			120279
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120280,
    			120280
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120281,
    			120281
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120282,
    			120282
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120283,
    			120283
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			120284,
    			120284
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			120285,
    			120285
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120286,
    			120286
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120287,
    			120287
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120288,
    			120288
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120289,
    			120289
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120290,
    			120290
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120291,
    			120291
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120292,
    			120292
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120293,
    			120293
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			120294,
    			120294
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120295,
    			120295
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120296,
    			120296
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120297,
    			120297
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120298,
    			120298
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120299,
    			120299
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120300,
    			120300
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120301,
    			120301
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			120302,
    			120302
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120303,
    			120303
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120304,
    			120304
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			120305,
    			120305
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120306,
    			120306
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120307,
    			120307
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120308,
    			120308
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120309,
    			120309
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			120310,
    			120310
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			120311,
    			120311
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120312,
    			120312
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120313,
    			120313
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120314,
    			120314
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120315,
    			120315
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120316,
    			120316
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120317,
    			120317
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120318,
    			120318
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120319,
    			120319
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			120320,
    			120320
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120321,
    			120321
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120322,
    			120322
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120323,
    			120323
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120324,
    			120324
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120325,
    			120325
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120326,
    			120326
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120327,
    			120327
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			120328,
    			120328
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120329,
    			120329
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120330,
    			120330
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			120331,
    			120331
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120332,
    			120332
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120333,
    			120333
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120334,
    			120334
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120335,
    			120335
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			120336,
    			120336
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			120337,
    			120337
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120338,
    			120338
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120339,
    			120339
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120340,
    			120340
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120341,
    			120341
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120342,
    			120342
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120343,
    			120343
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120344,
    			120344
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120345,
    			120345
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			120346,
    			120346
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120347,
    			120347
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120348,
    			120348
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120349,
    			120349
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120350,
    			120350
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120351,
    			120351
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120352,
    			120352
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120353,
    			120353
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			120354,
    			120354
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120355,
    			120355
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120356,
    			120356
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			120357,
    			120357
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120358,
    			120358
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120359,
    			120359
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120360,
    			120360
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120361,
    			120361
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			120362,
    			120362
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			120363,
    			120363
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120364,
    			120364
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120365,
    			120365
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120366,
    			120366
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120367,
    			120367
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120368,
    			120368
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120369,
    			120369
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120370,
    			120370
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120371,
    			120371
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			120372,
    			120372
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120373,
    			120373
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120374,
    			120374
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120375,
    			120375
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120376,
    			120376
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120377,
    			120377
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120378,
    			120378
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120379,
    			120379
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			120380,
    			120380
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120381,
    			120381
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120382,
    			120382
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			120383,
    			120383
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120384,
    			120384
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120385,
    			120385
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120386,
    			120386
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120387,
    			120387
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			120388,
    			120388
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			120389,
    			120389
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120390,
    			120390
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120391,
    			120391
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120392,
    			120392
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120393,
    			120393
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120394,
    			120394
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120395,
    			120395
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120396,
    			120396
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120397,
    			120397
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			120398,
    			120398
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120399,
    			120399
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120400,
    			120400
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120401,
    			120401
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120402,
    			120402
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120403,
    			120403
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120404,
    			120404
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120405,
    			120405
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			120406,
    			120406
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120407,
    			120407
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120408,
    			120408
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			120409,
    			120409
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120410,
    			120410
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120411,
    			120411
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120412,
    			120412
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120413,
    			120413
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			120414,
    			120414
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			120415,
    			120415
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120416,
    			120416
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120417,
    			120417
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120418,
    			120418
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120419,
    			120419
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120420,
    			120420
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120421,
    			120421
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120422,
    			120422
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120423,
    			120423
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			120424,
    			120424
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120425,
    			120425
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120426,
    			120426
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120427,
    			120427
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120428,
    			120428
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120429,
    			120429
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120430,
    			120430
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120431,
    			120431
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			120432,
    			120432
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120433,
    			120433
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120434,
    			120434
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			120435,
    			120435
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120436,
    			120436
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120437,
    			120437
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120438,
    			120438
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120439,
    			120439
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			120440,
    			120440
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			120441,
    			120441
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120442,
    			120442
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120443,
    			120443
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120444,
    			120444
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120445,
    			120445
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120446,
    			120446
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120447,
    			120447
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120448,
    			120448
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120449,
    			120449
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			120450,
    			120450
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120451,
    			120451
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120452,
    			120452
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120453,
    			120453
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120454,
    			120454
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120455,
    			120455
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120456,
    			120456
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120457,
    			120457
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			120458,
    			120458
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			120459,
    			120459
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			120460,
    			120460
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			120461,
    			120461
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			120462,
    			120462
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			120463,
    			120463
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			120464,
    			120464
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			120465,
    			120465
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			120466,
    			120466
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			120467,
    			120467
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			120468,
    			120468
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			120469,
    			120469
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			120470,
    			120470
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			120471,
    			120471
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			120472,
    			120472
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			120473,
    			120473
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			120474,
    			120474
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			120475,
    			120475
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			120476,
    			120476
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			120477,
    			120477
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			120478,
    			120478
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			120479,
    			120479
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			120480,
    			120480
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			120481,
    			120481
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			120482,
    			120482
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			120483,
    			120483
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			120484,
    			120484
    		],
    		"mapped",
    		[
    			305
    		]
    	],
    	[
    		[
    			120485,
    			120485
    		],
    		"mapped",
    		[
    			567
    		]
    	],
    	[
    		[
    			120486,
    			120487
    		],
    		"disallowed"
    	],
    	[
    		[
    			120488,
    			120488
    		],
    		"mapped",
    		[
    			945
    		]
    	],
    	[
    		[
    			120489,
    			120489
    		],
    		"mapped",
    		[
    			946
    		]
    	],
    	[
    		[
    			120490,
    			120490
    		],
    		"mapped",
    		[
    			947
    		]
    	],
    	[
    		[
    			120491,
    			120491
    		],
    		"mapped",
    		[
    			948
    		]
    	],
    	[
    		[
    			120492,
    			120492
    		],
    		"mapped",
    		[
    			949
    		]
    	],
    	[
    		[
    			120493,
    			120493
    		],
    		"mapped",
    		[
    			950
    		]
    	],
    	[
    		[
    			120494,
    			120494
    		],
    		"mapped",
    		[
    			951
    		]
    	],
    	[
    		[
    			120495,
    			120495
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120496,
    			120496
    		],
    		"mapped",
    		[
    			953
    		]
    	],
    	[
    		[
    			120497,
    			120497
    		],
    		"mapped",
    		[
    			954
    		]
    	],
    	[
    		[
    			120498,
    			120498
    		],
    		"mapped",
    		[
    			955
    		]
    	],
    	[
    		[
    			120499,
    			120499
    		],
    		"mapped",
    		[
    			956
    		]
    	],
    	[
    		[
    			120500,
    			120500
    		],
    		"mapped",
    		[
    			957
    		]
    	],
    	[
    		[
    			120501,
    			120501
    		],
    		"mapped",
    		[
    			958
    		]
    	],
    	[
    		[
    			120502,
    			120502
    		],
    		"mapped",
    		[
    			959
    		]
    	],
    	[
    		[
    			120503,
    			120503
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			120504,
    			120504
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			120505,
    			120505
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120506,
    			120506
    		],
    		"mapped",
    		[
    			963
    		]
    	],
    	[
    		[
    			120507,
    			120507
    		],
    		"mapped",
    		[
    			964
    		]
    	],
    	[
    		[
    			120508,
    			120508
    		],
    		"mapped",
    		[
    			965
    		]
    	],
    	[
    		[
    			120509,
    			120509
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			120510,
    			120510
    		],
    		"mapped",
    		[
    			967
    		]
    	],
    	[
    		[
    			120511,
    			120511
    		],
    		"mapped",
    		[
    			968
    		]
    	],
    	[
    		[
    			120512,
    			120512
    		],
    		"mapped",
    		[
    			969
    		]
    	],
    	[
    		[
    			120513,
    			120513
    		],
    		"mapped",
    		[
    			8711
    		]
    	],
    	[
    		[
    			120514,
    			120514
    		],
    		"mapped",
    		[
    			945
    		]
    	],
    	[
    		[
    			120515,
    			120515
    		],
    		"mapped",
    		[
    			946
    		]
    	],
    	[
    		[
    			120516,
    			120516
    		],
    		"mapped",
    		[
    			947
    		]
    	],
    	[
    		[
    			120517,
    			120517
    		],
    		"mapped",
    		[
    			948
    		]
    	],
    	[
    		[
    			120518,
    			120518
    		],
    		"mapped",
    		[
    			949
    		]
    	],
    	[
    		[
    			120519,
    			120519
    		],
    		"mapped",
    		[
    			950
    		]
    	],
    	[
    		[
    			120520,
    			120520
    		],
    		"mapped",
    		[
    			951
    		]
    	],
    	[
    		[
    			120521,
    			120521
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120522,
    			120522
    		],
    		"mapped",
    		[
    			953
    		]
    	],
    	[
    		[
    			120523,
    			120523
    		],
    		"mapped",
    		[
    			954
    		]
    	],
    	[
    		[
    			120524,
    			120524
    		],
    		"mapped",
    		[
    			955
    		]
    	],
    	[
    		[
    			120525,
    			120525
    		],
    		"mapped",
    		[
    			956
    		]
    	],
    	[
    		[
    			120526,
    			120526
    		],
    		"mapped",
    		[
    			957
    		]
    	],
    	[
    		[
    			120527,
    			120527
    		],
    		"mapped",
    		[
    			958
    		]
    	],
    	[
    		[
    			120528,
    			120528
    		],
    		"mapped",
    		[
    			959
    		]
    	],
    	[
    		[
    			120529,
    			120529
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			120530,
    			120530
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			120531,
    			120532
    		],
    		"mapped",
    		[
    			963
    		]
    	],
    	[
    		[
    			120533,
    			120533
    		],
    		"mapped",
    		[
    			964
    		]
    	],
    	[
    		[
    			120534,
    			120534
    		],
    		"mapped",
    		[
    			965
    		]
    	],
    	[
    		[
    			120535,
    			120535
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			120536,
    			120536
    		],
    		"mapped",
    		[
    			967
    		]
    	],
    	[
    		[
    			120537,
    			120537
    		],
    		"mapped",
    		[
    			968
    		]
    	],
    	[
    		[
    			120538,
    			120538
    		],
    		"mapped",
    		[
    			969
    		]
    	],
    	[
    		[
    			120539,
    			120539
    		],
    		"mapped",
    		[
    			8706
    		]
    	],
    	[
    		[
    			120540,
    			120540
    		],
    		"mapped",
    		[
    			949
    		]
    	],
    	[
    		[
    			120541,
    			120541
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120542,
    			120542
    		],
    		"mapped",
    		[
    			954
    		]
    	],
    	[
    		[
    			120543,
    			120543
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			120544,
    			120544
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			120545,
    			120545
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			120546,
    			120546
    		],
    		"mapped",
    		[
    			945
    		]
    	],
    	[
    		[
    			120547,
    			120547
    		],
    		"mapped",
    		[
    			946
    		]
    	],
    	[
    		[
    			120548,
    			120548
    		],
    		"mapped",
    		[
    			947
    		]
    	],
    	[
    		[
    			120549,
    			120549
    		],
    		"mapped",
    		[
    			948
    		]
    	],
    	[
    		[
    			120550,
    			120550
    		],
    		"mapped",
    		[
    			949
    		]
    	],
    	[
    		[
    			120551,
    			120551
    		],
    		"mapped",
    		[
    			950
    		]
    	],
    	[
    		[
    			120552,
    			120552
    		],
    		"mapped",
    		[
    			951
    		]
    	],
    	[
    		[
    			120553,
    			120553
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120554,
    			120554
    		],
    		"mapped",
    		[
    			953
    		]
    	],
    	[
    		[
    			120555,
    			120555
    		],
    		"mapped",
    		[
    			954
    		]
    	],
    	[
    		[
    			120556,
    			120556
    		],
    		"mapped",
    		[
    			955
    		]
    	],
    	[
    		[
    			120557,
    			120557
    		],
    		"mapped",
    		[
    			956
    		]
    	],
    	[
    		[
    			120558,
    			120558
    		],
    		"mapped",
    		[
    			957
    		]
    	],
    	[
    		[
    			120559,
    			120559
    		],
    		"mapped",
    		[
    			958
    		]
    	],
    	[
    		[
    			120560,
    			120560
    		],
    		"mapped",
    		[
    			959
    		]
    	],
    	[
    		[
    			120561,
    			120561
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			120562,
    			120562
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			120563,
    			120563
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120564,
    			120564
    		],
    		"mapped",
    		[
    			963
    		]
    	],
    	[
    		[
    			120565,
    			120565
    		],
    		"mapped",
    		[
    			964
    		]
    	],
    	[
    		[
    			120566,
    			120566
    		],
    		"mapped",
    		[
    			965
    		]
    	],
    	[
    		[
    			120567,
    			120567
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			120568,
    			120568
    		],
    		"mapped",
    		[
    			967
    		]
    	],
    	[
    		[
    			120569,
    			120569
    		],
    		"mapped",
    		[
    			968
    		]
    	],
    	[
    		[
    			120570,
    			120570
    		],
    		"mapped",
    		[
    			969
    		]
    	],
    	[
    		[
    			120571,
    			120571
    		],
    		"mapped",
    		[
    			8711
    		]
    	],
    	[
    		[
    			120572,
    			120572
    		],
    		"mapped",
    		[
    			945
    		]
    	],
    	[
    		[
    			120573,
    			120573
    		],
    		"mapped",
    		[
    			946
    		]
    	],
    	[
    		[
    			120574,
    			120574
    		],
    		"mapped",
    		[
    			947
    		]
    	],
    	[
    		[
    			120575,
    			120575
    		],
    		"mapped",
    		[
    			948
    		]
    	],
    	[
    		[
    			120576,
    			120576
    		],
    		"mapped",
    		[
    			949
    		]
    	],
    	[
    		[
    			120577,
    			120577
    		],
    		"mapped",
    		[
    			950
    		]
    	],
    	[
    		[
    			120578,
    			120578
    		],
    		"mapped",
    		[
    			951
    		]
    	],
    	[
    		[
    			120579,
    			120579
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120580,
    			120580
    		],
    		"mapped",
    		[
    			953
    		]
    	],
    	[
    		[
    			120581,
    			120581
    		],
    		"mapped",
    		[
    			954
    		]
    	],
    	[
    		[
    			120582,
    			120582
    		],
    		"mapped",
    		[
    			955
    		]
    	],
    	[
    		[
    			120583,
    			120583
    		],
    		"mapped",
    		[
    			956
    		]
    	],
    	[
    		[
    			120584,
    			120584
    		],
    		"mapped",
    		[
    			957
    		]
    	],
    	[
    		[
    			120585,
    			120585
    		],
    		"mapped",
    		[
    			958
    		]
    	],
    	[
    		[
    			120586,
    			120586
    		],
    		"mapped",
    		[
    			959
    		]
    	],
    	[
    		[
    			120587,
    			120587
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			120588,
    			120588
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			120589,
    			120590
    		],
    		"mapped",
    		[
    			963
    		]
    	],
    	[
    		[
    			120591,
    			120591
    		],
    		"mapped",
    		[
    			964
    		]
    	],
    	[
    		[
    			120592,
    			120592
    		],
    		"mapped",
    		[
    			965
    		]
    	],
    	[
    		[
    			120593,
    			120593
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			120594,
    			120594
    		],
    		"mapped",
    		[
    			967
    		]
    	],
    	[
    		[
    			120595,
    			120595
    		],
    		"mapped",
    		[
    			968
    		]
    	],
    	[
    		[
    			120596,
    			120596
    		],
    		"mapped",
    		[
    			969
    		]
    	],
    	[
    		[
    			120597,
    			120597
    		],
    		"mapped",
    		[
    			8706
    		]
    	],
    	[
    		[
    			120598,
    			120598
    		],
    		"mapped",
    		[
    			949
    		]
    	],
    	[
    		[
    			120599,
    			120599
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120600,
    			120600
    		],
    		"mapped",
    		[
    			954
    		]
    	],
    	[
    		[
    			120601,
    			120601
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			120602,
    			120602
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			120603,
    			120603
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			120604,
    			120604
    		],
    		"mapped",
    		[
    			945
    		]
    	],
    	[
    		[
    			120605,
    			120605
    		],
    		"mapped",
    		[
    			946
    		]
    	],
    	[
    		[
    			120606,
    			120606
    		],
    		"mapped",
    		[
    			947
    		]
    	],
    	[
    		[
    			120607,
    			120607
    		],
    		"mapped",
    		[
    			948
    		]
    	],
    	[
    		[
    			120608,
    			120608
    		],
    		"mapped",
    		[
    			949
    		]
    	],
    	[
    		[
    			120609,
    			120609
    		],
    		"mapped",
    		[
    			950
    		]
    	],
    	[
    		[
    			120610,
    			120610
    		],
    		"mapped",
    		[
    			951
    		]
    	],
    	[
    		[
    			120611,
    			120611
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120612,
    			120612
    		],
    		"mapped",
    		[
    			953
    		]
    	],
    	[
    		[
    			120613,
    			120613
    		],
    		"mapped",
    		[
    			954
    		]
    	],
    	[
    		[
    			120614,
    			120614
    		],
    		"mapped",
    		[
    			955
    		]
    	],
    	[
    		[
    			120615,
    			120615
    		],
    		"mapped",
    		[
    			956
    		]
    	],
    	[
    		[
    			120616,
    			120616
    		],
    		"mapped",
    		[
    			957
    		]
    	],
    	[
    		[
    			120617,
    			120617
    		],
    		"mapped",
    		[
    			958
    		]
    	],
    	[
    		[
    			120618,
    			120618
    		],
    		"mapped",
    		[
    			959
    		]
    	],
    	[
    		[
    			120619,
    			120619
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			120620,
    			120620
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			120621,
    			120621
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120622,
    			120622
    		],
    		"mapped",
    		[
    			963
    		]
    	],
    	[
    		[
    			120623,
    			120623
    		],
    		"mapped",
    		[
    			964
    		]
    	],
    	[
    		[
    			120624,
    			120624
    		],
    		"mapped",
    		[
    			965
    		]
    	],
    	[
    		[
    			120625,
    			120625
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			120626,
    			120626
    		],
    		"mapped",
    		[
    			967
    		]
    	],
    	[
    		[
    			120627,
    			120627
    		],
    		"mapped",
    		[
    			968
    		]
    	],
    	[
    		[
    			120628,
    			120628
    		],
    		"mapped",
    		[
    			969
    		]
    	],
    	[
    		[
    			120629,
    			120629
    		],
    		"mapped",
    		[
    			8711
    		]
    	],
    	[
    		[
    			120630,
    			120630
    		],
    		"mapped",
    		[
    			945
    		]
    	],
    	[
    		[
    			120631,
    			120631
    		],
    		"mapped",
    		[
    			946
    		]
    	],
    	[
    		[
    			120632,
    			120632
    		],
    		"mapped",
    		[
    			947
    		]
    	],
    	[
    		[
    			120633,
    			120633
    		],
    		"mapped",
    		[
    			948
    		]
    	],
    	[
    		[
    			120634,
    			120634
    		],
    		"mapped",
    		[
    			949
    		]
    	],
    	[
    		[
    			120635,
    			120635
    		],
    		"mapped",
    		[
    			950
    		]
    	],
    	[
    		[
    			120636,
    			120636
    		],
    		"mapped",
    		[
    			951
    		]
    	],
    	[
    		[
    			120637,
    			120637
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120638,
    			120638
    		],
    		"mapped",
    		[
    			953
    		]
    	],
    	[
    		[
    			120639,
    			120639
    		],
    		"mapped",
    		[
    			954
    		]
    	],
    	[
    		[
    			120640,
    			120640
    		],
    		"mapped",
    		[
    			955
    		]
    	],
    	[
    		[
    			120641,
    			120641
    		],
    		"mapped",
    		[
    			956
    		]
    	],
    	[
    		[
    			120642,
    			120642
    		],
    		"mapped",
    		[
    			957
    		]
    	],
    	[
    		[
    			120643,
    			120643
    		],
    		"mapped",
    		[
    			958
    		]
    	],
    	[
    		[
    			120644,
    			120644
    		],
    		"mapped",
    		[
    			959
    		]
    	],
    	[
    		[
    			120645,
    			120645
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			120646,
    			120646
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			120647,
    			120648
    		],
    		"mapped",
    		[
    			963
    		]
    	],
    	[
    		[
    			120649,
    			120649
    		],
    		"mapped",
    		[
    			964
    		]
    	],
    	[
    		[
    			120650,
    			120650
    		],
    		"mapped",
    		[
    			965
    		]
    	],
    	[
    		[
    			120651,
    			120651
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			120652,
    			120652
    		],
    		"mapped",
    		[
    			967
    		]
    	],
    	[
    		[
    			120653,
    			120653
    		],
    		"mapped",
    		[
    			968
    		]
    	],
    	[
    		[
    			120654,
    			120654
    		],
    		"mapped",
    		[
    			969
    		]
    	],
    	[
    		[
    			120655,
    			120655
    		],
    		"mapped",
    		[
    			8706
    		]
    	],
    	[
    		[
    			120656,
    			120656
    		],
    		"mapped",
    		[
    			949
    		]
    	],
    	[
    		[
    			120657,
    			120657
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120658,
    			120658
    		],
    		"mapped",
    		[
    			954
    		]
    	],
    	[
    		[
    			120659,
    			120659
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			120660,
    			120660
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			120661,
    			120661
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			120662,
    			120662
    		],
    		"mapped",
    		[
    			945
    		]
    	],
    	[
    		[
    			120663,
    			120663
    		],
    		"mapped",
    		[
    			946
    		]
    	],
    	[
    		[
    			120664,
    			120664
    		],
    		"mapped",
    		[
    			947
    		]
    	],
    	[
    		[
    			120665,
    			120665
    		],
    		"mapped",
    		[
    			948
    		]
    	],
    	[
    		[
    			120666,
    			120666
    		],
    		"mapped",
    		[
    			949
    		]
    	],
    	[
    		[
    			120667,
    			120667
    		],
    		"mapped",
    		[
    			950
    		]
    	],
    	[
    		[
    			120668,
    			120668
    		],
    		"mapped",
    		[
    			951
    		]
    	],
    	[
    		[
    			120669,
    			120669
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120670,
    			120670
    		],
    		"mapped",
    		[
    			953
    		]
    	],
    	[
    		[
    			120671,
    			120671
    		],
    		"mapped",
    		[
    			954
    		]
    	],
    	[
    		[
    			120672,
    			120672
    		],
    		"mapped",
    		[
    			955
    		]
    	],
    	[
    		[
    			120673,
    			120673
    		],
    		"mapped",
    		[
    			956
    		]
    	],
    	[
    		[
    			120674,
    			120674
    		],
    		"mapped",
    		[
    			957
    		]
    	],
    	[
    		[
    			120675,
    			120675
    		],
    		"mapped",
    		[
    			958
    		]
    	],
    	[
    		[
    			120676,
    			120676
    		],
    		"mapped",
    		[
    			959
    		]
    	],
    	[
    		[
    			120677,
    			120677
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			120678,
    			120678
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			120679,
    			120679
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120680,
    			120680
    		],
    		"mapped",
    		[
    			963
    		]
    	],
    	[
    		[
    			120681,
    			120681
    		],
    		"mapped",
    		[
    			964
    		]
    	],
    	[
    		[
    			120682,
    			120682
    		],
    		"mapped",
    		[
    			965
    		]
    	],
    	[
    		[
    			120683,
    			120683
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			120684,
    			120684
    		],
    		"mapped",
    		[
    			967
    		]
    	],
    	[
    		[
    			120685,
    			120685
    		],
    		"mapped",
    		[
    			968
    		]
    	],
    	[
    		[
    			120686,
    			120686
    		],
    		"mapped",
    		[
    			969
    		]
    	],
    	[
    		[
    			120687,
    			120687
    		],
    		"mapped",
    		[
    			8711
    		]
    	],
    	[
    		[
    			120688,
    			120688
    		],
    		"mapped",
    		[
    			945
    		]
    	],
    	[
    		[
    			120689,
    			120689
    		],
    		"mapped",
    		[
    			946
    		]
    	],
    	[
    		[
    			120690,
    			120690
    		],
    		"mapped",
    		[
    			947
    		]
    	],
    	[
    		[
    			120691,
    			120691
    		],
    		"mapped",
    		[
    			948
    		]
    	],
    	[
    		[
    			120692,
    			120692
    		],
    		"mapped",
    		[
    			949
    		]
    	],
    	[
    		[
    			120693,
    			120693
    		],
    		"mapped",
    		[
    			950
    		]
    	],
    	[
    		[
    			120694,
    			120694
    		],
    		"mapped",
    		[
    			951
    		]
    	],
    	[
    		[
    			120695,
    			120695
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120696,
    			120696
    		],
    		"mapped",
    		[
    			953
    		]
    	],
    	[
    		[
    			120697,
    			120697
    		],
    		"mapped",
    		[
    			954
    		]
    	],
    	[
    		[
    			120698,
    			120698
    		],
    		"mapped",
    		[
    			955
    		]
    	],
    	[
    		[
    			120699,
    			120699
    		],
    		"mapped",
    		[
    			956
    		]
    	],
    	[
    		[
    			120700,
    			120700
    		],
    		"mapped",
    		[
    			957
    		]
    	],
    	[
    		[
    			120701,
    			120701
    		],
    		"mapped",
    		[
    			958
    		]
    	],
    	[
    		[
    			120702,
    			120702
    		],
    		"mapped",
    		[
    			959
    		]
    	],
    	[
    		[
    			120703,
    			120703
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			120704,
    			120704
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			120705,
    			120706
    		],
    		"mapped",
    		[
    			963
    		]
    	],
    	[
    		[
    			120707,
    			120707
    		],
    		"mapped",
    		[
    			964
    		]
    	],
    	[
    		[
    			120708,
    			120708
    		],
    		"mapped",
    		[
    			965
    		]
    	],
    	[
    		[
    			120709,
    			120709
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			120710,
    			120710
    		],
    		"mapped",
    		[
    			967
    		]
    	],
    	[
    		[
    			120711,
    			120711
    		],
    		"mapped",
    		[
    			968
    		]
    	],
    	[
    		[
    			120712,
    			120712
    		],
    		"mapped",
    		[
    			969
    		]
    	],
    	[
    		[
    			120713,
    			120713
    		],
    		"mapped",
    		[
    			8706
    		]
    	],
    	[
    		[
    			120714,
    			120714
    		],
    		"mapped",
    		[
    			949
    		]
    	],
    	[
    		[
    			120715,
    			120715
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120716,
    			120716
    		],
    		"mapped",
    		[
    			954
    		]
    	],
    	[
    		[
    			120717,
    			120717
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			120718,
    			120718
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			120719,
    			120719
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			120720,
    			120720
    		],
    		"mapped",
    		[
    			945
    		]
    	],
    	[
    		[
    			120721,
    			120721
    		],
    		"mapped",
    		[
    			946
    		]
    	],
    	[
    		[
    			120722,
    			120722
    		],
    		"mapped",
    		[
    			947
    		]
    	],
    	[
    		[
    			120723,
    			120723
    		],
    		"mapped",
    		[
    			948
    		]
    	],
    	[
    		[
    			120724,
    			120724
    		],
    		"mapped",
    		[
    			949
    		]
    	],
    	[
    		[
    			120725,
    			120725
    		],
    		"mapped",
    		[
    			950
    		]
    	],
    	[
    		[
    			120726,
    			120726
    		],
    		"mapped",
    		[
    			951
    		]
    	],
    	[
    		[
    			120727,
    			120727
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120728,
    			120728
    		],
    		"mapped",
    		[
    			953
    		]
    	],
    	[
    		[
    			120729,
    			120729
    		],
    		"mapped",
    		[
    			954
    		]
    	],
    	[
    		[
    			120730,
    			120730
    		],
    		"mapped",
    		[
    			955
    		]
    	],
    	[
    		[
    			120731,
    			120731
    		],
    		"mapped",
    		[
    			956
    		]
    	],
    	[
    		[
    			120732,
    			120732
    		],
    		"mapped",
    		[
    			957
    		]
    	],
    	[
    		[
    			120733,
    			120733
    		],
    		"mapped",
    		[
    			958
    		]
    	],
    	[
    		[
    			120734,
    			120734
    		],
    		"mapped",
    		[
    			959
    		]
    	],
    	[
    		[
    			120735,
    			120735
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			120736,
    			120736
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			120737,
    			120737
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120738,
    			120738
    		],
    		"mapped",
    		[
    			963
    		]
    	],
    	[
    		[
    			120739,
    			120739
    		],
    		"mapped",
    		[
    			964
    		]
    	],
    	[
    		[
    			120740,
    			120740
    		],
    		"mapped",
    		[
    			965
    		]
    	],
    	[
    		[
    			120741,
    			120741
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			120742,
    			120742
    		],
    		"mapped",
    		[
    			967
    		]
    	],
    	[
    		[
    			120743,
    			120743
    		],
    		"mapped",
    		[
    			968
    		]
    	],
    	[
    		[
    			120744,
    			120744
    		],
    		"mapped",
    		[
    			969
    		]
    	],
    	[
    		[
    			120745,
    			120745
    		],
    		"mapped",
    		[
    			8711
    		]
    	],
    	[
    		[
    			120746,
    			120746
    		],
    		"mapped",
    		[
    			945
    		]
    	],
    	[
    		[
    			120747,
    			120747
    		],
    		"mapped",
    		[
    			946
    		]
    	],
    	[
    		[
    			120748,
    			120748
    		],
    		"mapped",
    		[
    			947
    		]
    	],
    	[
    		[
    			120749,
    			120749
    		],
    		"mapped",
    		[
    			948
    		]
    	],
    	[
    		[
    			120750,
    			120750
    		],
    		"mapped",
    		[
    			949
    		]
    	],
    	[
    		[
    			120751,
    			120751
    		],
    		"mapped",
    		[
    			950
    		]
    	],
    	[
    		[
    			120752,
    			120752
    		],
    		"mapped",
    		[
    			951
    		]
    	],
    	[
    		[
    			120753,
    			120753
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120754,
    			120754
    		],
    		"mapped",
    		[
    			953
    		]
    	],
    	[
    		[
    			120755,
    			120755
    		],
    		"mapped",
    		[
    			954
    		]
    	],
    	[
    		[
    			120756,
    			120756
    		],
    		"mapped",
    		[
    			955
    		]
    	],
    	[
    		[
    			120757,
    			120757
    		],
    		"mapped",
    		[
    			956
    		]
    	],
    	[
    		[
    			120758,
    			120758
    		],
    		"mapped",
    		[
    			957
    		]
    	],
    	[
    		[
    			120759,
    			120759
    		],
    		"mapped",
    		[
    			958
    		]
    	],
    	[
    		[
    			120760,
    			120760
    		],
    		"mapped",
    		[
    			959
    		]
    	],
    	[
    		[
    			120761,
    			120761
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			120762,
    			120762
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			120763,
    			120764
    		],
    		"mapped",
    		[
    			963
    		]
    	],
    	[
    		[
    			120765,
    			120765
    		],
    		"mapped",
    		[
    			964
    		]
    	],
    	[
    		[
    			120766,
    			120766
    		],
    		"mapped",
    		[
    			965
    		]
    	],
    	[
    		[
    			120767,
    			120767
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			120768,
    			120768
    		],
    		"mapped",
    		[
    			967
    		]
    	],
    	[
    		[
    			120769,
    			120769
    		],
    		"mapped",
    		[
    			968
    		]
    	],
    	[
    		[
    			120770,
    			120770
    		],
    		"mapped",
    		[
    			969
    		]
    	],
    	[
    		[
    			120771,
    			120771
    		],
    		"mapped",
    		[
    			8706
    		]
    	],
    	[
    		[
    			120772,
    			120772
    		],
    		"mapped",
    		[
    			949
    		]
    	],
    	[
    		[
    			120773,
    			120773
    		],
    		"mapped",
    		[
    			952
    		]
    	],
    	[
    		[
    			120774,
    			120774
    		],
    		"mapped",
    		[
    			954
    		]
    	],
    	[
    		[
    			120775,
    			120775
    		],
    		"mapped",
    		[
    			966
    		]
    	],
    	[
    		[
    			120776,
    			120776
    		],
    		"mapped",
    		[
    			961
    		]
    	],
    	[
    		[
    			120777,
    			120777
    		],
    		"mapped",
    		[
    			960
    		]
    	],
    	[
    		[
    			120778,
    			120779
    		],
    		"mapped",
    		[
    			989
    		]
    	],
    	[
    		[
    			120780,
    			120781
    		],
    		"disallowed"
    	],
    	[
    		[
    			120782,
    			120782
    		],
    		"mapped",
    		[
    			48
    		]
    	],
    	[
    		[
    			120783,
    			120783
    		],
    		"mapped",
    		[
    			49
    		]
    	],
    	[
    		[
    			120784,
    			120784
    		],
    		"mapped",
    		[
    			50
    		]
    	],
    	[
    		[
    			120785,
    			120785
    		],
    		"mapped",
    		[
    			51
    		]
    	],
    	[
    		[
    			120786,
    			120786
    		],
    		"mapped",
    		[
    			52
    		]
    	],
    	[
    		[
    			120787,
    			120787
    		],
    		"mapped",
    		[
    			53
    		]
    	],
    	[
    		[
    			120788,
    			120788
    		],
    		"mapped",
    		[
    			54
    		]
    	],
    	[
    		[
    			120789,
    			120789
    		],
    		"mapped",
    		[
    			55
    		]
    	],
    	[
    		[
    			120790,
    			120790
    		],
    		"mapped",
    		[
    			56
    		]
    	],
    	[
    		[
    			120791,
    			120791
    		],
    		"mapped",
    		[
    			57
    		]
    	],
    	[
    		[
    			120792,
    			120792
    		],
    		"mapped",
    		[
    			48
    		]
    	],
    	[
    		[
    			120793,
    			120793
    		],
    		"mapped",
    		[
    			49
    		]
    	],
    	[
    		[
    			120794,
    			120794
    		],
    		"mapped",
    		[
    			50
    		]
    	],
    	[
    		[
    			120795,
    			120795
    		],
    		"mapped",
    		[
    			51
    		]
    	],
    	[
    		[
    			120796,
    			120796
    		],
    		"mapped",
    		[
    			52
    		]
    	],
    	[
    		[
    			120797,
    			120797
    		],
    		"mapped",
    		[
    			53
    		]
    	],
    	[
    		[
    			120798,
    			120798
    		],
    		"mapped",
    		[
    			54
    		]
    	],
    	[
    		[
    			120799,
    			120799
    		],
    		"mapped",
    		[
    			55
    		]
    	],
    	[
    		[
    			120800,
    			120800
    		],
    		"mapped",
    		[
    			56
    		]
    	],
    	[
    		[
    			120801,
    			120801
    		],
    		"mapped",
    		[
    			57
    		]
    	],
    	[
    		[
    			120802,
    			120802
    		],
    		"mapped",
    		[
    			48
    		]
    	],
    	[
    		[
    			120803,
    			120803
    		],
    		"mapped",
    		[
    			49
    		]
    	],
    	[
    		[
    			120804,
    			120804
    		],
    		"mapped",
    		[
    			50
    		]
    	],
    	[
    		[
    			120805,
    			120805
    		],
    		"mapped",
    		[
    			51
    		]
    	],
    	[
    		[
    			120806,
    			120806
    		],
    		"mapped",
    		[
    			52
    		]
    	],
    	[
    		[
    			120807,
    			120807
    		],
    		"mapped",
    		[
    			53
    		]
    	],
    	[
    		[
    			120808,
    			120808
    		],
    		"mapped",
    		[
    			54
    		]
    	],
    	[
    		[
    			120809,
    			120809
    		],
    		"mapped",
    		[
    			55
    		]
    	],
    	[
    		[
    			120810,
    			120810
    		],
    		"mapped",
    		[
    			56
    		]
    	],
    	[
    		[
    			120811,
    			120811
    		],
    		"mapped",
    		[
    			57
    		]
    	],
    	[
    		[
    			120812,
    			120812
    		],
    		"mapped",
    		[
    			48
    		]
    	],
    	[
    		[
    			120813,
    			120813
    		],
    		"mapped",
    		[
    			49
    		]
    	],
    	[
    		[
    			120814,
    			120814
    		],
    		"mapped",
    		[
    			50
    		]
    	],
    	[
    		[
    			120815,
    			120815
    		],
    		"mapped",
    		[
    			51
    		]
    	],
    	[
    		[
    			120816,
    			120816
    		],
    		"mapped",
    		[
    			52
    		]
    	],
    	[
    		[
    			120817,
    			120817
    		],
    		"mapped",
    		[
    			53
    		]
    	],
    	[
    		[
    			120818,
    			120818
    		],
    		"mapped",
    		[
    			54
    		]
    	],
    	[
    		[
    			120819,
    			120819
    		],
    		"mapped",
    		[
    			55
    		]
    	],
    	[
    		[
    			120820,
    			120820
    		],
    		"mapped",
    		[
    			56
    		]
    	],
    	[
    		[
    			120821,
    			120821
    		],
    		"mapped",
    		[
    			57
    		]
    	],
    	[
    		[
    			120822,
    			120822
    		],
    		"mapped",
    		[
    			48
    		]
    	],
    	[
    		[
    			120823,
    			120823
    		],
    		"mapped",
    		[
    			49
    		]
    	],
    	[
    		[
    			120824,
    			120824
    		],
    		"mapped",
    		[
    			50
    		]
    	],
    	[
    		[
    			120825,
    			120825
    		],
    		"mapped",
    		[
    			51
    		]
    	],
    	[
    		[
    			120826,
    			120826
    		],
    		"mapped",
    		[
    			52
    		]
    	],
    	[
    		[
    			120827,
    			120827
    		],
    		"mapped",
    		[
    			53
    		]
    	],
    	[
    		[
    			120828,
    			120828
    		],
    		"mapped",
    		[
    			54
    		]
    	],
    	[
    		[
    			120829,
    			120829
    		],
    		"mapped",
    		[
    			55
    		]
    	],
    	[
    		[
    			120830,
    			120830
    		],
    		"mapped",
    		[
    			56
    		]
    	],
    	[
    		[
    			120831,
    			120831
    		],
    		"mapped",
    		[
    			57
    		]
    	],
    	[
    		[
    			120832,
    			121343
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			121344,
    			121398
    		],
    		"valid"
    	],
    	[
    		[
    			121399,
    			121402
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			121403,
    			121452
    		],
    		"valid"
    	],
    	[
    		[
    			121453,
    			121460
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			121461,
    			121461
    		],
    		"valid"
    	],
    	[
    		[
    			121462,
    			121475
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			121476,
    			121476
    		],
    		"valid"
    	],
    	[
    		[
    			121477,
    			121483
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			121484,
    			121498
    		],
    		"disallowed"
    	],
    	[
    		[
    			121499,
    			121503
    		],
    		"valid"
    	],
    	[
    		[
    			121504,
    			121504
    		],
    		"disallowed"
    	],
    	[
    		[
    			121505,
    			121519
    		],
    		"valid"
    	],
    	[
    		[
    			121520,
    			124927
    		],
    		"disallowed"
    	],
    	[
    		[
    			124928,
    			125124
    		],
    		"valid"
    	],
    	[
    		[
    			125125,
    			125126
    		],
    		"disallowed"
    	],
    	[
    		[
    			125127,
    			125135
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			125136,
    			125142
    		],
    		"valid"
    	],
    	[
    		[
    			125143,
    			126463
    		],
    		"disallowed"
    	],
    	[
    		[
    			126464,
    			126464
    		],
    		"mapped",
    		[
    			1575
    		]
    	],
    	[
    		[
    			126465,
    			126465
    		],
    		"mapped",
    		[
    			1576
    		]
    	],
    	[
    		[
    			126466,
    			126466
    		],
    		"mapped",
    		[
    			1580
    		]
    	],
    	[
    		[
    			126467,
    			126467
    		],
    		"mapped",
    		[
    			1583
    		]
    	],
    	[
    		[
    			126468,
    			126468
    		],
    		"disallowed"
    	],
    	[
    		[
    			126469,
    			126469
    		],
    		"mapped",
    		[
    			1608
    		]
    	],
    	[
    		[
    			126470,
    			126470
    		],
    		"mapped",
    		[
    			1586
    		]
    	],
    	[
    		[
    			126471,
    			126471
    		],
    		"mapped",
    		[
    			1581
    		]
    	],
    	[
    		[
    			126472,
    			126472
    		],
    		"mapped",
    		[
    			1591
    		]
    	],
    	[
    		[
    			126473,
    			126473
    		],
    		"mapped",
    		[
    			1610
    		]
    	],
    	[
    		[
    			126474,
    			126474
    		],
    		"mapped",
    		[
    			1603
    		]
    	],
    	[
    		[
    			126475,
    			126475
    		],
    		"mapped",
    		[
    			1604
    		]
    	],
    	[
    		[
    			126476,
    			126476
    		],
    		"mapped",
    		[
    			1605
    		]
    	],
    	[
    		[
    			126477,
    			126477
    		],
    		"mapped",
    		[
    			1606
    		]
    	],
    	[
    		[
    			126478,
    			126478
    		],
    		"mapped",
    		[
    			1587
    		]
    	],
    	[
    		[
    			126479,
    			126479
    		],
    		"mapped",
    		[
    			1593
    		]
    	],
    	[
    		[
    			126480,
    			126480
    		],
    		"mapped",
    		[
    			1601
    		]
    	],
    	[
    		[
    			126481,
    			126481
    		],
    		"mapped",
    		[
    			1589
    		]
    	],
    	[
    		[
    			126482,
    			126482
    		],
    		"mapped",
    		[
    			1602
    		]
    	],
    	[
    		[
    			126483,
    			126483
    		],
    		"mapped",
    		[
    			1585
    		]
    	],
    	[
    		[
    			126484,
    			126484
    		],
    		"mapped",
    		[
    			1588
    		]
    	],
    	[
    		[
    			126485,
    			126485
    		],
    		"mapped",
    		[
    			1578
    		]
    	],
    	[
    		[
    			126486,
    			126486
    		],
    		"mapped",
    		[
    			1579
    		]
    	],
    	[
    		[
    			126487,
    			126487
    		],
    		"mapped",
    		[
    			1582
    		]
    	],
    	[
    		[
    			126488,
    			126488
    		],
    		"mapped",
    		[
    			1584
    		]
    	],
    	[
    		[
    			126489,
    			126489
    		],
    		"mapped",
    		[
    			1590
    		]
    	],
    	[
    		[
    			126490,
    			126490
    		],
    		"mapped",
    		[
    			1592
    		]
    	],
    	[
    		[
    			126491,
    			126491
    		],
    		"mapped",
    		[
    			1594
    		]
    	],
    	[
    		[
    			126492,
    			126492
    		],
    		"mapped",
    		[
    			1646
    		]
    	],
    	[
    		[
    			126493,
    			126493
    		],
    		"mapped",
    		[
    			1722
    		]
    	],
    	[
    		[
    			126494,
    			126494
    		],
    		"mapped",
    		[
    			1697
    		]
    	],
    	[
    		[
    			126495,
    			126495
    		],
    		"mapped",
    		[
    			1647
    		]
    	],
    	[
    		[
    			126496,
    			126496
    		],
    		"disallowed"
    	],
    	[
    		[
    			126497,
    			126497
    		],
    		"mapped",
    		[
    			1576
    		]
    	],
    	[
    		[
    			126498,
    			126498
    		],
    		"mapped",
    		[
    			1580
    		]
    	],
    	[
    		[
    			126499,
    			126499
    		],
    		"disallowed"
    	],
    	[
    		[
    			126500,
    			126500
    		],
    		"mapped",
    		[
    			1607
    		]
    	],
    	[
    		[
    			126501,
    			126502
    		],
    		"disallowed"
    	],
    	[
    		[
    			126503,
    			126503
    		],
    		"mapped",
    		[
    			1581
    		]
    	],
    	[
    		[
    			126504,
    			126504
    		],
    		"disallowed"
    	],
    	[
    		[
    			126505,
    			126505
    		],
    		"mapped",
    		[
    			1610
    		]
    	],
    	[
    		[
    			126506,
    			126506
    		],
    		"mapped",
    		[
    			1603
    		]
    	],
    	[
    		[
    			126507,
    			126507
    		],
    		"mapped",
    		[
    			1604
    		]
    	],
    	[
    		[
    			126508,
    			126508
    		],
    		"mapped",
    		[
    			1605
    		]
    	],
    	[
    		[
    			126509,
    			126509
    		],
    		"mapped",
    		[
    			1606
    		]
    	],
    	[
    		[
    			126510,
    			126510
    		],
    		"mapped",
    		[
    			1587
    		]
    	],
    	[
    		[
    			126511,
    			126511
    		],
    		"mapped",
    		[
    			1593
    		]
    	],
    	[
    		[
    			126512,
    			126512
    		],
    		"mapped",
    		[
    			1601
    		]
    	],
    	[
    		[
    			126513,
    			126513
    		],
    		"mapped",
    		[
    			1589
    		]
    	],
    	[
    		[
    			126514,
    			126514
    		],
    		"mapped",
    		[
    			1602
    		]
    	],
    	[
    		[
    			126515,
    			126515
    		],
    		"disallowed"
    	],
    	[
    		[
    			126516,
    			126516
    		],
    		"mapped",
    		[
    			1588
    		]
    	],
    	[
    		[
    			126517,
    			126517
    		],
    		"mapped",
    		[
    			1578
    		]
    	],
    	[
    		[
    			126518,
    			126518
    		],
    		"mapped",
    		[
    			1579
    		]
    	],
    	[
    		[
    			126519,
    			126519
    		],
    		"mapped",
    		[
    			1582
    		]
    	],
    	[
    		[
    			126520,
    			126520
    		],
    		"disallowed"
    	],
    	[
    		[
    			126521,
    			126521
    		],
    		"mapped",
    		[
    			1590
    		]
    	],
    	[
    		[
    			126522,
    			126522
    		],
    		"disallowed"
    	],
    	[
    		[
    			126523,
    			126523
    		],
    		"mapped",
    		[
    			1594
    		]
    	],
    	[
    		[
    			126524,
    			126529
    		],
    		"disallowed"
    	],
    	[
    		[
    			126530,
    			126530
    		],
    		"mapped",
    		[
    			1580
    		]
    	],
    	[
    		[
    			126531,
    			126534
    		],
    		"disallowed"
    	],
    	[
    		[
    			126535,
    			126535
    		],
    		"mapped",
    		[
    			1581
    		]
    	],
    	[
    		[
    			126536,
    			126536
    		],
    		"disallowed"
    	],
    	[
    		[
    			126537,
    			126537
    		],
    		"mapped",
    		[
    			1610
    		]
    	],
    	[
    		[
    			126538,
    			126538
    		],
    		"disallowed"
    	],
    	[
    		[
    			126539,
    			126539
    		],
    		"mapped",
    		[
    			1604
    		]
    	],
    	[
    		[
    			126540,
    			126540
    		],
    		"disallowed"
    	],
    	[
    		[
    			126541,
    			126541
    		],
    		"mapped",
    		[
    			1606
    		]
    	],
    	[
    		[
    			126542,
    			126542
    		],
    		"mapped",
    		[
    			1587
    		]
    	],
    	[
    		[
    			126543,
    			126543
    		],
    		"mapped",
    		[
    			1593
    		]
    	],
    	[
    		[
    			126544,
    			126544
    		],
    		"disallowed"
    	],
    	[
    		[
    			126545,
    			126545
    		],
    		"mapped",
    		[
    			1589
    		]
    	],
    	[
    		[
    			126546,
    			126546
    		],
    		"mapped",
    		[
    			1602
    		]
    	],
    	[
    		[
    			126547,
    			126547
    		],
    		"disallowed"
    	],
    	[
    		[
    			126548,
    			126548
    		],
    		"mapped",
    		[
    			1588
    		]
    	],
    	[
    		[
    			126549,
    			126550
    		],
    		"disallowed"
    	],
    	[
    		[
    			126551,
    			126551
    		],
    		"mapped",
    		[
    			1582
    		]
    	],
    	[
    		[
    			126552,
    			126552
    		],
    		"disallowed"
    	],
    	[
    		[
    			126553,
    			126553
    		],
    		"mapped",
    		[
    			1590
    		]
    	],
    	[
    		[
    			126554,
    			126554
    		],
    		"disallowed"
    	],
    	[
    		[
    			126555,
    			126555
    		],
    		"mapped",
    		[
    			1594
    		]
    	],
    	[
    		[
    			126556,
    			126556
    		],
    		"disallowed"
    	],
    	[
    		[
    			126557,
    			126557
    		],
    		"mapped",
    		[
    			1722
    		]
    	],
    	[
    		[
    			126558,
    			126558
    		],
    		"disallowed"
    	],
    	[
    		[
    			126559,
    			126559
    		],
    		"mapped",
    		[
    			1647
    		]
    	],
    	[
    		[
    			126560,
    			126560
    		],
    		"disallowed"
    	],
    	[
    		[
    			126561,
    			126561
    		],
    		"mapped",
    		[
    			1576
    		]
    	],
    	[
    		[
    			126562,
    			126562
    		],
    		"mapped",
    		[
    			1580
    		]
    	],
    	[
    		[
    			126563,
    			126563
    		],
    		"disallowed"
    	],
    	[
    		[
    			126564,
    			126564
    		],
    		"mapped",
    		[
    			1607
    		]
    	],
    	[
    		[
    			126565,
    			126566
    		],
    		"disallowed"
    	],
    	[
    		[
    			126567,
    			126567
    		],
    		"mapped",
    		[
    			1581
    		]
    	],
    	[
    		[
    			126568,
    			126568
    		],
    		"mapped",
    		[
    			1591
    		]
    	],
    	[
    		[
    			126569,
    			126569
    		],
    		"mapped",
    		[
    			1610
    		]
    	],
    	[
    		[
    			126570,
    			126570
    		],
    		"mapped",
    		[
    			1603
    		]
    	],
    	[
    		[
    			126571,
    			126571
    		],
    		"disallowed"
    	],
    	[
    		[
    			126572,
    			126572
    		],
    		"mapped",
    		[
    			1605
    		]
    	],
    	[
    		[
    			126573,
    			126573
    		],
    		"mapped",
    		[
    			1606
    		]
    	],
    	[
    		[
    			126574,
    			126574
    		],
    		"mapped",
    		[
    			1587
    		]
    	],
    	[
    		[
    			126575,
    			126575
    		],
    		"mapped",
    		[
    			1593
    		]
    	],
    	[
    		[
    			126576,
    			126576
    		],
    		"mapped",
    		[
    			1601
    		]
    	],
    	[
    		[
    			126577,
    			126577
    		],
    		"mapped",
    		[
    			1589
    		]
    	],
    	[
    		[
    			126578,
    			126578
    		],
    		"mapped",
    		[
    			1602
    		]
    	],
    	[
    		[
    			126579,
    			126579
    		],
    		"disallowed"
    	],
    	[
    		[
    			126580,
    			126580
    		],
    		"mapped",
    		[
    			1588
    		]
    	],
    	[
    		[
    			126581,
    			126581
    		],
    		"mapped",
    		[
    			1578
    		]
    	],
    	[
    		[
    			126582,
    			126582
    		],
    		"mapped",
    		[
    			1579
    		]
    	],
    	[
    		[
    			126583,
    			126583
    		],
    		"mapped",
    		[
    			1582
    		]
    	],
    	[
    		[
    			126584,
    			126584
    		],
    		"disallowed"
    	],
    	[
    		[
    			126585,
    			126585
    		],
    		"mapped",
    		[
    			1590
    		]
    	],
    	[
    		[
    			126586,
    			126586
    		],
    		"mapped",
    		[
    			1592
    		]
    	],
    	[
    		[
    			126587,
    			126587
    		],
    		"mapped",
    		[
    			1594
    		]
    	],
    	[
    		[
    			126588,
    			126588
    		],
    		"mapped",
    		[
    			1646
    		]
    	],
    	[
    		[
    			126589,
    			126589
    		],
    		"disallowed"
    	],
    	[
    		[
    			126590,
    			126590
    		],
    		"mapped",
    		[
    			1697
    		]
    	],
    	[
    		[
    			126591,
    			126591
    		],
    		"disallowed"
    	],
    	[
    		[
    			126592,
    			126592
    		],
    		"mapped",
    		[
    			1575
    		]
    	],
    	[
    		[
    			126593,
    			126593
    		],
    		"mapped",
    		[
    			1576
    		]
    	],
    	[
    		[
    			126594,
    			126594
    		],
    		"mapped",
    		[
    			1580
    		]
    	],
    	[
    		[
    			126595,
    			126595
    		],
    		"mapped",
    		[
    			1583
    		]
    	],
    	[
    		[
    			126596,
    			126596
    		],
    		"mapped",
    		[
    			1607
    		]
    	],
    	[
    		[
    			126597,
    			126597
    		],
    		"mapped",
    		[
    			1608
    		]
    	],
    	[
    		[
    			126598,
    			126598
    		],
    		"mapped",
    		[
    			1586
    		]
    	],
    	[
    		[
    			126599,
    			126599
    		],
    		"mapped",
    		[
    			1581
    		]
    	],
    	[
    		[
    			126600,
    			126600
    		],
    		"mapped",
    		[
    			1591
    		]
    	],
    	[
    		[
    			126601,
    			126601
    		],
    		"mapped",
    		[
    			1610
    		]
    	],
    	[
    		[
    			126602,
    			126602
    		],
    		"disallowed"
    	],
    	[
    		[
    			126603,
    			126603
    		],
    		"mapped",
    		[
    			1604
    		]
    	],
    	[
    		[
    			126604,
    			126604
    		],
    		"mapped",
    		[
    			1605
    		]
    	],
    	[
    		[
    			126605,
    			126605
    		],
    		"mapped",
    		[
    			1606
    		]
    	],
    	[
    		[
    			126606,
    			126606
    		],
    		"mapped",
    		[
    			1587
    		]
    	],
    	[
    		[
    			126607,
    			126607
    		],
    		"mapped",
    		[
    			1593
    		]
    	],
    	[
    		[
    			126608,
    			126608
    		],
    		"mapped",
    		[
    			1601
    		]
    	],
    	[
    		[
    			126609,
    			126609
    		],
    		"mapped",
    		[
    			1589
    		]
    	],
    	[
    		[
    			126610,
    			126610
    		],
    		"mapped",
    		[
    			1602
    		]
    	],
    	[
    		[
    			126611,
    			126611
    		],
    		"mapped",
    		[
    			1585
    		]
    	],
    	[
    		[
    			126612,
    			126612
    		],
    		"mapped",
    		[
    			1588
    		]
    	],
    	[
    		[
    			126613,
    			126613
    		],
    		"mapped",
    		[
    			1578
    		]
    	],
    	[
    		[
    			126614,
    			126614
    		],
    		"mapped",
    		[
    			1579
    		]
    	],
    	[
    		[
    			126615,
    			126615
    		],
    		"mapped",
    		[
    			1582
    		]
    	],
    	[
    		[
    			126616,
    			126616
    		],
    		"mapped",
    		[
    			1584
    		]
    	],
    	[
    		[
    			126617,
    			126617
    		],
    		"mapped",
    		[
    			1590
    		]
    	],
    	[
    		[
    			126618,
    			126618
    		],
    		"mapped",
    		[
    			1592
    		]
    	],
    	[
    		[
    			126619,
    			126619
    		],
    		"mapped",
    		[
    			1594
    		]
    	],
    	[
    		[
    			126620,
    			126624
    		],
    		"disallowed"
    	],
    	[
    		[
    			126625,
    			126625
    		],
    		"mapped",
    		[
    			1576
    		]
    	],
    	[
    		[
    			126626,
    			126626
    		],
    		"mapped",
    		[
    			1580
    		]
    	],
    	[
    		[
    			126627,
    			126627
    		],
    		"mapped",
    		[
    			1583
    		]
    	],
    	[
    		[
    			126628,
    			126628
    		],
    		"disallowed"
    	],
    	[
    		[
    			126629,
    			126629
    		],
    		"mapped",
    		[
    			1608
    		]
    	],
    	[
    		[
    			126630,
    			126630
    		],
    		"mapped",
    		[
    			1586
    		]
    	],
    	[
    		[
    			126631,
    			126631
    		],
    		"mapped",
    		[
    			1581
    		]
    	],
    	[
    		[
    			126632,
    			126632
    		],
    		"mapped",
    		[
    			1591
    		]
    	],
    	[
    		[
    			126633,
    			126633
    		],
    		"mapped",
    		[
    			1610
    		]
    	],
    	[
    		[
    			126634,
    			126634
    		],
    		"disallowed"
    	],
    	[
    		[
    			126635,
    			126635
    		],
    		"mapped",
    		[
    			1604
    		]
    	],
    	[
    		[
    			126636,
    			126636
    		],
    		"mapped",
    		[
    			1605
    		]
    	],
    	[
    		[
    			126637,
    			126637
    		],
    		"mapped",
    		[
    			1606
    		]
    	],
    	[
    		[
    			126638,
    			126638
    		],
    		"mapped",
    		[
    			1587
    		]
    	],
    	[
    		[
    			126639,
    			126639
    		],
    		"mapped",
    		[
    			1593
    		]
    	],
    	[
    		[
    			126640,
    			126640
    		],
    		"mapped",
    		[
    			1601
    		]
    	],
    	[
    		[
    			126641,
    			126641
    		],
    		"mapped",
    		[
    			1589
    		]
    	],
    	[
    		[
    			126642,
    			126642
    		],
    		"mapped",
    		[
    			1602
    		]
    	],
    	[
    		[
    			126643,
    			126643
    		],
    		"mapped",
    		[
    			1585
    		]
    	],
    	[
    		[
    			126644,
    			126644
    		],
    		"mapped",
    		[
    			1588
    		]
    	],
    	[
    		[
    			126645,
    			126645
    		],
    		"mapped",
    		[
    			1578
    		]
    	],
    	[
    		[
    			126646,
    			126646
    		],
    		"mapped",
    		[
    			1579
    		]
    	],
    	[
    		[
    			126647,
    			126647
    		],
    		"mapped",
    		[
    			1582
    		]
    	],
    	[
    		[
    			126648,
    			126648
    		],
    		"mapped",
    		[
    			1584
    		]
    	],
    	[
    		[
    			126649,
    			126649
    		],
    		"mapped",
    		[
    			1590
    		]
    	],
    	[
    		[
    			126650,
    			126650
    		],
    		"mapped",
    		[
    			1592
    		]
    	],
    	[
    		[
    			126651,
    			126651
    		],
    		"mapped",
    		[
    			1594
    		]
    	],
    	[
    		[
    			126652,
    			126703
    		],
    		"disallowed"
    	],
    	[
    		[
    			126704,
    			126705
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			126706,
    			126975
    		],
    		"disallowed"
    	],
    	[
    		[
    			126976,
    			127019
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127020,
    			127023
    		],
    		"disallowed"
    	],
    	[
    		[
    			127024,
    			127123
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127124,
    			127135
    		],
    		"disallowed"
    	],
    	[
    		[
    			127136,
    			127150
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127151,
    			127152
    		],
    		"disallowed"
    	],
    	[
    		[
    			127153,
    			127166
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127167,
    			127167
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127168,
    			127168
    		],
    		"disallowed"
    	],
    	[
    		[
    			127169,
    			127183
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127184,
    			127184
    		],
    		"disallowed"
    	],
    	[
    		[
    			127185,
    			127199
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127200,
    			127221
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127222,
    			127231
    		],
    		"disallowed"
    	],
    	[
    		[
    			127232,
    			127232
    		],
    		"disallowed"
    	],
    	[
    		[
    			127233,
    			127233
    		],
    		"disallowed_STD3_mapped",
    		[
    			48,
    			44
    		]
    	],
    	[
    		[
    			127234,
    			127234
    		],
    		"disallowed_STD3_mapped",
    		[
    			49,
    			44
    		]
    	],
    	[
    		[
    			127235,
    			127235
    		],
    		"disallowed_STD3_mapped",
    		[
    			50,
    			44
    		]
    	],
    	[
    		[
    			127236,
    			127236
    		],
    		"disallowed_STD3_mapped",
    		[
    			51,
    			44
    		]
    	],
    	[
    		[
    			127237,
    			127237
    		],
    		"disallowed_STD3_mapped",
    		[
    			52,
    			44
    		]
    	],
    	[
    		[
    			127238,
    			127238
    		],
    		"disallowed_STD3_mapped",
    		[
    			53,
    			44
    		]
    	],
    	[
    		[
    			127239,
    			127239
    		],
    		"disallowed_STD3_mapped",
    		[
    			54,
    			44
    		]
    	],
    	[
    		[
    			127240,
    			127240
    		],
    		"disallowed_STD3_mapped",
    		[
    			55,
    			44
    		]
    	],
    	[
    		[
    			127241,
    			127241
    		],
    		"disallowed_STD3_mapped",
    		[
    			56,
    			44
    		]
    	],
    	[
    		[
    			127242,
    			127242
    		],
    		"disallowed_STD3_mapped",
    		[
    			57,
    			44
    		]
    	],
    	[
    		[
    			127243,
    			127244
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127245,
    			127247
    		],
    		"disallowed"
    	],
    	[
    		[
    			127248,
    			127248
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			97,
    			41
    		]
    	],
    	[
    		[
    			127249,
    			127249
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			98,
    			41
    		]
    	],
    	[
    		[
    			127250,
    			127250
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			99,
    			41
    		]
    	],
    	[
    		[
    			127251,
    			127251
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			100,
    			41
    		]
    	],
    	[
    		[
    			127252,
    			127252
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			101,
    			41
    		]
    	],
    	[
    		[
    			127253,
    			127253
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			102,
    			41
    		]
    	],
    	[
    		[
    			127254,
    			127254
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			103,
    			41
    		]
    	],
    	[
    		[
    			127255,
    			127255
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			104,
    			41
    		]
    	],
    	[
    		[
    			127256,
    			127256
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			105,
    			41
    		]
    	],
    	[
    		[
    			127257,
    			127257
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			106,
    			41
    		]
    	],
    	[
    		[
    			127258,
    			127258
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			107,
    			41
    		]
    	],
    	[
    		[
    			127259,
    			127259
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			108,
    			41
    		]
    	],
    	[
    		[
    			127260,
    			127260
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			109,
    			41
    		]
    	],
    	[
    		[
    			127261,
    			127261
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			110,
    			41
    		]
    	],
    	[
    		[
    			127262,
    			127262
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			111,
    			41
    		]
    	],
    	[
    		[
    			127263,
    			127263
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			112,
    			41
    		]
    	],
    	[
    		[
    			127264,
    			127264
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			113,
    			41
    		]
    	],
    	[
    		[
    			127265,
    			127265
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			114,
    			41
    		]
    	],
    	[
    		[
    			127266,
    			127266
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			115,
    			41
    		]
    	],
    	[
    		[
    			127267,
    			127267
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			116,
    			41
    		]
    	],
    	[
    		[
    			127268,
    			127268
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			117,
    			41
    		]
    	],
    	[
    		[
    			127269,
    			127269
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			118,
    			41
    		]
    	],
    	[
    		[
    			127270,
    			127270
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			119,
    			41
    		]
    	],
    	[
    		[
    			127271,
    			127271
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			120,
    			41
    		]
    	],
    	[
    		[
    			127272,
    			127272
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			121,
    			41
    		]
    	],
    	[
    		[
    			127273,
    			127273
    		],
    		"disallowed_STD3_mapped",
    		[
    			40,
    			122,
    			41
    		]
    	],
    	[
    		[
    			127274,
    			127274
    		],
    		"mapped",
    		[
    			12308,
    			115,
    			12309
    		]
    	],
    	[
    		[
    			127275,
    			127275
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			127276,
    			127276
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			127277,
    			127277
    		],
    		"mapped",
    		[
    			99,
    			100
    		]
    	],
    	[
    		[
    			127278,
    			127278
    		],
    		"mapped",
    		[
    			119,
    			122
    		]
    	],
    	[
    		[
    			127279,
    			127279
    		],
    		"disallowed"
    	],
    	[
    		[
    			127280,
    			127280
    		],
    		"mapped",
    		[
    			97
    		]
    	],
    	[
    		[
    			127281,
    			127281
    		],
    		"mapped",
    		[
    			98
    		]
    	],
    	[
    		[
    			127282,
    			127282
    		],
    		"mapped",
    		[
    			99
    		]
    	],
    	[
    		[
    			127283,
    			127283
    		],
    		"mapped",
    		[
    			100
    		]
    	],
    	[
    		[
    			127284,
    			127284
    		],
    		"mapped",
    		[
    			101
    		]
    	],
    	[
    		[
    			127285,
    			127285
    		],
    		"mapped",
    		[
    			102
    		]
    	],
    	[
    		[
    			127286,
    			127286
    		],
    		"mapped",
    		[
    			103
    		]
    	],
    	[
    		[
    			127287,
    			127287
    		],
    		"mapped",
    		[
    			104
    		]
    	],
    	[
    		[
    			127288,
    			127288
    		],
    		"mapped",
    		[
    			105
    		]
    	],
    	[
    		[
    			127289,
    			127289
    		],
    		"mapped",
    		[
    			106
    		]
    	],
    	[
    		[
    			127290,
    			127290
    		],
    		"mapped",
    		[
    			107
    		]
    	],
    	[
    		[
    			127291,
    			127291
    		],
    		"mapped",
    		[
    			108
    		]
    	],
    	[
    		[
    			127292,
    			127292
    		],
    		"mapped",
    		[
    			109
    		]
    	],
    	[
    		[
    			127293,
    			127293
    		],
    		"mapped",
    		[
    			110
    		]
    	],
    	[
    		[
    			127294,
    			127294
    		],
    		"mapped",
    		[
    			111
    		]
    	],
    	[
    		[
    			127295,
    			127295
    		],
    		"mapped",
    		[
    			112
    		]
    	],
    	[
    		[
    			127296,
    			127296
    		],
    		"mapped",
    		[
    			113
    		]
    	],
    	[
    		[
    			127297,
    			127297
    		],
    		"mapped",
    		[
    			114
    		]
    	],
    	[
    		[
    			127298,
    			127298
    		],
    		"mapped",
    		[
    			115
    		]
    	],
    	[
    		[
    			127299,
    			127299
    		],
    		"mapped",
    		[
    			116
    		]
    	],
    	[
    		[
    			127300,
    			127300
    		],
    		"mapped",
    		[
    			117
    		]
    	],
    	[
    		[
    			127301,
    			127301
    		],
    		"mapped",
    		[
    			118
    		]
    	],
    	[
    		[
    			127302,
    			127302
    		],
    		"mapped",
    		[
    			119
    		]
    	],
    	[
    		[
    			127303,
    			127303
    		],
    		"mapped",
    		[
    			120
    		]
    	],
    	[
    		[
    			127304,
    			127304
    		],
    		"mapped",
    		[
    			121
    		]
    	],
    	[
    		[
    			127305,
    			127305
    		],
    		"mapped",
    		[
    			122
    		]
    	],
    	[
    		[
    			127306,
    			127306
    		],
    		"mapped",
    		[
    			104,
    			118
    		]
    	],
    	[
    		[
    			127307,
    			127307
    		],
    		"mapped",
    		[
    			109,
    			118
    		]
    	],
    	[
    		[
    			127308,
    			127308
    		],
    		"mapped",
    		[
    			115,
    			100
    		]
    	],
    	[
    		[
    			127309,
    			127309
    		],
    		"mapped",
    		[
    			115,
    			115
    		]
    	],
    	[
    		[
    			127310,
    			127310
    		],
    		"mapped",
    		[
    			112,
    			112,
    			118
    		]
    	],
    	[
    		[
    			127311,
    			127311
    		],
    		"mapped",
    		[
    			119,
    			99
    		]
    	],
    	[
    		[
    			127312,
    			127318
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127319,
    			127319
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127320,
    			127326
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127327,
    			127327
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127328,
    			127337
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127338,
    			127338
    		],
    		"mapped",
    		[
    			109,
    			99
    		]
    	],
    	[
    		[
    			127339,
    			127339
    		],
    		"mapped",
    		[
    			109,
    			100
    		]
    	],
    	[
    		[
    			127340,
    			127343
    		],
    		"disallowed"
    	],
    	[
    		[
    			127344,
    			127352
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127353,
    			127353
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127354,
    			127354
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127355,
    			127356
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127357,
    			127358
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127359,
    			127359
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127360,
    			127369
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127370,
    			127373
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127374,
    			127375
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127376,
    			127376
    		],
    		"mapped",
    		[
    			100,
    			106
    		]
    	],
    	[
    		[
    			127377,
    			127386
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127387,
    			127461
    		],
    		"disallowed"
    	],
    	[
    		[
    			127462,
    			127487
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127488,
    			127488
    		],
    		"mapped",
    		[
    			12411,
    			12363
    		]
    	],
    	[
    		[
    			127489,
    			127489
    		],
    		"mapped",
    		[
    			12467,
    			12467
    		]
    	],
    	[
    		[
    			127490,
    			127490
    		],
    		"mapped",
    		[
    			12469
    		]
    	],
    	[
    		[
    			127491,
    			127503
    		],
    		"disallowed"
    	],
    	[
    		[
    			127504,
    			127504
    		],
    		"mapped",
    		[
    			25163
    		]
    	],
    	[
    		[
    			127505,
    			127505
    		],
    		"mapped",
    		[
    			23383
    		]
    	],
    	[
    		[
    			127506,
    			127506
    		],
    		"mapped",
    		[
    			21452
    		]
    	],
    	[
    		[
    			127507,
    			127507
    		],
    		"mapped",
    		[
    			12487
    		]
    	],
    	[
    		[
    			127508,
    			127508
    		],
    		"mapped",
    		[
    			20108
    		]
    	],
    	[
    		[
    			127509,
    			127509
    		],
    		"mapped",
    		[
    			22810
    		]
    	],
    	[
    		[
    			127510,
    			127510
    		],
    		"mapped",
    		[
    			35299
    		]
    	],
    	[
    		[
    			127511,
    			127511
    		],
    		"mapped",
    		[
    			22825
    		]
    	],
    	[
    		[
    			127512,
    			127512
    		],
    		"mapped",
    		[
    			20132
    		]
    	],
    	[
    		[
    			127513,
    			127513
    		],
    		"mapped",
    		[
    			26144
    		]
    	],
    	[
    		[
    			127514,
    			127514
    		],
    		"mapped",
    		[
    			28961
    		]
    	],
    	[
    		[
    			127515,
    			127515
    		],
    		"mapped",
    		[
    			26009
    		]
    	],
    	[
    		[
    			127516,
    			127516
    		],
    		"mapped",
    		[
    			21069
    		]
    	],
    	[
    		[
    			127517,
    			127517
    		],
    		"mapped",
    		[
    			24460
    		]
    	],
    	[
    		[
    			127518,
    			127518
    		],
    		"mapped",
    		[
    			20877
    		]
    	],
    	[
    		[
    			127519,
    			127519
    		],
    		"mapped",
    		[
    			26032
    		]
    	],
    	[
    		[
    			127520,
    			127520
    		],
    		"mapped",
    		[
    			21021
    		]
    	],
    	[
    		[
    			127521,
    			127521
    		],
    		"mapped",
    		[
    			32066
    		]
    	],
    	[
    		[
    			127522,
    			127522
    		],
    		"mapped",
    		[
    			29983
    		]
    	],
    	[
    		[
    			127523,
    			127523
    		],
    		"mapped",
    		[
    			36009
    		]
    	],
    	[
    		[
    			127524,
    			127524
    		],
    		"mapped",
    		[
    			22768
    		]
    	],
    	[
    		[
    			127525,
    			127525
    		],
    		"mapped",
    		[
    			21561
    		]
    	],
    	[
    		[
    			127526,
    			127526
    		],
    		"mapped",
    		[
    			28436
    		]
    	],
    	[
    		[
    			127527,
    			127527
    		],
    		"mapped",
    		[
    			25237
    		]
    	],
    	[
    		[
    			127528,
    			127528
    		],
    		"mapped",
    		[
    			25429
    		]
    	],
    	[
    		[
    			127529,
    			127529
    		],
    		"mapped",
    		[
    			19968
    		]
    	],
    	[
    		[
    			127530,
    			127530
    		],
    		"mapped",
    		[
    			19977
    		]
    	],
    	[
    		[
    			127531,
    			127531
    		],
    		"mapped",
    		[
    			36938
    		]
    	],
    	[
    		[
    			127532,
    			127532
    		],
    		"mapped",
    		[
    			24038
    		]
    	],
    	[
    		[
    			127533,
    			127533
    		],
    		"mapped",
    		[
    			20013
    		]
    	],
    	[
    		[
    			127534,
    			127534
    		],
    		"mapped",
    		[
    			21491
    		]
    	],
    	[
    		[
    			127535,
    			127535
    		],
    		"mapped",
    		[
    			25351
    		]
    	],
    	[
    		[
    			127536,
    			127536
    		],
    		"mapped",
    		[
    			36208
    		]
    	],
    	[
    		[
    			127537,
    			127537
    		],
    		"mapped",
    		[
    			25171
    		]
    	],
    	[
    		[
    			127538,
    			127538
    		],
    		"mapped",
    		[
    			31105
    		]
    	],
    	[
    		[
    			127539,
    			127539
    		],
    		"mapped",
    		[
    			31354
    		]
    	],
    	[
    		[
    			127540,
    			127540
    		],
    		"mapped",
    		[
    			21512
    		]
    	],
    	[
    		[
    			127541,
    			127541
    		],
    		"mapped",
    		[
    			28288
    		]
    	],
    	[
    		[
    			127542,
    			127542
    		],
    		"mapped",
    		[
    			26377
    		]
    	],
    	[
    		[
    			127543,
    			127543
    		],
    		"mapped",
    		[
    			26376
    		]
    	],
    	[
    		[
    			127544,
    			127544
    		],
    		"mapped",
    		[
    			30003
    		]
    	],
    	[
    		[
    			127545,
    			127545
    		],
    		"mapped",
    		[
    			21106
    		]
    	],
    	[
    		[
    			127546,
    			127546
    		],
    		"mapped",
    		[
    			21942
    		]
    	],
    	[
    		[
    			127547,
    			127551
    		],
    		"disallowed"
    	],
    	[
    		[
    			127552,
    			127552
    		],
    		"mapped",
    		[
    			12308,
    			26412,
    			12309
    		]
    	],
    	[
    		[
    			127553,
    			127553
    		],
    		"mapped",
    		[
    			12308,
    			19977,
    			12309
    		]
    	],
    	[
    		[
    			127554,
    			127554
    		],
    		"mapped",
    		[
    			12308,
    			20108,
    			12309
    		]
    	],
    	[
    		[
    			127555,
    			127555
    		],
    		"mapped",
    		[
    			12308,
    			23433,
    			12309
    		]
    	],
    	[
    		[
    			127556,
    			127556
    		],
    		"mapped",
    		[
    			12308,
    			28857,
    			12309
    		]
    	],
    	[
    		[
    			127557,
    			127557
    		],
    		"mapped",
    		[
    			12308,
    			25171,
    			12309
    		]
    	],
    	[
    		[
    			127558,
    			127558
    		],
    		"mapped",
    		[
    			12308,
    			30423,
    			12309
    		]
    	],
    	[
    		[
    			127559,
    			127559
    		],
    		"mapped",
    		[
    			12308,
    			21213,
    			12309
    		]
    	],
    	[
    		[
    			127560,
    			127560
    		],
    		"mapped",
    		[
    			12308,
    			25943,
    			12309
    		]
    	],
    	[
    		[
    			127561,
    			127567
    		],
    		"disallowed"
    	],
    	[
    		[
    			127568,
    			127568
    		],
    		"mapped",
    		[
    			24471
    		]
    	],
    	[
    		[
    			127569,
    			127569
    		],
    		"mapped",
    		[
    			21487
    		]
    	],
    	[
    		[
    			127570,
    			127743
    		],
    		"disallowed"
    	],
    	[
    		[
    			127744,
    			127776
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127777,
    			127788
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127789,
    			127791
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127792,
    			127797
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127798,
    			127798
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127799,
    			127868
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127869,
    			127869
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127870,
    			127871
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127872,
    			127891
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127892,
    			127903
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127904,
    			127940
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127941,
    			127941
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127942,
    			127946
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127947,
    			127950
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127951,
    			127955
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127956,
    			127967
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127968,
    			127984
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127985,
    			127991
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			127992,
    			127999
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128000,
    			128062
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128063,
    			128063
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128064,
    			128064
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128065,
    			128065
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128066,
    			128247
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128248,
    			128248
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128249,
    			128252
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128253,
    			128254
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128255,
    			128255
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128256,
    			128317
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128318,
    			128319
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128320,
    			128323
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128324,
    			128330
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128331,
    			128335
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128336,
    			128359
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128360,
    			128377
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128378,
    			128378
    		],
    		"disallowed"
    	],
    	[
    		[
    			128379,
    			128419
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128420,
    			128420
    		],
    		"disallowed"
    	],
    	[
    		[
    			128421,
    			128506
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128507,
    			128511
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128512,
    			128512
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128513,
    			128528
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128529,
    			128529
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128530,
    			128532
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128533,
    			128533
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128534,
    			128534
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128535,
    			128535
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128536,
    			128536
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128537,
    			128537
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128538,
    			128538
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128539,
    			128539
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128540,
    			128542
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128543,
    			128543
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128544,
    			128549
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128550,
    			128551
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128552,
    			128555
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128556,
    			128556
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128557,
    			128557
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128558,
    			128559
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128560,
    			128563
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128564,
    			128564
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128565,
    			128576
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128577,
    			128578
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128579,
    			128580
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128581,
    			128591
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128592,
    			128639
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128640,
    			128709
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128710,
    			128719
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128720,
    			128720
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128721,
    			128735
    		],
    		"disallowed"
    	],
    	[
    		[
    			128736,
    			128748
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128749,
    			128751
    		],
    		"disallowed"
    	],
    	[
    		[
    			128752,
    			128755
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128756,
    			128767
    		],
    		"disallowed"
    	],
    	[
    		[
    			128768,
    			128883
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128884,
    			128895
    		],
    		"disallowed"
    	],
    	[
    		[
    			128896,
    			128980
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			128981,
    			129023
    		],
    		"disallowed"
    	],
    	[
    		[
    			129024,
    			129035
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			129036,
    			129039
    		],
    		"disallowed"
    	],
    	[
    		[
    			129040,
    			129095
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			129096,
    			129103
    		],
    		"disallowed"
    	],
    	[
    		[
    			129104,
    			129113
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			129114,
    			129119
    		],
    		"disallowed"
    	],
    	[
    		[
    			129120,
    			129159
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			129160,
    			129167
    		],
    		"disallowed"
    	],
    	[
    		[
    			129168,
    			129197
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			129198,
    			129295
    		],
    		"disallowed"
    	],
    	[
    		[
    			129296,
    			129304
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			129305,
    			129407
    		],
    		"disallowed"
    	],
    	[
    		[
    			129408,
    			129412
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			129413,
    			129471
    		],
    		"disallowed"
    	],
    	[
    		[
    			129472,
    			129472
    		],
    		"valid",
    		[
    		],
    		"NV8"
    	],
    	[
    		[
    			129473,
    			131069
    		],
    		"disallowed"
    	],
    	[
    		[
    			131070,
    			131071
    		],
    		"disallowed"
    	],
    	[
    		[
    			131072,
    			173782
    		],
    		"valid"
    	],
    	[
    		[
    			173783,
    			173823
    		],
    		"disallowed"
    	],
    	[
    		[
    			173824,
    			177972
    		],
    		"valid"
    	],
    	[
    		[
    			177973,
    			177983
    		],
    		"disallowed"
    	],
    	[
    		[
    			177984,
    			178205
    		],
    		"valid"
    	],
    	[
    		[
    			178206,
    			178207
    		],
    		"disallowed"
    	],
    	[
    		[
    			178208,
    			183969
    		],
    		"valid"
    	],
    	[
    		[
    			183970,
    			194559
    		],
    		"disallowed"
    	],
    	[
    		[
    			194560,
    			194560
    		],
    		"mapped",
    		[
    			20029
    		]
    	],
    	[
    		[
    			194561,
    			194561
    		],
    		"mapped",
    		[
    			20024
    		]
    	],
    	[
    		[
    			194562,
    			194562
    		],
    		"mapped",
    		[
    			20033
    		]
    	],
    	[
    		[
    			194563,
    			194563
    		],
    		"mapped",
    		[
    			131362
    		]
    	],
    	[
    		[
    			194564,
    			194564
    		],
    		"mapped",
    		[
    			20320
    		]
    	],
    	[
    		[
    			194565,
    			194565
    		],
    		"mapped",
    		[
    			20398
    		]
    	],
    	[
    		[
    			194566,
    			194566
    		],
    		"mapped",
    		[
    			20411
    		]
    	],
    	[
    		[
    			194567,
    			194567
    		],
    		"mapped",
    		[
    			20482
    		]
    	],
    	[
    		[
    			194568,
    			194568
    		],
    		"mapped",
    		[
    			20602
    		]
    	],
    	[
    		[
    			194569,
    			194569
    		],
    		"mapped",
    		[
    			20633
    		]
    	],
    	[
    		[
    			194570,
    			194570
    		],
    		"mapped",
    		[
    			20711
    		]
    	],
    	[
    		[
    			194571,
    			194571
    		],
    		"mapped",
    		[
    			20687
    		]
    	],
    	[
    		[
    			194572,
    			194572
    		],
    		"mapped",
    		[
    			13470
    		]
    	],
    	[
    		[
    			194573,
    			194573
    		],
    		"mapped",
    		[
    			132666
    		]
    	],
    	[
    		[
    			194574,
    			194574
    		],
    		"mapped",
    		[
    			20813
    		]
    	],
    	[
    		[
    			194575,
    			194575
    		],
    		"mapped",
    		[
    			20820
    		]
    	],
    	[
    		[
    			194576,
    			194576
    		],
    		"mapped",
    		[
    			20836
    		]
    	],
    	[
    		[
    			194577,
    			194577
    		],
    		"mapped",
    		[
    			20855
    		]
    	],
    	[
    		[
    			194578,
    			194578
    		],
    		"mapped",
    		[
    			132380
    		]
    	],
    	[
    		[
    			194579,
    			194579
    		],
    		"mapped",
    		[
    			13497
    		]
    	],
    	[
    		[
    			194580,
    			194580
    		],
    		"mapped",
    		[
    			20839
    		]
    	],
    	[
    		[
    			194581,
    			194581
    		],
    		"mapped",
    		[
    			20877
    		]
    	],
    	[
    		[
    			194582,
    			194582
    		],
    		"mapped",
    		[
    			132427
    		]
    	],
    	[
    		[
    			194583,
    			194583
    		],
    		"mapped",
    		[
    			20887
    		]
    	],
    	[
    		[
    			194584,
    			194584
    		],
    		"mapped",
    		[
    			20900
    		]
    	],
    	[
    		[
    			194585,
    			194585
    		],
    		"mapped",
    		[
    			20172
    		]
    	],
    	[
    		[
    			194586,
    			194586
    		],
    		"mapped",
    		[
    			20908
    		]
    	],
    	[
    		[
    			194587,
    			194587
    		],
    		"mapped",
    		[
    			20917
    		]
    	],
    	[
    		[
    			194588,
    			194588
    		],
    		"mapped",
    		[
    			168415
    		]
    	],
    	[
    		[
    			194589,
    			194589
    		],
    		"mapped",
    		[
    			20981
    		]
    	],
    	[
    		[
    			194590,
    			194590
    		],
    		"mapped",
    		[
    			20995
    		]
    	],
    	[
    		[
    			194591,
    			194591
    		],
    		"mapped",
    		[
    			13535
    		]
    	],
    	[
    		[
    			194592,
    			194592
    		],
    		"mapped",
    		[
    			21051
    		]
    	],
    	[
    		[
    			194593,
    			194593
    		],
    		"mapped",
    		[
    			21062
    		]
    	],
    	[
    		[
    			194594,
    			194594
    		],
    		"mapped",
    		[
    			21106
    		]
    	],
    	[
    		[
    			194595,
    			194595
    		],
    		"mapped",
    		[
    			21111
    		]
    	],
    	[
    		[
    			194596,
    			194596
    		],
    		"mapped",
    		[
    			13589
    		]
    	],
    	[
    		[
    			194597,
    			194597
    		],
    		"mapped",
    		[
    			21191
    		]
    	],
    	[
    		[
    			194598,
    			194598
    		],
    		"mapped",
    		[
    			21193
    		]
    	],
    	[
    		[
    			194599,
    			194599
    		],
    		"mapped",
    		[
    			21220
    		]
    	],
    	[
    		[
    			194600,
    			194600
    		],
    		"mapped",
    		[
    			21242
    		]
    	],
    	[
    		[
    			194601,
    			194601
    		],
    		"mapped",
    		[
    			21253
    		]
    	],
    	[
    		[
    			194602,
    			194602
    		],
    		"mapped",
    		[
    			21254
    		]
    	],
    	[
    		[
    			194603,
    			194603
    		],
    		"mapped",
    		[
    			21271
    		]
    	],
    	[
    		[
    			194604,
    			194604
    		],
    		"mapped",
    		[
    			21321
    		]
    	],
    	[
    		[
    			194605,
    			194605
    		],
    		"mapped",
    		[
    			21329
    		]
    	],
    	[
    		[
    			194606,
    			194606
    		],
    		"mapped",
    		[
    			21338
    		]
    	],
    	[
    		[
    			194607,
    			194607
    		],
    		"mapped",
    		[
    			21363
    		]
    	],
    	[
    		[
    			194608,
    			194608
    		],
    		"mapped",
    		[
    			21373
    		]
    	],
    	[
    		[
    			194609,
    			194611
    		],
    		"mapped",
    		[
    			21375
    		]
    	],
    	[
    		[
    			194612,
    			194612
    		],
    		"mapped",
    		[
    			133676
    		]
    	],
    	[
    		[
    			194613,
    			194613
    		],
    		"mapped",
    		[
    			28784
    		]
    	],
    	[
    		[
    			194614,
    			194614
    		],
    		"mapped",
    		[
    			21450
    		]
    	],
    	[
    		[
    			194615,
    			194615
    		],
    		"mapped",
    		[
    			21471
    		]
    	],
    	[
    		[
    			194616,
    			194616
    		],
    		"mapped",
    		[
    			133987
    		]
    	],
    	[
    		[
    			194617,
    			194617
    		],
    		"mapped",
    		[
    			21483
    		]
    	],
    	[
    		[
    			194618,
    			194618
    		],
    		"mapped",
    		[
    			21489
    		]
    	],
    	[
    		[
    			194619,
    			194619
    		],
    		"mapped",
    		[
    			21510
    		]
    	],
    	[
    		[
    			194620,
    			194620
    		],
    		"mapped",
    		[
    			21662
    		]
    	],
    	[
    		[
    			194621,
    			194621
    		],
    		"mapped",
    		[
    			21560
    		]
    	],
    	[
    		[
    			194622,
    			194622
    		],
    		"mapped",
    		[
    			21576
    		]
    	],
    	[
    		[
    			194623,
    			194623
    		],
    		"mapped",
    		[
    			21608
    		]
    	],
    	[
    		[
    			194624,
    			194624
    		],
    		"mapped",
    		[
    			21666
    		]
    	],
    	[
    		[
    			194625,
    			194625
    		],
    		"mapped",
    		[
    			21750
    		]
    	],
    	[
    		[
    			194626,
    			194626
    		],
    		"mapped",
    		[
    			21776
    		]
    	],
    	[
    		[
    			194627,
    			194627
    		],
    		"mapped",
    		[
    			21843
    		]
    	],
    	[
    		[
    			194628,
    			194628
    		],
    		"mapped",
    		[
    			21859
    		]
    	],
    	[
    		[
    			194629,
    			194630
    		],
    		"mapped",
    		[
    			21892
    		]
    	],
    	[
    		[
    			194631,
    			194631
    		],
    		"mapped",
    		[
    			21913
    		]
    	],
    	[
    		[
    			194632,
    			194632
    		],
    		"mapped",
    		[
    			21931
    		]
    	],
    	[
    		[
    			194633,
    			194633
    		],
    		"mapped",
    		[
    			21939
    		]
    	],
    	[
    		[
    			194634,
    			194634
    		],
    		"mapped",
    		[
    			21954
    		]
    	],
    	[
    		[
    			194635,
    			194635
    		],
    		"mapped",
    		[
    			22294
    		]
    	],
    	[
    		[
    			194636,
    			194636
    		],
    		"mapped",
    		[
    			22022
    		]
    	],
    	[
    		[
    			194637,
    			194637
    		],
    		"mapped",
    		[
    			22295
    		]
    	],
    	[
    		[
    			194638,
    			194638
    		],
    		"mapped",
    		[
    			22097
    		]
    	],
    	[
    		[
    			194639,
    			194639
    		],
    		"mapped",
    		[
    			22132
    		]
    	],
    	[
    		[
    			194640,
    			194640
    		],
    		"mapped",
    		[
    			20999
    		]
    	],
    	[
    		[
    			194641,
    			194641
    		],
    		"mapped",
    		[
    			22766
    		]
    	],
    	[
    		[
    			194642,
    			194642
    		],
    		"mapped",
    		[
    			22478
    		]
    	],
    	[
    		[
    			194643,
    			194643
    		],
    		"mapped",
    		[
    			22516
    		]
    	],
    	[
    		[
    			194644,
    			194644
    		],
    		"mapped",
    		[
    			22541
    		]
    	],
    	[
    		[
    			194645,
    			194645
    		],
    		"mapped",
    		[
    			22411
    		]
    	],
    	[
    		[
    			194646,
    			194646
    		],
    		"mapped",
    		[
    			22578
    		]
    	],
    	[
    		[
    			194647,
    			194647
    		],
    		"mapped",
    		[
    			22577
    		]
    	],
    	[
    		[
    			194648,
    			194648
    		],
    		"mapped",
    		[
    			22700
    		]
    	],
    	[
    		[
    			194649,
    			194649
    		],
    		"mapped",
    		[
    			136420
    		]
    	],
    	[
    		[
    			194650,
    			194650
    		],
    		"mapped",
    		[
    			22770
    		]
    	],
    	[
    		[
    			194651,
    			194651
    		],
    		"mapped",
    		[
    			22775
    		]
    	],
    	[
    		[
    			194652,
    			194652
    		],
    		"mapped",
    		[
    			22790
    		]
    	],
    	[
    		[
    			194653,
    			194653
    		],
    		"mapped",
    		[
    			22810
    		]
    	],
    	[
    		[
    			194654,
    			194654
    		],
    		"mapped",
    		[
    			22818
    		]
    	],
    	[
    		[
    			194655,
    			194655
    		],
    		"mapped",
    		[
    			22882
    		]
    	],
    	[
    		[
    			194656,
    			194656
    		],
    		"mapped",
    		[
    			136872
    		]
    	],
    	[
    		[
    			194657,
    			194657
    		],
    		"mapped",
    		[
    			136938
    		]
    	],
    	[
    		[
    			194658,
    			194658
    		],
    		"mapped",
    		[
    			23020
    		]
    	],
    	[
    		[
    			194659,
    			194659
    		],
    		"mapped",
    		[
    			23067
    		]
    	],
    	[
    		[
    			194660,
    			194660
    		],
    		"mapped",
    		[
    			23079
    		]
    	],
    	[
    		[
    			194661,
    			194661
    		],
    		"mapped",
    		[
    			23000
    		]
    	],
    	[
    		[
    			194662,
    			194662
    		],
    		"mapped",
    		[
    			23142
    		]
    	],
    	[
    		[
    			194663,
    			194663
    		],
    		"mapped",
    		[
    			14062
    		]
    	],
    	[
    		[
    			194664,
    			194664
    		],
    		"disallowed"
    	],
    	[
    		[
    			194665,
    			194665
    		],
    		"mapped",
    		[
    			23304
    		]
    	],
    	[
    		[
    			194666,
    			194667
    		],
    		"mapped",
    		[
    			23358
    		]
    	],
    	[
    		[
    			194668,
    			194668
    		],
    		"mapped",
    		[
    			137672
    		]
    	],
    	[
    		[
    			194669,
    			194669
    		],
    		"mapped",
    		[
    			23491
    		]
    	],
    	[
    		[
    			194670,
    			194670
    		],
    		"mapped",
    		[
    			23512
    		]
    	],
    	[
    		[
    			194671,
    			194671
    		],
    		"mapped",
    		[
    			23527
    		]
    	],
    	[
    		[
    			194672,
    			194672
    		],
    		"mapped",
    		[
    			23539
    		]
    	],
    	[
    		[
    			194673,
    			194673
    		],
    		"mapped",
    		[
    			138008
    		]
    	],
    	[
    		[
    			194674,
    			194674
    		],
    		"mapped",
    		[
    			23551
    		]
    	],
    	[
    		[
    			194675,
    			194675
    		],
    		"mapped",
    		[
    			23558
    		]
    	],
    	[
    		[
    			194676,
    			194676
    		],
    		"disallowed"
    	],
    	[
    		[
    			194677,
    			194677
    		],
    		"mapped",
    		[
    			23586
    		]
    	],
    	[
    		[
    			194678,
    			194678
    		],
    		"mapped",
    		[
    			14209
    		]
    	],
    	[
    		[
    			194679,
    			194679
    		],
    		"mapped",
    		[
    			23648
    		]
    	],
    	[
    		[
    			194680,
    			194680
    		],
    		"mapped",
    		[
    			23662
    		]
    	],
    	[
    		[
    			194681,
    			194681
    		],
    		"mapped",
    		[
    			23744
    		]
    	],
    	[
    		[
    			194682,
    			194682
    		],
    		"mapped",
    		[
    			23693
    		]
    	],
    	[
    		[
    			194683,
    			194683
    		],
    		"mapped",
    		[
    			138724
    		]
    	],
    	[
    		[
    			194684,
    			194684
    		],
    		"mapped",
    		[
    			23875
    		]
    	],
    	[
    		[
    			194685,
    			194685
    		],
    		"mapped",
    		[
    			138726
    		]
    	],
    	[
    		[
    			194686,
    			194686
    		],
    		"mapped",
    		[
    			23918
    		]
    	],
    	[
    		[
    			194687,
    			194687
    		],
    		"mapped",
    		[
    			23915
    		]
    	],
    	[
    		[
    			194688,
    			194688
    		],
    		"mapped",
    		[
    			23932
    		]
    	],
    	[
    		[
    			194689,
    			194689
    		],
    		"mapped",
    		[
    			24033
    		]
    	],
    	[
    		[
    			194690,
    			194690
    		],
    		"mapped",
    		[
    			24034
    		]
    	],
    	[
    		[
    			194691,
    			194691
    		],
    		"mapped",
    		[
    			14383
    		]
    	],
    	[
    		[
    			194692,
    			194692
    		],
    		"mapped",
    		[
    			24061
    		]
    	],
    	[
    		[
    			194693,
    			194693
    		],
    		"mapped",
    		[
    			24104
    		]
    	],
    	[
    		[
    			194694,
    			194694
    		],
    		"mapped",
    		[
    			24125
    		]
    	],
    	[
    		[
    			194695,
    			194695
    		],
    		"mapped",
    		[
    			24169
    		]
    	],
    	[
    		[
    			194696,
    			194696
    		],
    		"mapped",
    		[
    			14434
    		]
    	],
    	[
    		[
    			194697,
    			194697
    		],
    		"mapped",
    		[
    			139651
    		]
    	],
    	[
    		[
    			194698,
    			194698
    		],
    		"mapped",
    		[
    			14460
    		]
    	],
    	[
    		[
    			194699,
    			194699
    		],
    		"mapped",
    		[
    			24240
    		]
    	],
    	[
    		[
    			194700,
    			194700
    		],
    		"mapped",
    		[
    			24243
    		]
    	],
    	[
    		[
    			194701,
    			194701
    		],
    		"mapped",
    		[
    			24246
    		]
    	],
    	[
    		[
    			194702,
    			194702
    		],
    		"mapped",
    		[
    			24266
    		]
    	],
    	[
    		[
    			194703,
    			194703
    		],
    		"mapped",
    		[
    			172946
    		]
    	],
    	[
    		[
    			194704,
    			194704
    		],
    		"mapped",
    		[
    			24318
    		]
    	],
    	[
    		[
    			194705,
    			194706
    		],
    		"mapped",
    		[
    			140081
    		]
    	],
    	[
    		[
    			194707,
    			194707
    		],
    		"mapped",
    		[
    			33281
    		]
    	],
    	[
    		[
    			194708,
    			194709
    		],
    		"mapped",
    		[
    			24354
    		]
    	],
    	[
    		[
    			194710,
    			194710
    		],
    		"mapped",
    		[
    			14535
    		]
    	],
    	[
    		[
    			194711,
    			194711
    		],
    		"mapped",
    		[
    			144056
    		]
    	],
    	[
    		[
    			194712,
    			194712
    		],
    		"mapped",
    		[
    			156122
    		]
    	],
    	[
    		[
    			194713,
    			194713
    		],
    		"mapped",
    		[
    			24418
    		]
    	],
    	[
    		[
    			194714,
    			194714
    		],
    		"mapped",
    		[
    			24427
    		]
    	],
    	[
    		[
    			194715,
    			194715
    		],
    		"mapped",
    		[
    			14563
    		]
    	],
    	[
    		[
    			194716,
    			194716
    		],
    		"mapped",
    		[
    			24474
    		]
    	],
    	[
    		[
    			194717,
    			194717
    		],
    		"mapped",
    		[
    			24525
    		]
    	],
    	[
    		[
    			194718,
    			194718
    		],
    		"mapped",
    		[
    			24535
    		]
    	],
    	[
    		[
    			194719,
    			194719
    		],
    		"mapped",
    		[
    			24569
    		]
    	],
    	[
    		[
    			194720,
    			194720
    		],
    		"mapped",
    		[
    			24705
    		]
    	],
    	[
    		[
    			194721,
    			194721
    		],
    		"mapped",
    		[
    			14650
    		]
    	],
    	[
    		[
    			194722,
    			194722
    		],
    		"mapped",
    		[
    			14620
    		]
    	],
    	[
    		[
    			194723,
    			194723
    		],
    		"mapped",
    		[
    			24724
    		]
    	],
    	[
    		[
    			194724,
    			194724
    		],
    		"mapped",
    		[
    			141012
    		]
    	],
    	[
    		[
    			194725,
    			194725
    		],
    		"mapped",
    		[
    			24775
    		]
    	],
    	[
    		[
    			194726,
    			194726
    		],
    		"mapped",
    		[
    			24904
    		]
    	],
    	[
    		[
    			194727,
    			194727
    		],
    		"mapped",
    		[
    			24908
    		]
    	],
    	[
    		[
    			194728,
    			194728
    		],
    		"mapped",
    		[
    			24910
    		]
    	],
    	[
    		[
    			194729,
    			194729
    		],
    		"mapped",
    		[
    			24908
    		]
    	],
    	[
    		[
    			194730,
    			194730
    		],
    		"mapped",
    		[
    			24954
    		]
    	],
    	[
    		[
    			194731,
    			194731
    		],
    		"mapped",
    		[
    			24974
    		]
    	],
    	[
    		[
    			194732,
    			194732
    		],
    		"mapped",
    		[
    			25010
    		]
    	],
    	[
    		[
    			194733,
    			194733
    		],
    		"mapped",
    		[
    			24996
    		]
    	],
    	[
    		[
    			194734,
    			194734
    		],
    		"mapped",
    		[
    			25007
    		]
    	],
    	[
    		[
    			194735,
    			194735
    		],
    		"mapped",
    		[
    			25054
    		]
    	],
    	[
    		[
    			194736,
    			194736
    		],
    		"mapped",
    		[
    			25074
    		]
    	],
    	[
    		[
    			194737,
    			194737
    		],
    		"mapped",
    		[
    			25078
    		]
    	],
    	[
    		[
    			194738,
    			194738
    		],
    		"mapped",
    		[
    			25104
    		]
    	],
    	[
    		[
    			194739,
    			194739
    		],
    		"mapped",
    		[
    			25115
    		]
    	],
    	[
    		[
    			194740,
    			194740
    		],
    		"mapped",
    		[
    			25181
    		]
    	],
    	[
    		[
    			194741,
    			194741
    		],
    		"mapped",
    		[
    			25265
    		]
    	],
    	[
    		[
    			194742,
    			194742
    		],
    		"mapped",
    		[
    			25300
    		]
    	],
    	[
    		[
    			194743,
    			194743
    		],
    		"mapped",
    		[
    			25424
    		]
    	],
    	[
    		[
    			194744,
    			194744
    		],
    		"mapped",
    		[
    			142092
    		]
    	],
    	[
    		[
    			194745,
    			194745
    		],
    		"mapped",
    		[
    			25405
    		]
    	],
    	[
    		[
    			194746,
    			194746
    		],
    		"mapped",
    		[
    			25340
    		]
    	],
    	[
    		[
    			194747,
    			194747
    		],
    		"mapped",
    		[
    			25448
    		]
    	],
    	[
    		[
    			194748,
    			194748
    		],
    		"mapped",
    		[
    			25475
    		]
    	],
    	[
    		[
    			194749,
    			194749
    		],
    		"mapped",
    		[
    			25572
    		]
    	],
    	[
    		[
    			194750,
    			194750
    		],
    		"mapped",
    		[
    			142321
    		]
    	],
    	[
    		[
    			194751,
    			194751
    		],
    		"mapped",
    		[
    			25634
    		]
    	],
    	[
    		[
    			194752,
    			194752
    		],
    		"mapped",
    		[
    			25541
    		]
    	],
    	[
    		[
    			194753,
    			194753
    		],
    		"mapped",
    		[
    			25513
    		]
    	],
    	[
    		[
    			194754,
    			194754
    		],
    		"mapped",
    		[
    			14894
    		]
    	],
    	[
    		[
    			194755,
    			194755
    		],
    		"mapped",
    		[
    			25705
    		]
    	],
    	[
    		[
    			194756,
    			194756
    		],
    		"mapped",
    		[
    			25726
    		]
    	],
    	[
    		[
    			194757,
    			194757
    		],
    		"mapped",
    		[
    			25757
    		]
    	],
    	[
    		[
    			194758,
    			194758
    		],
    		"mapped",
    		[
    			25719
    		]
    	],
    	[
    		[
    			194759,
    			194759
    		],
    		"mapped",
    		[
    			14956
    		]
    	],
    	[
    		[
    			194760,
    			194760
    		],
    		"mapped",
    		[
    			25935
    		]
    	],
    	[
    		[
    			194761,
    			194761
    		],
    		"mapped",
    		[
    			25964
    		]
    	],
    	[
    		[
    			194762,
    			194762
    		],
    		"mapped",
    		[
    			143370
    		]
    	],
    	[
    		[
    			194763,
    			194763
    		],
    		"mapped",
    		[
    			26083
    		]
    	],
    	[
    		[
    			194764,
    			194764
    		],
    		"mapped",
    		[
    			26360
    		]
    	],
    	[
    		[
    			194765,
    			194765
    		],
    		"mapped",
    		[
    			26185
    		]
    	],
    	[
    		[
    			194766,
    			194766
    		],
    		"mapped",
    		[
    			15129
    		]
    	],
    	[
    		[
    			194767,
    			194767
    		],
    		"mapped",
    		[
    			26257
    		]
    	],
    	[
    		[
    			194768,
    			194768
    		],
    		"mapped",
    		[
    			15112
    		]
    	],
    	[
    		[
    			194769,
    			194769
    		],
    		"mapped",
    		[
    			15076
    		]
    	],
    	[
    		[
    			194770,
    			194770
    		],
    		"mapped",
    		[
    			20882
    		]
    	],
    	[
    		[
    			194771,
    			194771
    		],
    		"mapped",
    		[
    			20885
    		]
    	],
    	[
    		[
    			194772,
    			194772
    		],
    		"mapped",
    		[
    			26368
    		]
    	],
    	[
    		[
    			194773,
    			194773
    		],
    		"mapped",
    		[
    			26268
    		]
    	],
    	[
    		[
    			194774,
    			194774
    		],
    		"mapped",
    		[
    			32941
    		]
    	],
    	[
    		[
    			194775,
    			194775
    		],
    		"mapped",
    		[
    			17369
    		]
    	],
    	[
    		[
    			194776,
    			194776
    		],
    		"mapped",
    		[
    			26391
    		]
    	],
    	[
    		[
    			194777,
    			194777
    		],
    		"mapped",
    		[
    			26395
    		]
    	],
    	[
    		[
    			194778,
    			194778
    		],
    		"mapped",
    		[
    			26401
    		]
    	],
    	[
    		[
    			194779,
    			194779
    		],
    		"mapped",
    		[
    			26462
    		]
    	],
    	[
    		[
    			194780,
    			194780
    		],
    		"mapped",
    		[
    			26451
    		]
    	],
    	[
    		[
    			194781,
    			194781
    		],
    		"mapped",
    		[
    			144323
    		]
    	],
    	[
    		[
    			194782,
    			194782
    		],
    		"mapped",
    		[
    			15177
    		]
    	],
    	[
    		[
    			194783,
    			194783
    		],
    		"mapped",
    		[
    			26618
    		]
    	],
    	[
    		[
    			194784,
    			194784
    		],
    		"mapped",
    		[
    			26501
    		]
    	],
    	[
    		[
    			194785,
    			194785
    		],
    		"mapped",
    		[
    			26706
    		]
    	],
    	[
    		[
    			194786,
    			194786
    		],
    		"mapped",
    		[
    			26757
    		]
    	],
    	[
    		[
    			194787,
    			194787
    		],
    		"mapped",
    		[
    			144493
    		]
    	],
    	[
    		[
    			194788,
    			194788
    		],
    		"mapped",
    		[
    			26766
    		]
    	],
    	[
    		[
    			194789,
    			194789
    		],
    		"mapped",
    		[
    			26655
    		]
    	],
    	[
    		[
    			194790,
    			194790
    		],
    		"mapped",
    		[
    			26900
    		]
    	],
    	[
    		[
    			194791,
    			194791
    		],
    		"mapped",
    		[
    			15261
    		]
    	],
    	[
    		[
    			194792,
    			194792
    		],
    		"mapped",
    		[
    			26946
    		]
    	],
    	[
    		[
    			194793,
    			194793
    		],
    		"mapped",
    		[
    			27043
    		]
    	],
    	[
    		[
    			194794,
    			194794
    		],
    		"mapped",
    		[
    			27114
    		]
    	],
    	[
    		[
    			194795,
    			194795
    		],
    		"mapped",
    		[
    			27304
    		]
    	],
    	[
    		[
    			194796,
    			194796
    		],
    		"mapped",
    		[
    			145059
    		]
    	],
    	[
    		[
    			194797,
    			194797
    		],
    		"mapped",
    		[
    			27355
    		]
    	],
    	[
    		[
    			194798,
    			194798
    		],
    		"mapped",
    		[
    			15384
    		]
    	],
    	[
    		[
    			194799,
    			194799
    		],
    		"mapped",
    		[
    			27425
    		]
    	],
    	[
    		[
    			194800,
    			194800
    		],
    		"mapped",
    		[
    			145575
    		]
    	],
    	[
    		[
    			194801,
    			194801
    		],
    		"mapped",
    		[
    			27476
    		]
    	],
    	[
    		[
    			194802,
    			194802
    		],
    		"mapped",
    		[
    			15438
    		]
    	],
    	[
    		[
    			194803,
    			194803
    		],
    		"mapped",
    		[
    			27506
    		]
    	],
    	[
    		[
    			194804,
    			194804
    		],
    		"mapped",
    		[
    			27551
    		]
    	],
    	[
    		[
    			194805,
    			194805
    		],
    		"mapped",
    		[
    			27578
    		]
    	],
    	[
    		[
    			194806,
    			194806
    		],
    		"mapped",
    		[
    			27579
    		]
    	],
    	[
    		[
    			194807,
    			194807
    		],
    		"mapped",
    		[
    			146061
    		]
    	],
    	[
    		[
    			194808,
    			194808
    		],
    		"mapped",
    		[
    			138507
    		]
    	],
    	[
    		[
    			194809,
    			194809
    		],
    		"mapped",
    		[
    			146170
    		]
    	],
    	[
    		[
    			194810,
    			194810
    		],
    		"mapped",
    		[
    			27726
    		]
    	],
    	[
    		[
    			194811,
    			194811
    		],
    		"mapped",
    		[
    			146620
    		]
    	],
    	[
    		[
    			194812,
    			194812
    		],
    		"mapped",
    		[
    			27839
    		]
    	],
    	[
    		[
    			194813,
    			194813
    		],
    		"mapped",
    		[
    			27853
    		]
    	],
    	[
    		[
    			194814,
    			194814
    		],
    		"mapped",
    		[
    			27751
    		]
    	],
    	[
    		[
    			194815,
    			194815
    		],
    		"mapped",
    		[
    			27926
    		]
    	],
    	[
    		[
    			194816,
    			194816
    		],
    		"mapped",
    		[
    			27966
    		]
    	],
    	[
    		[
    			194817,
    			194817
    		],
    		"mapped",
    		[
    			28023
    		]
    	],
    	[
    		[
    			194818,
    			194818
    		],
    		"mapped",
    		[
    			27969
    		]
    	],
    	[
    		[
    			194819,
    			194819
    		],
    		"mapped",
    		[
    			28009
    		]
    	],
    	[
    		[
    			194820,
    			194820
    		],
    		"mapped",
    		[
    			28024
    		]
    	],
    	[
    		[
    			194821,
    			194821
    		],
    		"mapped",
    		[
    			28037
    		]
    	],
    	[
    		[
    			194822,
    			194822
    		],
    		"mapped",
    		[
    			146718
    		]
    	],
    	[
    		[
    			194823,
    			194823
    		],
    		"mapped",
    		[
    			27956
    		]
    	],
    	[
    		[
    			194824,
    			194824
    		],
    		"mapped",
    		[
    			28207
    		]
    	],
    	[
    		[
    			194825,
    			194825
    		],
    		"mapped",
    		[
    			28270
    		]
    	],
    	[
    		[
    			194826,
    			194826
    		],
    		"mapped",
    		[
    			15667
    		]
    	],
    	[
    		[
    			194827,
    			194827
    		],
    		"mapped",
    		[
    			28363
    		]
    	],
    	[
    		[
    			194828,
    			194828
    		],
    		"mapped",
    		[
    			28359
    		]
    	],
    	[
    		[
    			194829,
    			194829
    		],
    		"mapped",
    		[
    			147153
    		]
    	],
    	[
    		[
    			194830,
    			194830
    		],
    		"mapped",
    		[
    			28153
    		]
    	],
    	[
    		[
    			194831,
    			194831
    		],
    		"mapped",
    		[
    			28526
    		]
    	],
    	[
    		[
    			194832,
    			194832
    		],
    		"mapped",
    		[
    			147294
    		]
    	],
    	[
    		[
    			194833,
    			194833
    		],
    		"mapped",
    		[
    			147342
    		]
    	],
    	[
    		[
    			194834,
    			194834
    		],
    		"mapped",
    		[
    			28614
    		]
    	],
    	[
    		[
    			194835,
    			194835
    		],
    		"mapped",
    		[
    			28729
    		]
    	],
    	[
    		[
    			194836,
    			194836
    		],
    		"mapped",
    		[
    			28702
    		]
    	],
    	[
    		[
    			194837,
    			194837
    		],
    		"mapped",
    		[
    			28699
    		]
    	],
    	[
    		[
    			194838,
    			194838
    		],
    		"mapped",
    		[
    			15766
    		]
    	],
    	[
    		[
    			194839,
    			194839
    		],
    		"mapped",
    		[
    			28746
    		]
    	],
    	[
    		[
    			194840,
    			194840
    		],
    		"mapped",
    		[
    			28797
    		]
    	],
    	[
    		[
    			194841,
    			194841
    		],
    		"mapped",
    		[
    			28791
    		]
    	],
    	[
    		[
    			194842,
    			194842
    		],
    		"mapped",
    		[
    			28845
    		]
    	],
    	[
    		[
    			194843,
    			194843
    		],
    		"mapped",
    		[
    			132389
    		]
    	],
    	[
    		[
    			194844,
    			194844
    		],
    		"mapped",
    		[
    			28997
    		]
    	],
    	[
    		[
    			194845,
    			194845
    		],
    		"mapped",
    		[
    			148067
    		]
    	],
    	[
    		[
    			194846,
    			194846
    		],
    		"mapped",
    		[
    			29084
    		]
    	],
    	[
    		[
    			194847,
    			194847
    		],
    		"disallowed"
    	],
    	[
    		[
    			194848,
    			194848
    		],
    		"mapped",
    		[
    			29224
    		]
    	],
    	[
    		[
    			194849,
    			194849
    		],
    		"mapped",
    		[
    			29237
    		]
    	],
    	[
    		[
    			194850,
    			194850
    		],
    		"mapped",
    		[
    			29264
    		]
    	],
    	[
    		[
    			194851,
    			194851
    		],
    		"mapped",
    		[
    			149000
    		]
    	],
    	[
    		[
    			194852,
    			194852
    		],
    		"mapped",
    		[
    			29312
    		]
    	],
    	[
    		[
    			194853,
    			194853
    		],
    		"mapped",
    		[
    			29333
    		]
    	],
    	[
    		[
    			194854,
    			194854
    		],
    		"mapped",
    		[
    			149301
    		]
    	],
    	[
    		[
    			194855,
    			194855
    		],
    		"mapped",
    		[
    			149524
    		]
    	],
    	[
    		[
    			194856,
    			194856
    		],
    		"mapped",
    		[
    			29562
    		]
    	],
    	[
    		[
    			194857,
    			194857
    		],
    		"mapped",
    		[
    			29579
    		]
    	],
    	[
    		[
    			194858,
    			194858
    		],
    		"mapped",
    		[
    			16044
    		]
    	],
    	[
    		[
    			194859,
    			194859
    		],
    		"mapped",
    		[
    			29605
    		]
    	],
    	[
    		[
    			194860,
    			194861
    		],
    		"mapped",
    		[
    			16056
    		]
    	],
    	[
    		[
    			194862,
    			194862
    		],
    		"mapped",
    		[
    			29767
    		]
    	],
    	[
    		[
    			194863,
    			194863
    		],
    		"mapped",
    		[
    			29788
    		]
    	],
    	[
    		[
    			194864,
    			194864
    		],
    		"mapped",
    		[
    			29809
    		]
    	],
    	[
    		[
    			194865,
    			194865
    		],
    		"mapped",
    		[
    			29829
    		]
    	],
    	[
    		[
    			194866,
    			194866
    		],
    		"mapped",
    		[
    			29898
    		]
    	],
    	[
    		[
    			194867,
    			194867
    		],
    		"mapped",
    		[
    			16155
    		]
    	],
    	[
    		[
    			194868,
    			194868
    		],
    		"mapped",
    		[
    			29988
    		]
    	],
    	[
    		[
    			194869,
    			194869
    		],
    		"mapped",
    		[
    			150582
    		]
    	],
    	[
    		[
    			194870,
    			194870
    		],
    		"mapped",
    		[
    			30014
    		]
    	],
    	[
    		[
    			194871,
    			194871
    		],
    		"mapped",
    		[
    			150674
    		]
    	],
    	[
    		[
    			194872,
    			194872
    		],
    		"mapped",
    		[
    			30064
    		]
    	],
    	[
    		[
    			194873,
    			194873
    		],
    		"mapped",
    		[
    			139679
    		]
    	],
    	[
    		[
    			194874,
    			194874
    		],
    		"mapped",
    		[
    			30224
    		]
    	],
    	[
    		[
    			194875,
    			194875
    		],
    		"mapped",
    		[
    			151457
    		]
    	],
    	[
    		[
    			194876,
    			194876
    		],
    		"mapped",
    		[
    			151480
    		]
    	],
    	[
    		[
    			194877,
    			194877
    		],
    		"mapped",
    		[
    			151620
    		]
    	],
    	[
    		[
    			194878,
    			194878
    		],
    		"mapped",
    		[
    			16380
    		]
    	],
    	[
    		[
    			194879,
    			194879
    		],
    		"mapped",
    		[
    			16392
    		]
    	],
    	[
    		[
    			194880,
    			194880
    		],
    		"mapped",
    		[
    			30452
    		]
    	],
    	[
    		[
    			194881,
    			194881
    		],
    		"mapped",
    		[
    			151795
    		]
    	],
    	[
    		[
    			194882,
    			194882
    		],
    		"mapped",
    		[
    			151794
    		]
    	],
    	[
    		[
    			194883,
    			194883
    		],
    		"mapped",
    		[
    			151833
    		]
    	],
    	[
    		[
    			194884,
    			194884
    		],
    		"mapped",
    		[
    			151859
    		]
    	],
    	[
    		[
    			194885,
    			194885
    		],
    		"mapped",
    		[
    			30494
    		]
    	],
    	[
    		[
    			194886,
    			194887
    		],
    		"mapped",
    		[
    			30495
    		]
    	],
    	[
    		[
    			194888,
    			194888
    		],
    		"mapped",
    		[
    			30538
    		]
    	],
    	[
    		[
    			194889,
    			194889
    		],
    		"mapped",
    		[
    			16441
    		]
    	],
    	[
    		[
    			194890,
    			194890
    		],
    		"mapped",
    		[
    			30603
    		]
    	],
    	[
    		[
    			194891,
    			194891
    		],
    		"mapped",
    		[
    			16454
    		]
    	],
    	[
    		[
    			194892,
    			194892
    		],
    		"mapped",
    		[
    			16534
    		]
    	],
    	[
    		[
    			194893,
    			194893
    		],
    		"mapped",
    		[
    			152605
    		]
    	],
    	[
    		[
    			194894,
    			194894
    		],
    		"mapped",
    		[
    			30798
    		]
    	],
    	[
    		[
    			194895,
    			194895
    		],
    		"mapped",
    		[
    			30860
    		]
    	],
    	[
    		[
    			194896,
    			194896
    		],
    		"mapped",
    		[
    			30924
    		]
    	],
    	[
    		[
    			194897,
    			194897
    		],
    		"mapped",
    		[
    			16611
    		]
    	],
    	[
    		[
    			194898,
    			194898
    		],
    		"mapped",
    		[
    			153126
    		]
    	],
    	[
    		[
    			194899,
    			194899
    		],
    		"mapped",
    		[
    			31062
    		]
    	],
    	[
    		[
    			194900,
    			194900
    		],
    		"mapped",
    		[
    			153242
    		]
    	],
    	[
    		[
    			194901,
    			194901
    		],
    		"mapped",
    		[
    			153285
    		]
    	],
    	[
    		[
    			194902,
    			194902
    		],
    		"mapped",
    		[
    			31119
    		]
    	],
    	[
    		[
    			194903,
    			194903
    		],
    		"mapped",
    		[
    			31211
    		]
    	],
    	[
    		[
    			194904,
    			194904
    		],
    		"mapped",
    		[
    			16687
    		]
    	],
    	[
    		[
    			194905,
    			194905
    		],
    		"mapped",
    		[
    			31296
    		]
    	],
    	[
    		[
    			194906,
    			194906
    		],
    		"mapped",
    		[
    			31306
    		]
    	],
    	[
    		[
    			194907,
    			194907
    		],
    		"mapped",
    		[
    			31311
    		]
    	],
    	[
    		[
    			194908,
    			194908
    		],
    		"mapped",
    		[
    			153980
    		]
    	],
    	[
    		[
    			194909,
    			194910
    		],
    		"mapped",
    		[
    			154279
    		]
    	],
    	[
    		[
    			194911,
    			194911
    		],
    		"disallowed"
    	],
    	[
    		[
    			194912,
    			194912
    		],
    		"mapped",
    		[
    			16898
    		]
    	],
    	[
    		[
    			194913,
    			194913
    		],
    		"mapped",
    		[
    			154539
    		]
    	],
    	[
    		[
    			194914,
    			194914
    		],
    		"mapped",
    		[
    			31686
    		]
    	],
    	[
    		[
    			194915,
    			194915
    		],
    		"mapped",
    		[
    			31689
    		]
    	],
    	[
    		[
    			194916,
    			194916
    		],
    		"mapped",
    		[
    			16935
    		]
    	],
    	[
    		[
    			194917,
    			194917
    		],
    		"mapped",
    		[
    			154752
    		]
    	],
    	[
    		[
    			194918,
    			194918
    		],
    		"mapped",
    		[
    			31954
    		]
    	],
    	[
    		[
    			194919,
    			194919
    		],
    		"mapped",
    		[
    			17056
    		]
    	],
    	[
    		[
    			194920,
    			194920
    		],
    		"mapped",
    		[
    			31976
    		]
    	],
    	[
    		[
    			194921,
    			194921
    		],
    		"mapped",
    		[
    			31971
    		]
    	],
    	[
    		[
    			194922,
    			194922
    		],
    		"mapped",
    		[
    			32000
    		]
    	],
    	[
    		[
    			194923,
    			194923
    		],
    		"mapped",
    		[
    			155526
    		]
    	],
    	[
    		[
    			194924,
    			194924
    		],
    		"mapped",
    		[
    			32099
    		]
    	],
    	[
    		[
    			194925,
    			194925
    		],
    		"mapped",
    		[
    			17153
    		]
    	],
    	[
    		[
    			194926,
    			194926
    		],
    		"mapped",
    		[
    			32199
    		]
    	],
    	[
    		[
    			194927,
    			194927
    		],
    		"mapped",
    		[
    			32258
    		]
    	],
    	[
    		[
    			194928,
    			194928
    		],
    		"mapped",
    		[
    			32325
    		]
    	],
    	[
    		[
    			194929,
    			194929
    		],
    		"mapped",
    		[
    			17204
    		]
    	],
    	[
    		[
    			194930,
    			194930
    		],
    		"mapped",
    		[
    			156200
    		]
    	],
    	[
    		[
    			194931,
    			194931
    		],
    		"mapped",
    		[
    			156231
    		]
    	],
    	[
    		[
    			194932,
    			194932
    		],
    		"mapped",
    		[
    			17241
    		]
    	],
    	[
    		[
    			194933,
    			194933
    		],
    		"mapped",
    		[
    			156377
    		]
    	],
    	[
    		[
    			194934,
    			194934
    		],
    		"mapped",
    		[
    			32634
    		]
    	],
    	[
    		[
    			194935,
    			194935
    		],
    		"mapped",
    		[
    			156478
    		]
    	],
    	[
    		[
    			194936,
    			194936
    		],
    		"mapped",
    		[
    			32661
    		]
    	],
    	[
    		[
    			194937,
    			194937
    		],
    		"mapped",
    		[
    			32762
    		]
    	],
    	[
    		[
    			194938,
    			194938
    		],
    		"mapped",
    		[
    			32773
    		]
    	],
    	[
    		[
    			194939,
    			194939
    		],
    		"mapped",
    		[
    			156890
    		]
    	],
    	[
    		[
    			194940,
    			194940
    		],
    		"mapped",
    		[
    			156963
    		]
    	],
    	[
    		[
    			194941,
    			194941
    		],
    		"mapped",
    		[
    			32864
    		]
    	],
    	[
    		[
    			194942,
    			194942
    		],
    		"mapped",
    		[
    			157096
    		]
    	],
    	[
    		[
    			194943,
    			194943
    		],
    		"mapped",
    		[
    			32880
    		]
    	],
    	[
    		[
    			194944,
    			194944
    		],
    		"mapped",
    		[
    			144223
    		]
    	],
    	[
    		[
    			194945,
    			194945
    		],
    		"mapped",
    		[
    			17365
    		]
    	],
    	[
    		[
    			194946,
    			194946
    		],
    		"mapped",
    		[
    			32946
    		]
    	],
    	[
    		[
    			194947,
    			194947
    		],
    		"mapped",
    		[
    			33027
    		]
    	],
    	[
    		[
    			194948,
    			194948
    		],
    		"mapped",
    		[
    			17419
    		]
    	],
    	[
    		[
    			194949,
    			194949
    		],
    		"mapped",
    		[
    			33086
    		]
    	],
    	[
    		[
    			194950,
    			194950
    		],
    		"mapped",
    		[
    			23221
    		]
    	],
    	[
    		[
    			194951,
    			194951
    		],
    		"mapped",
    		[
    			157607
    		]
    	],
    	[
    		[
    			194952,
    			194952
    		],
    		"mapped",
    		[
    			157621
    		]
    	],
    	[
    		[
    			194953,
    			194953
    		],
    		"mapped",
    		[
    			144275
    		]
    	],
    	[
    		[
    			194954,
    			194954
    		],
    		"mapped",
    		[
    			144284
    		]
    	],
    	[
    		[
    			194955,
    			194955
    		],
    		"mapped",
    		[
    			33281
    		]
    	],
    	[
    		[
    			194956,
    			194956
    		],
    		"mapped",
    		[
    			33284
    		]
    	],
    	[
    		[
    			194957,
    			194957
    		],
    		"mapped",
    		[
    			36766
    		]
    	],
    	[
    		[
    			194958,
    			194958
    		],
    		"mapped",
    		[
    			17515
    		]
    	],
    	[
    		[
    			194959,
    			194959
    		],
    		"mapped",
    		[
    			33425
    		]
    	],
    	[
    		[
    			194960,
    			194960
    		],
    		"mapped",
    		[
    			33419
    		]
    	],
    	[
    		[
    			194961,
    			194961
    		],
    		"mapped",
    		[
    			33437
    		]
    	],
    	[
    		[
    			194962,
    			194962
    		],
    		"mapped",
    		[
    			21171
    		]
    	],
    	[
    		[
    			194963,
    			194963
    		],
    		"mapped",
    		[
    			33457
    		]
    	],
    	[
    		[
    			194964,
    			194964
    		],
    		"mapped",
    		[
    			33459
    		]
    	],
    	[
    		[
    			194965,
    			194965
    		],
    		"mapped",
    		[
    			33469
    		]
    	],
    	[
    		[
    			194966,
    			194966
    		],
    		"mapped",
    		[
    			33510
    		]
    	],
    	[
    		[
    			194967,
    			194967
    		],
    		"mapped",
    		[
    			158524
    		]
    	],
    	[
    		[
    			194968,
    			194968
    		],
    		"mapped",
    		[
    			33509
    		]
    	],
    	[
    		[
    			194969,
    			194969
    		],
    		"mapped",
    		[
    			33565
    		]
    	],
    	[
    		[
    			194970,
    			194970
    		],
    		"mapped",
    		[
    			33635
    		]
    	],
    	[
    		[
    			194971,
    			194971
    		],
    		"mapped",
    		[
    			33709
    		]
    	],
    	[
    		[
    			194972,
    			194972
    		],
    		"mapped",
    		[
    			33571
    		]
    	],
    	[
    		[
    			194973,
    			194973
    		],
    		"mapped",
    		[
    			33725
    		]
    	],
    	[
    		[
    			194974,
    			194974
    		],
    		"mapped",
    		[
    			33767
    		]
    	],
    	[
    		[
    			194975,
    			194975
    		],
    		"mapped",
    		[
    			33879
    		]
    	],
    	[
    		[
    			194976,
    			194976
    		],
    		"mapped",
    		[
    			33619
    		]
    	],
    	[
    		[
    			194977,
    			194977
    		],
    		"mapped",
    		[
    			33738
    		]
    	],
    	[
    		[
    			194978,
    			194978
    		],
    		"mapped",
    		[
    			33740
    		]
    	],
    	[
    		[
    			194979,
    			194979
    		],
    		"mapped",
    		[
    			33756
    		]
    	],
    	[
    		[
    			194980,
    			194980
    		],
    		"mapped",
    		[
    			158774
    		]
    	],
    	[
    		[
    			194981,
    			194981
    		],
    		"mapped",
    		[
    			159083
    		]
    	],
    	[
    		[
    			194982,
    			194982
    		],
    		"mapped",
    		[
    			158933
    		]
    	],
    	[
    		[
    			194983,
    			194983
    		],
    		"mapped",
    		[
    			17707
    		]
    	],
    	[
    		[
    			194984,
    			194984
    		],
    		"mapped",
    		[
    			34033
    		]
    	],
    	[
    		[
    			194985,
    			194985
    		],
    		"mapped",
    		[
    			34035
    		]
    	],
    	[
    		[
    			194986,
    			194986
    		],
    		"mapped",
    		[
    			34070
    		]
    	],
    	[
    		[
    			194987,
    			194987
    		],
    		"mapped",
    		[
    			160714
    		]
    	],
    	[
    		[
    			194988,
    			194988
    		],
    		"mapped",
    		[
    			34148
    		]
    	],
    	[
    		[
    			194989,
    			194989
    		],
    		"mapped",
    		[
    			159532
    		]
    	],
    	[
    		[
    			194990,
    			194990
    		],
    		"mapped",
    		[
    			17757
    		]
    	],
    	[
    		[
    			194991,
    			194991
    		],
    		"mapped",
    		[
    			17761
    		]
    	],
    	[
    		[
    			194992,
    			194992
    		],
    		"mapped",
    		[
    			159665
    		]
    	],
    	[
    		[
    			194993,
    			194993
    		],
    		"mapped",
    		[
    			159954
    		]
    	],
    	[
    		[
    			194994,
    			194994
    		],
    		"mapped",
    		[
    			17771
    		]
    	],
    	[
    		[
    			194995,
    			194995
    		],
    		"mapped",
    		[
    			34384
    		]
    	],
    	[
    		[
    			194996,
    			194996
    		],
    		"mapped",
    		[
    			34396
    		]
    	],
    	[
    		[
    			194997,
    			194997
    		],
    		"mapped",
    		[
    			34407
    		]
    	],
    	[
    		[
    			194998,
    			194998
    		],
    		"mapped",
    		[
    			34409
    		]
    	],
    	[
    		[
    			194999,
    			194999
    		],
    		"mapped",
    		[
    			34473
    		]
    	],
    	[
    		[
    			195000,
    			195000
    		],
    		"mapped",
    		[
    			34440
    		]
    	],
    	[
    		[
    			195001,
    			195001
    		],
    		"mapped",
    		[
    			34574
    		]
    	],
    	[
    		[
    			195002,
    			195002
    		],
    		"mapped",
    		[
    			34530
    		]
    	],
    	[
    		[
    			195003,
    			195003
    		],
    		"mapped",
    		[
    			34681
    		]
    	],
    	[
    		[
    			195004,
    			195004
    		],
    		"mapped",
    		[
    			34600
    		]
    	],
    	[
    		[
    			195005,
    			195005
    		],
    		"mapped",
    		[
    			34667
    		]
    	],
    	[
    		[
    			195006,
    			195006
    		],
    		"mapped",
    		[
    			34694
    		]
    	],
    	[
    		[
    			195007,
    			195007
    		],
    		"disallowed"
    	],
    	[
    		[
    			195008,
    			195008
    		],
    		"mapped",
    		[
    			34785
    		]
    	],
    	[
    		[
    			195009,
    			195009
    		],
    		"mapped",
    		[
    			34817
    		]
    	],
    	[
    		[
    			195010,
    			195010
    		],
    		"mapped",
    		[
    			17913
    		]
    	],
    	[
    		[
    			195011,
    			195011
    		],
    		"mapped",
    		[
    			34912
    		]
    	],
    	[
    		[
    			195012,
    			195012
    		],
    		"mapped",
    		[
    			34915
    		]
    	],
    	[
    		[
    			195013,
    			195013
    		],
    		"mapped",
    		[
    			161383
    		]
    	],
    	[
    		[
    			195014,
    			195014
    		],
    		"mapped",
    		[
    			35031
    		]
    	],
    	[
    		[
    			195015,
    			195015
    		],
    		"mapped",
    		[
    			35038
    		]
    	],
    	[
    		[
    			195016,
    			195016
    		],
    		"mapped",
    		[
    			17973
    		]
    	],
    	[
    		[
    			195017,
    			195017
    		],
    		"mapped",
    		[
    			35066
    		]
    	],
    	[
    		[
    			195018,
    			195018
    		],
    		"mapped",
    		[
    			13499
    		]
    	],
    	[
    		[
    			195019,
    			195019
    		],
    		"mapped",
    		[
    			161966
    		]
    	],
    	[
    		[
    			195020,
    			195020
    		],
    		"mapped",
    		[
    			162150
    		]
    	],
    	[
    		[
    			195021,
    			195021
    		],
    		"mapped",
    		[
    			18110
    		]
    	],
    	[
    		[
    			195022,
    			195022
    		],
    		"mapped",
    		[
    			18119
    		]
    	],
    	[
    		[
    			195023,
    			195023
    		],
    		"mapped",
    		[
    			35488
    		]
    	],
    	[
    		[
    			195024,
    			195024
    		],
    		"mapped",
    		[
    			35565
    		]
    	],
    	[
    		[
    			195025,
    			195025
    		],
    		"mapped",
    		[
    			35722
    		]
    	],
    	[
    		[
    			195026,
    			195026
    		],
    		"mapped",
    		[
    			35925
    		]
    	],
    	[
    		[
    			195027,
    			195027
    		],
    		"mapped",
    		[
    			162984
    		]
    	],
    	[
    		[
    			195028,
    			195028
    		],
    		"mapped",
    		[
    			36011
    		]
    	],
    	[
    		[
    			195029,
    			195029
    		],
    		"mapped",
    		[
    			36033
    		]
    	],
    	[
    		[
    			195030,
    			195030
    		],
    		"mapped",
    		[
    			36123
    		]
    	],
    	[
    		[
    			195031,
    			195031
    		],
    		"mapped",
    		[
    			36215
    		]
    	],
    	[
    		[
    			195032,
    			195032
    		],
    		"mapped",
    		[
    			163631
    		]
    	],
    	[
    		[
    			195033,
    			195033
    		],
    		"mapped",
    		[
    			133124
    		]
    	],
    	[
    		[
    			195034,
    			195034
    		],
    		"mapped",
    		[
    			36299
    		]
    	],
    	[
    		[
    			195035,
    			195035
    		],
    		"mapped",
    		[
    			36284
    		]
    	],
    	[
    		[
    			195036,
    			195036
    		],
    		"mapped",
    		[
    			36336
    		]
    	],
    	[
    		[
    			195037,
    			195037
    		],
    		"mapped",
    		[
    			133342
    		]
    	],
    	[
    		[
    			195038,
    			195038
    		],
    		"mapped",
    		[
    			36564
    		]
    	],
    	[
    		[
    			195039,
    			195039
    		],
    		"mapped",
    		[
    			36664
    		]
    	],
    	[
    		[
    			195040,
    			195040
    		],
    		"mapped",
    		[
    			165330
    		]
    	],
    	[
    		[
    			195041,
    			195041
    		],
    		"mapped",
    		[
    			165357
    		]
    	],
    	[
    		[
    			195042,
    			195042
    		],
    		"mapped",
    		[
    			37012
    		]
    	],
    	[
    		[
    			195043,
    			195043
    		],
    		"mapped",
    		[
    			37105
    		]
    	],
    	[
    		[
    			195044,
    			195044
    		],
    		"mapped",
    		[
    			37137
    		]
    	],
    	[
    		[
    			195045,
    			195045
    		],
    		"mapped",
    		[
    			165678
    		]
    	],
    	[
    		[
    			195046,
    			195046
    		],
    		"mapped",
    		[
    			37147
    		]
    	],
    	[
    		[
    			195047,
    			195047
    		],
    		"mapped",
    		[
    			37432
    		]
    	],
    	[
    		[
    			195048,
    			195048
    		],
    		"mapped",
    		[
    			37591
    		]
    	],
    	[
    		[
    			195049,
    			195049
    		],
    		"mapped",
    		[
    			37592
    		]
    	],
    	[
    		[
    			195050,
    			195050
    		],
    		"mapped",
    		[
    			37500
    		]
    	],
    	[
    		[
    			195051,
    			195051
    		],
    		"mapped",
    		[
    			37881
    		]
    	],
    	[
    		[
    			195052,
    			195052
    		],
    		"mapped",
    		[
    			37909
    		]
    	],
    	[
    		[
    			195053,
    			195053
    		],
    		"mapped",
    		[
    			166906
    		]
    	],
    	[
    		[
    			195054,
    			195054
    		],
    		"mapped",
    		[
    			38283
    		]
    	],
    	[
    		[
    			195055,
    			195055
    		],
    		"mapped",
    		[
    			18837
    		]
    	],
    	[
    		[
    			195056,
    			195056
    		],
    		"mapped",
    		[
    			38327
    		]
    	],
    	[
    		[
    			195057,
    			195057
    		],
    		"mapped",
    		[
    			167287
    		]
    	],
    	[
    		[
    			195058,
    			195058
    		],
    		"mapped",
    		[
    			18918
    		]
    	],
    	[
    		[
    			195059,
    			195059
    		],
    		"mapped",
    		[
    			38595
    		]
    	],
    	[
    		[
    			195060,
    			195060
    		],
    		"mapped",
    		[
    			23986
    		]
    	],
    	[
    		[
    			195061,
    			195061
    		],
    		"mapped",
    		[
    			38691
    		]
    	],
    	[
    		[
    			195062,
    			195062
    		],
    		"mapped",
    		[
    			168261
    		]
    	],
    	[
    		[
    			195063,
    			195063
    		],
    		"mapped",
    		[
    			168474
    		]
    	],
    	[
    		[
    			195064,
    			195064
    		],
    		"mapped",
    		[
    			19054
    		]
    	],
    	[
    		[
    			195065,
    			195065
    		],
    		"mapped",
    		[
    			19062
    		]
    	],
    	[
    		[
    			195066,
    			195066
    		],
    		"mapped",
    		[
    			38880
    		]
    	],
    	[
    		[
    			195067,
    			195067
    		],
    		"mapped",
    		[
    			168970
    		]
    	],
    	[
    		[
    			195068,
    			195068
    		],
    		"mapped",
    		[
    			19122
    		]
    	],
    	[
    		[
    			195069,
    			195069
    		],
    		"mapped",
    		[
    			169110
    		]
    	],
    	[
    		[
    			195070,
    			195071
    		],
    		"mapped",
    		[
    			38923
    		]
    	],
    	[
    		[
    			195072,
    			195072
    		],
    		"mapped",
    		[
    			38953
    		]
    	],
    	[
    		[
    			195073,
    			195073
    		],
    		"mapped",
    		[
    			169398
    		]
    	],
    	[
    		[
    			195074,
    			195074
    		],
    		"mapped",
    		[
    			39138
    		]
    	],
    	[
    		[
    			195075,
    			195075
    		],
    		"mapped",
    		[
    			19251
    		]
    	],
    	[
    		[
    			195076,
    			195076
    		],
    		"mapped",
    		[
    			39209
    		]
    	],
    	[
    		[
    			195077,
    			195077
    		],
    		"mapped",
    		[
    			39335
    		]
    	],
    	[
    		[
    			195078,
    			195078
    		],
    		"mapped",
    		[
    			39362
    		]
    	],
    	[
    		[
    			195079,
    			195079
    		],
    		"mapped",
    		[
    			39422
    		]
    	],
    	[
    		[
    			195080,
    			195080
    		],
    		"mapped",
    		[
    			19406
    		]
    	],
    	[
    		[
    			195081,
    			195081
    		],
    		"mapped",
    		[
    			170800
    		]
    	],
    	[
    		[
    			195082,
    			195082
    		],
    		"mapped",
    		[
    			39698
    		]
    	],
    	[
    		[
    			195083,
    			195083
    		],
    		"mapped",
    		[
    			40000
    		]
    	],
    	[
    		[
    			195084,
    			195084
    		],
    		"mapped",
    		[
    			40189
    		]
    	],
    	[
    		[
    			195085,
    			195085
    		],
    		"mapped",
    		[
    			19662
    		]
    	],
    	[
    		[
    			195086,
    			195086
    		],
    		"mapped",
    		[
    			19693
    		]
    	],
    	[
    		[
    			195087,
    			195087
    		],
    		"mapped",
    		[
    			40295
    		]
    	],
    	[
    		[
    			195088,
    			195088
    		],
    		"mapped",
    		[
    			172238
    		]
    	],
    	[
    		[
    			195089,
    			195089
    		],
    		"mapped",
    		[
    			19704
    		]
    	],
    	[
    		[
    			195090,
    			195090
    		],
    		"mapped",
    		[
    			172293
    		]
    	],
    	[
    		[
    			195091,
    			195091
    		],
    		"mapped",
    		[
    			172558
    		]
    	],
    	[
    		[
    			195092,
    			195092
    		],
    		"mapped",
    		[
    			172689
    		]
    	],
    	[
    		[
    			195093,
    			195093
    		],
    		"mapped",
    		[
    			40635
    		]
    	],
    	[
    		[
    			195094,
    			195094
    		],
    		"mapped",
    		[
    			19798
    		]
    	],
    	[
    		[
    			195095,
    			195095
    		],
    		"mapped",
    		[
    			40697
    		]
    	],
    	[
    		[
    			195096,
    			195096
    		],
    		"mapped",
    		[
    			40702
    		]
    	],
    	[
    		[
    			195097,
    			195097
    		],
    		"mapped",
    		[
    			40709
    		]
    	],
    	[
    		[
    			195098,
    			195098
    		],
    		"mapped",
    		[
    			40719
    		]
    	],
    	[
    		[
    			195099,
    			195099
    		],
    		"mapped",
    		[
    			40726
    		]
    	],
    	[
    		[
    			195100,
    			195100
    		],
    		"mapped",
    		[
    			40763
    		]
    	],
    	[
    		[
    			195101,
    			195101
    		],
    		"mapped",
    		[
    			173568
    		]
    	],
    	[
    		[
    			195102,
    			196605
    		],
    		"disallowed"
    	],
    	[
    		[
    			196606,
    			196607
    		],
    		"disallowed"
    	],
    	[
    		[
    			196608,
    			262141
    		],
    		"disallowed"
    	],
    	[
    		[
    			262142,
    			262143
    		],
    		"disallowed"
    	],
    	[
    		[
    			262144,
    			327677
    		],
    		"disallowed"
    	],
    	[
    		[
    			327678,
    			327679
    		],
    		"disallowed"
    	],
    	[
    		[
    			327680,
    			393213
    		],
    		"disallowed"
    	],
    	[
    		[
    			393214,
    			393215
    		],
    		"disallowed"
    	],
    	[
    		[
    			393216,
    			458749
    		],
    		"disallowed"
    	],
    	[
    		[
    			458750,
    			458751
    		],
    		"disallowed"
    	],
    	[
    		[
    			458752,
    			524285
    		],
    		"disallowed"
    	],
    	[
    		[
    			524286,
    			524287
    		],
    		"disallowed"
    	],
    	[
    		[
    			524288,
    			589821
    		],
    		"disallowed"
    	],
    	[
    		[
    			589822,
    			589823
    		],
    		"disallowed"
    	],
    	[
    		[
    			589824,
    			655357
    		],
    		"disallowed"
    	],
    	[
    		[
    			655358,
    			655359
    		],
    		"disallowed"
    	],
    	[
    		[
    			655360,
    			720893
    		],
    		"disallowed"
    	],
    	[
    		[
    			720894,
    			720895
    		],
    		"disallowed"
    	],
    	[
    		[
    			720896,
    			786429
    		],
    		"disallowed"
    	],
    	[
    		[
    			786430,
    			786431
    		],
    		"disallowed"
    	],
    	[
    		[
    			786432,
    			851965
    		],
    		"disallowed"
    	],
    	[
    		[
    			851966,
    			851967
    		],
    		"disallowed"
    	],
    	[
    		[
    			851968,
    			917501
    		],
    		"disallowed"
    	],
    	[
    		[
    			917502,
    			917503
    		],
    		"disallowed"
    	],
    	[
    		[
    			917504,
    			917504
    		],
    		"disallowed"
    	],
    	[
    		[
    			917505,
    			917505
    		],
    		"disallowed"
    	],
    	[
    		[
    			917506,
    			917535
    		],
    		"disallowed"
    	],
    	[
    		[
    			917536,
    			917631
    		],
    		"disallowed"
    	],
    	[
    		[
    			917632,
    			917759
    		],
    		"disallowed"
    	],
    	[
    		[
    			917760,
    			917999
    		],
    		"ignored"
    	],
    	[
    		[
    			918000,
    			983037
    		],
    		"disallowed"
    	],
    	[
    		[
    			983038,
    			983039
    		],
    		"disallowed"
    	],
    	[
    		[
    			983040,
    			1048573
    		],
    		"disallowed"
    	],
    	[
    		[
    			1048574,
    			1048575
    		],
    		"disallowed"
    	],
    	[
    		[
    			1048576,
    			1114109
    		],
    		"disallowed"
    	],
    	[
    		[
    			1114110,
    			1114111
    		],
    		"disallowed"
    	]
    ];

    var punycode = require$$0$1;
    var mappingTable = require$$1;

    var PROCESSING_OPTIONS = {
      TRANSITIONAL: 0,
      NONTRANSITIONAL: 1
    };

    function normalize(str) { // fix bug in v8
      return str.split('\u0000').map(function (s) { return s.normalize('NFC'); }).join('\u0000');
    }

    function findStatus(val) {
      var start = 0;
      var end = mappingTable.length - 1;

      while (start <= end) {
        var mid = Math.floor((start + end) / 2);

        var target = mappingTable[mid];
        if (target[0][0] <= val && target[0][1] >= val) {
          return target;
        } else if (target[0][0] > val) {
          end = mid - 1;
        } else {
          start = mid + 1;
        }
      }

      return null;
    }

    var regexAstralSymbols = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g;

    function countSymbols(string) {
      return string
        // replace every surrogate pair with a BMP symbol
        .replace(regexAstralSymbols, '_')
        // then get the length
        .length;
    }

    function mapChars(domain_name, useSTD3, processing_option) {
      var hasError = false;
      var processed = "";

      var len = countSymbols(domain_name);
      for (var i = 0; i < len; ++i) {
        var codePoint = domain_name.codePointAt(i);
        var status = findStatus(codePoint);

        switch (status[1]) {
          case "disallowed":
            hasError = true;
            processed += String.fromCodePoint(codePoint);
            break;
          case "ignored":
            break;
          case "mapped":
            processed += String.fromCodePoint.apply(String, status[2]);
            break;
          case "deviation":
            if (processing_option === PROCESSING_OPTIONS.TRANSITIONAL) {
              processed += String.fromCodePoint.apply(String, status[2]);
            } else {
              processed += String.fromCodePoint(codePoint);
            }
            break;
          case "valid":
            processed += String.fromCodePoint(codePoint);
            break;
          case "disallowed_STD3_mapped":
            if (useSTD3) {
              hasError = true;
              processed += String.fromCodePoint(codePoint);
            } else {
              processed += String.fromCodePoint.apply(String, status[2]);
            }
            break;
          case "disallowed_STD3_valid":
            if (useSTD3) {
              hasError = true;
            }

            processed += String.fromCodePoint(codePoint);
            break;
        }
      }

      return {
        string: processed,
        error: hasError
      };
    }

    var combiningMarksRegex = /[\u0300-\u036F\u0483-\u0489\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u065F\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u0711\u0730-\u074A\u07A6-\u07B0\u07EB-\u07F3\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u08E4-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A70\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B62\u0B63\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0C00-\u0C03\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0D01-\u0D03\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D82\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0EB1\u0EB4-\u0EB9\u0EBB\u0EBC\u0EC8-\u0ECD\u0F18\u0F19\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F\u109A-\u109D\u135D-\u135F\u1712-\u1714\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u180B-\u180D\u18A9\u1920-\u192B\u1930-\u193B\u19B0-\u19C0\u19C8\u19C9\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F\u1AB0-\u1ABE\u1B00-\u1B04\u1B34-\u1B44\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BE6-\u1BF3\u1C24-\u1C37\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF2-\u1CF4\u1CF8\u1CF9\u1DC0-\u1DF5\u1DFC-\u1DFF\u20D0-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA66F-\uA672\uA674-\uA67D\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA880\uA881\uA8B4-\uA8C4\uA8E0-\uA8F1\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9E5\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uFB1E\uFE00-\uFE0F\uFE20-\uFE2D]|\uD800[\uDDFD\uDEE0\uDF76-\uDF7A]|\uD802[\uDE01-\uDE03\uDE05\uDE06\uDE0C-\uDE0F\uDE38-\uDE3A\uDE3F\uDEE5\uDEE6]|\uD804[\uDC00-\uDC02\uDC38-\uDC46\uDC7F-\uDC82\uDCB0-\uDCBA\uDD00-\uDD02\uDD27-\uDD34\uDD73\uDD80-\uDD82\uDDB3-\uDDC0\uDE2C-\uDE37\uDEDF-\uDEEA\uDF01-\uDF03\uDF3C\uDF3E-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF57\uDF62\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDCB0-\uDCC3\uDDAF-\uDDB5\uDDB8-\uDDC0\uDE30-\uDE40\uDEAB-\uDEB7]|\uD81A[\uDEF0-\uDEF4\uDF30-\uDF36]|\uD81B[\uDF51-\uDF7E\uDF8F-\uDF92]|\uD82F[\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD83A[\uDCD0-\uDCD6]|\uDB40[\uDD00-\uDDEF]/;

    function validateLabel(label, processing_option) {
      if (label.substr(0, 4) === "xn--") {
        label = punycode.toUnicode(label);
        PROCESSING_OPTIONS.NONTRANSITIONAL;
      }

      var error = false;

      if (normalize(label) !== label ||
          (label[3] === "-" && label[4] === "-") ||
          label[0] === "-" || label[label.length - 1] === "-" ||
          label.indexOf(".") !== -1 ||
          label.search(combiningMarksRegex) === 0) {
        error = true;
      }

      var len = countSymbols(label);
      for (var i = 0; i < len; ++i) {
        var status = findStatus(label.codePointAt(i));
        if ((processing === PROCESSING_OPTIONS.TRANSITIONAL && status[1] !== "valid") ||
            (processing === PROCESSING_OPTIONS.NONTRANSITIONAL &&
             status[1] !== "valid" && status[1] !== "deviation")) {
          error = true;
          break;
        }
      }

      return {
        label: label,
        error: error
      };
    }

    function processing(domain_name, useSTD3, processing_option) {
      var result = mapChars(domain_name, useSTD3, processing_option);
      result.string = normalize(result.string);

      var labels = result.string.split(".");
      for (var i = 0; i < labels.length; ++i) {
        try {
          var validation = validateLabel(labels[i]);
          labels[i] = validation.label;
          result.error = result.error || validation.error;
        } catch(e) {
          result.error = true;
        }
      }

      return {
        string: labels.join("."),
        error: result.error
      };
    }

    tr46.toASCII = function(domain_name, useSTD3, processing_option, verifyDnsLength) {
      var result = processing(domain_name, useSTD3, processing_option);
      var labels = result.string.split(".");
      labels = labels.map(function(l) {
        try {
          return punycode.toASCII(l);
        } catch(e) {
          result.error = true;
          return l;
        }
      });

      if (verifyDnsLength) {
        var total = labels.slice(0, labels.length - 1).join(".").length;
        if (total.length > 253 || total.length === 0) {
          result.error = true;
        }

        for (var i=0; i < labels.length; ++i) {
          if (labels.length > 63 || labels.length === 0) {
            result.error = true;
            break;
          }
        }
      }

      if (result.error) return null;
      return labels.join(".");
    };

    tr46.toUnicode = function(domain_name, useSTD3) {
      var result = processing(domain_name, useSTD3, PROCESSING_OPTIONS.NONTRANSITIONAL);

      return {
        domain: result.string,
        error: result.error
      };
    };

    tr46.PROCESSING_OPTIONS = PROCESSING_OPTIONS;

    (function (module) {
    	const punycode = require$$0$1;
    	const tr46$1 = tr46;

    	const specialSchemes = {
    	  ftp: 21,
    	  file: null,
    	  gopher: 70,
    	  http: 80,
    	  https: 443,
    	  ws: 80,
    	  wss: 443
    	};

    	const failure = Symbol("failure");

    	function countSymbols(str) {
    	  return punycode.ucs2.decode(str).length;
    	}

    	function at(input, idx) {
    	  const c = input[idx];
    	  return isNaN(c) ? undefined : String.fromCodePoint(c);
    	}

    	function isASCIIDigit(c) {
    	  return c >= 0x30 && c <= 0x39;
    	}

    	function isASCIIAlpha(c) {
    	  return (c >= 0x41 && c <= 0x5A) || (c >= 0x61 && c <= 0x7A);
    	}

    	function isASCIIAlphanumeric(c) {
    	  return isASCIIAlpha(c) || isASCIIDigit(c);
    	}

    	function isASCIIHex(c) {
    	  return isASCIIDigit(c) || (c >= 0x41 && c <= 0x46) || (c >= 0x61 && c <= 0x66);
    	}

    	function isSingleDot(buffer) {
    	  return buffer === "." || buffer.toLowerCase() === "%2e";
    	}

    	function isDoubleDot(buffer) {
    	  buffer = buffer.toLowerCase();
    	  return buffer === ".." || buffer === "%2e." || buffer === ".%2e" || buffer === "%2e%2e";
    	}

    	function isWindowsDriveLetterCodePoints(cp1, cp2) {
    	  return isASCIIAlpha(cp1) && (cp2 === 58 || cp2 === 124);
    	}

    	function isWindowsDriveLetterString(string) {
    	  return string.length === 2 && isASCIIAlpha(string.codePointAt(0)) && (string[1] === ":" || string[1] === "|");
    	}

    	function isNormalizedWindowsDriveLetterString(string) {
    	  return string.length === 2 && isASCIIAlpha(string.codePointAt(0)) && string[1] === ":";
    	}

    	function containsForbiddenHostCodePoint(string) {
    	  return string.search(/\u0000|\u0009|\u000A|\u000D|\u0020|#|%|\/|:|\?|@|\[|\\|\]/) !== -1;
    	}

    	function containsForbiddenHostCodePointExcludingPercent(string) {
    	  return string.search(/\u0000|\u0009|\u000A|\u000D|\u0020|#|\/|:|\?|@|\[|\\|\]/) !== -1;
    	}

    	function isSpecialScheme(scheme) {
    	  return specialSchemes[scheme] !== undefined;
    	}

    	function isSpecial(url) {
    	  return isSpecialScheme(url.scheme);
    	}

    	function defaultPort(scheme) {
    	  return specialSchemes[scheme];
    	}

    	function percentEncode(c) {
    	  let hex = c.toString(16).toUpperCase();
    	  if (hex.length === 1) {
    	    hex = "0" + hex;
    	  }

    	  return "%" + hex;
    	}

    	function utf8PercentEncode(c) {
    	  const buf = new Buffer$3(c);

    	  let str = "";

    	  for (let i = 0; i < buf.length; ++i) {
    	    str += percentEncode(buf[i]);
    	  }

    	  return str;
    	}

    	function utf8PercentDecode(str) {
    	  const input = new Buffer$3(str);
    	  const output = [];
    	  for (let i = 0; i < input.length; ++i) {
    	    if (input[i] !== 37) {
    	      output.push(input[i]);
    	    } else if (input[i] === 37 && isASCIIHex(input[i + 1]) && isASCIIHex(input[i + 2])) {
    	      output.push(parseInt(input.slice(i + 1, i + 3).toString(), 16));
    	      i += 2;
    	    } else {
    	      output.push(input[i]);
    	    }
    	  }
    	  return new Buffer$3(output).toString();
    	}

    	function isC0ControlPercentEncode(c) {
    	  return c <= 0x1F || c > 0x7E;
    	}

    	const extraPathPercentEncodeSet = new Set([32, 34, 35, 60, 62, 63, 96, 123, 125]);
    	function isPathPercentEncode(c) {
    	  return isC0ControlPercentEncode(c) || extraPathPercentEncodeSet.has(c);
    	}

    	const extraUserinfoPercentEncodeSet =
    	  new Set([47, 58, 59, 61, 64, 91, 92, 93, 94, 124]);
    	function isUserinfoPercentEncode(c) {
    	  return isPathPercentEncode(c) || extraUserinfoPercentEncodeSet.has(c);
    	}

    	function percentEncodeChar(c, encodeSetPredicate) {
    	  const cStr = String.fromCodePoint(c);

    	  if (encodeSetPredicate(c)) {
    	    return utf8PercentEncode(cStr);
    	  }

    	  return cStr;
    	}

    	function parseIPv4Number(input) {
    	  let R = 10;

    	  if (input.length >= 2 && input.charAt(0) === "0" && input.charAt(1).toLowerCase() === "x") {
    	    input = input.substring(2);
    	    R = 16;
    	  } else if (input.length >= 2 && input.charAt(0) === "0") {
    	    input = input.substring(1);
    	    R = 8;
    	  }

    	  if (input === "") {
    	    return 0;
    	  }

    	  const regex = R === 10 ? /[^0-9]/ : (R === 16 ? /[^0-9A-Fa-f]/ : /[^0-7]/);
    	  if (regex.test(input)) {
    	    return failure;
    	  }

    	  return parseInt(input, R);
    	}

    	function parseIPv4(input) {
    	  const parts = input.split(".");
    	  if (parts[parts.length - 1] === "") {
    	    if (parts.length > 1) {
    	      parts.pop();
    	    }
    	  }

    	  if (parts.length > 4) {
    	    return input;
    	  }

    	  const numbers = [];
    	  for (const part of parts) {
    	    if (part === "") {
    	      return input;
    	    }
    	    const n = parseIPv4Number(part);
    	    if (n === failure) {
    	      return input;
    	    }

    	    numbers.push(n);
    	  }

    	  for (let i = 0; i < numbers.length - 1; ++i) {
    	    if (numbers[i] > 255) {
    	      return failure;
    	    }
    	  }
    	  if (numbers[numbers.length - 1] >= Math.pow(256, 5 - numbers.length)) {
    	    return failure;
    	  }

    	  let ipv4 = numbers.pop();
    	  let counter = 0;

    	  for (const n of numbers) {
    	    ipv4 += n * Math.pow(256, 3 - counter);
    	    ++counter;
    	  }

    	  return ipv4;
    	}

    	function serializeIPv4(address) {
    	  let output = "";
    	  let n = address;

    	  for (let i = 1; i <= 4; ++i) {
    	    output = String(n % 256) + output;
    	    if (i !== 4) {
    	      output = "." + output;
    	    }
    	    n = Math.floor(n / 256);
    	  }

    	  return output;
    	}

    	function parseIPv6(input) {
    	  const address = [0, 0, 0, 0, 0, 0, 0, 0];
    	  let pieceIndex = 0;
    	  let compress = null;
    	  let pointer = 0;

    	  input = punycode.ucs2.decode(input);

    	  if (input[pointer] === 58) {
    	    if (input[pointer + 1] !== 58) {
    	      return failure;
    	    }

    	    pointer += 2;
    	    ++pieceIndex;
    	    compress = pieceIndex;
    	  }

    	  while (pointer < input.length) {
    	    if (pieceIndex === 8) {
    	      return failure;
    	    }

    	    if (input[pointer] === 58) {
    	      if (compress !== null) {
    	        return failure;
    	      }
    	      ++pointer;
    	      ++pieceIndex;
    	      compress = pieceIndex;
    	      continue;
    	    }

    	    let value = 0;
    	    let length = 0;

    	    while (length < 4 && isASCIIHex(input[pointer])) {
    	      value = value * 0x10 + parseInt(at(input, pointer), 16);
    	      ++pointer;
    	      ++length;
    	    }

    	    if (input[pointer] === 46) {
    	      if (length === 0) {
    	        return failure;
    	      }

    	      pointer -= length;

    	      if (pieceIndex > 6) {
    	        return failure;
    	      }

    	      let numbersSeen = 0;

    	      while (input[pointer] !== undefined) {
    	        let ipv4Piece = null;

    	        if (numbersSeen > 0) {
    	          if (input[pointer] === 46 && numbersSeen < 4) {
    	            ++pointer;
    	          } else {
    	            return failure;
    	          }
    	        }

    	        if (!isASCIIDigit(input[pointer])) {
    	          return failure;
    	        }

    	        while (isASCIIDigit(input[pointer])) {
    	          const number = parseInt(at(input, pointer));
    	          if (ipv4Piece === null) {
    	            ipv4Piece = number;
    	          } else if (ipv4Piece === 0) {
    	            return failure;
    	          } else {
    	            ipv4Piece = ipv4Piece * 10 + number;
    	          }
    	          if (ipv4Piece > 255) {
    	            return failure;
    	          }
    	          ++pointer;
    	        }

    	        address[pieceIndex] = address[pieceIndex] * 0x100 + ipv4Piece;

    	        ++numbersSeen;

    	        if (numbersSeen === 2 || numbersSeen === 4) {
    	          ++pieceIndex;
    	        }
    	      }

    	      if (numbersSeen !== 4) {
    	        return failure;
    	      }

    	      break;
    	    } else if (input[pointer] === 58) {
    	      ++pointer;
    	      if (input[pointer] === undefined) {
    	        return failure;
    	      }
    	    } else if (input[pointer] !== undefined) {
    	      return failure;
    	    }

    	    address[pieceIndex] = value;
    	    ++pieceIndex;
    	  }

    	  if (compress !== null) {
    	    let swaps = pieceIndex - compress;
    	    pieceIndex = 7;
    	    while (pieceIndex !== 0 && swaps > 0) {
    	      const temp = address[compress + swaps - 1];
    	      address[compress + swaps - 1] = address[pieceIndex];
    	      address[pieceIndex] = temp;
    	      --pieceIndex;
    	      --swaps;
    	    }
    	  } else if (compress === null && pieceIndex !== 8) {
    	    return failure;
    	  }

    	  return address;
    	}

    	function serializeIPv6(address) {
    	  let output = "";
    	  const seqResult = findLongestZeroSequence(address);
    	  const compress = seqResult.idx;
    	  let ignore0 = false;

    	  for (let pieceIndex = 0; pieceIndex <= 7; ++pieceIndex) {
    	    if (ignore0 && address[pieceIndex] === 0) {
    	      continue;
    	    } else if (ignore0) {
    	      ignore0 = false;
    	    }

    	    if (compress === pieceIndex) {
    	      const separator = pieceIndex === 0 ? "::" : ":";
    	      output += separator;
    	      ignore0 = true;
    	      continue;
    	    }

    	    output += address[pieceIndex].toString(16);

    	    if (pieceIndex !== 7) {
    	      output += ":";
    	    }
    	  }

    	  return output;
    	}

    	function parseHost(input, isSpecialArg) {
    	  if (input[0] === "[") {
    	    if (input[input.length - 1] !== "]") {
    	      return failure;
    	    }

    	    return parseIPv6(input.substring(1, input.length - 1));
    	  }

    	  if (!isSpecialArg) {
    	    return parseOpaqueHost(input);
    	  }

    	  const domain = utf8PercentDecode(input);
    	  const asciiDomain = tr46$1.toASCII(domain, false, tr46$1.PROCESSING_OPTIONS.NONTRANSITIONAL, false);
    	  if (asciiDomain === null) {
    	    return failure;
    	  }

    	  if (containsForbiddenHostCodePoint(asciiDomain)) {
    	    return failure;
    	  }

    	  const ipv4Host = parseIPv4(asciiDomain);
    	  if (typeof ipv4Host === "number" || ipv4Host === failure) {
    	    return ipv4Host;
    	  }

    	  return asciiDomain;
    	}

    	function parseOpaqueHost(input) {
    	  if (containsForbiddenHostCodePointExcludingPercent(input)) {
    	    return failure;
    	  }

    	  let output = "";
    	  const decoded = punycode.ucs2.decode(input);
    	  for (let i = 0; i < decoded.length; ++i) {
    	    output += percentEncodeChar(decoded[i], isC0ControlPercentEncode);
    	  }
    	  return output;
    	}

    	function findLongestZeroSequence(arr) {
    	  let maxIdx = null;
    	  let maxLen = 1; // only find elements > 1
    	  let currStart = null;
    	  let currLen = 0;

    	  for (let i = 0; i < arr.length; ++i) {
    	    if (arr[i] !== 0) {
    	      if (currLen > maxLen) {
    	        maxIdx = currStart;
    	        maxLen = currLen;
    	      }

    	      currStart = null;
    	      currLen = 0;
    	    } else {
    	      if (currStart === null) {
    	        currStart = i;
    	      }
    	      ++currLen;
    	    }
    	  }

    	  // if trailing zeros
    	  if (currLen > maxLen) {
    	    maxIdx = currStart;
    	    maxLen = currLen;
    	  }

    	  return {
    	    idx: maxIdx,
    	    len: maxLen
    	  };
    	}

    	function serializeHost(host) {
    	  if (typeof host === "number") {
    	    return serializeIPv4(host);
    	  }

    	  // IPv6 serializer
    	  if (host instanceof Array) {
    	    return "[" + serializeIPv6(host) + "]";
    	  }

    	  return host;
    	}

    	function trimControlChars(url) {
    	  return url.replace(/^[\u0000-\u001F\u0020]+|[\u0000-\u001F\u0020]+$/g, "");
    	}

    	function trimTabAndNewline(url) {
    	  return url.replace(/\u0009|\u000A|\u000D/g, "");
    	}

    	function shortenPath(url) {
    	  const path = url.path;
    	  if (path.length === 0) {
    	    return;
    	  }
    	  if (url.scheme === "file" && path.length === 1 && isNormalizedWindowsDriveLetter(path[0])) {
    	    return;
    	  }

    	  path.pop();
    	}

    	function includesCredentials(url) {
    	  return url.username !== "" || url.password !== "";
    	}

    	function cannotHaveAUsernamePasswordPort(url) {
    	  return url.host === null || url.host === "" || url.cannotBeABaseURL || url.scheme === "file";
    	}

    	function isNormalizedWindowsDriveLetter(string) {
    	  return /^[A-Za-z]:$/.test(string);
    	}

    	function URLStateMachine(input, base, encodingOverride, url, stateOverride) {
    	  this.pointer = 0;
    	  this.input = input;
    	  this.base = base || null;
    	  this.encodingOverride = encodingOverride || "utf-8";
    	  this.stateOverride = stateOverride;
    	  this.url = url;
    	  this.failure = false;
    	  this.parseError = false;

    	  if (!this.url) {
    	    this.url = {
    	      scheme: "",
    	      username: "",
    	      password: "",
    	      host: null,
    	      port: null,
    	      path: [],
    	      query: null,
    	      fragment: null,

    	      cannotBeABaseURL: false
    	    };

    	    const res = trimControlChars(this.input);
    	    if (res !== this.input) {
    	      this.parseError = true;
    	    }
    	    this.input = res;
    	  }

    	  const res = trimTabAndNewline(this.input);
    	  if (res !== this.input) {
    	    this.parseError = true;
    	  }
    	  this.input = res;

    	  this.state = stateOverride || "scheme start";

    	  this.buffer = "";
    	  this.atFlag = false;
    	  this.arrFlag = false;
    	  this.passwordTokenSeenFlag = false;

    	  this.input = punycode.ucs2.decode(this.input);

    	  for (; this.pointer <= this.input.length; ++this.pointer) {
    	    const c = this.input[this.pointer];
    	    const cStr = isNaN(c) ? undefined : String.fromCodePoint(c);

    	    // exec state machine
    	    const ret = this["parse " + this.state](c, cStr);
    	    if (!ret) {
    	      break; // terminate algorithm
    	    } else if (ret === failure) {
    	      this.failure = true;
    	      break;
    	    }
    	  }
    	}

    	URLStateMachine.prototype["parse scheme start"] = function parseSchemeStart(c, cStr) {
    	  if (isASCIIAlpha(c)) {
    	    this.buffer += cStr.toLowerCase();
    	    this.state = "scheme";
    	  } else if (!this.stateOverride) {
    	    this.state = "no scheme";
    	    --this.pointer;
    	  } else {
    	    this.parseError = true;
    	    return failure;
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse scheme"] = function parseScheme(c, cStr) {
    	  if (isASCIIAlphanumeric(c) || c === 43 || c === 45 || c === 46) {
    	    this.buffer += cStr.toLowerCase();
    	  } else if (c === 58) {
    	    if (this.stateOverride) {
    	      if (isSpecial(this.url) && !isSpecialScheme(this.buffer)) {
    	        return false;
    	      }

    	      if (!isSpecial(this.url) && isSpecialScheme(this.buffer)) {
    	        return false;
    	      }

    	      if ((includesCredentials(this.url) || this.url.port !== null) && this.buffer === "file") {
    	        return false;
    	      }

    	      if (this.url.scheme === "file" && (this.url.host === "" || this.url.host === null)) {
    	        return false;
    	      }
    	    }
    	    this.url.scheme = this.buffer;
    	    this.buffer = "";
    	    if (this.stateOverride) {
    	      return false;
    	    }
    	    if (this.url.scheme === "file") {
    	      if (this.input[this.pointer + 1] !== 47 || this.input[this.pointer + 2] !== 47) {
    	        this.parseError = true;
    	      }
    	      this.state = "file";
    	    } else if (isSpecial(this.url) && this.base !== null && this.base.scheme === this.url.scheme) {
    	      this.state = "special relative or authority";
    	    } else if (isSpecial(this.url)) {
    	      this.state = "special authority slashes";
    	    } else if (this.input[this.pointer + 1] === 47) {
    	      this.state = "path or authority";
    	      ++this.pointer;
    	    } else {
    	      this.url.cannotBeABaseURL = true;
    	      this.url.path.push("");
    	      this.state = "cannot-be-a-base-URL path";
    	    }
    	  } else if (!this.stateOverride) {
    	    this.buffer = "";
    	    this.state = "no scheme";
    	    this.pointer = -1;
    	  } else {
    	    this.parseError = true;
    	    return failure;
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse no scheme"] = function parseNoScheme(c) {
    	  if (this.base === null || (this.base.cannotBeABaseURL && c !== 35)) {
    	    return failure;
    	  } else if (this.base.cannotBeABaseURL && c === 35) {
    	    this.url.scheme = this.base.scheme;
    	    this.url.path = this.base.path.slice();
    	    this.url.query = this.base.query;
    	    this.url.fragment = "";
    	    this.url.cannotBeABaseURL = true;
    	    this.state = "fragment";
    	  } else if (this.base.scheme === "file") {
    	    this.state = "file";
    	    --this.pointer;
    	  } else {
    	    this.state = "relative";
    	    --this.pointer;
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse special relative or authority"] = function parseSpecialRelativeOrAuthority(c) {
    	  if (c === 47 && this.input[this.pointer + 1] === 47) {
    	    this.state = "special authority ignore slashes";
    	    ++this.pointer;
    	  } else {
    	    this.parseError = true;
    	    this.state = "relative";
    	    --this.pointer;
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse path or authority"] = function parsePathOrAuthority(c) {
    	  if (c === 47) {
    	    this.state = "authority";
    	  } else {
    	    this.state = "path";
    	    --this.pointer;
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse relative"] = function parseRelative(c) {
    	  this.url.scheme = this.base.scheme;
    	  if (isNaN(c)) {
    	    this.url.username = this.base.username;
    	    this.url.password = this.base.password;
    	    this.url.host = this.base.host;
    	    this.url.port = this.base.port;
    	    this.url.path = this.base.path.slice();
    	    this.url.query = this.base.query;
    	  } else if (c === 47) {
    	    this.state = "relative slash";
    	  } else if (c === 63) {
    	    this.url.username = this.base.username;
    	    this.url.password = this.base.password;
    	    this.url.host = this.base.host;
    	    this.url.port = this.base.port;
    	    this.url.path = this.base.path.slice();
    	    this.url.query = "";
    	    this.state = "query";
    	  } else if (c === 35) {
    	    this.url.username = this.base.username;
    	    this.url.password = this.base.password;
    	    this.url.host = this.base.host;
    	    this.url.port = this.base.port;
    	    this.url.path = this.base.path.slice();
    	    this.url.query = this.base.query;
    	    this.url.fragment = "";
    	    this.state = "fragment";
    	  } else if (isSpecial(this.url) && c === 92) {
    	    this.parseError = true;
    	    this.state = "relative slash";
    	  } else {
    	    this.url.username = this.base.username;
    	    this.url.password = this.base.password;
    	    this.url.host = this.base.host;
    	    this.url.port = this.base.port;
    	    this.url.path = this.base.path.slice(0, this.base.path.length - 1);

    	    this.state = "path";
    	    --this.pointer;
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse relative slash"] = function parseRelativeSlash(c) {
    	  if (isSpecial(this.url) && (c === 47 || c === 92)) {
    	    if (c === 92) {
    	      this.parseError = true;
    	    }
    	    this.state = "special authority ignore slashes";
    	  } else if (c === 47) {
    	    this.state = "authority";
    	  } else {
    	    this.url.username = this.base.username;
    	    this.url.password = this.base.password;
    	    this.url.host = this.base.host;
    	    this.url.port = this.base.port;
    	    this.state = "path";
    	    --this.pointer;
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse special authority slashes"] = function parseSpecialAuthoritySlashes(c) {
    	  if (c === 47 && this.input[this.pointer + 1] === 47) {
    	    this.state = "special authority ignore slashes";
    	    ++this.pointer;
    	  } else {
    	    this.parseError = true;
    	    this.state = "special authority ignore slashes";
    	    --this.pointer;
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse special authority ignore slashes"] = function parseSpecialAuthorityIgnoreSlashes(c) {
    	  if (c !== 47 && c !== 92) {
    	    this.state = "authority";
    	    --this.pointer;
    	  } else {
    	    this.parseError = true;
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse authority"] = function parseAuthority(c, cStr) {
    	  if (c === 64) {
    	    this.parseError = true;
    	    if (this.atFlag) {
    	      this.buffer = "%40" + this.buffer;
    	    }
    	    this.atFlag = true;

    	    // careful, this is based on buffer and has its own pointer (this.pointer != pointer) and inner chars
    	    const len = countSymbols(this.buffer);
    	    for (let pointer = 0; pointer < len; ++pointer) {
    	      const codePoint = this.buffer.codePointAt(pointer);

    	      if (codePoint === 58 && !this.passwordTokenSeenFlag) {
    	        this.passwordTokenSeenFlag = true;
    	        continue;
    	      }
    	      const encodedCodePoints = percentEncodeChar(codePoint, isUserinfoPercentEncode);
    	      if (this.passwordTokenSeenFlag) {
    	        this.url.password += encodedCodePoints;
    	      } else {
    	        this.url.username += encodedCodePoints;
    	      }
    	    }
    	    this.buffer = "";
    	  } else if (isNaN(c) || c === 47 || c === 63 || c === 35 ||
    	             (isSpecial(this.url) && c === 92)) {
    	    if (this.atFlag && this.buffer === "") {
    	      this.parseError = true;
    	      return failure;
    	    }
    	    this.pointer -= countSymbols(this.buffer) + 1;
    	    this.buffer = "";
    	    this.state = "host";
    	  } else {
    	    this.buffer += cStr;
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse hostname"] =
    	URLStateMachine.prototype["parse host"] = function parseHostName(c, cStr) {
    	  if (this.stateOverride && this.url.scheme === "file") {
    	    --this.pointer;
    	    this.state = "file host";
    	  } else if (c === 58 && !this.arrFlag) {
    	    if (this.buffer === "") {
    	      this.parseError = true;
    	      return failure;
    	    }

    	    const host = parseHost(this.buffer, isSpecial(this.url));
    	    if (host === failure) {
    	      return failure;
    	    }

    	    this.url.host = host;
    	    this.buffer = "";
    	    this.state = "port";
    	    if (this.stateOverride === "hostname") {
    	      return false;
    	    }
    	  } else if (isNaN(c) || c === 47 || c === 63 || c === 35 ||
    	             (isSpecial(this.url) && c === 92)) {
    	    --this.pointer;
    	    if (isSpecial(this.url) && this.buffer === "") {
    	      this.parseError = true;
    	      return failure;
    	    } else if (this.stateOverride && this.buffer === "" &&
    	               (includesCredentials(this.url) || this.url.port !== null)) {
    	      this.parseError = true;
    	      return false;
    	    }

    	    const host = parseHost(this.buffer, isSpecial(this.url));
    	    if (host === failure) {
    	      return failure;
    	    }

    	    this.url.host = host;
    	    this.buffer = "";
    	    this.state = "path start";
    	    if (this.stateOverride) {
    	      return false;
    	    }
    	  } else {
    	    if (c === 91) {
    	      this.arrFlag = true;
    	    } else if (c === 93) {
    	      this.arrFlag = false;
    	    }
    	    this.buffer += cStr;
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse port"] = function parsePort(c, cStr) {
    	  if (isASCIIDigit(c)) {
    	    this.buffer += cStr;
    	  } else if (isNaN(c) || c === 47 || c === 63 || c === 35 ||
    	             (isSpecial(this.url) && c === 92) ||
    	             this.stateOverride) {
    	    if (this.buffer !== "") {
    	      const port = parseInt(this.buffer);
    	      if (port > Math.pow(2, 16) - 1) {
    	        this.parseError = true;
    	        return failure;
    	      }
    	      this.url.port = port === defaultPort(this.url.scheme) ? null : port;
    	      this.buffer = "";
    	    }
    	    if (this.stateOverride) {
    	      return false;
    	    }
    	    this.state = "path start";
    	    --this.pointer;
    	  } else {
    	    this.parseError = true;
    	    return failure;
    	  }

    	  return true;
    	};

    	const fileOtherwiseCodePoints = new Set([47, 92, 63, 35]);

    	URLStateMachine.prototype["parse file"] = function parseFile(c) {
    	  this.url.scheme = "file";

    	  if (c === 47 || c === 92) {
    	    if (c === 92) {
    	      this.parseError = true;
    	    }
    	    this.state = "file slash";
    	  } else if (this.base !== null && this.base.scheme === "file") {
    	    if (isNaN(c)) {
    	      this.url.host = this.base.host;
    	      this.url.path = this.base.path.slice();
    	      this.url.query = this.base.query;
    	    } else if (c === 63) {
    	      this.url.host = this.base.host;
    	      this.url.path = this.base.path.slice();
    	      this.url.query = "";
    	      this.state = "query";
    	    } else if (c === 35) {
    	      this.url.host = this.base.host;
    	      this.url.path = this.base.path.slice();
    	      this.url.query = this.base.query;
    	      this.url.fragment = "";
    	      this.state = "fragment";
    	    } else {
    	      if (this.input.length - this.pointer - 1 === 0 || // remaining consists of 0 code points
    	          !isWindowsDriveLetterCodePoints(c, this.input[this.pointer + 1]) ||
    	          (this.input.length - this.pointer - 1 >= 2 && // remaining has at least 2 code points
    	           !fileOtherwiseCodePoints.has(this.input[this.pointer + 2]))) {
    	        this.url.host = this.base.host;
    	        this.url.path = this.base.path.slice();
    	        shortenPath(this.url);
    	      } else {
    	        this.parseError = true;
    	      }

    	      this.state = "path";
    	      --this.pointer;
    	    }
    	  } else {
    	    this.state = "path";
    	    --this.pointer;
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse file slash"] = function parseFileSlash(c) {
    	  if (c === 47 || c === 92) {
    	    if (c === 92) {
    	      this.parseError = true;
    	    }
    	    this.state = "file host";
    	  } else {
    	    if (this.base !== null && this.base.scheme === "file") {
    	      if (isNormalizedWindowsDriveLetterString(this.base.path[0])) {
    	        this.url.path.push(this.base.path[0]);
    	      } else {
    	        this.url.host = this.base.host;
    	      }
    	    }
    	    this.state = "path";
    	    --this.pointer;
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse file host"] = function parseFileHost(c, cStr) {
    	  if (isNaN(c) || c === 47 || c === 92 || c === 63 || c === 35) {
    	    --this.pointer;
    	    if (!this.stateOverride && isWindowsDriveLetterString(this.buffer)) {
    	      this.parseError = true;
    	      this.state = "path";
    	    } else if (this.buffer === "") {
    	      this.url.host = "";
    	      if (this.stateOverride) {
    	        return false;
    	      }
    	      this.state = "path start";
    	    } else {
    	      let host = parseHost(this.buffer, isSpecial(this.url));
    	      if (host === failure) {
    	        return failure;
    	      }
    	      if (host === "localhost") {
    	        host = "";
    	      }
    	      this.url.host = host;

    	      if (this.stateOverride) {
    	        return false;
    	      }

    	      this.buffer = "";
    	      this.state = "path start";
    	    }
    	  } else {
    	    this.buffer += cStr;
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse path start"] = function parsePathStart(c) {
    	  if (isSpecial(this.url)) {
    	    if (c === 92) {
    	      this.parseError = true;
    	    }
    	    this.state = "path";

    	    if (c !== 47 && c !== 92) {
    	      --this.pointer;
    	    }
    	  } else if (!this.stateOverride && c === 63) {
    	    this.url.query = "";
    	    this.state = "query";
    	  } else if (!this.stateOverride && c === 35) {
    	    this.url.fragment = "";
    	    this.state = "fragment";
    	  } else if (c !== undefined) {
    	    this.state = "path";
    	    if (c !== 47) {
    	      --this.pointer;
    	    }
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse path"] = function parsePath(c) {
    	  if (isNaN(c) || c === 47 || (isSpecial(this.url) && c === 92) ||
    	      (!this.stateOverride && (c === 63 || c === 35))) {
    	    if (isSpecial(this.url) && c === 92) {
    	      this.parseError = true;
    	    }

    	    if (isDoubleDot(this.buffer)) {
    	      shortenPath(this.url);
    	      if (c !== 47 && !(isSpecial(this.url) && c === 92)) {
    	        this.url.path.push("");
    	      }
    	    } else if (isSingleDot(this.buffer) && c !== 47 &&
    	               !(isSpecial(this.url) && c === 92)) {
    	      this.url.path.push("");
    	    } else if (!isSingleDot(this.buffer)) {
    	      if (this.url.scheme === "file" && this.url.path.length === 0 && isWindowsDriveLetterString(this.buffer)) {
    	        if (this.url.host !== "" && this.url.host !== null) {
    	          this.parseError = true;
    	          this.url.host = "";
    	        }
    	        this.buffer = this.buffer[0] + ":";
    	      }
    	      this.url.path.push(this.buffer);
    	    }
    	    this.buffer = "";
    	    if (this.url.scheme === "file" && (c === undefined || c === 63 || c === 35)) {
    	      while (this.url.path.length > 1 && this.url.path[0] === "") {
    	        this.parseError = true;
    	        this.url.path.shift();
    	      }
    	    }
    	    if (c === 63) {
    	      this.url.query = "";
    	      this.state = "query";
    	    }
    	    if (c === 35) {
    	      this.url.fragment = "";
    	      this.state = "fragment";
    	    }
    	  } else {
    	    // TODO: If c is not a URL code point and not "%", parse error.

    	    if (c === 37 &&
    	      (!isASCIIHex(this.input[this.pointer + 1]) ||
    	        !isASCIIHex(this.input[this.pointer + 2]))) {
    	      this.parseError = true;
    	    }

    	    this.buffer += percentEncodeChar(c, isPathPercentEncode);
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse cannot-be-a-base-URL path"] = function parseCannotBeABaseURLPath(c) {
    	  if (c === 63) {
    	    this.url.query = "";
    	    this.state = "query";
    	  } else if (c === 35) {
    	    this.url.fragment = "";
    	    this.state = "fragment";
    	  } else {
    	    // TODO: Add: not a URL code point
    	    if (!isNaN(c) && c !== 37) {
    	      this.parseError = true;
    	    }

    	    if (c === 37 &&
    	        (!isASCIIHex(this.input[this.pointer + 1]) ||
    	         !isASCIIHex(this.input[this.pointer + 2]))) {
    	      this.parseError = true;
    	    }

    	    if (!isNaN(c)) {
    	      this.url.path[0] = this.url.path[0] + percentEncodeChar(c, isC0ControlPercentEncode);
    	    }
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse query"] = function parseQuery(c, cStr) {
    	  if (isNaN(c) || (!this.stateOverride && c === 35)) {
    	    if (!isSpecial(this.url) || this.url.scheme === "ws" || this.url.scheme === "wss") {
    	      this.encodingOverride = "utf-8";
    	    }

    	    const buffer = new Buffer$3(this.buffer); // TODO: Use encoding override instead
    	    for (let i = 0; i < buffer.length; ++i) {
    	      if (buffer[i] < 0x21 || buffer[i] > 0x7E || buffer[i] === 0x22 || buffer[i] === 0x23 ||
    	          buffer[i] === 0x3C || buffer[i] === 0x3E) {
    	        this.url.query += percentEncode(buffer[i]);
    	      } else {
    	        this.url.query += String.fromCodePoint(buffer[i]);
    	      }
    	    }

    	    this.buffer = "";
    	    if (c === 35) {
    	      this.url.fragment = "";
    	      this.state = "fragment";
    	    }
    	  } else {
    	    // TODO: If c is not a URL code point and not "%", parse error.
    	    if (c === 37 &&
    	      (!isASCIIHex(this.input[this.pointer + 1]) ||
    	        !isASCIIHex(this.input[this.pointer + 2]))) {
    	      this.parseError = true;
    	    }

    	    this.buffer += cStr;
    	  }

    	  return true;
    	};

    	URLStateMachine.prototype["parse fragment"] = function parseFragment(c) {
    	  if (isNaN(c)) ; else if (c === 0x0) {
    	    this.parseError = true;
    	  } else {
    	    // TODO: If c is not a URL code point and not "%", parse error.
    	    if (c === 37 &&
    	      (!isASCIIHex(this.input[this.pointer + 1]) ||
    	        !isASCIIHex(this.input[this.pointer + 2]))) {
    	      this.parseError = true;
    	    }

    	    this.url.fragment += percentEncodeChar(c, isC0ControlPercentEncode);
    	  }

    	  return true;
    	};

    	function serializeURL(url, excludeFragment) {
    	  let output = url.scheme + ":";
    	  if (url.host !== null) {
    	    output += "//";

    	    if (url.username !== "" || url.password !== "") {
    	      output += url.username;
    	      if (url.password !== "") {
    	        output += ":" + url.password;
    	      }
    	      output += "@";
    	    }

    	    output += serializeHost(url.host);

    	    if (url.port !== null) {
    	      output += ":" + url.port;
    	    }
    	  } else if (url.host === null && url.scheme === "file") {
    	    output += "//";
    	  }

    	  if (url.cannotBeABaseURL) {
    	    output += url.path[0];
    	  } else {
    	    for (const string of url.path) {
    	      output += "/" + string;
    	    }
    	  }

    	  if (url.query !== null) {
    	    output += "?" + url.query;
    	  }

    	  if (!excludeFragment && url.fragment !== null) {
    	    output += "#" + url.fragment;
    	  }

    	  return output;
    	}

    	function serializeOrigin(tuple) {
    	  let result = tuple.scheme + "://";
    	  result += serializeHost(tuple.host);

    	  if (tuple.port !== null) {
    	    result += ":" + tuple.port;
    	  }

    	  return result;
    	}

    	module.exports.serializeURL = serializeURL;

    	module.exports.serializeURLOrigin = function (url) {
    	  // https://url.spec.whatwg.org/#concept-url-origin
    	  switch (url.scheme) {
    	    case "blob":
    	      try {
    	        return module.exports.serializeURLOrigin(module.exports.parseURL(url.path[0]));
    	      } catch (e) {
    	        // serializing an opaque origin returns "null"
    	        return "null";
    	      }
    	    case "ftp":
    	    case "gopher":
    	    case "http":
    	    case "https":
    	    case "ws":
    	    case "wss":
    	      return serializeOrigin({
    	        scheme: url.scheme,
    	        host: url.host,
    	        port: url.port
    	      });
    	    case "file":
    	      // spec says "exercise to the reader", chrome says "file://"
    	      return "file://";
    	    default:
    	      // serializing an opaque origin returns "null"
    	      return "null";
    	  }
    	};

    	module.exports.basicURLParse = function (input, options) {
    	  if (options === undefined) {
    	    options = {};
    	  }

    	  const usm = new URLStateMachine(input, options.baseURL, options.encodingOverride, options.url, options.stateOverride);
    	  if (usm.failure) {
    	    return "failure";
    	  }

    	  return usm.url;
    	};

    	module.exports.setTheUsername = function (url, username) {
    	  url.username = "";
    	  const decoded = punycode.ucs2.decode(username);
    	  for (let i = 0; i < decoded.length; ++i) {
    	    url.username += percentEncodeChar(decoded[i], isUserinfoPercentEncode);
    	  }
    	};

    	module.exports.setThePassword = function (url, password) {
    	  url.password = "";
    	  const decoded = punycode.ucs2.decode(password);
    	  for (let i = 0; i < decoded.length; ++i) {
    	    url.password += percentEncodeChar(decoded[i], isUserinfoPercentEncode);
    	  }
    	};

    	module.exports.serializeHost = serializeHost;

    	module.exports.cannotHaveAUsernamePasswordPort = cannotHaveAUsernamePasswordPort;

    	module.exports.serializeInteger = function (integer) {
    	  return String(integer);
    	};

    	module.exports.parseURL = function (input, options) {
    	  if (options === undefined) {
    	    options = {};
    	  }

    	  // We don't handle blobs, so this just delegates:
    	  return module.exports.basicURLParse(input, { baseURL: options.baseURL, encodingOverride: options.encodingOverride });
    	};
    } (urlStateMachine));

    const usm = urlStateMachine.exports;

    URLImpl.implementation = class URLImpl {
      constructor(constructorArgs) {
        const url = constructorArgs[0];
        const base = constructorArgs[1];

        let parsedBase = null;
        if (base !== undefined) {
          parsedBase = usm.basicURLParse(base);
          if (parsedBase === "failure") {
            throw new TypeError("Invalid base URL");
          }
        }

        const parsedURL = usm.basicURLParse(url, { baseURL: parsedBase });
        if (parsedURL === "failure") {
          throw new TypeError("Invalid URL");
        }

        this._url = parsedURL;

        // TODO: query stuff
      }

      get href() {
        return usm.serializeURL(this._url);
      }

      set href(v) {
        const parsedURL = usm.basicURLParse(v);
        if (parsedURL === "failure") {
          throw new TypeError("Invalid URL");
        }

        this._url = parsedURL;
      }

      get origin() {
        return usm.serializeURLOrigin(this._url);
      }

      get protocol() {
        return this._url.scheme + ":";
      }

      set protocol(v) {
        usm.basicURLParse(v + ":", { url: this._url, stateOverride: "scheme start" });
      }

      get username() {
        return this._url.username;
      }

      set username(v) {
        if (usm.cannotHaveAUsernamePasswordPort(this._url)) {
          return;
        }

        usm.setTheUsername(this._url, v);
      }

      get password() {
        return this._url.password;
      }

      set password(v) {
        if (usm.cannotHaveAUsernamePasswordPort(this._url)) {
          return;
        }

        usm.setThePassword(this._url, v);
      }

      get host() {
        const url = this._url;

        if (url.host === null) {
          return "";
        }

        if (url.port === null) {
          return usm.serializeHost(url.host);
        }

        return usm.serializeHost(url.host) + ":" + usm.serializeInteger(url.port);
      }

      set host(v) {
        if (this._url.cannotBeABaseURL) {
          return;
        }

        usm.basicURLParse(v, { url: this._url, stateOverride: "host" });
      }

      get hostname() {
        if (this._url.host === null) {
          return "";
        }

        return usm.serializeHost(this._url.host);
      }

      set hostname(v) {
        if (this._url.cannotBeABaseURL) {
          return;
        }

        usm.basicURLParse(v, { url: this._url, stateOverride: "hostname" });
      }

      get port() {
        if (this._url.port === null) {
          return "";
        }

        return usm.serializeInteger(this._url.port);
      }

      set port(v) {
        if (usm.cannotHaveAUsernamePasswordPort(this._url)) {
          return;
        }

        if (v === "") {
          this._url.port = null;
        } else {
          usm.basicURLParse(v, { url: this._url, stateOverride: "port" });
        }
      }

      get pathname() {
        if (this._url.cannotBeABaseURL) {
          return this._url.path[0];
        }

        if (this._url.path.length === 0) {
          return "";
        }

        return "/" + this._url.path.join("/");
      }

      set pathname(v) {
        if (this._url.cannotBeABaseURL) {
          return;
        }

        this._url.path = [];
        usm.basicURLParse(v, { url: this._url, stateOverride: "path start" });
      }

      get search() {
        if (this._url.query === null || this._url.query === "") {
          return "";
        }

        return "?" + this._url.query;
      }

      set search(v) {
        // TODO: query stuff

        const url = this._url;

        if (v === "") {
          url.query = null;
          return;
        }

        const input = v[0] === "?" ? v.substring(1) : v;
        url.query = "";
        usm.basicURLParse(input, { url, stateOverride: "query" });
      }

      get hash() {
        if (this._url.fragment === null || this._url.fragment === "") {
          return "";
        }

        return "#" + this._url.fragment;
      }

      set hash(v) {
        if (v === "") {
          this._url.fragment = null;
          return;
        }

        const input = v[0] === "#" ? v.substring(1) : v;
        this._url.fragment = "";
        usm.basicURLParse(input, { url: this._url, stateOverride: "fragment" });
      }

      toJSON() {
        return this.href;
      }
    };

    (function (module) {

    	const conversions = lib;
    	const utils$1 = utils.exports;
    	const Impl = URLImpl;

    	const impl = utils$1.implSymbol;

    	function URL(url) {
    	  if (!this || this[impl] || !(this instanceof URL)) {
    	    throw new TypeError("Failed to construct 'URL': Please use the 'new' operator, this DOM object constructor cannot be called as a function.");
    	  }
    	  if (arguments.length < 1) {
    	    throw new TypeError("Failed to construct 'URL': 1 argument required, but only " + arguments.length + " present.");
    	  }
    	  const args = [];
    	  for (let i = 0; i < arguments.length && i < 2; ++i) {
    	    args[i] = arguments[i];
    	  }
    	  args[0] = conversions["USVString"](args[0]);
    	  if (args[1] !== undefined) {
    	  args[1] = conversions["USVString"](args[1]);
    	  }

    	  module.exports.setup(this, args);
    	}

    	URL.prototype.toJSON = function toJSON() {
    	  if (!this || !module.exports.is(this)) {
    	    throw new TypeError("Illegal invocation");
    	  }
    	  const args = [];
    	  for (let i = 0; i < arguments.length && i < 0; ++i) {
    	    args[i] = arguments[i];
    	  }
    	  return this[impl].toJSON.apply(this[impl], args);
    	};
    	Object.defineProperty(URL.prototype, "href", {
    	  get() {
    	    return this[impl].href;
    	  },
    	  set(V) {
    	    V = conversions["USVString"](V);
    	    this[impl].href = V;
    	  },
    	  enumerable: true,
    	  configurable: true
    	});

    	URL.prototype.toString = function () {
    	  if (!this || !module.exports.is(this)) {
    	    throw new TypeError("Illegal invocation");
    	  }
    	  return this.href;
    	};

    	Object.defineProperty(URL.prototype, "origin", {
    	  get() {
    	    return this[impl].origin;
    	  },
    	  enumerable: true,
    	  configurable: true
    	});

    	Object.defineProperty(URL.prototype, "protocol", {
    	  get() {
    	    return this[impl].protocol;
    	  },
    	  set(V) {
    	    V = conversions["USVString"](V);
    	    this[impl].protocol = V;
    	  },
    	  enumerable: true,
    	  configurable: true
    	});

    	Object.defineProperty(URL.prototype, "username", {
    	  get() {
    	    return this[impl].username;
    	  },
    	  set(V) {
    	    V = conversions["USVString"](V);
    	    this[impl].username = V;
    	  },
    	  enumerable: true,
    	  configurable: true
    	});

    	Object.defineProperty(URL.prototype, "password", {
    	  get() {
    	    return this[impl].password;
    	  },
    	  set(V) {
    	    V = conversions["USVString"](V);
    	    this[impl].password = V;
    	  },
    	  enumerable: true,
    	  configurable: true
    	});

    	Object.defineProperty(URL.prototype, "host", {
    	  get() {
    	    return this[impl].host;
    	  },
    	  set(V) {
    	    V = conversions["USVString"](V);
    	    this[impl].host = V;
    	  },
    	  enumerable: true,
    	  configurable: true
    	});

    	Object.defineProperty(URL.prototype, "hostname", {
    	  get() {
    	    return this[impl].hostname;
    	  },
    	  set(V) {
    	    V = conversions["USVString"](V);
    	    this[impl].hostname = V;
    	  },
    	  enumerable: true,
    	  configurable: true
    	});

    	Object.defineProperty(URL.prototype, "port", {
    	  get() {
    	    return this[impl].port;
    	  },
    	  set(V) {
    	    V = conversions["USVString"](V);
    	    this[impl].port = V;
    	  },
    	  enumerable: true,
    	  configurable: true
    	});

    	Object.defineProperty(URL.prototype, "pathname", {
    	  get() {
    	    return this[impl].pathname;
    	  },
    	  set(V) {
    	    V = conversions["USVString"](V);
    	    this[impl].pathname = V;
    	  },
    	  enumerable: true,
    	  configurable: true
    	});

    	Object.defineProperty(URL.prototype, "search", {
    	  get() {
    	    return this[impl].search;
    	  },
    	  set(V) {
    	    V = conversions["USVString"](V);
    	    this[impl].search = V;
    	  },
    	  enumerable: true,
    	  configurable: true
    	});

    	Object.defineProperty(URL.prototype, "hash", {
    	  get() {
    	    return this[impl].hash;
    	  },
    	  set(V) {
    	    V = conversions["USVString"](V);
    	    this[impl].hash = V;
    	  },
    	  enumerable: true,
    	  configurable: true
    	});


    	module.exports = {
    	  is(obj) {
    	    return !!obj && obj[impl] instanceof Impl.implementation;
    	  },
    	  create(constructorArgs, privateData) {
    	    let obj = Object.create(URL.prototype);
    	    this.setup(obj, constructorArgs, privateData);
    	    return obj;
    	  },
    	  setup(obj, constructorArgs, privateData) {
    	    if (!privateData) privateData = {};
    	    privateData.wrapper = obj;

    	    obj[impl] = new Impl.implementation(constructorArgs, privateData);
    	    obj[impl][utils$1.wrapperSymbol] = obj;
    	  },
    	  interface: URL,
    	  expose: {
    	    Window: { URL: URL },
    	    Worker: { URL: URL }
    	  }
    	};
    } (URL));

    publicApi.URL = URL.exports.interface;
    publicApi.serializeURL = urlStateMachine.exports.serializeURL;
    publicApi.serializeURLOrigin = urlStateMachine.exports.serializeURLOrigin;
    publicApi.basicURLParse = urlStateMachine.exports.basicURLParse;
    publicApi.setTheUsername = urlStateMachine.exports.setTheUsername;
    publicApi.setThePassword = urlStateMachine.exports.setThePassword;
    publicApi.serializeHost = urlStateMachine.exports.serializeHost;
    publicApi.serializeInteger = urlStateMachine.exports.serializeInteger;
    publicApi.parseURL = urlStateMachine.exports.parseURL;

    var msg = {
      2:      'need dictionary',     /* Z_NEED_DICT       2  */
      1:      'stream end',          /* Z_STREAM_END      1  */
      0:      '',                    /* Z_OK              0  */
      '-1':   'file error',          /* Z_ERRNO         (-1) */
      '-2':   'stream error',        /* Z_STREAM_ERROR  (-2) */
      '-3':   'data error',          /* Z_DATA_ERROR    (-3) */
      '-4':   'insufficient memory', /* Z_MEM_ERROR     (-4) */
      '-5':   'buffer error',        /* Z_BUF_ERROR     (-5) */
      '-6':   'incompatible version' /* Z_VERSION_ERROR (-6) */
    };

    function ZStream() {
      /* next input byte */
      this.input = null; // JS specific, because we have no pointers
      this.next_in = 0;
      /* number of bytes available at input */
      this.avail_in = 0;
      /* total number of input bytes read so far */
      this.total_in = 0;
      /* next output byte should be put there */
      this.output = null; // JS specific, because we have no pointers
      this.next_out = 0;
      /* remaining free space at output */
      this.avail_out = 0;
      /* total number of bytes output so far */
      this.total_out = 0;
      /* last error message, NULL if no error */
      this.msg = ''/*Z_NULL*/;
      /* not visible by applications */
      this.state = null;
      /* best guess about the data type: binary or text */
      this.data_type = 2/*Z_UNKNOWN*/;
      /* adler32 value of the uncompressed data */
      this.adler = 0;
    }

    function arraySet(dest, src, src_offs, len, dest_offs) {
      if (src.subarray && dest.subarray) {
        dest.set(src.subarray(src_offs, src_offs + len), dest_offs);
        return;
      }
      // Fallback to ordinary array
      for (var i = 0; i < len; i++) {
        dest[dest_offs + i] = src[src_offs + i];
      }
    }


    var Buf8 = Uint8Array;
    var Buf16 = Uint16Array;
    var Buf32 = Int32Array;
    // Enable/Disable typed arrays use, for testing
    //

    /* Public constants ==========================================================*/
    /* ===========================================================================*/


    //var Z_FILTERED          = 1;
    //var Z_HUFFMAN_ONLY      = 2;
    //var Z_RLE               = 3;
    var Z_FIXED$2 = 4;
    //var Z_DEFAULT_STRATEGY  = 0;

    /* Possible values of the data_type field (though see inflate()) */
    var Z_BINARY$1 = 0;
    var Z_TEXT$1 = 1;
    //var Z_ASCII             = 1; // = Z_TEXT
    var Z_UNKNOWN$2 = 2;

    /*============================================================================*/


    function zero$1(buf) {
      var len = buf.length;
      while (--len >= 0) {
        buf[len] = 0;
      }
    }

    // From zutil.h

    var STORED_BLOCK = 0;
    var STATIC_TREES = 1;
    var DYN_TREES = 2;
    /* The three kinds of block type */

    var MIN_MATCH$1 = 3;
    var MAX_MATCH$1 = 258;
    /* The minimum and maximum match lengths */

    // From deflate.h
    /* ===========================================================================
     * Internal compression state.
     */

    var LENGTH_CODES$1 = 29;
    /* number of length codes, not counting the special END_BLOCK code */

    var LITERALS$1 = 256;
    /* number of literal bytes 0..255 */

    var L_CODES$1 = LITERALS$1 + 1 + LENGTH_CODES$1;
    /* number of Literal or Length codes, including the END_BLOCK code */

    var D_CODES$1 = 30;
    /* number of distance codes */

    var BL_CODES$1 = 19;
    /* number of codes used to transfer the bit lengths */

    var HEAP_SIZE$1 = 2 * L_CODES$1 + 1;
    /* maximum heap size */

    var MAX_BITS$1 = 15;
    /* All codes must not exceed MAX_BITS bits */

    var Buf_size = 16;
    /* size of bit buffer in bi_buf */


    /* ===========================================================================
     * Constants
     */

    var MAX_BL_BITS = 7;
    /* Bit length codes must not exceed MAX_BL_BITS bits */

    var END_BLOCK = 256;
    /* end of block literal code */

    var REP_3_6 = 16;
    /* repeat previous bit length 3-6 times (2 bits of repeat count) */

    var REPZ_3_10 = 17;
    /* repeat a zero length 3-10 times  (3 bits of repeat count) */

    var REPZ_11_138 = 18;
    /* repeat a zero length 11-138 times  (7 bits of repeat count) */

    /* eslint-disable comma-spacing,array-bracket-spacing */
    var extra_lbits = /* extra bits for each length code */ [0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0];

    var extra_dbits = /* extra bits for each distance code */ [0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10, 11, 11, 12, 12, 13, 13];

    var extra_blbits = /* extra bits for each bit length code */ [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 7];

    var bl_order = [16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15];
    /* eslint-enable comma-spacing,array-bracket-spacing */

    /* The lengths of the bit length codes are sent in order of decreasing
     * probability, to avoid transmitting the lengths for unused bit length codes.
     */

    /* ===========================================================================
     * Local data. These are initialized only once.
     */

    // We pre-fill arrays with 0 to avoid uninitialized gaps

    var DIST_CODE_LEN = 512; /* see definition of array dist_code below */

    // !!!! Use flat array insdead of structure, Freq = i*2, Len = i*2+1
    var static_ltree = new Array((L_CODES$1 + 2) * 2);
    zero$1(static_ltree);
    /* The static literal tree. Since the bit lengths are imposed, there is no
     * need for the L_CODES extra codes used during heap construction. However
     * The codes 286 and 287 are needed to build a canonical tree (see _tr_init
     * below).
     */

    var static_dtree = new Array(D_CODES$1 * 2);
    zero$1(static_dtree);
    /* The static distance tree. (Actually a trivial tree since all codes use
     * 5 bits.)
     */

    var _dist_code = new Array(DIST_CODE_LEN);
    zero$1(_dist_code);
    /* Distance codes. The first 256 values correspond to the distances
     * 3 .. 258, the last 256 values correspond to the top 8 bits of
     * the 15 bit distances.
     */

    var _length_code = new Array(MAX_MATCH$1 - MIN_MATCH$1 + 1);
    zero$1(_length_code);
    /* length code for each normalized match length (0 == MIN_MATCH) */

    var base_length = new Array(LENGTH_CODES$1);
    zero$1(base_length);
    /* First normalized length for each code (0 = MIN_MATCH) */

    var base_dist = new Array(D_CODES$1);
    zero$1(base_dist);
    /* First normalized distance for each code (0 = distance of 1) */


    function StaticTreeDesc(static_tree, extra_bits, extra_base, elems, max_length) {

      this.static_tree = static_tree; /* static tree or NULL */
      this.extra_bits = extra_bits; /* extra bits for each code or NULL */
      this.extra_base = extra_base; /* base index for extra_bits */
      this.elems = elems; /* max number of elements in the tree */
      this.max_length = max_length; /* max bit length for the codes */

      // show if `static_tree` has data or dummy - needed for monomorphic objects
      this.has_stree = static_tree && static_tree.length;
    }


    var static_l_desc;
    var static_d_desc;
    var static_bl_desc;


    function TreeDesc(dyn_tree, stat_desc) {
      this.dyn_tree = dyn_tree; /* the dynamic tree */
      this.max_code = 0; /* largest code with non zero frequency */
      this.stat_desc = stat_desc; /* the corresponding static tree */
    }



    function d_code(dist) {
      return dist < 256 ? _dist_code[dist] : _dist_code[256 + (dist >>> 7)];
    }


    /* ===========================================================================
     * Output a short LSB first on the stream.
     * IN assertion: there is enough room in pendingBuf.
     */
    function put_short(s, w) {
      //    put_byte(s, (uch)((w) & 0xff));
      //    put_byte(s, (uch)((ush)(w) >> 8));
      s.pending_buf[s.pending++] = (w) & 0xff;
      s.pending_buf[s.pending++] = (w >>> 8) & 0xff;
    }


    /* ===========================================================================
     * Send a value on a given number of bits.
     * IN assertion: length <= 16 and value fits in length bits.
     */
    function send_bits(s, value, length) {
      if (s.bi_valid > (Buf_size - length)) {
        s.bi_buf |= (value << s.bi_valid) & 0xffff;
        put_short(s, s.bi_buf);
        s.bi_buf = value >> (Buf_size - s.bi_valid);
        s.bi_valid += length - Buf_size;
      } else {
        s.bi_buf |= (value << s.bi_valid) & 0xffff;
        s.bi_valid += length;
      }
    }


    function send_code(s, c, tree) {
      send_bits(s, tree[c * 2] /*.Code*/ , tree[c * 2 + 1] /*.Len*/ );
    }


    /* ===========================================================================
     * Reverse the first len bits of a code, using straightforward code (a faster
     * method would use a table)
     * IN assertion: 1 <= len <= 15
     */
    function bi_reverse(code, len) {
      var res = 0;
      do {
        res |= code & 1;
        code >>>= 1;
        res <<= 1;
      } while (--len > 0);
      return res >>> 1;
    }


    /* ===========================================================================
     * Flush the bit buffer, keeping at most 7 bits in it.
     */
    function bi_flush(s) {
      if (s.bi_valid === 16) {
        put_short(s, s.bi_buf);
        s.bi_buf = 0;
        s.bi_valid = 0;

      } else if (s.bi_valid >= 8) {
        s.pending_buf[s.pending++] = s.bi_buf & 0xff;
        s.bi_buf >>= 8;
        s.bi_valid -= 8;
      }
    }


    /* ===========================================================================
     * Compute the optimal bit lengths for a tree and update the total bit length
     * for the current block.
     * IN assertion: the fields freq and dad are set, heap[heap_max] and
     *    above are the tree nodes sorted by increasing frequency.
     * OUT assertions: the field len is set to the optimal bit length, the
     *     array bl_count contains the frequencies for each bit length.
     *     The length opt_len is updated; static_len is also updated if stree is
     *     not null.
     */
    function gen_bitlen(s, desc) {
    //    deflate_state *s;
    //    tree_desc *desc;    /* the tree descriptor */
      var tree = desc.dyn_tree;
      var max_code = desc.max_code;
      var stree = desc.stat_desc.static_tree;
      var has_stree = desc.stat_desc.has_stree;
      var extra = desc.stat_desc.extra_bits;
      var base = desc.stat_desc.extra_base;
      var max_length = desc.stat_desc.max_length;
      var h; /* heap index */
      var n, m; /* iterate over the tree elements */
      var bits; /* bit length */
      var xbits; /* extra bits */
      var f; /* frequency */
      var overflow = 0; /* number of elements with bit length too large */

      for (bits = 0; bits <= MAX_BITS$1; bits++) {
        s.bl_count[bits] = 0;
      }

      /* In a first pass, compute the optimal bit lengths (which may
       * overflow in the case of the bit length tree).
       */
      tree[s.heap[s.heap_max] * 2 + 1] /*.Len*/ = 0; /* root of the heap */

      for (h = s.heap_max + 1; h < HEAP_SIZE$1; h++) {
        n = s.heap[h];
        bits = tree[tree[n * 2 + 1] /*.Dad*/ * 2 + 1] /*.Len*/ + 1;
        if (bits > max_length) {
          bits = max_length;
          overflow++;
        }
        tree[n * 2 + 1] /*.Len*/ = bits;
        /* We overwrite tree[n].Dad which is no longer needed */

        if (n > max_code) {
          continue;
        } /* not a leaf node */

        s.bl_count[bits]++;
        xbits = 0;
        if (n >= base) {
          xbits = extra[n - base];
        }
        f = tree[n * 2] /*.Freq*/ ;
        s.opt_len += f * (bits + xbits);
        if (has_stree) {
          s.static_len += f * (stree[n * 2 + 1] /*.Len*/ + xbits);
        }
      }
      if (overflow === 0) {
        return;
      }

      // Trace((stderr,"\nbit length overflow\n"));
      /* This happens for example on obj2 and pic of the Calgary corpus */

      /* Find the first bit length which could increase: */
      do {
        bits = max_length - 1;
        while (s.bl_count[bits] === 0) {
          bits--;
        }
        s.bl_count[bits]--; /* move one leaf down the tree */
        s.bl_count[bits + 1] += 2; /* move one overflow item as its brother */
        s.bl_count[max_length]--;
        /* The brother of the overflow item also moves one step up,
         * but this does not affect bl_count[max_length]
         */
        overflow -= 2;
      } while (overflow > 0);

      /* Now recompute all bit lengths, scanning in increasing frequency.
       * h is still equal to HEAP_SIZE. (It is simpler to reconstruct all
       * lengths instead of fixing only the wrong ones. This idea is taken
       * from 'ar' written by Haruhiko Okumura.)
       */
      for (bits = max_length; bits !== 0; bits--) {
        n = s.bl_count[bits];
        while (n !== 0) {
          m = s.heap[--h];
          if (m > max_code) {
            continue;
          }
          if (tree[m * 2 + 1] /*.Len*/ !== bits) {
            // Trace((stderr,"code %d bits %d->%d\n", m, tree[m].Len, bits));
            s.opt_len += (bits - tree[m * 2 + 1] /*.Len*/ ) * tree[m * 2] /*.Freq*/ ;
            tree[m * 2 + 1] /*.Len*/ = bits;
          }
          n--;
        }
      }
    }


    /* ===========================================================================
     * Generate the codes for a given tree and bit counts (which need not be
     * optimal).
     * IN assertion: the array bl_count contains the bit length statistics for
     * the given tree and the field len is set for all tree elements.
     * OUT assertion: the field code is set for all tree elements of non
     *     zero code length.
     */
    function gen_codes(tree, max_code, bl_count) {
    //    ct_data *tree;             /* the tree to decorate */
    //    int max_code;              /* largest code with non zero frequency */
    //    ushf *bl_count;            /* number of codes at each bit length */

      var next_code = new Array(MAX_BITS$1 + 1); /* next code value for each bit length */
      var code = 0; /* running code value */
      var bits; /* bit index */
      var n; /* code index */

      /* The distribution counts are first used to generate the code values
       * without bit reversal.
       */
      for (bits = 1; bits <= MAX_BITS$1; bits++) {
        next_code[bits] = code = (code + bl_count[bits - 1]) << 1;
      }
      /* Check that the bit counts in bl_count are consistent. The last code
       * must be all ones.
       */
      //Assert (code + bl_count[MAX_BITS]-1 == (1<<MAX_BITS)-1,
      //        "inconsistent bit counts");
      //Tracev((stderr,"\ngen_codes: max_code %d ", max_code));

      for (n = 0; n <= max_code; n++) {
        var len = tree[n * 2 + 1] /*.Len*/ ;
        if (len === 0) {
          continue;
        }
        /* Now reverse the bits */
        tree[n * 2] /*.Code*/ = bi_reverse(next_code[len]++, len);

        //Tracecv(tree != static_ltree, (stderr,"\nn %3d %c l %2d c %4x (%x) ",
        //     n, (isgraph(n) ? n : ' '), len, tree[n].Code, next_code[len]-1));
      }
    }


    /* ===========================================================================
     * Initialize the various 'constant' tables.
     */
    function tr_static_init() {
      var n; /* iterates over tree elements */
      var bits; /* bit counter */
      var length; /* length value */
      var code; /* code value */
      var dist; /* distance index */
      var bl_count = new Array(MAX_BITS$1 + 1);
      /* number of codes at each bit length for an optimal tree */

      // do check in _tr_init()
      //if (static_init_done) return;

      /* For some embedded targets, global variables are not initialized: */
      /*#ifdef NO_INIT_GLOBAL_POINTERS
        static_l_desc.static_tree = static_ltree;
        static_l_desc.extra_bits = extra_lbits;
        static_d_desc.static_tree = static_dtree;
        static_d_desc.extra_bits = extra_dbits;
        static_bl_desc.extra_bits = extra_blbits;
      #endif*/

      /* Initialize the mapping length (0..255) -> length code (0..28) */
      length = 0;
      for (code = 0; code < LENGTH_CODES$1 - 1; code++) {
        base_length[code] = length;
        for (n = 0; n < (1 << extra_lbits[code]); n++) {
          _length_code[length++] = code;
        }
      }
      //Assert (length == 256, "tr_static_init: length != 256");
      /* Note that the length 255 (match length 258) can be represented
       * in two different ways: code 284 + 5 bits or code 285, so we
       * overwrite length_code[255] to use the best encoding:
       */
      _length_code[length - 1] = code;

      /* Initialize the mapping dist (0..32K) -> dist code (0..29) */
      dist = 0;
      for (code = 0; code < 16; code++) {
        base_dist[code] = dist;
        for (n = 0; n < (1 << extra_dbits[code]); n++) {
          _dist_code[dist++] = code;
        }
      }
      //Assert (dist == 256, "tr_static_init: dist != 256");
      dist >>= 7; /* from now on, all distances are divided by 128 */
      for (; code < D_CODES$1; code++) {
        base_dist[code] = dist << 7;
        for (n = 0; n < (1 << (extra_dbits[code] - 7)); n++) {
          _dist_code[256 + dist++] = code;
        }
      }
      //Assert (dist == 256, "tr_static_init: 256+dist != 512");

      /* Construct the codes of the static literal tree */
      for (bits = 0; bits <= MAX_BITS$1; bits++) {
        bl_count[bits] = 0;
      }

      n = 0;
      while (n <= 143) {
        static_ltree[n * 2 + 1] /*.Len*/ = 8;
        n++;
        bl_count[8]++;
      }
      while (n <= 255) {
        static_ltree[n * 2 + 1] /*.Len*/ = 9;
        n++;
        bl_count[9]++;
      }
      while (n <= 279) {
        static_ltree[n * 2 + 1] /*.Len*/ = 7;
        n++;
        bl_count[7]++;
      }
      while (n <= 287) {
        static_ltree[n * 2 + 1] /*.Len*/ = 8;
        n++;
        bl_count[8]++;
      }
      /* Codes 286 and 287 do not exist, but we must include them in the
       * tree construction to get a canonical Huffman tree (longest code
       * all ones)
       */
      gen_codes(static_ltree, L_CODES$1 + 1, bl_count);

      /* The static distance tree is trivial: */
      for (n = 0; n < D_CODES$1; n++) {
        static_dtree[n * 2 + 1] /*.Len*/ = 5;
        static_dtree[n * 2] /*.Code*/ = bi_reverse(n, 5);
      }

      // Now data ready and we can init static trees
      static_l_desc = new StaticTreeDesc(static_ltree, extra_lbits, LITERALS$1 + 1, L_CODES$1, MAX_BITS$1);
      static_d_desc = new StaticTreeDesc(static_dtree, extra_dbits, 0, D_CODES$1, MAX_BITS$1);
      static_bl_desc = new StaticTreeDesc(new Array(0), extra_blbits, 0, BL_CODES$1, MAX_BL_BITS);

      //static_init_done = true;
    }


    /* ===========================================================================
     * Initialize a new block.
     */
    function init_block(s) {
      var n; /* iterates over tree elements */

      /* Initialize the trees. */
      for (n = 0; n < L_CODES$1; n++) {
        s.dyn_ltree[n * 2] /*.Freq*/ = 0;
      }
      for (n = 0; n < D_CODES$1; n++) {
        s.dyn_dtree[n * 2] /*.Freq*/ = 0;
      }
      for (n = 0; n < BL_CODES$1; n++) {
        s.bl_tree[n * 2] /*.Freq*/ = 0;
      }

      s.dyn_ltree[END_BLOCK * 2] /*.Freq*/ = 1;
      s.opt_len = s.static_len = 0;
      s.last_lit = s.matches = 0;
    }


    /* ===========================================================================
     * Flush the bit buffer and align the output on a byte boundary
     */
    function bi_windup(s) {
      if (s.bi_valid > 8) {
        put_short(s, s.bi_buf);
      } else if (s.bi_valid > 0) {
        //put_byte(s, (Byte)s->bi_buf);
        s.pending_buf[s.pending++] = s.bi_buf;
      }
      s.bi_buf = 0;
      s.bi_valid = 0;
    }

    /* ===========================================================================
     * Copy a stored block, storing first the length and its
     * one's complement if requested.
     */
    function copy_block(s, buf, len, header) {
    //DeflateState *s;
    //charf    *buf;    /* the input data */
    //unsigned len;     /* its length */
    //int      header;  /* true if block header must be written */

      bi_windup(s); /* align on byte boundary */

      if (header) {
        put_short(s, len);
        put_short(s, ~len);
      }
      //  while (len--) {
      //    put_byte(s, *buf++);
      //  }
      arraySet(s.pending_buf, s.window, buf, len, s.pending);
      s.pending += len;
    }

    /* ===========================================================================
     * Compares to subtrees, using the tree depth as tie breaker when
     * the subtrees have equal frequency. This minimizes the worst case length.
     */
    function smaller(tree, n, m, depth) {
      var _n2 = n * 2;
      var _m2 = m * 2;
      return (tree[_n2] /*.Freq*/ < tree[_m2] /*.Freq*/ ||
        (tree[_n2] /*.Freq*/ === tree[_m2] /*.Freq*/ && depth[n] <= depth[m]));
    }

    /* ===========================================================================
     * Restore the heap property by moving down the tree starting at node k,
     * exchanging a node with the smallest of its two sons if necessary, stopping
     * when the heap property is re-established (each father smaller than its
     * two sons).
     */
    function pqdownheap(s, tree, k)
    //    deflate_state *s;
    //    ct_data *tree;  /* the tree to restore */
    //    int k;               /* node to move down */
    {
      var v = s.heap[k];
      var j = k << 1; /* left son of k */
      while (j <= s.heap_len) {
        /* Set j to the smallest of the two sons: */
        if (j < s.heap_len &&
          smaller(tree, s.heap[j + 1], s.heap[j], s.depth)) {
          j++;
        }
        /* Exit if v is smaller than both sons */
        if (smaller(tree, v, s.heap[j], s.depth)) {
          break;
        }

        /* Exchange v with the smallest son */
        s.heap[k] = s.heap[j];
        k = j;

        /* And continue down the tree, setting j to the left son of k */
        j <<= 1;
      }
      s.heap[k] = v;
    }


    // inlined manually
    // var SMALLEST = 1;

    /* ===========================================================================
     * Send the block data compressed using the given Huffman trees
     */
    function compress_block(s, ltree, dtree)
    //    deflate_state *s;
    //    const ct_data *ltree; /* literal tree */
    //    const ct_data *dtree; /* distance tree */
    {
      var dist; /* distance of matched string */
      var lc; /* match length or unmatched char (if dist == 0) */
      var lx = 0; /* running index in l_buf */
      var code; /* the code to send */
      var extra; /* number of extra bits to send */

      if (s.last_lit !== 0) {
        do {
          dist = (s.pending_buf[s.d_buf + lx * 2] << 8) | (s.pending_buf[s.d_buf + lx * 2 + 1]);
          lc = s.pending_buf[s.l_buf + lx];
          lx++;

          if (dist === 0) {
            send_code(s, lc, ltree); /* send a literal byte */
            //Tracecv(isgraph(lc), (stderr," '%c' ", lc));
          } else {
            /* Here, lc is the match length - MIN_MATCH */
            code = _length_code[lc];
            send_code(s, code + LITERALS$1 + 1, ltree); /* send the length code */
            extra = extra_lbits[code];
            if (extra !== 0) {
              lc -= base_length[code];
              send_bits(s, lc, extra); /* send the extra length bits */
            }
            dist--; /* dist is now the match distance - 1 */
            code = d_code(dist);
            //Assert (code < D_CODES, "bad d_code");

            send_code(s, code, dtree); /* send the distance code */
            extra = extra_dbits[code];
            if (extra !== 0) {
              dist -= base_dist[code];
              send_bits(s, dist, extra); /* send the extra distance bits */
            }
          } /* literal or match pair ? */

          /* Check that the overlay between pending_buf and d_buf+l_buf is ok: */
          //Assert((uInt)(s->pending) < s->lit_bufsize + 2*lx,
          //       "pendingBuf overflow");

        } while (lx < s.last_lit);
      }

      send_code(s, END_BLOCK, ltree);
    }


    /* ===========================================================================
     * Construct one Huffman tree and assigns the code bit strings and lengths.
     * Update the total bit length for the current block.
     * IN assertion: the field freq is set for all tree elements.
     * OUT assertions: the fields len and code are set to the optimal bit length
     *     and corresponding code. The length opt_len is updated; static_len is
     *     also updated if stree is not null. The field max_code is set.
     */
    function build_tree(s, desc)
    //    deflate_state *s;
    //    tree_desc *desc; /* the tree descriptor */
    {
      var tree = desc.dyn_tree;
      var stree = desc.stat_desc.static_tree;
      var has_stree = desc.stat_desc.has_stree;
      var elems = desc.stat_desc.elems;
      var n, m; /* iterate over heap elements */
      var max_code = -1; /* largest code with non zero frequency */
      var node; /* new node being created */

      /* Construct the initial heap, with least frequent element in
       * heap[SMALLEST]. The sons of heap[n] are heap[2*n] and heap[2*n+1].
       * heap[0] is not used.
       */
      s.heap_len = 0;
      s.heap_max = HEAP_SIZE$1;

      for (n = 0; n < elems; n++) {
        if (tree[n * 2] /*.Freq*/ !== 0) {
          s.heap[++s.heap_len] = max_code = n;
          s.depth[n] = 0;

        } else {
          tree[n * 2 + 1] /*.Len*/ = 0;
        }
      }

      /* The pkzip format requires that at least one distance code exists,
       * and that at least one bit should be sent even if there is only one
       * possible code. So to avoid special checks later on we force at least
       * two codes of non zero frequency.
       */
      while (s.heap_len < 2) {
        node = s.heap[++s.heap_len] = (max_code < 2 ? ++max_code : 0);
        tree[node * 2] /*.Freq*/ = 1;
        s.depth[node] = 0;
        s.opt_len--;

        if (has_stree) {
          s.static_len -= stree[node * 2 + 1] /*.Len*/ ;
        }
        /* node is 0 or 1 so it does not have extra bits */
      }
      desc.max_code = max_code;

      /* The elements heap[heap_len/2+1 .. heap_len] are leaves of the tree,
       * establish sub-heaps of increasing lengths:
       */
      for (n = (s.heap_len >> 1 /*int /2*/ ); n >= 1; n--) {
        pqdownheap(s, tree, n);
      }

      /* Construct the Huffman tree by repeatedly combining the least two
       * frequent nodes.
       */
      node = elems; /* next internal node of the tree */
      do {
        //pqremove(s, tree, n);  /* n = node of least frequency */
        /*** pqremove ***/
        n = s.heap[1 /*SMALLEST*/ ];
        s.heap[1 /*SMALLEST*/ ] = s.heap[s.heap_len--];
        pqdownheap(s, tree, 1 /*SMALLEST*/ );
        /***/

        m = s.heap[1 /*SMALLEST*/ ]; /* m = node of next least frequency */

        s.heap[--s.heap_max] = n; /* keep the nodes sorted by frequency */
        s.heap[--s.heap_max] = m;

        /* Create a new node father of n and m */
        tree[node * 2] /*.Freq*/ = tree[n * 2] /*.Freq*/ + tree[m * 2] /*.Freq*/ ;
        s.depth[node] = (s.depth[n] >= s.depth[m] ? s.depth[n] : s.depth[m]) + 1;
        tree[n * 2 + 1] /*.Dad*/ = tree[m * 2 + 1] /*.Dad*/ = node;

        /* and insert the new node in the heap */
        s.heap[1 /*SMALLEST*/ ] = node++;
        pqdownheap(s, tree, 1 /*SMALLEST*/ );

      } while (s.heap_len >= 2);

      s.heap[--s.heap_max] = s.heap[1 /*SMALLEST*/ ];

      /* At this point, the fields freq and dad are set. We can now
       * generate the bit lengths.
       */
      gen_bitlen(s, desc);

      /* The field len is now set, we can generate the bit codes */
      gen_codes(tree, max_code, s.bl_count);
    }


    /* ===========================================================================
     * Scan a literal or distance tree to determine the frequencies of the codes
     * in the bit length tree.
     */
    function scan_tree(s, tree, max_code)
    //    deflate_state *s;
    //    ct_data *tree;   /* the tree to be scanned */
    //    int max_code;    /* and its largest code of non zero frequency */
    {
      var n; /* iterates over all tree elements */
      var prevlen = -1; /* last emitted length */
      var curlen; /* length of current code */

      var nextlen = tree[0 * 2 + 1] /*.Len*/ ; /* length of next code */

      var count = 0; /* repeat count of the current code */
      var max_count = 7; /* max repeat count */
      var min_count = 4; /* min repeat count */

      if (nextlen === 0) {
        max_count = 138;
        min_count = 3;
      }
      tree[(max_code + 1) * 2 + 1] /*.Len*/ = 0xffff; /* guard */

      for (n = 0; n <= max_code; n++) {
        curlen = nextlen;
        nextlen = tree[(n + 1) * 2 + 1] /*.Len*/ ;

        if (++count < max_count && curlen === nextlen) {
          continue;

        } else if (count < min_count) {
          s.bl_tree[curlen * 2] /*.Freq*/ += count;

        } else if (curlen !== 0) {

          if (curlen !== prevlen) {
            s.bl_tree[curlen * 2] /*.Freq*/ ++;
          }
          s.bl_tree[REP_3_6 * 2] /*.Freq*/ ++;

        } else if (count <= 10) {
          s.bl_tree[REPZ_3_10 * 2] /*.Freq*/ ++;

        } else {
          s.bl_tree[REPZ_11_138 * 2] /*.Freq*/ ++;
        }

        count = 0;
        prevlen = curlen;

        if (nextlen === 0) {
          max_count = 138;
          min_count = 3;

        } else if (curlen === nextlen) {
          max_count = 6;
          min_count = 3;

        } else {
          max_count = 7;
          min_count = 4;
        }
      }
    }


    /* ===========================================================================
     * Send a literal or distance tree in compressed form, using the codes in
     * bl_tree.
     */
    function send_tree(s, tree, max_code)
    //    deflate_state *s;
    //    ct_data *tree; /* the tree to be scanned */
    //    int max_code;       /* and its largest code of non zero frequency */
    {
      var n; /* iterates over all tree elements */
      var prevlen = -1; /* last emitted length */
      var curlen; /* length of current code */

      var nextlen = tree[0 * 2 + 1] /*.Len*/ ; /* length of next code */

      var count = 0; /* repeat count of the current code */
      var max_count = 7; /* max repeat count */
      var min_count = 4; /* min repeat count */

      /* tree[max_code+1].Len = -1; */
      /* guard already set */
      if (nextlen === 0) {
        max_count = 138;
        min_count = 3;
      }

      for (n = 0; n <= max_code; n++) {
        curlen = nextlen;
        nextlen = tree[(n + 1) * 2 + 1] /*.Len*/ ;

        if (++count < max_count && curlen === nextlen) {
          continue;

        } else if (count < min_count) {
          do {
            send_code(s, curlen, s.bl_tree);
          } while (--count !== 0);

        } else if (curlen !== 0) {
          if (curlen !== prevlen) {
            send_code(s, curlen, s.bl_tree);
            count--;
          }
          //Assert(count >= 3 && count <= 6, " 3_6?");
          send_code(s, REP_3_6, s.bl_tree);
          send_bits(s, count - 3, 2);

        } else if (count <= 10) {
          send_code(s, REPZ_3_10, s.bl_tree);
          send_bits(s, count - 3, 3);

        } else {
          send_code(s, REPZ_11_138, s.bl_tree);
          send_bits(s, count - 11, 7);
        }

        count = 0;
        prevlen = curlen;
        if (nextlen === 0) {
          max_count = 138;
          min_count = 3;

        } else if (curlen === nextlen) {
          max_count = 6;
          min_count = 3;

        } else {
          max_count = 7;
          min_count = 4;
        }
      }
    }


    /* ===========================================================================
     * Construct the Huffman tree for the bit lengths and return the index in
     * bl_order of the last bit length code to send.
     */
    function build_bl_tree(s) {
      var max_blindex; /* index of last bit length code of non zero freq */

      /* Determine the bit length frequencies for literal and distance trees */
      scan_tree(s, s.dyn_ltree, s.l_desc.max_code);
      scan_tree(s, s.dyn_dtree, s.d_desc.max_code);

      /* Build the bit length tree: */
      build_tree(s, s.bl_desc);
      /* opt_len now includes the length of the tree representations, except
       * the lengths of the bit lengths codes and the 5+5+4 bits for the counts.
       */

      /* Determine the number of bit length codes to send. The pkzip format
       * requires that at least 4 bit length codes be sent. (appnote.txt says
       * 3 but the actual value used is 4.)
       */
      for (max_blindex = BL_CODES$1 - 1; max_blindex >= 3; max_blindex--) {
        if (s.bl_tree[bl_order[max_blindex] * 2 + 1] /*.Len*/ !== 0) {
          break;
        }
      }
      /* Update opt_len to include the bit length tree and counts */
      s.opt_len += 3 * (max_blindex + 1) + 5 + 5 + 4;
      //Tracev((stderr, "\ndyn trees: dyn %ld, stat %ld",
      //        s->opt_len, s->static_len));

      return max_blindex;
    }


    /* ===========================================================================
     * Send the header for a block using dynamic Huffman trees: the counts, the
     * lengths of the bit length codes, the literal tree and the distance tree.
     * IN assertion: lcodes >= 257, dcodes >= 1, blcodes >= 4.
     */
    function send_all_trees(s, lcodes, dcodes, blcodes)
    //    deflate_state *s;
    //    int lcodes, dcodes, blcodes; /* number of codes for each tree */
    {
      var rank; /* index in bl_order */

      //Assert (lcodes >= 257 && dcodes >= 1 && blcodes >= 4, "not enough codes");
      //Assert (lcodes <= L_CODES && dcodes <= D_CODES && blcodes <= BL_CODES,
      //        "too many codes");
      //Tracev((stderr, "\nbl counts: "));
      send_bits(s, lcodes - 257, 5); /* not +255 as stated in appnote.txt */
      send_bits(s, dcodes - 1, 5);
      send_bits(s, blcodes - 4, 4); /* not -3 as stated in appnote.txt */
      for (rank = 0; rank < blcodes; rank++) {
        //Tracev((stderr, "\nbl code %2d ", bl_order[rank]));
        send_bits(s, s.bl_tree[bl_order[rank] * 2 + 1] /*.Len*/ , 3);
      }
      //Tracev((stderr, "\nbl tree: sent %ld", s->bits_sent));

      send_tree(s, s.dyn_ltree, lcodes - 1); /* literal tree */
      //Tracev((stderr, "\nlit tree: sent %ld", s->bits_sent));

      send_tree(s, s.dyn_dtree, dcodes - 1); /* distance tree */
      //Tracev((stderr, "\ndist tree: sent %ld", s->bits_sent));
    }


    /* ===========================================================================
     * Check if the data type is TEXT or BINARY, using the following algorithm:
     * - TEXT if the two conditions below are satisfied:
     *    a) There are no non-portable control characters belonging to the
     *       "black list" (0..6, 14..25, 28..31).
     *    b) There is at least one printable character belonging to the
     *       "white list" (9 {TAB}, 10 {LF}, 13 {CR}, 32..255).
     * - BINARY otherwise.
     * - The following partially-portable control characters form a
     *   "gray list" that is ignored in this detection algorithm:
     *   (7 {BEL}, 8 {BS}, 11 {VT}, 12 {FF}, 26 {SUB}, 27 {ESC}).
     * IN assertion: the fields Freq of dyn_ltree are set.
     */
    function detect_data_type(s) {
      /* black_mask is the bit mask of black-listed bytes
       * set bits 0..6, 14..25, and 28..31
       * 0xf3ffc07f = binary 11110011111111111100000001111111
       */
      var black_mask = 0xf3ffc07f;
      var n;

      /* Check for non-textual ("black-listed") bytes. */
      for (n = 0; n <= 31; n++, black_mask >>>= 1) {
        if ((black_mask & 1) && (s.dyn_ltree[n * 2] /*.Freq*/ !== 0)) {
          return Z_BINARY$1;
        }
      }

      /* Check for textual ("white-listed") bytes. */
      if (s.dyn_ltree[9 * 2] /*.Freq*/ !== 0 || s.dyn_ltree[10 * 2] /*.Freq*/ !== 0 ||
        s.dyn_ltree[13 * 2] /*.Freq*/ !== 0) {
        return Z_TEXT$1;
      }
      for (n = 32; n < LITERALS$1; n++) {
        if (s.dyn_ltree[n * 2] /*.Freq*/ !== 0) {
          return Z_TEXT$1;
        }
      }

      /* There are no "black-listed" or "white-listed" bytes:
       * this stream either is empty or has tolerated ("gray-listed") bytes only.
       */
      return Z_BINARY$1;
    }


    var static_init_done = false;

    /* ===========================================================================
     * Initialize the tree data structures for a new zlib stream.
     */
    function _tr_init(s) {

      if (!static_init_done) {
        tr_static_init();
        static_init_done = true;
      }

      s.l_desc = new TreeDesc(s.dyn_ltree, static_l_desc);
      s.d_desc = new TreeDesc(s.dyn_dtree, static_d_desc);
      s.bl_desc = new TreeDesc(s.bl_tree, static_bl_desc);

      s.bi_buf = 0;
      s.bi_valid = 0;

      /* Initialize the first block of the first file: */
      init_block(s);
    }


    /* ===========================================================================
     * Send a stored block
     */
    function _tr_stored_block(s, buf, stored_len, last)
    //DeflateState *s;
    //charf *buf;       /* input block */
    //ulg stored_len;   /* length of input block */
    //int last;         /* one if this is the last block for a file */
    {
      send_bits(s, (STORED_BLOCK << 1) + (last ? 1 : 0), 3); /* send block type */
      copy_block(s, buf, stored_len, true); /* with header */
    }


    /* ===========================================================================
     * Send one empty static block to give enough lookahead for inflate.
     * This takes 10 bits, of which 7 may remain in the bit buffer.
     */
    function _tr_align(s) {
      send_bits(s, STATIC_TREES << 1, 3);
      send_code(s, END_BLOCK, static_ltree);
      bi_flush(s);
    }


    /* ===========================================================================
     * Determine the best encoding for the current block: dynamic trees, static
     * trees or store, and output the encoded block to the zip file.
     */
    function _tr_flush_block(s, buf, stored_len, last)
    //DeflateState *s;
    //charf *buf;       /* input block, or NULL if too old */
    //ulg stored_len;   /* length of input block */
    //int last;         /* one if this is the last block for a file */
    {
      var opt_lenb, static_lenb; /* opt_len and static_len in bytes */
      var max_blindex = 0; /* index of last bit length code of non zero freq */

      /* Build the Huffman trees unless a stored block is forced */
      if (s.level > 0) {

        /* Check if the file is binary or text */
        if (s.strm.data_type === Z_UNKNOWN$2) {
          s.strm.data_type = detect_data_type(s);
        }

        /* Construct the literal and distance trees */
        build_tree(s, s.l_desc);
        // Tracev((stderr, "\nlit data: dyn %ld, stat %ld", s->opt_len,
        //        s->static_len));

        build_tree(s, s.d_desc);
        // Tracev((stderr, "\ndist data: dyn %ld, stat %ld", s->opt_len,
        //        s->static_len));
        /* At this point, opt_len and static_len are the total bit lengths of
         * the compressed block data, excluding the tree representations.
         */

        /* Build the bit length tree for the above two trees, and get the index
         * in bl_order of the last bit length code to send.
         */
        max_blindex = build_bl_tree(s);

        /* Determine the best encoding. Compute the block lengths in bytes. */
        opt_lenb = (s.opt_len + 3 + 7) >>> 3;
        static_lenb = (s.static_len + 3 + 7) >>> 3;

        // Tracev((stderr, "\nopt %lu(%lu) stat %lu(%lu) stored %lu lit %u ",
        //        opt_lenb, s->opt_len, static_lenb, s->static_len, stored_len,
        //        s->last_lit));

        if (static_lenb <= opt_lenb) {
          opt_lenb = static_lenb;
        }

      } else {
        // Assert(buf != (char*)0, "lost buf");
        opt_lenb = static_lenb = stored_len + 5; /* force a stored block */
      }

      if ((stored_len + 4 <= opt_lenb) && (buf !== -1)) {
        /* 4: two words for the lengths */

        /* The test buf != NULL is only necessary if LIT_BUFSIZE > WSIZE.
         * Otherwise we can't have processed more than WSIZE input bytes since
         * the last block flush, because compression would have been
         * successful. If LIT_BUFSIZE <= WSIZE, it is never too late to
         * transform a block into a stored block.
         */
        _tr_stored_block(s, buf, stored_len, last);

      } else if (s.strategy === Z_FIXED$2 || static_lenb === opt_lenb) {

        send_bits(s, (STATIC_TREES << 1) + (last ? 1 : 0), 3);
        compress_block(s, static_ltree, static_dtree);

      } else {
        send_bits(s, (DYN_TREES << 1) + (last ? 1 : 0), 3);
        send_all_trees(s, s.l_desc.max_code + 1, s.d_desc.max_code + 1, max_blindex + 1);
        compress_block(s, s.dyn_ltree, s.dyn_dtree);
      }
      // Assert (s->compressed_len == s->bits_sent, "bad compressed size");
      /* The above check is made mod 2^32, for files larger than 512 MB
       * and uLong implemented on 32 bits.
       */
      init_block(s);

      if (last) {
        bi_windup(s);
      }
      // Tracev((stderr,"\ncomprlen %lu(%lu) ", s->compressed_len>>3,
      //       s->compressed_len-7*last));
    }

    /* ===========================================================================
     * Save the match info and tally the frequency counts. Return true if
     * the current block must be flushed.
     */
    function _tr_tally(s, dist, lc)
    //    deflate_state *s;
    //    unsigned dist;  /* distance of matched string */
    //    unsigned lc;    /* match length-MIN_MATCH or unmatched char (if dist==0) */
    {
      //var out_length, in_length, dcode;

      s.pending_buf[s.d_buf + s.last_lit * 2] = (dist >>> 8) & 0xff;
      s.pending_buf[s.d_buf + s.last_lit * 2 + 1] = dist & 0xff;

      s.pending_buf[s.l_buf + s.last_lit] = lc & 0xff;
      s.last_lit++;

      if (dist === 0) {
        /* lc is the unmatched char */
        s.dyn_ltree[lc * 2] /*.Freq*/ ++;
      } else {
        s.matches++;
        /* Here, lc is the match length - MIN_MATCH */
        dist--; /* dist = match distance - 1 */
        //Assert((ush)dist < (ush)MAX_DIST(s) &&
        //       (ush)lc <= (ush)(MAX_MATCH-MIN_MATCH) &&
        //       (ush)d_code(dist) < (ush)D_CODES,  "_tr_tally: bad match");

        s.dyn_ltree[(_length_code[lc] + LITERALS$1 + 1) * 2] /*.Freq*/ ++;
        s.dyn_dtree[d_code(dist) * 2] /*.Freq*/ ++;
      }

      // (!) This block is disabled in zlib defailts,
      // don't enable it for binary compatibility

      //#ifdef TRUNCATE_BLOCK
      //  /* Try to guess if it is profitable to stop the current block here */
      //  if ((s.last_lit & 0x1fff) === 0 && s.level > 2) {
      //    /* Compute an upper bound for the compressed length */
      //    out_length = s.last_lit*8;
      //    in_length = s.strstart - s.block_start;
      //
      //    for (dcode = 0; dcode < D_CODES; dcode++) {
      //      out_length += s.dyn_dtree[dcode*2]/*.Freq*/ * (5 + extra_dbits[dcode]);
      //    }
      //    out_length >>>= 3;
      //    //Tracev((stderr,"\nlast_lit %u, in %ld, out ~%ld(%ld%%) ",
      //    //       s->last_lit, in_length, out_length,
      //    //       100L - out_length*100L/in_length));
      //    if (s.matches < (s.last_lit>>1)/*int /2*/ && out_length < (in_length>>1)/*int /2*/) {
      //      return true;
      //    }
      //  }
      //#endif

      return (s.last_lit === s.lit_bufsize - 1);
      /* We avoid equality with lit_bufsize because of wraparound at 64K
       * on 16 bit machines and because stored blocks are restricted to
       * 64K-1 bytes.
       */
    }

    // Note: adler32 takes 12% for level 0 and 2% for level 6.
    // It doesn't worth to make additional optimizationa as in original.
    // Small size is preferable.

    function adler32(adler, buf, len, pos) {
      var s1 = (adler & 0xffff) |0,
          s2 = ((adler >>> 16) & 0xffff) |0,
          n = 0;

      while (len !== 0) {
        // Set limit ~ twice less than 5552, to keep
        // s2 in 31-bits, because we force signed ints.
        // in other case %= will fail.
        n = len > 2000 ? 2000 : len;
        len -= n;

        do {
          s1 = (s1 + buf[pos++]) |0;
          s2 = (s2 + s1) |0;
        } while (--n);

        s1 %= 65521;
        s2 %= 65521;
      }

      return (s1 | (s2 << 16)) |0;
    }

    // Note: we can't get significant speed boost here.
    // So write code to minimize size - no pregenerated tables
    // and array tools dependencies.


    // Use ordinary array, since untyped makes no boost here
    function makeTable() {
      var c, table = [];

      for (var n = 0; n < 256; n++) {
        c = n;
        for (var k = 0; k < 8; k++) {
          c = ((c & 1) ? (0xEDB88320 ^ (c >>> 1)) : (c >>> 1));
        }
        table[n] = c;
      }

      return table;
    }

    // Create table on load. Just 255 signed longs. Not a problem.
    var crcTable = makeTable();


    function crc32(crc, buf, len, pos) {
      var t = crcTable,
          end = pos + len;

      crc ^= -1;

      for (var i = pos; i < end; i++) {
        crc = (crc >>> 8) ^ t[(crc ^ buf[i]) & 0xFF];
      }

      return (crc ^ (-1)); // >>> 0;
    }

    /* Public constants ==========================================================*/
    /* ===========================================================================*/


    /* Allowed flush values; see deflate() and inflate() below for details */
    var Z_NO_FLUSH$1 = 0;
    var Z_PARTIAL_FLUSH$1 = 1;
    //var Z_SYNC_FLUSH    = 2;
    var Z_FULL_FLUSH$1 = 3;
    var Z_FINISH$2 = 4;
    var Z_BLOCK$2 = 5;
    //var Z_TREES         = 6;


    /* Return codes for the compression/decompression functions. Negative values
     * are errors, positive values are used for special but normal events.
     */
    var Z_OK$2 = 0;
    var Z_STREAM_END$2 = 1;
    //var Z_NEED_DICT     = 2;
    //var Z_ERRNO         = -1;
    var Z_STREAM_ERROR$2 = -2;
    var Z_DATA_ERROR$2 = -3;
    //var Z_MEM_ERROR     = -4;
    var Z_BUF_ERROR$2 = -5;
    //var Z_VERSION_ERROR = -6;


    /* compression levels */
    //var Z_NO_COMPRESSION      = 0;
    //var Z_BEST_SPEED          = 1;
    //var Z_BEST_COMPRESSION    = 9;
    var Z_DEFAULT_COMPRESSION$1 = -1;


    var Z_FILTERED$1 = 1;
    var Z_HUFFMAN_ONLY$1 = 2;
    var Z_RLE$1 = 3;
    var Z_FIXED$1 = 4;

    /* Possible values of the data_type field (though see inflate()) */
    //var Z_BINARY              = 0;
    //var Z_TEXT                = 1;
    //var Z_ASCII               = 1; // = Z_TEXT
    var Z_UNKNOWN$1 = 2;


    /* The deflate compression method */
    var Z_DEFLATED$2 = 8;

    /*============================================================================*/


    var MAX_MEM_LEVEL = 9;


    var LENGTH_CODES = 29;
    /* number of length codes, not counting the special END_BLOCK code */
    var LITERALS = 256;
    /* number of literal bytes 0..255 */
    var L_CODES = LITERALS + 1 + LENGTH_CODES;
    /* number of Literal or Length codes, including the END_BLOCK code */
    var D_CODES = 30;
    /* number of distance codes */
    var BL_CODES = 19;
    /* number of codes used to transfer the bit lengths */
    var HEAP_SIZE = 2 * L_CODES + 1;
    /* maximum heap size */
    var MAX_BITS = 15;
    /* All codes must not exceed MAX_BITS bits */

    var MIN_MATCH = 3;
    var MAX_MATCH = 258;
    var MIN_LOOKAHEAD = (MAX_MATCH + MIN_MATCH + 1);

    var PRESET_DICT = 0x20;

    var INIT_STATE = 42;
    var EXTRA_STATE = 69;
    var NAME_STATE = 73;
    var COMMENT_STATE = 91;
    var HCRC_STATE = 103;
    var BUSY_STATE = 113;
    var FINISH_STATE = 666;

    var BS_NEED_MORE = 1; /* block not completed, need more input or more output */
    var BS_BLOCK_DONE = 2; /* block flush performed */
    var BS_FINISH_STARTED = 3; /* finish started, need only more output at next deflate */
    var BS_FINISH_DONE = 4; /* finish done, accept no more input or output */

    var OS_CODE = 0x03; // Unix :) . Don't detect, use this default.

    function err(strm, errorCode) {
      strm.msg = msg[errorCode];
      return errorCode;
    }

    function rank(f) {
      return ((f) << 1) - ((f) > 4 ? 9 : 0);
    }

    function zero(buf) {
      var len = buf.length;
      while (--len >= 0) {
        buf[len] = 0;
      }
    }


    /* =========================================================================
     * Flush as much pending output as possible. All deflate() output goes
     * through this function so some applications may wish to modify it
     * to avoid allocating a large strm->output buffer and copying into it.
     * (See also read_buf()).
     */
    function flush_pending(strm) {
      var s = strm.state;

      //_tr_flush_bits(s);
      var len = s.pending;
      if (len > strm.avail_out) {
        len = strm.avail_out;
      }
      if (len === 0) {
        return;
      }

      arraySet(strm.output, s.pending_buf, s.pending_out, len, strm.next_out);
      strm.next_out += len;
      s.pending_out += len;
      strm.total_out += len;
      strm.avail_out -= len;
      s.pending -= len;
      if (s.pending === 0) {
        s.pending_out = 0;
      }
    }


    function flush_block_only(s, last) {
      _tr_flush_block(s, (s.block_start >= 0 ? s.block_start : -1), s.strstart - s.block_start, last);
      s.block_start = s.strstart;
      flush_pending(s.strm);
    }


    function put_byte(s, b) {
      s.pending_buf[s.pending++] = b;
    }


    /* =========================================================================
     * Put a short in the pending buffer. The 16-bit value is put in MSB order.
     * IN assertion: the stream state is correct and there is enough room in
     * pending_buf.
     */
    function putShortMSB(s, b) {
      //  put_byte(s, (Byte)(b >> 8));
      //  put_byte(s, (Byte)(b & 0xff));
      s.pending_buf[s.pending++] = (b >>> 8) & 0xff;
      s.pending_buf[s.pending++] = b & 0xff;
    }


    /* ===========================================================================
     * Read a new buffer from the current input stream, update the adler32
     * and total number of bytes read.  All deflate() input goes through
     * this function so some applications may wish to modify it to avoid
     * allocating a large strm->input buffer and copying from it.
     * (See also flush_pending()).
     */
    function read_buf(strm, buf, start, size) {
      var len = strm.avail_in;

      if (len > size) {
        len = size;
      }
      if (len === 0) {
        return 0;
      }

      strm.avail_in -= len;

      // zmemcpy(buf, strm->next_in, len);
      arraySet(buf, strm.input, strm.next_in, len, start);
      if (strm.state.wrap === 1) {
        strm.adler = adler32(strm.adler, buf, len, start);
      } else if (strm.state.wrap === 2) {
        strm.adler = crc32(strm.adler, buf, len, start);
      }

      strm.next_in += len;
      strm.total_in += len;

      return len;
    }


    /* ===========================================================================
     * Set match_start to the longest match starting at the given string and
     * return its length. Matches shorter or equal to prev_length are discarded,
     * in which case the result is equal to prev_length and match_start is
     * garbage.
     * IN assertions: cur_match is the head of the hash chain for the current
     *   string (strstart) and its distance is <= MAX_DIST, and prev_length >= 1
     * OUT assertion: the match length is not greater than s->lookahead.
     */
    function longest_match(s, cur_match) {
      var chain_length = s.max_chain_length; /* max hash chain length */
      var scan = s.strstart; /* current string */
      var match; /* matched string */
      var len; /* length of current match */
      var best_len = s.prev_length; /* best match length so far */
      var nice_match = s.nice_match; /* stop if match long enough */
      var limit = (s.strstart > (s.w_size - MIN_LOOKAHEAD)) ?
        s.strstart - (s.w_size - MIN_LOOKAHEAD) : 0 /*NIL*/ ;

      var _win = s.window; // shortcut

      var wmask = s.w_mask;
      var prev = s.prev;

      /* Stop when cur_match becomes <= limit. To simplify the code,
       * we prevent matches with the string of window index 0.
       */

      var strend = s.strstart + MAX_MATCH;
      var scan_end1 = _win[scan + best_len - 1];
      var scan_end = _win[scan + best_len];

      /* The code is optimized for HASH_BITS >= 8 and MAX_MATCH-2 multiple of 16.
       * It is easy to get rid of this optimization if necessary.
       */
      // Assert(s->hash_bits >= 8 && MAX_MATCH == 258, "Code too clever");

      /* Do not waste too much time if we already have a good match: */
      if (s.prev_length >= s.good_match) {
        chain_length >>= 2;
      }
      /* Do not look for matches beyond the end of the input. This is necessary
       * to make deflate deterministic.
       */
      if (nice_match > s.lookahead) {
        nice_match = s.lookahead;
      }

      // Assert((ulg)s->strstart <= s->window_size-MIN_LOOKAHEAD, "need lookahead");

      do {
        // Assert(cur_match < s->strstart, "no future");
        match = cur_match;

        /* Skip to next match if the match length cannot increase
         * or if the match length is less than 2.  Note that the checks below
         * for insufficient lookahead only occur occasionally for performance
         * reasons.  Therefore uninitialized memory will be accessed, and
         * conditional jumps will be made that depend on those values.
         * However the length of the match is limited to the lookahead, so
         * the output of deflate is not affected by the uninitialized values.
         */

        if (_win[match + best_len] !== scan_end ||
          _win[match + best_len - 1] !== scan_end1 ||
          _win[match] !== _win[scan] ||
          _win[++match] !== _win[scan + 1]) {
          continue;
        }

        /* The check at best_len-1 can be removed because it will be made
         * again later. (This heuristic is not always a win.)
         * It is not necessary to compare scan[2] and match[2] since they
         * are always equal when the other bytes match, given that
         * the hash keys are equal and that HASH_BITS >= 8.
         */
        scan += 2;
        match++;
        // Assert(*scan == *match, "match[2]?");

        /* We check for insufficient lookahead only every 8th comparison;
         * the 256th check will be made at strstart+258.
         */
        do {
          /*jshint noempty:false*/
        } while (_win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
          _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
          _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
          _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
          scan < strend);

        // Assert(scan <= s->window+(unsigned)(s->window_size-1), "wild scan");

        len = MAX_MATCH - (strend - scan);
        scan = strend - MAX_MATCH;

        if (len > best_len) {
          s.match_start = cur_match;
          best_len = len;
          if (len >= nice_match) {
            break;
          }
          scan_end1 = _win[scan + best_len - 1];
          scan_end = _win[scan + best_len];
        }
      } while ((cur_match = prev[cur_match & wmask]) > limit && --chain_length !== 0);

      if (best_len <= s.lookahead) {
        return best_len;
      }
      return s.lookahead;
    }


    /* ===========================================================================
     * Fill the window when the lookahead becomes insufficient.
     * Updates strstart and lookahead.
     *
     * IN assertion: lookahead < MIN_LOOKAHEAD
     * OUT assertions: strstart <= window_size-MIN_LOOKAHEAD
     *    At least one byte has been read, or avail_in == 0; reads are
     *    performed for at least two bytes (required for the zip translate_eol
     *    option -- not supported here).
     */
    function fill_window(s) {
      var _w_size = s.w_size;
      var p, n, m, more, str;

      //Assert(s->lookahead < MIN_LOOKAHEAD, "already enough lookahead");

      do {
        more = s.window_size - s.lookahead - s.strstart;

        // JS ints have 32 bit, block below not needed
        /* Deal with !@#$% 64K limit: */
        //if (sizeof(int) <= 2) {
        //    if (more == 0 && s->strstart == 0 && s->lookahead == 0) {
        //        more = wsize;
        //
        //  } else if (more == (unsigned)(-1)) {
        //        /* Very unlikely, but possible on 16 bit machine if
        //         * strstart == 0 && lookahead == 1 (input done a byte at time)
        //         */
        //        more--;
        //    }
        //}


        /* If the window is almost full and there is insufficient lookahead,
         * move the upper half to the lower one to make room in the upper half.
         */
        if (s.strstart >= _w_size + (_w_size - MIN_LOOKAHEAD)) {

          arraySet(s.window, s.window, _w_size, _w_size, 0);
          s.match_start -= _w_size;
          s.strstart -= _w_size;
          /* we now have strstart >= MAX_DIST */
          s.block_start -= _w_size;

          /* Slide the hash table (could be avoided with 32 bit values
           at the expense of memory usage). We slide even when level == 0
           to keep the hash table consistent if we switch back to level > 0
           later. (Using level 0 permanently is not an optimal usage of
           zlib, so we don't care about this pathological case.)
           */

          n = s.hash_size;
          p = n;
          do {
            m = s.head[--p];
            s.head[p] = (m >= _w_size ? m - _w_size : 0);
          } while (--n);

          n = _w_size;
          p = n;
          do {
            m = s.prev[--p];
            s.prev[p] = (m >= _w_size ? m - _w_size : 0);
            /* If n is not on any hash chain, prev[n] is garbage but
             * its value will never be used.
             */
          } while (--n);

          more += _w_size;
        }
        if (s.strm.avail_in === 0) {
          break;
        }

        /* If there was no sliding:
         *    strstart <= WSIZE+MAX_DIST-1 && lookahead <= MIN_LOOKAHEAD - 1 &&
         *    more == window_size - lookahead - strstart
         * => more >= window_size - (MIN_LOOKAHEAD-1 + WSIZE + MAX_DIST-1)
         * => more >= window_size - 2*WSIZE + 2
         * In the BIG_MEM or MMAP case (not yet supported),
         *   window_size == input_size + MIN_LOOKAHEAD  &&
         *   strstart + s->lookahead <= input_size => more >= MIN_LOOKAHEAD.
         * Otherwise, window_size == 2*WSIZE so more >= 2.
         * If there was sliding, more >= WSIZE. So in all cases, more >= 2.
         */
        //Assert(more >= 2, "more < 2");
        n = read_buf(s.strm, s.window, s.strstart + s.lookahead, more);
        s.lookahead += n;

        /* Initialize the hash value now that we have some input: */
        if (s.lookahead + s.insert >= MIN_MATCH) {
          str = s.strstart - s.insert;
          s.ins_h = s.window[str];

          /* UPDATE_HASH(s, s->ins_h, s->window[str + 1]); */
          s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[str + 1]) & s.hash_mask;
          //#if MIN_MATCH != 3
          //        Call update_hash() MIN_MATCH-3 more times
          //#endif
          while (s.insert) {
            /* UPDATE_HASH(s, s->ins_h, s->window[str + MIN_MATCH-1]); */
            s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[str + MIN_MATCH - 1]) & s.hash_mask;

            s.prev[str & s.w_mask] = s.head[s.ins_h];
            s.head[s.ins_h] = str;
            str++;
            s.insert--;
            if (s.lookahead + s.insert < MIN_MATCH) {
              break;
            }
          }
        }
        /* If the whole input has less than MIN_MATCH bytes, ins_h is garbage,
         * but this is not important since only literal bytes will be emitted.
         */

      } while (s.lookahead < MIN_LOOKAHEAD && s.strm.avail_in !== 0);

      /* If the WIN_INIT bytes after the end of the current data have never been
       * written, then zero those bytes in order to avoid memory check reports of
       * the use of uninitialized (or uninitialised as Julian writes) bytes by
       * the longest match routines.  Update the high water mark for the next
       * time through here.  WIN_INIT is set to MAX_MATCH since the longest match
       * routines allow scanning to strstart + MAX_MATCH, ignoring lookahead.
       */
      //  if (s.high_water < s.window_size) {
      //    var curr = s.strstart + s.lookahead;
      //    var init = 0;
      //
      //    if (s.high_water < curr) {
      //      /* Previous high water mark below current data -- zero WIN_INIT
      //       * bytes or up to end of window, whichever is less.
      //       */
      //      init = s.window_size - curr;
      //      if (init > WIN_INIT)
      //        init = WIN_INIT;
      //      zmemzero(s->window + curr, (unsigned)init);
      //      s->high_water = curr + init;
      //    }
      //    else if (s->high_water < (ulg)curr + WIN_INIT) {
      //      /* High water mark at or above current data, but below current data
      //       * plus WIN_INIT -- zero out to current data plus WIN_INIT, or up
      //       * to end of window, whichever is less.
      //       */
      //      init = (ulg)curr + WIN_INIT - s->high_water;
      //      if (init > s->window_size - s->high_water)
      //        init = s->window_size - s->high_water;
      //      zmemzero(s->window + s->high_water, (unsigned)init);
      //      s->high_water += init;
      //    }
      //  }
      //
      //  Assert((ulg)s->strstart <= s->window_size - MIN_LOOKAHEAD,
      //    "not enough room for search");
    }

    /* ===========================================================================
     * Copy without compression as much as possible from the input stream, return
     * the current block state.
     * This function does not insert new strings in the dictionary since
     * uncompressible data is probably not useful. This function is used
     * only for the level=0 compression option.
     * NOTE: this function should be optimized to avoid extra copying from
     * window to pending_buf.
     */
    function deflate_stored(s, flush) {
      /* Stored blocks are limited to 0xffff bytes, pending_buf is limited
       * to pending_buf_size, and each stored block has a 5 byte header:
       */
      var max_block_size = 0xffff;

      if (max_block_size > s.pending_buf_size - 5) {
        max_block_size = s.pending_buf_size - 5;
      }

      /* Copy as much as possible from input to output: */
      for (;;) {
        /* Fill the window as much as possible: */
        if (s.lookahead <= 1) {

          //Assert(s->strstart < s->w_size+MAX_DIST(s) ||
          //  s->block_start >= (long)s->w_size, "slide too late");
          //      if (!(s.strstart < s.w_size + (s.w_size - MIN_LOOKAHEAD) ||
          //        s.block_start >= s.w_size)) {
          //        throw  new Error("slide too late");
          //      }

          fill_window(s);
          if (s.lookahead === 0 && flush === Z_NO_FLUSH$1) {
            return BS_NEED_MORE;
          }

          if (s.lookahead === 0) {
            break;
          }
          /* flush the current block */
        }
        //Assert(s->block_start >= 0L, "block gone");
        //    if (s.block_start < 0) throw new Error("block gone");

        s.strstart += s.lookahead;
        s.lookahead = 0;

        /* Emit a stored block if pending_buf will be full: */
        var max_start = s.block_start + max_block_size;

        if (s.strstart === 0 || s.strstart >= max_start) {
          /* strstart == 0 is possible when wraparound on 16-bit machine */
          s.lookahead = s.strstart - max_start;
          s.strstart = max_start;
          /*** FLUSH_BLOCK(s, 0); ***/
          flush_block_only(s, false);
          if (s.strm.avail_out === 0) {
            return BS_NEED_MORE;
          }
          /***/


        }
        /* Flush if we may have to slide, otherwise block_start may become
         * negative and the data will be gone:
         */
        if (s.strstart - s.block_start >= (s.w_size - MIN_LOOKAHEAD)) {
          /*** FLUSH_BLOCK(s, 0); ***/
          flush_block_only(s, false);
          if (s.strm.avail_out === 0) {
            return BS_NEED_MORE;
          }
          /***/
        }
      }

      s.insert = 0;

      if (flush === Z_FINISH$2) {
        /*** FLUSH_BLOCK(s, 1); ***/
        flush_block_only(s, true);
        if (s.strm.avail_out === 0) {
          return BS_FINISH_STARTED;
        }
        /***/
        return BS_FINISH_DONE;
      }

      if (s.strstart > s.block_start) {
        /*** FLUSH_BLOCK(s, 0); ***/
        flush_block_only(s, false);
        if (s.strm.avail_out === 0) {
          return BS_NEED_MORE;
        }
        /***/
      }

      return BS_NEED_MORE;
    }

    /* ===========================================================================
     * Compress as much as possible from the input stream, return the current
     * block state.
     * This function does not perform lazy evaluation of matches and inserts
     * new strings in the dictionary only for unmatched strings or for short
     * matches. It is used only for the fast compression options.
     */
    function deflate_fast(s, flush) {
      var hash_head; /* head of the hash chain */
      var bflush; /* set if current block must be flushed */

      for (;;) {
        /* Make sure that we always have enough lookahead, except
         * at the end of the input file. We need MAX_MATCH bytes
         * for the next match, plus MIN_MATCH bytes to insert the
         * string following the next match.
         */
        if (s.lookahead < MIN_LOOKAHEAD) {
          fill_window(s);
          if (s.lookahead < MIN_LOOKAHEAD && flush === Z_NO_FLUSH$1) {
            return BS_NEED_MORE;
          }
          if (s.lookahead === 0) {
            break; /* flush the current block */
          }
        }

        /* Insert the string window[strstart .. strstart+2] in the
         * dictionary, and set hash_head to the head of the hash chain:
         */
        hash_head = 0 /*NIL*/ ;
        if (s.lookahead >= MIN_MATCH) {
          /*** INSERT_STRING(s, s.strstart, hash_head); ***/
          s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
          hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
          s.head[s.ins_h] = s.strstart;
          /***/
        }

        /* Find the longest match, discarding those <= prev_length.
         * At this point we have always match_length < MIN_MATCH
         */
        if (hash_head !== 0 /*NIL*/ && ((s.strstart - hash_head) <= (s.w_size - MIN_LOOKAHEAD))) {
          /* To simplify the code, we prevent matches with the string
           * of window index 0 (in particular we have to avoid a match
           * of the string with itself at the start of the input file).
           */
          s.match_length = longest_match(s, hash_head);
          /* longest_match() sets match_start */
        }
        if (s.match_length >= MIN_MATCH) {
          // check_match(s, s.strstart, s.match_start, s.match_length); // for debug only

          /*** _tr_tally_dist(s, s.strstart - s.match_start,
                         s.match_length - MIN_MATCH, bflush); ***/
          bflush = _tr_tally(s, s.strstart - s.match_start, s.match_length - MIN_MATCH);

          s.lookahead -= s.match_length;

          /* Insert new strings in the hash table only if the match length
           * is not too large. This saves time but degrades compression.
           */
          if (s.match_length <= s.max_lazy_match /*max_insert_length*/ && s.lookahead >= MIN_MATCH) {
            s.match_length--; /* string at strstart already in table */
            do {
              s.strstart++;
              /*** INSERT_STRING(s, s.strstart, hash_head); ***/
              s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
              hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
              s.head[s.ins_h] = s.strstart;
              /***/
              /* strstart never exceeds WSIZE-MAX_MATCH, so there are
               * always MIN_MATCH bytes ahead.
               */
            } while (--s.match_length !== 0);
            s.strstart++;
          } else {
            s.strstart += s.match_length;
            s.match_length = 0;
            s.ins_h = s.window[s.strstart];
            /* UPDATE_HASH(s, s.ins_h, s.window[s.strstart+1]); */
            s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + 1]) & s.hash_mask;

            //#if MIN_MATCH != 3
            //                Call UPDATE_HASH() MIN_MATCH-3 more times
            //#endif
            /* If lookahead < MIN_MATCH, ins_h is garbage, but it does not
             * matter since it will be recomputed at next deflate call.
             */
          }
        } else {
          /* No match, output a literal byte */
          //Tracevv((stderr,"%c", s.window[s.strstart]));
          /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
          bflush = _tr_tally(s, 0, s.window[s.strstart]);

          s.lookahead--;
          s.strstart++;
        }
        if (bflush) {
          /*** FLUSH_BLOCK(s, 0); ***/
          flush_block_only(s, false);
          if (s.strm.avail_out === 0) {
            return BS_NEED_MORE;
          }
          /***/
        }
      }
      s.insert = ((s.strstart < (MIN_MATCH - 1)) ? s.strstart : MIN_MATCH - 1);
      if (flush === Z_FINISH$2) {
        /*** FLUSH_BLOCK(s, 1); ***/
        flush_block_only(s, true);
        if (s.strm.avail_out === 0) {
          return BS_FINISH_STARTED;
        }
        /***/
        return BS_FINISH_DONE;
      }
      if (s.last_lit) {
        /*** FLUSH_BLOCK(s, 0); ***/
        flush_block_only(s, false);
        if (s.strm.avail_out === 0) {
          return BS_NEED_MORE;
        }
        /***/
      }
      return BS_BLOCK_DONE;
    }

    /* ===========================================================================
     * Same as above, but achieves better compression. We use a lazy
     * evaluation for matches: a match is finally adopted only if there is
     * no better match at the next window position.
     */
    function deflate_slow(s, flush) {
      var hash_head; /* head of hash chain */
      var bflush; /* set if current block must be flushed */

      var max_insert;

      /* Process the input block. */
      for (;;) {
        /* Make sure that we always have enough lookahead, except
         * at the end of the input file. We need MAX_MATCH bytes
         * for the next match, plus MIN_MATCH bytes to insert the
         * string following the next match.
         */
        if (s.lookahead < MIN_LOOKAHEAD) {
          fill_window(s);
          if (s.lookahead < MIN_LOOKAHEAD && flush === Z_NO_FLUSH$1) {
            return BS_NEED_MORE;
          }
          if (s.lookahead === 0) {
            break;
          } /* flush the current block */
        }

        /* Insert the string window[strstart .. strstart+2] in the
         * dictionary, and set hash_head to the head of the hash chain:
         */
        hash_head = 0 /*NIL*/ ;
        if (s.lookahead >= MIN_MATCH) {
          /*** INSERT_STRING(s, s.strstart, hash_head); ***/
          s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
          hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
          s.head[s.ins_h] = s.strstart;
          /***/
        }

        /* Find the longest match, discarding those <= prev_length.
         */
        s.prev_length = s.match_length;
        s.prev_match = s.match_start;
        s.match_length = MIN_MATCH - 1;

        if (hash_head !== 0 /*NIL*/ && s.prev_length < s.max_lazy_match &&
          s.strstart - hash_head <= (s.w_size - MIN_LOOKAHEAD) /*MAX_DIST(s)*/ ) {
          /* To simplify the code, we prevent matches with the string
           * of window index 0 (in particular we have to avoid a match
           * of the string with itself at the start of the input file).
           */
          s.match_length = longest_match(s, hash_head);
          /* longest_match() sets match_start */

          if (s.match_length <= 5 &&
            (s.strategy === Z_FILTERED$1 || (s.match_length === MIN_MATCH && s.strstart - s.match_start > 4096 /*TOO_FAR*/ ))) {

            /* If prev_match is also MIN_MATCH, match_start is garbage
             * but we will ignore the current match anyway.
             */
            s.match_length = MIN_MATCH - 1;
          }
        }
        /* If there was a match at the previous step and the current
         * match is not better, output the previous match:
         */
        if (s.prev_length >= MIN_MATCH && s.match_length <= s.prev_length) {
          max_insert = s.strstart + s.lookahead - MIN_MATCH;
          /* Do not insert strings in hash table beyond this. */

          //check_match(s, s.strstart-1, s.prev_match, s.prev_length);

          /***_tr_tally_dist(s, s.strstart - 1 - s.prev_match,
                         s.prev_length - MIN_MATCH, bflush);***/
          bflush = _tr_tally(s, s.strstart - 1 - s.prev_match, s.prev_length - MIN_MATCH);
          /* Insert in hash table all strings up to the end of the match.
           * strstart-1 and strstart are already inserted. If there is not
           * enough lookahead, the last two strings are not inserted in
           * the hash table.
           */
          s.lookahead -= s.prev_length - 1;
          s.prev_length -= 2;
          do {
            if (++s.strstart <= max_insert) {
              /*** INSERT_STRING(s, s.strstart, hash_head); ***/
              s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
              hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
              s.head[s.ins_h] = s.strstart;
              /***/
            }
          } while (--s.prev_length !== 0);
          s.match_available = 0;
          s.match_length = MIN_MATCH - 1;
          s.strstart++;

          if (bflush) {
            /*** FLUSH_BLOCK(s, 0); ***/
            flush_block_only(s, false);
            if (s.strm.avail_out === 0) {
              return BS_NEED_MORE;
            }
            /***/
          }

        } else if (s.match_available) {
          /* If there was no match at the previous position, output a
           * single literal. If there was a match but the current match
           * is longer, truncate the previous match to a single literal.
           */
          //Tracevv((stderr,"%c", s->window[s->strstart-1]));
          /*** _tr_tally_lit(s, s.window[s.strstart-1], bflush); ***/
          bflush = _tr_tally(s, 0, s.window[s.strstart - 1]);

          if (bflush) {
            /*** FLUSH_BLOCK_ONLY(s, 0) ***/
            flush_block_only(s, false);
            /***/
          }
          s.strstart++;
          s.lookahead--;
          if (s.strm.avail_out === 0) {
            return BS_NEED_MORE;
          }
        } else {
          /* There is no previous match to compare with, wait for
           * the next step to decide.
           */
          s.match_available = 1;
          s.strstart++;
          s.lookahead--;
        }
      }
      //Assert (flush != Z_NO_FLUSH, "no flush?");
      if (s.match_available) {
        //Tracevv((stderr,"%c", s->window[s->strstart-1]));
        /*** _tr_tally_lit(s, s.window[s.strstart-1], bflush); ***/
        bflush = _tr_tally(s, 0, s.window[s.strstart - 1]);

        s.match_available = 0;
      }
      s.insert = s.strstart < MIN_MATCH - 1 ? s.strstart : MIN_MATCH - 1;
      if (flush === Z_FINISH$2) {
        /*** FLUSH_BLOCK(s, 1); ***/
        flush_block_only(s, true);
        if (s.strm.avail_out === 0) {
          return BS_FINISH_STARTED;
        }
        /***/
        return BS_FINISH_DONE;
      }
      if (s.last_lit) {
        /*** FLUSH_BLOCK(s, 0); ***/
        flush_block_only(s, false);
        if (s.strm.avail_out === 0) {
          return BS_NEED_MORE;
        }
        /***/
      }

      return BS_BLOCK_DONE;
    }


    /* ===========================================================================
     * For Z_RLE, simply look for runs of bytes, generate matches only of distance
     * one.  Do not maintain a hash table.  (It will be regenerated if this run of
     * deflate switches away from Z_RLE.)
     */
    function deflate_rle(s, flush) {
      var bflush; /* set if current block must be flushed */
      var prev; /* byte at distance one to match */
      var scan, strend; /* scan goes up to strend for length of run */

      var _win = s.window;

      for (;;) {
        /* Make sure that we always have enough lookahead, except
         * at the end of the input file. We need MAX_MATCH bytes
         * for the longest run, plus one for the unrolled loop.
         */
        if (s.lookahead <= MAX_MATCH) {
          fill_window(s);
          if (s.lookahead <= MAX_MATCH && flush === Z_NO_FLUSH$1) {
            return BS_NEED_MORE;
          }
          if (s.lookahead === 0) {
            break;
          } /* flush the current block */
        }

        /* See how many times the previous byte repeats */
        s.match_length = 0;
        if (s.lookahead >= MIN_MATCH && s.strstart > 0) {
          scan = s.strstart - 1;
          prev = _win[scan];
          if (prev === _win[++scan] && prev === _win[++scan] && prev === _win[++scan]) {
            strend = s.strstart + MAX_MATCH;
            do {
              /*jshint noempty:false*/
            } while (prev === _win[++scan] && prev === _win[++scan] &&
              prev === _win[++scan] && prev === _win[++scan] &&
              prev === _win[++scan] && prev === _win[++scan] &&
              prev === _win[++scan] && prev === _win[++scan] &&
              scan < strend);
            s.match_length = MAX_MATCH - (strend - scan);
            if (s.match_length > s.lookahead) {
              s.match_length = s.lookahead;
            }
          }
          //Assert(scan <= s->window+(uInt)(s->window_size-1), "wild scan");
        }

        /* Emit match if have run of MIN_MATCH or longer, else emit literal */
        if (s.match_length >= MIN_MATCH) {
          //check_match(s, s.strstart, s.strstart - 1, s.match_length);

          /*** _tr_tally_dist(s, 1, s.match_length - MIN_MATCH, bflush); ***/
          bflush = _tr_tally(s, 1, s.match_length - MIN_MATCH);

          s.lookahead -= s.match_length;
          s.strstart += s.match_length;
          s.match_length = 0;
        } else {
          /* No match, output a literal byte */
          //Tracevv((stderr,"%c", s->window[s->strstart]));
          /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
          bflush = _tr_tally(s, 0, s.window[s.strstart]);

          s.lookahead--;
          s.strstart++;
        }
        if (bflush) {
          /*** FLUSH_BLOCK(s, 0); ***/
          flush_block_only(s, false);
          if (s.strm.avail_out === 0) {
            return BS_NEED_MORE;
          }
          /***/
        }
      }
      s.insert = 0;
      if (flush === Z_FINISH$2) {
        /*** FLUSH_BLOCK(s, 1); ***/
        flush_block_only(s, true);
        if (s.strm.avail_out === 0) {
          return BS_FINISH_STARTED;
        }
        /***/
        return BS_FINISH_DONE;
      }
      if (s.last_lit) {
        /*** FLUSH_BLOCK(s, 0); ***/
        flush_block_only(s, false);
        if (s.strm.avail_out === 0) {
          return BS_NEED_MORE;
        }
        /***/
      }
      return BS_BLOCK_DONE;
    }

    /* ===========================================================================
     * For Z_HUFFMAN_ONLY, do not look for matches.  Do not maintain a hash table.
     * (It will be regenerated if this run of deflate switches away from Huffman.)
     */
    function deflate_huff(s, flush) {
      var bflush; /* set if current block must be flushed */

      for (;;) {
        /* Make sure that we have a literal to write. */
        if (s.lookahead === 0) {
          fill_window(s);
          if (s.lookahead === 0) {
            if (flush === Z_NO_FLUSH$1) {
              return BS_NEED_MORE;
            }
            break; /* flush the current block */
          }
        }

        /* Output a literal byte */
        s.match_length = 0;
        //Tracevv((stderr,"%c", s->window[s->strstart]));
        /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
        bflush = _tr_tally(s, 0, s.window[s.strstart]);
        s.lookahead--;
        s.strstart++;
        if (bflush) {
          /*** FLUSH_BLOCK(s, 0); ***/
          flush_block_only(s, false);
          if (s.strm.avail_out === 0) {
            return BS_NEED_MORE;
          }
          /***/
        }
      }
      s.insert = 0;
      if (flush === Z_FINISH$2) {
        /*** FLUSH_BLOCK(s, 1); ***/
        flush_block_only(s, true);
        if (s.strm.avail_out === 0) {
          return BS_FINISH_STARTED;
        }
        /***/
        return BS_FINISH_DONE;
      }
      if (s.last_lit) {
        /*** FLUSH_BLOCK(s, 0); ***/
        flush_block_only(s, false);
        if (s.strm.avail_out === 0) {
          return BS_NEED_MORE;
        }
        /***/
      }
      return BS_BLOCK_DONE;
    }

    /* Values for max_lazy_match, good_match and max_chain_length, depending on
     * the desired pack level (0..9). The values given below have been tuned to
     * exclude worst case performance for pathological files. Better values may be
     * found for specific files.
     */
    function Config(good_length, max_lazy, nice_length, max_chain, func) {
      this.good_length = good_length;
      this.max_lazy = max_lazy;
      this.nice_length = nice_length;
      this.max_chain = max_chain;
      this.func = func;
    }

    var configuration_table;

    configuration_table = [
      /*      good lazy nice chain */
      new Config(0, 0, 0, 0, deflate_stored), /* 0 store only */
      new Config(4, 4, 8, 4, deflate_fast), /* 1 max speed, no lazy matches */
      new Config(4, 5, 16, 8, deflate_fast), /* 2 */
      new Config(4, 6, 32, 32, deflate_fast), /* 3 */

      new Config(4, 4, 16, 16, deflate_slow), /* 4 lazy matches */
      new Config(8, 16, 32, 32, deflate_slow), /* 5 */
      new Config(8, 16, 128, 128, deflate_slow), /* 6 */
      new Config(8, 32, 128, 256, deflate_slow), /* 7 */
      new Config(32, 128, 258, 1024, deflate_slow), /* 8 */
      new Config(32, 258, 258, 4096, deflate_slow) /* 9 max compression */
    ];


    /* ===========================================================================
     * Initialize the "longest match" routines for a new zlib stream
     */
    function lm_init(s) {
      s.window_size = 2 * s.w_size;

      /*** CLEAR_HASH(s); ***/
      zero(s.head); // Fill with NIL (= 0);

      /* Set the default configuration parameters:
       */
      s.max_lazy_match = configuration_table[s.level].max_lazy;
      s.good_match = configuration_table[s.level].good_length;
      s.nice_match = configuration_table[s.level].nice_length;
      s.max_chain_length = configuration_table[s.level].max_chain;

      s.strstart = 0;
      s.block_start = 0;
      s.lookahead = 0;
      s.insert = 0;
      s.match_length = s.prev_length = MIN_MATCH - 1;
      s.match_available = 0;
      s.ins_h = 0;
    }


    function DeflateState() {
      this.strm = null; /* pointer back to this zlib stream */
      this.status = 0; /* as the name implies */
      this.pending_buf = null; /* output still pending */
      this.pending_buf_size = 0; /* size of pending_buf */
      this.pending_out = 0; /* next pending byte to output to the stream */
      this.pending = 0; /* nb of bytes in the pending buffer */
      this.wrap = 0; /* bit 0 true for zlib, bit 1 true for gzip */
      this.gzhead = null; /* gzip header information to write */
      this.gzindex = 0; /* where in extra, name, or comment */
      this.method = Z_DEFLATED$2; /* can only be DEFLATED */
      this.last_flush = -1; /* value of flush param for previous deflate call */

      this.w_size = 0; /* LZ77 window size (32K by default) */
      this.w_bits = 0; /* log2(w_size)  (8..16) */
      this.w_mask = 0; /* w_size - 1 */

      this.window = null;
      /* Sliding window. Input bytes are read into the second half of the window,
       * and move to the first half later to keep a dictionary of at least wSize
       * bytes. With this organization, matches are limited to a distance of
       * wSize-MAX_MATCH bytes, but this ensures that IO is always
       * performed with a length multiple of the block size.
       */

      this.window_size = 0;
      /* Actual size of window: 2*wSize, except when the user input buffer
       * is directly used as sliding window.
       */

      this.prev = null;
      /* Link to older string with same hash index. To limit the size of this
       * array to 64K, this link is maintained only for the last 32K strings.
       * An index in this array is thus a window index modulo 32K.
       */

      this.head = null; /* Heads of the hash chains or NIL. */

      this.ins_h = 0; /* hash index of string to be inserted */
      this.hash_size = 0; /* number of elements in hash table */
      this.hash_bits = 0; /* log2(hash_size) */
      this.hash_mask = 0; /* hash_size-1 */

      this.hash_shift = 0;
      /* Number of bits by which ins_h must be shifted at each input
       * step. It must be such that after MIN_MATCH steps, the oldest
       * byte no longer takes part in the hash key, that is:
       *   hash_shift * MIN_MATCH >= hash_bits
       */

      this.block_start = 0;
      /* Window position at the beginning of the current output block. Gets
       * negative when the window is moved backwards.
       */

      this.match_length = 0; /* length of best match */
      this.prev_match = 0; /* previous match */
      this.match_available = 0; /* set if previous match exists */
      this.strstart = 0; /* start of string to insert */
      this.match_start = 0; /* start of matching string */
      this.lookahead = 0; /* number of valid bytes ahead in window */

      this.prev_length = 0;
      /* Length of the best match at previous step. Matches not greater than this
       * are discarded. This is used in the lazy match evaluation.
       */

      this.max_chain_length = 0;
      /* To speed up deflation, hash chains are never searched beyond this
       * length.  A higher limit improves compression ratio but degrades the
       * speed.
       */

      this.max_lazy_match = 0;
      /* Attempt to find a better match only when the current match is strictly
       * smaller than this value. This mechanism is used only for compression
       * levels >= 4.
       */
      // That's alias to max_lazy_match, don't use directly
      //this.max_insert_length = 0;
      /* Insert new strings in the hash table only if the match length is not
       * greater than this length. This saves time but degrades compression.
       * max_insert_length is used only for compression levels <= 3.
       */

      this.level = 0; /* compression level (1..9) */
      this.strategy = 0; /* favor or force Huffman coding*/

      this.good_match = 0;
      /* Use a faster search when the previous match is longer than this */

      this.nice_match = 0; /* Stop searching when current match exceeds this */

      /* used by c: */

      /* Didn't use ct_data typedef below to suppress compiler warning */

      // struct ct_data_s dyn_ltree[HEAP_SIZE];   /* literal and length tree */
      // struct ct_data_s dyn_dtree[2*D_CODES+1]; /* distance tree */
      // struct ct_data_s bl_tree[2*BL_CODES+1];  /* Huffman tree for bit lengths */

      // Use flat array of DOUBLE size, with interleaved fata,
      // because JS does not support effective
      this.dyn_ltree = new Buf16(HEAP_SIZE * 2);
      this.dyn_dtree = new Buf16((2 * D_CODES + 1) * 2);
      this.bl_tree = new Buf16((2 * BL_CODES + 1) * 2);
      zero(this.dyn_ltree);
      zero(this.dyn_dtree);
      zero(this.bl_tree);

      this.l_desc = null; /* desc. for literal tree */
      this.d_desc = null; /* desc. for distance tree */
      this.bl_desc = null; /* desc. for bit length tree */

      //ush bl_count[MAX_BITS+1];
      this.bl_count = new Buf16(MAX_BITS + 1);
      /* number of codes at each bit length for an optimal tree */

      //int heap[2*L_CODES+1];      /* heap used to build the Huffman trees */
      this.heap = new Buf16(2 * L_CODES + 1); /* heap used to build the Huffman trees */
      zero(this.heap);

      this.heap_len = 0; /* number of elements in the heap */
      this.heap_max = 0; /* element of largest frequency */
      /* The sons of heap[n] are heap[2*n] and heap[2*n+1]. heap[0] is not used.
       * The same heap array is used to build all
       */

      this.depth = new Buf16(2 * L_CODES + 1); //uch depth[2*L_CODES+1];
      zero(this.depth);
      /* Depth of each subtree used as tie breaker for trees of equal frequency
       */

      this.l_buf = 0; /* buffer index for literals or lengths */

      this.lit_bufsize = 0;
      /* Size of match buffer for literals/lengths.  There are 4 reasons for
       * limiting lit_bufsize to 64K:
       *   - frequencies can be kept in 16 bit counters
       *   - if compression is not successful for the first block, all input
       *     data is still in the window so we can still emit a stored block even
       *     when input comes from standard input.  (This can also be done for
       *     all blocks if lit_bufsize is not greater than 32K.)
       *   - if compression is not successful for a file smaller than 64K, we can
       *     even emit a stored file instead of a stored block (saving 5 bytes).
       *     This is applicable only for zip (not gzip or zlib).
       *   - creating new Huffman trees less frequently may not provide fast
       *     adaptation to changes in the input data statistics. (Take for
       *     example a binary file with poorly compressible code followed by
       *     a highly compressible string table.) Smaller buffer sizes give
       *     fast adaptation but have of course the overhead of transmitting
       *     trees more frequently.
       *   - I can't count above 4
       */

      this.last_lit = 0; /* running index in l_buf */

      this.d_buf = 0;
      /* Buffer index for distances. To simplify the code, d_buf and l_buf have
       * the same number of elements. To use different lengths, an extra flag
       * array would be necessary.
       */

      this.opt_len = 0; /* bit length of current block with optimal trees */
      this.static_len = 0; /* bit length of current block with static trees */
      this.matches = 0; /* number of string matches in current block */
      this.insert = 0; /* bytes at end of window left to insert */


      this.bi_buf = 0;
      /* Output buffer. bits are inserted starting at the bottom (least
       * significant bits).
       */
      this.bi_valid = 0;
      /* Number of valid bits in bi_buf.  All bits above the last valid bit
       * are always zero.
       */

      // Used for window memory init. We safely ignore it for JS. That makes
      // sense only for pointers and memory check tools.
      //this.high_water = 0;
      /* High water mark offset in window for initialized bytes -- bytes above
       * this are set to zero in order to avoid memory check warnings when
       * longest match routines access bytes past the input.  This is then
       * updated to the new high water mark.
       */
    }


    function deflateResetKeep(strm) {
      var s;

      if (!strm || !strm.state) {
        return err(strm, Z_STREAM_ERROR$2);
      }

      strm.total_in = strm.total_out = 0;
      strm.data_type = Z_UNKNOWN$1;

      s = strm.state;
      s.pending = 0;
      s.pending_out = 0;

      if (s.wrap < 0) {
        s.wrap = -s.wrap;
        /* was made negative by deflate(..., Z_FINISH); */
      }
      s.status = (s.wrap ? INIT_STATE : BUSY_STATE);
      strm.adler = (s.wrap === 2) ?
        0 // crc32(0, Z_NULL, 0)
        :
        1; // adler32(0, Z_NULL, 0)
      s.last_flush = Z_NO_FLUSH$1;
      _tr_init(s);
      return Z_OK$2;
    }


    function deflateReset(strm) {
      var ret = deflateResetKeep(strm);
      if (ret === Z_OK$2) {
        lm_init(strm.state);
      }
      return ret;
    }


    function deflateInit2(strm, level, method, windowBits, memLevel, strategy) {
      if (!strm) { // === Z_NULL
        return Z_STREAM_ERROR$2;
      }
      var wrap = 1;

      if (level === Z_DEFAULT_COMPRESSION$1) {
        level = 6;
      }

      if (windowBits < 0) { /* suppress zlib wrapper */
        wrap = 0;
        windowBits = -windowBits;
      } else if (windowBits > 15) {
        wrap = 2; /* write gzip wrapper instead */
        windowBits -= 16;
      }


      if (memLevel < 1 || memLevel > MAX_MEM_LEVEL || method !== Z_DEFLATED$2 ||
        windowBits < 8 || windowBits > 15 || level < 0 || level > 9 ||
        strategy < 0 || strategy > Z_FIXED$1) {
        return err(strm, Z_STREAM_ERROR$2);
      }


      if (windowBits === 8) {
        windowBits = 9;
      }
      /* until 256-byte window bug fixed */

      var s = new DeflateState();

      strm.state = s;
      s.strm = strm;

      s.wrap = wrap;
      s.gzhead = null;
      s.w_bits = windowBits;
      s.w_size = 1 << s.w_bits;
      s.w_mask = s.w_size - 1;

      s.hash_bits = memLevel + 7;
      s.hash_size = 1 << s.hash_bits;
      s.hash_mask = s.hash_size - 1;
      s.hash_shift = ~~((s.hash_bits + MIN_MATCH - 1) / MIN_MATCH);

      s.window = new Buf8(s.w_size * 2);
      s.head = new Buf16(s.hash_size);
      s.prev = new Buf16(s.w_size);

      // Don't need mem init magic for JS.
      //s.high_water = 0;  /* nothing written to s->window yet */

      s.lit_bufsize = 1 << (memLevel + 6); /* 16K elements by default */

      s.pending_buf_size = s.lit_bufsize * 4;

      //overlay = (ushf *) ZALLOC(strm, s->lit_bufsize, sizeof(ush)+2);
      //s->pending_buf = (uchf *) overlay;
      s.pending_buf = new Buf8(s.pending_buf_size);

      // It is offset from `s.pending_buf` (size is `s.lit_bufsize * 2`)
      //s->d_buf = overlay + s->lit_bufsize/sizeof(ush);
      s.d_buf = 1 * s.lit_bufsize;

      //s->l_buf = s->pending_buf + (1+sizeof(ush))*s->lit_bufsize;
      s.l_buf = (1 + 2) * s.lit_bufsize;

      s.level = level;
      s.strategy = strategy;
      s.method = method;

      return deflateReset(strm);
    }


    function deflate$1(strm, flush) {
      var old_flush, s;
      var beg, val; // for gzip header write only

      if (!strm || !strm.state ||
        flush > Z_BLOCK$2 || flush < 0) {
        return strm ? err(strm, Z_STREAM_ERROR$2) : Z_STREAM_ERROR$2;
      }

      s = strm.state;

      if (!strm.output ||
        (!strm.input && strm.avail_in !== 0) ||
        (s.status === FINISH_STATE && flush !== Z_FINISH$2)) {
        return err(strm, (strm.avail_out === 0) ? Z_BUF_ERROR$2 : Z_STREAM_ERROR$2);
      }

      s.strm = strm; /* just in case */
      old_flush = s.last_flush;
      s.last_flush = flush;

      /* Write the header */
      if (s.status === INIT_STATE) {
        if (s.wrap === 2) {
          // GZIP header
          strm.adler = 0; //crc32(0L, Z_NULL, 0);
          put_byte(s, 31);
          put_byte(s, 139);
          put_byte(s, 8);
          if (!s.gzhead) { // s->gzhead == Z_NULL
            put_byte(s, 0);
            put_byte(s, 0);
            put_byte(s, 0);
            put_byte(s, 0);
            put_byte(s, 0);
            put_byte(s, s.level === 9 ? 2 :
              (s.strategy >= Z_HUFFMAN_ONLY$1 || s.level < 2 ?
                4 : 0));
            put_byte(s, OS_CODE);
            s.status = BUSY_STATE;
          } else {
            put_byte(s, (s.gzhead.text ? 1 : 0) +
              (s.gzhead.hcrc ? 2 : 0) +
              (!s.gzhead.extra ? 0 : 4) +
              (!s.gzhead.name ? 0 : 8) +
              (!s.gzhead.comment ? 0 : 16)
            );
            put_byte(s, s.gzhead.time & 0xff);
            put_byte(s, (s.gzhead.time >> 8) & 0xff);
            put_byte(s, (s.gzhead.time >> 16) & 0xff);
            put_byte(s, (s.gzhead.time >> 24) & 0xff);
            put_byte(s, s.level === 9 ? 2 :
              (s.strategy >= Z_HUFFMAN_ONLY$1 || s.level < 2 ?
                4 : 0));
            put_byte(s, s.gzhead.os & 0xff);
            if (s.gzhead.extra && s.gzhead.extra.length) {
              put_byte(s, s.gzhead.extra.length & 0xff);
              put_byte(s, (s.gzhead.extra.length >> 8) & 0xff);
            }
            if (s.gzhead.hcrc) {
              strm.adler = crc32(strm.adler, s.pending_buf, s.pending, 0);
            }
            s.gzindex = 0;
            s.status = EXTRA_STATE;
          }
        } else // DEFLATE header
        {
          var header = (Z_DEFLATED$2 + ((s.w_bits - 8) << 4)) << 8;
          var level_flags = -1;

          if (s.strategy >= Z_HUFFMAN_ONLY$1 || s.level < 2) {
            level_flags = 0;
          } else if (s.level < 6) {
            level_flags = 1;
          } else if (s.level === 6) {
            level_flags = 2;
          } else {
            level_flags = 3;
          }
          header |= (level_flags << 6);
          if (s.strstart !== 0) {
            header |= PRESET_DICT;
          }
          header += 31 - (header % 31);

          s.status = BUSY_STATE;
          putShortMSB(s, header);

          /* Save the adler32 of the preset dictionary: */
          if (s.strstart !== 0) {
            putShortMSB(s, strm.adler >>> 16);
            putShortMSB(s, strm.adler & 0xffff);
          }
          strm.adler = 1; // adler32(0L, Z_NULL, 0);
        }
      }

      //#ifdef GZIP
      if (s.status === EXTRA_STATE) {
        if (s.gzhead.extra /* != Z_NULL*/ ) {
          beg = s.pending; /* start of bytes to update crc */

          while (s.gzindex < (s.gzhead.extra.length & 0xffff)) {
            if (s.pending === s.pending_buf_size) {
              if (s.gzhead.hcrc && s.pending > beg) {
                strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
              }
              flush_pending(strm);
              beg = s.pending;
              if (s.pending === s.pending_buf_size) {
                break;
              }
            }
            put_byte(s, s.gzhead.extra[s.gzindex] & 0xff);
            s.gzindex++;
          }
          if (s.gzhead.hcrc && s.pending > beg) {
            strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
          }
          if (s.gzindex === s.gzhead.extra.length) {
            s.gzindex = 0;
            s.status = NAME_STATE;
          }
        } else {
          s.status = NAME_STATE;
        }
      }
      if (s.status === NAME_STATE) {
        if (s.gzhead.name /* != Z_NULL*/ ) {
          beg = s.pending; /* start of bytes to update crc */
          //int val;

          do {
            if (s.pending === s.pending_buf_size) {
              if (s.gzhead.hcrc && s.pending > beg) {
                strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
              }
              flush_pending(strm);
              beg = s.pending;
              if (s.pending === s.pending_buf_size) {
                val = 1;
                break;
              }
            }
            // JS specific: little magic to add zero terminator to end of string
            if (s.gzindex < s.gzhead.name.length) {
              val = s.gzhead.name.charCodeAt(s.gzindex++) & 0xff;
            } else {
              val = 0;
            }
            put_byte(s, val);
          } while (val !== 0);

          if (s.gzhead.hcrc && s.pending > beg) {
            strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
          }
          if (val === 0) {
            s.gzindex = 0;
            s.status = COMMENT_STATE;
          }
        } else {
          s.status = COMMENT_STATE;
        }
      }
      if (s.status === COMMENT_STATE) {
        if (s.gzhead.comment /* != Z_NULL*/ ) {
          beg = s.pending; /* start of bytes to update crc */
          //int val;

          do {
            if (s.pending === s.pending_buf_size) {
              if (s.gzhead.hcrc && s.pending > beg) {
                strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
              }
              flush_pending(strm);
              beg = s.pending;
              if (s.pending === s.pending_buf_size) {
                val = 1;
                break;
              }
            }
            // JS specific: little magic to add zero terminator to end of string
            if (s.gzindex < s.gzhead.comment.length) {
              val = s.gzhead.comment.charCodeAt(s.gzindex++) & 0xff;
            } else {
              val = 0;
            }
            put_byte(s, val);
          } while (val !== 0);

          if (s.gzhead.hcrc && s.pending > beg) {
            strm.adler = crc32(strm.adler, s.pending_buf, s.pending - beg, beg);
          }
          if (val === 0) {
            s.status = HCRC_STATE;
          }
        } else {
          s.status = HCRC_STATE;
        }
      }
      if (s.status === HCRC_STATE) {
        if (s.gzhead.hcrc) {
          if (s.pending + 2 > s.pending_buf_size) {
            flush_pending(strm);
          }
          if (s.pending + 2 <= s.pending_buf_size) {
            put_byte(s, strm.adler & 0xff);
            put_byte(s, (strm.adler >> 8) & 0xff);
            strm.adler = 0; //crc32(0L, Z_NULL, 0);
            s.status = BUSY_STATE;
          }
        } else {
          s.status = BUSY_STATE;
        }
      }
      //#endif

      /* Flush as much pending output as possible */
      if (s.pending !== 0) {
        flush_pending(strm);
        if (strm.avail_out === 0) {
          /* Since avail_out is 0, deflate will be called again with
           * more output space, but possibly with both pending and
           * avail_in equal to zero. There won't be anything to do,
           * but this is not an error situation so make sure we
           * return OK instead of BUF_ERROR at next call of deflate:
           */
          s.last_flush = -1;
          return Z_OK$2;
        }

        /* Make sure there is something to do and avoid duplicate consecutive
         * flushes. For repeated and useless calls with Z_FINISH, we keep
         * returning Z_STREAM_END instead of Z_BUF_ERROR.
         */
      } else if (strm.avail_in === 0 && rank(flush) <= rank(old_flush) &&
        flush !== Z_FINISH$2) {
        return err(strm, Z_BUF_ERROR$2);
      }

      /* User must not provide more input after the first FINISH: */
      if (s.status === FINISH_STATE && strm.avail_in !== 0) {
        return err(strm, Z_BUF_ERROR$2);
      }

      /* Start a new block or continue the current one.
       */
      if (strm.avail_in !== 0 || s.lookahead !== 0 ||
        (flush !== Z_NO_FLUSH$1 && s.status !== FINISH_STATE)) {
        var bstate = (s.strategy === Z_HUFFMAN_ONLY$1) ? deflate_huff(s, flush) :
          (s.strategy === Z_RLE$1 ? deflate_rle(s, flush) :
            configuration_table[s.level].func(s, flush));

        if (bstate === BS_FINISH_STARTED || bstate === BS_FINISH_DONE) {
          s.status = FINISH_STATE;
        }
        if (bstate === BS_NEED_MORE || bstate === BS_FINISH_STARTED) {
          if (strm.avail_out === 0) {
            s.last_flush = -1;
            /* avoid BUF_ERROR next call, see above */
          }
          return Z_OK$2;
          /* If flush != Z_NO_FLUSH && avail_out == 0, the next call
           * of deflate should use the same flush parameter to make sure
           * that the flush is complete. So we don't have to output an
           * empty block here, this will be done at next call. This also
           * ensures that for a very small output buffer, we emit at most
           * one empty block.
           */
        }
        if (bstate === BS_BLOCK_DONE) {
          if (flush === Z_PARTIAL_FLUSH$1) {
            _tr_align(s);
          } else if (flush !== Z_BLOCK$2) { /* FULL_FLUSH or SYNC_FLUSH */

            _tr_stored_block(s, 0, 0, false);
            /* For a full flush, this empty block will be recognized
             * as a special marker by inflate_sync().
             */
            if (flush === Z_FULL_FLUSH$1) {
              /*** CLEAR_HASH(s); ***/
              /* forget history */
              zero(s.head); // Fill with NIL (= 0);

              if (s.lookahead === 0) {
                s.strstart = 0;
                s.block_start = 0;
                s.insert = 0;
              }
            }
          }
          flush_pending(strm);
          if (strm.avail_out === 0) {
            s.last_flush = -1; /* avoid BUF_ERROR at next call, see above */
            return Z_OK$2;
          }
        }
      }
      //Assert(strm->avail_out > 0, "bug2");
      //if (strm.avail_out <= 0) { throw new Error("bug2");}

      if (flush !== Z_FINISH$2) {
        return Z_OK$2;
      }
      if (s.wrap <= 0) {
        return Z_STREAM_END$2;
      }

      /* Write the trailer */
      if (s.wrap === 2) {
        put_byte(s, strm.adler & 0xff);
        put_byte(s, (strm.adler >> 8) & 0xff);
        put_byte(s, (strm.adler >> 16) & 0xff);
        put_byte(s, (strm.adler >> 24) & 0xff);
        put_byte(s, strm.total_in & 0xff);
        put_byte(s, (strm.total_in >> 8) & 0xff);
        put_byte(s, (strm.total_in >> 16) & 0xff);
        put_byte(s, (strm.total_in >> 24) & 0xff);
      } else {
        putShortMSB(s, strm.adler >>> 16);
        putShortMSB(s, strm.adler & 0xffff);
      }

      flush_pending(strm);
      /* If avail_out is zero, the application will call deflate again
       * to flush the rest.
       */
      if (s.wrap > 0) {
        s.wrap = -s.wrap;
      }
      /* write the trailer only once! */
      return s.pending !== 0 ? Z_OK$2 : Z_STREAM_END$2;
    }

    function deflateEnd(strm) {
      var status;

      if (!strm /*== Z_NULL*/ || !strm.state /*== Z_NULL*/ ) {
        return Z_STREAM_ERROR$2;
      }

      status = strm.state.status;
      if (status !== INIT_STATE &&
        status !== EXTRA_STATE &&
        status !== NAME_STATE &&
        status !== COMMENT_STATE &&
        status !== HCRC_STATE &&
        status !== BUSY_STATE &&
        status !== FINISH_STATE
      ) {
        return err(strm, Z_STREAM_ERROR$2);
      }

      strm.state = null;

      return status === BUSY_STATE ? err(strm, Z_DATA_ERROR$2) : Z_OK$2;
    }

    /* Not implemented
    exports.deflateBound = deflateBound;
    exports.deflateCopy = deflateCopy;
    exports.deflateParams = deflateParams;
    exports.deflatePending = deflatePending;
    exports.deflatePrime = deflatePrime;
    exports.deflateTune = deflateTune;
    */

    // See state defs from inflate.js
    var BAD$1 = 30;       /* got a data error -- remain here until reset */
    var TYPE$1 = 12;      /* i: waiting for type bits, including last-flag bit */

    /*
       Decode literal, length, and distance codes and write out the resulting
       literal and match bytes until either not enough input or output is
       available, an end-of-block is encountered, or a data error is encountered.
       When large enough input and output buffers are supplied to inflate(), for
       example, a 16K input buffer and a 64K output buffer, more than 95% of the
       inflate execution time is spent in this routine.

       Entry assumptions:

            state.mode === LEN
            strm.avail_in >= 6
            strm.avail_out >= 258
            start >= strm.avail_out
            state.bits < 8

       On return, state.mode is one of:

            LEN -- ran out of enough output space or enough available input
            TYPE -- reached end of block code, inflate() to interpret next block
            BAD -- error in block data

       Notes:

        - The maximum input bits used by a length/distance pair is 15 bits for the
          length code, 5 bits for the length extra, 15 bits for the distance code,
          and 13 bits for the distance extra.  This totals 48 bits, or six bytes.
          Therefore if strm.avail_in >= 6, then there is enough input to avoid
          checking for available input while decoding.

        - The maximum bytes that a single length/distance pair can output is 258
          bytes, which is the maximum length that can be coded.  inflate_fast()
          requires strm.avail_out >= 258 for each loop to avoid checking for
          output space.
     */
    function inflate_fast(strm, start) {
      var state;
      var _in;                    /* local strm.input */
      var last;                   /* have enough input while in < last */
      var _out;                   /* local strm.output */
      var beg;                    /* inflate()'s initial strm.output */
      var end;                    /* while out < end, enough space available */
    //#ifdef INFLATE_STRICT
      var dmax;                   /* maximum distance from zlib header */
    //#endif
      var wsize;                  /* window size or zero if not using window */
      var whave;                  /* valid bytes in the window */
      var wnext;                  /* window write index */
      // Use `s_window` instead `window`, avoid conflict with instrumentation tools
      var s_window;               /* allocated sliding window, if wsize != 0 */
      var hold;                   /* local strm.hold */
      var bits;                   /* local strm.bits */
      var lcode;                  /* local strm.lencode */
      var dcode;                  /* local strm.distcode */
      var lmask;                  /* mask for first level of length codes */
      var dmask;                  /* mask for first level of distance codes */
      var here;                   /* retrieved table entry */
      var op;                     /* code bits, operation, extra bits, or */
                                  /*  window position, window bytes to copy */
      var len;                    /* match length, unused bytes */
      var dist;                   /* match distance */
      var from;                   /* where to copy match from */
      var from_source;


      var input, output; // JS specific, because we have no pointers

      /* copy state to local variables */
      state = strm.state;
      //here = state.here;
      _in = strm.next_in;
      input = strm.input;
      last = _in + (strm.avail_in - 5);
      _out = strm.next_out;
      output = strm.output;
      beg = _out - (start - strm.avail_out);
      end = _out + (strm.avail_out - 257);
    //#ifdef INFLATE_STRICT
      dmax = state.dmax;
    //#endif
      wsize = state.wsize;
      whave = state.whave;
      wnext = state.wnext;
      s_window = state.window;
      hold = state.hold;
      bits = state.bits;
      lcode = state.lencode;
      dcode = state.distcode;
      lmask = (1 << state.lenbits) - 1;
      dmask = (1 << state.distbits) - 1;


      /* decode literals and length/distances until end-of-block or not enough
         input data or output space */

      top:
      do {
        if (bits < 15) {
          hold += input[_in++] << bits;
          bits += 8;
          hold += input[_in++] << bits;
          bits += 8;
        }

        here = lcode[hold & lmask];

        dolen:
        for (;;) { // Goto emulation
          op = here >>> 24/*here.bits*/;
          hold >>>= op;
          bits -= op;
          op = (here >>> 16) & 0xff/*here.op*/;
          if (op === 0) {                          /* literal */
            //Tracevv((stderr, here.val >= 0x20 && here.val < 0x7f ?
            //        "inflate:         literal '%c'\n" :
            //        "inflate:         literal 0x%02x\n", here.val));
            output[_out++] = here & 0xffff/*here.val*/;
          }
          else if (op & 16) {                     /* length base */
            len = here & 0xffff/*here.val*/;
            op &= 15;                           /* number of extra bits */
            if (op) {
              if (bits < op) {
                hold += input[_in++] << bits;
                bits += 8;
              }
              len += hold & ((1 << op) - 1);
              hold >>>= op;
              bits -= op;
            }
            //Tracevv((stderr, "inflate:         length %u\n", len));
            if (bits < 15) {
              hold += input[_in++] << bits;
              bits += 8;
              hold += input[_in++] << bits;
              bits += 8;
            }
            here = dcode[hold & dmask];

            dodist:
            for (;;) { // goto emulation
              op = here >>> 24/*here.bits*/;
              hold >>>= op;
              bits -= op;
              op = (here >>> 16) & 0xff/*here.op*/;

              if (op & 16) {                      /* distance base */
                dist = here & 0xffff/*here.val*/;
                op &= 15;                       /* number of extra bits */
                if (bits < op) {
                  hold += input[_in++] << bits;
                  bits += 8;
                  if (bits < op) {
                    hold += input[_in++] << bits;
                    bits += 8;
                  }
                }
                dist += hold & ((1 << op) - 1);
    //#ifdef INFLATE_STRICT
                if (dist > dmax) {
                  strm.msg = 'invalid distance too far back';
                  state.mode = BAD$1;
                  break top;
                }
    //#endif
                hold >>>= op;
                bits -= op;
                //Tracevv((stderr, "inflate:         distance %u\n", dist));
                op = _out - beg;                /* max distance in output */
                if (dist > op) {                /* see if copy from window */
                  op = dist - op;               /* distance back in window */
                  if (op > whave) {
                    if (state.sane) {
                      strm.msg = 'invalid distance too far back';
                      state.mode = BAD$1;
                      break top;
                    }

    // (!) This block is disabled in zlib defailts,
    // don't enable it for binary compatibility
    //#ifdef INFLATE_ALLOW_INVALID_DISTANCE_TOOFAR_ARRR
    //                if (len <= op - whave) {
    //                  do {
    //                    output[_out++] = 0;
    //                  } while (--len);
    //                  continue top;
    //                }
    //                len -= op - whave;
    //                do {
    //                  output[_out++] = 0;
    //                } while (--op > whave);
    //                if (op === 0) {
    //                  from = _out - dist;
    //                  do {
    //                    output[_out++] = output[from++];
    //                  } while (--len);
    //                  continue top;
    //                }
    //#endif
                  }
                  from = 0; // window index
                  from_source = s_window;
                  if (wnext === 0) {           /* very common case */
                    from += wsize - op;
                    if (op < len) {         /* some from window */
                      len -= op;
                      do {
                        output[_out++] = s_window[from++];
                      } while (--op);
                      from = _out - dist;  /* rest from output */
                      from_source = output;
                    }
                  }
                  else if (wnext < op) {      /* wrap around window */
                    from += wsize + wnext - op;
                    op -= wnext;
                    if (op < len) {         /* some from end of window */
                      len -= op;
                      do {
                        output[_out++] = s_window[from++];
                      } while (--op);
                      from = 0;
                      if (wnext < len) {  /* some from start of window */
                        op = wnext;
                        len -= op;
                        do {
                          output[_out++] = s_window[from++];
                        } while (--op);
                        from = _out - dist;      /* rest from output */
                        from_source = output;
                      }
                    }
                  }
                  else {                      /* contiguous in window */
                    from += wnext - op;
                    if (op < len) {         /* some from window */
                      len -= op;
                      do {
                        output[_out++] = s_window[from++];
                      } while (--op);
                      from = _out - dist;  /* rest from output */
                      from_source = output;
                    }
                  }
                  while (len > 2) {
                    output[_out++] = from_source[from++];
                    output[_out++] = from_source[from++];
                    output[_out++] = from_source[from++];
                    len -= 3;
                  }
                  if (len) {
                    output[_out++] = from_source[from++];
                    if (len > 1) {
                      output[_out++] = from_source[from++];
                    }
                  }
                }
                else {
                  from = _out - dist;          /* copy direct from output */
                  do {                        /* minimum length is three */
                    output[_out++] = output[from++];
                    output[_out++] = output[from++];
                    output[_out++] = output[from++];
                    len -= 3;
                  } while (len > 2);
                  if (len) {
                    output[_out++] = output[from++];
                    if (len > 1) {
                      output[_out++] = output[from++];
                    }
                  }
                }
              }
              else if ((op & 64) === 0) {          /* 2nd level distance code */
                here = dcode[(here & 0xffff)/*here.val*/ + (hold & ((1 << op) - 1))];
                continue dodist;
              }
              else {
                strm.msg = 'invalid distance code';
                state.mode = BAD$1;
                break top;
              }

              break; // need to emulate goto via "continue"
            }
          }
          else if ((op & 64) === 0) {              /* 2nd level length code */
            here = lcode[(here & 0xffff)/*here.val*/ + (hold & ((1 << op) - 1))];
            continue dolen;
          }
          else if (op & 32) {                     /* end-of-block */
            //Tracevv((stderr, "inflate:         end of block\n"));
            state.mode = TYPE$1;
            break top;
          }
          else {
            strm.msg = 'invalid literal/length code';
            state.mode = BAD$1;
            break top;
          }

          break; // need to emulate goto via "continue"
        }
      } while (_in < last && _out < end);

      /* return unused bytes (on entry, bits < 8, so in won't go too far back) */
      len = bits >> 3;
      _in -= len;
      bits -= len << 3;
      hold &= (1 << bits) - 1;

      /* update state and return */
      strm.next_in = _in;
      strm.next_out = _out;
      strm.avail_in = (_in < last ? 5 + (last - _in) : 5 - (_in - last));
      strm.avail_out = (_out < end ? 257 + (end - _out) : 257 - (_out - end));
      state.hold = hold;
      state.bits = bits;
      return;
    }

    var MAXBITS = 15;
    var ENOUGH_LENS$1 = 852;
    var ENOUGH_DISTS$1 = 592;
    //var ENOUGH = (ENOUGH_LENS+ENOUGH_DISTS);

    var CODES$1 = 0;
    var LENS$1 = 1;
    var DISTS$1 = 2;

    var lbase = [ /* Length codes 257..285 base */
      3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31,
      35, 43, 51, 59, 67, 83, 99, 115, 131, 163, 195, 227, 258, 0, 0
    ];

    var lext = [ /* Length codes 257..285 extra */
      16, 16, 16, 16, 16, 16, 16, 16, 17, 17, 17, 17, 18, 18, 18, 18,
      19, 19, 19, 19, 20, 20, 20, 20, 21, 21, 21, 21, 16, 72, 78
    ];

    var dbase = [ /* Distance codes 0..29 base */
      1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193,
      257, 385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145,
      8193, 12289, 16385, 24577, 0, 0
    ];

    var dext = [ /* Distance codes 0..29 extra */
      16, 16, 16, 16, 17, 17, 18, 18, 19, 19, 20, 20, 21, 21, 22, 22,
      23, 23, 24, 24, 25, 25, 26, 26, 27, 27,
      28, 28, 29, 29, 64, 64
    ];

    function inflate_table(type, lens, lens_index, codes, table, table_index, work, opts) {
      var bits = opts.bits;
      //here = opts.here; /* table entry for duplication */

      var len = 0; /* a code's length in bits */
      var sym = 0; /* index of code symbols */
      var min = 0,
        max = 0; /* minimum and maximum code lengths */
      var root = 0; /* number of index bits for root table */
      var curr = 0; /* number of index bits for current table */
      var drop = 0; /* code bits to drop for sub-table */
      var left = 0; /* number of prefix codes available */
      var used = 0; /* code entries in table used */
      var huff = 0; /* Huffman code */
      var incr; /* for incrementing code, index */
      var fill; /* index for replicating entries */
      var low; /* low bits for current root entry */
      var mask; /* mask for low root bits */
      var next; /* next available space in table */
      var base = null; /* base value table to use */
      var base_index = 0;
      //  var shoextra;    /* extra bits table to use */
      var end; /* use base and extra for symbol > end */
      var count = new Buf16(MAXBITS + 1); //[MAXBITS+1];    /* number of codes of each length */
      var offs = new Buf16(MAXBITS + 1); //[MAXBITS+1];     /* offsets in table for each length */
      var extra = null;
      var extra_index = 0;

      var here_bits, here_op, here_val;

      /*
       Process a set of code lengths to create a canonical Huffman code.  The
       code lengths are lens[0..codes-1].  Each length corresponds to the
       symbols 0..codes-1.  The Huffman code is generated by first sorting the
       symbols by length from short to long, and retaining the symbol order
       for codes with equal lengths.  Then the code starts with all zero bits
       for the first code of the shortest length, and the codes are integer
       increments for the same length, and zeros are appended as the length
       increases.  For the deflate format, these bits are stored backwards
       from their more natural integer increment ordering, and so when the
       decoding tables are built in the large loop below, the integer codes
       are incremented backwards.

       This routine assumes, but does not check, that all of the entries in
       lens[] are in the range 0..MAXBITS.  The caller must assure this.
       1..MAXBITS is interpreted as that code length.  zero means that that
       symbol does not occur in this code.

       The codes are sorted by computing a count of codes for each length,
       creating from that a table of starting indices for each length in the
       sorted table, and then entering the symbols in order in the sorted
       table.  The sorted table is work[], with that space being provided by
       the caller.

       The length counts are used for other purposes as well, i.e. finding
       the minimum and maximum length codes, determining if there are any
       codes at all, checking for a valid set of lengths, and looking ahead
       at length counts to determine sub-table sizes when building the
       decoding tables.
       */

      /* accumulate lengths for codes (assumes lens[] all in 0..MAXBITS) */
      for (len = 0; len <= MAXBITS; len++) {
        count[len] = 0;
      }
      for (sym = 0; sym < codes; sym++) {
        count[lens[lens_index + sym]]++;
      }

      /* bound code lengths, force root to be within code lengths */
      root = bits;
      for (max = MAXBITS; max >= 1; max--) {
        if (count[max] !== 0) {
          break;
        }
      }
      if (root > max) {
        root = max;
      }
      if (max === 0) { /* no symbols to code at all */
        //table.op[opts.table_index] = 64;  //here.op = (var char)64;    /* invalid code marker */
        //table.bits[opts.table_index] = 1;   //here.bits = (var char)1;
        //table.val[opts.table_index++] = 0;   //here.val = (var short)0;
        table[table_index++] = (1 << 24) | (64 << 16) | 0;


        //table.op[opts.table_index] = 64;
        //table.bits[opts.table_index] = 1;
        //table.val[opts.table_index++] = 0;
        table[table_index++] = (1 << 24) | (64 << 16) | 0;

        opts.bits = 1;
        return 0; /* no symbols, but wait for decoding to report error */
      }
      for (min = 1; min < max; min++) {
        if (count[min] !== 0) {
          break;
        }
      }
      if (root < min) {
        root = min;
      }

      /* check for an over-subscribed or incomplete set of lengths */
      left = 1;
      for (len = 1; len <= MAXBITS; len++) {
        left <<= 1;
        left -= count[len];
        if (left < 0) {
          return -1;
        } /* over-subscribed */
      }
      if (left > 0 && (type === CODES$1 || max !== 1)) {
        return -1; /* incomplete set */
      }

      /* generate offsets into symbol table for each length for sorting */
      offs[1] = 0;
      for (len = 1; len < MAXBITS; len++) {
        offs[len + 1] = offs[len] + count[len];
      }

      /* sort symbols by length, by symbol order within each length */
      for (sym = 0; sym < codes; sym++) {
        if (lens[lens_index + sym] !== 0) {
          work[offs[lens[lens_index + sym]]++] = sym;
        }
      }

      /*
       Create and fill in decoding tables.  In this loop, the table being
       filled is at next and has curr index bits.  The code being used is huff
       with length len.  That code is converted to an index by dropping drop
       bits off of the bottom.  For codes where len is less than drop + curr,
       those top drop + curr - len bits are incremented through all values to
       fill the table with replicated entries.

       root is the number of index bits for the root table.  When len exceeds
       root, sub-tables are created pointed to by the root entry with an index
       of the low root bits of huff.  This is saved in low to check for when a
       new sub-table should be started.  drop is zero when the root table is
       being filled, and drop is root when sub-tables are being filled.

       When a new sub-table is needed, it is necessary to look ahead in the
       code lengths to determine what size sub-table is needed.  The length
       counts are used for this, and so count[] is decremented as codes are
       entered in the tables.

       used keeps track of how many table entries have been allocated from the
       provided *table space.  It is checked for LENS and DIST tables against
       the constants ENOUGH_LENS and ENOUGH_DISTS to guard against changes in
       the initial root table size constants.  See the comments in inftrees.h
       for more information.

       sym increments through all symbols, and the loop terminates when
       all codes of length max, i.e. all codes, have been processed.  This
       routine permits incomplete codes, so another loop after this one fills
       in the rest of the decoding tables with invalid code markers.
       */

      /* set up for code type */
      // poor man optimization - use if-else instead of switch,
      // to avoid deopts in old v8
      if (type === CODES$1) {
        base = extra = work; /* dummy value--not used */
        end = 19;

      } else if (type === LENS$1) {
        base = lbase;
        base_index -= 257;
        extra = lext;
        extra_index -= 257;
        end = 256;

      } else { /* DISTS */
        base = dbase;
        extra = dext;
        end = -1;
      }

      /* initialize opts for loop */
      huff = 0; /* starting code */
      sym = 0; /* starting code symbol */
      len = min; /* starting code length */
      next = table_index; /* current table to fill in */
      curr = root; /* current table index bits */
      drop = 0; /* current bits to drop from code for index */
      low = -1; /* trigger new sub-table when len > root */
      used = 1 << root; /* use root table entries */
      mask = used - 1; /* mask for comparing low */

      /* check available table space */
      if ((type === LENS$1 && used > ENOUGH_LENS$1) ||
        (type === DISTS$1 && used > ENOUGH_DISTS$1)) {
        return 1;
      }
      /* process all codes and make table entries */
      for (;;) {
        /* create table entry */
        here_bits = len - drop;
        if (work[sym] < end) {
          here_op = 0;
          here_val = work[sym];
        } else if (work[sym] > end) {
          here_op = extra[extra_index + work[sym]];
          here_val = base[base_index + work[sym]];
        } else {
          here_op = 32 + 64; /* end of block */
          here_val = 0;
        }

        /* replicate for those indices with low len bits equal to huff */
        incr = 1 << (len - drop);
        fill = 1 << curr;
        min = fill; /* save offset to next table */
        do {
          fill -= incr;
          table[next + (huff >> drop) + fill] = (here_bits << 24) | (here_op << 16) | here_val | 0;
        } while (fill !== 0);

        /* backwards increment the len-bit code huff */
        incr = 1 << (len - 1);
        while (huff & incr) {
          incr >>= 1;
        }
        if (incr !== 0) {
          huff &= incr - 1;
          huff += incr;
        } else {
          huff = 0;
        }

        /* go to next symbol, update count, len */
        sym++;
        if (--count[len] === 0) {
          if (len === max) {
            break;
          }
          len = lens[lens_index + work[sym]];
        }

        /* create new sub-table if needed */
        if (len > root && (huff & mask) !== low) {
          /* if first time, transition to sub-tables */
          if (drop === 0) {
            drop = root;
          }

          /* increment past last table */
          next += min; /* here min is 1 << curr */

          /* determine length of next table */
          curr = len - drop;
          left = 1 << curr;
          while (curr + drop < max) {
            left -= count[curr + drop];
            if (left <= 0) {
              break;
            }
            curr++;
            left <<= 1;
          }

          /* check for enough space */
          used += 1 << curr;
          if ((type === LENS$1 && used > ENOUGH_LENS$1) ||
            (type === DISTS$1 && used > ENOUGH_DISTS$1)) {
            return 1;
          }

          /* point entry in root table to sub-table */
          low = huff & mask;
          /*table.op[low] = curr;
          table.bits[low] = root;
          table.val[low] = next - opts.table_index;*/
          table[low] = (root << 24) | (curr << 16) | (next - table_index) | 0;
        }
      }

      /* fill in remaining table entry if code is incomplete (guaranteed to have
       at most one remaining entry, since if the code is incomplete, the
       maximum code length that was allowed to get this far is one bit) */
      if (huff !== 0) {
        //table.op[next + huff] = 64;            /* invalid code marker */
        //table.bits[next + huff] = len - drop;
        //table.val[next + huff] = 0;
        table[next + huff] = ((len - drop) << 24) | (64 << 16) | 0;
      }

      /* set return parameters */
      //opts.table_index += used;
      opts.bits = root;
      return 0;
    }

    var CODES = 0;
    var LENS = 1;
    var DISTS = 2;

    /* Public constants ==========================================================*/
    /* ===========================================================================*/


    /* Allowed flush values; see deflate() and inflate() below for details */
    //var Z_NO_FLUSH      = 0;
    //var Z_PARTIAL_FLUSH = 1;
    //var Z_SYNC_FLUSH    = 2;
    //var Z_FULL_FLUSH    = 3;
    var Z_FINISH$1 = 4;
    var Z_BLOCK$1 = 5;
    var Z_TREES$1 = 6;


    /* Return codes for the compression/decompression functions. Negative values
     * are errors, positive values are used for special but normal events.
     */
    var Z_OK$1 = 0;
    var Z_STREAM_END$1 = 1;
    var Z_NEED_DICT$1 = 2;
    //var Z_ERRNO         = -1;
    var Z_STREAM_ERROR$1 = -2;
    var Z_DATA_ERROR$1 = -3;
    var Z_MEM_ERROR = -4;
    var Z_BUF_ERROR$1 = -5;
    //var Z_VERSION_ERROR = -6;

    /* The deflate compression method */
    var Z_DEFLATED$1 = 8;


    /* STATES ====================================================================*/
    /* ===========================================================================*/


    var HEAD = 1; /* i: waiting for magic header */
    var FLAGS = 2; /* i: waiting for method and flags (gzip) */
    var TIME = 3; /* i: waiting for modification time (gzip) */
    var OS = 4; /* i: waiting for extra flags and operating system (gzip) */
    var EXLEN = 5; /* i: waiting for extra length (gzip) */
    var EXTRA = 6; /* i: waiting for extra bytes (gzip) */
    var NAME = 7; /* i: waiting for end of file name (gzip) */
    var COMMENT = 8; /* i: waiting for end of comment (gzip) */
    var HCRC = 9; /* i: waiting for header crc (gzip) */
    var DICTID = 10; /* i: waiting for dictionary check value */
    var DICT = 11; /* waiting for inflateSetDictionary() call */
    var TYPE = 12; /* i: waiting for type bits, including last-flag bit */
    var TYPEDO = 13; /* i: same, but skip check to exit inflate on new block */
    var STORED = 14; /* i: waiting for stored size (length and complement) */
    var COPY_ = 15; /* i/o: same as COPY below, but only first time in */
    var COPY = 16; /* i/o: waiting for input or output to copy stored block */
    var TABLE = 17; /* i: waiting for dynamic block table lengths */
    var LENLENS = 18; /* i: waiting for code length code lengths */
    var CODELENS = 19; /* i: waiting for length/lit and distance code lengths */
    var LEN_ = 20; /* i: same as LEN below, but only first time in */
    var LEN = 21; /* i: waiting for length/lit/eob code */
    var LENEXT = 22; /* i: waiting for length extra bits */
    var DIST = 23; /* i: waiting for distance code */
    var DISTEXT = 24; /* i: waiting for distance extra bits */
    var MATCH = 25; /* o: waiting for output space to copy string */
    var LIT = 26; /* o: waiting for output space to write literal */
    var CHECK = 27; /* i: waiting for 32-bit check value */
    var LENGTH = 28; /* i: waiting for 32-bit length (gzip) */
    var DONE = 29; /* finished check, done -- remain here until reset */
    var BAD = 30; /* got a data error -- remain here until reset */
    var MEM = 31; /* got an inflate() memory error -- remain here until reset */
    var SYNC = 32; /* looking for synchronization bytes to restart inflate() */

    /* ===========================================================================*/



    var ENOUGH_LENS = 852;
    var ENOUGH_DISTS = 592;


    function zswap32(q) {
      return (((q >>> 24) & 0xff) +
        ((q >>> 8) & 0xff00) +
        ((q & 0xff00) << 8) +
        ((q & 0xff) << 24));
    }


    function InflateState() {
      this.mode = 0; /* current inflate mode */
      this.last = false; /* true if processing last block */
      this.wrap = 0; /* bit 0 true for zlib, bit 1 true for gzip */
      this.havedict = false; /* true if dictionary provided */
      this.flags = 0; /* gzip header method and flags (0 if zlib) */
      this.dmax = 0; /* zlib header max distance (INFLATE_STRICT) */
      this.check = 0; /* protected copy of check value */
      this.total = 0; /* protected copy of output count */
      // TODO: may be {}
      this.head = null; /* where to save gzip header information */

      /* sliding window */
      this.wbits = 0; /* log base 2 of requested window size */
      this.wsize = 0; /* window size or zero if not using window */
      this.whave = 0; /* valid bytes in the window */
      this.wnext = 0; /* window write index */
      this.window = null; /* allocated sliding window, if needed */

      /* bit accumulator */
      this.hold = 0; /* input bit accumulator */
      this.bits = 0; /* number of bits in "in" */

      /* for string and stored block copying */
      this.length = 0; /* literal or length of data to copy */
      this.offset = 0; /* distance back to copy string from */

      /* for table and code decoding */
      this.extra = 0; /* extra bits needed */

      /* fixed and dynamic code tables */
      this.lencode = null; /* starting table for length/literal codes */
      this.distcode = null; /* starting table for distance codes */
      this.lenbits = 0; /* index bits for lencode */
      this.distbits = 0; /* index bits for distcode */

      /* dynamic table building */
      this.ncode = 0; /* number of code length code lengths */
      this.nlen = 0; /* number of length code lengths */
      this.ndist = 0; /* number of distance code lengths */
      this.have = 0; /* number of code lengths in lens[] */
      this.next = null; /* next available space in codes[] */

      this.lens = new Buf16(320); /* temporary storage for code lengths */
      this.work = new Buf16(288); /* work area for code table building */

      /*
       because we don't have pointers in js, we use lencode and distcode directly
       as buffers so we don't need codes
      */
      //this.codes = new Buf32(ENOUGH);       /* space for code tables */
      this.lendyn = null; /* dynamic table for length/literal codes (JS specific) */
      this.distdyn = null; /* dynamic table for distance codes (JS specific) */
      this.sane = 0; /* if false, allow invalid distance too far */
      this.back = 0; /* bits back of last unprocessed length/lit */
      this.was = 0; /* initial length of match */
    }

    function inflateResetKeep(strm) {
      var state;

      if (!strm || !strm.state) {
        return Z_STREAM_ERROR$1;
      }
      state = strm.state;
      strm.total_in = strm.total_out = state.total = 0;
      strm.msg = ''; /*Z_NULL*/
      if (state.wrap) { /* to support ill-conceived Java test suite */
        strm.adler = state.wrap & 1;
      }
      state.mode = HEAD;
      state.last = 0;
      state.havedict = 0;
      state.dmax = 32768;
      state.head = null /*Z_NULL*/ ;
      state.hold = 0;
      state.bits = 0;
      //state.lencode = state.distcode = state.next = state.codes;
      state.lencode = state.lendyn = new Buf32(ENOUGH_LENS);
      state.distcode = state.distdyn = new Buf32(ENOUGH_DISTS);

      state.sane = 1;
      state.back = -1;
      //Tracev((stderr, "inflate: reset\n"));
      return Z_OK$1;
    }

    function inflateReset(strm) {
      var state;

      if (!strm || !strm.state) {
        return Z_STREAM_ERROR$1;
      }
      state = strm.state;
      state.wsize = 0;
      state.whave = 0;
      state.wnext = 0;
      return inflateResetKeep(strm);

    }

    function inflateReset2(strm, windowBits) {
      var wrap;
      var state;

      /* get the state */
      if (!strm || !strm.state) {
        return Z_STREAM_ERROR$1;
      }
      state = strm.state;

      /* extract wrap request from windowBits parameter */
      if (windowBits < 0) {
        wrap = 0;
        windowBits = -windowBits;
      } else {
        wrap = (windowBits >> 4) + 1;
        if (windowBits < 48) {
          windowBits &= 15;
        }
      }

      /* set number of window bits, free window if different */
      if (windowBits && (windowBits < 8 || windowBits > 15)) {
        return Z_STREAM_ERROR$1;
      }
      if (state.window !== null && state.wbits !== windowBits) {
        state.window = null;
      }

      /* update state and reset the rest of it */
      state.wrap = wrap;
      state.wbits = windowBits;
      return inflateReset(strm);
    }

    function inflateInit2(strm, windowBits) {
      var ret;
      var state;

      if (!strm) {
        return Z_STREAM_ERROR$1;
      }
      //strm.msg = Z_NULL;                 /* in case we return an error */

      state = new InflateState();

      //if (state === Z_NULL) return Z_MEM_ERROR;
      //Tracev((stderr, "inflate: allocated\n"));
      strm.state = state;
      state.window = null /*Z_NULL*/ ;
      ret = inflateReset2(strm, windowBits);
      if (ret !== Z_OK$1) {
        strm.state = null /*Z_NULL*/ ;
      }
      return ret;
    }


    /*
     Return state with length and distance decoding tables and index sizes set to
     fixed code decoding.  Normally this returns fixed tables from inffixed.h.
     If BUILDFIXED is defined, then instead this routine builds the tables the
     first time it's called, and returns those tables the first time and
     thereafter.  This reduces the size of the code by about 2K bytes, in
     exchange for a little execution time.  However, BUILDFIXED should not be
     used for threaded applications, since the rewriting of the tables and virgin
     may not be thread-safe.
     */
    var virgin = true;

    var lenfix, distfix; // We have no pointers in JS, so keep tables separate

    function fixedtables(state) {
      /* build fixed huffman tables if first call (may not be thread safe) */
      if (virgin) {
        var sym;

        lenfix = new Buf32(512);
        distfix = new Buf32(32);

        /* literal/length table */
        sym = 0;
        while (sym < 144) {
          state.lens[sym++] = 8;
        }
        while (sym < 256) {
          state.lens[sym++] = 9;
        }
        while (sym < 280) {
          state.lens[sym++] = 7;
        }
        while (sym < 288) {
          state.lens[sym++] = 8;
        }

        inflate_table(LENS, state.lens, 0, 288, lenfix, 0, state.work, {
          bits: 9
        });

        /* distance table */
        sym = 0;
        while (sym < 32) {
          state.lens[sym++] = 5;
        }

        inflate_table(DISTS, state.lens, 0, 32, distfix, 0, state.work, {
          bits: 5
        });

        /* do this just once */
        virgin = false;
      }

      state.lencode = lenfix;
      state.lenbits = 9;
      state.distcode = distfix;
      state.distbits = 5;
    }


    /*
     Update the window with the last wsize (normally 32K) bytes written before
     returning.  If window does not exist yet, create it.  This is only called
     when a window is already in use, or when output has been written during this
     inflate call, but the end of the deflate stream has not been reached yet.
     It is also called to create a window for dictionary data when a dictionary
     is loaded.

     Providing output buffers larger than 32K to inflate() should provide a speed
     advantage, since only the last 32K of output is copied to the sliding window
     upon return from inflate(), and since all distances after the first 32K of
     output will fall in the output data, making match copies simpler and faster.
     The advantage may be dependent on the size of the processor's data caches.
     */
    function updatewindow(strm, src, end, copy) {
      var dist;
      var state = strm.state;

      /* if it hasn't been done already, allocate space for the window */
      if (state.window === null) {
        state.wsize = 1 << state.wbits;
        state.wnext = 0;
        state.whave = 0;

        state.window = new Buf8(state.wsize);
      }

      /* copy state->wsize or less output bytes into the circular window */
      if (copy >= state.wsize) {
        arraySet(state.window, src, end - state.wsize, state.wsize, 0);
        state.wnext = 0;
        state.whave = state.wsize;
      } else {
        dist = state.wsize - state.wnext;
        if (dist > copy) {
          dist = copy;
        }
        //zmemcpy(state->window + state->wnext, end - copy, dist);
        arraySet(state.window, src, end - copy, dist, state.wnext);
        copy -= dist;
        if (copy) {
          //zmemcpy(state->window, end - copy, copy);
          arraySet(state.window, src, end - copy, copy, 0);
          state.wnext = copy;
          state.whave = state.wsize;
        } else {
          state.wnext += dist;
          if (state.wnext === state.wsize) {
            state.wnext = 0;
          }
          if (state.whave < state.wsize) {
            state.whave += dist;
          }
        }
      }
      return 0;
    }

    function inflate$1(strm, flush) {
      var state;
      var input, output; // input/output buffers
      var next; /* next input INDEX */
      var put; /* next output INDEX */
      var have, left; /* available input and output */
      var hold; /* bit buffer */
      var bits; /* bits in bit buffer */
      var _in, _out; /* save starting available input and output */
      var copy; /* number of stored or match bytes to copy */
      var from; /* where to copy match bytes from */
      var from_source;
      var here = 0; /* current decoding table entry */
      var here_bits, here_op, here_val; // paked "here" denormalized (JS specific)
      //var last;                   /* parent table entry */
      var last_bits, last_op, last_val; // paked "last" denormalized (JS specific)
      var len; /* length to copy for repeats, bits to drop */
      var ret; /* return code */
      var hbuf = new Buf8(4); /* buffer for gzip header crc calculation */
      var opts;

      var n; // temporary var for NEED_BITS

      var order = /* permutation of code lengths */ [16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15];


      if (!strm || !strm.state || !strm.output ||
        (!strm.input && strm.avail_in !== 0)) {
        return Z_STREAM_ERROR$1;
      }

      state = strm.state;
      if (state.mode === TYPE) {
        state.mode = TYPEDO;
      } /* skip check */


      //--- LOAD() ---
      put = strm.next_out;
      output = strm.output;
      left = strm.avail_out;
      next = strm.next_in;
      input = strm.input;
      have = strm.avail_in;
      hold = state.hold;
      bits = state.bits;
      //---

      _in = have;
      _out = left;
      ret = Z_OK$1;

      inf_leave: // goto emulation
        for (;;) {
          switch (state.mode) {
          case HEAD:
            if (state.wrap === 0) {
              state.mode = TYPEDO;
              break;
            }
            //=== NEEDBITS(16);
            while (bits < 16) {
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            if ((state.wrap & 2) && hold === 0x8b1f) { /* gzip header */
              state.check = 0 /*crc32(0L, Z_NULL, 0)*/ ;
              //=== CRC2(state.check, hold);
              hbuf[0] = hold & 0xff;
              hbuf[1] = (hold >>> 8) & 0xff;
              state.check = crc32(state.check, hbuf, 2, 0);
              //===//

              //=== INITBITS();
              hold = 0;
              bits = 0;
              //===//
              state.mode = FLAGS;
              break;
            }
            state.flags = 0; /* expect zlib header */
            if (state.head) {
              state.head.done = false;
            }
            if (!(state.wrap & 1) || /* check if zlib header allowed */
              (((hold & 0xff) /*BITS(8)*/ << 8) + (hold >> 8)) % 31) {
              strm.msg = 'incorrect header check';
              state.mode = BAD;
              break;
            }
            if ((hold & 0x0f) /*BITS(4)*/ !== Z_DEFLATED$1) {
              strm.msg = 'unknown compression method';
              state.mode = BAD;
              break;
            }
            //--- DROPBITS(4) ---//
            hold >>>= 4;
            bits -= 4;
            //---//
            len = (hold & 0x0f) /*BITS(4)*/ + 8;
            if (state.wbits === 0) {
              state.wbits = len;
            } else if (len > state.wbits) {
              strm.msg = 'invalid window size';
              state.mode = BAD;
              break;
            }
            state.dmax = 1 << len;
            //Tracev((stderr, "inflate:   zlib header ok\n"));
            strm.adler = state.check = 1 /*adler32(0L, Z_NULL, 0)*/ ;
            state.mode = hold & 0x200 ? DICTID : TYPE;
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            break;
          case FLAGS:
            //=== NEEDBITS(16); */
            while (bits < 16) {
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            state.flags = hold;
            if ((state.flags & 0xff) !== Z_DEFLATED$1) {
              strm.msg = 'unknown compression method';
              state.mode = BAD;
              break;
            }
            if (state.flags & 0xe000) {
              strm.msg = 'unknown header flags set';
              state.mode = BAD;
              break;
            }
            if (state.head) {
              state.head.text = ((hold >> 8) & 1);
            }
            if (state.flags & 0x0200) {
              //=== CRC2(state.check, hold);
              hbuf[0] = hold & 0xff;
              hbuf[1] = (hold >>> 8) & 0xff;
              state.check = crc32(state.check, hbuf, 2, 0);
              //===//
            }
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            state.mode = TIME;
            /* falls through */
          case TIME:
            //=== NEEDBITS(32); */
            while (bits < 32) {
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            if (state.head) {
              state.head.time = hold;
            }
            if (state.flags & 0x0200) {
              //=== CRC4(state.check, hold)
              hbuf[0] = hold & 0xff;
              hbuf[1] = (hold >>> 8) & 0xff;
              hbuf[2] = (hold >>> 16) & 0xff;
              hbuf[3] = (hold >>> 24) & 0xff;
              state.check = crc32(state.check, hbuf, 4, 0);
              //===
            }
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            state.mode = OS;
            /* falls through */
          case OS:
            //=== NEEDBITS(16); */
            while (bits < 16) {
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            if (state.head) {
              state.head.xflags = (hold & 0xff);
              state.head.os = (hold >> 8);
            }
            if (state.flags & 0x0200) {
              //=== CRC2(state.check, hold);
              hbuf[0] = hold & 0xff;
              hbuf[1] = (hold >>> 8) & 0xff;
              state.check = crc32(state.check, hbuf, 2, 0);
              //===//
            }
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            state.mode = EXLEN;
            /* falls through */
          case EXLEN:
            if (state.flags & 0x0400) {
              //=== NEEDBITS(16); */
              while (bits < 16) {
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              //===//
              state.length = hold;
              if (state.head) {
                state.head.extra_len = hold;
              }
              if (state.flags & 0x0200) {
                //=== CRC2(state.check, hold);
                hbuf[0] = hold & 0xff;
                hbuf[1] = (hold >>> 8) & 0xff;
                state.check = crc32(state.check, hbuf, 2, 0);
                //===//
              }
              //=== INITBITS();
              hold = 0;
              bits = 0;
              //===//
            } else if (state.head) {
              state.head.extra = null /*Z_NULL*/ ;
            }
            state.mode = EXTRA;
            /* falls through */
          case EXTRA:
            if (state.flags & 0x0400) {
              copy = state.length;
              if (copy > have) {
                copy = have;
              }
              if (copy) {
                if (state.head) {
                  len = state.head.extra_len - state.length;
                  if (!state.head.extra) {
                    // Use untyped array for more conveniend processing later
                    state.head.extra = new Array(state.head.extra_len);
                  }
                  arraySet(
                    state.head.extra,
                    input,
                    next,
                    // extra field is limited to 65536 bytes
                    // - no need for additional size check
                    copy,
                    /*len + copy > state.head.extra_max - len ? state.head.extra_max : copy,*/
                    len
                  );
                  //zmemcpy(state.head.extra + len, next,
                  //        len + copy > state.head.extra_max ?
                  //        state.head.extra_max - len : copy);
                }
                if (state.flags & 0x0200) {
                  state.check = crc32(state.check, input, copy, next);
                }
                have -= copy;
                next += copy;
                state.length -= copy;
              }
              if (state.length) {
                break inf_leave;
              }
            }
            state.length = 0;
            state.mode = NAME;
            /* falls through */
          case NAME:
            if (state.flags & 0x0800) {
              if (have === 0) {
                break inf_leave;
              }
              copy = 0;
              do {
                // TODO: 2 or 1 bytes?
                len = input[next + copy++];
                /* use constant limit because in js we should not preallocate memory */
                if (state.head && len &&
                  (state.length < 65536 /*state.head.name_max*/ )) {
                  state.head.name += String.fromCharCode(len);
                }
              } while (len && copy < have);

              if (state.flags & 0x0200) {
                state.check = crc32(state.check, input, copy, next);
              }
              have -= copy;
              next += copy;
              if (len) {
                break inf_leave;
              }
            } else if (state.head) {
              state.head.name = null;
            }
            state.length = 0;
            state.mode = COMMENT;
            /* falls through */
          case COMMENT:
            if (state.flags & 0x1000) {
              if (have === 0) {
                break inf_leave;
              }
              copy = 0;
              do {
                len = input[next + copy++];
                /* use constant limit because in js we should not preallocate memory */
                if (state.head && len &&
                  (state.length < 65536 /*state.head.comm_max*/ )) {
                  state.head.comment += String.fromCharCode(len);
                }
              } while (len && copy < have);
              if (state.flags & 0x0200) {
                state.check = crc32(state.check, input, copy, next);
              }
              have -= copy;
              next += copy;
              if (len) {
                break inf_leave;
              }
            } else if (state.head) {
              state.head.comment = null;
            }
            state.mode = HCRC;
            /* falls through */
          case HCRC:
            if (state.flags & 0x0200) {
              //=== NEEDBITS(16); */
              while (bits < 16) {
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              //===//
              if (hold !== (state.check & 0xffff)) {
                strm.msg = 'header crc mismatch';
                state.mode = BAD;
                break;
              }
              //=== INITBITS();
              hold = 0;
              bits = 0;
              //===//
            }
            if (state.head) {
              state.head.hcrc = ((state.flags >> 9) & 1);
              state.head.done = true;
            }
            strm.adler = state.check = 0;
            state.mode = TYPE;
            break;
          case DICTID:
            //=== NEEDBITS(32); */
            while (bits < 32) {
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            strm.adler = state.check = zswap32(hold);
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            state.mode = DICT;
            /* falls through */
          case DICT:
            if (state.havedict === 0) {
              //--- RESTORE() ---
              strm.next_out = put;
              strm.avail_out = left;
              strm.next_in = next;
              strm.avail_in = have;
              state.hold = hold;
              state.bits = bits;
              //---
              return Z_NEED_DICT$1;
            }
            strm.adler = state.check = 1 /*adler32(0L, Z_NULL, 0)*/ ;
            state.mode = TYPE;
            /* falls through */
          case TYPE:
            if (flush === Z_BLOCK$1 || flush === Z_TREES$1) {
              break inf_leave;
            }
            /* falls through */
          case TYPEDO:
            if (state.last) {
              //--- BYTEBITS() ---//
              hold >>>= bits & 7;
              bits -= bits & 7;
              //---//
              state.mode = CHECK;
              break;
            }
            //=== NEEDBITS(3); */
            while (bits < 3) {
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            state.last = (hold & 0x01) /*BITS(1)*/ ;
            //--- DROPBITS(1) ---//
            hold >>>= 1;
            bits -= 1;
            //---//

            switch ((hold & 0x03) /*BITS(2)*/ ) {
            case 0:
              /* stored block */
              //Tracev((stderr, "inflate:     stored block%s\n",
              //        state.last ? " (last)" : ""));
              state.mode = STORED;
              break;
            case 1:
              /* fixed block */
              fixedtables(state);
              //Tracev((stderr, "inflate:     fixed codes block%s\n",
              //        state.last ? " (last)" : ""));
              state.mode = LEN_; /* decode codes */
              if (flush === Z_TREES$1) {
                //--- DROPBITS(2) ---//
                hold >>>= 2;
                bits -= 2;
                //---//
                break inf_leave;
              }
              break;
            case 2:
              /* dynamic block */
              //Tracev((stderr, "inflate:     dynamic codes block%s\n",
              //        state.last ? " (last)" : ""));
              state.mode = TABLE;
              break;
            case 3:
              strm.msg = 'invalid block type';
              state.mode = BAD;
            }
            //--- DROPBITS(2) ---//
            hold >>>= 2;
            bits -= 2;
            //---//
            break;
          case STORED:
            //--- BYTEBITS() ---// /* go to byte boundary */
            hold >>>= bits & 7;
            bits -= bits & 7;
            //---//
            //=== NEEDBITS(32); */
            while (bits < 32) {
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            if ((hold & 0xffff) !== ((hold >>> 16) ^ 0xffff)) {
              strm.msg = 'invalid stored block lengths';
              state.mode = BAD;
              break;
            }
            state.length = hold & 0xffff;
            //Tracev((stderr, "inflate:       stored length %u\n",
            //        state.length));
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            state.mode = COPY_;
            if (flush === Z_TREES$1) {
              break inf_leave;
            }
            /* falls through */
          case COPY_:
            state.mode = COPY;
            /* falls through */
          case COPY:
            copy = state.length;
            if (copy) {
              if (copy > have) {
                copy = have;
              }
              if (copy > left) {
                copy = left;
              }
              if (copy === 0) {
                break inf_leave;
              }
              //--- zmemcpy(put, next, copy); ---
              arraySet(output, input, next, copy, put);
              //---//
              have -= copy;
              next += copy;
              left -= copy;
              put += copy;
              state.length -= copy;
              break;
            }
            //Tracev((stderr, "inflate:       stored end\n"));
            state.mode = TYPE;
            break;
          case TABLE:
            //=== NEEDBITS(14); */
            while (bits < 14) {
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            state.nlen = (hold & 0x1f) /*BITS(5)*/ + 257;
            //--- DROPBITS(5) ---//
            hold >>>= 5;
            bits -= 5;
            //---//
            state.ndist = (hold & 0x1f) /*BITS(5)*/ + 1;
            //--- DROPBITS(5) ---//
            hold >>>= 5;
            bits -= 5;
            //---//
            state.ncode = (hold & 0x0f) /*BITS(4)*/ + 4;
            //--- DROPBITS(4) ---//
            hold >>>= 4;
            bits -= 4;
            //---//
            //#ifndef PKZIP_BUG_WORKAROUND
            if (state.nlen > 286 || state.ndist > 30) {
              strm.msg = 'too many length or distance symbols';
              state.mode = BAD;
              break;
            }
            //#endif
            //Tracev((stderr, "inflate:       table sizes ok\n"));
            state.have = 0;
            state.mode = LENLENS;
            /* falls through */
          case LENLENS:
            while (state.have < state.ncode) {
              //=== NEEDBITS(3);
              while (bits < 3) {
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              //===//
              state.lens[order[state.have++]] = (hold & 0x07); //BITS(3);
              //--- DROPBITS(3) ---//
              hold >>>= 3;
              bits -= 3;
              //---//
            }
            while (state.have < 19) {
              state.lens[order[state.have++]] = 0;
            }
            // We have separate tables & no pointers. 2 commented lines below not needed.
            //state.next = state.codes;
            //state.lencode = state.next;
            // Switch to use dynamic table
            state.lencode = state.lendyn;
            state.lenbits = 7;

            opts = {
              bits: state.lenbits
            };
            ret = inflate_table(CODES, state.lens, 0, 19, state.lencode, 0, state.work, opts);
            state.lenbits = opts.bits;

            if (ret) {
              strm.msg = 'invalid code lengths set';
              state.mode = BAD;
              break;
            }
            //Tracev((stderr, "inflate:       code lengths ok\n"));
            state.have = 0;
            state.mode = CODELENS;
            /* falls through */
          case CODELENS:
            while (state.have < state.nlen + state.ndist) {
              for (;;) {
                here = state.lencode[hold & ((1 << state.lenbits) - 1)]; /*BITS(state.lenbits)*/
                here_bits = here >>> 24;
                here_op = (here >>> 16) & 0xff;
                here_val = here & 0xffff;

                if ((here_bits) <= bits) {
                  break;
                }
                //--- PULLBYTE() ---//
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
                //---//
              }
              if (here_val < 16) {
                //--- DROPBITS(here.bits) ---//
                hold >>>= here_bits;
                bits -= here_bits;
                //---//
                state.lens[state.have++] = here_val;
              } else {
                if (here_val === 16) {
                  //=== NEEDBITS(here.bits + 2);
                  n = here_bits + 2;
                  while (bits < n) {
                    if (have === 0) {
                      break inf_leave;
                    }
                    have--;
                    hold += input[next++] << bits;
                    bits += 8;
                  }
                  //===//
                  //--- DROPBITS(here.bits) ---//
                  hold >>>= here_bits;
                  bits -= here_bits;
                  //---//
                  if (state.have === 0) {
                    strm.msg = 'invalid bit length repeat';
                    state.mode = BAD;
                    break;
                  }
                  len = state.lens[state.have - 1];
                  copy = 3 + (hold & 0x03); //BITS(2);
                  //--- DROPBITS(2) ---//
                  hold >>>= 2;
                  bits -= 2;
                  //---//
                } else if (here_val === 17) {
                  //=== NEEDBITS(here.bits + 3);
                  n = here_bits + 3;
                  while (bits < n) {
                    if (have === 0) {
                      break inf_leave;
                    }
                    have--;
                    hold += input[next++] << bits;
                    bits += 8;
                  }
                  //===//
                  //--- DROPBITS(here.bits) ---//
                  hold >>>= here_bits;
                  bits -= here_bits;
                  //---//
                  len = 0;
                  copy = 3 + (hold & 0x07); //BITS(3);
                  //--- DROPBITS(3) ---//
                  hold >>>= 3;
                  bits -= 3;
                  //---//
                } else {
                  //=== NEEDBITS(here.bits + 7);
                  n = here_bits + 7;
                  while (bits < n) {
                    if (have === 0) {
                      break inf_leave;
                    }
                    have--;
                    hold += input[next++] << bits;
                    bits += 8;
                  }
                  //===//
                  //--- DROPBITS(here.bits) ---//
                  hold >>>= here_bits;
                  bits -= here_bits;
                  //---//
                  len = 0;
                  copy = 11 + (hold & 0x7f); //BITS(7);
                  //--- DROPBITS(7) ---//
                  hold >>>= 7;
                  bits -= 7;
                  //---//
                }
                if (state.have + copy > state.nlen + state.ndist) {
                  strm.msg = 'invalid bit length repeat';
                  state.mode = BAD;
                  break;
                }
                while (copy--) {
                  state.lens[state.have++] = len;
                }
              }
            }

            /* handle error breaks in while */
            if (state.mode === BAD) {
              break;
            }

            /* check for end-of-block code (better have one) */
            if (state.lens[256] === 0) {
              strm.msg = 'invalid code -- missing end-of-block';
              state.mode = BAD;
              break;
            }

            /* build code tables -- note: do not change the lenbits or distbits
               values here (9 and 6) without reading the comments in inftrees.h
               concerning the ENOUGH constants, which depend on those values */
            state.lenbits = 9;

            opts = {
              bits: state.lenbits
            };
            ret = inflate_table(LENS, state.lens, 0, state.nlen, state.lencode, 0, state.work, opts);
            // We have separate tables & no pointers. 2 commented lines below not needed.
            // state.next_index = opts.table_index;
            state.lenbits = opts.bits;
            // state.lencode = state.next;

            if (ret) {
              strm.msg = 'invalid literal/lengths set';
              state.mode = BAD;
              break;
            }

            state.distbits = 6;
            //state.distcode.copy(state.codes);
            // Switch to use dynamic table
            state.distcode = state.distdyn;
            opts = {
              bits: state.distbits
            };
            ret = inflate_table(DISTS, state.lens, state.nlen, state.ndist, state.distcode, 0, state.work, opts);
            // We have separate tables & no pointers. 2 commented lines below not needed.
            // state.next_index = opts.table_index;
            state.distbits = opts.bits;
            // state.distcode = state.next;

            if (ret) {
              strm.msg = 'invalid distances set';
              state.mode = BAD;
              break;
            }
            //Tracev((stderr, 'inflate:       codes ok\n'));
            state.mode = LEN_;
            if (flush === Z_TREES$1) {
              break inf_leave;
            }
            /* falls through */
          case LEN_:
            state.mode = LEN;
            /* falls through */
          case LEN:
            if (have >= 6 && left >= 258) {
              //--- RESTORE() ---
              strm.next_out = put;
              strm.avail_out = left;
              strm.next_in = next;
              strm.avail_in = have;
              state.hold = hold;
              state.bits = bits;
              //---
              inflate_fast(strm, _out);
              //--- LOAD() ---
              put = strm.next_out;
              output = strm.output;
              left = strm.avail_out;
              next = strm.next_in;
              input = strm.input;
              have = strm.avail_in;
              hold = state.hold;
              bits = state.bits;
              //---

              if (state.mode === TYPE) {
                state.back = -1;
              }
              break;
            }
            state.back = 0;
            for (;;) {
              here = state.lencode[hold & ((1 << state.lenbits) - 1)]; /*BITS(state.lenbits)*/
              here_bits = here >>> 24;
              here_op = (here >>> 16) & 0xff;
              here_val = here & 0xffff;

              if (here_bits <= bits) {
                break;
              }
              //--- PULLBYTE() ---//
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
              //---//
            }
            if (here_op && (here_op & 0xf0) === 0) {
              last_bits = here_bits;
              last_op = here_op;
              last_val = here_val;
              for (;;) {
                here = state.lencode[last_val +
                  ((hold & ((1 << (last_bits + last_op)) - 1)) /*BITS(last.bits + last.op)*/ >> last_bits)];
                here_bits = here >>> 24;
                here_op = (here >>> 16) & 0xff;
                here_val = here & 0xffff;

                if ((last_bits + here_bits) <= bits) {
                  break;
                }
                //--- PULLBYTE() ---//
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
                //---//
              }
              //--- DROPBITS(last.bits) ---//
              hold >>>= last_bits;
              bits -= last_bits;
              //---//
              state.back += last_bits;
            }
            //--- DROPBITS(here.bits) ---//
            hold >>>= here_bits;
            bits -= here_bits;
            //---//
            state.back += here_bits;
            state.length = here_val;
            if (here_op === 0) {
              //Tracevv((stderr, here.val >= 0x20 && here.val < 0x7f ?
              //        "inflate:         literal '%c'\n" :
              //        "inflate:         literal 0x%02x\n", here.val));
              state.mode = LIT;
              break;
            }
            if (here_op & 32) {
              //Tracevv((stderr, "inflate:         end of block\n"));
              state.back = -1;
              state.mode = TYPE;
              break;
            }
            if (here_op & 64) {
              strm.msg = 'invalid literal/length code';
              state.mode = BAD;
              break;
            }
            state.extra = here_op & 15;
            state.mode = LENEXT;
            /* falls through */
          case LENEXT:
            if (state.extra) {
              //=== NEEDBITS(state.extra);
              n = state.extra;
              while (bits < n) {
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              //===//
              state.length += hold & ((1 << state.extra) - 1) /*BITS(state.extra)*/ ;
              //--- DROPBITS(state.extra) ---//
              hold >>>= state.extra;
              bits -= state.extra;
              //---//
              state.back += state.extra;
            }
            //Tracevv((stderr, "inflate:         length %u\n", state.length));
            state.was = state.length;
            state.mode = DIST;
            /* falls through */
          case DIST:
            for (;;) {
              here = state.distcode[hold & ((1 << state.distbits) - 1)]; /*BITS(state.distbits)*/
              here_bits = here >>> 24;
              here_op = (here >>> 16) & 0xff;
              here_val = here & 0xffff;

              if ((here_bits) <= bits) {
                break;
              }
              //--- PULLBYTE() ---//
              if (have === 0) {
                break inf_leave;
              }
              have--;
              hold += input[next++] << bits;
              bits += 8;
              //---//
            }
            if ((here_op & 0xf0) === 0) {
              last_bits = here_bits;
              last_op = here_op;
              last_val = here_val;
              for (;;) {
                here = state.distcode[last_val +
                  ((hold & ((1 << (last_bits + last_op)) - 1)) /*BITS(last.bits + last.op)*/ >> last_bits)];
                here_bits = here >>> 24;
                here_op = (here >>> 16) & 0xff;
                here_val = here & 0xffff;

                if ((last_bits + here_bits) <= bits) {
                  break;
                }
                //--- PULLBYTE() ---//
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
                //---//
              }
              //--- DROPBITS(last.bits) ---//
              hold >>>= last_bits;
              bits -= last_bits;
              //---//
              state.back += last_bits;
            }
            //--- DROPBITS(here.bits) ---//
            hold >>>= here_bits;
            bits -= here_bits;
            //---//
            state.back += here_bits;
            if (here_op & 64) {
              strm.msg = 'invalid distance code';
              state.mode = BAD;
              break;
            }
            state.offset = here_val;
            state.extra = (here_op) & 15;
            state.mode = DISTEXT;
            /* falls through */
          case DISTEXT:
            if (state.extra) {
              //=== NEEDBITS(state.extra);
              n = state.extra;
              while (bits < n) {
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              //===//
              state.offset += hold & ((1 << state.extra) - 1) /*BITS(state.extra)*/ ;
              //--- DROPBITS(state.extra) ---//
              hold >>>= state.extra;
              bits -= state.extra;
              //---//
              state.back += state.extra;
            }
            //#ifdef INFLATE_STRICT
            if (state.offset > state.dmax) {
              strm.msg = 'invalid distance too far back';
              state.mode = BAD;
              break;
            }
            //#endif
            //Tracevv((stderr, "inflate:         distance %u\n", state.offset));
            state.mode = MATCH;
            /* falls through */
          case MATCH:
            if (left === 0) {
              break inf_leave;
            }
            copy = _out - left;
            if (state.offset > copy) { /* copy from window */
              copy = state.offset - copy;
              if (copy > state.whave) {
                if (state.sane) {
                  strm.msg = 'invalid distance too far back';
                  state.mode = BAD;
                  break;
                }
                // (!) This block is disabled in zlib defailts,
                // don't enable it for binary compatibility
                //#ifdef INFLATE_ALLOW_INVALID_DISTANCE_TOOFAR_ARRR
                //          Trace((stderr, "inflate.c too far\n"));
                //          copy -= state.whave;
                //          if (copy > state.length) { copy = state.length; }
                //          if (copy > left) { copy = left; }
                //          left -= copy;
                //          state.length -= copy;
                //          do {
                //            output[put++] = 0;
                //          } while (--copy);
                //          if (state.length === 0) { state.mode = LEN; }
                //          break;
                //#endif
              }
              if (copy > state.wnext) {
                copy -= state.wnext;
                from = state.wsize - copy;
              } else {
                from = state.wnext - copy;
              }
              if (copy > state.length) {
                copy = state.length;
              }
              from_source = state.window;
            } else { /* copy from output */
              from_source = output;
              from = put - state.offset;
              copy = state.length;
            }
            if (copy > left) {
              copy = left;
            }
            left -= copy;
            state.length -= copy;
            do {
              output[put++] = from_source[from++];
            } while (--copy);
            if (state.length === 0) {
              state.mode = LEN;
            }
            break;
          case LIT:
            if (left === 0) {
              break inf_leave;
            }
            output[put++] = state.length;
            left--;
            state.mode = LEN;
            break;
          case CHECK:
            if (state.wrap) {
              //=== NEEDBITS(32);
              while (bits < 32) {
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                // Use '|' insdead of '+' to make sure that result is signed
                hold |= input[next++] << bits;
                bits += 8;
              }
              //===//
              _out -= left;
              strm.total_out += _out;
              state.total += _out;
              if (_out) {
                strm.adler = state.check =
                  /*UPDATE(state.check, put - _out, _out);*/
                  (state.flags ? crc32(state.check, output, _out, put - _out) : adler32(state.check, output, _out, put - _out));

              }
              _out = left;
              // NB: crc32 stored as signed 32-bit int, zswap32 returns signed too
              if ((state.flags ? hold : zswap32(hold)) !== state.check) {
                strm.msg = 'incorrect data check';
                state.mode = BAD;
                break;
              }
              //=== INITBITS();
              hold = 0;
              bits = 0;
              //===//
              //Tracev((stderr, "inflate:   check matches trailer\n"));
            }
            state.mode = LENGTH;
            /* falls through */
          case LENGTH:
            if (state.wrap && state.flags) {
              //=== NEEDBITS(32);
              while (bits < 32) {
                if (have === 0) {
                  break inf_leave;
                }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              //===//
              if (hold !== (state.total & 0xffffffff)) {
                strm.msg = 'incorrect length check';
                state.mode = BAD;
                break;
              }
              //=== INITBITS();
              hold = 0;
              bits = 0;
              //===//
              //Tracev((stderr, "inflate:   length matches trailer\n"));
            }
            state.mode = DONE;
            /* falls through */
          case DONE:
            ret = Z_STREAM_END$1;
            break inf_leave;
          case BAD:
            ret = Z_DATA_ERROR$1;
            break inf_leave;
          case MEM:
            return Z_MEM_ERROR;
          case SYNC:
            /* falls through */
          default:
            return Z_STREAM_ERROR$1;
          }
        }

      // inf_leave <- here is real place for "goto inf_leave", emulated via "break inf_leave"

      /*
         Return from inflate(), updating the total counts and the check value.
         If there was no progress during the inflate() call, return a buffer
         error.  Call updatewindow() to create and/or update the window state.
         Note: a memory error from inflate() is non-recoverable.
       */

      //--- RESTORE() ---
      strm.next_out = put;
      strm.avail_out = left;
      strm.next_in = next;
      strm.avail_in = have;
      state.hold = hold;
      state.bits = bits;
      //---

      if (state.wsize || (_out !== strm.avail_out && state.mode < BAD &&
          (state.mode < CHECK || flush !== Z_FINISH$1))) {
        if (updatewindow(strm, strm.output, strm.next_out, _out - strm.avail_out)) ;
      }
      _in -= strm.avail_in;
      _out -= strm.avail_out;
      strm.total_in += _in;
      strm.total_out += _out;
      state.total += _out;
      if (state.wrap && _out) {
        strm.adler = state.check = /*UPDATE(state.check, strm.next_out - _out, _out);*/
          (state.flags ? crc32(state.check, output, _out, strm.next_out - _out) : adler32(state.check, output, _out, strm.next_out - _out));
      }
      strm.data_type = state.bits + (state.last ? 64 : 0) +
        (state.mode === TYPE ? 128 : 0) +
        (state.mode === LEN_ || state.mode === COPY_ ? 256 : 0);
      if (((_in === 0 && _out === 0) || flush === Z_FINISH$1) && ret === Z_OK$1) {
        ret = Z_BUF_ERROR$1;
      }
      return ret;
    }

    function inflateEnd(strm) {

      if (!strm || !strm.state /*|| strm->zfree == (free_func)0*/ ) {
        return Z_STREAM_ERROR$1;
      }

      var state = strm.state;
      if (state.window) {
        state.window = null;
      }
      strm.state = null;
      return Z_OK$1;
    }

    /* Not implemented
    exports.inflateCopy = inflateCopy;
    exports.inflateGetDictionary = inflateGetDictionary;
    exports.inflateMark = inflateMark;
    exports.inflatePrime = inflatePrime;
    exports.inflateSync = inflateSync;
    exports.inflateSyncPoint = inflateSyncPoint;
    exports.inflateUndermine = inflateUndermine;
    */

    // import constants from './constants';


    // zlib modes
    var NONE = 0;
    var DEFLATE = 1;
    var INFLATE = 2;
    var GZIP = 3;
    var GUNZIP = 4;
    var DEFLATERAW = 5;
    var INFLATERAW = 6;
    var UNZIP = 7;
    var Z_NO_FLUSH=         0,
      Z_PARTIAL_FLUSH=    1,
      Z_SYNC_FLUSH=    2,
      Z_FULL_FLUSH=       3,
      Z_FINISH=       4,
      Z_BLOCK=           5,
      Z_TREES=            6,

      /* Return codes for the compression/decompression functions. Negative values
      * are errors, positive values are used for special but normal events.
      */
      Z_OK=               0,
      Z_STREAM_END=       1,
      Z_NEED_DICT=      2,
      Z_ERRNO=       -1,
      Z_STREAM_ERROR=   -2,
      Z_DATA_ERROR=    -3,
      //Z_MEM_ERROR:     -4,
      Z_BUF_ERROR=    -5,
      //Z_VERSION_ERROR: -6,

      /* compression levels */
      Z_NO_COMPRESSION=         0,
      Z_BEST_SPEED=             1,
      Z_BEST_COMPRESSION=       9,
      Z_DEFAULT_COMPRESSION=   -1,


      Z_FILTERED=               1,
      Z_HUFFMAN_ONLY=           2,
      Z_RLE=                    3,
      Z_FIXED=                  4,
      Z_DEFAULT_STRATEGY=       0,

      /* Possible values of the data_type field (though see inflate()) */
      Z_BINARY=                 0,
      Z_TEXT=                   1,
      //Z_ASCII:                1, // = Z_TEXT (deprecated)
      Z_UNKNOWN=                2,

      /* The deflate compression method */
      Z_DEFLATED=               8;
    function Zlib$1(mode) {
      if (mode < DEFLATE || mode > UNZIP)
        throw new TypeError('Bad argument');

      this.mode = mode;
      this.init_done = false;
      this.write_in_progress = false;
      this.pending_close = false;
      this.windowBits = 0;
      this.level = 0;
      this.memLevel = 0;
      this.strategy = 0;
      this.dictionary = null;
    }

    Zlib$1.prototype.init = function(windowBits, level, memLevel, strategy, dictionary) {
      this.windowBits = windowBits;
      this.level = level;
      this.memLevel = memLevel;
      this.strategy = strategy;
      // dictionary not supported.

      if (this.mode === GZIP || this.mode === GUNZIP)
        this.windowBits += 16;

      if (this.mode === UNZIP)
        this.windowBits += 32;

      if (this.mode === DEFLATERAW || this.mode === INFLATERAW)
        this.windowBits = -this.windowBits;

      this.strm = new ZStream();
      var status;
      switch (this.mode) {
      case DEFLATE:
      case GZIP:
      case DEFLATERAW:
        status = deflateInit2(
          this.strm,
          this.level,
          Z_DEFLATED,
          this.windowBits,
          this.memLevel,
          this.strategy
        );
        break;
      case INFLATE:
      case GUNZIP:
      case INFLATERAW:
      case UNZIP:
        status  = inflateInit2(
          this.strm,
          this.windowBits
        );
        break;
      default:
        throw new Error('Unknown mode ' + this.mode);
      }

      if (status !== Z_OK) {
        this._error(status);
        return;
      }

      this.write_in_progress = false;
      this.init_done = true;
    };

    Zlib$1.prototype.params = function() {
      throw new Error('deflateParams Not supported');
    };

    Zlib$1.prototype._writeCheck = function() {
      if (!this.init_done)
        throw new Error('write before init');

      if (this.mode === NONE)
        throw new Error('already finalized');

      if (this.write_in_progress)
        throw new Error('write already in progress');

      if (this.pending_close)
        throw new Error('close is pending');
    };

    Zlib$1.prototype.write = function(flush, input, in_off, in_len, out, out_off, out_len) {
      this._writeCheck();
      this.write_in_progress = true;

      var self = this;
      browser$1$1.nextTick(function() {
        self.write_in_progress = false;
        var res = self._write(flush, input, in_off, in_len, out, out_off, out_len);
        self.callback(res[0], res[1]);

        if (self.pending_close)
          self.close();
      });

      return this;
    };

    // set method for Node buffers, used by pako
    function bufferSet(data, offset) {
      for (var i = 0; i < data.length; i++) {
        this[offset + i] = data[i];
      }
    }

    Zlib$1.prototype.writeSync = function(flush, input, in_off, in_len, out, out_off, out_len) {
      this._writeCheck();
      return this._write(flush, input, in_off, in_len, out, out_off, out_len);
    };

    Zlib$1.prototype._write = function(flush, input, in_off, in_len, out, out_off, out_len) {
      this.write_in_progress = true;

      if (flush !== Z_NO_FLUSH &&
          flush !== Z_PARTIAL_FLUSH &&
          flush !== Z_SYNC_FLUSH &&
          flush !== Z_FULL_FLUSH &&
          flush !== Z_FINISH &&
          flush !== Z_BLOCK) {
        throw new Error('Invalid flush value');
      }

      if (input == null) {
        input = new Buffer$3(0);
        in_len = 0;
        in_off = 0;
      }

      if (out._set)
        out.set = out._set;
      else
        out.set = bufferSet;

      var strm = this.strm;
      strm.avail_in = in_len;
      strm.input = input;
      strm.next_in = in_off;
      strm.avail_out = out_len;
      strm.output = out;
      strm.next_out = out_off;
      var status;
      switch (this.mode) {
      case DEFLATE:
      case GZIP:
      case DEFLATERAW:
        status = deflate$1(strm, flush);
        break;
      case UNZIP:
      case INFLATE:
      case GUNZIP:
      case INFLATERAW:
        status = inflate$1(strm, flush);
        break;
      default:
        throw new Error('Unknown mode ' + this.mode);
      }

      if (status !== Z_STREAM_END && status !== Z_OK) {
        this._error(status);
      }

      this.write_in_progress = false;
      return [strm.avail_in, strm.avail_out];
    };

    Zlib$1.prototype.close = function() {
      if (this.write_in_progress) {
        this.pending_close = true;
        return;
      }

      this.pending_close = false;

      if (this.mode === DEFLATE || this.mode === GZIP || this.mode === DEFLATERAW) {
        deflateEnd(this.strm);
      } else {
        inflateEnd(this.strm);
      }

      this.mode = NONE;
    };
    var status;
    Zlib$1.prototype.reset = function() {
      switch (this.mode) {
      case DEFLATE:
      case DEFLATERAW:
        status = deflateReset(this.strm);
        break;
      case INFLATE:
      case INFLATERAW:
        status = inflateReset(this.strm);
        break;
      }

      if (status !== Z_OK) {
        this._error(status);
      }
    };

    Zlib$1.prototype._error = function(status) {
      this.onerror(msg[status] + ': ' + this.strm.msg, status);

      this.write_in_progress = false;
      if (this.pending_close)
        this.close();
    };

    var _binding = /*#__PURE__*/Object.freeze({
        __proto__: null,
        NONE: NONE,
        DEFLATE: DEFLATE,
        INFLATE: INFLATE,
        GZIP: GZIP,
        GUNZIP: GUNZIP,
        DEFLATERAW: DEFLATERAW,
        INFLATERAW: INFLATERAW,
        UNZIP: UNZIP,
        Z_NO_FLUSH: Z_NO_FLUSH,
        Z_PARTIAL_FLUSH: Z_PARTIAL_FLUSH,
        Z_SYNC_FLUSH: Z_SYNC_FLUSH,
        Z_FULL_FLUSH: Z_FULL_FLUSH,
        Z_FINISH: Z_FINISH,
        Z_BLOCK: Z_BLOCK,
        Z_TREES: Z_TREES,
        Z_OK: Z_OK,
        Z_STREAM_END: Z_STREAM_END,
        Z_NEED_DICT: Z_NEED_DICT,
        Z_ERRNO: Z_ERRNO,
        Z_STREAM_ERROR: Z_STREAM_ERROR,
        Z_DATA_ERROR: Z_DATA_ERROR,
        Z_BUF_ERROR: Z_BUF_ERROR,
        Z_NO_COMPRESSION: Z_NO_COMPRESSION,
        Z_BEST_SPEED: Z_BEST_SPEED,
        Z_BEST_COMPRESSION: Z_BEST_COMPRESSION,
        Z_DEFAULT_COMPRESSION: Z_DEFAULT_COMPRESSION,
        Z_FILTERED: Z_FILTERED,
        Z_HUFFMAN_ONLY: Z_HUFFMAN_ONLY,
        Z_RLE: Z_RLE,
        Z_FIXED: Z_FIXED,
        Z_DEFAULT_STRATEGY: Z_DEFAULT_STRATEGY,
        Z_BINARY: Z_BINARY,
        Z_TEXT: Z_TEXT,
        Z_UNKNOWN: Z_UNKNOWN,
        Z_DEFLATED: Z_DEFLATED,
        Zlib: Zlib$1
    });

    function assert (a, msg) {
      if (!a) {
        throw new Error(msg);
      }
    }
    var binding = {};
    Object.keys(_binding).forEach(function (key) {
      binding[key] = _binding[key];
    });
    // zlib doesn't provide these, so kludge them in following the same
    // const naming scheme zlib uses.
    binding.Z_MIN_WINDOWBITS = 8;
    binding.Z_MAX_WINDOWBITS = 15;
    binding.Z_DEFAULT_WINDOWBITS = 15;

    // fewer than 64 bytes per chunk is stupid.
    // technically it could work with as few as 8, but even 64 bytes
    // is absurdly low.  Usually a MB or more is best.
    binding.Z_MIN_CHUNK = 64;
    binding.Z_MAX_CHUNK = Infinity;
    binding.Z_DEFAULT_CHUNK = (16 * 1024);

    binding.Z_MIN_MEMLEVEL = 1;
    binding.Z_MAX_MEMLEVEL = 9;
    binding.Z_DEFAULT_MEMLEVEL = 8;

    binding.Z_MIN_LEVEL = -1;
    binding.Z_MAX_LEVEL = 9;
    binding.Z_DEFAULT_LEVEL = binding.Z_DEFAULT_COMPRESSION;


    // translation table for return codes.
    var codes = {
      Z_OK: binding.Z_OK,
      Z_STREAM_END: binding.Z_STREAM_END,
      Z_NEED_DICT: binding.Z_NEED_DICT,
      Z_ERRNO: binding.Z_ERRNO,
      Z_STREAM_ERROR: binding.Z_STREAM_ERROR,
      Z_DATA_ERROR: binding.Z_DATA_ERROR,
      Z_MEM_ERROR: binding.Z_MEM_ERROR,
      Z_BUF_ERROR: binding.Z_BUF_ERROR,
      Z_VERSION_ERROR: binding.Z_VERSION_ERROR
    };

    Object.keys(codes).forEach(function(k) {
      codes[codes[k]] = k;
    });

    function createDeflate(o) {
      return new Deflate(o);
    }

    function createInflate(o) {
      return new Inflate(o);
    }

    function createDeflateRaw(o) {
      return new DeflateRaw(o);
    }

    function createInflateRaw(o) {
      return new InflateRaw(o);
    }

    function createGzip(o) {
      return new Gzip(o);
    }

    function createGunzip(o) {
      return new Gunzip(o);
    }

    function createUnzip(o) {
      return new Unzip(o);
    }


    // Convenience methods.
    // compress/decompress a string or buffer in one step.
    function deflate(buffer, opts, callback) {
      if (typeof opts === 'function') {
        callback = opts;
        opts = {};
      }
      return zlibBuffer(new Deflate(opts), buffer, callback);
    }

    function deflateSync(buffer, opts) {
      return zlibBufferSync(new Deflate(opts), buffer);
    }

    function gzip(buffer, opts, callback) {
      if (typeof opts === 'function') {
        callback = opts;
        opts = {};
      }
      return zlibBuffer(new Gzip(opts), buffer, callback);
    }

    function gzipSync(buffer, opts) {
      return zlibBufferSync(new Gzip(opts), buffer);
    }

    function deflateRaw(buffer, opts, callback) {
      if (typeof opts === 'function') {
        callback = opts;
        opts = {};
      }
      return zlibBuffer(new DeflateRaw(opts), buffer, callback);
    }

    function deflateRawSync(buffer, opts) {
      return zlibBufferSync(new DeflateRaw(opts), buffer);
    }

    function unzip(buffer, opts, callback) {
      if (typeof opts === 'function') {
        callback = opts;
        opts = {};
      }
      return zlibBuffer(new Unzip(opts), buffer, callback);
    }

    function unzipSync(buffer, opts) {
      return zlibBufferSync(new Unzip(opts), buffer);
    }

    function inflate(buffer, opts, callback) {
      if (typeof opts === 'function') {
        callback = opts;
        opts = {};
      }
      return zlibBuffer(new Inflate(opts), buffer, callback);
    }

    function inflateSync(buffer, opts) {
      return zlibBufferSync(new Inflate(opts), buffer);
    }

    function gunzip(buffer, opts, callback) {
      if (typeof opts === 'function') {
        callback = opts;
        opts = {};
      }
      return zlibBuffer(new Gunzip(opts), buffer, callback);
    }

    function gunzipSync(buffer, opts) {
      return zlibBufferSync(new Gunzip(opts), buffer);
    }

    function inflateRaw(buffer, opts, callback) {
      if (typeof opts === 'function') {
        callback = opts;
        opts = {};
      }
      return zlibBuffer(new InflateRaw(opts), buffer, callback);
    }

    function inflateRawSync(buffer, opts) {
      return zlibBufferSync(new InflateRaw(opts), buffer);
    }

    function zlibBuffer(engine, buffer, callback) {
      var buffers = [];
      var nread = 0;

      engine.on('error', onError);
      engine.on('end', onEnd);

      engine.end(buffer);
      flow();

      function flow() {
        var chunk;
        while (null !== (chunk = engine.read())) {
          buffers.push(chunk);
          nread += chunk.length;
        }
        engine.once('readable', flow);
      }

      function onError(err) {
        engine.removeListener('end', onEnd);
        engine.removeListener('readable', flow);
        callback(err);
      }

      function onEnd() {
        var buf = Buffer$3.concat(buffers, nread);
        buffers = [];
        callback(null, buf);
        engine.close();
      }
    }

    function zlibBufferSync(engine, buffer) {
      if (typeof buffer === 'string')
        buffer = new Buffer$3(buffer);
      if (!Buffer$3.isBuffer(buffer))
        throw new TypeError('Not a string or buffer');

      var flushFlag = binding.Z_FINISH;

      return engine._processChunk(buffer, flushFlag);
    }

    // generic zlib
    // minimal 2-byte header
    function Deflate(opts) {
      if (!(this instanceof Deflate)) return new Deflate(opts);
      Zlib.call(this, opts, binding.DEFLATE);
    }

    function Inflate(opts) {
      if (!(this instanceof Inflate)) return new Inflate(opts);
      Zlib.call(this, opts, binding.INFLATE);
    }



    // gzip - bigger header, same deflate compression
    function Gzip(opts) {
      if (!(this instanceof Gzip)) return new Gzip(opts);
      Zlib.call(this, opts, binding.GZIP);
    }

    function Gunzip(opts) {
      if (!(this instanceof Gunzip)) return new Gunzip(opts);
      Zlib.call(this, opts, binding.GUNZIP);
    }



    // raw - no header
    function DeflateRaw(opts) {
      if (!(this instanceof DeflateRaw)) return new DeflateRaw(opts);
      Zlib.call(this, opts, binding.DEFLATERAW);
    }

    function InflateRaw(opts) {
      if (!(this instanceof InflateRaw)) return new InflateRaw(opts);
      Zlib.call(this, opts, binding.INFLATERAW);
    }


    // auto-detect header.
    function Unzip(opts) {
      if (!(this instanceof Unzip)) return new Unzip(opts);
      Zlib.call(this, opts, binding.UNZIP);
    }


    // the Zlib class they all inherit from
    // This thing manages the queue of requests, and returns
    // true or false if there is anything in the queue when
    // you call the .write() method.

    function Zlib(opts, mode) {
      this._opts = opts = opts || {};
      this._chunkSize = opts.chunkSize || binding.Z_DEFAULT_CHUNK;

      Transform.call(this, opts);

      if (opts.flush) {
        if (opts.flush !== binding.Z_NO_FLUSH &&
            opts.flush !== binding.Z_PARTIAL_FLUSH &&
            opts.flush !== binding.Z_SYNC_FLUSH &&
            opts.flush !== binding.Z_FULL_FLUSH &&
            opts.flush !== binding.Z_FINISH &&
            opts.flush !== binding.Z_BLOCK) {
          throw new Error('Invalid flush flag: ' + opts.flush);
        }
      }
      this._flushFlag = opts.flush || binding.Z_NO_FLUSH;

      if (opts.chunkSize) {
        if (opts.chunkSize < binding.Z_MIN_CHUNK ||
            opts.chunkSize > binding.Z_MAX_CHUNK) {
          throw new Error('Invalid chunk size: ' + opts.chunkSize);
        }
      }

      if (opts.windowBits) {
        if (opts.windowBits < binding.Z_MIN_WINDOWBITS ||
            opts.windowBits > binding.Z_MAX_WINDOWBITS) {
          throw new Error('Invalid windowBits: ' + opts.windowBits);
        }
      }

      if (opts.level) {
        if (opts.level < binding.Z_MIN_LEVEL ||
            opts.level > binding.Z_MAX_LEVEL) {
          throw new Error('Invalid compression level: ' + opts.level);
        }
      }

      if (opts.memLevel) {
        if (opts.memLevel < binding.Z_MIN_MEMLEVEL ||
            opts.memLevel > binding.Z_MAX_MEMLEVEL) {
          throw new Error('Invalid memLevel: ' + opts.memLevel);
        }
      }

      if (opts.strategy) {
        if (opts.strategy != binding.Z_FILTERED &&
            opts.strategy != binding.Z_HUFFMAN_ONLY &&
            opts.strategy != binding.Z_RLE &&
            opts.strategy != binding.Z_FIXED &&
            opts.strategy != binding.Z_DEFAULT_STRATEGY) {
          throw new Error('Invalid strategy: ' + opts.strategy);
        }
      }

      if (opts.dictionary) {
        if (!Buffer$3.isBuffer(opts.dictionary)) {
          throw new Error('Invalid dictionary: it should be a Buffer instance');
        }
      }

      this._binding = new binding.Zlib(mode);

      var self = this;
      this._hadError = false;
      this._binding.onerror = function(message, errno) {
        // there is no way to cleanly recover.
        // continuing only obscures problems.
        self._binding = null;
        self._hadError = true;

        var error = new Error(message);
        error.errno = errno;
        error.code = binding.codes[errno];
        self.emit('error', error);
      };

      var level = binding.Z_DEFAULT_COMPRESSION;
      if (typeof opts.level === 'number') level = opts.level;

      var strategy = binding.Z_DEFAULT_STRATEGY;
      if (typeof opts.strategy === 'number') strategy = opts.strategy;

      this._binding.init(opts.windowBits || binding.Z_DEFAULT_WINDOWBITS,
                         level,
                         opts.memLevel || binding.Z_DEFAULT_MEMLEVEL,
                         strategy,
                         opts.dictionary);

      this._buffer = new Buffer$3(this._chunkSize);
      this._offset = 0;
      this._closed = false;
      this._level = level;
      this._strategy = strategy;

      this.once('end', this.close);
    }

    inherits$1(Zlib, Transform);

    Zlib.prototype.params = function(level, strategy, callback) {
      if (level < binding.Z_MIN_LEVEL ||
          level > binding.Z_MAX_LEVEL) {
        throw new RangeError('Invalid compression level: ' + level);
      }
      if (strategy != binding.Z_FILTERED &&
          strategy != binding.Z_HUFFMAN_ONLY &&
          strategy != binding.Z_RLE &&
          strategy != binding.Z_FIXED &&
          strategy != binding.Z_DEFAULT_STRATEGY) {
        throw new TypeError('Invalid strategy: ' + strategy);
      }

      if (this._level !== level || this._strategy !== strategy) {
        var self = this;
        this.flush(binding.Z_SYNC_FLUSH, function() {
          self._binding.params(level, strategy);
          if (!self._hadError) {
            self._level = level;
            self._strategy = strategy;
            if (callback) callback();
          }
        });
      } else {
        browser$1$1.nextTick(callback);
      }
    };

    Zlib.prototype.reset = function() {
      return this._binding.reset();
    };

    // This is the _flush function called by the transform class,
    // internally, when the last chunk has been written.
    Zlib.prototype._flush = function(callback) {
      this._transform(new Buffer$3(0), '', callback);
    };

    Zlib.prototype.flush = function(kind, callback) {
      var ws = this._writableState;

      if (typeof kind === 'function' || (kind === void 0 && !callback)) {
        callback = kind;
        kind = binding.Z_FULL_FLUSH;
      }

      if (ws.ended) {
        if (callback)
          browser$1$1.nextTick(callback);
      } else if (ws.ending) {
        if (callback)
          this.once('end', callback);
      } else if (ws.needDrain) {
        var self = this;
        this.once('drain', function() {
          self.flush(callback);
        });
      } else {
        this._flushFlag = kind;
        this.write(new Buffer$3(0), '', callback);
      }
    };

    Zlib.prototype.close = function(callback) {
      if (callback)
        browser$1$1.nextTick(callback);

      if (this._closed)
        return;

      this._closed = true;

      this._binding.close();

      var self = this;
      browser$1$1.nextTick(function() {
        self.emit('close');
      });
    };

    Zlib.prototype._transform = function(chunk, encoding, cb) {
      var flushFlag;
      var ws = this._writableState;
      var ending = ws.ending || ws.ended;
      var last = ending && (!chunk || ws.length === chunk.length);

      if (!chunk === null && !Buffer$3.isBuffer(chunk))
        return cb(new Error('invalid input'));

      // If it's the last chunk, or a final flush, we use the Z_FINISH flush flag.
      // If it's explicitly flushing at some other time, then we use
      // Z_FULL_FLUSH. Otherwise, use Z_NO_FLUSH for maximum compression
      // goodness.
      if (last)
        flushFlag = binding.Z_FINISH;
      else {
        flushFlag = this._flushFlag;
        // once we've flushed the last of the queue, stop flushing and
        // go back to the normal behavior.
        if (chunk.length >= ws.length) {
          this._flushFlag = this._opts.flush || binding.Z_NO_FLUSH;
        }
      }

      this._processChunk(chunk, flushFlag, cb);
    };

    Zlib.prototype._processChunk = function(chunk, flushFlag, cb) {
      var availInBefore = chunk && chunk.length;
      var availOutBefore = this._chunkSize - this._offset;
      var inOff = 0;

      var self = this;

      var async = typeof cb === 'function';

      if (!async) {
        var buffers = [];
        var nread = 0;

        var error;
        this.on('error', function(er) {
          error = er;
        });

        do {
          var res = this._binding.writeSync(flushFlag,
                                            chunk, // in
                                            inOff, // in_off
                                            availInBefore, // in_len
                                            this._buffer, // out
                                            this._offset, //out_off
                                            availOutBefore); // out_len
        } while (!this._hadError && callback(res[0], res[1]));

        if (this._hadError) {
          throw error;
        }

        var buf = Buffer$3.concat(buffers, nread);
        this.close();

        return buf;
      }

      var req = this._binding.write(flushFlag,
                                    chunk, // in
                                    inOff, // in_off
                                    availInBefore, // in_len
                                    this._buffer, // out
                                    this._offset, //out_off
                                    availOutBefore); // out_len

      req.buffer = chunk;
      req.callback = callback;

      function callback(availInAfter, availOutAfter) {
        if (self._hadError)
          return;

        var have = availOutBefore - availOutAfter;
        assert(have >= 0, 'have should not go down');

        if (have > 0) {
          var out = self._buffer.slice(self._offset, self._offset + have);
          self._offset += have;
          // serve some output to the consumer.
          if (async) {
            self.push(out);
          } else {
            buffers.push(out);
            nread += out.length;
          }
        }

        // exhausted the output buffer, or used all the input create a new one.
        if (availOutAfter === 0 || self._offset >= self._chunkSize) {
          availOutBefore = self._chunkSize;
          self._offset = 0;
          self._buffer = new Buffer$3(self._chunkSize);
        }

        if (availOutAfter === 0) {
          // Not actually done.  Need to reprocess.
          // Also, update the availInBefore to the availInAfter value,
          // so that if we have to hit it a third (fourth, etc.) time,
          // it'll have the correct byte counts.
          inOff += (availInBefore - availInAfter);
          availInBefore = availInAfter;

          if (!async)
            return true;

          var newReq = self._binding.write(flushFlag,
                                           chunk,
                                           inOff,
                                           availInBefore,
                                           self._buffer,
                                           self._offset,
                                           self._chunkSize);
          newReq.callback = callback; // this same function
          newReq.buffer = chunk;
          return;
        }

        if (!async)
          return false;

        // finished with the chunk.
        cb();
      }
    };

    inherits$1(Deflate, Zlib);
    inherits$1(Inflate, Zlib);
    inherits$1(Gzip, Zlib);
    inherits$1(Gunzip, Zlib);
    inherits$1(DeflateRaw, Zlib);
    inherits$1(InflateRaw, Zlib);
    inherits$1(Unzip, Zlib);
    var zlib = {
      codes: codes,
      createDeflate: createDeflate,
      createInflate: createInflate,
      createDeflateRaw: createDeflateRaw,
      createInflateRaw: createInflateRaw,
      createGzip: createGzip,
      createGunzip: createGunzip,
      createUnzip: createUnzip,
      deflate: deflate,
      deflateSync: deflateSync,
      gzip: gzip,
      gzipSync: gzipSync,
      deflateRaw: deflateRaw,
      deflateRawSync: deflateRawSync,
      unzip: unzip,
      unzipSync: unzipSync,
      inflate: inflate,
      inflateSync: inflateSync,
      gunzip: gunzip,
      gunzipSync: gunzipSync,
      inflateRaw: inflateRaw,
      inflateRawSync: inflateRawSync,
      Deflate: Deflate,
      Inflate: Inflate,
      Gzip: Gzip,
      Gunzip: Gunzip,
      DeflateRaw: DeflateRaw,
      InflateRaw: InflateRaw,
      Unzip: Unzip,
      Zlib: Zlib
    };

    var zlib$1 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        codes: codes,
        createDeflate: createDeflate,
        createInflate: createInflate,
        createDeflateRaw: createDeflateRaw,
        createInflateRaw: createInflateRaw,
        createGzip: createGzip,
        createGunzip: createGunzip,
        createUnzip: createUnzip,
        deflate: deflate,
        deflateSync: deflateSync,
        gzip: gzip,
        gzipSync: gzipSync,
        deflateRaw: deflateRaw,
        deflateRawSync: deflateRawSync,
        unzip: unzip,
        unzipSync: unzipSync,
        inflate: inflate,
        inflateSync: inflateSync,
        gunzip: gunzip,
        gunzipSync: gunzipSync,
        inflateRaw: inflateRaw,
        inflateRawSync: inflateRawSync,
        Deflate: Deflate,
        Inflate: Inflate,
        Gzip: Gzip,
        Gunzip: Gunzip,
        DeflateRaw: DeflateRaw,
        InflateRaw: InflateRaw,
        Unzip: Unzip,
        Zlib: Zlib,
        'default': zlib
    });

    var require$$5 = /*@__PURE__*/getAugmentedNamespace(zlib$1);

    (function (module, exports) {

    	Object.defineProperty(exports, '__esModule', { value: true });

    	function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

    	var Stream = _interopDefault(require$$0$2);
    	var http = _interopDefault(require$$4);
    	var Url = _interopDefault(require$$2);
    	var whatwgUrl = _interopDefault(publicApi);
    	var https = _interopDefault(require$$4);
    	var zlib = _interopDefault(require$$5);

    	// Based on https://github.com/tmpvar/jsdom/blob/aa85b2abf07766ff7bf5c1f6daafb3726f2f2db5/lib/jsdom/living/blob.js

    	// fix for "Readable" isn't a named export issue
    	const Readable = Stream.Readable;

    	const BUFFER = Symbol('buffer');
    	const TYPE = Symbol('type');

    	class Blob {
    		constructor() {
    			this[TYPE] = '';

    			const blobParts = arguments[0];
    			const options = arguments[1];

    			const buffers = [];
    			let size = 0;

    			if (blobParts) {
    				const a = blobParts;
    				const length = Number(a.length);
    				for (let i = 0; i < length; i++) {
    					const element = a[i];
    					let buffer;
    					if (element instanceof Buffer$3) {
    						buffer = element;
    					} else if (ArrayBuffer.isView(element)) {
    						buffer = Buffer$3.from(element.buffer, element.byteOffset, element.byteLength);
    					} else if (element instanceof ArrayBuffer) {
    						buffer = Buffer$3.from(element);
    					} else if (element instanceof Blob) {
    						buffer = element[BUFFER];
    					} else {
    						buffer = Buffer$3.from(typeof element === 'string' ? element : String(element));
    					}
    					size += buffer.length;
    					buffers.push(buffer);
    				}
    			}

    			this[BUFFER] = Buffer$3.concat(buffers);

    			let type = options && options.type !== undefined && String(options.type).toLowerCase();
    			if (type && !/[^\u0020-\u007E]/.test(type)) {
    				this[TYPE] = type;
    			}
    		}
    		get size() {
    			return this[BUFFER].length;
    		}
    		get type() {
    			return this[TYPE];
    		}
    		text() {
    			return Promise.resolve(this[BUFFER].toString());
    		}
    		arrayBuffer() {
    			const buf = this[BUFFER];
    			const ab = buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength);
    			return Promise.resolve(ab);
    		}
    		stream() {
    			const readable = new Readable();
    			readable._read = function () {};
    			readable.push(this[BUFFER]);
    			readable.push(null);
    			return readable;
    		}
    		toString() {
    			return '[object Blob]';
    		}
    		slice() {
    			const size = this.size;

    			const start = arguments[0];
    			const end = arguments[1];
    			let relativeStart, relativeEnd;
    			if (start === undefined) {
    				relativeStart = 0;
    			} else if (start < 0) {
    				relativeStart = Math.max(size + start, 0);
    			} else {
    				relativeStart = Math.min(start, size);
    			}
    			if (end === undefined) {
    				relativeEnd = size;
    			} else if (end < 0) {
    				relativeEnd = Math.max(size + end, 0);
    			} else {
    				relativeEnd = Math.min(end, size);
    			}
    			const span = Math.max(relativeEnd - relativeStart, 0);

    			const buffer = this[BUFFER];
    			const slicedBuffer = buffer.slice(relativeStart, relativeStart + span);
    			const blob = new Blob([], { type: arguments[2] });
    			blob[BUFFER] = slicedBuffer;
    			return blob;
    		}
    	}

    	Object.defineProperties(Blob.prototype, {
    		size: { enumerable: true },
    		type: { enumerable: true },
    		slice: { enumerable: true }
    	});

    	Object.defineProperty(Blob.prototype, Symbol.toStringTag, {
    		value: 'Blob',
    		writable: false,
    		enumerable: false,
    		configurable: true
    	});

    	/**
    	 * fetch-error.js
    	 *
    	 * FetchError interface for operational errors
    	 */

    	/**
    	 * Create FetchError instance
    	 *
    	 * @param   String      message      Error message for human
    	 * @param   String      type         Error type for machine
    	 * @param   String      systemError  For Node.js system error
    	 * @return  FetchError
    	 */
    	function FetchError(message, type, systemError) {
    	  Error.call(this, message);

    	  this.message = message;
    	  this.type = type;

    	  // when err.type is `system`, err.code contains system error code
    	  if (systemError) {
    	    this.code = this.errno = systemError.code;
    	  }

    	  // hide custom error implementation details from end-users
    	  Error.captureStackTrace(this, this.constructor);
    	}

    	FetchError.prototype = Object.create(Error.prototype);
    	FetchError.prototype.constructor = FetchError;
    	FetchError.prototype.name = 'FetchError';

    	let convert;
    	try {
    		convert = require('encoding').convert;
    	} catch (e) {}

    	const INTERNALS = Symbol('Body internals');

    	// fix an issue where "PassThrough" isn't a named export for node <10
    	const PassThrough = Stream.PassThrough;

    	/**
    	 * Body mixin
    	 *
    	 * Ref: https://fetch.spec.whatwg.org/#body
    	 *
    	 * @param   Stream  body  Readable stream
    	 * @param   Object  opts  Response options
    	 * @return  Void
    	 */
    	function Body(body) {
    		var _this = this;

    		var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
    		    _ref$size = _ref.size;

    		let size = _ref$size === undefined ? 0 : _ref$size;
    		var _ref$timeout = _ref.timeout;
    		let timeout = _ref$timeout === undefined ? 0 : _ref$timeout;

    		if (body == null) {
    			// body is undefined or null
    			body = null;
    		} else if (isURLSearchParams(body)) {
    			// body is a URLSearchParams
    			body = Buffer$3.from(body.toString());
    		} else if (isBlob(body)) ; else if (Buffer$3.isBuffer(body)) ; else if (Object.prototype.toString.call(body) === '[object ArrayBuffer]') {
    			// body is ArrayBuffer
    			body = Buffer$3.from(body);
    		} else if (ArrayBuffer.isView(body)) {
    			// body is ArrayBufferView
    			body = Buffer$3.from(body.buffer, body.byteOffset, body.byteLength);
    		} else if (body instanceof Stream) ; else {
    			// none of the above
    			// coerce to string then buffer
    			body = Buffer$3.from(String(body));
    		}
    		this[INTERNALS] = {
    			body,
    			disturbed: false,
    			error: null
    		};
    		this.size = size;
    		this.timeout = timeout;

    		if (body instanceof Stream) {
    			body.on('error', function (err) {
    				const error = err.name === 'AbortError' ? err : new FetchError(`Invalid response body while trying to fetch ${_this.url}: ${err.message}`, 'system', err);
    				_this[INTERNALS].error = error;
    			});
    		}
    	}

    	Body.prototype = {
    		get body() {
    			return this[INTERNALS].body;
    		},

    		get bodyUsed() {
    			return this[INTERNALS].disturbed;
    		},

    		/**
    	  * Decode response as ArrayBuffer
    	  *
    	  * @return  Promise
    	  */
    		arrayBuffer() {
    			return consumeBody.call(this).then(function (buf) {
    				return buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength);
    			});
    		},

    		/**
    	  * Return raw response as Blob
    	  *
    	  * @return Promise
    	  */
    		blob() {
    			let ct = this.headers && this.headers.get('content-type') || '';
    			return consumeBody.call(this).then(function (buf) {
    				return Object.assign(
    				// Prevent copying
    				new Blob([], {
    					type: ct.toLowerCase()
    				}), {
    					[BUFFER]: buf
    				});
    			});
    		},

    		/**
    	  * Decode response as json
    	  *
    	  * @return  Promise
    	  */
    		json() {
    			var _this2 = this;

    			return consumeBody.call(this).then(function (buffer) {
    				try {
    					return JSON.parse(buffer.toString());
    				} catch (err) {
    					return Body.Promise.reject(new FetchError(`invalid json response body at ${_this2.url} reason: ${err.message}`, 'invalid-json'));
    				}
    			});
    		},

    		/**
    	  * Decode response as text
    	  *
    	  * @return  Promise
    	  */
    		text() {
    			return consumeBody.call(this).then(function (buffer) {
    				return buffer.toString();
    			});
    		},

    		/**
    	  * Decode response as buffer (non-spec api)
    	  *
    	  * @return  Promise
    	  */
    		buffer() {
    			return consumeBody.call(this);
    		},

    		/**
    	  * Decode response as text, while automatically detecting the encoding and
    	  * trying to decode to UTF-8 (non-spec api)
    	  *
    	  * @return  Promise
    	  */
    		textConverted() {
    			var _this3 = this;

    			return consumeBody.call(this).then(function (buffer) {
    				return convertBody(buffer, _this3.headers);
    			});
    		}
    	};

    	// In browsers, all properties are enumerable.
    	Object.defineProperties(Body.prototype, {
    		body: { enumerable: true },
    		bodyUsed: { enumerable: true },
    		arrayBuffer: { enumerable: true },
    		blob: { enumerable: true },
    		json: { enumerable: true },
    		text: { enumerable: true }
    	});

    	Body.mixIn = function (proto) {
    		for (const name of Object.getOwnPropertyNames(Body.prototype)) {
    			// istanbul ignore else: future proof
    			if (!(name in proto)) {
    				const desc = Object.getOwnPropertyDescriptor(Body.prototype, name);
    				Object.defineProperty(proto, name, desc);
    			}
    		}
    	};

    	/**
    	 * Consume and convert an entire Body to a Buffer.
    	 *
    	 * Ref: https://fetch.spec.whatwg.org/#concept-body-consume-body
    	 *
    	 * @return  Promise
    	 */
    	function consumeBody() {
    		var _this4 = this;

    		if (this[INTERNALS].disturbed) {
    			return Body.Promise.reject(new TypeError(`body used already for: ${this.url}`));
    		}

    		this[INTERNALS].disturbed = true;

    		if (this[INTERNALS].error) {
    			return Body.Promise.reject(this[INTERNALS].error);
    		}

    		let body = this.body;

    		// body is null
    		if (body === null) {
    			return Body.Promise.resolve(Buffer$3.alloc(0));
    		}

    		// body is blob
    		if (isBlob(body)) {
    			body = body.stream();
    		}

    		// body is buffer
    		if (Buffer$3.isBuffer(body)) {
    			return Body.Promise.resolve(body);
    		}

    		// istanbul ignore if: should never happen
    		if (!(body instanceof Stream)) {
    			return Body.Promise.resolve(Buffer$3.alloc(0));
    		}

    		// body is stream
    		// get ready to actually consume the body
    		let accum = [];
    		let accumBytes = 0;
    		let abort = false;

    		return new Body.Promise(function (resolve, reject) {
    			let resTimeout;

    			// allow timeout on slow response body
    			if (_this4.timeout) {
    				resTimeout = setTimeout(function () {
    					abort = true;
    					reject(new FetchError(`Response timeout while trying to fetch ${_this4.url} (over ${_this4.timeout}ms)`, 'body-timeout'));
    				}, _this4.timeout);
    			}

    			// handle stream errors
    			body.on('error', function (err) {
    				if (err.name === 'AbortError') {
    					// if the request was aborted, reject with this Error
    					abort = true;
    					reject(err);
    				} else {
    					// other errors, such as incorrect content-encoding
    					reject(new FetchError(`Invalid response body while trying to fetch ${_this4.url}: ${err.message}`, 'system', err));
    				}
    			});

    			body.on('data', function (chunk) {
    				if (abort || chunk === null) {
    					return;
    				}

    				if (_this4.size && accumBytes + chunk.length > _this4.size) {
    					abort = true;
    					reject(new FetchError(`content size at ${_this4.url} over limit: ${_this4.size}`, 'max-size'));
    					return;
    				}

    				accumBytes += chunk.length;
    				accum.push(chunk);
    			});

    			body.on('end', function () {
    				if (abort) {
    					return;
    				}

    				clearTimeout(resTimeout);

    				try {
    					resolve(Buffer$3.concat(accum, accumBytes));
    				} catch (err) {
    					// handle streams that have accumulated too much data (issue #414)
    					reject(new FetchError(`Could not create Buffer from response body for ${_this4.url}: ${err.message}`, 'system', err));
    				}
    			});
    		});
    	}

    	/**
    	 * Detect buffer encoding and convert to target encoding
    	 * ref: http://www.w3.org/TR/2011/WD-html5-20110113/parsing.html#determining-the-character-encoding
    	 *
    	 * @param   Buffer  buffer    Incoming buffer
    	 * @param   String  encoding  Target encoding
    	 * @return  String
    	 */
    	function convertBody(buffer, headers) {
    		if (typeof convert !== 'function') {
    			throw new Error('The package `encoding` must be installed to use the textConverted() function');
    		}

    		const ct = headers.get('content-type');
    		let charset = 'utf-8';
    		let res, str;

    		// header
    		if (ct) {
    			res = /charset=([^;]*)/i.exec(ct);
    		}

    		// no charset in content type, peek at response body for at most 1024 bytes
    		str = buffer.slice(0, 1024).toString();

    		// html5
    		if (!res && str) {
    			res = /<meta.+?charset=(['"])(.+?)\1/i.exec(str);
    		}

    		// html4
    		if (!res && str) {
    			res = /<meta[\s]+?http-equiv=(['"])content-type\1[\s]+?content=(['"])(.+?)\2/i.exec(str);
    			if (!res) {
    				res = /<meta[\s]+?content=(['"])(.+?)\1[\s]+?http-equiv=(['"])content-type\3/i.exec(str);
    				if (res) {
    					res.pop(); // drop last quote
    				}
    			}

    			if (res) {
    				res = /charset=(.*)/i.exec(res.pop());
    			}
    		}

    		// xml
    		if (!res && str) {
    			res = /<\?xml.+?encoding=(['"])(.+?)\1/i.exec(str);
    		}

    		// found charset
    		if (res) {
    			charset = res.pop();

    			// prevent decode issues when sites use incorrect encoding
    			// ref: https://hsivonen.fi/encoding-menu/
    			if (charset === 'gb2312' || charset === 'gbk') {
    				charset = 'gb18030';
    			}
    		}

    		// turn raw buffers into a single utf-8 buffer
    		return convert(buffer, 'UTF-8', charset).toString();
    	}

    	/**
    	 * Detect a URLSearchParams object
    	 * ref: https://github.com/bitinn/node-fetch/issues/296#issuecomment-307598143
    	 *
    	 * @param   Object  obj     Object to detect by type or brand
    	 * @return  String
    	 */
    	function isURLSearchParams(obj) {
    		// Duck-typing as a necessary condition.
    		if (typeof obj !== 'object' || typeof obj.append !== 'function' || typeof obj.delete !== 'function' || typeof obj.get !== 'function' || typeof obj.getAll !== 'function' || typeof obj.has !== 'function' || typeof obj.set !== 'function') {
    			return false;
    		}

    		// Brand-checking and more duck-typing as optional condition.
    		return obj.constructor.name === 'URLSearchParams' || Object.prototype.toString.call(obj) === '[object URLSearchParams]' || typeof obj.sort === 'function';
    	}

    	/**
    	 * Check if `obj` is a W3C `Blob` object (which `File` inherits from)
    	 * @param  {*} obj
    	 * @return {boolean}
    	 */
    	function isBlob(obj) {
    		return typeof obj === 'object' && typeof obj.arrayBuffer === 'function' && typeof obj.type === 'string' && typeof obj.stream === 'function' && typeof obj.constructor === 'function' && typeof obj.constructor.name === 'string' && /^(Blob|File)$/.test(obj.constructor.name) && /^(Blob|File)$/.test(obj[Symbol.toStringTag]);
    	}

    	/**
    	 * Clone body given Res/Req instance
    	 *
    	 * @param   Mixed  instance  Response or Request instance
    	 * @return  Mixed
    	 */
    	function clone(instance) {
    		let p1, p2;
    		let body = instance.body;

    		// don't allow cloning a used body
    		if (instance.bodyUsed) {
    			throw new Error('cannot clone body after it is used');
    		}

    		// check that body is a stream and not form-data object
    		// note: we can't clone the form-data object without having it as a dependency
    		if (body instanceof Stream && typeof body.getBoundary !== 'function') {
    			// tee instance body
    			p1 = new PassThrough();
    			p2 = new PassThrough();
    			body.pipe(p1);
    			body.pipe(p2);
    			// set instance body to teed body and return the other teed body
    			instance[INTERNALS].body = p1;
    			body = p2;
    		}

    		return body;
    	}

    	/**
    	 * Performs the operation "extract a `Content-Type` value from |object|" as
    	 * specified in the specification:
    	 * https://fetch.spec.whatwg.org/#concept-bodyinit-extract
    	 *
    	 * This function assumes that instance.body is present.
    	 *
    	 * @param   Mixed  instance  Any options.body input
    	 */
    	function extractContentType(body) {
    		if (body === null) {
    			// body is null
    			return null;
    		} else if (typeof body === 'string') {
    			// body is string
    			return 'text/plain;charset=UTF-8';
    		} else if (isURLSearchParams(body)) {
    			// body is a URLSearchParams
    			return 'application/x-www-form-urlencoded;charset=UTF-8';
    		} else if (isBlob(body)) {
    			// body is blob
    			return body.type || null;
    		} else if (Buffer$3.isBuffer(body)) {
    			// body is buffer
    			return null;
    		} else if (Object.prototype.toString.call(body) === '[object ArrayBuffer]') {
    			// body is ArrayBuffer
    			return null;
    		} else if (ArrayBuffer.isView(body)) {
    			// body is ArrayBufferView
    			return null;
    		} else if (typeof body.getBoundary === 'function') {
    			// detect form data input from form-data module
    			return `multipart/form-data;boundary=${body.getBoundary()}`;
    		} else if (body instanceof Stream) {
    			// body is stream
    			// can't really do much about this
    			return null;
    		} else {
    			// Body constructor defaults other things to string
    			return 'text/plain;charset=UTF-8';
    		}
    	}

    	/**
    	 * The Fetch Standard treats this as if "total bytes" is a property on the body.
    	 * For us, we have to explicitly get it with a function.
    	 *
    	 * ref: https://fetch.spec.whatwg.org/#concept-body-total-bytes
    	 *
    	 * @param   Body    instance   Instance of Body
    	 * @return  Number?            Number of bytes, or null if not possible
    	 */
    	function getTotalBytes(instance) {
    		const body = instance.body;


    		if (body === null) {
    			// body is null
    			return 0;
    		} else if (isBlob(body)) {
    			return body.size;
    		} else if (Buffer$3.isBuffer(body)) {
    			// body is buffer
    			return body.length;
    		} else if (body && typeof body.getLengthSync === 'function') {
    			// detect form data input from form-data module
    			if (body._lengthRetrievers && body._lengthRetrievers.length == 0 || // 1.x
    			body.hasKnownLength && body.hasKnownLength()) {
    				// 2.x
    				return body.getLengthSync();
    			}
    			return null;
    		} else {
    			// body is stream
    			return null;
    		}
    	}

    	/**
    	 * Write a Body to a Node.js WritableStream (e.g. http.Request) object.
    	 *
    	 * @param   Body    instance   Instance of Body
    	 * @return  Void
    	 */
    	function writeToStream(dest, instance) {
    		const body = instance.body;


    		if (body === null) {
    			// body is null
    			dest.end();
    		} else if (isBlob(body)) {
    			body.stream().pipe(dest);
    		} else if (Buffer$3.isBuffer(body)) {
    			// body is buffer
    			dest.write(body);
    			dest.end();
    		} else {
    			// body is stream
    			body.pipe(dest);
    		}
    	}

    	// expose Promise
    	Body.Promise = commonjsGlobal.Promise;

    	/**
    	 * headers.js
    	 *
    	 * Headers class offers convenient helpers
    	 */

    	const invalidTokenRegex = /[^\^_`a-zA-Z\-0-9!#$%&'*+.|~]/;
    	const invalidHeaderCharRegex = /[^\t\x20-\x7e\x80-\xff]/;

    	function validateName(name) {
    		name = `${name}`;
    		if (invalidTokenRegex.test(name) || name === '') {
    			throw new TypeError(`${name} is not a legal HTTP header name`);
    		}
    	}

    	function validateValue(value) {
    		value = `${value}`;
    		if (invalidHeaderCharRegex.test(value)) {
    			throw new TypeError(`${value} is not a legal HTTP header value`);
    		}
    	}

    	/**
    	 * Find the key in the map object given a header name.
    	 *
    	 * Returns undefined if not found.
    	 *
    	 * @param   String  name  Header name
    	 * @return  String|Undefined
    	 */
    	function find(map, name) {
    		name = name.toLowerCase();
    		for (const key in map) {
    			if (key.toLowerCase() === name) {
    				return key;
    			}
    		}
    		return undefined;
    	}

    	const MAP = Symbol('map');
    	class Headers {
    		/**
    	  * Headers class
    	  *
    	  * @param   Object  headers  Response headers
    	  * @return  Void
    	  */
    		constructor() {
    			let init = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : undefined;

    			this[MAP] = Object.create(null);

    			if (init instanceof Headers) {
    				const rawHeaders = init.raw();
    				const headerNames = Object.keys(rawHeaders);

    				for (const headerName of headerNames) {
    					for (const value of rawHeaders[headerName]) {
    						this.append(headerName, value);
    					}
    				}

    				return;
    			}

    			// We don't worry about converting prop to ByteString here as append()
    			// will handle it.
    			if (init == null) ; else if (typeof init === 'object') {
    				const method = init[Symbol.iterator];
    				if (method != null) {
    					if (typeof method !== 'function') {
    						throw new TypeError('Header pairs must be iterable');
    					}

    					// sequence<sequence<ByteString>>
    					// Note: per spec we have to first exhaust the lists then process them
    					const pairs = [];
    					for (const pair of init) {
    						if (typeof pair !== 'object' || typeof pair[Symbol.iterator] !== 'function') {
    							throw new TypeError('Each header pair must be iterable');
    						}
    						pairs.push(Array.from(pair));
    					}

    					for (const pair of pairs) {
    						if (pair.length !== 2) {
    							throw new TypeError('Each header pair must be a name/value tuple');
    						}
    						this.append(pair[0], pair[1]);
    					}
    				} else {
    					// record<ByteString, ByteString>
    					for (const key of Object.keys(init)) {
    						const value = init[key];
    						this.append(key, value);
    					}
    				}
    			} else {
    				throw new TypeError('Provided initializer must be an object');
    			}
    		}

    		/**
    	  * Return combined header value given name
    	  *
    	  * @param   String  name  Header name
    	  * @return  Mixed
    	  */
    		get(name) {
    			name = `${name}`;
    			validateName(name);
    			const key = find(this[MAP], name);
    			if (key === undefined) {
    				return null;
    			}

    			return this[MAP][key].join(', ');
    		}

    		/**
    	  * Iterate over all headers
    	  *
    	  * @param   Function  callback  Executed for each item with parameters (value, name, thisArg)
    	  * @param   Boolean   thisArg   `this` context for callback function
    	  * @return  Void
    	  */
    		forEach(callback) {
    			let thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;

    			let pairs = getHeaders(this);
    			let i = 0;
    			while (i < pairs.length) {
    				var _pairs$i = pairs[i];
    				const name = _pairs$i[0],
    				      value = _pairs$i[1];

    				callback.call(thisArg, value, name, this);
    				pairs = getHeaders(this);
    				i++;
    			}
    		}

    		/**
    	  * Overwrite header values given name
    	  *
    	  * @param   String  name   Header name
    	  * @param   String  value  Header value
    	  * @return  Void
    	  */
    		set(name, value) {
    			name = `${name}`;
    			value = `${value}`;
    			validateName(name);
    			validateValue(value);
    			const key = find(this[MAP], name);
    			this[MAP][key !== undefined ? key : name] = [value];
    		}

    		/**
    	  * Append a value onto existing header
    	  *
    	  * @param   String  name   Header name
    	  * @param   String  value  Header value
    	  * @return  Void
    	  */
    		append(name, value) {
    			name = `${name}`;
    			value = `${value}`;
    			validateName(name);
    			validateValue(value);
    			const key = find(this[MAP], name);
    			if (key !== undefined) {
    				this[MAP][key].push(value);
    			} else {
    				this[MAP][name] = [value];
    			}
    		}

    		/**
    	  * Check for header name existence
    	  *
    	  * @param   String   name  Header name
    	  * @return  Boolean
    	  */
    		has(name) {
    			name = `${name}`;
    			validateName(name);
    			return find(this[MAP], name) !== undefined;
    		}

    		/**
    	  * Delete all header values given name
    	  *
    	  * @param   String  name  Header name
    	  * @return  Void
    	  */
    		delete(name) {
    			name = `${name}`;
    			validateName(name);
    			const key = find(this[MAP], name);
    			if (key !== undefined) {
    				delete this[MAP][key];
    			}
    		}

    		/**
    	  * Return raw headers (non-spec api)
    	  *
    	  * @return  Object
    	  */
    		raw() {
    			return this[MAP];
    		}

    		/**
    	  * Get an iterator on keys.
    	  *
    	  * @return  Iterator
    	  */
    		keys() {
    			return createHeadersIterator(this, 'key');
    		}

    		/**
    	  * Get an iterator on values.
    	  *
    	  * @return  Iterator
    	  */
    		values() {
    			return createHeadersIterator(this, 'value');
    		}

    		/**
    	  * Get an iterator on entries.
    	  *
    	  * This is the default iterator of the Headers object.
    	  *
    	  * @return  Iterator
    	  */
    		[Symbol.iterator]() {
    			return createHeadersIterator(this, 'key+value');
    		}
    	}
    	Headers.prototype.entries = Headers.prototype[Symbol.iterator];

    	Object.defineProperty(Headers.prototype, Symbol.toStringTag, {
    		value: 'Headers',
    		writable: false,
    		enumerable: false,
    		configurable: true
    	});

    	Object.defineProperties(Headers.prototype, {
    		get: { enumerable: true },
    		forEach: { enumerable: true },
    		set: { enumerable: true },
    		append: { enumerable: true },
    		has: { enumerable: true },
    		delete: { enumerable: true },
    		keys: { enumerable: true },
    		values: { enumerable: true },
    		entries: { enumerable: true }
    	});

    	function getHeaders(headers) {
    		let kind = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'key+value';

    		const keys = Object.keys(headers[MAP]).sort();
    		return keys.map(kind === 'key' ? function (k) {
    			return k.toLowerCase();
    		} : kind === 'value' ? function (k) {
    			return headers[MAP][k].join(', ');
    		} : function (k) {
    			return [k.toLowerCase(), headers[MAP][k].join(', ')];
    		});
    	}

    	const INTERNAL = Symbol('internal');

    	function createHeadersIterator(target, kind) {
    		const iterator = Object.create(HeadersIteratorPrototype);
    		iterator[INTERNAL] = {
    			target,
    			kind,
    			index: 0
    		};
    		return iterator;
    	}

    	const HeadersIteratorPrototype = Object.setPrototypeOf({
    		next() {
    			// istanbul ignore if
    			if (!this || Object.getPrototypeOf(this) !== HeadersIteratorPrototype) {
    				throw new TypeError('Value of `this` is not a HeadersIterator');
    			}

    			var _INTERNAL = this[INTERNAL];
    			const target = _INTERNAL.target,
    			      kind = _INTERNAL.kind,
    			      index = _INTERNAL.index;

    			const values = getHeaders(target, kind);
    			const len = values.length;
    			if (index >= len) {
    				return {
    					value: undefined,
    					done: true
    				};
    			}

    			this[INTERNAL].index = index + 1;

    			return {
    				value: values[index],
    				done: false
    			};
    		}
    	}, Object.getPrototypeOf(Object.getPrototypeOf([][Symbol.iterator]())));

    	Object.defineProperty(HeadersIteratorPrototype, Symbol.toStringTag, {
    		value: 'HeadersIterator',
    		writable: false,
    		enumerable: false,
    		configurable: true
    	});

    	/**
    	 * Export the Headers object in a form that Node.js can consume.
    	 *
    	 * @param   Headers  headers
    	 * @return  Object
    	 */
    	function exportNodeCompatibleHeaders(headers) {
    		const obj = Object.assign({ __proto__: null }, headers[MAP]);

    		// http.request() only supports string as Host header. This hack makes
    		// specifying custom Host header possible.
    		const hostHeaderKey = find(headers[MAP], 'Host');
    		if (hostHeaderKey !== undefined) {
    			obj[hostHeaderKey] = obj[hostHeaderKey][0];
    		}

    		return obj;
    	}

    	/**
    	 * Create a Headers object from an object of headers, ignoring those that do
    	 * not conform to HTTP grammar productions.
    	 *
    	 * @param   Object  obj  Object of headers
    	 * @return  Headers
    	 */
    	function createHeadersLenient(obj) {
    		const headers = new Headers();
    		for (const name of Object.keys(obj)) {
    			if (invalidTokenRegex.test(name)) {
    				continue;
    			}
    			if (Array.isArray(obj[name])) {
    				for (const val of obj[name]) {
    					if (invalidHeaderCharRegex.test(val)) {
    						continue;
    					}
    					if (headers[MAP][name] === undefined) {
    						headers[MAP][name] = [val];
    					} else {
    						headers[MAP][name].push(val);
    					}
    				}
    			} else if (!invalidHeaderCharRegex.test(obj[name])) {
    				headers[MAP][name] = [obj[name]];
    			}
    		}
    		return headers;
    	}

    	const INTERNALS$1 = Symbol('Response internals');

    	// fix an issue where "STATUS_CODES" aren't a named export for node <10
    	const STATUS_CODES = http.STATUS_CODES;

    	/**
    	 * Response class
    	 *
    	 * @param   Stream  body  Readable stream
    	 * @param   Object  opts  Response options
    	 * @return  Void
    	 */
    	class Response {
    		constructor() {
    			let body = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
    			let opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    			Body.call(this, body, opts);

    			const status = opts.status || 200;
    			const headers = new Headers(opts.headers);

    			if (body != null && !headers.has('Content-Type')) {
    				const contentType = extractContentType(body);
    				if (contentType) {
    					headers.append('Content-Type', contentType);
    				}
    			}

    			this[INTERNALS$1] = {
    				url: opts.url,
    				status,
    				statusText: opts.statusText || STATUS_CODES[status],
    				headers,
    				counter: opts.counter
    			};
    		}

    		get url() {
    			return this[INTERNALS$1].url || '';
    		}

    		get status() {
    			return this[INTERNALS$1].status;
    		}

    		/**
    	  * Convenience property representing if the request ended normally
    	  */
    		get ok() {
    			return this[INTERNALS$1].status >= 200 && this[INTERNALS$1].status < 300;
    		}

    		get redirected() {
    			return this[INTERNALS$1].counter > 0;
    		}

    		get statusText() {
    			return this[INTERNALS$1].statusText;
    		}

    		get headers() {
    			return this[INTERNALS$1].headers;
    		}

    		/**
    	  * Clone this response
    	  *
    	  * @return  Response
    	  */
    		clone() {
    			return new Response(clone(this), {
    				url: this.url,
    				status: this.status,
    				statusText: this.statusText,
    				headers: this.headers,
    				ok: this.ok,
    				redirected: this.redirected
    			});
    		}
    	}

    	Body.mixIn(Response.prototype);

    	Object.defineProperties(Response.prototype, {
    		url: { enumerable: true },
    		status: { enumerable: true },
    		ok: { enumerable: true },
    		redirected: { enumerable: true },
    		statusText: { enumerable: true },
    		headers: { enumerable: true },
    		clone: { enumerable: true }
    	});

    	Object.defineProperty(Response.prototype, Symbol.toStringTag, {
    		value: 'Response',
    		writable: false,
    		enumerable: false,
    		configurable: true
    	});

    	const INTERNALS$2 = Symbol('Request internals');
    	const URL = Url.URL || whatwgUrl.URL;

    	// fix an issue where "format", "parse" aren't a named export for node <10
    	const parse_url = Url.parse;
    	const format_url = Url.format;

    	/**
    	 * Wrapper around `new URL` to handle arbitrary URLs
    	 *
    	 * @param  {string} urlStr
    	 * @return {void}
    	 */
    	function parseURL(urlStr) {
    		/*
    	 	Check whether the URL is absolute or not
    	 		Scheme: https://tools.ietf.org/html/rfc3986#section-3.1
    	 	Absolute URL: https://tools.ietf.org/html/rfc3986#section-4.3
    	 */
    		if (/^[a-zA-Z][a-zA-Z\d+\-.]*:/.exec(urlStr)) {
    			urlStr = new URL(urlStr).toString();
    		}

    		// Fallback to old implementation for arbitrary URLs
    		return parse_url(urlStr);
    	}

    	const streamDestructionSupported = 'destroy' in Stream.Readable.prototype;

    	/**
    	 * Check if a value is an instance of Request.
    	 *
    	 * @param   Mixed   input
    	 * @return  Boolean
    	 */
    	function isRequest(input) {
    		return typeof input === 'object' && typeof input[INTERNALS$2] === 'object';
    	}

    	function isAbortSignal(signal) {
    		const proto = signal && typeof signal === 'object' && Object.getPrototypeOf(signal);
    		return !!(proto && proto.constructor.name === 'AbortSignal');
    	}

    	/**
    	 * Request class
    	 *
    	 * @param   Mixed   input  Url or Request instance
    	 * @param   Object  init   Custom options
    	 * @return  Void
    	 */
    	class Request {
    		constructor(input) {
    			let init = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    			let parsedURL;

    			// normalize input
    			if (!isRequest(input)) {
    				if (input && input.href) {
    					// in order to support Node.js' Url objects; though WHATWG's URL objects
    					// will fall into this branch also (since their `toString()` will return
    					// `href` property anyway)
    					parsedURL = parseURL(input.href);
    				} else {
    					// coerce input to a string before attempting to parse
    					parsedURL = parseURL(`${input}`);
    				}
    				input = {};
    			} else {
    				parsedURL = parseURL(input.url);
    			}

    			let method = init.method || input.method || 'GET';
    			method = method.toUpperCase();

    			if ((init.body != null || isRequest(input) && input.body !== null) && (method === 'GET' || method === 'HEAD')) {
    				throw new TypeError('Request with GET/HEAD method cannot have body');
    			}

    			let inputBody = init.body != null ? init.body : isRequest(input) && input.body !== null ? clone(input) : null;

    			Body.call(this, inputBody, {
    				timeout: init.timeout || input.timeout || 0,
    				size: init.size || input.size || 0
    			});

    			const headers = new Headers(init.headers || input.headers || {});

    			if (inputBody != null && !headers.has('Content-Type')) {
    				const contentType = extractContentType(inputBody);
    				if (contentType) {
    					headers.append('Content-Type', contentType);
    				}
    			}

    			let signal = isRequest(input) ? input.signal : null;
    			if ('signal' in init) signal = init.signal;

    			if (signal != null && !isAbortSignal(signal)) {
    				throw new TypeError('Expected signal to be an instanceof AbortSignal');
    			}

    			this[INTERNALS$2] = {
    				method,
    				redirect: init.redirect || input.redirect || 'follow',
    				headers,
    				parsedURL,
    				signal
    			};

    			// node-fetch-only options
    			this.follow = init.follow !== undefined ? init.follow : input.follow !== undefined ? input.follow : 20;
    			this.compress = init.compress !== undefined ? init.compress : input.compress !== undefined ? input.compress : true;
    			this.counter = init.counter || input.counter || 0;
    			this.agent = init.agent || input.agent;
    		}

    		get method() {
    			return this[INTERNALS$2].method;
    		}

    		get url() {
    			return format_url(this[INTERNALS$2].parsedURL);
    		}

    		get headers() {
    			return this[INTERNALS$2].headers;
    		}

    		get redirect() {
    			return this[INTERNALS$2].redirect;
    		}

    		get signal() {
    			return this[INTERNALS$2].signal;
    		}

    		/**
    	  * Clone this request
    	  *
    	  * @return  Request
    	  */
    		clone() {
    			return new Request(this);
    		}
    	}

    	Body.mixIn(Request.prototype);

    	Object.defineProperty(Request.prototype, Symbol.toStringTag, {
    		value: 'Request',
    		writable: false,
    		enumerable: false,
    		configurable: true
    	});

    	Object.defineProperties(Request.prototype, {
    		method: { enumerable: true },
    		url: { enumerable: true },
    		headers: { enumerable: true },
    		redirect: { enumerable: true },
    		clone: { enumerable: true },
    		signal: { enumerable: true }
    	});

    	/**
    	 * Convert a Request to Node.js http request options.
    	 *
    	 * @param   Request  A Request instance
    	 * @return  Object   The options object to be passed to http.request
    	 */
    	function getNodeRequestOptions(request) {
    		const parsedURL = request[INTERNALS$2].parsedURL;
    		const headers = new Headers(request[INTERNALS$2].headers);

    		// fetch step 1.3
    		if (!headers.has('Accept')) {
    			headers.set('Accept', '*/*');
    		}

    		// Basic fetch
    		if (!parsedURL.protocol || !parsedURL.hostname) {
    			throw new TypeError('Only absolute URLs are supported');
    		}

    		if (!/^https?:$/.test(parsedURL.protocol)) {
    			throw new TypeError('Only HTTP(S) protocols are supported');
    		}

    		if (request.signal && request.body instanceof Stream.Readable && !streamDestructionSupported) {
    			throw new Error('Cancellation of streamed requests with AbortSignal is not supported in node < 8');
    		}

    		// HTTP-network-or-cache fetch steps 2.4-2.7
    		let contentLengthValue = null;
    		if (request.body == null && /^(POST|PUT)$/i.test(request.method)) {
    			contentLengthValue = '0';
    		}
    		if (request.body != null) {
    			const totalBytes = getTotalBytes(request);
    			if (typeof totalBytes === 'number') {
    				contentLengthValue = String(totalBytes);
    			}
    		}
    		if (contentLengthValue) {
    			headers.set('Content-Length', contentLengthValue);
    		}

    		// HTTP-network-or-cache fetch step 2.11
    		if (!headers.has('User-Agent')) {
    			headers.set('User-Agent', 'node-fetch/1.0 (+https://github.com/bitinn/node-fetch)');
    		}

    		// HTTP-network-or-cache fetch step 2.15
    		if (request.compress && !headers.has('Accept-Encoding')) {
    			headers.set('Accept-Encoding', 'gzip,deflate');
    		}

    		let agent = request.agent;
    		if (typeof agent === 'function') {
    			agent = agent(parsedURL);
    		}

    		// HTTP-network fetch step 4.2
    		// chunked encoding is handled by Node.js

    		return Object.assign({}, parsedURL, {
    			method: request.method,
    			headers: exportNodeCompatibleHeaders(headers),
    			agent
    		});
    	}

    	/**
    	 * abort-error.js
    	 *
    	 * AbortError interface for cancelled requests
    	 */

    	/**
    	 * Create AbortError instance
    	 *
    	 * @param   String      message      Error message for human
    	 * @return  AbortError
    	 */
    	function AbortError(message) {
    	  Error.call(this, message);

    	  this.type = 'aborted';
    	  this.message = message;

    	  // hide custom error implementation details from end-users
    	  Error.captureStackTrace(this, this.constructor);
    	}

    	AbortError.prototype = Object.create(Error.prototype);
    	AbortError.prototype.constructor = AbortError;
    	AbortError.prototype.name = 'AbortError';

    	const URL$1 = Url.URL || whatwgUrl.URL;

    	// fix an issue where "PassThrough", "resolve" aren't a named export for node <10
    	const PassThrough$1 = Stream.PassThrough;

    	const isDomainOrSubdomain = function isDomainOrSubdomain(destination, original) {
    		const orig = new URL$1(original).hostname;
    		const dest = new URL$1(destination).hostname;

    		return orig === dest || orig[orig.length - dest.length - 1] === '.' && orig.endsWith(dest);
    	};

    	/**
    	 * isSameProtocol reports whether the two provided URLs use the same protocol.
    	 *
    	 * Both domains must already be in canonical form.
    	 * @param {string|URL} original
    	 * @param {string|URL} destination
    	 */
    	const isSameProtocol = function isSameProtocol(destination, original) {
    		const orig = new URL$1(original).protocol;
    		const dest = new URL$1(destination).protocol;

    		return orig === dest;
    	};

    	/**
    	 * Fetch function
    	 *
    	 * @param   Mixed    url   Absolute url or Request instance
    	 * @param   Object   opts  Fetch options
    	 * @return  Promise
    	 */
    	function fetch(url, opts) {

    		// allow custom promise
    		if (!fetch.Promise) {
    			throw new Error('native promise missing, set fetch.Promise to your favorite alternative');
    		}

    		Body.Promise = fetch.Promise;

    		// wrap http.request into fetch
    		return new fetch.Promise(function (resolve, reject) {
    			// build request object
    			const request = new Request(url, opts);
    			const options = getNodeRequestOptions(request);

    			const send = (options.protocol === 'https:' ? https : http).request;
    			const signal = request.signal;

    			let response = null;

    			const abort = function abort() {
    				let error = new AbortError('The user aborted a request.');
    				reject(error);
    				if (request.body && request.body instanceof Stream.Readable) {
    					destroyStream(request.body, error);
    				}
    				if (!response || !response.body) return;
    				response.body.emit('error', error);
    			};

    			if (signal && signal.aborted) {
    				abort();
    				return;
    			}

    			const abortAndFinalize = function abortAndFinalize() {
    				abort();
    				finalize();
    			};

    			// send request
    			const req = send(options);
    			let reqTimeout;

    			if (signal) {
    				signal.addEventListener('abort', abortAndFinalize);
    			}

    			function finalize() {
    				req.abort();
    				if (signal) signal.removeEventListener('abort', abortAndFinalize);
    				clearTimeout(reqTimeout);
    			}

    			if (request.timeout) {
    				req.once('socket', function (socket) {
    					reqTimeout = setTimeout(function () {
    						reject(new FetchError(`network timeout at: ${request.url}`, 'request-timeout'));
    						finalize();
    					}, request.timeout);
    				});
    			}

    			req.on('error', function (err) {
    				reject(new FetchError(`request to ${request.url} failed, reason: ${err.message}`, 'system', err));

    				if (response && response.body) {
    					destroyStream(response.body, err);
    				}

    				finalize();
    			});

    			fixResponseChunkedTransferBadEnding(req, function (err) {
    				if (signal && signal.aborted) {
    					return;
    				}

    				if (response && response.body) {
    					destroyStream(response.body, err);
    				}
    			});

    			/* c8 ignore next 18 */
    			if (parseInt(browser$1$1.version.substring(1)) < 14) {
    				// Before Node.js 14, pipeline() does not fully support async iterators and does not always
    				// properly handle when the socket close/end events are out of order.
    				req.on('socket', function (s) {
    					s.addListener('close', function (hadError) {
    						// if a data listener is still present we didn't end cleanly
    						const hasDataListener = s.listenerCount('data') > 0;

    						// if end happened before close but the socket didn't emit an error, do it now
    						if (response && hasDataListener && !hadError && !(signal && signal.aborted)) {
    							const err = new Error('Premature close');
    							err.code = 'ERR_STREAM_PREMATURE_CLOSE';
    							response.body.emit('error', err);
    						}
    					});
    				});
    			}

    			req.on('response', function (res) {
    				clearTimeout(reqTimeout);

    				const headers = createHeadersLenient(res.headers);

    				// HTTP fetch step 5
    				if (fetch.isRedirect(res.statusCode)) {
    					// HTTP fetch step 5.2
    					const location = headers.get('Location');

    					// HTTP fetch step 5.3
    					let locationURL = null;
    					try {
    						locationURL = location === null ? null : new URL$1(location, request.url).toString();
    					} catch (err) {
    						// error here can only be invalid URL in Location: header
    						// do not throw when options.redirect == manual
    						// let the user extract the errorneous redirect URL
    						if (request.redirect !== 'manual') {
    							reject(new FetchError(`uri requested responds with an invalid redirect URL: ${location}`, 'invalid-redirect'));
    							finalize();
    							return;
    						}
    					}

    					// HTTP fetch step 5.5
    					switch (request.redirect) {
    						case 'error':
    							reject(new FetchError(`uri requested responds with a redirect, redirect mode is set to error: ${request.url}`, 'no-redirect'));
    							finalize();
    							return;
    						case 'manual':
    							// node-fetch-specific step: make manual redirect a bit easier to use by setting the Location header value to the resolved URL.
    							if (locationURL !== null) {
    								// handle corrupted header
    								try {
    									headers.set('Location', locationURL);
    								} catch (err) {
    									// istanbul ignore next: nodejs server prevent invalid response headers, we can't test this through normal request
    									reject(err);
    								}
    							}
    							break;
    						case 'follow':
    							// HTTP-redirect fetch step 2
    							if (locationURL === null) {
    								break;
    							}

    							// HTTP-redirect fetch step 5
    							if (request.counter >= request.follow) {
    								reject(new FetchError(`maximum redirect reached at: ${request.url}`, 'max-redirect'));
    								finalize();
    								return;
    							}

    							// HTTP-redirect fetch step 6 (counter increment)
    							// Create a new Request object.
    							const requestOpts = {
    								headers: new Headers(request.headers),
    								follow: request.follow,
    								counter: request.counter + 1,
    								agent: request.agent,
    								compress: request.compress,
    								method: request.method,
    								body: request.body,
    								signal: request.signal,
    								timeout: request.timeout,
    								size: request.size
    							};

    							if (!isDomainOrSubdomain(request.url, locationURL) || !isSameProtocol(request.url, locationURL)) {
    								for (const name of ['authorization', 'www-authenticate', 'cookie', 'cookie2']) {
    									requestOpts.headers.delete(name);
    								}
    							}

    							// HTTP-redirect fetch step 9
    							if (res.statusCode !== 303 && request.body && getTotalBytes(request) === null) {
    								reject(new FetchError('Cannot follow redirect with body being a readable stream', 'unsupported-redirect'));
    								finalize();
    								return;
    							}

    							// HTTP-redirect fetch step 11
    							if (res.statusCode === 303 || (res.statusCode === 301 || res.statusCode === 302) && request.method === 'POST') {
    								requestOpts.method = 'GET';
    								requestOpts.body = undefined;
    								requestOpts.headers.delete('content-length');
    							}

    							// HTTP-redirect fetch step 15
    							resolve(fetch(new Request(locationURL, requestOpts)));
    							finalize();
    							return;
    					}
    				}

    				// prepare response
    				res.once('end', function () {
    					if (signal) signal.removeEventListener('abort', abortAndFinalize);
    				});
    				let body = res.pipe(new PassThrough$1());

    				const response_options = {
    					url: request.url,
    					status: res.statusCode,
    					statusText: res.statusMessage,
    					headers: headers,
    					size: request.size,
    					timeout: request.timeout,
    					counter: request.counter
    				};

    				// HTTP-network fetch step 12.1.1.3
    				const codings = headers.get('Content-Encoding');

    				// HTTP-network fetch step 12.1.1.4: handle content codings

    				// in following scenarios we ignore compression support
    				// 1. compression support is disabled
    				// 2. HEAD request
    				// 3. no Content-Encoding header
    				// 4. no content response (204)
    				// 5. content not modified response (304)
    				if (!request.compress || request.method === 'HEAD' || codings === null || res.statusCode === 204 || res.statusCode === 304) {
    					response = new Response(body, response_options);
    					resolve(response);
    					return;
    				}

    				// For Node v6+
    				// Be less strict when decoding compressed responses, since sometimes
    				// servers send slightly invalid responses that are still accepted
    				// by common browsers.
    				// Always using Z_SYNC_FLUSH is what cURL does.
    				const zlibOptions = {
    					flush: zlib.Z_SYNC_FLUSH,
    					finishFlush: zlib.Z_SYNC_FLUSH
    				};

    				// for gzip
    				if (codings == 'gzip' || codings == 'x-gzip') {
    					body = body.pipe(zlib.createGunzip(zlibOptions));
    					response = new Response(body, response_options);
    					resolve(response);
    					return;
    				}

    				// for deflate
    				if (codings == 'deflate' || codings == 'x-deflate') {
    					// handle the infamous raw deflate response from old servers
    					// a hack for old IIS and Apache servers
    					const raw = res.pipe(new PassThrough$1());
    					raw.once('data', function (chunk) {
    						// see http://stackoverflow.com/questions/37519828
    						if ((chunk[0] & 0x0F) === 0x08) {
    							body = body.pipe(zlib.createInflate());
    						} else {
    							body = body.pipe(zlib.createInflateRaw());
    						}
    						response = new Response(body, response_options);
    						resolve(response);
    					});
    					raw.on('end', function () {
    						// some old IIS servers return zero-length OK deflate responses, so 'data' is never emitted.
    						if (!response) {
    							response = new Response(body, response_options);
    							resolve(response);
    						}
    					});
    					return;
    				}

    				// for br
    				if (codings == 'br' && typeof zlib.createBrotliDecompress === 'function') {
    					body = body.pipe(zlib.createBrotliDecompress());
    					response = new Response(body, response_options);
    					resolve(response);
    					return;
    				}

    				// otherwise, use response as-is
    				response = new Response(body, response_options);
    				resolve(response);
    			});

    			writeToStream(req, request);
    		});
    	}
    	function fixResponseChunkedTransferBadEnding(request, errorCallback) {
    		let socket;

    		request.on('socket', function (s) {
    			socket = s;
    		});

    		request.on('response', function (response) {
    			const headers = response.headers;

    			if (headers['transfer-encoding'] === 'chunked' && !headers['content-length']) {
    				response.once('close', function (hadError) {
    					// tests for socket presence, as in some situations the
    					// the 'socket' event is not triggered for the request
    					// (happens in deno), avoids `TypeError`
    					// if a data listener is still present we didn't end cleanly
    					const hasDataListener = socket && socket.listenerCount('data') > 0;

    					if (hasDataListener && !hadError) {
    						const err = new Error('Premature close');
    						err.code = 'ERR_STREAM_PREMATURE_CLOSE';
    						errorCallback(err);
    					}
    				});
    			}
    		});
    	}

    	function destroyStream(stream, err) {
    		if (stream.destroy) {
    			stream.destroy(err);
    		} else {
    			// node < 8
    			stream.emit('error', err);
    			stream.end();
    		}
    	}

    	/**
    	 * Redirect code matching
    	 *
    	 * @param   Number   code  Status code
    	 * @return  Boolean
    	 */
    	fetch.isRedirect = function (code) {
    		return code === 301 || code === 302 || code === 303 || code === 307 || code === 308;
    	};

    	// expose Promise
    	fetch.Promise = commonjsGlobal.Promise;

    	module.exports = exports = fetch;
    	Object.defineProperty(exports, "__esModule", { value: true });
    	exports.default = exports;
    	exports.Headers = Headers;
    	exports.Request = Request;
    	exports.Response = Response;
    	exports.FetchError = FetchError;
    	exports.AbortError = AbortError;
    } (lib$1, lib$1.exports));

    var browser = {exports: {}};

    var safeBuffer = {exports: {}};

    var require$$0 = /*@__PURE__*/getAugmentedNamespace(bufferEs6);

    /*! safe-buffer. MIT License. Feross Aboukhadijeh <https://feross.org/opensource> */

    (function (module, exports) {
    	/* eslint-disable node/no-deprecated-api */
    	var buffer = require$$0;
    	var Buffer = buffer.Buffer;

    	// alternative to using Object.keys for old browsers
    	function copyProps (src, dst) {
    	  for (var key in src) {
    	    dst[key] = src[key];
    	  }
    	}
    	if (Buffer.from && Buffer.alloc && Buffer.allocUnsafe && Buffer.allocUnsafeSlow) {
    	  module.exports = buffer;
    	} else {
    	  // Copy properties from require('buffer')
    	  copyProps(buffer, exports);
    	  exports.Buffer = SafeBuffer;
    	}

    	function SafeBuffer (arg, encodingOrOffset, length) {
    	  return Buffer(arg, encodingOrOffset, length)
    	}

    	SafeBuffer.prototype = Object.create(Buffer.prototype);

    	// Copy static methods from Buffer
    	copyProps(Buffer, SafeBuffer);

    	SafeBuffer.from = function (arg, encodingOrOffset, length) {
    	  if (typeof arg === 'number') {
    	    throw new TypeError('Argument must not be a number')
    	  }
    	  return Buffer(arg, encodingOrOffset, length)
    	};

    	SafeBuffer.alloc = function (size, fill, encoding) {
    	  if (typeof size !== 'number') {
    	    throw new TypeError('Argument must be a number')
    	  }
    	  var buf = Buffer(size);
    	  if (fill !== undefined) {
    	    if (typeof encoding === 'string') {
    	      buf.fill(fill, encoding);
    	    } else {
    	      buf.fill(fill);
    	    }
    	  } else {
    	    buf.fill(0);
    	  }
    	  return buf
    	};

    	SafeBuffer.allocUnsafe = function (size) {
    	  if (typeof size !== 'number') {
    	    throw new TypeError('Argument must be a number')
    	  }
    	  return Buffer(size)
    	};

    	SafeBuffer.allocUnsafeSlow = function (size) {
    	  if (typeof size !== 'number') {
    	    throw new TypeError('Argument must be a number')
    	  }
    	  return buffer.SlowBuffer(size)
    	};
    } (safeBuffer, safeBuffer.exports));

    // limit of Crypto.getRandomValues()
    // https://developer.mozilla.org/en-US/docs/Web/API/Crypto/getRandomValues
    var MAX_BYTES = 65536;

    // Node supports requesting up to this number of bytes
    // https://github.com/nodejs/node/blob/master/lib/internal/crypto/random.js#L48
    var MAX_UINT32 = 4294967295;

    function oldBrowser () {
      throw new Error('Secure random number generation is not supported by this browser.\nUse Chrome, Firefox or Internet Explorer 11')
    }

    var Buffer$1 = safeBuffer.exports.Buffer;
    var crypto = commonjsGlobal.crypto || commonjsGlobal.msCrypto;

    if (crypto && crypto.getRandomValues) {
      browser.exports = randomBytes;
    } else {
      browser.exports = oldBrowser;
    }

    function randomBytes (size, cb) {
      // phantomjs needs to throw
      if (size > MAX_UINT32) throw new RangeError('requested too many random bytes')

      var bytes = Buffer$1.allocUnsafe(size);

      if (size > 0) {  // getRandomValues fails on IE if size == 0
        if (size > MAX_BYTES) { // this is the max bytes crypto.getRandomValues
          // can do at once see https://developer.mozilla.org/en-US/docs/Web/API/window.crypto.getRandomValues
          for (var generated = 0; generated < size; generated += MAX_BYTES) {
            // buffer.slice automatically checks if the end is past the end of
            // the buffer so we don't have to here
            crypto.getRandomValues(bytes.slice(generated, generated + MAX_BYTES));
          }
        } else {
          crypto.getRandomValues(bytes);
        }
      }

      if (typeof cb === 'function') {
        return browser$1$1.nextTick(function () {
          cb(null, bytes);
        })
      }

      return bytes
    }

    const Utils = {
        /**
         * Helper function for encoding strings to hex
         *
         * @param string
         * @returns {string}
         */
        hexEncode(string) {
            return `0x${Buffer.from(string).toString('hex')}`;
        },
        /**
         * Helper function for encoding strings to hex
         *
         * @param hexString string
         * @param encoding BufferEncoding
         * @returns {string}
         */
        hexDecode(hexString, encoding = 'utf8') {
            return Buffer.from(hexString.replace('0x', ''), 'hex').toString(encoding);
        },
        /**
         * Helper function to generate a random nonce
         *
         * @returns {string}
         */
        getRandomString(length = 32) {
            return browser.exports(length).toString('hex');
        },
        /**
         * Test whether the given string is hex
         *
         * @param value any
         * @returns {boolean}
         */
        isHex(value) {
            if (typeof value !== 'string') {
                return false;
            }
            return /^[0-9a-fA-F]+$/.test(value);
        },
        /**
         * Get a signing path from a hex number
         *
         * @param hexString {string}
         * @param hardened {boolean} Whether to return a hardened path
         * @returns {string}
         */
        getSigningPathFromHex(hexString, hardened = true) {
            // "m/0/0/1"
            let signingPath = 'm';
            const signingHex = hexString.match(/.{1,8}/g);
            if (!signingHex) {
                throw new Error('Invalid hex string');
            }
            const maxNumber = 2147483648 - 1; // 0x80000000
            for (const hexNumber of signingHex) {
                let number = Number(`0x${hexNumber}`);
                if (number > maxNumber)
                    number -= maxNumber;
                signingPath += `/${number}${(hardened ? "'" : '')}`;
            }
            return signingPath;
        },
        /**
         * Increment that second to last part from the given part, set the last part to 0
         *
         * @param path string
         * @returns {*}
         */
        getNextIdentityPath(path) {
            const pathValues = path.split('/');
            const secondToLastPart = pathValues[pathValues.length - 2];
            let hardened = false;
            if (secondToLastPart.match('\'')) {
                hardened = true;
            }
            const nextPath = (Number(secondToLastPart.replace(/[^0-9]/g, '')) + 1).toString();
            pathValues[pathValues.length - 2] = nextPath + (hardened ? '\'' : '');
            pathValues[pathValues.length - 1] = `0${hardened ? '\'' : ''}`;
            return pathValues.join('/');
        },
        /**
         * Increment that last part of the given path
         *
         * @param path string
         * @returns {*}
         */
        getNextPath(path) {
            const pathValues = path.split('/');
            const lastPart = pathValues[pathValues.length - 1];
            let hardened = false;
            if (lastPart.match('\'')) {
                hardened = true;
            }
            const nextPath = (Number(lastPart.replace(/[^0-9]/g, '')) + 1).toString();
            pathValues[pathValues.length - 1] = nextPath + (hardened ? '\'' : '');
            return pathValues.join('/');
        },
    };

    const BAP_BITCOM_ADDRESS = '1BAPSuaPnfGnSBM3GLV9yhxUdYe4vGbdMT';
    const BAP_BITCOM_ADDRESS_HEX = `0x${Buffer.from(BAP_BITCOM_ADDRESS).toString('hex')}`;
    const AIP_BITCOM_ADDRESS = '15PciHG22SNLQJXMoSUaWVi7WSqc7hCfva';
`0x${Buffer.from(AIP_BITCOM_ADDRESS).toString('hex')}`;
    const BAP_SERVER = 'https://bap.network/api/v1';
    const MAX_INT = 2147483648 - 1; // 0x80000000
    // This is just a choice for this library and could be anything else if so needed/wanted
    // but it is advisable to use the same derivation between libraries for compatibility
    const SIGNING_PATH_PREFIX = 'm/424150\'/0\'/0\''; // BAP in hex
    const ENCRYPTION_PATH = `m/424150'/${MAX_INT}'/${MAX_INT}'`;

    var _BAP_ID_HDPrivateKey, _BAP_ID_BAP_SERVER, _BAP_ID_BAP_TOKEN, _BAP_ID_rootPath, _BAP_ID_previousPath, _BAP_ID_currentPath, _BAP_ID_idSeed;
    const { toArray: toArray$1, toHex, toBase58, toUTF8: toUTF8$1, toBase64: toBase64$1 } = BSVUtils;
    const { bitcoreDecrypt: bitcoreDecrypt$1, bitcoreEncrypt: bitcoreEncrypt$1 } = ECIES;
    /**
     * BAP_ID class
     *
     * This class should be used in conjunction with the BAP class
     *
     * @type {BAP_ID}
     */
    class BAP_ID {
        constructor(HDPrivateKey, identityAttributes = {}, idSeed = "") {
            _BAP_ID_HDPrivateKey.set(this, void 0);
            _BAP_ID_BAP_SERVER.set(this, BAP_SERVER);
            _BAP_ID_BAP_TOKEN.set(this, "");
            _BAP_ID_rootPath.set(this, void 0);
            _BAP_ID_previousPath.set(this, void 0);
            _BAP_ID_currentPath.set(this, void 0);
            _BAP_ID_idSeed.set(this, void 0);
            __classPrivateFieldSet(this, _BAP_ID_idSeed, idSeed, "f");
            if (idSeed) {
                // create a new HDPrivateKey based on the seed
                const seedHex = toHex(sha256(idSeed, "utf8"));
                const seedPath = Utils.getSigningPathFromHex(seedHex);
                __classPrivateFieldSet(this, _BAP_ID_HDPrivateKey, HDPrivateKey.derive(seedPath), "f");
            }
            else {
                __classPrivateFieldSet(this, _BAP_ID_HDPrivateKey, HDPrivateKey, "f");
            }
            this.idName = "ID 1";
            this.description = "";
            __classPrivateFieldSet(this, _BAP_ID_rootPath, `${SIGNING_PATH_PREFIX}/0/0/0`, "f");
            __classPrivateFieldSet(this, _BAP_ID_previousPath, `${SIGNING_PATH_PREFIX}/0/0/0`, "f");
            __classPrivateFieldSet(this, _BAP_ID_currentPath, `${SIGNING_PATH_PREFIX}/0/0/1`, "f");
            const rootChild = __classPrivateFieldGet(this, _BAP_ID_HDPrivateKey, "f").derive(__classPrivateFieldGet(this, _BAP_ID_rootPath, "f"));
            this.rootAddress = rootChild.privKey.toPublicKey().toAddress();
            this.identityKey = this.deriveIdentityKey(this.rootAddress);
            // unlink the object
            identityAttributes = Object.assign({}, identityAttributes);
            this.identityAttributes = this.parseAttributes(identityAttributes);
        }
        set BAP_SERVER(bapServer) {
            __classPrivateFieldSet(this, _BAP_ID_BAP_SERVER, bapServer, "f");
        }
        get BAP_SERVER() {
            return __classPrivateFieldGet(this, _BAP_ID_BAP_SERVER, "f");
        }
        set BAP_TOKEN(token) {
            __classPrivateFieldSet(this, _BAP_ID_BAP_TOKEN, token, "f");
        }
        get BAP_TOKEN() {
            return __classPrivateFieldGet(this, _BAP_ID_BAP_TOKEN, "f");
        }
        deriveIdentityKey(address) {
            // base58( ripemd160 ( sha256 ( rootAddress ) ) )
            const rootAddressHash = toHex(sha256(address, "utf8"));
            return toBase58(ripemd160(rootAddressHash, "hex"));
        }
        /**
         * Helper function to parse identity attributes
         *
         * @param identityAttributes
         * @returns {{}}
         */
        parseAttributes(identityAttributes) {
            if (typeof identityAttributes === "string") {
                return this.parseStringUrns(identityAttributes);
            }
            for (const key in identityAttributes) {
                if (!identityAttributes[key].value || !identityAttributes[key].nonce) {
                    throw new Error("Invalid identity attribute");
                }
            }
            return identityAttributes || {};
        }
        /**
         * Parse a text of urn string into identity attributes
         *
         * urn:bap:id:name:John Doe:e2c6fb4063cc04af58935737eaffc938011dff546d47b7fbb18ed346f8c4d4fa
         * urn:bap:id:birthday:1990-05-22:e61f23cbbb2284842d77965e2b0e32f0ca890b1894ca4ce652831347ee3596d9
         * urn:bap:id:over18:1:480ca17ccaacd671b28dc811332525f2f2cd594d8e8e7825de515ce5d52d30e8
         *
         * @param urnIdentityAttributes
         */
        parseStringUrns(urnIdentityAttributes) {
            const identityAttributes = {};
            // avoid forEach
            const attributesRaw = urnIdentityAttributes
                .replace(/^\s+/g, "")
                .replace(/\r/gm, "")
                .split("\n");
            for (const line of attributesRaw) {
                // remove any whitespace from the string (trim)
                const attribute = line.replace(/^\s+/g, "").replace(/\s+$/g, "");
                const urn = attribute.split(":");
                if (urn[0] === "urn" &&
                    urn[1] === "bap" &&
                    urn[2] === "id" &&
                    urn[3] &&
                    urn[4] &&
                    urn[5]) {
                    identityAttributes[urn[3]] = {
                        value: urn[4],
                        nonce: urn[5],
                    };
                }
            }
            return identityAttributes;
        }
        /**
         * Returns the identity key
         *
         * @returns {*|string}
         */
        getIdentityKey() {
            return this.identityKey;
        }
        /**
         * Returns all the attributes in the identity
         *
         * @returns {*}
         */
        getAttributes() {
            return this.identityAttributes;
        }
        /**
         * Get the value of the given attribute
         *
         * @param attributeName
         * @returns {{}|null}
         */
        getAttribute(attributeName) {
            if (this.identityAttributes[attributeName]) {
                return this.identityAttributes[attributeName];
            }
            return null;
        }
        /**
         * Set the value of the given attribute
         *
         * If an empty value ('' || null || false) is given, the attribute is removed from the ID
         *
         * @param attributeName string
         * @param attributeValue any
         * @returns {{}|null}
         */
        setAttribute(attributeName, attributeValue) {
            if (attributeValue) {
                if (this.identityAttributes[attributeName]) {
                    this.identityAttributes[attributeName].value = attributeValue;
                }
                else {
                    this.addAttribute(attributeName, attributeValue);
                }
            }
        }
        /**
         * Unset the given attribute from the ID
         *
         * @param attributeName
         * @returns {{}|null}
         */
        unsetAttribute(attributeName) {
            delete this.identityAttributes[attributeName];
        }
        /**
         * Get all attribute urn's for this id
         *
         * @returns {string}
         */
        getAttributeUrns() {
            let urns = "";
            for (const key in this.identityAttributes) {
                const urn = this.getAttributeUrn(key);
                if (urn) {
                    urns += `${urn}\n`;
                }
            }
            return urns;
        }
        /**
         * Create an return the attribute urn for the given attribute
         *
         * @param attributeName
         * @returns {string|null}
         */
        getAttributeUrn(attributeName) {
            const attribute = this.identityAttributes[attributeName];
            if (attribute) {
                return `urn:bap:id:${attributeName}:${attribute.value}:${attribute.nonce}`;
            }
            return null;
        }
        /**
         * Add an attribute to this identity
         *
         * @param attributeName
         * @param value
         * @param nonce
         */
        addAttribute(attributeName, value, nonce = "") {
            if (!nonce) {
                nonce = Utils.getRandomString();
            }
            this.identityAttributes[attributeName] = {
                value,
                nonce,
            };
        }
        /**
         * This should be called with the last part of the signing path (/.../.../...)
         * This library assumes the first part is m/424150'/0'/0' as defined at the top of this file
         *
         * @param path The second path of the signing path in the format [0-9]{0,9}/[0-9]{0,9}/[0-9]{0,9}
         */
        set rootPath(path) {
            if (__classPrivateFieldGet(this, _BAP_ID_HDPrivateKey, "f")) {
                if (path.split("/").length < 5) {
                    path = `${SIGNING_PATH_PREFIX}${path}`;
                }
                if (!this.validatePath(path)) {
                    throw new Error(`invalid signing path given ${path}`);
                }
                __classPrivateFieldSet(this, _BAP_ID_rootPath, path, "f");
                const derivedChild = __classPrivateFieldGet(this, _BAP_ID_HDPrivateKey, "f").derive(path);
                this.rootAddress = derivedChild.pubKey.toAddress();
                // Identity keys should be derivatives of the root address - this allows checking
                // of the creation transaction
                this.identityKey = this.deriveIdentityKey(this.rootAddress);
                // we also set this previousPath / currentPath to the root as we seem to be (re)setting this ID
                __classPrivateFieldSet(this, _BAP_ID_previousPath, path, "f");
                __classPrivateFieldSet(this, _BAP_ID_currentPath, path, "f");
            }
        }
        get rootPath() {
            return __classPrivateFieldGet(this, _BAP_ID_rootPath, "f");
        }
        getRootPath() {
            return __classPrivateFieldGet(this, _BAP_ID_rootPath, "f");
        }
        /**
         * This should be called with the last part of the signing path (/.../.../...)
         * This library assumes the first part is m/424150'/0'/0' as defined at the top of this file
         *
         * @param path The second path of the signing path in the format [0-9]{0,9}/[0-9]{0,9}/[0-9]{0,9}
         */
        set currentPath(path) {
            if (path.split("/").length < 5) {
                path = `${SIGNING_PATH_PREFIX}${path}`;
            }
            if (!this.validatePath(path)) {
                throw new Error("invalid signing path given");
            }
            __classPrivateFieldSet(this, _BAP_ID_previousPath, __classPrivateFieldGet(this, _BAP_ID_currentPath, "f"), "f");
            __classPrivateFieldSet(this, _BAP_ID_currentPath, path, "f");
        }
        get currentPath() {
            return __classPrivateFieldGet(this, _BAP_ID_currentPath, "f");
        }
        get previousPath() {
            return __classPrivateFieldGet(this, _BAP_ID_previousPath, "f");
        }
        /**
         * This can be used to break the deterministic way child keys are created to make it harder for
         * an attacker to steal the identites when the root key is compromised. This does however require
         * the seeds to be stored at all times. If the seed is lost, the identity will not be recoverable.
         */
        get idSeed() {
            return __classPrivateFieldGet(this, _BAP_ID_idSeed, "f");
        }
        /**
         * Increment current path to a new path
         *
         * @returns {*}
         */
        incrementPath() {
            this.currentPath = Utils.getNextPath(this.currentPath);
        }
        /**
         * Check whether the given path is a valid path for use with this class
         * The signing paths used here always have a length of 3
         *
         * @param path The last part of the signing path (example "/0/0/1")
         * @returns {boolean}
         */
        validatePath(path) {
            /* eslint-disable max-len */
            if (path.match(/\/[0-9]{1,10}'?\/[0-9]{1,10}'?\/[0-9]{1,10}'?\/[0-9]{1,10}'?\/[0-9]{1,10}'?\/[0-9]{1,10}'?/)) {
                const pathValues = path.split("/");
                if (pathValues.length === 7 &&
                    Number(pathValues[1].replace("'", "")) <= MAX_INT &&
                    Number(pathValues[2].replace("'", "")) <= MAX_INT &&
                    Number(pathValues[3].replace("'", "")) <= MAX_INT &&
                    Number(pathValues[4].replace("'", "")) <= MAX_INT &&
                    Number(pathValues[5].replace("'", "")) <= MAX_INT &&
                    Number(pathValues[6].replace("'", "")) <= MAX_INT) {
                    return true;
                }
            }
            return false;
        }
        /**
         * Get the OP_RETURN for the initial ID transaction (signed with root address)
         *
         * @returns {[]}
         */
        getInitialIdTransaction() {
            return this.getIdTransaction(__classPrivateFieldGet(this, _BAP_ID_rootPath, "f"));
        }
        /**
         * Get the OP_RETURN for the ID transaction of the current address / path
         *
         * @returns {[]}
         */
        getIdTransaction(previousPath = "") {
            if (__classPrivateFieldGet(this, _BAP_ID_currentPath, "f") === __classPrivateFieldGet(this, _BAP_ID_rootPath, "f")) {
                throw new Error("Current path equals rootPath. ID was probably not initialized properly");
            }
            const opReturn = [
                Buffer.from(BAP_BITCOM_ADDRESS).toString("hex"),
                Buffer.from("ID").toString("hex"),
                Buffer.from(this.identityKey).toString("hex"),
                Buffer.from(this.getCurrentAddress()).toString("hex"),
            ];
            previousPath = previousPath || __classPrivateFieldGet(this, _BAP_ID_previousPath, "f");
            return this.signOpReturnWithAIP(opReturn, previousPath);
        }
        /**
         * Get address for given path
         *
         * @param path
         * @returns {*}
         */
        getAddress(path) {
            const derivedChild = __classPrivateFieldGet(this, _BAP_ID_HDPrivateKey, "f").derive(path);
            return derivedChild.privKey.toPublicKey().toAddress();
        }
        /**
         * Get current signing address
         *
         * @returns {*}
         */
        getCurrentAddress() {
            return this.getAddress(__classPrivateFieldGet(this, _BAP_ID_currentPath, "f"));
        }
        /**
         * Get the public key for encrypting data for this identity
         */
        getEncryptionPublicKey() {
            const HDPrivateKey = __classPrivateFieldGet(this, _BAP_ID_HDPrivateKey, "f").derive(__classPrivateFieldGet(this, _BAP_ID_rootPath, "f"));
            const encryptionKey = HDPrivateKey.derive(ENCRYPTION_PATH).privKey;
            // @ts-ignore
            return encryptionKey.toPublicKey().toString();
        }
        /**
         * Get the public key for encrypting data for this identity, using a seed for the encryption
         */
        getEncryptionPublicKeyWithSeed(seed) {
            const encryptionKey = this.getEncryptionPrivateKeyWithSeed(seed);
            // @ts-ignore
            return encryptionKey.toPublicKey().toString("hex");
        }
        /**
         * Encrypt the given string data with the identity encryption key
         * @param stringData
         * @param counterPartyPublicKey Optional public key of the counterparty
         * @return string Base64
         */
        encrypt(stringData, counterPartyPublicKey) {
            const HDPrivateKey = __classPrivateFieldGet(this, _BAP_ID_HDPrivateKey, "f").derive(__classPrivateFieldGet(this, _BAP_ID_rootPath, "f"));
            const encryptionKey = HDPrivateKey.derive(ENCRYPTION_PATH).privKey;
            const publicKey = encryptionKey.toPublicKey();
            const pubKey = counterPartyPublicKey
                ? PublicKey.fromString(counterPartyPublicKey)
                : publicKey;
            return toBase64$1(bitcoreEncrypt$1(toArray$1(stringData), pubKey));
        }
        /**
         * Decrypt the given ciphertext with the identity encryption key
         * @param ciphertext
         * @param counterPartyPublicKey Optional public key of the counterparty
         */
        decrypt(ciphertext, counterPartyPublicKey) {
            const HDPrivateKey = __classPrivateFieldGet(this, _BAP_ID_HDPrivateKey, "f").derive(__classPrivateFieldGet(this, _BAP_ID_rootPath, "f"));
            const encryptionKey = HDPrivateKey.derive(ENCRYPTION_PATH).privKey;
            // const ecies = new ECIES();
            // if (counterPartyPublicKey) {
            //   return toUTF8(bitcoreDecrypt(toArray(Buffer.from(ciphertext, 'base64'), 'base64'), encryptionKey))
            // }
            // TODO: It seems the counterPartyPublicKey is not being used here
            return toUTF8$1(bitcoreDecrypt$1(toArray$1(Buffer.from(ciphertext, "base64"), "base64"), encryptionKey));
            // ecies.privateKey(encryptionKey);
            // if (counterPartyPublicKey) {
            //   ecies.publicKey(counterPartyPublicKey);
            // }
            // return ecies.decrypt(Buffer.from(ciphertext, 'base64')).toString();
        }
        /**
         * Encrypt the given string data with the identity encryption key
         * @param stringData
         * @param seed String seed
         * @param counterPartyPublicKey Optional public key of the counterparty
         * @return string Base64
         */
        encryptWithSeed(stringData, seed, counterPartyPublicKey) {
            const encryptionKey = this.getEncryptionPrivateKeyWithSeed(seed);
            const publicKey = encryptionKey.toPublicKey();
            // const ecies = new ECIES();
            if (counterPartyPublicKey) {
                // ecies.privateKey(encryptionKey);
                // ecies.publicKey(counterPartyPublicKey);
                return toBase64$1(bitcoreEncrypt$1(toArray$1(stringData), PublicKey.fromString(counterPartyPublicKey)));
            }
            // ecies.publicKey(publicKey);
            return toBase64$1(bitcoreEncrypt$1(toArray$1(stringData), publicKey));
            // return ecies.encrypt(stringData).toString('base64');
        }
        /**
         * Decrypt the given ciphertext with the identity encryption key
         * @param ciphertext
         * @param seed String seed
         * @param counterPartyPublicKey Public key of the counterparty
         */
        decryptWithSeed(ciphertext, seed, counterPartyPublicKey) {
            const encryptionKey = this.getEncryptionPrivateKeyWithSeed(seed);
            // const ecies = new ECIES();
            // ecies.privateKey(encryptionKey);
            // if (counterPartyPublicKey) {
            // ecies.publicKey(counterPartyPublicKey);
            // TODOL: It seems the counterPartyPublicKey is not being used here
            return toUTF8$1(bitcoreDecrypt$1(toArray$1(Buffer.from(ciphertext, "base64"), "base64"), encryptionKey));
            // }
            // return ecies.decrypt(Buffer.from(ciphertext, 'base64')).toString();
        }
        getEncryptionPrivateKeyWithSeed(seed) {
            const pathHex = toHex(sha256(seed, "utf8"));
            const path = Utils.getSigningPathFromHex(pathHex);
            const HDPrivateKey = __classPrivateFieldGet(this, _BAP_ID_HDPrivateKey, "f").derive(__classPrivateFieldGet(this, _BAP_ID_rootPath, "f"));
            return HDPrivateKey.derive(path).privKey;
        }
        /**
         * Get an attestation string for the given urn for this identity
         *
         * @param urn
         * @returns {string}
         */
        getAttestation(urn) {
            const urnHash = sha256(urn, "utf8");
            return `bap:attest:${toHex(urnHash)}:${this.getIdentityKey()}`;
        }
        /**
         * Generate and return the attestation hash for the given attribute of this identity
         *
         * @param attribute Attribute name (name, email etc.)
         * @returns {string}
         */
        getAttestationHash(attribute) {
            const urn = this.getAttributeUrn(attribute);
            if (!urn)
                return null;
            const attestation = this.getAttestation(urn);
            const attestationHash = sha256(attestation, "utf8");
            return toHex(attestationHash);
        }
        /**
         * Sign a message with the current signing address of this identity
         *
         * @param message
         * @param signingPath
         * @returns {{address, signature}}
         */
        signMessage(message, signingPath = "") {
            let msg;
            if (!(message instanceof Buffer)) {
                msg = Buffer.from(message);
            }
            else {
                msg = message;
            }
            signingPath = signingPath || __classPrivateFieldGet(this, _BAP_ID_currentPath, "f");
            const childPk = __classPrivateFieldGet(this, _BAP_ID_HDPrivateKey, "f").derive(signingPath).privKey;
            const address = childPk.toAddress();
            const signature = sign$1(toArray$1(msg), childPk).toCompact(0, true, "base64");
            return { address, signature };
        }
        /**
         * Sign a message using a key based on the given string seed
         *
         * This works by creating a private key from the root key of this identity. It will always
         * work with the rootPath / rootKey, to be deterministic. It will not change even if the keys
         * are rotated for this ID.
         *
         * This is used in for instance deterministic login systems, that do not support BAP.
         *
         * @param message
         * @param seed {string} String seed that will be used to generate a path
         */
        signMessageWithSeed(message, seed) {
            const pathHex = toHex(sha256(seed, "utf8"));
            const path = Utils.getSigningPathFromHex(pathHex);
            const HDPrivateKey = __classPrivateFieldGet(this, _BAP_ID_HDPrivateKey, "f").derive(__classPrivateFieldGet(this, _BAP_ID_rootPath, "f"));
            const derivedChild = HDPrivateKey.derive(path);
            const address = derivedChild.privKey.toPublicKey().toAddress();
            const signature = sign$1(toArray$1(Buffer.from(message)), derivedChild.privKey).toCompact(0, true, "base64");
            return { address, signature };
        }
        /**
         * Sign an op_return hex array with AIP
         * @param opReturn {array}
         * @param signingPath {string}
         * @param outputType {string}
         * @return {[]}
         */
        signOpReturnWithAIP(opReturn, signingPath = "", outputType = "hex") {
            const aipMessageBuffer = this.getAIPMessageBuffer(opReturn);
            const { address, signature } = this.signMessage(aipMessageBuffer, signingPath);
            return opReturn.concat([
                Buffer.from("|").toString(outputType),
                Buffer.from(AIP_BITCOM_ADDRESS).toString(outputType),
                Buffer.from("BITCOIN_ECDSA").toString(outputType),
                Buffer.from(address).toString(outputType),
                Buffer.from(signature, "base64").toString(outputType),
            ]);
        }
        /**
         * Construct an AIP buffer from the op return data
         * @param opReturn
         * @returns {Buffer}
         */
        getAIPMessageBuffer(opReturn) {
            const buffers = [];
            if (opReturn[0].replace("0x", "") !== "6a") {
                // include OP_RETURN in constructing the signature buffer
                buffers.push(Buffer.from("6a", "hex"));
            }
            for (const op of opReturn) {
                buffers.push(Buffer.from(op.replace("0x", ""), "hex"));
            }
            // add a trailing "|" - this is the AIP way
            buffers.push(Buffer.from("|"));
            return Buffer.concat([...buffers]);
        }
        /**
         * Get all signing keys for this identity
         */
        getIdSigningKeys() {
            return __awaiter(this, void 0, void 0, function* () {
                const signingKeys = yield this.getApiData("/signing-keys", {
                    idKey: this.identityKey,
                });
                console.log("getIdSigningKeys", signingKeys);
                return signingKeys;
            });
        }
        /**
         * Get all attestations for the given attribute
         *
         * @param attribute
         */
        getAttributeAttestations(attribute) {
            return __awaiter(this, void 0, void 0, function* () {
                // This function needs to make a call to a BAP server to get all the attestations for this
                // identity for the given attribute
                const attestationHash = this.getAttestationHash(attribute);
                // get all BAP ATTEST records for the given attestationHash
                const attestations = yield this.getApiData("/attestations", {
                    hash: attestationHash,
                });
                console.log("getAttestations", attribute, attestationHash, attestations);
                return attestations;
            });
        }
        /**
         * Helper function to get attestation from a BAP API server
         *
         * @param apiUrl
         * @param apiData
         * @returns {Promise<any>}
         */
        getApiData(apiUrl, apiData) {
            return __awaiter(this, void 0, void 0, function* () {
                const url = `${__classPrivateFieldGet(this, _BAP_ID_BAP_SERVER, "f")}${apiUrl}`;
                const response = yield fetch(url, {
                    method: "post",
                    headers: {
                        "Content-type": "application/json; charset=utf-8",
                        token: __classPrivateFieldGet(this, _BAP_ID_BAP_TOKEN, "f"),
                        format: "json",
                    },
                    body: JSON.stringify(apiData),
                });
                return response.json();
            });
        }
        /**
         * Import an identity from a JSON object
         *
         * @param identity{{}}
         */
        import(identity) {
            this.idName = identity.name;
            this.description = identity.description || "";
            this.identityKey = identity.identityKey;
            __classPrivateFieldSet(this, _BAP_ID_rootPath, identity.rootPath, "f");
            this.rootAddress = identity.rootAddress;
            __classPrivateFieldSet(this, _BAP_ID_previousPath, identity.previousPath, "f");
            __classPrivateFieldSet(this, _BAP_ID_currentPath, identity.currentPath, "f");
            __classPrivateFieldSet(this, _BAP_ID_idSeed, identity.idSeed || "", "f");
            this.identityAttributes = this.parseAttributes(identity.identityAttributes);
        }
        /**
         * Export this identity to a JSON object
         * @returns {{}}
         */
        export() {
            return {
                name: this.idName,
                description: this.description,
                identityKey: this.identityKey,
                rootPath: __classPrivateFieldGet(this, _BAP_ID_rootPath, "f"),
                rootAddress: this.rootAddress,
                previousPath: __classPrivateFieldGet(this, _BAP_ID_previousPath, "f"),
                currentPath: __classPrivateFieldGet(this, _BAP_ID_currentPath, "f"),
                idSeed: __classPrivateFieldGet(this, _BAP_ID_idSeed, "f"),
                identityAttributes: this.getAttributes(),
                lastIdPath: "",
            };
        }
    }
    _BAP_ID_HDPrivateKey = new WeakMap(), _BAP_ID_BAP_SERVER = new WeakMap(), _BAP_ID_BAP_TOKEN = new WeakMap(), _BAP_ID_rootPath = new WeakMap(), _BAP_ID_previousPath = new WeakMap(), _BAP_ID_currentPath = new WeakMap(), _BAP_ID_idSeed = new WeakMap();

    var _HDPrivateKey, _ids, _BAP_SERVER, _BAP_TOKEN, _lastIdPath, _a;
    const { toArray, toUTF8, toBase64 } = BSVUtils;
    const { bitcoreDecrypt, bitcoreEncrypt } = ECIES;
    /**
     * BAP class
     *
     * Creates an instance of the BAP class and uses the given HDPrivateKey for all BAP operations.
     *
     * @param HDPrivateKey
     */
    const BAP = (_a = class {
            constructor(HDPrivateKey, token = "") {
                _HDPrivateKey.set(this, void 0);
                _ids.set(this, {});
                _BAP_SERVER.set(this, BAP_SERVER);
                _BAP_TOKEN.set(this, "");
                _lastIdPath.set(this, "");
                if (!HDPrivateKey) {
                    throw new Error("No HDPrivateKey given");
                }
                __classPrivateFieldSet(this, _HDPrivateKey, HD.fromString(HDPrivateKey), "f");
                if (token) {
                    __classPrivateFieldSet(this, _BAP_TOKEN, token, "f");
                }
            }
            get lastIdPath() {
                return __classPrivateFieldGet(this, _lastIdPath, "f");
            }
            /**
             * Get the public key of the given childPath, or of the current HDPrivateKey of childPath is empty
             *
             * @param childPath Full derivation path for this child
             * @returns {*}
             */
            getPublicKey(childPath = "") {
                if (childPath) {
                    return __classPrivateFieldGet(this, _HDPrivateKey, "f").derive(childPath).pubKey.toString();
                }
                return __classPrivateFieldGet(this, _HDPrivateKey, "f").pubKey.toString();
            }
            /**
             * Get the public key of the given childPath, or of the current HDPrivateKey of childPath is empty
             *
             * @param childPath Full derivation path for this child
             * @returns {*}
             */
            getHdPublicKey(childPath = "") {
                if (childPath) {
                    return __classPrivateFieldGet(this, _HDPrivateKey, "f").derive(childPath).toPublic().toString();
                }
                return __classPrivateFieldGet(this, _HDPrivateKey, "f").toPublic().toString();
            }
            set BAP_SERVER(bapServer) {
                __classPrivateFieldSet(this, _BAP_SERVER, bapServer, "f");
                Object.keys(__classPrivateFieldGet(this, _ids, "f")).forEach((key) => {
                    // @ts-ignore - does not recognize private fields that can be set
                    __classPrivateFieldGet(this, _ids, "f")[key].BAP_SERVER = bapServer;
                });
            }
            get BAP_SERVER() {
                return __classPrivateFieldGet(this, _BAP_SERVER, "f");
            }
            set BAP_TOKEN(token) {
                __classPrivateFieldSet(this, _BAP_TOKEN, token, "f");
                Object.keys(__classPrivateFieldGet(this, _ids, "f")).forEach((key) => {
                    // @ts-ignore - does not recognize private fields that can be set
                    __classPrivateFieldGet(this, _ids, "f")[key].BAP_TOKEN = token;
                });
            }
            get BAP_TOKEN() {
                return __classPrivateFieldGet(this, _BAP_TOKEN, "f");
            }
            /**
             * This function verifies that the given bapId matches the given root address
             * This is used as a data integrity check
             *
             * @param bapId BAP_ID instance
             */
            checkIdBelongs(bapId) {
                const derivedChild = __classPrivateFieldGet(this, _HDPrivateKey, "f").derive(bapId.rootPath);
                const checkRootAddress = derivedChild.pubKey.toAddress();
                if (checkRootAddress !== bapId.rootAddress) {
                    throw new Error("ID does not belong to this private key");
                }
                return true;
            }
            /**
             * Returns a list of all the identity keys that are stored in this instance
             *
             * @returns {string[]}
             */
            listIds() {
                return Object.keys(__classPrivateFieldGet(this, _ids, "f"));
            }
            /**
             * Create a new Id and link it to this BAP instance
             *
             * This function uses the length of the #ids of this class to determine the next valid path.
             * If not all ids related to this HDPrivateKey have been loaded, determine the path externally
             * and pass it to newId when creating a new ID.
             *
             * @param path
             * @param identityAttributes
             * @param idSeed
             * @returns {*}
             */
            newId(path = "", identityAttributes = {}, idSeed = "") {
                if (!path) {
                    // get next usable path for this key
                    path = this.getNextValidPath();
                }
                const newIdentity = new BAP_ID(__classPrivateFieldGet(this, _HDPrivateKey, "f"), identityAttributes, idSeed);
                newIdentity.BAP_SERVER = __classPrivateFieldGet(this, _BAP_SERVER, "f");
                newIdentity.BAP_TOKEN = __classPrivateFieldGet(this, _BAP_TOKEN, "f");
                newIdentity.rootPath = path;
                newIdentity.currentPath = Utils.getNextPath(path);
                const idKey = newIdentity.getIdentityKey();
                __classPrivateFieldGet(this, _ids, "f")[idKey] = newIdentity;
                __classPrivateFieldSet(this, _lastIdPath, path, "f");
                return __classPrivateFieldGet(this, _ids, "f")[idKey];
            }
            /**
             * Remove identity
             *
             * @param idKey
             * @returns {*}
             */
            removeId(idKey) {
                delete __classPrivateFieldGet(this, _ids, "f")[idKey];
            }
            /**
             * Get the next valid path for the used HDPrivateKey and loaded #ids
             *
             * @returns {string}
             */
            getNextValidPath() {
                // prefer hardened paths
                if (__classPrivateFieldGet(this, _lastIdPath, "f")) {
                    return Utils.getNextIdentityPath(__classPrivateFieldGet(this, _lastIdPath, "f"));
                }
                return `/0'/${Object.keys(__classPrivateFieldGet(this, _ids, "f")).length}'/0'`;
            }
            /**
             * Get a certain Id
             *
             * @param identityKey
             * @returns {null}
             */
            getId(identityKey) {
                return __classPrivateFieldGet(this, _ids, "f")[identityKey] || null;
            }
            /**
             * This function is used when manipulating ID's, adding or removing attributes etc
             * First create an id through this class and then use getId to get it. Then you can add/edit or
             * increment the signing path and then re-set it with this function.
             *
             * Note: when you getId() from this class, you will be working on the same object as this class
             * has and any changes made will be propagated to the id in this class. When you call exportIds
             * your new changes will also be included, without having to setId().
             *
             * @param bapId
             */
            setId(bapId) {
                this.checkIdBelongs(bapId);
                __classPrivateFieldGet(this, _ids, "f")[bapId.getIdentityKey()] = bapId;
            }
            /**
             * This function is used to import IDs and attributes from some external storage
             *
             * The ID information should NOT be stored together with the HD private key !
             *
             * @param idData Array of ids that have been exported
             * @param encrypted Whether the data should be treated as being encrypted (default true)
             */
            importIds(idData, encrypted = true) {
                if (encrypted) {
                    // we first need to decrypt the ids array using ECIES
                    const derivedChild = __classPrivateFieldGet(this, _HDPrivateKey, "f").derive(ENCRYPTION_PATH);
                    const decrypted = toUTF8(bitcoreDecrypt(toArray(Buffer.from(idData, Utils.isHex(idData) ? "hex" : "base64").toString("hex"), "hex"), derivedChild.privKey));
                    idData = JSON.parse(decrypted);
                }
                let oldFormatImport = false;
                if (!idData.ids) {
                    // old format id container
                    oldFormatImport = true;
                    idData = {
                        lastIdPath: "",
                        ids: idData,
                    };
                }
                for (const id of idData.ids) {
                    if (!id.identityKey || !id.identityAttributes || !id.rootAddress) {
                        throw new Error("ID cannot be imported as it is not complete");
                    }
                    const importId = new BAP_ID(__classPrivateFieldGet(this, _HDPrivateKey, "f"), {}, id.idSeed);
                    importId.BAP_SERVER = __classPrivateFieldGet(this, _BAP_SERVER, "f");
                    importId.BAP_TOKEN = __classPrivateFieldGet(this, _BAP_TOKEN, "f");
                    importId.import(id);
                    this.checkIdBelongs(importId);
                    __classPrivateFieldGet(this, _ids, "f")[importId.getIdentityKey()] = importId;
                    if (oldFormatImport) {
                        // overwrite with the last value on this array
                        idData.lastIdPath = importId.currentPath;
                    }
                }
                __classPrivateFieldSet(this, _lastIdPath, idData.lastIdPath, "f");
            }
            /**
             * Export all the IDs of this instance for external storage
             *
             * By default this function will encrypt the data, using a derivative child of the main HD key
             *
             * @param encrypted Whether the data should be encrypted (default true)
             * @returns {[]|*}
             */
            exportIds(encrypted = true) {
                const idData = {
                    lastIdPath: __classPrivateFieldGet(this, _lastIdPath, "f"),
                    ids: [],
                };
                for (const key of Object.keys(__classPrivateFieldGet(this, _ids, "f"))) {
                    idData.ids.push(__classPrivateFieldGet(this, _ids, "f")[key].export());
                }
                if (encrypted) {
                    const derivedChild = __classPrivateFieldGet(this, _HDPrivateKey, "f").derive(ENCRYPTION_PATH);
                    return toBase64(bitcoreEncrypt(toArray(JSON.stringify(idData), 'utf8'), derivedChild.pubKey));
                }
                return idData;
            }
            /**
             * Encrypt a string of data
             *
             * @param string
             * @returns {string}
             */
            encrypt(string) {
                const derivedChild = __classPrivateFieldGet(this, _HDPrivateKey, "f").derive(ENCRYPTION_PATH);
                return toBase64(bitcoreEncrypt(toArray(string, 'utf8'), derivedChild.pubKey));
            }
            /**
             * Decrypt a string of data
             *
             * @param string
             * @returns {string}
             */
            decrypt(string) {
                const derivedChild = __classPrivateFieldGet(this, _HDPrivateKey, "f").derive(ENCRYPTION_PATH);
                return toUTF8(bitcoreDecrypt(toArray(string, 'base64'), derivedChild.privKey));
            }
            /**
             * Sign an attestation for a user
             *
             * @param attestationHash The computed attestation hash for the user - this should be calculated with the BAP_ID class for an identity for the user
             * @param identityKey The identity key we are using for the signing
             * @param counter
             * @param dataString Optional data string that will be appended to the BAP attestation
             * @returns {string[]}
             */
            signAttestationWithAIP(attestationHash, identityKey, counter = 0, dataString = "") {
                const id = this.getId(identityKey);
                if (!id) {
                    throw new Error("Could not find identity to attest with");
                }
                const attestationBuffer = this.getAttestationBuffer(attestationHash, counter, dataString);
                const { address, signature } = id.signMessage(attestationBuffer);
                return this.createAttestationTransaction(attestationHash, counter, address, signature, dataString);
            }
            /**
             * Verify an AIP signed attestation for a user
             *
             * [
             *   '0x6a',
             *   '0x31424150537561506e66476e53424d33474c56397968785564596534764762644d54',
             *   '0x415454455354',
             *   '0x33656166366361396334313936356538353831366439336439643034333136393032376633396661623034386333633031333663343364663635376462383761',
             *   '0x30',
             *   '0x7c',
             *   '0x313550636948473232534e4c514a584d6f5355615756693757537163376843667661',
             *   '0x424954434f494e5f4543445341',
             *   '0x31477531796d52567a595557634638776f6f506a7a4a4c764d383550795a64655876',
             *   '0x20ef60c5555001ddb1039bb0f215e46571fcb39ee46f48b089d1c08b0304dbcb3366d8fdf8bafd82be24b5ac42dcd6a5e96c90705dd42e3ad918b1b47ac3ce6ac2'
             * ]
             *
             * @param tx Array of hex values for the OP_RETURN values
             * @returns {{}}
             */
            verifyAttestationWithAIP(tx) {
                if (!Array.isArray(tx) ||
                    tx[0] !== "0x6a" ||
                    tx[1] !== BAP_BITCOM_ADDRESS_HEX) {
                    throw new Error("Not a valid BAP transaction");
                }
                const dataOffset = tx[7] === "0x44415441" ? 5 : 0; // DATA
                const attestation = {
                    type: Utils.hexDecode(tx[2]),
                    hash: Utils.hexDecode(tx[3]),
                    sequence: Utils.hexDecode(tx[4]),
                    signingProtocol: Utils.hexDecode(tx[7 + dataOffset]),
                    signingAddress: Utils.hexDecode(tx[8 + dataOffset]),
                    signature: Utils.hexDecode(tx[9 + dataOffset], "base64"),
                };
                if (dataOffset && tx[3] === tx[8]) {
                    // valid data addition
                    attestation.data = Utils.hexDecode(tx[9]);
                }
                try {
                    const signatureBufferStatements = [];
                    for (let i = 0; i < 6 + dataOffset; i++) {
                        signatureBufferStatements.push(Buffer.from(tx[i].replace("0x", ""), "hex"));
                    }
                    const attestationBuffer = Buffer.concat([...signatureBufferStatements]);
                    attestation.verified = this.verifySignature(attestationBuffer, attestation.signingAddress, attestation.signature);
                }
                catch (e) {
                    attestation.verified = false;
                }
                return attestation;
            }
            /**
             * For BAP attestations we use all fields for the attestation
             *
             * @param attestationHash
             * @param counter
             * @param address
             * @param signature
             * @param dataString Optional data string that will be appended to the BAP attestation
             * @returns {[string]}
             */
            createAttestationTransaction(attestationHash, counter, address, signature, dataString = "") {
                const transaction = ["0x6a", Utils.hexEncode(BAP_BITCOM_ADDRESS)];
                transaction.push(Utils.hexEncode("ATTEST"));
                transaction.push(Utils.hexEncode(attestationHash));
                transaction.push(Utils.hexEncode(`${counter}`));
                transaction.push("0x7c"); // |
                if (dataString) {
                    // data should be a string, either encrypted or stringified JSON if applicable
                    transaction.push(Utils.hexEncode(BAP_BITCOM_ADDRESS));
                    transaction.push(Utils.hexEncode("DATA"));
                    transaction.push(Utils.hexEncode(attestationHash));
                    transaction.push(Utils.hexEncode(dataString));
                    transaction.push("0x7c"); // |
                }
                transaction.push(Utils.hexEncode(AIP_BITCOM_ADDRESS));
                transaction.push(Utils.hexEncode("BITCOIN_ECDSA"));
                transaction.push(Utils.hexEncode(address));
                transaction.push(`0x${Buffer.from(signature, "base64").toString("hex")}`);
                return transaction;
            }
            /**
             * This is a re-creation of how the bitcoinfiles-sdk creates a hash to sign for AIP
             *
             * @param attestationHash
             * @param counter
             * @param dataString Optional data string
             * @returns {Buffer}
             */
            getAttestationBuffer(attestationHash, counter = 0, dataString = "") {
                // re-create how AIP creates the buffer to sign
                let dataStringBuffer = Buffer.from("");
                if (dataString) {
                    dataStringBuffer = Buffer.concat([
                        Buffer.from(BAP_BITCOM_ADDRESS),
                        Buffer.from("DATA"),
                        Buffer.from(attestationHash),
                        Buffer.from(dataString),
                        Buffer.from("7c", "hex"),
                    ]);
                }
                return Buffer.concat([
                    Buffer.from("6a", "hex"),
                    Buffer.from(BAP_BITCOM_ADDRESS),
                    Buffer.from("ATTEST"),
                    Buffer.from(attestationHash),
                    Buffer.from(`${counter}`),
                    Buffer.from("7c", "hex"),
                    dataStringBuffer,
                ]);
            }
            /**
             * Verify that the identity challenge is signed by the address
             *
             * @param message Buffer or utf-8 string
             * @param address Bitcoin address of signee
             * @param signature Signature base64 string
             *
             * @return boolean
             */
            verifySignature(message, address, signature) {
                // check the signature against the challenge
                const messageBuffer = Buffer.isBuffer(message)
                    ? message
                    : Buffer.from(message);
                const sig = Signature.fromCompact(signature, "base64");
                let publicKey;
                const msg = toArray(messageBuffer.toString("hex"), "hex");
                for (let recovery = 0; recovery < 4; recovery++) {
                    try {
                        publicKey = sig.RecoverPublicKey(recovery, new BigNumber(magicHash(msg)));
                        const sigFitsPubkey = verify(msg, sig, publicKey);
                        if (sigFitsPubkey && publicKey.toAddress() === address) {
                            return true;
                        }
                    }
                    catch (e) {
                        // try next recovery
                    }
                }
                return false;
            }
            /**
             * Check whether the given transaction (BAP OP_RETURN) is valid, is signed and that the
             * identity signing is also valid at the time of signing
             *
             * @param idKey
             * @param address
             * @param challenge
             * @param signature
             *
             * @returns {Promise<boolean|*>}
             */
            verifyChallengeSignature(idKey, address, challenge, signature) {
                return __awaiter(this, void 0, void 0, function* () {
                    // first we test locally before sending to server
                    if (this.verifySignature(challenge, address, signature)) {
                        const result = yield this.getApiData("/attestation/valid", {
                            idKey,
                            challenge,
                            signature,
                        });
                        return result.data;
                    }
                    return false;
                });
            }
            /**
             * Check whether the given transaction (BAP OP_RETURN) is valid, is signed and that the
             * identity signing is also valid at the time of signing
             *
             * @param tx
             * @returns {Promise<boolean|*>}
             */
            isValidAttestationTransaction(tx) {
                return __awaiter(this, void 0, void 0, function* () {
                    // first we test locally before sending to server
                    if (this.verifyAttestationWithAIP(tx)) {
                        return this.getApiData("/attestation/valid", {
                            tx,
                        });
                    }
                    return false;
                });
            }
            /**
             * Get all signing keys for the given idKey
             *
             * @param address
             * @returns {Promise<*>}
             */
            getIdentityFromAddress(address) {
                return __awaiter(this, void 0, void 0, function* () {
                    return this.getApiData("/identity/from-address", {
                        address,
                    });
                });
            }
            /**
             * Get all signing keys for the given idKey
             *
             * @param idKey
             * @returns {Promise<*>}
             */
            getIdentity(idKey) {
                return __awaiter(this, void 0, void 0, function* () {
                    return this.getApiData("/identity", {
                        idKey,
                    });
                });
            }
            /**
             * Get all attestations for the given attestation hash
             *
             * @param attestationHash
             */
            getAttestationsForHash(attestationHash) {
                return __awaiter(this, void 0, void 0, function* () {
                    // get all BAP ATTEST records for the given attestationHash
                    return this.getApiData("/attestations", {
                        hash: attestationHash,
                    });
                });
            }
            /**
             * Helper function to get attestation from a BAP API server
             *
             * @param apiUrl
             * @param apiData
             * @returns {Promise<any>}
             */
            getApiData(apiUrl, apiData) {
                return __awaiter(this, void 0, void 0, function* () {
                    const url = `${__classPrivateFieldGet(this, _BAP_SERVER, "f")}${apiUrl}`;
                    const response = yield fetch(url, {
                        method: "post",
                        headers: {
                            "Content-type": "application/json; charset=utf-8",
                            token: __classPrivateFieldGet(this, _BAP_TOKEN, "f"),
                            format: "json",
                        },
                        body: JSON.stringify(apiData),
                    });
                    return response.json();
                });
            }
        },
        _HDPrivateKey = new WeakMap(),
        _ids = new WeakMap(),
        _BAP_SERVER = new WeakMap(),
        _BAP_TOKEN = new WeakMap(),
        _lastIdPath = new WeakMap(),
        _a);

    exports.BAP = BAP;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=typescript-npm-package.umd.js.map
